dojo.provide("com.ibm.skins.Thin.bspaceSkin");

dojo.require("com.ibm.skins.Thin.skin");

dojo.declare("com.ibm.skins.Thin.bspaceSkin", com.ibm.skins.Thin.skin, {

	resizedWithTitleBar: false,
	
	constructor: function(id, node) {

		if (dojo.hasClass(node,'bspace-skin')) 
			return;
		dojo.addClass(node,'bspace-skin');

		dojo.registerModulePath("bspaceColumnLayout", "/BusinessSpace/iWidget/widgets/system/columnLayout");
		dojo.requireLocalization("bspaceColumnLayout", "columnLayoutResources", dojo.locale, window.bspaceSupportedLocales);
		var columnLayoutResources = dojo.i18n.getLocalization("bspaceColumnLayout", "columnLayoutResources");

	    dojo.registerModulePath("widgetNLS", "/BusinessSpace/iWidget/com/ibm/mm/builder");	
		dojo.requireLocalization("widgetNLS", "coreWidgetsStr", dojo.locale, window.bspaceSupportedLocales);
		var coreWidgetsStr = dojo.i18n.getLocalization("widgetNLS", "coreWidgetsStr"); 		

		var title = dojo.query(".decoration-titlebar", node)[0];
        if (title) {
	        this.connect(title,"mouseover","onMouseOver");
	        this.connect(title,"mouseout","onMouseOut");
        }
        var max = dojo.query(".bspaceMaxIcon", node)[0];
        if(max) {
        	dijit.setWaiRole(max,"button");
        	max.title = columnLayoutResources.maximizeWidgetTitle;
	        this.connect(max,"click","maximizeWidget");
        }
        var rest = dojo.query(".bspaceRestoreIcon", node)[0];
        if (rest) {
        	dijit.setWaiRole(rest,"button");
        	rest.title = columnLayoutResources.restoreWidgetTitle;
	        this.connect(rest,"click","restoreWidget");
		}
        var min = dojo.query(".bspaceMinIcon", node)[0];
        if(min) {
        	dijit.setWaiRole(min,"button");
        	min.title = columnLayoutResources.minimizeWidgetTitle;
	        this.connect(min,"click","minimizeWidget");
        }
        var menu = dojo.query(".decoration-contextMenuAction", node)[0];
        if(menu) {
        	dijit.setWaiRole(menu,"button");
        	menu.title = coreWidgetsStr.I_SKIN_EDIT_ICON_TITLE;
        }
        var showTitle = dojo.query(".ibmShowTitleBarLink", node)[0];
        if(showTitle) {
        	showTitle.title = coreWidgetsStr.I_SKIN_SHOW_TITLE;
        	var alt = dojo.query(".lotusAltText", showTitle)[0];
        	if (alt) {
        		alt.innerHTML = coreWidgetsStr.I_SKIN_SHOW_TITLE_ALT;
        	}
        	dijit.setWaiRole(showTitle,"button");
        }
        var hideTitle = dojo.query(".ibmHideTitleBarLink", node)[0];
        if(hideTitle) {
        	hideTitle.title = coreWidgetsStr.I_SKIN_HIDE_TITLE;
        	var alt = dojo.query(".lotusAltText", hideTitle)[0];
        	if (alt) {
        		alt.innerHTML = coreWidgetsStr.I_SKIN_HIDE_TITLE_ALT;
        	}
        	dijit.setWaiRole(hideTitle,"button");
        }
        
		if (!this.resizerInited) {
			this.createWidgetResizeHandle(id,node);
		}

        var evtSvc = com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService");
    	this.resizeWidgetHandler = evtSvc.subscribeEvent("com.ibm.mashups.builder.resizeWidget", null, dojo.hitch(this, 'onResizeWidget'));

    },

    onMouseOver: function(evt) {
    	var title = dojo.query(".bspaceSkinTopEdgeAndTitleFill", this.root)[0];
    	if (title) {
    		dojo.addClass(title.parentNode,"bspaceOverEditBar");
    	}
    },

    onMouseOut: function(evt) {
    	var title = dojo.query(".bspaceSkinTopEdgeAndTitleFill", this.root)[0];
    	if (title) {
    		dojo.removeClass(title.parentNode,"bspaceOverEditBar");
    	}
    },

    maximizeWidget: function() {
    	var metadata = {
    		newWindowState: "maximize",
    		event: com.ibm.mashups.iwidget.Constants.CHANGE_WIDGETWINDOWSTATE
    	};
    	com.ibm.pb.contextMenu.sharedActions.changeWindowState(this.id,null,metadata,null);
        var rest = dojo.query(".bspaceRestoreIcon", this.root)[0];
        if (rest) {
        	rest.focus();
		}
    },

    minimizeWidget: function() {
    	var metadata = {
    		newWindowState: "minimize",
    		event: com.ibm.mashups.iwidget.Constants.CHANGE_WIDGETWINDOWSTATE
    	};
    	com.ibm.pb.contextMenu.sharedActions.changeWindowState(this.id,null,metadata,null);
        var rest = dojo.query(".bspaceRestoreIcon", this.root)[0];
        if (rest) {
        	rest.focus();
		}
    },

    restoreWidget: function() {
    	var metadata = {
    		newWindowState: "normal",
    		event: com.ibm.mashups.iwidget.Constants.CHANGE_WIDGETWINDOWSTATE
    	};
    	com.ibm.pb.contextMenu.sharedActions.changeWindowState(this.id,null,metadata,null);
        var min = dojo.query(".bspaceMinIcon", this.root)[0];
        if (min) {
        	min.focus();
		}
	},

	destroy: function() {
		if (this.resizeWidgetHandler) {
	   		var evtSvc = com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService");
	   		this.resizeWidgetHandler = evtSvc.unsubscribeEvent(this.resizeWidgetHandler,null);
		}
		this.inherited(arguments);
	},
	
	showTitleBar: function(controlDiv, showLink, node) {
		this.inherited(arguments);
		this.resizedWithTitleBar = false;
	},
	
	hideTitleBar: function(controlDiv, node) {
		this.inherited(arguments);
		if (this.resizedWithTitleBar) {
			this.loadWidgetHeight(this.root);
		}
	},

	onResizeWidget: function(evt) {
		// make sure this message is for this widget 
		if (evt.widgetId == this.id) {
			// if we are in view mode, we need to save the new size in the personalized data
			if (com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getPageMode() != "edit") {
				// Clear dirty flag after resize processing finishes since this is not edit mode
				window.setTimeout(this._resetDirtyFlag,100);
			}
			// if the title bar is currently showing, set a flag to indicate that we 
			// will need to fix up the height when the title bar is hidden again
			var controlDiv = dojo.query(".lotusWidget2", this.root)[0];
			if (controlDiv && !dojo.hasClass(controlDiv,"ibmHideTitleBar")) {
				this.resizedWithTitleBar = true;
			}
		}
	},

	// Business Space moved the ibmToggleTitleBar control above the widget
	// so it should not be included in any height adjustments
	_getMarginHeight: function(node) {
		var h = 0;
		if (!dojo.hasClass(node,'ibmToggleTitleBar')) {
			h = this.inherited(arguments);
		}
		return h;
	},

	loadWidgetHeight: function(parentNode){
		if (!dojo.hasClass(parentNode,'ibm-maximized')) {
			this.inherited(arguments);
		}
	},
	
	_resetDirtyFlag: function() {
		com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(false);
	}
	
	
});
