// Licensed Materials - Property of IBM
// 5724-M22, 5724-M23, 5724-M24, 5724-L01, 5724-R31
// (C) Copyright IBM Corporation 2011. 
// US Government Users Restricted Rights- Use, duplication or disclosure
// restricted by GSA ADP Schedule Contract with IBM Corp.

dojo.provide("com.ibm.themes.bspaceTheme.common");

//cs: here we programmatically add a link element in order to make use of the 'themeRootURI' javascript variable
var linkElement = document.createElement("link");
linkElement.rel = "stylesheet";
linkElement.type = "text/css";
linkElement.href = ibmCfg.themeConfig.themeRootURI + "/theme.css";
var headElement= document.getElementsByTagName("head")[0];  
headElement.appendChild(linkElement);
// end create link element

//bp: fix up lang and bidi values that mashups handles with nls versions of theme
var locale = djConfig.locale;
if ((locale.length > 2) && (locale.charAt(2) == '-')) {
	locale = locale.substring(0,2) + '_' + locale.substring(3).toUpperCase(); 
}
document.documentElement.setAttribute('lang',locale);
document.documentElement.setAttribute('xml:lang',locale);
if ((locale == 'ar') || (locale == 'iw') || (locale == 'he')) {
	document.body.setAttribute('dir','rtl');
}

// bp: define a variable for the supported locales so that we have a common
// location that the code can reference to restrict which locales are
// searched for nls files within the core Business Space code.  
window.bspaceSupportedLocales = "ar,cs,de,el,es,fr,he,hu,it,iw,ja,ko,pl,pt,ro,ru,tr,zh,zh-tw,da,fi,nb,sk,sv,nl,no";

// rt: register BSpace theme bundles now
var cs = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
var co = cs.getConfigObject(com.ibm.mashups.enabler.services.ConfigConstants.ENDPOINT_CONFIG_PROVIDER);
var serverEndpointURL = co.getValue("{com.ibm.bspace}bspaceServerRootId.url");
dojo.registerModulePath("com.ibm.bspace.bundles", serverEndpointURL + "/com/ibm/bspace/bundles");

// bp: run the following logic after the PageBuilder2 theme is initialized
com.ibm.themes.bspaceTheme.common.init = function() {
	com.ibm.themes.bspaceTheme.showResizeCover = function() {
		var div = document.createElement('div');
		div.id = 'bspaceSizingCover';
		div.style.position = 'absolute';
		div.style.top = '0px';
		div.style.left = '0px';
		div.style.width = '100%';
		div.style.height = '100%';
		if (dojo.isIE) {
			div.style.backgroundColor = '#f0f0f0';
			div.style.opacity = 0.1;
			div.style.filter = 'alpha(opacity=1)';
		}
		document.body.appendChild(div);
	};
	com.ibm.themes.bspaceTheme.hideResizeCover = function() {
		var div = dojo.byId('bspaceSizingCover');
		if (div) {
			document.body.removeChild(div);
			delete div;
		}
	};
	dojo.extend(com.ibm.pb.layout.resize.WidgetResizer, {
		_mashupsBeginSizing: com.ibm.pb.layout.resize.WidgetResizer.prototype._beginSizing,
		_mashupsEndSizing: com.ibm.pb.layout.resize.WidgetResizer.prototype._endSizing,
		_beginSizing: function(e) {
			this._mashupsBeginSizing(e);
			com.ibm.themes.bspaceTheme.showResizeCover();
		},
		_endSizing: function(e) {
			com.ibm.themes.bspaceTheme.hideResizeCover();
			this._mashupsEndSizing(e);
		}
	});
	dojo.extend(com.ibm.pb.layout.resize.ContainerResizer, {
		_mashupsBeginSizing: com.ibm.pb.layout.resize.ContainerResizer.prototype._beginSizing,
		_mashupsEndSizing: com.ibm.pb.layout.resize.ContainerResizer.prototype._endSizing,
		_beginSizing: function(e) {
			this._mashupsBeginSizing(e);
			com.ibm.themes.bspaceTheme.showResizeCover();
		},
		_endSizing: function(e) {
			com.ibm.themes.bspaceTheme.hideResizeCover();
			this._mashupsEndSizing(e);
		},
		onEndSizing: function(styles) {
			// if we are in view mode, we need to save the new size in the personalized data
			if (com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getPageMode() != "edit") {				
				var leftNodeId = this.leftNodeId;
				var rightNodeId = this.rightNodeId;
				var leftWidth = styles.left.width;
				var rightWidth = styles.right.width; 
				// Clear dirty flag since this is not edit mode
				com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(false);
			}
		}
	});
	// modify the default widget wrapper to allow the config, edit,
	// and personalize modes to be displayed in a dialog
	com.ibm.themes.bspaceTheme.common.editModeDialog = null;
	com.ibm.themes.bspaceTheme.common.editModeWidgetId = null;
	com.ibm.themes.bspaceTheme.common.editModeDialogClosed = function() {
        var variableName = "_" + com.ibm.themes.bspaceTheme.common.editModeWidgetId + "_" + "iContext";
        var iContext = dojo.global[variableName]
		iContext.iEvents.fireEvent("onModeChanged",null,"{newMode:'view'}");
	};
	dojo.addOnUnload(function () {
		if (com.ibm.themes.bspaceTheme.common.editModeDialog) {
			com.ibm.themes.bspaceTheme.common.editModeDialog.destroy();
			com.ibm.themes.bspaceTheme.common.editModeDialog = null;
		}
	});
	dojo.extend(com.ibm.mm.iwidget.widget.IWidgetWrapperDefaultImpl, {
		_isDialogSupportedForMode: function(mode) {
			var rc = false;
			if (mode == 'edit') rc = true;
			if (mode == 'config') rc = true;
			if (mode == 'personalize') rc = true;
			if (rc) {
				// defect 46734
				// if the widget does not have a title span, then we do not have a way
				// to get a title to use when showing the mode correctly as a dialog
				var titleSpan = dojo.byId('title.'+this.id);
				if (!titleSpan) {
					rc = false;
				}
			}
			return rc;
		},
		_handleMashupsModeChange: com.ibm.mm.iwidget.widget.IWidgetWrapperDefaultImpl.prototype._handleModeChange,
		_handleMashupsOnModeEvent: com.ibm.mm.iwidget.widget.IWidgetWrapperDefaultImpl.prototype._handleOnModeEvent,
		_handleMashupsEventInternal: com.ibm.mm.iwidget.widget.IWidgetWrapperDefaultImpl.prototype._handleEventInternal,
		_handleModeChange: function(iEvent) {
			var payload = iEvent.payload;
			var newMode = null;
			if (payload) {
				newMode = payload.newMode;
			}
			if (this._isDialogSupportedForMode(newMode)) {
				dojo.addClass(this.rootElement,'showWidgetView');
				dojo.addClass(this.rootElement,'hideWidgetEdit');
				dojo.addClass(this.rootElement,'hideWidgetConfig');
				dojo.addClass(this.rootElement,'hideWidgetPersonalize');
			}
			this._handleMashupsModeChange(iEvent);
			if (!this._isDialogSupportedForMode(newMode)) {
				dojo.removeClass(this.rootElement,'showWidgetView');
				dojo.removeClass(this.rootElement,'hideWidgetEdit');
				dojo.removeClass(this.rootElement,'hideWidgetConfig');
				dojo.removeClass(this.rootElement,'hideWidgetPersonalize');
			}
		},
		_handleOnModeEvent: function(mode,oldMode) {
			if (this._editModeDialog) {
				this._editModeDialogCleanup(oldMode);
			}
			this._handleMashupsOnModeEvent(mode,oldMode);
			if (this._isDialogSupportedForMode(mode)) {
				this._showEditModeDialog(mode);
			}
		},
		_editModeDialog: null,
		_showEditModeDialog: function(mode) {
			var titleSpan = dojo.byId('title.'+this.id);
			var titleText = titleSpan.innerHTML;
			if (com.ibm.themes.bspaceTheme.common.editModeDialog &&
			   (com.ibm.themes.bspaceTheme.common.editModeWidgetId != this.id)) {
				com.ibm.themes.bspaceTheme.common.editModeDialog.destroy();
				com.ibm.themes.bspaceTheme.common.editModeDialog = null;
			}
			com.ibm.themes.bspaceTheme.common.editModeWidgetId = this.id;
			if (com.ibm.themes.bspaceTheme.common.editModeDialog) {
				this._editModeDialog = com.ibm.themes.bspaceTheme.common.editModeDialog;
				this._editModeDialog.setTitle(titleText);
			} else {
				this._editModeDialog = new com.ibm.mm.builder.widget.CustomDialog({
					id: "com_ibm_bspace_edit_dialog",
	            	type: "config",
	            	title: titleText,
	            	needModeSwitch: false,
	            	belongId: this.id,
	            	containerBackgroundColor: "white",
					hasRightBottomResizer: false,
					closeCallback: com.ibm.themes.bspaceTheme.common.editModeDialogClosed
				});
				com.ibm.themes.bspaceTheme.common.editModeDialog = this._editModeDialog;
			}
			var editRootNode = this.windowManager[mode].root;			
			this._editModeDialog.containerNode.appendChild(editRootNode);
	        this._editModeDialog.show();
		},
		_editModeDialogCleanup: function(oldMode) {
			var editRootNode = this.windowManager[oldMode].root;
			this.rootElement.appendChild(editRootNode);
			this._editModeDialog.hide();
			this._editModeDialog = null;
		}
	});
	// modify the decoration manager to automatically call _addStyleFilter
	// when a LayoutFilter is registered with the decoration manager 
	com.ibm.pb.decorations.DECORATION_MANAGER.mashupsRegisterLayout = com.ibm.pb.decorations.DECORATION_MANAGER.registerLayout; 
	com.ibm.pb.decorations.DECORATION_MANAGER.registerLayout = function(node) {
			this.mashupsRegisterLayout(node);
			var name = com.ibm.domUtilities.textContent(node);
			if (name == 'com.ibm.pb.decorations.LayoutFilters') {
				// filter is the last one on the array
				var obj = this._layoutComps[this._layoutComps.length-1].obj;
				if (obj && obj._addStyleFilter) {
					obj._addStyleFilter();					
				}
			}
	};
	// mashups container resizers are always set to the height of the layout
	// node when they are created.  this causes problems when container heights
	// change and when containers are placed above/below other containers.
	// to fix this, we are using a timer to set the height of the resizers
	// based on the nodes to either side of the resizer
	dojo.extend(com.ibm.pb.decorations.LayoutResizers, {
		_mashupsProcessContainer: com.ibm.pb.decorations.LayoutResizers.prototype.processContainer,
		processContainer: function(id,node) {
			this._mashupsProcessContainer(id,node);
			var resizer = this.components[id];
			if (resizer) {
				resizer.fixHeight();
			}
		}
	});
	dojo.extend(com.ibm.pb.layout.resize.ContainerResizer, {
		intervalHandle: null,
		fixHeight: function() {
			if (this.domNode && !this.intervalHandle) {
				this.intervalHandle = window.setInterval(dojo.hitch(this,'fixHeight'),500);
			}
			if (this.domNode && this.domNode.previousSibling && this.domNode.nextSibling) {
				var h = this.domNode.previousSibling.offsetHeight;
				if (h < this.domNode.nextSibling.offsetHeight) {
					h = this.domNode.nextSibling.offsetHeight;
				}
				if (this.domNode.offsetHeight != h) {
					this.domNode.style.height = h + 'px';
				}
			}
			if (this.intervalHandle && !this.domNode) {
				window.clearInterval(this.intervalHandle);
				this.intervalHandle = null;
			}
		}
	});
	// get the initial width of the lotusMain container so we can
	// check for size changes later
	com.ibm.themes.bspaceTheme.common.width = document.body.offsetWidth;
	if (dojo.byId('lotusMain')) {
		com.ibm.themes.bspaceTheme.common.width = dojo.byId('lotusMain').offsetWidth;
	}
	// when the browser size has changed, send onSizeChanged to any
	// widgets inside of column containers
	com.ibm.themes.bspaceTheme.common.handleWidthChanged = function() {
		com.ibm.themes.bspaceTheme.common.timeout = null;
		var lotusMain = dojo.byId('lotusMain');
		if (lotusMain) {
			var width = lotusMain.offsetWidth;
			if (com.ibm.themes.bspaceTheme.common.width != width) {
				com.ibm.themes.bspaceTheme.common.width = width;				
	            var cols = dojo.query(".ibmDndColumn", lotusMain);
	            for (var i=0; i<cols.length; i++){
	            	var nodes = dojo.query(".iw-iWidget", cols[i]);
	            	for (var j=0; j<nodes.length; j++) {
	            		var widgetId = nodes[j].id;
	            		var box = dojo.contentBox(nodes[j].parentNode);
		            	var payload = { "newWidth": box.w, "newHeight": box.h };
		            	var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
		            	eventService.publishEvent(com.ibm.mashups.iwidget.Constants.RESIZE_WIDGET+"."+widgetId,payload);
	            	}
	            }
			}
		}
	};
	// connect to the window resize event so we know when the
	// browser window changes.  use a timer so that we only resize
	// widgets after 1 second since the last sizing movement
	if (dojo.isIE) {
		window.attachEvent('onresize',function() {
			if (com.ibm.themes.bspaceTheme.common.timeout) {
				window.clearTimeout(com.ibm.themes.bspaceTheme.common.timeout);
			}
			com.ibm.themes.bspaceTheme.common.timeout = window.setTimeout(com.ibm.themes.bspaceTheme.common.handleWidthChanged,1000);
		});
	} else {
		dojo.connect(window,'resize',function() {
			if (com.ibm.themes.bspaceTheme.common.timeout) {
				window.clearTimeout(com.ibm.themes.bspaceTheme.common.timeout);
			}
			com.ibm.themes.bspaceTheme.common.timeout = window.setTimeout(com.ibm.themes.bspaceTheme.common.handleWidthChanged,1000);
		});
	}
	dojo.extend(com.ibm.pb.control.RenderingController, {
		_mashupsMaximizeWidget: com.ibm.pb.control.RenderingController.prototype._maximizeWidget,
		_mashupsProcessMaximize: com.ibm.pb.control.RenderingController.prototype._processMaximize,
		_mashupsRemoveMaximize: com.ibm.pb.control.RenderingController.prototype._removeMaximize,
		_mashupsGetWindowHeight: com.ibm.pb.control.RenderingController.prototype._getWindowHeight,
		_mashupsProcessControls: com.ibm.pb.control.RenderingController.prototype.processControls,
		// if a widget is maximized when the page is loaded, the correct size may not
		// be available, so we need to check for this condition and fix up the maxWidgetStore
		// values 
		_maximizeWidget: function(currentWidget, keepOldWidgetHeight) {
			var fixBodyHeight = false;
			var widgetBody = dojo.query(".lotusWidgetBody", currentWidget)[0];
			if (keepOldWidgetHeight) {
				var controlHeight = currentWidget.style.height;
				var bodyHeight = widgetBody.style.height;
				if (!bodyHeight || (bodyHeight == 'auto')) {
					var bodyBox = dojo.contentBox(widgetBody);
					bodyHeight = bodyBox.h+'px';
					fixBodyHeight = true;
					if ((bodyBox.h == 0) && controlHeight && (controlHeight != 'auto')) {
						bodyHeight = (parseInt(controlHeight)-dojo.contentBox(currentWidget).h)+'px';
						fixBodyHeight = false;
					}
				}
				if (!controlHeight || (controlHeight=='auto')) {
					controlHeight = dojo.contentBox(currentWidget).h+'px';
				}
				this.maxWidgetStore = {controlHeight: controlHeight, bodyHeight: bodyHeight};
			}
			this._insideMaximizeWidget = true;
			this._mashupsMaximizeWidget(currentWidget, false);
			this._insideMaximizeWidget = false;
			widgetBody.style.minHeight = widgetBody.style.height;
			if (fixBodyHeight) {
				this.maxWidgetStore = {controlHeight: 'auto', bodyHeight: 'auto'};
			}
			this.layoutContainers.style.height = currentWidget.style.height;
			
		},
		// when a widget is maximized, we need to change the styles on the lotusMain
		// container
		_processMaximize: function(currentWidget, container){
			dojo.addClass(dojo.byId('lotusMain'),'bspace-maximized');
			this._mashupsProcessMaximize(currentWidget, container);
		},
		_removeMaximize: function(widget){
			var widgetBody = dojo.query(".lotusWidgetBody", widget)[0];
			widgetBody.style.minHeight = '';
			dojo.removeClass(dojo.byId('lotusMain'),'bspace-maximized');
			this._mashupsRemoveMaximize(widget);
		},
		processControls: function(node,addMaxBuffer){
			dojo.removeClass(dojo.byId('lotusMain'),'bspace-maximized');
			this._mashupsProcessControls(node,addMaxBuffer);
		},
		// when doing size calculations for a maximized widget, remove the footer height (27px)
		_getWindowHeight: function() {
			h = this._mashupsGetWindowHeight();
			if (this._insideMaximizeWidget) {
				h = h - 27;
			}
			return h;
		}
	});
	dojo.registerModulePath("com.ibm.bspace.common.util.ui", "/BusinessSpace/com/ibm/bspace/common/util/ui");
	dojo.require('com.ibm.bspace.common.util.ui.Helper');
	com.ibm.themes.bspaceTheme.mashupsDisplayEmbedDialog = com.ibm.mm.builder.utils.embedUtil.displayEmbedDialog;
	com.ibm.mm.builder.utils.embedUtil.displayEmbedDialog = function(id, type, widgetType) {
		com.ibm.themes.bspaceTheme.mashupsDisplayEmbedDialog(id,type,widgetType);
		if (type == 'page') {
			var txt = dojo.query('.embedPgDlgDesp')[0];
			if (txt) {
				com.ibm.bspace.common.util.ui.Helper.screenReaderReadText(txt.innerHTML);
			}
		}
	};
	// defect 45903
	// when trying to switch to a space that has pages, but none that the
	// current user can access, we get a status of 400 and a null resource.
	// watch for this condition and call the callback instead of allowing
	// the default mashups processing which will throw exceptions
	dojo.extend(com.ibm.pb.tree.DFSTraversal,{
		_mashupsVisitChildren: com.ibm.pb.tree.DFSTraversal.prototype._visitChildren,
		_visitChildren: function(resource, status, dfdParams) {
			if ((status == 400) && (resource == null)){
				dfdParams.callback(dfdParams.params.list); 
			} else {
				this._mashupsVisitChildren(resource,status,dfdParams);
			}
		}
	});
	// defect 46264
	// there is a bug when using Adobe Flash/Flex with IE that causes the
	// document title to be corrupted.  this is a work-around that watches
	// for changes to the document title and fixes the title if it appears
	// to be corrupted
	if (dojo.isIE) {
		document.attachEvent('onpropertychange',function() {
		    if (window.event.propertyName == 'title') {
		    	if (document.title.indexOf("#pid") != -1) {
		    		page = com.ibm.mm.builder.utils.pageUtil.getCurrentPageNode();
		    		if (page) {
		    			// use unescaped title
		    			var title = com.ibm.mm.builder.utils.enablerUtil.getUnescapedNodeTitle(page, dojo.locale);
		    			// check if the title is already correct to avoid inifinite loop case
		    			if (document.title != title) {
		    				document.title = title;
		    			}
		    		}
		    	}
		    } 
		});
	}
}

