if(!dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerActions"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerActions"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerActions");
dojo.require("com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerUtil");
dojo.require("com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants");
dojo.require("dojo.io.iframe");
dojo.require("dojox.xml.parser");

(function() {
var spaceManagerUtil = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerUtil,
    spaceUtil = com.ibm.mm.builder.utils.spaceUtil,
	pageUtil = com.ibm.mm.builder.utils.pageUtil,
    enablerUtil = com.ibm.mm.builder.utils.enablerUtil,
    bundle = com.ibm.mm.builder.coreWidgetsStrings,
    constants = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants,
    messages = com.ibm.mm.builder.coreWidgetsMessages,
    eventService = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.iwidget.services.EventService.SERVICE_NAME),
    navigationUtil = com.ibm.mm.builder.utils.navigationUtil;

com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerActions.space = {
    LOGGER : com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerActions.space"),
	
    importNewPage : function(spaceId) {
        var payload = {
            widgetTypeId: "importWidget",
            eventName: "com.ibm.mashups.builder.importWidgetAction",
            eventPayload: {spaceId : spaceId},
			requestRefresh: true,
            dialogParam: {
				title: bundle.I_IMPORT_PAGE_TITLE,
				nodeWidth: "328px",
				leftBarWidth: "0px",
				rightBarWidth: "0px",
                containerBackgroundColor: "white",
                hasRightBottomResizer: false
            }};
        eventService.broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
    },
	
    canSaveAsTemplate : function(spaceId) {
		return !com.ibm.mm.builder.commonActions.hasHub();
    },
    
	canCreateSpace : function() {
		return spaceUtil.getSpaceModel().confirmCreate();
	},
	
	canImportSpace : function() {
		return spaceUtil.getSpaceModel().confirmCreate() && com.ibm.mm.builder.commonActions.isSpaceImportExportEnabled();
	},
	
    saveAsTemplate : function(spaceId) {
        var spaceModel = spaceUtil.getSpaceModel();
        var space = spaceModel.find(spaceId).start();
		var title = enablerUtil.getNodeTitle(space);
        var d = space.saveAsTemplate();
        d.setOperationCallback(function(node, mode, statusCode) {
			if (statusCode < 400) {
	            dojo.publish(constants.Topic.Common.showMessage, [dojo.string.substitute(bundle.I_SPACE_MANAGER_SAVE_SPACE_AS_TEMPLATE_OK, [title]), "info"]);
			} else {
	            dojo.publish(constants.Topic.Common.showMessage, [dojo.string.substitute(bundle.I_SPACE_MANAGER_SAVE_SPACE_AS_TEMPLATE_FAILED, [title])]);
			}        
		});

        d.start();
    },
    
    exportSpace : function(spaceId) {
        if (!spaceId) {
            this.LOGGER.severe("exportSpace", messages.E_SPACE_MANAGER_SPACE_ID_IS_NULL_0);
            return;
        }
        var spaceModel = spaceUtil.getSpaceModel();
        var space = spaceModel.find(spaceId).start();
        var exportSpaceIframeName = "com.ibm.mashups.builder.spacemanager.exportSpace.iframe";
        var url = space.getExportSpaceURL();
        var iframe = dojo.io.iframe.create(exportSpaceIframeName);
		dojo.attr(iframe,'title',exportSpaceIframeName);
        dojo.io.iframe.setSrc(iframe, url, true);
		
    },
    
    deleteSpace : function(spaceId) {		
	   if (!spaceId) {
            this.LOGGER.severe("deleteSpace", messages.E_SPACE_MANAGER_SPACE_ID_IS_NULL_0);
            return;
        }

        var spaceModel = spaceUtil.getSpaceModel();
		var currentSpaceId = spaceUtil.getCurrentSpaceId();
        var space = spaceModel.find(spaceId).start();
        if (!space) {
            return;
        }
		
		var message = dojo.string.substitute(bundle.I_SPACE_MANAGER_DELETE_SPACE_PROMPT, [enablerUtil.getNodeTitle(space)]);
		
        this._deleteSpaceDialog = spaceManagerUtil.ui.dialog.openConfirmDialog(dojo.body(), {message : message}, {
            type: "delete space",
			title : dojo.string.substitute(bundle.I_SPACE_MANAGER_DELETE_SPACE_TITLE, [com.ibm.mm.builder.utils.spaceUtil.getSpaceTitle(spaceId)]),
            nodeWidth : "400px",
			leftBarWidth: "0px",
        	rightBarWidth: "0px",
            containerBackgroundColor: "white",
            displayCloseButton: true,
            hasRightBottomResizer: false,
            resourceBundle: bundle,
            okFunc : function() {
                if(spaceUtil.isHomeSpace(spaceId)){
					spaceUtil.setHomeSpaceId();
				};
				
				if (com.ibm.mm.builder.commonActions.isSpaceInFavorite(spaceId)) {
					com.ibm.mm.builder.commonActions.removeSpaceFromFavorite(spaceId);
				};
				
                var d = new dojo.Deferred();				
                spaceModel.remove(space);
				
                var deferred = spaceModel.commit();
				deferred.setFinishedCallback(function() {
					dojo.publish(constants.Topic.Space["delete"],[spaceId]);
                	dojo.publish(constants.Topic.Space.refresh,[constants.Action.DELETE_SPACE, {spaceId: spaceId}]);
					eventService.broadcastEvent("com.ibm.mashups.builder.deleteSpace", {spaceId: spaceId, currentSpaceId: currentSpaceId});
				});
				deferred.start();                
                d.callback({});
                return d;
            },
            okCallback : function() {
            }
        },this._deleteSpaceDialog);
    },
    
    addSpaceToFavorite : function(spaceId) {
        if (!spaceId) {
            this.LOGGER.severe("addSpaceToFavorite", messages.E_SPACE_MANAGER_SPACE_ID_IS_NULL_0);
            return;
        }
        var spaceModel = spaceUtil.getSpaceModel();
        var space = spaceModel.find(spaceId).start();
        if (space && !space.isFavorite()) {            
            
			this._toggleSpaceFavorite(space);
			dojo.publish(constants.Topic.Space.refresh,[constants.Action.ADD_FAVORITE, {spaceId: space.getID()}]);
        }
    },
    
    removeSpaceFromFavorite : function(spaceId) {
        if (!spaceId) {
            this.LOGGER.severe("removeSpaceFromFavorite", messages.E_SPACE_MANAGER_SPACE_ID_IS_NULL_0);
            return;
        }
        var spaceModel = spaceUtil.getSpaceModel();
        var space = spaceModel.find(spaceId).start();
        if (space && space.isFavorite()) {
            
			this._toggleSpaceFavorite(space);
			dojo.publish(constants.Topic.Space.refresh,[constants.Action.REMOVE_FAVORITE, {spaceId: space.getID()}]);
			
        }
    },
    
    _toggleSpaceFavorite : function(space) {
        space.setFavorite(!space.isFavorite());
        spaceUtil.getSpaceModel().commit().start();
        eventService.broadcastEvent("com.ibm.mashups.builder.refreshSpaceSelector");
    },
	
	show : function(spaceId) {
		if (!spaceId) {
			return;
		}
		var space = spaceUtil.getSpaceNode(spaceId);
		if (!space) {
			return;
		}
		space.setHidden(false);
		spaceUtil.getSpaceModel().commit().start();
		dojo.publish(constants.Topic.Space.refresh,[constants.Action.SHOW_SPACE, {spaceId: spaceId}]);
		eventService.broadcastEvent("com.ibm.mashups.builder.refreshSpaceSelector");
	},
	
	hide : function(spaceId) {
		if (!spaceId) {
			return;
		}
		var space = spaceUtil.getSpaceNode(spaceId);
		if (!space) {
			return;
		}
		space.setHidden(true);
		spaceUtil.getSpaceModel().commit().start();
		dojo.publish(constants.Topic.Space.refresh,[constants.Action.HIDE_SPACE, {spaceId: spaceId}]);
		eventService.broadcastEvent("com.ibm.mashups.builder.refreshSpaceSelector");
	},
	
	canSetHidden : function(spaceId, hide) {
		if (!spaceId) {
			return false;
		}
		var space = spaceUtil.getSpaceNode(spaceId);
		if (!space) {
			return false;
		}
		return space.confirmSetHidden(hide);
	},
	
	isHidden : function(spaceId) {
		if (!spaceId) {
			return true;
		}
        var space = spaceUtil.getSpaceNode(spaceId);
		if (!space) {
			return true;
		}
		return space.isHidden();
	},
	
	isNotHidden : function(spaceId) {
		return !com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerActions.space.isHidden(spaceId);
	},
	
	isHideActionDisplayed : function(spaceId) {
		var action = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerActions.space;
		return action.canSetHidden(spaceId, true) && action.isNotHidden(spaceId) && constants.changeHideMenuItemLabel === "false";
	},

	isHideActionDisplayed2 : function(spaceId) {
		var action = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerActions.space;
		return action.canSetHidden(spaceId, true) && action.isNotHidden(spaceId) && constants.changeHideMenuItemLabel === "true";
	},
		
	isShowActionDisplayed : function(spaceId) {
		var action = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerActions.space;
		return action.canSetHidden(spaceId, false) && action.isHidden(spaceId);
	},
	
	editSpaceProperties : function(spaceId) {	
		var payload = {
			widgetTypeId: "editSpace",
			eventName: "com.ibm.mashups.builder.spaceEditor",
			eventPayload: {spaceId: spaceId, editSpaceInSpaceManager: true},
			requestRefresh: true,
			dialogParam: {
				title: dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.EDIT_SPACE_PROPERTIES, [com.ibm.mm.builder.utils.spaceUtil.getSpaceTitle(spaceId)]),
				nodeWidth: "975px",
				containerBackgroundColor: "white",
				hasRightBottomResizer: false
			}
		};
		com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.iwidget.services.EventService.SERVICE_NAME).broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
	},
	
	copySpace : function(spaceId) {
		var payload = {
			widgetTypeId: "copySpace",
			eventName: "com.ibm.mashups.builder.copySpace",
			eventPayload: {spaceId:spaceId, copySpaceInSpaceManager:true},
			requestRefresh: true,
			dialogParam: {
				title: dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.COPY_SPACE_CAPTION, [com.ibm.mm.builder.utils.spaceUtil.getSpaceTitle(spaceId)]),
				nodeWidth: "350px",
				containerBackgroundColor: "white",
				hasRightBottomResizer: false
			}
		};
		com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.iwidget.services.EventService.SERVICE_NAME).broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
	},
	
	canChangeOwner: function(spaceId) {
		if (!space) {
			return false;
		}
		if (dojo.isString(space)) {
			space = spaceUtil.getSpaceNode(spaceId);
		}
		
		if (!space) {
			return false;
		}

		var ac = com.ibm.mashups.enabler.ac.AccessControlModelFactory.getAccessControlModel(space);
		return ac.confirmSetOwner(space);
	},
	
	createSpace : function() {
		var payload = {
           widgetTypeId: "createSpace",
            eventName: "com.ibm.mashups.builder.createSpace",
            eventPayload: {createSpaceFromSpaceManager:true},
            dialogParam: {
				title: com.ibm.mm.builder.coreWidgetsStrings.CREATE_SPACE_CAPTION,
                nodeWidth: "675px",
                containerBackgroundColor: "white",
                hasRightBottomResizer: false
            }
		};
    	com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
	},
	
	importSpace : function() {
		var payload = {
           widgetTypeId: "importWidget",
            eventName: "com.ibm.mashups.builder.importWidgetAction",
            eventPayload: null,
			requestRefresh: true,
            dialogParam: {
				title: com.ibm.mm.builder.coreWidgetsStrings.I_IMPORT_SPACE_TITLE,
				nodeWidth: "328px",
                containerBackgroundColor: "white",
                hasRightBottomResizer: false
            }
		};
    	com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
	}
	
};


com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerActions.page = {
    
    LOGGER : com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerActions.page"),
    
    createNewPage : function(id, type) {
        var parentPageId = id;
        var spaceId = null;
		var space;
        var navMode = navigationUtil.getNavigationModel();
        var spaceModel = spaceUtil.getSpaceModel();
        if (type == "space") {
            space = spaceModel.find(id).start();
            spaceId = id;
            
            parentPageId = space.getRootNavigation().getID();
        }
        else {
            var parentPage = navMode.find(id).start();
            space = spaceModel.findSpaceByNavigation(parentPage).start();
            spaceId = space.getID();
        }
        var bundle = com.ibm.mm.builder.coreWidgetsStrings;
			var payload = {
				widgetTypeId: "createPage",
				eventName: "com.ibm.mashups.builder.createPage",
				eventPayload: {"spaceId":spaceId, "parentPageId":parentPageId},
				requestRefresh: true,
				dialogParam: {
					nodeWidth: "675px",
					title: (type == "space") ? bundle.I_CREATE_PAGE_IN_SPACE_TITLE : dojo.string.substitute(bundle.I_CREATE_SUBPAGE_IN_SPACE_TITLE,[com.ibm.mm.builder.utils.pageUtil.getPageTitle(parentPageId)]),
					leftBarWidth: "0px",
					rightBarWidth: "0px",
					containerBackgroundColor: "white",
					hasRightBottomResizer: false
				}
			};
			eventService.broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
    },
    
    editPageProperties : function(pageId) {
        var payload = {
	    	widgetTypeId: "editPage",
	        eventName:  "com.ibm.mashups.builder.editPage",
	        eventPayload: {pageId: pageId, editPageInSpaceManager: true},
			requestRefresh: true,
	        dialogParam: { 
				id: pageId + "_pageProperty",
				title: dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_EDIT_PROPERTIE_PAGE, [com.ibm.mm.builder.utils.pageUtil.getPageTitle(pageId)]),
				nodeWidth: "515px",
				containerBackgroundColor: "white",
				leftBarWidth: "0px",
				rightBarWidth: "0px",
				hasRightBottomResizer: false
			}
		};
        eventService.broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog",payload);
    },
    
    copyPage : function(pageId) {
        if (!pageId) {
            this.LOGGER.severe("copyPage", messages.E_SPACE_MANAGER_PAGE_ID_IS_NULL_0);
            return;
        }
        var navModel = navigationUtil.getNavigationModel();
        var page = navModel.find(pageId).start();
        if (!page) {
            return;
        }

        var oldName = enablerUtil.getNodeTitle(page);
        var locale = dojo.locale;
        var newName = dojo.string.substitute(bundle.I_SPACE_MANAGER_COPY_OF, [oldName]);

        var parentPageId = com.ibm.mm.builder.utils.pageUtil.getParentPageId(pageId);
        var copyUrl = spaceManagerUtil.importPage.getResourceCollectionsUrl() + "&mode=duplicate" 
									      + "&copyPageId=" + pageId
									      + "&parentPageId=" + parentPageId 
									      + "&pageName=" + encodeURIComponent(newName);

        dojo.xhrPost({
        	url : copyUrl,
            headers : {
                	"Content-Type" : "text/xml; charset=UTF-8"
            },
            load : dojo.hitch(this, function(data) {
            	//parse data	
            	var newPageId = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerUtil.util.parseResourceIdFromResponseData(data);
            	var parentPageId = com.ibm.mm.builder.utils.pageUtil.getParentPageId(newPageId);
            	var spaceId = com.ibm.mm.builder.utils.spaceUtil.getSpaceIdByPageId(parentPageId);
            	var newPage = com.ibm.mm.builder.utils.pageUtil.getPageNode(newPageId);
                // refresh parent node so that the navigation can be correctly redrawn
                var navModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
                navModel.invalidate(parentPageId);

                dojo.publish(constants.Topic.Common.showMessage, ["save ok", "info"]);                        
                dojo.publish(constants.Topic.Space.refresh, [constants.Action.ADD_PAGE, {spaceId: spaceId, parentPageId: parentPageId, page: newPage}]);
				eventService.broadcastEvent("com.ibm.mashups.builder.refreshNavigation");
            }),
            error : dojo.hitch(this, function() {
            	dojo.publish(constants.Topic.Common.showMessage, ["save error"]);
        	})
        });
    },
    
    exportPage : function(pageId) {
        if (!pageId) {
            this.LOGGER.severe("exportPage", messages.E_SPACE_MANAGER_PAGE_ID_IS_NULL_0);
            return;
        }
        var exportURL = null;
        var page = com.ibm.mm.builder.utils.pageUtil.getPageNode(pageId);
        if (page !== null) {
            exportURL = page.getExportPageURL();
        }
		if(!exportURL){
			this.LOGGER.severe("exportPage", messages.E_SPACE_MANAGER_PAGE_EXPORT_URL_IS_NULL_0);
			return;
		} else {
			//var idx = dojo.indexOf(exportURL,"?"); 
			idx = exportURL.indexOf("?");
			var query = exportURL.substring(1+idx);
			var obj = dojo.queryToObject(query);
			obj['mime-type'] = 'application/zip';
			obj.rep = 'template';
			exportURL = exportURL.substring(0,idx)+"?"+dojo.objectToQuery(obj);
		}
        var exportPageIframeName = "com.ibm.mashups.builder.spacemanager.exportPage.iframe";
        var iframe = dojo.io.iframe.create(exportPageIframeName);
        dojo.io.iframe.setSrc(iframe, exportURL, true);
    },
    
    deletePage : function(pageId) {
        if (!pageId) {
            this.LOGGER.severe("deletePage", messages.E_SPACE_MANAGER_PAGE_ID_IS_NULL_0);
            return;
        }
		var spaceId = spaceUtil.getSpaceIdByPageId(pageId);
		var parentPageId = com.ibm.mm.builder.utils.pageUtil.getParentPageId(pageId);
		var currentPageId = com.ibm.mm.builder.utils.pageUtil.getCurrentPageId();
		var enabler = com.ibm.mashups.enabler;	
		var navModel = enabler.navigation.Factory.getNavigationModel();
		
        var page = navModel.find(pageId).start();
        if (!page) {
            return;
        }
        var message = dojo.string.substitute(bundle.I_SPACE_MANAGER_DELETE_PAGE_PROMPT, [enablerUtil.getNodeTitle(page)]);
        this._deletePageDialog = spaceManagerUtil.ui.dialog.openConfirmDialog(dojo.body(), {message : message}, {
            type: "delete page",
			title: dojo.string.substitute(bundle.I_SPACE_MANAGER_DELETE_PAGE_TITLE,[com.ibm.mm.builder.utils.pageUtil.getPageTitle(pageId)]),
            nodeWidth : "400px",
			leftBarWidth: "0px",
        	rightBarWidth: "0px",
            containerBackgroundColor: "white",
            displayCloseButton: true,
            hasRightBottomResizer: false,
            resourceBundle: bundle,
            okFunc : dojo.hitch(this, function() {
				
				var node = page;
				var parent = navModel.getParent(node).start();				
				var previousSibling = parent; // default to parent if no siblings
				var children = navModel.getChildren(parent);
				var child;
				// find previous sibling
				while (children.hasNext()) {
					child = children.next();
					if (child.getID() === pageId) {
						// if first child, and there are other children, use second child (next sibling)
						if (previousSibling === parent && children.hasNext()) {
							previousSibling = children.next();
						}
						break;
					}
					previousSibling = child;
				};			
				
				
				var d = new dojo.Deferred();        
                navModel.remove(pageId);
				
                var deferred = navModel.commit();
                deferred.setOperationCallback(function(data) {				
					
					var navStateModelFactory = enabler.model.state.NavigationStateModelFactory;
					var accessorFactory = enabler.model.state.AccessorFactory;
					// clear all widget edit modes since we're deleting and discarding any changes
					com.ibm.pb.contextMenu.sharedActions.widgetEditModeClearer();	
					com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setID(null);
					com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(false);
					// switch to previous sibling
					var navStateModel = navStateModelFactory.getNavigationStateModel();
					var pageAccessor = accessorFactory.getPageAccessor(navStateModel, null);
					pageAccessor.setPageID(previousSibling.getID());
					navStateModel.commit().setFinishedCallback(function(){
						var evtSvc = com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService");
						evtSvc.broadcastEvent("com.ibm.mashups.builder.switchPage", previousSibling.getID());
						evtSvc.broadcastEvent("com.ibm.mashups.builder.refreshNavigation", previousSibling.getID());
					}).start();					
					
                	d.callback(data);
                });
                deferred.start(false);
                return d;
            }),
            okCallback : dojo.hitch(this, function() {
                dojo.publish(constants.Topic.Space.refresh,[constants.Action.DELETE_PAGE, {pageId: pageId}]);
				eventService.broadcastEvent("com.ibm.mashups.builder.spacemanager.deletePage", {currentPageId:currentPageId, parentPageId: parentPageId, pageId: pageId});

            })
        },this._deletePageDialog);
        
    },
	
	canSetHidden : function(pageId, hide) {
		if (!pageId) {
			return false;
		}
		var navModel = navigationUtil.getNavigationModel();
        var page = navModel.find(pageId).start();
        if (!page) {
            return false;
        }
		return page.confirmSetHidden(hide);
	},
	
	show : function(pageId) {
		if (!pageId) {
			return;
		}
		var page = pageUtil.getPageNode(pageId);
		if (!page) {
			return;
		}
		page.setHidden(false);
		navigationUtil.getNavigationModel().commit().start();
		dojo.publish(constants.Topic.Space.refresh,[constants.Action.SHOW_PAGE, {pageId: pageId}]);
	},
	
	hide : function(pageId) {
		if (!pageId) {
			return;
		}
		var page = pageUtil.getPageNode(pageId);
		if (!page) {
			return;
		}
		page.setHidden(true);
		navigationUtil.getNavigationModel().commit().start();
		dojo.publish(constants.Topic.Space.refresh,[constants.Action.HIDE_PAGE, {pageId: pageId}]);
	},
	
	isHidden : function(pageId) {
		if (!pageId) {
			return true;
		}
		var page = pageUtil.getPageNode(pageId);
		if (!page) {
			return true;
		}
		return page.isHidden();
	},
	
	isNotHidden : function(spaceId) {
		return !com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerActions.page.isHidden(spaceId);
	},
	
	isHideActionDisplayed : function(pageId) {
		var action = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerActions.page;
		return action.canSetHidden(pageId, true) && action.isNotHidden(pageId) && constants.changeHideMenuItemLabel === "false";
	},
	
	isHideActionDisplayed2 : function(pageId) {
		var action = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerActions.page;
		return action.canSetHidden(pageId, true) && action.isNotHidden(pageId) && constants.changeHideMenuItemLabel;
	},
	
	isShowActionDisplayed : function(pageId) {
		var action = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerActions.page;
		return action.canSetHidden(pageId, false) && action.isHidden(pageId);
	}
};
})();

}
