if(!dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.DetailedSpacesList"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.DetailedSpacesList"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.spacemanager.widget.DetailedSpacesList");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.mm.builder.iwidget.spacemanager.widget.ModelAwareMixin");
dojo.require("com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants");
dojo.require("com.ibm.mm.builder.iwidget.spacemanager.widget.SpacesList");
dojo.require("com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceItem");
dojo.require("com.ibm.mm.builder.iwidget.spacemanager.widget.PageItem");
dojo.require("com.ibm.mm.builder.iwidget.spacemanager.widget.spaceFilter");
dojo.require("com.ibm.mm.builder.iwidget.spacemanager.widget.Toggler");
dojo.require("com.ibm.mm.builder.iwidget.spacemanager.widget.ActionsMenu");
dojo.require("dojo.fx");
dojo.require("dijit.layout.StackContainer");
dojo.require("dijit.layout.ContentPane");
dojo.require("dojo.string");

dojo.declare("com.ibm.mm.builder.iwidget.spacemanager.widget.DetailedSpacesList", 
		[dijit._Widget, dijit._Templated], 
{
	templatePath : dojo.moduleUrl("com.ibm.mm.builder", "iwidget/spacemanager/widget/templates/DetailedSpacesList.html"),
	
	widgetsInTemplate : true,
	
	constructor : function() {
		this.spaceUtil = com.ibm.mm.builder.utils.spaceUtil;
		this.enablerUtil = com.ibm.mm.builder.utils.enablerUtil;
		this.navigationUtil = com.ibm.mm.builder.utils.navigationUtil;
		this.spaceManagerUtil = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerUtil;
		this.pageUtil = com.ibm.mm.builder.utils.pageUtil;
		this._bundle = com.ibm.mm.builder.coreWidgetsStrings;
		this._spacesLoaded = {};
		this._subscriptions = [];
	},
	
	postMixInProperties : function() {
		this._constants = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants;
	},
	
	uninitialized: function() {
        dojo.forEach(this._subscriptions, dojo.unsubscribe);
    },
	
	postCreate : function() {
		this._subscriptions.push(dojo.subscribe(this._constants.Topic.Category.change, dojo.hitch(this, this.changeCategory)));
		this._subscriptions.push(dojo.subscribe(this._constants.Topic.Space.filter, dojo.hitch(this, this.filterByTitle)));
		this._subscriptions.push(dojo.subscribe(this._constants.Topic.Space.refresh, dojo.hitch(this, this.refreshSpaces)));
		
		this._container.addChild(new com.ibm.mm.builder.iwidget.spacemanager.widget.SpacesList({spacesListType: this._constants.ALL}, dojo.doc.createElement("div")));
		this._container.addChild(new com.ibm.mm.builder.iwidget.spacemanager.widget.SpacesList({spacesListType: this._constants.FAVORITE}, dojo.doc.createElement("div")));
		this._container.addChild(new com.ibm.mm.builder.iwidget.spacemanager.widget.SpacesList({spacesListType: this._constants.MY}, dojo.doc.createElement("div")));
		
		this._allSpacesList = this._getSpacesListByIndex(0);
		this._favoriteSpacesList = this._getSpacesListByIndex(1);
		this._mySpacesList = this._getSpacesListByIndex(2);
		
		this._container.startup();
		
		this.spaceManagerUtil.util.delayCall(dojo.hitch(this, this.changeCategory, "all", true), 200);
	},
	
	_selectCategoryByIndex : function(index) {
		var child = this._getSpacesListByIndex(index);
		if (child) {
			this._container.selectChild(child);
		}
	},
	
	_getSpacesListByIndex : function(index) {
		var children = this._container.getChildren();
		if (index >= 0 && index < children.length) {
			return children[index];
		}
	},
	
	changeCategory : function(category, isRefreshNeeded) {
		var needRefresh = isRefreshNeeded || !this._spacesLoaded[category];
		
		switch (category) {
			case this._constants.ALL:
				this.currentCategory = this._constants.ALL;
				this._selectCategoryByIndex(0);
				this._showAllSpaces(needRefresh);
				break;
			case this._constants.FAVORITE:
				this.currentCategory = this._constants.FAVORITE;
				this._selectCategoryByIndex(1);
				this._showFavoriteSpaces(needRefresh);
				break;
			case this._constants.MY :
				this.currentCategory = this._constants.MY;
				this._selectCategoryByIndex(2);
				this._showMySpaces(needRefresh);
				break;
		}
		this._category = category;
		this._spacesLoaded[category] = true;
	},
	
	_showAllSpaces : function(isRefreshNeeded) {
		if (isRefreshNeeded) {
			var containerNode = this._allSpacesList.domNode;
			var spaceModel = this.spaceUtil.getSpaceModel();
			this._allSpacesList.refresh(spaceModel.iterator());
		}
	},
	
	_showFavoriteSpaces : function(isRefreshNeeded) {
		if (isRefreshNeeded) {
			var containerNode = this._favoriteSpacesList.domNode;
			var spaceModel = this.spaceUtil.getSpaceModel();
			this._favoriteSpacesList.refresh(spaceModel.findFavorites());
		}
	},
	
	_showMySpaces : function(isRefreshNeeded) {
		if (isRefreshNeeded) {
			this._mySpacesList.refresh({hasNext : function(){return false;}});
		}
	},
	
    _toTurkishLowerCase : function(aStr) {      
        if (aStr === "")
        {
          return aStr;
        } else {
            // manually lowercase non-dotted uppercase i to a non-dotted lowercase i
            var manuallyLoweredStr = aStr.replace(/I/g, '\u0131');
            // the toLowerCase() will now leave the already processed I characters alone
            return manuallyLoweredStr.toLowerCase();
        }
    },
        
    filterByTitle : function(title) {
        dojo.query(".space_item_wrapper", this.domNode).forEach(function(node) {
            var titleNode = dojo.query(".title", node);
            if (titleNode && titleNode.length > 0) {

                // setup variables for handling the special turkish characters (especially the 4 i's)           
                var turkishLowerCaseNodeTitle = this._toTurkishLowerCase(com.ibm.mm.builder.utils.htmlUtil.unEscapeString(titleNode[0].innerHTML));
                var turkishLowerCaseTitle = (title !== "") ? this._toTurkishLowerCase(title) : "";

                // setup variables for all other languages
                var lowerCaseNodeTitle = com.ibm.mm.builder.utils.htmlUtil.unEscapeString(titleNode[0].innerHTML).toLowerCase();
                var lowerCaseTitle = (title !== "") ? title.toLowerCase() : "";
                
                // keep the nodes visible, if either the turkish values match or the regular ones. This
                // gives a few false positives for turkish though, but we're no longer missing any search 
                // results. The code works just as before for all other languages.
                var display = (title === "" || (turkishLowerCaseNodeTitle.indexOf(turkishLowerCaseTitle) != -1) 
                                            || (lowerCaseNodeTitle.indexOf(lowerCaseTitle) != -1)) ? "block" : "none";
                
                dojo.style(node, "display", display);                
                //ARIA
                if (display === "none") {
                    dojo.attr(node, "aria-hidden", "true");
                }
                else {
                    dojo.removeAttr(node, "aria-hidden");
                }
            }
        }, this);
    },
	
	_refreshSpacesList : function(category) {
		this.changeCategory(category || this._constants.ALL, true);
	},
	
	refreshSpaces : function(actionType, payload) {
		dojo.publish(this._constants.Topic.Common.hideMessage);
		if(!actionType || !payload){
			this._refreshSpacesList(this._category);
			return;
		}
		this[actionType](payload);
	},
	
	refreshWithDeletePage : function(payload){
		var pageId = payload.pageId;
		var pageItem = this._getPageItemById(pageId);
		if (pageItem) {
			pageItem.remove();
		}
	},
	
	refreshWithEditPage : function(payload){
		var pageId = payload.pageId;	
		var pageItem = this._getPageItemById(pageId);
		if(pageItem){
			pageItem.refresh();
			pageItem.refreshActionsMenu();
		}
	},
		
	refreshWithMovePage : function(payload){

		var currentPageId = payload.currentPageId;
		var targetPageId = payload.targetPageId;
		var position = payload.position;

		var pageItem = this._getPageItemById(currentPageId);
		if(pageItem){
			pageItem.move(targetPageId, position);
		}
		
	},
	
	refreshWithShowPage :function(payload){
		var pageId = payload.pageId;
		this._togglePageHidden(pageId, false);
	},
	
	refreshWithHidePage : function(payload){
		var pageId = payload.pageId;
		this._togglePageHidden(pageId, true);
	},
	
	_getPageNodeById :function(pageId){
		var pageNodes = dojo.query(".dijitVisible [page_id='"+pageId+"']");
		return pageNodes.length > 0 ? pageNodes[0] : null;
	},
	
	_getPageItemById : function(pageId){
		var pageNode = this._getPageNodeById(pageId);
		if (pageNode) {
			return dijit.byNode(pageNode);
		}else{
			return null;
		}
	},
	
	_togglePageHidden : function(pageId, hidden){
		var pageItem = this._getPageItemById(pageId);
		if(pageItem){
			if (hidden) {
				pageItem.hide();
			}
			else {
				pageItem.show();
			}
		}
	},	
	
	refreshWithNewPages : function(payload){
		var spaceId = payload.spaceId;
		var parentPageId = payload.parentPageId;
		var page = payload.page;
		
		var parentPageNode = this._getPageNodeById(parentPageId);
		if(parentPageNode){ //if parent page is not root node of space
			var pageItem = this._getPageItemById(parentPageId);
			if (pageItem) {
				pageItem.createSubPage(page);
			}
		}else{ // add pages under space
			var spaceItem = this._getSpaceItemById(spaceId);
			if (spaceItem) {
				spaceItem.createSubPage(page);
			}
		}
	},
		
	refreshWithEditSpace : function(payload){
		var spaceId = payload.spaceId;
		var spaceItem = this._getSpaceItemById(spaceId);
		if (spaceItem) {
			spaceItem.refresh();
		}
	},
	
	
	refreshWithChangeOwner : function(payload){
		var spaceId = payload.spaceId;
		var needRemoveSpace = payload.needRemoveSpace;		
		var spaceItem = this._getSpaceItemById(spaceId);
		
		if(spaceItem){			
			var space = this.spaceUtil.getSpaceNode(spaceId);
			if(!this.spaceUtil.isVisiable(space)){
				spaceItem.destroyRecursive();
				return;
			}
			
			 // invalidate root navigation node of a space after change owner
				var rootNavID = space.getRootNavigation();
				var navModel = this.navigationUtil.getNavigationModel();
				if (rootNavID){
					navModel.invalidate(rootNavID);
				}
           
			if (needRemoveSpace) {
				spaceItem.remove();
			} else {
				
				spaceItem.refresh();
				spaceItem.refreshActionsMenu();
			}
			
		}
	},
	
	refreshWithCreateSpace : function(payload){
		
		var spaceId = payload.spaceId;
		var space = this.spaceUtil.getSpaceNode(spaceId);
		
		if(this.currentCategory === this._constants.ALL || space.isFavorite()) {
			var spacesListNode = dojo.query(".spaces_list").filter(function(item){return (dojo.hasClass(item, "dijitVisible"));})[0];
			
			var spacesList = dijit.byNode(spacesListNode);
			if (spacesList) {
				spacesList.createSpace(space);
			}
		}
	},
	
	refreshWithDeleteSpace : function(payload){
		var spaceId = payload.spaceId;
		var spaceItem = this._getSpaceItemById(spaceId);
		if (spaceItem) {
			spaceItem.remove();
		}
	},
		
	refreshWithMakeHomeSpace : function(payload){
		var spaceId = payload.spaceId;
		var originalHomeSpaceId = payload.originalHomeSpaceId;
		
		var spaceItem = this._getSpaceItemById(spaceId);
		if (spaceItem) {
			spaceItem.makeHome();
			spaceItem.truncateSpaceTitle();
		}
		
		var originalHomeSpace = this._getSpaceItemById(originalHomeSpaceId);
		if (originalHomeSpace) {
			originalHomeSpace.unMakeHome();
			originalHomeSpace.truncateSpaceTitle();
		} 
	},
	
	refreshWithUnmakeHomeSpace : function(payload){
		var spaceId = payload.spaceId;
		var spaceItem = this._getSpaceItemById(spaceId);
		if (spaceItem) {
			spaceItem.unMakeHome();
			spaceItem.truncateSpaceTitle();
		}
	},
	
	refreshWithShowSpace : function(payload){
		var spaceId = payload.spaceId;		
		this._toggleSpaceHidden(spaceId, false);
	},
	
	refreshWithHideSpace : function(payload){
		var spaceId = payload.spaceId;
		this._toggleSpaceHidden(spaceId, true);
	},
	
	_toggleSpaceHidden : function(spaceId, hidden){
		var spaceItem = this._getSpaceItemById(spaceId);
		if(spaceItem){
			if (hidden) {
				spaceItem.hide(spaceId);
			}
			else {
				spaceItem.show(spaceId);
			}
		}
	},	
	
	_getSpaceNodeById : function(spaceId){
		var spaceNodes = dojo.query(".dijitVisible [space_id='"+spaceId+"']");
		return spaceNodes.length > 0 ? spaceNodes[0] : null;
	},
	
	_getSpaceItemById : function(spaceId){
		var spaceNode = this._getSpaceNodeById(spaceId);
		if (spaceNode) {
		    //fix defect 16920, dijit.byNode doesn't work if the space is not opened.
			var spaceItems = dijit.registry.byClass("com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceItem");
			var items = spaceItems.toArray();
			var item = null;
			for (var i=0;i<items.length;i++){
				if (items[i].spaceId == spaceId){
					item = items[i];
					break;
				}
			}
			return item;
		}else{
			return null;
		}
	},
	
	refreshWithAddFavorite : function(payload){
		var spaceId = payload.spaceId;
		this._toggleSpaceFavorite(spaceId, true);
		
	},
	
	refreshWithRemoveFavorite : function(payload){
		var spaceId = payload.spaceId;
		this._toggleSpaceFavorite(spaceId, false);
	},
	
	_toggleSpaceFavorite : function(spaceId, setAsFavorite){
		var spaceItem = this._getSpaceItemById(spaceId); 
		if(spaceItem){
			if (setAsFavorite) {
				spaceItem.addToFavorite();
			}else{
				spaceItem.removeFromFavorite();
			}
		}
	}

});

}
