/** Licensed Materials - Property of IBM, 5724-U69, (C) Copyright IBM Corp. 2009, 2010 - All Rights reserved.  **/
dojo.provide("com.ibm.themes.PageBuilder2.theme");

dojo.i18n._preloadLocalizations("com.ibm.themes.PageBuilder2.nls.theme", ["ROOT","ar","ca","cs","da","de","de-de","el","en","en-gb","en-us","es","es-es","fi","fi-fi","fr","fr-fr","he","he-il","hr","hu","it","it-it","ja","ja-jp","ko","ko-kr","nb","nl","nl-be","nl-nl","no","pl","pt","pt-br","pt-pt","ro","ro-ro","ru","sk","sl","sv","th","tr","uk","xx","zh","zh-cn","zh-tw"]);


if(!dojo._hasResource["com.ibm.pb.logging.FirebugLogger"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.logging.FirebugLogger"] = true;
dojo.provide("com.ibm.pb.logging.FirebugLogger");

if(window.console && window.console.firebug && window.ibmConfig && ibmConfig.useFirebugLogger) {
	var lvl = com.ibm.mashups.enabler.logging.LogLevel;
	
	var fbgLogger = dojo.declare("com.ibm.pb.logging.FirebugLogger", null, {
		methods: {},
		constructor: function(name, parent) {
			this.name = name;
			this.parent = parent;
			this._loggers = {};
			this._initConfig(ibmConfig && ibmConfig.traceConfig);
		},
		_initConfig: function(config) {
			if(config && config.length > 0) {
				this._test = new RegExp(dojo.isArray(config) ? config.join("|") : config);
			}
			else {this._test = null;}
		},
		_getTest: function() {
			if(!this._test && this.parent) {return this.parent._getTest();}
			return this._test;
		},
		getLogger: function(loggerName) {
			if(this.parent) {return this.parent.getLogger(loggerName);}
			if(!this._loggers[loggerName]) {
				this._loggers[loggerName] = new this.constructor(loggerName, this);
			}
			return this._loggers[loggerName];
		},
		addHandler: function(handler) {
			// no-op, unsupported
		},
		removeHandler: function(handler) {
			// no-op, unsupported
		},
		entering: function(methodName, args) {
			var trc = lvl.TRACE;
			if(this.isLoggable(trc)) {
				this.log(trc, methodName, "ENTRY ${0}", [args]);
			}
		},
		exiting: function(methodName, args) {
			var trc = lvl.TRACE;
			if(this.isLoggable(trc)) {
				this.log(trc, methodName, "RETURN ${0}", [args]);
			}
		},
		info: function(methodName, message, args) {
			this.log(lvl.INFO, methodName, message, args);
		},	
		warning: function(methodName, message, args) {
			this.log(lvl.WARNING, methodName, message, args);
		},	
		severe: function(methodName, message, args) {
			this.log(lvl.SEVERE, methodName, message, args);
		},
		trace: function(methodName, message, args) {
			this.log(lvl.TRACE, methodName, message, args);
		},
		log: function(logLevel, methodName, message, args) {
			if(this.isLoggable(logLevel)) {
				var msg = this._firebugStyle(this.name + " " + methodName + " - " + message, args);
				console[this.methods[this._normalizeLevel(logLevel)]].apply(window, msg);
			}
		},
		_firebugStyle: function(text, args) {
			var argsArr = [], msg = dojo.string.substitute(text, args, function(value, key){
				argsArr.push(value);
				return dojo.isString(value) ? "%s" : "%o";
			});
			argsArr.unshift(msg);
			return argsArr;
		},
		_normalizeLevel: function(level) {
			var logLvl = lvl.SEVERE;
			if(level <= lvl.SEVERE) {logLvl = lvl.SEVERE;}
			if(level <= lvl.WARNING) {logLvl = lvl.WARNING;}
			if(level <= lvl.INFO) {logLvl = lvl.INFO;}
			if(level <= lvl.TRACE) {logLvl = lvl.TRACE;}
			return logLvl;
		},
		isLoggable: function(logLevel) {
			if(logLevel > lvl.TRACE) {return true;	}
			if(!(ibmConfig && ibmConfig.isDebug)) {return false;}
			var test = this._getTest();
			return test && test.test(this.name);
		}
	});
	
	var methods = fbgLogger.prototype.methods;
	methods[lvl.INFO] = "info";
	methods[lvl.WARNING] = "warn";
	methods[lvl.SEVERE] = "error";
	methods[lvl.TRACE] = "debug";
	
	var baseFbgLogger = com.ibm.mashups.enabler.logging.Logger = new com.ibm.pb.logging.FirebugLogger();
	
	ibmConfig.extensions.push( { 
	    "com.ibm.mashups.enabler.logging.Logger.getLogger": { 
	        type: "around", 
	        handler: function (func, args) { 
	            return baseFbgLogger.getLogger.apply(baseFbgLogger, args);
	        } 
	    } 
	});
}

}

if(!dojo._hasResource["com.ibm.pb.debug.liveTracing"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.debug.liveTracing"] = true;
dojo.provide("com.ibm.pb.debug.liveTracing");

(function(){
	
	var arrayToString = function(arr) {
		var str = "";
		while(arr.length > 0) {
			str += "'" + arr.shift() + "'";
			if(arr.length > 0) {
				str += ",";
			}
		}
		return str;
	};
	
	var ltrace = com.ibm.pb.debug.liveTracing = {
		traceConfigCookieName: "digest.ignore.debug.traceString",
		useFirebugLoggerCookieName: "digest.ignore.debug.useFirebugLogger",
		
		setTracing: function(traceSetting, useFirebugLogger) {
			// supports two formats:
			// string:   "happy,sad,glad.smiling,glad.grinning"
			// array:	["happy","sad","glad.smiling","glad.grinning"]
			if(traceSetting) {
				if(dojo.isString(traceSetting)) {
					var parts = traceSetting.split(",");
					traceSetting = arrayToString(parts);
				}
				else if(dojo.isArray(traceSetting)) {
					traceSetting = arrayToString(traceSetting);
				}
				dojo.cookie(ltrace.traceConfigCookieName, "[" + traceSetting + "]", {path: "/"});
			}
			if(useFirebugLogger !== undefined) {
				dojo.cookie(ltrace.useFirebugLoggerCookieName, useFirebugLogger == true, {path: "/"});
			}
		},
		clearTracing: function() {
			dojo.cookie(ltrace.traceConfigCookieName, null, {path: "/", expires: -1});
		},
		showEffectiveTracing: function() {
			// what is actually being used
			alert(ibmConfig.traceConfig);
		},
		showConfiguredTracing: function() {
			// what is set in the cookie
			alert(dojo.cookie(ltrace.traceConfigCookieName));
		}
	}
})();

}

if(!dojo._hasResource["com.ibm.data.SelectionModel"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.data.SelectionModel"] = true;
dojo.provide("com.ibm.data.SelectionModel");

dojo.declare("com.ibm.data.SelectionModel",
	null,
	{
		// treeModel: An instance of a DataTreeModel which backs this SelectionModel
		treeModel: null,
		
		// selectionPath: Array of items in the DataTreeModel which represent the current selection path.
		//		Starts at the currently selected node and goes up the tree to the root.
		selectionPath: [],
		
		constructor: function(args) {
			dojo.mixin(this, args);
			this.modelConnection = dojo.connect(this.treeModel, "onTreeChange", this, "onModelTreeChange");
		},
		
		atLevel: function(level, fromRoot) {
			return this.selectionPath[fromRoot ? this.selectionPath.length - 1 - level : level];
		},
		getPath: function() {
			return this.selectionPath.slice();
		},
		
		onModelTreeChange: function(/*Item*/ childItem, /*Item*/ oldParentItem, /*Item*/ newParentItem, /*Item*/ nextSiblingItem) {
			if(oldParentItem != newParentItem 
					&& dojo.some(this.selectionPath, function(item) {
						return this._itemIsEqual(item, childItem);
					}, this)) {
				this._calculateNewPath(this.selectionPath[0]);
				this.onSelectionPathChange(false);
			}
		},
		_itemIsEqual: function(item1, item2) {
			return (item1 && this.treeModel.getIdentity(item1)) == (item2 && this.treeModel.getIdentity(item2));
		},		
		_calculateNewPath: function(lastSelected) {
			// the model is built from the top-down, so the model should already have
			// loaded all the ancestors of the lastSelected item so that model.getParent()
			// returns loaded items
			var cur = lastSelected;
			this.selectionPath.splice(0, this.selectionPath.length);
			while(cur) {
				this.selectionPath.push(cur);
				cur = this.treeModel.getParent(cur);
			}
		},
		
		onSelectionPathChange: function(/*Boolean*/ selectionChanged) {
			// summary: Event called when the selection path is updated.  This can occur when the
			//		selection model changes because the tree was restructured, changing the path
			//		from the currently selected node to the root by reparenting some nodes, or
			//		by actually changing the currently selected node in the tree.
			// selectionChanged: Boolean true if the currently selected node changed, false if the
			//		path changed but the currently selected node is the same.
		},
		
		changeSelection: function(/*item*/ newSelection) {
			this._calculateNewPath(newSelection);
			this.onSelectionPathChange(true);
		}
	}
);

}

if(!dojo._hasResource["com.ibm.portal.xslt"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.portal.xslt"] = true;
dojo.provide( "com.ibm.portal.xslt" );

dojo.require( "dojox.data.dom" );

dojo.declare( "com.ibm.portal.xslt.TransformerFactory",
    null,
    {
        constructor: function() {
            // create our internal XSL cache
            this._xsltMap = [];
        },
        /**
         * summary:
         *		Creates a new com.ibm.portal.xslt.Transformer object.
         */
        newTransformer: function(/*String*/ xsltUrl) {
             ibm.portal.debug.entry( "newTransformer", [ xsltUrl ] );
             var trf = this._getCached(xsltUrl);
             if(trf === null) {
             	trf = new com.ibm.portal.xslt.Transformer(xsltUrl);
             	this._xsltMap.push({url: xsltUrl, transformer: trf});
             }
             return trf;
        },
        _getCached: function(xsltUrl) {
        	var xslt = null;
             // try to get the XSL object from our internal cache
             for (var i=0; i<this._xsltMap.length; i++) {
                 var entry = this._xsltMap[i];
                 if (xsltUrl == entry.url) {
                     // alert("cache hit");
                     xslt = entry.transformer;
                     break;
                 }
             }
             return xslt;
        }
    }
);

dojo.declare( "com.ibm.portal.xslt.Transformer",
    null,
    {
        /**
         * summary:
         *		Creates a new transformer for cross-browser XSLT operations
         */
        constructor: function(/* String */ xsltUrl) {
            this._xslt = com.ibm.portal.xslt.loadXsl(xsltUrl);
        },
        /**
         * summary:
         *		Transforms the given xmlDoc and puts the result into the passed
         *		DOM node
         *
         * xmlDoc:
         * 		XML Document to transform
         * xsltParams:
         *		Set of configuration parameters to pass to the transformation
         *		engine.  Object map in this format: {param1Name: "param1Value", param2Name: "param2Value"}
         * node:
         * 		DOM node to put the transform results in
         * doc:
         * 		HTML document to update
         */ 
        transformToRegion: function(xmlDoc, xsltParams, node, doc) {
			if (dojo.isIE) {
				var resultStr = com.ibm.portal.xslt.transform(xmlDoc, this._xslt, null, xsltParams, true);
				node.innerHTML = dojo.string.trim(resultStr);
			} else {
				/*
				var resultsDoc = this.transformToDocument( xmlDoc, xsltParams);
				dojox.data.dom.replaceChildren(node, resultsDoc.documentElement);
				*/
				var frag = com.ibm.portal.xslt.gecko._transformToFragment(xmlDoc, this._xslt, null, xsltParams, doc);
				node.innerHTML = "";
				node.appendChild(frag);
			}
        },
        /** 
         * summary:
         *		Transforms the given xmlDoc and returns a new XML document or String containing
         *		the result
         * xmlDoc:
         * 		XML Document to transform
         * xsltParams:
         *		Set of configuration parameters to pass to the transformation
         *		engine.  Object map in this format: {param1Name: "param1Value", param2Name: "param2Value"}
         * bReturnAsString:
         * 		Boolean indicating whether a XML document or String should be returned.
         */
        transformToDocument: function(xmlDoc, xsltParams, bReturnAsString) {
             var results = com.ibm.portal.xslt.transform(xmlDoc, this._xslt, null, xsltParams, bReturnAsString);
             return results;
        }
    }
);

// global transformer factory
com.ibm.portal.xslt.TRANSFORMER_FACTORY = new com.ibm.portal.xslt.TransformerFactory();



//---------------------------------------------------------------------- xml related utility methods
/*
 * loadXml(sUrl) - returns oDomDoc. parses xml from the url into DOM document object.
 * loadXmlString() - returns oDomDoc. parses xml from the contents of the string into DOM document object.
 * loadXsl()
 * transform()
 */
com.ibm.portal.xslt.ie = {};
com.ibm.portal.xslt.gecko = {};

com.ibm.portal.xslt.getXmlHttpRequest = function() {
	var oXml = null;
	if (typeof ActiveXObject != "undefined") {
		oXml = new ActiveXObject("Microsoft.XMLHTTP");
	} else {
		oXml = new XMLHttpRequest();
	}
  return oXml;
};

com.ibm.portal.xslt.loadXml = function(sUrl) {
	if (typeof ActiveXObject != "undefined") {
		return com.ibm.portal.xslt.ie.loadXml(sUrl);
	}
	else {
		return com.ibm.portal.xslt.gecko.loadXml(sUrl);
	}
};

com.ibm.portal.xslt.loadXmlString = function(sXml) {
	if (typeof ActiveXObject != "undefined") {
		return com.ibm.portal.xslt.ie.loadXmlString(sXml);
	}
	else {
		return com.ibm.portal.xslt.gecko.loadXmlString(sXml);
	}
};

com.ibm.portal.xslt.loadXsl = function(sUrl) {
	if (typeof ActiveXObject != "undefined") {
		return com.ibm.portal.xslt.ie.loadXsl(sUrl);
	}
	else {
		return com.ibm.portal.xslt.gecko.loadXsl(sUrl);
	}
};

com.ibm.portal.xslt.transform = function (xml, xsl, sXslMode, aXslParams, bReturnString)
{
   ibm.portal.debug.entry( "transform", [xml,xsl,sXslMode,aXslParams,bReturnString] );  
   if (typeof ActiveXObject != "undefined") {
		return com.ibm.portal.xslt.ie.transform(xml, xsl, sXslMode, aXslParams, bReturnString);
   }
   else {
	   	return com.ibm.portal.xslt.gecko.transform(xml, xsl, sXslMode, aXslParams, bReturnString);
   }
};

com.ibm.portal.xslt.transformAndUpdate = function (/*HTMLElement*/nodeToUpdate, /*XMLDocument*/xml, /*XMLDocument*/xsl, /*String?*/sXslMode, /*Map*/aXslParams) {
	ibm.portal.debug.entry( "transformAndUpdate", [ nodeToUpdate, xml, xsl, sXslMode, aXslParams ]);
	
	if ( typeof ActiveXObject != "undefined" ) {
		var resultStr = com.ibm.portal.xslt.transform(xml, xsl, sXslMode, aXslParams, true);
		nodeToUpdate.innerHTML = dojo.string.trim(resultStr);
	} else {
		var doc = nodeToUpdate.ownerDocument ? nodeToUpdate.ownerDocument : document;
		var frag = com.ibm.portal.xslt.gecko._transformToFragment(xml, xsl, sXslMode, aXslParams, doc);
		nodeToUpdate.innerHTML = "";
		nodeToUpdate.appendChild(frag);
	}
	
	ibm.portal.debug.exit( "transformAndUpdate" );
};

//---------------------------------------------------------------------- IE xml related utility methods

com.ibm.portal.xslt.ie.XSLT_PROG_IDS = [
		"Msxml2.XSLTemplate.6.0",
		"Msxml2.XSLTemplate.5.0",
		"Msxml2.XSLTemplate.4.0",
		"MSXML2.XSLTemplate.3.0",
		"MSXML2.XSLTemplate"
	];
	
com.ibm.portal.xslt.ie.DOM_PROG_IDS = [
		"Msxml2.DOMDocument.6.0",
		"Msxml2.DOMDocument.5.0",
		"Msxml2.DOMDocument.4.0",
		"MSXML2.DOMDocument",
		"MSXML.DOMDocument",
		"Microsoft.XMLDOM"
	];
	
com.ibm.portal.xslt.ie.FTDOM_PROG_IDS = [
		"Msxml2.FreeThreadedDOMDocument.6.0",
		"Msxml2.FreeThreadedDOMDocument.5.0",
		"Msxml2.FreeThreadedDOMDocument.4.0",
		"MSXML2.FreeThreadedDOMDocument",
		"MSXML.FreeThreadedDOMDocument",
		"Microsoft.FreeThreadedXMLDOM"
	];
	
com.ibm.portal.xslt.ie._getMSXMLImpl = function(array) {
	// This iterates through the passed in array of Strings which represent ProgIDs for
	// MSXML objects, and attempts to find the first available one and returns an instance
	// to the caller
	for(var i = 0; i < array.length; i++) {
		try {
			var impl = new ActiveXObject(array[i]);
			if (impl) {
				return impl;
			}
		}
		catch(err){}
	}
	throw new Error("No MSXML implementation exists");
};

com.ibm.portal.xslt.ie.loadXml = function(sUrl) {
	//var oXmlDoc = new ActiveXObject("MSXML2.DOMDocument");
	var oXmlDoc = this._getMSXMLImpl(this.DOM_PROG_IDS);
	oXmlDoc.async=0;
	oXmlDoc.resolveExternals = 0;
  	if(!oXmlDoc.load(sUrl))
  	{
  		//Callers should catch this and can substitute their own error message
  		throw new Error("Error loading xml file " + sUrl);
  	}
	return oXmlDoc;

};

com.ibm.portal.xslt.ie.loadXmlString = function(sXml) {
	var oXmlDoc = this._getMSXMLImpl(this.DOM_PROG_IDS);
	oXmlDoc.async=0;
	oXmlDoc.resolveExternals = 0;
  	if(!oXmlDoc.loadXML(sXml))
  	{
  	    //Callers should catch this and can substitute their own error message
  		throw new Error("Error loading xml string " + sXml); 
  	}
	return oXmlDoc;
};

com.ibm.portal.xslt.ie.loadXsl = function(sUrl) {
	//we need to use MSXML2.FreeThreadedDOMDocument interface in order to support 
	//mode and parameters in XSL transformation.
	var oXslDoc = this._getMSXMLImpl(this.FTDOM_PROG_IDS);
	oXslDoc.async=0;
	oXslDoc.resolveExternals = 0;
  	if(!oXslDoc.load(sUrl))
  	{
  		//Callers should catch this and can substitute their own error message
  		throw new Error("Error loading xsl file " + sUrl);
  	}	
	return oXslDoc;
};

com.ibm.portal.xslt.ie.transform = function(xmlDoc, xsl, sXslMode, aXslParams,bReturnString) {
	var oXml = xmlDoc;
	var oXsl = xsl;

     try {		
		if (!oXsl.documentElement) {
			oXsl = this.loadXsl(xsl);
		}
	 }
	 catch(e) {
		var sMsg = e.message;
		throw new Error(""+sMsg, ""+sMsg);
	 }
	//create the xsl processor and apply the transformation
	var oXslt = this._getMSXMLImpl(this.XSLT_PROG_IDS);
	oXslt.stylesheet = oXsl;
	var oXslProc = oXslt.createProcessor();
	oXslProc.input = oXml;
	
	//set paramaters if any
	if(aXslParams) {
		for(var p in aXslParams) {
			oXslProc.addParameter(p, aXslParams[p]);
		}
	}
	if (sXslMode) {
		oXslProc.addParameter("mode", sXslMode);
	}
	
	if (bReturnString) {
		if(!oXslProc.transform()) {
			//Callers should catch this and can substitute their own error message
  			throw new Error("Error transforming xml doc " + oXml); 
  		}
  		return oXslProc.output;
	} else {
		var oHtmlDoc = this._getMSXMLImpl(this.DOM_PROG_IDS);
		oHtmlDoc.async = false;
		oHtmlDoc.validateOnParse = false;
		oXml.transformNodeToObject(oXsl,oHtmlDoc);
		return oHtmlDoc;	
	}
};

//---------------------------------------------------------------------- GECKO xml related utility methods

com.ibm.portal.xslt.gecko.loadXml = function(sUrl) {
    //var oXmlResponse = NG.ServerRequest.postRequest(sUrl);
//    if (oXmlResponse) return xmlLoadString(oXmlResponse.responseText);
//    else return null;
	var oDomDoc = null;
	if(dojo.isSafari) {
		var xhr = new XMLHttpRequest();
		xhr.open( "GET", sUrl, false );
		xhr.send( null );
		  
		if ( xhr.status == 200 ) {
			oDomDoc = xhr.responseXML;
		}
	}
	else {
		oDomDoc = document.implementation.createDocument('','',null);
		oDomDoc.async = 0; // this is the important part
		oDomDoc.load(sUrl);
	} 
	return oDomDoc;
};

com.ibm.portal.xslt.gecko.loadXmlString = function(sXml) {
    var parser = new DOMParser();
    try { oXmlDoc = parser.parseFromString(sXml, "text/xml"); }
    catch (exc) {
	    //Callers should catch this and can substitute their own error message
  		throw new Error("Error loading xml string " + sXml); 
    }
	return oXmlDoc;
};

com.ibm.portal.xslt.gecko.loadXsl = function(sUrl) {
	//This is done through createDocument because of anchor(#) we have in portal url. 
	//Do not change the code without testing the case.
	var oDomDoc = null;
	if(dojo.isSafari) {
		var xhr = new XMLHttpRequest();
		xhr.open( "GET", sUrl, false );
		xhr.send( null );
		  
		if ( xhr.status == 200 ) {
			oDomDoc = xhr.responseXML;
		}
	}
	else {
		oDomDoc = document.implementation.createDocument('','',null); 
		oDomDoc.async = 0; // this is the important part
		oDomDoc.load(sUrl);
	}
	
	return oDomDoc;
};

com.ibm.portal.xslt.gecko._getXSLTProc = function(xmlDoc, xsl, sXslMode, aXslParams) {
	var xslDoc = xsl;
	if(!xslDoc.documentElement) 
	{
		xslDoc = this.loadXsl(xsl);
	}        
    var proc = new XSLTProcessor();
    proc.importStylesheet(xslDoc); 

	
	//set parameters if any
	if(aXslParams) {
		for(var p in aXslParams)  {
			proc.setParameter(null, p, aXslParams[p]);
		}
	}
	
	if (sXslMode) {
		proc.setParameter(null, "mode", sXslMode);
	}
	
	return proc;
};

com.ibm.portal.xslt.gecko._transformToFragment = function(xmlDoc, xsl, sXslMode, aXslParams, doc) {
	var proc = com.ibm.portal.xslt.gecko._getXSLTProc(xmlDoc, xsl, sXslMode, aXslParams);
	
	var resultDoc = null;
	resultDoc = proc.transformToFragment(xmlDoc, doc);
	proc.clearParameters();
	return resultDoc;
};

com.ibm.portal.xslt.gecko.transform = function(xmlDoc, xsl, sXslMode, aXslParams,bReturnString) {
	try {
		var resultDoc = null;
		if (!bReturnString) {
			var proc = com.ibm.portal.xslt.gecko._getXSLTProc(xmlDoc, xsl, sXslMode, aXslParams);
			resultDoc = proc.transformToDocument(xmlDoc);
			return resultDoc;
		}
		else {
			resultDoc = com.ibm.portal.xslt.gecko._transformToFragment(xmlDoc, xsl, sXslMode, aXslParams, document);
		}

		var serializer = new XMLSerializer();
		// need to trim newlines and spaces from beginning and end so that the root node always has the same
		// number of child nodes regardless of the browser implementation
		// this should be lossless of real expected content
		var resultStr = dojo.string.trim(serializer.serializeToString(resultDoc));
		if(dojo.isOpera && resultDoc.firstChild && resultDoc.firstChild.nodeName == 'result') {
			var start = resultStr.indexOf("<result>") + 8;
			var end = resultStr.lastIndexOf("</result>");
			resultStr = dojo.string.trim(resultStr.substring(start, end));
		}
		return resultStr;    
    }
    catch (exc)
    {
        //alert("error transforming document: "+exc)
		//Callers should catch this and can substitute their own error message
  		throw new Error("Error transforming xml doc " + exc);
	}
};

/* This method sets the content of a layer within the HTML page
 * to the result of transforming the xml parameter by the xsl
 * parameter. The xml and xsl parameters may be of any form
 * supported by the transformXml() method. The layer parameter
 * may be either a DOM object or the name of a DOM object that
 * can be found using the findObject() method.
 */

com.ibm.portal.xslt.setLayerContentByXml = function (layer, xml, xsl, xslparam,bReturnString) {
    var result = com.ibm.portal.xslt.transform(xml,xsl,null,xslparam,bReturnString);
    if (layer.innerHTML) {
		layer.innerHTML = result;
	}
	else {
		var obj = document.getElementById(layer);
		obj.innerHTML = result;
	}
};

}

if(!dojo._hasResource["com.ibm.domUtilities"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.domUtilities"] = true;
/*
 * @author Ben
 */
dojo.provide( "com.ibm.domUtilities" );
/*
 * This module provides cross-browser functions for interacting with a DOM object to
 * create nodes and get and set attributes that may or may not be namespaced.  Since
 * browsers use various functions for interacting with namespaced DOM nodes and attributes,
 * this module abstracts those away and provides a single layer for using those operations.
 */

dojo.require( "dojox.xml.parser" );
dojo.require( "com.ibm.portal.xslt" );

(function(){
	var dUtil = com.ibm.domUtilities = {
		constants: {
			// NodeTypes: Constants for defining integer values for node type strings
			NodeTypes: {
				element: 1,
				attribute: 2,
				text: 3,
				cdata: 4,
				entity_reference: 5,
				entity: 6,
				processing_instruction: 7,
				comment: 8,
				document: 9,
				document_type: 10,
				document_fragment: 11,
				notation: 12
			}
		},
		
		nsInfo: function(/*String*/ str, /*Object*/ namespaces) {
			// summary: Extracts the namespace URI, prefix, and local name of a QName according to this
			//		object's namespaces map that includes known prefixes and their namespace URIs.  If
			//		the string is not namespaced, then the namespaceURI and prefix are set to null, and
			//		the localName is set to the str as-is.
			// str: QName to extract namespace from
			// namespaces: Map of namespaces where keys are namespace prefixes and values are the namespace URIs.
			// returns: Map - {namespaceURI: namespaceURI, prefix: prefix, localName: localName}
			var parts = str.split(":");
			var prefix, localName;
			if(parts.length > 1) {
				prefix = parts[0];
				localName = parts[1];
				return { namespaceURI: namespaces[prefix], prefix: prefix, localName: localName};
			}
			else {
				return { namespaceURI: null, prefix: null, localName: str};
			}
		},
		getAttribute: function(/*DOMNode*/ node, /*String*/ attrName, /*Object*/ namespaces) {
			// summary: Gets an attribute of the given node, supporting namespaced and 
			// 		non-namespaced attributes.
			// node: Node to retrieve the attribute value from
			// attrName: The name of the attribute to get from the node.
			//		If the attribute is namespaced, it will be split into its parts using the : delimiter
			//		and the namespace used during lookup will be the one keyed in the namespace map.
			// namespaces: Map of prefixes to namespaceURIs
			// returns: Object value of attribute
			var ret = null;
			var parts = dUtil.nsInfo(attrName, namespaces);
			if(parts.namespaceURI) {
				if (node.getAttributeNS) {
					ret = node.getAttributeNS(parts.namespaceURI, parts.localName);
				}
				else 
					if (dojo.isIE) {
						ret = node.attributes.getQualifiedItem(parts.localName, parts.namespaceURI);
						if (ret) {
							ret = ret.value;
						}
					}
					else {
						ret = node.getAttribute(attrName);
					}
			}
			else {
				ret = node.getAttribute( attrName );
			}
			return ret;
		},
		setAttribute: function(/*DOMNode*/ node, /*String*/ attrName, /*String*/ value, /*Object*/ namespaces) {
			// summary: Sets an attribute of the given node, supporting namespaced and 
			// 		non-namespaced attributes.
			// node: Node to set the attribute value on
			// attrName: The name of the attribute to set on the node.
			//		If the attribute is namespaced, it will be split into its parts using the : delimiter
			//		and the namespace used during lookup will be the one keyed in the namespace map.
			// value: The actual value to store in the node at the key attribute specified by attrName.
			// namespaces: Map of prefixes to namespaceURIs
			if (value === true) {
				value = "true";
			}
			else {
				if (value === false) {
					value = "false";
				}
				else 
					if (value === null) {
						value = "";
					}
			}
			var parts = dUtil.nsInfo(attrName, namespaces);
			if (parts.namespaceURI) {
				if (node.setAttributeNS) {
					node.setAttributeNS(parts.namespaceURI, attrName, value);
				}
				else 
					if (dojo.isIE && node.ownerDocument) {
						var attrNode = node.ownerDocument.createNode(dUtil.constants.NodeTypes.attribute, attrName, parts.namespaceURI);
						attrNode.value = value;
						node.setAttributeNode(attrNode);
					}
					else {
						node.setAttribute(attrName, value);
					}
			}
			else {
				node.setAttribute(attrName, value);
			}
		},
		removeAttribute: function(/*DOMNode*/ node, /*String*/ attrName, /*Object*/ namespaces) {
			// summary: Removes an attribute of the given node, supporting namespaced and 
			// 		non-namespaced attributes.
			// node: Node to remove the attribute from
			// attrName: The name of the attribute to remove from the node.
			//		If the attribute is namespaced, it will be split into its parts using the : delimiter
			//		and the namespace used during lookup will be the one keyed in the namespaces map.
			// namespaces: Map of prefixes to namespaceURIs
			var parts = dUtil.nsInfo(attrName, namespaces);
			if(parts.namespaceURI) {
				if(node.removeAttributeNS) {
					// for some reason we have to use the localName when getting the attribute even
					// though we have to use the full name when setting it
					node.removeAttributeNS( parts.namespaceURI, attrName );
				}
				else if(dojo.isIE) {
					node.attributes.removeQualifiedItem( parts.localName, parts.namespaceURI );
				}
				else node.removeAttribute( attrName );
			}
	        else node.removeAttribute( attrName );
		},
		hasAttribute: function(/*DOMNode*/ node, /*String*/ attrName, /*Object*/ namespaces) {
			// summary: Checks if an attribute of the given node exists, supporting namespaced and 
			// 		non-namespaced attributes.
			// node: Node to check for the existence of the attribute from
			// attrName: The name of the attribute to check from the node.
			//		If the attribute is namespaced, it will be split into its parts using the : delimiter
			//		and the namespace used during lookup will be the one keyed in this item or store's 
			// 		namespace map.
			// namespaces: Map of prefixes to namespaceURIs
			// returns: Boolean true if attribute exists, false otherwise
			var ret = null;
			var parts = dUtil.nsInfo(attrName, namespaces);
			if (parts.namespaceURI) {
				if (node.hasAttributeNS) {
					ret = node.hasAttributeNS(parts.namespaceURI, parts.localName);
				}
				else {
					if (dojo.isIE) {
						ret = node.attributes.getQualifiedItem(parts.localName, parts.namespaceURI) !== null;
					}
					else {
						ret = node.hasAttribute(attrName);
					}
				}
			}
			else {
				if (!dojo.isIE) {
					ret = node.hasAttribute(attrName);
				}
				else {
					ret = node.getAttributeNode(attrName) !== null;
				}
			}
			
			return ret;	
		},
		createElement: function(/*DOMDoc*/ doc, /*String*/ tagName, /*Object*/ namespaces, /*Object?*/ attrMap) {
			// summary: Cross-browser implementation for creating a namespaced node using the namespace
			//		map in this object to resolve prefixes to namespace URIs.
			//		If the tagName is not namespaced or a namespace URI cannot be resolved
			// 		using this object's namespaces map, a non-namespaced element will be created instead.
			// doc: DOMDoc document object to use to create the DOM node.
			// tagName: String name for the tag name of the element to create.  
			// 		Can be namespaced like prefix:localName or not like localName.
			// namespaces: Map of namespaces where keys are namespace prefixes and values are the namespace URIs.
			// attrMap: Optional argument specifying a key-value map of attributes to be
			// 		set on the node before returning it. 
			// returns: DOMNode A new DOM node that was created by doc
			var node = null;
			var parts = dUtil.nsInfo(tagName, namespaces);
			if(parts.namespaceURI) {
				if(doc.createElementNS) {
					// W3C standard way of creating namespaced elements
					node = doc.createElementNS(parts.namespaceURI, tagName);
				}
				else if(dojo.isIE) {
					// we have to check dojo.isIE because IE throws an error when trying to check for
					// the existence of particular methods on the document object
					
					// this is IE's way of creating a namespaced node
					// use the tagName since it already includes the prefix as well
					node = doc.createNode("element", tagName, parts.namespaceURI);
				}
			}
			// if we don't have a node at this point, just create it without a namespace
			if (!node) {
				node = doc.createElement(tagName);
			}
			
			for(var name in attrMap) {
				dUtil.setAttribute(node, name, attrMap[name], namespaces);
			}
			
			return node;
		},
		createFromJson: function(/*DOMDoc*/ doc, /*Object*/ def, /*Object*/ namespaces, /*DOMNode?*/ parentNode) {
			// summary: Creates a new element using a JSON object as a declarative definition of the structure
			//		to create.  Can pass in an optional parentNode argument to append the new element as a child
			//		of the parentNode.
			// doc: Document object to use for creating the DOM nodes and that will own the created element.
			// def: Object JSON object DOM definition specifying the structure to create.  Supports these properties -
			//		{
			//			name: String name of the element to create, can be namespace-prefixed using a prefix in the
			//				namespaces map argument
			//			attributes: Object map of attributes to set on the element with names and values which may 
			// 				be namespace-prefixed names
			//			children: Array of JSON object DOM definitions to allow creating nested structures with the
			//				same syntax
			//		}
			// namespaces: Object map of prefix-namespaceURI pairs to use for namespace resolution of elements and
			// 		attributes created by this function.
			// parentNode: DOMNode optional argument to specify the parent of the newly created element
			// returns: DOMNode the created element	
			var obj = null;
			if(!dojo.isObject(def)){
				obj =  doc.createTextNode(def);
				if (parentNode) {
					parentNode.appendChild(obj); // append the nodes to the DOM as they are created to avoid memory issues in IE
				}
			}
			else {
				obj = dUtil.createElement(doc, def.name, namespaces, def.attributes);
				if (parentNode) {
					parentNode.appendChild(obj); // append the nodes to the DOM as they are created to avoid memory issues in IE
				}
				dojo.forEach(def.children, function(childDef) {
					dUtil.createFromJson(doc, childDef, namespaces, obj);
				});
			}
			return obj;
		},
		removeChildren: function(node) {
			// summary: Removes all the children from a node and returns a NodeList of those orphaned children
			//		which may consist of children of different node types.
			// node: DOMNode to remove children from
			var arr = [];
			while(node.hasChildNodes()) {
				arr.push(node.removeChild(node.firstChild));
			}
			return dojo.NodeList.apply(null, arr);
		},
		textContent: function(/*DOMNode*/ node, /*String?*/ text) {
			// summary: Gets or sets the text content under a given DOM node.  This acts as a getter if 
			// 		one argument is passed, while it acts as a setter if two arguments are passed.
			// node: DOMNode to get/set the text content for
			// text: String optional argument specifying the text to set under the node, replacing the existing
			// 		text. 
			return dojox.xml.parser.textContent.apply(null, arguments);
		},
		innerXML: function(/*DOMNode*/ node) {
			// summary: Serializes a DOM node into a string representation of the DOM at that level (including the
			//		node itself).
			// node: DOMNode node to serialize
			return dojox.xml.parser.innerXML(node);
		},
		stringFromDoc: function(/*DOMNode*/ node) {
			// summary: Serializes a DOM node into a string representation of the DOM at that level (including the
			//		node itself).  Same as innerXML.
			// node: DOMNode node to serialize
			return dUtil.innerXML(node);
		},
		docFromString: function(/*String*/ str) {
			// summary: Deserializes/parses a string representation of a DOM document into a new DOM document object.
			// str: String to deserialize/parse
			return dojox.xml.parser.parse(str && str.length > 0 ? str : null);
			//return com.ibm.portal.xslt.loadXmlString(str && str.length > 0 ? str : null);
		},
		encodeXML: function(/*String*/ xmlStr, /*Boolean?*/ encodeQuotes) {
			// summary: Encodes a string for inclusion into an XML document so that any XML delimiters will
			//		be encoded as CDATA.
			// xmlStr: String value to encode
			// encodeQuotes: Boolean optional argument indicating whether or not quotes should be encoded as
			//		well.  By default, single and double quotes are not encoded in the returned string for
			//		increased flexibility depending on the context in which the caller uses the encoded string.
			if (dojo.isString(xmlStr)) {
				xmlStr = xmlStr.replace(/&/gm, "&amp;").replace(/</gm, "&lt;").replace(/>/gm, "&gt;");
				if (encodeQuotes) {
					xmlStr = xmlStr.replace(/'/gm, "&#039;").replace(/"/gm, "&#034;");
				}
				return xmlStr;
			}
			else {
				if (xmlStr !== null) {
					return xmlStr;
				}
				else {
					return "";
				}
			}
		},
		decodeXML: function(/*String*/ xmlStr, /*Boolean?*/ decodeQuotes) {
			// summary: Decodes an XML-encoded string so that any XML-encoded characters will be decoded
			//		to their non-encoded value.
			// xmlStr: String value to decode
			// decodeQuotes: Boolean optional argument indicating whether or not quotes should be decoded as
			//		well.  By default, single and double quotes are not decoded in the returned string for
			//		increased flexibility depending on the context in which the caller uses the decoded string.
			if (dojo.isString(xmlStr)) {
				xmlStr = xmlStr.replace(/&lt;/gm, "<").replace(/&gt;/gm, ">").replace(/&amp;/gm, "&");
				if (decodeQuotes) {
					xmlStr = xmlStr.replace(/&#039;/gm, "\'").replace(/&#034;/gm, "\"");
				}
				return xmlStr;
			}
			else {
				if (xmlStr != null) {
					return xmlStr;
				}
				else {
					return "";
				}
			}
		}
	};
	
	dUtil.constants.MSXML_NodeTypes = dUtil.constants.NodeTypes;	// backwards compat
})();


}

if(!dojo._hasResource["com.ibm.utilities"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.utilities"] = true;
/*
 * @author Ben
 */ 
dojo.provide("com.ibm.utilities");




com.ibm.utilities = {
	urlToProxyUrl: function ( /*String*/ url, /*String?*/ proxyURI ) {
		var ret = proxyURI ? proxyURI : "/proxy";
		var protocol = "http";
		var colon = url.indexOf('://');
		if(colon > -1) {
			protocol = url.substring(0, colon);
			url = url.substring(colon + 3);
		}
		url = url.replace(/:/g, '%3A');
		
		return ret + '/' + protocol + '/' + url;
	},
	withBaseUrl: function(/*String*/ relativeUrl) {
		// summary: Rewrites a relative url to include the base url that's present in
		//		the href attribute of the first base tag found in the document if one exists.
		//		If one does not exist, this returns the relative url argument unchanged.
		//		This is useful for fixing relative URLs in a document that includes a base
		//		url while using IE as it does not include base url calculations when dynamically
		//		changing href or src attributes on elements, or when modifying window.location
		//		properties.
		// relativeUrl: String url relative to the current host to rewrite
		if (relativeUrl.charAt(0) == '/') {
			return relativeUrl;
		}
		return com.ibm.utilities.baseUrl() + relativeUrl;
	},
	baseUrl: function() {
		// summary: Returns the base url used in the document for any relative url
		//		resolution.  This is retrieved by looking up the base tag in the document
		//		and returning its href attribute if it exists.  Otherwise, it simply
		//		returns the empty string.
		if(!this._baseUrl) {
			var base = dojo.doc.getElementsByTagName("base")[0];
			if (base) {
				this._baseUrl = base.getAttribute("href");
			}
			if (!this._baseUrl) {
				this._baseUrl = "";
			}
		}
		return this._baseUrl;
	},
	stripUrlFragment: function(/*String*/url) {
		// summary: Strips the fragment identifier from a url if one exists, returning
		//		the new url without any fragment identifiers.
		// url: String url to strip fragment identifiers
		var h = url.indexOf("#");
		if (h > -1) {
			url = url.substr(0, h);
		}
		return url;
	},
	stripTrailingSlash: function(/*String*/url) {
		// summary: Strips trailing slashes from a url if any exist, returning
		//		the new url without a slash at the end.
		// url: String url to strip any trailing slashes from
		if(!url) {
			return "";
		}
		else {
			return url.replace(/\/+$/g, "");
		}
	},
	actionIO: function(/*String*/ url, /*String*/ method) {
		if(url) {
			var form = dojo.doc.createElement("form");
			form.setAttribute("action", url);
			if (method) {
				method = method.toLowerCase();
			}
			switch(method) {
				case "get":
					form.setAttribute("method", "GET");
					break;
				case "post":
				case "delete":
				case "put":
					form.setAttribute("method", "POST");
					break;
				default:
			}
			dojo.body().appendChild(form);
			form.submit();
		}
	},
	refreshPage: function(){
		var url, hash = -1, bases = document.getElementsByTagName('base');
		if (bases.length > 0) {
			url = bases[0].href; // use url from base tag
		}
		else { // use current location with any hash removed
			url = top.location.href;
			hash = url.indexOf('#');
			if (dojo.isSafari < 4 && hash > -1) { // nothing but location.reload works in 
				window.location.reload(); // Safari when there is a hash in the url
			}
			if (hash > -1) {
				url = url.substring(0, hash);
			}
		}
		window.location.assign(url);  // refresh without reloading static content
	}
};

(function(){
	// unique (arbitrary) boundary
	var boundary = "{EB2F8DA2-5B2C-F66A-CDD0-A2D42143F5AC}";
	var newL = "\r\n";
	var sep = "--";
	var startB = newL + sep + boundary + newL;			
	var endB = sep + boundary + sep + newL;
	
	// used to capture the header
	var headerBodySplitterRegx = new RegExp(newL + newL);
	var headerRegx= new RegExp(newL + "\s*([^\r]*)\s*", "mg");
	var headerPartsRegx = /\s*([^:]*):\s*(.+)/;
	
	// used to find the boundary
	var boundaryRegx = /boundary\s*=\s*\"?([^\"]*)\"?/;
	
	var partHandler = function(partArgs, responsePart, ioArgs) {
		// use a try-catch so any errors in callback execution don't
		// kill the processing of other parts... this behaves as
		// if each part were a separate request with its own async
		// callback
		try {
			if(responsePart instanceof Error) {
				if (partArgs.error) {
					partArgs.error(responsePart, ioArgs);
				}
			}
			else {
				try {
					if (partArgs.load) {
						partArgs.load(responsePart, ioArgs);
					}
				}
				catch(err) {
					if (partArgs.error) {
						partArgs.error(err, ioArgs);
					}
				}
			}
			// always call the handle function if it exists
			if (partArgs.handle) {
				partArgs.handle(responsePart, ioArgs);
			}
		} catch(err2) {}
	};
	
	function xhrMime() {
		this.respHeaders = [];
		this.responseText = "";
		this.responseXML = null;
		this.status = 0;
		this.statusText = "";
		this.readyState = 0;
		this.onreadystatechange = function(){};
	}
	
	dojo.extend(xhrMime, {
		getResponseHeader: function(key) {
			key = key.toLowerCase();
			for(var i = 0, header, l = this.respHeaders.length;i < l; i++) {
                header = this.respHeaders[i];
				if (header[0].toLowerCase() == key) {
					return header[1];
				}
			}
			return null;
		},
		getAllResponseHeaders: function() {
			var str = "";
			for(var i = 0, header,l = this.respHeaders.length; i < l; i++) {
                header = this.respHeaders[i];
				str += header[0] + ": " + header[1];
				if(i < l - 1) {
					str += "\n";
				}
			}
			return str;
		},
		send: function(){},
		open: function(){},
		abort: function(){},
		setRequestHeader: function(){}
	});
	
	var unfoldHeaders = function(headerSection) {
		return headerSection.replace(/\r\n\s/mg, " ");
	};
	
	var defaultContentHandler = function(partArgs, partXhr) {
		var xmlPart = null;
		if(partArgs.handleAs == "xml") {
			// create document object from text string
			try {
				xmlPart = com.ibm.domUtilities.docFromString(partXhr.responseText);
			} catch(err) {}
		}
		partXhr.responseXML = xmlPart;
		// call the appropriate content handler for this part
        // dojo.contentHandlers is public since Dojo 1.4
        var djCh = dojo.contentHandlers ? "contentHandlers" : "_contentHandlers";
		return dojo[djCh][partArgs.handleAs](partXhr);
	};

	dojo.mixin(com.ibm.utilities, {
		handleMultiPartResponse: function(parts, response, ioArgs) {
			// Getting the Content-Type header from the response, and extract
			// the boundary string
			var boundMatch = ioArgs.xhr.getResponseHeader("Content-Type").match(boundaryRegx);
			if (!boundMatch) {
				throw new Error("No boundary specified in Content-Type response header");
			}
			var bound = boundMatch[1];
			// build a regx from the response boundary string used to split the parts
			var splitterRegx = new RegExp(newL + sep + bound, "mg");
			
			var respParts = response.split(splitterRegx);
			
			// if handleAs is xml, it comes as text so build it using the domUtilities
			
			// iterate through the response parts, handling the callbacks for each
			for(var i = 1, j = i - 1; i < respParts.length - 1; i++, j++) {
				var partXhr = new xhrMime(),
					part = respParts[i],
					header = null;
				headerRegx.lastIndex = 0;
				
				var partSections = part.split(headerBodySplitterRegx);
				var headerSection = unfoldHeaders(partSections[0]),
					bodySection = partSections[1];
				
				if (!bodySection) {
					bodySection = "";
				}
				
				// extract the headers for this part, stopping at the blank line
				while((header= headerRegx.exec(headerSection)) !== null && (header[1].length > 0)) {
					var headerParts = header[1].match(headerPartsRegx);
					if(headerParts)	{
						partXhr.respHeaders.push([headerParts[1],headerParts[2]]);
					}
				}
				
				part = dojo.string.trim(bodySection);
				partXhr.responseText = part;
				
				if(ioArgs.args.partContentHandler) {
					part = ioArgs.args.partContentHandler(parts[j], partXhr, defaultContentHandler);
				}
				else {
					part = defaultContentHandler(parts[j], partXhr);
				}
				
				partHandler(parts[j], part, dojo.mixin({}, ioArgs, {xhr: partXhr}));
			}
		},
		
		multiPartXhr: function( /*String*/ method, /*dojo.__XhrArgs*/ args, /*Array*/ parts) {
			// summary: Sends a request with a multi-part body (and content type) to
			//		the server.  Uses dojo.xhr functions under the covers, so the args
			//		object has the same structure as what those functions expect.
			//		The main difference is that this function builds the raw post or put
			//		data automatically from the parts array.  Each item in the parts array
			//		is an object which is a subset of the dojo.__XhrArgs type.  The callbacks
			//		should be specified per part as this function will provide a general
			//		callback that parses the multi-part response and calls the callback
			//		associated with that response part provided in the parts array.
			// method: String specifying the HTTP method used.  Must be either POST or PUT.
			//		Default is POST.
			// args: dojo.__XhrArgs specifying how this XHR should be handled.  The following
			//		properties are not used since they do not make sense in this context -
			//			[form, handle, load, content, handleAs]
			//		The following are new args that are available for sending multiPart requests.
			//		{
			//			partContentHandler: function(partArgs, partXhr, defaultContentHandler){} optional 
			// 				function to handle response parts after they've been split and parsed enabling a 
			// 				caller to modify the part response body or the XHR mime associated with the part, 
			// 				returns the response associated with this part in some format, potentially modified
			//				by this handler function
			//			preHandle: function(response, ioArgs){} callback called before the parts
			//				callbacks are called
			//			postHandle: function(response, ioArgs){} callback called after the parts
			//				callbacks have been called
			//
			//		}
			// parts: Array the multiple parts to use to build the multi-part request body.
			//		Each item in the array should be an object with these properties -
			//			{
			//				headers: Object key-value map which is used to write out a
			//					section at the top of this part in the form key: value.
			//					Example could be Content-Type of this part of the multi-part
			//					request.
			//				data: String text to write out the body of this part
			//				load: function(response, ioArgs){} callback called where
			// 					the response body is the body of the part associated this
			//					request part
			//				error: function(response, ioArgs){} callback called when
			//					a failure occurs either in the transmission or from the
			//					server
			//				handle: function(response, ioArgs){} callback called at the
			//					end of this request with either the response or an error
			//					if one occured
			//				handleAs: String value indicating how the response body of this
			//					part should be handled
			//			}
			// returns: Deferred object which can be used to attach additional callbacks to
			
			var body = "",
				headersStr = null;
			dojo.forEach(parts, function(part){
				part.handleAs = part.handleAs ? part.handleAs.toLowerCase() : "text";
				headersStr = "";
				for(var x in part.headers) {
					headersStr += x + ": " + part.headers[x] + newL;
				}
				body += startB + headersStr + newL;
				if (part.data && part.data.length > 0) {
					body += part.data + newL;
				}
			});
			
			body += endB;
			
			// if method is PUT, leave it be; otherwise set it to POST
			if (method.toUpperCase() != "PUT") {
				method = "POST";
			}
			
			args.headers = dojo.mixin({}, args.headers, {
				"Content-type": 'multipart/mixed; boundary="' + boundary + '"'
			});
			
			var xhrArgs = dojo.mixin({}, args, {
				load: function(response, ioArgs) {
					if (args.preHandle) {
						args.preHandle(response, ioArgs);
					}
					com.ibm.utilities.handleMultiPartResponse(parts, response, ioArgs);
					if (args.postHandle) {
						args.postHandle(response, ioArgs);
					}
				}, 
				error: function(response, ioArgs) {
					if (args.preHandle) {
						args.preHandle(response, ioArgs);
					}
					dojo.forEach(parts, function(part){
						partHandler(part, response, ioArgs, null);
					});
					if (args.error) {
						args.error(response, ioArgs);
					}
					if (args.postHandle) {
						args.postHandle(response, ioArgs);
					}						
				},
				handleAs: "text",
				form: null,
				content: null,
				postData: null,
				putData: null
			});
			
			xhrArgs[method.toLowerCase() + "Data"] = body;
			
			return dojo.xhr(method, xhrArgs, true);
		}
	});
})();

}

if(!dojo._hasResource["com.ibm.data.ProxyHelper"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.data.ProxyHelper"] = true;
dojo.provide( "com.ibm.data.ProxyHelper" );

dojo.require( "com.ibm.utilities" );

dojo.declare( "com.ibm.data.ProxyHelper",
			null,
			{
				// proxyURI: String
				//		URI to the proxy servlet.
				proxyURI: "",
				
				urlThroughProxy: function(/*String*/ url) {
					return com.ibm.utilities.urlToProxyUrl(url ? url : "", this.proxyURI);
				}
			}
);

}

if(!dojo._hasResource["com.ibm.data.CatalogMixin"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.data.CatalogMixin"] = true;
// Datastores written for use in the content search widget must inherit from this class to make the mapItem and prepareQuery function available to the widget
// These functions are used to unify access to datastores, so the widget can  query and access items the same way for every source

dojo.provide("com.ibm.data.CatalogMixin");
dojo.declare("com.ibm.data.CatalogMixin", 
		null,
		{	
			searchable: true,
			
			mapItem: function(/*DatstoreItem*/item){
				// summary: Returns a map containing parameters for the given datastore item
				//		The keys must be: label, description, tags, rating, url, id, thumbnail
				//			- label, description, url, id and thumbnail are strings
				//			- tags is an array of strings
				//			- rating is a string that contains a number, note that decimal values are allowed
				//		Having all content search datastores create item maps with the same keys allows the widget to access information uniformly
				// 		If a datastore item does not have the same attributes for getValue as seen below, this function must be overridden
				//		If a datastore item does not have an appropriate parameter to  map to a key, that map entry can be omitted
				//		An example for a datastore item with a title, summary, rating and identifier:
				//			mapItem: function(/*DatastoreItem*/item){
				//				// does not include the "tags" and "url" keys
				//				var map = {};
				//				map["label"] = this.getEPResolvedValue(item, "title", "untitled");
				//				map["description"] = this.getEPResolvedValue(item, "summary", null);
				//				map["rating"] = this.getEPResolvedValue(item, "rating", "0.0");
				//				map["id"] = this.getEPResolvedValue(item, "identifier", null);
				//				map["thumbnail"] = this.getEPResolvedValue(item, "thumbnail", null);
				//				return map;
				//			}
				var map = {};
				map["label"] = this.getEPResolvedValue(item, "label", "untitled");
				map["description"] = this.getEPResolvedValue(item, "description", null);
				map["tags"] = this.getEPResolvedValue(item, "tags", null);
				map["rating"] = this.getEPResolvedValue(item, "rating", "0.0");
				map["url"] = this.getEPResolvedValue(item, "url", null);
				map["id"] = this.getEPResolvedValue(item, "id", null);
				map["thumbnail"] = this.getEPResolvedValue(item, "thumbnail", null);
				return map;
			},

			prepareQuery: function(/*Object*/keywordArgs) {
				// summary: User overridable function to modify the keywordArgs object used to fetch results from the back end
				//		Called after the keywordArgs.query property has been normalized to an object map but before any other processing has taken place to build the URL
				//		After this function is called, anything in the keywordArgs.query map is appended to the fetch URL in the form (?|&)<key1>=<value1> &<key2>=<value2> &<key3>=<value3> ...
				//		Can be used to extract other parts of the keywordArgs map to add properties to the query object that are dependent on back end implementation
				//		Properties of the query object that are not part of the fetch URL should be deleted
				//		The keywordArgs object is defined in dojo.data.api.Read.fetch and query will be an object containing the key "keywords" with an array of strings as a value
				//		An example for a feed URL containing "searchTerms", "startIndex" and "count" parameters:
				//			prepareQuery: function(/*Object*/keywordArgs) {
				//				if(keywordArgs.query.keywords) {
				//					// searchTerms is a comma separated list of search parameters
				//					keywordArgs.query.searchTerms = keywordArgs.query.keywords.join(",");
				//					delete keywordArgs.query.keywords;
				//				}
				//				if(keywordArgs.count) {
				//					keywordArgs.query.count = keywordArgs.count;
				//					if(keywordArgs.start == null) {
				//						keywordArgs.start = 0;
				//					}
				//					keywordArgs.query.startIndex = keywordArgs.start;
				//				}
				//			}
				return keywordArgs;
			},
			
			validateSelf: function(){
				// summary: validates this datastore, if it does not validate the source will not be used
				// returns true for validation and false otherwise
				return true;
			},
			
			getSourceLabel: function(){
				return false;
			}
});

}

if(!dojo._hasResource["com.ibm.data.JsonStore"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.data.JsonStore"] = true;
// A json store that can be used for the customize shelf
// dojo.data.ItemFileReadstore already is a JSON store, this store extends it and overwrites the _fetchItems function to do an AND instead of an OR search for the given keywords
// it also adds support for passing in parameters for an nls bundle and keywords

dojo.provide("com.ibm.data.JsonStore");







dojo.declare("com.ibm.data.JsonStore", 
		[dojo.data.ItemFileReadStore, com.ibm.data.ProxyHelper, com.ibm.data.CatalogMixin],
		{	
			nlsBundle: null,
		
			_getItemsFromLoadedData: function(/* Object */ dataObject){
				this.inherited("_getItemsFromLoadedData",arguments);
				
				this.shelfBundle = dojo.i18n.getLocalization("com.ibm.bundles", "Shelf");
				var localizationPackageName = dataObject.localizationPackageName;
				var localizationBundleName = dataObject.localizationBundleName;
				if(localizationPackageName && localizationBundleName){
					this.nlsBundle = dojo.i18n.getLocalization(localizationPackageName, localizationBundleName);
					dojo.forEach(this._arrayOfAllItems,
						dojo.hitch(this, function(item) {
							if (item.label) {
								item.label[0] = (this.nlsBundle && this.nlsBundle[item.label[0]]) ? this.nlsBundle[item.label[0]] : item.label[0];
							}
							else {
								item.label = [];
							}
							if (!item.label[0]) {
								item.label[0] = this.shelfBundle.add_content_untitled;
							}
							if (item.description) {
								item.description[0] = (this.nlsBundle && this.nlsBundle[item.description[0]]) ? this.nlsBundle[item.description[0]] : item.description[0];
							}
							if (item.help) {
								item.help[0] = (this.nlsBundle && this.nlsBundle[item.help[0]]) ? this.nlsBundle[item.help[0]] : item.help[0];
							}
						})
					);
				}
			},
			
			mapItem: function(/*DatstoreItem*/item){
				var map = {};
			
				map.label = this.getValue(item, "label", null);
				map.description = this.getValue(item, "description", null);
				map.url = this.getValue(item, "url", null);
				map.id = this.getValue(item, "id", null);
				map.thumbnail = this.getValue(item, "thumbnail", null);
				map.help = this.getValue(item, "help", null);
				map.takeoverFcn = this.getValue(item,"takeover",null);
				
				return map;
			},
		
			_fetchItems: function(/*Object*/ keywordArgs, /*Function*/ findCallback, /*Function*/ errorCallback){
				var self = this;
				var filter = function(requestArgs, arrayOfItems){
					
					var items = [];
					var i = 0;
					if(requestArgs.query){
						var filterKeywords = requestArgs.query.keywords;
						var ignoreCase = requestArgs.queryOptions ? requestArgs.queryOptions.ignoreCase : false; 
					
						var regexpList = {};
						var currFilter = null;
						for(i = 0; i < filterKeywords.length; i++){
							currFilter = filterKeywords[i];
							if(typeof currFilter === "string"){
								regexpList[currFilter] = dojo.data.util.filter.patternToRegExp("*"+currFilter+"*", ignoreCase);
							}
						}

						for(i = 0; i < arrayOfItems.length; ++i){
							var match = true;
							var candidateItem = arrayOfItems[i];
							if(candidateItem === null){
								match = false; 
							} else {
								for(var j = 0; j < filterKeywords.length; j++){
									currFilter = filterKeywords[j];
									if(!self._containsValue(candidateItem, 'label', currFilter, regexpList[currFilter]) && 
											!self._containsValue(candidateItem, 'description', currFilter, regexpList[currFilter])){
										match = false;
									}
								}
							}
							
							if(match){
								items.push(candidateItem);
							}
						}
						findCallback(items, requestArgs);
					} else {
						for(i = 0; i < arrayOfItems.length; ++i){
							var item = arrayOfItems[i];
							if(item !== null){
								items.push(item);
							}
						}
						findCallback(items, requestArgs);
					}
			};

			if(this._loadFinished){
				filter(keywordArgs, this._getItemsArray(keywordArgs.queryOptions));
			} else {

				if(this._jsonFileUrl){
					if(this._loadInProgress){
						this._queuedFetches.push({args: keywordArgs, filter: filter});
					} else {
						this._loadInProgress = true;
						var getArgs = {
								url: self._jsonFileUrl, 
								handleAs: "json-comment-optional"
						};
						var getHandler = dojo.xhrGet(getArgs);
						getHandler.addCallback(function(data){
							try{
								self._getItemsFromLoadedData(data);
								self._loadFinished = true;
								self._loadInProgress = false;
				
								filter(keywordArgs, self._getItemsArray(keywordArgs.queryOptions));
								self._handleQueuedFetches();
							}catch(e){
								self._loadFinished = true;
								self._loadInProgress = false;
								errorCallback(e, keywordArgs);
							}
						});
						getHandler.addErrback(function(error){
							self._loadInProgress = false;
							errorCallback(error, keywordArgs);
						});
					}
				} else if(this._jsonData){
					try{
						this._loadFinished = true;
						this._getItemsFromLoadedData(this._jsonData);
						this._jsonData = null;
						filter(keywordArgs, this._getItemsArray(keywordArgs.queryOptions));
					}catch(e){
						errorCallback(e, keywordArgs);
					}
				} else {
					errorCallback(new Error("dojo.data.ItemFileReadStore: No JSON source data was provided as either URL or a nested Javascript object."), keywordArgs);
				}
			}
		}
});

}

if(!dojo._hasResource["com.ibm.pb.logging.Loggable"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.logging.Loggable"] = true;
dojo.provide("com.ibm.pb.logging.Loggable");

(function(){
	var Logger = com.ibm.mashups.enabler.logging.Logger;
	
	/**
	 * Automatically provides the a logger for the correct module namespace for a dojo module 
	 * that includes this module in its list of mixins.
	 */
	dojo.declare("com.ibm.pb.logging.Loggable", null, {
		LOGGER: null,
		constructor: function() {
			this.LOGGER = Logger.getLogger(this.declaredClass);
		}
	});
})();

}

if(!dojo._hasResource["com.ibm.pb.data.NavigationPrimer"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.data.NavigationPrimer"] = true;
dojo.provide("com.ibm.pb.data.NavigationPrimer");



dojo.declare("com.ibm.pb.data.NavigationPrimer", com.ibm.pb.logging.Loggable, {
	
	LEVEL_ATTR: "data-nm-level",
	PRIMED_ATTR: "data-nm-primed",
	END: {},
	
	selPath: null,	// Array of selection path starting from root going down towards selected node
	map: null,		// Object map of priming node data with keys as node ids
	
	constructor: function() {
		this.selPath = [];
		this.map = {};
	},
	
	parse: function(domNode) {
		var mname = "parse", lgr = this.LOGGER;
		lgr.entering(mname, [domNode]);
		domNode = dojo.byId(domNode);
		var level = dojo.attr(domNode, this.LEVEL_ATTR);
		if(level !== null && level !== undefined) {
			lgr.trace(mname, "Priming the parse root node itself");
			this._prime(domNode);
		}
		// now look for descendants that may have the level attribute defined
		var levelNodes = dojo.query("[" + this.LEVEL_ATTR + "]", domNode);
		if(levelNodes.length > 0) {
			levelNodes.forEach(this._prime, this);
		}
		else {
			lgr.trace(mname, "No level nodes detected in descendant nodes");
			lgr.exiting(mname, [null]);
			return;
		}
		
		lgr.exiting(mname, [domNode]);
	},
	_prime: function(domNode) {
		var mname = "_prime", lgr = this.LOGGER;
		lgr.entering(mname, [domNode]);
		var level = dojo.attr(domNode, this.LEVEL_ATTR);
		
		var nodeData = this.extractData(domNode);
		if(nodeData) {
			this.addItem(nodeData);
			if(!this.selPath[level]) {
				lgr.trace(mname, "No previous selection path data at level ${0}", [level]);
			}
		}
		else {
			if(this.selPath[level]) {
				nodeData = this.selPath[level];
				lgr.trace(mname, "No data provided for selection path data, using previously known", []);
			}
			else {
				lgr.trace(mname, "No data provided for selection path data, and no previous data to use", []);
				lgr.exiting(mname, []);
				return;
			}
		}
		nodeData = this.byId(nodeData.id);
		this.selPath[level] = nodeData;
		lgr.trace(mname, "Priming selection path data at level ${0}", [level]);
		var childNodes = dojo.query("[" + this.PRIMED_ATTR + "]", domNode);
		if(childNodes.length > 0) {
			lgr.trace(mname, "Found children of ${0}", [nodeData.id]);
			if(!nodeData.children) {
				nodeData.children = [];
			}
			childNodes.forEach(function(childDomNode){
				var childData = this.extractData(childDomNode);
				if(childData) {
					lgr.trace(mname, "Adding child ${0} of ${1}", [childData.id, nodeData.id]);
					this.addItem(childData);
					childData = this.byId(childData.id);
					nodeData.children.push(childData);
				}
			}, this);
			nodeData.children.push(this.END);
		}
		else {
			lgr.trace(mname, "Found NO children of ${0}", [nodeData.id]);
		}
		lgr.exiting(mname, [nodeData]);
	},
	addItem: function(data){
		var mname = "addItem", lgr = this.LOGGER;
		if(data && data.id) {
			if(this.map[data.id]) {
				// data already primed... mix in any additional attributes
				lgr.trace(mname, "Adding properties ${0} for ${1} to existing data", [data, data.id]);
				dojo.mixin(this.map[data.id], data);
			}
			else {
				// data not primed yet
				lgr.trace(mname, "Adding new data ${0} for ${1}", [data, data.id]);
				this.map[data.id] = data;
			}
		}
	},
	byId: function(id) {
		return this.map[id];
	},
	_normalizeType: function(type) {
		type = type ? type.toLowerCase() : "page";
		switch(type) {
			case "internalurl":
			case "externalurl":
				type = "url";
				break;
			case "staticpage":
				type = "page";
				break;
		}
		return type;
	},
	extractData: function(domNode) {
		var mname = "extractData", lgr = this.LOGGER;
		var data = dojo.attr(domNode, this.PRIMED_ATTR);
		if(data) {
			data = dojo.fromJson(data);
			data.locale = ibmConfig.locale;
			data.type = this._normalizeType(data.type);
			lgr.trace(mname, "Extracted data ${0}", [data]);
		}
		else {
			data = null;
		}
		return data;
	},
	finalize: function() {
		var mname = "finalize", lgr = this.LOGGER;
		for(var i=this.selPath.length-1; i>=0; i--) {
			if(i > 0) {
				if(!this.selPath[i-1].children) {
					this.selPath[i-1].children = [this.selPath[i]];
				}
				else if(this.selPath[i-1].children.length == 0) {
					// pushing the END marker onto the beginning along with other nodes
					// specifies that this set of children is incomplete, but that it
					// doesn't start at the beginning; hence the system will get all
					// children from the model if getChildren is called on this parent
					this.selPath[i-1].children.push(this.END, this.selPath[i]);
				}
			}
		}
		var nm = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel();
		if(lgr.isLoggable(com.ibm.mashups.enabler.logging.LogLevel.TRACE)) {
			lgr.trace(mname, "Priming navigation model ${0}", [this]);
			lgr.trace(mname, "Priming data:\n  ${0}", [dojo.toJson(this.selPath[0], true)]);
		}
		nm.setPrimingData(this.selPath[0]);
	}
});

}

if(!dojo._hasResource["dijit.InlineEditBox"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.InlineEditBox"] = true;
dojo.provide("dijit.InlineEditBox");










dojo.declare("dijit.InlineEditBox",
	dijit._Widget,
	{
	// summary:
	//		An element with in-line edit capabilitites
	//
	// description:
	//		Behavior for an existing node (`<p>`, `<div>`, `<span>`, etc.) so that
	// 		when you click it, an editor shows up in place of the original
	//		text.  Optionally, Save and Cancel button are displayed below the edit widget.
	//		When Save is clicked, the text is pulled from the edit
	//		widget and redisplayed and the edit widget is again hidden.
	//		By default a plain Textarea widget is used as the editor (or for
	//		inline values a TextBox), but you can specify an editor such as
	//		dijit.Editor (for editing HTML) or a Slider (for adjusting a number).
	//		An edit widget must support the following API to be used:
	//			- displayedValue or value as initialization parameter,
	//			and available through attr('displayedValue') / attr('value')
	//			- void focus()
	//			- DOM-node focusNode = node containing editable text

	// editing: [readonly] Boolean
	//		Is the node currently in edit mode?
	editing: false,

	// autoSave: Boolean
	//		Changing the value automatically saves it; don't have to push save button
	//		(and save button isn't even displayed)
	autoSave: true,

	// buttonSave: String
	//		Save button label
	buttonSave: "",

	// buttonCancel: String
	//		Cancel button label
	buttonCancel: "",

	// renderAsHtml: Boolean
	//		Set this to true if the specified Editor's value should be interpreted as HTML
	//		rather than plain text (ex: `dijit.Editor`)
	renderAsHtml: false,

	// editor: String
	//		Class name for Editor widget
	editor: "dijit.form.TextBox",

	// editorWrapper: String
	//		Class name for widget that wraps the editor widget, displaying save/cancel
	//		buttons.
	editorWrapper: "dijit._InlineEditor",

	// editorParams: Object
	//		Set of parameters for editor, like {required: true}
	editorParams: {},

	onChange: function(value){
		// summary:
		//		Set this handler to be notified of changes to value.
		// tags:
		//		callback
	},

	onCancel: function(){
		// summary:
		//		Set this handler to be notified when editing is cancelled.
		// tags:
		//		callback
	},

	// width: String
	//		Width of editor.  By default it's width=100% (ie, block mode).
	width: "100%",

	// value: String
	//		The display value of the widget in read-only mode
	value: "",

	// noValueIndicator: [const] String
	//		The text that gets displayed when there is no value (so that the user has a place to click to edit)
	noValueIndicator: "<span style='font-family: wingdings; text-decoration: underline;'>&nbsp;&nbsp;&nbsp;&nbsp;&#x270d;&nbsp;&nbsp;&nbsp;&nbsp;</span>",

	constructor: function(){
		// summary:
		//		Sets up private arrays etc.
		// tags:
		//		private
		this.editorParams = {};
	},

	postMixInProperties: function(){
		this.inherited(arguments);

		// save pointer to original source node, since Widget nulls-out srcNodeRef
		this.displayNode = this.srcNodeRef;

		// connect handlers to the display node
		var events = {
			ondijitclick: "_onClick",
			onmouseover: "_onMouseOver",
			onmouseout: "_onMouseOut",
			onfocus: "_onMouseOver",
			onblur: "_onMouseOut"
		};
		for(var name in events){
			this.connect(this.displayNode, name, events[name]);
		}
		dijit.setWaiRole(this.displayNode, "button");
		if(!this.displayNode.getAttribute("tabIndex")){
			this.displayNode.setAttribute("tabIndex", 0);
		}

		this.attr('value', this.value || this.displayNode.innerHTML);
	},

	setDisabled: function(/*Boolean*/ disabled){
		// summary:
		//		Deprecated.   Use attr('disable', ...) instead.
		// tags:
		//		deprecated
		dojo.deprecated("dijit.InlineEditBox.setDisabled() is deprecated.  Use attr('disabled', bool) instead.", "", "2.0");
		this.attr('disabled', disabled);
	},

	_setDisabledAttr: function(/*Boolean*/ disabled){
		// summary:
		//		Hook to make attr("disabled", ...) work.
		//		Set disabled state of widget.
		this.disabled = disabled;
		dijit.setWaiState(this.domNode, "disabled", disabled);
		if(disabled){
			this.displayNode.removeAttribute("tabIndex");
		}else{
			this.displayNode.setAttribute("tabIndex", 0);
		}
	},

	_onMouseOver: function(){
		// summary:
		//		Handler for onmouseover event.
		// tags:
		//		private
		dojo.addClass(this.displayNode, this.disabled ? "dijitDisabledClickableRegion" : "dijitClickableRegion");
	},

	_onMouseOut: function(){
		// summary:
		//		Handler for onmouseout event.
		// tags:
		//		private
		dojo.removeClass(this.displayNode, this.disabled ? "dijitDisabledClickableRegion" : "dijitClickableRegion");
	},

	_onClick: function(/*Event*/ e){
		// summary:
		//		Handler for onclick event.
		// tags:
		//		private
		if(this.disabled){ return; }
		if(e){ dojo.stopEvent(e); }
		this._onMouseOut();

		// Since FF gets upset if you move a node while in an event handler for that node...
		setTimeout(dojo.hitch(this, "edit"), 0);
	},

	edit: function(){
		// summary:
		//		Display the editor widget in place of the original (read only) markup.
		// tags:
		//		private

		if(this.disabled || this.editing){ return; }
		this.editing = true;

		// save some display node values that can be restored later
		this._savedPosition = dojo.style(this.displayNode, "position") || "static";
		this._savedOpacity = dojo.style(this.displayNode, "opacity") || "1";
		this._savedTabIndex = dojo.attr(this.displayNode, "tabIndex") || "0";

		if(this.wrapperWidget){
			this.wrapperWidget.editWidget.attr("displayedValue" in this.editorParams ? "displayedValue" : "value", this.value);
		}else{
			// Placeholder for edit widget
			// Put place holder (and eventually editWidget) before the display node so that it's positioned correctly
			// when Calendar dropdown appears, which happens automatically on focus.
			var placeholder = dojo.create("span", null, this.domNode, "before");

			// Create the editor wrapper (the thing that holds the editor widget and the save/cancel buttons)
			var ewc = dojo.getObject(this.editorWrapper);
			this.wrapperWidget = new ewc({
				value: this.value,
				buttonSave: this.buttonSave,
				buttonCancel: this.buttonCancel,
				tabIndex: this._savedTabIndex,
				editor: this.editor,
				inlineEditBox: this,
				sourceStyle: dojo.getComputedStyle(this.displayNode),
				save: dojo.hitch(this, "save"),
				cancel: dojo.hitch(this, "cancel")
			}, placeholder);
		}
		var ww = this.wrapperWidget;

		if(dojo.isIE){
			dijit.focus(dijit.getFocus()); // IE (at least 8) needs help with tab order changes
		}
		// to avoid screen jitter, we first create the editor with position:absolute, visibility:hidden,
		// and then when it's finished rendering, we switch from display mode to editor
		// position:absolute releases screen space allocated to the display node
		// opacity:0 is the same as visibility:hidden but is still focusable
		// visiblity:hidden removes focus outline

		dojo.style(this.displayNode, { position: "absolute", opacity: "0", display: "none" }); // makes display node invisible, display style used for focus-ability
		dojo.style(ww.domNode, { position: this._savedPosition, visibility: "visible", opacity: "1" });
		dojo.attr(this.displayNode, "tabIndex", "-1"); // needed by WebKit for TAB from editor to skip displayNode

		// Replace the display widget with edit widget, leaving them both displayed for a brief time so that
		// focus can be shifted without incident.  (browser may needs some time to render the editor.)
		setTimeout(dojo.hitch(this, function(){
			ww.focus(); // both nodes are showing, so we can switch focus safely
			ww._resetValue = ww.getValue();
		}), 0);
	},

	_onBlur: function(){
		// summary:
		//		Called when focus moves outside the InlineEditBox.
		//		Performs garbage collection.
		// tags:
		//		private

		this.inherited(arguments);
		if(!this.editing){
			setTimeout(dojo.hitch(this, function(){
				if(this.wrapperWidget){
					this.wrapperWidget.destroy();
					delete this.wrapperWidget;
				}
			}), 0);
		}
	},

	_showText: function(/*Boolean*/ focus){
		// summary:
		//		Revert to display mode, and optionally focus on display node
		// tags:
		//		private

		var ww = this.wrapperWidget;
		dojo.style(ww.domNode, { position: "absolute", visibility: "hidden", opacity: "0" }); // hide the editor from mouse/keyboard events
		dojo.style(this.displayNode, { position: this._savedPosition, opacity: this._savedOpacity, display: "" }); // make the original text visible
		dojo.attr(this.displayNode, "tabIndex", this._savedTabIndex);
		if(focus){
			dijit.focus(this.displayNode);
		}
	},

	save: function(/*Boolean*/ focus){
		// summary:
		//		Save the contents of the editor and revert to display mode.
		// focus: Boolean
		//		Focus on the display mode text
		// tags:
		//		private

		if(this.disabled || !this.editing){ return; }
		this.editing = false;

		var ww = this.wrapperWidget;
		var value = ww.getValue();
		this.attr('value', value); // display changed, formatted value

		// tell the world that we have changed
		setTimeout(dojo.hitch(this, "onChange", value), 0); // setTimeout prevents browser freeze for long-running event handlers

		this._showText(focus); // set focus as needed
	},

	setValue: function(/*String*/ val){
		// summary:
		//		Deprecated.   Use attr('value', ...) instead.
		// tags:
		//		deprecated
		dojo.deprecated("dijit.InlineEditBox.setValue() is deprecated.  Use attr('value', ...) instead.", "", "2.0");
		return this.attr("value", val);
	},

	_setValueAttr: function(/*String*/ val){
		// summary:
		// 		Hook to make attr("value", ...) work.
		//		Inserts specified HTML value into this node, or an "input needed" character if node is blank.

		this.value = val = dojo.trim(val);
		if(!this.renderAsHtml){
			val = val.replace(/&/gm, "&amp;").replace(/</gm, "&lt;").replace(/>/gm, "&gt;").replace(/"/gm, "&quot;").replace(/\n/g, "<br>");
		}
		this.displayNode.innerHTML = val || this.noValueIndicator;
	},

	getValue: function(){
		// summary:
		//		Deprecated.   Use attr('value') instead.
		// tags:
		//		deprecated
		dojo.deprecated("dijit.InlineEditBox.getValue() is deprecated.  Use attr('value') instead.", "", "2.0");
		return this.attr("value");
	},

	cancel: function(/*Boolean*/ focus){
		// summary:
		//		Revert to display mode, discarding any changes made in the editor
		// tags:
		//		private

		if(this.disabled || !this.editing){ return; }
		this.editing = false;

		// tell the world that we have no changes
		setTimeout(dojo.hitch(this, "onCancel"), 0); // setTimeout prevents browser freeze for long-running event handlers

		this._showText(focus);
	}
});

dojo.declare(
	"dijit._InlineEditor",
	 [dijit._Widget, dijit._Templated],
{
	// summary:
	// 		Internal widget used by InlineEditBox, displayed when in editing mode
	//		to display the editor and maybe save/cancel buttons.  Calling code should
	//		connect to save/cancel methods to detect when editing is finished
	//
	//		Has mainly the same parameters as InlineEditBox, plus these values:
	//
	// style: Object
	//		Set of CSS attributes of display node, to replicate in editor
	//
	// value: String
	//		Value as an HTML string or plain text string, depending on renderAsHTML flag

	templateString: dojo.cache("dijit", "templates/InlineEditBox.html", "<span dojoAttachPoint=\"editNode\" waiRole=\"presentation\" style=\"position: absolute; visibility:hidden\" class=\"dijitReset dijitInline\"\n\tdojoAttachEvent=\"onkeypress: _onKeyPress\"\n\t><span dojoAttachPoint=\"editorPlaceholder\"></span\n\t><span dojoAttachPoint=\"buttonContainer\"\n\t\t><button class='saveButton' dojoAttachPoint=\"saveButton\" dojoType=\"dijit.form.Button\" dojoAttachEvent=\"onClick:save\" label=\"${buttonSave}\"></button\n\t\t><button class='cancelButton' dojoAttachPoint=\"cancelButton\" dojoType=\"dijit.form.Button\" dojoAttachEvent=\"onClick:cancel\" label=\"${buttonCancel}\"></button\n\t></span\n></span>\n"),
	widgetsInTemplate: true,

	postMixInProperties: function(){
		this.inherited(arguments);
		this.messages = dojo.i18n.getLocalization("dijit", "common", this.lang);
		dojo.forEach(["buttonSave", "buttonCancel"], function(prop){
			if(!this[prop]){ this[prop] = this.messages[prop]; }
		}, this);
	},

	postCreate: function(){
		// Create edit widget in place in the template
		var cls = dojo.getObject(this.editor);

		// Copy the style from the source
		// Don't copy ALL properties though, just the necessary/applicable ones
		var srcStyle = this.sourceStyle;
		var editStyle = "line-height:" + srcStyle.lineHeight + ";";
		dojo.forEach(["Weight","Family","Size","Style"], function(prop){
			editStyle += "font-"+prop+":"+srcStyle["font"+prop]+";";
		}, this);
		dojo.forEach(["marginTop","marginBottom","marginLeft", "marginRight"], function(prop){
			this.domNode.style[prop] = srcStyle[prop];
		}, this);
		var width = this.inlineEditBox.width;
		if(width == "100%"){
			// block mode
			editStyle += "width:100%;";
			this.domNode.style.display = "block";
		}else{
			// inline-block mode
			editStyle += "width:" + (width + (Number(width) == width ? "px" : "")) + ";";
		}
		var editorParams = this.inlineEditBox.editorParams;
		editorParams.style = editStyle;
		editorParams[ "displayedValue" in cls.prototype ? "displayedValue" : "value"] = this.value;
		var ew = this.editWidget = new cls(editorParams, this.editorPlaceholder);

		if(this.inlineEditBox.autoSave){
			// Hide the save/cancel buttons since saving is done by simply tabbing away or
			// selecting a value from the drop down list
			this.buttonContainer.style.display="none";

			// Selecting a value from a drop down list causes an onChange event and then we save
			this.connect(ew, "onChange", "_onChange");

			// ESC and TAB should cancel and save.  Note that edit widgets do a stopEvent() on ESC key (to
			// prevent Dialog from closing when the user just wants to revert the value in the edit widget),
			// so this is the only way we can see the key press event.
			this.connect(ew, "onKeyPress", "_onKeyPress");
		}else{
			// If possible, enable/disable save button based on whether the user has changed the value
			if("intermediateChanges" in cls.prototype){
				ew.attr("intermediateChanges", true);
				this.connect(ew, "onChange", "_onIntermediateChange");
				this.saveButton.attr("disabled", true);
			}
		}
	},

	_onIntermediateChange: function(val){
		// summary:
		//		Called for editor widgets that support the intermediateChanges=true flag as a way
		//		to detect when to enable/disabled the save button
		this.saveButton.attr("disabled", (this.getValue() == this._resetValue) || !this.enableSave());
	},

	destroy: function(){
		this.editWidget.destroy(true); // let the parent wrapper widget clean up the DOM
		this.inherited(arguments);
	},

	getValue: function(){
		// summary:
		//		Return the [display] value of the edit widget
		var ew = this.editWidget;
		return String(ew.attr("displayedValue" in ew ? "displayedValue" : "value"));
	},

	_onKeyPress: function(e){
		// summary:
		//		Handler for keypress in the edit box in autoSave mode.
		// description:
		//		For autoSave widgets, if Esc/Enter, call cancel/save.
		// tags:
		//		private

		if(this.inlineEditBox.autoSave && this.inlineEditBox.editing){
			if(e.altKey || e.ctrlKey){ return; }
			// If Enter/Esc pressed, treat as save/cancel.
			if(e.charOrCode == dojo.keys.ESCAPE){
				dojo.stopEvent(e);
				this.cancel(true); // sets editing=false which short-circuits _onBlur processing
			}else if(e.charOrCode == dojo.keys.ENTER && e.target.tagName == "INPUT"){
				dojo.stopEvent(e);
				this._onChange(); // fire _onBlur and then save
			}

			// _onBlur will handle TAB automatically by allowing
			// the TAB to change focus before we mess with the DOM: #6227
			// Expounding by request:
			// 	The current focus is on the edit widget input field.
			//	save() will hide and destroy this widget.
			//	We want the focus to jump from the currently hidden
			//	displayNode, but since it's hidden, it's impossible to
			//	unhide it, focus it, and then have the browser focus
			//	away from it to the next focusable element since each
			//	of these events is asynchronous and the focus-to-next-element
			//	is already queued.
			//	So we allow the browser time to unqueue the move-focus event
			//	before we do all the hide/show stuff.
		}
	},

	_onBlur: function(){
		// summary:
		//		Called when focus moves outside the editor
		// tags:
		//		private

		this.inherited(arguments);
		if(this.inlineEditBox.autoSave && this.inlineEditBox.editing){
			if(this.getValue() == this._resetValue){
				this.cancel(false);
			}else if(this.enableSave()){
				this.save(false);
			}
		}
	},

	_onChange: function(){
		// summary:
		//		Called when the underlying widget fires an onChange event,
		//		such as when the user selects a value from the drop down list of a ComboBox,
		//		which means that the user has finished entering the value and we should save.
		// tags:
		//		private

		if(this.inlineEditBox.autoSave && this.inlineEditBox.editing && this.enableSave()){
			dojo.style(this.inlineEditBox.displayNode, { display: "" });
			dijit.focus(this.inlineEditBox.displayNode); // fires _onBlur which will save the formatted value
		}
	},

	enableSave: function(){
		// summary:
		//		User overridable function returning a Boolean to indicate
		// 		if the Save button should be enabled or not - usually due to invalid conditions
		// tags:
		//		extension
		return (
			this.editWidget.isValid
			? this.editWidget.isValid()
			: true
		);
	},

	focus: function(){
		// summary:
		//		Focus the edit widget.
		// tags:
		//		protected

		this.editWidget.focus();
		setTimeout(dojo.hitch(this, function(){
			if(this.editWidget.focusNode.tagName == "INPUT"){
				dijit.selectInputText(this.editWidget.focusNode);
			}
		}), 0);
	}
});

}

if(!dojo._hasResource["dijit.form.CheckBox"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.form.CheckBox"] = true;
dojo.provide("dijit.form.CheckBox");



dojo.declare(
	"dijit.form.CheckBox",
	dijit.form.ToggleButton,
	{
		// summary:
		// 		Same as an HTML checkbox, but with fancy styling.
		//
		// description:
		// User interacts with real html inputs.
		// On onclick (which occurs by mouse click, space-bar, or
		// using the arrow keys to switch the selected radio button),
		// we update the state of the checkbox/radio.
		//
		// There are two modes:
		//   1. High contrast mode
		//   2. Normal mode
		// In case 1, the regular html inputs are shown and used by the user.
		// In case 2, the regular html inputs are invisible but still used by
		// the user. They are turned quasi-invisible and overlay the background-image.

		templateString: dojo.cache("dijit.form", "templates/CheckBox.html", "<div class=\"dijitReset dijitInline\" waiRole=\"presentation\"\n\t><input\n\t \t${nameAttrSetting} type=\"${type}\" ${checkedAttrSetting}\n\t\tclass=\"dijitReset dijitCheckBoxInput\"\n\t\tdojoAttachPoint=\"focusNode\"\n\t \tdojoAttachEvent=\"onmouseover:_onMouse,onmouseout:_onMouse,onclick:_onClick\"\n/></div>\n"),

		baseClass: "dijitCheckBox",

		// type: [private] String
		//		type attribute on <input> node.
		//		Overrides `dijit.form.Button.type`.   Users should not change this value.
		type: "checkbox",

		// value: String
		//		As an initialization parameter, equivalent to value field on normal checkbox
		//		(if checked, the value is passed as the value when form is submitted).
		//
		//		However, attr('value') will return either the string or false depending on
		//		whether or not the checkbox is checked.
		//
		//		attr('value', string) will check the checkbox and change the value to the
		//		specified string
		//
		//		attr('value', boolean) will change the checked state.
		value: "on",

		// readOnly: Boolean
		//		Should this widget respond to user input?
		//		In markup, this is specified as "readOnly".
		//		Similar to disabled except readOnly form values are submitted.
		readOnly: false,

		attributeMap: dojo.delegate(dijit.form.ToggleButton.prototype.attributeMap, {
			readOnly: "focusNode"
		}),

		_setReadOnlyAttr: function(/*Boolean*/ value){
			this.readOnly = value;
			dojo.attr(this.focusNode, 'readOnly', value);
			dijit.setWaiState(this.focusNode, "readonly", value);
			this._setStateClass();
		},

		_setValueAttr: function(/*String or Boolean*/ newValue){
			// summary:
			//		Handler for value= attribute to constructor, and also calls to
			//		attr('value', val).
			// description:
			//		During initialization, just saves as attribute to the <input type=checkbox>.
			//
			//		After initialization,
			//		when passed a boolean, controls whether or not the CheckBox is checked.
			//		If passed a string, changes the value attribute of the CheckBox (the one
			//		specified as "value" when the CheckBox was constructed (ex: <input
			//		dojoType="dijit.CheckBox" value="chicken">)
			if(typeof newValue == "string"){
				this.value = newValue;
				dojo.attr(this.focusNode, 'value', newValue);
				newValue = true;
			}
			if(this._created){
				this.attr('checked', newValue);
			}
		},
		_getValueAttr: function(){
			// summary:
			//		Hook so attr('value') works.
			// description:
			//		If the CheckBox is checked, returns the value attribute.
			//		Otherwise returns false.
			return (this.checked ? this.value : false);
		},

		postMixInProperties: function(){
			if(this.value == ""){
				this.value = "on";
			}

			// Need to set initial checked state as part of template, so that form submit works.
			// dojo.attr(node, "checked", bool) doesn't work on IEuntil node has been attached
			// to <body>, see #8666
			this.checkedAttrSetting = this.checked ? "checked" : "";

			this.inherited(arguments);
		},

		 _fillContent: function(/*DomNode*/ source){
			// Override Button::_fillContent() since it doesn't make sense for CheckBox,
			// since CheckBox doesn't even have a container
		},

		reset: function(){
			// Override ToggleButton.reset()

			this._hasBeenBlurred = false;

			this.attr('checked', this.params.checked || false);

			// Handle unlikely event that the <input type=checkbox> value attribute has changed
			this.value = this.params.value || "on";
			dojo.attr(this.focusNode, 'value', this.value);
		},

		_onFocus: function(){
			if(this.id){
				dojo.query("label[for='"+this.id+"']").addClass("dijitFocusedLabel");
			}
		},

		_onBlur: function(){
			if(this.id){
				dojo.query("label[for='"+this.id+"']").removeClass("dijitFocusedLabel");
			}
		},

		_onClick: function(/*Event*/ e){
			// summary:
			//		Internal function to handle click actions - need to check
			//		readOnly, since button no longer does that check.
			if(this.readOnly){
				return false;
			}
			return this.inherited(arguments);
		}
	}
);

dojo.declare(
	"dijit.form.RadioButton",
	dijit.form.CheckBox,
	{
		// summary:
		// 		Same as an HTML radio, but with fancy styling.

		type: "radio",
		baseClass: "dijitRadio",

		_setCheckedAttr: function(/*Boolean*/ value){
			// If I am being checked then have to deselect currently checked radio button
			this.inherited(arguments);
			if(!this._created){ return; }
			if(value){
				var _this = this;
				// search for radio buttons with the same name that need to be unchecked
				dojo.query("INPUT[type=radio]", this.focusNode.form || dojo.doc).forEach( // can't use name= since dojo.query doesn't support [] in the name
					function(inputNode){
						if(inputNode.name == _this.name && inputNode != _this.focusNode && inputNode.form == _this.focusNode.form){
							var widget = dijit.getEnclosingWidget(inputNode);
							if(widget && widget.checked){
								widget.attr('checked', false);
							}
						}
					}
				);
			}
		},

		_clicked: function(/*Event*/ e){
			if(!this.checked){
				this.attr('checked', true);
			}
		}
	}
);

}

if(!dojo._hasResource["com.ibm.widgets.InlineEditorWrapper"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.widgets.InlineEditorWrapper"] = true;
dojo.provide("com.ibm.widgets.InlineEditorWrapper");






// mix this into any other widget to get wrapped inline editor support with an optional popup
// advanced editor
dojo.declare("com.ibm.widgets.InlineEditorWrapper",
			null,
			{
				embeddedEditorWidget: "dijit.form.TextBox",
				embeddedEditorParams: {},
				
				popupWidget: "com.ibm.widgets.InlineEditorPopup",
				popupParams: {},
				
				postMixInProperties: function() {
					this.inherited(arguments);
					this.popupParams = dojo.mixin({}, this.popupParams);
				},
				
				postCreate: function() {
					this.inherited(arguments);
					if(!this._supportingWidgets) this._supportingWidgets = [];
					
					this._supportingWidgets.push(this.editor = new com.ibm.widgets.WrappedInlineEditBox({
						value: this.label,
						title: this.title,
						editor: this.embeddedEditorWidget,
						editorParams: this.embeddedEditorParams,
						canExit: dojo.hitch(this, function(){
							if(this.popupFocused || (this.editorFocused && !this.editor._wantsFocus)) {
								this.editor.editWidget._exitInProgress = false;
								return false;
							}
							return true;
						}),
						saveIsValid: function() {
							if(this.disabled || !this.editing || me.popupFocused || (
								this.editWidget.editWidget &&
								this.editWidget.editWidget.validate &&
								!this.editWidget.editWidget.validate()
								)) {
									this.editWidget._exitInProgress = false;
									return false;
							}
							return true;
						}
					}, this.editor));
					
					var _save = this.editor.save;
					var me = this;
					
					var _edit = dojo.hitch(this.editor, this.editor.edit);
					this.editor.edit = dojo.hitch(this, function() {
						this.editor.attr("value", this.defaultValue);
						_edit();
						
						// disable popup for checking private or public
						//this.editorPopup = this._getPopup();
						if(this.editorPopup) {
							this.editorPopup.attr("value", this.popupDefaultValue);
							dijit.popup.open({
								parent: this,
								popup: this.editorPopup,
								around: this.domNode,
								onCancel: dojo.hitch(this, this.editor.cancel),
								onClose: function(){ }
							});
						}
					});
					
					this.connect(this.editor, "onChange", "_onChange");
					this.connect(this.editor, "onCancel", "_onCancel");
					this.connect(this.editor, "edit", "onEdit");
				},
				_getPopup: function() {
					if(this.editorPopup) return this.editorPopup;
					if(!this.popupWidget) return null;
					var cls = dojo.getObject(this.popupWidget);
					if(cls) {
						this.editorPopup = new cls(this.popupParams);
						dijit.popup.prepare(this.editorPopup.domNode);
						this.editorPopup.startup();
						this.popupDefaultValue = this.editorPopup.attr("value");
						this.connect(this.editorPopup, "onFocus", function() {
							this.popupFocused = true;
							this.editorFocused = false;
						});
						this.connect(this.editorPopup, "onBlur", function() {
							this.popupFocused = false;
							setTimeout(dojo.hitch(this, function(){
								if(!this.editorFocused && this.editor.editWidget) {
									this.editor.editWidget._onBlur();
								}
							}),50);
						});
						this.connect(this.editor, "onFocus", function(){
							this.editorFocused = true;
							this.popupFocused = false;
						});
						this.connect(this.editor, "onBlur", function(){
							this.editorFocused = false;
						});
						
						return this.editorPopup;
					}
					return null;
				},
				startup: function() {
					this.editor.startup();
				},
				isEditing: function() {
					return this.editor && this.editor.editing;
				},
				_onChange: function(value) {
					// change the value back to its default, and call onChange with the
					// saved value
					this.editor.attr("value", this.label);
					var compositeValue = {label: value};
					if(this.editorPopup) {
						compositeValue = dojo.mixin(this.editorPopup.attr("value"), compositeValue);
						dijit.popup.close(this.editorPopup);
					}
					this.onChange(compositeValue, this.editor._wantsFocus);
				},
				onChange: function(value, focus) {
					// summary: Extension point for getting notifications about when this editor
					//		changes values.
					// value: New value of the inline editor
					// focus: Boolean indicating whether or not focus should stay on the inline editor
					//		usually because the ENTER key was pressed to save the value as opposed to
					//		an onblur event.
				},
				_onCancel: function() {
					this.editor.attr("value", this.label);
					if(this.editorPopup) dijit.popup.close(this.editorPopup);
					this.onCancel(this.editor._wantsFocus);
				},
				onCancel: function(focus) {
					// summary: Extension point for getting notifications about when this editor
					//		is canceled during an edit operation.
				},
				onEdit: function() {
					// summary: Extension point for getting notifications about when this editor
					//		goes into edit mode.
				}
			}
);

dojo.declare("com.ibm.widgets.WrappedInlineEditBox",
	dijit.InlineEditBox,
	{
		waitTime: 50,
		
		_wantsFocus: false,
		
		constructor: function() {
			this._connections = [];
		},
		canExit: function() {
			return true;
		},
		waitToExit: function(fname, argsArray) {
			setTimeout(dojo.hitch(this, function(){
				if(this.canExit() && this[fname + "IsValid"]()) {
					dijit.InlineEditBox.prototype[fname].apply(this, argsArray);
					this._wantsFocus = false;
				}
			}), this.waitTime);
		},
		saveIsValid: function() {
			return true;
		},
		cancelIsValid: function() {
			return true;
		},
		save: function(focus) {
			this._wantsFocus = focus;
			this.waitToExit("save", arguments);
		},
		cancel: function(focus) {
			this._wantsFocus = focus;
			this.waitToExit("cancel", arguments);
		},
		edit: function() {
			this.inherited(arguments);
			this._wantsFocus = false;
			var ew = this.editWidget;
			this._connections.push(dojo.connect(ew, "focus", this, "onFocus"));
			this._connections.push(dojo.connect(ew.editWidget, "onFocus", this, "onFocus"));
			this._connections.push(dojo.connect(ew, "onBlur", this, "onBlur"));
			var destroyConnection = dojo.connect(ew.editWidget, "destroy", this, function(){
				dojo.forEach(this._connections, dojo.disconnect);
				dojo.disconnect(destroyConnection);
			});
		}
	}
);

dojo.declare("com.ibm.widgets.InlineEditorPopup",
	dijit.layout.ContentPane,
	{
		"class": "inlineEditorPopup",
		
		content: 
			'<form dojoType="dijit.form.Form" encType="multipart/form-data" action="" method="POST" onSubmit="return false;" onReset="return false;">'
				+'<input name="isPrivate" checked="checked" dojoType="dijit.form.CheckBox">'
				+'<label for="isPrivate">Make this my private page</label>'
			+'</form>',

		onFocus: function() {
			
		},
			
		_getValueAttr: function() {
			var childWidgets = dojo.query("> [widgetId]", this.containerNode).map(dijit.byNode);
			if(childWidgets.length > 0)	return childWidgets[0].attr("value");
			return null;
		},
		_setValueAttr: function(value) {
			var childWidgets = dojo.query("> [widgetId]", this.containerNode).map(dijit.byNode);
			if(childWidgets.length > 0)	childWidgets[0].attr("value", value);
		}
	}
);

}

if(!dojo._hasResource["com.ibm.widgets.TabBar"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.widgets.TabBar"] = true;
dojo.provide( "com.ibm.widgets.TabBar" );






/*
 * Provides Menu widgets using OneUI structure and styles by subclassing dijit.Menu widgets
 * and modifying the templates
 */


dojo.declare( "com.ibm.widgets.TabBar",
			[dijit._Widget, dijit._Templated, dijit._KeyNavContainer],
			{
				// summary: 
				//		Holds a set of tabs in a bar widget.  Provides logic to manage popups
				// 		for each tab (specified by the 'popup' property of the tab widget) if
				//		present.
				
				// class: String class applied to the root node in this widget
				"class": "lotusTabContainer",
				
				// tabListClass: String class applied to the unorderered list node in this 
				// 		widget
				tabListClass: "lotusTabs",
				
				// tabClass: String the class passed in as the class of each tab widget
				//		that is added as a child to this tab bar.  If empty or null, the
				//		tab widget will assume whatever its default class is.
				tabClass: "lotusTab",
				
				// tagWidget: String the name of the widget class to instantiate for each
				//		tab in this tab bar.  Alternatively, simply calling the addChild
				//		function with any widget as the argument will add that widget to
				//		this tab bar, although it may not look appropriate.
				tabWidget: "com.ibm.widgets.Tab",
				
				// tabStrip: Boolean indicating if an additional CSS class is applied to the
				//		root DOM node of this widget which has the value of the class+"Strip"
				//		Example - class = "lotusTabContainer", with tabStrip = true, an additional
				//		class "lotusTabContainerStrip" is added as well.
				tabStrip: false,
				
				// skipPreload: Boolean indicating whether or not this widget should skip an
				//		attempt to preload data found in parsed widget markup.  False by default.
				skipPreload: false,
				
				templateString: '<div class="${class}" waiRole="navigation" dojoAttachPoint="focusNode">'+
									'<ul class="${tabListClass}" waiRole="tablist" dojoAttachPoint="containerNode,tabList" dojoAttachEvent="onkeypress:_onKeyPress"></ul>'+
								'</div>',
				
				attributeMap: dojo.mixin(dojo.clone(dijit._Widget.prototype.attributeMap), {
					tabListClass: {node: "containerNode", type: "class" }
				}),
				
				_setClassAttr: function(/*String*/ value){
					this["class"] = value;
					this.domNode.className = value;
				},
				
				postCreate: function() {
					this.inherited(arguments);
					if (this.tabStrip) {
						dojo.addClass(this.tabList, this["class"] + "Strip");
					}
					var ltr = this.isLeftToRight(),
						k = dojo.keys;
					this.connectKeyNavHandlers(
						ltr ? [k.LEFT_ARROW] : [k.RIGHT_ARROW],
						ltr ? [k.RIGHT_ARROW] : [k.LEFT_ARROW]
					);
				},
				
				startup: function() {
					this.startupKeyNavChildren();
					this.inherited(arguments);
				},
				
				_fillContent: function(/*DomNode*/ source){
					var dest = this.containerNode;
					if(source && dest) {
						var nodes = dojo.query("> ul", source);
						if(nodes.length > 0) {
							this.preloaded = !this.skipPreload;
							this.tabListClass = nodes[0].className;
							this.containerNode.className = this.tabListClass;
							source = nodes[0];
						}
					}
					
					return this.inherited(arguments);
				},
				
				_onKeyPress: function(evt){
					if (evt.ctrlKey || evt.altKey) {
						return;
					}
					if (evt.charOrCode == dojo.keys.DOWN_ARROW) {
					 	this._moveToPopup(evt);
					 	dojo.stopEvent(evt);
					}	
				},
				_onNodeBlur: function(evt){
					// when focus leaves a child,
					// reinstate the container's tabindex
					/*
					var item = dijit.getEnclosingWidget(evt.target);
					this._onChildBlur(item);
					*/
					this._startCloseTimer();
					this.inherited(arguments);
				},
				_onChildBlur: function(item) {
					if (item.popup) {
						dijit.popup.close(item.popup);
					}
					item._blur();
				},
				_moveToPopup: function(/*Event*/ evt){
					if(this.focusedChild && this.focusedChild.popup && !this.focusedChild.disabled) {
						this._openPopup(this.focusedChild, true);
					}
				},
				_moveToNextPopup: function() {
					this.focusNext();
				},
				_openPopup: function(item, focus) {
					var popup = item.popup;
					if (!popup) {
						return false;
					}
					if(this.currentPopup == popup) {
						if(focus && popup.focus) {
							popup.focus();
						}
						return false;
					}
					var me = this;
					var ori = {'BL':'TL', 'TL':'BL'};
					if (!this.isLeftToRight())
					{
						ori = {'BR':'TR', 'TR':'BR'};
					}
					dijit.popup.open({
						parent: this,
						popup: popup,
						orient: ori,
						around: item.domNode,
						onCancel: function() {
							if (popup.close) {
								popup.close();
							}
							else {
								dijit.popup.close(popup);
							}
							item.focus();
							me.currentPopup = null;
						},
						onClose: function() {
							me.currentPopup = null;
						}
					});
					
					this.currentPopup = popup;
					
					if(focus && popup.focus) {
						popup.focus();
					}
					
					return true;
				},
				
				_closePopup: function() {
					if(this.currentPopup) {
						if (this.currentPopup.close) {
							this.currentPopup.close();
						}
						else {
							dijit.popup.close(this.currentPopup);
						}
					}
					this.currentPopup = null;
				},
				
				_startCloseTimer: function() {
					if(this.currentPopup) {
						if(this.currentPopup._startCloseTimer) {
							// the popup supports the _startCloseTimer function, call it
							this.currentPopup._startCloseTimer();
						}
						else {
							// if it does not, close it immediately
							this._closePopup();
						}
					}
				},
				
				_stopCloseTimer: function() {
					if(this.currentPopup && this.currentPopup._stopCloseTimer) {
						this.currentPopup._stopCloseTimer();
					}
				},
				_onItemAccent: function(child, focus) {
					if (child.attr("disabled")) {
						return;
					}
					// stop any close timers
					this._stopCloseTimer();
					if(this.currentPopup) {
						if (this.currentPopup.canClose && !this.currentPopup.canClose()) {
							return;
						}
						if(this.currentPopup != child.popup) {
							// close the existing popup if it's not the one associated with hovered item
							// close it immediately without allowing any animation or effect so that
							// the new menu that's being opened will display correctly
							dijit.popup.close(this.currentPopup);
						}
					}
					// open the hovered item popup
					this._openPopup(child, focus);
				},
				onItemFocus: function(child) {
					//this._onItemAccent(child, false);
				},
				onItemClick: function(child, evt) {
					if (child.attr("disabled")) {
						return;
					}
					child.onClick(evt);
				},
				onItemHover: function(child, evt) {
					this._onItemAccent(child, false);
				},
				onItemUnhover: function(item) {
					this._startCloseTimer();
				}
			}
);

dojo.declare( "com.ibm.widgets._TabBase",
			[dijit._Widget, dijit._Templated, dijit._Contained],
			{
				"class": "lotusTab",
				_setDisabledAttr: function(/*Boolean*/ value){
					this.disabled = value;
					dojo[value ? "addClass" : "removeClass"](this.domNode, "disabled");
					dijit.setWaiState(this.focusNode, 'disabled', value ? 'true' : 'false');
				},
				_setClassAttr: function(/*String*/ value){
					this["class"] = value;
					this.domNode.className = value;
				},
				focus: function(){
					dijit.focus(this.focusNode);
				},
				onFocus: function() {
					this.getParent().onItemFocus(this);
				},
				_onHover: function(evt) {
					this.getParent().onItemHover(this, evt);
				},
				_onUnhover: function(evt) {
					this.getParent().onItemUnhover(this, evt);
				},
				_blur: function() {
					// called by parent to perform any blur action on this item
				}
			}
);

dojo.declare( "com.ibm.widgets.Tab",
			com.ibm.widgets._TabBase,
			{
				iconClass: "",
				href: "",
				label: "",
				
				templateString:"<li class=\"${class}\" dojoAttachEvent=\"onclick:_onClick,onmouseenter:_onHover,onmouseleave:_onUnhover\"\n\t><div waiRole=\"presentation\" dojoAttachPoint=\"containerNode\"\n\t\t><span class=\"dragHandle\" waiRole=\"presentation\" dojoAttachPoint=\"dndHandleNode\"\n\t\t\t><span class=\"dragHandleInner\" waiRole=\"presentation\"\n\t\t\t\t><img dojoAttachPoint=\"iconNode\" alt=\"\" src=\"${_blankGif}\" waiRole=\"presentation\" \n\t\t\t\t/><span waiRole=\"presentation\" class=\"dragHandleA11y\">|</span\n\t\t\t></span\n\t\t></span\n\t\t><a dojoAttachPoint=\"focusNode,linkNode,labelNode\" href=\"javascript:;\" onclick=\"javascript:return false;\" waiRole=\"menuitem\"></a\n\t\t><span class=\"modelHasChildrenIcon\" waiRole=\"presentation\" dojoAttachPoint=\"hasChildrenIconNode\"\n\t\t\t><img src=\"${_blankGif}\" alt=\"\" waiRole=\"presentation\" class=\"dijitArrowButtonInner\"\n\t\t\t/><span waiRole=\"presentation\" class=\"dijitArrowButtonChar\">&#9660;</span\n\t\t></span\n\t\t><div class=\"dndMagicZone\" waiRole=\"presentation\"\n\t\t></div\n\t></div\n></li>\n",
								
				attributeMap: dojo.mixin(dojo.clone(dijit._Widget.prototype.attributeMap), {
					label: {node: "labelNode", type: "innerHTML"},
					href: {node: "linkNode", type: "attribute"},
					iconClass: {node: "iconNode", type: "class" }
				}),
				_setDndHandleAttr: function(value) {
					this.dndHandle = value;
					dojo[value ? "addClass" : "removeClass"](this.dndHandleNode, "dojoDndHandle");
				},
				postCreate: function() {
					this.inherited(arguments);
					if(this.popup) {
						this.setPopup(this.popup);
					}
				},
				
				_fillContent: function(/*DomNode*/ source){
					var dest = this.containerNode;
					var handled = false;
					if(source && dest) {
						var nodes = dojo.query("a", source);
						if(nodes.length > 0) {
							handled = true;
							this.linkNode.setAttribute("href", nodes[0].getAttribute("href"));
							while(nodes[0].hasChildNodes()) {
								this.linkNode.appendChild(nodes[0].firstChild);
							}
						}
					}
					if (!handled) {
						return this.inherited(arguments);
					}
				},
				
				setPopup: function(popup) {
					this.popup = popup;
					this.popup.anchor = this;
					this.popup.startup();
					dijit.setWaiState(this.linkNode, "haspopup", "true");
				},
				destroyPopup: function() {
					if(this.popup) {
						this.popup.destroyRecursive();
						delete this.popup;
						dijit.setWaiState(this.linkNode, "haspopup", "false");
					}
				},
				destroyDescendants: function() {
					this.destroyPopup();
					this.inherited(arguments);
				},
				
				startup: function() {
					this.inherited(arguments);
					if (this.popup) {
						this.popup.startup();
					}
				},
				_onClick: function(evt) {
					var p = this.getParent();
					if(p) {
						p.onItemClick(this, evt);
						dojo.stopEvent(evt);
					}
				},
				onClick: function(evt) {
					
				}
			}
);


dojo.declare( "com.ibm.widgets.ShowEditorTab",
			com.ibm.widgets._TabBase,
			{
				"class": "showEditorTab",
				templateString:	'<li class="${class}" dojoAttachPoint="containerNode" dojoAttachEvent="onclick:onClick">'+
									'<a dojoAttachPoint="focusNode" waiRole="menuitem" class="tabLabel" onclick="javascript:return false;" href="javascript:void(0);">${label}</a>'+
								'</li>',

				
				postCreate: function() {
					this.inherited(arguments);
					dojo.setSelectable(this.domNode, true);
					if(this.popupWidget) {
						var cls = dojo.getObject(this.popupWidget);
						this.popup = new cls(this.popupParams);
						this.connect(this.popup, "onChange", "onChange");
						this.connect(this.popup, "onCancel", "onCancel");
						this.connect(this.popup, "focus", "onEdit");
					}
				},
				onFocus: function() {
					
				},
				onChange: function(value) {
					
				},
				onCancel: function() {
					
				},
				onEdit: function() {
					
				},
				onClick: function(evt) {
					if (this.popup){
						// Check if there is a page manager and bring up the save changes dialog.
						if (typeof ibmPortalConfig != "undefined" && typeof ibmPortalConfig.savePageManager != "undefined" && typeof ibmPortalConfig.savePageManager.leavePage != "undefined") {
							var dialog = this.popup;
							var dialogOpen = function() { dialog.focus(); };
							ibmPortalConfig.savePageManager.leavePage(dialogOpen);
						}
						else {
							this.popup.focus();
						}
					}
				}
			}
);

dojo.declare( "com.ibm.widgets.EditorTab",
			[com.ibm.widgets._TabBase, com.ibm.widgets.InlineEditorWrapper],
			{
				templateString:"<li class=\"inlineEditor ${class}\" waiRole=\"presentation\" dojoAttachPoint=\"containerNode\" dojoAttachEvent=\"onclick:onClick,onmouseenter:_onHover,onmouseleave:_onUnhover\"\n\t><div\n\t\t><a dojoAttachPoint=\"editor,focusNode\" href=\"javascript:;\" class=\"tabLabel\" waiRole=\"tab\" onclick=\"javascript:return false;\">${label}</a\n\t></div\n></li>\n",
				
				"class": "lotusTab",
				
				postCreate: function() {
					this.inherited(arguments);
					dojo.setSelectable(this.domNode, true);
				}	
			}
);

}

if(!dojo._hasResource["com.ibm.widgets.TimedMenu"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.widgets.TimedMenu"] = true;
dojo.provide("com.ibm.widgets.TimedMenu");

dojo.declare("com.ibm.widgets.TimedMenu",
			null,
			{
				_onHover: function() {
					this._enter();
				},
				_onUnhover: function() {
					this._exit();
				},
				_onNodeFocus: function(evt){
					this._enter();
					this.inherited(arguments);
				},
				_onNodeBlur: function(evt){
					this._exit();
					this.inherited(arguments);
				},
				_exit: function() {
					this._startCloseTimer();
					if(this.parentMenu && this.parentMenu._startCloseTimer) {
						// if we have a parent that has this function (ie, an instance of the same class),
						// tell it to start its timer too
						this.parentMenu._startCloseTimer();
					}
				},
				_enter: function() {
					this._stopCloseTimer();
				},
				_startCloseTimer: function() {
					// summary: Starts the timer to close this menu if it's not already set.
					//		Marks this menu to be closed and marks the parent menu to be closed too.
					if(!this._closeTimer) {
						this._isClosing = true;
						if(this.parentMenu) this.parentMenu._isClosing = true;
						if(this.closeDelay == 0) {
							this.close();
						} 
						else {
							this._closeTimer = setTimeout(dojo.hitch(this, function(){
								this._closeTimer = null;
								this.close();
							}), this.closeDelay);
						}
					}
				},
				_stopCloseTimer: function() {
					// summary: Stops the timer that closes this menu if it's set.
					//		Clears this menu from being closed and stops the parent
					//		from being closed if it exists.
					this._isClosing = false;
					if(this.parentMenu && this.parentMenu._stopCloseTimer) this.parentMenu._stopCloseTimer();
					if(this._closeTimer) {
						clearTimeout(this._closeTimer);
						this._closeTimer = null;
					}
				},
				canClose: function() {
					// summary: Indicates whether or not this menu can close right now.  Is
					//		used to keep menus from closing when they are editing or in other
					//		conditions.
					return true;
				},
				close: function() {
					// summary: Closes this menu upon the condition that the menu is still set for
					//		close when this is called (typically after some delay).  Will also
					//		call the parent's close function if it exists.
					if(this._isClosing && this.canClose())	{
						var parentMenu = this.parentMenu;
						this.closeAction();
						if(parentMenu && parentMenu.close) parentMenu.close();
					}
				},
				closeAction: function() {
					// summary: Closes this menu.  Can be overriden to animate the close operation or
					//		do something different.  Default is simply to close the menu.  Is called
					//		after delays have already been processed, so take care not to wait for
					//		the expected delay again unless that is the desired action.
					dijit.popup.close(this);
				}
			}
);

}

if(!dojo._hasResource["com.ibm.dnd.CustomManagerSource"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.dnd.CustomManagerSource"] = true;
dojo.provide("com.ibm.dnd.CustomManagerSource");



com.ibm.dnd.CustomManagerMixin = {
		// summary: An extension of the dojo.dnd.Source base module which provides 
		//		automatic declarative support for overriding properties on the dnd
		//		manager dynamically when a drag operation originates from this source.
		//		All properties that are overriden are reset back to their original
		//		values once the drag operation ends, regardless of the target or
		//		the outcome.  Customizing the dnd manager from a dnd Source is easily
		//		done by extending this module and overriding the managerOverrides
		//		map in the extension.
		
		// managerOverrides: Object
		//		Map of properties to override in the dojo.dnd.Manager instance returned
		//		by dojo.dnd.manager() when onMouseDown occurs in this dnd Source.
		//		The properties defined here will override the same properties in the
		//		dnd manager, and then reset back to what they were before after the
		//		drag operation ends.
		managerOverrides: {},
		
		_partialMixin: function(tgt, src, map) {
			// summary: Performs a partial, simple mixin from the src to the tgt as defined
			// 		by the map.  For each property defined in map, it sets the value of 
			// 		that property in tgt to the value of that same property in src.
			for(var p in map) {
				tgt[p] = src[p];
			}
			return tgt;
		},
		
		_changeManager: function() {
			// only fix once
			if(!this._mgr) {
				this.mgrProps = {};
				this._mgr = dojo.dnd.manager();
				this._partialMixin(this.mgrProps, this._mgr, this.managerOverrides);
				dojo.mixin(this._mgr, this.managerOverrides);
				this._mgrFixConn = dojo.connect(dojo.doc, "onmouseup", this, "_fixManager");
			}
		},
		_fixManager: function() {
			if(this._mgrFixConn) {
				dojo.disconnect(this._mgrFixConn);
				this._mgrFixConn = null;
			}
			if(this._mgr) {
				dojo.mixin(this._mgr, this.mgrProps);
				this.mgrProps = {};
			}
			// reset
			this._mgr = null;
		},
		onMouseDown: function(e){
			// summary: Plugin to change the dojo.dnd manager instance using the dynamic
			//		hot replace/fix paradigm.
			this._changeManager();
			this.inherited(arguments);
		},
		destroy: function() {
			// safety if for some reason we get destroyed before fixing the manager
			if(this._mgrFixConn) dojo.disconnect(this._mgrFixConn);
			this._mgrFixConn = null;
			this.inherited(arguments);
		}
	}

dojo.declare("com.ibm.dnd.CustomManagerSource",
	dojo.dnd.Source,
	com.ibm.dnd.CustomManagerMixin
);

dojo.declare("com.ibm.dnd.CustomManagerAutoSource",
	dojo.dnd.AutoSource,
	com.ibm.dnd.CustomManagerMixin
);

}

if(!dojo._hasResource["com.ibm.dnd.TunedLayoutSource"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.dnd.TunedLayoutSource"] = true;
/**
 * @author Qing Guo
 * This class is used to override the default dojo dnd implementation to minimize un-necessary html refolow and repaint
 * for performance concern regarding IE6&IE7
 */
dojo.provide("com.ibm.dnd.TunedLayoutSource");



dojo.declare("com.ibm.dnd.TunedLayoutSource", com.ibm.dnd.CustomManagerSource, {
    managerOverrides: {
        OFFSET_X: 1,
        OFFSET_Y: 1,
        //Following codes are used to override default dojo implementation to provide better performance	
        stopDrag: function(){
            // summary:
            //		stop the DnD in progress
            if (!dojo.isIE) {
                dojo.removeClass(dojo.body(), "dojoDndCopy");
                dojo.removeClass(dojo.body(), "dojoDndMove");
            }
            dojo.forEach(this.events, dojo.disconnect);
            this.events = [];
            this.avatar.destroy();
            this.avatar = null;
            this.source = this.target = null;
            this.nodes = [];
        }
    },
    
    //Override default dojo.dnd.Container's _changeState method
    _changeState: function(type, newState){
        var prefix = "dojoDnd" + type;
        var state = type.toLowerCase() + "State";
        
        //Following changes are against default dojo, if state doesn't change, do not "remove and add" again
        if (this[state] != newState) {
            //dojo.removeClass(this.node, prefix + this[state]);
            //dojo.addClass(this.node, prefix + newState);
            
            var toR = prefix + this[state];
            var toA = prefix + newState;
            var cls = " " + this.node["className"] + " ";
            cls = cls.replace(" " + toR + " ", " ");
            if (toA && cls.indexOf(" " + toA + " ") < 0) {
                cls += toA + " ";
            }
            this.node["className"] = dojo.string.trim(cls);
            this[state] = newState;
        }
    }
});


}

if(!dojo._hasResource["com.ibm.dnd.PageAvatar"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.dnd.PageAvatar"] = true;
dojo.provide("com.ibm.dnd.PageAvatar");

dojo.declare("com.ibm.dnd.PageAvatar", dojo.dnd.Avatar, {
	construct: function(){
		// summary: constructs the avatar for page tabs, 
		//          opacity for the avatar is applied by the 
		//          class assigned during creator
		var div = dojo.doc.createElement("div");
		div.style.position = "absolute";
		div.style.zIndex = 1999;
		div.style.margin = "0px";
		var source = this.manager.source, node;
		// create an avatar representation of the node
		// Portal only allows 1 page tab to be dragged, 
		// so it is known to use the first item in the array
		node = source._normalizedCreator(source.getItem(this.manager.nodes[0].id).data, "avatar").node;
		node.id = "";
		div.appendChild(node);
		this.node = div;
	}
});

}

if(!dojo._hasResource["com.ibm.dnd.ModeledSource"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.dnd.ModeledSource"] = true;
dojo.provide("com.ibm.dnd.ModeledSource");

/*
 * A ModeledSource is a dnd Source which provides dnd operational support to a modeled widget.
 * Can be extended to provide different drop actions, as well as drop zones, depending on the
 * type of data being dragged around.  
 * Examples:
 * 	1) Dragging items of the same type around simply creates drop zones around other objects 
 * 		in a heirarchy or list.  Dropping them reorders those items in the modeled heirarchy.
 *  2) Dragging items of different types onto other items creates drop zones on top of the
 * 		items themselves, representing actions where a certain type of data is applied to a
 * 		different type of data.
 */




if(!dojo.isCopyKey) dojo.isCopyKey = dojo.dnd.getCopyKeyState;

dojo.declare("com.ibm.dnd.ModeledSource",
	com.ibm.dnd.TunedLayoutSource,
	{
		managerOverrides: {
			OFFSET_X: 1,
			OFFSET_Y: 1,
			makeAvatar: function(){
				return new com.ibm.dnd.PageAvatar(this);
			}
		},
		model: null,
		item: null,
		isBidi: false,
		constructor: function(/*DOMNode|String*/node, /*dojo.dnd.__SourceArgs?*/params) {
			if(this.withHandles) {
				dojo.addClass(node, "dndHasHandles");
			}
			
			/* PM31491: fixed isBidi calculation (fixes rtl items being dropped to wrong location) */
			if (typeof(ibmCfg) != "undefined" && ibmCfg.themeConfig){this.isBidi = ibmCfg.themeConfig.isRTL;}
			else if(typeof(ibmConfig) != "undefined"){this.isBidi = ibmConfig.isBidi;}
			else if(typeof(ibmPortalConfig) != "undefined") {this.isBidi = ibmPortalConfig.isRTL;}
		},
		onDrop: function(source, nodes, copy) {
			// summary: Called when a drop action occurs in this container
			var targetWidget = dijit.getEnclosingWidget(this.current),
			nextSibling = null,
			newParentItem = null;
			
			if(dojo.hasClass(this.current, "dojoDndItemChild")){
				newParentItem = targetWidget.item;
			}else{
				newParentItem = targetWidget.getParent().item;

				if(this.current) {
					var afterClass = (this.isBidi && this.horizontal) ? "dojoDndItemBefore" : "dojoDndItemAfter";
					
					if(dojo.hasClass(this.current, afterClass)) {
						targetWidget = targetWidget.getNextSibling();
						while(targetWidget && dojo.hasClass(targetWidget.domNode, "dojoDndItemAnchor")) {
							targetWidget = targetWidget.getNextSibling();
						}
					}
					if(targetWidget) nextSibling = targetWidget.item;
				}
			}
			
			setTimeout(dojo.hitch(this, function() {
				dojo.forEach(nodes, function(node){
					var childWidget = dijit.getEnclosingWidget(node),
						childItem = childWidget.item,
						prevParentItem = childWidget.getParent().item;		
						if(this.checkModelAcceptance(childItem,newParentItem)) this.model.pasteItem(childItem, prevParentItem, newParentItem, copy, nextSibling);
				}, this);
			}), 50);
		},
		checkModelAcceptance: function(childItem,parentItem){
				// stub that is called right before an item is pasted to another location
				// overwite to do more specific checks before moving an item
				return true;
		},
		// mouse event processors
		onMouseMove: function(e){
			// summary: event processor for onmousemove
			// e: Event: mouse event
			if(this.isDragging && this.targetState == "Disabled"){ return; }
			dojo.dnd.Source.superclass.onMouseMove.call(this, e);
			var m = dojo.dnd.manager();
			if(this.isDragging){
				dojo.forEach(this.draggingItems, function(item){
					if(item.popup.isShowingNow){
						dijit.popup.close(item.popup);
						this._removeItemClass(this.current, "Over");
						dojo.removeClass(this.current, "dijitMenuItemHover");
					}
				}, this);
				
				// calculate before/after
				var before = false;
				if(this.current){
					
					if(!this.targetBox || this.targetAnchor != this.current){
						this.targetBox = {
							xy: dojo.coords(this.current, true),
							w: this.current.offsetWidth,
							h: this.current.offsetHeight
						};
					}

					if(this.horizontal){
						//before = (e.pageX - this.targetBox.xy.x) < (this.targetBox.w / 2);
						if((e.pageX - this.targetBox.xy.x) < (this.targetBox.w * 0.25)){
							before = "Before";
						}else if((e.pageX - this.targetBox.xy.x) > (this.targetBox.w * 0.75)){
							before = "After";
						}else{
							before = "Child";
						}
						
					}else{
						//before = (e.pageY - this.targetBox.xy.y) < (this.targetBox.h / 2);
						if((e.pageY - this.targetBox.xy.y) < (this.targetBox.h * 0.25)){
							before = "Before";
						}else if((e.pageY - this.targetBox.xy.y) > (this.targetBox.h * 0.75)){
							before = "After";
						}else{
							before = "Child";
						}
						
					}
				}
				if(this.current != this.targetAnchor || before != this.before){
					this._markTargetAnchor(before);
					m.canDrop(!this.current || m.source != this || !(this.current.id in this.selection));
				}
			}else{
				if(this.mouseDown && this.isSource &&
						(Math.abs(e.pageX - this._lastX) > this.delay || Math.abs(e.pageY - this._lastY) > this.delay)){
					var nodes = this.getSelectedNodes();
					if(nodes.length){
						m.startDrag(this, nodes, this.copyState(dojo.isCopyKey(e), true));
					}
				}
			}
		},
		_markTargetAnchor: function(before){
			// summary: assigns a class to the current target anchor based on "before" status
			// before: Boolean: insert before, if true, after otherwise
			if(this.current == this.targetAnchor && this.before == before){ return; }
			if(this.targetAnchor){
				this._removeItemClass(this.targetAnchor, this.before);
			}
			this.targetAnchor = this.current;
			this.targetBox = null;
			this.before = before;
			if(this.targetAnchor){
				this._addItemClass(this.targetAnchor, this.before);
			}
		},
		_unmarkTargetAnchor: function(){
			// summary: removes a class of the current target anchor based on "before" status
			if(!this.targetAnchor){ return; }
			this._removeItemClass(this.targetAnchor, this.before);
			this.targetAnchor = null;
			this.targetBox = null;
			this.before = true;
		},
		onDndStart: function(source, nodes, copy){
			this.draggingItems = [];
			dojo.forEach(nodes, function(node){
				var widget = dijit.getEnclosingWidget(node);
				if(widget && widget.popup){
					this.draggingItems.push(widget);
					this._removeItemClass(widget.popup, "Over");
					dijit.popup.close(widget.popup);
				}
			}, this);
			
			this.inherited(arguments);
			dojo.addClass(this.node, "isDragging");
		},
		onDndCancel: function(){
			this.inherited(arguments);
			dojo.removeClass(this.node, "isDragging");
		},
		destroy: function() {
			this.inherited(arguments);
			this.model = this.node = this.current = this.item = null;
		}
	}
);

}

if(!dojo._hasResource["com.ibm.widgets.TreeModeled"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.widgets.TreeModeled"] = true;
dojo.provide( "com.ibm.widgets.TreeModeled" );

dojo.require( "com.ibm.dnd.ModeledSource" );
 
/*
 * This module provides a simple API for creating a widget that is built from a data set through
 * some API.  Examples include but are not limited to the tree model API used by dijit.Tree and
 * the dojo.data API.  This module can be mixed in to other widgets that use data to build their
 * representations.
 */

dojo.declare( "com.ibm.widgets._DataBacked",
			null,
			{
				// _loaded: Boolean flag indicates whether or not this data backed widget has loaded
				//		its data yet
				_loaded: false,
				
				// _loading: Boolean flag indicates whether or not this data backed widget is currently
				//		loading its data
				_loading: false,
				
				load: function() {
					// summary: Loads the data used to build the implementing widget.  Subclasses should
					//		ensure that the _onLoad and _onLoading functions are called so that listeners
					//		to the onLoad and onLoading functions can receive proper notifications.
				},
				
				reload: function(force) {
					// summary: Reload a widget's data set in order to (optionally) rebuild
					//		the widget's representation.  Not all subclasses may support this.
					// force: Boolean indicating if reloading should be forced, potentially
					// 		cancelling any current reloading operation.  May be used, for example,
					//		in cases where something about the widget has changed since the
					//		last reload operation started.
				},
				_onLoad: function() {
					// implementations should call this internal function not the public one
					this._loaded = true;
					this._loading = false;
					this.onLoad();
				},
				_onLoading: function() {
					// implementations should call this internal function not the public one
					this._loading = true;
					this.onLoading();
				},
				
				onLoad: function() {
					// summary: Extension point called when data loading is finished regardless
					// 		of success or error.
				},
				onLoading: function() {
					// summary: Extension point called when data loading begins.
					
				}
			}
);


dojo.declare( "com.ibm.widgets.TreeModeled",
			com.ibm.widgets._DataBacked,
			{
				// summary:
				//		Mixin used for widgets that are built using a data model to represent
				//		data in some visual way.  Listens to model notifications of change events
				//		in order to update the representation of the model data in the widget.
				//		To use this mixin, call initializeModelWidget() in postCreate()
				//		and startupModelWidget() in startup().  They must also mixin the 
				// 		dijit._Container mixin or subclass an widget that already mixes it in.
				
				// model: Object which is an implementation	of the com.ibm.data.DataTreeModel
				// 		APIs.
				model: null,
				
				// item: Object the root item of this widget whose children will 
				//		populate the tabs in this widget.  Must be provided to root
				//		this widget at some point in the model.
				item: null,
				
				// items: Map of the widgets representing the children items of item retrieved 
				// 		from the model.  Keys are item ids and values are the widgets representing
				//		the items.
				items: null,
				
				// levels: Number of levels to recurse down the model when creating widget
				//		representations of the model.  Default is Number.MAX_VALUE, indicating 
				// 		no maximum depth, which will continue to create representations of 
				// 		descendants all the	way down the tree model.  Implementations should
				//		handle this accordingly when creating new children.
				levels: Number.MAX_VALUE,
				
				// level: Number the level of the current modeled widget in a heirarchy of modeled
				//		widgets.
				level: 0,
				
				// dndEnabled: Boolean indicates whether or not this widget should allow dnd operations
				dndEnabled: false,
				
				// dndClass: String class used to create a DND source object for this modeled widget
				dndClass: "com.ibm.dnd.ModeledSource",
				
				// dndAccept: Array of dnd types that this widget accepts
				dndAccept: null,
				
				// dndType: Array indicating the dndType(s) of items represented in this
				//		modeled widget.
				dndType: null,
				
				// dndCreator: Function dnd creator function
				dndCreator: null,
				
				// dndSingular: Boolean to determine if multiple items can be dragged
				//		simultaneously or not
				dndSingular: true,
				
				// dndDelay: Number of pixels to use as a delay before triggering a dnd operation
				dndDelay: 0,
				
				// dndHorizontal: Boolean indicating if this model widget should use horizontal dnd
				//		operations.  Default is false.
				dndHorizontal: false,
				
				// loadingIndicatorWidget: String name of widget class used to represent the loading state of this 
				// 		modeled widget.  By default, it is displayed as a child of this widget while children 
				// 		are being loaded, and is then removed after loading has completed.
				loadingIndicatorWidget: "",
				
				// showLoadingOnBootstrap: Boolean indicating whether or not the loading indicator should be displayed
				//		during bootstrap of the widget, or at the first time it loads.  If false, then the loading
				//		indicator will only display after the first time the widget loads.
				showLoadingOnBootstrap: true,
				
				// showInlineEditor: Boolean indicating whether or not to show an inline editor widget 
				// 		somewhere in this modeled widget.  Implementations are free to handle this
				// 		however they please.  One example use case is to provide a means of creating 
				// 		new data in a data backed widget through an inline editor.  Inline editor
				//		onchange events are propagated to the onInlineEditorChange function with the
				//		parentItem and the new value passed as arguments.
				showInlineEditor: false,
				
				// inlineEditorWidget: String name of widget class to use to instantiate the inline
				//		editor of this data backed widget.  Must implement onChange, onCancel, and onEdit
				// 		events for the inline editor.  The com.ibm.widgets.InlineEditorWrapper mixin
				//		provides prebuilt logic for these handlers and can be mixed into other widgets
				//		that will contain the editor.
				inlineEditorWidget: "",
				
				// inlineEditorWidgetParams: Object set of parameters used when instantiating the 
				//		inline editor widget, like {required: true} or {constraints: {}}
				inlineEditorWidgetParams: {},
				
				// inlineEditorTitle: String title to display on hover over the inline editor
				//		while in edit mode
				inlineEditorTitle: "",
				
				// inlineEditorLabel: String default label to display in inline editor
				// 		when not in edit mode 
				inlineEditorLabel: "",
				
				// inlineEditorLabel: String default value to display in inline editor when going into
				// 		edit mode
				inlineEditorDefaultValue: "",
				
				// embeddedEditorWidget: Widget class used to instantiate the embedded inline editor
				//		used inside this modeled widget
				embeddedEditorWidget: "dijit.form.TextBox",
				
				// embeddedEditorParams: Object set of parameters used when instantiating the embedded
				//		inline editor widget, like {required: true} or {constraints: {}}
				embeddedEditorParams: {},
				
				embeddedEditorPopup: "com.ibm.widgets.InlineEditorPopup",
				embeddedEditorPopupParams: {},
				
				//bootstrapped: set to true after the widget is setup on initial page load
				bootstrapped: false,
						
				constructor: function() {
					this.inlineEditorWidgetParams = {};
					this.embeddedEditorParams = {};
					this.embeddedEditorPopupParams = {};
					this.items = {};
				},
				
				initializeModelWidget: function() {
					this.connect(this.model, "onTreeChange", "onModelTreeChange");
					this.connect(this.model, "onChange", "onModelChange");
					this.connect(this.model, "onChildrenChange", "onModelChildrenChange");
					
					if(!this.preloaded) {
						var loaderCls = dojo.getObject(this.loadingIndicatorWidget);
						if(loaderCls) {
							this.loadingIndicator = new loaderCls();
						}
					}
					
					if(this.showInlineEditor) {
						this.connect(this, "onLoad", "setupInlineEditor");
					}
					
					if (!dojo.isArray(this.dndAccept)) {
						this.dndAccept = [this.dndAccept];
					}
					this._dndParams = {
						model: this.model,
						item: this.item,
						skipForm: true,
						accept: this.dndAccept || [],
						singular: this.dndSingular,
						creator: this.dndCreator,
						delay: this.dndDelay,
						horizontal: this.dndHorizontal,
						dropParent: this.containerNode
					};
					
					if(this.dndEnabled && !this.preloaded) {
						this.setupDnd();	// not set up when preloaded, called after preload processing
					}
					
					this._draggingNodes = [];
				},
				
				startupModelWidget: function() {
					if (!this.preloaded && this.showLoadingOnBootstrap) {
						this.showLoading();
					}
				},
				
				setupInlineEditor: function() {
					if(!this.inlineEditor) {
						var editorCls = dojo.getObject(this.inlineEditorWidget);
						if(editorCls) {
							this.inlineEditor = new editorCls(dojo.delegate({
								label: this.inlineEditorLabel,
								title: this.inlineEditorTitle,
								defaultValue: this.inlineEditorDefaultValue,
								embeddedEditorWidget: this.embeddedEditorWidget,
								embeddedEditorParams: this.embeddedEditorParams,
								popupWidget: this.embeddedEditorPopup,
								popupParams: this.embeddedEditorPopupParams
							}, this.inlineEditorWidgetParams));
							
							this.connect(this.inlineEditor, "onChange", "_onInlineEditorChange");
							this.connect(this.inlineEditor, "onCancel", "onInlineEditorCancel");
							this.connect(this.inlineEditor, "onEdit", "onInlineEdit");
							this.addChild(this.inlineEditor);
						}
					}
				},
				
				setupDnd: function() {
					// summary: Called during postCreate to setup dnd operations for this widget.
					//		Subclasses may override for customized behavior.
					if(!this.dndSource) {
						this.dndEnabled = true;
						var cls = dojo.getObject(this.dndClass);
						this.dndSource = new cls(this.domNode, this._dndParams);
						this._dndConnects = [];
						this._dndConnects.push(this.connect(this.dndSource, "onDraggingOver", "onDraggingOver"));
						this._dndConnects.push(this.connect(this.dndSource, "onDraggingOut", "onDraggingOut"));
						this._dndConnects.push(this.connect(this.dndSource, "onDndStart", "onDndStart"));
						this._dndConnects.push(this.connect(this.dndSource, "onDndCancel", "onDndCancel"));
					}
					dojo.forEach(this.getChildren(), function(child){
						child.attr("dndStatus", true);
					}, this);
				},
				disableDnd: function() {
					this._disableLocalDnd();
					dojo.forEach(this.getChildren(), function(child){
						child.attr("dndStatus", false);
					}, this);
				},
				_disableLocalDnd: function() {
					if(this.dndSource) {
						this.dndEnabled = false;
						dojo.forEach(this._dndConnects, this.disconnect, this);
						this._dndConnects = [];
						this.dndSource.destroy();
						this.dndSource = null;
					}
				},
				destroy: function() {
					this._disableLocalDnd();
					this.inherited(arguments);
				},
				getInheritableParameters: function(item) {
					// summary: Returns an object map of parameters to use when constructing the
					//		widget representation of the next level of the model.  Subclasses
					//		can extend this and provide additional properties or override ones
					//		set here.  Much of this is boilerplate, so it's often easiest to
					//		call this.inherited(arguments) and then modify the result before
					//		returning.
					// item: Current item to use as the root of the next level in the model.
					return {
						item: item,
						model: this.model, 
						level: this.level + 1,
						levels: this.levels,
						showInlineEditor: this.showInlineEditor,
						inlineEditorLabel: this.inlineEditorLabel,
						inlineEditorTitle: this.inlineEditorTitle,
						inlineEditorDefaultValue: this.inlineEditorDefaultValue,
						embeddedEditorWidget: this.embeddedEditorWidget,
						embeddedEditorParams: dojo.mixin({}, this.embeddedEditorParams),
						embeddedEditorPopup: this.embeddedEditorPopup,
						embeddedEditorPopupParams: dojo.mixin({}, this.embeddedEditorPopupParams),
						dndCreator: this.dndCreator,
						dndEnabled: this.dndEnabled,
						dndAccept: this.dndAccept,
						dndSingular: this.dndSingular,
						dndDelay: this.dndDelay,
						dndType: this.dndType,
						onModelItemClick: this.onModelItemClick,
						setupInlineEditor: this.setupInlineEditor,
						seedPreloadedData: this.seedPreloadedData
					};
				},
				createItemRep: function(item) {
					// summary: Subclasses should implement this function to create a widget representation of
					//		a data item in the model which is a child of the item backing this widget.  Each
					//		representation created here should mixin dijit._Contained as they will be children
					//		of this widget.  They also must support the dndHandle attribute getter/setter to set 
					// 		and get a boolean value indicating whether or not a	dnd handle should be used on the item.
					// item: Object item in the model backing this widget
				},
				handlePreloaded: function() {
					// summary: Plugin point for overrides that handle instantiation of this widget where data
					//		has been provided in the contents of the of the widget itself.
					this.domNode.removeAttribute("item");
					dojo.forEach(this.getChildren(), function(wij){
						this.items[this.model.getIdentity(wij.item)] = wij;
						this._flagChildForDnd(wij);
						this._flagChildHasChildren(wij);
						wij.domNode.removeAttribute("item");
					}, this);
				},
				seedPreloadedData: function() {
					// summary: Called when a widget is instantiated with preloaded data.  Override this to
					//		parse the data and do any processing such as seeding the model or store with the
					//		data found in the widget source point.
				},
				showLoading: function() {
					if (this.loadingIndicator && !this._loaderVisible) {
						this.addChild(this.loadingIndicator);
						this._loaderVisible = true;
					}
				},
				clearLoading: function() {
					if (this.loadingIndicator && this._loaderVisible) {
						this.removeChild(this.loadingIndicator);
						this._loaderVisible = false;
					}
				},
				load: function(reloadTimeStamp) {
					// summary: Loads the children of this widget's item property from the model, and 
					// 		creates widgets	to represent each child item.  Can be overriden by subclasses 
					// 		to provide customized behavior.
					// returns: Boolean indicating whether or not this widget had any children to load.
					//		In either case, the onLoad and onLoading events are still fired.
					if (this._loaded || this._loading || !this.item) {
						return false; // already loaded, in process, or n/a
					}
					if(this.preloaded) {
						this.seedPreloadedData();
						this.handlePreloaded();
						if(this.showInlineEditor){
							this.setupInlineEditor();
						}
						if(this.dndEnabled) {
							this.setupDnd();	// not set up when preloaded
						}
						return false;
					}
					if(!this.model.mayHaveChildren(this.item)) {
						this.clearLoading();
						this._onLoading();
						this._onLoad();
						return false;
					}
					this._onLoading();
					this.model.getChildren(this.item, 
						dojo.hitch(this, function(items) {
							if(reloadTimeStamp && reloadTimeStamp < this._reloadTimeStamp) {
								return false;
							}
							this.clearLoading();
							if(this._loaded) {
								return false;
							}
							this.loadHandler(items);

							this._onLoad();
						}),
						dojo.hitch(this, function(error) {
							this.clearLoading();
							this._onLoad();
							this.onError(error);
						})
					);
					return true;
				},
				reload: function(force) {
					// summary: Reloads this widget's children by destroying the existing children
					//		that are backed by model items and then calling load again.
					// force: Boolean indicating if reloading should be forced, potentially
					// 		cancelling any current reloading operation.  May be used, for example,
					//		in cases where something about the widget has changed since the
					//		last reload operation started.
					if (this._loading && force != true) {
						return false;
					}
					this._loaded = this._loading = false;
					var items = this.items;
					for(var id in items) {
						this.removeChild(items[id]);
						items[id].destroyRecursive();
						delete items[id];
					}
					if (this.dndSource) {
						this.dndSource.sync();
					}
					this.showLoading();
					this.preloaded = false;
					if (this.model.resolver) {
						this.model.resolver.getValue(this.item, "children").reload();
					}
					this._reloadTimeStamp = new Date().getTime();
					return this.load(this._reloadTimeStamp);
				},
				loadHandler: function(items) {
					if(!this.showInlineEditor && this.inlineEditor){
							this.inlineEditor.destroy();
							this.inlineEditor = null;
					}else if(this.showInlineEditor && !this.inlineEditor){
							this.setupInlineEditor();
					}
					
					var insIndex = 0;
					if (this.inlineEditor) {								
						insIndex = this.getIndexOfChild(this.inlineEditor);
						if(insIndex < 0){ insIndex = null };
					}
					
					dojo.forEach(items, function(item){
						var childWidget = this._setupNewChild(item);
						this.items[this.model.getIdentity(item)] = childWidget;
						
						var li = null;
						if(!this.bootstrapped){
							li = dojo.query("> #"+this.model.getIdentity(childWidget.item), this.containerNode)[0];
						}									
						if(li){
							this.containerNode.replaceChild(childWidget.domNode,li);
							if (insIndex !== null) {
								this.addChild(childWidget, insIndex++);
							}else{
								this.addChild(childWidget);
							}
						}else{
							if (insIndex !== null) {
								this.addChild(childWidget, insIndex++);
							}
							else {
								this.addChild(childWidget);
							}
						}								
					}, this);
					this.bootstrapped = true;
					
					if (this.dndSource) {
						this.dndSource.sync();
					}
				},
				_flagChildForDnd: function(childWidget) {
					//if(this.dndEnabled) {
						dojo.addClass(childWidget.domNode, "dojoDndItem");
						childWidget.domNode.setAttribute("dndType", this.dndType);
						childWidget.domNode.setAttribute("dndData", this.model.getLabel(childWidget.item));
						childWidget.attr("dndHandle", this._dndParams.withHandles);
					//}
				},
				_flagChildHasChildren: function(childWidget) {
					if(!this.model.mayHaveChildren(childWidget.item) || this.levels === 0 || this.level >= this.levels) {
						childWidget.attr("hasChildren", false);
					} else {
						childWidget.attr("hasChildren", true);
					}
				},
				_setupNewChild: function(item) {
					var childWidget = this.createItemRep(item);
					childWidget.item = item;
					this._flagChildForDnd(childWidget);
					this._flagChildHasChildren(childWidget);
					return childWidget;
				},
				onError: function(error) {
					// summary: Called when there is an error loading this widget.
					// error: Error data indicating what failed during the process of retrieving the children
					//		of this widget's item from the model.
					console.error(error);
				},
				onItemCreate: function(childWidget, item) {
					// summary: Can be fired for child items when they are created perhaps after the widget creates 
					// 		some representation of the item before it was created on the server.
				},
				onModelRemoveChild: function(/*Item*/ childItem) {
					var childWidgets = this.getChildren();
					for(var i=0, wij; wij=childWidgets[i], i<childWidgets.length; i++) {
						if(wij.item == childItem) {
							delete this.items[this.model.getIdentity(childItem)];
							this.removeChild(wij);
							wij.destroyRecursive();
							for(var x in wij) {
								try {
									delete wij[x];
								}
								catch(e){
									wij[x] = null;
								}
							}
							if (this.dndSource) {
								this.dndSource.sync();
							}
							return;
						}
					}
				},
				onModelInsertChild: function(/*Item*/ childItem, /*Item*/ nextSiblingItem) {
					var childWidget = this._setupNewChild(childItem);
					var childWidgets = this.getChildren();
					var insIdx = null;
					if(nextSiblingItem) {
						for(var i=0, wij; wij=childWidgets[i], i<childWidgets.length; i++) {
							if(wij.item == nextSiblingItem) {
								insIdx = i;
								break;
							}
						}
					}
					else {
						insIdx = this.getIndexOfChild(this.inlineEditor)
					}
					this.animateInChild(childWidget, insIdx);
					if(!this.model.isCreated(childItem)) {
						if(this._editorChangedWithFocus) {
							setTimeout(function(){
								dijit.focus(childWidget.focusNode ? childWidget.focusNode : childWidget.domNode);
							},0);
						}
						this._editorChangedWithFocus = false;
						childWidget.attr("disabled", true);
						this.model.addOnCreate(childItem, dojo.hitch(this, function(){
							this.items[this.model.getIdentity(childItem)] = childWidget;
							childWidget.attr("disabled", false);
							this.onItemCreate(childWidget, childItem);
						}));
					}
					else {
						this.items[this.model.getIdentity(childItem)] = childWidget;
					}
					if (this.dndSource) {
						this.dndSource.sync();
					}
				},
				onModelReorderChild: function(/*Item*/childItem, /*Item*/nextSiblingItem) {
					var childWidgets = this.getChildren();
					var childWidget = null;
					for(var i=0, wij; wij=childWidgets[i], i<childWidgets.length; i++) {
						if(wij.item == childItem) {
							childWidget = wij;
							this.removeChild(childWidget);
							// remove the item from the childWidgets node-list too, since we process
							// using the childWidgets below
							childWidgets.splice(i, 1);
							break;
						}
					}
					
					var insIdx = null;
					if(nextSiblingItem) {
						for(var i=0, wij; wij=childWidgets[i], i<childWidgets.length; i++) {
							if(wij.item == nextSiblingItem) {
								insIdx = i;
								break;
							}
						}
					}
					else {
						insIdx = this.getIndexOfChild(this.inlineEditor);
					}
					this.animateInChild(childWidget, insIdx);
					if (this.dndSource) {
						this.dndSource.sync();
					}
				},
				onModelTreeChange: function(/*Item*/ childItem, /*Item*/ oldParentItem, /*Item*/ newParentItem, /*Item*/ nextSiblingItem) {
					// summary: Listens to changes in the tree model where a particular childItem is added, removed, or moved
					//		under a parent item in the tree.  Here are the semantics:
					//		1) If oldParentItem is non-null, the childItem used to be a child of the oldParentItem (and still
					//			may, depending upon the other conditions.  If it is null, then the childItem is being inserted
					//			into the tree under the newParentItem as a new created tree node.
					//		2) If newParentItem is non-null, the childItem is now a child of the newParentItem.  If newParentItem
					//			is null, then the item is being deleted from the tree altogether from under the oldParentItem.
					//			If newParentItem is equal to oldParentItem, then the childItem is being reordered among the list
					//			of children of its parent.
					//		3) If nextSiblingItem is non-null, then the item is being moved or inserted into the tree and the 
					//			nextSiblingItem is the next sibling of the childItem under its parent.
					// childItem: Item being operated on in the model.
					// oldParentItem: Item previous parent of the childItem
					// newParentItem: Item new parent of the childItem
					// nextSiblingItem: Item next sibling of the childItem
					var f = null;
					if(this.item == oldParentItem) {
						f = "onModelRemoveChild";
					}
					if(this.item == newParentItem) {
						f = f ? "onModelReorderChild" : "onModelInsertChild";
					}
					if(f) {
						this[f](childItem, nextSiblingItem);
						return true;
					}
					return false;
				},
				onModelChange: function(/*dojo.data.Item*/ item) {
					if(this.items[this.model.getIdentity(item)]) {
						// TODO: process the change
					}
					return false;
				},
				onModelChildrenChange: function(parentItem, children) {
					if(this.item != parentItem) {
						var parentId = this.model.getIdentity(parentItem), child = this.items[parentId];
						if(child) {
							this.handleChildChildrenChange(child, children || []);
						}
						return false;
					}
					// only handle the no-children case... all other updates to children are 
					// handled by the other callbacks
					if(this.anchor) {
						this.anchor.attr("hasChildren", children && children.length > 0);
					}
				},
				handleChildChildrenChange: function(child, children) {
					// summary: Called when a child that has no children gets children or when a child that has children
					//		loses all its children.
				},
				onModelItemClick: function(widget, item) {
					// summary: Extension point for getting notifications when users click
					//		a widget representing an item in this model.  By default, this
					//		is propogated to all cascading modeled widgets created by the
					//		model so that all descendants fire the same function.
					//		Implementations should ensure that any onclick event on a child 
					// 		widget representing	modeled data calls results in a call to this 
					// 		function with the appropriate arguments. 
				},
				onDraggingOver: function() {
					if(this.inlineEditor && this.dndSource.getAllNodes().length === 0) {
						// empty container... style the inlineEditor
						this.dndSource._addItemClass(this.inlineEditor.domNode, "Before");
					}
				},
				onDraggingOut: function() {
					if(this.inlineEditor && this.dndSource.getAllNodes().length === 0) {
						// empty container... style the inlineEditor
						this.dndSource._removeItemClass(this.inlineEditor.domNode, "Before");
					}
				},
				onDndStart: function(source, nodes, copy) {
					if(this.dndSource == source) {
						dojo.forEach(nodes, function(node){
							this._animateOut(node);
						}, this);
						this._draggingNodes = nodes;
					}
				},
				onDndCancel: function() {
					if (this.inlineEditor) {
						this.dndSource._removeItemClass(this.inlineEditor.domNode, "Before");
					}
					dojo.forEach(this._draggingNodes, function(node){
						this._animateIn(node);
					}, this);
					this._draggingNodes = [];
				},
				_animateIn: function(node) {
					if (node._animation) {
						node._animation.stop(true);
					}
					dojo.style(node, "display", "");
					var anim = dojo.fadeIn({
						node: node,
						duration: 500
					});
					if(dojo.isIE) {
						var filter = node.style.filter;
						anim.onEnd = function() {
							node._animation = null;
							node.style.filter = filter;
						}
					}
					node._animation = anim;
					anim.play();
					return anim;
				},
				_animateOut: function(node) {
					if (node._animation) {
						node._animation.stop(true);
					}
					var anim = dojo.fadeOut({
						node: node,
						duration: 500,
						onEnd: function() {
							node._animation = null;
							dojo.style(node, "display", "none");
						}
					});
					node._animation = anim;
					anim.play();
					return anim;
				},
				animateInChild: function(/*Widget*/ widget, /*int?*/ insertIndex) {
					// summary: Adds a child to this modeled widget but allows animation
					//		effects to display the new child.
					// returns: Animation object which has already been started on return.
					//		Returns null if no animation was used.
					var filter = null;
					if(dojo.isIE) {
						filter = widget.domNode.style.filter;
					}
					dojo.style(widget.domNode, "opacity", "0");
					(insertIndex >= 0) ? this.addChild(widget, insertIndex) : this.addChild(widget);
					var anim = this._animateIn(widget.domNode);
					// hack for IE to get filter exactly back to original before animation
					if (dojo.isIE) {
						var conn = dojo.connect(anim, "onEnd", function(){
							widget.domNode.style.filter = filter;
							dojo.disconnect(conn);
						});
					}
					return anim;
				},
				animateOutChild: function(/*Widget*/ widget) {
					// summary: Hides a child from this modeled widget but allows animation
					//		effects when hiding the child.  At the end of the animation,
					//		this removes the child.
					// returns: Animation object which has already been started on return.
					//		Returns null if no animation was used.
					var anim = this._animateOut(widget.domNode);
					dojo.connect(anim, "onEnd", this, function(){
						this.removeChild(widget);
					});
					return anim;
				},
				moveChild: function(/*Widget*/ widget, /*int?*/ newIndex) {
					this.removeChild(widget);
					this.animateInChild(widget, newIndex);
				},
				_onInlineEditorChange: function(value, focus) {
					this._editorChangedWithFocus = focus;
					this.onInlineEditorChange(value, this.item);
				},
				onInlineEditorChange: function(value, parentItem) {
					// summary: Override or connect to this function to get notifications of changes to
					//		this menu's inline editor (if one exists).  The default implementation calls 
					// 		the model's newItem function passing in an object of the form {title: newValue}
					//		as the first argument and the item of this widget as the parent in the second
					//		argument.
					// value: Object map of key-value pairs from the inline editor's composite value.
					// parentItem: Item which is root of the widget whose editor fired its onChange event.
					this.model.newItem(value, parentItem);
				},
				onInlineEditorCancel: function() {
					// summary: Override or connect to this function to get notified when the user cancels
					//		an edit operation in the inline editor.
				},
				onInlineEdit: function() {
					// summary: Override or connect to this function to get notified when the user starts
					//		an edit operation in the inline editor usually by clicking or entering the inline
					//		editor.
				}
			}
);

}

if(!dojo._hasResource["com.ibm.widgets.SelectionModeled"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.widgets.SelectionModeled"] = true;
dojo.provide("com.ibm.widgets.SelectionModeled");





dojo.declare( "com.ibm.widgets.SelectionModeled",
			com.ibm.widgets.TreeModeled,
			{
				// summary:
				//		Mixin for building widgets from a selection model, which is a list structure
				//		that represents a current selection in a model starting at the root and walking
				//		down a tree to the currently selected node.
				
				// level: Number the level of the current modeled widget in a heirarchy of modeled
				//		widgets.  This represents the level in the tree from the root where this
				//		widget is rooted.  From the selection model's point of view, it is the index
				//		into the reverse selection path (since that goes up the tree instead).
				level: 0,
				
				// selectionModel: An instance of the com.ibm.data.SelectionModel class representing
				//		a selection model.
				selectionModel: null,
				
				// selectedClass: String name of the CSS class to apply to a node that is in the
				//		selection path.
				selectedClass: "",
				
				// selectedChild: Child widget which is currently marked as selected, indicating that
				//		it is part of the selection model.
				selectedChild: null,
				
				// tiedToSelection: Boolean flag indicating if this widget is tied to the selection
				//		model at this level.  If this is true, then if the selection path changes
				//		at this level, this widget will reload itself completely to root itself
				//		at the new item in the selection path at this level.
				tiedToSelection: false,
				
				constructor: function(){
					this.bundle = dojo.i18n.getLocalization("com.ibm.bundles", "Theme");
					this.currentlySelected = this.bundle["currently_selected"];
				},
				postMixInProperties: function() {
					this.inherited(arguments);
					this.attr("level", this.getVariedLevel());	// initialize ourselves with level-varying support
				},
				initializeModelWidget: function() {
					this.inherited(arguments);
					this.connect(this.selectionModel, "onSelectionPathChange", "_updateSelection");
				},
				loadHandler: function(items) {
					if(this.selectedChild) {
						delete this.selectedChild;
					}
					return this.inherited(arguments);
				},
				_itemIsEqual: function(item1, item2) {
					return (item1 && this.model.getIdentity(item1)) == (item2 && this.model.getIdentity(item2));
				},
				_setLevelAttr: function(/*String*/ value){
					this.level = value;
					if(this.tiedToSelection) {
						this.item = this.selectionModel.atLevel(this.level, true);
					}
				},
				_markSel: function(childWidget, value) {
					if(value) {
						if(this.selectedChild) {
							this.markSelected(this.selectedChild, false);
						}
						this.selectedChild = childWidget;
					}
					this.markSelected(childWidget, value);
				},
				markSelected: function(childWidget, value) { 
					// summary: Marks the childWidget as selected or unselected depending on the value.
					//		By default, adds/removes the selectedClass to the childWidget's domNode.
					//		Modules that mix this module in can override it to support DOM modifications
					//		that are specific to their markup since this default implementation is
					// 		agnostic to any specific markup.
                    if (childWidget.domNode) {
                        dojo[value ? "addClass" : "removeClass"](childWidget.domNode, this.selectedClass);
                    }
				},
				getVariedLevel: function() {
					// summary: Extension point at which plugins can vary the level at which this
					// 		SelectionModeled widget is tied to.  This is called when the selection path
					// 		changes to determine how the widget should render itself on that change
					// 		event.  If this returns a level that is different than the previous level, 
					// 		the widget will reload itself from scratch and root itself at the item
					//		indexed in the selection path at the level returned by this function.
					//		If this returns the same level as before, no special handling is performed
					//		besides normal widget processing for selections.
					return this.level;
				},
				_updateSelection: function() {
					var oldLevel = this.level, variedLevel = this.getVariedLevel();
					if(oldLevel != variedLevel) {
						// reroot ourselves, and reload
						this.attr("level", variedLevel);
						this.reload(true);
					}
					else {
						var curLevelItem = this.selectionModel.atLevel(this.level, true),
							lastLevelItem = this.selectionModel.atLevel(this.level + 1, true);
						if(curLevelItem != null){
							if(this.tiedToSelection && !this._itemIsEqual(this.item, curLevelItem) ) {
								this.item = curLevelItem;
								this.reload(true);
							}
							else {
								var curLevelId = curLevelItem ? this.model.getIdentity(curLevelItem) : null,
									levelId = lastLevelItem ? this.model.getIdentity(lastLevelItem) : null;
								
								if(curLevelItem && curLevelId != levelId && this.items[curLevelId]) {
									this._markSel(this.items[curLevelId], false);
								}
								if(levelId && this.items[levelId]) {
									this._markSel(this.items[levelId], true);
								}
							}
						}
					}
				},
				_setupNewChild: function(item) {
					var childWidget = this.inherited(arguments);
					if(this._itemIsEqual(this.selectionModel.atLevel(this.level + 1, true), item)) {
						this._markSel(childWidget, true);
					}
					return childWidget;
				},
				getInheritableParameters: function(item) {
					return dojo.mixin(this.inherited(arguments), {
						selectionModel: this.selectionModel,
						selectedClass: this.selectedClass
					});
				},
				onModelItemClick: function(widget, item) {
					// summary: Extension point for getting notifications when users click
					//		a widget representing an item in this model.  By default, this
					//		is propogated to all cascading modeled widgets created by the
					//		model so that all descendants fire the same function.
					//		Implementations should ensure that any onclick event on a child 
					// 		widget representing	modeled data calls results in a call to this 
					// 		function with the appropriate arguments. 
					//		For SelectionModeled widgets, this changes the current selection
					//		to the widget's item that was clicked.
					if(widget.disabled) return false;
					var id = this.model.getIdentity(item);
						thisSel = this.selectionModel.atLevel(this.level, true),
						thisSelId = thisSel ? this.model.getIdentity(thisSel) : null;
					if(thisSelId != id) {
						// didn't click the current selection
						try {
							this.selectionModel.changeSelection(item);
						} catch(e) {/*IE fix*/}
						return true;
					}
					return false;
				}
			}
);

}

if(!dojo._hasResource["com.ibm.widgets.DataMenu"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.widgets.DataMenu"] = true;
dojo.provide("com.ibm.widgets.DataMenu");

dojo.require( "dijit.Menu" );
dojo.require( "dijit.InlineEditBox" );
dojo.require( "com.ibm.widgets.TimedMenu" );
dojo.require( "com.ibm.widgets.SelectionModeled" );
dojo.require( "com.ibm.widgets.InlineEditorWrapper" );



dojo.declare( "com.ibm.widgets.DataMenu",
			[dijit.Menu, com.ibm.widgets.TimedMenu, com.ibm.widgets.SelectionModeled],
			{			
				"class": "lotusActionMenu",
				
				// loadingIndicatorWidget: String name of widget class used to represent the loading state of this 
				// 		modeled widget.  By default, it is displayed as a child of this widget while children 
				// 		are being loaded, and is then removed after loading has completed.
				loadingIndicatorWidget: "com.ibm.widgets.LoadingMenuItem",
				
				// inlineEditorWidget: String name of widget class to use to instantiate the inline
				//		editor of this data backed widget.
				inlineEditorWidget: "com.ibm.widgets.EditorMenuItem",
				
				// closeDelay: Number of milliseconds to wait before closing a menu when it 
				// 		loses focus or receives an unhover event
				closeDelay: 500,
				
				// level: Number indicating the number of ancestor menus in the model chain above
				//		this menu.  Default is 0, indicating that this is a top level menu.
				level: 0,
				
				postCreate: function() {
					this.inherited(arguments);
					var ltr = this.isLeftToRight(),
						k = dojo.keys;
					this._exitKey = ltr ? k.LEFT_ARROW : k.RIGHT_ARROW;
					this._openKey = ltr ? k.RIGHT_ARROW : k.LEFT_ARROW;
					if(this.embeddedEditorParams.tooltipPosition) {
						this.embeddedEditorParams.tooltipPosition = ["after", "before", "below"];
					}
					this.initializeModelWidget();
					this._dndParams.withHandles = true;
					dojo.addClass(this.domNode, this["class"]);
					dojo.addClass(this.domNode, "modeledDataMenu");
					this.connect(this, "onMouseEnter", "_onHover");
					this.connect(this, "onMouseLeave", "_onUnhover");
					
					this.domNode.setAttribute("cellSpacing", "0px");
					dojo.style(this.domNode, {
						borderCollapse: "separate",
						borderSpacing: "0px"
					});
				},
				
				startup: function() {
					this.inherited(arguments);
					this.startupModelWidget();
				},
				
				setupInlineEditor: function() {
					return;
				},
				
				setupDnd: function() {
					this._dndParams.withHandles = true;
					this.inherited(arguments);
				},
				getInheritableParameters: function(item) {
					return dojo.mixin(this.inherited(arguments), {
						parentMenu: this,
						closeDelay: this.closeDelay,
						popupDelay: this.popupDelay,
						"class": this["class"]
					});
				},
				_getPopup: function(item) {
					if(this.level < this.levels) {
						return new this.constructor(this.getInheritableParameters(item));
					}
					return null;
				},
				createItemRep: function(item) {
					var args = {
						iconClass: "dragHandleIcon", 
						label: com.ibm.domUtilities.encodeXML(this.model.getLabel(item)), 
						item: item
					};
					var cls = com.ibm.widgets.DataPopupMenuItem;
					
					if(this.model.mayHaveChildren(item) || this.showInlineEditor) {
						var popup = this._getPopup(item);
						if(popup) {
							args.popup = popup;
						}
					}
					
					var childWidget = new cls(args);
					return childWidget;
				},
				handleChildChildrenChange: function(child, children) {
					// summary: Called when a child that has no children gets children or when a child that has children
					//		loses all its children.
					if(children.length === 0) {
						// child lost all children, destroy its popup
						child.destroyPopup();
						child.attr("hasChildren", false);
					}
					else if(!child.popup){
						// child without children got new children, create its popup
						var popup = this._getPopup(child.item);
						if(popup) {
							child.setPopup(popup);
							child.attr("hasChildren", true);
							popup.load();
							this.onItemHover(child);
						}
					}
				},
				getTopAnchor: function() {
					if (this.anchor) {
						var parent = this.anchor.getParent();
						return parent && parent.getTopAnchor ? parent.getTopAnchor() : this.anchor;
					}
					else {
						return null;
					}
				},
				_moveToPopup: function(/*Event*/ evt){
					if(this.focusedChild && this.focusedChild.popup && !this.focusedChild.disabled) {
						this._openPopup();
					}
					else {
						var topAnchor = this.getTopAnchor();
						if(topAnchor) {
							topAnchor.getParent().focusNext();
						}
					}
				},
				_onChildBlur: function(item) {
					// nobody else is checking this, and apparently when widgets are destroyed
					// and the dom destroyed too, this fails trying to blur a non-existing node
					if (!item || !item.domNode) {
						return;
					}
					return this.inherited(arguments);
				},
				onItemHover: function(/*Widget*/ item){
					// summary: Called when cursor is over a MenuItem
					if(!this.inlineEditor || !this.inlineEditor.isEditing()) {
						this.isActive = true;
						return this.inherited(arguments);
					}
				},
				onItemClick: function(/*Widget*/ child, /*Event*/ evt){
					// summary: user defined function to handle clicks on an item
					if (child.attr("disabled")) {
						return false;
					} 
					this.onExecute();
					child.onClick(evt);
					if(child.item) this.onModelItemClick(child, child.item);
					this._isClosing = true;
					this.close();
				},
				_onKeyPress: function(/*Event*/ evt){
					if(this.inlineEditor && 
					   this.inlineEditor.isEditing() && 
					   dojo.isDescendant(evt.target, this.inlineEditor.domNode)) {
						return;
					}
					 
					if (evt.ctrlKey || evt.altKey) {
						return;
					}
					switch(evt.charOrCode) {
						case this._exitKey:
							if(this.parentMenu) {
								this.onCancel(false);
							}
							else {
								var topAnchor = this.getTopAnchor();
								if(topAnchor) {
									topAnchor.getParent().focusPrev();
								}
							}
							dojo.stopEvent(evt);
							break;
						case this._openKey:
						 	this._moveToPopup(evt);
						 	dojo.stopEvent(evt);
						 	break;
					}
				},
				canClose: function() {
					// summary: Indicates whether or not this menu can close right now.  Is
					//		used to keep menus from closing when they are editing or in other
					//		conditions.
					return !this.inlineEditor || (this.inlineEditor && !this.inlineEditor.isEditing());
				}
			}
);

dojo.declare( "com.ibm.widgets._DataMenuItem", 
			null, 
			{
				templateString: 
				 '<tr class="dijitReset dijitMenuItem" dojoAttachPoint="focusNode" waiRole="menuitem" tabIndex="-1"'+
				 'dojoAttachEvent="onmouseenter:_onHover,onmouseleave:_onUnhover,ondijitclick:_onClick">'+
				 '<td dojoAttachPoint="dndHandleNode" class="dijitReset dragHandle" waiRole="presentation">'+
					'<img dojoAttachPoint="iconNode" src="${_blankGif}" alt="" />'+
					'<span class="dragHandleA11y">|</span>'+
				 '</td>'+
				 '<td class="dijitReset dijitMenuItemLabel" dojoAttachPoint="containerNode"></td>'+
				 '<td class="dijitReset dijitMenuArrowCell" waiRole="presentation">'+
					'<div class="modelHasChildrenIcon" dojoAttachPoint="arrowWrapper">'+
						'<div class="dijitMenuExpand"></div>'+
						'<span class="dijitMenuExpandA11y">+</span>'+
					'</div>'+
				 '</td>'+
				 '</tr>',
				
				_setDndHandleAttr: function(value) {
					this.dndHandle = value;
					dojo[value ? "addClass" : "removeClass"](this.dndHandleNode, "dojoDndHandle");
				},
				_setHasChildrenAttr: function(value) {
					this.hasChildren = value;
					dojo[value ? "addClass" : "removeClass"](this.domNode, "modelHasChildren");
				},
				_setDndStatusAttr: function(value) {
					this.dndStatus = value;
					if(this.popup) {
						this.popup[value ? "setupDnd" : "disableDnd"]();
					}
				},
				focus: function() {
					var parent = this.getParent();
					if(!parent.dndSource || !parent.dndSource.isDragging) {
						this.inherited(arguments);
					}
				}
			}
);

dojo.declare( "com.ibm.widgets.DataMenuItem",
			[dijit.MenuItem, com.ibm.widgets._DataMenuItem], 
			{
				
			}
);

dojo.declare( "com.ibm.widgets.DataPopupMenuItem",
			[dijit.MenuItem, com.ibm.widgets._DataMenuItem],
			{
				constructor: function() {
					this._popupConnects = null;
				},
				startup: function() {
					this.inherited(arguments);
					if(this.popup) {
						this.setPopup(this.popup);
					}
				},
				setPopup: function(popup) {
					this.popup = popup;
					this.popup.anchor = this;
					this._popupConnects = [
						this.connect(this.focusNode, "onfocus", "loadPopup"),
						this.connect(this.popup, "onLoading", "onLoading"),
						this.connect(this.popup, "onLoad", "onLoad")
					];
					this.popup.startup();
					if(this.arrowWrapper) {
						dojo.style(this.arrowWrapper, "visibility", "");
					}
					dijit.setWaiState(this.focusNode, "haspopup", "true");
				},
				destroyPopup: function() {
					if(this.popup) {
						dojo.forEach(this._popupConnects, this.disconnect, this);
						this._popupConnects = null;
						this.popup.destroyRecursive();
						delete this.popup;
						dijit.setWaiState(this.focusNode, "haspopup", "false");
					}
				},
				loadPopup: function() {
					if (this.popup) {
						this.popup.load();
					}
				},
				onLoad: function() {
					// fired when loading this menu item's popup is complete
				},
				onLoading: function() {
					// fired when loading this menu item's popup has started
				},
				_onHover: function() {
					this.loadPopup();
					this.inherited(arguments);
				},
				destroyDescendants: function() {
					this.destroyPopup();
					this.inherited(arguments);
				}
			}
);

dojo.declare( "com.ibm.widgets.LoadingMenuItem",
			dijit.MenuItem,
			{
				label: "Loading...",
				iconClass: "ibmLoading",
				
				postMixInProperties: function() {
					this.shelfBundle = dojo.i18n.getLocalization("com.ibm.bundles", "Shelf");
					this.label=this.shelfBundle.shelf_loading;
				}
			}
);

dojo.declare( "com.ibm.widgets.EditorMenuItem",
			[dijit.MenuItem, com.ibm.widgets.InlineEditorWrapper],
			{
				templateString:
					 '<tr class="dijitReset dijitMenuItem inlineEditor lotusMenuSeparator" dojoAttachPoint="focusNode" waiRole="menuitem" tabIndex="-1"'+
					 'dojoAttachEvent="onmouseenter:_onHover,onmouseleave:_onUnhover,onkeypress:_onKeyPress">'+
					 '<td class="dijitReset" waiRole="presentation"><div class="dijitMenuItemIcon" dojoAttachPoint="iconNode"></div></td>'+
					 '<td class="dijitReset dijitMenuItemLabel" dojoAttachPoint="containerNode"><span dojoAttachPoint="editor">${label}</span></td>'+
					 '<td class="dijitReset dijitMenuArrowCell" waiRole="presentation"></td>'+
					 '</tr>',
					
				attributeMap: dojo.mixin(dojo.clone(dijit.MenuItem.prototype.attributeMap), {
					label: {node: "editor", type: "innerHTML"}
				}),
				postCreate: function() {
					this.inherited(arguments);
					dojo.setSelectable(this.domNode, true);
				},
				focus: function() {
					var parent = this.getParent();
					if(!parent.dndSource || !parent.dndSource.isDragging) {
						this.inherited(arguments);
					}
				},
				_onKeyPress: function(evt) {
					if(!evt.ctrlKey && !evt.altKey && evt.charOrCode == dojo.keys.ENTER	&& !this.isEditing()) {
						this.editor.edit();
						dojo.stopEvent(evt);
						return false;
					}
				}
			}
);

}

if(!dojo._hasResource["com.ibm.widgets.DataTabBar"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.widgets.DataTabBar"] = true;
dojo.provide( "com.ibm.widgets.DataTabBar" );

dojo.require( "com.ibm.widgets.TabBar" );
dojo.require( "com.ibm.widgets.DataMenu" );
dojo.require( "com.ibm.widgets.SelectionModeled" );




dojo.declare( "com.ibm.widgets.DataTabBar",
			[com.ibm.widgets.TabBar, com.ibm.widgets.SelectionModeled],
			{				
				// tagWidget: String the name of the widget class to instantiate for each
				//		tab in this tab bar.
				tabWidget: "com.ibm.widgets.DataTab",
				
				// menuWidget: String the name of the widget class to instantiate for each
				//		menu associated with the tabs.
				menuWidget: "com.ibm.widgets.DataMenu",
				
				// closeDelay: Number of milliseconds to wait before closing a menu when a tab
				//		and any of its menus are no longer hovered over
				closeDelay: 500,
				
				// openDelay: Number of milliseconds to wait before opening a menu when a tab
				//		is hovered over
				openDelay: 0,
				
				// dndHorizontal: Boolean indicating if this model widget should use horizontal dnd
				//		operations.  True for this widget.
				dndHorizontal: true,
				
				// loadingIndicatorWidget: String name of widget class used to represent the loading state of this 
				// 		modeled widget.  By default, it is displayed as a child of this widget while children 
				// 		are being loaded, and is then removed after loading has completed.
				loadingIndicatorWidget: "com.ibm.widgets.LoadingTab",
				
				// inlineEditorWidget: String name of widget class to use to instantiate the inline
				//		editor of this data backed widget.
				inlineEditorWidget: "com.ibm.widgets.ShowEditorTab",
				
				// showNestedInlineEditor: Boolean indicating whether or not to show the inline editor on 
				//		nested menus, cascading down the tree.  False does not show the inline editor for any
				//		while true shows it for all descendants.
				showNestedInlineEditor: false,
								
				postCreate: function() {
					this.inherited(arguments);
					this.initializeModelWidget();
					this._dndParams.withHandles = true;
					dojo.addClass(this.domNode, "modeledTabs");
					if(this.tabStrip) dojo.addClass(this.tabList, this["class"] + "Strip");
				},
				
				startup: function() {
					this.inherited(arguments);
					this.startupModelWidget();
					this.load();
				},
				
				getInheritableParameters: function(item) {
					return dojo.mixin(this.inherited(arguments), {
						closeDelay: this.closeDelay,
						popupDelay: this.popupDelay,
						showInlineEditor: this.showNestedInlineEditor,
						dndClass: this.dndClass
					});
				},
				handlePreloaded: function() {
					// summary: Plugin point for overrides that handle instantiation of this widget where data
					//		has been provided in the contents of the of the widget itself.
					dojo.forEach(this.getChildren(), function(wij){
						if(this.model.mayHaveChildren(wij.item) || this.showNestedInlineEditor) {
							var popup = this._getPopup(wij.item);
							if(popup) {
								wij.setPopup(popup);
								popup.startup();
							}
						}
					}, this);
					return this.inherited(arguments);
				},
				_getPopup: function(item) {
					if(this.level < this.levels) {
						var menuConstructor = dojo.getObject(this.menuWidget);
						return new menuConstructor(this.getInheritableParameters(item));
					}
					return null;
				},
				createItemRep: function(item) {
					var tabConstructor = dojo.getObject(this.tabWidget);
									
					var args = {
						label: com.ibm.domUtilities.encodeXML(this.model.getLabel(item)),
						iconClass: "dragHandleIcon",
						model: this.model,
						item: item
					};
					if(this.tabClass) {
						args["class"]= this.tabClass;
					}
					if(this.model.mayHaveChildren(item) || this.showNestedInlineEditor) {
						var popup = this._getPopup(item);
						if(popup) args.popup = popup;
					}
					
					var childWidget = new tabConstructor(args);
					childWidget.startup();
					
					// don't load the popup immediately
					// if(childWidget.popup) childWidget.popup.load(); 
					return childWidget; 
				},
				handleChildChildrenChange: function(child, children) {
					// summary: Called when a child that has no children gets children or when a child that has children
					//		loses all its children.
					if(!this.showNestedInlineEditor) {
						if(children.length == 0) {
							// child lost all children, destroy its popup
							child.destroyPopup();
							child.attr("hasChildren", false);
						}
						else if(!child.popup){
							// child without children got new children, create its popup
							var popup = this._getPopup(child.item);
							if(popup) {
								child.setPopup(popup);
								child.attr("hasChildren", true);
								popup.load();
								this.onItemHover(child);
							}
						}
					}
				},
				markSelected: function(childWidget, value) { 
					// summary: Marks the childWidget as selected or unselected depending on the value.
					//		By default, adds/removes the selectedClass to the childWidget's domNode.
					dojo[value ? "addClass" : "removeClass"](childWidget.domNode, this.selectedClass);
					if(childWidget.labelNode){
						if(value){  
							// add a strong tag to a selected child widget
							var children = com.ibm.domUtilities.removeChildren(childWidget.labelNode);
							var selectedLabel = dojo.create("strong", null, childWidget.labelNode);
							children.place(selectedLabel);
							if(this.selectionModel.atLevel(0) == childWidget.item){
								var hiddenText = dojo.create("span", {innerHTML: this.currentlySelected, className: "ibmHiddenText"});
								selectedLabel.appendChild(hiddenText);
							}
						} else { 
							// remove a strong tag from a unselected child widget
							var label = dojo.query("strong",childWidget.labelNode); 
							if(label[0]) {
								var children = com.ibm.domUtilities.removeChildren(label[0]);
								children.place(childWidget.labelNode);
								dojo.destroy(label[0]);
							} 
						}
					}
				},
				onItemFocus: function(child) {
					if(child.popup) child.popup.load();
					this.inherited(arguments);
				},
				onItemHover: function(child, evt) {
					if(child.popup) child.popup.load();
					this.inherited(arguments);
				},
				onItemClick: function(child, evt) {
					if(child.attr("disabled")) return false; 
					child.onClick(evt);
					if(child.item) this.onModelItemClick(child, child.item);
				}
			}
);

dojo.declare("com.ibm.widgets.DataTab",
			com.ibm.widgets.Tab,
			{
				_setHasChildrenAttr: function(value) {
					this.hasChildren = value;
					dojo[value ? "addClass" : "removeClass"](this.domNode, "modelHasChildren");
				},
				_setDndStatusAttr: function(value) {
					this.dndStatus = value;
					if(this.popup) {
						this.popup[value ? "setupDnd" : "disableDnd"]();
					}
				},
				item: null	// type is string so we can process parsed attributes as strings
			}
);

dojo.declare( "com.ibm.widgets.LoadingTab",
			com.ibm.widgets._TabBase,
			{
				templateString:"<li class=\"${class}\" waiRole=\"presentation\" dojoAttachPoint=\"containerNode\" dojoAttachEvent=\"onclick:onClick,onmouseenter:_onHover,onmouseleave:_onUnhover\"\n\t><div\n\t\t><img alt=\"\" dojoAttachPoint=\"iconNode\" src=\"${_blankGif}\" class=\"${iconClass}\"\n\t\t/><a dojoAttachPoint=\"labelNode,focusNode\" href=\"javascript:;\" class=\"tabLabel\" waiRole=\"tab\" onclick=\"javascript:return false;\">${label}</a\n\t></div\n></li>\n",
				
				"class": "loadingTab lotusTab",
				
				iconClass: "ibmLoading",
				
				label: "Loading...",
				
				postMixInProperties: function() {
					this.shelfBundle = dojo.i18n.getLocalization("com.ibm.bundles", "Shelf");
					this.label=this.shelfBundle["shelf_loading"];
				},
				
				attributeMap: dojo.mixin(dojo.clone(dijit._Widget.prototype.attributeMap), {
					label: {node: "labelNode", type: "innerHTML"},
					iconClass: {node: "iconNode", type: "class" }
				}),
				
				isFocusable: function() {
					// loading tabs are not focusable because they provide no actionable
					// content and are simply indicators of an unready or pending status
					return false;
				}
			}
);

}

if(!dojo._hasResource["com.ibm.widgets.NavigationWidget"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.widgets.NavigationWidget"] = true;
dojo.provide( "com.ibm.widgets.NavigationWidget" );

dojo.require( "com.ibm.widgets.DataTabBar" );
dojo.require( "com.ibm.widgets.DataMenu" );



dojo.declare( "com.ibm.widgets.NavigationWidget",
		com.ibm.widgets.DataTabBar,
		{
			
			menuWidget: "com.ibm.widgets.NavigationMenu",
			
			"class": "lotusTabContainer",
			
			tabListClass: "lotusTabs",
			
			tabClass: "lotusTab",
			
			// selectedClass: String the class added to the tab widget which is the
			//		currently selected tab.
			selectedClass: "lotusSelected",
			
			// menuBaseClass: String class to set as the base class of submenus.
			menuBaseClass: "lotusActionMenu",
			
			nestedInlineEditorLabel: "",
			
			// emptyContentsInlineEditorLabel: String used to display the label on inline editor
			//		widgets in the popup menu widgets beneath this level in the model 
			// 		if there are no children at those nodes in the model.
			emptyContentsInlineEditorLabel: "",
			
			constructor: function() {
				this.bundle = dojo.i18n.getLocalization("com.ibm.bundles", "NavWidget");
				this.inlineEditorLabel = this.bundle.nav_new_page_label;
				this.inlineEditorDefaultValue = this.bundle.nav_new_page_default_value;
				this.nestedInlineEditorLabel = this.bundle.nav_new_page_nested_label;
				this.emptyContentsInlineEditorLabel = this.bundle.nav_new_page_empty_nested_label;
				this.inlineEditorTitle = this.bundle.nav_new_page_title;
			},
			
			postMixInProperties: function() {
				this.inherited(arguments);
				if (!this.embeddedEditorParams.invalidMessage) {
					this.embeddedEditorParams.invalidMessage = this.bundle.nav_new_page_invalid_message;
				}
				if (!this.embeddedEditorParams.promptMessage) {
					this.embeddedEditorParams.promptMessage = this.bundle.nav_new_page_prompt_message;
				}
			},
			
			postCreate: function() {
				this.inherited(arguments);
				dijit.setWaiRole(this.containerNode, "menubar");
				if (dojo.isOpera)
				{
					this.connect(this, "onLoad", function(){
						dojo.query(".ibmPortalList").addContent(" ");
					});
				}
			},	
			
			getInheritableParameters: function(item) {
				return dojo.mixin(this.inherited(arguments), {
					inlineEditorLabel: this.nestedInlineEditorLabel,
					emptyContentsInlineEditorLabel: this.emptyContentsInlineEditorLabel,
					"class": this.menuBaseClass
					/*
					,animateOpen: function() {
						var box = dojo.marginBox(this.domNode);
						var origH = this.domNode.parentNode.style.height,
							origW = this.domNode.parentNode.style.width 
							origD = this.domNode.style.display;
						dojo.style(this.domNode, "display", "none");
						dojo.style(this.domNode.parentNode, {
							"width": box.w + "px"
						});
						
						dojo.addClass(this.domNode.parentNode, "bordered");
						
						var dur = 200, anim = null;
						dojo.animateProperty({
							node: this.domNode.parentNode, 
							duration: 150, 
							properties: {
								height: { start:'0', end: box.h, unit:"px" }
							}
						});

						anim.onEnd = dojo.hitch(this, function() {
							dojo.style(this.domNode.parentNode, "height", origH);
							dojo.removeClass(this.domNode.parentNode, "bordered");
							dojo.style(this.domNode, "display", origD);
						});
						anim.play();
					}
					*/
				});
			}
		}
);

dojo.declare( "com.ibm.widgets.NavigationMenu",
		com.ibm.widgets.DataMenu,
		{	
			// emptyContentsInlineEditorLabel: String used to display the label on inline editor
			//		widgets in this widget if there are no children at this node in the model.
			emptyContentsInlineEditorLabel: "",
			
			"class": "lotusActionMenu",
			
			constructor: function() {
				this.bundle = dojo.i18n.getLocalization("com.ibm.bundles", "NavWidget");
				this.inlineEditorLabel = this.bundle.nav_new_page_label;
				this.inlineEditorDefaultValue = this.bundle.nav_new_page_default_value;
				this.nestedInlineEditorLabel = this.bundle.nav_new_page_nested_label;
				this.emptyContentsInlineEditorLabel = this.bundle.nav_new_page_empty_nested_label;
				this.inlineEditorTitle = this.bundle.nav_new_page_title;
			},
			
			postMixInProperties: function() {
				this.inherited(arguments);
				if (!this.embeddedEditorParams.invalidMessage) {
					this.embeddedEditorParams.invalidMessage = this.bundle.nav_new_page_invalid_message;
				}
				if (!this.embeddedEditorParams.promptMessage) {
					this.embeddedEditorParams.promptMessage = this.bundle.nav_new_page_prompt_message;
				}
			},
			
			postCreate: function() {
				this.inherited(arguments);
				dijit.setWaiRole(this.containerNode, "navigation");
				if(this.showInlineEditor && this.level == 1) {
					this.connect(this, "onLoad", function() {
						if(this.inlineEditor) {
							if(this.getChildren().length < 2) {
								this.inlineEditor.editor.attr("value", this.emptyContentsInlineEditorLabel);
							}
						}
					});
					this.connect(this, "onModelRemoveChild", function(parentItem, childItem) {
						if(this.item == parentItem && this.getChildren().length < 2) {
							this.inlineEditor.editor.attr("value", this.emptyContentsInlineEditorLabel);
						}
					});
					this.connect(this, "onModelInsertChild", function(parentItem, childItem, nextSibling) {
						if(this.item == parentItem) {
							this.inlineEditor.editor.attr("value", this.inlineEditorLabel);
						}
					});
				}
			},
			getInheritableParameters: function(item) {
				return dojo.mixin(this.inherited(arguments), {
					emptyContentsInlineEditorLabel: this.emptyContentsInlineEditorLabel
					/*
					,animateOpen: function() {
						var box = dojo.marginBox(this.domNode);
						var origH = this.domNode.parentNode.style.height,
							origW = this.domNode.parentNode.style.width 
							origD = this.domNode.style.display;
						dojo.style(this.domNode, "display", "none");
						dojo.style(this.domNode.parentNode, {
							"height": box.h + "px"
						});
						
						dojo.addClass(this.domNode.parentNode, "bordered");
						
						var dur = 200, anim = null;
						anim = dojo.animateProperty({
							node: this.domNode.parentNode, 
							duration: 150, 
							properties: {
								width: { start:'0', end: box.w, unit:"px" }
							}
						})

						anim.onEnd = dojo.hitch(this, function() {
							dojo.style(this.domNode.parentNode, "width", origW);
							dojo.removeClass(this.domNode.parentNode, "bordered");
							dojo.style(this.domNode, "display", origD);
						});
						anim.play();
					}
					*/
				});
			}
		}
);

}

if(!dojo._hasResource["com.ibm.widgets.Breadcrumbs"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.widgets.Breadcrumbs"] = true;
dojo.provide("com.ibm.widgets.Breadcrumbs");







dojo.declare("com.ibm.widgets.Breadcrumbs",
			[dijit._Widget, dijit._Templated],
			{
				model: null,				// a selection model on which to base the breadcrumb trail
				treeModel: null,			// the tree model backing the selection model 
				item: null,					// the currently selected item with in the model
				parent: null,				// the parent of item
				siblings: {},				// an associative array of item => DOM node pairs
				startLevel: null,			// the number of the level to start rendering the breadcrumbs at
				levels: Number.MAX_VALUE,	// the number of levels to render in the trail, Number.MAX_VALUE is used to represent all levels
				renderSiblings: true,		// true if siblings of the current selection should be rendered in the trail
				newSiblingText: "",			// text to display in the link to create a new sibling item
				newSiblingDefaultValue: "",
				embeddedEditorWidget: "dijit.form.TextBox",
				allowNew: true,				// true if a link should be rendered allowing the user to create a new sibling item
				newEditor: null,			// a dijit.form.ValidationTextBox to create new pages
				embeddedEditorParams: {},	// parameters for the dijit.form.ValidationTextBox
				introText: "",				// text to display before the trail begins
				listDOM: "ul",				// the type of DOM node that holds the trail links
				itemDOM: "li",				// the type of DOM node to act as a trail node
				containerClass: "",			// the class to put on the outer container div to the trail
				listClass: "",				// the CSS class to put on the container of the trail links
				ancestorClass: "",			// the CSS class to put on any ancestor nodes in the trail
				siblingClass: "",			// the CSS class to put on any sibling nodes in the trail
				newClass: "",				// the CSS class to put on the link to create a new item
				ancestorSeparator: " > ",	// the text separation to put between ancestor nodes
				siblingSeparator: " | ",	// the text separation to put between sibling nodes
				templateString: '<div dojoAttachPoint="focusNode" class="${containerClass}"><span dojoAttachPoint="introTextNode"></span><${listDOM} dojoAttachPoint="trail" class="${listClass}"></${listDOM}></div>',
					
				constructor: function() {
					this.bundle = dojo.i18n.getLocalization("com.ibm.bundles", "NavWidget");
					this.theme = dojo.i18n.getLocalization("com.ibm.bundles", "Theme");
					this.introText = this.bundle["breadcrumb_intro"];
					this.newSiblingText = this.bundle["breadcrumb_new_page_label"];			
					this.newSiblingDefaultValue = this.bundle["nav_new_page_default_value"];
					this.currentlySelected = this.theme["currently_selected"];
				},
				
				postMixInProperties: function() {
					this.inherited(arguments);
					if(!this.embeddedEditorParams.invalidMessage) this.embeddedEditorParams.invalidMessage = this.bundle["nav_new_page_invalid_message"];
					if(!this.embeddedEditorParams.promptMessage) this.embeddedEditorParams.promptMessage = this.bundle["nav_new_page_prompt_message"];
				},
				
				postCreate: function(){
					// summary: populate some of the class variables and set up listeners
					//this.parent = this.model.getParent(this.item);
					// set up listeners on the model for when an item is removed/inserted/moved
					this.treeModel = this.model.treeModel;
					this.connect(this.model, "onSelectionPathChange", "redraw");
					this.connect(this.treeModel, "onTreeChange", "onModelTreeChange");
				},
				
				startup: function() {
					this.inherited(arguments);
					// populate the breadcrumbtail
					this.draw();
				},
					
				draw: function(){
					// summary: populates the breadcrumb trail with ancestors and siblings (if specified) to the current item
					var path = this.model.getPath();
					this.parent = path[1];
					if(path.length - this.startLevel <= 1){
						this.introTextNode.innerHTML = "";
						return;
					}
					this.introTextNode.innerHTML = this.introText;
					for(var i = 1; i < path.length && i <= this.levels && i < (path.length - this.startLevel); i++) {
						this.createDomLink(path[i], this.ancestorClass, this.ancestorSeparator, this.trail.firstChild);
					}
					// retrieve and add the siblings to the current item
					if(this.renderSiblings){	
						this.siblings = [];
						this.shelfBundle = dojo.i18n.getLocalization("com.ibm.bundles", "Shelf");
						var loading = document.createTextNode(this.shelfBundle["shelf_loading"]);
						this.trail.appendChild(loading);
						this.treeModel.getChildren(path[1], dojo.hitch(this, function(siblings){
							this.trail.removeChild(loading);
							// render the current item
							this.createDomText(path[0], this.siblingClass, this.siblingSeparator, null);
							// render the siblings
							var curPageId = this.treeModel.getIdentity(path[0]);
							dojo.forEach(siblings, function(sibling) {  
								if(curPageId != this.treeModel.getIdentity(sibling)) 
									this.siblings.push({item: sibling, node: this.createDomLink(sibling, this.siblingClass, this.siblingSeparator, null)});
							}, this)
							this.createEditBox();
						}));
					} else { // do not add siblings
						this.createDomText(path[0], this.siblingClass, this.siblingSeparator, null);
						this.createEditBox();
					}
				},
				
				redraw: function(/*Boolean*/ selectionChanged) {
					this.trail.innerHTML = "";
					this.draw();
				},
				
				onModelTreeChange: function(/*Item*/ childItem, /*Item*/ oldParentItem, /*Item*/ newParentItem, /*Item*/ nextSiblingItem) {
					// summary: Listens to changes in the tree model where items are inserted, deleted, or moved within the tree.
					// 		This only cares about insertions and deletions under the current selection's parent node.
					var currentlySelectedItem = this.model.getPath()[0];
					if(oldParentItem != newParentItem && childItem != currentlySelectedItem) {
						if(this.parent == oldParentItem) {
							this.onModelRemoveChild(childItem);
						}
						else if(this.parent == newParentItem) {
							var isNew = (!oldParentItem)?true:false;
							this.onModelInsertChild(childItem, isNew);
						}
					}
				},
				
				onModelRemoveChild: function(/*Item*/childItem){
					// summary: Responds to events which cause a node to be removed from the current selection's parent node
					// 		in the model either by moving or deletion of an item.
					// childItem: the item that was deleted
					var path = this.model.getPath();
					if(path.length - this.startLevel <= 1) return;
					for(var i = 0; i < this.siblings.length; i++) {
						if(childItem == this.siblings[i].item) {
							this.trail.removeChild(this.siblings[i].node);
							delete this.siblings[i].item;
							delete this.siblings[i].node;
							this.siblings.splice(i, 1);						
							return;
						}
					}
				},
				
				onModelInsertChild: function(/*Item*/childItem,/*bool*/isNew){
					// summary: Responds to events which cause a node to be inserted under the current selection's parent
					// 		node in the model either by moving or creation of a new item. 
					// childItem: the new/moved item
					// isNew: true if the child is new, as opposed to having been moved from a different parent
					var path = this.model.getPath();
					if(path.length - this.startLevel <= 1) return;
					if(this.renderSiblings){ 
						// this.item has a new sibling
						// find the new item editor link and insert the new sibling item BEFORE this node
						var editor = this.newEditor;
						var insertBefore = (editor)?editor.domNode:null;
						var node = this.createDomLink(childItem,this.siblingClass,this.siblingSeparator,insertBefore);
						if(isNew) dojo.addClass(node,"disabled");
						this.siblings.push({item: childItem, node: node});
						
						if(!childItem.created) {
							setTimeout(function(){
								dijit.focus(node);
							},0);
							var conn = dojo.connect(childItem, "onCreate", this, function(){
								node.firstChild.href = top.location.href + "?uri=" + this.treeModel.getIdentity(childItem);
								dojo.removeClass(node,"disabled");
								dojo.disconnect(conn);
							});
						}
					}
				},
				
				createDomLink: function(item, className, separator, node){
					// summary: creates a DOM node in the breadcrumb trail with a link as inner html
					// item: the item for which to create the DOM node
					// className: the CSS class to put on the new DOM node
					// separator: a text separator to append after the item link
					// node: a DOM item before which to place the new DOM link, null to place it at the end of the list
					var domItem = document.createElement(this.itemDOM);
					dojo.addClass(domItem, className);
					var link = document.createElement("a");
					domItem.appendChild(link);
					domItem.appendChild(document.createTextNode(separator));
					link.appendChild(document.createTextNode(this.treeModel.getLabel(item)));
					var url = top.location.href;
					// check to see if url has reference anchors or parameters, and if so, then discard them
					if(url.indexOf('#') > -1)
						url = url.substring(0, url.indexOf('#'));
					if(url.indexOf('?') > -1)
						url = url.substring(0, url.indexOf('?'));
					link.href = url + "?uri=" + this.treeModel.getIdentity(item);
					this.trail.insertBefore(domItem, node);
					return domItem;
				},
				
				createDomText: function(item, className, separator, node){
					// summary: creates a DOM node in the breadcrumb trail with plain text inner html
					// item: the item for which to create the DOM node
					// className: the CSS class to put on the new DOM node
					// separator: a text separator to append after the item text
					// node: a DOM item before which to place the new DOM text, null to place it at the end of the list
					var domItem = document.createElement(this.itemDOM);
					dojo.addClass(domItem, className);
					var hiddenText = dojo.create("span", {innerHTML: this.currentlySelected, className: "ibmHiddenText"});
					var hiddenSpan = dojo.create("span");
					hiddenSpan.appendChild(hiddenText);
					domItem.appendChild(document.createTextNode(this.treeModel.getLabel(item)));
					domItem.appendChild(hiddenText);
					domItem.appendChild(document.createTextNode(separator));
					this.trail.insertBefore(domItem, node);
					return domItem;
				},
				
				createEditBox: function(){
					// summary: creates a link to create a new sibling item iff this.allowNew is true
					if(this.allowNew){
						this.newEditor = new com.ibm.widgets.BreadcrumbsEditor({
							embeddedEditorWidget: this.embeddedEditorWidget,
							embeddedEditorParams: this.embeddedEditorParams,
							"class": this.newClass,
							label: this.newSiblingText,
							defaultValue: this.newSiblingDefaultValue
						});
						
						this.newEditor.editor.width = "10em";
						this.newEditor.editor.lineHeight = "1.5em";
						
						//this.newEditor = new dijit.InlineEditBox({value:this.newSiblingText,width:"10em",lineheight:"1.5em",editor:"dijit.form.ValidationTextBox",editorParams:this.embeddedEditorParams},link);
						this.connect(this.newEditor, "onChange", "createNewSiblingItem");
						this.trail.appendChild(this.newEditor.domNode);
					}
				},
				
				onClickItem: function(item){
					// summary: redirects the browser to the url associated with item
					// item: the item with the link to redirect to
					if(!item.created) return false;
					top.location.href = top.location.href + "?uri=" + this.treeModel.getIdentity(item);
				},
				
				createNewSiblingItem: function(/*Object*/value, focus){
					// summary: triggered by the onChange event from the dijit.InlineEditBox used for creating new items
					// value: Object key-value map of attributes to set on the new item
					var newItem = null;
					var onComplete = function() {
						newItem.onCreate();
					}
					newItem = this.treeModel.newItem(dojo.mixin(value, {onComplete: onComplete, scope: this}),this.parent); // create the new item as a sibling to this.item
					newItem._onCreate = function(){ /*do nothing*/ };  // make sure _onCreate is a non null function
				}
				
			}
);

dojo.declare("com.ibm.widgets.BreadcrumbsEditor",
	[dijit._Widget, dijit._Templated, com.ibm.widgets.InlineEditorWrapper],
	{
		templateString: '<span class="inlineEditor ${class}" waiRole="presentation"><a dojoAttachPoint="editor,focusNode" class="newPageLink" href="javascript:;">${label}</a></span>'
		
	}
);

}

if(!dojo._hasResource["com.ibm.pb.widgets.ContentMenu"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.widgets.ContentMenu"] = true;
dojo.provide("com.ibm.pb.widgets.ContentMenu");







dojo.declare("com.ibm.pb.widgets.ContentMenu", [dijit.Menu, com.ibm.pb.logging.Loggable], {
	
	builderFactory: com.ibm.mashups.builder.model.Factory,
	
	contextMenuID: "",
	resourceType: "",
	resourceID: "",
	
	_setListener: null,
	internalRefresh:true,
	
	postCreate: function() {
		this.refreshContents();
		this.connect(this, "onSetChange", "refreshContents");
		this.connectKeyNavHandlers([dojo.keys.UP_ARROW], [dojo.keys.DOWN_ARROW]);
	},
	getSet: function() {
		var mname = "getSet", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		var contextMenu = this.builderFactory.getContextMenuModel();
		var data = contextMenu.getContextMenu(this.contextMenuID, this.resourceID, 
			this.resourceType, this.getSetContextParams());
		if(!this._setListener && this.internalRefresh) {
			this._setListener = contextMenu.registerListener(this.contextMenuID, this, "onSetChange");
		}
		lgr.exiting(mname, [data]);
		return data;
	},
	getSetContextParams: function() {
		return { context:this };
	},
	getInheritableParams: function(item) {
		return {
			contextMenuID: item.contextMenuID || this.contextMenuID,
			resourceType: item.resourceType || this.resourceType,
			resourceID: item.resourceId || this.resourceID,
			internalRefresh:this.internalRefresh
		};
	},
	destroy: function() {
		if(this._setListener) {
			this.builderFactory.getContextMenuModel().unregisterListener(this._setListener);
			delete this._setListener;
		}
		this.inherited(arguments);
	},
	getItemRep: function(item) {
		var menuItem = null;
		if(item.isSeparator) {
			menuItem = new dijit.MenuSeparator();
		}
		else if(item.contextMenuID) {
			var subCSMenu = this.createSubmenu(this.getInheritableParams(item));
			menuItem = new dijit.PopupMenuItem({
				label: item.title,
				iconClass: item.iconClass || "",
				popup: subCSMenu,
				disabled: !item.enabled,
				onClick: item.actionCallBackFunction,
				pageActionType: item.id
			});
		}
		else {
			if (item.checkedMenuItem){
				menuItem = new dijit.CheckedMenuItem({
					label: item.title,
					iconClass: item.iconClass || "",
					disabled: !item.enabled,
					onClick: item.actionCallBackFunction,
					checked: item.checked,
					pageActionType: item.id
				});
			}else {
				menuItem = new dijit.MenuItem({
					label: item.title,
					iconClass: item.iconClass || "",
					disabled: !item.enabled,
					onClick: item.actionCallBackFunction,
					pageActionType: item.id
				});
			}
		}
		if(item.itemClass) {
			dojo.addClass(menuItem.domNode, item.itemClass);
		}
		return menuItem;
	},
	onSetChange: function() {},
	createSubmenu: function(args) {
		var subCSMenu = new com.ibm.pb.widgets.ContentMenu(args);
		return subCSMenu;
	},
	initContents: function(resourceID) {
		var mname = "initContents", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		// clear the existing contents, and rebuild the menu contents
		this.resourceID = resourceID;
		this.clearContents();
		this.fillContents();
		lgr.exiting(mname, arguments);
	},
	clearContents: function() {
		this.destroyDescendants();
	},
	refreshContents: function() {
		if(this.resourceID) {
			this.initContents(this.resourceID);
		}
	},
	fillContents: function() {
		var mname = "fillContents", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		// get the contents of the menu from the data set, then rebuild the visual elements of 
		// the menu using the returned data
		var data = this.getSet();
		dojo.forEach(data, function(item){
			var menuItem = this.getItemRep(item);
			lgr.trace(mname, "Adding menu item ${0} to menu ${1} backed by item ${2}", [menuItem, this, item]);
			this.addChild(menuItem);
		}, this);
		lgr.exiting(mname, [data]);
	}
});

}

if(!dojo._hasResource["com.ibm.pb.dnd.ControlledModeledSource"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.dnd.ControlledModeledSource"] = true;
dojo.provide("com.ibm.pb.dnd.ControlledModeledSource");


dojo.declare("com.ibm.pb.dnd.ControlledModeledSource",
	com.ibm.dnd.ModeledSource,
	{
		constructor: function(/*DOMNode|String*/node, /*dojo.dnd.__SourceArgs?*/params) {
			this.inherited(arguments);
		},
		onDrop: function(source, nodes, copy) {
			this.inherited(arguments);
			
			// When enabler correctly updates the runtime nav model, 
			// DND can start to use transactions for page reordering
			//com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
		},
		checkModelAcceptance: function(childItem,parentItem){
			if(typeof(ibmCfg.portalConfig) == "undefined") return true; // skip this for mashups
			var store = ibmCfg.controllers.navigation.getTreeModel(),
				isChildPrivate = this._isPrivate(childItem),
				isParentPrivate = this._isPrivate(parentItem),
				navBundle = dojo.i18n.getLocalization("com.ibm.bundles", "NavWidget");
				
			if(isChildPrivate && isParentPrivate) {
				// allowed: both the child and new parent are private
				return true;
			} else if(!isChildPrivate && isParentPrivate){
				// not allowed: cannot drag a public under a private page
				var statusMessage = new com.ibm.widgets.StatusMessage("error", navBundle["nav_invalid_drop_error"], dojo.i18n.getLocalization("com.ibm.bundles", "Theme")["private_public_modelError"]);
				dojo.publish("/portal/status",[{message: statusMessage, uid: 'ibmStatusBox'}]);
				return false;
			} else {
				// new parent is public, permissions must be checked
				// TODO: Are there constants for the roles?
				var privAtParent = parentItem.hasRole("Privileged User");//store.getValue(parentItem,"accessLevel[Privileged User]$") == "Privileged User";
				var managerAtChild = parentItem.hasRole("Manager");//store.getValue(childItem,"accessLevel[Manager]$") == "Manager";
				var editorAtParent = parentItem.hasRole("Editor"); //store.getValue(parentItem,"accessLevel[Editor]$") == "Editor";
				
				if((isChildPrivate && !privAtParent) || (!isChildPrivate && (!managerAtChild || !editorAtParent))){
					// not allowed: must have priv user access on new parent when parent is public and child is private
					// not allowed: must have manager access on the child and editor access on new parent when both are public
					var statusMessage = new com.ibm.widgets.StatusMessage("error", navBundle["nav_invalid_drop_error"], nlsBundle = navBundle["nav_invalid_drop_msg"]);
					dojo.publish("/portal/status",[{message: statusMessage, uid: 'ibmStatusBox'}]);
					return false;
				} else return true;
			}
		},
		_isPrivate: function(navNode) {
			var isPrivate = false;
			if(navNode) {
				var xml = navNode.getXml(),
					expr = "./atom:content/*/ac:allowed-access[@ac:private='true']";
				isPrivate = com.ibm.mashups.enabler.xml.XPath.evaluateBoolean(expr, xml, {
					app: "http://www.w3.org/2007/app",
					atom: "http://www.w3.org/2005/Atom",
					ac: "http://www.ibm.com/xmlns/prod/lotus/access-control/v1.0"
				});
			}
			return isPrivate;
		}
	}
);

}

if(!dojo._hasResource["com.ibm.pb.dnd.layout.LayoutControlAvatar"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.dnd.layout.LayoutControlAvatar"] = true;
dojo.provide("com.ibm.pb.dnd.layout.LayoutControlAvatar");

dojo.declare("com.ibm.pb.dnd.layout.LayoutControlAvatar", dojo.dnd.Avatar, {
	construct: function(){
		// summary: constructs the avatar for portlets
		var div = dojo.doc.createElement("div");
		div.style.position = "absolute";
		div.style.zIndex = 1999;
		div.style.margin = "0px";
		var source = this.manager.source, node;
		// create an avatar representation of the node
		// Portal only allows 1 portlet to be dragged, 
		// so it is known to use only the first item in the array
		_temp = source._normalizedCreator(source.getItem(this.manager.nodes[0].id).data, "avatar");
		node = _temp.node;
		node.id = "";
		dojo.style(div, "opacity", 0.5);
		div.appendChild(node);
		this.node = div;
	},
	
	//override default one
	update: function(){
		
		// summary:
		//		updates the avatar to reflect the current DnD state
		
		//comment following line to improve the performance
		//dojo[(this.manager.canDropFlag ? "add" : "remove") + "Class"](this.node, "dojoDndAvatarCanDrop");
		
		if (this.isA11y){
			var icon = dojo.byId("a11yIcon");
			var text = '+';   // assume canDrop && copy
			if (this.manager.canDropFlag && !this.manager.copy) {
				text = '< '; // canDrop && move 
			}else if (!this.manager.canDropFlag && !this.manager.copy) {
				text = "o"; //!canDrop && move
			}else if(!this.manager.canDropFlag){
				text = 'x';  // !canDrop && copy
			}
			icon.innerHTML=text;
		}
		// replace text
		dojo.query(("tr.dojoDndAvatarHeader td span" +(this.isA11y ? " span" : "")), this.node).forEach(
			function(node){
				node.innerHTML = this._generateText();
			}, this);
	}
});

}

if(!dojo._hasResource["com.ibm.pb.layout.LayoutParser"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.layout.LayoutParser"] = true;
dojo.provide("com.ibm.pb.layout.LayoutParser");

(function(){
	var lp = com.ibm.pb.layout.LayoutParser = {
		CONTAINER_QUERY: ".component-container",
		CONTROL_QUERY: ".component-control",
		ROOT_NODE_ID: "layoutContainers",
		ID_MATCHER: /id-([\S]+)/,
		_rootNode: null,
		_containersCache:null,
		
		extractID: function(layoutDOMNode) {
			var m = (dojo.attr(layoutDOMNode, "class") || "").match(lp.ID_MATCHER);
			return m && m[1];
		},
		findById: function(id) {
			//In IE 7, The query with detailed path -E.g.> .component-container > .id- costs less than 10% of whole page -e.g .id-
			if(!id) return null;
			var ele= dojo.query("> .component-container > .id-"+ id,this.getRootNode());//check from visible layout container
			if (!!ele && ele.length>0) {
				return ele[0];
			}
			ele = dojo.query("> .hiddenWidgetsDiv > .component-container > .id-" +id,this.getRootNode());//check from hidden container
			if (!!ele && ele.length>0) {
				return ele[0];
			}
			return dojo.query(".id-" + id, this.getRootNode())[0];
		},
		findContainers: function(root) {
			if(root == this.getRootNode()){//most request for containers are from root
				if(!this._containersCache){
					this._containersCache = dojo.query(lp.CONTAINER_QUERY, root); 
				}
				return this._containersCache;
			}else {
				return dojo.query(lp.CONTAINER_QUERY, root); 
			}
		},
		findControls: function(root) {
			return dojo.query(lp.CONTROL_QUERY, root);
		},
		getRootNode: function(){
			if(!lp._rootNode) {
				lp._rootNode = dojo.byId(lp.ROOT_NODE_ID);
			}
			return lp._rootNode;
		},
		clearCachedContainers:function(){
			this._containersCache=null;
		}
	};
})();

}

if(!dojo._hasResource["com.ibm.pb.dnd.layout.LayoutSource"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.dnd.layout.LayoutSource"] = true;
dojo.provide("com.ibm.pb.dnd.layout.LayoutSource");






dojo.declare("com.ibm.pb.dnd.layout.LayoutSource", [com.ibm.dnd.TunedLayoutSource, com.ibm.pb.logging.Loggable], {
	isDragging: false,
	currentNode: null,
	currentMargin: 0,
	currentTarget: null,
	emptyContainer: null,
	delaySave: true,
	movedItems: [],
	layoutParser: com.ibm.pb.layout.LayoutParser,
	
	constructor: function() {
		this.evtSvc = com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService");
		this.moveWidget = this.evtSvc.subscribeEvent("com.ibm.mashups.builder.widgetMoved", this, "_widgetMoved");
		this.applyDefaultSizing = this.evtSvc.subscribeEvent("com.ibm.mashups.builder.addNewWidget", this, "_widgetDefaultSizingApplied");
	},
	
	managerOverrides: {
		makeAvatar: function(){
			return new com.ibm.pb.dnd.layout.LayoutControlAvatar(this);
		},
		startDrag: function(source, nodes, copy){
			this.source = source;
			this.nodes  = nodes;
			this.copy   = Boolean(copy); // normalizing to true boolean
			this.avatar = this.makeAvatar();
			dojo.body().appendChild(this.avatar.node); //cost 651ms TODO
			dojo.publish("/dnd/start", [source, nodes, this.copy]); 
			this.events = [
				dojo.connect(dojo.doc, "onmousemove", this, "onMouseMove"),
				dojo.connect(dojo.doc, "onmouseup",   this, "onMouseUp"),
				dojo.connect(dojo.doc, "onkeydown",   this, "onKeyDown"),
				dojo.connect(dojo.doc, "onkeyup",     this, "onKeyUp"),
				dojo.connect(dojo.doc, "ondragstart",   dojo.stopEvent),
				dojo.connect(dojo.body(), "onselectstart", dojo.stopEvent)
			];
		}
	},
	
	copyState: function(){
		return false;
	},
	onDndStart: function(source, nodes, copy){
		this.inherited(arguments);
		
		if(source !== this) {
			// we need this once only
			return;
		}
		
		this.isDragging = true;
		
		this.currentNode = dojo.byId(nodes[0].id);
		
		// current node stored in controller for use in creator
		ibmCfg.controllers.dnd.currentNode = this.currentNode;
		ibmCfg.controllers.dnd.currentNode._isCanceled = false;
		
		// ghost height stored in controller to use cross-source
		if (ibmCfg.controllers.dnd.ghostHeight == 0) {
			if (dojo.isIE) {
				ibmCfg.controllers.dnd.ghostHeight = 200;
			}
			else {
				ibmCfg.controllers.dnd.ghostHeight = this.currentNode.offsetHeight;
			}
		}
		//if(!dojo.isIE)dojo.style(this.currentNode , {cursor:"move"});	
		
//	this.currentMargin = dojo.marginBox(this.currentNode).w - this.currentNode.offsetWidth;	
		
		var sourceItem = source.getItem(this.currentNode.id);
		if(sourceItem && (sourceItem.type != ibmCfg.controllers.dnd.SHELF_TYPE)){
			if(!dojo.isIE){
				dojo.style(this.currentNode,{display:"none"});
			}
		}
	},
	
	onDrop: function(source, nodes, copy){
		this.LOGGER.entering("onDrop",[source, nodes, copy]);

		if(!this.current && !this.emptyContainer){
			this.onDndCancel();
			return;
		}
		
		var currentNode = dojo.byId(nodes[0].id);
				
		var sourceItem = source.getItem(currentNode.id);
		var type = sourceItem ? sourceItem.type : null;
		
		// is the source from the shelf?
		if(type && (type == ibmCfg.controllers.dnd.SHELF_TYPE)){
			//handle the widget creation from the shelf
			this.onDropFromShelf(source, nodes, copy);
		}else{
			//handle the widget move operation
			if(this != source){
				this.onDropExternal(source, nodes, copy);
			}else{
				this.onDropInternal(nodes, copy);
			}
		}
		
		var currentContainer = null;
		if(this.current){
			currentContainer = this.current.parentNode;
		}else{
			currentContainer = this.emptyContainer;
		}
		
		this._calculateDropTarget(currentNode, currentContainer, type);
		
		this._processDrop(currentNode, currentContainer, source, nodes, copy);

		this.isDragging = false;
		
		this.LOGGER.exiting("onDrop",[source, nodes, copy]);
	},
	
	onDndCancel: function(){
		this.inherited(arguments);
		if (ibmCfg.controllers.dnd.currentNode && !ibmCfg.controllers.dnd.currentNode._isCanceled) {
			if(!dojo.isIE){
				dojo.style(ibmCfg.controllers.dnd.currentNode, {display: ""});
			}
			this.isDragging = false;
			ibmCfg.controllers.dnd.currentNode._isCanceled = true;
		}
	},
	onDropFromShelf: function(source, nodes, copy){
		// Override onDropExternal for the shelf items 
		// so the shelf grid item is not inserted into 
		// the container markup before displaying the widget
		var oldCreator = this._normalizedCreator;
		// transferring nodes from the source to the target
		if(this.creator){
			// use defined creator
			this._normalizedCreator = function(node, hint){
				return oldCreator.call(this, source.getItem(node.id).data, hint);
			};
		}else{
			// we have no creator defined => move/clone nodes
			if(copy){
				// clone nodes
				this._normalizedCreator = function(node, hint){
					var t = source.getItem(node.id);
					var n = node.cloneNode(true);
					n.id = dojo.dnd.getUniqueId();
					return {node: n, data: t.data, type: t.type};
				};
			}else{
				// move nodes
				this._normalizedCreator = function(node, hint){
					var t = source.getItem(node.id);
					source.delItem(node.id);
					return {node: node, data: t.data, type: t.type};
				};
			}
		}
		this.selectNone();
		if(!copy && !this.creator){
			source.selectNone();
		}
		if(!copy && this.creator){
			source.deleteSelectedNodes();
		}
		this._normalizedCreator = oldCreator;
	},
	_calculateDropTarget: function(currentNode, currentContainer, type){
		if(this.current && (this.current != currentNode) && !this.emptyContainer){
			if(this.before != true){
				// the target is after the current node			
				var controls = dojo.query("."+ibmCfg.controllers.dnd.CONTROL_CLASS, currentContainer);
				for(var i=0;i<controls.length;i++){
					if(controls[i] == this.current){
						//if drop is from shelf, only add 1 to get next control, 
						//otherwise...
						//the portlet node is inserted into the markup and
						//the index needs to add 1 for the node dropped,
						//then add another 1 for the correct node after the target
						var realIndex = (type == "sm") ? i+1 : i+2; 
						if(realIndex < controls.length){
							this.current = controls[realIndex];
							break;
						}else{
							// the target is below the last node set to null to append at end of container
							this.current = null;	
							break;
						}
					}
				}
			}
		}else{
			// the target is an empty container
			if(this.emptyContainer){
				currentContainer = this.emptyContainer;
				this.current = null;
			}else{
				this.onDndCancel();
				return;
			}
		}
	},
	_processDrop: function(currentNode, currentContainer, source, nodes, copy){
		var sourceItem = source.getItem(currentNode.id);		
		if (sourceItem && (sourceItem.type == ibmCfg.controllers.dnd.SHELF_TYPE)) {
			var widget = dijit.byId(nodes[0].id);			
			var nextSiblingId = this.current ? this.layoutParser.extractID(this.current) : null;
			widget.apply(this.layoutParser.extractID(currentContainer), nextSiblingId);
		} else {
			var currentPageId = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
			var lm = ibmCfg.controllers.dnd.nm.getLayoutModel(currentPageId);
			var containerDef = lm.find(this.layoutParser.extractID(currentContainer));
			
			if (containerDef) {
				containerDef.setFinishedCallback(dojo.hitch(this, "_insert"), {
					layoutModel: lm,
					controls: {
						target: this.current,
						current: currentNode
					}
				});
				containerDef.start(false);
			}
			else {
				this.LOGGER.severe("onDrop", "Cannot find container in the layout model");
			}
			
		}
		this.evtSvc.broadcastEvent("com.ibm.mashups.builder.widgetMoved", this.layoutParser.extractID(currentNode));
	},
	_insert: function(container, status, x){
		// summary: inserts a control to the new location
		// container: layout container into which to put the new control
		// status: HTTP status returned from request to get container
		// x: {layoutModel, controls {target, current dragging node}}
		this.LOGGER.entering("_insert",[container, status, x]);
		if(status != 200) {
			this.LOGGER.severe("_insert","Could not find container in the layout model.  Cannot move control.",[container, status, x]);
			return;
		}
		if(container instanceof com.ibm.mashups.enabler.layout.LayoutContainer){
			var current = x.layoutModel.find(this.layoutParser.extractID(x.controls.current)).start();
			
			if(!current){
				this.LOGGER.severe("_insert","Cannot find current dragging node in the layout model", [x.controls.current]);
			}
				
			var target = null;
			if (x.controls.target) { 
				target = x.layoutModel.find(this.layoutParser.extractID(x.controls.target)).start();
				if(!target){
					this.LOGGER.severe("_insert","Cannot find target node in the layout model", [x.controls.target]);
				}
			}
	
			if( x.layoutModel.confirmInsert(current,container,target) ){
				if (target && current.getID() == target.getID()) {
					target = null;
				}
				x.layoutModel.insert(current,container,target);
			}
			
			com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
			
			if(!this.delaySave){
				ibmCfg.controllers.dnd.nm.commit().start();				
			}
			
		} else { 
			this.LOGGER.severe("_insert","Container is not an instance of com.ibm.mashups.enabler.layout.LayoutContainer",[container, status, x]); 
		}
		
		this.LOGGER.exiting("_insert",[container, status, x]);
	},
	
	_widgetMoved: function(iEvent){
		this.syncSourcesMap(iEvent);
	},

	_widgetDefaultSizingApplied: function(iEvent){
		com.ibm.mm.builder.utils.skinUtil.updateDefaultSize(iEvent);
	},

	//This method is used to sync all dnd sources on the page with their map attributes
	syncSourcesMap: function(id){
		
		var nodes = dojo.query(".id-"+id ,this.node);
		if (nodes[0] && nodes[0].id) {
			var nid = nodes[0].id;
			var sources = ibmCfg.controllers.dnd.dndSources;
			for (i in sources) {
				if (i) {
					if (sources[i].getItem(nid)) {
						if (sources[i] != this) {
							this.setItem(nid, sources[i].getItem(nid));
							sources[i].setItem(nid, null);
							sources[i].delItem(nid);
						}
					}
				}
			}
		}
	},
	
	destroy: function(){
		this.evtSvc.unsubscribeEvent(this.moveWidget);
		this.evtSvc.unsubscribeEvent(this.applyDefaultSizing); 
		this.moveWidget = null;
		this.applyDefaultSizing = null;
	}
});

}

if(!dojo._hasResource["com.ibm.mashups.builder.IEvent"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.builder.IEvent"] = true;
dojo.provide("com.ibm.mashups.builder.IEvent");

/**
 * com.ibm.mashups.builder.IEvent defines all the public builder iEvents.<br/>
 * Usage: call com.ibm.mashups.builder.iEvents.SWITCH_PAGE to retreive the ievent name "com.ibm.mashups.builder.switchPage".<br/>
 * <br/>
 * 1. IEvent naming convention.<br/>
 * IEvent name such as <code>SWITCH_PAGE</code> and <code>PAGE_SWITCHED</code> followed the basic rules:<br/> 
 * (1) Verb + Noun:  the iEvent is broadcast before the action happen.<br/>
 * (2) Noun + Past Tense Verb:  the iEvent is broadcast after the action happen.<br/>
 * <br/>
 * 2. Terminology<br/>
 * (1) System iWidget: iWidget defined in theme.<br/>
 * (2) User iWidget: iWidget which user can add to a mashup page.<br/>
 * (3) Layout iWidget: a kind of system iWidget that manages user iWidget instances.<br/>
 * (4) None visible area: a kind of system iWidget that contains user iWidget instances in a hidden area.<br/>
 * (5) iWidget definition id: unique id of the iWidget metadata in enabler catalog API.<br/>
 * (6) iWidget instance id: unique id of the iWidget instance.<br/>
 * @ibm-api
 * @ibm-module Builder
 */

dojo.declare("com.ibm.mashups.builder.IEvent", null, {

	/**
	* <b>Description</b>: System iWidget should broadcast SWITCH_PAGE iEvent to switch to a given page.<br/>
	* Navigation iWidget must handle SWITCH_PAGE iEvent to switch page; 
	* after page is switched, iEvent <code>"com.ibm.mashups.builder.pageSwitched"</code> must be broadcast. <br/>
	* <b>Value</b>: "com.ibm.mashups.builder.switchPage"<br/>
	* <b>Payload</b>: id of page which will be switched to. Could be <code>null</code>. If null, Navigation iWidget will load current user's first page.<br/>
	* <b>Payload type</b>: text <br/> 
	* @type String
	*/
	SWITCH_PAGE: "com.ibm.mashups.builder.switchPage",
	
	/**
	* <b>Description</b>: Navigation iWidget must broadcast PAGE_SWITCHED iEvent after page is switched. <br/>
	* System iWidget can handle PAGE_SWITCHED iEvent to do follow-up work.<br/>
	* <b>Value</b>: "com.ibm.mashups.builder.pageSwitched"<br/>
	* <b>Payload</b>: id of page switched to. Could be <code>null</code> which means no page available for current user.<br/>
	* <b>Payload type</b>: text<br/> 
	* @type String
	*/	
	PAGE_SWITCHED: "com.ibm.mashups.builder.pageSwitched",
	
	/**
	* <b>Description</b>: System iWidget should broadcast SWITCH_SPACE iEvent to switch to a given space.<br/>
	* SpaceSelector iWidget must handle SWITCH_PAGE iEvent to switch space.<br/>
	* <b>Value</b>: "com.ibm.mashups.builder.switchSpace"<br/>
	* <b>Payload</b>: id of space which will be switched to. Could be <code>null</code>. If null, SpaceSelector iWidget will switch to personal space.<br/>
	* <b>Payload type</b>: text <br/> 
	* @type String
	*/
	SWITCH_SPACE: "com.ibm.mashups.builder.switchSpace",
	
	/**
	* <b>Description</b>: System iWidget broadcasts REFRESH_SPACE_SELECTOR iEvent to announce the space model has been changed.<br/>
	* SpaceSelector iWidget must handle REFRESH_SPACE_SELECTOR iEvent to retrieve the latest space model and re-render the UI.<br/>
	* For example, when user creates space within space manager, REFRESH_SPACE_SELECTOR iEvent must be broadcast to refresh Space Selector iWidget UI.<br/>
	* <b>Value</b>: "com.ibm.mashups.builder.refreshSpaceSelector"<br/>
	* <b>Payload</b>: id of space which title will be shown up in space selector. Could be <code>null</code>. If null, current space title will be used.<br/>
	* <b>Payload type</b>: text <br/> 
	* @type String
	*/
	REFRESH_SPACE_SELECTOR: "com.ibm.mashups.builder.refreshSpaceSelector",
	
	/**
	* <b>Description</b>: REFRESH_SPACE_LIST_IN_SPACE_MANAGER iEvent is broadcasted to refresh the space list in the space manager when space manager is opened<br/>
	* Space Manager iWidget must handle this iEvent to retrieve the latest space model and re-refresh the space list<br/>
	* <b>Value</b>: "com.ibm.mashups.builder.spacemanager.refreshSpaceList"<br/>
	* <b>Payload</b>: N/A<br/> 
	* @type String
	*/
	REFRESH_SPACE_LIST_IN_SPACE_MANAGER: "com.ibm.mashups.builder.spacemanager.refreshSpaceList",
	
	/**
	* <b>Description</b>: System iWidget broadcasts REFRESH_NAVIGATION iEvent to announce the navigation model has been changed.<br/>
	* Navigation iWidget must handle REFRESH_NAVIGATION iEvent to retrieve the latest navigation model and re-render the UI.<br/>
	* For example, when user changes the page title, REFRESH_NAVIGATION iEvent must be broadcast to refresh Navigation iWidget UI.<br/>
	* <b>Value</b>: "com.ibm.mashups.builder.refreshNavigation"<br/>
	* <b>Payload</b>: N/A<br/> 
	* @type String
	*/
	REFRESH_NAVIGATION: "com.ibm.mashups.builder.refreshNavigation",
	
	/**
	* <b>Description</b>: System iWidget broadcasts REFRESH_PALETTE iEvent to announce the catalog model has been changed.<br/>
	* Palette iWidget must handle this iEvent to retrieve the latest catalog model and re-render the UI.<br/>
	* For example, when a new iWidget is added to Palette, REFRESH_PALETTE iEvent must be broadcast to refresh Palette.<br/>
	* <b>Value</b>: "com.ibm.mashups.builder.refreshPalette"<br/>
	* <b>Payload</b>: N/A<br/> 
	* @type String
	*/
	REFRESH_PALETTE: "com.ibm.mashups.builder.refreshPalette",
	
	/**
	* <b>Description</b>: System iWidget can broadcast LAYOUT_REFRESH iEvent to announce the layout model has been changed.<br/>
	* TemplateLayout iWidget handles LAYOUT_REFRESH iEvent to retrieve the latest layout model and re-render the UI.<br/>
	* <b>Value</b>: "com.ibm.mashups.builder.layoutRefresh"<br/>
	* <b>Payload</b>: id of layout container or control whose markup will be refreshed. Can be <code>null</code>. If null, entire layout (all containers) will be refreshed.<br/>
	* <b>Payload type</b>: text <br/> 
	* @type String
	*/
	LAYOUT_REFRESH: "com.ibm.mashups.builder.layoutRefresh",
	
	/**
	* <b>Description</b>: TemplateLayout iWidget broadcasts LAYOUT_REFRESHED iEvent after layout is done refreshing. <br/>
	* <b>Value</b>: "com.ibm.mashups.builder.layoutRefreshed"<br/>
	* <b>Payload</b>: <code>null</code> if entire layout was just refreshed. Or, id of individual layout container or control that was just refreshed.<br/>
	* <b>Payload type</b>: text <br/> 
	* @type String
	*/
	LAYOUT_REFRESHED: "com.ibm.mashups.builder.layoutRefreshed",
	
	/**
	* <b>Description</b>: System iWidget can broadcast REFRESH_CONTEXT_MENU iEvent to notify a context menu's listeners that it was updated.<br/>
	* <b>Value</b>: "com.ibm.mashups.builder.refreshContextMenu"<br/>
	* <b>Payload</b>: id of context menu whose listeners will be fired. Must not be <code>null</code>.
	* <b>Payload type</b>: text <br/> 
	* @type String
	*/
	REFRESH_CONTEXT_MENU: "com.ibm.mashups.builder.refreshContextMenu",
	
	/**
	* <b>Description</b>: System iWidget can broadcast VIEW_HIDDEN_WIDGETS iEvent to show any hidden-widget containers on the page.<br/>
	* TemplateLayout iWidget handles VIEW_HIDDEN_WIDGETS iEvent to show any hidden-widget containers on the page.<br/>
	* <b>Value</b>: "com.ibm.mashups.builder.viewHiddenWidgets"<br/>
	* <b>Payload</b>: none; can be <code>null</code>.<br/>
	* <b>Payload type</b>: text <br/> 
	* @type String
	*/
	VIEW_HIDDEN_WIDGETS: "com.ibm.mashups.builder.viewHiddenWidgets",
	
	/**
	* <b>Description</b>: System iWidget can broadcast HIDE_HIDDEN_WIDGETS iEvent to hide any hidden-widget containers on the page.<br/>
	* TemplateLayout iWidget handles HIDE_HIDDEN_WIDGETS iEvent to hide any hidden-widget containers on the page.<br/>
	* <b>Value</b>: "com.ibm.mashups.builder.hideHiddenWidgets"<br/>
	* <b>Payload</b>: none; can be <code>null</code>.<br/>
	* <b>Payload type</b>: text <br/> 
	* @type String
	*/
	HIDE_HIDDEN_WIDGETS: "com.ibm.mashups.builder.hideHiddenWidgets",
	
	/**
	* <b>Description</b>: CHANGE_PAGE_MODE iEvent will be broadcast when page mode is changed. <br/>
	* System iWidgets can define CHANGE_PAGE_MODE iEvent as handled iEvent to update their UI accordingly. In current Lotus Mashups it only has 2 modes
	* ("view"/"edit"), but it's not limited to. <br/>
    * <b>Value</b>: "com.ibm.mashups.builder.changePageMode"<br/>
	* <b>Payload</b>: new page mode. Either "view" or "edit". Must not be <code>null</code>.<br/>
	* <b>Payload type</b>: text<br/> 
	* @type String
	*/		
	CHANGE_PAGE_MODE: "com.ibm.mashups.builder.changePageMode",

	/**
	* <b>Deprecated</b>: ADD_WIDGET_FROM_TOOLBOX iEvent is replaced witch ADD_WIDGET.<br/>
	* <b>Description</b>: System iWidget can broadcast ADD_WIDGET_FROM_TOOLBOX iEvent to create a user iWidget instance.<br/>
	* Layout iWidget must define ADD_WIDGET_FROM_TOOLBOX iEvent as handled iEvent to create the user iWidget instance according to the payload<br/>
	* Base on the enabler CatalogModel API, system iWidget developer can get the user iWidget metadata according to user iWidget definition id.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.addWidgetFromToolbox"<br/>
	* <b>Payload</b>: this event could accept three kinds of payload.<br/>
	* &nbsp;-&nbsp;<b>Text</b>: It is the iWidget definition id. The definition id must a valid value in enabler CatalogModel API. Must not be <code>null</code>.<br/>. 
	* &nbsp;&nbsp;&nbsp;For example: "feedReader".<br/>
	* &nbsp;-&nbsp;<b>Json Object</b>: It includes widget definition id and itemset as preference. The itemset enable developer set/change preference of widget instance during widget rendering.<br/>
	* &nbsp;&nbsp;&nbsp;For example:<br/>
	* &nbsp;&nbsp;&nbsp;{id: "feedReader", itemset: {feedUrl:"http://www.ibm.com/feed.rss"} }.<br/>
	* &nbsp;-&nbsp;<b>Json Object</b>: It includes widget definition metadata and itemset as preference. The keys in widgetMetadata should be same as enabler API.<br/>
	* &nbsp;&nbsp;&nbsp;For example:<br/>
	* &nbsp;&nbsp;&nbsp;{<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;widgetMetadata: <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;{<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;id:"feedReader", <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;definition:"/feedReader/feedReader.xml", <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;icon: "/feedReader/feedreader.png", <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;title:{en:"FeedReader", zh_CN:"yueduqi"},<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;onNewWire: "",<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;widgetParam: "[]"<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}, <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;itemset: {feedURL:"http://www.ibm.com/feed.rss"} <br/>
	* &nbsp;&nbsp;&nbsp;}<br/>
	* <b>Payload type</b>: text or json<br/> 
	* @type String
	*/
	ADD_WIDGET_FROM_TOOLBOX: "com.ibm.mashups.builder.addWidgetFromToolbox",
	
	/**
	* <b>Description</b>: System iWidget can broadcast ADD_WIDGET iEvent to create a user iWidget instance.<br/>
	* Layout iWidget must define ADD_WIDGET iEvent as handled iEvent to create the user iWidget instance according to the payload<br/>
	* Base on the enabler CatalogModel API, system iWidget developer can get the user iWidget metadata according to user iWidget definition id.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.addWidget"<br/>
	* <b>Payload</b>: this event could accept three kinds of payload.<br/>
	* &nbsp;-&nbsp;<b>Text</b>: It is the iWidget definition id. The definition id must a valid value in enabler CatalogModel API. Must not be <code>null</code>.<br/>. 
	* &nbsp;&nbsp;&nbsp;For example: "feedReader".<br/>
	* &nbsp;-&nbsp;<b>Json Object</b>: It includes widget definition id and itemset as preference. The itemset enable developer set/change preference of widget instance during widget rendering.<br/>
	* &nbsp;&nbsp;&nbsp;For example:<br/>
	* &nbsp;&nbsp;&nbsp;{id: "feedReader", itemset: {feedUrl:"http://www.ibm.com/feed.rss"} }.<br/>
	* &nbsp;-&nbsp;<b>Json Object</b>: It includes widget definition metadata and itemset as preference. The keys in widgetMetadata should be same as enabler API.<br/>
	* &nbsp;&nbsp;&nbsp;For example:<br/>
	* &nbsp;&nbsp;&nbsp;{<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;widgetMetadata: <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;{<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;id:"feedReader", <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;definition:"/feedReader/feedReader.xml", <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;icon: "/feedReader/feedreader.png", <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;title:{en:"FeedReader", zh_CN:"yueduqi"},<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;onNewWire: "",<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;widgetParam: "[]"<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}, <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;itemset: {feedURL:"http://www.ibm.com/feed.rss"} <br/>
	* &nbsp;&nbsp;&nbsp;}<br/>
	* <b>Payload type</b>: text or json<br/> 
	* @type String
	*/
	ADD_WIDGET: "com.ibm.mashups.builder.addWidget",
	
	/**
	* <b>Description</b>: RESET_STYLE iEvent is broadcast to recreate a empty style of layout iWidget.<br/> 
	* Layout iWidget can define RESET_STYLE iEvent as handled iEvent to recreate style of itself.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.resetStyle"<br/>
	* <b>Payload</b>: N/A<br/>
	* @type String
	*/	
	RESET_STYLE: "com.ibm.mashups.builder.resetStyle",

	/**
	* <b>Description</b>: DISPLAY_WIDGET iEvent is broadcast to move a user iWidget instance from none visible area to layout iWidgets.<br/> 
	* Layout iWidget must define DISPLAY_WIDGET iEvent as handled iEvent to show a user iWidget instance in itself.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.displayWidget"<br/>
	* <b>Payload</b>: user iWidget instance id. Must not be <code>null</code>.<br/>
	* <b>Payload type</b>: text<br/> 
	* @type String
	*/	
	DISPLAY_WIDGET: "com.ibm.mashups.builder.displayWidget",

	/**
	* <b>Description</b>: HIDE_WIDGET iEvent is broadcast to move a user iWidget instance from layout iWidget to none visible area. <br/>
	* None visible area must define HIDE_WIDGET iEvent as handled iEvent to hide a user iWidget instance into itself.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.hideWidget"<br/>
	* <b>Payload</b>: user iWidget instance id. Must not be <code>null</code>.<br/>
	* <b>Payload type</b>: text<br/> 
	* @type String
	*/
	HIDE_WIDGET: "com.ibm.mashups.builder.hideWidget",

	/**
	* <b>Description</b>: RENAME_WIDGET iEvent is broadcast to rename a user iWidget instance. <br/>
	* Layout iWidget must define RENAME_WIDGET iEvent as handled iEvent to update the user iWidget instance name.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.renameWidget"<br/>
	* <b>Payload</b>: data of the updated user iWidget name. Must not be <code>null</code>. <br/>
	* {<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;id: user iWidget instance id,<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;name: new name of the user iWidget instance<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;locale(optional): locale of the name<br/>
	* }<br/>
	* <b>Payload type</b>: json<br/> 
	* @type String
	*/
	RENAME_WIDGET: "com.ibm.mashups.builder.renameWidget",

	/**
	* <b>Description</b>: RENAME_ACTION iEvent is broadcast from iWidget context menu to inform another system iWidget to handle rename iWidget action. <br/>
    * <b>Value</b>: "com.ibm.mashups.builder.renameAction"<br/>
	* <b>Payload</b>: user iWidget instance id. Must not be <code>null</code>. <br/>
	* <b>Payload type</b>: text<br/> 
	* @type String
	*/
	RENAME_ACTION: "com.ibm.mashups.builder.renameAction",

	/**
	* <b>Description</b>: MOVE_ACTION iEvent is broadcast from iWidget context menu to inform another system iWidget to handle move iWidget action. <br/>
    * <b>Value</b>: "com.ibm.mashups.builder.moveAction"<br/>
	* <b>Payload</b>: user iWidget instance id. Must not be <code>null</code>. <br/>
	* <b>Payload type</b>: text<br/> 
	* @type String
	*/
	MOVE_ACTION: "com.ibm.mashups.builder.moveAction",
	
	/**
	* <b>Description</b>: RESIZE_ACTION iEvent is broadcast from iWidget context menu to inform another system iWidget to handle resize iWidget action. <br/>
    * <b>Value</b>: "com.ibm.mashups.builder.resizeAction"<br/>
	* <b>Payload</b>: user iWidget instance id. Must not be <code>null</code>. <br/>
	* <b>Payload type</b>: text<br/> 
	* @type String
	*/
	RESIZE_ACTION: "com.ibm.mashups.builder.resizeAction",
	
	/**
	* <b>Description</b>: CHANGE_SKIN iEvent is broadcast to change the skin of a user iWidget instance. <br/>
	* Layout iWidget must define CHANGE_SKIN iEvent as handled iEvent to update the skin of user iWidget instance. <br/>
	* Enabler ThemeModel will provide all the Skin available in current theme. Builder runtime model API will provide current theme Id. <br/>
    * <b>Value</b>: "com.ibm.mashups.builder.changeSkin"<br/>
	* <b>Payload</b>: user iWidget instance and the new skin id. The new skin id must be a valid skin id in enabler ThemeModel api.
	* Must not be <code>null</code>.<br/>
	* {<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;id: user iWidget instance id<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;skin: new skin name<br/>
	* }<br/>
	* <b>Payload type</b>: json<br/> 
	* @type String
	*/
	CHANGE_SKIN: "com.ibm.mashups.builder.changeSkin",

	/**
	* <b>Description</b>: Mashup skin service broadcasts SKIN_LOADED iEvent when skin is loaded. <br/>
	* Layout iWidget could define SKIN_LOADED iEvent as handled iEvent if it needs to
	* initialize some additional handlers in user iWidget skin, such as drag and drop handler, resize handler. <br/>
    * <b>Value</b>: "com.ibm.mashups.builder.skinLoaded"<br/>
	* <b>Payload</b>: skin parameters. Must not be <code>null</code>.<br/>
	* {<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;widgetId: user iWidget instance id,<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;skinNodeId: user iWidget skin node,<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;skinParam: skin parameters defined in skin.js in the skin resource directory, json<br/>
	* }<br/>
	* <b>Payload type</b>: json<br/> 
	* @type String
	*/
	SKIN_LOADED: "com.ibm.mashups.builder.skinLoaded",

	/**
	* <b>Description</b>: RESIZE_WIDGET iEvent should be broadcast to adjust the width or height of user iWidget instance. <br/>
	* Layout iWidget can define RESIZE_WIDGET iEvent as handled iEvent to update the size of user iWidget instance. <br/>
    * <b>Value</b>: "com.ibm.mashups.builder.resizeWidget"<br/>
	* <b>Payload</b>: size of user iWidget instance. Must not be <code>null</code>.<br/>
	* {<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;widgetId: id of user iWidget instance,<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;width: new width of user iWidget instance,<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;height: new height of user iWidget instance<br/>
	* }<br/>
	* <b>Payload type</b>: json<br/> 
	* @type String
	*/	
	RESIZE_WIDGET: "com.ibm.mashups.builder.resizeWidget",

	/**
	* <b>Description</b>: WIDGET_RESIZED iEvent should be broadcast after the size of user iWidget instance is changed. <br/>
	* User iWidget can define WIDGET_RESIZED iEvent as handled iEvent to do some follow up work if necessary. <br/>
    * <b>Value</b>: "com.ibm.mashups.builder.widgetResized"<br/>
	* <b>Payload</b>: size of user iWidget instance. Must not be <code>null</code>.<br/>
	* {<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;widgetId: id of user iWidget instance,<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;width: new width of user iWidget instance,<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;height: new height of user iWidget instance<br/>
	* }<br/>
	* <b>Payload type</b>: json<br/> 
	* @type String
	*/	
	WIDGET_RESIZED: "com.ibm.mashups.builder.widgetResized",
	
	/**
	* <b>Description</b>: WIDGET_MOVED iEvent should be broadcast after a user iWidget instance is moved in the layout. <br/>
	* User iWidget can define WIDGET_MOVED iEvent as handled iEvent to do some follow up work if necessary. <br/>
    * <b>Value</b>: "com.ibm.mashups.builder.widgetMoved"<br/>
	* <b>Payload</b>: user iWidget instance id. Must not be <code>null</code>. <br/>
	* <b>Payload type</b>: text<br/> 
	* @type String
	*/	
	WIDGET_MOVED: "com.ibm.mashups.builder.widgetMoved",
	
	/**
	* <b>Description</b>: WIDGET_DELETED iEvent should be broadcast after a user iWidget instance has been deleted from the layout. <br/>
	* User iWidget can define WIDGET_DELETED iEvent as handled iEvent to do some follow up work if necessary. <br/>
    * <b>Value</b>: "com.ibm.mashups.builder.widgetDeleted"<br/>
	* <b>Payload</b>: user iWidget instance id. Must not be <code>null</code>. <br/>
	* <b>Payload type</b>: text<br/> 
	* @type String
	*/	
	WIDGET_DELETED: "com.ibm.mashups.builder.widgetDeleted",

	/**
	* <b>Description</b>: System iWidget should broadcast EMBED_PAGE iEvent to embed a mashup page. <br/>
	* System iWidget (e.g EmbedPage) can define EMBED_PAGE iEvent as handled iEvent to accept to create the embedding UI for the page. <br/>
    * <b>Value</b>: "com.ibm.mashups.builder.embedPage"<br/>
	* <b>Payload</b>: page id. Must not be <code>null</code>.<br/>
	* <b>Payload type</b>: text<br/> 
	* @type String
	*/
	EMBED_PAGE: "com.ibm.mashups.builder.embedPage",

	/**
	* <b>Description</b>: System iWidget broadcasts EMBED_WIDGET iEvent to embed a user iWidget. <br/>
	* System iWidget (e.g EmbedWidget) can define EMBED_WIDGET iEvent as handled iEvent to create the embedding UI for the user iWidget. <br/>
    * <b>Value</b>: "com.ibm.mashups.builder.embedWidget"<br/>
	* <b>Payload</b>: user iWidget definition id. Must not be <code>null</code>.<br/>
	* <b>Payload type</b>: text<br/> 
	* @type String
	*/
	EMBED_WIDGET: "com.ibm.mashups.builder.embedWidget",
	
	/**
	* <b>Description</b>: System iWidget broadcasts LOAD_PAGESOURCE iEvent to load the page source. <br/>
	* System iWidget (e.g PageSource) can define LOAD_PAGESOURCE iEvent as handled iEvent to load the mashup page user iWidget markups into its source container. <br/>
    * <b>Value</b>: "com.ibm.mashups.builder.loadPageSource"<br/>
	* <b>Payload</b>: N/A<br/> 
	* @type String
	*/
	LOAD_PAGESOURCE: "com.ibm.mashups.builder.loadPageSource",

	/**
	* <b>Description</b>: System iWidget broadcasts SAVE_PAGE iEvent to save page source. <br/>
	* System iWidget (e.g PageSource) must define SAVE_PAGE iEvent as handled iEvent to persist the user iWidget markups in current page.<br/>
	* System iWidget developer can call enabler Navigation Model API to persist current page. <br/>
    * <b>Value</b>: "com.ibm.mashups.builder.savePage"<br/>
	* <b>Payload</b>: page id. Must not be <code>null</code>. <br/> 
	* <b>Payload type</b>: text<br/> 
	* @type String
	*/
	SAVE_PAGE: "com.ibm.mashups.builder.savePage",

	/**
	* <b>Description</b>: System iWidget broadcasts EDIT_PAGE iEvent to load page property. <br/>
	* System iWidget (e.g PagePropertyEditor) can define EDIT_PAGE iEvent as handled iEvent to load the page properties, for example, page theme and page title. <br/>
    * <b>Value</b>: "com.ibm.mashups.builder.editPage"<br/>
	* <b>Payload</b>: page id. Must not be <code>null</code>.<br/>
	* <b>Payload type</b>: text<br/> 
	* @type String
	*/
	EDIT_PAGE: "com.ibm.mashups.builder.editPage",

	/**
	* <b>Description</b>: System iWidget broadcasts UPDATE_PAGE_TITLE iEvent to update page title. <br/>
	* System iWidget (e.g PageTitle) can define UPDATE_PAGE_TITLE iEvent as handled iEvent to update the title in its displaying area. <br/>
    * <b>Value</b>: "com.ibm.mashups.builder.updatePageTitle"<br/>
	* <b>Payload</b>: page title. Must not be <code>null</code>.<br/>
	* {<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;title: page title,<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;locale(optional): locale of the title<br/>
	* }<br/>
	* <b>Payload type</b>: json<br/> 
	* @type String
	*/
	UPDATE_PAGE_TITLE: "com.ibm.mashups.builder.updatePageTitle",
	
	/**
	* <b>Description</b>: System iWidgets broadcasts HIGHLIGHT_WIDGET iEvent to make Layout iWidget highlight a specific user iWidget.<br/>
	* Layout iWidget should define HIGHLIGHT_WIDGET iEvent as handled iEvent in case it wants to highlight a user iWidget instance.  <br/>
    * <b>Value</b>: "com.ibm.mashups.builder.highlightWidget"<br/>
	* <b>Payload</b>: id of user iWidget instance. Must not be <code>null</code>. <br/>
	* <b>Payload type</b>: text<br/> 
	* @type String
	*/
	HIGHLIGHT_WIDGET: "com.ibm.mashups.builder.highlightWidget",
	
	/**
	* <b>Description</b>: System iWidgets broadcasts REMOVE_WIDGET_HIGHTLIGHT iEvent to make Layout iWidget remove highlight of a specific user iWidget.<br/>
	* Layout iWidget should define REMOVE_WIDGET_HIGHTLIGHT iEvent as handled iEvent in case it wants to remove the highlight on a user iWidget instance.  <br/>
    * <b>Value</b>: "com.ibm.mashups.builder.removeWidgetHighlight"<br/>
	* <b>Payload</b>: id of user iWidget instance. Must not be <code>null</code>.<br/>
	* <b>Payload type</b>: text<br/> 
	* @type String
	*/
	REMOVE_WIDGET_HIGHTLIGHT: "com.ibm.mashups.builder.removeWidgetHighlight",
	
	/**
	* <b>Description</b>: System iWidget broadcasts ADD_NEW_WIRE iEvent to inform layout iWidget to add a new wire. <br/>
	* Layout iWidget must define ADD_NEW_WIRE iEvent as handled iEvent, update the iWidget markup to add the new wire.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.addNewWire"<br/>
	* <b>Payload</b>: context information used to create new wire. Must not be <code>null</code>.<br/>
	* { <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;sourceWidgetId: id of the wire's source iWidget<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;sourceEvent: published event name of the source iWidget<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;targetWidgetId: id of the wire's target iWidget<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;targetEvent: handled event name of the target iWidget<br/>
	* } <br/>
	* <b>Payload type</b>: json<br/> 
	* @type String
	*/	
	ADD_NEW_WIRE: "com.ibm.mashups.builder.addNewWire",
	
	/**
	* <b>Description</b>: System iWidget broadcasts REMOVE_NEW_WIRE iEvent to inform layout iWidget to remove an existing wire.<br/>
	* Layout iWidget must define REMOVE_NEW_WIRE iEvent as handled iEvent, update the iWidget markup to remove the wire.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.removeWire"<br/>
	* <b>Payload</b>: context information used to remove the wire. Must not be <code>null</code>.<br/>
	* { <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;sourceWidgetId: id of the wire's source iWidget<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;sourceEvent: published event name of the source iWidget<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;targetWidgetId: id of the wire's target iWidget<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;targetEvent: handled event name of the target iWidget<br/>
	* }<br/>
	* <b>Payload type</b>: json<br/> 
	* @type String
	*/	
	REMOVE_WIRE: "com.ibm.mashups.builder.removeWire",
	
	/**
	* <b>Description</b>: CREATE_AUTO_WIRE iEvent can be broadcast to add auto wire between the specified widget with other iWidget instances on the page. <br/>
	* Auto wire: Auto wire happens when<br/>
	* 1. Auto-wiring is enabled for the page;<br/>
	* 2. Specified iWidget is auto-wiring enabled;<br/>
	* 3. The wired-to iWidget is auto-wiring enabled;<br/>
	* 4. Wire the specified iWidget's iEvent to other iWidget's iEvent when the two iEvent have exactly same event name and payload type.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.createAutoWire"<br/>
	* <b>Payload</b>: iWidget instance id. Must not be <code>null</code>.<br/>
	* <b>Payload type</b>: text<br/> 
	* @type String
	*/
	CREATE_AUTO_WIRE: "com.ibm.mashups.builder.createAutoWire",
	
	/**
	* <b>Description</b>: AUTO_WIRE_CREATED iEvent will be broadcast to after a auto wire is added between two iWidget instances. <br/>
	* Auto wire: refer to the iEvent CREATE_AUTO_WIRE.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.autoWireCreated"<br/>
	* <b>Payload</b>: Created auto-wires information. Must not be <code>null</code>.<br/>
	* { <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;widgetId: instance id of the new added iWidget<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;publishTo: Array, contains all instance id of the widgets which the new added iWidget is wired with as source iWidget<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;receiveFrom: Array, contains all instance id of the widgets which the new added iWidget is wired with as target iWidget<br/>
	* }<br/>
	* <b>Payload type</b>: json<br/> 
	* @type String
	*/
	AUTO_WIRE_CREATED: "com.ibm.mashups.builder.autoWireCreated",
	
	/**
	* <b>Description</b>: CREATE_QUICK_WIRE iEvent can be broadcast to add a wire between two iWidget instances automatically. <br/>
	* Quick wire: Check the two iWidget's first iEvent, if they can be wired together(payload type is compatible), wire them. 
	* QUICK_WIRE_CREATED iEvent must be broadcast after the wire is created<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.createQuickWire"<br/>
	* <b>Payload</b>: context information used to add the wire. Must not be <code>null</code>.<br/>
	* { <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;sourceWidgetId: id of the wire's source iWidget<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;targetWidgetId: id of the wire's target iWidget<br/>
	* }<br/>
	* 
	* <b>Payload type</b>: json<br/> 
	* @type String
	*/
	CREATE_QUICK_WIRE: "com.ibm.mashups.builder.createquickWire",
	
	/**
	* <b>Description</b>: QUICK_WIRE_CREATED iEvent will be broadcast to after a quick wire is added between two iWidget instances. <br/>
	* Quick wire: refer to the iEvent CREATE_QUICK_WIRE.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.quickWireCreated"<br/>
	* <b>Payload</b>: context information of the added wire. Must not be <code>null</code>.<br/>
	* { <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;sourceWidgetId: id of the wire's source iWidget<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;targetWidgetId: id of the wire's target iWidget<br/>
	* }<br/>
	* 
	* <b>Payload type</b>: json<br/> 
	* @type String
	*/
	QUICK_WIRE_CREATED: "com.ibm.mashups.builder.quickWireCreated",
	
	/**
	* <b>Description</b>: EDIT_WIRE iEvent can be broadcast to launch the wiring interface of a iWidget instance.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.editWire"<br/>
	* <b>Payload</b>: id of the user iWidget instance. Must not be <code>null</code>.<br/>
	* <b>Payload type</b>: text<br/> 
	* @type String
	*/	
	EDIT_WIRE: "com.ibm.mashups.builder.editWire",
	
	/**
	* <b>Description</b>: DISPLAY_WIRE_GRAPH iEvent can be broadcast to display the wire graph of a iWidget instance.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.displayWireGraph"<br/>
	* <b>Payload</b>: id of the user iWidget instance. Must not be <code>null</code>.<br/>
	* <b>Payload type</b>: text<br/> 
	* @type String
	*/	
	DISPLAY_WIRE_GRAPH: "com.ibm.mashups.builder.displayWireGraph",
	
	/**
	* <b>Description</b>: System iWidget broadcasts SHARE_PAGE iEvent to notice other iWidgets to start the sharing work.
	* System iWidget (e.g SharePage iWidget) which implements the sharing function should define this iEvent as handled iEvent<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.sharePage"<br/>
	* <b>Payload</b>: id of the shared page. Must not be <code>null</code>.<br/>
	* <b>Payload type</b>: text<br/> 
	* @type String
	*/
	SHARE_PAGE: "com.ibm.mashups.builder.sharePage",

	/**
	* <b>Description</b>: System iWidget broadcasts SHARE_SPACE iEvent to notice other iWidgets to start the sharing work.
	* System iWidget (e.g SharePage iWidget) which implements the sharing function should define this iEvent as handled iEvent<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.shareSpace"<br/>
	* <b>Payload</b>: id of the shared space. Must not be <code>null</code>.<br/>
	* <b>Payload type</b>: text<br/> 
	* @type String
	*/
	SHARE_SPACE: "com.ibm.mashups.builder.shareSpace",

	/**
	* <b>Description</b>: System iWidget broadcasts PUBLISH_PAGE iEvent to notice other iWidgets to start the publishing page work.
	* System iWidget (e.g PublishPage iWidget) which implements the publish function must define this iEvent as handled iEvent<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.publishPage"<br/>
	* <b>Payload</b>: id of the published page. Must not be <code>null</code>.<br/>
	* <b>Payload type</b>: text<br/> 
	* @type String
	*/
	PUBLISH_PAGE: "com.ibm.mashups.builder.publishPage",
	
	/**
	* <b>Description</b>: System iWidget broadcasts VIEW_MORE_PAGE iEvent to notice other iWidgets it wants to accept pages from other users.
	* System iWidget (e.g viewMorePage iWidget) which implements that function should define this iEvent as handled iEvent.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.viewMorePage"<br/>
	* <b>Payload</b>: N/A<br/>
	* @type String
	*/
	VIEW_MORE_PAGE: "com.ibm.mashups.builder.viewMorePage",
	
	/**
	* <b>Description</b>: DISPLAY_IN_MASHUP_DIALOG iEvent can be broadcast to display system iWidget in a configurable mashup dialog.<br/>
	* The system iWidget need to be linked to a type id in "dialogDisplayer" iWidget's itemset. <br/>
	* Current supported type id: 
	* <ul>
	* 	<li>sharePage</li>
	*   <li>publishPage</li>
	*   <li>viewMorePage</li>
	*   <li>renameWidget</li>
	*   <li>wireInteface</li>
	*   <li>pageSource</li>
	*   <li>embedPage</li>
	*   <li>embedWidget</li>
	*   <li>editPage</li>
	*   <li>hiddenWidgetCorral</li>
	*   <li>editSpace</li>
	*   <li>spaceManager</li>
	*   <li>createPage</li>
	*   <li>createSpace</li>
	*   <li>copySpace</li>
	*   <li>changeSpaceOwnerWidget</li>
	*   
	* </ul>
    * <b>Value</b>: "com.ibm.mashups.builder.displayInMashupDialog"<br/>
	* <b>Payload</b>: <br/>
	* {<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;widgetTypeId: type id. Must not be <code>null</code>.<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;eventName(optional): name of the iEvent of target iWidget which will be invoked <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;eventPayloa(optional): payload which will be passed to the handled iEvent<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;dialogParam(optional): parameters used to configure the dialog<br/>
	* }<br/>
	* Example: show wire interface iWidget in a dialog:<br/>
	* We have below definition in theme.html. <br/>
	* &lt;div class="mm_iWidget" id="dialogDisplayer"> <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&lt;a class="mm_Definition" href="/mum/widget-catalog/displayHelper.xml">&lt;/a> <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&lt;span class="mm_ItemSet" title="attributes" style="visibility: hidden; display: none;"> <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;a class="mm_Item" style="visibility: hidden; display: none;" href="#wireInterface">wireInterface&lt;/a> <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;....... <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&lt;/span><br/>
	* &lt;/div> <br/>
	* Call following javascript code to display wire iWidget in dialog and invoke <code>EDIT_WIRE<code> iEvent.<br/>
	* var dialogParam = <br/>
	* { <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;nodeWidth: "486px", <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;...... <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;displayCloseButton: false, <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;hasRightBottomResizer: false <br/>
	* } <br/>
	* var payload = <br/>
	* {<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;widgetTypeId: "pageSoure", <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;eventName:  "com.ibm.mashups.builder.loadPageSource", <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;eventPayload:  ..., <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;dialogParam:  dialogParam <br/>
	* }<br/>
	* var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService"); <br/>
	* eventService.broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);<br/>
	* <b>Payload type</b>: json<br/> 
	* @type String
	*/
	DISPLAY_IN_MASHUP_DIALOG: "com.ibm.mashups.builder.displayInMashupDialog",
	
	/**
	* <b>Description</b>: CLOSE_MASHUP_DIALOG iEvent can be broadcast with a system iWidget id. 
	* If that system iWidget is displayed in a mashup dialog, then the dialog will be closed.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.closeMashupDialog"<br/>
	* <b>Payload</b>: id of the system iWidget instance which is displayed in the mashup style dialog. Must not be <code>null</code>.<br/>
	* <b>Payload type</b>: text<br/> 
	* @type String
	*/
	CLOSE_MASHUP_DIALOG: "com.ibm.mashups.builder.closeMashupDialog",
		
	/**
	* <b>Description</b>: STATE_CHANGED iEvent can be broadcast to change the widget's state, restore/max/min the current widget by layout widget.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.stateChanged"<br/>
	* <b>Payload</b>: id of the iWidget instance, and widget's state. Must not be <code>null</code>.<br/>
	* {<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;widgetId: iwidgetId, <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;state:  "max"/"min"/"normal" <br/>
	* }<br/>
	* <b>Payload type</b>: json<br/> 
	* @type String
	*/
	STATE_CHANGED: "com.ibm.mashups.builder.stateChanged",
	
	/**
	* <b>Description</b>: Broadcast OPEN_PAGE iEvent to open a given page and optionally broadcast widget events to it.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.openPage"<br/>
	* <b>Payload</b>: This event can accept two kinds of payload, id of the page to be opened or a json object in the follow format. Must not be <code>null</code>.<br/>
	* { <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;pid: id of the page to be opened<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;eventsArray: an array of events to be broadcast to the widgets on the page<br/>
	* }<br/>
	* The "eventsArray" should include one or more event objects in this format <br/>
	* { <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;targetEvent: targetEvent<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;payload: payload<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;payloadType: payloadType<br/>
	* }<br/>
	* <b>Payload type</b>: text or json<br/>
	* @type String
	*/
	OPEN_PAGE:"com.ibm.mashups.builder.openPage",
	
	/**
	* <b>Description</b>: Broadcast CLOSE_PAGE iEvent to close a given page that was opened using the OPEN_PAGE iEvent. If CLOSE_PAGE is broadcast multiple times, 
	* the actual close page action only happen once.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.closePage"<br/>
	* <b>Payload</b>: id of the page to be closed. <br/>
	* <b>Payload type</b>: text<br/> 
	* @type String
	*/
    CLOSE_PAGE:"com.ibm.mashups.builder.closePage",
	
	/**
	* <b>Description</b>: System iWidget broadcasts CREATE_PAGE iEvent to initiate Create Page widget, which allows to create a new page.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.createPage"<br/>
	* <b>Payload</b>: <code>spaceId</code> refers to under which space new page will be created, <code>parentPageId</code> refers to new page's parent page. Must not be <code>null</code>.<br/>
	* {<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;spaceId: space id, <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;parentPageId: parent page id<br/>
	* }<br/>	
	* <b>Payload type</b>: json<br/> 
	* @type String
	*/
    CREATE_PAGE:"com.ibm.mashups.builder.createPage",

	/**
	* <b>Description</b>: System iWidget broadcasts CREATE_SPACE iEvent to initiate Create Space widget, which allows to create a new space.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.createSpace"<br/>
	* <b>Payload</b>: <code>createSpaceFromSpaceManager</code> should be set as <code>true</code> if CREATE_SPACE is broadcast inside Space Manager, otherwise <code>false</code>. Must not be <code>null</code>.<br/>
	* {<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;createSpaceFromSpaceManager: a boolean value to indicate whether the create space action is launched from space manager<br/>
	* }<br/>
	* <b>Payload type</b>: json<br/> 
	* @type String
	*/
    CREATE_SPACE:"com.ibm.mashups.builder.createSpace",

	/**
	* <b>Description</b>: System iWidget broadcasts EDIT_SPACE iEvent to initiate Edit Space widget, which allows to edit existing space.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.editSpace"<br/>
	* <b>Payload</b>: id of space to be edited. Must not be <code>null</code>.<br/>
	* <b>Payload type</b>: text<br/>
	* @type String	
	*/
    EDIT_SPACE:"com.ibm.mashups.builder.editSpace",

	/**
	* <b>Description</b>: System iWidget broadcasts COPY_SPACE iEvent to initiate Copy Space widget, which allows to clone given space.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.copySpace"<br/>
	* <b>Payload</b>: <code>spaceId</code> is the id of space to be cloned, and <code>copySpaceInSpaceManager</code> should be set as <code>true</code> if COPY_SPACE is broadcast inside Space Manager, otherwise <code>false</code>. Must not be <code>null</code>.<br/>
	* {<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;spaceId: id of the space, <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;copySpaceInSpaceManager: a boolean value to indicate whether the copy space action is launched from space manager <br/>
	* }<br/>
	* <b>Payload type</b>: json<br/> 
	* @type String
	*/
    COPY_SPACE:"com.ibm.mashups.builder.copySpace",		
	
	/**
	* <b>Description</b>: System iWidget broadcasts CHANGE_SPACE_OWNER iEvent to initiate Change Space Owner widget, which allows to change space owner. After space owner is changed, two dojo events will be published:<br/>
	* <code>dojo.publish("com.ibm.mm.builder.spaceEditorWidget.OwnerName", [username]);</code><br/>
	* <code>dojo.publish("com.ibm.mm.builder.spaceEditorWidget.OwnerId", [userid]);</code><br/>
	* These two dojo events should be subscribed to get new owner id and owner name.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.changeSpaceOwner"<br/>
	* <b>Payload</b>: original space owner id, Must not be <code>null</code>.<br/>
	* <b>Payload type</b>: text<br/>
	* @type String
	*/
    CHANGE_SPACE_OWNER:"com.ibm.mashups.builder.changeSpaceOwner",
	
	/**
	* <b>Description</b>: System iWidget broadcasts MANAGE_SPACES iEvent to initiate Space Manager widget, which allows to manage spaces.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.manageSpaces"<br/>
	* <b>Payload</b>: N/A<br/>
	* @type String
	*/
    MANAGE_SPACES:"com.ibm.mashups.builder.manageSpaces"	
});

com.ibm.mashups.builder.iEvents = new com.ibm.mashups.builder.IEvent();

}

if(!dojo._hasResource["com.ibm.mm.builder.utils.PageWidthChanger"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.utils.PageWidthChanger"] = true;
dojo.provide("com.ibm.mm.builder.utils.PageWidthChanger");

dojo.declare("com.ibm.mm.builder.utils.PageWidthChanger", null, {

	constructor : function() {
		this._changer = new com.ibm.mm.builder.utils.PageWidthChanger.Changer();
		this._pageWidthMode = {};
		if (dojo.isIE == 6) {
			this._resizeFn = dojo.hitch(this, this._resizeHandler);
			window.attachEvent("onresize", this._resizeFn);
		}
	},	
	
	setWidthRangeProvider : function(provider) {
		this._wrp = provider;
	},
	
	setWidgetListProvider : function(provider) {
	    this._wlp = provider;
	},
	
	setPageWidthModeProvider : function(provider) {
		this._pwmp = provider;
	},
	
	init : function() {
		this._pageWidthMode = this.getPageWidthMode();
	},
	
	addPageWidthModeChangedListener : function(listener) {
		this._pwmcListener = listener;
	},
	
	getPageWidthRange : function() {
		return {
			min : this._wrp.getMinimum(),
			max : this._wrp.getMaximum()
		};
	},
	
	_getBodyWidthToFitViewport : function() {
		var d = this._getViewportDimension();
		var delta = dojo.marginBox(dojo.body()).w - dojo.contentBox(dojo.body()).w;
		return d.width - delta - 23;
	},
	
	changeWidthToFitViewport : function(minWidth) {
		var d = this._getViewportDimension();
		var delta = dojo.marginBox(dojo.body()).w - dojo.contentBox(dojo.body()).w;
		/*var fluidWidth = d.width - delta - 60;
		dojo.style(dojo.query("html")[0], {
			"width" : (d.width - delta) + "px"
		});
		this._changer.setWidth(fluidWidth);*/
		this.useFluidLayout(minWidth);
		//this._changer.setOverflow();
	},
	
	useFluidLayout : function(minWidth) {
		this._changer.restoreToFluidLayout();
		if (minWidth) {
			var min = Math.max(parseInt(minWidth,10), this._wrp.getMinimum());
			this.setMinimumWidth(min);
		}
	},
	
	_getViewportDimension : function() {
	  var w = window.innerWidth || (document.documentElement && document.documentElement.clientWidth) || document.getElementsByTagName('body')[0].clientWidth;
	  var h = window.innerHeight || (document.documentElement && document.documentElement.clientHeight) || document.getElementsByTagName('body')[0].clientHeight;
	  return {width : w, height : h};
	},
	
	changeWidth : function(width) {
	    var minWidth = this._pageWidthMode.mode == "dynamic" ? this._getBodyWidthToFitViewport() : 0;
		var viewportWidth = this._getBodyWidthToFitViewport();
		//var min = Math.max(this._wrp.getMinimum(), minWidth), max = this._wrp.getMaximum();
		var min = Math.min(this._wrp.getMinimum(), this._wrp.getMaximum()) , max = this._wrp.getMaximum();
		width = Math.min(Math.max(width, min), max);
		if (this._pageWidthMode.mode == "dynamic") {
			width = width < viewportWidth ? "auto" : width;
		}
		this._changer.changeTo(width, min, max);
	},
	
	changeWidthDelta : function(delta) {
	    var oldX = this._changer.getWidth();
		this.changeWidth(oldX + delta);
	},
	
	setMinimumWidth : function(width) {
		this._changer.setMinimum(width);
	},

	
	_normalizeWidgetId : function(widgetId) {
	   return  widgetId.indexOf(com.ibm.mm.builder.constant.skinIdPrefix) === 0 ? widgetId : com.ibm.mm.builder.constant.skinIdPrefix + widgetId;
	},
	
	_getMinimumWidthForWidgets : function(widgetIds) {
	  widgetIds = widgetIds || this._wlp.getWidgetIds() || [];
	  var rightPos = dojo.map(widgetIds, function(widgetId) {
	   var box = dojo.marginBox(dojo.byId(this._normalizeWidgetId(widgetId)));
			return box.l + box.w;
	  }, this);
	  var min = 0;
	  dojo.forEach(rightPos, function(value) {
		  min = Math.max(min, value);
	  });
	  return min;
	},
	
	_getWidgetMarginBox : function(widgetId) {
	    widgetId = this._normalizeWidgetId(widgetId);
	    return dojo.marginBox(dojo.byId(widgetId));
	},
	
	_isWidthInViewport : function(width) {
		var d = this._getViewportDimension();
		var delta = dojo.marginBox(dojo.body()).w - dojo.contentBox(dojo.body()).w;
		var fluidWidth = d.width - delta - 60;
		return width < fluidWidth;
	},
	
	getPageWidthMode : function() {
	    return (this._pwmp && this._pwmp.getPageWidthMode && this._pwmp.getPageWidthMode()) || {};
	},
	
	setPageWidthMode : function(pageWidthMode) {
		if (pageWidthMode.mode !== this._pageWidthMode.mode || 
			parseInt(pageWidthMode.width,10) !== parseInt(this._pageWidthMode.width,10)) {
			this._pageWidthMode = pageWidthMode;
			
			var payload = {
				"type" : "change",
				"summary" : {
				   "old" : dojo.clone(this._pageWidthMode),
				   "new" : dojo.clone(pageWidthMode)
				}
			};
			if (this._pwmcListener) {
				if (dojo.isFunction(this._pwmcListener)) {
				   this._pwmcListener(payload);
				}
				else if (dojo.isObject(this._pwmcListener)) {
					this._pwmcListener.fn.apply(this._pwmcListener.scope || dojo.global, [payload]);
				}
			}
		}
	},
	
	hasReactionToWidget : function() {
	   return this._pageWidthMode.mode == "dynamic";
	},
	
	_needsToAdjustWidth : function() {
		return this._pageWidthMode.mode == "dynamic";
	},
	
	_changeWidthAndScroll : function(width, left) {
		this.changeWidth(width);
		this._changer.scrollToView(left);
	},

	widgetToBeResized : function(widgetId, width, deltaW) {
	    if (!this.hasReactionToWidget()) {
			return;
		}
		//this._changer.cancelOverflow();
		/*if (deltaW < 0) {
			var box = this._getWidgetMarginBox(widgetId);
			if (box.l + width > this._changer.getWidth()) {
			  this.changeWidth(box.l + width);
			  this._changer.scrollToView(box.l);
			}
		}*/
		var box = this._getWidgetMarginBox(widgetId);
		this.changeWidth(box.l + width);
		this._changer.scrollToView(box.l);
	},
	
	widgetToBeMoved : function(widgetId, left, width) {
	   if (!this.hasReactionToWidget()) {
			return;
		}
		if (typeof left == "undefined" || left === null) {
			throw new Error("Please provide the left coordinate.");
		}
		if (typeof width == "undefined" || width === null) {
			if (widgetId) {
				var box = this._getWidgetMarginBox(widgetId);
				width = box.w;
			}
			else {
				throw new Error("Please provide the widget id or width.");
			}
		}
		//this._changer.cancelOverflow();
		
		this.changeWidth(left + width);
		this._changer.scrollToView(left);
	},
	
	
	widgetToBeRemoved : function() {
	   if (!this.hasReactionToWidget()) {
			return;
	   }
	   var widgetIds = this._wlp.getWidgetIds();
	   var min = this._getMinimumWidthForWidgets(widgetIds);
	   this.changeWidth(min);
	},
	
	_resizeHandler : function() {
		if (!this._needsToAdjustWidth()) {
			return;
		}
		window.detachEvent("onresize", this._resizeFn);
		this._clearWidthChangerTimeout();
		this._widthChangerTimeout = window.setTimeout(dojo.hitch(this, this._changeMinMaxWidth), 300);
		window.attachEvent("onresize", this._resizeFn);
	},
	
	_changeMinMaxWidth : function() {
		var min = this._wrp.getMinimum();
		var max = this._wrp.getMaximum();
		this._changer._changeMinMaxWidth(min, max);
		this._clearWidthChangerTimeout();
	},
	
	_clearWidthChangerTimeout : function() {
		if (this._widthChangerTimeout) {
			window.clearTimeout(this._widthChangerTimeout);
		}
	}
	
});


dojo.declare("com.ibm.mm.builder.utils.PageWidthChanger.Changer", null, {
	WIDTH_CHANGE_THROTTLE_VALUE : 50,
	
	constructor : function() {
		this._node = dojo.body();
		this._toChangeWidthTimer = null;
	},
	
	_getNode : function() {
		return this._node;
	},
	
	_changeMinMaxWidth : function(min, max) {
		var currentWidth = document.documentElement.clientWidth;
		var newWidth = currentWidth < min ? min : (currentWidth > max ? max : currentWidth);
		if (newWidth == min || newWidth == max) {
			this.setWidth(newWidth);
		}
		else {
			this.setWidth("auto");
		}
	},
	
	changeTo : function(/* Number */ width, min, max) {
		//this._clearChangeToTimer();
		//this._toChangeWidthTimer = window.setTimeout(dojo.hitch(this, this._doChangeTo, width, min, max),this.WIDTH_CHANGE_THROTTLE_VALUE);
		this._doChangeTo(width, min, max);
	},
	
	_clearChangeToTimer : function() {
		if (this._toChangeWidthTimer) {
			window.clearTimeout(this._toChangeWidthTimer);
		}
	},
	
	_normalizeNumericValues : function(value) {
		if (value || value === 0) {
			var v = /^\d+$/.test(value + "") ? (value + "px") : value;
			return v;
		}
	},
	
	_hackForShadowMenu : function() {
		dojo.query(".mashupsShadowNode").style("left", 0);
	},
	
	_doChangeTo : function(width, min, max) {
		var obj = {};
		var w = this._normalizeNumericValues(width);
		if (w) {
			obj.width = w;
		}
		var minW = this._normalizeNumericValues(min);
		if (minW) {
			obj.minWidth = minW;
		}
		var maxW = this._normalizeNumericValues(max);
		if (maxW) { 
			obj.maxWidth = maxW;
		}
		dojo.style(this._getNode(), obj);
		this._hackForShadowMenu();
	},
	
	setMinimum : function(width) {
	    this._doChangeTo(null, width);
	},
	
	setWidth : function(width) {
		this._doChangeTo(width);
	},
	
	getWidth : function() {
	  return dojo.style(this._getNode(), "width");
	},
	
	setOverflow : function() {
		dojo.style(dojo.query("html")[0], {
			"overflowX" : "hidden"
		});
		window.scrollTo(0, window.pageYOffset);
	},
	
	cancelOverflow : function() {
		dojo.style(dojo.query("html")[0], {
			"overflowX" : "auto"
		});
	},
	
	scrollToView : function(xPos) {
		//window.scrollTo(xPos, window.pageYOffset);
	},
	
	restoreToFluidLayout : function() {
		var maxWidth = dojo.isIE ? "100%" : "auto";
		this._doChangeTo("auto", "auto", "100%");
	}
});

if (!dojo.isObject("com.ibm.mm.builder.utils.pageWidthChanger")) {
	dojo.setObject("com.ibm.mm.builder.utils.pageWidthChanger", new com.ibm.mm.builder.utils.PageWidthChanger());
}

}

if(!dojo._hasResource["com.ibm.mm.builder.dnd.QuickWireTarget"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.dnd.QuickWireTarget"] = true;
/**
 * @author Yi Ming Huang(huangyim@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.dnd.QuickWireTarget");

/**
 * FreeformSource is the drop target of one column in free form
 */
dojo.declare("com.ibm.mm.builder.dnd.QuickWireTarget", dojo.dnd.Target, {
	
	//accept: ["iWidgetDefinition", "iWidgetInstance"],
	accept: ["lm"],
	
	handler: null,
	
	onDndDrop: function(source, nodes, copy, target){
		try {
			this.inherited(arguments);
		} catch (e) {
			//the source node will be null for unknown reason.
		}
	},
	/**
	onDropExternal: function(source, nodes, copy){
		var sid = nodes[0].getAttribute("dnddata");
		if(nodes[0].getAttribute("dndtype") === "iWidgetDefinition"){
			sid = this.layout.createWidget(nodes[0].getAttribute("dnddata"));
		}
		//hide before do autowire
		com.ibm.mm.builder.utils.iwidgetUtil.hideWidget(sid);
		var self = this;
		this.handler = com.ibm.mm.builder.utils.iwidgetUtil.invokeCallbackByWidgetInstanceId(sid, function(){
			var payload = {
				sourceWidgetId: sid,
				targetWidgetId: self.targetId,
				callBackFuncContext: self,
				callbackFunc: "moveEffect"
			};
			var es = com.ibm.mashups.services.ServiceManager.getService("eventService");
			es.broadcastEvent("com.ibm.mashups.builder.createQuickWire", payload);
			com.ibm.mm.builder.utils.iwidgetUtil.showWidget(sid);
			self.disconnectHandler();
		});
	},
	*/
	
	onDropExternal: function(source, nodes, copy) {
		var type = dojo.attr(nodes[0], "dndtype");
		if(this._acceptType(type)) {
			var sourceLcId = com.ibm.pb.layout.LayoutParser.extractID(nodes[0]);
			var targetLcId = this.node.title;
			var payload = {
				sourceWidgetId: sourceLcId,
				targetWidgetId: targetLcId
			};
			var es = com.ibm.mashups.services.ServiceManager.getService("eventService");
			es.broadcastEvent("com.ibm.mashups.builder.createQuickWire", payload);
		}
	},
	
	disconnectHandler: function(){
		if (this.handler) {
			com.ibm.mashups.services.ServiceManager.getService("eventService").unsubscribeEvent(this.handler, null);
		}
	},
	
	_acceptType: function(type) {
		if(this.accept[type])
			return true;
		return false;
	}
});

com.ibm.mm.builder.dnd.QuickWireTargetMap = {};

}

if(!dojo._hasResource["com.ibm.mm.builder.dnd.QuickWireHelper"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.dnd.QuickWireHelper"] = true;
dojo.provide("com.ibm.mm.builder.dnd.QuickWireHelper");



dojo.declare("com.ibm.mm.builder.dnd.QuickWireHelper", null, {
	
	quickWireHandlers: {},
	
	quickWireHandlerHeight: 34,
	
	createQuickWireTarget: function(nodeId) {
		var lcDiv = com.ibm.pb.layout.LayoutParser.findById(nodeId);
		var handler = dojo.query(".decoration-titlebar", lcDiv)[0];
		var coords = dojo.coords(handler);
		var div = dojo.create("div", {zIndex: 999, title: nodeId});
		
		var left = coords.x + (window.scrollX || document.documentElement.scrollLeft);
		var top = coords.y + (window.scrollY || document.documentElement.scrollTop);
		div.style.cssText = "position: absolute; "
						+ "height: " + coords.h + "px; "
						+ "width: " + coords.w + "px; "
						+ "left: " + left + "px; "
						+ "top: " + top + "px;"
		//div.style.backgroundColor = "blue";
		dojo.body().appendChild(div);
		var target = new com.ibm.mm.builder.dnd.QuickWireTarget(div);
		
		this.quickWireHandlers[nodeId] = target;
	},
	
	destroyQuickWireTarget: function(nodeId) {
		var target = this.quickWireHandlers[nodeId];
		if(target) {
			var div = target.node;
			dojo.body().removeChild(div);
			delete target;
			this.quickWireHandlers[nodeId] = null;
		}
	},
	
	destroyAllQuickWireTarget: function() {
		for(var id in this.quickWireHandlers) {
			this.destroyQuickWireTarget(id);
		}
	}
});

}

if(!dojo._hasResource["com.ibm.pb.dnd.layout.LayoutFreeformSource"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.dnd.layout.LayoutFreeformSource"] = true;
/**
 * @author Qing Guo
 */

 dojo.provide("com.ibm.pb.dnd.layout.LayoutFreeformSource");
 
 
 
 
 
 
 
 dojo.declare("com.ibm.pb.dnd.layout.LayoutFreeformSource", 
 	[com.ibm.dnd.TunedLayoutSource, com.ibm.mm.builder.dnd.QuickWireHelper, com.ibm.pb.logging.Loggable], {
 	mouseDown:false,
	topPos: null,
	height: 700,
	managerOverrides: {
		OFFSET_X: 1,
		OFFSET_Y: 1,
		makeAvatar: function(){
			return new com.ibm.pb.dnd.layout.LayoutControlAvatar(this);
		}
	},
	layoutParser: com.ibm.pb.layout.LayoutParser,
	constructor: function() {
		this.evtSvc = com.ibm.mashups.services.ServiceManager.getService("eventService");
		this.resizeWidgetEvt = this.evtSvc.subscribeEvent("com.ibm.mashups.builder.resizeWidget", this, "__widgetResized");
		this.addNewWidget = this.evtSvc.subscribeEvent("com.ibm.mashups.builder.addNewWidget", this, "_addNewWidget");
		var currentPageId = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
		this.lm = ibmCfg.controllers.dnd.nm.getLayoutModel(currentPageId);
		if(this.node.style){
			this.height = dojo.style(this.node,"height");
			if(this.node.style.width){
				if (dojo.isIE) {
					dojo.style(this.node, "width", "100%");
				}
				else {
					this.node.style.removeProperty("width");
				}
			}
		}
		this.count = dojo.query(".component-control", this.node).length;
		//following codes are used for MoveWidget Dialog
		var cst = dojo.coords(this.node, true);
		var pageWidthChanger = com.ibm.mm.builder.utils.pageWidthChanger;
		pageWidthChanger.setWidthRangeProvider(this.createFixedWidthRangeProvider(cst.w));
		//end
   		this.onOverEvent();
	},
		
	onDrop: function(source, nodes, copy,draggedOut){	
		this.LOGGER.entering("onDrop",[source, nodes, copy]);
		this.inherited(arguments);
		var currentNode = nodes[0];
		
		//dojo.style(dojo.body(),{cursor:"default"});
		var sourceItem = source.getItem(currentNode.id);
		if (sourceItem && (sourceItem.type == ibmCfg.controllers.dnd.SHELF_TYPE)) {
			this.layoutContainer = dojo.dnd.manager().target.node;
		}else{
			if(source.anchor){
				this.layoutContainer = source.anchor.parentNode;
			}else{
				this.layoutContainer = dojo.dnd.manager().target.node;
			}
		}
		var _containerId = this.layoutParser.extractID(this.node);
		var _currentNodeId = this.layoutParser.extractID(currentNode);
		var lcCoords = dojo.coords(this.node, true);
		
		if (sourceItem && (sourceItem.type == ibmCfg.controllers.dnd.SHELF_TYPE)) {
			com.ibm.pb.dnd.layout.LayoutFreeformSource.addWidgetByDrop = true;
			var widget = dijit.byId(nodes[0].id);
			widget.apply(_containerId, null);
		} else {
			widgetNode = currentNode;
			var lctrl = this.lm.find(_currentNodeId).start();
			var _position = {
				x: Math.max(this._last_drop_X - lcCoords.x - this._last_layerX, 0),
				y: Math.max(this._last_drop_Y - lcCoords.y, 0)
			};
			if(draggedOut){//user's mouse has moved out of the layout.
				var avatarPosition = dojo.position(dojo.dnd.manager().avatar.node);
				_position = {
				x: Math.max(avatarPosition.x- dojo.dnd.manager().OFFSET_X- lcCoords.x, 0),
				y: Math.max(avatarPosition.y - dojo.dnd.manager().OFFSET_Y- lcCoords.y, 0)
				};
			}
			
			if(source != this){
				_position = {
				x: Math.max(this._last_drop_X - lcCoords.x, 0),
				y: Math.max(this._last_drop_Y - lcCoords.y, 0)
				};
				if (lctrl) {
					var styleTxt = lctrl.getMetaData("css-style-backup");
					if (styleTxt) 
						widgetNode.style.cssText = styleTxt;
				}
			}
			
			widgetNode.style.cssText += "; position: absolute; "
									+ "left: " + _position.x + "px; "
									+ "top: " + _position.y + "px;"
			if (lctrl) {
				lctrl.setMetaData("css-style", widgetNode.style.cssText);
			}
			this._saveWidgetStyles();//to update the zindex for all widgets.
			
			if(dojo.hasClass(source.node, "hiddenWidgetsContainer")){
				var containerDef = this.lm.find(_containerId);
				if (containerDef) {
					containerDef.setFinishedCallback(dojo.hitch(this, "_insert"), {
					layoutModel: this.lm,
					controls: { target: null, current: currentNode }});
					containerDef.start(false);
				}
				else {
					this.LOGGER.severe("onDrop", "Cannot find container in the layout model");
				}
			}			
		}
		
		if (this.updateContainer){
			var ctrol = this.lm.find(_containerId).start();
			this._saveContainerSize(ctrol);
			this.updateContainer = false;
		}
		this.evtSvc.broadcastEvent("com.ibm.mashups.builder.widgetMoved", _currentNodeId);
		com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
		
		this.isDragging = false;
				
		this.LOGGER.exiting("onDrop",[source, nodes, copy]);
	},
	
	_addNewWidget: function(iEvent){
		var newPlaceHolderID = iEvent;
		//judget whether widget is added to freeform layout rather than hidden area
		var _nws = dojo.query(".id-"+newPlaceHolderID, this.node);
		if (!_nws || !_nws[0]){
			return;
		}
		var lcCoords = dojo.coords(this.node, true);
		var lc = com.ibm.pb.dnd.layout.LayoutFreeformSource.getWidgetLocation(this.count, lcCoords);
		var _position;
		if (com.ibm.pb.dnd.layout.LayoutFreeformSource.addWidgetByDrop) {
			_position = {
				x: Math.max(this._last_drop_X - lcCoords.x, 0),
				y: Math.max(this._last_drop_Y - lcCoords.y, 0),
				zIndex: this.count
			};
		}else{
			_position = {x:lc.x, y:lc.y, zIndex: lc.zIndex};
		}
		if(lcCoords.h < _position.y+300){
			this._saveContainerHeight(_position.y+300);		
		}
		com.ibm.pb.dnd.layout.LayoutFreeformSource.setWidgetPosition(newPlaceHolderID, _position);
		com.ibm.pb.dnd.layout.LayoutFreeformSource.setWidgetInitHeight(newPlaceHolderID);
		this.refreshCallback = this.evtSvc.subscribeEvent("com.ibm.mashups.builder.layoutRefreshed", this, dojo.hitch(this, "_loadDefaultSize", newPlaceHolderID));
		
		com.ibm.pb.dnd.layout.LayoutFreeformSource.addWidgetByDrop = false;
		this.count++;
	},
	_saveContainerHeight:function(newHeight){
		dojo.style(this.node, "height", newHeight + "px");
		var _containerId =this.layoutParser.extractID(this.node);
		var ctrol = this.lm.find(_containerId).start();
		this._saveContainerSize(ctrol);	
	},
	
	_saveWidgetStyles:function(){
		dojo.query(".component-control", this.node).forEach(function(node, index, arr){
			var id =this.layoutParser.extractID(node);
			if(id){
				var lctrl = this.lm.find(id).start();
				if (lctrl) {
					lctrl.setMetaData("css-style", node.style.cssText);
				}
			}
		},this);
	},
	_syncZindex:function(ctrlnode){
		var currentZ = ctrlnode.style.zIndex;
		if (currentZ) {
			dojo.query(".component-control", this.node).forEach(function(node, index, arr){
				var tempZ = node.style.zIndex;
				if (tempZ && tempZ >= currentZ) {
					tempZ--;
					node.style.zIndex=tempZ;
				}
			});
		}
		ctrlnode.style.zIndex = this.count;
	},
	_loadDefaultSize: function(id){
		try{
			var newPlaceHolderDiv = this.layoutParser.findById(id);
			var widgetBody = dojo.query(".lotusWidgetBody", newPlaceHolderDiv)[0];
			var wb = dojo.query(".iw-iWidget",widgetBody)[0];
			if (wb && wb.id) {
				var wrapper = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(wb.id);
				if (wrapper) {
					var iitems = wrapper.getIDescriptorItems();
					var defaultHeight = iitems.getItemValue("defaultHeight");
					var defaultWidth = iitems.getItemValue("defaultWidth");
					var payload = null;
					if (defaultHeight || defaultWidth) {
						payload = {};
						if (defaultHeight) {
							payload.newHeight = defaultHeight;
						}
						if (defaultWidth) {
							payload.newWidth = defaultWidth;
						}
					}
					if (payload) {
						this.evtSvc.publishEvent(com.ibm.mashups.iwidget.Constants.RESIZE_WIDGET + "." + wb.id, payload);
					}
				}
			}
			if(this.refreshCallback){
				this.evtSvc.unsubscribeEvent(this.refreshCallback);
				this.refreshCallback = null;
				this.newWidgetId = null;
			}
		}catch(er){
			this.LOGGER.severe("_loadDefaultSize", er.message);
		}
	},
	_insert: function(container, status, x){
		// summary: inserts a control to the new location
		// container: layout container into which to put the new control
		// status: HTTP status returned from request to get container
		// x: {layoutModel, controls {target, current dragging node}}
		this.LOGGER.entering("_insert",[container, status, x]);
		if(status != 200) {
			this.LOGGER.severe("_insert","Could not find container in the layout model.  Cannot move control.",[container, status, x]);
			return;
		}

		if(container instanceof com.ibm.mashups.enabler.layout.LayoutContainer){
			var current = x.layoutModel.find(this.layoutParser.extractID(x.controls.current)).start();
			
			if(!current){
				this.LOGGER.severe("_insert","Cannot find current dragging node in the layout model", [x.controls.current]);
			}
				
			var target = null;
			if (x.controls.target) { 
				target = x.layoutModel.find(this.layoutParser.extractID(x.controls.target)).start();
				if(!target){
					this.LOGGER.severe("_insert","Cannot find target node in the layout model", [x.controls.target]);
				}
			}
	
			if( x.layoutModel.confirmInsert(current,container,target) ){
				x.layoutModel.insert(current,container,target);
			}
			
			com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
			
			if(!this.delaySave){
				ibmCfg.controllers.dnd.nm.commit().start();				
			}
			
		} else { 
			this.LOGGER.severe("_insert","Container is not an instance of com.ibm.mashups.enabler.layout.LayoutContainer",[container, status, x]); 
		}
		
		this.LOGGER.exiting("_insert",[container, status, x]);
	},
	onDndCancel: function(){
		if (dojo.dnd.manager().source !== this) { 
			return;
		}
		
		if (this.isDragging) {
			//mouse move out of the layout, ondrop will not be called by dnd manager, manuall call it.
			this.onDrop(this,this.getSelectedNodes(),false,true);
			
			this.inherited(arguments);			
			ibmCfg.controllers.dnd.ghostHeight = 0;
			this.isDragging = false;
		}
		
		if (ibmCfg.controllers.dnd.currentNode && !ibmCfg.controllers.dnd.currentNode._isCanceled) {
					
			if (!dojo.isIE) {
				dojo.style(ibmCfg.controllers.dnd.currentNode, {display: ""});
			}
			
			ibmCfg.controllers.dnd.currentNode._isCanceled = true;
		}
		
		try{
			if(dojo.dnd.manager().target && dojo.dnd.manager().target.declaredClass != this.declaredClass && dojo.hasClass(dojo.dnd.manager().source.node, "ibmFreeform")){
				var currentId = this.layoutParser.extractID(dojo.dnd.manager().nodes[0]);	
				this.evtSvc.broadcastEvent("com.ibm.mashups.builder.leaveFreeformContainer"+"."+currentId);
			}
		}catch(e){}
		
		try{
			if(dojo.dnd.manager().target && dojo.dnd.manager().target.declaredClass == this.declaredClass && !dojo.hasClass(dojo.dnd.manager().source.node, "ibmFreeform")){
				var currentId = this.layoutParser.extractID(dojo.dnd.manager().nodes[0]);
				this.evtSvc.broadcastEvent("com.ibm.mashups.builder.enterFreeformContainer"+"."+currentId);
			}
		}catch(e){}
		
		this.current = null;
		this.destroyAllQuickWireTarget();
	},
	destroy: function(){
		this.evtSvc.unsubscribeEvent(this.resizeWidgetEvt);
		this.evtSvc.unsubscribeEvent(this.addNewWidget);
		this.count = 0;
		this.onOutEvent();
		this.inherited(arguments);
	},
	onDndStart: function(source, nodes, copy){
		this.inherited(arguments);
		this.isDragging = true;
		this._syncZindex(nodes[0]);
		
		var currentNode = dojo.byId(nodes[0].id);
		// current node stored in controller for use in creator
		ibmCfg.controllers.dnd.currentNode = currentNode;
		ibmCfg.controllers.dnd.currentNode._isCanceled = false;
		
		var sourceItem = source.getItem(nodes[0].id);
		if(sourceItem && (sourceItem.type != ibmCfg.controllers.dnd.SHELF_TYPE)){
			if (!dojo.isIE) {
				dojo.style(currentNode, {display: "none"});
			}
		}
	},
	onOverEvent: function(){
		if(!this.onmousemoveEvent){
			this.onmousemoveEvent = dojo.connect(this.node, "onmousemove", this, "onMouseMove");
		}
		
		dojo.dnd.manager().overSource(this);
		if(this.isDragging && this.targetState != "Disabled"){
			this.onDraggingOver();
		}
		this.active = true;
	},
	
	onOutEvent: function(){
		if(this.onmousemoveEvent){
			dojo.disconnect(this.onmousemoveEvent);
			delete this.onmousemoveEvent;
		}
		
		dojo.dnd.manager().outSource(this);
		if(this.isDragging && this.targetState != "Disabled"){
			this.onDraggingOut();
		}
		this.active = false;
	},
	

	onMouseUp: function(e){
		try {
			this._last_drop_X = e.pageX;
			this._last_drop_Y = e.pageY;
			com.ibm.pb.dnd.layout.LayoutFreeformSource.superclass.onMouseUp.call(this, e);
		} catch (e) {
			this.LOGGER.severe("onMouseUp", e.message);
		}
	},
	
	onMouseDown: function(e){
		com.ibm.pb.dnd.layout.LayoutFreeformSource.superclass.onMouseDown.call(this, e);
		this._last_layerX =  dojo.isOpera ? e.offsetX: e.layerX;
		this._last_layerY =  dojo.isOpera ? e.offsetY: e.layerY;
	},
	
	onMouseMove: function(e){
			if(this.isDragging && this.targetState == "Disabled"){ return; }
			dojo.dnd.Source.superclass.onMouseMove.call(this, e);
			var m = dojo.dnd.manager();
			if(!this.isDragging){
				if(this.mouseDown && this.isSource &&
						(Math.abs(e.pageX - this._lastX) > this.delay || Math.abs(e.pageY - this._lastY) > this.delay)){
					var nodes = this.getSelectedNodes();
					if(nodes.length){
						m.startDrag(this, nodes, this.copyState(dojo.isCopyKey(e), true));
					}
				}
			}
		
			//com.ibm.pb.dnd.layout.LayoutFreeformSource.superclass.onMouseMove.call(this, e); //don't call this for performance concern
			if (this.isDragging) {
				var m = dojo.dnd.manager();
				if (this === m.source && m.avatar && m.avatar.node && m.avatar.node.style.marginLeft === "0px" && (dojo.isOpera || e.layerX > 0)) 
				{
//					var ml = builderConfig.isBidi ? (parseInt(m.nodes[0].style.width, 10) - this._last_layerX) : this._last_layerX;
					var ml = this._last_layerX;
					dojo.style(m.avatar.node, {
						'marginLeft': -ml + "px",
						'marginTop' : "0px"
						//'marginTop': 34-this._last_layerY + "px",
					});
					//dojo.query(".dojoDndItem", m.avatar.node).style({	display: ""});
				}				
				
				if(!this.targetBox){
					this.targetBox = dojo.position(m.avatar.node, true);
				}
				this.topPos = e.pageY - this.targetBox.y;
				
				m.canDrop(true);
			}
	},
	
	_addItemClass: function(node, type){
		if(this.isDragging){
			if(type!="Anchor") {
				var _id = this.layoutParser.extractID(node);
				if(this.topPos > this.quickWireHandlerHeight) {
					this.destroyQuickWireTarget(_id);
				} else {
					if(this.quickWireHandlers[_id]) {
						// do nothing
					} else {
						this.createQuickWireTarget(_id);
					}
				}
			}
		}
	},
	
	_removeItemClass: function(node, type){
		if(this.isDragging){
		}
	},
	
	moving: function(e){
		try {
			var m = dojo.dnd.manager();
			var avatar = m.avatar;
			if(!avatar){
				return false;
			}
			
			dojo.dnd.autoScroll(e);
			
			var a = dojo.coords(avatar.node);
			var ml = parseInt(avatar.node.style.marginLeft, 10) || 0;
			var mt = parseInt(avatar.node.style.marginTop, 10) || 0;
			//avatar container coords
			var ac = {
				l: (e.pageX + m.OFFSET_X),
				t: (e.pageY + m.OFFSET_Y),
				w: a.w - ml,
				h: a.h
			};
			
			var cst = dojo.coords(this.node, true);
			//source constrained area
			var c = {
				l:cst.x + 1 - ml,
				r:cst.x + cst.w - ml - ac.w, 
				t:cst.y - mt,
				b:cst.y + cst.h - ac.h
			};
			//limit four direction.
			avatar.node.style.left = (ac.l < c.l ? c.l : c.r < ac.l ? c.r : ac.l) + "px";
			avatar.node.style.top = (ac.t < c.t ? c.t : c.b < ac.t ? c.b : ac.t) + "px";
			//limit only top-left direction.
			//var al = ac.l < c.l ? c.l : ac.l;
			//var at = ac.t < c.t ? c.t : ac.t;
			//dojo.marginBox(avatar.node, {l: al, t: at});
			//adjust the width
			com.ibm.mm.builder.utils.pageWidthChanger.widgetToBeMoved(null, ac.l, ac.w);
			//adjust the height
			if (e.pageY > c.b) {
				this.updateContainer = true;
			   var newHeight = (e.pageY + ac.h);
			   dojo.style(this.node, "height", newHeight + "px");
			}
		} catch (err) {
			this.LOGGER.severe("moving", err.message);
		}
	},

	_saveContainerSize: function(ctrl){
		var cheight = dojo.style(this.node,"height");
		var sstyle = "height:"+cheight+"px;";
		ctrl.setMetaData("css-style", sstyle);
	},
	
	_saveWidgetSize: function(widgetId, layoutControlId, control){
		var node = dojo.byId(widgetId).parentNode;
		var layoutCtl = this.lm.find(layoutControlId).start();
		var tp = control.style.overflow;
		if(tp){
			control.style.removeProperty("overflow");
		};
		layoutCtl.setMetaData("css-style", control.style.cssText);
		layoutCtl.setMetaData("wrapper-css-style", node.style.cssText);
		if(tp){
			control.style.overflow = tp;
		};
	},
	
	__widgetResized: function(iEvent){
		var widgetId = iEvent.widgetId;
		var newH = iEvent.newHeight + 50;
		var control = this.layoutParser.findById(widgetId);
		var top = 0;
		if (control.style) {
			var top = dojo.style(control, "top");
			if (!top) 
				top = 0;
		}
		
		if (top + newH > this.height) {
			this.updateContainer = true;
			var newheight = top + newH + 50;
			this.height = newheight;
			this.node.style.height = newheight + "px";
		}
		if (this.updateContainer) {
			var ctrol = this.lm.find(this.layoutParser.extractID(this.node)).start();
			this._saveContainerSize(ctrol);
			this.updateContainer = false;
		}
	},
	
	createFixedWidthRangeProvider : function(width) {
	   return {
	      getMinimum : function() {
		     return width;
		  },
		  getMaximum : function() {
		     return width;
		  }
	   };
	}
 });
 
com.ibm.pb.dnd.layout.LayoutFreeformSource.creator = function(item, hint){
	if(hint=="avatar"){
		var _node = dojo.doc.createElement("div");
		if(dojo.dnd.manager().source.current){
			// use the portlet markup as avatar
			_node.innerHTML = String(item);
			var elem = dojo.byId(dojo.dnd.manager().source.current.id);
			var isPlaceHolder = false;
			//if(!dojo.hasClass(elem, "ibmPlaceholder")){
			var _id = this.layoutParser.extractID(dojo.dnd.manager().source.current);
			var widget = dojo.byId(_id);
			if(!widget){
				widget = dojo.query(".iw-iWidget", elem)[0];
				isPlaceHolder = true;
			}
			var m = dojo.contentBox(widget.parentNode);
			var ava_widget = dojo.query("[id~="+_id+"]",_node)[0]; 
			if(!ava_widget && isPlaceHolder){
				ava_widget = dojo.query(".iw-iWidget", _node)[0];
			}
			if(dojo.isFF){
				dojo._setMarginBox(ava_widget.parentNode, 0, 0, m.w + 17, m.h);
			}else{
				dojo._setMarginBox(ava_widget.parentNode, 0, 0, m.w, m.h);
			}
			if(isPlaceHolder){
				var size = dojo.contentBox(elem);
				dojo.style(_node, { width: size.w+"px", height: size.h+"px", opacity: 0.5});
			}else{
				dojo.style(_node, { width: elem.style.width, height: elem.style.height, opacity: 0.5});			
			}				
		}
		return {node: _node, data: item, type: [ibmCfg.controllers.dnd.DND_TYPE]};
	} else {  // this works the same way as the _normalizedCreator/onDropExternal functions in dojo.dnd.Source when there is no given creator function
		var node;
		if(dojo.isOpera) {
			node = dojo.byId(ibmCfg.controllers.dnd.currentNode.id).parentNode;  // opera returned nothing using dojo.query below
		} else {
			node = dojo.query("[id~="+ibmCfg.controllers.dnd.currentNode.id+"]")[0];
		}
		if(node){
			var source = ibmCfg.controllers.dnd.dndSources[this.layoutParser.extractID(node.parentNode)];
			if(source){
				var t = source.getItem(node.id);
				source.delItem(node.id);
				source.selection = {};  // prevents node from being deleted in dojo.dnd.Selector.deleteSelectedNodes called by onDropExternal()
				return {node: node, data: t.data, type: t.type};
			}
		} 
		return {node:dojo.create("div"),data:item,type:ibmCfg.controllers.dnd.SHELF_TYPE}
	}
};
com.ibm.pb.dnd.layout.LayoutFreeformSource.withHandles = true;
com.ibm.pb.dnd.layout.LayoutFreeformSource.addWidgetByDrop = false;

com.ibm.mashups.services.ServiceManager.getService("eventService").subscribeEvent("com.ibm.mashups.builder.initWidgets", null, function(iEvent){
	try {
		var container = com.ibm.pb.layout.LayoutParser.findById(iEvent.containerId);
		var lcCoords = dojo.coords(container, true);
		for(var i = 0; i < iEvent.data.length; i++){
			var item = iEvent.data[i];
			var widgetId = item.widgetId;
			var idx = item.index;
			var lc = com.ibm.pb.dnd.layout.LayoutFreeformSource.getWidgetLocation(idx, lcCoords);
			com.ibm.pb.dnd.layout.LayoutFreeformSource.setWidgetPosition(widgetId, lc);
			com.ibm.pb.dnd.layout.LayoutFreeformSource.setWidgetInitHeight(widgetId);
		}
		com.ibm.mashups.enabler.navigation.Factory.getNavigationModel().commit().start();
		com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(false);
	}catch(e){
		this.LOGGER.severe("com.ibm.mashups.builder.initWidgets", e.message);
	}
});

com.ibm.pb.dnd.layout.LayoutFreeformSource.getWidgetLocation = function(index, coords){
	try{
		var maxWidth = coords.w;
		if(!index) index = 0;
		if (index * 30 < maxWidth-400) {
			return {
				x: 30 * index,
				y: 30 * index,
				zIndex: index+1
			}
		}else{
			return {
				x: (30 * index) % (maxWidth-400),
				y: 30 * index,
				zIndex: index+1
			}
		}
	}catch(e){
		this.LOGGER.severe("com.ibm.pb.dnd.layout.LayoutFreeformSource.getWidgetLocation", e.message);
	}
};
com.ibm.pb.dnd.layout.LayoutFreeformSource.setWidgetPosition = function(widgetId, position){
	try {
		var _style = "position:absolute;left:" + position.x + "px;top:" + position.y + "px;width:400px;z-index:" + position.zIndex + ";";
		var currentPageId = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
		var lm = ibmCfg.controllers.dnd.nm.getLayoutModel(currentPageId);
		var ctl = lm.find(widgetId).start();
		ctl.setMetaData("css-style", _style);
		var control = com.ibm.pb.layout.LayoutParser.findById(widgetId);
		if (control) {
			control.style.position = "absolute";
			control.style.left = position.x + "px";
			control.style.top = position.y + "px";
			control.style.width = "400px";
			control.style.zIndex = position.zIndex;
		}
	}catch(e){
		this.LOGGER.severe("com.ibm.pb.dnd.layout.LayoutFreeformSource.setWidgetPosition", e.message);
	};
};
com.ibm.pb.dnd.layout.LayoutFreeformSource.setWidgetInitHeight = function(widgetId){
	var currentPageId = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
	var lm = ibmCfg.controllers.dnd.nm.getLayoutModel(currentPageId);
	var control = com.ibm.pb.layout.LayoutParser.findById(widgetId);
	var outheight = 300;
	if (control.style.height){
		outheight = parseInt(control.style.height);
	}else{
		control.style.height = outheight + "px";
	}
	if(control){
		var wb = dojo.query(".lotusWidgetBody", control)[0];
		var innerheight = outheight - 50;
		if(wb) wb.style.height = innerheight+"px";
		var layoutCtl = lm.find(widgetId).start();
		layoutCtl.setMetaData("widget-body-height", innerheight+"px");
		layoutCtl.setMetaData("css-style", control.style.cssText);
	}
};

}

if(!dojo._hasResource["com.ibm.pb.dnd.layout.LayoutColumnSource"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.dnd.layout.LayoutColumnSource"] = true;
dojo.provide("com.ibm.pb.dnd.layout.LayoutColumnSource");



dojo.declare("com.ibm.pb.dnd.layout.LayoutColumnSource", [com.ibm.pb.dnd.layout.LayoutSource], {
	ghostClass: "ibmDndGhost",
	onDndCancel: function(){
		if (this.isDragging) {
			this.inherited(arguments);			
			this.removeGhost();	
			ibmCfg.controllers.dnd.ghostHeight = 0;
		}
	},
	onOverEvent: function(){
		// create ghost in empty container
		this.inherited(arguments);
		this.active = true;
		
		if(this.isDragging && dojo.dnd.manager().target){
			var currentContainer = dojo.dnd.manager().target.node;	
			var controls = dojo.query('.'+ibmCfg.controllers.dnd.CONTROL_CLASS, currentContainer);	
			// check to see if layout container is empty
			if(controls.length == 0){			
				this.emptyContainer = currentContainer;
				if(dojo.query("."+this.ghostClass).length == 0 ){
					// creating ghosts in empty layout container
					this.emptyContainer.appendChild(this.createGhostMarkup(ibmCfg.controllers.dnd.ghostHeight));
				}
			}else{
			// clear the empty layout container object
				this.emptyContainer = null;			
			}
		}
	},
	onOutEvent: function(){
		// remove ghost from empty container
		this.inherited(arguments);
		this.active = false;
		
		if(dojo.query("."+this.ghostClass).length > 0){
			this.removeGhost();
		}
	},
	_addItemClass: function(node, type){
		// create ghost
		if(this.current == node && this.before == type){ return; }
		if(this.isDragging){
			this.createGhost(node, type);
		}
	},
	_removeItemClass: function(node, type){
		// remove ghost
		if(this.isDragging){
			this.removeGhost();
		}
	},
	createGhost: function(node, type){        
		// determines whether to create ghost before or after node
		if(type == "Before"){
			node.insertBefore(this.createGhostMarkup(ibmCfg.controllers.dnd.ghostHeight),
							  node.childNodes[0]);
		}else if (type == "After"){
			node.appendChild(this.createGhostMarkup(ibmCfg.controllers.dnd.ghostHeight));
			if (this.hasHeight(node)) {
			// add height to the node to make room for the ghost ONLY if there is a height set on the node
			// otherwise the node will become too long
				var nodeHeight = dojo.style(node, "height");
				if (nodeHeight > 0) {
				// make sure the node height isn't 0 as it always is the first time this function is called
				// add the ghost height to the height of the node (which is the widget skin)
					ibmCfg.controllers.dnd.ghostAddedHeight = true;
					dojo.style(node, "height", nodeHeight + ibmCfg.controllers.dnd.ghostHeight + "px");
				}
			}
		}
	},
	removeGhost: function(){
		//removes ghost from page
		var ghost = dojo.byId(this.ghostClass);
		if(ghost){
			var parent = ghost.parentNode;
			parent.removeChild(ghost);
			var nodeHeight = dojo.style(parent, "height");
			if (ibmCfg.controllers.dnd.ghostAddedHeight) {
				// if the createGhost() function added some height to the dnd node, 
				// it must now be removed since the ghost was removed
				ibmCfg.controllers.dnd.ghostAddedHeight = false;
				dojo.style(parent, "height", nodeHeight - ibmCfg.controllers.dnd.ghostHeight + "px");
	
			}
		}
	},
	createGhostMarkup: function(height){
		// creates ghost markup for a column container
		var elem = document.createElement("div");
		elem.className = this.ghostClass;
		elem.id = this.ghostClass;
		dojo.style(elem, { height: height+"px"});
		return elem;
	},
	hasHeight: function(node){
		//returns true if the node has a height set on it
		var style = dojo.attr(node, "style");
		if (!style) {
			return false;
		} else if (style.toString().toLowerCase().indexOf("height") >=0) {
			return true;
		} else if (style.height) {
			return true;
		} else {
			return false;
		}
	}
});

com.ibm.pb.dnd.layout.LayoutColumnSource.creator = function(item, hint){
	if(hint=="avatar"){
		var node = dojo.doc.createElement("div");
		if(dojo.dnd.manager().source.current){
			// use the portlet markup as avatar
			node.innerHTML = String(item);
			var elem = dojo.byId(dojo.dnd.manager().source.current.id);
			dojo.style(node, { width: elem.offsetWidth+"px", opacity: 0.5});
		}
		return {node: node, data: item, type: [ibmCfg.controllers.dnd.DND_TYPE]};
	} else {  // this works the same way as the _normalizedCreator/onDropExternal functions in dojo.dnd.Source when there is no given creator function
		if(dojo.isOpera) {
			var node = dojo.byId(ibmCfg.controllers.dnd.currentNode.id).parentNode;  // opera returned nothing using dojo.query below
		} else {
			var node = dojo.query("[id~="+ibmCfg.controllers.dnd.currentNode.id+"]")[0];
		}
		if(node){
			var source = ibmCfg.controllers.dnd.dndSources[com.ibm.pb.layout.LayoutParser.extractID(node.parentNode)];
			if(source){
				var t = source.getItem(node.id);
				source.delItem(node.id);
				source.selection = {};  // prevents node from being deleted in dojo.dnd.Selector.deleteSelectedNodes called by onDropExternal()
				return {node: node, data: t.data, type: t.type};
			}
		} 
		return {node:dojo.create("div"),data:item,type:ibmCfg.controllers.dnd.DND_TYPE}
	}
};

com.ibm.pb.dnd.layout.LayoutColumnSource.withHandles = true;

}

if(!dojo._hasResource["com.ibm.pb.dnd.layout.LayoutMashupColumnSource"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.dnd.layout.LayoutMashupColumnSource"] = true;
dojo.provide("com.ibm.pb.dnd.layout.LayoutMashupColumnSource");




dojo.declare("com.ibm.pb.dnd.layout.LayoutMashupColumnSource", 
		[com.ibm.pb.dnd.layout.LayoutColumnSource, com.ibm.mm.builder.dnd.QuickWireHelper], {

	layoutParser: com.ibm.pb.layout.LayoutParser,

	onDndCancel: function() {
		this.inherited(arguments);
		this.destroyAllQuickWireTarget();
	},
	
	onMouseMove: function(e){
		// summary:
		//		event processor for onmousemove
		// e: Event
		//		mouse event
		// Customization: add topPos
		if(this.isDragging && this.targetState == "Disabled"){ return; }
		dojo.dnd.Source.superclass.onMouseMove.call(this, e);
		var m = dojo.dnd.manager();
		if(!this.isDragging){
			if(this.mouseDown && this.isSource &&
					(Math.abs(e.pageX - this._lastX) > this.delay || Math.abs(e.pageY - this._lastY) > this.delay)){
				var nodes = this.getSelectedNodes();
				if(nodes.length){
					m.startDrag(this, nodes, this.copyState(dojo.isCopyKey(e), true));
				}
			}
		}
		if(this.isDragging){
			// calculate before/after
			var before = false;
			var topPos = -1;
			if(this.current){
				if(!this.targetBox || this.targetAnchor != this.current){
					this.targetBox = dojo.position(this.current, true);
				}
				if(this.horizontal){
					topPos = e.pageX - this.targetBox.x;
					before = topPos < (this.targetBox.w / 2);
				}else{
					topPos = e.pageY - this.targetBox.y;
					before = topPos < (this.targetBox.h / 2);
				}
			}
			if(this.current != this.targetAnchor || before != this.before){
				this._markTargetAnchor(before, topPos);
				m.canDrop(!this.current || m.source != this || !(this.current.id in this.selection));
			}
		}
	},
	
	_markTargetAnchor: function(before, topPos){
		// summary:
		//		assigns a class to the current target anchor based on "before" status
		// before: Boolean
		//		insert before, if true, after otherwise
		// Customization: add topPos
		if(this.current == this.targetAnchor && this.before == before){ return; }
		if(this.targetAnchor){
			this._removeItemClass(this.targetAnchor, this.before ? "Before" : "After");
		}
		this.targetAnchor = this.current;
		this.targetBox = null;
		this.before = before;
		if(this.targetAnchor){
			this._addItemClass(this.targetAnchor, this.before ? "Before" : "After", topPos);
		}
	},
	
	_addItemClass: function(node, type, topPos){
		// summary: adds a class with prefix "dojoDndItem" and create ghost
		// node: Node: a node
		// type: String: a variable suffix for a class name
		if(this.current == node && this.before == type){ return; }
		if(this.isDragging){
			var _id = this.layoutParser.extractID(node);
			if(topPos == undefined) {
				// we are dragging from the content shelf
				this.createGhost(node, type);
			} else if(topPos > this.quickWireHandlerHeight) {
				// we are not dragging on the handler
				this.createGhost(node, type);
				this.destroyQuickWireTarget(_id);
			} else {
				// we are dragging on the handler
				if(this.quickWireHandlers[_id]) {
					// do nothing
				} else {
					this.createQuickWireTarget(_id);
				}
			}
		}
	}
});

com.ibm.pb.dnd.layout.LayoutMashupColumnSource.creator = 
	dojo.hitch(com.ibm.pb.dnd.layout.LayoutMashupColumnSource, 
			com.ibm.pb.dnd.layout.LayoutColumnSource.creator);

com.ibm.pb.dnd.layout.LayoutMashupColumnSource.withHandles = true;

}

if(!dojo._hasResource["com.ibm.pb.dnd.layout.LayoutRowSource"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.dnd.layout.LayoutRowSource"] = true;
dojo.provide("com.ibm.pb.dnd.layout.LayoutRowSource");



dojo.declare("com.ibm.pb.dnd.layout.LayoutRowSource", [com.ibm.pb.dnd.layout.LayoutSource], {
	ghostClass: "ibmDndHorizontalGhost",
	currentHolder: null, // this holds the current target when the ghost is inserted before a source
	onDrop: function(source, nodes, copy){
		this.LOGGER.entering("onDrop",[source, nodes, copy]);
		
		//this.firstInsert is used to flag whether the widget will be inserted in the first place of the un-empty row 
		/*
		if(!this.current && !this.emptyContainer && !this.firstInsert){
			this.onDndCancel();
			return;
		}
		*/
						
		// A row source can have an active target without a current target
		// active in the dojo framework. currentHolder will hold the target 
		// to determine where to drop when this scenario occurs
		if(!this.current && this.currentHolder && !this.emptyContainer){
			this.current = this.currentHolder;		
			this.before = true; 
		}
		
		var currentNode = dojo.byId(nodes[0].id);
		var sourceItem = source.getItem(currentNode.id);
		var type = sourceItem ? sourceItem.type : null;
		if(sourceItem && (type == ibmCfg.controllers.dnd.SHELF_TYPE)){
			this.onDropFromShelf(source, nodes, copy);
		}else{
			if(this != source){
				this.onDropExternal(source, nodes, copy);
			}else{
				this.onDropInternal(nodes, copy);
			}
		}
		var currentContainer = null;
		if(this.current){
			currentContainer = this.current.parentNode;
		}else{
			currentContainer = this.emptyContainer;
		}
		
		if (!currentContainer) {
			currentContainer = dojo.dnd.manager().target.node;
		}
		
		if (!currentContainer) {
			currentContainer = currentNode.parentNode;
		}
		
		this._calculateDropTarget(currentNode, currentContainer, type);
		
		this._processDrop(currentNode, currentContainer, source, nodes, copy);
		
		dojo.style(currentNode,{cursor:"default",opacity: 1,display: ""});
		
		this.LOGGER.exiting("onDrop",[source, nodes, copy]);
	},
	onDndCancel: function(){
		if (this.isDragging) {
			this.inherited(arguments);			
			this.removeGhost();	
		}
	},
	onOverEvent: function(){
		// create ghost in empty container
		this.inherited(arguments);
		this.active = true;
		
		if(this.isDragging && dojo.dnd.manager().target){
			var currentContainer = dojo.dnd.manager().target.node;	
			var controls = dojo.query('.'+ibmCfg.controllers.dnd.CONTROL_CLASS, currentContainer);	
			
			this.emptyContainer = currentContainer;
			if(dojo.query("."+this.ghostClass).length == 0 ){
					// creating ghosts in empty layout container
					this.emptyContainer.appendChild(this.createEmptyContainerGhostMarkup());
				}
			if(controls.length != 0){	
				this.emptyContainer = null;
			}
			
			/*
			// check to see if layout container is empty
			if(controls.length == 0){			
				this.emptyContainer = currentContainer;
				if(dojo.query("."+this.ghostClass).length == 0 ){
					// creating ghosts in empty layout container
					this.emptyContainer.appendChild(this.createEmptyContainerGhostMarkup());
				}
			}else{
			// clear the empty layout container object
				this.emptyContainer = null;			
			}
			*/
		}
	},
	onOutEvent: function(){
		// remove ghost from empty container
		this.inherited(arguments);
		this.active = false;
		
		if((dojo.query("."+this.ghostClass).length > 0) && !this.current){
			this.removeGhost();
		}
	},	
	_markTargetAnchor: function(before){
		// determines when to create the ghost, before or after the target
		if(this.current == this.targetAnchor && this.before == before){ return; }
		if((this.targetAnchor != this.current) && !this.targetSelected){
			this.currentHolder = null;
			this.removeGhost(this.targetAnchor);
		}
		if (this.current == null && this.targetAnchor != null) {
			this.current = this.targetAnchor;
		}else if (this.targetAnchor == null && this.current != null){
			this.targetAnchor = this.current;
		}else{
			this.targetAnchor = this.current;
		}
		this.targetBox = null;
		this.before = before;
		if(this.targetAnchor){
			this.currentHolder = this.current;
			this.createGhost(this.targetAnchor, this.before ? "Before" : "After");
			if(this.before){
				this.firstInsert = true;
			}
		}else{
			this.firstInsert = false;
		}
	},
	_unmarkTargetAnchor: function(){
		// determines when to remove the ghost
		if(!this.targetAnchor && !this.targetSelected){ return; }
		this.removeGhost(this.targetAnchor);
		this.currentHolder = null;
		this.targetAnchor = null;
		this.targetBox = null;
		this.before = true;
	},
	createGhost: function(node, type){	
		// creates ghost on page
		if(type == "Before"){
			var container = node.parentNode;
			container.insertBefore(this.createGhostMarkup(), node);
		}else if (type == "After"){
			var container = node.parentNode;
			container.insertBefore(this.createGhostMarkup(), node.nextSibling);
		}
	},
	removeGhost: function(){
		// removes ghost from page
		var ghost = dojo.byId(this.ghostClass);
		if(ghost){
			var parent = ghost.parentNode;
			parent.removeChild(ghost);
		}
	},
	createGhostMarkup: function(){
		// check to see if a ghost is already on the page
		// and remove before creating another
		this.removeGhost();
		var elem = document.createElement("div");
		dojo.attr(elem, {
				className: this.ghostClass,
				id: this.ghostClass,
		        onmouseover: dojo.hitch(this, function(e){	if (!e) var e = window.event; 
															if(dojo.isIE){ this.targetSelected=e.srcElement; }
															else{ this.targetSelected = e.currentTarget; }
											  }
										),
				onmouseout: dojo.hitch(this, function(){ this.targetSelected = null })
			});
		return elem;
	},
	createEmptyContainerGhostMarkup: function(){
		var elem = document.createElement("div");
		elem.className = this.ghostClass;
		elem.id = this.ghostClass;
		return elem;
	}
});

com.ibm.pb.dnd.layout.LayoutRowSource.creator = function(item, hint){
		if(hint=="avatar"){
			var node = dojo.doc.createElement("div");
			if(dojo.dnd.manager().source.current){
				// use the portlet markup as avatar
				node.innerHTML = String(item);
				var elem = dojo.byId(dojo.dnd.manager().source.current.id);
				dojo.style(node, { width: elem.offsetWidth+"px", opacity: 0.5});
			}
			return {node: node, data: item, type: [ibmCfg.controllers.dnd.DND_TYPE]};
		} else {  // this works the same way as the _normalizedCreator/onDropExternal functions in dojo.dnd.Source when there is no given creator function
			if(dojo.isOpera) {
				var node = dojo.byId(ibmCfg.controllers.dnd.currentNode.id).parentNode;  // opera returned nothing using dojo.query below
			} else {
				var node = dojo.query("[id~="+ibmCfg.controllers.dnd.currentNode.id+"]")[0];
			}
			if(node){
				var source = ibmCfg.controllers.dnd.dndSources[com.ibm.pb.layout.LayoutParser.extractID(node.parentNode)];
				if(source){
					var t = source.getItem(node.id);
					source.delItem(node.id);
					source.selection = {};  // prevents node from being deleted in dojo.dnd.Selector.deleteSelectedNodes called by onDropExternal()
					return {node: node, data: t.data, type: t.type};
				}
			} 
			return {node:dojo.create("div"),data:item,type:ibmCfg.controllers.dnd.DND_TYPE}
		}
};

com.ibm.pb.dnd.layout.LayoutRowSource.withHandles = true;

}

if(!dojo._hasResource["com.ibm.pb.dnd.layout.LayoutMashupRowSource"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.dnd.layout.LayoutMashupRowSource"] = true;
dojo.provide("com.ibm.pb.dnd.layout.LayoutMashupRowSource");




dojo.declare("com.ibm.pb.dnd.layout.LayoutMashupRowSource", 
		[com.ibm.pb.dnd.layout.LayoutRowSource, com.ibm.mm.builder.dnd.QuickWireHelper], {
	
	layoutParser: com.ibm.pb.layout.LayoutParser,
	
	onDndCancel: function() {
		this.inherited(arguments);
		this.destroyAllQuickWireTarget();
	},
	
	onMouseMove: function(e){
		// summary:
		//		event processor for onmousemove
		// e: Event
		//		mouse event
		// Customization: add topPos
		if(this.isDragging && this.targetState == "Disabled"){ return; }
		dojo.dnd.Source.superclass.onMouseMove.call(this, e);
		var m = dojo.dnd.manager();
		if(!this.isDragging){
			if(this.mouseDown && this.isSource &&
					(Math.abs(e.pageX - this._lastX) > this.delay || Math.abs(e.pageY - this._lastY) > this.delay)){
				var nodes = this.getSelectedNodes();
				if(nodes.length){
					m.startDrag(this, nodes, this.copyState(dojo.isCopyKey(e), true));
				}
			}
		}
		if(this.isDragging){
			// calculate before/after
			var before = false;
			var topPos = -1;
			if(this.current){
				if(!this.targetBox || this.targetAnchor != this.current){
					this.targetBox = dojo.position(this.current, true);
				}
				if(this.horizontal){
					before = (e.pageX - this.targetBox.x) < (this.targetBox.w / 2);
					topPos = e.pageY - this.targetBox.y;
					
					// create QuickWireTarget when mouse over the handler
					if(this.targetAnchor) {
						var node = this.targetAnchor;
						var _id = this.layoutParser.extractID(node);
						if(topPos >= this.quickWireHandlerHeight) {
							this.destroyQuickWireTarget(_id);
						} else {
							if(this.quickWireHandlers[_id]) {
								// do nothing
							} else {
								this.createQuickWireTarget(_id);
							}
						}
					}
					// end of customization	
				}else{
					topPos = e.pageY - this.targetBox.y;
					before = topPos < (this.targetBox.h / 2);
				}
			}
			if(this.current != this.targetAnchor || before != this.before){
				this._markTargetAnchor(before);
				m.canDrop(!this.current || m.source != this || !(this.current.id in this.selection));
			}
		}
	}
	
});

com.ibm.pb.dnd.layout.LayoutMashupRowSource.creator = 
	dojo.hitch(com.ibm.pb.dnd.layout.LayoutMashupRowSource, 
		com.ibm.pb.dnd.layout.LayoutRowSource.creator);

com.ibm.pb.dnd.layout.LayoutMashupRowSource.withHandles = true;

}

if(!dojo._hasResource["com.ibm.pb.dnd.layout.LayoutMashupCustomRowSource"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.dnd.layout.LayoutMashupCustomRowSource"] = true;
dojo.provide("com.ibm.pb.dnd.layout.LayoutMashupCustomRowSource");



dojo.declare("com.ibm.pb.dnd.layout.LayoutMashupCustomRowSource", 
		com.ibm.pb.dnd.layout.LayoutMashupRowSource, {
	
	layoutParser: com.ibm.pb.layout.LayoutParser,
	clearDiv: null,
	constructor: function(){
		this.containerID = this.layoutParser.extractID(this.node);
		this.clearDivID = "clear-" + this.containerID;
		this.initClearDiv(this.clearDivID);
		this.node.appendChild(this.clearDiv);
		
//		this.moveWidget = this.evtSvc.subscribeEvent("com.ibm.mashups.builder.widgetMoved", this, "_widgetMoved");
	},
	initClearDiv:function(id){
		this.clearDiv = dojo.query(".ibmClearRow", this.node)[0];
		if(!this.clearDiv){
			this.clearDiv = dojo.doc.createElement("div");
		}
		dojo.attr(this.clearDiv, {
			"id": id,
			"class": "ibmClearRow"
		});
	},
	removeClearDiv: function(){
		var temp = dojo.byId(this.clearDivID);
		if (temp) {
			this.node.removeChild(temp);
			this.clearDiv = null;
		}
		temp = null;
	},
	addClearDiv:function(){
		this.initClearDiv(this.clearDivID);
		this.node.appendChild(this.clearDiv);
	},
	updateClearDiv:function(){
		this.clearDiv = null;
		this.clearDiv = dojo.byId(this.clearDivID);
		if(!this.clearDiv){
			this.initClearDiv(this.clearDivID);
		}
		this.node.appendChild(this.clearDiv);
	},
	onDndCancel: function() {
		this.inherited(arguments);
		var clearDiv = dojo.query(".ibmClearRow", this.node)[0];
		if (!clearDiv) {
			this.addClearDiv();
		}
	},
	
	onDrop: function(source, nodes, copy){
		this.removeClearDiv();
		this.inherited(arguments);
	},
	createGhost: function(node, type){	
		// creates ghost on page
		if(type == "Before"){
			var container = node.parentNode;
			container.insertBefore(this.createGhostMarkup(), node);
		}else if (type == "After"){
			var container = node.parentNode;
			container.insertBefore(this.createGhostMarkup(), node.nextSibling);
		}
	},
	removeGhost: function(){
		// removes ghost from page
		var ghost = dojo.byId(this.ghostClass);
		if(ghost){
			var parent = ghost.parentNode;
			parent.removeChild(ghost);
		}
	},
	onOverEvent: function(){
		// create ghost in empty container
		this.inherited(arguments);
		this.active = true;
		if(this.isDragging && dojo.dnd.manager().target){
			if(dojo.query("."+this.ghostClass).length > 0 ){
				this.updateClearDiv();
			}
		}
	},

	destroy: function(){
		this.inherited(arguments);
		this.clearDiv = null;
		this.inherited(arguments);
	},
	
	_widgetMoved: function(iEvent){
		this.inherited(arguments);
		var widgetId = iEvent;
		var nodes = dojo.query(".id-"+widgetId ,this.node);
		if (nodes.length >= 1) {
			var last = this.node.lastChild;
			if(dojo.hasClass(last, "ibmClearRow")){
				//do nothing
			}else{
				this.updateClearDiv();
			}
		}
	}
});

com.ibm.pb.dnd.layout.LayoutMashupCustomRowSource.creator = 
	dojo.hitch(com.ibm.pb.dnd.layout.LayoutMashupCustomRowSource, 
		com.ibm.pb.dnd.layout.LayoutRowSource.creator);

com.ibm.pb.dnd.layout.LayoutMashupCustomRowSource.withHandles = true;

}

if(!dojo._hasResource["com.ibm.pb.dnd.layout.ShelfSource"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.dnd.layout.ShelfSource"] = true;
dojo.provide("com.ibm.pb.dnd.layout.ShelfSource");



dojo.declare("com.ibm.pb.dnd.layout.ShelfSource", [com.ibm.pb.dnd.layout.LayoutSource], {
	_markTargetAnchor: function(before){	
		return false;
	},
	_unmarkTargetAnchor: function(){
		return false;
	}
});

com.ibm.pb.dnd.layout.ShelfSource.creator = function(item, hint){
	var node = dojo.create("div");
	if(hint=="avatar"){
		dojo.attr(node, {innerHTML: String(item), className: "ibmDndAvatar lotusPaletteWidget dojoDndItem dojoDndItemAnchor", role: "gridcell"});
		dojo.style(node, { width: dojo.byId(dojo.dnd.manager().source.current.id).offsetWidth+"px", opacity: 0.5 });	
	}
	return {node: node, data: item, type: [ibmCfg.controllers.dnd.SHELF_TYPE]};
};

}

if(!dojo._hasResource["com.ibm.pb.control.DNDController"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.control.DNDController"] = true;
dojo.provide("com.ibm.pb.control.DNDController");



dojo.declare("com.ibm.pb.control.DNDController", com.ibm.pb.logging.Loggable, {	
	
	DND_TYPE: "lm",
	SHELF_TYPE: "sm",
	CONTROL_CLASS: "component-control",
	CONTAINER_CLASS: "component-container",
	DND_HANDLE_CLASS: "component-control-draghandle",
	DND_ORIENTATION: {vertical: "vertical", horizontal: "horizontal", freeform: "freeform"},
	
	dndSources: {}, 		// all of the dnd sources created on the page
	isDndLoaded: false, 	// has the controller been initialized?
	ghostHeight: 0, 		// store ghost height to use cross-source
	ghostAddedHeight: false,// Boolean used to determine if height was added to control node, used on resized widgets
	currentNode: null, 		// current node being dragged
	
	layoutParser: com.ibm.pb.layout.LayoutParser,
	
	nm: null, //navigation model
	
	constructor: function(){
		var lgr = this.LOGGER, mname = "constructor";
		lgr.entering(mname, arguments);
		
		com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService")
			.subscribeEvent("com.ibm.mashups.builder.changePageMode", this, this.onPageModeChanged);
		this.sourceDefinitions = ibmCfg.themeConfig.dndSourceDefinitions;
		
		// get layout model
		this.nm = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel();
				
		lgr.exiting(mname, arguments);
	},
	init: function() {
		var lgr = this.LOGGER, mname = "init";
		lgr.entering(mname, arguments);			
		this.getContainers().forEach(
			function(container){									
				dojo.query("."+this.CONTROL_CLASS, container).forEach(
					function(control){	
						dojo.addClass(control, "dojoDndItem");
						dojo.attr(control, "dndType", this.DND_TYPE);
					}
				, this);		
				
				this.dndSources[container.id] = null;		
				var cls = null;
				var object = null;
				var orientation = null;

				dojo.forEach(this.sourceDefinitions, function(sourceDef){
					if(dojo.hasClass(container, sourceDef.id)){
						object = sourceDef.object;
						orientation = sourceDef.orientation;
						
						cls = dojo.getObject(object);
						if(!cls) {
							dojo["require"](object);
							cls = dojo.getObject(object);
							if(!cls) {
								console.error("%o not found", object);
								return;
							}
						}
					}
				}, this);

				if (cls) {
					this.dndSources[this.layoutParser.extractID(container)] = new cls(container, {
						horizontal: (this.DND_ORIENTATION.horizontal == orientation),
						creator: dojo.getObject(object+".creator"), 
						accept: [this.DND_TYPE, this.SHELF_TYPE],
						withHandles: dojo.getObject(object+".withHandles") ? true : false,
						singular: true,
						skipForm: true
					});
				}
			}
		, this);	
			
		this.isDndLoaded = true;	
		
		lgr.exiting(mname, arguments);
	},
	getContainers: function() {
		if(!this.containers) {
			this.containers = dojo.query("."+this.CONTAINER_CLASS);
		}
		return this.containers;
	},
	destroySources: function(){
		for(var name in this.dndSources){
			if(name) this.dndSources[name].destroy();
		}
		this.dndSources = {};
	},
	reset: function() {
		this.destroySources();
		this.isDndLoaded = false;
		delete this.containers;
	},
	onPageModeChanged: function(iEvent){
		var lgr = this.LOGGER, mname = "onPageModeChanged";
		lgr.entering(mname, arguments);
		if(iEvent == "edit") {
			if(!this.isDndLoaded){
				this.init();
			}else{
				for (var i in this.dndSources) {
                    if(!!this.dndSources[i]) this.dndSources[i].isSource = true;
                }
			}
		} else {
			if (this.isDndLoaded) {
				for (var i in this.dndSources) {
                    if(!!this.dndSources[i]) this.dndSources[i].isSource = false;
                }
			}
		}
		
		lgr.exiting(mname, arguments);
	}
});

(function(){
	var controller = null;
	com.ibm.pb.control.DNDController.getController = function() {
		if(!controller) {
			controller = new com.ibm.pb.control.DNDController();
		}
		return controller;
	};
})();

}

if(!dojo._hasResource["com.ibm.dnd.PageCreator"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.dnd.PageCreator"] = true;
dojo.provide("com.ibm.dnd.PageCreator");

dojo.declare("com.ibm.dnd.PageCreator",
	null,
	{		
		creator: function(item, hint){
		//summary: creates the node to be used during
	    //         construction of the avatar
			var node = document.createElement("div");
			if(hint=="avatar"){
				node.className = "ibmPortalDndPageAvatar";
				var title = document.createTextNode(item);
				node.appendChild(title);
			}
			return {node: node, data: item, type: ["cmNode"]};
		}
	});

com.ibm.dnd.PAGE_CREATOR = new com.ibm.dnd.PageCreator();

}

if(!dojo._hasResource["com.ibm.widgets.InlineShelf"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.widgets.InlineShelf"] = true;
 // This is a dropdown inline shelf

dojo.provide("com.ibm.widgets.InlineShelf");



dojo.declare("com.ibm.widgets.InlineShelf",
	[dijit._Widget, dijit._Templated],
	{
		content: null,				// HTML content to display in the shelf
		link: null,					// an id or DOM element to which the shelf's toggle function should be attached
		shelfClass: "",				// css classes to put on the shelf
		displayState: "closed",		// state of the shelf, ie "open", "closed"
		everOpened: false,			// true when the shelf has been opened before
		wipeOut: null,				// animation to slide the shelf out of view
		wipeIn: null,				// animation to slide the shelf into view
		wipeTime: 300,				// the time the shelf takes to slide in/out in milliseconds
		templateString: '<div dojoAttachPoint="focusNode" style="display: none;" class="${shelfClass}"></div>',
		
		startup: function(){
			// create the hide/show animations
			this.wipeOut = dojo.fx.wipeOut({node:this.domNode, duration:this.wipeTime});
			this.wipeIn = dojo.fx.wipeIn({node:this.domNode, duration:this.wipeTime});
			
			// add the content
			if(this.content) this.domNode.appendChild(this.content);
			this.onCreate();
		},
		
		connectButton: function(){
			// set the onclick handler for the toggle link
			if (dojo.isString(this.link)) this.link = dojo.byId(this.link);
			if(this.link && !this.buttonConnection) {
				this.buttonConnection = dojo.connect(this.link, "onclick", this, this.toggleDisplay);
				dojo.removeClass(this.link,"lotusBtnDisabled");
			}
		},
		
		disconnectButton: function(){
			// set the onclick handler for the toggle link
			if(this.displayState == "open") this.toggleDisplay();
			if(this.buttonConnection) {
				dojo.disconnect(this.buttonConnection);
				this.buttonConnection = null;
			}
			if(this.link) dojo.addClass(this.link, "lotusBtnDisabled");
		},
		
		toggleDisplay: function(){
			// summary: changes the state of the display
			if(this.displayState == "open") {
				this.displayState = "closed";
				this.onClose();
				if(dojo.isIE) dojo.style(this.domNode,"display","none");
				else this.wipeOut.play();
			} else if (this.displayState == "closed"){
				this.displayState = "open";
				this.onOpen();
				if(!this.everOpened) { this.startup(); }
				if(dojo.isIE) dojo.style(this.domNode,"display","");
				else this.wipeIn.play();
				if(!this.everOpened) { this.onFirstOpen(); this.everOpened = true; }
			}
		},
		
		onCreate: function(){
			// summary: stub event for when the shelf is instantiated
		},
		
		onOpen: function(){
			// summary: stub event for when the shelf is displayed
		},
		
		onFirstOpen: function(){
			// summary: stub event for when the shelf is opened for the first time
		},
		
		onClose: function(){
			// summary: stub event for when the shelf is hidden
		}
});

}

if(!dojo._hasResource["com.ibm.data.CatalogFeedStore"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.data.CatalogFeedStore"] = true;
//C:\Documents and Settings\Administrator\workspace\enabler\lwp\enabler\eclipse\plugins\com.ibm.mm.enabler\resources\js\com\ibm\mm\enabler\model\catalog.js
//for category entry API line 923
dojo.provide("com.ibm.data.CatalogFeedStore");

dojo.declare("com.ibm.data.CatalogFeedStore", 
		[com.ibm.data.CatalogMixin],
		{
			searchable: false,
			items: [],
			attributes: ["id","label","description","thumbnail","definition"],
			features: {'dojo.data.api.Read': true},
			label: "",
			category: "",
			pageSize: 30,
			//defaultCatalog: "default",
			valid: true,
		       
			constructor: function(args) {
				this.items = [];
				this.category = args.category;
				var catalogModel = com.ibm.mashups.enabler.model.Factory.getCatalogCategoryModel();
				catalogModel.setStrategy(new com.ibm.mashups.enabler.strategy.ListLoadAheadStrategy(this.pageSize));
				/*var catalogStr = args.catalog || this.defaultCatalog;
				var categoryStr = ibmPortalConfig ? this.category : this.category + "_c_" + catalogStr;
				var category = catalogModel.find(categoryStr).start();*/
				var category = catalogModel.find(this.category).start();
				if(!category){
					this.valid = false;
					return;
				}
				var locale = com.ibm.mashups.enabler.context.Factory.getLocalizedContext().getLocale() || "en"; // RETURNS NULL
				this.label = category.getTitle(locale);
				var entryIter = catalogModel.getCatalogEntryModel(category).iterator();
				while (entryIter.hasNext()){
					var entry = entryIter.next();
					this.items.push({
						"id":entry.getID(),
						"label":entry.getTitle(locale),
						"description":entry.getDescription(locale),
						"thumbnail":entry.getIconURL(),
						"url":entry.getDefinitionURL()
					});
				}
			},
			
			getValue: function(/* item */ item, /* attribute-name-string */ attribute, /* value? */ defaultValue){
				return item[attribute] || defaultValue;
			},
			
			getValues: function(/* item */ item, /* attribute-name-string */ attribute){
				var value = this.getValue(item,attribute,null);
				return value ? [value] : [];
			},
			
			getAttributes: function(/* item */ item){
				return this.isItem(item) ? this.attributes : [];
			},
			
			hasAttribute: function(/* item */ item, /* attribute-name-string */ attribute){
				return item[attribute] ? true : false;
			},
			
			containsValue: function(/* item */ item, /* attribute-name-string */ attribute, /* anything */ value){
				var values = this.getValues(item,attribute);
				for(var i in values){
					if(values[i] == value) return true
				}
				return false;
			},
			
			isItem: function(/* anything */ something){
				for(var i in this.items){
					if(this.items[i].id == something.id) return true;
				}
				return false;
			},
			
			isItemLoaded: function(/* anything */ something){
				return this.isItem(something);
			},
			
			loadItem: function(/* object */ keywordArgs){
				// do nothing because all items are already loaded
			},
			
			fetch: function(/* Object */ keywordArgs){
				try {
					var scope = keywordArgs.scope || dojo.global,
						items = [],
						count = keywordArgs.count,
						start = keywordArgs.start;
					if(!start) start = 0;
					if(keywordArgs.onBegin) keywordArgs.onBegin.call(scope,this.items.length,keywordArgs);
					if(start < this.items.length){
						if(count && count + start <= this.items.length){
							items = this.items.slice(start,count);
						} else {
							items = this.items.slice(start);
						}
					}
					if(keywordArgs.onItem){
						dojo.forEach(items,function(item){keywordArgs.onItem.call(scope,item,keywordArgs)});
					}
					var itemsLeft = keywordArgs.onItem ? null : items;
					if(keywordArgs.onComplete) keywordArgs.onComplete.call(scope,itemsLeft,keywordArgs);
					return dojo.mixin(keywordArgs,{abort:function(){}});
				} catch (e) {
					if(keywordArgs.onError) keywordArgs.onError.call(scope,e,keywordArgs);
				}
			},
			
			getFeatures: function(){
				return this.features;
			},
			
			close: function(/*dojo.data.api.Request || keywordArgs || null */ request){
				// nothing to do here
			},
			
			getLabel: function(/* item */ item){
				if(this.isItem(item)) return item["label"];
				else return null;
			},
			
			getLabelAttributes: function(/* item */ item){
				return ["label"];
			},
			
			getSourceLabel: function(){
				return this.label;
			},
			
			validateSelf: function(){
				// summary: validates this datastore, if it does not validate the source will not be used
				// returns true for validation and false otherwise
				return this.valid;
			}
});

}

if(!dojo._hasResource["com.ibm.portal.xpath"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.portal.xpath"] = true;
dojo.provide( "com.ibm.portal.xpath" );

// generic impl

com.ibm.portal.xpath.evaluateXPath = function(/*String*/xpathExpr, /*DOMDocument*/ doc, /*Object{prefix:ns,prefix2:ns2,...}*/namespaces) {
    if (typeof ActiveXObject != "undefined") {
        return com.ibm.portal.xpath.ie.evaluateXPath(xpathExpr, doc, namespaces);
    }
    else {
        return com.ibm.portal.xpath.gecko.evaluateXPath(xpathExpr, doc, namespaces);
    }
}

// IE Implementation

dojo.provide( "com.ibm.portal.xpath.ie" );

com.ibm.portal.xpath.ie.evaluateXPath = function(/*String*/xpathExpr, /*DOMDocument*/ doc, /*Object{prefix:ns,prefix2:ns2,...}*/namespaces) {
        if (namespaces) {        
            var ns = "";
            for (var prop in namespaces) {
                ns += "xmlns:"+prop+"='"+namespaces[prop]+"' ";
            }
            if (doc.ownerDocument) {
                doc.ownerDocument.setProperty("SelectionNamespaces", ns);
            } else {
                doc.setProperty("SelectionNamespaces", ns);
            }
        }
        var result = doc.selectNodes(xpathExpr);

        var thisResult;
        var resultSet = [];
        var len = 0;
        for (var i=0; i<result.length; i++) {
            thisResult = result[i];
            if (thisResult) {
                resultSet[len] = thisResult;
                len++;
            }
        }
        return resultSet;
}


// GECKO Implementation

dojo.provide( "com.ibm.portal.xpath.gecko" );

com.ibm.portal.xpath.gecko.evaluateXPath = function(/*String*/xpathExpr, /*DOMDocument*/ doc, /*Object{prefix:ns,prefix2:ns2,...}*/namespaces) {
        var result;
        try {
        	var rootDoc = doc;
        	if(!rootDoc.evaluate) rootDoc = doc.ownerDocument;
            result = rootDoc.evaluate( xpathExpr, doc, function(prefix) { return namespaces[prefix] || null;}, XPathResult.ANY_TYPE, null );
        } 
        catch (exc)
        {
            //Callers should catch this and can substitute their own error message
            throw new Error("Error with xpath expression" + exc);
        }
    
        //alert(result.resultType);
        var thisResult;
        var resultSet = [];
        var len = 0;
        do {
            thisResult = result.iterateNext();
            if (thisResult) {
                resultSet[len] = thisResult;
                len++;
            }
        } while ( thisResult );
        return resultSet;
}


}

if(!dojo._hasResource["com.ibm.data.XpathHelper"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.data.XpathHelper"] = true;
dojo.provide( "com.ibm.data.XpathHelper" );
// summary: This module is meant to be extended by modules that want to use XPath
//		to query DOM documents for information.  It provides read support and limited 
// 		write support.  Write support is limited in that if an xpath query is used to
//		set a node, property of a node, or DOM attribute of a node, then the write support
//		will only work if a node that matches that query already exists and is returned.
//		If no node matches the query and the Xpath query returns null, the all write operations
//		provided by this module will return false to indicate that the caller needs to handle
//		them in a different way like creating the node from scratch.
//
//		This module provides cross-browser methods for reading and writing to DOM nodes,
//		properties of DOM nodes, and DOM attributes of DOM nodes.  It also supports extensions
//		so that special constructs can be returned by a query instead of a DOM node or String value
//		of a property or attribute.  By default, no constructs are defined by this module.


dojo.require( "com.ibm.portal.xpath" );
dojo.require( "com.ibm.portal.xslt" );
dojo.require( "com.ibm.domUtilities" );

dojo.declare( "com.ibm.data.XpathHelper",
			null,
			{
				// namespaces: A map of prefix - namespace URI pairs used to specify what namespaces
				//		are used by this XpathHelper to query nodes in a DOM document
				namespaces: {},
				
				_getNodesByXpath: function(/*Object*/ context, /*String*/expr, /*String?*/prop) {
					// summary: Gets an array of DOM nodes or String node properties using the XPath expr relative 
					// 		to the context (not relative to the document root itself).  Returns an object allowing
					//		the caller to determine if the actual value requested is null or if there were no nodes
					//		found at all.
					// context: The XML element to use as the root context for the XPath query
					// expr: XPath expression used to find the nodes
					// prop: Optional prop to specify to get a property of the nodes instead of the nodes themselves.
					// returns: Object with two properties:
					//		-	{
					//		-		found: Boolean indicating if any nodes were found matching the XPath expression
					//		-		value: Array the actual nodes found by the expression, or the properties of the nodes
					// 		-			found by the expression as specified by the prop argument
					// 		-	} 
					var results = com.ibm.portal.xpath.evaluateXPath(expr, context, this.namespaces);
					var found = results && results.length > 0;
					if(prop) {
						var nodes = results;
						results = [];
						for(var i = 0; i < nodes.length; i++) {
							results[i] = this._getNodeProp(nodes[i], prop);
						}
					}
					return {found: found, value: results};
				},
				_getNodeByXpath: function(/*Object*/ context, /*String*/expr, /*String?*/ prop) {
					// summary: Gets a node using the XPath expr relative to 
					// 		the context	(not relative to the document root itself).  Returns an object allowing
					//		the caller to determine if the actual value requested is null or if there were no nodes
					//		found at all.
					// context: The XML element to use as the root context for the XPath query
					// expr: XPath expression used to find the node
					// prop: Optional prop to specify to get an property of the node instead of the node itself.
					// returns: Object with two properties:
					//		-	{
					//		-		found: Boolean indicating if any nodes were found matching the XPath expression
					//		-		value: DOMNode|Object the first node found by the expression, or the property of the first
					// 		-			node found by the expression as specified by the prop argument
					// 		-	}
					var result = this._getNodesByXpath(context, expr);
					var found = result.found;
					if(!found) return {found: found};
					var nodes = result.value;
					if(nodes.length > 0) {
						if(prop) return {found: true, value: this._getNodeProp(nodes[0], prop)};
						else return {found: true, value: nodes[0]};
					}
					return {found: false};
				},
				_getNodeProp: function(/*DOMNode*/ node, /*String*/ prop) {
					// summary:  Function to provide cross-browser support for properties of a queried
					//		node.  If the prop string is not special, control will be passed to the 
					//		handleConstructs function for this object.
					//		Currently only supports textContent as a special property since not
					//		all browsers implement the textContent property of DOM nodes.
					switch(prop) {
						case "textContent":
							return dojox.data.dom.textContent(node);
						default:
							return this.handleConstructs(node, prop);
					}
				},
				handleConstructs: function(/*DOMNode*/ node, /*String*/ prop) {
					// summary: Allows a data store to return complex javascript objects
					//		or alternative values when a specific non-standard property of a node 
					// 		is requested.  Example: An Atom Feed data store may create a special 
					// 		Person Construct when querying an <atom:author> element.  This construct
					//		may provide accessor functions to the name, email, and URI of the author.
					//		See http://tools.ietf.org/html/rfc4287#section-3.2
					//		Constructs that are created here should implement and handle write functionality
					//		themselves as this module will not handle writes to constructs natively.
					
					return node[prop];
				},
				_setNodeProp: function(/*DOMNode*/ node, /*String*/ prop, /*Object*/ value) {
					// summary: Allows a data store to set properties of a node in a cross-browser
					//		way for properties that may be non-standard.
					//		Currently only supports textContent as a special property since not
					//		all browsers implement the textContent property of DOM nodes.
					//		Note that for special constructs that are created using the handleConstructs
					// 		function, write support is handled by the returned construct object not by
					//		this module's functions.
					switch(prop) {
						case "textContent":
							dojox.data.dom.textContent(node, value);
							break;
						default:
							node[prop] = value;
					}
				},
				_getAttrsByXpath: function(/*Object*/ context, /*String*/ expr, /*String*/attrName) {
					// summary: Gets an array of attribute values for the nodes returned 
					// 		using the XPath expr relative to the context (not relative to the 
					// 		document root itself).  The attributes are retrieved using the 
					// 		getAttributeNS/getAttribute	functions of the nodes.  Returns an object allowing
					//		the caller to determine if the actual value requested is null or if there were no nodes
					//		found at all.
					// context: The XML element to use as the root context for the XPath query
					// expr: XPath expression used to find the nodes
					// attrName: The name of the attribute to get from each node returned by the XPath expr.
					//		If the attribute is namespaced, it will be split into its parts using the : delimiter
					//		and the namespace used during lookup will be the one keyed in this item or store's 
					// 		namespace map.
					// returns: Object with two properties:
					//		-	{
					//		-		found: Boolean indicating if any nodes were found matching the XPath expression
					//		-		value: Array the attribute values of the nodes found by the expression
					// 		-	}
					var result = this._getNodesByXpath(context, expr);
					var found = result.found;
					if(!found) return {found: found};
					var nodes = result.value;
					var attrs = [];
					for(var i = 0; i < nodes.length; i++) {
						attrs[i] = this._getAttribute(nodes[i], attrName);
					}
                    return {found: found, value: attrs};
				},
				_getAttrByXpath: function(/*Object*/ context, /*String*/expr, /*String*/ attrName) {
					// summary: Gets the attribute value of the first node returned 
					// 		using the XPath expr relative to the context (not relative to the 
					// 		document root itself).  The attribute is retrieved using the 
					// 		getAttributeNS/getAttribute	functions of the node.  Returns an object allowing
					//		the caller to determine if the actual value requested is null or if there were no nodes
					//		found at all.
					// context: The XML element to use as the root context for the XPath query
					// expr: XPath expression used to find the node
					// attrName: The name of the attribute to get from the node returned by the XPath expr.
					//		If the attribute is namespaced, it will be split into its parts using the : delimiter
					//		and the namespace used during lookup will be the one keyed in this item or store's 
					// 		namespace map.
					// returns: Object with two properties:
					//		-	{
					//		-		found: Boolean indicating if any nodes were found matching the XPath expression
					//		-		value: Array the attribute value of the first node found by the expression
					// 		-	}
					var result = this._getNodeByXpath(context, expr);
					var found = result.found;
					if(!found) return {found: found}; 
					var node = result.value;
                    return {found: found, value: this._getAttribute(node, attrName)};
				},
				_extractNSInfo: function(str) {
					// summary: Extracts the namespace URI, prefix, and local name of a QName according to this
					//		object's namespaces map that includes known prefixes and their namespace URIs.  If
					//		the string is not namespaced, then the namespaceURI and prefix are set to null, and
					//		the localName is set to the str as-is.
					// str: QName to extract namespace from
					// returns: Map - {namespaceURI: namespaceURI, prefix: prefix, localName: localName}
					return com.ibm.domUtilities.nsInfo(str, this.namespaces);
				},
				_getAttribute: function(/*DOMNode*/ node, /*String*/ attrName) {
					// summary: Gets an attribute of the given node, supporting namespaced and 
					// 		non-namespaced attributes.
					// node: Node to retrieve the attribute value from
					// attrName: The name of the attribute to get from the node.
					//		If the attribute is namespaced, it will be split into its parts using the : delimiter
					//		and the namespace used during lookup will be the one keyed in this item or store's 
					// 		namespace map.
					return com.ibm.domUtilities.getAttribute(node, attrName, this.namespaces);
				},
				_setAttribute: function(/*DOMNode*/ node, /*String*/ attrName, /*String*/ value) {
					// summary: Sets an attribute of the given node, supporting namespaced and 
					// 		non-namespaced attributes.
					// node: Node to set the attribute value on
					// attrName: The name of the attribute to set on the node.
					//		If the attribute is namespaced, it will be split into its parts using the : delimiter
					//		and the namespace used during lookup will be the one keyed in this item or store's 
					// 		namespace map.
					// value: The actual value to store in the node at the key attribute specified by attrName.
					if(value) com.ibm.domUtilities.setAttribute(node, attrName, value, this.namespaces);
					else com.ibm.domUtilities.removeAttribute(node, attrName, this.namespaces);
				},
				_setNodesByXpath: function(/*Object*/ context, /*String*/expr, /*String*/ prop, /*Array*/values) {
					// Empty for now since there's little use for this type of function, particularly due to 
					// mismatches between the number of values and number of returned nodes.
					//var nodes = this._getNodesByXpath(context, expr);
					
					return false;
				},
				_setNodeByXpath: function(/*Object*/ context, /*String*/expr, /*String*/ prop, /*Object*/value) {
					// summary: Will replace a node returned by the xpath expr query with the value object
					// 		if prop is null.  If prop exists, the specified property on the returned node
					// 		will be set to the value.
					// 		If no node is found that matches the xpath expr, this function returns false to indicate
					//		failure to the caller for further processing if necessary.
					// context: The DOM element to use as the root context for the XPath query
					// expr: XPath expression used to find the node
					// prop: Optional prop to specify to set a property of the node instead of the node itself.
					// returns: true if the set operation was successful, false otherwise
					var result = this._getNodeByXpath(context, expr);
					var found = result.found;
					if(!found) return false; 
					var node = result.value;
					if(prop) {
						this._setNodeProp(node, prop, value);
					}
					else {
						dojo.place(value, node, "before");
						node.parentNode.removeChild(node);
						delete node;
					}
					return true;
				},
				_setAttrsByXpath: function(/*Object*/ context, /*String*/expr, /*String*/ attrName, /*Array*/values) {
					// Empty for now since there's little use for this type of function, particularly due to 
					// mismatches between the number of values and number of returned nodes.
					//var nodes = this._getNodesByXpath(context, expr);
					
					return false;
				},
				_setAttrByXpath: function(/*Object*/ context, /*String*/expr, /*String*/ attrName, /*String*/value) {
					// summary: The specified DOM attribute on the returned node will be set to the value.
					// 		If no node is found that matches the xpath expr, this function returns false to indicate
					//		failure to the caller for further processing if necessary.
					// context: The DOM element to use as the root context for the XPath query
					// expr: XPath expression used to find the node
					// attrName: The name of the attribute to get from the node returned by the XPath expr.
					//		If the attribute is namespaced, it will be split into its parts using the : delimiter
					//		and the namespace used during lookup will be the one keyed in this item or store's 
					// 		namespace map.
					// returns: true if the set operation was successful, false otherwise
					var result = this._getNodeByXpath(context, expr);
					var found = result.found;
					if(!found) return false;
					var node = result.value;
					this._setAttribute(node, attrName, value);
					return true;
				},
				_createNSElement: function(doc, tagName, attrMap) {
					// summary: Cross-browser implementation for creating a namespaced node using the namespace
					//		map in this object to resolve prefixes to namespace URIs.
					//		If the tagName is not namespaced or a namespace URI cannot be resolved
					// 		using this object's namespaces map, a non-namespaced element will be created instead.
					// doc: DOMDoc document object to use to create the DOM node.
					// tagName: String name for the tag name of the element to create.  
					// 		Can be namespaced like prefix:localName or not like localName.
					// attrMap: Optional argument specifying a key-value map of attributes to be
					// 		set on the node before returning it. 
					// returns: DOMNode A new DOM node that was created by doc
					return com.ibm.domUtilities.createElement(doc, tagName, this.namespaces, attrMap);
				},
				__getClassName: function() {
					var cls = this.declaredClass;
					if(!cls) return "Object";
					var idx = cls.lastIndexOf(".");
					if(idx > -1 && (idx < cls.length - 1)) cls = cls.substring(idx + 1);
					return cls;
				}
			}
);

dojo.declare( "com.ibm.data._XmlConstruct",
			com.ibm.data.XpathHelper,
			{
				// summary: Provides a base construct for modules to extend when building constructs
				//		to be returned by queries using this module's APIs.
				isConstruct: true,
				toString: function() {
					// summary: Default toString method for this object so that it can be inserted
					//		in a string and be properly represented.  Overridable by extensions of this
					//		module.
					return "<"   + this.__getClassName() + ">";
				}
			}
);


}

if(!dojo._hasResource["com.ibm.data.AtomFeedStore"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.data.AtomFeedStore"] = true;
dojo.provide( "com.ibm.data.AtomFeedStore" );

dojo.require( "com.ibm.data.XpathHelper" );
dojo.require( "dojo.date.stamp" );

dojo.declare( "com.ibm.data.AtomFeedStore",
			com.ibm.data.XpathHelper,
			{
				// namespaces: Map
				//		Map of namespaces used by the ATOM feeds
				namespaces: {
		            "atom" : "http://www.w3.org/2005/Atom"
		        },
		        // _features: Map
				//		Map of features that this store supports.
				//		This generic AtomFeedStore only supports Read and Identity.
				_features: {
					'dojo.data.api.Read': true,
					'dojo.data.api.Write': false,
					'dojo.data.api.Identity': false,
					'dojo.data.api.Notification': false
				},
				attrMappings: {
					title: {xpath: "./atom:title", targetName: "textContent", type: "node", setter: 
						function(item, rule, value){
							var elem = this._createNSElement(item.element.ownerDocument, "atom:title");
							this._setNodeProp(elem, rule.targetName, value);
							item.element.appendChild(elem);
							return true;
						}
					},
					id: {xpath: "./atom:id", targetName: "textContent", type: "node", setter: 
						function(item, rule, value){
							var elem = this._createNSElement(item.element.ownerDocument, "atom:id");
							this._setNodeProp(elem, rule.targetName, value);
							item.element.appendChild(elem);
							return true;
						}
					},
					updated: {xpath: "./atom:updated", targetName: "AtomDateConstruct", type: "node"},
					category: {xpath: "./atom:category", targetName: "term", type: "attr", setter: 
						function(item, rule, value){
							var elem = this._createNSElement(item.element.ownerDocument, "atom:category");
							this._setAttribute(elem, rule.targetName, value);
							item.element.appendChild(elem);
							return true;
						}
					},
					categoryScheme: {xpath: "./atom:category", targetName: "scheme", type: "attr", setter: 
						function(item, rule, value){
							var elem = this._createNSElement(item.element.ownerDocument, "atom:category");
							this._setAttribute(elem, rule.targetName, value);
							item.element.appendChild(elem);
							return true;
						}
					},
					categoryLabel: {xpath: "./atom:category", targetName: "label", type: "attr", setter: 
						function(item, rule, value){
							var elem = this._createNSElement(item.element.ownerDocument, "atom:category");
							this._setAttribute(elem, rule.targetName, value);
							item.element.appendChild(elem);
							return true;
						}
					},
					contributer: {xpath: "./atom:contributer", targetName: "AtomPersonConstruct", type: "node"},
					author: {xpath: "./atom:author", targetName: "AtomPersonConstruct", type: "node"},
					summary: {xpath: "./atom:summary", targetName: "textContent", type: "node", setter: 
						function(item, rule, value){
							var elem = this._createNSElement(item.element.ownerDocument, "atom:summary");
							this._setNodeProp(elem, rule.targetName, value);
							item.element.appendChild(elem);
							return true;
						}
					},
					source: {xpath: "./atom:source", type: "node", setter: 
						function(item, rule, value){
							item.element.appendChild(value);
							return true;
						}
					},
					rights: {xpath: "./atom:rights", targetName: "textContent", type: "node", setter: 
						function(item, rule, value){
							var elem = this._createNSElement(item.element.ownerDocument, "atom:rights");
							this._setNodeProp(elem, rule.targetName, value);
							item.element.appendChild(elem);
							return true;
						}
					},
					selfLink: {xpath: "./atom:link[@rel='self']", targetName: "href", type: "attr", setter: 
						function(item, rule, value){
							var elem = this._createNSElement(item.element.ownerDocument, "atom:link");
							this._setAttribute(elem, "rel", "self");
							this._setAttribute(elem, rule.targetName, value);
							item.element.appendChild(elem);
							return true;
						}
					},
					link: {xpath: "./atom:link[@href]", targetName: "href", type: "attr", setter: 
						function(item, rule, value){
							var elem = this._createNSElement(item.element.ownerDocument, "atom:link");
							this._setAttribute(elem, rule.targetName, value);
							item.element.appendChild(elem);
							return true;
						}
					},
					content: {xpath: "./atom:content", type: "node", setter: 
						function(item, rule, value){
							item.element.appendChild(value);
							return true;
						}
					}
				},
				
				// timeout: Number milliseconds to wait for a response for any request
				//		sent by this data store.
				timeout: null,
				
				// itemClass: String the class used to represent items of this store
				itemClass: "com.ibm.data.AtomEntryItem",
								
				constructor: function( /*Map*/ args ) {
					// summary: Creates a new instance of a com.ibm.data.AtomFeedStore
					// args: Map
					//		The args map will be used to replace any default values of this store with the
					//		values specified in the args map.
					dojo.mixin(this, args);
					this._dirtyItems = [];
					this._deletedItems = [];
					this._newItems = [];
				},
				toString: function() {
					return "<" + this.__getClassName() + ": " + this.url + ">";
				},
				handleConstructs: function(/*DOMNode*/ node, /*String*/ prop) {
					switch(prop) {
						case "AtomPersonConstruct": return new com.ibm.data.AtomPersonConstruct(node);
						case "AtomDateConstruct": return new com.ibm.data.AtomDateConstruct(node);
						default: return this.inherited(arguments);
					}
				},
				
				_assertIsItem: function(/*Object*/ something) {
					// summary: Throws an exception if the argument is not a valid item in this store.
					// something: Object to check to determine if it is an item in this store.
					if (!this.isItem(something)) {
						throw new Error(something + " is not an item in this store");
					}
					return true;
				},
				_assertIsString: function(/*Object*/ something) {
					// summary: Throws an exception if the argument is not a string.
					// something: Object to check to determine if it is a string.
					if (!dojo.isString(something)) {
						throw new Error(something + " is not a string");
					}
					return true;
				},
				_getItem: function(args) {
					// summary: Overridable function to create a new item in this store based on the args map.
					var cls = this.itemClass;
					if(dojo.isString(cls)) {
						cls = dojo.getObject(this.itemClass);
					}
					return new cls({store: this, element: args.element, loaded: true}); 
				},
				/********************************/
				/**                            **/
				/**                            **/
				/**    		 Public  		   **/
				/**                            **/
				/**                            **/
				/********************************/
								
				getFeedValue: function( /*String*/ attribute, /*Value?*/ defaultValue) {
					var ret = defaultValue;
					this._assertIsString(attribute);
					var mapRule = this.getMapRule(attribute, this.attrMappings);
					// if mapRule is null here, then we couldn't find one in the map, 
					// so we can't proceed successfully
					if(mapRule) {
						ret = this.getValueByMapping(null, mapRule, defaultValue);
					}
					
					return ret;
				},
				getFeedValues: function( /*String*/ attribute) {
					var ret = [];
					this._assertIsString(attribute);
					var mapRule = this.getMapRule(attribute, this.attrMappings);
					// if mapRule is null here, then we couldn't find one in the map, 
					// so we can't proceed successfully
					if(mapRule) {
						ret = this.getValuesByMapping(null, mapRule);
					}
					
					return ret;
				},
				extractEmptyFeed: function() {
					var toClone = this._getNodeByXpath(this._feed, "//atom:feed").value;
					var feedDOM = toClone.cloneNode(false);
					// get all non-entry nodes
					var result = this._getNodesByXpath(toClone, "/atom:feed/*");
					var nodes = result.value;
					for(var i = 0; i < nodes.length; i++) {
						if(nodes[i].nodeName != "atom:entry") {
							feedDOM.appendChild(nodes[i].cloneNode(true));
						}
					}
					return feedDOM;
				},
				extractSingleEntryFeed: function(/* com.ibm.data.AtomEntryItem */ item ) {
					var ret = this.extractEmptyFeed();
					ret.appendChild(item.element.cloneNode(true));
					return ret;
				},
				extractMultipleEntryFeed: function(/* Array */ items ) {
					var ret = this.extractEmptyFeed();
					dojo.forEach(items, function(item){
						ret.appendChild(item.element.cloneNode(true));
					});
					return ret;
				},
				
				getEPResolvedValue: function(	/* com.ibm.data.AtomEntryItem */ item, 
						/* String */ attribute, 
						/* Value? */ defaultValue){
					var ret = null;
					if(this.hasAttribute(item, attribute)) {
						var mapRule = this.getMapRule(attribute, item.attrMappings);
						// if mapRule is null here, then we couldn't find one in the map, 
						// so we return the defaultValue 
						if (!mapRule) {
							return ret;
						}
						ret = this.getValueByMapping(item, mapRule, defaultValue);
					}
					if (!ret) {
						ret = defaultValue;
					}
					ret = com.ibm.mashups.enabler.utils.EndpointHelper.resolve(ret);
					return ret;
				},
								
				/********************************/
				/**                            **/
				/**                            **/
				/**   dojo.data.api.Identity   **/
				/**                            **/
				/**                            **/
				/********************************/				
				getIdentity: function(/* item */ item) {
					// summary: See dojo.data.api.Identity.getIdentity()
					// returns: The entry's unique identifier
					if (item._id) {
						return item._id;
					}
					// this is a common operation... so cache this on the item itself
					var attrs = this.getIdentityAttributes(item);
					var id = "";
					dojo.forEach(attrs, function(attr){
						id += this.getEPResolvedValue(item, attr, "");
					}, this);
					item._id = id;
					return id;
				},
				
				getIdentityAttributes: function(/* item */ item){
					//	summary:
					//		Returns an array of attribute names that are used to generate the identity. 
					//		For most stores, this is a single attribute, but for some complex stores
					//		such as RDB backed stores that use compound (multi-attribute) identifiers
					//		it can be more than one.  If the identity is not composed of attributes
					//		on the item, it will return null.  This function is intended to identify
					//		the attributes that comprise the identity so that so that during a render
					//		of all attributes, the UI can hide the the identity information if it 
					//		chooses.
					//	item:
					//		The item from the store from which to obtain the array of public attributes that 
					//		compose the identifier, if any.
					return ['id']; // Array
				},
			
				fetchItemByIdentity: function(/* object */ keywordArgs){
					//	summary:
					//		Given the identity of an item, this method returns the item that has 
					//		that identity through the onItem callback.  Conforming implementations 
					//		should return null if there is no item with the given identity.  
					//		Implementations of fetchItemByIdentity() may sometimes return an item 
					//		from a local cache and may sometimes fetch an item from a remote server, 
					//
					// 	keywordArgs:
					//		An anonymous object that defines the item to locate and callbacks to invoke when the 
					//		item has been located and load has completed.  The format of the object is as follows:
					//		{
					//			identity: string|object,
					//			onItem: Function,
					//			onError: Function,
					//			scope: object
					//		}
					//	The *identity* parameter.
					//		The identity parameter is the identity of the item you wish to locate and load
					//		This attribute is required.  It should be a string or an object that toString() 
					//		can be called on.
					//		
					//	The *onItem* parameter.
					//		Function(item)
					//		The onItem parameter is the callback to invoke when the item has been loaded.  It takes only one
					//		parameter, the item located, or null if none found.
					//
					//	The *onError* parameter.
					//		Function(error)
					//		The onError parameter is the callback to invoke when the item load encountered an error.  It takes only one
					//		parameter, the error object
					//
					//	The *scope* parameter.
					//		If a scope object is provided, all of the callback functions (onItem, 
					//		onError, etc) will be invoked in the context of the scope object.
					//		In the body of the callback function, the value of the "this"
					//		keyword will be the scope object.   If no scope object is provided,
					//		the callback functions will be called in the context of dojo.global.
					//		For example, onItem.call(scope, item, request) vs. 
					//		onItem.call(dojo.global, item, request)
					
					
					// not implemented by the AtomFeedStore since this supports generic Atom Feeds and therefore
					// can't generate a URL to get a particular item by its identity without additional knowledge
					// of how the feed URLs are created... however, this can be overridden by a application consuming
					// an instance of this store that does have knowledge of the particular feed URLs
					return false;
				},
				/********************************/
				/**                            **/
				/**                            **/
				/**     dojo.data.api.Read     **/
				/**                            **/
				/**                            **/
				/********************************/
				getValue: function(	/* com.ibm.data.AtomEntryItem */ item, 
						/* String */ attribute, 
						/* Value? */ defaultValue){
					var ret = null;
					if(this.hasAttribute(item, attribute)) {
						var mapRule = this.getMapRule(attribute, item.attrMappings);
						// if mapRule is null here, then we couldn't find one in the map, 
						// so we return the defaultValue 
						if (!mapRule) {
							return ret;
						}
						ret = this.getValueByMapping(item, mapRule, defaultValue);
					}
					if (!ret) {
						ret = defaultValue;
					}
					
					return ret;
				},
				
				getValues: function(/* com.ibm.data.AtomEntryItem */ item,
						/* String */ attribute){
					if(this.hasAttribute(item, attribute)) {
						var mapRule = this.getMapRule(attribute, item.attrMappings);
						// if mapRule is null here, then we couldn't find one in the map, 
						// so we return an empty list
						if (!mapRule) {
							return [];
						}
						return this.getValuesByMapping(item, mapRule);
					}
					return [];
				},
				_extractParameterizedMapKey: function( /*String*/ mapKey ) {
					// summary: Expands a mapKey and determines if it is a key to a parameterizable map rule.
					//		If it is, extract the parameters from the argument and return the base key name
					//		used to look up the correct map rule in this object's attrMappings without the parameter
					// 		values, and also return the parameters as an array of strings.  
					// 		If the mapKey is not the key of a parameterizable map rule, just return the key and a 
					// 		null parameter array.
					// returns: Object {key: stringMapKey, parameters: arrayOfParameterValues}
					if(mapKey.charAt(mapKey.length - 1) == '$') {
						var start = mapKey.indexOf('[');
						var end = mapKey.lastIndexOf(']');
						if(start > -1 && end > start) {
							var baseName = mapKey.substring(0, start) + "$";
							var parms = mapKey.substring(start + 1, end).split(',');
							return {key: baseName, parameters: parms};
						}
					}
					return {key: mapKey, parameters: null};
				},
				
				getMapRule: function( /*String*/ mapKey, /*Object*/map, /*Boolean?*/ multiValued ) {
					// summary: Takes a mapKey string that ends in '$' to key into this object's 
					// 		attrMappings, and then parameterizes the map it finds according
					// 		to the parameters found within the '[...]' block of the mapKey.
					// 		Example: A mapKey of 'localizedName[edward, tj]$' would lookup
					// 			the key 'localizedName$' in this.attrMappings.
					// 			The resulting map rule would be used as a template for the returned
					//			map rule.  The parameters used to parameterize the template would
					//			be ['edward', 'tj'] and would match the ${0} and ${1} parameters
					//			in the map rule respectively.
					// returns: The map rule specified by this mapKey after all parameters have been
					//			bound to their values as specified by the caller.
					var obj = this._extractParameterizedMapKey(mapKey);
					var rule = map[obj.key];
					
					if (!rule) {
						return rule;
					}
					// if this is not a parameterized map rule, just return the map rule as-is
					if(!obj.parameters) {
						rule._ruleKey = obj.key;
						return rule;
					}
					
					// otherwise, parameterize the map by using the array of parameters passed into the attribute
					// like this ->  attribute[parm1, parm2, parm3]$
					// parameterized attributes always end with $
					var expRule = {};
					for(var prop in rule) {
						if(dojo.isString(rule[prop])) {
							expRule[prop] = dojo.string.substitute(rule[prop], obj.parameters, function(part){
								return dojo.string.trim(part);
							});
						}
						else {
							expRule[prop] = rule[prop];
						}
					}
					expRule._parameters = obj.parameters;
					expRule._ruleKey = obj.key;
					expRule.multiValued = !!multiValued;
					return expRule;
				},
				
				getValuesByMapping: function( /* com.ibm.data.AtomEntryItem */ item, 
						/* Object */ mapping){
					// summary: Executes the correct query API using the mapping argument to
					//		retrieve the desired attribute value for the item as specified by the 
					// 		mapping.
					// mapping: A mapping object from this object's attrMappings
					var ret = null;
					var xpath = mapping.xpath;
					var type = mapping.type;
					var targetName = mapping.targetName;
					var context = this._feed;
					if(item) {
						this._assertIsItem(item);
						context = item.element;
					}
					if(type == "attr") {
						ret = this._getAttrsByXpath(context, xpath, targetName);
					}
					else {
						ret = this._getNodesByXpath(context, xpath, targetName);
					}
					
					if(!ret.found && item._backup) {
						// we didn't find any nodes matching the xpath query, and
						// this item has been copied from its original for modification,
						// so perhaps we explicitly removed it in the modified version for
						// performance reasons... so lets look it up in the original unmodified version						
						context = item._backup;
						if(type == "attr") {
							ret = this._getAttrsByXpath(context, xpath, targetName);
						}
						else {
							ret = this._getNodesByXpath(context, xpath, targetName);
						}
						
						// if ret.found is still false, then just return the defaultValue
						if (!ret.found) {
							ret.value = [];
						}
					}
					
					return ret.value;
				},
				
				getValueByMapping: function( /* com.ibm.data.AtomEntryItem */ item, 
						/* Object */ mapping, 
						/* Value? */ defaultValue){
					// summary: Executes the correct query API using the mapping argument to
					//		retrieve the desired attribute value for the item as specified by the 
					// 		mapping.
					// mapping: A mapping object from this object's attrMappings
					// defaultValue: The default value to return if no value exists for the mapping.
					//		If null is returned by the query, the defaultValue will be returned
					//		instead.
					var ret = null;
					var xpath = mapping.xpath;
					var type = mapping.type;
					var targetName = mapping.targetName;
					var context = this._feed;
					if(item) {
						this._assertIsItem(item);
						context = item.element;
					}
					if(type == "attr") {
						ret = this._getAttrByXpath(context, xpath, targetName);
					}
					else {
						ret = this._getNodeByXpath(context, xpath, targetName);
					}
					
					if(!ret.found && item && item._backup) {
						// we didn't find any nodes matching the xpath query, and
						// this item has been copied from its original for modification,
						// so perhaps we explicitly removed it in the modified version for
						// performance reasons... so lets look it up in the original unmodified version						
						context = item._backup;
						if(type == "attr") {
							ret = this._getAttrByXpath(context, xpath, targetName);
						}
						else {
							ret = this._getNodeByXpath(context, xpath, targetName);
						}
						
						// if ret.found is still false, then just return the defaultValue
						if (!ret.found && defaultValue) {
							ret.value = defaultValue;
						}
					}
					
					if (type == "attr" && ret.value && ret.value.length === 0) {
						ret.value = null;
					}
					
					return ret.value;
				},
				
				setValueByMapping: function( /* com.ibm.data.AtomEntryItem */ item, 
						/* Object */ mapping, 
						/* Value */ value){
					// summary: Executes the correct query API using the mapping argument to
					//		retrieve the desired attribute value for the item as specified by the 
					// 		mapping.
					// mapping: A mapping object from this object's attrMappings
					// value: The value to set that matches the mapping rule on the item.
					var xpath = mapping.xpath;
					var type = mapping.type;
					var targetName = mapping.targetName;
					var context = this._feed;
					var ret = false;
					if(item) {
						this._assertIsItem(item);
						context = item.element;
					}
					if(type == "attr") {
						ret = this._setAttrByXpath(context, xpath, targetName, value);
					}
					else {
						ret = this._setNodeByXpath(context, xpath, targetName, value);
					}
					
					if(!ret && mapping.setter) {
						return mapping.setter.apply(this, arguments);
					}
					return ret;
				},
				
				setValuesByMapping: function( /* com.ibm.data.AtomEntryItem */ item, 
						/* Object */ mapping, 
						/* Array */ values){
					// summary: Executes the correct query API using the mapping argument to
					//		retrieve the desired attribute value for the item as specified by the 
					// 		mapping.
					// mapping: A mapping object from this object's attrMappings
					// values: The value to set that matches the mapping rule on the item.
					var xpath = mapping.xpath;
					var type = mapping.type;
					var targetName = mapping.targetName;
					var context = this._feed;
					var ret = false;
					if(item) {
						this._assertIsItem(item);
						context = item.element;
					}
					if(type == "attr") {
						ret = this._setAttrsByXpath(context, xpath, targetName, value);
					}
					else {
						ret = this._setNodesByXpath(context, xpath, targetName, value);
					}
					
					if(!ret && mapping.setter) {
						return mapping.setter.apply(this, arguments);
					}					
					return ret;
				},
				
				getAttributes: function(/* com.ibm.data.AtomEntryItem? */ item){
					// summary: Gets the valid attributes for the given item if one is provided and
					//		returns an array of attribute names in String format.  If the item is
					//		null, it returns an array of attributes on the current feed that can
					//		be retrieved via the getFeedValue function.
					// item: Optional argument to get the list of attributes from.
					var attrs = [];
					var x = null;
					if(item) {
						this._assertIsItem(item);
						for(x in item.attrMappings) {
							attrs.push(x);
						}
					}
					else {
						for(x in this.attrMappings) {
							attrs.push(x);
						}
					}
					
					return attrs;
				},
				
				hasAttribute: function(	/* com.ibm.data.AtomEntryItem */ item,
							/* String */ attribute){
					// summary: Returns true if the attribute is a valid attribute on the given item,
					//		false otherwise.  This does not check if the attribute value on the item
					//		is null or empty, but just checks if the item supports that attribute.
					// item: Item to check if the attribute is valid
					// attribute: Name of the attribute to check
					this._assertIsItem(item);
					this._assertIsString(attribute);
					if(attribute.charAt(attribute.length - 1) == '$') {
						// this looks like an attribute whose map rule is parameterizable
						// so lets defer checking if its valid until later so we don't
						// duplicate any string processing
						return true;
					}
					if (item.attrMappings[attribute]) {
						return true;
					}
					else {
						return false;
					}
				},
				
				containsValue: function(/* com.ibm.data.AtomEntryItem */ item,
							/* String */ attribute, 
							/* Object */ value){
					// summary: Returns true if the value of the attribute on the given item is
					//		equal to the value argument, false otherwise.  If the attribute is a
					//		multi-valued attribute, it will check all the values of the attribute.
					// item: Item to check if the attribute is valid
					// attribute: Name of the attribute to check
					// value: Value to compare the actual value(s) to.
					var values = this.getValues(item, attribute);
					for(var i = 0; i < values.length; i++) {
						if (values[i] == value) {
							return true;
						}
					}
					return false;
				},
				
				isItem: function(/* Object */ something){
					// summary: Returns true if the argument is a valid item in this store, false otherwise.
					// something: Object to check to determine if it is an item in this store.
					return something.store == this && something.element && !something._isDeleted;
				},
				
				isItemLoaded: function(/* Object */ something) {
					// summary: All valid items in this data store are loaded all of the time as there
					//		is no support currently for stubs.  Therefore, this is effectively the same
					//		as isItem.
					return this.isItem(something) && something.loaded;
				},
				
				loadItem: function(/* Object */ keywordArgs){
					// summary: All valid items in this data store are loaded all of the time as there
					//		is no support currently for stubs.  Therefore, this function is a no-op. 
				},
				getResultSize: function(/*DOMDoc*/ doc, /*Request*/ request, /*Array*/ items) {
					// summary: Gets the total number of items retrieved by the query, which is not
					//		necessarily the number of items returned to the callbacks to fetch.
					//		This can be used for paging purposes to get the total number of items
					//		on the server that match the query, where subsequent fetch requests can
					//		be made to retrieve additional pages.
					return items.length;
				},
				processFetchedItems: function(/*Array*/ items, /*Request*/ request) {
					// summary: Extension point for descendants or consumers of this store to preprocess
					// 		the list of items that the store returns from a fetch call.  Allows a store
					// 		to filter the list or implement caching techniques on the client, or sort
					// 		the items, or anything else.
					// items: Array items of this data store found in the response of a fetch call
					// returns: Array items of this data store after processing
					return items;
				},		
				processResponse: function(/*DOMDoc*/ xmlDoc, /*Request*/ request) {
					// summary: Extension point for descendants or consumers of this store to handle
					//		responses from server requests for data.  Most subclasses can leave this
					// 		function as-is, but if special handling is required that cannot be done
					// 		with other extension points, this can be overridden as well.
					// 		Must call onBegin, onItem, and onComplete callbacks correctly as 
					// 		specified by dojo.data.api.Read.  The onError callback is handled elsewhere.
					// xmlDoc: DOMDoc of the response from an IO request
					// request: Request used to fetch the result
					if (request.aborted) {
						return;
					}
					var composite = this._parseFeed(request, xmlDoc); 
					var items = composite.items;
					this._feed = composite.root;
					items = this.processFetchedItems(items, request);
					if (request.onBegin) {
						request.onBegin.call(request.scope, this.getResultSize(composite.root, request, items), request);
					}
					if(request.onItem) {
						for(var i = 0; i < items.length; i++) {
							if (request.aborted) {
								return;
							}
							request.onItem.call(request.scope, items[i], request);
						}
					}
					if(request.onComplete) {
						// call onComplete with items array if onItem wasn't specified, otherwise
						// call it with null
						if (request.aborted) {
							return;
						}
						if (!request.onItem) {
							request.onComplete.call(request.scope, items, request);
						}
						else {
							request.onComplete.call(request.scope, null, request);
						}
					}
				},
				fetch: function( keywordArgs ) {
					//    summary:
			        //        Given a query and set of defined options, such as a start and count of items to return,
			        //        this method executes the query and makes the results available as data items.
			        //        The format and expectations of stores is that they operate in a generally asynchronous 
			        //        manner, therefore callbacks are always used to return items located by the fetch parameters.
			        //
			        //    description:
			        //        A Request object will always be returned and is returned immediately.
			        //        The basic request is nothing more than the keyword args passed to fetch and 
			        //        an additional function attached, abort().  The returned request object may then be used 
			        //        to cancel a fetch.  All data items returns are passed through the callbacks defined in the 
			        //        fetch parameters and are not present on the 'request' object.
			        //
			        //        This does not mean that custom stores can not add methods and properties to the request object
			        //        returned, only that the API does not require it.  For more info about the Request API, 
			        //        see dojo.data.api.Request
			        //
			        //    keywordArgs:
			        //        The keywordArgs parameter may either be an instance of 
			        //        conforming to dojo.data.api.Request or may be a simple anonymous object
			        //        that may contain any of the following:
			        //        { 
			        //            query: query-string or query-object,
			        //            queryOptions: object,
			        //            onBegin: Function,
			        //            onItem: Function,
			        //            onComplete: Function,
			        //            onError: Function,
			        //            scope: object,
			        //            start: int
			        //            count: int
			        //            sort: array
			        //        }
			        //        All implementations should accept keywordArgs objects with any of
			        //        the 9 standard properties: query, onBegin, onItem, onComplete, onError 
			        //        scope, sort, start, and count.  Some implementations may accept additional 
			        //        properties in the keywordArgs object as valid parameters, such as 
			        //        {includeOutliers:true}.         
			        //
					//	The *query* parameter.
					//        The query may be optional in some data store implementations.
					//        The dojo.data.api.Read API does not specify the syntax or semantics
					//        of the query itself -- each different data store implementation
					//        may have its own notion of what a query should look like.
					//        However, as of dojo 0.9, 1.0, and 1.1, all the provided datastores in dojo.data
					//        and dojox.data support an object structure query, where the object is a set of 
					//        name/value parameters such as { attrFoo: valueBar, attrFoo1: valueBar1}.  Most of the
					//        dijit widgets, such as ComboBox assume this to be the case when working with a datastore 
					//        when they dynamically update the query.  Therefore, for maximum compatibility with dijit 
					//        widgets the recommended query parameter is a key/value object.  That does not mean that the
					//        the datastore may not take alternative query forms, such as a simple string, a Date, a number, 
					//        or a mix of such.  Ultimately, The dojo.data.api.Read API is agnostic about what the query 
					//        format.  
					//        Further note:  In general for query objects that accept strings as attribute 
					//        value matches, the store should also support basic filtering capability, such as * 
					//        (match any character) and ? (match single character).  An example query that is a query object
					//        would be like: { attrFoo: "value*"}.  Which generally means match all items where they have 
					//        an attribute named attrFoo, with a value that starts with 'value'.
			        //
			        //    The *queryOptions* parameter
			        //        The queryOptions parameter is an optional parameter used to specify optiosn that may modify
			        //        the query in some fashion, such as doing a case insensitive search, or doing a deep search
			        //        where all items in a hierarchical representation of data are scanned instead of just the root 
			        //        items.  It currently defines two options that all datastores should attempt to honor if possible:
			        //        {
			        //            ignoreCase: boolean, //Whether or not the query should match case sensitively or not.  Default behaviour is false.
			        //            deep: boolean     //Whether or not a fetch should do a deep search of items and all child 
			        //                            //items instead of just root-level items in a datastore.  Default is false.
			        //        }
			        //
			        //    The *onBegin* parameter.
			        //        function(size, request);
			        //        If an onBegin callback function is provided, the callback function
			        //        will be called just once, before the first onItem callback is called.
			        //        The onBegin callback function will be passed two arguments, the
			        //        the total number of items identified and the Request object.  If the total number is
			        //        unknown, then size will be -1.  Note that size is not necessarily the size of the 
			        //        collection of items returned from the query, as the request may have specified to return only a 
			        //        subset of the total set of items through the use of the start and count parameters.
			        //
			        //    The *onItem* parameter.
			        //        function(item, request);
			        //        If an onItem callback function is provided, the callback function
			        //        will be called as each item in the result is received. The callback 
			        //        function will be passed two arguments: the item itself, and the
			        //        Request object.
			        //
			        //    The *onComplete* parameter.
			        //        function(items, request);
			        //
			        //        If an onComplete callback function is provided, the callback function
			        //        will be called just once, after the last onItem callback is called.
			        //        Note that if the onItem callback is not present, then onComplete will be passed
			        //        an array containing all items which matched the query and the request object.  
			        //        If the onItem callback is present, then onComplete is called as: 
			        //        onComplete(null, request).
			        //
			        //    The *onError* parameter.
			        //        function(errorData, request); 
			        //        If an onError callback function is provided, the callback function
			        //        will be called if there is any sort of error while attempting to
			        //        execute the query.
			        //        The onError callback function will be passed two arguments:
			        //        an Error object and the Request object.
			        //
			        //    The *scope* parameter.
			        //        If a scope object is provided, all of the callback functions (onItem, 
			        //        onComplete, onError, etc) will be invoked in the context of the scope
			        //        object.  In the body of the callback function, the value of the "this"
			        //        keyword will be the scope object.   If no scope object is provided,
			        //        the callback functions will be called in the context of dojo.global().  
			        //        For example, onItem.call(scope, item, request) vs. 
			        //        onItem.call(dojo.global(), item, request)
			        //
			        //    The *start* parameter.
			        //        If a start parameter is specified, this is a indication to the datastore to 
			        //        only start returning items once the start number of items have been located and
			        //        skipped.  When this parameter is paired withh 'count', the store should be able
			        //        to page across queries with millions of hits by only returning subsets of the 
			        //        hits for each query
			        //
			        //    The *count* parameter.
			        //        If a count parameter is specified, this is a indication to the datastore to 
			        //        only return up to that many items.  This allows a fetch call that may have 
			        //        millions of item matches to be paired down to something reasonable.  
			        //
			        //    The *sort* parameter.
			        //        If a sort parameter is specified, this is a indication to the datastore to 
			        //        sort the items in some manner before returning the items.  The array is an array of 
			        //        javascript objects that must conform to the following format to be applied to the
			        //        fetching of items:
			        //        {
			        //            attribute: attribute || attribute-name-string,
			        //            descending: true|false;   // Optional.  Default is false.
			        //        }
			        //        Note that when comparing attributes, if an item contains no value for the attribute
			        //        (undefined), then it the default ascending sort logic should push it to the bottom 
			        //        of the list.  In the descending order case, it such items should appear at the top of the list.
			        // 
			        //    returns:
			        //        The fetch() method will return a javascript object conforming to the API
			        //        defined in dojo.data.api.Request.  In general, it will be the keywordArgs
			        //        object returned with the required functions in Request.js attached.
			        //        Its general purpose is to provide a convenient way for a caller to abort an
			        //        ongoing fetch.  
			        // 
			        //        The Request object may also have additional properties when it is returned
			        //        such as request.store property, which is a pointer to the datastore object that 
			        //        fetch() is a method of.
			        //
			        //    exceptions:
			        //        Throws an exception if the query is not valid, or if the query
			        //        is required but was not supplied.
					if (!keywordArgs) {
						keywordArgs = {};
					}
			        var me = this;
					keywordArgs.aborted = false;
					if (!keywordArgs.scope) {
						keywordArgs.scope = dojo.global;
					}
					var url = this._buildUrl(keywordArgs, this.url);
					keywordArgs.url = url;
					var loadHandler = function(response, ioArgs) {
						if (keywordArgs.aborted) {
							return;
						}
						if (dojo.isIE) {
							response = com.ibm.domUtilities.docFromString(response);
						}
						me.doc = response;
						me.processResponse(response, keywordArgs);
					};
					var errorHandler = function(error, ioArgs) {
						if (keywordArgs.onError) {
							keywordArgs.onError.call(keywordArgs.scope, error, keywordArgs);
						}
					};
					var preventCache = false;
					if(keywordArgs.queryOptions && keywordArgs.queryOptions.preventCache) {
						preventCache = true; 
					}
					var args = {
						preventCache: preventCache,
						content: {},
						url: url,
						handleAs: "xml"
					}
					if(keywordArgs.queryOptions && keywordArgs.queryOptions.timeout) {
						args.timeout = keywordArgs.queryOptions.timeout;
					}
					else if(this.timeout) {
						args.timeout = this.timeout;
					}
					if(dojo.isIE) {
						args.handleAs = "text";
						args.content["ibm.web2.contentType"] = "text/xml";
					}
					
					var handle = null;
					keywordArgs.abort = function() {
						keywordArgs.aborted = true;
						handle.cancel();
					};
					args = this.modifyRequestArgs(args, keywordArgs);
					
					handle = dojo.xhrGet(args);
					handle.addCallback(loadHandler);
					handle.addErrback(errorHandler);

					this._lastRequest = keywordArgs;
					return keywordArgs;
				},
				modifyRequestArgs: function(ioArgs, request) {
					// summary: Allows modification to request arguments before sending a request
					//		to the server.  Subclasses may override this to modify arguments
					//		like setting headers, manipulating the url, overriding a handleAs argument,
					//		or anything else.  Returns the modified request args.
					// ioArgs: dojo.__XhrArgs request args to be sent to the server
					// request: dojo.data.api.Request object
					// returns: dojo.__XhrArgs modified request arguments
					return ioArgs;
				},
				_queryUrlToObject: function(queryStr) {
					if (!queryStr || queryStr.length === 0) {
						return {};
					}
					var start = queryStr.indexOf("?");
					var str = queryStr;
					if(start > -1 && (start < str.length - 1)) { 
						// extract only the query part of the queryStr URL
						str = queryStr.substring(start + 1);
					}
					return dojo.queryToObject(str);
				},
				_prepareQuery: function(keywordArgs) {
					var query = keywordArgs.query;
					if (!query) {
						keywordArgs.query = {};
					}
					else 
						if (dojo.isString(query)) {
							keywordArgs.query = this._queryUrlToObject(query);
						}
					return this.prepareQuery(keywordArgs);
				},
				prepareQuery: function(keywordArgs) {
					// summary: User overridable function to modify the keywordArgs object
					// 		used to fetch results from the back end after the keywordArgs.query
					//		property has been normalized to an object map but before any other
					//		processing has taken place to build the URL.  This can be used to
					//		extract other parts of the keywordArgs map to add properties to the
					//		query object that are dependent on the back end implementation.  One
					//		example includes extracting the keywordArgs.sort parameters and appending
					//		appropriate properties to the keywordArgs.query property that will end
					//		up being built into the generated URL to the server.
					// returns: Object Modified keywordArgs object.
					return keywordArgs;
				},
				_buildUrl: function(keywordArgs, baseUrl) {
					// summary: Builds a url string from this store's base url and the
					// 		query argument.
					// keywordArgs: Object
					//		A request object map as sent to the fetch function
					// returns: String The constructed url.
					var ret = "";
					var keywordArgs = this._prepareQuery(keywordArgs);
					var queryPart = dojo.objectToQuery(keywordArgs.query);
					if (baseUrl.indexOf("?") > -1) {
						ret = baseUrl + "&" + queryPart; // String
					}
					else {
						ret = baseUrl + "?" + queryPart; // String
					}
					
					return (this.modifyUrl(keywordArgs, ret));
				},
				modifyUrl: function(keywordArgs, url) {
					return url;
				},
				_parseFeed: function(request, xmlDoc) {
					var items = [];
					var root = null;
					var result = this._getNodeByXpath(xmlDoc, "/atom:feed");
					if(!result.found) {
						result = this._getNodeByXpath(xmlDoc, "/atom:entry");
						if(!result.found) {
							// the root is not an atom:feed or atom:entry
							throw new Error("Illegal atom feed format: the root element is not an ATOM feed or entry element.");
						}
						else {
							// the root is an atom:entry element, so there's only one item
							root = result.value;
							var query = this._queryUrlToObject(request.url);
							items.push(this._getItem({element: root, query: query}));
						}
					}
					else {
						// the root is an atom:feed element
						root = result.value;
						var query = this._queryUrlToObject(request.url);
						result = this._getNodesByXpath(root ? root : xmlDoc, "./atom:entry");
						if(result.found) {
							var nodes = result.value;
							for(var i = 0; i < nodes.length; i++) {
								items.push(this._getItem({element: nodes[i], query: query}));
							}
						}
					}
					
					return {items: items, root: root};
				},
				
				getFeatures: function () {
					//	summary:
					//		Return supported data APIs
					//	returns:
					//		Map of supported data APIs with keys as API classes and values as true/false to indicate support
					//		by this store.
					return this._features; //returns Map
				},
				
				close: function(/*dojo.data.api.Request || keywordArgs || null */ request){
					if (request && request.abort) {
						request.abort();
					}
				},
				
				getLabel: function(/* com.ibm.data.AtomEntryItem */ item){
					return this.getEPResolvedValue(item, "title");
				},
				
				getLabelAttributes: function(/* com.ibm.data.AtomEntryItem */ item){
					return ['title'];
				},
				
				/********************************/
				/**                            **/
				/**                            **/
				/**    dojo.data.api.Write     **/
				/**                            **/
				/**                            **/
				/********************************/
				newItem: function(/* Object? */ keywordArgs, /*Object?*/ parentInfo){
					// summary: Must be overridden by stores that extend this but support writes,
					//		like ATOM services that support APP.
					return null;
				},
				
				deleteItem: function(/* com.ibm.data.AtomEntryItem */ item){
					// summary: Deletes an item from the store.  Does not persist to the server until save is called.
					// item: The item to delete.
					// returns: Boolean true if successful, false otherwise.							
					if (!this._deletedItems) {
						this._deletedItems = [];
					}
					item.backup();
					this._deletedItems.push(item);
					// storing identity into item since we need it later and can't access it through store APIs
					// after it's been marked as deleted
					item.id = this.getIdentity(item);
					item._isDeleted = true;
					// we are assuming that order does not matter, so we don't have to save the item's
					// current position in the list of entries in this feed
					return true;
				},
				
				setValue: function(	/* com.ibm.data.AtomEntryItem */ item, 
						/* String */ attribute,
						/* almost anything */ value){
					var ret = false;
					var oldValue = null;
					if(this.hasAttribute(item, attribute)) {
						var mapRule = this.getMapRule(attribute, item.attrMappings);
						// if mapRule is null here, then we didn't find one
						// in the map, so we can't proceed successfully
						if(mapRule) {
							item.backup();
							oldValue = this.getValueByMapping(item, mapRule);
							ret = this.setValueByMapping(item, mapRule, value);
							if(ret) {
								this._addDirtyItem(item);
								item.logWrite({attribute: attribute, value: value});
							}
						}
					}
					else {
						throw new Error(attribute + " is not an attribute of any item in this store");
					}
					return {success: ret, oldValue: oldValue, newValue: value};
				},
				
				setValues: function(/* com.ibm.data.AtomEntryItem */ item,
						/* String */ attribute, 
						/* array */ values){
					var ret = false;
					var oldValue = null;
					if(this.hasAttribute(item, attribute)) {
						var mapRule = this.getMapRule(attribute, item.attrMappings, true);
						// if mapRule is null here, then we didn't find one
						// in the map, so we can't proceed successfully
						if(mapRule) {
							item.backup();
							oldValue = this.getValueByMapping(item, mapRule);
							ret = this.setValuesByMapping(item, mapRule, values);
							if(ret) {
								this._addDirtyItem(item);
								item.logWrite({attribute: attribute, values: values});
							}
						}
					}
					else {
						throw new Error(attribute + " is not an attribute of any item in this store");
					}
					return {success: ret, oldValue: oldValue, newValue: values};
				},
				
				unsetAttribute: function(/* com.ibm.data.AtomEntryItem */ item, 
								/* String */ attribute){
					var ret = false;
					var oldValue = null;
					var value = null;
					if(this.hasAttribute(item, attribute)) {
						var mapRule = this.getMapRule(attribute, item.attrMappings);
						// if mapRule is null here, then we didn't find one
						// in the map, so we can't proceed successfully
						if(mapRule) {
							item.backup();
							oldValue = this.getValueByMapping(item, mapRule);
							if(mapRule.type == "attr") {
								ret = this.setValueByMapping(item, mapRule, "");
								value = "";
							}
							else {
								// it's a node or node property
								if (mapRule.targetName) {
									ret = this.setValueByMapping(item, mapRule, null);
								}
								// if targetName, then it's a property
								else 
									if (oldValue) {
										// if no targetName, then it's a node... so remove the node				
										oldValue.parentNode.removeChild(oldValue);
										ret = true;
									}
							}
							
							if(ret) {
								this._addDirtyItem(item);
								item.logWrite({attribute: attribute, value: value});
							}
						}
					}
					return {success: ret, oldValue: oldValue, newValue: value};
				},
				
				save: function(/* Object */ keywordArgs){
					var it = null;
					for(var d = 0; d < this._deletedItems.length; d++) {
						it = this._deletedItems[d];
						it.persist();
						delete it.element;
					}
					for(var i = 0; i < this._dirtyItems.length; i++) {
						this._dirtyItems[i].persist();
					}
					for(var i = 0; i < this._newItems.length; i++) {
						this._newItems[i].persist();
					}
					
					// the persist operation of the above items set some values on their backups
					// which may have updated the dirtyItems list... by putting this below here
					// we're removing those immediately if they are here 
					
					// instead of just reinitializing these pointers,
					// splice these so that we can keep the same array references forever in case others have
					// pointers to these still (so that they won't break)
					this._newItems.splice(0, this._newItems.length);
					this._dirtyItems.splice(0, this._dirtyItems.length);
					this._deletedItems.splice(0, this._deletedItems.length);
				},
				_addDirtyItem: function(/* com.ibm.portal.data.ContentModelItem */ item) {
					if (item._isDirty) {
						return;
					}
					item._isDirty = true;
					
					// need to check this
					for(var i = 0; i < this._dirtyItems.length; i++) {
						if (this._dirtyItems[i] == item) {
							return;
						}
					}
					
					this._dirtyItems.push(item);
				},
				
				revert: function(){
					var it = null;
					for(var d = 0; d < this._deletedItems.length; d++) {
						it = this._deletedItems[d];
						it.restore();
						delete item._isDeleted;
					}
					for(var i = 0; i < this._dirtyItems.length; i++) {
						this._dirtyItems[i].restore();
					}
					this._dirtyItems = [];
					this._deletedItems = [];
				},
				
				isDirty: function(/* com.ibm.data.AtomEntryItem? */ item){
					// summary: Determines whether or not an item is dirty or if this store in general has dirty items.
					//		If item is specified, it returns true if that item is dirty, and false otherwise.
					//		If no item is specified, it returns an array of all the dirty items in this store (modified,
					//		deleted, and new), and false if there are none.
					// item: Optional argument to check if a particular item is dirty.  Leaving this null
					if (item && this._assertIsItem(item)) {
						return item._isDirty;
					}
					else {
						var array = this._dirtyItems.concat(this._deletedItems).concat(this._newItems);
						if (!array || array.length === 0) {
							return false;
						}
						else {
							return array;
						}
					}
				}
			}
);	


dojo.declare( "com.ibm.data.AtomEntryItem",
			com.ibm.data.XpathHelper, 
			{
				namespaces: dojo.mixin({}, com.ibm.data.AtomFeedStore.prototype.namespaces),
		        // attrMappings: This maps attribute names to a query object consisting of an 
		        // 		xpath expression used to find the relevant node(s), an attr name, and a type.
		        // 		The map contains key-value pairs in this format:
		        //		{
		        //			attributeName: {xpath: "./this/is/the/xpath/expr", targetName: "attrName"|null, type: "node"|"attr"}  
		        //		}
		        //		The xpath expression is resolved from the context of the atom:entry node 
		        // 		assigned to this atom feed entry item.  The attr property is an optional property
		        //		used to specify whether to get an object property of the returned DOM node object or 
		        // 		an attribute of the returned DOM node.  The type specifies what type the lookup
		        //		will perform in conjunction with the attr.  If the lookup is an attribute of the
		        // 		DOM node, it will attempt to resolve any namespacing it encounters when looking
		        // 		up the attribute.  The following explains the possible combinations of lookup 
		        // 		mechanisms.
		        // 		
		        // 		xpath: "./node", targetName: "textContent", type: "node" = node["textContent"]
		        //		xpath: "./node", targetName: "href", type: "attr" = node.getAttribute("href")
		        // 		xpath: "./node", targetName: "textContent", type: "node" = cross browser node["textContent"] property
		        // 		xpath: "./node", targetName: null, type: "node" = node
		        //  	xpath: "./node", targetName: null, type: "attr" = invalid query, requires the attribute name
		        //
		        //		Map rules can be parameterized by substituting parameters specified by the caller into the
		        //		rule template.  Parameterized map rules MUST end with a $ character to mark them as such.
		        // 		Example:
		        //	 		pAttribute$: {xpath: "./${0}['${1}']", targetName: "${2}", type: "node", customRuleProperty: "${1}"}
		        //
		        //		Callers supply a comma-separated list of parameter values to be bound to subsequent numerical
		        //		parameter keys in the template respectively surrounded by brackets immediately following the
		        //		name of the attribute key but before the $ character.
		        //		Example:
		        // 			To request the value of pAttribute$ with values set for the parameters, the caller would 
		        // 			use code like this -
		        //		store.getValue(item, "pAttribute[div, id, nodeValue]$");
		        //
		        attrMappings: dojo.mixin({}, com.ibm.data.AtomFeedStore.prototype.attrMappings, { 		
					subtitle: {xpath: "./atom:subtitle", targetName: "textContent", type: "node", setter: 
						function(item, rule, value){
							var elem = this._createNSElement(item.element.ownerDocument, "atom:subtitle");
							this._setNodeProp(elem, rule.targetName, value);
							item.element.appendChild(elem);
							return true;
						}
					},
					generator: {xpath: "./atom:generator", targetName: "textContent", type: "node", setter: 
						function(item, rule, value){
							var elem = this._createNSElement(item.element.ownerDocument, "atom:generator");
							this._setNodeProp(elem, rule.targetName, value);
							item.element.appendChild(elem);
							return true;
						}
					},
					icon: {xpath: "./atom:icon", targetName: "textContent", type: "node", setter: 
						function(item, rule, value){
							var elem = this._createNSElement(item.element.ownerDocument, "atom:icon");
							this._setNodeProp(elem, rule.targetName, value);
							item.element.appendChild(elem);
							return true;
						}
					},
					logo: {xpath: "./atom:logo", targetName: "textContent", type: "node", setter: 
						function(item, rule, value){
							var elem = this._createNSElement(item.element.ownerDocument, "atom:logo");
							this._setNodeProp(elem, rule.targetName, value);
							item.element.appendChild(elem);
							return true;
						}
					}
				}), 
				
				constructor: function( /*Map*/ args ) {
					dojo.mixin(this, args);
					this._writeLog = [];
				},
				toString: function() {
					return "<" + this.__getClassName() + ">";
				},
				_onCreate: function() {
					// summary: Called internally to indicate an item has been created.  Should
					//		be called immediately on creation for stores that do not save to
					//		a backend server, but should be called on a valid server response for
					// 		an item that was created and saved to the server successfully.  This
					// 		calls onCreate to notify listeners of the event and can therefore be
					// 		overriden if custom logic needs to be applied to handle cases where
					// 		other conditions need to be satisfied before the onCreate event is called.
					this.onCreate();
				},
				onCreate: function() {
					// summary: Called when this item is created.  This callback is reserved
					// 		for sending notifications when a new item stub has been created
					// 		on the actual server.  This will be called when a new item has been
					//		created, saved to the server, and the server responds back with
					//		a verification of the created item.  Some stores may not have any
					// 		notion of creating items on the server and should call this immediately
					// 		when the item is created on the client, while others actually defer 
					// 		the full creation of a new item from the newItem call until after the 
					// 		save operation has persisted to the backend.  This allows interested 
					// 		parties to get notified when an item they've created is actually saved
					// 		on the server.  This is especially useful if the server has to generate
					//		something like a unique ID for the item which is not available on the
					//		item until the server response comes back.
				},
				_makeModifiable: function() {
					// summary: Modifies the element of this item to become modifiable
					//		for writing back to the server.  Subclasses can override this
					//		to do things like prune an item to only include necessary information
					//		for updates and nothing more.  This is called by backup once after
					//		backing up the original element first.  After this returns,
					//		this item's element may have been modified.  Any queries against
					//		this item should now include logic to check the backup copy as well
					//		if a query doesn't return anything as it could have been deleted by
					//		this function.  Care should be taken to ensure that the query result
					//		specifically detects if nothing was found or if the actual value was
					//		null or empty.
				},
				backup: function() {
					// summary: Creates a single backup copy of this item on the client for
					//		later restoration if necessary.  Calling this function multiple
					//		times before restore() or persist() is called on this item will do nothing
					//		after the initial backup, effectively maintaining only the first
					//		version of the item before any changes were made.
					if(!this._backup) {
						this._backup = this.element.cloneNode(true);
						this._makeModifiable();
						this._logEnabled = true;
						return true;
					}
					return false;
				},
				restore: function() {
					// summary: Restores the single backup copy of this item on the client,
					//		erasing all modifications made since backup() was called.
					if(!this._backup) {
						dojo.place(this._backup, this.element, "before");
						this.element.parentNode.removeChild(this.element);
						delete this.element;
						this.element = this._backup;
						this.backup = null;
						this._writeLog.splice(0, this._writeLog.length);
						return true;
					}
					return false;
				},
				persist: function() {
					// summary: Persists the changes made to this item since the backup() was
					// 		called.  After this is called, there is no way to restore the backup
					//		as it is erased completely.
					this._writeLogToBackup();
					this._isDirty = false;
					delete this._backup;
				},
				logWrite: function(map) {
					// summary: Logs write operations to this item so that they can later
					//		be repeated to the backup during persistence.
					if (this._logEnabled) {
						this._writeLog.push(map);
					}
				},
				_writeLogToBackup: function() {
					// summary: Repeates the write log for this item to the original backup
					// 		node.  Used mainly for persisting changes to support a 2-phase
					//		write operation (write, commit).
					if(this._backup) {
						this.element = this._backup;
						this._logEnabled = false;
						for(var i = 0; i < this._writeLog.length; i++) {
							var op = this._writeLog[i];
							if(op.values) {
								this.store.setValues(this, op.attribute, op.values);
							}
							else {
								this.store.setValue(this, op.attribute, op.value);
							}
						}
						this._writeLog.splice(0, this._writeLog.length);
					}
				}
			}
);


dojo.declare( "com.ibm.data.AtomPersonConstruct",
			com.ibm.data._XmlConstruct,
			{
				// summary: Construct for retrieving appropriate information
				// 		from an Atom Person Construct as defined in 
				// 		http://tools.ietf.org/html/rfc4287#section-3.2.
				
				namespaces: dojo.mixin({}, com.ibm.data.AtomFeedStore.prototype.namespaces),
		        
				constructor: function(/*DOMNode*/ root) {
					this.root = root;
				},
				getName: function() {
					// summary: Gets the name specified by this Atom person construct.
					// returns: String
					var result = this._getNodeByXpath(this.root, "./atom:name", "textContent");
					if (!result.found) {
						result.value = "";
					}
					return result.value;
				},
				getEmail: function() {
					// summary: Gets the email specified by this Atom person construct.
					// returns: String
					var result = this._getNodeByXpath(this.root, "./atom:email", "textContent");
					if (!result.found) {
						result.value = "";
					}
					return result.value;
				},
				getURI: function() {
					// summary: Gets the name specified by this Atom person construct.
					// returns: String
					var result = this._getNodeByXpath(this.root, "./atom:uri", "textContent");
					if (!result.found) {
						result.value = "";
					}
					return result.value;
				},
				toString: function() {
					// summary: Gets the name string specified by this Atom person construct.
					// returns: String
					return this.getName();
				}
			}
);

dojo.declare( "com.ibm.data.AtomDateConstruct",
			com.ibm.data._XmlConstruct,
			{
				// summary: Construct for retrieving javascript-appropriate information
				// 		from an Atom Date Construct as defined in 
				// 		http://tools.ietf.org/html/rfc4287#section-3.3.
				
				namespaces: dojo.mixin({}, com.ibm.data.AtomFeedStore.prototype.namespaces),
		        
				// Supports date strings in the following formats - 
				//		2003-12-13T18:30:02Z
				//		2003-12-13T18:30:02.25Z
				//		2003-12-13T18:30:02+01:00
				//		2003-12-13T18:30:02.25+01:00
				
				constructor: function(/*DOMNode*/ root) {
					this.root = root;
				},
				getDate: function() {
					// summary: Parses and retrieves a javascript Date object from a date string
					//		specified in an Atom feed according to the allowable string formats
					//		by the Atom spec itself (http://tools.ietf.org/html/rfc4287#section-3.3)
					// returns: Date
					if (this.date) {
						return this.date;
					}
					
					var d = this._getNodeProp(this.root, "textContent");
					if (!d) {
						return null;
					}
					
					this.date = dojo.date.stamp.fromISOString(d);
					return this.date;
				},
				getTime: function() {
					// summary: Gets the time specified by this Atom date construct.
					// returns: int
					this.getDate();
					if (this.date) {
						return this.date.getTime();
					}
					
					return null;
				},
				toString: function() {
					// summary: Gets a string representation of the date specified by this
					//		Atom data construct.
					this.getDate();
					if (this.date) {
						return this.date.toString();
					}
					return "";
				}
			}
);

}

if(!dojo._hasResource["com.ibm.data.OpenSearchFeedStore"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.data.OpenSearchFeedStore"] = true;
dojo.provide( "com.ibm.data.OpenSearchFeedStore" );

dojo.require( "com.ibm.data.AtomFeedStore" );
dojo.require( "dojox.data.dom" );

dojo.declare( "com.ibm.data.OpenSearchFeedStore",
			com.ibm.data.AtomFeedStore,
			{
				// namespaces: Map
				//		Map of namespaces used by the MashupHub feeds
				namespaces: dojo.mixin({}, com.ibm.data.AtomFeedStore.prototype.namespaces, {
		            "xhtml" : "http://www.w3.org/1999/xhtml",
		            "os" : "http://a9.com/-/spec/opensearch/1.1/"
		        }),
		        
		        attrMappings: dojo.mixin({}, com.ibm.data.AtomFeedStore.prototype.attrMappings, {
					nextLink: {xpath: "./atom:link[@rel='next']", targetName: "href", type: "attr"},
					startIndex: {xpath: "./os:startIndex", targetName: "textContent", type: "node"},
					itemsPerPage: {xpath: "./os:itemsPerPage", targetName: "textContent", type: "node"},
					totalResults: {xpath: "./os:totalResults", targetName: "textContent", type: "node"},
					query: {xpath: "./os:Query", type: "OpenSearchQueryConstruct"}
				}),
				
				// itemClass: String the class used to represent items of this store
				itemClass: "com.ibm.data.OpenSearchFeedItem",
				
				constructor: function( /*Map*/ args ) {
					// summary: Creates a new instance of a com.ibm.portal.data._PortalModelStore
					// args: Map
					//		The args map will be used to replace any default values of this store with the
					//		values specified in the args map.
					this._features['dojo.data.api.Identity'] = true;
				},
				
				handleConstructs: function(/*DOMNode*/ node, /*String*/ prop) {
					switch(prop) {
						case "OpenSearchQueryConstruct": return new com.ibm.data.OpenSearchQueryConstruct(node);
						default: return this.inherited(arguments);
					}
				},
				
				getResultSize: function(/*DOMDoc*/ doc, /*Request*/ request, /*Array*/ items) {
					// summary: Gets the total number of items retrieved by the query, which is not
					//		necessarily the number of items returned to the callbacks to fetch.
					//		This can be used for paging purposes to get the total number of items
					//		on the server that match the query, where subsequent fetch requests can
					//		be made to retrieve additional pages.
					var rule = this.attrMappings.totalResults;
					var ret = null;
					if(rule.type == "attr") ret = this._getAttrByXpath(doc, rule.xpath, rule.targetName);
					else ret = this._getNodeByXpath(doc, rule.xpath, rule.targetName);
					// if we found total results, return it as a number
					if(ret.found) return ret.value - 0;
					// otherwise, return -1 to indicate that we don't know
					else return -1;
				},
				
				/********************************/
				/**                            **/
				/**                            **/
				/**   dojo.data.api.Identity   **/
				/**                            **/
				/**                            **/
				/********************************/			
				fetchItemByIdentity: function(/* object */ keywordArgs){
					//	summary:
					//		Given the identity of an item, this method returns the item that has 
					//		that identity through the onItem callback.  Conforming implementations 
					//		should return null if there is no item with the given identity.  
					//		Implementations of fetchItemByIdentity() may sometimes return an item 
					//		from a local cache and may sometimes fetch an item from a remote server, 
					//
					// 	keywordArgs:
					//		An anonymous object that defines the item to locate and callbacks to invoke when the 
					//		item has been located and load has completed.  The format of the object is as follows:
					//		{
					//			identity: string|object,
					//			onItem: Function,
					//			onError: Function,
					//			scope: object
					//		}
					//	The *identity* parameter.
					//		The identity parameter is the identity of the item you wish to locate and load
					//		This attribute is required.  It should be a string or an object that toString() 
					//		can be called on.
					//		
					//	The *onItem* parameter.
					//		Function(item)
					//		The onItem parameter is the callback to invoke when the item has been loaded.  It takes only one
					//		parameter, the item located, or null if none found.
					//
					//	The *onError* parameter.
					//		Function(error)
					//		The onError parameter is the callback to invoke when the item load encountered an error.  It takes only one
					//		parameter, the error object
					//
					//	The *scope* parameter.
					//		If a scope object is provided, all of the callback functions (onItem, 
					//		onError, etc) will be invoked in the context of the scope object.
					//		In the body of the callback function, the value of the "this"
					//		keyword will be the scope object.   If no scope object is provided,
					//		the callback functions will be called in the context of dojo.global.
					//		For example, onItem.call(scope, item, request) vs. 
					//		onItem.call(dojo.global, item, request)
					return false;
				}
			}
);

dojo.declare( "com.ibm.data.OpenSearchFeedItem",
			com.ibm.data.AtomEntryItem, 
			{
				// namespaces: Map
				//		Map of namespaces used by the MashupHub feeds
				namespaces: dojo.mixin({}, com.ibm.data.OpenSearchFeedStore.prototype.namespaces)
			}
);


dojo.declare( "com.ibm.data.OpenSearchQueryConstruct",
			com.ibm.data._XmlConstruct,
			{
				namespaces: dojo.mixin({}, com.ibm.data.OpenSearchFeedStore.prototype.namespaces),
				
				constructor: function(/*DOMNode*/ root) {
					this.root = root;
				},
				getRole: function() {
					return this._getAttribute(this.root, "role");
				},
				getTitle: function() {
					return this._getAttribute(this.root, "title");
				},
				getTotalResults: function() {
					return this._getAttribute(this.root, "totalResults");
				},
				getSearchTerms: function() {
					return this._getAttribute(this.root, "searchTerms");
				},
				getCount: function() {
					return this._getAttribute(this.root, "count");
				},
				getStartIndex: function() {
					return this._getAttribute(this.root, "startIndex");
				},
				getStartPage: function() {
					return this._getAttribute(this.root, "startPage");
				},
				getLanguage: function() {
					return this._getAttribute(this.root, "language");
				},
				getInputEncoding: function() {
					return this._getAttribute(this.root, "inputEncoding");
				},
				getOutputEncoding: function() {
					return this._getAttribute(this.root, "outputEncoding");
				},
				toString: function() {
					return com.ibm.domUtilities.stringFromDoc(this.root);
				}
			}
);

}

if(!dojo._hasResource["com.ibm.data.MashupHubStore"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.data.MashupHubStore"] = true;
dojo.provide( "com.ibm.data.MashupHubStore" );


dojo.require( "com.ibm.data.ProxyHelper" );

dojo.declare( "com.ibm.data.MashupHubStore",
			[com.ibm.data.OpenSearchFeedStore, com.ibm.data.ProxyHelper],
			{
				// namespaces: Map
				//		Map of namespaces used by the MashupHub feeds
				namespaces: null,
		        
		        // itemClass: String the class used to represent items of this store
				itemClass: "com.ibm.data.MashupHubItem",
				
				constructor: function( /*Map*/ args ) {
					// summary: Creates a new instance of a this data store
					// args: Map
					//		The args map will be used to replace any default values of this store with the
					//		values specified in the args map.
					this._features['dojo.data.api.Identity'] = true;
					
					var newUrl = new com.ibm.mm.enabler.utils.HttpUrl(this.url);
					this.url = newUrl.toProxifiedString();
					
					this.bundle = dojo.i18n.getLocalization("com.ibm.bundles", "Shelf"); 
					
					if(args && args.namespace == 'widget') {
						this.namespaces = dojo.delegate(com.ibm.data.OpenSearchFeedStore.prototype.namespaces,{
							catalog: "http://www.ibm.com/xmlns/atom/opensearch/widget/1.0/"
							});
					} else if(args && args.namespace == 'feed') {
						this.namespaces = dojo.delegate(com.ibm.data.OpenSearchFeedStore.prototype.namespaces,{
							catalog: "http://www.ibm.com/xmlns/atom/opensearch/feed/1.0/"
							});
					} else {
						this.namespaces = dojo.delegate(com.ibm.data.OpenSearchFeedStore.prototype.namespaces,{
							catalog: "http://www.ibm.com/opensearch/1.0"
							});
					}	
				},
				
				handleConstructs: function(/*DOMNode*/ node, /*String*/ prop) {
					switch(prop) {
						case "OpenSearchQueryConstruct": return new com.ibm.data.MashupHubQueryConstruct(node);
						default: return this.inherited(arguments);
					}
				},
			
				fetchItemByIdentity: function(/* object */ keywordArgs){
					//	summary:
					//		Given the identity of an item, this method returns the item that has 
					//		that identity through the onItem callback.  Conforming implementations 
					//		should return null if there is no item with the given identity.  
					//		Implementations of fetchItemByIdentity() may sometimes return an item 
					//		from a local cache and may sometimes fetch an item from a remote server, 
					//
					// 	keywordArgs:
					//		An anonymous object that defines the item to locate and callbacks to invoke when the 
					//		item has been located and load has completed.  The format of the object is as follows:
					//		{
					//			identity: string|object,
					//			onItem: Function,
					//			onError: Function,
					//			scope: object
					//		}
					//	The *identity* parameter.
					//		The identity parameter is the identity of the item you wish to locate and load
					//		This attribute is required.  It should be a string or an object that toString() 
					//		can be called on.
					//		
					//	The *onItem* parameter.
					//		Function(item)
					//		The onItem parameter is the callback to invoke when the item has been loaded.  It takes only one
					//		parameter, the item located, or null if none found.
					//
					//	The *onError* parameter.
					//		Function(error)
					//		The onError parameter is the callback to invoke when the item load encountered an error.  It takes only one
					//		parameter, the error object
					//
					//	The *scope* parameter.
					//		If a scope object is provided, all of the callback functions (onItem, 
					//		onError, etc) will be invoked in the context of the scope object.
					//		In the body of the callback function, the value of the "this"
					//		keyword will be the scope object.   If no scope object is provided,
					//		the callback functions will be called in the context of dojo.global.
					//		For example, onItem.call(scope, item, request) vs. 
					//		onItem.call(dojo.global, item, request)
					var id = keywordArgs.identity;
					
					// our IDs may come in as urn:id:# and all we want is the # part
					if(id.indexOf(":") > -1) id = id.substring(id.lastIndexOf(":") + 1);
					var scope = keywordArgs.scope ? keywordArgs.scope : dojo.global;
					var args = {
						query: {
							id: id,
							collection: "ui.all"
						},
						onComplete: dojo.hitch(this, 
							function(items) {
								if(items.length == 0 && keywordArgs.onError) {
									keywordArgs.onError.call(scope, "No items returned matching identity " + id);
								}
								else {
									keywordArgs.onItem.call(scope, items[0]);
								}
							}
						)
					};
					if(keywordArgs.onError) args.onError = dojo.hitch(scope, keywordArgs.onError);

					return this.fetch(args);
				}
			}
);

dojo.declare( "com.ibm.data.MashupHubItem",
		com.ibm.data.OpenSearchFeedItem, 
		{
			// namespaces: Map
			//		Map of namespaces used by the MashupHub feeds
			namespaces: dojo.mixin({}, com.ibm.data.MashupHubStore.prototype.namespaces),
			
	        attrMappings: dojo.mixin({}, com.ibm.data.OpenSearchFeedItem.prototype.attrMappings, {
				editLink: {xpath: "./atom:link[@rel='self']", targetName: "href", type: "attr"},
				category: {xpath: "./atom:category", targetName: "term", type: "attr"},
				catalogVersion: {xpath: "./atom:content/catalog:*/catalog:version", targetName: "textContent", type: "node"},
				catalogName: {xpath: "./atom:content/catalog:*/catalog:name", targetName: "textContent", type: "node"},
				catalogAuthor: {xpath: "./atom:content/catalog:*/catalog:author", targetName: "textContent", type: "node"},
				catalogDescription: {xpath: "./atom:content/catalog:*/catalog:description", targetName: "textContent", type: "node"},
				catalogRating: {xpath: "./atom:content/catalog:*/catalog:rating", targetName: "textContent", type: "node"},
				catalogUseCount: {xpath: "./atom:content/catalog:*/catalog:useCount", targetName: "textContent", type: "node"},
				catalogDateModified: {xpath: "./atom:content/catalog:*/catalog:dateModified", targetName: "textContent", type: "node"},
				catalogNumComments: {xpath: "./atom:content/catalog:*/catalog:numComments", targetName: "textContent", type: "node"},
				catalogTags: {xpath: "./atom:content/catalog:*/catalog:tags/catalog:tags", targetName: "textContent", type: "node"},
				catalogCategories: {xpath: "./atom:content/catalog:*/catalog:categories", targetName: "textContent", type: "node"},
				catalogDocumentationURL: {xpath: "./atom:content/catalog:*/catalog:documentationURL", targetName: "textContent", type: "node"},
				catalogDownloadURL: {xpath: "./atom:content/catalog:*/catalog:downloadURL", targetName: "textContent", type: "node"},
				catalogIcon: {xpath: "./atom:content/catalog:*/catalog:objectmeta/catalog:metadata[@name='icon']", targetName: "value", type: "attr"},
				catalogWidgetParam: {xpath: "./atom:content/catalog:*/catalog:objectmeta/catalog:metadata[@name='widget.metadata.widgetParam']", targetName: "value", type: "attr"},
				catalogOnNewWire: {xpath: "./atom:content/catalog:*/catalog:objectmeta/catalog:metadata[@name='widget.metadata.onNewWire']", targetName: "value", type: "attr"},
				catalogAutoWire: {xpath: "./atom:content/catalog:*/catalog:objectmeta/catalog:metadata[@name='widget.metadata.com.ibm.mashups.builder.autoWiringEnabled']", targetName: "value", type: "attr"},
				catalogPermission: {xpath: "./atom:content/catalog:*/catalog:permission", targetName: "textContent", type: "node"},
				catalogDefinitionURL: {xpath: "./atom:content/catalog:*/catalog:definitionURL", targetName: "textContent", type: "node"},
				catalogTitles: {xpath: "./atom:content/catalog:*/catalog:l10n/catalog:title", targetName: null, type: "node"},
				catalogSandboxUser: {xpath: "./atom:content/catalog:*/catalog:objectmeta/catalog:metadata[@name='sandbox_user']", targetName: "value", type: "attr"},
				catalogSandboxUserDefinition: {xpath: "./atom:content/catalog:*/catalog:objectmeta/catalog:metadata[@name='widget.metadata.sandbox_definition']", targetName: "value", type: "attr"},
				catalogWidgetType: {xpath: "./atom:content/catalog:*/catalog:objectmeta/catalog:metadata[@name='widget.metadata.widgetType']", targetName: "value", type: "attr"}				
			})
		}
);

dojo.declare( "com.ibm.data.MashupHubQueryConstruct",
			com.ibm.data.OpenSearchQueryConstruct,
			{
				namespaces: dojo.mixin({}, com.ibm.data.MashupHubStore.prototype.namespaces),
				
				getSearchType: function() {
					return this._getAttribute(this.root, "catalog:searchType");
				},
				getCollection: function() {
					return this._getAttribute(this.root, "catalog:collection");
				}
			}
);

}

if(!dojo._hasResource["com.ibm.data.MashupFileDataStore"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.data.MashupFileDataStore"] = true;
dojo.provide("com.ibm.data.MashupFileDataStore");

dojo.require( "com.ibm.data.CatalogMixin" );


dojo.declare("com.ibm.data.MashupFileDataStore", 
		[com.ibm.data.MashupHubStore,com.ibm.data.CatalogMixin],
		{	
				/********************************/
				/**                            **/
				/**                            **/
				/**  catalog extension point   **/
				/**                            **/
				/**                            **/
				/********************************/
				
			mapItem: function(/*item*/item){
				var map = {};
				map.id = this.getEPResolvedValue(item, "id", null);
				map.label = this.getEPResolvedValue(item, "catalogName", this.bundle["shelf_untitled"]);
				map.description = this.getEPResolvedValue(item, "catalogDescription", "");
				map.tags = this.getEPResolvedValue(item, "catalogTags", "");
				map.rating = this.getEPResolvedValue(item, "catalogRating", 0.0);
				map.url = this.getEPResolvedValue(item, "catalogDownloadURL", "");
				map.type = this.getEPResolvedValue(item, "category", "");
				map.thumbnail = this.getValue(item, "catalogIcon", "");
				map.widgetParam = this.getEPResolvedValue(item, "catalogWidgetParam", "");
				map.onNewWire = this.getEPResolvedValue(item, "catalogOnNewWire", "");
				map.onAutoWire = this.getEPResolvedValue(item, "catalogAutoWire", "");
				map.permission = this.getEPResolvedValue(item, "catalogPermission", "");
				map.definitionURL = this.getValue(item, "catalogDefinitionURL", "");
				map.sandbox_user = this.getEPResolvedValue(item, "catalogSandboxUser", "false");
				map.sandbox_definition = this.getEPResolvedValue(item, "catalogSandboxUserDefinition", "false");
				map.icon = this.getValue(item, "catalogIcon", "false");
				map.widgetType = this.getEPResolvedValue(item, "catalogWidgetType", "");
				if (map.widgetType === "mm_OSGadget") {
					map.titles = this.getValue(item, "catalogTitles", null);
				}
				map.hubURL = this.url;
				map.isTrusted = map.sandbox_user == "true" ? false : true;
				if(map.widgetParam.length > 0) { map.prefsMapFcn = this.prefsMapFcn; }
				if (!map.thumbnail && builderConfig.builderPath) {
					if (item.store.namespace == "widget"){
						map["thumbnail"] = builderConfig.builderPath + "/images/generic_widget_icon.png";
					} else {
						map["thumbnail"] = builderConfig.builderPath + "/images/gray_generic_feed_icon.png";
					}						
				}
				return map;
			},
			
			prefsMapFcn: function(map){
				var pars = dojo.fromJson(map.widgetParam);
				var ret = {};
				for(var i in pars){
					ret[pars[i].itemName] = pars[i].itemValue;
				}
				return ret;
			},
				
			prepareQuery: function(keywordArgs) {
				if(keywordArgs.query.keywords) {
					keywordArgs.query.searchTerms = keywordArgs.query.keywords.join(" ");
					keywordArgs.query.searchType = "";
					delete keywordArgs.query.keywords;
				}
				else if(keywordArgs.query.tags && keywordArgs.query.tags.length > 0) {
					keywordArgs.query.searchTerms = keywordArgs.query.tags[0];
					keywordArgs.query.searchType = "tag";
					delete keywordArgs.query.tags;
				}
				else {
					keywordArgs.query.searchTerms = "*";
					keywordArgs.query.searchType = "";
				}
				
				if(keywordArgs.sort && keywordArgs.sort.length > 0) {
					switch(keywordArgs.sort[0].attribute) {
						case "date": 
							keywordArgs.query.sortBy = "updated";
							break;
						default:
							keywordArgs.query.sortBy = keywordArgs.sort[0].attribute;
					}
					keywordArgs.query.sortOrder = "asc";
					if(keywordArgs.sort[0].descending == true) {
						keywordArgs.query.sortOrder = "desc";
					}
				}
				
				if(keywordArgs.count) {
					keywordArgs.query.count = keywordArgs.count;
					if(keywordArgs.start == null) {
						keywordArgs.start = 0;
					}
					keywordArgs.query.startIndex = keywordArgs.start;
				}
				
				// NEVER get the feed from the cache, defect 16700
				if(!keywordArgs.queryOptions){
					keywordArgs.queryOptions = {};
				}
				keywordArgs.queryOptions.preventCache = true;
				
				return keywordArgs;
			},
			
			validateSelf: function(){
				// summary: validates this datastore, if it does not validate the source will not be used
				// returns true for validation and false otherwise
				var configSvc = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
				var hubUrl = configSvc.getValue(com.ibm.mashups.enabler.services.ConfigConstants.HUB_URL);
				if(dojo.trim(ibmConfig["com.ibm.mashups.builder.contentShelf.mode"]) != "mashups" && hubUrl && this.url.indexOf("undefined") < 0) {
					return true;
				} else {
					return false;
				}
			}
});

}

if(!dojo._hasResource["com.ibm.customize.ResultsList"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.customize.ResultsList"] = true;
// This controls the list of results in the customization shelf.  It handles searching datastores and paging.  It usually works with a com.ibm.customize.Container as its parent.

dojo.provide("com.ibm.customize.ResultsList");





dojo.declare("com.ibm.customize.ResultsList",
	[dijit._Widget, dijit._Templated],
	{
		source: null,						// the source which is currently selected for searching
		parent: null, 						// the parent container for this widget
		searchTerms: [], 					// an array of search terms for fetch 
		currRequest: null,					// the current fetch request
		size: 9,							// the number of results displayed at once
		start: 0,							// the index of the first result displayed in the section
		totalItemCount: 0,					// the total number of items matched by the last search query
		draggable: false,					// true if items are draggable off the shelf
		dndType: "ibmPortalShelfItem",		// dnd type of items that are draggable
		cssClass: "",
		events: [],
		secondCssClass: "lotusPaletteWidgetContainer",
		listHtmlType: "div",
		templateString: '<div dojoAttachPoint="focusNode" class="${cssClass}">' +
							'<div class="${secondCssClass}">' +
								'<${listHtmlType} role="grid" dojoAttachPoint="table"></${listHtmlType}>' +
							'</div>' +
							'<div class="lotusPaging">' +
								'<div class="lotusLeft" dojoAttachPoint="pagingStatus"></div>' +
								'<div dojoAttachPoint="jumpToLink" class="ibmJumpToLink"></div>' +
								'<ul class="lotusRight lotusInlinelist">' +
									'<li class="lotusFirst" dojoAttachPoint="prevLink"></li>' +
									'<li dojoAttachPoint="nextLink"></li>' +
								'</ul>' +
							'</div>' +
						'</div>',
		
		constructor: function() {
			this.shelfBundle = dojo.i18n.getLocalization("com.ibm.bundles", "Shelf");
			this.newCell = function(){};
		},
		
		postMixInProperties: function(){
			// summary: if this object was created without a parent, provide self with items usually provided by the parent object
			if(!this.parent){
				this.parent = {
					id:this.id,
					createLotusMsgNode: function(message,type){
						var err = dojo.create("div",{className:"lotusMessage lotus" + type, style:{ marginRight:"15px" }});
						var img = dojo.create("img",{src:this.imagePath + "/icon" + type + ".gif", alt:message});
						var msg = dojo.create("span",{innerHTML:message});
						err.appendChild(img);
						err.appendChild(msg);
						return err;
					},
					newCell: this.newCell
				}
			}
		},
		
		postCreate: function(){ 
			// summary: subscribes to events for when the search terms changes, the source changes, the user wants to add a saved search, or the size of the browser window adjusts
			this.events.push(dojo.subscribe("/epc/customize/search"+this.parent.id, this, this.changeSearchTerms));
			this.events.push(dojo.subscribe("/epc/customize/changeSource"+this.parent.id, this, this.changeSource));
			if(this.source) this.changeSource(this.source);
			if(this.draggable) this.setUpDndSource();
		},
		
		/**********************************/
		/*               DND              */
		/**********************************/
			
		setUpDndSource: function(){
			var cls = dojo.getObject(ibmPortalConfig.portletDndSource || "com.ibm.pb.dnd.layout.ShelfSource");  // LAURA
			this.dndSource = new cls(
				this.table,{
				creator: ibmPortalConfig.portletDndSource ? this.creator : cls.creator, 
				accept: [], 
				singular: true,
				skipForm: true,
				copyOnly: true,
				selfAccept: false,
				selfCopy: false,
				copyState: function(){	return true; }
			});
			this.events.push(dojo.subscribe("/dnd/drop", this, "onDrop"));
		},
		
		makeCellDraggable: function(cell){
			dojo.addClass(cell, "dojoDndItem dojoDndHandle");
			var control = dojo.query(".lotusInner", cell)[0];
			dojo.addClass(control,"ibmPortalControl");
			dojo.attr(cell, "dndType", this.dndType);
		},
		
		creator: function(item, hint){
			if(hint == "avatar"){
				var node = dojo.dnd.manager().nodes[0];
				var widget = dijit.byId(node.id);
				var title = (widget) ? widget.truncTitleText : "";
				var node = dojo.create("div",{className:"ibmPortalShelfAvatar",innerHTML:title});
				return {node: node, data: item, type: [this.dndType]};
			}
		},
		
		onDrop: function(source, nodes, copy){
			if(typeof com.ibm.portal.dnd != "undefined" && typeof com.ibm.portal.dnd.PORTLET_MEDIATOR != "undefined"){
				if(com.ibm.portal.dnd.PORTLET_MEDIATOR.currentType == this.dndType){
					com.ibm.portal.dnd.PORTLET_MEDIATOR.fromShelf = true;
					var widget = dijit.byId(nodes[0].id);
					widget.apply();
				}
			}
		},
		
		/**********************************/
		/*            SEARCH              */
		/**********************************/
		
		changeSearchTerms: function(/*String[]*/ searchTerms){
			// summary: does a new search when the filters change
			// searchTerms: an array of strings which are filters
			this.searchTerms = searchTerms;
			this.start = 0;
			this._search();
		},
		
		changeSource: function(/*Object*/ source){
			// summary: does a fresh search with no filters when the hub changes
			// source: the new source to search
			if(!source.hub.fetch) {
				this.clear();
				return;
			}
			if(this.currRequest) this.currRequest.abort();  // make sure any unfinished request is aborted
			this.source = source;
			this.searchTerms = [];
			this.start = 0;
			if(source.hub.noIcons) dojo.addClass(this.domNode.parentNode,"lotusPlain");
			else dojo.removeClass(this.domNode.parentNode,"lotusPlain");
			this._search();
		},
		
		_search: function(){
			// summary: does a fetch operation on the hub and fills the table with the results
			if(this.source.hub == null){
				// alert the user if the hub is null and clear out old info on the paging bar
				this.addMessage("Error",dojo.string.substitute(this.shelfBundle["shelf_badDatastoreError"], [this.source.label]));
				return;
			} else this.setLoading();
			
			// See dojo.data.api.Read.fetch()
			this.currRequest = this.source.hub.fetch({
				queryOptions: { ignoreCase: true },
				query: { keywords: this.searchTerms }, // query is the array of filters that the hub handles in its own way
				count: this.size,
				start: this.start,  
				
				onComplete: dojo.hitch(this, function(/*DatastoreItem[]*/items) {
					// summary: uses the items returned from the search to adjust what is displayed on the paging bars, and fill the table with results
					if(this.parent.filterAdd){
						// filter out any items that should not be displayed
						filterFcn = dojo.hitch(this,function(item){ return this.parent.filterAdd(this.source.hub.mapItem(item)); })
						items = dojo.filter(items,filterFcn);
					}
					if(items.length == 0) this.addMessage("Warning",this.shelfBundle["shelf_noResults"]);
					else this.fill(items);
				}),
				
				onError: dojo.hitch(this, function(/*String*/error, /*Object*/request) {
					console.error("error loading this category: " +error);
					// summary: displays an error message in the table and clears out old info on the paging bar
					if  (error.status == 401) {
						ibm.portal.debug.text( "Basic auth 401 found, trigger reload");
						var authObj = dojo.getObject("com.ibm.ajax.auth");
						if(authObj) com.ibm.ajax.auth.authenticationHandler();
						else window.location.reload();
						return;
					}
					this.clear();
					this.addMessage("Error", dojo.string.substitute(this.shelfBundle["shelf_feedError"], [this.source.label]));
				}),
				
				onBegin: dojo.hitch(this, function(totalNumber) {
					// summary: records the number of results returns in the current query
					this.totalItemCount = totalNumber;
				})
			});
		},
		
		/***********************************/
		/*              TABLE              */
		/***********************************/
		
		setLoading: function() {
			// summary: adds a loading indicator, for use before search results are appended
			this.clear();
			this.table.appendChild(document.createTextNode(this.shelfBundle["shelf_loading"]));
		},
		
		addMessage: function(/*String*/type,/*String*/msg){
			// summary: clears out the table and then builds it back up enough to enter a single message into the table
			// msg: the message to enter in the table
			this.clear();
			// create the cell
			var message = this.parent.createLotusMsgNode(msg,type);
			this.table.appendChild(message);
			// reset search numbers to 0 and adjust the info on the paging bar
			this.start = 0;
			this.totalItemCount = 0;
		},
		
		clear: function(){
			// summary: clears out the table
			var items = dojo.query(".lotusPaletteWidget",this.table);
			dojo.forEach(items, dojo.hitch(this, function(item){
				dijit.byId(item.id).destroy();
			}));
			this.table.innerHTML = "";
			this.pagingStatus.innerHTML = "";
			this.jumpToLink.innerHTML = "";
			this.prevLink.innerHTML = "";
			this.nextLink.innerHTML = "";
		},
		
		fill: function(/*DatastoreItem[]*/contents){
			// summary: fills the table with rows of catalog item results
			// contents: array holding DatastoreItems to be entered in the table
			this.clear();
			dojo.forEach(contents, dojo.hitch(this, function(item) {
				var newCell = this.parent.newCell(this.source,item);
				if(this.draggable) this.makeCellDraggable(newCell);
				this.table.appendChild(newCell);
			}));	
			this.adjustPagingBar();
			if(this.draggable) this.dndSource.sync();
		},
		
		/************************************/
		/*              PAGING              */
		/************************************/
		
		prev: function(){
			// summary: triggers when the user clicks the Previous link,
			this.start = this.start - this.size;
			this._search();
		},
		
		next: function(){
			// summary: triggers when the user clicks the Next link
			this.start = this.start + this.size;
			this._search();
		},
		
		jumpTo: function(/*Event*/e){
			// summary: triggers when a user jumps to a new page
			// event: the onkeydown event
			e = dojo.fixEvent(e, e.target);
			var key = e.keyCode;
		
			if(key == dojo.keys.ENTER){
				var input = this.jumpToInput.value;
				// if number is not an integer, return
				if(input.toString().search(/^[0-9]+$/) != 0)  return;
				// if number is less than 1, set it to 1
				if(input < 1) input = 1;
				
				// calculate the new starting index for result items and make sure it's within range
				var userInputStart = (input - 1) * this.size;
				var maxStart = (Math.ceil(this.totalItemCount/this.size) - 1) * this.size;
				this.start = (userInputStart < maxStart)?userInputStart:maxStart;
				// search with the new starting index
				this._search();
			}
		},
		
		adjustPagingBar: function(){
			// summary: triggers when a search is performed to make sure the numbers and contents of the bar match up
			var firstItem = (this.totalItemCount == 0)?0:this.start + 1;
			var lastItem = this.start + this.size;
			lastItem = (this.totalItemCount > lastItem)?lastItem:this.totalItemCount;
			
			// displays "Page X of Y" in the paging bar
			var currentPage = Math.ceil(firstItem/this.size);
			var totalPageCount = Math.ceil(this.totalItemCount/this.size);
			this.pagingStatus.innerHTML = dojo.string.substitute(this.shelfBundle["shelf_page"], [currentPage, totalPageCount]);
			
			// create Previous and Next links , and Jump to page ___  if appropriate
			this.createPrevNode(firstItem);
			this.createNextNode(lastItem);
			if(this.totalItemCount > this.size) this.createJumpTo(firstItem);
		},
		
		createPrevNode: function(/*Int*/firstItem){
			// summary: determines if a Previous link should be rendered and creates it if appropriate
			if(firstItem > 1){  // create a link
				var prev = dojo.create("a", {href:"javascript:void(0)",innerHTML:this.shelfBundle["shelf_previous"]});
				prev.onclick = this._createPrevNodeEventHandlers().onclick;
				this.prevLink.appendChild(prev);
			}
			else  // create unclickable text
				this.prevLink.appendChild(document.createTextNode(this.shelfBundle["shelf_previous"]));
		},
		
		_createPrevNodeEventHandlers: function () {
			return {
				onclick: dojo.hitch(this, function(){ this.prev(); return false; /* to prevent onBeforeUnload event from triggering in IE */ })
			};
		},
		
		createNextNode: function(/*Int*/lastItem){
			// summary: determines if a Next link should be rendered and creates it if appropriate
			if(this.totalItemCount > lastItem){  // create a link
				var next = dojo.create("a", {href:"javascript:void(0)",innerHTML:this.shelfBundle["shelf_next"]});
				next.onclick = this._createNextNodeEventHandlers().onclick;
				this.nextLink.appendChild(next);
			}
			else // create unclickable text
				this.nextLink.appendChild(document.createTextNode(this.shelfBundle["shelf_next"]));
		},
		
		_createNextNodeEventHandlers: function () {
			return {
				onclick: dojo.hitch(this, function(){ this.next(); return false; /* to prevent onBeforeUnload event from triggering in IE */ })
			};
		},
		
		createJumpTo: function(firstItem){
			// summary: if there is  more than one page available, this creates a "Jump to page ___" input
			this.jumpToInput = dojo.create("input",{type:"text",value:Math.ceil(firstItem/this.size),className:"lotusText","id":this.parent.id+"_jumpTo"});
			dojo.connect(this.jumpToInput, "onkeydown", this, this.jumpTo);
			this.jumpToLink.appendChild(dojo.create("label",{"innerHTML":this.shelfBundle["shelf_jumpTo"],"for":this.parent.id+"_jumpTo"}));
			this.jumpToLink.appendChild(this.jumpToInput);
		},
		
		destroy: function(){
			dojo.forEach(this.events, dojo.unsubscribe);
			this.events = null;
			this.inherited(arguments);
		}
});

}

if(!dojo._hasResource["com.ibm.customize.SearchBar"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.customize.SearchBar"] = true;
// This is an input box which publishes all the words of the input's value as an array to a given event

dojo.provide("com.ibm.customize.SearchBar");





dojo.declare("com.ibm.customize.SearchBar",
	[dijit._Widget, dijit._Templated],
	{
		imagePath: ".",
		searchId: "",
		searchFieldText: "",
		searching: true,
		events: [],
		publishKeyword: "/epc/customize/search",	// the keyword to publish when a string is submitted
		templateString: '<div dojoAttachPoint="focusNode" class="lotusChunk lotusSearch">' +
							'<form role="search" action="" onsubmit="return false">' +
								'<label for="${searchBoxId}" class="ibmHiddenText" dojoAttachPoint="searchFieldLabel">${searchFieldText}</label>' +
								'<input id="${searchBoxId}" dojoAttachEvent="onkeydown:newSearch" class="lotusText" type="text" value="${searchFieldText}" onfocus="this.value=\'\';" dojoAttachPoint="searchField"/>' +
								'<span class="lotusBtnImg" title="${submitSearchText}">' +
									'<input dojoAttachEvent="onclick:searchButton" class="lotusSearchButton" type="image" alt="${submitSearchText}" src="${imagePath}/blank.gif"/>' +
									'<span class="lotusAltText">Search</span>' +
								'</span>' +
							'</form>' +
						'</div>',
		
		constructor: function() {
			this.bundle = dojo.i18n.getLocalization("com.ibm.bundles", "Shelf");
			this.submitSearchText = this.bundle["shelf_submitSearch"];
		},
		
		postMixInProperties: function(){
			this.searchBoxId = this.searchId + "_search";
		},
		
		postCreate: function(){
			// summary: subscribe to the event that changes the default text in the search box
			this.events.push(dojo.subscribe("/epc/customize/changeSource"+this.searchId, this, this.changeInputValue));
		},
		
		enableSearch: function(){
			if(!this.searching){
				this.searching = true;
				dojo.style(this.searchField, "backgroundColor", "#FFFFFF");
				dojo.style(this.searchField, "borderColor", "#FFFFFF");
				this.searchField.removeAttribute("disabled");
			}
		},
		
		disableSearch: function(){
			if(this.searching){
				this.searching = false;
				dojo.style(this.searchField, "backgroundColor", "#CCCCCC");
				dojo.style(this.searchField, "borderColor", "#CCCCCC");
				dojo.attr(this.searchField, "disabled", true);
			}
		},
		
		changeInputValue: function(/*Object*/source){
			// summary: changes the text in the field
			if(source.hub.searchable) this.enableSearch();
			else this.disableSearch();
			if(source.searchStr) this.searchFieldText = source.hub.searchable ? source.searchStr : "";
			else this.searchFieldText = source.hub.searchable ? dojo.string.substitute(this.bundle["shelf_search"], [source.label]) : "";
			this.searchField.value = this.searchFieldLabel.innerHTML = this.searchFieldText;
		},
		
		newSearch: function(/*Event*/e){
			// summary: triggers when a user is typing 
			// Publishes an event when the user presses the enter key
			e = dojo.fixEvent(e, e.target);
			var key = e.keyCode;
		
			if(dojo.isIE && key == dojo.keys.ENTER)
				this.searchButton();
		},
		
		searchButton: function(){
			// summary: creates an array of the space separated search terms and publishes them to an event
			if(this.searching){
				var searchWords = (this.searchField.value == this.searchFieldText) ? "" : this.searchField.value;  // no search criteria if field = "Search xxxx"
				var searchArray = searchWords.split(" ");
				// publish the event to a specific id so not all instances of the receiving class respond
				dojo.publish(this.publishKeyword+this.searchId, [searchArray]);
			}
		},
		
		destroy: function(){
			dojo.forEach(this.events, dojo.unsubscribe);
			this.events = null;
			this.inherited(arguments);
		}
});

}

if(!dojo._hasResource["dojo.fx.easing"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.fx.easing"] = true;
dojo.provide("dojo.fx.easing");

dojo.fx.easing = {
	// summary: 
	//		Collection of easing functions to use beyond the default 
	//		`dojo._defaultEasing` function.
	// 
	// description:
	//
	//		Easing functions are used to manipulate the iteration through
	//		an `dojo.Animation`s _Line. _Line being the properties of an Animation,
	//		and the easing function progresses through that Line determing
	//		how quickly (or slowly) it should go. Or more accurately: modify
	//		the value of the _Line based on the percentage of animation completed.
	//	
	//		All functions follow a simple naming convention of "ease type" + "when".
	//		If the name of the function ends in Out, the easing described appears
	//		towards the end of the animation. "In" means during the beginning,
	//		and InOut means both ranges of the Animation will applied, both
	//		beginning and end. 
	//
	//		One does not call the easing function directly, it must be passed to 
	//		the `easing` property of an animation.
	//
	//	example:
	//	|	
	//	|	var anim = dojo.fadeOut({
	//	|		node: 'node',	
	//	|		duration: 2000,
	//	|		//	note there is no () 
	//	|		easing: dojo.fx.easing.quadIn
	//	|	}).play();
	//
	
	linear: function(/* Decimal? */n){
		// summary: A linear easing function
		return n;
	},

	quadIn: function(/* Decimal? */n){
		return Math.pow(n, 2);
	},

	quadOut: function(/* Decimal? */n){
		return n * (n - 2) * -1;
	},

	quadInOut: function(/* Decimal? */n){
		n = n * 2;
		if(n < 1){ return Math.pow(n, 2) / 2; }
		return -1 * ((--n) * (n - 2) - 1) / 2;
	},

	cubicIn: function(/* Decimal? */n){
		return Math.pow(n, 3);
	},

	cubicOut: function(/* Decimal? */n){
		return Math.pow(n - 1, 3) + 1;
	},

	cubicInOut: function(/* Decimal? */n){
		n = n * 2;
		if(n < 1){ return Math.pow(n, 3) / 2; }
		n -= 2;
		return (Math.pow(n, 3) + 2) / 2;
	},

	quartIn: function(/* Decimal? */n){
		return Math.pow(n, 4);
	},

	quartOut: function(/* Decimal? */n){
		return -1 * (Math.pow(n - 1, 4) - 1);
	},

	quartInOut: function(/* Decimal? */n){
		n = n * 2;
		if(n < 1){ return Math.pow(n, 4) / 2; }
		n -= 2;
		return -1 / 2 * (Math.pow(n, 4) - 2);
	},

	quintIn: function(/* Decimal? */n){
		return Math.pow(n, 5);
	},

	quintOut: function(/* Decimal? */n){
		return Math.pow(n - 1, 5) + 1;
	},

	quintInOut: function(/* Decimal? */n){
		n = n * 2;
		if(n < 1){ return Math.pow(n, 5) / 2; };
		n -= 2;
		return (Math.pow(n, 5) + 2) / 2;
	},

	sineIn: function(/* Decimal? */n){
		return -1 * Math.cos(n * (Math.PI / 2)) + 1;
	},

	sineOut: function(/* Decimal? */n){
		return Math.sin(n * (Math.PI / 2));
	},

	sineInOut: function(/* Decimal? */n){
		return -1 * (Math.cos(Math.PI * n) - 1) / 2;
	},

	expoIn: function(/* Decimal? */n){
		return (n == 0) ? 0 : Math.pow(2, 10 * (n - 1));
	},

	expoOut: function(/* Decimal? */n){
		return (n == 1) ? 1 : (-1 * Math.pow(2, -10 * n) + 1);
	},

	expoInOut: function(/* Decimal? */n){
		if(n == 0){ return 0; }
		if(n == 1){ return 1; }
		n = n * 2;
		if(n < 1){ return Math.pow(2, 10 * (n - 1)) / 2; }
		--n;
		return (-1 * Math.pow(2, -10 * n) + 2) / 2;
	},

	circIn: function(/* Decimal? */n){
		return -1 * (Math.sqrt(1 - Math.pow(n, 2)) - 1);
	},

	circOut: function(/* Decimal? */n){
		n = n - 1;
		return Math.sqrt(1 - Math.pow(n, 2));
	},

	circInOut: function(/* Decimal? */n){
		n = n * 2;
		if(n < 1){ return -1 / 2 * (Math.sqrt(1 - Math.pow(n, 2)) - 1); }
		n -= 2;
		return 1 / 2 * (Math.sqrt(1 - Math.pow(n, 2)) + 1);
	},

	backIn: function(/* Decimal? */n){
		// summary: 
		//		An easing function that starts away from the target, 
		//		and quickly accelerates towards the end value.
		// 
		//		Use caution when the easing will cause values to become 
		//		negative as some properties cannot be set to negative values.
		var s = 1.70158;
		return Math.pow(n, 2) * ((s + 1) * n - s);
	},

	backOut: function(/* Decimal? */n){
		// summary: 
		//		An easing function that pops past the range briefly, and slowly comes back. 
		//
		// description:
		//		An easing function that pops past the range briefly, and slowly comes back. 
		//
		//		Use caution when the easing will cause values to become negative as some 
		//		properties cannot be set to negative values.
		
		n = n - 1;
		var s = 1.70158;
		return Math.pow(n, 2) * ((s + 1) * n + s) + 1;
	},

	backInOut: function(/* Decimal? */n){
		// summary: 
		//		An easing function combining the effects of `backIn` and `backOut`
		//
		// description:
		//		An easing function combining the effects of `backIn` and `backOut`.
		//		Use caution when the easing will cause values to become negative 
		//		as some properties cannot be set to negative values.
		var s = 1.70158 * 1.525;
		n = n * 2;
		if(n < 1){ return (Math.pow(n, 2) * ((s + 1) * n - s)) / 2; }
		n-=2;
		return (Math.pow(n, 2) * ((s + 1) * n + s) + 2) / 2;
	},

	elasticIn: function(/* Decimal? */n){
		// summary: 
		//		An easing function the elastically snaps from the start value
		//
		// description:
		//		An easing function the elastically snaps from the start value
		//	
		//		Use caution when the elasticity will cause values to become negative 
		//		as some properties cannot be set to negative values.
		if(n == 0 || n == 1){ return n; }
		var p = .3;
		var s = p / 4;
		n = n - 1;
		return -1 * Math.pow(2, 10 * n) * Math.sin((n - s) * (2 * Math.PI) / p);
	},

	elasticOut: function(/* Decimal? */n){
		// summary: 
		//		An easing function that elasticly snaps around the target value,
		//		near the end of the Animation
		//
		// description:
		//		An easing function that elasticly snaps around the target value,
		//		near the end of the Animation
		//
		//		Use caution when the elasticity will cause values to become 
		//		negative as some properties cannot be set to negative values.
		if(n==0 || n == 1){ return n; }
		var p = .3;
		var s = p / 4;
		return Math.pow(2, -10 * n) * Math.sin((n - s) * (2 * Math.PI) / p) + 1;
	},

	elasticInOut: function(/* Decimal? */n){
		// summary: 
		//		An easing function that elasticly snaps around the value, near
		//		the beginning and end of the Animation.
		//
		// description:
		//		An easing function that elasticly snaps around the value, near
		//		the beginning and end of the Animation.
		//
		//		Use caution when the elasticity will cause values to become 
		//		negative as some properties cannot be set to negative values.
		if(n == 0) return 0;
		n = n * 2;
		if(n == 2) return 1;
		var p = .3 * 1.5;
		var s = p / 4;
		if(n < 1){
			n -= 1;
			return -.5 * (Math.pow(2, 10 * n) * Math.sin((n - s) * (2 * Math.PI) / p));
		}
		n -= 1;
		return .5 * (Math.pow(2, -10 * n) * Math.sin((n - s) * (2 * Math.PI) / p)) + 1;
	},

	bounceIn: function(/* Decimal? */n){
		// summary: 
		//		An easing function that 'bounces' near the beginning of an Animation
		return (1 - dojo.fx.easing.bounceOut(1 - n)); // Decimal
	},

	bounceOut: function(/* Decimal? */n){
		// summary:
		//		An easing function that 'bounces' near the end of an Animation
		var s = 7.5625;
		var p = 2.75;
		var l; 
		if(n < (1 / p)){
			l = s * Math.pow(n, 2);
		}else if(n < (2 / p)){
			n -= (1.5 / p);
			l = s * Math.pow(n, 2) + .75;
		}else if(n < (2.5 / p)){
			n -= (2.25 / p);
			l = s * Math.pow(n, 2) + .9375;
		}else{
			n -= (2.625 / p);
			l = s * Math.pow(n, 2) + .984375;
		}
		return l;
	},

	bounceInOut: function(/* Decimal? */n){
		// summary: 
		//		An easing function that 'bounces' at the beginning and end of the Animation
		if(n < 0.5){ return dojo.fx.easing.bounceIn(n * 2) / 2; }
		return (dojo.fx.easing.bounceOut(n * 2 - 1) / 2) + 0.5; // Decimal
	}
};

}

if(!dojo._hasResource["dojox.fx.easing"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojox.fx.easing"] = true;
dojo.provide("dojox.fx.easing");
dojo.deprecated("dojox.fx.easing","Upgraded to Core, use dojo.fx.easing instead","2.0");

/*=====
	dojox.fx.easing = {
		// summary:
		//		An Alias to `dojo.fx.easing`. Moved to Core in Dojo 1.2.
	};
=====*/
dojox.fx.easing = dojo.fx.easing;

}

if(!dojo._hasResource["com.ibm.customize.Menu"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.customize.Menu"] = true;
// This is a menu.  It takes a list of sources that each have label attributes to use as display titles.  It publishes an event on a source each time one is clicked.
dojo.provide("com.ibm.customize.Menu");








dojo.declare("com.ibm.customize.Menu",
	[dijit._Widget, dijit._Templated],
	{
		sources: [],									// an array of objects containing labels and datastore hubs for each menu choice
		choices: {},									// a map of label : DOMNode pairs for each choice in the menu
		searchId: "",									// the id of the Container to search within
		menuTitle: "Menu",								// title for the menu
		current: null,									// the menu choice currently selected
		blankImg: "",									// path to a clear pixel
		selectedText: "currently selected category",
		unselectedText: "press enter to browse this category",
		publishKeyword: "/epc/customize/changeSource",	// the keyword to publish to add a filter
		templateString: '<div dojoAttachPoint="focusNode">' +
							'<h3>' +
								'<a dojoAttachPoint="back" title="back" class="lotusBtnImg lotusHidden" href="javascript:void(0)">' +
									'<img alt="${backText}" src="${blankImg}">' +
									'<span class="lotusAltText">${backText}</span>' +
								'</a>' +
								' ${menuTitle}' +
							'</h3>' +
							'<div role="menu" dojoAttachPoint="menuContainer" class="lotusMenu">' +
								'<ul dojoAttachPoint="list"></ul>' +
							'</div>' + 
						'</div>',
		
		constructor: function() {
			this.bundle = dojo.i18n.getLocalization("com.ibm.bundles", "Shelf");
			this.menuTitle = this.bundle["shelf_menu"];
			this.selectedText = this.bundle["menu_selected_text"] || this.selectedText;
			this.unselectedText = this.bundle["menu_unselected_text"] || this.unselectedText;
			this.backText = this.bundle["menu_back"] || "Back";
		},
	
		postCreate: function(){
			// summary: populates the menu with the given choices
			this.back.onclick = dojo.hitch(this,function(){this.backOneLevel();return false;});
			this.processSources(this.sources);
		},
		
		processSources: function(sources){
			dojo.empty(this.list);
			if(this.sources.length > 0) {
				// add the choices to the menu with the first choice selected
				dojo.forEach(sources, dojo.hitch(this, function(choice){ this.addLi(choice); }));
				if(!sources[0].categories) this.select(sources[0]);  // select if it's a datastore
				else dojo.publish(this.publishKeyword+this.searchId, [{hub:{searchable:false},label:sources[0].label}]);  // parent category
			}
		},
		
		addLi: function(/*Object*/choice){
			// summary: adds a new element to the list of choices in the menu
			// choice: a member of the choices array to add to the menu
			var li = dojo.create("li");
			if(choice.categories) dojo.addClass(li,"lotusMore");
			var evtHandlers = this._createLiEventHandlers(choice);
			var newLink = dojo.create("a",{href:"javascript:void(0)",innerHTML:choice.label});
			newLink.onclick = evtHandlers.anchorOnclick;
			li.appendChild(newLink);
			var selectedSpan = dojo.create("span",{innerHTML:this.unselectedText,className:"",className:"ibmHiddenText"});
			newLink.appendChild(selectedSpan);
			// when the menu item is clicked, call the select function on it
			dojo.connect(li, 'onclick', evtHandlers.liOnclick);
			// add the new item to DOM and the map of choices
			this.list.appendChild(li);
			this.choices[choice.url] = {li:li,span:selectedSpan};
		},
		
		_createLiEventHandlers: function (choice) {
			return {
				anchorOnclick: function(){ return false; /* to prevent onBeforeUnload event from triggering in IE */ },
				liOnclick: dojo.hitch( this, function(){ this.select(choice); })
			};
		},
		
		select: function(/*Object*/source){
			// summary: triggered by a menu click,
			// source: the menu choice that was clicked
			if(source.categories){
				this.processSources(source.categories);  // drill down
				dojo.removeClass(this.back,"lotusHidden");  // show back button
			} else {
				// publish the event to a specific id so not all instances of the receiving class respond
				dojo.publish(this.publishKeyword+this.searchId, [source]);  // search
				this.changeHighlighting(source);
			}
		},
		
		backOneLevel: function(){
			// summary: drills back up one level
			this.processSources(this.sources);
			dojo.addClass(this.back,"lotusHidden");
		},
		
		changeHighlighting: function(/*String*/source){
			// summary: switches which menu choice is selected
			// source: the menu choice that was chosen
			if(source.categories) return;  // parent categories are never highlighted
			if(this.current) {
				dojo.removeClass(this.choices[this.current].li, "lotusSelected");
				this.choices[this.current].span.innerHTML = this.unselectedText;
			}
			dojo.addClass(this.choices[source.url].li, "lotusSelected");
			this.choices[source.url].span.innerHTML = this.selectedText;
			this.current = source.url;
		}
});

}

if(!dojo._hasResource["com.ibm.pb.customize.LotusDialog"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.customize.LotusDialog"] = true;
dojo.provide("com.ibm.pb.customize.LotusDialog");

dojo.declare("com.ibm.pb.customize.LotusDialog", [dijit.Dialog], {
    blankImg: "",
    titleText: "",
    okText: "OK",
    destroyOnClose: false,
    templateString: '<div class="lotusDialogBorder lotusui" waistate="labelledby-${id}" wairole="dialog" role="dialog" index="-1" aria-labelledby="${id}">' +
    '<div class="lotusDialog">' +
    '<h1>' +
    '<a href="javascript:void(0);" dojoAttachPoint="closeButtonNode" class="lotusBtnImg lotusClose" title="${closeText}">' +
    '<img src="${blankImg}" aria-label="${closeText}" alt=""/>' +
    '<span class="lotusAltText">X</span>' +
    '</a>' +
    '<span dojoAttachPoint="titleNode">${titleText}</span>' +
    '</h1>' +
    '<div class="lotusDialogContent" dojoAttachPoint="containerNode"></div>' +
    '<div class="lotusDialogFooter">' +
    '<input value="${okText}" class="lotusFormButton" dojoAttachPoint="submitNode" type="submit" dojoAttachEvent="onclick: submit"/> ' +
    '<a href="javascript:void(0);" dojoAttachPoint="closeLinkNode" class="lotusAction">${cancelText}</a>' +
    '</div>' +
    '</div>' +
    '</div>',
    
    postMixInProperties: function(){
        this.nlsBundle = dojo.i18n.getLocalization("com.ibm.bundles", "Shelf");
        this.closeText = this.nlsBundle["shelf_closeDialog"];
        this.cancelText = this.nlsBundle["add_content_cancel"];
    },
    
    onSubmit: function(){
    },
    
    submit: function(){
        this.onSubmit();
    },
    
    cancel: function(){
        this.hide();
        if (this.destroyOnClose && !this._destroyingOnClose) {
            this._destroyingOnClose = true; // protect from potential recursive loops
            this.destroy();
        }
    },
    
    setContent: function(content, title, okText, submitFcn){
        dojo.empty(this.containerNode);
        if (dojo.isString(content)) 
            content = document.createTextNode(content);
        this.containerNode.appendChild(content);
        this.titleNode.innerHTML = title || this.titleText;
        this.submitNode.value = okText || this.okText;
        this.onSubmit = submitFcn ||
        function(){
        };
        this.show();
    }
});

}

if(!dojo._hasResource["com.ibm.pb.customize.LotusWaitingDialog"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.customize.LotusWaitingDialog"] = true;
dojo.provide("com.ibm.pb.customize.LotusWaitingDialog");


dojo.declare("com.ibm.pb.customize.LotusWaitingDialog", [com.ibm.pb.customize.LotusDialog], {
    spinner: "",
    message: "",
    destroyOnClose: true,
    templateString: '<div class="lotusDialogBorder lotusui" waistate="labelledby-${id}" wairole="dialog" role="dialog" index="-1" aria-labelledby="${id}">' +
    '<div class="lotusDialog">' +
    '<div class="lotusDialogContent" dojoAttachPoint="containerNode">' +
    '<img src="${spinner}" alt="${loadingText}" title="${loadingText}"/>' +
    '${message}' +
    '</div>' +
    '</div>' +
    '</div>',
    
    postMixInProperties: function(){
        this.nlsBundle = dojo.i18n.getLocalization("com.ibm.bundles", "Shelf");
        this.loadingText = this.nlsBundle["shelf_loading"];
        this.message = "      " + this.message;
    },
    
    show: function(){
        if (!this.domNode) 
            return;
        var me = this;
//        setTimeout(function(){
//            if (me.open) 
//                dijit._underlay.show();
//        }, this.duration + 200); // make sure underlay is visible
//cause memory leak (defect 19322), since this is a quick disappear dialog, remove it.
        this.inherited(arguments);
    }
});

}

if(!dojo._hasResource["com.ibm.pb.customize.LotusPaletteContainer"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.customize.LotusPaletteContainer"] = true;
// This is a container which follows the one ui lotus palette spec
// must be provided with a processChange function
dojo.provide("com.ibm.pb.customize.LotusPaletteContainer");












dojo.declare("com.ibm.pb.customize.LotusPaletteContainer",
	[dijit._Widget, dijit._Templated],
	{
		jsonFile: null,				// a JSON configuration file
		dialog: null,				// a dijit dialog
		maxLabelLength: 16,			// the maximum length allowed for a label
		smallWidget: false,			// false if it follows the lotusLargeWidget pattern
		numRows: 4,					// the number of rows of results to be displayed
		label: "",					// a label for this palette section
		selectedClass: "lotusSelected",
		imagePath: ".",
		draggable: false,			// true if items can be dragged off the shelf, will only work with Portal dnd
		size: null,
		dndType: "ibmPortalShelfItem",		// dnd type of items that are draggable
		templateString:'<div class="lotusui">' +
							'<div class="lotusPaletteBody">' +
								'<div dojoAttachPoint="left" class="lotusPaletteNav"></div>' +
								'<div dojoAttachPoint="center" class="lotusPaletteContent lotusui"></div>' +
							'</div>' +
						'</div>',
						
		constructor: function() {
			this.nlsBundle = dojo.i18n.getLocalization("com.ibm.bundles", "Shelf");
		},
		
		postMixInProperties: function() {
			if(this.smallWidget) {
				this.dialog = new com.ibm.pb.customize.LotusDialog({ blankImg:this.imagePath + "/blank.gif" });
				this.dialog.closeButtonNode.onclick = this.dialog.closeLinkNode.onclick = dojo.hitch(this,function(){this.dialog.cancel();return false;});
			}
		},
		
		processChange: function(/*Object*/args) {
		},
		
		getSize: function(){
			// summary: determine the width of a palette widget element on the page with all the current settings by adding one to the page, taking its width, then deleting it
			// use the palette widget to determine how many of them can fit in the ResultsList
			if(this.size) { return this.size; }
			var paletteWidget = dojo.create("div",{className:"lotusPaletteWidget"});
			document.body.appendChild(paletteWidget);
			if (paletteWidget.currentStyle){
				marginL = paletteWidget.currentStyle["marginLeft"].match(/^\d+/);
				marginR = paletteWidget.currentStyle["marginRight"].match(/^\d+/);
			} else if (window.getComputedStyle) {
				marginL = document.defaultView.getComputedStyle(paletteWidget,null).getPropertyValue("margin-left").match(/^\d+/);
				marginR = document.defaultView.getComputedStyle(paletteWidget,null).getPropertyValue("margin-right").match(/^\d+/);
			} 
			var width = paletteWidget.offsetWidth + marginL*1 + marginR*1;
			this.left.innerHTML = ".";
			var containerWidth = this.center.offsetWidth;
			this.left.innerHTML = "";
			var resultsInOneRow = Math.floor(containerWidth / width);
			dojo.destroy(paletteWidget);
			this.size = resultsInOneRow * this.numRows;
			return this.size;
		},
		
		destroyChildWidgets: function(){
			this.resultsList.destroy();
			this.resultsList = null;
			this.searchBar.destroy();
			this.searchBar = null;
			this.menu.destroy();
			this.menu = null;
			this.started = false;
		},
		
		setupUI: function(){
			// summary: starts the UI setup
			this.processJSON(dojo.hitch(this,this.setupUICallback));
		},
		
		setupUICallback: function(sources){
			// summary: populates the SearchBar, Menu and ResultsList widget with configuration data from the JSON file
			this.resultsList = new com.ibm.customize.ResultsList({parent:this,size:this.getSize(),draggable:this.draggable,dndType:this.dndType});
			this.center.appendChild(this.resultsList.domNode);
				
			this.searchBar = new com.ibm.customize.SearchBar({searchId:this.id,imagePath:this.imagePath});
			this.left.appendChild(this.searchBar.domNode);
				
			this.menu = new com.ibm.customize.Menu({sources:sources,searchId:this.id,menuTitle:this.label,blankImg:this.imagePath + "/blank.gif"});
			this.left.appendChild(this.menu.domNode);
		},
		
		processJSON: function(/*function*/callback){
			// summary: processes the JSON file associated with this controller
			// callback: function to call after the JSON is processed that uses the sourceObjects
			dojo.xhrGet ({
		        url: this.jsonFile,
		        handleAs: 'json',
		        load: dojo.hitch(this, function(data){
					// get the bundle if one is provided
					if(data.localizationPackageName && data.localizationBundleName){
						this.nlsJsonBundle = dojo.i18n.getLocalization(data.localizationPackageName, data.localizationBundleName);
					} else this.nlsJsonBundle = null;
					var sources = data.categories;
					var sourceObjects = [];
					for(var i = 0, l = sources.length; i < l; i++) {
						if(sources[i].categories){
							var childSourceObjects = [];
							var childSources = sources[i].categories;
							for(var j = 0, l2 = childSources.length; j < l2; j++){
								var source = this.processCategory(childSources[j]);
								if(source) childSourceObjects.push(source);
							}
							if(childSourceObjects.length > 0) {
								var label = this.getNlsString(sources[i].label,this.nlsBundle["add_content_untitled"]);
								sourceObjects.push({label:label,categories:childSourceObjects});
							}
						} else {
							var source = this.processCategory(sources[i]);							
							if(source) sourceObjects.push(source);
						}
					}
					if(callback) callback(sourceObjects);
				}),	
		        error: dojo.hitch(this, function (/*String*/error) {
					console.error("error loading categories: " +error);
		            var errorMsg = this.createLotusMsgNode(this.nlsBundle["shelf_configError"],"Error");
					dojo.style(errorMsg,"margin","20px");
					this.domNode.innerHTML = "";
					this.domNode.appendChild(errorMsg);
		        })
		    });
		},
		
		processCategory: function(source){
			// pass the exact same sources item to the class's constructor minus the datastore and renderers properties
			var map = dojo.mixin({}, source);
			if(map.url && this.createProxyURI) map.url = this.createProxyURI(map.url);
			delete map.datastore; delete map.renderers; delete map.label;
			// create a datastore hub and a new source object
			var hub = new (dojo.getObject(source.datastore))(map);
			
			if(!hub.validateSelf()) return null;  // do not use this source if it does not validate
			if(hub.getSourceLabel()) var label = hub.getSourceLabel();  // get dynamic label
			else var label = this.getNlsString(source.label,this.nlsBundle["add_content_untitled"]);
			var searchStr = this.getNlsString(source.searchStr,null);
			return {label:label,hub:hub,renderers:source.renderers,url:source.url,searchStr:searchStr};
		},
		
		getNlsString: function(key, defaultStr){
			var value = this.nlsJsonBundle && this.nlsJsonBundle[key] ? this.nlsJsonBundle[key] : key;
			if(value && value.length == 0) value = defaultStr;
			return value;
		},
		
		newCell: function(/*Object*/source,/*DataItem*/item){
			// summary:  override this function to fill innerCell with information about the given datastore item
			// source: a datastore
			// item: an item in source
			var map = source.hub.mapItem(item);
			
			var label = (map.label.length > this.maxLabelLength)?map.label.substring(0,this.maxLabelLength) + '...':map.label;
			if(this.smallWidget) {
				var applyToPage = dojo.hitch(this, function(cID,sID) { this.processIntermediateDialogs(map,source,item,cID,sID); });
				showDetails = dojo.hitch(this, function() { this.showDetailsDialog(map,applyToPage); return false; /* to prevent onBeforeUnload event from triggering in IE */ });
				
				var context = {hub:source.hub, item:item, map:map, truncTitleText:label, imagePath:this.imagePath, apply:applyToPage, showDetails:showDetails};
				if(source.hub.noIcons){
					var widget = new com.ibm.pb.customize.noIconSmallWidget(context);
				} else if(source.hub.namespace == "feed") {
					var widget = new com.ibm.pb.customize.feedSmallWidget(context);
				} else {
					if(ibmCfg.portalConfig.portalContext) {
						var widget = new com.ibm.pb.customize.smallWidget(context);
					} else {
						var widget = new com.ibm.pb.customize.smallMenuWidget(context);
					}
				}
			}
			else {
				var applyToPage = dojo.hitch(this, function() { this.processChange(dojo.mixin(map,{hub:source.hub, item:item})) });
				var widget = new com.ibm.pb.customize.largeWidget({map:map, truncTitleText:label, imagePath:this.imagePath, apply:applyToPage, current:map.id == this.current});
			}
			return widget.domNode;
		},
		
		createLotusMsgNode: function(/*string*/message,/*string*/type){
			// summary: returns a div node containing the given message with OneUI styles
			// msg: the error message to display
			// type: either "Warning", "Error", "Info" or "Confirm"
			var err = dojo.create("div",{className:"lotusMessage lotus" + type, style:{ marginRight:"15px"}, role: "alert"});
			var img = dojo.create("img",{src:this.imagePath + "/icon" + type + ".gif", alt:message});
			var msg = dojo.create("span",{innerHTML:message});
			err.appendChild(img);
			err.appendChild(msg);
			return err;
		},
		
		changeSelected: function(/*string*/selected){
			// reset the look of the previously selected style/layout
			var items = dojo.query(".lotusPaletteWidget",this.center), selectedWidget = null;
			dojo.forEach(items, dojo.hitch(this, function(item){
				selectedWidget = dijit.byId(item.id);
				if(selectedWidget) selectedWidget.deselect();
			}));
			selectedWidget = dijit.byId(selected);
			if(selectedWidget) selectedWidget.select();
		},
		
		/**********************************/
		/*        DIALOG HELPERS          */
		/**********************************/
		
		processIntermediateDialogs: function(/*MapItem*/map,/*Object*/source,/*DataItem*/item,/*string*/cID,/*string*/sID){
			// source: a datastore
			// item: an item in source's hub
			if(source.renderers.length == 0){
				// if there are no renderers defined, then this is a self renderer and we assume the item's id is the id of the piece of content to be added
				var takeoverObject = map.takeoverFcn ? {submit:dojo.hitch(this,this.processChange),getInfo:dojo.hitch(this,this.getValuesFromDialog),showInfo:dojo.hitch(this,this.showWaitMsgInDialog),submitObj:{hub:source.hub,item:item,sID:sID,cID:cID}} : {};
				var args = dojo.mixin(map,{takeoverObject:takeoverObject,sID:sID,cID:cID,hub:source.hub,item:item});
				this.processChange(args);
			} else if(source.renderers.length == 1){ 
				// if there is only one renderer available, add it
                var dataLabel = map.label;
				var args = dojo.mixin(dojo.mixin(map,source.renderers[0]),{label:dataLabel,prefsMapFcn:source.renderers[0].fcn,sID:sID,cID:cID,hub:source.hub,item:item});
				this.processChange(args);
			} else {
				// an intermediate dialog box is opened for the user to choose the desired renderer
				var content = dojo.create("div");
				var header = dojo.create("h4");
				var headerLabel = dojo.create("label",{"for":"widgetRendererSelect",innerHTML:this.nlsBundle["add_content_selectRenderer"]});
				header.appendChild(headerLabel);
				content.appendChild(header);
				var rendererSelect = dojo.create("select",{id:"widgetRendererSelect"});
				content.appendChild(rendererSelect);
				for(var i = 0; i < source.renderers.length; i++){
					var select = dojo.create("option",{innerHTML:this.nlsJsonBundle && this.nlsJsonBundle[source.renderers[i].label] ? this.nlsJsonBundle[source.renderers[i].label] : source.renderers[i].label,value:i});
					rendererSelect.appendChild(select);
				}
				var onSubmit = dojo.hitch(this, function(){ 
					this.dialog.cancel();
					var renderer = source.renderers[rendererSelect.value];
                    var dataLabel = map.label; 
					var args = dojo.mixin(dojo.mixin(map,renderer),{label:dataLabel,prefsMapFcn:renderer.fcn,sID:sID,cID:cID,hub:source.hub,item:item});
					this.processChange(args);
				});
				this.dialog.setContent(content, this.nlsBundle["add_content_addToPage"], this.nlsBundle["add_content_add"], onSubmit);
			}
		},
		
		showDetailsDialog: function(/*Object*/itemMap,/*Function*/submitFcn){
			// summary: prepares the markup for the popup dialog to display details.  
			// itemMap: a map of information on the content from the mapItem function of the CatalogMixin class
			// submitFcn: the function to call when the submit button on the dialog is clicked
			var content = dojo.create("div");
			var title = dojo.create("h4",{innerHTML:(itemMap.label)?itemMap.label:this.nlsBundle["add_content_untitled"]});
			content.appendChild(title);
			if(itemMap.updated) {
				var updated = dojo.create("p",{innerHTML:dojo.string.substitute(this.nlsBundle["add_content_lastMod"], [itemMap.updated])});
				content.appendChild(updated);
			}
			if(itemMap.description){ 
				var desc = dojo.create("p",{innerHTML:itemMap.description});
				content.appendChild(desc);
			}
			if(itemMap.tags && itemMap.tags.length > 0){ 
				var tags = dojo.create("p",{innerHTML:dojo.string.substitute(this.nlsBundle["add_content_tags"], [itemMap.tags.join(", ")])});
				content.appendChild(tags);
			}
			var submit = dojo.hitch(this, function(){ this.dialog.cancel(); submitFcn(); });
			this.dialog.setContent(content, this.nlsBundle["add_content_details"], this.nlsBundle["add_content_addToPage"], submit);
		},
		
		showWaitMsgInDialog: function(/*String*/message){
			// summary: abstracts the use of the popup dialog by displaying a message
			// message: message to display in the dialog
			if(!this.waitingDialog)
			this.waitingDialog = new com.ibm.pb.customize.LotusWaitingDialog({spinner:this.imagePath + "/loading.gif", message:message});
			try {
				this.waitingDialog.show();
			} catch(e) {}
			return dojo.hitch(this,function(){ this.waitingDialog.hide(); });
		},
		
		getValuesFromDialog: function(/*object*/formObjs,/*String*/titleText,/*String*/submitText,/*String*/errorText,/*function*/callback){ 
			// summary: abstracts the use of the popup dialog by dislaying a form of text fields to be filled out
			// formObjs: an array of objects in the form:	label: a label for a text field 
			//												id: an id for the input field
			//												value: a value for the same text field 
			//												regex: a regular expression that the value of the field must validate against
			//												error: an error to display if the value does not validate
			// titleText: text to user as the title of the dialog
			// submitText: text to user on the submit button in the dialog
			// errorText: an optional error message to preface the entire form in the dialog, ie a "try again" error
			// callback: a function to be called when all the fields validate, it is called with an object of key value pairs
			//			 with the labels from the formObjs as keys and their corresponding values from the form as values
			var content = document.createElement("div");
			for(var i = 0; i < formObjs.length; i++){ // add an input for each item in formObjs
				var title = dojo.create("h4");
				var titleLabel = dojo.create("label",{innerHTML:formObjs[i].label, "for":formObjs[i].id});
				var error = dojo.create("div",{className:"lotusFormError"}); formObjs[i].errorDiv = error;
				var additionalClasses = "";
				if (formObjs[i].ltr)
					additionalClasses =" lotusLTR";
				var input = dojo.create("input",{type:"text", id:formObjs[i].id, className:"lotusText" + additionalClasses, value:formObjs[i].value}); formObjs[i].input = input;
				title.appendChild(titleLabel);
				content.appendChild(error);
				content.appendChild(title);
				content.appendChild(input);
			}
			if(errorText) formObjs[0].errorDiv.innerHTML = errorText;
			var validateInputs = dojo.hitch(this, function(){
				var fail = false;
				var values = {};
				for(var i = 0; i < formObjs.length; i++){
					if(!formObjs[i].input.value.match(formObjs[i].regex)){ // if the input does not match the regular expression, display an error
						fail = true;
						formObjs[i].errorDiv.innerHTML = formObjs[i].error;
					} else { // if the input does match the regex, add the input value to the return object
						values[formObjs[i].id] = formObjs[i].input.value;
						formObjs[i].errorDiv.innerHTML = "";
					}
				}
				if(!fail){ // if all the regular expressions matched, run the callback function on the values and close the dialog
					this.dialog.cancel();
					callback(values);				
				}
			});
			this.dialog.setContent(content, titleText, submitText, dojo.hitch(this, function(){ validateInputs(); }));
		}
});

dojo.provide("com.ibm.pb.customize.smallWidget");
dojo.declare("com.ibm.pb.customize.smallWidget",
	[dijit._Widget, dijit._Templated],
	{
		truncTitleText: "",
		imagePath: ".",
		map: {},
		detailDialogInstruction: "press enter to see details dialog",
		templateString: '<div class="lotusPaletteWidget" role="gridcell" dojoAttachPoint="lotusPaletteWidget">' +
							'<div class="lotusInner">' +
								'<div class="lotusIcon">' +
									'<span>' +
										'<img alt="${truncTitleText}" src="${map.thumbnail}"/>' +
									'</span>' +
								'</div>' +
								'<div class="lotusTitle">' +
									'<h4>' +
										'<a href="javascript:void(0);" title="${map.label}" dojoAttachPoint="titleAnchor">' +
											'${truncTitleText}' +
											'<span class="ibmHiddenText">${detailDialogInstruction}</span>' +
										'</a>' +
									'</h4>' +
								'</div>' +
								'<a class="lotusIcon" href="javascript:void(0)" title="${addToPage}" dojoAttachPoint="addButton">' +
									'<img width="16" height="16" src="${blankPath}" alt="${addToPage}"/>' +
									'<span class="lotusAltText">+</span>' +
								'</a>' +
							'</div>' +
						'</div>',
						
		postMixInProperties: function(){
			var bundle = dojo.i18n.getLocalization("com.ibm.bundles", "Shelf");
			this.addToPage = bundle["add_content_addToPage"];
			this.detailDialogInstruction = bundle["detail_dialog_instruction_text"] || this.detailDialogInstruction;
			if (!this.map.thumbnail) {
				this.map.thumbnail = this.imagePath + "/portletIcon.gif";
			} else {
				this.map.thumbnail = com.ibm.mashups.enabler.utils.EndpointHelper.resolve(this.map.thumbnail);
			}
			this.blankPath = this.imagePath + "/blank.gif";
		},
			
		postCreate: function(){ 
			this.titleAnchor.onclick = dojo.hitch(this, function(){ this.showDetails(); return false; });
			this.addButton.onclick = dojo.hitch(this, function(){ this.apply(); return false; });
			
		},
		
		apply: function(){},
		
		showDetails: function(){},
		
		select: function(){},
		
		deselect: function(){},
		
		destroy: function() {
			this.titleAnchor.onclick = null;
			this.addButton.onclick = null;
			this.inherited(arguments);
		}
	});
	
dojo.provide("com.ibm.pb.customize.smallMenuWidget");
dojo.declare("com.ibm.pb.customize.smallMenuWidget",
	[dijit._Widget, dijit._Templated],
	{
		truncTitleText: "",
		imagePath: ".",
		hub: null,
		item: null,
		map: {},
		warningIcon: "",
		menu: null,
		isFeed: false,
		isOpenSocial: false,
		widgetActions: "Actions",
		detailDialogInstruction: "press enter to see details dialog",
		templateString: '<div class="lotusPaletteWidget" role="gridcell" dojoAttachPoint="lotusPaletteWidget">' +
							'<div class="lotusInner">' +
								'<div class="lotusIcon">' +
									'<span>' +
										'<img alt="${truncTitleText}" src="${map.thumbnail}"/>' +
									'</span>' +
								'</div>' +
								'<a class="lotusWarningIcon" href="javascript:void(0)" title="sandboxed" dojoAttachPoint="warningIconAnchor">' +
										'<img width="16" height="16" src="${blankPath}" alt=""/>' +
										'<span class="lotusAltText">sandboxed</span>' +
							    '</a>' +
								'<div class="lotusTitle">' +
									'<h4>' +
										'<a href="javascript:void(0);" title="${map.label}" dojoAttachPoint="titleAnchor">' +
											'${truncTitleText}' +
											'<span class="ibmHiddenText">${detailDialogInstruction}</span>' +
										'</a>' +
									'</h4>' +
								'</div>' +
								'<a class="lotusIcon" href="javascript:void(0)" title="${addToPage}" dojoAttachPoint="addButton">' +
									'<img width="16" height="16" src="${blankPath}" alt="${addToPage}"/>' +
									'<span class="lotusAltText">+</span>' +
								'</a>' +
								'<a class="lotusIcon iconContextMenu" href="javascript:void(0)" title="${widgetActions}" dojoAttachPoint="contextMenuButton">' +
								    '<img width="16" height="16" src="${menuIconPath}" alt="${widgetActions}"/>' +
								    '<span class="lotusAltText">${widgetActions}</span>' +
							    '</a>' +
							'</div>' +
						'</div>',
						
		postMixInProperties: function(){
			var bundle = dojo.i18n.getLocalization("com.ibm.bundles", "Shelf");
			this.addToPage = bundle["add_content_addToPage"];
			this.widgetActions = bundle["add_content_widgetActions"] || this.widgetActions; 
			this.detailDialogInstruction = bundle["detail_dialog_instruction_text"] || this.detailDialogInstruction;
			if (!this.map.thumbnail) {
				this.map.thumbnail = this.imagePath + "/portletIcon.gif";
			} else {
				this.map.thumbnail = com.ibm.mashups.enabler.utils.EndpointHelper.resolve(this.map.thumbnail);
			}
			if (!this.warningIcon) this.warningIcon = "/mum/images/oneui/iconWarning.gif";
			this.blankPath = this.imagePath + "/blank.gif";
			this.menuIconPath = "/mum/images/context_menu.png";
		},
			
		postCreate: function(){ 
			this.titleAnchor.onclick = dojo.hitch(this, function(){ this.showDetails(); return false; });
			this.addButton.onclick = dojo.hitch(this, function(){ this.apply(); return false; });
			if(!ibmCfg.portalConfig.portalContext) {  // Portal does not use the menus
				var applyToPage = dojo.hitch(this, function(){
					this.apply();
				});
				var updateShelfItemUI = dojo.hitch(this, function(){
					this._updateShelfItemUI(true);
				});

				if (this._isFromHub()) {
					this.isOpenSocial = this.map.widgetType == "mm_OSGadget";
				} else {
					this.isOpenSocial = this.hub.category == "OpenSocial";
				};
				this.isFeed = this.item.store.namespace == "feed";
				
				this.widgetContextMenu = new com.ibm.mm.builder.iwidget.SmallWidgetContextMenu({
					targetNodeIds: [this.contextMenuButton],
					entryId: this.map.id,
					category: this.category,
					widget: this,
					addWidget: applyToPage,
					updateWidgetItemUI: updateShelfItemUI
				});
				this._updateShelfItemUI(false);
			}
		},
		
		_isFromHub: function() {
			return dojo.trim(ibmConfig["com.ibm.mashups.builder.contentShelf.mode"]) == "hub";
		},
		
		_updateShelfItemUI: function(refresh){
			var cs = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
			var sandboxEnabled = cs.getValue(com.ibm.mashups.enabler.services.ConfigConstants.SANDBOXENABLED);
			if (!sandboxEnabled) return;
			
			if (refresh) {
				this.map.isTrusted = this.widgetContextMenu.widget.map.isTrusted;
            }
			
			if (this._isFromHub()) {	
				this.map.isTrusted = this.map.sandbox_definition == "true" ? false : true;
				if (this.map.isTrusted) {
					this.map.isTrusted = this.map.sandbox_user == "true" ? false : true;
				}	
			} else {		
				this.map.isTrusted = com.ibm.mm.builder.utils.iwidgetUtil.isWidgetTrusted(this.map.id);	
			}			
            
			if(this.map.isTrusted){
				dojo.removeClass(this.lotusPaletteWidget, "lotusPaletteUnTrustedWidget");
			} else {
				dojo.addClass(this.lotusPaletteWidget, "lotusPaletteUnTrustedWidget");
			}
		},
		
		apply: function(){},
		
		showDetails: function(){},
		
		select: function(){},
		
		deselect: function(){},
		
		destroy: function() {
			this.titleAnchor.onclick = null;
			this.addButton.onclick = null;
			if(this.widgetContextMenu) {
				this.widgetContextMenu._clearMenu();
				this.widgetContextMenu.destroy();
			}
			this.inherited(arguments);
		}
	});

dojo.provide("com.ibm.pb.customize.feedSmallWidget");
dojo.declare("com.ibm.pb.customize.feedSmallWidget",
	[dijit._Widget, dijit._Templated],
	{
		truncTitleText: "",
		imagePath: ".",
		hub: null,
		item: null,
		map: {},
		warningIcon: "",
		menu: null,
		detailDialogInstruction: "press enter to see details dialog",
		templateString: '<div class="lotusPaletteWidget" role="gridcell" dojoAttachPoint="lotusPaletteWidget">' +
							'<div class="lotusInner">' +
								'<div class="lotusIcon">' +
									'<span>' +
										'<img alt="${truncTitleText}" src="${map.thumbnail}"/>' +
									'</span>' +
								'</div>' +
								'<div class="lotusTitle">' +
									'<h4>' +
										'<a href="javascript:void(0);" title="${map.label}" dojoAttachPoint="titleAnchor">' +
											'${truncTitleText}' +
											'<span class="ibmHiddenText">${detailDialogInstruction}</span>' +
										'</a>' +
									'</h4>' +
								'</div>' +
								'<a class="lotusIcon" href="javascript:void(0)" title="${addToPage}" dojoAttachPoint="addButton">' +
									'<img width="16" height="16" src="${blankPath}" alt=""/>' +
									'<span class="lotusAltText">+</span>' +
								'</a>' +
							'</div>' +
						'</div>',
			
		postMixInProperties: function(){
			var bundle = dojo.i18n.getLocalization("com.ibm.bundles", "Shelf");
			this.addToPage = bundle["add_content_addToPage"];
			this.detailDialogInstruction = bundle["detail_dialog_instruction_text"] || this.detailDialogInstruction;
			if (!this.map.thumbnail) {
				this.map.thumbnail = this.imagePath + "/portletIcon.gif";
			} else {
				this.map.thumbnail = com.ibm.mashups.enabler.utils.EndpointHelper.resolve(this.map.thumbnail);
			}
			this.blankPath = this.imagePath + "/blank.gif";
		},
		
		postCreate: function(){	
			this.titleAnchor.onclick = dojo.hitch(this, function(){ this.showDetails(); return false; });
			this.addButton.onclick = dojo.hitch(this, function(){ this.apply(); return false; });
		},
		
		apply: function(){},
		
		showDetails: function(){},
		
		select: function(){},
		
		deselect: function(){},
		
		destroy: function() {
			this.titleAnchor.onclick = null;
			this.addButton.onclick = null;
			this.inherited(arguments);
		}
	});

dojo.provide("com.ibm.pb.customize.noIconSmallWidget");
dojo.declare("com.ibm.pb.customize.noIconSmallWidget",
	[com.ibm.pb.customize.smallWidget],
	{
		templateString: '<div class="lotusPaletteWidget" role="gridcell">' +
							'<div class="lotusInner">' +
								'<div class="lotusIcon"></div>' +
								'<div class="lotusTitle">' +
									'<h4>' +
										'<a href="javascript:void(0);" title="${map.label}" dojoAttachPoint="titleAnchor">${truncTitleText}</a>' +
									'</h4>' +
								'</div>' +
								'<a class="lotusIcon" href="javascript:void(0)" title="${addToPage}" dojoAttachPoint="addButton">' +
									'<img width="16" height="16" src="${blankPath}" alt=""/>' +
									'<span class="lotusAltText">+</span>' +
								'</a>' +
							'</div>' +
						'</div>'
	});
	
	dojo.provide("com.ibm.pb.customize.largeWidget");
	dojo.declare("com.ibm.pb.customize.largeWidget",
	[dijit._Widget, dijit._Templated],
	{
		truncTitleText: "",
		imagePath: ".",
		map:{},
		current: false,
		selectedClass: "lotusSelected",
		hiddenSelectedText: "currently selected for the page",
		hiddenUnselectedText: "press enter to select",
		templateString: '<div class="lotusPaletteWidget" dojoAttachPoint="addButton" role="gridcell" aria-selected="false">' +
							'<div class="lotusInner">' +
								'<div class="lotusIcon">' +
									'<span>' +
										'<img alt="${truncTitleText}" src="${map.thumbnail}"/>' +
									'</span>' +
								'</div>' +
								'<div class="lotusTitle">' +
									'<h4>' +
										'<a href="javascript:void(0);" title="${map.label}">' +
											'${truncTitleText}' +
											'<span class="ibmHiddenText" dojoAttachPoint="hiddenSelectedTextNode">${hiddenUnselectedText}</span>' +
										'</a>' +
									'</h4>' +
								'</div>' +
							'</div>' +
						'</div>',
						
		postMixInProperties: function(){
			if (!this.map.thumbnail) {
				this.map.thumbnail = this.imagePath + "/portletIcon.gif";
			} else {
				this.map.thumbnail = com.ibm.mashups.enabler.utils.EndpointHelper.resolve(this.map.thumbnail);
			}
			this.hiddenSelectedText = dojo.i18n.getLocalization("com.ibm.bundles", "Theme")["currently_selected"] || this.hiddenSelectedText;
			this.hiddenUnselectedText = dojo.i18n.getLocalization("com.ibm.bundles", "Shelf")["selection_instructions"] || this.hiddenUnselectedText;
			this.id = this.map.id;
		},
		
		postCreate: function(){
			if(this.current) this.select();
			this.addButton.onclick = dojo.hitch(this, function(){ this.apply(); return false; });
		},
		
		apply: function(){},
		
		select: function(){
			this.current = true;
			dojo.addClass(this.domNode,this.selectedClass);
			dojo.attr(this.domNode,"aria-selected","true");
			this.hiddenSelectedTextNode.innerHTML = this.hiddenSelectedText;
		},
		
		deselect: function(){
			this.current = false;
			dojo.removeClass(this.domNode,this.selectedClass);
			dojo.attr(this.domNode,"aria-selected","false");
			this.hiddenSelectedTextNode.innerHTML = this.hiddenUnselectedText;
		},
		destroy: function () {
			this.addButton.onclick = null;
			this.inherited(arguments);
		}
	});
	




}

if(!dojo._hasResource["com.ibm.pb.customize.AddContentPaletteContainer"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.customize.AddContentPaletteContainer"] = true;
// This is Add Content
dojo.provide("com.ibm.pb.customize.AddContentPaletteContainer");



dojo.declare("com.ibm.pb.customize.AddContentPaletteContainer",
	[com.ibm.pb.customize.LotusPaletteContainer],
	{
		createProxyURI: null,	// function to create a proxy url
		pendingItems: null,		// items pending creation/modification
		beforeSubmitDfds: null, // Array of Deferreds that must all get called back before submit processing can occur
		afterSubmitDfds: null, 	// Array of Deferreds that must all get called back before submit fires its onComplete/onError handlers
		
		constructor: function() {
			this.label = this.nlsBundle["add_content_browseContent"];
			this.tabLabel = this.nlsBundle["add_content_launchLabel"];
			this.pendingItems = {};
			this.beforeSubmitDfds = [];
			this.afterSubmitDfds = [];
			
			// create context menu loader
			/*var menuDefinitionsModule = "com.ibm.themes.PageBuilder2.menuDefinitions",
				ctxMenusObj = dojo.getObject("ibmCfg.themeConfig.contextMenus", true),
				addContentActionsMenu = new com.ibm.pb.contextMenu.JsonContextMenuLoader({url:dojo.moduleUrl(menuDefinitionsModule,"addContentActions.json"), data: ctxMenusObj.addContentActions});
			com.ibm.mashups.builder.model.Factory.getContextMenuModel().registerContextMenu("addContentActions", addContentActionsMenu);*/
		}
});

}

if(!dojo._hasResource["com.ibm.pb.customize.ChangeStylePaletteContainer"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.customize.ChangeStylePaletteContainer"] = true;
// This is Change Style
dojo.provide("com.ibm.pb.customize.ChangeStylePaletteContainer");




dojo.declare("com.ibm.pb.customize.ChangeStylePaletteContainer",
	[com.ibm.pb.customize.LotusPaletteContainer],
	{
		numRows: 3,			// the number of rows of results to be displayed
		baseCssPath: "",
		
		constructor: function() {
			this.label = this.nlsBundle["change_style_browseStyles"];
			this.tabLabel = this.nlsBundle["change_style_launchLabel"];
			this.themeBundle = dojo.i18n.getLocalization("com.ibm.bundles", "Theme");
		},
		
		postCreate: function(){
			this.inherited("postCreate",arguments);
			
			// change the size of the item results by adding a css class
			dojo.addClass(this.domNode,"lotusLargeWidgets");
			
			// when the apply function from the Customize Controller API is executed, change the visually selected item
			this.connect(this, "apply", "changeSelection");
		},
		
		setupUICallback: function(sources){
			dojo.forEach(sources, dojo.hitch(this, function(source){ 
				source.hub.fetch({
					onComplete:dojo.hitch(this, function(items){
						dojo.forEach(items, dojo.hitch(this, function(item){
							if(item.id[0] != "initial" && dojo.query("[title~="+item.id[0]+"]").length == 0) {
								this._loadCss(this.baseCssPath + item.url[0],item.id[0],true,true);
							}
						}));
					})
				});
			}));
			this.inherited(arguments);
		},
		
		changeSelection: function(/*object*/args){
			// summary: called when apply is called
			// args: contains args.id which is the newly selected item
			this.changeSelected(args.id);
		},
		newCell: function(/*Object*/source,/*DataItem*/item){
			// summary:  override this function to fill innerCell with information about the given datastore item
			// source: a datastore
			// item: an item in source
			var node = this.inherited(arguments),
				widget = dijit.byNode(node),
				editStyleFn = dojo.getObject("ibmCfg.themeConfig.editStyle"); // check if its defined
			if(editStyleFn && widget && widget.textBlock){
				var anchor = dojo.create("a", {
					href: "javascript:void(0);",
					className: "editStyleLink",
					innerHTML: this.themeBundle.edit_title
				}, widget.textBlock);
				widget.connect(anchor, "onclick", function(){
					ibmCfg.themeConfig.editStyle({	// use the reference here in case it changes
						source: source, 
						item: item, 
						node: anchor, 
						apply: widget.apply	// this is the function to call when selecting a style
					});
				});
			}
			return node;
		}
});

}

if(!dojo._hasResource["com.ibm.pb.customize.ChangeLayoutPaletteContainer"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.customize.ChangeLayoutPaletteContainer"] = true;
// This is Change Layout
dojo.provide("com.ibm.pb.customize.ChangeLayoutPaletteContainer");



dojo.declare("com.ibm.pb.customize.ChangeLayoutPaletteContainer",
	[com.ibm.pb.customize.LotusPaletteContainer],
	{
		numRows: 3,			// the number of rows of results to be displayed
		columnHash:{},		// an associative array of layout id to number of columns
		
		constructor: function() {
			this.label = this.nlsBundle["change_layout_browseLayouts"];
			this.tabLabel = this.nlsBundle["change_layout_launchLabel"];
		},
		
		postCreate: function(){
			this.inherited("postCreate",arguments);
			
			// change the size of the item results by adding a css class
			dojo.addClass(this.domNode,"lotusLargeWidgets hasLotusMessage");
			
			// add a message to the UI that says the layout will not change until the page is saved
			var msgNode = this.createLotusMsgNode(this.nlsBundle.change_layout_save_warning,"Warning");
			this.center.appendChild(msgNode);
			
			// when the apply function from the Customize Controller API is executed, change the visually selected item
			this.connect(this, "apply", "changeSelection");
		},
		
		changeSelection: function(/*object*/args){
			// summary: called when apply is called
			// args: contains args.id which is the newly selected item
			this.changeSelected(args.id);
		}
});

}

if(!dojo._hasResource["com.ibm.UnloadGuard"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.UnloadGuard"] = true;
dojo.provide("com.ibm.UnloadGuard");

(function(){
	
	// This utility is used for guarding against unload events when certain events
	// are still pending.  It provides topics for adding and removing pending events
	// through the dojo.publish/subscribe model.
	
	// If events are still pending when the window tries to unload, a confirmation dialog
	// will be displayed to the user with one of the outstanding pending messages, allowing the user
	// to cancel the unload event and stay on the page if the user so chooses.  There is no
	// way to determine which message amongst the list of pending events is displayed to the user as
	// the only guarantee is that one of them will be displayed.
	
	// Other things can subscribe to these topics also in order to perform other functions.
	// An example could be a widget that shows some visual indicator while certain events are
	// still pending and hides itself when they complete.
	
	// Below is a list of topics used by this module.  The arguments that this utility is interested
	// in are also documented, however, any additional arguments can be used by other modules
	// that are also interested in these topics.  However, this utility will only use the arguments
	// specified below.  Other things can subscribe to these topics also in order to perform other 
	// functions.  An example could be a widget that shows some visual indicator while certain events 
	// are still pending and hides itself when they complete.
	//
	// Topics:
	//		"/window/unload/addPending" - Publish to this with one argument which is the message 
	//			to display to the user if the window is unloaded before the event is completed.
	//		
	//		"/window/unload/removePending" - Publish to this with one argument which is a previously
	//			added message in order to remove this message from the list of pending events.
	//				
	//		"/window/unload/nonePending" - Do not publish to this topic.  It is published to by this
	//			module whenever there are no more pending events after a previous one was removed.
	//			It is meant to be subscribed to.
	
	var pending = {};
	
	var isPending = function() {
		for(var x in pending) {
			if(pending[x] && pending[x].length > 0) return x;
		}
		return false;
	}
	
	var addPending = function(message) {
		if(!pending[message]) pending[message] = [];
		pending[message].push(true);
	}
	
	var removePending = function(message) {
		if(pending[message]) {
			pending[message].pop();
		}
		if(!isPending()) {
			dojo.publish("/window/unload/nonePending");
		}
	}
	

	dojo.subscribe("/window/unload/addPending", null, addPending);
	dojo.subscribe("/window/unload/removePending", null, removePending);

	window.onbeforeunload = function() {
		var msg = isPending();
		if(msg !== false) return msg;
	}
})();

}

if(!dojo._hasResource["com.ibm.pb.customize.enabler.TabbedController"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.customize.enabler.TabbedController"] = true;
dojo.provide("com.ibm.pb.customize.enabler.TabbedController");







dojo.declare("com.ibm.pb.customize.enabler.TabbedController",
	[com.ibm.widgets.InlineShelf],
	{
		children: [],					// array of children to display in the tabs, each array item is an object {tabName:"",controller:object that implements the Customize Controller API}
		imagePath: '.',					// path to the css images
		hiddenClass: "lotusHidden",		// the css class name to hide content panes
		selectedClass: "lotusSelected",	// the css class to select tabs
		navModel: null,					// reference to the enabler navigation model
		widgetModel: null,				// reference to the enabler widget model
		selectedChild: null,			// the id of the currently selected child
		
		templateString: '<div class="lotusui ibmPortalCustomizeShelf lotusPalette" style="display: none;">' +
							'<div class="lotusPaletteHeader">' +							
							'<ul dojoAttachPoint="tabs" class="lotusTabs"></ul>' +
							'</div>' +
							'<div dojoAttachPoint="containerDivs"></div>' +
						'</div>',
		refreshRetryInterval: 300,		// if a refresh request is delayed because a save is pending, this is the amount of time to wait before retrying the refresh				
		
		constructor: function() {
			this.logger = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.pb.customize.enabler.TabbedController");
			this.logger.entering("contructor");
			this.bundle = dojo.i18n.getLocalization("com.ibm.bundles", "Shelf");
			this.messages = dojo.i18n.getLocalization("com.ibm.bundles", "SharedMessages");
			this.okText = this.bundle["shelf_saveChanges"];
			this.cancelText = this.bundle["add_content_cancel"];
			this.eventService = com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService");
	        this.eventService.subscribeEvent("com.ibm.mashups.builder.changePageMode", this, this.onPageModeChanged);
            this.saveInProgress = false;
            this.changedToPageViewMode = false;
            this.logger.exiting("contructor");
		},

        /***********************************************/
        /*              Handle this event              */
        /***********************************************/
        
	    onPageModeChanged: function(iEvent){
	        var nsm = com.ibm.mashups.enabler.model.state.NavigationStateModelFactory.getNavigationStateModel();        
	        if(iEvent == "edit") {
	            nsm.startTransaction();
	        } else if(iEvent == "view") {
	            // if we are saving, then don't discard the transaction
	            // saveChildren() will commit the transaction if the page is actually saved
	            // or discard the transaction if the page is not saved, e.g. due to an error
	            // saveChildren() does need to know that a change to page view mode occurred
	            // also both saveInProgress and changedToPageViewMode will be reset in saveChildren()
	            if (this.saveInProgress)
	                this.changedToPageViewMode = true;
	            
	            // we are not saving, so just discard the transaction
	            else
                    nsm.discardTransaction();
	        }
	    },  
		
		/***********************************************/
		/*           Connect to these events           */
		/***********************************************/
		
		onFirstOpen: function(){
			// summary: stub event to be called the first time the shelf is opened
			this.logger.entering("onFirstOpen");
			this.fillTabs();
			this.logger.exiting("onFirstOpen");
		},
		
		onStartup: function(){
			// summary: stub event to be called when the TabbedController is started up
			this.logger.entering("onStartup");
			this.logger.exiting("onStartup");
		},
		
		onShowTab: function(/*Object*/selectedChild){
			// summary: stub event to be called whenever a tab is shown
			this.logger.entering("onShowTab",[selectedChild]);
			this.logger.exiting("onShowTab",[selectedChild]);
		},
		
		/***********************************************/
		/*         		  UI Functions    		       */
		/***********************************************/
		
		fillTabs: function(){
			// create the tabs and container divs for each child
			this.logger.entering("fillTabs");
			var count = 0, index = 0;
			dojo.forEach(
				this.children,
			    dojo.hitch(this, function(child){
					// create a node for the child to create its container
					var div = dojo.create("div",{className:this.hiddenClass},this.containerDivs);
					dojo.place(child.controller.domNode,div);
					child.containerDiv = div;
					// create a tab div to access the container
					var tab = dojo.create("li");
					var tabName = dojo.create("a",{innerHTML:child.controller.tabLabel,href:"javascript:void(0)"},tab);
					dojo.place(tab,this.tabs);
					child.tab = tab;
					// create an onclick handler for each tab that opens its container
					tabName.onclick = dojo.hitch(this,this.showTab,child);
					if	(child.controller.id == this.selectedChild) {
						index = count;
					}
					count++;
			}));
			if(this.children.length == 0) {
				this.disconnectButton();
			} else {
				this.showTab(this.children[index]);
			}
			this.onStartup();
			this.logger.exiting("fillTabs");
		},
		
		showTab: function(/*Object*/selectedChild){
			// summary: displays the content pane for the given controller
			// selectedChild: the child to show
			this.logger.entering("showTab",[selectedChild]);
			if(!selectedChild.controller.started){
				// if the child isn't started yet, start it up
				selectedChild.controller.startup(this);
			}
			// clear all the tabs and container divs
			dojo.forEach(
				this.children,
			    dojo.hitch(this, function(child){
					dojo.removeClass(child.tab,this.selectedClass);
					dojo.addClass(child.containerDiv,this.hiddenClass);
			}));
			// select and show the given child
			dojo.addClass(selectedChild.tab,this.selectedClass);
			dojo.removeClass(selectedChild.containerDiv,this.hiddenClass);
			this.onShowTab(selectedChild);
			this.selectedChild = selectedChild.controller.id;
			this.logger.exiting("showTab",[selectedChild]);
			return false; /* to prevent onBeforeUnload event from triggering in IE */
		},
		
		refreshTabs: function(/*Array*/newChildren){
			// summary: refreshes the tabs shown in the UI
			// newChildren: the new array of child controllers to show
			var refresh = false;
			if (this.children.length != newChildren.length) {
				refresh = true;
			} else {
				for (var i = 0,l=newChildren.length; i < l; i++) {
					var found = false;
					for (var j = 0,l2 = this.children.length; j < l2; j++) {
						if (newChildren[i].controller.id == this.children[j].controller.id) {
							found = true;
							break;
						}
					}
					if (!found) {
						refresh = true;
						break;
					}
				}
			}
			if (refresh) {
				this.children = newChildren;
				if(!this.everOpened) { return; }
				while(this.containerDivs.children.length > 0){
					this.containerDivs.removeChild(this.containerDivs.firstChild);
				}
				while(this.tabs.children.length > 0){
					this.tabs.removeChild(this.tabs.firstChild);
				}
				this.fillTabs();
			}
		},
		
		clearSelectedTab: function(){
			// summary: sets the currently selected child to null
			this.selectedChild = null;
		},
		
		/***********************************************/
		/*         		  Model Functions  		       */
		/***********************************************/
		
		undoChildren: function(){
			// summary: undoes all pending changes in the children
			this.logger.entering("undoChildren");
			dojo.forEach( this.children, dojo.hitch(this, function(child){ 
				child.controller.undo();	
			}));
			this.logger.entering("exiting");
		},
		
		beforeSave: function(callback){
		    
			// summary: calls the beforeSave function for each child
			this.logger.entering("beforeSave",[callback]);

		    if(!this.children || this.children.length==0){callback();return}//BSpace removed the the first panel.
			// this.children.length is 0 in their UI 
			
			// onPageModeChanged() handler needs to know if a save is in progress
			// this will be reset in saveChildren()
			this.saveInProgress = true;
			
			this.closeOverlay = this.children[0].controller.showWaitMsgInDialog(this.bundle["shelf_saving"]);
			var dfdl = new dojo.DeferredList(dojo.map( this.children, function(child){
				return child.controller.beforeSubmit();
			}, this));
			// add the callback in a timeout or else it occurs so fast the overlay won't show
			setTimeout( dojo.hitch(this, function(){ dfdl.addCallback(dojo.hitch(this, callback)); }), 500 );
			this.logger.exiting("beforeSave",[callback]);
		},
		_setDialogErr: function(dialog, msg, callback){
			dialog.containerNode.innerHTML = msg;
			var footer = dojo.create("div", {
				className: "lotusDialogFooter"
			}, dialog.containerNode, "after");
			if(callback){
				dojo.create("button", {
					className: "lotusBtn",
					innerHTML: this.bundle.add_content_ok,
					onclick: function(){
						callback();
					}
				}, footer);
			}
		},
		saveChildren: function(callback){ 
			// summary: calls submit on each child
			this.logger.entering("saveChildren",[callback]);
			var nsm = com.ibm.mashups.enabler.model.state.NavigationStateModelFactory.getNavigationStateModel();
			var waitingDialog = null;
			if (this.children && this.children.length) {
			    waitingDialog = this.children[0].controller.waitingDialog;
			}
			var saveErr = null;
		
			var refresh = ibmCfg.themeConfig.alwaysRefreshOnPageSave || 
						  com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().isDirty();
			com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(false);
			var count = this.children.length;
			var counter = dojo.hitch(this,function(){
				this.logger.entering("counter in saveChildren",[count]);
				if(--count === 0) {
					// commit widget and navigation models
					var nCommit = this.navModel.commit();
					nCommit.setFinishedCallback(dojo.hitch(this,function(x, status){
						if(status == 200 || status == 201 || status == 400) {
							if(status >= 300 && waitingDialog){
								saveErr = true;
								this._setDialogErr(waitingDialog, this.messages.shelf_customizeError_0, function(){
									window.location.reload();
								});
							}
							else {
								var wCommit = this.widgetModel.commit();
								wCommit.setFinishedCallback(dojo.hitch(this,function(x, status){
									callback();
									if(status == 200 || status == 201 || status == 400) {
										if(status >= 300 && waitingDialog && !saveErr){
											saveErr = true;
											this._setDialogErr(waitingDialog, this.messages.shelf_customizeError_0, function(){
												window.location.reload();
											});
										}
										else {
											// save was sucessful, so commit the nsm transaction
											nsm.commitTransaction();
		
											// if we have NOT changed to page view mode we are still in edit mode
											// so start a new transaction
			                                if (!this.changedToPageViewMode)
			                                    nsm.startTransaction();
		
			                                if(refresh && !ibmCfg.themeConfig.savePageCheckerUnloading && (dojo.isOpera || !ibmCfg.themeConfig.isPageRenderModeCSA)) { com.ibm.utilities.refreshPage(); }
											else if (refresh) {
												this.eventService.broadcastEvent("com.ibm.mashups.builder.layoutRefresh");
											} 
											this.closeOverlay();
										}
									} else {
	                                    // we have changed to page view mode
									    // and not successfully saved
	                                    // so discard the nsm transaction
	                                    if (this.changedToPageViewMode)
	                                        nsm.discardTransaction();
	                                    // if we are still in edit mode
	                                    // then keep the nsm transaction
	                                    // since subsequent saves might work
	
										this.logger.severe("saveChildren","Cannot save the widget model", arguments);
										this.closeOverlay();
									}
	
									// reset state members
									this.changedToPageViewMode= false;
						            this.saveInProgress = false;
								}));
								wCommit.start(false);
							}
						} else {
							this.logger.severe("saveChildren","Cannot save the navigation model", arguments);
							this.closeOverlay();
							callback();

                            // we have changed to page view mode
                            // and not successfully saved
                            // so discard the nsm transaction
                            if (this.changedToPageViewMode)
                                nsm.discardTransaction();
                            // if we are still in edit mode
                            // then keep the nsm transaction
                            // since subsequent saves might work

                            // reset state members
                            this.changedToPageViewMode = false;
                            this.saveInProgress = false;
						}
					}));
					nCommit.start(false);
				}
				this.logger.exiting("counter in saveChildren",[count]);
			});
			var handleError = dojo.hitch(this,function(errors){ 
			    // summary: publishes the given errors
				this.logger.entering("handleError in saveChildren",[errors]);
				counter();
				var message = this.bundle["add_content_addContentError"];
				var details = "";
				if(errors){
					message = errors[0].message;
					details = errors[0].responseText;
				}
				if(message.match(/\D401/)){ // Portal session not authenticated
					details = message;
					message = this.bundle["shelf_session_timeout"];
				}
				this.logger.severe("handleError in saveChildren",message + " : " + details,[errors]);
				this.logger.entering("handleError in saveChildren",[errors]);
			});
			dojo.forEach( this.children, function(child){ 
				if(child.controller.refresh && child.controller.dirty) { refresh = true; }
				child.controller.submit({onComplete:counter,onError:handleError});	
			}, this);
			this.logger.exiting("saveChildren",[callback]);
		}
});

}

if(!dojo._hasResource["com.ibm.pb.data.InstalledPortletStore"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.data.InstalledPortletStore"] = true;
dojo.provide( "com.ibm.pb.data.InstalledPortletStore" );


dojo.require( "com.ibm.data.AtomFeedStore" );
dojo.require( "com.ibm.data.CatalogMixin" );

dojo.declare( "com.ibm.pb.data.InstalledPortletStore",
			[com.ibm.data.AtomFeedStore,com.ibm.data.CatalogMixin],
			{
				// itemClass: String the class used to represent items of this store
				itemClass: "com.ibm.pb.data.InstalledPortletItem",
				_loadFinished: false,
				_items: [],
				noIcons: true,
				idPrefix: "",
				
				constructor: function( /*Map*/ args ) {
				},
				
				/********************************/
				/**                            **/
				/**                            **/
				/**  catalog extension point   **/
				/**                            **/
				/**                            **/
				/********************************/
				
				mapItem: function(/*DatstoreItem*/item){
					var map = {};
					var id = this.getEPResolvedValue(item, "id", "");
					map.id = id.indexOf(this.idPrefix) == 0 ? id.substring(this.idPrefix.length) : id;
					map.label = this.getEPResolvedValue(item, "title", "untitled");
					map.description = this.getEPResolvedValue(item, "summary", "");
					return map;
				},
			
				_fetchItems: function(/*Object*/ keywordArgs, /*Function*/ findCallback, /*Function*/ errorCallback){
					// summary: see dojo.data.util.simpleFetch
					//The _fetchItems() method should ignore any keywordArgs parameters for start, count, onBegin, onItem, onComplete, onError, sort, and scope, and only needs to handle queryOptions and query
					var me = this;
					var filter = function(requestArgs, arrayOfItems){ 
						
						var items = [];
						if(requestArgs.query){
							var keywordStrings = requestArgs.query.keywords;
							var ignoreCase = requestArgs.queryOptions ? requestArgs.queryOptions.ignoreCase : false; 
							
							// loop through the keywordStrings and push anything that isn't an empty string onto the keywords array
							var keywords = [];
							for(var i = 0; i < keywordStrings.length; i++){
								if(keywordStrings[i].length <= 0) { continue; }
								// make the keyword all lower case if we are doing a case insensitive search
								var keyword = (ignoreCase)?keywordStrings[i].toLowerCase():keywordStrings[i];
								keywords.push(keyword);
							}

							// loop through all the items in the store looking for matches
							for(var i = 0; i < arrayOfItems.length; ++i){
								var match = true;
								if(arrayOfItems[i] === null){
									match = false; 
								} else {
									// loop through each keyword and make sure the store item contains all of them to be a match
									for(var j = 0; j < keywords.length; j++){
										var title = me.getValue(arrayOfItems[i],"title","");
										if(ignoreCase) { title = title.toLowerCase(); } // make the title all lower case if we are doing a case insensitive search
										var summary = me.getValue(arrayOfItems[i],"summary","");
										if(ignoreCase) { summary = summary.toLowerCase(); } // make the summary all lower case if we are doing a case insensitive search
										// if the title AND summary both don't contain the keyword, the match is false
										if(title.indexOf(keywords[j]) == -1 && summary.indexOf(keywords[j]) == -1){
											match = false;
											break;
										}
									}
								}
								if(match) { items.push(arrayOfItems[i]); }
							}
							findCallback(items, requestArgs);
						} else {
							findCallback(arrayOfItems, requestArgs);
						}
					};

					if(this._loadFinished){ 
						filter(keywordArgs, this._items);
					} else {  // the items in the store must be fetched and stored for the first and last time
						var args = arguments;  // create a reference to arguments
						var savedOnComplete = arguments[0].onComplete;  // save a reference to arguments' onComplete function
						// create a new onComplete function to pass to the inherited fetch function
						args[0].onComplete = function(items){  	args[0].onComplete = savedOnComplete; // restore the onComplete function for _fetchItems
																me._loadFinished = true; 
																me._items = items;	// store the items in the store
																filter(keywordArgs,items);
															};
						// retrieve all the store items using the inherited fetch function
						com.ibm.data.AtomFeedStore.prototype.fetch.apply(this, args);
					}
				}
});
dojo.extend(com.ibm.pb.data.InstalledPortletStore,dojo.data.util.simpleFetch);

dojo.declare( "com.ibm.pb.data.InstalledPortletItem",
			com.ibm.data.AtomEntryItem, 
			{
			}
);

}

if(!dojo._hasResource["com.ibm.portal.fx.Transitions"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.portal.fx.Transitions"] = true;
dojo.provide("com.ibm.portal.fx.Transitions");




com.ibm.portal.fx.Transitions = {
	collapsePortlets: function(/*String*/ portletQuery, /*Object*/args){
		dojo.query(portletQuery || ".wpsPortletBody").wipeOut(dojo.mixin({duration: 1000}, args)).play();
	},
	uncollapsePortlets: function(/*String*/ portletQuery, /*Object*/args){
		dojo.query(portletQuery || ".wpsPortletBody").wipeIn(dojo.mixin({duration: 1000}, args)).play();
	},
	combineMapAnimations: function(/*Object*/ map, /*String?*/ prop) {
		prop = prop || "animation";
		return dojo.fx.combine(dojo.map(map, function(obj){
			return obj.animation;
		}));
	},
	chainMapAnimations: function(/*Object*/ map, /*String?*/ prop) {
		prop = prop || "animation";
		return dojo.fx.chain(dojo.map(map, function(obj){
			return obj.animation;
		}));
	},
	fadeToOverlay: function(/*String*/ query, /*Object*/ args, /*Node?*/ context) {
		// summary: Find all nodes matched by the query and cross-fade them out with an overlay
		//		over top of them which has a class called fxOverlay applied to it to visualize
		//		the old position of the node that was just faded.
		// query: String query used in conjunction with dojo.query to retrieve nodes to animate
		// args: Object animation arguments
		// context: Node optional to use as context from which to execute the dojo.query
		// returns: Object map of matching nodes in this format ->
		//		{
		//			overlay: Node overlay node which is faded in by animation
		//			node: Node matched by query that is faded out by animation
		//			animation: dojo._Animation cross-fading animation used to animate the transition
		// 				of the overlay and node.
		// 		} 
		//			
		return dojo.query(query, context).map(function(node) {
			var overlay = dojo.doc.createElement("div");
			var cds = dojo.coords(node);
			dojo.style(overlay, "position", "absolute");
			dojo.style(overlay, "top", (cds.y - dojo.style(node, "marginTop")) + "px");
			dojo.style(overlay, "left", (cds.x - dojo.style(node, "marginLeft")) + "px");
			dojo.style(overlay, "height", cds.h + "px");
			dojo.style(overlay, "width", cds.w + "px");
			dojo.addClass(overlay, "fxOverlay");
			dojo.style(overlay, "border", "solid 2px orange");
			dojo.style(overlay, "opacity", 0);
			dojo.body().appendChild(overlay);
			var anim = dojo.fx.combine([
				dojo.fadeIn(dojo.mixin({node: overlay}, args)),
				dojo.fadeOut(dojo.mixin({node: node}, args))
			]);
			
			return {overlay: overlay, node: node, animation: anim};
		});
	},
	fadeOutOverlay: function(/*Object*/ map, /*Object*/ args) {
		// summary: Cross-fades overlays with the nodes they cover by fading out the overlay
		// 		then fading in the covered node.  Can be used in conjunction with fadeToOverlay.
		//		Note that at the end of each animation, the overlay node will be destroyed.
		// map: Map of overlay nodes and their corresponding nodes that they cover in this format -> 
		// 		{
		//			overlay: Node overlay node
		//			node: Node being covered by overlay
		//		}
		// args: Object animation arguments
		// returns: Object map of matching nodes in this format ->
		//		{
		//			overlay: Node overlay node which is faded out by animation
		//			node: Node matched by query that is faded in by animation
		//			animation: dojo._Animation used to cross-fade the overlays with the
		//				nodes they cover.
		// 		}
		return dojo.map(map, function(obj){
			var anim = dojo.fx.combine([
				dojo.fadeOut(dojo.mixin({node: obj.overlay}, args)),
				dojo.fadeIn(dojo.mixin({node: obj.node}, args))
			]);
			return {overlay: obj.overlay, node: obj.node, animation: anim};
		});
	},
	positionOverlay: function(/*Object*/ map, /*Object*/ args) {
		// summary: Slides overlays to the position and size of the nodes they cover.  Can be
		//		used in conjunction with fadeToOverlay.
		// map: Map of overlay nodes and their corresponding nodes that they cover in this format -> 
		// 		{
		//			overlay: Node overlay node to reposition/resize
		//			node: Node being covered by overlay
		//		}
		// args: Object animation arguments
		// returns: Object map of matching nodes in this format ->
		//		{
		//			overlay: Node overlay node which is faded in by animation
		//			node: Node matched by query that is faded out by animation
		//			animation: dojo._Animation used to slide/resize the overlays to the
		//				nodes they cover.
		// 		}
		return dojo.map(map, function(obj){
			var newCds = dojo.coords(obj.node);
			var oldCds = dojo.coords(obj.overlay);
			
			var sizingAnim = dojo.animateProperty(dojo.mixin({ 
				node: obj.overlay,
				properties: {
					width: { start: oldCds.w, end: newCds.w, unit:"px" },
					height: { start: oldCds.h, end: newCds.h, unit:"px" }
				}
			}, args));
			
			var anim = dojo.fx.combine([
				dojo.fx.slideTo(dojo.mixin({node: obj.overlay, unit:"px", left: newCds.l, top: newCds.t}, args)), 
				sizingAnim
			]);
			return {overlay: obj.overlay, node: obj.node, animation: anim};
		});
	},
	showOverlayDisable: function(node,loading){
		// summary: displays an overlay on top of the given node, disabling its contents
		// node: a string for dojo.query that produces nodes to overlay
		// loading: if true, a loading icon will display on the overlay
		var nodes = dojo.query(node); // TODO: a foreach for this array
		var overlays = [];
		for(var i = 0; i < nodes.length; i++){
			nodes[i].style.position = "relative";  // the position of the div must be relative or absolute so the overlay will stay within it
			// create the overlay div
			var overlay = document.createElement("div");
			dojo.addClass(overlay,"ibmPortalOverlayShow");
			if(loading) {
				dojo.addClass(overlay,"ibmPortalLoading");
			}
			// make the overlay the same size as the main content
			dojo.style(overlay,"height",nodes[i].offsetHeight+"px");
			dojo.style(overlay,"width",nodes[i].offsetWidth+"px");
			// save the overlay
			overlays.push(overlay);
			// show the overlay
			nodes[i].appendChild(overlay);
		} 
		return overlays;
	},
	hideOverlayDisable: function(/*DOMNode[]*/overlays){
		// summary: removes an array of overlays by deleting the nodes
		for(var i = 0; i < overlays.length; i++) {
			overlays[i].parentNode.removeChild(overlays[i]);
		}
	}
};

}

if(!dojo._hasResource["com.ibm.pb.customize.enabler.AddContentController"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.customize.enabler.AddContentController"] = true;
dojo.provide("com.ibm.pb.customize.enabler.AddContentController");










com.ibm.pb.customize.enabler.AddContentController = {
	dirty: false,			// true if there are changes pending
	started: false,			// true if the widget is started up
	refresh: true,			// true if a page refresh is required to show saved changes
	navModel: null,			// reference to enabler navigation model
	imagePath: "",			// path to CSS images
	pendingItems: {},		// map of controls on the page
	placeholders: [],		// array of SSA portlet placeholders
	ibmMainContainer: "ibmMainContainer",
    layoutParser: com.ibm.pb.layout.LayoutParser,

	startup: function(){
		this.logger.entering("startup");
		this.started = true;	// widget is atarted
		this.eventService = com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService");
		this.setupUI();
		this.logger.exiting("startup");
	},
		
	makeDirty: function(/*bool*/change){
		// summary: changes the dirty attribute
		// change: value to assign to the dirty attribute
		this.logger.entering("makeDirty",[change]);
		this.dirty = change;
		this.logger.exiting("makeDirty",[change]);
	},
		
	processChange: function(/*Object*/args){
		// summary: used as an event handler for when a user clicks on an item
		//			hub: the datastore to which the object belongs
		//			item: the item in the datastore being processed
		//			prefsMapFcn (optional): a function or the name of a function in dot notation which retrieves a map of the preferences for the piece of content
		//			takeoverFcn (optional 2): a function or the name of a function in dot notation which will be run instead of the body of this submit function
		//			takeoverObject (optional 2): an object of parameters to be passed to takeoverFcn, must have both takeoverFcn and takeoverObject
		//			cID (optional 3): id of the container in which to insert the control
		//			sID (optional 3): goes with cID, it is the sibling id before which to insert the control
		if(!this.dirty) { this.makeDirty(true); }
		if(args.takeoverFcn) {
			// if there is a takeover function, pass control on to it
			args.takeoverObject = dojo.mixin(args.takeoverObject, {controller:this});
			if(dojo.isString(args.takeoverFcn)) { return dojo.getObject(args.takeoverFcn)(args.takeoverObject); }
			else { return args.takeoverFcn(args.takeoverObject); }
		} else { return this.apply(args); }
	},
		
	apply: function(/*Object*/args){
		// summary: applies a change associated with a selected item to the page
		// args: same as processChange
		this.logger.entering("apply",[args]);
		
		// get layout model
		var navId = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
		var layoutModel = this.navModel.getLayoutModel(navId);
		
		// get container into which the widget/portlet will go
		var container = null,
			containerDef = null,
			containerId = "";
		if(args.cID) { 
			//get container id from dnd
			containerId = args.cID; 
			containerDef = layoutModel.find(containerId);
			if(containerDef) {
				containerDef.setFinishedCallback(dojo.hitch(this, "_apply"), {layoutModel:layoutModel, args:args});
				containerDef.start(false);
			} else { this.logger.severe("apply","Cannot find dnd container in the layout model",[args]); }
		} else {
			// get the container from the layout model
			var mainContainer = dojo.query("[name~="+this.ibmMainContainer+"]");
			if(mainContainer.length > 0){
				// get the container which has the ibmMainContainer name
				containerId = this.layoutParser.extractID(mainContainer[0]);
				containerDef = layoutModel.find(containerId);
				if(containerDef) {
					containerDef.setFinishedCallback(dojo.hitch(this, "_apply"), {layoutModel:layoutModel, args:args});
					containerDef.start(false);
				} else { this.logger.severe("apply","Cannot find main container in the layout model",[args]); }
			} else {
				// get first container on the page
				var rootDef = layoutModel.getRoot();
				if(rootDef) { var root = rootDef.start(); }
				else { this.logger.severe("apply","Cannot find root layout container in the model",[args]); return; }
				var iter = layoutModel.getChildren(root);
				while(iter.hasNext()){
					container = iter.next();
					if(dojo.byId(container.getID())) { break; }
				}
				if(container) { this._apply(container, "200", {layoutModel:layoutModel, args:args});  }
				else { this.logger.severe("apply","Cannot find any containers in the layout model",[args]); }
			}
		}
		this.logger.exiting("apply",[args]);
	},
	
	_apply: function(container, status, x){
		// summary: inserts a control onto the page
		// container: layout container into which to put the new control
		// status: HTTP status returned from request to get container
		// x: {layoutModel, args from apply()}
		this.logger.entering("_apply",[container, status, x]);
		if(status != 200) {
			this.logger.severe("_apply","Could not find container in the layout model.  Cannot Add Content",[container, status, x]);
			return;
		}
		
		if(container instanceof com.ibm.mashups.enabler.layout.LayoutContainer){
			// get the next sibling
			var nextSibling = null;
			if(x.args.cID && !x.args.sID){
				nextSibling = null;
			} else if(x.args.sID){
				// get the next sibling from dnd
				var controlId = x.args.sID;
				if(controlId) { nextSiblingDef = x.layoutModel.find(controlId); }
				if(nextSiblingDef) { nextSibling = nextSiblingDef.start(); }
				if(!nextSibling) { this.logger.warning("_apply","Cannot find dnd sibling control in the layout model.  Setting it to null.",[container, status, x]); }
			} else {
				// get the first control in the container
				var iter = x.layoutModel.getChildren(container);
				if(iter.hasNext()) { nextSibling = iter.next(); }
			}
			if(nextSibling && !(nextSibling instanceof com.ibm.mashups.enabler.layout.LayoutControl)) { 
				// make sure nextSiblig is a Layout Control object
				this.logger.warning("_apply","Next sibling control is not an instance of com.ibm.mashups.enabler.layout.LayoutControl.  Setting it to null.",[container, status, x]);
				nextSibling = null;
			}
			
			// create the new control instance
			var constants = com.ibm.mashups.enabler.layout.Constants;
			var context = {};
			context[constants.CONTEXT_TYPE] = constants.LAYOUT_CONTROL;
            if (x.args.definitionURL) {
                context[constants.CONTEXT_WIDGET_DEFINITION_URL] = x.args.definitionURL;
            } else {
                context[constants.CONTEXT_WIDGET_DEFINITION_ID] = new com.ibm.pb.customize.Identifiable(x.args.id);
            }
            context[constants.DISPLAY_TITLE] = x.args.label;
			var control = x.layoutModel.create(context);
			if(!ibmCfg.portalConfig.portalContext){
				// temp fix for 18222 - Portal only
				control.setSkin(this._getDefaultSkin());
			}
			
			if (x.args.widgetType === "mm_OSGadget") {
				// gadgets do not have translated titles in their definition,
				// so the titles are forced in from the catalog for gadgets
				var titles = {};
				if (x.args.titles) {
					for (var i = 0; i < x.args.titles.childNodes.length; i++) {
						if (x.args.titles.childNodes[i].nodeType === 1) {
							titles[x.args.titles.childNodes[i].attributes[0].textContent] = x.args.titles.childNodes[i].textContent;
						}
					}
				}
				
				for (var loc in titles) {
					if (titles[loc] !== "{$data}") {
						control.setTitle(titles[loc],loc);
					}
				}
			} else {
				var defaultTitle=this._getWidgetDefinitionTitle(x.args.definitionURL);
				if(defaultTitle !=x.args.label){
					control.setTitle(x.args.label,dojo.locale);
				}
			}
			
			this._addLayoutControlMetaData(control, x.args);
			x.layoutModel.insert(control, container, nextSibling);
			this.pendingItems[x.args.label] = control;
			
			// get and assign prefs
			if(x.args.prefsMapFcn) { this._addPreferences(control, x.args.prefsMapFcn, x.args); }
			
			//set sandbox mark
			this._setSandboxMark(control, !x.args.isTrusted);
			
			// refresh the layout to show the new widget
			this._addPreviewToPage(control, container, nextSibling, x.args.label);
			
		} else { this.logger.severe("_apply","Container is not an instance of com.ibm.mashups.enabler.layout.LayoutContainer",[container, status, x]); }
		com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
		this.logger.exiting("_apply",[container, status, x]);
	},
	_getWidgetDefinitionTitle:function(definitionURL){
		if(!definitionURL) { return null; }  // Portlets do not have definition URLs, so this functions breaks in Portal
		var globalModel = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel();
		var widgetDef = globalModel.getWidgetDefinitionByURL(definitionURL).start(true);
		try {
			return widgetDef.getItemSet("idescriptor").items.title.values[dojo.locale];
		}catch(e){
			return null;
		}
	},
	
	_addPreviewToPage: function(control, container, nextSibling, title) {
		// summary: adds the markup to the page for live preview of the new widget
		// control: the control instance added to the page
		// container: the container instance to which the control was added
		// nextSibling: if present, the control was inserted before this other control
		// title: title of the control
		var getPreviewHTML = control.getRuntimeContent().getRuntimeMarkup();
		var me = this;
		getPreviewHTML.setFinishedCallback(function(markup){
			// put the runtime markup on the page
			if(ibmCfg.portalConfig.portalContext){
				// temp fix for 18222 and Portal blog&wiki UAT breakage - Portal only!
				var i = markup.match(/id-([^"]+)/);
				i = i && i[1];
				markup = '<div class="component-control id-'+i+'"><div class="lotusWidget2"><h2 class="dojoDndHandle"><span>' + title + '</span></h2><div class="lotusWidgetBody"><div class="iw-iWidget" id="'+i+'"><a class="iw-Definition" href="/mccenabler/js/com/ibm/mm/enabler/layout/widget/NonPreviewableContentWidget.xml"></a></div></div></div></div>';
			}
			var controlId = control.getID(), containerId = container.getID();
			if (nextSibling) {
				var sibling = me.layoutParser.findById(nextSibling.getID());
				var newWidget = dojo.place(markup, sibling, "before");
			} else {
				var parent = me.layoutParser.findById(containerId);
				var newWidget = dojo.place(markup, parent, "last");
			}
			// add dnd attributes
			// if you run into problems here with newWidget not a correct DOM Node, this is most likely
			// due to LayoutContainerFragment.html and/or LayoutControlFragment.html containing leading or trailing whitespaces.
			// If so, remove them before building, because dojo.place behaves strange otherwise and returns a DOM fragment instead of a real DOM Node.
			dojo.addClass(newWidget, "dojoDndItem"); 
			dojo.attr(newWidget, "dndType", "lm");
			// extend the sandboxed widget height to 100%
			dojo.forEach(
				dojo.query(".iw-iWidget[sandbox='true']",newWidget),
				function(sandboxed){
					dojo.addClass(sandboxed,"extendediwiWidget");
				}
			);				
			// publish events to parse, add, and wire the widget
			dojo.publish("/com/ibm/mashups/livetext/livetextchanged", [newWidget, true]);
			me.eventService.broadcastEvent("com.ibm.mashups.builder.addNewWidget", controlId); 
			com.ibm.mm.builder.utils.wireUtil.triggerAutowire(controlId);	
			ibmCfg.controllers.dnd.dndSources[containerId].sync();
		});
		getPreviewHTML.start(false); 
	},
	
	_getDefaultSkin: function(){
		// summary: returns the default skin for the theme assigned to the current page
		var pageId = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
		var page = this.navModel.find(pageId).start();
		var themeId = page.getTheme();
		var theme = com.ibm.mashups.enabler.model.Factory.getThemeModel().find(themeId).start();
		return theme.getDefaultSkin();
	},
	
	_setSandboxMark: function (control, markSandBox) {
		try {
			var windowDef = this.widgetModel.getWidgetWindow(control);
			windowDef.setFinishedCallback(dojo.hitch(this,function(window, status){
				if(status == 200){
					instanceDef = this.widgetModel.getWidgetInstance(window);
					instanceDef.setFinishedCallback(dojo.hitch(this,function(instance, status){
						if(status == 200){
							instance.setSandboxed(markSandBox);
						}
					}));
					instanceDef.start(true);
				}
			}));
			windowDef.start(true);	
		} catch(e) {
			console.log(e);			
		}
	},
	
	_addLayoutControlMetaData: function(control, map) {
		// summary: add meta data to layout control
		// key refers to results from mapItem()
		control.setMetaData("thumbnail", map["thumbnail"]);
		control.setMetaData("onNewWire", map["onNewWire"]);
		control.setMetaData("onAutoWire", map["onAutoWire"]);
		control.setMetaData("icon", map["icon"]);
		control.setMetaData("widgetParam", map["widgetParam"]);
	},
	
	_addPreferences: function(control, prefsMapFcn, map){
		// summary: adds preferences to a control
		// control: layout control to which to add preferences
		// prefsMapFcn: function which gets the preferences
		// map: arguments for the prefsMapFcn
		this.logger.entering("_addPreferences",[control, prefsMapFcn, map]);
		var windowDef = this.widgetModel.getWidgetWindow(control);
		windowDef.setFinishedCallback(dojo.hitch(this,function(window, status){
			if(status == 200){
				instanceDef = this.widgetModel.getWidgetInstance(window);
				instanceDef.setFinishedCallback(dojo.hitch(this,function(instance, status){
					if(status == 200){
						var prefsDef = this.widgetModel.getHierarchicalPreferences(instance);
						prefsDef.setFinishedCallback(dojo.hitch(this,function(preferences, status){
							if(status == 200) {
								var prefsMap = {};
								if(dojo.isString(prefsMapFcn)) { prefsMap = dojo.getObject(prefsMapFcn)(map); }
								else { prefsMap = prefsMapFcn(map); }
								for(var i in prefsMap){ 
									preferences.setValue(i, prefsMap[i]);
								}
							} else { this.logger.warning("_addPreferences","Cannot preferences for widget instance",[control, prefsMapFcn, map]); }
						}));
						prefsDef.start(true);
					} else { this.logger.warning("_addPreferences","Cannot find instance for widget window",[control, prefsMapFcn, map]); }
				}));
				instanceDef.start(true);
			} else { this.logger.warning("_addPreferences","Cannot find widget window based on newly created control",[control, prefsMapFcn, map]); }
		}));
		windowDef.start(true);
		this.logger.exiting("_addPreferences",[control, prefsMapFcn, map]);
	},
		
	undo: function(){
		// summary: reverts any changes made
		this.logger.entering("undo");
		dojo.forEach(this.beforeSubmitDfds, function(dfd){dfd.cancel();});
		this.beforeSubmitDfds = [];
		/*var isSSA = true;
		if(isSSA){
			for(var p in this.placeholders) {
				this.placeholders[p].destroyRecursive();
			}
		} else {
			var pageId = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
			this.eventService.broadcastEvent("com.ibm.mashups.builder.layoutRefresh");
		}*/
		this.logger.exiting("undo");
	},
		
	beforeSubmit: function(/*Object*/args){
		// summary: Called before submit and returns a Deferred object which should be used
		// 		to get notified when the controller is ready to be submitted.  Attach a callback
		//		to this Deferred to call the controller's submit function instead of calling
		//		it directly.
		this.logger.entering("beforeSubmit",[args]);
		var dfd = (new dojo.Deferred()).addCallback(dojo.hitch(this, function(){
			// add all the controls to the containers
			// chain up all the functions added with addBeforeSubmit
			this.logger.entering("beforeSubmit dfd callback");
			var dfdl = new dojo.DeferredList(this.beforeSubmitDfds, false, false);
			dojo.forEach(this.beforeSubmitDfds, function(df){
				if(df.fired < 0) {
					df.callback();
				}
			});
			this.beforeSubmitDfds = [];
			this.logger.exiting("beforeSubmit dfd callback");
			return dfdl;	// chain up another deferred after dfd calls back so subsequent callbacks now wait on dfdl
		}));
		// add the error callack to the deferred object
		if(args && args.onError) { dfd.addErrback(args.onError); }
		dfd.callback();
		this.logger.exiting("beforeSubmit",[args]);
		return dfd;
	},
		
	submit: function(/*Object*/args){
		// summary: saves any pending changes
		// args: args may contain an onComplete handler
		this.logger.entering("submit",[args]);
		if(this.dirty) { this.makeDirty(false); }
		this.pendingItems = {};
		if(args.onComplete) { args.onComplete(); }
		this.logger.exiting("submit",[args]);
	},
	
	addBeforeSubmit: function(/*Deferred*/ dfd) {
		// summary: Adds a Deferred object to the list of deferreds that must all be fired before
		//		the Deferred object returned by beforeSubmit is fired. 
		this.logger.entering("addBeforeSubmit",[dfd]);
		if(dfd) { this.beforeSubmitDfds.push(dfd); }
		this.logger.exiting("addBeforeSubmit",[dfd]);
	},

/********************************************************/
/*     Functions to create "new" pieces of content      */
/********************************************************/	

	newFeed: function(/*object*/args){
	    // summary: creates a new Feedspace portlet with user provided feed url
		// args: contains one item, getInfo, which is a function that takes the form data and runs a callback function on the validated user inputs
		var bundle = dojo.i18n.getLocalization("com.ibm.bundles", "Shelf");
		var form = [{label:bundle["new_feed_title"], id:"new_feed_title", value:"", regex:/\S+/, error:bundle["new_feed_enterTitle"]}, 
					{label:bundle["new_feed_url"], id:"new_feed_url", value:"http://", regex:/http:\/\/\S+/, error:bundle["new_feed_enterUrl"], ltr:true}];
		var submit = dojo.hitch(args.controller, function(inputs){ 
			var label = inputs["new_feed_title"].replace(/<(?:\/?)script>/g,""), url = inputs["new_feed_url"].replace(/<(?:\/?)script>/g,"");
			args.submit(dojo.mixin(args.submitObj,{id:ibmPortalConfig.contentRenderers.feed,label:label})); // add the feed reader to the page
			this.addBeforeSubmit((new dojo.Deferred()).addCallback(dojo.hitch(this, function(){      
				// set a beforeSubmit function to add the feed preferences
				this._addPreferences(this.pendingItems[label], this.getFeedspacePreferences, {url:url,label:label});
			})));
		});
		args.getInfo(form, bundle["new_feed_addFeed"], bundle["add_content_add"], null, submit);
	},
		
	newWCM: function(/*object*/args){
	    // summary: creates a new WCM item like a blog, wiki or solo blog
		// args: an associative array that contains:	getInfo: function that takes the form data and runs a callback function on the validated user inputs
		//												showInfo: function that takes an HTML payload and displays it to the user, then runs a callback function
		//												label (optional): a human readable label for the WCM item, such as "Wiki"
		//												type (optional): the type of WCM content, such as "WIKI_LIBRARY_TYPE"
		//												submitObj (optional): {
		//													hub (optional): a datastore
		//													item (optional): an item in the datastore
		//												}
		// args MUST contain EITHER label, type OR hub and an item containing the "label", and "type" attributes
		var label = args.label ? args.label : args.submitObj.hub.getValue(args.submitObj.item,"label","");
		label = (args.submitObj.hub && args.submitObj.hub.nlsBundle && args.submitObj.hub.nlsBundle[label]) ? args.submitObj.hub.nlsBundle[label] : label;
		var waitingMsg = args.submitObj.hub.getValue(args.submitObj.item,"waitingMsg","");
		waitingMsg = (args.submitObj.hub && args.submitObj.hub.nlsBundle && args.submitObj.hub.nlsBundle[waitingMsg]) ? args.submitObj.hub.nlsBundle[waitingMsg] : waitingMsg;
		var type = args.type ? args.type : args.submitObj.hub.getValue(args.submitObj.item,"type","");
		var bundle = dojo.i18n.getLocalization("com.ibm.bundles", "Shelf");
		var genericAddStr = dojo.string.substitute(bundle["new_generic_add"], [label]);
		var processInputs = dojo.hitch(args.controller, function(inputs){ 
			// context "this" object points to controller, args.controller 
			var name = dojo.string.trim(inputs["new_wcm_name"]).replace(/<(?:\/?)script>/g,"");
			if(name && name.length > 0){
				var contr = com.ibm.pb.customize.enabler.AddContentController;
				var closeOverlay = args.showInfo(waitingMsg);
				var validateNameCallback = dojo.hitch(this, function(response){
					closeOverlay();
					if(response == "false"){
						// set up the portlet to get created now
						args.submit(dojo.mixin(args.submitObj,{id:ibmPortalConfig.contentRenderers.wcm,label:name}));
						prefsCallback = dojo.hitch(this, function(data){
							this._addPreferences(this.pendingItems[name], this.getJSRWcmRenderingPreferences, {contextid:data, title:name});
						});
						this.addBeforeSubmit((new dojo.Deferred()).addCallback(dojo.hitch(this, "_processCreateLibrary", name, type, prefsCallback, null)));
					} else {
						// alert the user that the name is already in use
						args.getInfo(form,genericAddStr,bundle["add_content_add"],bundle["new_wcm_wcmNameTaken"],processInputs);
					}
				});
				contr._validateNameField(name, type, validateNameCallback, closeOverlay);
			} else {
				// alert the user that the name is invalid
				args.getInfo(form,genericAddStr,bundle["add_content_add"],bundle["new_wcm_wcmNameInvalid"],processInputs);
			}
		});
		// get a name for the WCM object from the user
	    var form = [{label:bundle["new_wcm_name"],id:"new_wcm_name",value:"",regex:/^[\s\S]/,error:bundle["new_wcm_wcmNameInvalid"]}];
		args.getInfo(form,genericAddStr,bundle["add_content_add"],null,processInputs);
	},

/*******************************************************/
/*       functions to create control preferences   	   */
/*******************************************************/	

	getFeedReaderPreferences: function(/*Object*/itemMap){
		var map = {};
		map.feedURL = itemMap.url;
		map.title = itemMap.label;
		return map;
	},
	
	getChartPreferences: function(/*Object*/itemMap){
		var map = {};
		map.dataSourceURL = itemMap.url;
		map.caption = itemMap.label;
		return map;
	},
	
	getDataViewerPreferences: function(/*Object*/itemMap){
		var map = {};
		map.feedURL = itemMap.url;
		map.tableTitle = itemMap.label;
		return map;
	},
    
	getDrilldownPreferences: function(/*Object*/itemMap){
		var map = {};
        var url={"baseURL":itemMap.url,"parameters":[]};
        
		map.__vUrl = dojo.toJson(url);
		map.tableTitle = itemMap.label;
		return map;
	},    

	getFeedspacePreferences: function(/*Object*/itemMap){
		// summary: get feedspace portlet preferences
	    var url = itemMap.url.replace(/&/g,"&amp;").replace(/>/g,"&gt;").replace(/</g,"&lt;").replace(/"/g,"&quot;").replace(/'/,"&#39;");
		var label = itemMap.label.replace(/&/g,"&amp;").replace(/>/g,"&gt;").replace(/</g,"&lt;").replace(/"/g,"&quot;").replace(/'/,"&#39;");
		var map = {};          
		map.selection = "/0";            
	    var subscriptions = '<?xml version="1.0" encoding="utf-8"?><opml version="2.0"><head><title><![CDATA[My Subscription List]]></title><dateModified><![CDATA[' + Date() + ']]></dateModified></head><body><outline xml:id="Subscription_1';
	    subscriptions = subscriptions + '" text="' + label + '" type="rss" isComment="false" isBreakpoint="false" created="' + Date() + '" category="" title="' + label + '" xmlUrl="' + url + '" /></body></opml>';
	    map.subscriptions = subscriptions;
	    return map;
	},
	
	getJSRWcmRenderingPreferences: function(/*Object*/args){  
		// summary: get WCM rendering portlet preferences
		var displayTitle = args.title.replace(/&/g,"&amp;").replace(/>/g,"&gt;").replace(/</g,"&lt;").replace(/"/g,"&quot;").replace(/'/,"&#39;");
		var map = {};
	    map.WCM_CONTENT_CONTEXT_IDR = args.contextid; 
	    map.WCM_BROADCASTS_TO = "WCM_LINKING_NONE";
	    map.WCM_CONTENT_TYPE = "CONTENT";
	    map.WCM_CONTENT_CONTEXT_TYPE = "sitearea";
	    map.WCM_LISTENS_TO = "WCM_LINKING_OTHER";
	    map.WCM_PORTLET_TITLE = displayTitle;
		map.WCM_PORTLET_TITLE_TYPE = "WCM_PORTLET_TITLE_TYPE_GENERAL";      
	    return map;
	},

/*******************************************************/
/*       Helper functions for blogs/wikis  	           */
/*******************************************************/

	_addResourceListFeed: function(/*string*/new_name, /*string*/wcmLibraryType, /*string*/operation_id, /*function*/callback, /*function*/ errorFcn){
		// summary: verifies the name or copies a library with the feed
		var baseUrl = ibmPortalConfig.contentHandlerURI;
		var feedUrl = baseUrl + "?uri=wcmbw:id:" + operation_id;
		var message = dojo.i18n.getLocalization("com.ibm.bundles", "Shelf")["new_wcm_wcmNotCopied"];
		var getResourceHandler = dojo.xhrPost({
			url: feedUrl,
			content: {
				blogname: new_name,
				resourcetype: wcmLibraryType,
				pageid: com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID()
			},
			handleAs: "json",
			preventCache: true,
			load: function(data){
				var pageId = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID(),
					navModel = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel(),
					page = navModel.find(pageId).start(),
					hasScopeMetadata = page.getMetaData("param.sharing.scope") != null,
					canSet = page.confirmSetMetaData("param.sharing.scope");
				if(operation_id == "copylibrary" && canSet && !hasScopeMetadata){
					page.setMetaData("param.sharing.scope","ibm.wcm.0." + new Date().getTime());
				}
				if(callback) { callback(data.items[0]); }
			},
			error: function(error,ioArgs){
				if(errorFcn) { errorFcn(); }
			}
		 });
		return getResourceHandler;
	},

	_validateNameField: function(/*String*/newName, /*String*/wcmLibraryType, /*function*/callback, /*function*/ errorFcn){
		// summary: makes sure that a name is not already taken in WCM
		var rv = false;
		if (newName && newName.length > 0) {
			rv = true;
			return com.ibm.pb.customize.enabler.AddContentController._addResourceListFeed(newName, wcmLibraryType, "validinput", callback, errorFcn); 
		}
	},

	_processCreateLibrary: function(/*String*/name, /*String*/wcmLibraryType, /*function*/callback, /*function*/ errorFcn){
		// summary: creates a blog/wiki
		var newLibrId = null;
		var templateName = "Wiki Template v70";
		if (wcmLibraryType == "BLOG_LIBRARY_TYPE") {
			templateName = "Blog Template v70";
		}else if (wcmLibraryType == "BLOG_SOLO_TYPE") {
			templateName = "Blog Solo Template v70";
		}    
		return com.ibm.pb.customize.enabler.AddContentController._addResourceListFeed(name, templateName, "copylibrary", callback, errorFcn);
	}
};

dojo.provide("com.ibm.pb.customize.Identifiable");
dojo.declare("com.ibm.pb.customize.Identifiable",com.ibm.mashups.enabler.Identifiable,{
	_id: null,
	
	constructor: function(id) {
		this._id = id;
	},
	
	getID: function() {
		return this._id;
	}
});

}

if(!dojo._hasResource["com.ibm.pb.data.LayoutTemplateModelStore"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.data.LayoutTemplateModelStore"] = true;
dojo.provide( "com.ibm.pb.data.LayoutTemplateModelStore" );

dojo.require( "com.ibm.data.CatalogMixin" );

// summary: Wrappers Enabler's Layout Template Model API into a dojo DataStore for use with dojo widgets.
// description: This data store in particular is designed to work with the Customize shelf widgets. 
dojo.declare( "com.ibm.pb.data.LayoutTemplateModelStore", [com.ibm.data.CatalogMixin], {
	constructor: function () {
		this.model = com.ibm.mashups.enabler.layouttemplate.Factory.getTemplateModel();
		this.localizedContext = com.ibm.mashups.enabler.context.Factory.getLocalizedContext();
	},
	searchable: true,
	mapItem: function(/*DatstoreItem*/item){
		// summary: Returns a map containing parameters for the given datastore item
		//		The keys must be: label, description, tags, rating, url, id, thumbnail
		//			- label, description, url, id and thumbnail are strings
		//			- tags is an array of strings
		//			- rating is a string that contains a number, note that decimal values are allowed
		//		Having all content search datastores create item maps with the same keys allows the widget to access information uniformly
		// 		If a datastore item does not have the same attributes for getValue as seen below, this function must be overridden
		//		If a datastore item does not have an appropriate parameter to  map to a key, that map entry can be omitted
		//		An example for a datastore item with a title, summary, rating and identifier:
		//			mapItem: function(/*DatastoreItem*/item){
		//				// does not include the "tags" and "url" keys
		//				var map = {};
		//				map["label"] = this.getValue(item, "title", "untitled");
		//				map["description"] = this.getValue(item, "summary", null);
		//				map["rating"] = this.getValue(item, "rating", "0.0");
		//				map["id"] = this.getValue(item, "identifier", null);
		//				map["thumbnail"] = this.getValue(item, "thumbnail", null);
		//				return map;
		//			}
		var map = {};
		map.label = "untitled3";
		var titleFar = this.getLabel(item);
		if (titleFar) {
			if ( typeof titleFar == "string" ) {
				map.label = titleFar;
			} else {
				titleFar.setFinishedCallback(function (title) {
					map.label = title ? title : "untitled2";
				});
				titleFar.start();
			}
		}
		
		map["description"] = null;

		var url = this.getValue(item, "URL", "");
		map["url"] = "dav:"+url.substring(url.indexOf("dav")+4,url.lastIndexOf("/"));  // dav url
		
		map["id"] = this.getValue(item, "ID", null);
		
		map.thumbnail = "";
		var webDavBasePath = com.ibm.mm.enabler.remote.WebDavUrlFactory.createUrl();
		var thumbnailPath = item.getMetaData( "thumbnailPath" );
		if ( thumbnailPath ) {
		   if( typeof thumbnailPath === "string" ){
			   map.thumbnail = webDavBasePath + thumbnailPath;
		   } else {
			   thumbnailPath.setFinishedCallback(function (path) {
				   map.thumbnail = webDavBasePath + path;
			   });
			   thumbnailPath.start();
		   }
		}
		
		return map;
	},
	/********************************/
	/**                            **/
	/**                            **/
	/**    dojo.data.api.Identity  **/
	/**                            **/
	/**                            **/
	/********************************/
   getIdentity: function(/* item */ item) {
		//    summary:
		//        Returns a unique identifier for an item. The return value will be
		//        either a string or something that has a toString() method.
		//    item:
		//        The item from the store from which to obtain its identifier.
		//    exceptions:
		//        Conforming implementations may throw an exception or return null if
		//        item is not an item.
		return this.getValue( "ID" );
    },
    getIdentityAttributes: function(/* item */ item) {
		//    summary:
		//        Returns an array of attribute names that are used to generate the identity.
		//        For most stores, this is a single attribute, but for some complex stores
		//        such as RDB backed stores that use compound (multi-attribute) identifiers
		//        it can be more than one. If the identity is not composed of attributes
		//        on the item, it will return null. This function is intended to identify
		//        the attributes that comprise the identity so that so that during a render
		//        of all attributes, the UI can hide the the identity information if it
		//        chooses.
		//    item:
		//        The item from the store from which to obtain the array of public attributes that
		//        compose the identifier, if any.
    	return [ "ID" ];
    },
    fetchItemByIdentity: function(/* object */ keywordArgs) {
		//    summary:
		//        Given the identity of an item, this method returns the item that has
		//        that identity through the onItem callback. Conforming implementations
		//        should return null if there is no item with the given identity.
		//        Implementations of fetchItemByIdentity() may sometimes return an item
		//        from a local cache and may sometimes fetch an item from a remote server,
		//
		//    keywordArgs:
		//        An anonymous object that defines the item to locate and callbacks to invoke when the
		//        item has been located and load has completed. The format of the object is as follows:
		//        {
		//            identity: string|object,
		//            onItem: Function,
		//            onError: Function,
		//            scope: object
		//        }
		//    The *identity* parameter.
		//        The identity parameter is the identity of the item you wish to locate and load
		//        This attribute is required. It should be a string or an object that toString()
		//        can be called on.
		//
		//    The *onItem* parameter.
		//        Function(item)
		//        The onItem parameter is the callback to invoke when the item has been loaded. It takes only one
		//        parameter, the item located, or null if none found.
		//
		//    The *onError* parameter.
		//        Function(error)
		//        The onError parameter is the callback to invoke when the item load encountered an error. It takes only one
		//        parameter, the error object
		//
		//    The *scope* parameter.
		//        If a scope object is provided, all of the callback functions (onItem,
		//        onError, etc) will be invoked in the context of the scope object.
		//        In the body of the callback function, the value of the "this"
		//        keyword will be the scope object. If no scope object is provided,
		//        the callback functions will be called in the context of dojo.global.
		//        For example, onItem.call(scope, item, request) vs.
		//        onItem.call(dojo.global, item, request)
		keywordArgs.path = keywordArgs.identity.toString();
		return this.fetch( keywordArgs );
    },
    /********************************/
	/**                            **/
	/**                            **/
	/**    dojo.data.api.Read      **/
	/**                            **/
	/**                            **/
	/********************************/
	getFeatures: function() {
		//    summary:
		//        The getFeatures() method returns an simple keyword values object
		//        that specifies what interface features the datastore implements.
		//        A simple CsvStore may be read-only, and the only feature it
		//        implements will be the 'dojo.data.api.Read' interface, so the
		//        getFeatures() method will return an object like this one:
		//        {'dojo.data.api.Read': true}.
		//        A more sophisticated datastore might implement a variety of
		//        interface features, like 'dojo.data.api.Read', 'dojo.data.api.Write',
		//        'dojo.data.api.Identity', and 'dojo.data.api.Attribution'.
		return {
			'dojo.data.api.Read': true,
			'dojo.data.api.Identity': true
		};
	},
    getValue: function( /* item */ item, /* attribute-name-string */ attribute, 
                        /* value? */ defaultValue){
		var result = defaultValue;
		var attribute_lc = attribute.toLowerCase();
	
		switch ( attribute_lc ) {
			case "title": 
				result = this.localizedContext.getTitle( item );
				break;
			case "description": 
				result = this.localizedContext.getDescription( item );
				break;
			case "id": 
				result = item.remoteFile.getName();
				break;
			default: 
				if ( this.hasAttribute( item, attribute ) ) {
					result = item[ "get" + attribute ]();
				}
		}
   		
   		return result;
    },
   getValues: function(/* item */ item, /* attribute-name-string */ attribute) {
		//    summary:
		//         This getValues() method works just like the getValue() method, but getValues()
		//        always returns an array rather than a single attribute value.  The array
		//        may be empty, may contain a single attribute value, or may contain many
		//        attribute values.
		//        If the item does not have a value for the given attribute, then getValues()
		//        will return an empty array: [].  (So, if store.hasAttribute(item, attribute)
		//        returns false, then store.getValues(item, attribute) will return [].)
		//
		//    item:
		//        The item to access values on.
		//    attribute:
		//        The attribute to access represented as a string.
		//
		//    exceptions:
		//        Throws an exception if *item* is not an item, or *attribute* is not a string
		var result = [];
		var value = this.getValue( item, attribute, undefined );
		if ( value !== undefined ) {
			result.push( value );
		}
		return result;
    },
    getAttributes: function(/* item */ item) {
		//    summary:
		//        Returns an array with all the attributes that this item has.  This
		//        method will always return an array; if the item has no attributes
		//        at all, getAttributes() will return an empty array: [].
		//
		//    item:
		//        The item to access attributes on.
		//
		//    exceptions:
		//        Throws an exception if *item* is not an item, or *attribute* is not a string
		var attr = [];
		
		for (var prop in item ) {
			if (Object.prototype.hasOwnProperty.call( item, prop ) && prop.indexOf( "get" ) === 0 ) {
				attr.push( prop.substring( 3 ) );
			}
		}
		return attr;
    },
    hasAttribute: function(/* item */ item, /* attribute-name-string */ attribute) {
		//    summary:
		//        Returns true if the given *item* has a value for the given *attribute*.
		//
		//    item:
		//        The item to access attributes on.
		//    attribute:
		//        The attribute to access represented as a string.
		//
		//    exceptions:
		//        Throws an exception if *item* is not an item, or *attribute* is not a string
    	var result = false;
    	if ( item[ "get" + attribute ] !== undefined ) {
    		result = true;
    	}
    	
    	return result;
    },
    containsValue: function(/* item */ item, /* attribute-name-string */ attribute, /* anything */ value) {
		//    summary:
		//        Returns true if the given *value* is one of the values that getValues()
		//        would return.
		//
		//    item:
		//        The item to access values on.
		//    attribute:
		//        The attribute to access represented as a string.
		//    value:
		//        The value to match as a value for the attribute.
		//
		//    exceptions:
		//        Throws an exception if *item* is not an item, or *attribute* is not a string
		var result = false;
		var values = this.getValues( item, attribute );

		if ( values.length > 0 ) {
			var l = values.length;
			var i = 0;
			var found = false;
			while ( !found && i < l ) {
				found = ( values[i] === value );
				i++;
			}
		}
		
		return result;
    }, 
    isItem: function(/* anything */ something) {
		//    summary:
		//        Returns true if *something* is an item and came from the store instance.
		//        Returns false if *something* is a literal, an item from another store instance,
		//        or is any object other than an item.
		//
		//    something:
		//        Can be anything.
		//
   		return something !== undefined && something.declaredClass === "com.ibm.mm.enabler.layouttemplate.LayoutTemplate";
    },
    isItemLoaded: function(/* anything */ something) {
		//    summary:
		//        Returns false if isItem(something) is false.  Returns false if
		//        if isItem(something) is true but the the item is not yet loaded
		//        in local memory (for example, if the item has not yet been read
		//        from the server).
		//
		//    something:
		//        Can be anything.
		//
		return this.isItem(something) && something.remoteFile !== undefined;
	},
	loadItem: function(/* object */ keywordArgs) {
		//    summary:
		//        Given an item, this method loads the item so that a subsequent call
		//        to store.isItemLoaded(item) will return true.  If a call to
		//        isItemLoaded() returns true before loadItem() is even called,
		//        then loadItem() need not do any work at all and will not even invoke
		//        the callback handlers.  So, before invoking this method, check that
		//        the item has not already been loaded.
		//     keywordArgs:
		//        An anonymous object that defines the item to load and callbacks to invoke when the
		//        load has completed.  The format of the object is as follows:
		//        {
		//            item: object,
		//            onItem: Function,
		//            onError: Function,
		//            scope: object
		//        }
		//    The *item* parameter.
		//        The item parameter is an object that represents the item in question that should be
		//        contained by the store.  This attribute is required.
		//    The *onItem* parameter.
		//        Function(item)
		//        The onItem parameter is the callback to invoke when the item has been loaded.  It takes only one
		//        parameter, the fully loaded item.
		//
		//    The *onError* parameter.
		//        Function(error)
		//        The onError parameter is the callback to invoke when the item load encountered an error.  It takes only one
		//        parameter, the error object
		//
		//    The *scope* parameter.
		//        If a scope object is provided, all of the callback functions (onItem,
		//        onError, etc) will be invoked in the context of the scope object.
		//        In the body of the callback function, the value of the "this"
		//        keyword will be the scope object.   If no scope object is provided,
		//        the callback functions will be called in the context of dojo.global().
		//        For example, onItem.call(scope, item, request) vs.
		//        onItem.call(dojo.global(), item, request) 
	},
    getLabel: function(/* item */ item) {
		//    summary:
		//        Method to inspect the item and return a user-readable 'label' for the item
		//        that provides a general/adequate description of what the item is.
		//
		//    description:
		//        Method to inspect the item and return a user-readable 'label' for the item
		//        that provides a general/adequate description of what the item is.  In general
		//        most labels will be a specific attribute value or collection of the attribute
		//        values that combine to label the item in some manner.  For example for an item
		//        that represents a person it may return the label as:  "firstname lastlame" where
		//        the firstname and lastname are attributes on the item.  If the store is unable
		//        to determine an adequate human readable label, it should return undefined.  Users that wish
		//        to customize how a store instance labels items should replace the getLabel() function on
		//        their instance of the store, or extend the store and replace the function in
		//        the extension class.
		//
		//    item:
		//        The item to return the label for.
		//
		//    returns:
		//        A user-readable string representing the item or undefined if no user-readable label can
		//        be generated.
		return this.localizedContext.getTitle( item );   	
    },
    getLabelAttributes: function(/* item */ item) {
		//    summary:
		//        Method to inspect the item and return an array of what attributes of the item were used
		//        to generate its label, if any.
		//
		//    description:
		//        Method to inspect the item and return an array of what attributes of the item were used
		//        to generate its label, if any.  This function is to assist UI developers in knowing what
		//        attributes can be ignored out of the attributes an item has when displaying it, in cases
		//        where the UI is using the label as an overall identifer should they wish to hide
		//        redundant information.
		//
		//    item:
		//        The item to return the list of label attributes for.
		//
		//    returns:
		//        An array of attribute names that were used to generate the label, or null if public attributes
		//        were not used to generate the label.
		return [ "Title", "Description" ];
    },
    fetch: function(/* Object */ keywordArgs) {
		//    summary:
		//        Given a query and set of defined options, such as a start and count of items to return,
		//        this method executes the query and makes the results available as data items.
		//        The format and expectations of stores is that they operate in a generally asynchronous
		//        manner, therefore callbacks are always used to return items located by the fetch parameters.
		//
		//    description:
		//        A Request object will always be returned and is returned immediately.
		//        The basic request is nothing more than the keyword args passed to fetch and
		//        an additional function attached, abort().  The returned request object may then be used
		//        to cancel a fetch.  All data items returns are passed through the callbacks defined in the
		//        fetch parameters and are not present on the 'request' object.
		//
		//        This does not mean that custom stores can not add methods and properties to the request object
		//        returned, only that the API does not require it.  For more info about the Request API,
		//        see dojo.data.api.Request
		//
		//    keywordArgs:
		//        The keywordArgs parameter may either be an instance of
		//        conforming to dojo.data.api.Request or may be a simple anonymous object
		//        that may contain any of the following:
		//        {
		//            query: query-string or query-object,
		//            queryOptions: object,
		//            onBegin: Function,
		//            onItem: Function,
		//            onComplete: Function,
		//            onError: Function,
		//            scope: object,
		//            start: int
		//            count: int
		//            sort: array
		//        }
		//        All implementations should accept keywordArgs objects with any of
		//        the 9 standard properties: query, onBegin, onItem, onComplete, onError
		//        scope, sort, start, and count.  Some implementations may accept additional
		//        properties in the keywordArgs object as valid parameters, such as
		//        {includeOutliers:true}.
		//
		//        The *query* parameter.
		//        The query may be optional in some data store implementations.
		//        The dojo.data.api.Read API does not specify the syntax or semantics
		//        of the query itself -- each different data store implementation
		//        may have its own notion of what a query should look like.
		//        However, as of dojo 0.9, 1.0, and 1.1, all the provided datastores in dojo.data
		//        and dojox.data support an object structure query, where the object is a set of
		//        name/value parameters such as { attrFoo: valueBar, attrFoo1: valueBar1}.  Most of the
		//        dijit widgets, such as ComboBox assume this to be the case when working with a datastore
		//        when they dynamically update the query.  Therefore, for maximum compatibility with dijit
		//        widgets the recommended query parameter is a key/value object.  That does not mean that th
		//        the datastore may not take alternative query forms, such as a simple string, a Date, a number,
		//        or a mix of such.  Ultimately, The dojo.data.api.Read API is agnostic about what the query
		//        format.
		//        Further note:  In general for query objects that accept strings as attribute
		//        value matches, the store should also support basic filtering capability, such as *
		//        (match any character) and ? (match single character).  An example query that is a query object
		//        would be like: { attrFoo: "value*"}.  Which generally means match all items where they have
		//        an attribute named attrFoo, with a value that starts with 'value'.
		//
		//    The *queryOptions* parameter
		//        The queryOptions parameter is an optional parameter used to specify options that may modify
		//        the query in some fashion, such as doing a case insensitive search, or doing a deep search
		//        where all items in a hierarchical representation of data are scanned instead of just the root
		//        items.  It currently defines two options that all datastores should attempt to honor if possible:
		//        {
		//            ignoreCase: boolean, //Whether or not the query should match case sensitively or not.  Default behaviour is false.
		//            deep: boolean     //Whether or not a fetch should do a deep search of items and all child
		//                            //items instead of just root-level items in a datastore.  Default is false.
		//        }
		//
		//    The *onBegin* parameter.
		//        function(size, request);
		//        If an onBegin callback function is provided, the callback function
		//        will be called just once, before the first onItem callback is called.
		//        The onBegin callback function will be passed two arguments, the
		//        the total number of items identified and the Request object.  If the total number is
		//        unknown, then size will be -1.  Note that size is not necessarily the size of the
		//        collection of items returned from the query, as the request may have specified to return only a
		//        subset of the total set of items through the use of the start and count parameters.
		//
		//    The *onItem* parameter.
		//        function(item, request);
		//        If an onItem callback function is provided, the callback function
		//        will be called as each item in the result is received. The callback
		//        function will be passed two arguments: the item itself, and the
		//        Request object.
		//
		//    The *onComplete* parameter.
		//        function(items, request);
		//
		//        If an onComplete callback function is provided, the callback function
		//        will be called just once, after the last onItem callback is called.
		//        Note that if the onItem callback is not present, then onComplete will be passed
		//        an array containing all items which matched the query and the request object.
		//        If the onItem callback is present, then onComplete is called as:
		//        onComplete(null, request).
		//
		//    The *onError* parameter.
		//        function(errorData, request);
		//        If an onError callback function is provided, the callback function
		//        will be called if there is any sort of error while attempting to
		//        execute the query.
		//        The onError callback function will be passed two arguments:
		//        an Error object and the Request object.
		//
		//    The *scope* parameter.
		//        If a scope object is provided, all of the callback functions (onItem,
		//        onComplete, onError, etc) will be invoked in the context of the scope
		//        object.  In the body of the callback function, the value of the "this"
		//        keyword will be the scope object.   If no scope object is provided,
		//        the callback functions will be called in the context of dojo.global().
		//        For example, onItem.call(scope, item, request) vs.
		//        onItem.call(dojo.global(), item, request)
		//
		//    The *start* parameter.
		//        If a start parameter is specified, this is a indication to the datastore to
		//        only start returning items once the start number of items have been located and
		//        skipped.  When this parameter is paired with 'count', the store should be able
		//        to page across queries with millions of hits by only returning subsets of the
		//        hits for each query
		//
		//    The *count* parameter.
		//        If a count parameter is specified, this is a indication to the datastore to
		//        only return up to that many items.  This allows a fetch call that may have
		//        millions of item matches to be paired down to something reasonable.
		//
		//    The *sort* parameter.
		//        If a sort parameter is specified, this is a indication to the datastore to
		//        sort the items in some manner before returning the items.  The array is an array of
		//        javascript objects that must conform to the following format to be applied to the
		//        fetching of items:
		//        {
		//            attribute: attribute || attribute-name-string,
		//            descending: true|false;   // Optional.  Default is false.
		//        }
		//        Note that when comparing attributes, if an item contains no value for the attribute
		//        (undefined), then it the default ascending sort logic should push it to the bottom
		//        of the list.  In the descending order case, it such items should appear at the top of the list.
		//
		//    returns:
		//        The fetch() method will return a javascript object conforming to the API
		//        defined in dojo.data.api.Request.  In general, it will be the keywordArgs
		//        object returned with the required functions in Request.js attached.
		//        Its general purpose is to provide a convenient way for a caller to abort an
		//        ongoing fetch.
		//
		//        The Request object may also have additional properties when it is returned
		//        such as request.store property, which is a pointer to the datastore object that
		//        fetch() is a method of.
		//
		//    exceptions:
		//        Throws an exception if the query is not valid, or if the query
		//        is required but was not supplied.
		if ( keywordArgs === undefined || keywordArgs === null ) {
			keywordArgs = {};
		}
		
		var query = keywordArgs.query;
		var keywordSearch = query ? query.keywords : undefined;
		var onBegin = keywordArgs.onBegin;
		var onItem = keywordArgs.onItem;
		var onComplete = keywordArgs.onComplete;
		var onError = keywordArgs.onError;
		var scope = keywordArgs.scope ? keywordArgs.scope : dojo.global;
		var start = keywordArgs.start ? keywordArgs.start : 0;
		var count = keywordArgs.count ? keywordArgs.count : Number.POSITIVE_INFINITY;
		var sort = keywordArgs.sort ? keywordArgs.sort : undefined;
		var caseInsensitive = keywordArgs.queryOptions ? keywordArgs.queryOptions.ignoreCase : undefined;
		var sortAttribute;
		var isSortDescending;
		
		if ( sort ) {
			sortAttribute = sort.attribute;
			isSortDescending = sort.descending;
		} else {
			sortAttribute = "id";
		}
		
		var request = keywordArgs;
		request.abort = function () {
			//any way to abort an Enabler Deferred?
			this.aborted = true;
		};
		
		//These odd looking function definitions simply ensure that all of the possible events are defined to a valid
		//function - even if it's an empty function. This simplifies the iteration code a bit, saving a few conditional
		//checks later on.
		var makeOnBeginCall = onBegin ? function (size) {
			if ( !request.aborted ) {
				onBegin.call( scope, size, request );
			}
		} : function () {};
		
		//Determines whether or not an item should be accepted into the result set.
		var me = this;
		var itemAcceptFunction = function ( item ) {
			var shouldCall = !request.aborted;
			if ( keywordSearch && keywordSearch.length > 0) {
				var id = me.mapItem(item).label;
				if ( caseInsensitive ) {
					id = id.toUpperCase();
				}
				
				var len = keywordSearch.length;
				var keyword;
				for ( var i = 0; i < len; i++ ) {
					keyword = keywordSearch[i];
					
					if ( caseInsensitive ) {
						keyword = keyword.toUpperCase();
					}
					if ( id.indexOf( keyword ) < 0 ) {
						return false;
					}
				}	
			}
			return shouldCall;
		};
		
		var makeOnItemCall = onItem ? function ( item ) {
			onItem.call( scope, item, request );
		} : function () {};
		
		var me = this;
		var makeOnCompleteCall = onComplete ? function ( items ) {
			if ( !request.aborted ) {
				if ( onItem ) {
					onComplete.call( scope, null, request );
				} else {
					//Sorts based on the given attribute. The given attribute must be one of the attributes provided by
					//this.mapItem().
					if ( sortAttribute ) {
						var lc_sortAttribute = sortAttribute.toLowerCase();
						//Control sort order based on the provided options.
						var lessThan = isSortDescending ? 1 : -1;
						var greaterThan = isSortDescending ? -1 : 1;
						var equal = 0;
						
						var sortedItems = items.sort(function (a,b) {
							var retVal = undefined;
							var item1 = me.mapItem(a);
							var item2 = me.mapItem(b);
							
							var value1 = item1[ lc_sortAttribute ];
							var value2 = item2[ lc_sortAttribute ];
							
							//Sorting logic:
							//According to the dojo data API definition, any undefined values go to the end for 
							//ascending sort order and the beginning for descending sort order. We return a -1 if value1
							//is less than value2, a 0 if value1 is equal to value2, or a +1 if value1 is greater than 
							//value2. The return value is reversed (via the local variables declared outside of this
							//function) if the sort order is descending (ascending is the default).
							
							if ( !value1 && value2 ) {
								retVal = greaterThan;
							} else if ( !value1 && !value2 ) {
								retVal = equal;
							} else if ( value1 && !value2 ) {
								retVal = lessThan;
							} else if ( value1 === value2 ) {
								retVal = equal;
							} else if ( value1 > value2 ) {
								retVal = greaterThan;
							} else if ( value1 < value2 ) {
								retVal = lessThan;
							} else {
								retVal = equal;
							}
							
							return retVal;
						});
						
						//Make sure we didn't have a failure or lose an item along the way - probably better to return
						//out of order items instead of nothing or an incomplete result set.
						if ( sortedItems !== null && sortedItems.length === items.length ) {
							items = sortedItems.splice( start, count );
						}
					}	
					
					onComplete.call( scope, items, request );
				}
			}
		} : function () {};
		
		var makeOnBeginCall = onBegin ? function ( size ) {
			if ( !request.aborted ) {
				onBegin.call(scope, size, request );
			}
		} : function () {};
		
		var path = query ? query.path : query;
		this._loadItems( path, start, count, itemAcceptFunction, makeOnBeginCall, makeOnItemCall, makeOnCompleteCall );
		
		return request;		
	},
	_loadItems: function ( path, start, count, itemAcceptFunction, makeOnBeginCall, makeOnItemCall, makeOnCompleteCall ) {
		//No specific path is specified or all items are requested. 
		if ( path === undefined || path === null || path === "*" ) {
			var me = this;
			var it = this.model.iterator();
			//The iterator has to load before it can be used. Can switch to setForEachCallback once that is fully implemented.
			it.setFinishedCallback(function () {
				var size = it.size();
				size.setFinishedCallback( function ( totalCount ) {
					var results = [];
					var pending = 0;
					returnedCount = 0;
					var delayedStarts = [];
					var threshold = 2;
					while ( it.hasNext() ) {
						var item = it.next();
						item.setFinishedCallback(function (object) { 
							if ( object && itemAcceptFunction( object ) ) {
								results.push( object );
								//Before an item is fully "loaded", we need to ensure that all remote artifacts are
								//loaded since the widgets make no allowance for a title or description being an 
								//asynchronous call away. Requesting the title here forces the item to load the remote
								//properties file for the current locale that defines the title and description.
								var locale = me.localizedContext.getLocale( object );
								//The available locales are local to the item once the initial PROPFIND occurs. If a 
								//title exists for the current configured locale, then this item isn't finished until 
								//that remote properties file is loaded. Otherwise, just be done.
								if ( locale ) {
									var d = object.getTitle( locale );
									d.setFinishedCallback(function () {
										var d2 = object.getMetaData( "" );
										d2.setFinishedCallback(function () {
											pending--;
											makeOnItemCall( object );
											returnedCount++;
											if ( pending < threshold && delayedStarts.length > 0 ) {
												pending++;
												delayedStarts.pop().start();
											}
											if ( returnedCount == totalCount ) {
												// make callbacks
												makeOnBeginCall( results.length );
												makeOnCompleteCall( results );
											}
										});
										d2.start();
									});
									d.start();
								} else {
									pending--;
									makeOnItemCall( object );
								}
							} else {
								returnedCount++;
								pending--;
								if ( pending < threshold && delayedStarts.length > 0 ) {
									pending++;
									delayedStarts.pop().start();
								}
								if ( returnedCount == totalCount ) {
									// make callbacks
									makeOnBeginCall( results.length );
									makeOnCompleteCall( results );
								}
							}	 
						});
						if ( pending >= threshold ) {
							delayedStarts.push( item );
						} else {
							pending++;
							item.start();
						}
					}
				});
				size.start();
			});
			it.start();
		} else {
			var deferred = this.model.find( path );
			deferred.setFinishedCallback(function (object) {
				makeOnBeginCall( 1 );
				makeOnItemCall( object );
				makeOnCompleteCall( object );
			});
			deferred.start();
		}
	}
    /********************************/
	/**                            **/
	/**                            **/
	/**    dojo.data.api.Write     **/
	/**                            **/
	/**                            **/
	/********************************/
	// deleteItem: function(/* item */ item){
// 		//	summary:
// 		//		Deletes an item from the store.
// 		//
// 		//	item: 
// 		//		The item to delete.
// 		//
// 		//	exceptions:
// 		//		Throws an exception if the argument *item* is not an item 
// 		//		(if store.isItem(item) returns false).
// 		//	example:
// 		//	|	var success = store.deleteItem(kermit);
// 		var success = false;
// 		
// 		if ( this.isItem( item ) ) {
// 			this.model.remove( item );
// 			success = true;
// 		}
// 		
// 		return success;
// 	},
// 	setValue: function(	/* item */ item, 
// 						/* string */ attribute,
// 						/* almost anything */ value){
// 		//	summary:
// 		//		Sets the value of an attribute on an item.
// 		//		Replaces any previous value or values.
// 		//
// 		//	item:
// 		//		The item to modify.
// 		//	attribute:
// 		//		The attribute of the item to change represented as a string name.
// 		//	value:
// 		//		The value to assign to the item.
// 		var attribute = attribute.toLowerCase();
// 		var success = false;
// 		switch ( attribute ) {
// 			case "title": 
// 				item.setTitle( value.locale, value.string );
// 				success = true;
// 			break;
// 			case "description": 
// 				item.setDescription( value.locale, value.string );
// 				success = true;
// 			break;
// 			case "metadata": 
// 				item.setMetaData( value.name, value.value );
// 				success = true;
// 			break;
// 		}
// 		
// 		return success;
// 	},
// 	setValues: function(/* item */ item, /* string */ attribute, /* array */ values) {
// 		//    summary:
// 		//        Adds each value in the *values* array as a value of the given
// 		//        attribute on the given item.
// 		//        Replaces any previous value or values.
// 		//        Calling store.setValues(x, y, []) (with *values* as an empty array) has
// 		//        the same effect as calling store.unsetAttribute(x, y).
// 		//
// 		//    item:
// 		//        The item to modify.
// 		//    attribute:
// 		//        The attribute of the item to change represented as a string name.
// 		//    values:
// 		//        An array of values to assign to the attribute..
// 		//
// 		//    exceptions:
// 		//        Throws an exception if *values* is not an array, if *item* is not an
// 		//        item, or if *attribute* is neither an attribute object or a string.
// 		//    examples:
// 		//        var success = store.setValues(kermit, "color", ["green", "aqua"]);
// 		//        success = store.setValues(kermit, "color", []);
// 		//        if (success) {assert(!store.hasAttribute(kermit, "color"));}
// 		var l = values.length;
// 		var success = true;
// 		for ( var i = 0; i < l; i++ ) {
// 			success = success && this.setValue( item, attribute, values[i] );
// 		}
// 		
// 		return success;
//     },
// 	newItem: function(/* Object */ keywordArgs, /*Object?*/ parentInfo) {
// 		//   summary:
// 		//        Returns a newly created item.  Sets the attributes of the new
// 		//        item based on the *keywordArgs* provided.  In general, the attribute
// 		//        names in the keywords become the attributes in the new item and as for
// 		//        the attribute values in keywordArgs, they become the values of the attributes
// 		//        in the new item.  In addition, for stores that support hierarchical item
// 		//        creation, an optional second parameter is accepted that defines what item is the parent
// 		//        of the new item and what attribute of that item should the new item be assigned to.
// 		//        In general, this will assume that the attribute targetted is multi-valued and a new item
// 		//        is appended onto the list of values for that attribute.
// 		//
// 		//    keywordArgs:
// 		//        A javascript object defining the initial content of the item as a set of JavaScript 'property name: value' pairs.
// 		//    parentInfo:
// 		//        An optional javascript object defining what item is the parent of this item (in a hierarchical store.  Not all stores do hierarchical items),
// 		//        and what attribute of that parent to assign the new item to.  If this is present, and the attribute specified
// 		//        is a multi-valued attribute, it will append this item into the array of values for that attribute.  The structure
// 		//        of the object is as follows:
// 		//        {
// 		//            parent: someItem,
// 		//            attribute: "attribute-name-string"
// 		//        }
// 		//
// 		//    exceptions:
// 		//        Throws an exception if *keywordArgs* is a string or a number or
// 		//        anything other than a simple anonymous object.
// 		//        Throws an exception if the item in parentInfo is not an item from the store
// 		//        or if the attribute isn't an attribute name string.
// 		//    examples:
// 		//        var kermit = store.newItem({name: "Kermit", color:[blue, green]});
// 		var path = keywordArgs.path;
// 		var metadata = keywordArgs.metadata;
// 		var titles = keywordArgs.titles;
// 		var descriptions = keywordArgs.descriptions;
// 		
// 		var item = this.model.create({ name: path });
// 		if ( metadata ) {
// 			for (var prop in metadata ) {
// 				if (Object.prototype.hasOwnProperty.call( metadata, prop ) ) {
// 					item.setMetaData( prop, metadata[prop] );
// 				}
// 			}
// 		}
// 		if ( titles ) {
// 			for (var locale in titles ) {
// 				if (Object.prototype.hasOwnProperty.call( titles, locale ) ) {
// 					item.setMetaData( locale, titles[locale] );
// 				}
// 			}
// 		}
// 		if ( descriptions ) {
// 			for (var locale in descriptions ) {
// 				if (Object.prototype.hasOwnProperty.call( descriptions, locale ) ) {
// 					item.setMetaData( locale, descriptions[locale] );
// 				}
// 			}
// 		}
// 		return item;
// 	},
// 	save: function(/* object */ keywordArgs) {
// 		//    summary:
// 		//        Saves to the server all the changes that have been made locally.
// 		//        The save operation may take some time and is generally performed
// 		//        in an asynchronous fashion.  The outcome of the save action is
// 		//        is passed into the set of supported callbacks for the save.
// 		//
// 		//    keywordArgs:
// 		//        {
// 		//            onComplete: function
// 		//            onError: function
// 		//            scope: object
// 		//        }
// 		//
// 		//    The *onComplete* parameter.
// 		//        function();
// 		//
// 		//        If an onComplete callback function is provided, the callback function
// 		//        will be called just once, after the save has completed.  No parameters
// 		//        are generally passed to the onComplete.
// 		//
// 		//    The *onError* parameter.
// 		//        function(errorData);
// 		//
// 		//        If an onError callback function is provided, the callback function
// 		//        will be called if there is any sort of error while attempting to
// 		//        execute the save.  The onError function will be based one parameter, the
// 		//        error.
// 		//
// 		//    The *scope* parameter.
// 		//        If a scope object is provided, all of the callback function (
// 		//        onComplete, onError, etc) will be invoked in the context of the scope
// 		//        object.  In the body of the callback function, the value of the "this"
// 		//        keyword will be the scope object.   If no scope object is provided,
// 		//        the callback functions will be called in the context of dojo.global.
// 		//        For example, onComplete.call(scope) vs.
// 		//        onComplete.call(dojo.global)
// 		//
// 		//    returns:
// 		//        Nothing.  Since the saves are generally asynchronous, there is
// 		//        no need to return anything.  All results are passed via callbacks.
// 		//    examples:
// 		//        store.save({onComplete: onSave});
// 		//        store.save({scope: fooObj, onComplete: onSave, onError: saveFailed});
// 		var scope = keywordArgs.scope ? keywordArgs.scope : dojo.global;
// 		var d = this.model.commit();
// 		d.setFinishedCallback(function () {
// 			onComplete.call( scope );
// 		});
// 	},
// 	revert: function() {
// 		//    summary:
// 		//        Discards any unsaved changes.
// 		//    description:
// 		//        Discards any unsaved changes.
// 		//
// 		//    examples:
// 		//        var success = store.revert();
// 		this.model._revert();
// 		return true;
// 	},
// 	isDirty: function(/* item? */ item) {
// 		//    summary:
// 		//        Given an item, isDirty() returns true if the item has been modified
// 		//        since the last save().  If isDirty() is called with no *item* argument,
// 		//        then this method returns true if any item has been modified since
// 		//        the last save().
// 		//
// 		//    item:
// 		//        The item to check.
// 		//
// 		//    exceptions:
// 		//        Throws an exception if isDirty() is passed an argument and the
// 		//        argument is not an item.
// 		//    examples:
// 		//        var trueOrFalse = store.isDirty(kermit); // true if kermit is dirty
// 		//        var trueOrFalse = store.isDirty();       // true if any item is dirty
// 		var result = false;
// 		
// 		if ( item ) {
// 			result = item._isDirty();
// 		} else {
// 			result = this.model.isDirty();
// 		}
// 		
// 		return result;
// 	}
});
			 

}

if(!dojo._hasResource["com.ibm.pb.customize.enabler.ChangeLayoutController"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.customize.enabler.ChangeLayoutController"] = true;
dojo.provide("com.ibm.pb.customize.enabler.ChangeLayoutController");

com.ibm.pb.customize.enabler.ChangeLayoutController = {
	current: "",		// the layout currently selected on the shelf
	set: "",			// the layout currently set on the page
	url: "",			// url to the current layout
	navModel: null,		// enabler navigation model
	dirty: false,		// true if there are changes pending
	started: false,		// true if the widget is started up
	refresh: true,		// true if a page refresh is required to show saved changes
	layoutMarkupMetadataKey: "com.ibm.portal.layout.template.markup",
	layoutNameMetadataKey: "com.ibm.portal.layout.template.file.name.",
	layoutFileName: "layout.html",
	ibmMainContainer: "ibmMainContainer",
	ibmHiddenWidgets: "ibmHiddenWidgets",
	containerNameMetadataKey: "com.ibm.portal.layoutnode.localname",
		
	startup: function(){
		// summary: sets up variables and UI
		this.logger.entering("startup");
		this.current = this.set;		// the currently selected layout is one set for the page
		this.started = true;			// this widget is now started up
		this.setupUI();
		if(!this.navModel) { this.navModel = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel(); }
		this.logger.exiting("startup");
	},
		
	makeDirty: function(/*bool*/change){
		// summary: changes the dirty attribute
		// change: value to assign to the dirty attribute
		this.logger.entering("makeDirty",[change]);
		this.dirty = change;
		this.logger.exiting("makeDirty",[change]);
	},
		
	processChange: function(/*Object*/args){
		// summary: used as an event handler for when a user clicks on an item
		// args: {id:id of the item clicked}
		this.logger.entering("processChange",[args]);
		this.apply(args); 
		this.logger.exiting("processChange",[args]);
	},
		
	apply: function(/*Object*/args){
		// summary: applies a change associated with a selected item to the page
		// args: {id:id of the item clicked}
		this.logger.entering("apply",[args]);
		if(args.id != this.current) {								// return if no change has been made from the current selection
			if(args.id == this.set) { this.makeDirty(false); }		// Change Layout is no longer dirty if the selection is the same as on the server
			else if(this.dirty === false) { this.makeDirty(true); }	// else make Change Layout dirty if it is not already
			this.current = args.id;	
			this.url = args.url;
		}
		com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
		this.logger.exiting("apply",[args]);
	},
		
	undo: function(){
		// summary: reverts any changes made
		this.logger.entering("undo");
		if(this.started) { this.apply({id:this.set}); }
		this.logger.exiting("undo");
	},
		
	beforeSubmit: function(/*Object*/args){
		// summary: Called before submit and returns a Deferred object which should be used
		// 		to get notified when the controller is ready to be submitted.  Attach a callback
		//		to this Deferred to call the controller's submit function instead of calling
		//		it directly.
		this.logger.entering("beforeSubmit",[args]);
		var dfd = new dojo.Deferred();
		dfd.callback();
		this.logger.exiting("beforeSubmit",[args]);
		return dfd;
	},
		
	submit: function(/*Object*/args){
		// summary: saves any pending changes
		// args: {onComplete:function to call when submission is done, onError:function to call if submission fails}
		this.logger.entering("submit",[args]);
		if(!this.dirty) { 
			// if Change Layout is not dirty, call the onComplete handler and return
			if(args.onComplete) { args.onComplete(); }
			this.logger.exiting("submit",[args]);
			return; 
		}
		var pageId = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
		if(pageId){
			var pageRef = this.navModel.find(pageId);
			if(pageRef){
				// get the current page and then call setLayout
				pageRef.setFinishedCallback(dojo.hitch(this, "_setLayout"), args);
				pageRef.start(false);
			} else {
				this.logger.severe("submit","Cannot get page node object from Navigation Model",[args]);
				if(args.onError) { args.onError(); }
			}
		} else {
			this.logger.severe("submit","Cannot get current page id",[args]);
			if(args.onError) { args.onError(); }
		}
		this.logger.exiting("submit",[args]);
	},
	
	/**********************************************/
	/*                                            */
	/*                 	helpers                   */
	/*                                            */
	/**********************************************/
	
	_setLayout: function(page, status, args){
		// summary: receives the current page and from that gets the page content
		// page: current page object
		// status: HTTP status returned from request to retrieve page
		// args: from submit()
		this.logger.entering("_setLayout",[page,status,args]);
		if(status == "200"){
			var contentDef = page.getContent();
			if(contentDef){
				contentDef.setFinishedCallback(dojo.hitch(this,"_setMetadata"), args);
				contentDef.start(false);
			} else {
				this.logger.severe("submit","Cannot get page content object",[args]);
				if(args.onError) { args.onError(); }
			}
		} else {
			this.logger.severe("submit","Cannot get page object for current node",[args]);
			if(args.onError) { args.onError(); }
		}
		this.logger.exiting("_setLayout",[page,status,args]);
	},
	
	_setMetadata: function(content, status, args){
		// summary: receives the current page content and from that sets the layout metadata
		// page: current page content object
		// status: HTTP status returned from request to retrieve page content
		// args: from submit()
		this.logger.entering("_setMetadata",[content,status,args]);
		if(status == 200){
			var markup = content.getMetaData(this.layoutMarkupMetadataKey) || "html";
			if(content.confirmSetStaticContentURL(this.url) && content.confirmSetMetaData(this.layoutNameMetadataKey+markup,this.layoutFileName) && content.confirmRefreshStaticMarkup()) {
					content.setStaticContentURL(this.url);
					content.setMetaData(this.layoutNameMetadataKey+markup,this.layoutFileName);
					content.refreshStaticMarkup();
					this.makeDirty(false);		// make Change Layout not dirty
					this.set = this.current; 	// the set layout is now the same as the current
					this._reparentControls(args.onComplete);
			} else {
				this.logger.severe("_setMetadata","User does not have permission to set new static layout template",[content,status,args]);
				if(args.onError) { args.onError(); }
			}
		} else {
			this.logger.severe("_setMetadata","Cannot get page content object",[content,status,args]);
			if(args.onError) { args.onError(); }
		}
		this.logger.exiting("_setMetadata",[content,status,args]);
	},
	
	_reparentControls: function(onComplete){
		// summary: finds the root layout node
		// onComplete: function to call when finished
		this.logger.entering("_reparentControls",[onComplete]);
		var pageId = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID(),
			layoutModel = this.navModel.getLayoutModel(pageId),
			rootDef = layoutModel.getRoot();
		if(rootDef) {
			rootDef.setFinishedCallback(dojo.hitch(this, "_processControls"), {layoutModel:layoutModel, onComplete:onComplete});
			rootDef.start(false);
		} else { 
			this.logger.severe("_reparentControls","Cannot find root layout container in the Layout Model",[onComplete]);  
			if(onComplete) { onComplete(); }
		}
		this.logger.exiting("_reparentControls",[onComplete]);
	},
	
	_processControls: function(root, status, x){
		// summary: gets the children of the root layout node and reparents those in containers to be deleted
		// root: root layout node object
		// status: HTTP status from request to retrieve root
		// x.layoutModel: layout model for the page
		// x.onComplete: function to call when finished
		this.logger.entering("_processControls",[root,status,x]);
		if(status == 200 || status == "200"){
			var children = x.layoutModel.getChildren(root);
			var newParent = null,
				orphans = [];
			// find the named main layout container
			while(children.hasNext()){
				var child = children.next();
				// found main container
				if(child.getMetaData(this.containerNameMetadataKey) == this.ibmMainContainer) { newParent = child; }
				// skip hidden widgets container
				else if (child.getMetadata(this.containerNameMetadataKey) == this.ibmHiddenWidgets) { continue; }
				else { // reparent controls from this container into the main container
					var grandChildren = x.layoutModel.getChildren(child);
					while(grandChildren.hasNext()) { orphans.push(grandChildren.next()); }
				}
			}
			if(newParent) {
				// reparent the orphans into newParent
				for(var i = 0; i < orphans.length; i++){
					if(!(orphans[i] instanceof com.ibm.mashups.enabler.layout.LayoutControl)) { this.logger.warning("_reparentControls","Orphan is not an instance of a layout control.  Skipping...");  continue; }
					/*if(x.layoutModel.confirmInsert(orphans[i], newParent)) { */try{x.layoutModel.insert(orphans[i], newParent); }catch(e){console.error(e);}//}
					//else { this.logger.warning("_reparentControls","Cannot insert orphaned control into new container.  It will be lost.");  continue; }
				}
			} else { this.logger.warning("_reparentControls","Cannot find the container named '" + this.ibmMainContainer + "' to hold orphaned controls.  They will be lost."); }
			if(x.onComplete) { x.onComplete(); }
		} else {
			this.logger.severe("_processControls","Cannot find root layout container in the Layout Model",[root,status,x]); 
			if(x.onComplete) { x.onComplete(); }
		}
		this.logger.exiting("_processControls",[root,status,x]);
	}
};

}

if(!dojo._hasResource["com.ibm.pb.customize.enabler.ChangeStyleController"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.customize.enabler.ChangeStyleController"] = true;
dojo.provide("com.ibm.pb.customize.enabler.ChangeStyleController");

com.ibm.pb.customize.enabler.ChangeStyleController = {
	current: "",		// the style currently selected on the shelf
	set: "",			// the style currently set on the page
	url: "",			// url to the current stylesheet
	navModel: null,		// enabler navigation model
	dirty: false,		// true if there are changes pending
	started: false,		// true if the widget is started up
	refresh: false,		// true if a page refresh is required to show saved changes
	styleMetadataKey: "colorPalette",
	urlPrefix: ibmCfg.themeConfig.themeRootURI + "/",
	layoutParser: com.ibm.pb.layout.LayoutParser,
	
	startup: function(){
		// summary: sets up variables and UI
		this.logger.entering("startup");
		this.current = this.set;			// the currently selected style is one set for the page
		this.started = true;				// this widget is now started up
		this.setupUI();						// set up the Change Style UI
		if(!this.navModel) { this.navModel = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel(); }
		this.logger.exiting("startup");
	},
		
	makeDirty: function(/*bool*/change){
		// summary: changes the dirty attribute
		// change: value to assign to the dirty attribute
		this.logger.entering("makeDirty",[change]);
		this.dirty = change;
		this.logger.exiting("makeDirty",[change]);
	},
		
	processChange: function(/*Object*/args){
		// summary: used as an event handler for when a user clicks on an item
		// args: {id:id of the item clicked}
		this.logger.entering("processChange",[args]);
		this.apply(args);
		this.logger.exiting("processChange",[args]);
	},
		
	apply: function(/*Object*/args){
		// summary: applies a change associated with a selected item to the page
		// args: {id:id of the item clicked}
		this.logger.entering("apply",[args]);
		if(args.id != this.current) {								// return if no change has been made from the current selection
			if(args.id == this.set) { this.makeDirty(false); }		// Change Style is no longer dirty if the selection is the same as on the server
			else if(this.dirty === false) { this.makeDirty(true); }	// else make Change Style dirty if it is not already
			this.current = args.id;									// set current to the given id
			this.url = args.url;									// set the current url
			this._switchStylesheet(this.current,this.url);			// change the stylesheet on the client
		}
		com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
		this.logger.exiting("apply",[args]);
	},
		
	undo: function(){
		// summary: reverts any changes made
		this.logger.entering("undo");
		if(this.started) { this.apply({id:this.set}); }
		this.logger.exiting("undo");
	},
		
	beforeSubmit: function(/*Object*/args){
		// summary: Called before submit and returns a Deferred object which should be used
		// 		to get notified when the controller is ready to be submitted.  Attach a callback
		//		to this Deferred to call the controller's submit function instead of calling
		//		it directly.
		this.logger.entering("beforeSubmit",[args]);
		var dfd = new dojo.Deferred();
		dfd.callback();
		this.logger.exiting("beforeSubmit",[args]);
		return dfd;
	},
		
	submit: function(/*Object*/args){
		// summary: saves any pending changes
		// args: {onComplete:function to call when submission is done, onError:function to call if submission fails}
		this.logger.entering("submit",[args]);
		if(!this.dirty) { 
			// if Change Style is not dirty, call the onComplete handler and return
			if(args.onComplete) { args.onComplete(); }
			this.logger.exiting("submit",[args]);
			return; 
		}
		var pageId = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
		if(pageId) {
			var pageRef = this.navModel.find(pageId);
			if(pageRef){
				pageRef.setFinishedCallback(dojo.hitch(this, "_setMetadata"), args);
				pageRef.start(false);
			} else {
				this.logger.severe("submit","Cannot get page node object from Navigation Model",[args]);
				if(args.onError) { args.onError(); }
			}
		} else {
			this.logger.severe("submit","Cannot get current page id",[args]);
			if(args.onError) { args.onError(); }
		}	
		this.logger.exiting("submit",[args]);
	},
		
	/***********************************************/
	/*              Helper functions   		       */
	/***********************************************/

	_setMetadata: function(page, status, args){
		// summary: receives the current page and from that sets the layout metadata
		// page: current page object
		// status: HTTP status returned from request to retrieve page
		// args: from submit()
		this.logger.entering("_setMetadata",[page,status,args]); 
		if(status == "200") {
			var content = page.getContent().start();
			if(this.url && content.confirmSetMetaData(this.styleMetadataKey,this.url)){
				if(this.url) content.setMetaData(this.styleMetadataKey,this.url);	// set the style metadata to the currently selected
			} else if(!this.url && content.confirmRemoveMetaData(this.styleMetadataKey)){
				content.removeMetaData(this.styleMetadataKey);
			} else {
				this.logger.severe("submit","User does not have permission to set or delete page metadata",[args]);
				if(args.onError) { args.onError(); }
			}
			this.makeDirty(false);		// make Change Style not dirty
			this.set = this.current; 	// the set style is now the same as the current
			if(args.onComplete) { args.onComplete(); }
		} else {
			this.logger.severe("submit","Cannot find the page object for the current node",[args]);
			if(args.onError) { args.onError(); }
		}
		this.logger.exiting("_setMetadata",[page,status,args]);
	},
	
	_switchStylesheet: function(title,url){
		// summary: switch to the stylesheet with the given title
		var i, currLink, found = false;
		for(i = 0; (currLink = document.getElementsByTagName("link")[i]); i++) {
			// if the link is a perferred stylesheet
			if(currLink.getAttribute("rel").indexOf("style") >= 0 && currLink.getAttribute("title")) { 
				// if the chosen theme is found
				if(currLink.getAttribute("title") == title) {
					currLink.disabled = false;
					found = true;
				}
				else { currLink.disabled = true;  }
			}
		}
		if(!found && url) {
			this._loadCss(url,title,true,true); 
			this._switchStylesheet(title);
		}
	},

	_loadCss: function(path, title, alternate, disabled){
		if(dojo.isIE){
			var link = document.createElement("link");
			link.setAttribute("disabled",disabled);
			if(title) { link.title = title; }
			var head = document.getElementsByTagName("head")[0];
			head.appendChild(link);
			link.setAttribute("type","text/css");
			link.setAttribute("rel",(alternate)?"alternate stylesheet":"stylesheet");
			link.setAttribute("href",this.urlPrefix+path);
			link.setAttribute("media","screen");
		} else {
			var link = dojo.create("link",{type:"text/css",rel:(alternate)?"alternate stylesheet":"stylesheet",href:this.urlPrefix+path,media:"screen",disabled:disabled});
			if(title) { link.title = title; }
			var head = document.getElementsByTagName("head")[0];
			head.appendChild(link);
		}
	}
};

}

if(!dojo._hasResource["com.ibm.widgets.StatusBar"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.widgets.StatusBar"] = true;
dojo.provide( "com.ibm.widgets.StatusBar" );

dojo.require( "dojox.data.dom" );



dojo.declare( "com.ibm.widgets.StatusType", 
    null,
    {
	    constructor: function(/*int*/id,  /*String*/styleClass, /*String*/ iconPath, /*String*/ colorStr) {
	        this._id = id;
	        this._styleClass = styleClass;
	        this._iconPath = iconPath;
	        this._color = colorStr;  // status color fader start color for this class
	    }
    }
);

dojo.declare( "com.ibm.widgets.StatusMessage", 
    null,
    {
    	constructor: function(/*int*/type, /*String*/message, /*String*/details) {
	        this._type = type;
	        this._message = message;
	        this._details = details;
    	}	
    }
);


dojo.declare( "com.ibm.widgets.StatusColorFader", 
    null,
    {
    	constructor: function(/*String*/containerId, /*String*/endColorStr) {
	        this._containerId = containerId;
	        this._beginColorStr = "";
	        this._endColorStr = "";
	
	        this._redCtr = 0x00;
	        this._greenCtr = 0x00;
	        this._blueCtr = 0x00;
	
	        this._endRed = 0x00;
	        this._endGreen = 0x00;
	        this._endBlue = 0x00;
	
	        this.setEndColor(endColorStr);
	
	        this._fadeCallbackId = null;
	
	        this._enable = true;
	    },
        fade: function() {

             // adjust r, g, b counters and see if we have reached end color
             var shouldStop = true;

             // looping here rather than incrementing/decrementing by 10
             // this makes sure we approach the end value without going past it
             // and we can still support any arbitrary start and end color values
             for (var ctr = 0; ctr < 10; ctr++) {
                 if (this._redCtr < this._endRed) {
                     this._redCtr++;
                     shouldStop = false;
                 }
                 else if (this._redCtr > this._endRed) {
                     this._redCtr--;
                     shouldStop = false;
                 }
    
                 if (this._greenCtr < this._endGreen) {
                     this._greenCtr++;
                     shouldStop = false;
                 }
                 else if (this._greenCtr > this._endGreen) {
                     this._greenCtr--;
                     shouldStop = false;
                 }
    
                 if (this._blueCtr < this._endBlue) {
                     this._blueCtr++;
                     shouldStop = false;
                 }
                 else if (this._blueCtr > this._endBlue) {
                     this._blueCtr--;
                     shouldStop = false;
                 }
             }

             if (shouldStop) {
                 this.stop();
             }
             else {
                 var updateColorStr = "#" + this.getHexString(this._redCtr) + this.getHexString(this._greenCtr) + this.getHexString(this._blueCtr);
                 var header = document.getElementById(this._containerId);
                 if (header != null) {
                     header.style.backgroundColor = updateColorStr;
                     
                 }
                 else {
                     //alert("problem - header was null");
                     this.stop();
                 }
             }

        },
        start: function() {

             if (this._enable) {
                 var header = document.getElementById(this._containerId);
                 header.style.backgroundColor = this._beginColorStr;
                 var me = this;
                 this._fadeCallbackId = self.setInterval(function () { me.fade(); }, 20);
             }

        },
        stop: function() {

             if (this._fadeCallbackId != null) { // JSLINT-IGNORE: null or undefined
                 clearInterval(this._fadeCallbackId);
             }

        },
        setBeginColor: function(/*string*/ hexString) {

             this._beginColorStr = hexString;

             this._redCtr = this.getColorValue(hexString, "r");
             this._greenCtr = this.getColorValue(hexString, "g");
             this._blueCtr = this.getColorValue(hexString, "b");

        },
        setEndColor: function(/*string*/ hexString) {

             this._endColorStr = hexString;

             this._endRed = this.getColorValue(hexString, "r");
             this._endGreen = this.getColorValue(hexString, "g");
             this._endBlue = this.getColorValue(hexString, "b");

        },
        getColorValue: function(/*string*/ hexString, /*string*/ rgb) {

             var subStr = "";
             if (rgb == "r") {
                 subStr = hexString.slice(1, 3);
             }
             else if (rgb == "g") {
                 subStr = hexString.slice(3, 5);
             }
             else if (rgb == "b") {
                 subStr = hexString.slice(5);
             }
             var rv = parseInt(subStr, 16);

             return rv;
        },
        getHexString: function(/*int*/ num) {

             var rv = 0;
             if (num >= 0x10) {
                 rv = num.toString(16);
             }
             else {
                 rv = "0" + num.toString(16);
             }
             return rv;
        },
        setEnable: function(/*boolean*/ value) {

             this._enable = value;

        }
    }
);



dojo.declare( "com.ibm.widgets.StatusBar", 
    [dijit._Widget, dijit._Templated],
    // end constructor
    {
    	uid: "statusBar",
    	locale: "en",
    	errorGifPath: "",
    	warningGifPath: "",
    	infoGifPath: "",
    	multipleMessagesGifPath: "",
    	showDetails: false,
    	isBidi: false,
    	
    	templateString:"<div class=\"statusBar\"\r\n\t><div dojoAttachEvent=\"\"\r\n\t\t\twaiRole=\"alert\" \r\n\t\t\tclass=\"ibmPortalStatusBar\" \r\n\t\t\tdojoAttachPoint=\"containerNode,focusNode\"\r\n\t></div\r\n></div>\r\n",
		
		constructor: function(){
			this.bundle = dojo.i18n.getLocalization("com.ibm.bundles", "Theme");
		},
    	postCreate: function() {  
	        this._messages = [];
			this._connections = [];
	        this._numMessages = 0;
	        this._baseURL = window.location.protocol+"//"+window.location.host;
	        this._statusTypesMap = { 
	            "error" : new com.ibm.widgets.StatusType(0, "ibmPortalError", this._baseURL + this.errorGifPath, "#FF0000"),
	            "warning" : new com.ibm.widgets.StatusType(1, "ibmPortalWarning", this._baseURL + this.warningGifPath, "FFFF00"),
	            "info" : new com.ibm.widgets.StatusType(2, "ibmPortalInfo", this._baseURL + this.infoGifPath, "#0077FF"),
	            "multiple" : new com.ibm.widgets.StatusType(3, "ibmPortalMultiple",this._baseURL + this.multipleMessagesGifPath, "#E9CAF9")
	        };
	        //Subscribe to status topics.
	        this._statusHandler = dojo.subscribe("/portal/status", this, this.addMessage);
	        this._msgStatusHandler = dojo.subscribe("/message/status", this, this.addMessage);
	
	        // create new message status bar color fader
	        this._summaryHeaderId = "ibmPortalStatusBarHeader";
	        var endBackgroundColorStr = this._statusTypesMap.multiple._color;
	        this.colorFader = new com.ibm.widgets.StatusColorFader( this._summaryHeaderId, endBackgroundColorStr);
	        		
			if (typeof(ibmCfg) != "undefined" && ibmCfg.portalConfig){this.isBidi = ibmCfg.portalConfig.isRTL;}
			else if(typeof(ibmPortalConfig) != "undefined") {this.isBidi = ibmPortalConfig.isRTL;}
			else if(typeof(ibmConfig) != "undefined"){this.isBidi = ibmConfig.isBidi;}
			
			dojo.addOnWindowUnload(this,"_onWindowUnload");
			
			// #18974 limit the title width
			this.widthLimit = parseInt(dojo.contentBox(this.containerNode).w * 0.8);
	    }, 
		
		_onWindowUnload: function() {
			dojo.forEach(this._connections, dojo.disconnect);
			this.clear();			
			this._messages = null;
			/*
			dojox.data.dom.removeChildren( this.containerNode );
			dojo.destroy(this.containerNode);
			this.containerNode = null;
			this.destroyRecursive();
			*/
		},
		
	    startup: function() {
			this.inherited(arguments);
		},
        _getStatusContainer: function () {
            return this.containerNode;   
        },
        setShowDetails: function (/*boolean*/showDetails) {
            this.showDetails = showDetails;    
        },
        toggleShowDetails: function() {
            this.setShowDetails(!this.showDetails);
            this.colorFader.setEnable(false);  // disable the fader when toggling details
            this.render();
            this.colorFader.setEnable(true);
        },
        clear: function () {
            //summary: clears all contents of the statusBar
            var statusContainer = this._getStatusContainer();
			if(!!statusContainer){
				dojox.data.dom.removeChildren( statusContainer );
			}
            this._messages.length = 0;
        },
        print: function() {
            //create new window
            var printWindow=window.open( '', 'status', 'resizable=yes,scrollbars=yes,menubar=no,toolbar=yes,status=no,width=800px,height=600px,screenX=10px,screenY=10px,top=10px,left=10px');
            var printDoc = printWindow.document;
            printDoc.title="Status";
            // set base url so relative image paths will resolve correctly
            var baseElem = printWindow.document.createElement("base");
            baseElem.setAttribute("href",window.location.protocol+"//"+window.location.host);
            printDoc.documentElement.childNodes[0].appendChild(baseElem);
            //add container div
            printDoc.body.innerHTML = "<div id='statusBar' class='statusBar'></div>";
            
            for (x in this._messages) {
				var statusType = this._statusTypesMap[this._messages[x]._type];
				
				// status entry base container
				var entry = printDoc.createElement("div");
				entry.className = statusType._styleClass;
				
				// header for status bar message
				var header = printDoc.createElement("h3");
				var headerDiv = printDoc.createElement("div");
				if (this.isBidi) {
					headerDiv.className = "ibmPortalStatusHeaderRHS";
					dojo.attr(headerDiv, "dir", "rtl");
				}
				else {
					headerDiv.className = "ibmPortalStatusHeaderLHS";
				}
				var icon = printDoc.createElement("img");
				icon.src = statusType._iconPath;
				headerDiv.appendChild(icon);
				headerDiv.appendChild(printDoc.createTextNode(this._messages[x]._message));
				header.appendChild(headerDiv);
				entry.appendChild(header);
				// details of the status bar message
				var detailsDiv = printDoc.createElement("div");
				if (this.isBidi) {
					dojo.attr(detailsDiv, "dir", "rtl");
				}
				detailsDiv.className = "ibmPortalDetails";
				detailsDiv.appendChild(printDoc.createTextNode(this._messages[x]._details));
				entry.appendChild(detailsDiv);
				printWindow.document.getElementById("statusBar").appendChild(entry);
			}
        },
        addMessage: function(/*Object*/args) {
            //summary: adds a message to the message array
            if(args.uid && args.uid != this.uid) {
            	return;
            }
            var message = args.message;
            this._messages.push(message);
            // temp limit to handle infinite loops if there is an error raised in this code
            if (this._messages.length < 100){
               this.render(this._getStatusContainer());
            }
  
        },
        render: function(/*Node*/ targetContainer) {
            //summary: render the message(s) in the statusBar  
            if (targetContainer == null){ // JSLINT-IGNORE: null or undefined
            targetContainer = this._getStatusContainer();
            }
            dojox.data.dom.removeChildren( targetContainer );
            // only render multiple header if there is more than one message.
            // in renderMessage, if their is only one message, it will render as the header
            if (this._messages.length > 1) {
                this.renderHeader(targetContainer);
            }
            else if (this._messages.length == 1) {
                this.renderMessage(targetContainer,this._messages[0], this.showDetails,0);
            }
            
            // if showing details, render all the messages
            if(this.showDetails && this._messages.length > 1){
                for (x in this._messages){
                    this.renderMessage(targetContainer, this._messages[x], this.showDetails, x);
                }
            }

            // if we have more than one message and we are not showing details,
            // then start a color fade based on the last message received
            if(!this.showDetails && this._messages.length > 1){
                // in case its already running for a previous message
                this.colorFader.stop();

                // get the last message type that came in to get its color
                var end = this._messages.length - 1;
                var startBackgroundColorStr = this._statusTypesMap[this._messages[end]._type]._color;
                this.colorFader.setBeginColor(startBackgroundColorStr);
                this.colorFader.start();
            }
        
   
        },
        renderHeader: function(/*Node*/ targetContainer) {            
            //summary: render the main statusBar 
            //description: this is the main statusBar, which includes the main controls, and either the single status message,
            // or an indicator of the number of messages contained within the details view. 
            //
            if(this._messages.length > 1) {
                var headerMessage = new com.ibm.widgets.StatusMessage( "multiple", "", "" );
                this.renderMessage(targetContainer, headerMessage, this.showDetails, -1);
            } 
        },
        renderMessage: function (/*Node*/ targetContainer, /*com.ibm.widgets.StatusMessage*/message, /*boolean*/ showDetails, /*int*/index ) {
            //summary: renders a single message in the statusBar
            //description: renders the following markup:
            //<div class="ibmPortalError">
            //<h3><img src="./error.gif"/> An Error Occurred <a href="#"> 3 more...</a></h3>
            //<div class="ibmPortalDetails">Its a really really bad one</div>
            //</div>
            //var statusContainer = this._getStatusContainer();
            var statusType = this._statusTypesMap[message._type];
            
            // status entry base container
            var entry = document.createElement( "div" );
            entry.className = statusType._styleClass;
            
            // summary header - the colored area of each status message
            var header = document.createElement("h3");
            header.id = this._summaryHeaderId;   // set id for color fader
            // Lefthandside (LHS) contains icon, message, and show/hide details
            var header_LHS = document.createElement("div");
            if(!this.isBidi){
                header_LHS.className = "ibmPortalStatusHeaderLHS";
            }
            else{
                header_LHS.className = "ibmPortalStatusHeaderRHS";
            }               

            var icon = document.createElement("img");
            icon.src = statusType._iconPath;
            header_LHS.appendChild(icon);
            
			var messagesNode = null;				
            // is this the top header status summary and we have more than one message
            if(this._messages.length > 1 && index < 0){
                // then format the message
               	messagesNode = document.createTextNode(dojo.string.substitute(this.bundle["statusbar_messages_available"], [this._messages.length]));

            }
            // do we have only one message
            else if(this._messages.length == 1){
				messagesNode = document.createTextNode(message._message)
                // adjust the left margin for a single message which will have a style class that is normally indented
                entry.style.marginLeft="0px";
            }
            else{
                // truncate multiple messages in the detail pane
                //header_LHS.appendChild(document.createTextNode(message._message));
				var messageNode = document.createTextNode(message._message)
				var messageSpan = document.createElement("span");
				messageSpan.appendChild(messageNode);
				var msg = message._message;
				var truncatedMsg = com.ibm.mm.builder.utils.htmlUtil.getStrWithLimit(msg, messageSpan, this.widthLimit);
				if(msg != truncatedMsg) {
					messageSpan.innerHTML = truncatedMsg;
					messageSpan.title = msg;
				}
				header_LHS.appendChild(messageSpan);
            }

            header.appendChild(header_LHS);

            // render top level multiple messages status bar header
            if((this._messages.length > 1 && index < 0)||(this._messages.length == 1)){
                var me = this;
                var detailsAnchor = document.createElement("a");
                detailsAnchor.href="javascript:void(0)";
				
                this._connections.push(dojo.connect(detailsAnchor, "onclick", dojo.hitch(this, function(){  
						this.toggleShowDetails(); return false;
				})));
				
				//detailsAnchor.onclick=function (e) { me.toggleShowDetails(); return false; };

                var header_RHS = document.createElement("div");

                var clearAnchor = document.createElement("a");
                clearAnchor.href="javascript:void(0);";
				
				this._connections.push(dojo.connect(clearAnchor, "onclick", dojo.hitch(this, function(){  
						this.clear(); return false;
				})));
				
               // clearAnchor.onclick=function (e) { me.clear(); return false; };
                clearAnchor.appendChild(document.createTextNode(this.bundle.statusbar_clear));

                var printAnchor = document.createElement("a");
                printAnchor.href="javascript:void(0);";
                this._connections.push(dojo.connect(printAnchor, "onclick", dojo.hitch(this, function(){  
						this.print();
				})));
				
				//printAnchor.onclick=function(e){ me.print(); };
                printAnchor.appendChild(document.createTextNode(this.bundle.statusbar_print));
                
                if(this.isBidi){
                	header_RHS.className = "ibmPortalStatusHeaderLHS";
                }
                else {
                	header_RHS.className = "ibmPortalStatusHeaderRHS";
                }
                
				//header_LHS.appendChild(messagesNode);
				// truncate the message node
				var messageSpan = document.createElement("span");
				messageSpan.appendChild(messagesNode);
				var msg = message._message;
				var truncatedMsg = com.ibm.mm.builder.utils.htmlUtil.getStrWithLimit(msg, messageSpan, this.widthLimit);
				if(msg != truncatedMsg) {
					messageSpan.innerHTML = truncatedMsg;
					messageSpan.title = msg;
				}
				header_LHS.appendChild(messageSpan);
				
                if (showDetails){
                    detailsAnchor.appendChild(document.createTextNode(this.bundle.statusbar_hide_details));
                }
                else {
                    detailsAnchor.appendChild(document.createTextNode(this.bundle.statusbar_show_details));
                }
                
				header_LHS.appendChild(detailsAnchor);
                header_RHS.appendChild(clearAnchor);
                header_RHS.appendChild(printAnchor);
                header.appendChild(header_RHS);
            }

            var clearingDiv = document.createElement("div");
            clearingDiv.className="wptheme-clearing ";
            header.appendChild(clearingDiv);

            entry.appendChild(header);
    
            // details
            if (showDetails && index >=0){
                var detailsDiv = document.createElement("div");
                detailsDiv.className = "ibmPortalDetails";
                detailsDiv.appendChild(document.createTextNode(message._details));
                entry.appendChild(detailsDiv);
            }
            targetContainer.appendChild(entry);
    
        }
    }
); // end declare StatusBar

}

if(!dojo._hasResource["com.ibm.widgets.PageToolbarButton"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.widgets.PageToolbarButton"] = true;
dojo.provide("com.ibm.widgets.PageToolbarButton");

dojo.declare("com.ibm.widgets.PageToolbarButton", dijit.form.Button, {
	label: "",
	btnClass: "",
	templateString: '<button class="lotusBtn ${btnClass}" dojoattachevent="onclick:onClick,onmouseenter:_onMouse,onmouseleave:_onMouse,onmousedown:_onMouse" widgetid="${id}" id="${id}" waistate="labelledby-${id}_label" wairole="button" type="button" name="" dojoattachpoint="titleNode,focusNode" role="button" aria-labelledby="${id}_label" tabindex="0" style="-moz-user-select: none;">'+
					'<span id="${id}_label" class="dijitInline dijitButtonText" dojoattachpoint="containerNode">${label}</span>'+
					'</button>',

	onClick: function(){
		// summary: stub event for when button is clicked
	}
});

}

if(!dojo._hasResource["com.ibm.lang.DeferredQueue"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.lang.DeferredQueue"] = true;
/*
 * @author allenbj
 */ 
dojo.provide("com.ibm.lang.DeferredQueue");

dojo.declare("com.ibm.lang.DeferredQueue",
	null,
	{
		constructor: function(/*Deferred?*/ def) {
			this.curDef = def;
			this.firstDef = def;
		},
		_addCallbacks: function(/*Deferred*/ source, /*Deferred*/ target) {
			source.addCallbacks(
				function(res){target.callback(res); return res;},	// callback
				dojo.hitch(this, function(err){						// errback
					try{
						if(!err._raised) {
							this.raiseError(err);	// in case raiseError fails... we still guarantee all callbacks
							err._raised = true;
						}
					}catch(err2){}
					target.callback(err);
					return err;
				})
			);
		},
		addBefore: function(/*Deferred*/ def) {
			// summary: Inserts a Deferred into the front of the queue which will fire the 
			// 		Deferred that is currently in the front of the queue when it calls back.
			//		Allows preprocessing or delaying of this DeferredQueue's firing.
			//		Note, if the queue has already fired, this will cause an error when the
			//		def argument callsback.
			if(!this.firstDef) this.firstDef = def;
			else {
				var oldFirst = this.firstDef;
				this.firstDef = def;
				this._addCallbacks(def, oldFirst);
			}
		},
		add: function(/*Deferred*/ def) {
			// summary: Adds a deferred to the queue which will be fired as a callback
			//		to the previous deferred in the queue.  If this is the first deferred
			//		to be added to the queue, firing it will start the queue.
			if(!this.firstDef) this.firstDef = def;
			if(this.curDef) {
				var oldCur = this.curDef;
				this.curDef = def;
				this._addCallbacks(oldCur, def);
			}
			else {
				this.curDef = def;
			}
			return this;
		},
		fire: function(res) {
			// summary: Starts the queue by firing the first deferred in the queue
			//		passing the argument to this function to the callback function of
			//		the first deferred.
			// res: Anything
			if(this.firstDef) this.firstDef.callback(res);
			return this;
		},
		raiseError: function(err) {
			// summary: Called whenever one of the Deferreds in the queue fires its errback.
			//		If an error is raised once by this and then a subsequent Deferred is errbacked
			//		with the exact same error, it will not be raised again.  However, if the next
			//		Deferred throws or returns a new error, that will be raised only once itself.
			//		This allows any errors to be raised once and only once without losing any of them.
			//		NOOP by default, so override this or connect to it to provide implementation.
		},
		destroy: function() {
			delete this.firstDef;
			delete this.curDef;
			delete this.raiseError;
		}
	}
);

}

if(!dojo._hasResource["com.ibm.data.EnablerModelStore"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.data.EnablerModelStore"] = true;
dojo.provide("com.ibm.data.EnablerModelStore");




dojo.declare("com.ibm.data.EnablerModelStore", 
		com.ibm.data._NotificationHelper,{
	// itemClass: String the class used to represent items of this store
	
	itemClass: "com.ibm.mm.enabler.navigation.NavigationNodeImpl",
	
	_isItemCreated: false,
	
	_isDirty: false,
	
	rootNode: null,
	
	globalPage: null,
	globalPageInSpace: null,
	
	constructor: function(){		
		this.navigationUtil = com.ibm.mm.builder.utils.navigationUtil;
		this.pageUtil = com.ibm.mm.builder.utils.pageUtil;
    	this.spaceUtil = com.ibm.mm.builder.utils.spaceUtil;
    	var root = this.getRootNode();
		this.rootNode = root;
    },
    getRootNode: function(){
    	var pid = null;
    	var currentPage = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage();
    	var items = [];
    	
		if(!currentPage){
			var spaceId = this.spaceUtil.getCurrentSpaceId();
			pid = spaceId ? this.pageUtil.getFirstPageInSpace(spaceId) : this.pageUtil.getFirstRootPageId();
		} else {
			pid = currentPage.getID();
		}
		if(!pid) return null;
		
		//update current page id and space id
		currentPage.setID(pid);
		
		var spaceId = this.spaceUtil.getSpaceIdByPageId(pid);
		if (spaceId !== this.spaceUtil.getCurrentSpaceId()) {
			this.spaceUtil.setSpaceId(spaceId);
		}
		//try to build model array
		var navModel = this.navigationUtil.getNavigationModel();
		var currentModel = navModel.find(pid).start();
		var rootId = this.navigationUtil.getNavigationRootNodeId();
		var currentSpaceRootId = this.navigationUtil.getNavigationRootNodeId(this.spaceUtil.getCurrentSpaceId());
		//Loop to root to build the menuModelArrays array that holds all the models of the item that need to be rendered
		while(currentModel && currentModel.getID() !== rootId && currentModel.getID() !== currentSpaceRootId) {
			items.push(currentModel);
			currentModel = navModel.getParent(currentModel.getID()).start();
		}
		return items[items.length - 1];
    },
    getFeatures: function(){
        return {'dojo.data.api.Read':true, 'dojo.data.api.Write':true, 'dojo.data.api.Identity':'id', "dojo.data.api.Notification": true };
    },

	/********************************/
	/**                            **/
	/**                            **/
	/**    dojo.data.api.Read      **/
	/**                            **/
	/**                            **/
	/********************************/
    getValue: function( /* item */ item, /* attribute-name-string */ attribute, 
                        /* value? */ defaultValue){
        var values = this.getValues(item, attribute);
        return (values.length > 0)?values[0]:defaultValue;
    },

    getValues: function(/* item */ item, /* attribute-name-string */ attribute){
		var values = null;
		switch(attribute) {
			case "id":
			    values = [item.getID()];
			    break;
			case "title":
				/* only needed in standalone mashups 
			    if (this.rootNode == item) values = ["Content Root"];
			    else*/ if (item.title) values = [item.title];
				else values = [this.pageUtil.getUnescapedPageTitle(item.getID())];
				break;
			case "description":
			    values = [this.pageUtil.getPageDescription(item.getID())];
				break;
			case "type":
			    values = item.type;
				break;
			case "parent":
				if (this.globalPage && item.openPageId && item.pageLoadedSpaceId===com.ibm.mm.builder.utils.spaceUtil.getCurrentSpaceId()){
					// to support global page, open the faked new item under current parent
					if (dojo.cookie(com.ibm.mm.builder.constant.cookieKey_previous_pid)){
						var lastNonGlobalPageId = dojo.cookie(com.ibm.mm.builder.constant.cookieKey_previous_pid);
						var lastPage = com.ibm.mm.builder.utils.pageUtil.getPageNode(lastNonGlobalPageId);
						var _navModel = this.navigationUtil.getNavigationModel();
						//TODO: need to update the logic here.
						var parent = _navModel.getParent(lastPage.getID()).start();
						values = [parent];						
					}else{
						console.log("Error: previous_pid in cookie is missing!");
					}					
				}else{
					var _navModel = this.navigationUtil.getNavigationModel();
					var parent = _navModel.getParent(item.getID()).start();
				    values = [parent];					
				}
				break;
			case "parentId":
				var _navModel = this.navigationUtil.getNavigationModel();
				var parent = _navModel.getParent(item.getID()).start();
	            var parentId = parent ? parent.getID() : null;
			    values = [parentId];
				break;
			case "children":
				var _navModel = this.navigationUtil.getNavigationModel();
				var childrenIter = _navModel.getChildren(item);
				var children = [];
			    while (childrenIter.hasNext()) {
					var child = childrenIter.next();
					var isVisible = com.ibm.mm.builder.utils.pageUtil.isVisiable(child);
					if(isVisible){ children.push(child); }
				}
				// support global page
				if (this.globalPage && this.globalPageInSpace===com.ibm.mm.builder.utils.spaceUtil.getCurrentSpaceId()){
					children.push(this.globalPage);
				}
			    values = children;
				break;
			case "hasChildren":
				if(com.ibm.mm.builder.utils.spaceUtil.getCurrentSpaceNode() == item){ return false; }
				var _navModel = this.navigationUtil.getNavigationModel();
			    values = [_navModel.hasChildren(item)];
				break;
			default:
			    values = null;
		}
		values = (values && dojo.isArray(values)) ? values : [values];
		return values;
    },
    getAttributes: function(/* item */ item){
        return ["id", "title", "description", "type", "parent", "parentId", "children", "hasChildren"];
    },
    hasAttribute: function( /* item */ item, /* attribute-name-string */ attribute){
        return !!(this.getValue(item, attribute));
    },
    containsValue: function(/* item */ item, /* attribute-name-string */ attribute, /* anything */ value){
        return this.getValue(item, attribute) == value;
    },
    isItem: function(/* anything */ something){
    	//returns page node id if it is indeed an item
        return something.declaredClass == "com.ibm.mm.enabler.navigation.NavigationNodeImpl" && something.getID();
    },
    isItemLoaded: function(/* Object */ something) {
		// summary: All valid items in this data store are loaded all of the time as there
		//		is no support currently for stubs.  Therefore, this is effectively the same
		//		as isItem.
		return this.isItem(something) && something.loaded;
	},
	loadItem: function(/* Object */ keywordArgs){
		// summary: All valid items in this data store are loaded all of the time as there
		//			is no support currently for stubs.  Therefore, this function is a no-op. 
	},
    getLabel: function(/* item */ item){
        return this.getValue(item, "title");
    },
    getLabelAttributes: function(/* item */ item){
        return ["title"];
    },
    fetch: function(/* Object */ keywordArgs){
        if(!keywordArgs) keywordArgs = {};
        var me = this;
		keywordArgs.aborted = false;
		if(!keywordArgs.scope) keywordArgs.scope = dojo.global;
    	
        var query = keywordArgs.query;
        var items = []; 
        var _navModel = this.navigationUtil.getNavigationModel();
        
        if(query === null) {
        	items.push(this.rootNode);
        } else { 
        	var spaceUtil = com.ibm.mm.builder.utils.spaceUtil;
    		var pid = query.uri;
    		if(!pid){
    			var spaceId = spaceUtil.getCurrentSpaceId();
    			pid = spaceId ? this.pageUtil.getFirstPageInSpace(spaceId) : this.pageUtil.getFirstRootPageId();
    		}
			
    		//if current page still is null, this means no page exists.
    		if(pid) {
				if(com.ibm.mm.builder.utils.spaceUtil.getCurrentSpaceId() == pid){
					// if navigating to a space with no pages, manually set up the selection path to the 
					// space root and content root, otherwise getChildren will fail
					items.push(com.ibm.mm.builder.utils.spaceUtil.getCurrentSpaceNode());
					items.push(this.navigationUtil.getNavigationRootNode());
				}else{
	    			var currentPage = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage();
					currentPage.setID(pid);
					
					var spaceId = spaceUtil.getSpaceIdByPageId(pid);
					if (spaceId !== spaceUtil.getCurrentSpaceId()) {
						spaceUtil.setSpaceId(spaceId);
					}
					
					var navModel = this.navigationUtil.getNavigationModel();
					var currentModel = navModel.find(pid).start();
					//Loop to root to build the menuModelArrays array that holds all the models of the item that need to be rendered
					while(currentModel) {
						items.push(currentModel);
						currentModel = navModel.getParent(currentModel.getID()).start();
					}
				}
			}
        }
		items = this.processFetchedItems(items, keywordArgs);
		
		//TODO: implement getResultSize
		if(keywordArgs.onBegin) keywordArgs.onBegin.call(keywordArgs.scope, this.getResultSize(items.root, keywordArgs, items), keywordArgs);
		
		if(keywordArgs.onItem) {
			for(var i = 0; i < items.length; i++) {
				if(keywordArgs.aborted) return;
				keywordArgs.onItem.call(keywordArgs.scope, items[i], keywordArgs);
			}
		}
		
		if(keywordArgs.onComplete) {
			// call onComplete with items array if onItem wasn't specified, otherwise
			// call it with null
			if(keywordArgs.aborted) return;
			if(!keywordArgs.onItem) keywordArgs.onComplete.call(keywordArgs.scope, items, keywordArgs);
			else keywordArgs.onComplete.call(keywordArgs.scope, null, keywordArgs);
		}
	},
	processFetchedItems: function(items, keywordArgs){
		// do nothing
		return items;
	},
    getRootItem: function(){
        return this.rootNode;
    },    
	/********************************/
	/**                            **/
	/**                            **/
	/**    dojo.data.api.Identity  **/
	/**                            **/
	/**                            **/
	/********************************/
    getIdentity: function(/* item */ item){
        return this.getValue(item, "id");
    },
    getIdentityAttributes: function(/* item */ item){
        return ["id"];
    },
    fetchItemByIdentity: function(/* object */ keywordArgs){
        var node = this.pageUtil.getPageNode(getkeywordArgs.identify);
        node = node ? node : null;
        if(keywordArgs.onItem){
    		if(!keywordArgs.scope) keywordArgs.scope = dojo.global;
            keywordArgs.onItem.call(keywordArgs.scope, node);
        }
    },    
	/********************************/
	/**                            **/
	/**                            **/
	/**    dojo.data.api.Write     **/
	/**                            **/
	/**                            **/
	/********************************/
	deleteItem: function(/* item */ item){
		//	summary:
		//		Deletes an item from the store.
		//
		//	item: 
		//		The item to delete.
		//
		//	exceptions:
		//		Throws an exception if the argument *item* is not an item 
		//		(if store.isItem(item) returns false).
		//	example:
		//	|	var success = store.deleteItem(kermit);
		return false; // boolean
	},
	setValue: function(	/* item */ item, 
						/* string */ attribute,
						/* almost anything */ value){
		//	summary:
		//		Sets the value of an attribute on an item.
		//		Replaces any previous value or values.
		//
		//	item:
		//		The item to modify.
		//	attribute:
		//		The attribute of the item to change represented as a string name.
		//	value:
		//		The value to assign to the item.

		var lc = com.ibm.mashups.enabler.context.Factory.getLocalizedContext();    		
		switch(attribute) {
			case "id":
			    item.setID(value);
			    break;
			case "title":
				item.setTitle(value, lc.getLocale(item) || ibmConfig.locale);
				break;
			case "description":
			    item.setDescription(item, lc.getLocale(item) || ibmConfig.locale);
				break;
			case "type":
			    item.type = value;
				break;
			case "parent":
				// TODO?
				break;
			case "parentId":
				// TODO?
				break;
			case "children":
				// TODO?
				break;
			case "hasChildren":
				// TODO?
				break;
			case "position":
				var _navModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
				_navModel.insert(item, value.newParent, value.next);
				item.loaded = false;
				item.created = true;
				if(value.oldParent == value.newParent){
					this.onSet(item, attribute, value.oldParent, value.next);
				}else if(value.next){
					this.onSet(item, "parent_next", value.oldParent, value.next);
				}else{
					this.onSet(item, "parent", value.oldParent, value.newParent);
				}
				break;
		}
	},
	newItem: function(/* Object? */ keywordArgs, /*Object?*/ parentInfo){
		// summary:
		//
        var title = keywordArgs.label;
    	var utils = com.ibm.mm.builder.utils;
    	var _navModel = utils.navigationUtil.getNavigationModel();
		
		var newPage;
		if (keywordArgs.openPageId){
			// load an existing page as an new item
			newPage = com.ibm.mm.builder.utils.pageUtil.getPageNode(keywordArgs.openPageId);
			newPage.loaded = false;
			newPage.created = false;			
			newPage.openPageId = keywordArgs.openPageId;
			newPage.pageLoadedSpaceId = keywordArgs.pageLoadedSpaceId;
			newPage.onCreate = function(){}; 
			this.globalPageInSpace = newPage.pageLoadedSpaceId;
			this.globalPage = newPage;
		}else{
	        newPage = _navModel.create(null);
	        newPage.setTitle(title, dojo.locale);
	    	newPage.setTitle(title, ibmConfig["default.locale"]);
	    	var themeId = utils.themeUtil.getThemeId(parentInfo.parent.getID());
		    if (!utils.themeUtil.getThemeModel().find(themeId).start()){
		        themeId = utils.themeUtil.getDefaultThemeId();
		    }
		    newPage.setTheme(themeId);
			newPage.title = title;
			newPage.loaded = false;
			newPage.created = false;
			newPage.onCreate = function(){};  
			_navModel.insert(newPage, parentInfo.parent, null);
	
			// create layout
			var lm = _navModel.getLayoutModel(newPage.getID());
			var lmRoot = lm.create();
			lm.insert(lmRoot);
			// set empty fragment
			lmRoot.setFragment(" ");			
		}

		this.onNew(newPage, parentInfo);
		this._isItemCreated = true;
		return newPage;
	},
	isCreated: function(item) {
		return !!item.created;
	},
	addOnCreate: function(item, callback) {
		if(this.isCreated(item)) {
			callback(item);
		}
		else {
			if(!item.onCreateDefQueue) {
				item.onCreateDefQueue = new com.ibm.lang.DeferredQueue(new dojo.Deferred());
			}
			item.onCreateDefQueue.add((new dojo.Deferred()).addCallback(callback));
		}
	},
	_fireCreated: function(item) {
		if(item.onCreateDefQueue) {
			// TODO: open a global page twice will lead an exception.
			try{
				item.onCreateDefQueue.fire(item);
			}catch(ex){
				console.log(ex);
			}
		}
	},
	save: function(/* object */ keywordArgs){
		// summary:
    	var utils = com.ibm.mm.builder.utils;
    	var _navModel = utils.navigationUtil.getNavigationModel();
    	this.keywordArgs = keywordArgs;
		if (this.keywordArgs.openPageId){
			// just open an existing page, no need to save the page node.
			var newPage = com.ibm.mm.builder.utils.pageUtil.getPageNode(this.keywordArgs.openPageId);
			if(this._isItemCreated){
				// create new items
				this.keywordArgs = keywordArgs;
				this.keywordArgs.item.onCreate();
				this.keywordArgs.item.created = true;
				this.keywordArgs.item.setID(newPage.getID());
				this._fireCreated(this.keywordArgs.item);
				this.onSaveComplete();
				this._isItemCreated = false;
				if(this.keywordArgs.onComplete) this.keywordArgs.onComplete(this.keywordArgs);
			}
		}else{
			if(this._isItemCreated){
				// create new items
				this.keywordArgs = keywordArgs;
				this.keywordArgs.item.onCreate();
		        var deferred = _navModel.commit();	
		        deferred.addFinishedCallback( dojo.hitch(this, function(node){
					this.keywordArgs.item.created = true;
			    	var es = com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService");
					es.broadcastEvent("com.ibm.mashups.builder.pageCreated", node.getID());
					this.keywordArgs.item.setID(node.getID());
					this._fireCreated(this.keywordArgs.item);
		    		this.onSaveComplete();
		    		this._isItemCreated = false;
		    		if(this.keywordArgs.onComplete) this.keywordArgs.onComplete(this.keywordArgs);
		    	}));
		        deferred.start(false);
			}
			if(this._isDirty){
				// update dirty items
	        	_navModel.commit().start(false);
	        	this._isDirty = false;
	        	if(keywordArgs.onComplete) keywordArgs.onComplete(keywordArgs);
			}			
		}
	},
	
	revert: function(){
		//	summary:
		//		Discards any unsaved changes.
		//	description:
		//		Discards any unsaved changes.
		this._isItemCreated = false;
		this._isDirty = false;
		return false; // boolean
	},
    onSaveComplete: function(args) {
		// summary: Callers can attach listeners to this function to get notified when a save operation
		//		on this store has received its last response from the server for all write operations.
		//		This is called before callback handlers to the save function itself are called but after
		// 		all the responses for the requests to the server have returned.
	}
});

}

if(!dojo._hasResource["com.ibm.data.EnablerTreeModel"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.data.EnablerTreeModel"] = true;
dojo.provide( "com.ibm.data.EnablerTreeModel" );

// This module provides the API for a data model that corresponds to any data set that contains
// parent-child relationships that can be represented as a tree.  It's exactly the same as the
// model API that's used by dijit.Tree with some functions already implemented for ease of use.
// As a result, any implementation of this API can be used as the model to a dijit.Tree widget
// or any other widget that uses a data model as its backend service provider.  This data API
// also adds some additional constraints and extension points that implementations should support
// in addition to the model API that's used by dijit.Tree, but by no means breaks the API or
// deviates from the required functions of the dijit model API.  One such addition is the
// support for additional query parameters that can be specified when instantiating a model
// that are always appended to any request to the server for data.  This allows particular instances
// of a data model to include metadata information that would not otherwise be included by certain
// data services that support it.
dojo.declare( "com.ibm.data.EnablerTreeModel",
			com.ibm.data.DataTreeModel,
			{
				// model: The Enabler TreeModel implementation
				eModel: null,
				
				// store: The dojo.data.Read/Write implementation 
				store: null,
				
				// query: The query used to retrieve the root item for this model
				query: null,
				
				// root: The root item of this model
				root: null,
				
				// addQueryParams: Object additional query parameters that should be appended
				//		to any request for items from the back end.  Is useful for getting
				// 		additional information such as metadata for each item from a data service 
				// 		that provides it.
				addQueryParams: null,
				
				constructor: function(args) {
					dojo.mixin(this, args);
					
					if(!this.addQueryParams) this.addQueryParams = {};
					
					this.connections = [];
					if(this.store.getFeatures()["dojo.data.api.Notification"]) {
						this.connections.concat([
							dojo.connect(this.store, "onNew", this, "_onNew"),
							dojo.connect(this.store, "onSet", this, "_onSet"),
							dojo.connect(this.store, "onDelete", this, "_onDelete")
						]);
					}
				},
				destroy: function() {
				        // summary: destroys this object, releasing connections to the store
				        dojo.forEach(this.connections, dojo.disconnect);
				},
				reset: function() {
					// summary: Resets the root of this model to null.
					this.root = null;
				},
				getRoot: function(onItem, onError){
					// summary:
				    //            Calls onItem with the root item for the tree, possibly a fabricated item.
				    //			  Any request for data that is sent to the server should also include
				    //			  the request parameters in addQueryParams. 
					//            Throws exception on error.
					this.root = this.store.rootNode;
					onItem(this.root);
				},
				mayHaveChildren: function(/*Object*/ item){
				        // summary:
				        //            Tells if an item has or may have children.  Implementing logic here
				        //            avoids showing +/- expando icon for nodes that we know don't have children.
				        //            (For efficiency reasons we may not want to check if an element actually
				        //            has children until user clicks the expando node)
				        return this.store.getValue(item, "hasChildren");
				
				},
				getChildren: function(/*Object*/ parentItem, /*function(items)*/ onComplete, /*function*/ onError){
				        // summary:
				        // 			  Calls onComplete() with array of child items of given parent item, all loaded.
				        //			  Any request for data that is sent to the server should also include
				    	//			  the request parameters in addQueryParams. 
				        //            Throws exception on error.
						var store = this.store;		
						if(this.mayHaveChildren(parentItem)){
							parentItem._children = this.store.getValues(parentItem, "children");
				        	if(parentItem._children && parentItem._children.length > 0){
				        		onComplete(parentItem._children);
				        	}else{
				        		//does not have children so return empty array
				        		parentItem._children = null;
				        		onComplete(parentItem._children);
				        	}
				        }else {
				        	// does not have children so return empty array
				        	parentItem._children = null;
				        	onComplete(parentItem._children);
				        }        
				},
				// =======================================================================
				// Inspecting items
				getIdentity: function(/* item */ item){
				        // summary: returns identity for an item
				        return this.store.getIdentity(item);
				},
				getLabel: function(/*dojo.data.Item*/ item){
				        // summary: get the label for an item
				        return this.store.getLabel(item);
				},
				getParent: function(/*dojo.data.Item*/ item) {
					// summary: returns the parent item of this item argument
					return this.store.getValue(item, "parent");
				},
				// =======================================================================
				// Write interface
				newItem: function(/* Object? */ args, /*Item?*/ parent){
					// summary
			        // Creates a new item.   See dojo.data.api.Write for details on args.
					if(parent.getRootNavigation)
					{
						parent = com.ibm.mm.builder.utils.navigationUtil.getNavigationRootNode(parent.getID());
					}
			        var newPage = this.store.newItem(args, {parent: parent});
					var es = com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService");
					if (args.openPageId){
						this.store.save({item: newPage, onComplete: args.onComplete, onError: args.onError, scope: args.scope, openPageId:args.openPageId, pageLoadedSpaceId:args.pageLoadedSpaceId});
						// to do the real broadcast event thing, broadcast the event and open the global page
						es.broadcastEvent("com.ibm.mashups.builder.saveCheck", dojo.hitch(this,function(){
							es.broadcastEvents(args.eventsArray || [],args.lastVisitedPage,args.openPageId);
						}));
					}else{
						this.store.save({item: newPage, onComplete: args.onComplete, onError: args.onError, scope: args.scope});
						es.broadcastEvent("com.ibm.mashups.builder.saveCheck", dojo.hitch(this,function(){
							es.broadcastEvent("com.ibm.mashups.builder.switchPage", this.getIdentity(newPage));
						})); 						
					}
			        return newPage;
				},
				deleteItem: function(/*Object*/args, /*item*/ item){
					// This is a fake delete item method, which only will remove global page.
					var parent = this.getParent(item);
					// key to set the global page as null, so the parent and children info will back to normal
					this.store.globalPage = null;
				    this._removeChildItem(parent, item, null, dojo.hitch(this, function(){
				    	this.onTreeChange(parent, null, parent);
				    }));
					var es = com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService");
					if (args.openPagePayload){
						// do not switch to the last visited non-global page, we will open another global page instead.		
					}else{
						// go to last visited non-global page
						es.broadcastEvent("com.ibm.mashups.builder.saveCheck", dojo.hitch(this,function(){
							es.broadcastEvent("com.ibm.mashups.builder.switchPage", args.lastVisitedPage);
						})); 						
					}	
				},	
				clearGlobalPageItem:function(/*Object*/args, /*item*/ item){
					var parent = this.getParent(item);
					this.store.globalPage = null;
				    this._removeChildItem(parent, item, null, dojo.hitch(this, function(){
				    	this.onTreeChange(parent, null, parent);
				    }));
				},			
				isCreated: function(/*item*/ item) {
					// summary: Indicates whether or not the item has been created on the server and
					//		the server-generated values were properly applied to the client-side
					//		object.	NOTE: Any client-side modifications	to the values of an item for 
					// 		which isCreated returns true can potentially modify the server-generated 
					// 		values to be out-of-sync with the server.
					// 		Therefore, it's important to note that isCreated merely indicates whether
					//		or not the client-side item has a server-side resource associated with it,
					// 		and any values that the server generated for the resource (such as a unique
					return this.store.isCreated(item);	
				},
				addOnCreate: function(/*item*/ item, /*Function*/ callback) {
					// summary: Register callback to be called when the given item is created on the server.
					//		If the item is already created, this will call the callback immediately.
					return this.store.addOnCreate(item, callback);			
				},
				pasteItem: function(/*Item*/ childItem, /*Item*/ oldParentItem, /*Item*/ newParentItem, /*Boolean*/ copy, /*Item*/ nextSibling, /*Boolean?*/ extra){
				        // summary:
				        //            Move an item from one parent item to another or to another position under the same parent.
				        //            Used in drag & drop.
				        // See dojo.data.api.Write for details on args.

				        this.store.setValue(childItem, "position", {newParent: newParentItem, 
				        											oldParent: oldParentItem, 
				        											next: nextSibling});	        	
				        this.store._isDirty = true;
				        this.store.save({});
				        this.store.onSaveComplete();
				},
				toString: function() {
					return "[TreeModel " + this.declaredClass + "]";
				},
				_onNew: function(item, parentInfo){
					this.newPageItem = item;
					this.newPageParent = parentInfo.parent;
				    this._insertChildItem(this.newPageParent, this.newPageItem, null, dojo.hitch(this, function(){
				    	this.onTreeChange(this.newPageItem, null, this.newPageParent);
				    }));
				},
				_onDelete: function(item){
									
				},				
				_onSet: function(/* Item */ item, /*String*/ attribute, /*Object | Array*/ oldValue, /*Object | Array*/ newValue){				
					
					if(attribute.indexOf("parent") > -1) {
						var newParent = null;
						if(attribute == "parent_next"){
							newParent = this.store.getValue(item, "parent");
						}else{
							newParent = newValue;
							newValue = null;
						}

						this._removeChildItem(oldValue, item);
		        		this._insertChildItem(newParent, item, newValue, dojo.hitch(this, function(){
		        			this.onTreeChange(item, oldValue, newParent, newValue);
		        		}));		        		
					}else if(attribute == "position"){
						// if we're not reparenting, then we can only be moving
		        		this._moveChildItem(oldValue, item, newValue, dojo.hitch(this, function(){
		        			this.onTreeChange(item, oldValue, oldValue, newValue);
		        		}));
		        	}else {
						this.onChange(item);
					}
				},
				refreshItemChildren: function(/*Item*/ item, /*Function?*/ modifier) {
					item._children = null;					
					var func = modifier ? modifier : function(items) {
							this.onChildrenChange(item, items);
						};
					this.getChildren(item, dojo.hitch(this, func));
				},
				_insertChildItem: function(/*Item*/parentItem, /*Item*/ item, /*Item*/ newNextSibling, /*Function*/callbackfn) {
					this.getChildren(parentItem, dojo.hitch(this, function(items) {
						// refresh the item children with a function that will add the item first
						if(!items){
							items = [];
						}
						if(!newNextSibling) {
							items.push(item);
						} else {
							var id = this.getIdentity(newNextSibling);
							for(var i = 0; i < items.length; i++) {
								if(this.getIdentity(items[i]) == id) {
									items.splice(i, 0, item);
									break;
								}
							}
						}
						if(callbackfn) callbackfn();
						this.onChildrenChange(parentItem, items);
					}));
				},
				_removeChildItem: function(/*Item*/parentItem, /*Item*/ item, /*Function*/callbackfn) {
					this.getChildren(parentItem, dojo.hitch(this, function(items) {
						var id = this.store.getIdentity(item);
						if(items){
							for(var i = 0; i < items.length; i++) {
								if(this.store.getIdentity(items[i]) == id) {
									items.splice(i,1);	// remove the item from the array
									break;	// break out of the loop since we already found ourselves
								}
							}
						}
						if(callbackfn) callbackfn();
						this.onChildrenChange(parentItem, items);
					}));
				},
				_moveChildItem: function(/*Item*/parentItem, /*Item*/ item, /*String*/ newNextSibling, /*Function*/callbackfn) {
					this.getChildren(parentItem, dojo.hitch(this, function(items) {
						var id = this.store.getIdentity(item);
						var nextIndex = items.length - 1;
						for(var i = 0; i < items.length; i++) {
							if(this.store.getIdentity(items[i]) == id) {
								items.splice(i, 1);	// remove item from index i
								i--;
							}
							else if(newNextSibling && this.store.getIdentity(items[i]) == newNextSibling) {
								// insert item at index i before the existing item at that index without deleting it
								items.splice(i, 0, item);
								i++;
							}
						}
						if(!newNextSibling) {
							// if this is null, append the item to the end of the list
							items.push(item);
						}
						if(callbackfn) callbackfn();
						this.onChildrenChange(parentItem, items);
					}));
				},
				onTreeChange: function(/*Item*/ childItem, /*Item*/ oldParentItem, /*Item*/ newParentItem, /*Item*/ nextSiblingItem) {
					
				},
				onChange: function(/*Item*/ item){
					
				},
				onChildrenChange: function(/*Item*/ parentItem, /*Array*/ items){
					
				}
			}
);

}

if(!dojo._hasResource['com.ibm.widgets.NewPageDialog']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['com.ibm.widgets.NewPageDialog'] = true;
dojo.provide('com.ibm.widgets.NewPageDialog');




dojo.declare('com.ibm.widgets.NewPageDialog',
	[dijit.Dialog],
    {
		shelfBundle: null,
		dialogBundle: null,
		blankImg: "",
		autofocus: false,
		showMakePrivate: true,
		showFriendlyURL: true,
		showPageTemplate: false,
		value: {},
		
		templateString: '<div class="lotusDialogBorder lotusui" waistate="labelledby-${id}" wairole="dialog" role="dialog" index="-1" aria-labelledby="${id}" dojoAttachPoint="dialogDiv">' +
						'<div class="lotusDialog">' +
							'<h1>' +
								'<a href="javascript:void(0);" dojoAttachPoint="closeButtonNode" class="lotusBtnImg lotusClose" title="${closeText}">' +
									'<img src="${_blankGif}" alt="" aria-label="${closeText}" />' +
									'<span class="lotusAltText">X</span>' +
								'</a>' +
								'<span dojoAttachPoint="titleNode">${titleText}</span>' +
							'</h1>' +
							'<form dojoAttachPoint="newPageForm,containerNode" action="javascript:;">' +
								'<div class="lotusDialogContent">' +
									'<div>' +
										'<div class="lotusMessage" dojoAttachPoint="newPageError" style="display: none" role="alert">' +
											'<span>${nlsTitleError}</span>' +
										'</div>' +
										'<div><label for="${id}_name">${nlsPageTitle}</label></div>' +
										'<div><input id="${id}_name" type="text" name="title" dojoAttachPoint="typingNode, focusNode" size="24"/></div><br />' +
										
										'<div dojoAttachPoint="divFriendlyURL">'+
											'<div><label for="${id}_friendly">${nlsFriendlyURL}</label></div>' +
											'<div><input id="${id}_friendly" type="text" name="friendlyURL" dojoAttachPoint="newPageFriendlyURL" size="24"/></div>'+
										'</div><br />' +
										
										'<div dojoAttachPoint="divPrivate">' +
											'<input id="${id}_private" type="checkbox" name="private" dojoAttachPoint="makePrivate"/><span> <label for="${id}_private">${nlsMakePrivate}</label></span>' +
										'</div><br />' +
										'<div dojoAttachPoint="divPageTemplate">' +
											'<div><b style="margin-right:10px">${nlsPageTemplate}</b><span dojoAttachPoint="divSelectedTemplateName" style="margin-right:10px">${nlsDefault}&nbsp;</span><a href="javascript:void(0);" class="lotusAction" dojoAttachPoint="showHideTemplateNode">${nlsChange}</a></div>' +
											'<div dojoAttachPoint="divTemplate" style="display: none">' +
												'<div><label for="${id}_template">${nlsPageTemplateLabel}</label></div>' +
												'<div><select dojoAttachPoint="templateSelect" id="${id}_template" name="template"><option selected value="">${nlsNoTemplate}</option></select></div>' +
											'</div>' +
										'</div>' +
									'</div>' +
								'</div>' +
								'<div class="lotusDialogFooter" dojoAttachPoint="dialogFooter">' +
									'<input value="${okText}" class="lotusFormButton" dojoAttachPoint="submitDialog" type="submit"/> ' +
									'<a href="javascript:void(0);" class="lotusAction" dojoAttachPoint="dialogCancel">${cancelText}</a>' +
								'</div>' +
							'</form>' +
						'</div>' +
					'</div>',
								
		postMixInProperties: function() {
			this.shelfBundle = dojo.i18n.getLocalization("com.ibm.bundles", "Shelf");
			this.dialogBundle = dojo.i18n.getLocalization("com.ibm.bundles", "PageCreatorDialog");
			this.cancelText = this.shelfBundle["add_content_cancel"];
			this.closeText = this.shelfBundle["add_content_close"];
			this.okText = this.dialogBundle["page_dialog_create_page"];
			this.nlsPageTitle = this.dialogBundle["page_dialog_page_name"];
			this.nlsTitleError = this.shelfBundle["new_feed_enterTitle"];
			this.nlsFriendlyURL = this.dialogBundle["page_dialog_friendly_url_name"];
			this.nlsMakePrivate = this.dialogBundle["page_dialog_make_private"];
			this.titleText = this.dialogBundle["page_dialog_create_page"];		
			this.nlsPageTemplate = this.dialogBundle["page_dialog_page_template"];
			this.nlsPageTemplateLabel = this.dialogBundle["page_dialog_page_template_label"];
			this.nlsNoTemplate = this.dialogBundle["page_dialog_no_template"];
			this.nlsDefault = this.dialogBundle["page_dialog_default"];
			this.nlsChange = this.dialogBundle["page_dialog_change"];
		},	
		
		postCreate: function() { 
			this.inherited(arguments);
			
			this.submitDialog.onclick = dojo.hitch(this,function(){this.submit();return false;});
			this.closeButtonNode.onclick = this.dialogCancel.onclick = dojo.hitch(this,function(){this.cancel();return false;});
			
			if (!this.showMakePrivate) { dojo.destroy(this.divPrivate); delete this.divPrivate; }
			
			this.connect(this.typingNode, "onkeyup", function(){
				if (this.typingNode.value != "") { this.newPageError.style.display="none"; }
			});
			
			this.connect(this.typingNode, "onkeypress", dojo.hitch(this, function(event) {
	            if (event.keyCode==dojo.keys.ENTER) { this.submit(); }
			}));
			
			if (this.showFriendlyURL){
				this.connect(this.typingNode, "onkeyup", function(){ 
					this.filterFriendlyURL(this.typingNode.value);
				});
				this.connect(this.newPageFriendlyURL, "onkeyup", function(){
					this.filterFriendlyURL(this.newPageFriendlyURL.value);
				});
			} else {
				dojo.destroy(this.divFriendlyURL);
				delete this.divFriendlyURL;
			}
			
			if (this.showPageTemplate) {
				this.connect(this.showHideTemplateNode, "onclick", this.fireEventToTemplateSelectDialog);
			}
			else {
				dojo.destroy(this.divPageTemplate);
				delete this.divPageTemplate;
			}
		},
		fireEventToTemplateSelectDialog: function () {
            // summary:
            //      When the Template Select dialog is called the first time, it will initialize itself
            //        and fire back the value of the default template. On subsequent calls, the dialog will
            //        display itself and send back the id of the selected template.
            if(this.showPageTemplate){
				var widgetModel = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel();
				com.ibm.mashups.services.ServiceManager.getService("eventService").fireEvent("templateSelect", "onTemplateSelect", this.templateSelect.options[0].value, null, "newPage");
            }
		},
		_templateSelectChanged: function(value) {
            // summary:
            //      Callback from the Template Select dialog with the selected template value
            if(this.showPageTemplate){
				if (value.templateName) {
					this.divSelectedTemplateName.innerHTML = value.templateName;
				}
				this.templateSelect.options[0].value = value.templateValue;
            }
		},
		_validatePageName: function(title) {
			dojo["require"]("com.ibm.mm.builder.builderpre");
			var cwm = com.ibm.mm.builder.coreWidgetsMessages;
		    if (!title) {
		        return false;
		    }
		    if (title.length === 0) {
		        alert(cwm.E_PAGE_UTIL_INVALID_NAME_EMPTY_0);
		        return false;
		    }
		    title = dojo.trim(title);
		    if (title.length === 0) {
		        alert(cwm.E_PAGE_UTIL_INVALID_NAME_BLANK_0);
		        return false;
		    }
		    
		    if (title.length >= 256) {
		        alert(cwm.E_PAGE_UTIL_INVALID_NAME_LENGTH_0);
		        return false;
		    }
		    
		    var match = ibmConfig[com.ibm.mashups.enabler.services.ConfigConstants.BUILDER_TITLE_FILTER_REGEXP];
		    if (match) {
		        if (title.match(match)) {
		            alert(cwm.E_PAGE_UTIL_INVALID_NAME_CHAR_0);
		            return false;
		        }
		    }
		    return true;
		},
		
		submit: function(){
			var pagename = this.typingNode.value.replace(/<(?:\/?).+?>/g,"");  // remove tags to protect against XSS
			this.typingNode.value = pagename;
			// shows error if there is no page title.
			if (pagename == "") {
				this.newPageError.style.display = "block";
				return;
			}
			//bug 13511, xss check before submit.
			if (!this._validatePageName(pagename)) { return; }
			
			dojo.attr(this.submitDialog, "disabled", "disabled");
			this.hide();
			this.beforeSubmit();
			//bug 12089, fix multi click to create page multi times.
			var self = this;
			setTimeout(function(){
				self.onSubmit();
			}, this.duration * 2);  // time needed for create dialog to hide and waiting dialog to appear);
		},
		
		cancel: function(){
			this.hide();
		},
		
		onChange: function(/*Object*/arg){
		},
		
		onComplete: function(){
		},
		
		beforeSubmit: function(){
		},
		
		onSubmit: function() {
			// When the user presses the Submit button.
			this.value = dojo.formToObject(this.newPageForm);
			// if user does not have editor rights on parent page, they have no choice
			//   and are always making private pages so we need to set the parameter
			if (!this.value["private"] && !this.showMakePrivate) {
				this.value["private"]="on";
			}
			this.value.onComplete = this.onComplete;
			this.onChange(this.value);
		},
		
		layout: function() {
			if(this.domNode.style.display != "none") {
				/* 
				 * Calling internal API to fix a bug where resizing the viewport
				 * does not resize the dialog, but simply calls "layout" and should
				 * also call "_size"
				 */
				this._size();
			}
			return this.inherited(arguments);
		},
		
		focus: function(){
			this.newPageError.style.display="none";
			if(this.showMakePrivate){this.makePrivate.checked = false;}
			this.typingNode.value = "";
			if(this.showFriendlyURL){this.newPageFriendlyURL.value = "";}
			this.submitDialog.removeAttribute("disabled");
			this.show();
			this.focusNode.focus();
            
            if(this.showPageTemplate){this.fireEventToTemplateSelectDialog();}  // get the default template value
		},
		
		filterFriendlyURL: function(/*String*/textToFilter) {
		// summary: filters the given text into something more acceptable for the friendly url.
		// textToFilter: text for the filter to run on.
			var friendly = textToFilter.replace(/[!\*\'\(\);:@&=+$,\/?%#\[\]\s]/g,'-');
			this.newPageFriendlyURL.value = friendly;
		},
		destroy: function () {
			this.submitDialog.onclick = null;
			this.closeButtonNode.onclick = null;
			this.inherited(arguments);		
		}
    }
);

}

if(!dojo._hasResource["com.ibm.mm.builder.navigationHelper"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.navigationHelper"] = true;
dojo.provide("com.ibm.mm.builder.navigationHelper");





dojo.declare("com.ibm.mm.builder.navigationHelper",
		null,
		{
			loaded: false,
			init: function(){
				// singleton instance of data store to be used under the covers by any component using these APIs
				this.store = new com.ibm.data.EnablerModelStore();
				this.navigationUtil = com.ibm.mm.builder.utils.navigationUtil;
				this.pageUtil = com.ibm.mm.builder.utils.pageUtil;
				this.spaceUtil = com.ibm.mm.builder.utils.spaceUtil;
				
				// TEMP for portal, does not cause issues in mashups 2.5
				var nm = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel();
				
				var currentPage = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage();
				var currentPageId = currentPage.getID();
				if(!currentPageId) {
					var spaceId = this.spaceUtil.getCurrentSpaceId();
					currentPageId = spaceId ? this.pageUtil.getFirstPageInSpace(spaceId) : this.pageUtil.getFirstRootPageId();
					
					if(!currentPageId && spaceId){
						currentPageId = spaceId;
					}else{
						currentPageID = this.navigationUtil.getNavigationRootNode().getID();
					}
				}
				
				var onComplete = dojo.hitch(this,
											function(items) {
												this.treeModel = 
													new com.ibm.data.EnablerTreeModel({
														newItem: function(args) {
															args.label = args.title;
															return this.inherited("newItem", arguments);
														},
														root: items[items.length - 1],
														store: this.store
													});
												
												this.selectionModel = 
													new com.ibm.data.SelectionModel({
														treeModel: this.treeModel,
														selectionPath: items
													});
												
												this.loaded = true;
											} );
				
				var args = { onComplete: onComplete,
							 onError: function(err) {
										console.error(err);
										throw err;
									  },
							 query: {uri: currentPageId }
						   }
				
				if(!this.treeModel || !this.selectionModel) this.store.fetch(args);
			},
			getStore: function(){
				return this.store;
			},
			getTreeModel: function(){
				return this.treeModel;
			},
			getSelectionModel: function(){
				return this.selectionModel;
			}
	}
);

com.ibm.mm.builder.navigationHelper = new com.ibm.mm.builder.navigationHelper();

}

if(!dojo._hasResource["com.ibm.data.MashupCatalogFeedStore"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.data.MashupCatalogFeedStore"] = true;
dojo.provide("com.ibm.data.MashupCatalogFeedStore");




dojo.declare("com.ibm.data.MashupCatalogFeedStore", 
		[com.ibm.data.OpenSearchFeedStore,com.ibm.data.CatalogMixin],
		{
			itemClass: "com.ibm.data.MashupCatalogFeedItem",
			searchable: false,
			
			namespaces: dojo.mixin({}, com.ibm.data.OpenSearchFeedStore.prototype.namespaces, {
		        "ext" : "http://www.ibm.com/xmlns/prod/lotus/mashups/v1.0/extensions",
				"model" : "http://www.ibm.com/xmlns/prod/lotus/mashups/v1.0/model-elements",
				"base" : "http://www.ibm.com/xmlns/prod/lotus/mashups/v1.0/base",
				"catalog" : "http://www.ibm.com/xmlns/atom/opensearch/catalog/1.0/",
				"xsi" : "http://www.w3.org/2001/XMLSchema-datatypes",
				"openSearch" : "http://a9.com/-/spec/opensearch/1.1/"
		    }),
		       
			constructor: function( /*Map*/ args ) {
				this._features['dojo.data.api.Identity'] = true;
				var serviceDoc = com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_CATALOG;
				var serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(serviceDoc);
				this.isPortal = (serviceJson.idprefix == "id") ? false : true;
				
				this.url = serviceJson.url + "@"+ serviceJson.idprefix + ":" + this.category;
				var catalog = this.catalog ? this.catalog : "default";
				var mashupsIdPostfix = this.isPortal ? "" : "_c_" + catalog;
				this.url = this.url + mashupsIdPostfix;				
			},
				
			mapItem: function(/*item*/item){
				var map = {};
				var bigId = this.getEPResolvedValue(item, "id", null);
				if(this.isPortal) var ids = /^catalog:oid:(.+)@oid:.+/.exec(bigId);
				else var ids = /^catalog:id:(.+)@/.exec(bigId);
				map.id = ids.length > 1 ? ids[1] : "";
				map.label = this.getEPResolvedValue(item, "title", "untitled");
				map.description = this.getEPResolvedValue(item, "summary", "");
				map.thumbnail = this.getValue(item, "thumbnail", "");
				map.icon = this.getValue(item, "catalogIcon", "");
				map.onAutoWire = this.getEPResolvedValue(item, "catalogAutoWire", "");
				map.widgetParam = this.getEPResolvedValue(item, "catalogWidgetParam", "");
                if(map.widgetParam.length > 0) { map.prefsMapFcn = this.prefsMapFcn; }
                map.definitionURL = this.getValue(item, "definitionURL", "");
				map.type = "catalog";
				map.isTrusted = com.ibm.mm.builder.utils.iwidgetUtil.isWidgetTrusted(map.id);
				if(!map.thumbnail && builderConfig.builderPath) map["thumbnail"] = builderConfig.builderPath + "/images/gray_generic_widget_icon.png";
				return map;
			},
			
            prefsMapFcn: function(map){
				var pars = dojo.fromJson(map.widgetParam);
				var ret = {};
				for(var i in pars){
					ret[pars[i].itemName] = pars[i].itemValue;
				}
				return ret;
			},
            	
			prepareQuery: function(keywordArgs) {
				if(keywordArgs.count) {
					if(this.isPortal) keywordArgs.query["max-results"] = keywordArgs.count;
					else keywordArgs.query.num = keywordArgs.count;
					if(keywordArgs.start == null) {
						keywordArgs.start = 0;
					}
					if(this.isPortal) keywordArgs.query["start-index"] = keywordArgs.start;
					else keywordArgs.query.start = keywordArgs.start;
				}
				return keywordArgs;
			},
			
			validateSelf: function(){
				// summary: validates this datastore, if it does not validate the source will not be used
				// returns true for validation and false otherwise
				if(dojo.trim(ibmConfig["com.ibm.mashups.builder.contentShelf.mode"]) == "mashups") {
					var categories = com.ibm.mm.builder.utils.toolboxUtil.getCategories();
					var found = false;
					for (var i = 0; i < categories.length; i++) {
						var category = categories[i];
						var id = category.getID();
						if(id.indexOf(this.category) == 0) {
							found = true;
							break;
						}					
					}					
					return found;
					
				} else {
					return false;
				}
			},
			
			
			
			getSourceLabel: function(){
				var categories = com.ibm.mm.builder.utils.toolboxUtil.getCategories();
				for (var i = 0; i < categories.length; i++) {
					var category = categories[i];
					var id = category.getID();
                    if(id.indexOf(this.category) == 0
                        && (this.isPortal ? true : (id.indexOf("_c_") == this.category.length))) {
                        return com.ibm.mm.builder.utils.enablerUtil.getNodeTitle(category);
                    }
				}
				return false;
			}
});

dojo.declare( "com.ibm.data.MashupCatalogFeedItem",
		com.ibm.data.OpenSearchFeedItem, 
		{
			namespaces: dojo.mixin({}, com.ibm.data.MashupCatalogFeedStore.prototype.namespaces),
			// there is no 'widget.metadata' prefix for the metadata
	        attrMappings: dojo.mixin({}, com.ibm.data.OpenSearchFeedItem.prototype.attrMappings, {
				thumbnail: {xpath: "./atom:content/model:catalog-entry/atom:link[@ext:rel='icon']", targetName: "href", type: "attr"},
                catalogIcon: {xpath: "./atom:content/model:catalog-entry/atom:link[@ext:rel='icon']", targetName: "href", type: "attr"},
				catalogAutoWire: {xpath: "//model:metadata[@name='com.ibm.mashups.builder.autoWiringEnabled']/base:value", targetName: "value", type: "attr"},
                definitionURL: {xpath: "./atom:content/model:catalog-entry/atom:link[@ext:rel='definition']", targetName: "href", type: "attr"},
				catalogWidgetParam: {xpath: "//model:metadata[@name='widgetParam']/base:value", targetName: "value", type: "attr"}
			})
		}
);

}

if(!dojo._hasResource["com.ibm.mm.builder.DeferredImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.DeferredImpl"] = true;
dojo.provide("com.ibm.mm.builder.DeferredImpl");

// base
dojo.declare("com.ibm.mm.builder.DeferredImpl", [com.ibm.mashups.enabler.Deferred], {
    // If you mixin the DeferredImpl into your class, you may use a different 
    // set of parameters for the constructor, but then you do not have access
    // to the parameters 'context', 'startfn', as well as 'params' and thus, 
    // you need to overwrite the start function, which accesses those parameters.
    // If you want to use the start function defined in DeferredImpl, you need 
    // to make sure, the parameters 'context', 'startfn', as well as 'params' 
    // are set in the constructor of DeferredImpl.     
    constructor: function(context, startfn, params){
        // context for start function
        this.context = context;
        
        // start function
        this.startfn = startfn;
        
        // parameters to pass to start function
        this.params = params;
    },
    
    setFinishedCallback: function(callback, parameters){
        this.finishedCallback2 = callback;
        this.finishedCallbackParameters2 = parameters;
        return this;
    },
    
    start: function(sync){
        var mode = (sync || typeof(sync) == 'undefined') ? true : false;
        return dojo.hitch(this.context, this.startfn)(this, mode, this.params);
    },
    
    getFinishedCallback: function(){
        return this.finishedCallback2;
    },
    
    getFinishedCallbackParameters: function(){
        return this.finishedCallbackParameters2;
    }
    
});

}

if(!dojo._hasResource["com.ibm.mm.builder.DelegatedDeferredImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.DelegatedDeferredImpl"] = true;
/**
 * Provides enhanced Deferred implementations for dealing with situations where data
 * is loaded from one place by multiple consumers.  Each consumer gets its own Deferred
 * implementation, but the data loading can be performed by a single Deferred under the
 * covers.
 * @author Ben
 */
dojo.provide("com.ibm.mm.builder.DelegatedDeferredImpl");



/**
 * A DelegatorDeferredImpl is a deferred that allows DelegatedDeferredImpls to piggy back on top of it
 * so that its loading operation will fire the callbacks of all DelegatedDeferredImpls that are attached
 * to it.  This provides a mechanism for a single pipe to load data and then multiplex the output to 
 * multiple other outputs.
 */
dojo.declare("com.ibm.mm.builder.DelegatorDeferredImpl", com.ibm.mm.builder.DeferredImpl, {
	
	constructor: function() {
		this._delegates = [];
		this._finishedData = [];
		var me = this;
		this.finishedCallback2 = function(result, status, params){
			if(!me._restarted || !me._finished) {
				// Only call the callbacks if we were never finished before, or if we've been finished
				// already without having been restarted (like if a particular caller calls the callback
				// multiple times at the end of an async operation; unlikely but possible)
				me._finishedData = [result, status, params];
				me._finished = true;
				while(me._delegates.length > 0) {
					me._fireDelegate(me._delegates.shift());
				}
				return me._finish.apply(me, arguments);
			}
		};
	},
	_finish: function(result, status, params) {
		if(this._hiddenCallback) {
			return this._hiddenCallback.apply(this, arguments);
		}
	},
	
	setFinishedCallback: function(callback, parameters){
		this._hiddenCallback = callback;
		this.finishedCallbackParameters2 = parameters;
		return this;
	},
	/**
	 * Important semantics to note here... cannot be started twice
	 */
	start: function(sync){
		if(this._started) {
			return;
		}
		this._started = true;
		return this.inherited(arguments);
	},
	/**
	 * This allows a caller to "restart" this DelegatorDeferredImpl in sync mode if it is currently processing
	 * in async mode and hasn't finished yet.
	 */
	_restart: function(sync) {
		if(sync && this._started && !this._finished) {
			// we started in async mode but need to restart in sync mode
			this._restarted = true;
			this._started = false;
			return this.start(true);
		}
	},
	_fireDelegate: function(dfd) {
		var data = this._finishedData,
			cbk = dfd.getFinishedCallback(),
			parms = dfd.getFinishedCallbackParameters();
		if(cbk) {
			// Do NOT catch errors so that they propagate to the top
			// Side effect is the potential to stop calling callbacks if an error occurs in one of them
			return cbk(data[0], data[1], parms);
		}
	},
	/**
	 * Adds a DelegatedDeferredImpl to this DelegatorDeferredImpl's delegate chain
	 */
	addDelegate: function(dfd) {
		this._delegates.push(dfd);
		dfd.delegator = this;
		if(this._finished) {
			this._fireDelegate(this._delegates.shift());
		}
		return this;
	}
});


/**
 * A DelegatedDeferredImpl is a deferred which actually piggy backs on top of an existing DelegatorDeferredImpl.
 * These are created without a start function and are then added to an existing DelegatorDeferredImpl via its
 * addDelegate API.  When the DelegatorDeferredImpl finishes, this Deferred is fired as well with the same results
 * so that multiple Deferreds can be passed to consuming code while relying on a single pipe for the actual
 * data.
 */
dojo.declare("com.ibm.mm.builder.DelegatedDeferredImpl", com.ibm.mm.builder.DeferredImpl, {
	
	delegator: null,
	
	setFinishedCallback: function(callback, parameters){
		var me = this;
		this.finishedCallback2 = function(result, status, params){
			if(me._started) {
				me._result = result;	// store this for sync mode
				// Only call our callback if we've been started already
				return callback.apply(this, arguments);
			}
		};
		this.finishedCallbackParameters2 = parameters;
		return this;
	},
	
	/**
	 * Important note on side effects here... starting a DelegatedDeferredImpl will implicitly start the underlying
	 * delegator if it hasn't been started yet.
	 */
	start: function(sync){
		if(!this.delegator) {
			// if we have no delegator, just escape immediately
			return;
		}
		this._started = true;
		var mode = (sync || typeof(sync) === "undefined") ? true : false;
		if(this.delegator._finished && this.finishedCallback2) {
			// the delegator finished already, add us back to it to be automatically fired
			this.delegator.addDelegate(this);
			return this._result;	// for sync support
		}
		else if(mode && this.delegator._started && !this.delegator._finished) {
			// the delegator was started in async mode, hasn't finished, and we're starting in sync mode
			return this.delegator._restart(mode);
		}
		else if(!this.delegator._started) {
			// the delegator hasn't started yet
			return this.delegator.start(mode);
		}
	}
});

}

if(!dojo._hasResource["com.ibm.pb.data.ResourceLoader"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.data.ResourceLoader"] = true;
dojo.provide("com.ibm.pb.data.ResourceLoader");




/**
 * Reusable generic resource loader that returns a Deferred object that loads a resource
 * remotely.  Underneath, the loader pipes all requests to the same resource through the
 * same IO operation so that multiple simultaneous requests for the same data aren't made
 * at the same time, but rather piggy back on top of an existing operation.  Supports
 * loading in async or sync mode. 
 */
dojo.declare("com.ibm.pb.data.ResourceLoader", com.ibm.pb.logging.Loggable, {
	
	_cache: {},
	
	constructor: function() {
		this._cache = {};
	},
	
	getData: function(url, type) {
		// multiple calls to this before a previous call finishes may result in multiple requests for the same data.... depending on
		// the implementation of the ConfigService Deferred
		var mname = "getData", lgr = this.LOGGER, me = this;
		if(!this._cache[url]) {
			this._cache[url] = new com.ibm.mm.builder.DelegatorDeferredImpl(this, function(deferred, sync, params) {
				var callBack = deferred.getFinishedCallback(), callBackParams = deferred.getFinishedCallbackParameters();
				lgr.trace(mname, "Start loading remote data");
				if (deferred._data) {
					lgr.trace(mname, "Data already loaded ${0}", [deferred._data]);
					if(callBack) {
						callBack(deferred._data, 200, callBackParams);
					}
				}
				else {
					dojo.xhrGet({
						url: url,
						load: function(data, ioArgs){
							lgr.trace(mname, "Received response from url ${0} with data ${1}", [url, data]);
							deferred._hasFired = true;
							me._finishDeferred(deferred, data, 200);
						},
						error: function(err, ioArgs) {
							lgr.warning(mname, "Error getting data from url ${0}: ${1}", [url, err]);
							if(!deferred._hasFired) {
								// we don't want to get into this if the deferred's callback was
								// already fired in the load function, but threw an error that dojo
								// catches underneath us and then calls the error function too
								me._finishDeferred(deferred, err, me.statusCodes.HTTP_NOT_FOUND);
							}
						},
						handleAs: type,
						sync: sync
					});
				}
				return deferred._data;
	        });
		}
		var dfd = new com.ibm.mm.builder.DelegatedDeferredImpl();
		this._cache[url].addDelegate(dfd);
		return dfd;
	},
	_finishDeferred: function(deferred, data, status) {
		deferred._data = data;
		var callBack = deferred.getFinishedCallback(), callBackParams = deferred.getFinishedCallbackParameters();
		if(callBack) {
			callBack(data, status, callBackParams);
		}
		return data;
	}
});


com.ibm.pb.data.RESOURCE_LOADER = new com.ibm.pb.data.ResourceLoader();

}

if(!dojo._hasResource["com.ibm.pb.localized.DojoLocalized"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.localized.DojoLocalized"] = true;
dojo.provide("com.ibm.pb.localized.DojoLocalized");




dojo.declare("com.ibm.pb.localized.DojoLocalized", [com.ibm.mashups.enabler.Localized, com.ibm.pb.logging.Loggable], {
	/**
	 * Defines the package where the resource bundle for this item exists
	 * @type String
	 */
	bundlePackage: "",
	
	/**
	 * Defines the name of resource bundle for this item
	 * @type String
	 */
	bundleName: "",
	
	/**
	 * Defines the key to use to look up the title and description in the resource bundle.
	 * The title is mapped to the "bundleKey.title" property and the description is mapped to the
	 * "bundleKey.description" property in the resource bundle.
	 * @type String
	 */
	bundleKey: "",
	
	constructor: function(jsonObj) {
		this.bundlePackage = jsonObj.bundlePackage;
		this.bundleName = jsonObj.bundleName;
		this.bundleKey = jsonObj.bundleKey;
		this._locales = [dojo.locale];
		var extra = dojo.config && dojo.config.extraLocale;
		if(extra) {this._locales.push.apply(this._locales, extra);}
		// avoid build process picking this up... then failing; jslint complains, but its required
		dojo["require" + "Localization"](this.bundlePackage, this.bundleName);
	},
	_getBundle: function(locale) {
		var mname = "_getBundle", ret = {};
		try {
			ret = dojo.i18n.getLocalization(this.bundlePackage, this.bundleName, locale);
			this.LOGGER.trace(mname, "Found bundle for locale ${0}", [locale]);
		} catch(err) {
			// no-op, just return {}
			// must catch this per the API spec, instead of propagating to the caller
			this.LOGGER.warning("_getBundle", "Bundle not found for locale ${0}", [locale]);
		}
		return ret;
	},
	getLocales: function() {
		var mname = "getLocales";
		this.LOGGER.entering(mname, []);
		if(!this._locales.filtered) {
			this.LOGGER.trace(mname, "Filtering locales", []);
			// filter the locales list to only those locales where a title OR description exist
			// for this localized instance in the bundle
			this._locales = dojo.filter(this._locales, function(locale){
				var bundle = this._getBundle(locale);
				var ret = bundle[this.bundleKey] || 
					bundle[this.bundleKey + "_title"] || 
					bundle[this.bundleKey + "_description"];
				this.LOGGER.trace(mname, "Does title or description exist for locale ${0}? ${1}", [locale, ret]);
				return ret;
			}, this);
			this._locales.filtered = true;
		}
		this.LOGGER.exiting(mname, [this._locales]);
		return this._locales;
	},
	getTitle: function(locale) {
		var mname = "getTitle";
		this.LOGGER.entering(mname, [locale]);
		var bundle = this._getBundle(locale);
		var ret = bundle[this.bundleKey + "_title"] || bundle[this.bundleKey];
		this.LOGGER.exiting(mname, [locale]);
		return ret;
	},
	getDescription: function(locale) {
		var mname = "getDescription";
		this.LOGGER.entering(mname, [locale]);
		var ret = this._getBundle(locale)[this.bundleKey + "_description"];
		this.LOGGER.exiting(mname, [locale]);
		return ret;
	}
});

}

if(!dojo._hasResource["com.ibm.pb.contextMenu.JsonContextMenuLoader"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.contextMenu.JsonContextMenuLoader"] = true;
dojo.provide("com.ibm.pb.contextMenu.JsonContextMenuLoader");






dojo.declare("com.ibm.pb.contextMenu.JsonContextMenuLoader", [com.ibm.mashups.builder.model.ContextMenuLoader, com.ibm.pb.logging.Loggable], {
	
	/**
	 * Definition: 	{
	 * 					url: "",
	 * 					data: {},
	 * 					name: ""
	 * 				}
	 */
	_df: null,
	
	statusCodes: com.ibm.mm.enabler.model.HttpStatusCodes,
	
	constructor: function(/*Object*/ definition) {
		if(!definition) {
			throw new Error("definition must not be null");
		}
		this._df = definition;
		this._data = null;
	},
	getItems: function(/*String*/ contextMenuId, /*String*/ targetResourceId, /*String*/ targetResourceType, /*Object*/ someObject) {
		var mname = "getItems", lgr = this.LOGGER, me = this;
		lgr.entering(mname, arguments);
		dfd = new com.ibm.mm.builder.DeferredImpl(this, function(deferred, sync, params) {
			var callBack = deferred.getFinishedCallback(), callBackParams = deferred.getFinishedCallbackParameters(),
				res;
			if(!this._data) {
				this.getData(function(data, status){
					if(status == 200) {
						res = me._initMenuItems(contextMenuId, targetResourceId, targetResourceType, someObject);
					}
					else {
						res = data;
					}
					if(callBack){
						callBack(res, status, callBackParams);	// callback for success or error
					}
				}, sync);
			}
			else {
				res = this._initMenuItems(contextMenuId, targetResourceId, targetResourceType, someObject);
				if(callBack){
					callBack(res, 200, callBackParams);
				}
			}
			return res;
		});
		lgr.exiting(mname, arguments);
		return dfd;
	},
	getData: function(callback, sync) {
		var mname = "getData", lgr = this.LOGGER, me = this, jsonName = this._df.name, HTTP_OK = com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK;
		lgr.entering(mname, arguments);
		if(!this._data) {
			if(this._df.data) {
				this._data = jsonName ? dojo.getObject(jsonName, false, this._df.data) : this._df.data;
				if(callback) {
					callback(this._data, 200);
				}
			}
			else if(this._df.url) {
				lgr.trace(mname, "Requesting context menu by url ${0}", [this._df.url]);
				com.ibm.pb.data.RESOURCE_LOADER.getData(this._df.url, "json").setFinishedCallback(function(data, status, params){
					me._data = data;
					if(status == 200 && jsonName) {
						me._data = dojo.getObject(jsonName, false, data);
					}
					if(callback) {
						callback(me._data, status);
					}
				}).start(sync);
			}
			else {
				throw new Error("Configuration error for context menu: Must specify url or data properties");
			}
		}
		lgr.exiting(mname, [this._data]);
		return this._data;
	},
	_initMenuItems: function(contextMenuId, targetResourceId, targetResourceType, someObject) {
		var mname = "_initMenuItems", lgr = this.LOGGER, ret = [],
			lclCtx = com.ibm.mashups.enabler.context.Factory.getLocalizedContext();
		// TODO: Add deferred processing support for visibility and state functions
		dojo.forEach(this._data, function(item){
			if(this._isVisible(item, targetResourceId, targetResourceType, someObject)) {
				lgr.trace(mname, "Adding item ${0}", [item.id]);
				var l7d = this._getLocalized(item);
				ret.push(dojo.delegate(item, {
					enabled: this._isEnabled(item, targetResourceId, targetResourceType, someObject),
					localized: l7d,
					title: item.title || lclCtx.getTitle(l7d), // if item's title is already defined, and perhaps calculated
					description: item.description || lclCtx.getDescription(l7d), // if item's description is already defined, and perhaps calculated
					actionCallBackFunction: this._getAction(item, targetResourceId, targetResourceType, someObject)
				}));
				lgr.trace(mname, "Added item ${0}", [item.id]);
			}
			else {
				lgr.trace(mname, "Item ${0} is hidden", [item.id]);
			}
		}, this);
		return ret;
	},
	_getAction: function(item, targetResourceId, targetResourceType, someObject) {
		var mname = "_getAction", lgr = this.LOGGER;
		lgr.entering(mname, [item.id, targetResourceId, targetResourceType, someObject]);
		var ret = dojo.partial(item.actionFn, targetResourceId, targetResourceType, item.metadata, someObject);
		lgr.exiting(mname, [item.id, ret]);
		return ret;
	},
	_isVisible: function(item, targetResourceId, targetResourceType, someObject) {
		var mname = "_isVisible", lgr = this.LOGGER;
		lgr.entering(mname, [item.id, targetResourceId, targetResourceType, someObject]);
		var ret = false;
		try {
			ret = dojo.isFunction(item.visibilityFn) ? dojo.partial(item.visibilityFn)(targetResourceId, targetResourceType, item.metadata, someObject) : true;
		} catch(err) {
			lgr.severe(mname, "Error executing visibilityFn for item ${0}: ${1}", [item, err]);
		}
		lgr.exiting(mname, [item.id, ret]);
		return ret;
	},
	_isEnabled: function(item, targetResourceId, targetResourceType, someObject) {
		var mname = "_isEnabled", lgr = this.LOGGER;
		lgr.entering(mname, [item.id, targetResourceId, targetResourceType, someObject]);
		var ret = false;
		try {
			ret = item.stateFn ? item.stateFn(targetResourceId, targetResourceType, item.metadata, someObject) : item.enabled;
		} catch(err) {
			lgr.severe(mname, "Error executing stateFn ${0}", [err]);
		}
		lgr.exiting(mname, [item.id, ret]);
		return ret;
	},
	_getLocalized: function(item) {
		return new com.ibm.pb.localized.DojoLocalized(item);
	}
});

}

if(!dojo._hasResource["com.ibm.pb.iwidget.iWidgetBase"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.iwidget.iWidgetBase"] = true;
dojo.provide("com.ibm.pb.iwidget.iWidgetBase");



dojo.declare("com.ibm.pb.iwidget.iWidgetBase", com.ibm.pb.logging.Loggable, {
	builderFactory: com.ibm.mashups.builder.model.Factory,
	builderEvents: com.ibm.mashups.builder.iEvents,
	iWidgetConstants: com.ibm.mashups.iwidget.Constants,
	configConstants: com.ibm.mashups.enabler.services.ConfigConstants,
	serviceManager: com.ibm.mashups.services.ServiceManager,
	roleTypes: com.ibm.mashups.enabler.ac.RoleType,
	
	constructor: function() {
		this.runtimeModel = this.builderFactory.getRuntimeModel();
		this.evtSvc = this.serviceManager.getService(com.ibm.mashups.iwidget.services.EventService.SERVICE_NAME);
		this.configSvc = this.serviceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
	},
	
	/**
	 * Returns an object map of values retrieved from this iWidget's attributes.  This finds values
	 * for all the keys found in the names array, puts them on the map if they are non-null values,
	 * and returns the map where keys are the attribute names found, and their respective values are
	 * retrieved from the iWidgets attributes.
	 */
	getItemSetValues: function(/*String[]*/ names) {
		var attrs = this.iContext.getiWidgetAttributes();
		var map = {};
		for(var i=0;i<names.length;i++) {
			var val = attrs.getItemValue(names[i]);
			if(val !== null && val !== undefined) {map[names[i]] = val;}
		}
		return map;
	},
	convertMapTypes: function(map, keys, type) {
		var cnv = null;
		switch(type) {
			case "Number":
				cnv = function(key) {
					map[key] = parseInt(map[key],10);
				};
				break;
			case "Boolean":
				cnv = function(key) {
					map[key] = (map[key] === "true" || map[key] === true) ? true : false;
				};
				break;
			case "Object":
				cnv = function(key) {
					if(dojo.isString(map[key])) {map[key] = dojo.eval(map[key]);} // JSLINT-IGNORE: <eval is neccessary to turn string into expression or function>
				};
				break;
			default: 
				cnv = function(key) {};	
		}
		dojo.forEach(keys, function(key){
			if(map[key] !== undefined) {
				cnv(key);
			}
		}, this);
	}
});

}

if(!dojo._hasResource["com.ibm.pb.data.EnablerNavigationTreeModel"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.data.EnablerNavigationTreeModel"] = true;
dojo.provide( "com.ibm.pb.data.EnablerNavigationTreeModel" );



(function(){
	//com.ibm.mashups.enabler.model.state.NavigationStateModelFactory
	var enabler = com.ibm.mashups.enabler,
		em = enabler.model,
		state = em.state,
		accFct = state.AccessorFactory,
		spaceFct = enabler.space.Factory,
		navFct = enabler.navigation.Factory,
		lCtxt = enabler.context.Factory.getLocalizedContext(),
		dfOpP = enabler.DeferredOperation.prototype,
		opCodes = {};
	dojo.forEach(["GET","CREATE","MODIFY","DELETE"], function(c){
		this[c] = dfOpP["OPERATION_" + c];
	}, opCodes);
	
	// This module provides the API for a data model that corresponds to any data set that contains
	// parent-child relationships that can be represented as a tree.  It's exactly the same as the
	// model API that's used by dijit.Tree with some functions already implemented for ease of use.
	// As a result, any implementation of this API can be used as the model to a dijit.Tree widget
	// or any other widget that uses a data model as its backend service provider.  This data API
	// also adds some additional constraints and extension points that implementations should support
	// in addition to the model API that's used by dijit.Tree, but by no means breaks the API or
	// deviates from the required functions of the dijit model API.  One such addition is the
	// support for additional query parameters that can be specified when instantiating a model
	// that are always appended to any request to the server for data.  This allows particular instances
	// of a data model to include metadata information that would not otherwise be included by certain
	// data services that support it.
	dojo.declare( "com.ibm.pb.data.EnablerNavigationTreeModel", com.ibm.pb.logging.Loggable, {
		SAVE_CHECK: "com.ibm.mashups.builder.saveCheck",
		
		SWITCH_PAGE: "com.ibm.mashups.builder.switchPage",
		
		// root: The root item of this model
		root: null,
		
		// navigation state model
		nsm: null,
		
		// navigation model
		nm: null,
		
		// space model
		spm: null,
		
		codes: {
			HTTP_OK: 200
		},
		
		// global page support
		globalPages: [],   // the global pages that are open
		globalPageInSpace: null,  // the space in which the global pages were opened
		
		constructor: function(args) {
			dojo.safeMixin(this, args);
			if(!this.nsm) {this.nsm = state.NavigationStateModelFactory.getNavigationStateModel();}
			if(!this.nm) {this.nm = navFct.getNavigationModel();}
			if(!this.spm) {this.spm = spaceFct.getSpaceModel();}
			if(!this.delaySave) {this.delaySave = false;}
		},
		destroy: function() {
		        // summary: destroys this object, releasing connections to the store
		},
		reset: function(root) {
			// summary: Resets the root of this model to the argument.
			this.root = root;
		},
		_getRootBySpace: function(space, status, params) {
			var mname = "_getRootBySpace", lgr = this.LOGGER;
			lgr.entering(mname, arguments);
			try {
				var navDfd;
				if(space) {
					navDfd = this.nm.find(space.getRootNavigation());
				}
				else {
					navDfd = this.nm.getRoot();
				}
				navDfd.setFinishedCallback(dojo.hitch(this, function(navNode, statusCode){
					lgr.trace(mname, "Callback: ${0} ${1}", [navNode, statusCode]);
					if(navNode && !(navNode instanceof Error)) {
						this.root = navNode;
						if(params.onItem) {
							params.onItem(this.root);
						}
					}
					else if(params.onError){
						lgr.error(mname, "Error getting the root nav node in space ${0}: ${1}", [space, err]);
						params.onError(navNode);
					}
				}));
				lgr.trace(mname, "Finding root nav node in space ${0}", [space]);
				node = navDfd.start(false);
			} catch(err) {
				lgr.error(mname, "Error starting find operation for the root nav node in space ${0}: ${1}", [space, err]);
				console.error(err);
			}
			lgr.exiting(mname, arguments);
		},
		getRoot: function(onItem, onError){
			// summary:
		    //      Calls onItem with the root item for the tree
		    var mname = "getRoot", lgr = this.LOGGER;
		    lgr.entering(mname, arguments);
			var globalSpaceId = dojo.cookie(com.ibm.mm.builder.constant.cookieKey_globalPageOpenedSpaceId);
			if (globalSpaceId) {
				var id = globalSpaceId;
			} else {
				var id = accFct.getSpaceAccessor(this.nsm).getSpaceID();
			}
			var params = {onItem:onItem, onError:onError};
			if(id) {
				var dfd = this.spm.find(id);
				dfd.setFinishedCallback(dojo.hitch(this, "_getRootBySpace"), params);
				dfd.start(false);
			}
			else {
				this._getRootBySpace(null, 200, params);
			}
			lgr.exiting(mname, arguments);
		},
		mayHaveChildren: function(/*Object*/ item){
	        // summary:
	        //            Tells if an item has or may have children.  Implementing logic here
	        //            avoids showing +/- expando icon for nodes that we know don't have children.
	        //            (For efficiency reasons we may not want to check if an element actually
	        //            has children until user clicks the expando node)
	        return this.nm.hasChildren(item);
		},
		getChildren: function(/*Object*/ parentItem, /*function(items)*/ onComplete, /*function*/ onError){
	        // summary:
	        // 			  Calls onComplete() with array of child items of given parent item, all loaded.
	        var mname = "getChildren", lgr = this.LOGGER;
	    	lgr.entering(mname, arguments);
	        var dfd = this.nm.getChildren(parentItem);
	        var children = [];
	        dfd.setForEachCallback(function(child){
	        	lgr.trace(mname, "Got child ${0}", [child]);
	        	if(child && !child.isHidden()) {
	        		children.push(child);
	        	}
	        });
	       	dfd.setFinishedCallback(dojo.hitch(this, function(res, status, params){
	       		lgr.trace(mname, "Finished getting children with status ${0}", [status]);
	       		if(status == this.codes.HTTP_OK) {
					// support global pages
					if (this.globalPageInSpace) {
						var parentItemSpace = com.ibm.mm.builder.utils.spaceUtil.getSpaceByNavigation(parentItem);
						if (parentItemSpace && this.globalPageInSpace == parentItemSpace.getID()) {
							for (var i in this.globalPages) {
								var inChildren = false;
								for (var j in children) {
									if (this.globalPages[i].getID() == children[j].getID()) {
										inChildren = true;
									}
								}
								if (!inChildren) {
									children.push(this.globalPages[i]);
								}
							}
						}
					}
	       			if(onComplete) {onComplete(children);}
	       		}
	       		else if(onError) {
	       			onError(res);
	       		}
	      	}));
	      	dfd.start(false);  
	      	lgr.exiting(mname, arguments); 
		},
		// =======================================================================
		// Inspecting items
		getIdentity: function(/* item */ item){
	        // summary: returns identity for an item
			if(item == null){
				return null;
			}
	        return item.getID();
		},
		getLabel: function(/*dojo.data.Item*/ item){
	        // summary: get the label for an item
			if(item == null){
				return null;
			}
	        return lCtxt.getTitle(item);
		},
		getParent: function(/*dojo.data.Item*/ item) {
			// summary: returns the parent item of this item argument
			var mname = "getParent", lgr = this.LOGGER;
		    lgr.entering(mname, arguments);
			
			if (this._isGlobalPage(item)) {
				// to support global page, return the parent of the top level pages of the space that opened the global page
				var globalSpaceId = dojo.cookie(com.ibm.mm.builder.constant.cookieKey_globalPageOpenedSpaceId);
				if (globalSpaceId) {
					var parent = com.ibm.mm.builder.utils.navigationUtil.getNavigationRootNode(globalSpaceId);
				} else {
					console.log("Error: globaPageOpenedSpaceId in cookie is missing!");
				}
			}else{
				var parent = this.nm.getParent(item).start();
			}

		    lgr.exiting(mname, [parent]);
			return parent;
		},
		// =======================================================================
		// Write interface
		newItem: function(args, parent) {
			var nm = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel();
			var createParams = {type: com.ibm.mashups.enabler.navigation.Constants.NAVIGATION_PAGE}
			if (args["private"] == "on") {
				createParams["private"] = true;
			} 
			var isPageTemplate = args["template"] != "";
			if (isPageTemplate) {
				createParams.pageTemplate = args["template"];
			}
			var newPage = nm.create(createParams);
			newPage.setTitle(args.title, dojo.locale);
			if (args.friendlyURL) 
				newPage.setMetaData("com.ibm.portal.friendly.name", args.friendlyURL);
			var parentId = this.getIdentity(parent);
			var parentNavNode = nm.find(parentId).start();
			nm.insert(newPage, parentNavNode);
			var content = newPage.getContent().start();
			if(!isPageTemplate) {
				content.setStaticContentURL(ibmConfig.defaultLayoutTemplateURI);
			}
			var dfd = nm.commit();
			dfd.setOperationCallback(function(page, mode, status, params){
				var evtSvc = com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService");
				if(page && page.getID && status < 300) {
					evtSvc.broadcastEvent("com.ibm.mashups.builder.refreshNavigation");
					evtSvc.broadcastEvent("com.ibm.mashups.builder.switchPage", page.getID());
					evtSvc.broadcastEvent("com.ibm.mashups.builder.spacemanager.pageCreated", page.getID());
				}else if(status >= 400){
					var bundle = dojo.i18n.getLocalization("com.ibm.bundles", "PageCreatorDialog");
					var statusMessage = new com.ibm.widgets.StatusMessage("error", bundle["page_dialog_error_creating_page"], "");
					dojo.publish("/message/status",[{message: statusMessage, uid: 'ibmStatusBox'}]);
				}
				if(args.callback) {
					args.callback(page, mode, status, params);
				}
			});
			dfd.setFinishedCallback(function(page, status){
                if(status >= 400) {
					var bundle = dojo.i18n.getLocalization("com.ibm.bundles", "PageCreatorDialog");
					var statusMessage = new com.ibm.widgets.StatusMessage("error", bundle["page_dialog_error_creating_page"], "");
					dojo.publish("/message/status",[{message: statusMessage, uid: 'ibmStatusBox'}]);
                }
				if(args.callback){
					args.callback(page, null, status);
				}
            });
			dfd.start(true);
			return newPage;
		},
		// newGlobalItem adds an item but it is temporary.  It doesn't exist in the enabler model.  This is used for global page support.
		newGlobalItem: function(args, parent){
			if(parent.getRootNavigation)
			{
				parent = com.ibm.mm.builder.utils.navigationUtil.getNavigationRootNode(parent.getID());
			}
			var newPage = com.ibm.mm.builder.utils.pageUtil.getPageNode(args.openPageId);
			newPage.loaded = false;
			newPage.created = false;			
			newPage.openPageId = args.openPageId;
			newPage.pageLoadedSpaceId = args.pageLoadedSpaceId;
			newPage.onCreate = function(){}; 
			this.globalPageInSpace = newPage.pageLoadedSpaceId;
			this.globalPages.push(newPage);
			this.newPageItem = newPage;
			this.newPageParent = parent;
			// Note: onTreeChange seems appropriate here, but it causes duplicate tabs to appear for the global page
	    	//this.onTreeChange(this.newPageItem, null, this.newPageParent);
			this._isItemCreated = true;
	        return newPage;
		},
		// Note: _createItem appears to be dead code.
		_createItem: function(args, parentInfo) {
			// summary: Creates an item
			//		All model requests must be synchronous since this must return the
			//		created item directly.
	        var title = args.title;
			
			var newPage, mix = {
				loaded: false,
				created: false
			};
			if (args.openPageId){
				// load an existing page as an new item
				newPage = this.nm.find(args.openPageId).start();
				mix = dojo.mixin(mix, {
					openPageId: args.openPageId,
					pageLoadedSpaceId: args.pageLoadedSpaceId
				});			
				this.globalPageInSpace = args.pageLoadedSpaceId;
				this.globalPage = newPage;
			}else{
				if(!this.nm.confirmCreate(args)) {
		        	// throw new Error("Not allowed");
		        	return;
		        }
		        newPage = this.nm.create(args);
		        newPage.setTitle(title, lCtxt.getPreferredLocale());
				newPage.setTitle(title, ibmCfg.enablerConfig["default.locale"]);
				newPage.setTheme(parentInfo.parent.getTheme());
			    mix.title = title;
				this.nm.insert(newPage, parentInfo.parent, args.next);			
			}
			dojo.mixin(newPage, mix);
			return newPage;
		},
		save: function(/* object */ keywordArgs) {
			// summary: Saves the model updates
			// 		Model requests can and should be asynchronous since this returns nothing
			//		is uses callbacks.
			var scope = keywordArgs.scope || dojo.global; 
	    	var utils = com.ibm.mm.builder.utils;
			if (keywordArgs.openPageId){
				// just open an existing page, no need to save the page node.
				var newPage = this.nm.find(keywordArgs.openPageId).start();
				// create new items
				newPage.created = true;
				newPage.setID(newPage.getID());
				this._fireCreated(newPage);
				if(keywordArgs.onComplete) {keywordArgs.onComplete.call(scope);}
			}else{
				// create new items
		        var dfdOp = this.nm.commit();	
		        dfdOp.setOperationCallback( dojo.hitch(this, function(node){
					node.created = true;
			    	var es = com.ibm.mashups.services.ServiceManager.getService("eventService");
					es.broadcastEvent("com.ibm.mashups.builder.pageCreated", node.getID());
					node.setID(node.getID());
					this._fireCreated(node);
		    	}));
		    	dfdOp.setFinishedCallback(function(page, status){
					if(status >= 400) {
						// 4xx and 5xx HTTP errors
						var bundle = dojo.i18n.getLocalization("com.ibm.bundles", "Theme");
						var statusMessage = new com.ibm.widgets.StatusMessage("error", bundle["dnd_move_failed"], "");
						dojo.publish("/message/status",[{message: statusMessage, uid: 'ibmStatusBox'}]);
					}
		    		if(keywordArgs.onComplete) {keywordArgs.onComplete.call(scope);}
		    	});
		        dfdOp.start(false);
				if(this._isDirty){
					// update dirty items
		        	this.nm.commit().start(false);
		        	this._isDirty = false;
		        	if(keywordArgs.onComplete) {keywordArgs.onComplete(keywordArgs);}
				}			
			}
		},
		_fireCreated: function(item) {
			if(item.onCreateDefQueue && !item.onCreateDefQueue._fired) {
				try {
					item.onCreateDefQueue.fire(item);
					item.onCreateDefQueue._fired = true;
				} catch(ex) {
					// open a global page twice will lead an exception.
					console.log(ex);
				}
			}
		},
		deleteGlobalItem: function(/*Object*/args, /*item*/ item){
			// This is a fake delete item method, which only will remove global page.
			var parent = this.getParent(item);
			for (var i in this.globalPages) {
				if (this.globalPages[i].getID() == item.getID()) {
					this.globalPages.splice(i, 1);
					break;
				}
			}
	    	this.onTreeChange(null, parent, parent);
		},			
		isCreated: function(/*item*/ item) {
			// summary: Indicates whether or not the item has been created on the server and
			//		the server-generated values were properly applied to the client-side
			//		object.	NOTE: Any client-side modifications	to the values of an item for 
			// 		which isCreated returns true can potentially modify the server-generated 
			// 		values to be out-of-sync with the server.
			// 		Therefore, it's important to note that isCreated merely indicates whether
			//		or not the client-side item has a server-side resource associated with it,
			// 		and any values that the server generated for the resource (such as a unique
			return true;
		},
		addOnCreate: function(/*item*/ item, /*Function*/ callback) {
			// summary: Register callback to be called when the given item is created on the server.
			//		If the item is already created, this will call the callback immediately.
			if(this.isCreated(item)) {
				if(callback) {callback(item);}
			}
			else {
				if(!item.onCreateDefQueue) {
					item.onCreateDefQueue = new com.ibm.lang.DeferredQueue(new dojo.Deferred());
				}
				item.onCreateDefQueue.add(new dojo.Deferred().addCallback(callback));
			}
		},
		_updateChildren: function(parentItem) {
			if(parentItem) {
				this.getChildren(parentItem, dojo.hitch(this, function(children){
					this.onChildrenChange(parentItem, children);
				}));
	        }
		},
		pasteItem: function(/*Item*/ childItem, /*Item*/ oldParentItem, /*Item*/ newParentItem, /*Boolean*/ copy, /*Item*/ nextSibling, /*Boolean?*/ extra){
	        // summary:
	        //            Move an item from one parent item to another or to another position under the same parent.
	        //            Used in drag & drop.
	        // See dojo.data.api.Write for details on args.
	        var mname = "pasteItem", lgr = this.LOGGER;
	    	lgr.entering(mname, arguments);
	        if(!this.nm.confirmInsert(childItem, newParentItem, nextSibling)) {
	        	lgr.trace("confirmInsert returns false");
	        }
	        else {
	        	lgr.trace("insert into the tree model");
		        this.nm.insert(childItem, newParentItem, nextSibling);
		        
		        // workaround so that the enabler 
				// runtime model has latest updates
				this.save({});
								
		        this.onTreeChange(childItem, oldParentItem, newParentItem, nextSibling);
		        this._updateChildren(oldParentItem);
		        this._updateChildren(newParentItem);
				// When enabler correctly updates the runtime nav model, 
				// the tree model can start to use transactions for reordering
				/*if(!this.delaySave){ 
					this.save({}); 
				} else { 
					com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true); 
				}*/
	        }
	        lgr.exiting(mname, arguments);
		},
		toString: function() {
			return "[TreeModel " + this.declaredClass + "]";
		},
		_onNew: function(item, parentInfo){
			
		},
		_onDelete: function(item){
							
		},				
		_onSet: function(/* Item */ item, /*String*/ attribute, /*Object | Array*/ oldValue, /*Object | Array*/ newValue){				
			
		},
		
		_isGlobalPage: function(item){
			for (var i in this.globalPages) {
				if (this.globalPages[i].getID() == item.getID()) {
					return true;
				}
			}
			return false;
		},

		onTreeChange: function(/*Item*/ childItem, /*Item*/ oldParentItem, /*Item*/ newParentItem, /*Item*/ nextSiblingItem) {
			
		},
		onChange: function(/*Item*/ item){
			
		},
		onChildrenChange: function(/*Item*/ parentItem, /*Array*/ items){
			
		}

});
	
})();



}

if(!dojo._hasResource["com.ibm.pb.tree.Traversal"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.tree.Traversal"] = true;
dojo.provide("com.ibm.pb.tree.Traversal");



dojo.declare("com.ibm.pb.tree.Traversal", com.ibm.pb.logging.Loggable, {
	model: null,
	constructor: function(model) {
		this.model = model;
		this.stopped = true;
	},
	isStopped: function() {
		return this.stopped;
	},
	/**
	 * Finds the first node in the tree model that meets the test criteria
	 * and calls the callback with that single node.
	 */
	find: function(node, test, callback) {
		var mname = "find", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		this.collect(node, test, function(list){
			callback(list[0]);
		}, function(params){
			return params.list.length > 0;
		});
		lgr.exiting(mname, arguments);
	},
	/**
	 * Finds all the nodes in the tree model that meet the test criteria
	 * and calls the callback with an array of those nodes.  Supports
	 * conditionally stopping at any point using a stop test function.
	 */
	collect: function(node, test, callback, stop, params) {
		var mname = "collect", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		this.stopped = false;
		if(!params) {
			params = {};
		}
		if(!params.list) {
			params.list = [];
		}
		params.level = 1;
		this.visit(node, test, callback, stop || function(){return false;}, params);
		lgr.exiting(mname, arguments);
	},
	/**
	 * Visits a particular node, performing the test condition on the
	 * node and conditionally adding it to the list of found nodes that
	 * meet the test criteria.
	 */
	visit: function(node, test, callback, stop, params) {
		var mname = "visit", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		if(test(this.model, node)) {
			lgr.trace(mname, "Found positive testing node ${0}", [node]);
			params.list.push(node);
		}
		if(stop(params)) {
			this.stopped = true;
			lgr.trace(mname, "Hard stopping traversal and calling back with results ${0}", [params.list]);
			callback(params.list);
		}
		else {
			this.next(node, test, callback, stop, params);
		}
		lgr.exiting(mname, arguments);
	},
	/**
	 * Called after a node is visited in order to find and visit the next
	 * node in the traversal sequence so long as the traversal hasn't
	 * stopped.  Unimplemented and requires extensions using a particular
	 * traversal algorithm to implement.
	 */
	next: function(node, test, callback, stop, params) {
		
	}
});

}

if(!dojo._hasResource["com.ibm.pb.tree.DFSTraversal"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.tree.DFSTraversal"] = true;
dojo.provide("com.ibm.pb.tree.DFSTraversal");



dojo.declare("com.ibm.pb.tree.DFSTraversal", com.ibm.pb.tree.Traversal, {
	next: function(node, test, callback, stop, params) {
		// visit the next node in the tree using depth-first search
		var mname = "next", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		
		var iterator = null;
		if(this.model.hasChildren(node)) {
			lgr.trace(mname, "Traversing down children of ${0}", [node]);
			var dfdParams = {
				node: node,
				test: test,
				callback: callback,
				stop: stop,
				params: params,
				list: []
			}, me = this;
			this.model.getChildren(node)
				.setForEachCallback(function(){
					me._collectChild.apply(me, arguments);
				}, dfdParams)
				.setFinishedCallback(function(){
					me._visitChildren.apply(me, arguments);
				}, dfdParams)
				.start(false);
		}
		else {
			lgr.trace(mname, "Reached end of traversal at ${0}", [node]);
			if(!this.isStopped()) {
				callback(params.list);
			}
		}
		lgr.exiting(mname, arguments);
	},
	_collectChild: function(resource, dfdParams) {
		dfdParams.list.push(resource);
	},
	_visitChildren: function(resource, status, dfdParams) {
		var mname = "_visitChildren", lgr = this.LOGGER, me = this;
		lgr.entering(mname, [resource, status, dfdParams]);
		if((status !== 200) && (status != "200")) {
			lgr.severe(mname, "An error occurred ${0} ${1}", [status, resource]);
			lgr.exiting(mname, arguments);
			return;
		}
		var subTreeCallback = function() {
			if(!me.isStopped()) {
				var currentNode = dfdParams.list.shift();
				if(currentNode) {
					me._visitChild(currentNode, dfdParams.test, subTreeCallback, dfdParams.stop, dojo.delegate(dfdParams.params, {level: dfdParams.params.level+1}));
				}
				else {
					lgr.trace(mname, "Reached end of list of children of ${0}", [dfdParams.node]);
					dfdParams.callback(dfdParams.params.list);
				}
			}
			else {
				lgr.trace(mname, "Stopped in the middle of the list of children of ${0}", [dfdParams.node]);
				dfdParams.callback(dfdParams.params.list);
			}
		}
		lgr.exiting(mname, arguments);
		subTreeCallback();
	},
	_visitChild: function(node, test, callback, stop, params) {
		var mname = "_visitChild", lgr = this.LOGGER, me = this;
		lgr.trace(mname, "Visiting next node in list of children ${0}", [node]);
		if(!this.isStopped()) {
			this.visit(node, test, callback, stop, params);
		}
		else {
			// FIXME: Stop any iterators at this point, 13729
			lgr.trace(mname, "Hard stopped iterating");
		}
	}
});

}

if(!dojo._hasResource["dojo.hash"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.hash"] = true;
dojo.provide("dojo.hash");
//TODOC: where does this go?
// summary:
//		Methods for monitoring and updating the hash in the browser URL.
//
// example:
//		dojo.subscribe("/dojo/hashchange", context, callback);
//
//		function callback (hashValue){
//			// do something based on the hash value.
// 		}

(function(){
	dojo.hash = function(/* String? */ hash, /* Boolean? */ replace){
		//	summary:
		//		Gets or sets the hash string.
		//	description:
		//		Handles getting and setting of location.hash.
		//		 - If no arguments are passed, acts as a getter.
		//		 - If a string is passed, acts as a setter.
		//	hash: 
		//		String: the hash is set - #string.
		//	replace:
		//		Boolean: If true, updates the hash value in the current history 
		//			state instead of creating a new history state.
		//	returns:
		//		when used as a getter, returns the current hash string.
		//		when used as a setter, returns the new hash string.
		
		// getter
		if(!arguments.length){
			return _getHash();
		}
		// setter
		if(hash.charAt(0) == "#"){
			hash = hash.substring(1);
		}
		if(replace){
			_replace(hash);
		}else{
			location.href = "#" + hash;
		}
		return hash; // String
	}

	// Global vars
	var _recentHash = null,
		_ieUriMonitor = null,
		_pollFrequency = dojo.config.hashPollFrequency || 100;

	//Internal functions
	function _getHash(){
		var h = location.href, i = h.indexOf("#");
		return (i >= 0) ? h.substring(i + 1) : "";
	}

	function _dispatchEvent(){
		dojo.publish("/dojo/hashchange", [_getHash()]);
	}

	function _pollLocation(){
		if(_getHash() === _recentHash){
			return;
		}
		_recentHash = _getHash();
		_dispatchEvent();
	}
	
	function _replace(hash){
		if(_ieUriMonitor){
			if(_ieUriMonitor.isTransitioning()){
				setTimeout(dojo.hitch(null,_replace,hash), _pollFrequency);
				return;
			}
			var href = _ieUriMonitor.iframe.location.href;
			var index = href.indexOf('?');
			// main frame will detect and update itself
			_ieUriMonitor.iframe.location.replace(href.substring(0, index) + "?" + hash);
			return;
		}
		location.replace("#"+hash);
		_pollLocation();
	}

	function IEUriMonitor(){
		// summary:
		//		Determine if the browser's URI has changed or if the user has pressed the 
		//		back or forward button. If so, call _dispatchEvent.
		//
		//	description:
		//		IE doesn't add changes to the URI's hash into the history unless the hash
		//		value corresponds to an actual named anchor in the document. To get around
		//      this IE difference, we use a background IFrame to maintain a back-forward
		//		history, by updating the IFrame's query string to correspond to the
		//		value of the main browser location's hash value.
		//
		//		E.g. if the value of the browser window's location changes to
		//
		//		#action=someAction
		//
		//		... then we'd update the IFrame's source to:
		//
		//		?action=someAction
		//
		//		This design leads to a somewhat complex state machine, which is
		//		described below:
		//
		//		s1: Stable state - neither the window's location has changed nor
		//			has the IFrame's location. Note that this is the 99.9% case, so
		//			we optimize for it.
		//			Transitions: s1, s2, s3
		//		s2: Window's location changed - when a user clicks a hyperlink or
		//			code programmatically changes the window's URI.
		//			Transitions: s4
		//		s3: Iframe's location changed as a result of user pressing back or
		//			forward - when the user presses back or forward, the location of
		//			the background's iframe changes to the previous or next value in
		//			its history.
		//			Transitions: s1
		//		s4: IEUriMonitor has programmatically changed the location of the
		//			background iframe, but it's location hasn't yet changed. In this
		//			case we do nothing because we need to wait for the iframe's
		//			location to reflect its actual state.
		//			Transitions: s4, s5
		//		s5:	IEUriMonitor has programmatically changed the location of the
		//			background iframe, and the iframe's location has caught up with
		//			reality. In this case we need to transition to s1.
		//			Transitions: s1
		//
		//		The hashchange event is always dispatched on the transition back to s1.
		//

		// create and append iframe
		var ifr = document.createElement("iframe"),
			IFRAME_ID = "dojo-hash-iframe",
			ifrSrc = dojo.config.dojoBlankHtmlUrl || dojo.moduleUrl("dojo", "resources/blank.html");
		ifr.id = IFRAME_ID;
		ifr.src = ifrSrc + "?" + _getHash();
		ifr.style.display = "none";
		document.body.appendChild(ifr);

		this.iframe = dojo.global[IFRAME_ID];
		var recentIframeQuery, transitioning, expectedIFrameQuery, docTitle, ifrOffline,
			iframeLoc = this.iframe.location,
			winLoc = dojo.global.location;

		function resetState(){
			_recentHash = winLoc.hash;
			recentIframeQuery = ifrOffline ? _recentHash : iframeLoc.search;
			transitioning = false;
			expectedIFrameQuery = null;
		}

		this.isTransitioning = function(){
			return transitioning;
		}
		
		this.pollLocation = function(){
			if(!ifrOffline) {
				try{
					iframeLoc.search;  //see if we can access the iframe without a permission denied error
					//good, the iframe is same origin (no thrown exception)
					if(document.title != docTitle){ //sync title of main window with title of iframe.
						docTitle = this.iframe.document.title = document.title;
					}
				}catch(e){
					//permission denied - server cannot be reached.
					ifrOffline = true;
					console.error("dojo.hash: Error adding history entry. Server unreachable.");
				}
			}
			if(transitioning && _recentHash === winLoc.hash){
				// we're in an iframe transition (s4 or s5)
				if(ifrOffline || iframeLoc.search === expectedIFrameQuery){
					// s5 (iframe caught up to main window or iframe offline), transition back to s1
					resetState();
					_dispatchEvent();
				}else{
					// s4 (waiting for iframe to catch up to main window)
					setTimeout(dojo.hitch(this,this.pollLocation),0);
					return;
				}
			}else if(_recentHash === winLoc.hash && (ifrOffline || recentIframeQuery === iframeLoc.search)){
				// we're in stable state (s1, iframe query == main window hash), do nothing
			}else{
				// the user has initiated a URL change somehow.
				// sync iframe query <-> main window hash
				if(_recentHash !== winLoc.hash){
					// s2 (main window location changed), set iframe url and transition to s4
					_recentHash = winLoc.hash;
					transitioning = true;
					expectedIFrameQuery = "?" + _getHash();
					ifr.src = ifrSrc + expectedIFrameQuery;
					ifrOffline = false;	//we're updating the iframe src - set offline to false so we can check again on next poll.
					setTimeout(dojo.hitch(this,this.pollLocation),0); //yielded transition to s4 while iframe reloads.
					return;
				}else if(!ifrOffline){
					// s3 (iframe location changed via back/forward button), set main window url and transition to s1.
					winLoc.href = "#" + iframeLoc.search.substring(1);
					resetState();
					_dispatchEvent();
				}
			}
			setTimeout(dojo.hitch(this,this.pollLocation), _pollFrequency);
		}
		resetState(); // initialize state (transition to s1)
		setTimeout(dojo.hitch(this,this.pollLocation), _pollFrequency);
	}
	dojo.addOnLoad(function(){
		if("onhashchange" in dojo.global && (!dojo.isIE || (dojo.isIE >= 8 && document.compatMode != "BackCompat"))){	//need this IE browser test because "onhashchange" exists in IE8 in IE7 mode
			dojo.connect(dojo.global,"onhashchange",_dispatchEvent);
		}else{
			if(document.addEventListener){ // Non-IE
				_recentHash = _getHash();
				setInterval(_pollLocation, _pollFrequency); //Poll the window location for changes
			}else if(document.attachEvent){ // IE7-
				//Use hidden iframe in versions of IE that don't have onhashchange event
				_ieUriMonitor = new IEUriMonitor();
			} 
			// else non-supported browser, do nothing.
		}
	});
})();

}

if(!dojo._hasResource["com.ibm.pb.control.NavigationController"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.control.NavigationController"] = true;
dojo.provide("com.ibm.pb.control.NavigationController");












/**
 * The NavigationController is meant to be a singleton object retrieved via the
 * com.ibm.pb.control.NavigationController.getController API.  It is responsible
 * for managing global navigation state and model information by providing access
 * to a dijit.tree.model implementation representing the navigation model.  It
 * also provides a selection model implementation that is mapped over top of the 
 * tree model and provides semantics as to the selection path from the currently
 * selected node in the navigation model up to the navigation root node.  These
 * constructs provide suitable models for backing interface widgets and for managing
 * public navigation selection events such as SWITCH_PAGE and PAGE_SWITCHED.  This
 * module provides logic for handling page switches both explicitly and via navigation
 * state changes.  It determines the correct context, updates the state, fires
 * the appropriate internal events to its selection model and tree model, and fires
 * the PAGE_SWITCHED event on successful selection changes.
 */
// not an iWidget, but uses the iWidget base for convenient provision of member variables
dojo.declare("com.ibm.pb.control.NavigationController", com.ibm.pb.iwidget.iWidgetBase, {
	
	navigationConstants: com.ibm.mashups.enabler.navigation.Constants,
	accFactory: com.ibm.mashups.enabler.model.state.AccessorFactory,
	treeModel: null,
	selectionModel: null,
	_changingSelection:false,
	currentThemeTemplate: "",

	// these fields are used for global page support
	lastNonGlobalPageId: null, // the last non-global page at any given time	
	lastSpaceId: null,  // the space being shown before the most recent update to the navigation
	globalPageLoadedSpaceId: null, // the space where global pages are opened		
	globalPagesOpened: [],   // the ids of the global pages currently showing
	globalPagesOpenedBy: [],   // the ids of the pages that opened each of the global pages currently showing

	constructor: function(){
		var lgr = this.LOGGER, mname = "constructor";
		lgr.entering(mname, arguments);
		this.themeBundle = dojo.i18n.getLocalization("com.ibm.bundles", "Theme");
		this.navWidgetBundle = dojo.i18n.getLocalization("com.ibm.bundles", "NavWidget");
		this.nm = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel();
		this.nsm = com.ibm.mashups.enabler.model.state.NavigationStateModelFactory.getNavigationStateModel();
		this.spm = com.ibm.mashups.enabler.space.Factory.getSpaceModel();
		this.spaceAcc = this.accFactory.getSpaceAccessor(this.nsm);
		this.nm.addStrategy(new com.ibm.mashups.enabler.strategy.TreeLoadAheadStrategy(10, 1));	// 10 parents up, 1 level of children
		this.nm.addStrategy(new com.ibm.mashups.enabler.strategy.ListLoadAheadStrategy(50));	// 50 children at a time
		
		this.treeModel = new com.ibm.pb.data.EnablerNavigationTreeModel({nm: this.nm, nsm: this.nsm, spm: this.spm, delaySave: true});
		// Somewhat complex logic in getting the root, so keep it out of the tree model impl and just put it here
		this.treeModel.getRoot = dojo.hitch(this, "getRootNavigation");
		
		this.selectionModel = new com.ibm.data.SelectionModel({
			treeModel: this.treeModel,
			selectionPath: []
		});
		
		// Note: this logic was here for logging purposes but is throwing exceptions
		// in the case of global pages
//		var origChangeSelection = this.selectionModel.changeSelection;
//		this.selectionModel.changeSelection = dojo.partial(function(node){
//			lgr.trace("changeSelection", "Changing the selection model's selection ${0}", [node]);
//			return origChangeSelection.apply(this, arguments);
//		});

		// Restore global page information for cases of full page refresh
		this._restorePersistedGlobalPages();
		
		this._changingSelection = true;
		// calculate the current page asynchronously... will callback a selection model update
		this.bootstrapping = true;
		this._bootstrapState = false;
		this._calculateCurrentPage();
				
		this.evtSvc.subscribeEvent(this.iWidgetConstants.NAVSTATE_UPDATED, this, function(){
			var cbkName = "NavStateUpdatedHandler";
			lgr.entering(cbkName, arguments);
			// fetch the navigational state model again so it is not stale
			this.nsm = com.ibm.mashups.enabler.model.state.NavigationStateModelFactory.getNavigationStateModel();
			this.spaceAcc = this.accFactory.getSpaceAccessor(this.nsm);
			this.treeModel.nsm = this.nsm;
			
			var cid = this.getCurrentPageId();
			
			// Switch to the page if it is not the current page in navigation
			if(!this._changingSelection && cid !== this.currentPageId) {
				this.onSwitchPage(cid, {skipStateUpdate: true});
			}
			
			lgr.exiting(cbkName, arguments);
		});
		
		this.evtSvc.subscribeEvent(this.builderEvents.SWITCH_PAGE, this, "onSwitchPage");
		this.evtSvc.subscribeEvent(this.builderEvents.SWITCH_SPACE, this, "onSwitchSpace");
		this.evtSvc.subscribeEvent(this.builderEvents.REFRESH_NAVIGATION, this, "onRefreshNavigation");
		this.evtSvc.subscribeEvent("com.ibm.mashups.builder.saveCheck", this, "dirtyPageCheck");

        dojo.subscribe("/dojo/hashchange", this, this._processHashChange);
		
		lgr.exiting(mname, arguments);
	},
	getSelectionModel: function() {
		return this.selectionModel;
	},
	getTreeModel: function() {
		return this.treeModel;
	},
	getThemeTemplate: function(node){
		return node.getMetaData("com.ibm.portal.theme.template.file.name.html") || "";
	},
	getThemeId: function(node) {
		var themeId = node.getThemeIdentifier ? node.getThemeIdentifier() : null;
		while(!themeId && node) {
			node = this.nm.getParent(node).start();
			themeId = (node && node.getThemeIdentifier) ? node.getThemeIdentifier() : null;
		}
		if(!themeId) {
			themeId = this.runtimeModel.getCurrentTheme();
		}
		return themeId.getID();
	},
	getRenderMode: function(node) {
		var renderType = node.getMetaData("com.ibm.portal.rendertype") || null;
		while(!renderType && node) {
			node = this.nm.getParent(node).start();
			if(node) {
				renderType = node.getMetaData("com.ibm.portal.rendertype") || null;
			}
		}
		return renderType || ibmConfig.defaultRenderingMode;
	},
	_visibleChildFinder: function(node){
		// Find the first visible child of the node
		var mname = "_visibleChildFinder";
		this._findFirstVisible(node, dojo.hitch(this, function(child){
			if(child && !(child instanceof Error)) {
				this._setCurrentNavNode(child);
			}
			else {
				this.LOGGER.severe(mname, "Error finding a visible child of navigation node ${0}: ${1}", [node, child]);
			}
		}));
	},
	_isNavLabel: function(model, node) {
		return node.getNavigationElementType() === this.navigationConstants.NAVIGATION_LABEL;
	},
	/**
	 * Sets the current navigation node of the controller internally, and updates any models
	 * and state information accordingly.
	 */
	_setCurrentNavNode: function(node, semantics) {
		// Set the current navigation node
		var mname = "_setCurrentNavNode", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		this.currentNavNode = node;
		this.currentPageId = node.getID();
		if(this.bootstrapping) {
			this.renderMode = this.getRenderMode(node);
			this.bootstrapping = false;
		}
		this.currentThemeTemplate = this.getThemeTemplate(node);
		// Walk up the tree to load the ancestors asynchronously, if not already loaded
		// which will finally update the selection model at the end
		this._walkUpTree(node);
		this._updateNavigationState(this.currentPageId, semantics);
		if(this.renderMode === "iwidget") {
			// the title is set by theme markup or during initialization code;
			// this is meant primarily for client-side page changes
			this.setBrowserTitle(node);
		}
		lgr.exiting(mname, arguments);
	},
	_calculateCurrentPage: function() {
		var mname = "_calculateCurrentPage", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		var currentPageId = this.getCurrentPageId();
		if(!currentPageId) {
			this._bootstrapState = true;
			currentPageId = this.runtimeModel.getCurrentPage().getID();
		}
		else {
			this._bootstrapState = false;
			lgr.trace(mname, "Got current page from the navigation state", []);
		}
		if(!currentPageId) {
			// If we don't currently have a current page, then calculate it by loading the root
			// of the current navigation, which will load the root navigation node of the current
			// space we're in, or the default space if we're not in one.
			lgr.trace(mname, "No runtime model of current page, getting root navigation", []);
			this.treeModel.getRoot(dojo.hitch(this, "_visibleChildFinder"), dojo.hitch(this, function(err){
				lgr.severe(mname, "Error getting root navigation node ${0}", [err]);
			}));
		}
		else {
			lgr.trace(mname, "Found current page id ${0}", [currentPageId]);
			
			if (currentPageId && com.ibm.mm.builder.utils.spaceUtil.getSpaceIdByPageId(currentPageId)!=this.globalPageLoadedSpaceId
			  && !this._isOpenedGlobalPage(currentPageId)){
				// clear the global pages, as this initial page is in a different space from the one where the pages were opened
				this.onClearGlobalPage();
			}
			
			this.nm.find(currentPageId)
				.setFinishedCallback(dojo.hitch(this, function(node, status, params){
					if(status == 200) {
						this.refresh(node.getID());
					}
					else {
						// defect 16786: There will be page ID in the cookie, and such page won't be found in next install.
						// So in this case, we refresh the navigation with the nav root
						lgr.trace(mname, "Error finding the current page with id ${0} ${1}", [currentPageId, node||""]);
						var navRootID = this.nm.getRoot().start().getID();
						var spaceID = com.ibm.mm.builder.utils.spaceUtil.getSpaceIdByPageId(navRootID);
						com.ibm.mm.builder.utils.spaceUtil.setSpaceId(spaceID);
						this.refresh(navRootID);
					}
				}))
				.start(false);
		}
		lgr.exiting(mname, arguments);
	},
	_walkUpTree: function(navNode) {
		// Recursively walks up the tree from the navNode until the root is reached
		// Finally internally updates the selection model with the current navigation node
		var mname = "_walkUpTree", lgr = this.LOGGER;
		if(navNode) {
			var dfd = this.nm.getParent(navNode).setFinishedCallback(
				// walk up the tree asynchronously to guarantee all the ancestors are loaded before
				// firing the selection model update
				dojo.hitch(this, "_walkUpTree"));
			dfd.start(false);
		} 
		else {
			lgr.trace(mname, "Updating selection to ${0}", [this.currentNavNode.getID()]);
			this.selectionModel.changeSelection(this.currentNavNode);
		}
	},
	_findFirstVisible: function(parentNode, callback) {
		// Finds the first visible descendant of the given parentNode, and calls the callback
		// with that child navigation node as the argument
		var mname = "_findFirstVisible", lgr = this.LOGGER, me = this;
		lgr.entering(mname, arguments);
		var dft = new com.ibm.pb.tree.DFSTraversal(this.nm);
		dft.find(parentNode, function(model, navNode){
			return !me._isNavLabel(model, navNode) && !navNode.isHidden();
		}, function(foundNode){
			lgr.trace(mname, "Found visible non-label node ${0}, executing callback", [foundNode]);
			callback(foundNode);
		});
		lgr.exiting(mname, arguments);
	},
	getCurrentSpaceId: function() {
		var globalSpaceId = dojo.cookie(com.ibm.mm.builder.constant.cookieKey_globalPageOpenedSpaceId);
		if (globalSpaceId) {
			return globalSpaceId;
		} else {
			return this.spaceAcc.getSpaceID();
		}
	},
	getCurrentPageId: function() {
		var pageAcc = this.accFactory.getPageAccessor(this.nsm, this.spaceAcc.getSpaceID());
		return pageAcc.getPageID();
	},
	getRootNavigation: function(onItem, onError) {
		var mname = "getRootNavigation", lgr = this.LOGGER;
	    lgr.entering(mname, arguments);
		var id = this.getCurrentSpaceId(),
			params = {onItem:onItem, onError:onError};
		if(id) {
			var dfd = this.spm.find(id);
			dfd.setFinishedCallback(dojo.hitch(this, "_getRootBySpace"), params);
			dfd.start(false);
		}
		else {
			this._getRootBySpace(null, 200, params);
		}
		lgr.exiting(mname, arguments);
	},
	_getRootBySpace: function(space, status, params) {
		// This gets the root navigation node of a space, or gets the root navigation node
		// of the default space if the space argument is null.
		// Once retrieved, it calls the params.onItem function with the resulting node,
		// or the params.onError function if an error occurs at any point along the way.
		var mname = "_getRootBySpace", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		try {
			var navDfd;
			if(space) {
				navDfd = this.nm.find(space.getRootNavigation().getID());
			}
			else {
				navDfd = this.nm.getRoot();
			}
			navDfd.setFinishedCallback(dojo.hitch(this, function(navNode, statusCode){
				var cbkMname = mname + ":callback";
				lgr.entering(cbkMname, arguments);
				//lgr.trace(cbkMname, "Callback: ${0} ${1}", [navNode, statusCode]);
				
				if(navNode && !(navNode instanceof Error)) {
					this.root = navNode;
					if(params.onItem) {
						params.onItem(navNode);
					}
				}
				else if(params.onError){
					lgr.severe(cbkMname, "Error getting the root nav node in space ${0}: ${1}", [space, navNode]);
					params.onError(navNode);
				}
			}));
			lgr.trace(mname, "Finding root nav node in space ${0}", [space]);
			navDfd.start(false);
		} catch(err) {
			lgr.severe(mname, "Error starting find operation for the root nav node in space ${0}: ${1}", [space, err]);
		}
		lgr.exiting(mname, arguments);
	},
	/**
	 * Entry point for handling the SWITCH_SPACE event.
	 */
	onSwitchSpace: function(spaceId, semantics) {
		var mname = "onSwitchSpace", lgr = this.LOGGER, me = this;
		lgr.entering(mname, arguments);
		this.dirtyPageCheck(function(){
			me.switchSpaceHandler(spaceId, semantics);
		});
		lgr.exiting(mname, arguments);
	},
	switchSpaceHandler: function(spaceId, semantics) {
		var mname = "switchSpaceHandler", lgr = this.LOGGER, me = this;
		lgr.entering(mname, arguments);
		
		if (spaceId) {
			// we need to verify if the space is still in the model before we switch to it
			// in cases where the space has just been deleted and an event is sent to switch a space
			// or an invalid ID is used to send that event the enduser sees many JS exceptions
	        var spaceModel = com.ibm.mashups.enabler.space.Factory.getSpaceModel();
	    	var spaceNode = spaceModel.find(spaceId).start(true);
	    	if (!spaceNode) {
	    	    // this space node has been deleted
	    	    lgr.exiting(mname, arguments);
	        	return;
	    	}
		}

		// D18206
		// When switching spaces, check whether the currently opened page is a global page.
		// If so, need to update (fix) the pageID for the spaceID in the pageselection lookup index. 
		// At this point the pageselection for the current space will be referencing the global page.
		// If the user comes back to this space, the global page will be the one that is re-opened
		// (furthermore, the user will be taken to the space for the global page).
		// This fix here, "cleans up" the pageselection to refer back to the last non-global page
		// viewed in this space.
		if (this._isOpenedGlobalPage(this.currentPageId)) {
			this.accFactory.getPageAccessor(this.nsm, this.lastSpaceId).setPageID(this.lastNonGlobalPageId);				
		}

		if (spaceId != this.lastSpaceId){
			// clear global pages
			this.onClearGlobalPage();
		}				

		this.spaceAcc.setSpaceID(spaceId);	// set the new space so all subsequent calls will use that
		if (!spaceId) {
			dojo.cookie("inPersonalSpace", "true");
		}
		else {
			dojo.cookie("inPersonalSpace", null);
		}
		
		// get the current page from the nav state in the current space
		var pageId = this.getCurrentPageId(),
			pageNode = null;
		
		//switch to last page or first page.
		if(pageId) {
			pageNode = this.nm.find(pageId).start();
            // we need to update the navstate as setSpaceID will clear out the pageId from the navstate, so we have to set it back
            this.accFactory.getPageAccessor(this.nsm, spaceId).setPageID(pageId);
		}
		
		// if no page node was found matching that pageId
		if(!pageNode) {
			this.getRootNavigation(function(navNode){	// gets the root navigation of the current space
				me._findFirstVisible(navNode, function(firstVisibleNode){
					if(firstVisibleNode) {
						// broadcast SWITCH_PAGE to the page we've calculated
						me.evtSvc.broadcastEvent(me.builderEvents.SWITCH_PAGE, firstVisibleNode.getID());
					}
					else {
						// broadcast SWITCH_PAGE to the root page
						if(!spaceId) {
							com.ibm.mm.builder.utils.navigationUtil.autoAcceptPagesFromDefaultGroup();
						}
						me.evtSvc.broadcastEvent(me.builderEvents.SWITCH_PAGE, navNode.getID());
					}
				});
			}, function(err){
				lgr.severe(mname, "${0}", [err.message]);
			});
		}
		else {
			this.evtSvc.broadcastEvent(this.builderEvents.SWITCH_PAGE, pageId);
		}
		
		lgr.exiting(mname, arguments);
	},
	/**
	 * Entry point for handling the SWITCH_PAGE event.  The controller handles this event
	 * globally and singularly on behalf of all components that are interested in navigation
	 * selection changes.  This allows such logic to be consolidated and managed in one place.
	 * The semantics argument is optional and provides additional information which can be
	 * used by the controller during event handling.
	 */
	onSwitchPage: function(pageId, semantics){
		var mname = "onSwitchPage", lgr = this.LOGGER;
		lgr.entering(mname, arguments);

		// Mashup fix, do not refresh current page.
		if (pageId == this.currentPageId && !com.ibm.mm.builder.utils.pageUtil.isRoot(pageId)) {		
			if (this.spaceAcc.getSpaceID()!==null && this.spaceAcc.getSpaceID()!==undefined &&
			    this.lastSpaceId!==null && this.lastSpaceId!==undefined) {
				if (this.spaceAcc.getSpaceID()===this.lastSpaceId) {
					lgr.trace(mname, "skipping switchPage handling as already the current page");
					lgr.exiting(mname, arguments);
					return;
				}
			}
			else {
				lgr.trace(mname, "skipping switchPage handling as already the current page");
				lgr.exiting(mname, arguments);
				return;
			}			
		}
		// end fix

		// D18206
		// When switching a page, check if the page is a global page.
		// If it is not, remember it as the last non-global page opened.
		// The lastNonGlobalPageId variable is used in switchSpaceHandler() to set the last non-global
		// page visited in that space. 
		if (!this._isOpenedGlobalPage(pageId)) {
			this.lastNonGlobalPageId = pageId;
		}

		if (pageId && com.ibm.mm.builder.utils.spaceUtil.getSpaceIdByPageId(pageId)!=this.globalPageLoadedSpaceId
		  && !this._isOpenedGlobalPage(pageId)){
			// clear the global pages, as we've switched to a different space from the one where the pages were opened
			this.onClearGlobalPage();
		}

		this._changingSelection = true;
		
		this.nm.find(pageId).setFinishedCallback(dojo.hitch(this, "switchPageHandler"), semantics).start(false);
		
		this.lastSpaceId = this.getCurrentSpaceId();
		lgr.exiting(mname, arguments);
	},
	/**
	 * Handles the SWITCH_PAGE event to normalize the selection, potentially modifying it
	 * before updating internal models and firing the PAGE_SWITCHED event.  Takes
	 * the navigation node whose ID is equal to the payload of the SWITCH_PAGE event. 
	 */
	switchPageHandler: function(pageNode, status, semantics) {
		var mname = "switchPageHandler", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		if (this.renderMode != "iwidget") {
			// If we're in SSA mode, perform a full page refresh
			lgr.trace(mname, "Current rendertype: ${0} - performing a full page refresh", [this.renderMode]);
			this._reloadToPageWithConfirm(pageNode.getID());
		} /*** End SSA switch check ***/
		else {
			/*** Begin page node is label check ***/
			var isLabel = this._isNavLabel(this.nm, pageNode);
			lgr.trace(mname, "Is ${0} a label? ${1}", [pageNode, isLabel]);
			if(isLabel) {
				this._findFirstVisible(pageNode, dojo.hitch(this, function(node){
					if(node) {
						this.evtSvc.broadcastEvent(this.builderEvents.SWITCH_PAGE, node.getID());
					}
					else {
						lgr.trace(mname, "Could not find visible non-label descendant of ${0}, loading directly", [pageNode]);
						return this._postLabelCheck(pageNode, semantics);
					}
				}));
			} /*** End page node is label check ***/
			else {
				this._postLabelCheck(pageNode, semantics);
			}
		}	
		lgr.exiting(mname, arguments);
	},
	setLastNonGlobalPage: function() {
		var es = com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService");
		es.broadcastEvent("com.ibm.mashups.builder.switchPage", this.lastNonGlobalPageId);
		
		this.onClearGlobalPage();
	},	
	_postLabelCheck: function(pageNode, semantics) {
		var mname = "_postLabelCheck", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		/*** Begin SSA switch check ***/
		var renderType = this.getRenderMode(pageNode);
		if (renderType.toLowerCase() != "iwidget") {
			// If we are going into SSA mode, perform a full page refresh
			lgr.trace(mname, "Switched page rendertype: ${0}  - performing a full page refresh", [renderType]);
			this._reloadToPageWithConfirm(pageNode.getID());
		} /*** End SSA switch check ***/
		else {
			/*** Begin theme template check ***/
			var themeTemplate = this.getThemeTemplate(pageNode).toLowerCase();
			if (themeTemplate != this.currentThemeTemplate &&
				!((themeTemplate === "" && this.currentThemeTemplate === "theme.html") || 
				(themeTemplate === "theme.html" && this.currentThemeTemplate === ""))) {
				lgr.trace(mname, "Switched theme template from ${0} to ${1}", [this.currentThemeTemplate, themeTemplate]);
				return this._reloadToPageWithConfirm(pageNode.getID());
			} /*** End theme template  check ***/
			else {
				this.currentThemeTemplate = themeTemplate;
				/*** Begin global page check ***/				
					this._postGlobalPageCheck(pageNode, semantics);
				/*** End global page check ***/
			}
		}
		lgr.exiting(mname, arguments);
	},
	_postGlobalPageCheck: function(pageNode, semantics) {
		var mname = "_postGlobalPageCheck", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		var cb = dojo.hitch(this, function(){
			//this.isSwitching = true;
			try{
				this.refresh(pageNode.getID(), true, semantics);
			}catch(e){
				// if an error occurs during refresh, make sure we reset our _changingSelection
				// state
				this._changingSelection = false;
				lgr.severe(mname, "An error occured during page switching ${0}", [e]);
			}
			// refresh() will ensure that _changingSelection is reset appropriately when all
			// processing is completed
		});
		
		this.dirtyPageCheck(cb);
		lgr.exiting(mname, arguments);
	},
	/**
	 * Sets the browser title using the title of the pageNode as part of the new title.
	 * This is called when a SWITCH_PAGE event proceeds passed all normalization
	 * steps to ensure that a proper selection is chosen.
	 * Extensions may override this to provide custom implementations.
	 */
	setBrowserTitle: function(pageNode) {
		var mname = "setBrowserTitle", lgr = this.LOGGER;
		lgr.entering(mname, arguments);

		var pageTitle = "";
		if(this.nm.getRoot().start().getID() != pageNode.getID()) {
			pageTitle = this.treeModel.getLabel(pageNode);
		}
		var trimmedTitle =  dojo.trim(pageTitle || ""),
			pageContext = com.ibm.mashups.enabler.context.Factory.getPageContext();
		
		// use the enabler API to set the HTML page title in browser
		if (pageContext) {
			var product = this.configSvc.getValue(this.configConstants.PRODUCT_NAME);
			if(product) {
				if (!pageTitle || trimmedTitle === "") {
					pageContext.setBrowserTitle(product);
				} 
				else {
					pageContext.setBrowserTitle(pageTitle);
				}
			}
			else if(pageTitle && trimmedTitle !== ""){
				pageContext.setBrowserTitle(pageTitle);
			}
		}
		lgr.exiting(mname, arguments);
	},
	
	dirtyPageCheck: function(callback, callbackNoSave, cancelcb){
		var mname = "dirtyPageCheck", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		if(com.ibm.pb.contextMenu.sharedActions.widgetEditModeChecker()) {
			// skip the page dirty check and display another confirm dialog if there is unsaved widget
			lgr.exiting(mname, arguments);
			return;
		}
		if(this.runtimeModel.getCurrentPage().isDirty()){
			lgr.trace(mname, "Page is dirty, display confirmation dialog", []);
			var cws = com.ibm.mm.builder.coreWidgetsStrings;
			/* Late lazy load */
			dojo["require"]("com.ibm.mm.builder.dialog.PageSaveConfirmDialog");
			var saveConfirmDlg = new com.ibm.mm.builder.dialog.PageSaveConfirmDialog({
		        contentWarning: cws.I_PAGE_SAVE_WARNING,
		        contentQuestion: cws.I_PAGE_SAVE_SUGGEST,
		        btnSaveText: cws.I_COMMON_SAVE,
		        btnNotSaveText: cws.I_PAGE_SAVE_NO_SAVE,
		        btnCancelText: cws.I_PAGE_SAVE_KEEP_EDIT,
		        hideNotSave: true,
		        callbackSave: callback,
		        callbackNotSave: callbackNoSave,
				callbackCancel: cancelcb
		    });
		    saveConfirmDlg.show();
		}else{
			lgr.trace(mname, "Page is NOT dirty, callback immediately", []);
			if(callback) callback();
		}
		lgr.exiting(mname, arguments);
	},
	_reloadToPageWithConfirm: function(pageId) {
		var cb = dojo.hitch(this, this.reloadToPage, pageId);
		this.dirtyPageCheck(cb);
	},
	reloadToPage: function(pageId) {
		var mname = "reloadToPage", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		var pageNode = this.nm.find(pageId).start();
		if(pageNode) {
			this._setCurrentNavNode(pageNode);
		}
		var redirectAddress = com.ibm.mashups.enabler.model.state.UrlGeneratorFactory.getUrlGenerator().getUrl(this.nsm, null, {skipState: true, pocURI: "nm:oid:"+pageId});
		lgr.trace(mname, "Navigating to URL immediately ${0}", [redirectAddress]);
		lgr.exiting(mname, arguments);
        
        // set the pageID cookie
        com.ibm.mm.builder.utils.navigationUtil.setPageIDCookie(pageId);

		var oldAddress = top.location.href;
		top.location.href = redirectAddress;
		if(this._removeHash(oldAddress) == this._removeHash(redirectAddress)) {
			setTimeout(function() {
				// if we simply changed the hash, then setting the location before won't force a page refresh
				// so we force it here, attempting to minimize performance hit by getting from cache if possible
				top.location.reload(false);
			}, 50);
		}
	},
	_removeHash:function(s){
		var hash = s.indexOf("#");
		if(hash >= 0) {
			s = s.substring(0,hash);
		}
		return s;
	},
	onRefreshNavigation:function(){
		this.LOGGER.entering("onRefreshNavigation", arguments);
		try{
			this.refresh();
		}catch(e){
			var msg = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.E_NAV_REFRESH_NAVIGATION_1,[e.message]);
			this.LOGGER.severe("onRefreshNavigation",msg);
			setTimeout(function(){
				throw e;	// the window can catch this and handle it outside our execution thread
			}, 1);
		}
		this.LOGGER.exiting("onRefreshNavigation", arguments);
	},
	/**
	 * Refreshes the navigation selection in the controller, potentially changing it
	 * depending on the value of the pid parameter.
	 */
	refresh: function(pid, isPageSwitch, semantics){
		var mname = "refresh", lgr = this.LOGGER, me = this, node, contentNode, spaceId = this.getCurrentSpaceId();
		lgr.entering(mname, arguments);
		if(pid) {
			// check if we have bootstrapped before and have a current page set already
			if(!this.bootstrapping) {
				/*** begin theme change check ***/
				lgr.trace(mname, "Checking for theme change");
				var currentThemeID = this.runtimeModel.getCurrentTheme().getID();
				var pageNode = this.nm.find(pid).start();
				if (pageNode && this.getThemeId(pageNode) != currentThemeID) {
					lgr.trace(mname, "Theme changed!");
					var cb = dojo.hitch(this, this.reloadToPage, pid);
					this.dirtyPageCheck(cb);
					lgr.exiting(mname, arguments);
					// don't set this._changingSelection to false because we're doing a full page refresh
					// and want it to stick until the browser reloads
					return;
				}
				/*** end theme change check ***/
			}
			else {
				// We're actually bootstrapping, so don't act like we're switching pages from an already selected page
				if(!semantics) {
					semantics = {};
				}
				semantics.skipStateUpdate = !this._bootstrapState;
				lgr.trace(mname, "Bootstrapping to current page ${0}", [pid]);
			}
		}
		else {
			pid = this.getCurrentPageId();
			if(!pid){
				lgr.trace(mname, "Find the first visible page from the current root");
				this.getRootNavigation(function(item){
					lgr.trace(mname, "Initiate page switch to ${0}", item);
					me.refresh(me.treeModel.getIdentity(item), isPageSwitch);
				}, function(err){
					this._changingSelection = false;
					lgr.severe(mname, "Error getting root navigation ${0}", err.message);
					setTimeout(function(){throw err;}, 1);
				});
				lgr.exiting(mname, arguments);
				return;
			}
		}
		// defect 16614
		// if the we are in nav root, we need to find whether there is child page visible
		// this page can be added from shares or hub
		var navRoot = this.nm.getRoot().start();
		if(pid == navRoot.getID()) {
            var interruptProcessing = false;
			this._findFirstVisible(navRoot, dojo.hitch(this, function(child){
				if(child && !(child instanceof Error)) {
                    interruptProcessing = true;
					this.onSwitchPage(child.getID());
					return;
				}
			}));
            if (interruptProcessing) {
                // we already found the correct page and initiated a page switch, no need to continue
                lgr.exiting(mname, arguments);
                return;
            }
		}
		
		// the nav must be reloaded on every refresh because deleting 
		// a page is handled the same as switching the page.  Since there
		// is no way to tell whether a page has been deleted we must
		// reload the nav to make sure the page is removed from the markup.
		// This will be fixed once Mashups created a deletePage iEvent.		
		if(pid){
			lgr.trace(mname, "Reloading navigation");
			node = this.nm.find(pid).start();
			if(node) {
				// node may have been deleted
				this._setCurrentNavNode(node, semantics);
			}
		}
		this._changingSelection = false;
		if(isPageSwitch) {
	        var nsm = com.ibm.mashups.enabler.model.state.NavigationStateModelFactory.getNavigationStateModel();        
			lgr.trace(mname, "Setting timeout to fire page switched event later");
			setTimeout(dojo.hitch(this, function(){
				lgr.trace(mname, "Sending page switched event");
				this.runtimeModel.getCurrentPage().setDirty(false);
				this.evtSvc.broadcastEvent(this.builderEvents.PAGE_SWITCHED, pid);
			}), 50);
		}
		lgr.exiting(mname, arguments);
	},
	/**
	 * The optional semantics arguments allows additional semantic information to be provided
	 * in paths where custom logic is required based on the context and circumstances.
	 * 
	 * The skipStateUpdate property specifies whether or not the state should be updated when
	 * the controller sets the current nav node.  The reason for this is because this function may
	 * be fired by listening to the SWITCH_PAGE event, in which case the navigation state
	 * should be updated by the controller.  Alternatively, this function may be called 
	 * on a path where the controller detects a NAVSTATE_UPDATED event separate
	 * from a SWITCH_PAGE event, but detects that the selection has changed as part of that
	 * state change.  In that case, the controller should not update the state since it
	 * has already been updated and the controller is merely synchronizing its internal
	 * models to reflect the new state.  If skipStateUpdate is true, then this does NOT
	 * update the navigation state.
	 */
	_updateNavigationState: function(pageId, semantics){
		var mname = "_updateNavigationState", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		this.runtimeModel.getCurrentPage().setID(pageId);
		if(!semantics || !semantics.skipStateUpdate) {
			// Do not update the navigation state if semantics.skipStateUpdate is truthy
			var spaceId = com.ibm.mm.builder.utils.spaceUtil.getSpaceIdByPageId(pageId);
			if (spaceId !== com.ibm.mm.builder.utils.spaceUtil.getCurrentSpaceId()) {
				com.ibm.mm.builder.utils.spaceUtil.setSpaceId(spaceId);
			}
			this.accFactory.getPageAccessor(this.nsm, spaceId).setPageID(pageId);
			this.navigationStateUpdated = true; // for testing in _processHashChange, to avoid firing page switch			
			this.nsm.commit({addToHistory: true}).start();
		}
		lgr.exiting(mname, arguments);
	},	
	
	onOpenPage: function(iEvent){
		var mname = "onOpenPage", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		// there are two kinds of payload format for ievent com.ibm.mashups.builder.openPage
		// 1. payload is a string : the page id, just switch to the page.
		// 2. payload is a JSON object : {"pid":"123456",eventsArray:{{"targetEvent": targetEvent1, "payload": payload1, "payloadType": payloadType1},{"targetEvent": targetEvent2, "payload": payload2, "payloadType": payloadType2}}}
		var openPageId = null;
		if (iEvent.payload.pid){
			openPageId = iEvent.payload.pid;	
		}else{
			openPageId = iEvent.payload;
		}
		var es = com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService");
		es.broadcastEvent("com.ibm.mashups.builder.saveCheck", dojo.hitch(this,function(){
			var mname = "onOpenPage_saveCheck", lgr = this.LOGGER;
			lgr.entering(mname, arguments);
			if (this._isOpenedGlobalPage(openPageId)) {
				// if the global page is already opened, switch to it and reload it.
			}else{
				// otherwise this is a new global page, not currently open
				this.lastVisitedPage = com.ibm.mm.builder.utils.pageUtil.getCurrentPageId();
				if (this.lastSpaceId) {
					this.globalPageLoadedSpaceId = this.lastSpaceId;
				} else {
					this.globalPageLoadedSpaceId = this.getCurrentSpaceId();
				}
				this._addToGlobalPages(openPageId, this.lastVisitedPage);
				//create new tab in the tabbed navigation, and navigate to the new tab, with event broadcast to the page.
				var openPage = com.ibm.mm.builder.utils.pageUtil.getPageNode(openPageId);
				var globalSpaceRoot = com.ibm.mm.builder.utils.navigationUtil.getNavigationRootNode(this.globalPageLoadedSpaceId);
				var args = { 
					title:openPage.getTitle(dojo.locale),
					pageLoadedSpaceId:this.globalPageLoadedSpaceId,
					openPageId: openPageId
				};
				if (iEvent.payload.pid){
					args.eventsArray = iEvent.payload.eventsArray;
					args.lastVisitedPage = this.lastVisitedPage;
				}
				this.treeModel.newGlobalItem(args, globalSpaceRoot);
				lgr.trace(mname, "Broadcasting refreshNavigation event");
				es.broadcastEvent("com.ibm.mashups.builder.refreshNavigation");
			}
			setTimeout(dojo.hitch(this, function(){
				lgr.trace("onOpenPage_Timeout", "Broadcasting switch page event");
				if (iEvent.payload.eventsArray) {
					es.broadcastEvents(iEvent.payload.eventsArray, com.ibm.mm.builder.utils.pageUtil.getCurrentPageId(), openPageId);
				} else {
					es.broadcastEvent("com.ibm.mashups.builder.switchPage", openPageId);
				}
			}), 50);
			lgr.exiting(mname, arguments);
		}));	
		lgr.exiting(mname, arguments);
	},
	
	onClosePage: function(iEvent){
		var mname = "onClosePage", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		var closePageId = null;
		if (iEvent.payload) {
			if (iEvent.payload.closePageId) {
				closePageId = iEvent.payload.closePageId;
			} else if (!iEvent.payload.eventsArray) {
				closePageId = iEvent.payload;
			}
		}
		if (!closePageId) {
			closePageId = com.ibm.mm.builder.utils.pageUtil.getCurrentPageId();
		}
		if (!this._isOpenedGlobalPage(closePageId)){
			console.log("Error: you are closing a global page not opened now!");
			return;
		}
		var es = com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService");
		es.broadcastEvent("com.ibm.mashups.builder.saveCheck", dojo.hitch(this,function(){
			var mname = "onClosePage_saveCheck", lgr = this.LOGGER;
			lgr.entering(mname, arguments);
			// go to last visited non-global page
			var openedPage = com.ibm.mm.builder.utils.pageUtil.getPageNode(closePageId);
			var args = {
				"lastVisitedPage": this._getGlobalPageOpenedBy(closePageId)
			};
			if (iEvent.payload && iEvent.payload.openPagePayload){
				args.openPagePayload = iEvent.payload.openPagePayload;
			}
			this._removeFromGlobalPages(closePageId);
			this.treeModel.deleteGlobalItem(args,openedPage);
			this.evtSvc.publishEvent(this.builderEvents.REFRESH_NAVIGATION);
			setTimeout(dojo.hitch(this, function(){
				lgr.trace("onClosePage_Timeout", "Broadcasting switch page event");
				if (args.openPagePayload){
					// do not switch to the last visited non-global page, we will open another global page instead.		
					es.broadcastEvent("com.ibm.mashups.builder.openPage", args.openPagePayload);
				}else{
					if (iEvent.payload && iEvent.payload.eventsArray) {
						es.broadcastEvents(iEvent.payload.eventsArray, null, args.lastVisitedPage, this.globalPageLoadedSpaceId);
					} else {
						es.broadcastEvent("com.ibm.mashups.builder.switchPage", args.lastVisitedPage);
					}
				}
			}), 50);	
			lgr.exiting(mname, arguments);
		}));
		lgr.exiting(mname, arguments);
	},
	
	onClearGlobalPage:function(){
		var mname = "onClearGlobalPage", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		for (var i in this.globalPagesOpened) {
			var openedPage = com.ibm.mm.builder.utils.pageUtil.getPageNode(this.globalPagesOpened[i]);
			var args = {"lastVisitedPage":this.lastVisitedPage};
			this.treeModel.deleteGlobalItem(args,openedPage);
		}
		this.globalPagesOpened = [];
		this.globalPagesOpenedBy = [];
		this.globalPageLoadedSpaceId = null;		
		dojo.cookie(com.ibm.mm.builder.constant.cookieKey_globalPageId, null, {expires: -1});
		dojo.cookie(com.ibm.mm.builder.constant.cookieKey_globalPageOpenedSpaceId, null, {expires: -1});
		dojo.cookie(com.ibm.mm.builder.constant.cookieKey_previous_pid, null, {expires: -1});
		lgr.exiting(mname, arguments);
	},
	
	_isOpenedGlobalPage: function(pageId){
		for (var i in this.globalPagesOpened) {
			if (this.globalPagesOpened[i] == pageId) {
				return true;
			}
		}
		return false;
	},
	
	_addToGlobalPages: function(pageId, openerPageId) {
		// find the index of the page to be deleted
		var pageIndex = -1;
		for (var i in this.globalPagesOpened) {
			if (this.globalPagesOpened[i] == pageId) {
				pageIndex = i;
			}
		}
		if (pageIndex >= 0) { // page already opened, just update info
			this.globalPagesOpened[pageIndex] = pageId;
			this.globalPagesOpenedBy[pageIndex] = openerPageId;
		} else { // new global page
			this.globalPagesOpened.push(pageId);
			this.globalPagesOpenedBy.push(openerPageId);
		}
		this._persistGlobalPages();
	},
	
	_removeFromGlobalPages: function(pageId){
		// find the index of the page to be deleted
		var pageIndex = -1;
		for (var i in this.globalPagesOpened) {
			if (this.globalPagesOpened[i] == pageId) {
				pageIndex = i;
			}
		}
		if (pageIndex >= 0) {
			// If there are any global pages that were opened by this global page, update
			// the opened by so they would return to the opener of this (deleted) global page
			for (var i in this.globalPagesOpened) {
				if (this.globalPagesOpenedBy[i] == pageId) {
					this.globalPagesOpenedBy[i] = this.globalPagesOpenedBy[pageIndex];
				}
			}
			// delete the page
			this.globalPagesOpened.splice(pageIndex, 1);
			this.globalPagesOpenedBy.splice(pageIndex, 1);
		}
		this._persistGlobalPages();
	},
	
	_getGlobalPageOpenedBy: function(pageId) {
		for (var i in this.globalPagesOpened) {
			if (this.globalPagesOpened[i] == pageId) {
				return this.globalPagesOpenedBy[i];
			}
		}
		return null;
	},
	
	_persistGlobalPages: function(){
		dojo.cookie(com.ibm.mm.builder.constant.cookieKey_globalPageId,dojo.toJson(this.globalPagesOpened));
		dojo.cookie(com.ibm.mm.builder.constant.cookieKey_previous_pid,dojo.toJson(this.globalPagesOpenedBy));
		dojo.cookie(com.ibm.mm.builder.constant.cookieKey_globalPageOpenedSpaceId,this.globalPageLoadedSpaceId);
	},
	
	_restorePersistedGlobalPages: function(){
		if (dojo.cookie(com.ibm.mm.builder.constant.cookieKey_globalPageOpenedSpaceId)) {
			this.globalPagesOpened = dojo.fromJson(dojo.cookie(com.ibm.mm.builder.constant.cookieKey_globalPageId));
			this.globalPagesOpenedBy = dojo.fromJson(dojo.cookie(com.ibm.mm.builder.constant.cookieKey_previous_pid));
			this.globalPageLoadedSpaceId = dojo.cookie(com.ibm.mm.builder.constant.cookieKey_globalPageOpenedSpaceId);
			for (var i in this.globalPagesOpened) {
				var openedPage = com.ibm.mm.builder.utils.pageUtil.getPageNode(this.globalPagesOpened[i]);
				var globalSpaceRoot = com.ibm.mm.builder.utils.navigationUtil.getNavigationRootNode(this.globalPageLoadedSpaceId);
				var args = { 
					title:openedPage.getTitle(dojo.locale),
					pageLoadedSpaceId:this.globalPageLoadedSpaceId,
					openPageId: this.globalPagesOpened[i]
				};
				this.treeModel.newGlobalItem(args, globalSpaceRoot);
			}
		}
	},
	
	_processHashChange: function(/*string*/hash) {
		var mname = "_processHashChange", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		if (!this.navigationStateUpdated) {
			var hashDec = decodeURIComponent(hash);
			var hashObj = dojo.queryToObject(hashDec);
			if (hashObj.pid) {
				var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
				eventService.publishEvent(com.ibm.mashups.builder.iEvents.SWITCH_PAGE, hashObj.pid);
			}
		}
		this.navigationStateUpdated = false;
		lgr.exiting(mname, arguments);
	},

	onUnLoad: function(){
		var mname = "onUnLoad", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
	    if (this.tabNavigation) {
			this.tabNavigation.destroy();
	        this.tabNavigation = null;
	    }
	    lgr.exiting(mname, arguments);
	}
	
});

(function(){
	var controller = null;
	com.ibm.pb.control.NavigationController.getController = function() {
		if(!controller) {
			controller = new com.ibm.pb.control.NavigationController();
		}
		return controller;
	};
})();

}

if(!dojo._hasResource["dojo.io.script"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.io.script"] = true;
dojo.provide("dojo.io.script");

/*=====
dojo.declare("dojo.io.script.__ioArgs", dojo.__IoArgs, {
	constructor: function(){
		//	summary:
		//		All the properties described in the dojo.__ioArgs type, apply to this
		//		type as well, EXCEPT "handleAs". It is not applicable to
		//		dojo.io.script.get() calls, since it is implied by the usage of
		//		"jsonp" (response will be a JSONP call returning JSON)
		//		or the response is pure JavaScript defined in
		//		the body of the script that was attached.
		//	callbackParamName: String
		//		Deprecated as of Dojo 1.4 in favor of "jsonp", but still supported for
		// 		legacy code. See notes for jsonp property.
		//	jsonp: String
		//		The URL parameter name that indicates the JSONP callback string.
		//		For instance, when using Yahoo JSONP calls it is normally, 
		//		jsonp: "callback". For AOL JSONP calls it is normally 
		//		jsonp: "c".
		//	checkString: String
		//		A string of JavaScript that when evaluated like so: 
		//		"typeof(" + checkString + ") != 'undefined'"
		//		being true means that the script fetched has been loaded. 
		//		Do not use this if doing a JSONP type of call (use callbackParamName instead).
		//	frameDoc: Document
		//		The Document object for a child iframe. If this is passed in, the script
		//		will be attached to that document. This can be helpful in some comet long-polling
		//		scenarios with Firefox and Opera.
		this.callbackParamName = callbackParamName;
		this.jsonp = jsonp;
		this.checkString = checkString;
		this.frameDoc = frameDoc;
	}
});
=====*/
;(function(){
	var loadEvent = dojo.isIE ? "onreadystatechange" : "load",
		readyRegExp = /complete|loaded/;

	dojo.io.script = {
		get: function(/*dojo.io.script.__ioArgs*/args){
			//	summary:
			//		sends a get request using a dynamically created script tag.
			var dfd = this._makeScriptDeferred(args);
			var ioArgs = dfd.ioArgs;
			dojo._ioAddQueryToUrl(ioArgs);
	
			dojo._ioNotifyStart(dfd);

			if(this._canAttach(ioArgs)){
				var node = this.attach(ioArgs.id, ioArgs.url, args.frameDoc);

				//If not a jsonp callback or a polling checkString case, bind
				//to load event on the script tag.
				if(!ioArgs.jsonp && !ioArgs.args.checkString){
					var handle = dojo.connect(node, loadEvent, function(evt){
						if(evt.type == "load" || readyRegExp.test(node.readyState)){
							dojo.disconnect(handle);
							ioArgs.scriptLoaded = evt;
						}
					});
				}
			}

			dojo._ioWatch(dfd, this._validCheck, this._ioCheck, this._resHandle);
			return dfd;
		},
	
		attach: function(/*String*/id, /*String*/url, /*Document?*/frameDocument){
			//	summary:
			//		creates a new <script> tag pointing to the specified URL and
			//		adds it to the document.
			//	description:
			//		Attaches the script element to the DOM.  Use this method if you
			//		just want to attach a script to the DOM and do not care when or
			//		if it loads.
			var doc = (frameDocument || dojo.doc);
			var element = doc.createElement("script");
			element.type = "text/javascript";
			element.src = url;
			element.id = id;
			element.charset = "utf-8";
			return doc.getElementsByTagName("head")[0].appendChild(element);
		},
	
		remove: function(/*String*/id, /*Document?*/frameDocument){
			//summary: removes the script element with the given id, from the given frameDocument.
			//If no frameDocument is passed, the current document is used.
			dojo.destroy(dojo.byId(id, frameDocument));
			
			//Remove the jsonp callback on dojo.io.script, if it exists.
			if(this["jsonp_" + id]){
				delete this["jsonp_" + id];
			}
		},
	
		_makeScriptDeferred: function(/*Object*/args){
			//summary: 
			//		sets up a Deferred object for an IO request.
			var dfd = dojo._ioSetArgs(args, this._deferredCancel, this._deferredOk, this._deferredError);
	
			var ioArgs = dfd.ioArgs;
			ioArgs.id = dojo._scopeName + "IoScript" + (this._counter++);
			ioArgs.canDelete = false;
	
			//Special setup for jsonp case
			ioArgs.jsonp = args.callbackParamName || args.jsonp;
			if(ioArgs.jsonp){
				//Add the jsonp parameter.
				ioArgs.query = ioArgs.query || "";
				if(ioArgs.query.length > 0){
					ioArgs.query += "&";
				}
				ioArgs.query += ioArgs.jsonp
					+ "="
					+ (args.frameDoc ? "parent." : "")
					+ dojo._scopeName + ".io.script.jsonp_" + ioArgs.id + "._jsonpCallback";
	
				ioArgs.frameDoc = args.frameDoc;
	
				//Setup the Deferred to have the jsonp callback.
				ioArgs.canDelete = true;
				dfd._jsonpCallback = this._jsonpCallback;
				this["jsonp_" + ioArgs.id] = dfd;
			}
			return dfd; // dojo.Deferred
		},
		
		_deferredCancel: function(/*Deferred*/dfd){
			//summary: canceller function for dojo._ioSetArgs call.
	
			//DO NOT use "this" and expect it to be dojo.io.script.
			dfd.canceled = true;
			if(dfd.ioArgs.canDelete){
				dojo.io.script._addDeadScript(dfd.ioArgs);
			}
		},
	
		_deferredOk: function(/*Deferred*/dfd){
			//summary: okHandler function for dojo._ioSetArgs call.
	
			//DO NOT use "this" and expect it to be dojo.io.script.
			var ioArgs = dfd.ioArgs;
	
			//Add script to list of things that can be removed.		
			if(ioArgs.canDelete){
				dojo.io.script._addDeadScript(ioArgs);
			}
	
			//Favor JSONP responses, script load events then lastly ioArgs.
			//The ioArgs are goofy, but cannot return the dfd since that stops
			//the callback chain in Deferred. The return value is not that important
			//in that case, probably a checkString case.
			return ioArgs.json || ioArgs.scriptLoaded || ioArgs;
		},
	
		_deferredError: function(/*Error*/error, /*Deferred*/dfd){
			//summary: errHandler function for dojo._ioSetArgs call.
	
			if(dfd.ioArgs.canDelete){
				//DO NOT use "this" and expect it to be dojo.io.script.
				if(error.dojoType == "timeout"){
					//For timeouts, remove the script element immediately to
					//avoid a response from it coming back later and causing trouble.
					dojo.io.script.remove(dfd.ioArgs.id, dfd.ioArgs.frameDoc);
				}else{
					dojo.io.script._addDeadScript(dfd.ioArgs);
				}
			}
			console.log("dojo.io.script error", error);
			return error;
		},
	
		_deadScripts: [],
		_counter: 1,
	
		_addDeadScript: function(/*Object*/ioArgs){
			//summary: sets up an entry in the deadScripts array.
			dojo.io.script._deadScripts.push({id: ioArgs.id, frameDoc: ioArgs.frameDoc});
			//Being extra paranoid about leaks:
			ioArgs.frameDoc = null;
		},
	
		_validCheck: function(/*Deferred*/dfd){
			//summary: inflight check function to see if dfd is still valid.
	
			//Do script cleanup here. We wait for one inflight pass
			//to make sure we don't get any weird things by trying to remove a script
			//tag that is part of the call chain (IE 6 has been known to
			//crash in that case).
			var _self = dojo.io.script;
			var deadScripts = _self._deadScripts;
			if(deadScripts && deadScripts.length > 0){
				for(var i = 0; i < deadScripts.length; i++){
					//Remove the script tag
					_self.remove(deadScripts[i].id, deadScripts[i].frameDoc);
					deadScripts[i].frameDoc = null;
				}
				dojo.io.script._deadScripts = [];
			}
	
			return true;
		},
	
		_ioCheck: function(/*Deferred*/dfd){
			//summary: inflight check function to see if IO finished.
			var ioArgs = dfd.ioArgs;
			//Check for finished jsonp
			if(ioArgs.json || (ioArgs.scriptLoaded && !ioArgs.args.checkString)){
				return true;
			}
	
			//Check for finished "checkString" case.
			var checkString = ioArgs.args.checkString;
			if(checkString && eval("typeof(" + checkString + ") != 'undefined'")){
				return true;
			}
	
			return false;
		},
	
		_resHandle: function(/*Deferred*/dfd){
			//summary: inflight function to handle a completed response.
			if(dojo.io.script._ioCheck(dfd)){
				dfd.callback(dfd);
			}else{
				//This path should never happen since the only way we can get
				//to _resHandle is if _ioCheck is true.
				dfd.errback(new Error("inconceivable dojo.io.script._resHandle error"));
			}
		},
	
		_canAttach: function(/*Object*/ioArgs){
			//summary: A method that can be overridden by other modules
			//to control when the script attachment occurs.
			return true;
		},
		
		_jsonpCallback: function(/*JSON Object*/json){
			//summary: 
			//		generic handler for jsonp callback. A pointer to this function
			//		is used for all jsonp callbacks.  NOTE: the "this" in this
			//		function will be the Deferred object that represents the script
			//		request.
			this.ioArgs.json = json;
		}
	}
})();

}

if(!dojo._hasResource["com.ibm.pb.iwidget.control"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.iwidget.control"] = true;
dojo.provide("com.ibm.pb.iwidget.control");

(function(){
	var mashiWidget = com.ibm.mashups.iwidget,
		iwidgetConstants = mashiWidget.Constants,
		eventService = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.iwidget.services.EventService.SERVICE_NAME),
		globalIWidgetModel = mashiWidget.model.Factory.getGlobalWidgetModel();
		
	com.ibm.pb.iwidget.control = {
		onLoad: function(id, cb) {
			// if id is not null, look up the iwidget in the global iwidget model with that
			// id and wait till its loaded before calling the callback function
			if(id) {
				var iWidgetWrapper = globalIWidgetModel.find(id);
				if(iWidgetWrapper) {
					if(iWidgetWrapper.isLoaded() === false) {
						var me = this;
						eventService.subscribeEvent(iwidgetConstants.WIDGET_LOADED + "." + id, null, function(){
								cb(iWidgetWrapper);
							});
						return;
					}
					else {
						cb(iWidgetWrapper);
						// we don't need to callback twice
						return;
					}
				}
			}
			cb();
		}				
	}
	var iCtl = com.ibm.pb.iwidget.control;
})();

}

if(!dojo._hasResource["com.ibm.pb.control.RenderingController"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.control.RenderingController"] = true;
dojo.provide("com.ibm.pb.control.RenderingController");






// not an iWidget, but uses the iWidget base for convenient provision of member variables
dojo.declare("com.ibm.pb.control.RenderingController", com.ibm.pb.iwidget.iWidgetBase, {	
	MINIMIZE_CLASS: "ibm-minimized",
	MAXIMIZE_CLASS: "ibm-maximized",
	HIDDEN_CONTAINER_NAME: "ibmHiddenWidgets",
	
	PRERENDER_BUFFER_ID: "ibmPreRenderBuffer",
	MAXIMIZE_BUFFER_ID: "ibmMaximizeBuffer",
	MAXIMIZE_PLACEHOLDER_ID: "ibmMaximizePlaceHolder",
	
	STYLE_METADATA: "colorPalette",
	INITIAL_STYLE_ID: "initial",
	PAGE_STYLE_METADATA: "pageStyle",
	PAGE_STYLE_ID: "ibmPageStyleLink",
	
	widgetAccessor: null,
	navStateModel: null,
	maximizeBuffer: null,
	preRenderBuffer: null,
	layoutContainers: null,
	activeElement: null,
	layoutParser: com.ibm.pb.layout.LayoutParser,
	
	modeWidgets: {},

	constructor: function(){
		var lgr = this.LOGGER, mname = "constructor";
		lgr.entering(mname, arguments);
		this.navStateModel = com.ibm.mashups.enabler.model.state.NavigationStateModelFactory.getNavigationStateModel();
		this.navModel = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel();
		this.evtSvc.subscribeEvent(this.iWidgetConstants.CHANGE_WIDGETWINDOWSTATE, this, this.onWidgetWindowStateChange);
		this.evtSvc.subscribeEvent("com.ibm.mashups.builder.preRenderProcess", this, this.onPreRenderProcess);
		this.evtSvc.subscribeEvent("com.ibm.mashups.builder.layoutRefresh", this, this.onLayoutRefresh);
		this.configService = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
		this.layoutContainers = dojo.byId("layoutContainers");
        // TODO: Why are the widgets not parsed when outside lotusFrame?  Issue with lotusMain usage is if client does not include it in their theme.
        this.preRenderBuffer = dojo.create("div", {id: this.PRERENDER_BUFFER_ID, style:{position: "absolute", top: "-9999px"} }, dojo.byId("lotusMain"), "last");
		this.layoutContainersDefaultY = parseInt(dojo.coords(this.layoutContainers).y);
		this.doCheckNewPage();
		lgr.exiting(mname, arguments);
	},
	boostrapPreRenderProcess: function(){
		// summary: used at bootstrap to process window states before rendering layout
		var mname="boostrapPreRenderProcess", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		
		try {
			/* START test for non-content node */
				var pageId = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
				var nm = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel();
				var page = nm.find(pageId).start();
				if(page && page.getNavigationElementType() == com.ibm.mashups.enabler.navigation.Constants.NAVIGATION_LABEL) {
					var defaultLabelContent = this.configService.getValue("labelDefaultRuntimeContent");
					if(defaultLabelContent) {
						if(dojo.isFunction(defaultLabelContent)) {
							defaultLabelContent = defaultLabelContent(pageId);
						}
						this.layoutContainers.innerHTML = defaultLabelContent;
						this.layoutContainers.className = "ibmLayoutContainers";
						lgr.exiting(mname, arguments);
						return;
					}
			  	} /* END test for non-content node */
			  	
		  		/* Normal content page handling */
				this._setActiveElement();
				
		        this.processControls(this.layoutContainers,true);
		        dojo.removeClass(this.layoutContainers, "ibmLayoutContainersHidden");
		        //page.primeServerRuntimeContent(this.layoutContainers);	// skip priming for now
		        if(this.activeElement){ 
			        this._setActiveElementFocus();
		        }	  			
		} catch (e) {
			console.log(e)
		}

		lgr.exiting(mname, arguments);
	},
	onPreRenderProcess: function(iEvent){
		// summary: used during page switches to process window states before rendering layout
		var mname="onPreRenderProcess", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		
		//this._setActiveElement(); has errors and halts execution in IE
		
		this.preRenderBuffer.innerHTML = iEvent.markup;
		
		var pageId = this.runtimeModel.getCurrentPage().getID();
		var page = this.navModel.find(pageId).start();
		
		// ************************************************
		// * THIS ACTIVATES PRIMING                       *
		// * YOU CAN DEACTIVATE IT IN THE CONFIGURATION   *
		if(ibmConfig["com.ibm.mashups.priming.enabled"] && 
			page.getNavigationElementType() == com.ibm.mashups.enabler.navigation.Constants.NAVIGATION_PAGE &&
			!iEvent.id && 
			this.runtimeModel.getCurrentPage().getPageMode() == com.ibm.mashups.enabler.model.state.PageModeAccessor.VIEW){
			// Priming is enabled, the page is a regular navigation node and we are doing a full layout refresh and we are in view mode
			console.info("activating Optimus Prime, savior of performance and killer of the Requesticons!");
			page.primeServerRuntimeContent(this.preRenderBuffer);			
		}
		// * END PRIMING ACTIVATION                        *
		// *************************************************
		
		this.processControls(this.preRenderBuffer,!iEvent.id);
		
		if(this.activeElement){ 
			this._setActiveElementFocus();
		}
		

		var transitionName = page.getMetaData('transition');
		var transitionFn = null;
		if (ibmCfg && ibmCfg.themeConfig && ibmCfg.themeConfig.transitions){
			if (transitionName){
				transitionFn = ibmCfg.themeConfig.transitions[transitionName];
			} else {
				transitionFn = ibmCfg.themeConfig.transitions[ibmCfg.themeConfig.transitions.fallback];
			}
		}
        this.evtSvc.broadcastEvent("com.ibm.mashups.builder.preRenderComplete", { "id": iEvent.id, "markupDivId":  this.PRERENDER_BUFFER_ID, "fn": transitionFn} ); 
		
        this.doChangeStyle();
		
		this.doCheckNewPage();
		
		lgr.exiting(mname, arguments);
	},
	processControls: function(node,addMaxBuffer){
		// summary: after markup has been set in pre-render buffer,
		//			the controls are processed
		// node: the node that contains the layout controls, 
		//		 all OOB cases it is the pre-render buffer
		// addMaxBuffer: true if the maximize buffer should be
		//		 		 created inside the given node
		//				 will be false when refreshing only a single
		//				 container or control
		var mname="processControls", lgr = this.LOGGER;
		lgr.entering(mname, arguments);

		var controls = new Array();
		var widgetAccessor = null;
        
        var pid = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
        var layoutAccessor = com.ibm.mashups.enabler.model.state.AccessorFactory.getLayoutAccessor(this.navStateModel, pid);
        var navstateTemplateUrl = layoutAccessor.getTemplateURL();

		// if there is no Navstate template URL 
		// or if it is different from the Instance template URL
		// then don't apply the widget size, they are invalid
        var honorNavStateWidgetSizes = false;
        if (navstateTemplateUrl) {
            // get the page instance layout template url
            var navNode = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel().find(pid).start(true);
            var content = navNode.getContent().start(true);
            var instanceTemplateUrl = content.getMetaData("com.ibm.portal.layout.template.ref");
            honorNavStateWidgetSizes = (navstateTemplateUrl == instanceTemplateUrl);
        }
		
		// clean the maximizeBuffer since we're processing fresh controls
		// reuse it when we refresh a single control (change skin, etc)
		if(this.maximizeBuffer && addMaxBuffer) {
			dojo.destroy(this.maximizeBuffer);
		}
		// create a new maximizeBuffer, hide it completely, and put it at the end of the container node we're processing
		// that way anything that's inside the maximizeBuffer will be included in any processing by other components
		// such as a live text invocation against the node we're processing
		if(addMaxBuffer) {
			this.maximizeBuffer = dojo.create("div", {id: this.MAXIMIZE_BUFFER_ID, style:{position: "absolute", top: "-9999px"} }, dojo.byId("lotusMain"), "last");
		}
		
		// restore the layoutContainers height if set by maximize
		if (this.layoutContainers.style.height.length > 0) {
			this.layoutContainers.style.height = "";
		}
		
		// disconnect the onresize event if it is connected
		if (this.onBrowserResizeHandler) {
			dojo.disconnect(this.onBrowserResizeHandler);
		}
		
		// gather window states of the controls
		dojo.forEach(
		    dojo.query(".component-control", node),
		    function(control){
				var cid = this.layoutParser.extractID(control);
				var id = cid; // we can assume that window ID and control ID are always the same, even in live preview
				widgetAccessor = com.ibm.mashups.enabler.model.state.AccessorFactory.getWidgetAccessor(this.navStateModel, id);
				controls.push({node: control, id: id, state: widgetAccessor.getWindowState(), size: widgetAccessor.getSize()});
		    }, 
			this);

		// process widget size
		if (honorNavStateWidgetSizes) {
	        dojo.forEach(
	                controls,
	                function(control){
	                    if(control.size){
	                        this._processWidgetSize(control.node, control.size);
	                    }
	                }, 
	                this);
		}

		// process minimized controls
		dojo.forEach(
		    controls,
		    function(control){
				if(control.state == "minimize"){
					this._processMinimize(control.node);
				}
		    }, 
			this);
		
		// process a maximized control
		dojo.forEach(
		    controls,
		    function(control){
				if(control.state == "maximize"){
					this._processMaximize(control.node, node);
				}
		    }, 
			this);
		
		// extend the sandboxed widget height to 100%
		dojo.forEach(
			dojo.query(".iw-iWidget[sandbox='true']", node),
			function(sandboxed){
				dojo.addClass(sandboxed,"extendediwiWidget");
			}
		);
		// #17713 memory leak for each DIV:component-control if not applied
		// remove the nodes that ref to the dom node that will be removed shortly
		for (var i=0, l=controls.length; i<l; i++) {
			controls[i].node = null;
			controls[i] = null;
		}
		controls.length = 0;
		
		lgr.exiting(mname, arguments);
	},
	addModeWidgets: function(mode, widgetIds) {
		if(!this.modeWidgets[mode]) {
			this.modeWidgets[mode] = [];
		}
		this.modeWidgets[mode].push.apply(this.modeWidgets[mode], widgetIds);
	},
	changePageMode: function(mode, cb) {
		var page = this.runtimeModel.getCurrentPage(),
			currentMode = page.getPageMode(), 
			me = this;
		if(mode && mode != currentMode) {
			var editModeLoadedAsynchronously = ( typeof ibmCfg.themeConfig.editModeJSURL !== "undefined" );
			var changeModeWork = function() {
				var widgetIds = me.modeWidgets[mode];
				var cmCbk = function() {
					me.evtSvc.broadcastEvent("com.ibm.mashups.builder.changePageMode", mode);
					page.setPageMode(mode);
					if(cb) {
						cb();
					}
				}
				
				if ( editModeLoadedAsynchronously && !me.editModeInitialized ) { 
						com.ibm.themes.PageBuilder2.initEditMode();
						me.editModeInitialized = true;
					}
				
				if(widgetIds && !widgetIds.loaded && widgetIds.length > 0) {
					
					var count = widgetIds.length,
						decrFunc = function() {
							if(--count <= 0) {
								widgetIds.loaded = true;
								cmCbk();
							}
						};
					dojo.forEach(widgetIds, function(widgetId){
						this.onLoad(widgetId, decrFunc);
					}, com.ibm.pb.iwidget.control);
				}
				else {
					cmCbk();
				}
			}
			
			if ( editModeLoadedAsynchronously && !this.editModeInitialized ) {
				dojo.io.script.get({
					url: ibmCfg.themeConfig.editModeJSURL,
					checkString: "com.ibm.pb.PB2EditModeLoadedFlag",
					load: changeModeWork
				});
			} else {
				changeModeWork();
			}
		}
	},
	onLayoutRefresh: function(iEvent){
		// summary: restore any widgets so that the layout can refresh normally
		//			if this is not done, the page area will show the layout twice after the user restores the widget
		//			layout is refreshed (for example) after adding content or changing the layout of a CSA page
		// iEvent: stores these values: [containerId]
		if(this.widgetAccessor && this.widgetAccessor.getWindowState() == this.widgetAccessor.MAX) {
			this.evtSvc.publishEvent(this.iWidgetConstants.CHANGE_WIDGETWINDOWSTATE, {id: this.widgetAccessor.wid, newWindowState: this.widgetAccessor.NORMAL, oldWindowState: this.widgetAccessor.MAX});
		}
	},
	onWidgetWindowStateChange: function(iEvent){
		// summary: process widget window state change (maximize, minimize, restore)
		// iEvent: stores these values: [id, newWindowState, oldWindowState]
		var mname="onWidgetWindowStateChange", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		
		this.widgetAccessor = com.ibm.mashups.enabler.model.state.AccessorFactory.getWidgetAccessor(this.navStateModel, iEvent.id);
		this.currentWidget = this.layoutParser.findById(iEvent.controlId);

		switch(iEvent.newWindowState){
			case this.widgetAccessor.MIN:
			  this.doMinimize(iEvent);
			  break;
			case this.widgetAccessor.MAX:
			  this.doMaximize(iEvent);
			  break;
			default:
			  this.doRestore(iEvent);
		}
		
		lgr.exiting(mname, arguments);
	},
	doMinimize: function(widgetInfo){
		var mname="doMinimize", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		
		this.widgetAccessor.setWindowState(this.widgetAccessor.MIN);
		if(widgetInfo.oldWindowState == this.widgetAccessor.MAX){
			this._removeMaximize(this.currentWidget);
		}
		this._processMinimize(this.currentWidget);
		
		this._updateNavStateModel(widgetInfo);
	
		lgr.exiting(mname, arguments);
	},
	doMaximize: function(widgetInfo){
		var mname="doMaximize", lgr = this.LOGGER;
		lgr.entering(mname, arguments);

		this.widgetAccessor.setWindowState(this.widgetAccessor.MAX);
		
		if(widgetInfo.oldWindowState == this.widgetAccessor.MIN){
			this._removeMinimize(this.currentWidget);
		}
		
		// need the _setActiveElement/_setActiveElementFocus pair because _processMaximize
		// manipulates the DOM (and potentially the focus to fix an IE bug) so that
		// the focus is the same after this call
		this._setActiveElement();
		this._processMaximize(this.currentWidget, this.layoutContainers);
		if(this.activeElement){ 
			this._setActiveElementFocus();
		}
		
		var lc = this._getLayoutControl(this.layoutParser.extractID(this.currentWidget));
		var css_style = lc.getMetadata("css-style");
		
		if(this.isFreeform() || css_style) {
			this._processMaximizeFreeform(this.currentWidget);
		}
		
		this._updateNavStateModel(widgetInfo);
		
		lgr.exiting(mname, arguments);
	},
	doRestore: function(widgetInfo){
		var mname="doRestore", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		
		this.widgetAccessor.setWindowState(this.widgetAccessor.NORMAL);

		if(widgetInfo.oldWindowState == this.widgetAccessor.MIN){
			this._removeMinimize(this.currentWidget);
		}else if(widgetInfo.oldWindowState == this.widgetAccessor.MAX){
			this._removeMaximize(this.currentWidget);			
		}
		
		var lc = this._getLayoutControl(this.layoutParser.extractID(this.currentWidget));
		var css_style_backup = lc.getMetadata("css-style-backup");
		
		if(this.isFreeform() || css_style_backup) {
			this._processRestoreFreeform(this.currentWidget);
		}
		
		this._updateNavStateModel(widgetInfo);
		
		lgr.exiting(mname, arguments);
	},
	doCheckNewPage: function(){
		// summary: go into edit mode automatically when switching to blank pages
		var mname="doCheckNewPage", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		if(ibmCfg.themeConfig.autoEditNewPages && dojo.query(".component-control",this.layoutContainers).length == 0){
			lgr.trace(mname, "Going into edit mode on a blank page");
			this.changePageMode("edit");
		}
		lgr.exiting(mname, arguments);
	},
	doChangeStyle: function(id){
		// summary: changes the styles on page switched
		// id: id of the page
		var mname="doChangeStyle", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		
		var nm = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel();
		var pid = id || com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
		var pageRef = nm.find(pid);
		pageRef.setFinishedCallback(dojo.hitch(this, function(page){
			this._processPageStyle(page.getMetaData(this.PAGE_STYLE_METADATA));
			var contentRef = page.getContent();
			contentRef.setFinishedCallback(dojo.hitch(this, function(content){
				this._findAggregatedColorPalette(nm, content, page);
			}));
			contentRef.start(false);
		}));
		pageRef.start(false);
		
		lgr.exiting(mname, arguments);
	},
	_processPageStyle: function(url){
		// summary: changes the assigned page style
		// url: url to page stylesheet
		var mname="_processPageStyle", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		
		var link = dojo.byId(this.PAGE_STYLE_ID),
			head = document.getElementsByTagName("head")[0];
		if(link){
			head.removeChild(link);
			delete link;
		}
		if(url){
			var newLink = dojo.create("link",{type:"text/css",id:this.PAGE_STYLE_ID,rel:"stylesheet",href:url,media:"screen"});
			head.appendChild(newLink);
		}
		
		lgr.exiting(mname, arguments);
	},
	_processColorPalette: function(url){
		// summary: changes the color palette style from the shelf on the page
		// url: url to color palette stylesheet
		var mname="_processColorPalette", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		
		
		var csc = com.ibm.pb.customize.enabler.ChangeStyleController;
		var title = this.INITIAL_STYLE_ID;
		if(url){
			title = url.substring(url.lastIndexOf("/")+1);
		}
		dojo.hitch(csc, "_switchStylesheet", title, url)();
		ibmCfg.portalConfig.aggregatedStyle = url;
		dojo.publish("com.ibm.pb.customize.pageStyleChanged",[url]);  // alert the customize shelf of the style change
		
		lgr.exiting(mname, arguments);
	},
	_findAggregatedColorPalette: function(navModel, content, page){
		// summary: climbs the navigation model to find the aggregated color palette page style
		// navModel: the navigation model
		// content: the content of the current page on which the color palette is set, or a label
		// page: the page associated with the content, or a label
		var style = content.getMetaData(this.STYLE_METADATA);
		if(style) {
			this._processColorPalette(style);
		} else {
			var parentDef = navModel.getParent(page);
			parentDef.setFinishedCallback( dojo.hitch(this, function(parent){
				if(!parent){
					this._processColorPalette(null);
				} else if(parent.getContent){
					var contentDef = parent.getContent();
					contentDef.setFinishedCallback( dojo.hitch(this,function(content){
						this._findAggregatedColorPalette(navModel, content, parent);
					}));
					contentDef.start(false);
				} else {  // parent is not a page so does not have a corresponding content node
					this._findAggregatedColorPalette(navModel, parent, parent);
				}
			}));
			parentDef.start(false);
		}
	},
	_processWidgetSize: function(node, size){
		if (size.w) {
			dojo.style(node, "width", size.w);
		}
		if (size.h) {
			dojo.style(node, "height", size.h);
		}
	},
	_processMinimize: function(currentWidget){
		// summary: minimize a widget
		// currentWidget: widget to minimize
		var mname="_processMinimize", lgr = this.LOGGER;
		lgr.entering(mname, arguments);

		var widgetID = this.layoutParser.extractID(currentWidget);
		var minimizeBufferDiv = dojo.byId(widgetID+"_minimizebuffer");
		if (!minimizeBufferDiv) {
    		minimizeBufferDiv = dojo.create("div", {id: widgetID+"_minimizebuffer", style:{display: "none"} }, currentWidget, "first");
    	}
		dojo.style(minimizeBufferDiv, "height", currentWidget.style.height);
		dojo.addClass(currentWidget, this.MINIMIZE_CLASS);
		dojo.style(currentWidget, "height", null);

		lgr.exiting(mname, arguments);
	},
	_processMaximize: function(currentWidget, container){
		// summary: make a widget maximized and 
		//			store other controls in maximized buffer
		// currentWidget: widget to maximize
		// container: the container to place the maximized widget
		var mname="_processMaximize", lgr = this.LOGGER;
		lgr.entering(mname, arguments);

		var containerHeight = dojo.contentBox(container).h;
		// find the maximize buffer in the container
		this.maximizeBuffer = dojo.byId(this.MAXIMIZE_BUFFER_ID);
		
		dojo.addClass(currentWidget, this.MAXIMIZE_CLASS);
		dojo.create("div", {id: this.MAXIMIZE_PLACEHOLDER_ID, style:{display: "none"} }, currentWidget, "after");
		if(dojo.isIE){
			// IE has a bug where moving an ancestor node of the current focused node
			// causes the focus to mess up on things like text input fields such that
			// even though they appear focused, the user cannot type in them.
			// The fix is to focus another node before manipulating the DOM of the ancestor.
			// In both doMaximize and boostrapPreRenderProcess we save the current focus
			// and then set it back afterwards.
			container.focus();
		}
		// #19446 we also need to consider the resizer
		var nodes = dojo.query("> DIV", container);
		for(var i=0,j=nodes.length; i<j; i++) {
			var node = nodes[i];
			if(dojo.hasClass(node, "component-container") || dojo.hasClass(node, "component-container-resizer")) {
				this.maximizeBuffer.appendChild(node);
			}
		}
		dojo.place(currentWidget, container, "last");	
		
		// # 18798
		this._maximizeWidget(currentWidget, true);
		this.onBrowserResizeHandler = dojo.connect(window, "onresize", this, "_onBrowserResize");
		
		lgr.exiting(mname, arguments);
	},
	
	_onBrowserResize: function() {
		//console.log("_onBrowserResize");
		var maxWidget = dojo.query("."+this.MAXIMIZE_CLASS, this.layoutContainers)[0];
		this._maximizeWidget(maxWidget, false);
	},
	
	_maximizeWidget: function(currentWidget, keepOldWidgetHeight) {
		var containerY = dojo.coords(this.layoutContainers).y;
		if (containerY < 0) {
			containerY = this.layoutContainersDefaultY;
		}
		var windowH = this._getWindowHeight();
		var containerHeight = windowH - containerY;
		this.layoutContainers.style.height = containerHeight + "px";
		
		var controlHeight = dojo.contentBox(currentWidget).h;
		var widgetBody = dojo.query(".lotusWidgetBody", currentWidget)[0];
		var bodyBox = dojo.contentBox(widgetBody);
		var bodyHeight = bodyBox.h;
		if (keepOldWidgetHeight) {
			if (bodyHeight > 0) {
				this.maxWidgetStore = {controlHeight: controlHeight+"px", bodyHeight: bodyHeight+"px"};
				
			}
		}
		var maxControlHeight = containerHeight - 25;
		var maxBodyHeight;
		if ((bodyHeight > 0) || (!this.maxWidgetStore)) {
			maxBodyHeight = maxControlHeight - (controlHeight - bodyHeight);
		}
		else {
			maxBodyHeight = maxControlHeight - (parseInt(this.maxWidgetStore["controlHeight"]) - parseInt(this.maxWidgetStore["bodyHeight"]));
		}
		
		currentWidget.style.height = maxControlHeight + "px";
		widgetBody.style.height = maxBodyHeight + "px";
		
		var changes = {newHeight: maxBodyHeight,newWidth:bodyBox.w};
		var widgetID = this.layoutParser.extractID(currentWidget);
		this.evtSvc.publishEvent(com.ibm.mashups.iwidget.Constants.RESIZE_WIDGET + "." + widgetID, changes);
	},
	
	_getWindowHeight: function() {
		if (dojo.isIE) {
			return document.documentElement.offsetHeight || document.body.offsetHeight;
		} else {
			return window.innerHeight;
		}
	},
	
	_removeMinimize: function(widget){
		var mname="_removeMinimize", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		
		var widgetID = this.layoutParser.extractID(widget);
		var minimizeBufferDiv = dojo.byId(widgetID+"_minimizebuffer");
		if (minimizeBufferDiv) {
			dojo.style(widget, "height", minimizeBufferDiv.style.height);
			dojo.style(minimizeBufferDiv, "height", null);
		}
		dojo.removeClass(widget, this.MINIMIZE_CLASS);
		
		lgr.exiting(mname, arguments);
	},
	_removeMaximize: function(widget){
		var mname="_removeMaximize", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		
		dojo.removeClass(widget, this.MAXIMIZE_CLASS);
		var placeHolder = dojo.byId(this.MAXIMIZE_PLACEHOLDER_ID);
		if(placeHolder){
			placeHolder.parentNode.replaceChild(widget, placeHolder);
			var nodes = dojo.query("> DIV", dojo.byId(this.MAXIMIZE_BUFFER_ID));
			for (var i = 0, j = nodes.length; i < j; i++) {
				var node = nodes[i];
				if (dojo.hasClass(node, "component-container") || dojo.hasClass(node, "component-container-resizer")) {
					this.layoutContainers.appendChild(node);
					if (dojo.hasClass(node, "component-container")) {
						dojo.publish("/com/ibm/mashups/livetext/livetextchanged", [node, true]);
					}
				}
			}
		}
		
		// #18798
		this.layoutContainers.style.height = "";
		widget.style.height = this.maxWidgetStore["controlHeight"];
		var widgetBody = dojo.query(".lotusWidgetBody", widget)[0];
		widgetBody.style.height = this.maxWidgetStore["bodyHeight"];
		dojo.disconnect(this.onBrowserResizeHandler);
		
		lgr.exiting(mname, arguments);
	},
	_setActiveElement: function(){
		if(document.activeElement){ 
			this.activeElement = document.activeElement; 
		}
	},
	_setActiveElementFocus: function(){
		if (this.activeElement.nodeName == "IFRAME") {
			return;  // do not try to set focus on an iframe, avoid "Permission denied" errors in IE
		}
		this.activeElement.focus(); 
		this.activeElement = null;
	},
	_updateNavStateModel: function(widgetInfo){
		var mname="_updateNavStateModel", lgr = this.LOGGER;
		lgr.entering(mname, arguments);	

		this.evtSvc.publishEvent(com.ibm.mashups.iwidget.Constants.WIDGET_WINDOWSTATECHANGED, {id: widgetInfo.id, oldWindowState: widgetInfo.oldWindowState, newWindowState: widgetInfo.newWindowState});			
		this.navStateModel.commit().start();

		lgr.exiting(mname, arguments);
	},
	
	////////////////// For freeform /////////////////////////////////////
	isFreeform: function() {
		return dojo.query(".ibmFreeform", this.layoutContainers).length > 0 ? true : false;
	},
	
	_getLayoutControl: function(id) {
		var pageId = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
		var navModel = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel();
		var pageNode = navModel.find(pageId).start();
		var layoutModel = navModel.getLayoutModel(pageNode);
		return layoutModel.find(id).start();
	},
	
	_processMaximizeFreeform: function(currentWidget) {
		var mname="_processMaximizeFreeform", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		
		// backup the original style metadata
		var widgetID = this.layoutParser.extractID(currentWidget);
		var lc = this._getLayoutControl(widgetID);
		var css_style = lc.getMetadata("css-style");
		// no wrapper-css-style in the latest build
		lc.removeMetadata("css-style");
		lc.setMetadata("css-style-backup", css_style);
		
		// remove the absolute positions
		currentWidget.style.position = "";
		currentWidget.style.left = "";
		currentWidget.style.top = "";
		currentWidget.style.height = "";
		currentWidget.style.width = "";
		
		lgr.exiting(mname, arguments);
	},
	
	_processRestoreFreeform: function(currentWidget) {
		var mname="_processRestoreFreeform", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		
		// restore the original style metadata
		var widgetID = this.layoutParser.extractID(currentWidget);
		var lc = this._getLayoutControl(widgetID);
		var css_style = lc.getMetadata("css-style-backup");
		lc.removeMetadata("css-style-backup");
		lc.setMetadata("css-style", css_style);
		if (css_style) {
			// restore the original style to dom node
			if(this.isFreeform())
				dojo.style(currentWidget, "position", "absolute");
			var left = this._extractStyle(css_style, "left");
			if (left) 
				dojo.style(currentWidget, "left", left);
			var top = this._extractStyle(css_style, "top");
			if (top) 
				dojo.style(currentWidget, "top", top);
			var height = this._extractStyle(css_style, "height");
			if (height) 
				dojo.style(currentWidget, "height", height);
			var width = this._extractStyle(css_style, "width");
			if (width) 
				dojo.style(currentWidget, "width", width);
		}
		lgr.exiting(mname, arguments);
	},
	
	_extractStyle: function(styleString, styleName) {
		var start = styleString.indexOf(styleName);
		if(start > -1) {
			var end = styleString.indexOf(";", start);
			var style2 = styleString.substring(start+styleName.length+1, end);	// eg. height: 123px;
			return dojo.trim(style2);
		} else {
			return null;
		}
	}
	////////////////// For freeform /////////////////////////////////////
});

(function(){
	var controller = null;
	com.ibm.pb.control.RenderingController.getController = function() {
		if(!controller) {
			controller = new com.ibm.pb.control.RenderingController();
		}
		return controller;
	};
})();

}

if(!dojo._hasResource["com.ibm.pb.decorations.DecorationManager"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.decorations.DecorationManager"] = true;
dojo.provide("com.ibm.pb.decorations.DecorationManager");





dojo.declare("com.ibm.pb.decorations.DecorationManager", com.ibm.pb.logging.Loggable, {
	
	// TODO: Consolidate with com.ibm.mm.enabler.navigation.priming.PrimingCentral.COMPONENT_CONTROL_CLASS
	controlClass: "component-control",
	// TODO: Consolidate with com.ibm.mm.enabler.navigation.priming.PrimingCentral.COMPONENT_CONTAINER_CLASS
	containerClass: "component-container",
	layoutParser: com.ibm.pb.layout.LayoutParser,
	
	constructor: function() {
		this._controlComps = {};
		this._layoutComps = new Array();
		this.evtSvc = com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService");
		this.evtSvc.subscribeEvent("com.ibm.mashups.builder.pageSwitched", this, "reset");
		this.evtSvc.subscribeEvent("com.ibm.mashups.builder.widgetDeleted", this, "unregisterControl");
		this.evtSvc.subscribeEvent("com.ibm.mashups.builder.layoutRefreshed", this, "processLayout");
	},
	processTag: function(tag){
		var mname = "processTag", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		if(dojo.hasClass(tag, this.controlClass)) {
			lgr.trace(mname, "Found control ${0}", [tag]);
			var decNode = dojo.query("a[rel=decoration],span.decoration", tag)[0];
			if(decNode) {
				lgr.trace(mname, "Found decoration ${0} on control", [decNode]);
				this.registerControl(tag, decNode);
			}
		}
		lgr.exiting(mname, arguments);
	},
    unprocessTag: function(tag) {
		if(dojo.hasClass(tag, this.controlClass)) {
			lgr.trace(mname, "Found control ${0}", [tag]);
			var id = this.layoutParser.extractID(tag);
			if(id) {
				lgr.trace(mname, "Unregister control decoration ${0}", [id]);
				this.unregisterControl(id);
			}
		}
    },
	processLayout: function(id){
		var mname = "processLayout", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		
		var node = this.layoutParser.findById(id);
		
		if(node && dojo.hasClass(node, this.containerClass)) {
			lgr.trace(mname, "Layout refreshed container ${0}", [node]);

			var containers = this.layoutParser.findContainers(this.layoutParser.getRootNode());
			for(var i=0; i<this._layoutComps.length; i++){
				var obj = this._layoutComps[i].obj;
				obj.processContainer(id, node, containers);				
			}
		} else {
			lgr.trace(mname, "Layout refreshed, handle all containers");
			
			if(this._layoutComps.length > 0){
				this.unregisterLayout();
			}
			dojo.query('> span.decoration', this.layoutParser.getRootNode()).forEach(dojo.hitch(this, function(node){
				this.registerLayout(node);
			}));
		}
	},
	reset: function() {
		var mname = "reset", lgr = this.LOGGER;
		lgr.entering(mname, arguments);

		var skipPageId = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();

		for(var controlId in this._controlComps) {
			if(this._controlComps[controlId].pageId != skipPageId)
				this.unregisterControl(controlId);
    	}

    	this.unregisterLayout(skipPageId);
    },
	registerControl: function(controlNode, decorationNode) {
    	var mname = "registerControl", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		var ret = null;

    	var pageId = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
    	var controlId = this.layoutParser.extractID(controlNode);
    	
		var name = com.ibm.domUtilities.textContent(decorationNode);
		var ctr = this.getDecorationObject(name);
		ret = this._controlComps[controlId] = {control: new ctr(controlId, controlNode), pageId: pageId};
		this.evtSvc.broadcastEvent("com.ibm.mashups.builder.skinLoaded", {widgetId: controlId, skinNodeId: controlId, skinParam: {}});

		lgr.exiting(mname, [ret]);
		return ret;
	},
	unregisterControl: function(controlId) {
		var mname = "unregisterControl", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		var ret = false;

		if(this._controlComps[controlId]) {
			if(this._controlComps[controlId].control)
				this._controlComps[controlId].control.destroy();
			delete this._controlComps[controlId];
			ret = true;
		}
		lgr.exiting(mname, [ret]);
		return ret;
	},
	registerLayout: function(node) {
		var mname = "registerLayout", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		
		var name = com.ibm.domUtilities.textContent(node);
		var cls = this.getDecorationObject(name);
		var obj = new cls();
		var pageId = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
		this._layoutComps.push({obj: obj, pageId: pageId});
		
		var containers = this.layoutParser.findContainers(this.layoutParser.getRootNode());
		// FIXME sometimes obj.processContainer is not defined which breaks testing
		if(dojo.isFunction(obj.processContainer)) {
			for(var i=0, l = containers.length; i<l; i++) {
				var container = containers[i];
				var id = this.layoutParser.extractID(container);
				obj.processContainer(id, container);
			}
		}
		
		lgr.exiting(mname);
	},
	unregisterLayout: function(skipPageId) {
		var mname = "unregisterLayout", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		var ret = false;
		var skippedComps = new Array();
		for(var i=0; i<this._layoutComps.length; i++) {
			if (this._layoutComps[i].pageId == skipPageId) {
				skippedComps.push(this._layoutComps[i]);
			} else {
				this._layoutComps[i].obj.destroy();
			}
			ret = true;
		}
		this._layoutComps = skippedComps;
		lgr.exiting(mname, [ret]);
		return ret;
		
	},
	getDecorationObject: function(name){
		try {
			var ctr = dojo.getObject(name);
			if(!ctr) {
				dojo["require"](name);
				ctr = dojo.getObject(name);
				if(!ctr) {
					lgr.severe(mname, "${0} not found", [name]);
					return;
				}
			}
			return ctr;
		}
		catch(err) {
			lgr.severe(mname, "Error instantiating control delegate ${0}", [err]);
		}
	}
});

com.ibm.pb.decorations.DECORATION_MANAGER = new com.ibm.pb.decorations.DecorationManager();

}

if(!dojo._hasResource["com.ibm.pb.screen.position"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.screen.position"] = true;
dojo.provide("com.ibm.pb.screen.position");

(function(){
	
	var axes = ["x","y"],
		depth = {
			x: "w",
			y: "h"	
		},
		toArray = function(a) {
			if(!dojo.isArray(a)) {
				a = [a];
			}
			return a;
		},
		isHidden = function(a) {
			return (dojo.style(a, "display") || "").toLowerCase() == "none";
		};
		
	
	
	scrPos = com.ibm.pb.screen.position = {
		findByDirection: function(relNode, nodes, dir, strictAxis) {
			var p = dojo.position(relNode),
				comp = "beforeDelta", axis, deltaList = [], ret = [], node;
			switch(dir) {
				case "left":
					axis = "x";
					break;
				case "right":
					comp = "afterDelta";
					axis = "x";
					break;
				case "up":
					axis = "y";
					break;
				case "down":
				default:
					comp = "afterDelta";
					axis = "y";
			}
			var nPos = null;
			for(var i=0; i<nodes.length; i++) {
				node = nodes[i];
				if(!isHidden(node)) {
					nPos = dojo.position(node);
					deltaList.push({
						pos: nPos,
						delta: scrPos[comp](nPos, p, axis),
						node: node 
					});
				}
			}
			deltaList = deltaList.sort(this._sortByDelta);
			for(var k=deltaList.length-1; k>=0; k--) {
				if(deltaList[k].delta < 0) {
					deltaList.splice(0, k+1);
					break;
				}
				if(!strictAxis || scrPos.inAxis(p, deltaList[k].pos, axis)) {
					ret.unshift(deltaList[k].node);
				}
			}
			return ret;
		},
		inAxis: function(p1, p2, axis) {
			var a = axis === "x" ? "y" : "x";
			return !(
				(p1[a] > (p2[a] + p2[depth[a]])) || 
				((p1[a] + p1[depth[a]]) < p2[a])
				);
		},
		_sortByDelta: function(p1, p2) {
			return p1.delta - p2.delta;
		},
		isContainedIn: function(p1, p2) {
			return (p1.x >= p2.x && (p1.x + p1.w <= p2.x + p2.w))
				&&   (p1.y >= p2.y && (p1.y + p1.h <= p2.y + p2.h));
		},
		contains: function(p1, p2) {
			return (p1.x <= p2.x && (p1.x + p1.w >= p2.x + p2.w))
				&&   (p1.y <= p2.y && (p1.y + p1.h >= p2.y + p2.h));
		},
		beforeDelta: function(p1, p2, axis) {
			return scrPos.afterDelta.call(this, p2, p1, axis);
		},
		afterDelta: function(p1, p2, axis) {
			return p1[axis] - (p2[axis] + p2[depth[axis]]);
		},
		isBefore: function(p1, p2, axis) {
			return scrPos.beforeDelta.call(this, p1, p2, axis) >= 0;
		},
		isAfter: function(p1, p2, axis) {
			return scrPos.afterDelta.call(this, p1, p2, axis) >= 0;
		},
		boundingBox: function(nodes) {
			var b = {x:null,y:null,w:0,h:0};
			nodes = toArray(nodes);
			dojo.forEach(nodes, function(n){
				if(!isHidden(node)) {
					var p = dojo.position(n);
					dojo.forEach(axes, function(a){
						if(p[a] < b[a] || b[a] === null) {
							b[a] = p[a];
						}
						var diff = (p[a] + p[depth[a]]) - (b[a] + b[depth[a]]);
						if(diff > 0) {
							b[depth[a]] += diff;
						}
					});
				}
			});
			return b;
		},
		extreme: function(nodes, axis) {
			nodes = toArray(nodes);
			var b = scrPos.boundingBox(nodes);
			var ret = {low:[],high:[]}, v = 0;
			
		}
	}
})();

}

if(!dojo._hasResource["com.ibm.pb.decorations.DirectionalMoveControls"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.decorations.DirectionalMoveControls"] = true;
dojo.provide("com.ibm.pb.decorations.DirectionalMoveControls");






/**
 * Provides controls to move a node between containers or between siblings in its own container
 */
dojo.declare("com.ibm.pb.decorations.DirectionalMoveControls", [com.ibm.mashups.builder.model.ContextMenuLoader, com.ibm.pb.logging.Loggable], {
	
	layoutParser: com.ibm.pb.layout.LayoutParser,
	
	directions: ["up", "down", "left", "right"],
	contentsQuery: ">",
	containerQuery: "div",
		
	constructor: function(args) {
		if(args) {
			dojo.safeMixin(this, args);
		}
	},
	getItems: function(/*String*/ contextMenuId, /*String*/ targetResourceId, /*String*/ targetResourceType, /*Object*/ someObject) {
		var mname = "getItems", lgr = this.LOGGER, me = this;
		lgr.entering(mname, arguments);
		dfd = new com.ibm.mm.builder.DeferredImpl(this, function(deferred, sync, params) {
			var callBack = deferred.getFinishedCallback(), callBackParams = deferred.getFinishedCallbackParameters(),
				ret = this.getControls(targetResourceId);
			if(callBack) {
				callBack(ret, 200, callBackParams);
			}
			return ret;
		});
		lgr.exiting(mname, arguments);
		return dfd;
	},
	getControls: function(node) {
		var ret = [], ordinal = 1;
		node = this.layoutParser.findById(node);
		if(node) {
			var nodeContainer = this.getContainer(node);
			var isFreeformLayoutContainer = dojo.hasClass(nodeContainer, "ibmFreeform");
			dojo.forEach(this.directions, function(dir){
				if(isFreeformLayoutContainer){
					var container = this.getContainerByDirection(node, dir);
					if(container){
						ret.push(dojo.mixin(this._getItem(dir), {
						ordinal: ordinal++,
						actionCallBackFunction: this.getMoveAction(node, container, sibling, dir)
					}));
					}
				}else{
					var sibling = this.getSiblingByDirection(node, dir), container = null;
				if(!sibling) {
					container = this.getContainerByDirection(node, dir);
				}
				if(sibling || container) {
					ret.push(dojo.mixin(this._getItem(dir), {
						ordinal: ordinal++,
						actionCallBackFunction: this.getMoveAction(node, sibling ? nodeContainer : container, sibling, dir)
					}));
				}
				}
			}, this);
		}
		return ret;
	},
	_getItem: function(dir) {
		return {
			id: "DirectionalMove:" + dir,
			localized: new com.ibm.pb.localized.DojoLocalized({
				bundlePackage: "com.ibm.bundles",
				bundleName: "Theme",
				bundleKey: "move_" + dir
			}),
			enabled: true
		};
	},
	nextElementSibling: function(node) {
		var next = node && node.nextSibling;
		if(!next) {
			return null;
		}
		else if(next.nodeType != 1) {
			return this.nextElementSibling(next);
		}
		else {
			return next;
		}
	},
	getPostMoveAction: function(node, parentNode, nextSibling) {
		return function(){};
	},
	onMove: function(node, refNode, position) {
		this.onChange();
	},
	moveNode: function(node, refNode, position) {
		dojo.place(node, refNode, position);
		this.onMove(node, refNode, position);
	},
	getMoveAction: function(childNode, parentNode, siblingNode, dir) {
		var mname = "getMoveAction", lgr = this.LOGGER, pos = "last", func, postMove, me = this, refNode;
		if(siblingNode && siblingNode.parentNode == parentNode) {
			// if we're here, we're just swapping node positions, we don't use dir explicitly
			// because it has already been calculated by examining nodes in the DOM
			pos = this._isBefore(childNode, siblingNode) ? "after" : "before";
			postMove = this.getPostMoveAction(childNode, parentNode, pos == "after" ? this.nextElementSibling(siblingNode) : siblingNode);
			lgr.trace(mname, "Get action to move ${0} ${1} ${2}", childNode, pos, siblingNode);
			refNode = siblingNode;
		}
		else {
			lgr.trace(mname, "Get action to move ${0} to ${1} of ${2}", childNode, pos, parentNode);
			postMove = this.getPostMoveAction(childNode, parentNode);
			refNode = parentNode;
		}
		return function(){
			me.moveNode(childNode, refNode, pos);
			postMove();
		};
	},
	_isBefore: function(node, sibling) {
		var idx = this._childIdx(node),
			sidx = this._childIdx(sibling);
		return idx < sidx;
	},
	_childIdx: function(node) {
		return dojo.indexOf(node.parentNode.childNodes, node);
	},
	isLTR: function() {
		if(this._isLTR !== undefined) {
			this._isLTR = (dojo.body().dir || dojo.doc.documentElement.dir || "ltr").toLowerCase() == "ltr";
		}
		return this._isLTR;
	},
	getSiblingByDirection: function(node, direction) {
		var mname = "getSiblingByDirection", lgr = this.LOGGER;
		var siblings = this.getContents(this.getContainer(node)).filter(function(c){
			return c != node;
		});
		var nodes = com.ibm.pb.screen.position.findByDirection(node, siblings, direction);
		lgr.trace(mname, "Found siblings %o in direction %o from %o", nodes, direction, node); 
		return nodes[0];
	},
	getContainerByDirection: function(node, direction) {
		var mname = "getContainerByDirection", lgr = this.LOGGER;
		var container = this.getContainer(node);
		var containers = this.getContainers().filter(function(c){
			return c != container;
		});
		var nodes = com.ibm.pb.screen.position.findByDirection(node, containers, direction);
		lgr.trace(mname, "Found containers %o in direction %o from %o", nodes, direction, node);
		return nodes[0];
	},
	getContents: function(node) {
		return dojo.query(this.contentsQuery, node);
	},
	getContainers: function() {
		return dojo.query(this.containerQuery);
	},
	getContainer: function(node) {
		return node.parentNode;
	}
});

}

if(!dojo._hasResource["com.ibm.pb.decorations.LayoutDirectionalMoveControls"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.decorations.LayoutDirectionalMoveControls"] = true;
dojo.provide("com.ibm.pb.decorations.LayoutDirectionalMoveControls");



/**
 * Provides controls to move a node between containers or between siblings in its own container
 */
dojo.declare("com.ibm.pb.decorations.LayoutDirectionalMoveControls", com.ibm.pb.decorations.DirectionalMoveControls, {
	
	builderFactory: com.ibm.mashups.builder.model.Factory,
	
	contentsQuery: "> .component-control",
	containerQuery: ".component-container:not(.hiddenWidgetsContainer)",
	
	constructor: function() {
		this.evtSvc = com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService");
		this.evtSvc.subscribeEvent("com.ibm.mashups.builder.widgetMoved", this, "onChange");
		this.nm = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel();
	},
	
	getControls: function(node) {
		// if view mode, no move action available
		if(this.builderFactory.getRuntimeModel().getCurrentPage().getPageMode() == "view") { 
			return []; 
		} else {
			var navStateModel = com.ibm.mashups.enabler.model.state.NavigationStateModelFactory.getNavigationStateModel();
			var widgetAccessor = com.ibm.mashups.enabler.model.state.AccessorFactory.getWidgetAccessor(navStateModel,node);
			var state = widgetAccessor.getWindowState();
			// if in maximized mode, no move action available
			if (widgetAccessor.MAX == state){
				return []; 
			} else {
				return this.inherited(arguments);
			}
		}
	},
	
	getPostMoveAction: function(node, parentNode, nextSibling) {
		var nodeId = this.layoutParser.extractID(node),
			parentId = this.layoutParser.extractID(parentNode),
			nextId = (nextSibling && this.layoutParser.extractID(nextSibling)) || null,
			pageId, currentNavNode, lm, lmNode, lmParentNode, lmNextNode;
		pageId = this.builderFactory.getRuntimeModel().getCurrentPage().getID();
		currentNavNode = this.nm.find(pageId).start();
		lm = this.nm.getLayoutModel(currentNavNode);
		lmNode = lm.find(nodeId).start();
		lmParentNode = lm.find(parentId).start();
		if(nextId) {
			lmNextNode = lm.find(nextId).start();
		}
		return function(){
			if(lm.confirmInsert(lmNode, lmParentNode, lmNextNode)) {
				lm.insert(lmNode, lmParentNode, lmNextNode);
				com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
			}
		};
	},
	
	onMove: function(node, refNode, position) {
		this.evtSvc.broadcastEvent("com.ibm.mashups.builder.widgetMoved", this.layoutParser.extractID(node));
	}
});

}

if(!dojo._hasResource["com.ibm.pb.decorations.Control"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.decorations.Control"] = true;
dojo.provide("com.ibm.pb.decorations.Control");



dojo.declare("com.ibm.pb.decorations.Control", com.ibm.pb.logging.Loggable, {
	
	evtSvc: com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService"),
	
	constructor: function(id, node) {
		this.id = id;
		this.node = node;
		this.connections = [];
	},
	connect: function(scope, func, cbk) {
		this.connections.push(dojo.connect.apply(dojo, [scope, func, this, cbk]));
		return this.connections.slice(-1);
	},
	destroy: function() {
		var mname = "destroy", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		while(this.connections.length > 0) {
			dojo.disconnect(this.connections.shift());
		}
		lgr.exiting(mname, arguments);
	}
});

}

if(!dojo._hasResource["com.ibm.pb.contextMenu.ShadowContextMenuLoader"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.contextMenu.ShadowContextMenuLoader"] = true;
dojo.provide("com.ibm.pb.contextMenu.ShadowContextMenuLoader");



/**
 * Creates a context menu loader that shadows an existing context menu by its specific ID.  This loader
 * can be registered to a different context menu ID in the system, but will retrieve its contents
 * internally from the context menu that it shadows.  This module can be used to create nested structures
 * of context menu loaders where a base loader may be registered to a particular context menu ID in
 * the system and the specific instances mapped to different IDs may get the same data from the base
 * loader but provide a place for custom contributions and onChange events.  Any contributions to the
 * shadowed menu will be reflected here, and any update event in the base menu will be reflected here too.
 */
dojo.declare("com.ibm.pb.contextMenu.ShadowContextMenuLoader", [com.ibm.mashups.builder.model.ContextMenuLoader, com.ibm.pb.logging.Loggable], {
	
	builderFactory: com.ibm.mashups.builder.model.Factory,
	shadowedMenuId: "",
	
	constructor: function(contextMenuId) {
		this.shadowedMenuId = contextMenuId;
		this.builderFactory.getContextMenuModel().registerListener(contextMenuId, this, "onChange");
		
	},
	getItems: function(/*String*/ contextMenuId, /*String*/ targetResourceId, /*String*/ targetResourceType, /*Object*/ someObject) {
		return this.builderFactory.getContextMenuModel().getContextMenuDeferred(this.shadowedMenuId, targetResourceId, targetResourceType, someObject);
	}
});
	

}

if(!dojo._hasResource["com.ibm.pb.decorations.ControlMenu"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.decorations.ControlMenu"] = true;
dojo.provide("com.ibm.pb.decorations.ControlMenu");




dojo.declare("com.ibm.pb.decorations.ControlMenu", com.ibm.pb.logging.Loggable, {
	
	builderFactory: com.ibm.mashups.builder.model.Factory,
	
	baseContextMenuId: "widgetActions",
	
    constructor: function(controlId, contextMenuId, baseContextMenuId) {
        var mname = "constructor", lgr = this.LOGGER, me = this;
        this._connections = [];
        if(baseContextMenuId) {
            this.baseContextMenuId = baseContextMenuId;
        }
        this.controlId = controlId;
        this.contextMenuId = contextMenuId;
        this.contextMenuLoader = new com.ibm.pb.contextMenu.ShadowContextMenuLoader(this.baseContextMenuId);
        this.builderFactory.getContextMenuModel().registerContextMenu(contextMenuId, this.contextMenuLoader);
        this.evtSvc = com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService");
        
        // lookup the widget window id based on the control Id
        this.windowId = controlId; // we can assume that window ID and control ID are always the same, even in live preview
        
        dojo.forEach(["com.ibm.mashups.iwidget.widgetmodechanged", "com.ibm.mashups.iwidget.widgetwindowstatechanged"], function(evt) {
            this._connections.push(this.evtSvc.subscribeEvent(evt, this, this._checkChange));
        }, this);
        
        dojo.forEach(["com.ibm.mashups.builder.moveAction","com.ibm.mashups.builder.hideWidget","com.ibm.mashups.builder.displayWidget"], function(evt) {
            this._connections.push(this.evtSvc.subscribeEvent(evt, this, function(id){
                // payload is simple string id
                this._checkChange({id: id});
            }));
        }, this);
        
        this._connections.push(this.evtSvc.subscribeEvent("com.ibm.mashups.builder.changePageMode", this, function(){
            this._checkChange({id: this.windowId}); // not part of event payload
        }));
    },
    _checkChange: function(obj){
        var mname = "_checkChange", lgr = this.LOGGER, me = this;
        lgr.entering(mname, arguments);
        if(this.windowId == obj.id) {
            lgr.trace(mname, "Firing change event for widget context menu ${0}", [this.windowId]);
            this.contextMenuLoader.onChange();
        }
        lgr.exiting(mname, arguments);
    },
	destroy: function() {
		this.builderFactory.getContextMenuModel().registerContextMenu(this.contextMenuId, null);
		delete this.contextMenuLoader;
		while(this._connections.length > 0) {
			this.evtSvc.unsubscribeEvent(this._connections.shift());
		}
	}
});

}

if(!dojo._hasResource["com.ibm.pb.decorations.MashupSkinSelectionMenu"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.decorations.MashupSkinSelectionMenu"] = true;
dojo.provide("com.ibm.pb.decorations.MashupSkinSelectionMenu");




dojo.declare("com.ibm.pb.decorations.MashupSkinSelectionMenu", [com.ibm.mashups.builder.model.ContextMenuLoader, com.ibm.pb.logging.Loggable], {

    subMenuID: "mashupSkinSelectionMenu",
    builderFactory: com.ibm.mashups.builder.model.Factory,
    
    constructor: function(args){
        if (args) {
            dojo.safeMixin(this, args);
        }
    },
    getItems: function(/*String*/contextMenuId, /*String*/ targetResourceId, /*String*/ targetResourceType, /*Object*/ someObject){
        var mname = "getItems", lgr = this.LOGGER, me = this;
        lgr.entering(mname, arguments);
        dfd = new com.ibm.mm.builder.DeferredImpl(this, function(deferred, sync, params){
            var callBack = deferred.getFinishedCallback(), callBackParams = deferred.getFinishedCallbackParameters(), ret = this._getItem(targetResourceId);
            if (callBack) {
                callBack(ret, 200, callBackParams);
            }
            return ret;
        });
        lgr.exiting(mname, arguments);
        return dfd;
    },
    
    _getItem: function(targetResourceId){
        if (this.builderFactory.getRuntimeModel().getCurrentPage().getPageMode() == "view") {
            return [];
        }
        else {
            var ret = [];
            var item = {
                id: "skin:Selection",
                localized: new com.ibm.pb.localized.DojoLocalized({
                    bundlePackage: "com.ibm.bundles",
                    bundleName: "Theme",
                    bundleKey: "theme_choose_skin"
                }),
                contextMenuID: this.subMenuID,
                //resourceType:,
                //resourceId:,
                enabled: true,
                ordinal: 140
            };
            ret.push(item);
            return ret;
        }
    }
});

dojo.declare("com.ibm.pb.decorations.MashupSkinItems", com.ibm.pb.decorations.MashupSkinSelectionMenu, {

    subMenuID: "",
    
    registerMenu: function(menuID){
        var cmm = this.builderFactory.getContextMenuModel();
        cmm.registerContextMenu(menuID, this);
    },
    
    _getItem: function(targetResourceId){
        var ret = [], ordinal = 1;
        dojo.forEach(com.ibm.mm.builder.utils.skinUtil.getAllSkins(), function(skin){
			var checked = false;
            var skinId = skin.getID();
            var layoutControl = com.ibm.mm.builder.utils.pageUtil.getLayoutControlByWidgetId(targetResourceId);
			if(!layoutControl) return;
            var currentSkinId = layoutControl.getSkin().getID();
            var skinTitle = skin.getTitle(dojo.locale);
			if (skinId === currentSkinId) {
				checked = true;
				skinTitle = skinTitle + "<span class = 'access'>" + com.ibm.mm.builder.coreWidgetsStrings.I_MODE_IS_SELECT + "</span>";
			}
            var item = {
                id: "skin:" + skinId,
                title: skinTitle,
                enabled: true,
                ordinal: ordinal++,
                actionCallBackFunction: this._switchToSkin(skinId, targetResourceId),
				checkedMenuItem:true,
				checked:true
            };
            dojo.mixin(item, {
				checked:checked,
                iconClass: (skinId === currentSkinId ? "menuIconClass" : "")
            });
            ret.push(item);
        }, this);
        return ret;
    },
    
    _switchToSkin: function(skinId, widgetId){
        return function(){
            var layoutControl = com.ibm.mm.builder.utils.pageUtil.getLayoutControlByWidgetId(widgetId);
            layoutControl.setSkin(skinId);
            com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.layoutRefresh", widgetId);
        }
    }
});

}

if(!dojo._hasResource["com.ibm.pb.decorations.LayoutResizers"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.decorations.LayoutResizers"] = true;
dojo.provide("com.ibm.pb.decorations.LayoutResizers");




dojo.declare("com.ibm.pb.decorations.LayoutResizers", com.ibm.pb.logging.Loggable, {
	components: {},
	runtimeModel: null,
	layoutParser: com.ibm.pb.layout.LayoutParser,
	
	constructor: function(){
		var mname = "constructor", lgr = this.LOGGER;
		lgr.entering(mname, arguments);

		// get the runtime skin model
		this.runtimeModel = com.ibm.mashups.enabler.runtime.skin.Factory.getRuntimeSkinModel();
		
		lgr.exiting(mname);
	},
	processContainer: function(id, node){
		var mname = "processContainer", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		
		if(this.components[id]){
			this.destroy(id);
		}
		
		// Search for containers to right of container
		var containers = this.layoutParser.findContainers(this.layoutParser.getRootNode());
		var nodes = com.ibm.pb.screen.position.findByDirection(node, containers, "right", true);
		
		lgr.trace(mname, "Found containers %o to the right of %o", nodes, node);
		
		// if nodes were found to the right of the container, create resizer widget
		if(nodes.length > 0){
			var leftNodeId = this.layoutParser.extractID(node);
			var rightNodeId = this.layoutParser.extractID(nodes[0]);
			
			//following line is used to avoid adding container resizer to hidden area in IE6
			if(dojo.isIE == 6 && leftNodeId == rightNodeId) return;
			
			var root = this.layoutParser.getRootNode();
			if(root) {
				// if root was found, calculate height of layout to apply to resizer
				var height = root.offsetHeight;
				while(height <= 0){
					// height was not found, move up the tree to find a height
					height = root.parentNode.offsetHeight;
				}		
			}			
			
			//var leftNodeId = this.layoutParser.extractID(node);
			//var rightNodeId = this.layoutParser.extractID(nodes[0]);
			
			var resizer = new com.ibm.pb.layout.resize.ContainerResizer({   
				height: height,
				leftNodeId: leftNodeId,
				rightNodeId: rightNodeId,
				runtimeNodes: {
					//#19024 lazy find the node until edit mode
					//left: this.runtimeModel.find(leftNodeId),
					//right: this.runtimeModel.find(rightNodeId)
					left: null,
					right: null
				}
			});
			if (!ibmCfg.themeConfig.isRTL) {
				dojo.place(resizer.domNode, node, "after");
			}else{
				dojo.place(resizer.domNode, node, "before");
			}
			
			this.components[id] = resizer;
		}		
	},
	destroy: function(id) {
		var mname = "destroy", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		
		var ret = false;
		if(id){
			if (this.components[id]) {
				this.components[id].destroy();
				delete this.components[id];
				ret = true;
			}
		}else{
			for(var id in this.components) {
				if(this.components[id]){
					this.components[id].destroy();
					delete this.components[id];
				}
			}
			ret = true;
		}
		this.inherited(arguments);
		return ret;
	}
});

}

if(!dojo._hasResource["com.ibm.pb.decorations.LayoutFilters"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.decorations.LayoutFilters"] = true;
// @author Laura
// module to add runtime style filters to each layout container on the page

dojo.provide("com.ibm.pb.decorations.LayoutFilters");

dojo.declare("com.ibm.pb.decorations.LayoutFilters", com.ibm.pb.logging.Loggable, {

	constructor: function() {
		// summary: assigns runtime style filters to each of the given containers
		var mname = "constructor", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		this.layoutParser = com.ibm.pb.layout.LayoutParser;
		this._filters = [];
		this.filterAdded = false;
		
		this.evtSvc = com.ibm.mashups.services.ServiceManager.getService("eventService");
		this.changePageModeEvt = this.evtSvc.subscribeEvent("com.ibm.mashups.builder.changePageMode", this, "_onPageModeChanged");
		
		// #19538, when click save, the filters will be destroyed and re-constructed
		// in this case _addStyleFilter again
		if (com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getPageMode() == "edit") {
			if (this.filterAdded) return;
			this.filterAdded = true;
			this._addStyleFilter();	
		}
		lgr.exiting(mname);
	},
	
	_onPageModeChanged: function(iEvent){
		if (this.filterAdded) return;
		if(iEvent == "edit") {
			this.filterAdded = true;
			this._addStyleFilter();	
		}		
	},
	
	_addStyleFilter: function() {
		// initialize layout and runtime skin models
		var containers = this.layoutParser.findContainers(this.layoutParser.getRootNode());
		this.rsModel = com.ibm.mashups.enabler.runtime.skin.Factory.getRuntimeSkinModel();
		var pageId = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID(),
			navModel = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel(),
			layoutModel = navModel.getLayoutModel(pageId),
			c = ibmCfg.themeConfig.layoutFilterDefinitions;  // a map that pairs css classes on container types with their corresponding layout filter
		
		// loop through the containers and apply the appropriate runtime style filter to each
		for (var i = 0, l = containers.length; i < l; i++) {
			// loop through the filter map to find the correct filter class to apply
			for (var j = 0, cl = c.length; j < cl; j++) {
				if (dojo.hasClass(containers[i], c[j].id)) {
					// get an instance of the filter class needed for this container
					var filterCls = dojo.getObject(c[j].filter);
					if (!filterCls) {
						dojo["require"](c[j].filter);
						filterCls = dojo.getObject(c[j].filter);
						if (!filterCls) {
							this.logger.severe(mname,"Cannot find layout container filter class",[arguments]);
							return;
						}
					}
					var filter = new filterCls();
					// find the container in the layout model and apply the filter to it
					var id = this.layoutParser.extractID(containers[i]);
					var layoutContainer = layoutModel.find(id).start();
					var intt = this.rsModel.addStyleFilter(com.ibm.mashups.enabler.runtime.skin.Constants.ORDINAL_FIRST, filter, layoutContainer);
					this._filters.push({"id":intt,"filter":filter});
				}
			}
		}	
	},
	
	destroy: function() {
		// summary: remove and destroy all the style filters
		var mname = "destroy", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		
		this.evtSvc.unsubscribeEvent(this.changePageModeEvt);		
		var len = this._filters.length;
		for (var i = 0; i < len; i++) {
			this.rsModel.removeStyleFilter(this._filters[i].id);
			delete this._filters[i].filter;
		}
		this._filters = [];
		
		lgr.exiting(mname);
	}
});

}

if(!dojo._hasResource["com.ibm.pb.dijit.WidgetResizer"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.dijit.WidgetResizer"] = true;
dojo.provide("com.ibm.pb.dijit.WidgetResizer");




dojo.declare("com.ibm.pb.dijit.WidgetResizer", [dijit._Widget, dijit._Templated],{
	templateString: 
		'<div dojoAttachEvent="onmousedown: _beginSizing" class="lotusWidgetResizer">'+
			'<div></div>'+
		'</div>',
		
	widgetId: null,
	//component-control node of the widget
	control: null,
	// contentElm: widget content dom node id
	contentElm: "",	

	widgetBodyElmId: "",
	
	minWidth:20,
	
	minHeight:20,
	
	oldHeight:0,
	
	// layout-container
	parentNode:null,
	
	intLeftRTLOrig:0,
	
	intOriginalWidth:0,
	
	isRtl: builderConfig.isBidi,
	
	postCreate: function(){
		if(this.isRtl){
			dojo.addClass(this.domNode, "rtl");
			// #16766 we shall set the left/right inline instead of using css class
			// because in rtl, the right=0 will also take effect
			dojo.style(this.domNode, "left", 0);
		} else {
			dojo.style(this.domNode, "right", 0);
		}
		this.runtimeModel = com.ibm.mashups.builder.model.Factory.getRuntimeModel();
		this.evtSvc = com.ibm.mashups.services.ServiceManager.getService("eventService");
		this.bEvents = com.ibm.mm.builder.eventTopics;
		//com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService");
		this.changePageModeEvt = this.evtSvc.subscribeEvent("com.ibm.mashups.builder.changePageMode", this, "_onPageModeChanged");
		this.leaveFreeformEvt = this.evtSvc.subscribeEvent("com.ibm.mashups.builder.leaveFreeformContainer"+"."+this.widgetId, this, "_onleaveFreeform");
		this.enterFreeformEvt = this.evtSvc.subscribeEvent("com.ibm.mashups.builder.enterFreeformContainer"+"."+this.widgetId, this, "_onenterFreeform");
		this._checkMode();
	},
	_checkMode: function(){
		if (this.runtimeModel.getCurrentPage().getPageMode() == "edit" && dojo.hasClass(this.parentNode,"ibmFreeform")){
			this.domNode.style.display="block";
		}else{
			this.domNode.style.display="none";
		}
	},
	_onPageModeChanged: function(iEvent){
		if(iEvent == "edit" && dojo.hasClass(this.parentNode,"ibmFreeform")){
			this.domNode.style.display="block";
		}else{
			this.domNode.style.display="none";
		}
	},
	_onleaveFreeform: function(iEvent){
		this.domNode.style.display="none";
	},
	_onenterFreeform: function(iEvent){
		this.domNode.style.display="block";		
	},
	_beginSizing: function(/*Event*/ e){
		this.maxSize = this.createMaxSize();
		if (this._isSizing){ 
			return false; 
		}
		
		this.targetDomNode = this.control;
		this.intLeftRTLOrig = parseInt(this.targetDomNode.style.left,10);
		this.intOriginalWidth = parseInt(this.targetDomNode.style.width,10);
		
		if (!this.targetDomNode) {
			return;
		}
		this._isSizing = true;
		
		if (dojo.isIE){
			this.startPoint  = {'x':event.clientX, 'y':event.clientY};
		}else{
			this.startPoint  = {'x':e.clientX, 'y':e.clientY};
		}

		var mb = dojo._getContentBox(this.targetDomNode);
		var widgetbody = dojo.byId(this.widgetId).parentNode;
		var wb = dojo._getContentBox(widgetbody);
		this.startSize  = {'w':mb.w, 'h':mb.h};
		this.startWidgetSize = {'w':wb.w, 'h':wb.h};
		this.eventHandles = []; 
		this.eventHandles.push(dojo.connect(document, "onmousemove", this, "_changeSizing")); 
		this.eventHandles.push(dojo.connect(document, "onmouseup", this, "_endSizing")); 
		this.eventHandles.push(dojo.connect(document, "onmouseleave", this, "_endSizing")); 

		// Publish to the start sizing topic
		dojo.publish(this.bEvents.Resize_StartSizing, [this.widgetId]);
		e.preventDefault();	
	},

	_changeSizing: function(/*Event*/ e){
		// On IE, if you move the mouse above/to the left of the object being resized,
		// sometimes clientX/Y aren't set, apparently.  Just ignore the event.
		try{
			if (dojo.isIE){
				if(!event.clientX  || !event.clientY){
					return; 
				}				
			}else{
				if(!e.clientX  || !e.clientY){
					return; 
				}				
			}
		} catch (ex){
			// sometimes you get an exception accessing above fields...
			return;
		}

		var dx,dy;
		if (dojo.isIE){
			dx = this.startPoint.x - event.clientX;
			dy = this.startPoint.y - event.clientY;
		}else{
			dx = this.startPoint.x - e.clientX;
			dy = this.startPoint.y - e.clientY;
		}
		var newW;
		if(!this.isRtl){
			newW = this.startSize.w - dx;
		}else{
			newW = this.startSize.w + dx;	//for rtl
		}
		
		var newH = this.startSize.h - dy;
		var newWidgetH = this.startWidgetSize.h - dy;
		
		com.ibm.mm.builder.utils.pageWidthChanger.widgetToBeResized(this.control.id, newW, dx);
		// minimum size check
		var minWidthExceeded = newW < this.minWidth;
		if (minWidthExceeded) {
			newW = this.minWidth;
		}
		if (newH < this.minHeight) {
			newH = this.minHeight;
		}
		// maximum size check
		var maxWidthExceeded = newW > this.maxSize.w;
		if (maxWidthExceeded) {
			newW =this.maxSize.w;
		}
		if (newH > this.maxSize.h) {
			var _delta = this.startSize.h - this.startWidgetSize.h;
			newH = this.maxSize.h;
			newWidgetH = this.maxSize.h - _delta;
		}

		//In Right to Left, move the widget to the left by the same amount that the width is increased.
		var intLeft;
		if (this.isRtl) {
			if(minWidthExceeded){				
				intLeft = this.intLeftRTLOrig + (this.intOriginalWidth - this.minWidth);
			}else{				
				intLeft = maxWidthExceeded ? 0 : this.intLeftRTLOrig - dx;
			}
		}else{			
			intLeft = parseInt(this.targetDomNode.style.left,10);
		}
		
		var intTop = parseInt(this.targetDomNode.style.top,10);
		
		dojo._setBox(this.targetDomNode,intLeft,intTop,newW,newH);
		
		tempWidgetBody = dojo.byId(this.widgetId);
		if(!this.widgetBodyPadTop && tempWidgetBody){
			
			this.widgetBodyPadTop = com.ibm.mm.builder.utils.htmlUtil.getCurrentStyle(tempWidgetBody ,"paddingTop");
			
			if (this.widgetBodyPadTop) {
				this.widgetBodyPadTop = parseInt(this.widgetBodyPadTop,10);
			} else {
				this.widgetBodyPadTop = 0;
			}
		}

		var contentDiv = tempWidgetBody.parentNode;
		
		var hei = newWidgetH - this.widgetBodyPadTop;
		//hei + 10 for temp solve
		dojo._setMarginBox(contentDiv,0,0,newW,hei+10);
		
		if(this.skin){
			if(this.skin == "Thin"){
				var nht = hei - 20 ;
				tempWidgetBody.style.height = nht + "px";
			}else if(this.skin == "Standard"){
				var nhs = hei - 10;
				tempWidgetBody.style.height = nhs + "px";
			}
		}
		if (dojo.isSafari && builderConfig.isBidi) {
			contentDiv.style.width = (parseInt(this.targetDomNode.style.width,10) - 51) + "px";
		}
		this._updateContainer();
		// Publish to the change sizing topic
		var sizeDelta = {x: dx, y: dy};
		dojo.publish(this.bEvents.Resize_ChangeSizing, [sizeDelta]);
		e.preventDefault();
	},

	_endSizing: function(/*Event*/ e){
		this.runtimeModel.getCurrentPage().setDirty(true);
		while (this.eventHandles.length > 0) {
			dojo.disconnect(this.eventHandles.pop());
		}
		dojo.publish(this.widgetId + this.bEvents.Resize_EndSizing, [e]);
		
		payload = {
			widgetId: this.widgetId,
			layoutControlId: this.layoutControlId,
			width: parseInt(this.targetDomNode.style.width,10),
			height: parseInt(this.targetDomNode.style.height,10),
			action: "only_save"
		}
		this.evtSvc.broadcastEvent("com.ibm.mashups.builder.resizeWidget", payload);
		
		this._isSizing = false;
		this.widgetBodyPadTop = null;
		dojo.style(dojo.body(),{cursor:"default"});
	},
	
	_updateContainer: function(){
		if(this.parentNode){
			var lcoords = dojo.coords(this.parentNode);
			var widgetBox = dojo.coords(this.control.id);
			if(widgetBox.t + widgetBox.h > lcoords.h){
				this.parentNode.style.height = (widgetBox.t + widgetBox.h) + "px";
			}
		}
	},
	
	createMaxSize:function(){
		var curWidget = this.control;
		if(curWidget && curWidget.parentNode){
			var curLeft = parseInt(curWidget.style.left,10);
			var curWidth = parseInt(curWidget.style.width,10);
			var curTop = parseInt(curWidget.style.top,10);	
			var wholeWidth = dojo._getContentBox(curWidget.parentNode).w;
			var wholeHeight = dojo._getContentBox(curWidget.parentNode).h;
			
			var maxWidth = this.isRtl ? curLeft + curWidth : wholeWidth - curLeft;
			return {
				w: maxWidth,
				h: wholeHeight - curTop
			};
		}
		return null;
	},
	

	destroy : function(){
		this.widgetId = null;
		this.targetDomNode = null;
		this.evtSvc.unsubscribeEvent(this.changePageModeEvt);
		this.evtSvc.unsubscribeEvent(this.leaveFreeformEvt);
		this.evtSvc.unsubscribeEvent(this.enterFreeformEvt);
		this.inherited(arguments);
	},
	
	onKeyPress: function(evt){
		if (evt.keyCode == dojo.keys.ENTER) {
			this.show();
		}
	},
	
	show: function(){
		if (com.ibm.mm.builder.utils.pageUtil.getCurrentPageMode() != "edit") {
			return;
		}
		clearTimeout(this.showTimer);
		this.showTimer = setTimeout(dojo.hitch(this, function(){
			if (this.domNode) {
				this.domNode.style.display = "";
			}
		}), 100);
	},
	
	hide: function(){
		if (com.ibm.mm.builder.widgetMenu && com.ibm.mm.builder.widgetMenu.pMenu && com.ibm.mm.builder.widgetMenu.pMenu.isShowingNow) {
			return;
		}
		clearTimeout(this.hideTimer);
		clearTimeout(this.showTimer);
		this.hideTimer = setTimeout(dojo.hitch(this, function(){
			if (this.domNode) {
				this.domNode.style.display = "none";
			}
		}), 100);
	}
});

}

if(!dojo._hasResource["com.ibm.mashups.enabler.model.state.NavigationStateNode"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.model.state.NavigationStateNode"] = true;
dojo.provide("com.ibm.mashups.enabler.model.state.NavigationStateNode");





}

if(!dojo._hasResource["com.ibm.mashups.enabler.model.state.NavigationStateModelFactory"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.model.state.NavigationStateModelFactory"] = true;
dojo.provide("com.ibm.mashups.enabler.model.state.NavigationStateModelFactory");





}

if(!dojo._hasResource["com.ibm.pb.layout.resize.ContainerResizer"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.layout.resize.ContainerResizer"] = true;
dojo.provide("com.ibm.pb.layout.resize.ContainerResizer");









dojo.declare("com.ibm.pb.layout.resize.ContainerResizer", [com.ibm.pb.logging.Loggable, dijit._Widget, dijit._Templated],{

    templateString: '<div dojoAttachPoint="focusNode" dojoAttachEvent="onmousedown:_beginSizing" class="component-container-resizer ibmLayoutResizer lotusLeft" tabIndex="0" style="display:none;"></div>',
	layoutParser: com.ibm.pb.layout.LayoutParser,
	currContainerStyles: {left: {}, right: {}},	// the current styles set on the container runtime node
	containerStyles: {left: {}, right: {}},		// the style objects for the runtime model nodes, containerStyles.left & containerStyles.right
	runtimeNodes: {left: {}, right: {}},		// runtime skin nodes for the container, runtimeNodes.right & runtimeNodes.left
	leftNodeId: null,							// the id of the container to the left of resizer
	rightNodeId: null,							// the id of the container to the right of resizer
	eventHandles: [],							// stores the mouse event connections
	keyHandles: [],								// stores the key event connections
	height: 0, 									// the height of the resizer
	keyIncrementMap: { RIGHT_ARROW: 5,	
					   LEFT_ARROW: 5 },			// Dojo key constant name and increment to use for keyboard sizing
	defaultTimeout: 200, 						// number of milliseconds before a held key or button becomes typematic
	timeoutChangeRate: 0.9, 					// fraction of time used to change the typematic timer between events, < 1.0 fires at an increasing rate
	alwaysShow: false,							// true if the handle should always show, false to show only in edit mode
	a11yLabelId: "ibmLayoutResizerLabel",		// the id of the node used to label the resizer for accessibility
	
	constructor: function() {
		this.nlsBundle = dojo.i18n.getLocalization("com.ibm.bundles", "Theme");
		this.a11yValueText = this.nlsBundle["a11y_layout_resized"];
	},
	postCreate: function() {
		// summary: intialize variables and connect events
		var mname = "postCreate", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		
		var evtSvc = com.ibm.mashups.services.ServiceManager.getService("eventService");
		
		// set the height on the resizer so it is displayed
		dojo.style(this.domNode, "height", this.height+"px");
		
		// Accessibility support using WAI-ARIA
		// - Fetch/Create a label node to be used by all resizers
		// - set the role as slider, this will give proper instruction for use
		// - set valuetext, communicates the widths of the containers associated with resizer
		var a11yLabel = dojo.byId(this.a11yLabelId);
		if(!a11yLabel){
			a11yLabel = dojo.create("div", {id: this.a11yLabelId, className: "ibmHiddenText", role: "presentation", innerHTML: this.nlsBundle["layout_resizer"]}, dojo.body(), "last");
		}
		dojo.attr(this.domNode, "role", "slider");
		dojo.attr(this.domNode, "aria-labelledby", this.a11yLabelId);
		// #19024 lazy load after the resizer shows
		//var leftContainerWidth = this._getPercentageWidth(dojo.contentBox(this.layoutParser.findById(this.leftNodeId)).w); 
		//var rightContainerWidth = this._getPercentageWidth(dojo.contentBox(this.layoutParser.findById(this.rightNodeId)).w); 
		//dojo.attr(this.domNode, "aria-valuetext", dojo.string.substitute(this.a11yValueText, [leftContainerWidth, rightContainerWidth]));
		// end accessibility support
		
		if (this.alwaysShow) {
			this._showHandle();
		} else {
			this.changePageModeEvt = evtSvc.subscribeEvent("com.ibm.mashups.builder.changePageMode", this, "_checkMode");
			this._checkMode(com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getPageMode());
		}
		
		// connect the listeners for the left and right arrow keys, this satisfies accessibility.		
		for(var key in this.keyIncrementMap){
			this.keyHandles[key] = dijit.typematic.addKeyListener(this.domNode,
				{charOrCode:dojo.keys[key], ctrlKey:false, altKey:false, shiftKey:false},
				this,
				function(count, node, e){
					if(node == this.domNode){
						this._changeKeySizing(e.charOrCode, this.keyIncrementMap[key]);
					}
				},
				this.timeoutChangeRate, 
				this.defaultTimeout);
		}
	},
	_hideHandle: function() {
		// summary: hides the resize handle
		if (this.domNode) {
			dojo.style(this.domNode,"display","none");
		}
	},
    _getRuntimeNodes: function() {
        if (!this.runtimeNodes.left && !this.runtimeNodes.right) {
            var runtimeModel = com.ibm.mashups.enabler.runtime.skin.Factory.getRuntimeSkinModel();
            this.runtimeNodes.left = runtimeModel.find(this.leftNodeId);
            this.runtimeNodes.right = runtimeModel.find(this.rightNodeId);
			
			var widths = this._getPercentageWidth(dojo.contentBox(this.runtimeNodes.left).w, dojo.contentBox(this.runtimeNodes.right).w); 
			var leftContainerWidth = widths[0];
			var rightContainerWidth = widths[1];
			dojo.attr(this.domNode, "aria-valuetext", dojo.string.substitute(this.a11yValueText, [leftContainerWidth, rightContainerWidth]));
        }
    },
	_showHandle: function() {
		// summary: shows the resize handle
		// #18844 runtimeModel is not ready in view mode
		this._getRuntimeNodes();
		var canResize = (this.runtimeNodes.left.checkStyle(this.runtimeNodes.left.getStyle()) && this.runtimeNodes.right.checkStyle(this.runtimeNodes.left.getStyle()));
		if (canResize && this.domNode) {
			this.domNode.style.display = "block";
		}
	},
	_checkMode: function(/*String*/ mode) {
		// summary: shows the resize handle if we are in page edit mode
		// mode: the page's current mode, the handle will show if mode = "edit"
		var mname = "_checkMode", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		
		if (mode == com.ibm.mm.iwidget.Constants.mode_edit) {
			this._showHandle();
		} else {
			this._hideHandle();
		}
	},
	_beginSizing: function(/*Event*/ e) {
		// summary: called when the user selects the resize handle with the mouse
		// e: event
		var mname = "_beginSizing", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		
		if (this._isSizing) {   // return if the handle is already dragging
			return false; 
		} else {
			this._isSizing = true;
		}
		
		// set the cursor on the body
		dojo.style(dojo.body(), {cursor:dojo.style(this.domNode).cursor});
		this.startX = e.clientX;

		this._getStartValues();	
		this.orignalWidgetsSize=this._getWidgetsSizing();

		this.eventHandles.push(dojo.connect(document, "onmousemove", this, "_changeSizing")); 
		this.eventHandles.push(dojo.connect(document, "onmouseup", this, "_endSizing")); 
		this.eventHandles.push(dojo.connect(document, "onmouseleave", this, "_endSizing")); 
		
		e.preventDefault();		
	},
	_changeKeySizing:function(/*Event*/ key, /*int*/increment){
		// summary: called when the user uses the arrow keys on the resize handle
		// key: key being pressed
		var mname = "_changeKeySizing", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		
		this._getStartValues();		
		
		var leftActualWidth,
			rightActualWidth;
		
		if(key === dojo.keys.RIGHT_ARROW){
			leftActualWidth = this.leftStartWidth + increment;			
			rightActualWidth = this.rightStartWidth - increment;	
		}else if(key === dojo.keys.LEFT_ARROW){			
			leftActualWidth = this.leftStartWidth - increment;
			rightActualWidth = this.rightStartWidth + increment;	
		}
		
		this._updateContainersWidth(leftActualWidth, rightActualWidth);

		// update the text for accessibility
		dojo.attr(this.domNode, 
				"aria-valuetext", 
				dojo.string.substitute(this.a11yValueText, [this.currContainerStyles.left.width, this.currContainerStyles.right.width]));
		
		// save the changes
		this.runtimeNodes.left.setStyle(this.currContainerStyles.left);
		this.runtimeNodes.right.setStyle(this.currContainerStyles.right);
	},
	_changeSizing: function(/*Event*/ e) {
		// summary: called when the user moves the resize handle
		// e: DOM event		
		var leftActualWidth,
			rightActualWidth,
			dx;
		
		if (this.startX > e.clientX){
			// dragging right to left
			dx = this.startX - e.clientX;
			leftActualWidth = this.leftStartWidth - dx;
			rightActualWidth = this.rightStartWidth + dx;
		}else{
			// dragging left to right		
			dx = e.clientX - this.startX;			
			leftActualWidth = this.leftStartWidth + dx;
			rightActualWidth = this.rightStartWidth - dx;	
		}
		
		var isUpdated = this._updateContainersWidth(leftActualWidth, rightActualWidth);
		
		if(!isUpdated){
			// If the style was not updated by the filter, 
			// then grab the values in the DOM to make sure 
			// what is displayed on screen matches what is saved.
			var widths = this._getPercentageWidth(dojo.contentBox(this.layoutParser.findById(this.leftNodeId)).w, dojo.contentBox(this.layoutParser.findById(this.rightNodeId)).w); 
			this.currContainerStyles.left.width = widths[0];
			this.currContainerStyles.right.width = widths[1];
		}
		
		e.preventDefault();
	},
	_endSizing: function(/*Event*/ e) {
		// summary: called when the user stops moving the resize handle, does clean up and then sets the style on the skin
		// e: DOM event
		var mname = "_endSizing", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		
		this._isSizing = false;
		
		// cleanup: reset cursor, set the page as dirty, and disconnect drag handlers
		dojo.style(dojo.body(),{cursor:"default"});
		com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
		while (this.eventHandles.length > 0) {
			dojo.disconnect(this.eventHandles.pop());
		}
		
		// update the text for accessibility
		dojo.attr(this.domNode, 
				"aria-valuetext", 
				dojo.string.substitute(this.a11yValueText, [this.currContainerStyles.left.width, this.currContainerStyles.right.width]));
		
		// save the changes
		this.runtimeNodes.left.setStyle(this.currContainerStyles.left);
		this.runtimeNodes.right.setStyle(this.currContainerStyles.right);
		this._setContainersWidth();
		this._sendResizeEvents();
		this.onEndSizing(this.containerStyles);
	},
	_sendResizeEvents:function(){
		this._sendResizeEventsOnContainer(this._getWidgetsSizing());
	},
	_sendResizeEventsOnContainer:function(widgetSizings){
		var evtSvc = com.ibm.mashups.services.ServiceManager.getService("eventService");
		for(var id in widgetSizings){
			evtSvc.publishEvent(com.ibm.mashups.iwidget.Constants.RESIZE_WIDGET + "." + id, this._updateWidgetSize(widgetSizings[id]));
		}
	},
	_updateWidgetSize:function(newSize){
		var result = {"widgetId":newSize.widgetId};
		result.newHeight= newSize.newContentHeight;
		result.newWidth= newSize.newContentWidth;
		if(!this.orignalWidgetsSize) return result;
		var oldSize= this.orignalWidgetsSize[newSize.widgetId];
		if(!!oldSize){
			//container resizer only update widgets' width, not height.
			//Widget height may changed while doing container resize. This is caused by the automatically generated horizontal scroll bar.
			if (oldSize.newContentHeight > newSize.newContentHeight) {
				result.newHeight = oldSize.newContentHeight;
			}
			var widthGap = (newSize.newMarginWidth - newSize.newContentWidth) -(oldSize.newMarginWidth - oldSize.newContentWidth);
			if(widthGap >0){//While resizing, we do not change the widget style, the gap between margin & content should be fixed, 
							//widthGap means there may be a vertical scroll bar show up during resize, but this scrollbar may not be needed if the widget
							//can handle properly for the size change.
				if(newSize.newContentWidth +widthGap <  newSize.newMarginWidth ){//I don't know any situation that this can be false, just in case.
					result.newWidth =newSize.newContentWidth +widthGap;
				}
			}
			
						
		}
		return result;
	},
	_getWidgetsSizing:function(){
		return dojo.mixin(this._getWidgetsSizingByContainer(this.leftNodeId),this._getWidgetsSizingByContainer(this.rightNodeId));
	},
	
	_getWidgetsSizingByContainer:function(containerId){
		var widgetsSizing={};
		dojo.forEach(this.layoutParser.findControls(this.layoutParser.findById(containerId)),function(control){
			var id = this.layoutParser.extractID(control);
			var div = dojo.query(".lotusWidgetBody",control)[0]; 
			var contentBox =dojo.contentBox(div);
			var marginBox =dojo.marginBox(div);
			var changes = {"widgetId":id};
			changes.newContentWidth = contentBox.w;
			changes.newContentHeight = contentBox.h;
			changes.newMarginWidth = marginBox.w;
			changes.newMarginHeight = marginBox.h;
			widgetsSizing[id]=changes;
		},this);
		return widgetsSizing;
	},
	_setContainersWidth:function(){
		var pid = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
		var navStateModel = com.ibm.mashups.enabler.model.state.NavigationStateModelFactory.getNavigationStateModel();
        var layoutAccessor =  com.ibm.mashups.enabler.model.state.AccessorFactory.getLayoutAccessor(navStateModel, pid);

        // if there is no template url associated with this layout navstate
        // then get it from the page instance
        // and set it here
        if (!layoutAccessor.getTemplateURL()) {
            var navNode = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel().find(pid).start(true);
            var content = navNode.getContent().start(true);
            var templateUrl = content.getStaticContentURL();

            layoutAccessor.setTemplateURL(templateUrl)
        }

		this._setContainerWidth(layoutAccessor,this.leftNodeId, this.rightNodeId);
		navStateModel.commit().start();
	},
	_setContainerWidth:function(layoutAccessor, cidLeft, cidRight){
	    var widths = this._getPercentageWidth(dojo.contentBox(this.layoutParser.findById(cidLeft)).w, dojo.contentBox(this.layoutParser.findById(cidRight)).w);
		var containerAcc = layoutAccessor.getContainerAccessor(cidLeft);
		containerAcc.setSize( widths[0] );
		containerAcc = layoutAccessor.getContainerAccessor(cidRight);
		containerAcc.setSize( widths[1] );
	},
	onEndSizing: function(/*Object*/ styles) {
		// summary: called when the layout has been resized
		// style: an object storing style objects for both containers that were resized, styles.left and styles.right
		//	        a styles object consists of these properties {width, height, left, right}, i.e. styles.left.width
		//			if a style property for the width or height exists, it has s a string format of "XXXXpx"
		//			styles.left has the styles for the container to the left of the resizer
		//			styles.right has the styles for the container to the right of the resizer
	},	
	_getStartValues:function(){		
		// summary: retrieves the values required when starting a resize action
		var mname = "_getStartValues", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		
        this._getRuntimeNodes();
		this.currContainerStyles.left = this.runtimeNodes.left.getStyle();
		this.currContainerStyles.right = this.runtimeNodes.right.getStyle();
	
		this.leftStartWidth = dojo.contentBox(this.layoutParser.findById(this.leftNodeId)).w; 
		this.rightStartWidth = dojo.contentBox(this.layoutParser.findById(this.rightNodeId)).w;
				
		/* In Safari the percentages translate to be 1 pixel smaller by dojo.contentBox
		 * than what is currently displayed on screen, 1 pixel is added to maintain consistency, 
		 * otherwise the containers shrink as you use the arrow keys */
		if(dojo.isSafari){
			this.leftStartWidth++;
			this.rightStartWidth++;
		}
	},
	_updateContainersWidth: function(leftWidth, rightWidth){
		// summary: update the width of the containers in the DOM and 
		//			merge the new width with the current runtime style object
		// leftWidth: the new width of the left container
		// rightWidth: the new width of the right container
		var mname = "_updateContainersWidth", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		
		// convert the width to a percentage
		var widths = this._getPercentageWidth(leftWidth, rightWidth);
		this.containerStyles.left.width = widths[0];
		this.containerStyles.right.width = widths[1];
	
		// check to see if the width is to be updated
		var isUpdated = this.runtimeNodes.left.checkStyle(this.containerStyles.left) && this.runtimeNodes.right.checkStyle(this.containerStyles.right);
		
		if(isUpdated){			
	        // mixin the new widths to the current styles set on the runtime node
			dojo.mixin(this.currContainerStyles.left, this.containerStyles.left);
			dojo.mixin(this.currContainerStyles.right, this.containerStyles.right);
		
			// set the percentage width on the container DOM node
			dojo.style(this.layoutParser.findById(this.leftNodeId), "width", this.containerStyles.left.width);		
			dojo.style(this.layoutParser.findById(this.rightNodeId), "width", this.containerStyles.right.width);		
		}
		
		return isUpdated;
	},
	_getPercentageWidth: function(containerWidth1, containerWidth2){
		// summary: calculates the container width as a percentage of the total layout
		var layoutWidth = dojo.contentBox(this.layoutParser.getRootNode()).w + 1;
		// calculate the first width
		var ret = (containerWidth1 / layoutWidth) * 100;
		// now calculate the second width
		var ret2 = (containerWidth2 / layoutWidth) * 100;
		// calculate the target total percentage
		var target = 95.75;
		if (this.currContainerStyles.left.width && this.currContainerStyles.right.width) {
			// after already calculated the first time, reuse from then on so nothing ever shrinks or grows
			target = parseFloat(this.currContainerStyles.left.width) + parseFloat(this.currContainerStyles.right.width);
		} else {
			// calculate the first time
			target = ((containerWidth1 + containerWidth2) / layoutWidth) * 100;
		}
		// adjust if current total percentage is different from target total percentage
		var adjustment = ((ret+ret2) - target) / 2;
		ret -= adjustment;
		ret2 -= adjustment;

		return [ret+"%", ret2+"%"];
	},
	destroy: function() {
		var mname = "destroy", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		// disconnect all events
		for(var key in this.keyHandles){
			for(var i=0; i<this.keyHandles[key].length; i++){
				dojo.disconnect(this.keyHandles[key][i]);
			}
		}
		while (this.eventHandles.length > 0) {
			dojo.disconnect(this.eventHandles.pop());
		}
		this.inherited(arguments);
		return;
	}
});

}

if(!dojo._hasResource["com.ibm.pb.layout.resize.WidgetResizer"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.layout.resize.WidgetResizer"] = true;
// @author Laura
// This module is a handle that can be attached to a widget skin and used to drag the widge to a different size

dojo.provide("com.ibm.pb.layout.resize.WidgetResizer");




dojo.declare("com.ibm.pb.layout.resize.WidgetResizer", [dijit._Widget, dijit._Templated],{


	
	widgetId: null, 		// id of the widget
	controlId: "",			// the id of the given layout control
	containerId: "",		// the id of the container in which the control resides
	skinNode: null,			// a reference to the control's modifiable runtime skin node which corresponds to the given control
	alwaysShow: false,		// true if the handle should always show, false to show only in edit mode, PLEASE NOTE: you must provide a mechanism to save the resizing in view mode, it is only automatic in edit mode
	controlStyle: {},		// the current style on the skin object from the DOM in dojo.style format
	widgetStyle: {},		// the current style on the widget node from the DOM in dojo.style format
	point: {x:0,y:0},		// the {x,y} coordinates of the dragging handle point
	positionAttrs: {"width":null,"height":null,"top":null,"left":null,"position":"static"},	// list of style attribute names that have to do with position
	templateString: '<div>' +
						'<div dojoAttachPoint="handle" dojoAttachEvent="onmousedown:_beginSizing" class="ibmWidgetResizer lotusRight" style="display:none;"></div>' +
						'<div style="clear: both;"></div>' +
					'<div>',
	
	postCreate: function() {
		// summary: intialize variables and connect events
		this.evtSvc = com.ibm.mashups.services.ServiceManager.getService("eventService");
		this.widgetMovedHandler = this.evtSvc.subscribeEvent("com.ibm.mashups.builder.widgetMoved", this, "_clearStyle");
		
		//This is used to avoid losing position when switching to freeform layout and then dnd a widget
		this.initWidgetHandler = this.evtSvc.subscribeEvent("com.ibm.mashups.builder.initWidgets", this, "_initWidgetsInFreeformLayout");
		if (this.alwaysShow) {
			// if the handle should always be shown, make it visible now
			this._showHandle();
		} else {
			// if the handle should only be shown in page edit mode, attach to the changePageMode event to we know when to show it
			this.changeModeHandler = this.evtSvc.subscribeEvent("com.ibm.mashups.builder.changePageMode", this, "_checkMode");
            if (this.forceShowHandle) {
                this._checkMode(com.ibm.mm.iwidget.Constants.mode_edit);
            }
            else {
                this._checkMode(com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getPageMode());
            }
		}
	},
	
	destroy: function() {
		// summary: destoys the nodes and connections associated with this dijit
		this.evtSvc.unsubscribeEvent(this.widgetMovedHandler, null);
		this.evtSvc.unsubscribeEvent(this.initWidgetHandler, null);
		this.evtSvc.unsubscribeEvent(this.changeModeHandler, null);
		this.widgetId = null;
		this.inherited(arguments);
	},
	
	/** GET/SET STYLE FROM/ON THE SERVER **/
	
	setStyle: function(/*Object*/ style) {
		// summary: called to save a new skin style to the server
		// style: a style object
		//		  if it exists, height is found at style.height and has a string format of "XXXXpx"
		//		  if it exists, width is found at style.width and has a string format of "XXXXpx"
		// a widget instance can be retrieved from the Widget Model API using the ID: this.widgetId
		style = style || {};
		this.skinNode.setStyle(style);
	},
	
	getStyle: function() {
		// returns the style object for the current node from wherever it is stored server-side
		return this.skinNode.getStyle();
	},
	
	_setWidgetStyle: function(/*String*/ style) {
		// summary: along with _setWidgetStyleContinue() sets the wrapper-css-style metadata on the control that will get applied to its widget DOM node
		// style: a string that represents the inline style for the widget DOM node
		var navModel = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel();
		var pageId = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
		var layoutModel = navModel.getLayoutModel(pageId);
		var control = layoutModel.find(this.controlId);
		var me = this;
		control.setFinishedCallback( function(control, status) {
			me._setWidgetStyleContinue(control, status, style);
		}, style);
		control.start(false);
	},
	
	_setWidgetStyleContinue: function(control, status, style) {
		// summary: along with _setWidgetStyle() sets the wrapper-css-style metadata on the control that will get applied to its widget DOM node
		// control: a layout control on which to set the metadata
		// status: the HTTP status result from retrieving the control
		// style: a string that represents the inline style for the widget DOM node
		if (status == 200) {
			control.setMetaData("widget-body-height", style);
		} else {
			console.error("Could not find control when setting wrapper-css-style metadata");
		}
	},
	
	/** RESIZE DOM EVENT FUNCTIONS **/
	
	_beginSizing: function(/*Event*/ e) {
		// summary: called when the user selects the resize handle with the mouse
		// e: DOM event
		if (this._isSizing) {   // return if the handle is already dragging
			return false; 
		} else {
			this._isSizing = true;
		}
		
		// set the drag cursor on the body
		dojo.style(dojo.body(), {cursor:dojo.style(this.handle).cursor});
		
		// store these values so they can be dynamically updated as the handle is dragged: 	
		//				x and y coordinates of the drag handle
		//				the style on the skin/control node
		//				the style on the widget body node
		this.point = {'x':e.clientX, 'y':e.clientY};
		// results of _getDomPositionStyle are mixed together in case the left/height/width attributes are not included in 
		//		the runtime skin style from getStyle() but are present in the DOM and stored elsewhere
		var controlNode = com.ibm.pb.layout.LayoutParser.findById(this.controlId);	
		this.controlStyle  = dojo.mixin(this._getDomPositionStyle(controlNode), this.getStyle()); 
		var widgetNode = dojo.byId(this.widgetId).parentNode;
		this.widgetStyle = this._getDomPositionStyle(widgetNode);
		this.oldSize= this._getWidgetSize();
		
		// connect to events for dragging the mouse
		this.eventHandles = []; 
		this.eventHandles.push(dojo.connect(document, "onmousemove", this, "_changeSizing")); 
		this.eventHandles.push(dojo.connect(document, "onmouseup", this, "_endSizing")); 
		this.eventHandles.push(dojo.connect(document, "onmouseleave", this, "_endSizing")); 

		e.preventDefault();	
	},
	
	_getWidgetSize:function(){
		var size={};
		var control = com.ibm.pb.layout.LayoutParser.findById(this.controlId);
		var div = dojo.query(".lotusWidgetBody",control)[0]; 
		var contentBox =dojo.contentBox(div);
		var marginBox =dojo.marginBox(div);
		size.newContentWidth = contentBox.w;
		size.newContentHeight = contentBox.h;
		size.newMarginWidth = marginBox.w;
		size.newMarginHeight = marginBox.h;
		return size;
	},

	_changeSizing: function(/*Event*/ e) {
		// summary: called when the user moves the resize handle
		// e: DOM event

		// calculate the dy/dx of the drag handle => calculate the new height and width of the control
		var dx = this.point.x - e.clientX;  this.point.x -= dx;
		var dy = this.point.y - e.clientY; 	this.point.y -= dy;
		var oldHeight = this.controlStyle.height;
		this._updatePosition(this.controlStyle, dx, dy);  // changes the height, width and left attributes to incorporate dy/dx
		
		// filter the style and set the resulting style on the skin in the DOM
		// need to create a new style object instead of using this.controlStyle directly to avoid errors in IE
		// the IE errors happen because sometimes this.controlStyle has other attributes in it that are out of our control
		this.skinNode.checkStyle(this.controlStyle);  // NOTE: checkStyle will update the this.controlStyle object
		var controlNode = com.ibm.pb.layout.LayoutParser.findById(this.controlId);	
		var style = {};
		style.height = this.controlStyle.height ? this.controlStyle.height : null;
		style.width = this.controlStyle.width ? this.controlStyle.width : null;
		style.left = this.controlStyle.left ? this.controlStyle.left : null;
		dojo.style(controlNode, style);
		
		// change height on the widget body to reflect changes in the skin height
		// this is to make sure the widget body takes up the full height available to it in the skin
		if (this.controlStyle.height) {
			var dy = parseInt(oldHeight) - parseInt(this.controlStyle.height);
			this._updatePosition(this.widgetStyle, dx, dy);  // changes the height attribute to incorporate dy/dx
			var widgetNode = dojo.byId(this.widgetId).parentNode;
			dojo.style(widgetNode, "height", this.widgetStyle.height);
		}

		e.preventDefault();
	},

	_endSizing: function(/*Event*/ e) {
        // summary: called when the user stops moving the resize handle, does clean up and then sets the style on the skin
		// e: DOM event

	    var currentPage = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage();

		this._isSizing = false;
		
		// cleanup: reset cursor, set the page as dirty, and disconnect drag handlers
		dojo.style(dojo.body(),{cursor:"default"});
		currentPage.setDirty(true);
		while (this.eventHandles.length > 0) {
			dojo.disconnect(this.eventHandles.pop());
		}

		// save the change in skin/control size and widget height
		this.setStyle(this.controlStyle);
		if (this.controlStyle.height) {
			// a height is set on the widget body as well as the skin/control to make sure the widget fills up the entire available height inside the skin
			this._setWidgetStyle(this.widgetStyle.height);
		}

        // if there is no template url
        // associated with this layout navstate
        // then get it from the page instance
        // and set it here
        var navStateModel = com.ibm.mashups.enabler.model.state.NavigationStateModelFactory.getNavigationStateModel();
        var layoutAccessor =  com.ibm.mashups.enabler.model.state.AccessorFactory.getLayoutAccessor(navStateModel, currentPage.getID());

        if (!layoutAccessor.getTemplateURL()) {
            var navNode = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel().find(currentPage.getID()).start(true);
            var content = navNode.getContent().start(true);
            var templateUrl = content.getStaticContentURL();

            layoutAccessor.setTemplateURL(templateUrl)
        }
        
		// save the new control size in the NavState
		var navStateModel = com.ibm.mashups.enabler.model.state.NavigationStateModelFactory.getNavigationStateModel();
		var accessorFactory = com.ibm.mashups.enabler.model.state.AccessorFactory;
		var widgetAccessor = accessorFactory.getWidgetAccessor(navStateModel, this.widgetId);
		widgetAccessor.setSize(this.controlStyle.width, this.controlStyle.height);
		navStateModel.commit().start();

		// broadcast the widget change size event to tell the widget it can reflow since its size has changed
		// create a new changes object instead of just using {height:this.controlStyle.height,width:this.controlStyle.width} 
		//			because if either height or width is null, errors are thrown
		var box = this._getBoxWithScroll();
		var changes = {"widgetId":this.widgetId};
		if (this.controlStyle.width) {
			changes.newWidth = parseInt(this.controlStyle.width);
		}else {
			changes.newWidth=box.w;
		}
		if (this.controlStyle.height) {
			changes.newHeight = parseInt(this.widgetStyle.height);
		}else {
			changes.newHeight = box.h;
		}
		this.evtSvc.publishEvent(com.ibm.mashups.iwidget.Constants.RESIZE_WIDGET + "." + this.widgetId, changes);
		this.evtSvc.publishEvent("com.ibm.mashups.builder.resizeWidget", changes);  // needed for freeform layout
	},
	
	_getSizeWithScroll:function(oldSize,newSize,dimension){
		var gap = (newSize["newMargin"+dimension] - newSize["newContent"+dimension]) -(oldSize["newMargin"+dimension] - oldSize["newContent"+dimension]);
		if(gap >0){//While resizing, we do not change the widget style, the gap between margin & content should be fixed, 
						//gap means there may be a scroll bar show up during resize, but this scrollbar may not be needed if the widget
						//can handle properly for the size change.
			if(newSize["newContent"+dimension] +gap < newSize["newMargin"+dimension] ){//I don't know any situation that this can be false, just in case.
				return newSize["newContent"+dimension] +gap;
			}
		}
		return newSize["newContent"+dimension];
	},
	
	_getBoxWithScroll:function(){
		var newSize = this._getWidgetSize();
		var result = {h:newSize.newContentHeight,w:newSize.newContentWidth};
		if(!this.oldSize) return result;
		result.h= this._getSizeWithScroll(this.oldSize,newSize,"Height");
		result.w= this._getSizeWithScroll(this.oldSize,newSize,"Width");
		return result;
	},
	
	/** HANDLE HELPERS **/
	
	_hideHandle: function() {
		// summary: hides the resize handle
		if(this.handle) {
			dojo.style(this.handle,'display',"none");
		}
	},
	
	_showHandle: function() {
		// summary: shows the resize handle
		// #18844 runtimeModel is not ready in view mode
		if (!this.skinNode) {
			var runtimeModel = com.ibm.mashups.enabler.runtime.skin.Factory.getRuntimeSkinModel();
			this.skinNode = runtimeModel.find(this.controlId);
			//#19026 lazy find when first time show the resize handle
			var controlNode = com.ibm.pb.layout.LayoutParser.findById(this.controlId);	
			this.containerId = com.ibm.pb.layout.LayoutParser.extractID(controlNode.parentNode);
		}
		var canResize = this.skinNode.checkStyle(this.getStyle());
		if (canResize && this.handle) {
			dojo.style(this.handle,'display',"block");
		}
	},
	
	/** FUNCTIONS FOR ATTACHING TO ENABLER EVENTS **/
	
	_checkMode: function(/*String*/ mode) {
		// summary: shows the resize handle if we are in page edit mode
		// mode: the page's current mode, the handle will show if mode = "edit"
		if (mode == com.ibm.mm.iwidget.Constants.mode_edit) {
			this._showHandle();
		} else {
			this._hideHandle();
		}
	},
	_initWidgetsInFreeformLayout: function(iEvent){
		this.containerId = iEvent.containerId;
	},
	_clearStyle: function(/*string*/ id) {
		// summary: clears out styles that have been set on the skin and widget nodes on the server and in the DOM
		//			ONLY triggered if the control has been moved to another container
		// id: id for which the styles should be cleared
		if (this.controlId != id) {
			// not me
			return;
		}
		
		var controlNode = com.ibm.pb.layout.LayoutParser.findById(this.controlId);	
		var newContainerId = com.ibm.pb.layout.LayoutParser.extractID(controlNode.parentNode);
		if (newContainerId != this.containerId) {
			this.containerId = newContainerId;
			// clear the position attributes from the current style
			var noPositionStyle = this._removePositionFromStyle(this.getStyle());
			// save the control and widget style to the server
			this.setStyle(noPositionStyle);
			this._setWidgetStyle("");
			// clear the styles in the DOM too
			var w = dojo.byId(this.widgetId);
			if(w) { 
				if(dojo.isSafari) {
					dojo.style(w.parentNode, "height", null);
				} else {
					w.parentNode.removeAttribute("style");
				}
			}
			dojo.style(controlNode, this.positionAttrs);
			// clear the runtime model cache for this node
			var rsModel = com.ibm.mashups.enabler.runtime.skin.Factory.getRuntimeSkinModel();
			rsModel.invalidate(this.skinNode);
		}
	},
	
	/** HELPERS TO MANIPULATE STYLE OBJECTS **/
	
	_removePositionFromStyle: function(/*Object*/ style) {
		// summary: removes all the DOM attributes having to do with position from a given style object
		//			for example, this is done when a widget is moved into a different container and needs to be reset
		// style: the style object to manipulate
		for (var i in this.positionAttrs) {
			if (style[i]) {
				delete style[i];
			}
		}
	},
	
	_getDomPositionStyle: function(/*DOMNode*/ node) {
		// summary: returns a style object with only height/width/left?/top? attributes
		//			style attributes are retrieved from the DOM
		// node: the DOM node for which to get the style
		var dBox = dojo.contentBox(node);
		var dStyle = dojo.style(node);
		var ret = {};
		ret.height = dStyle.height;
		if (ret.height == "auto") {
			ret.height = dBox.h + "px";
		}
		ret.width = dStyle.width;
		if (ret.width == "auto") {
			ret.width = dBox.w + "px";
		}
		if (dStyle.left != "auto") {
			ret.left = dStyle.left;
		}
		if (dStyle.right != "auto") {
			ret.right = dStyle.right;
		}
		return ret;
	},
	
	_updatePosition: function(/*Object*/ style, /*int*/ dx, /*int*/ dy) {
		// summary: updates a size object using dx/dy, the style object pass in will be updated
		// style: CSS style object
		// dx: change in x direction in pixels
		// dy: change in y direction in pixels
		var width = parseInt(style.width);
		var height = parseInt(style.height);
		if (width && dx) {
			if (!ibmCfg.themeConfig.isRTL) {
				style.width = width - dx + "px";
			} else {
				style.width = width + dx + "px";
				// adjust the left parameter in RTL mode 
				// so the widget doesn't jump to the right
				var left = parseInt(style.left);
				if (left) {
					style.left = left - dx + "px";
				}
			}
		}
		if (height && dy) {
			style.height = height - dy + "px";
		}
	}
});

}

if(!dojo._hasResource["com.ibm.pb.layout.filters.ContainerStyleFilter"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.layout.filters.ContainerStyleFilter"] = true;
// @author Laura
// This module implements the com.ibm.mashups.enabler.runtime.skin.StyleFilter interface
// It is meant to be applied to a layout container
// Other modules should inherit from this and overwrite the _isAgree and _filterStyle functions to make any changes
// known to inherit : 	com.ibm.pb.layout.filters.ColumnContainerStyleFilter
//						com.ibm.pb.layout.filters.RowContainerStyleFilter
//						com.ibm.pb.layout.filters.FreeFormContainerStyleFilter

dojo.provide("com.ibm.pb.layout.filters.ContainerStyleFilter");

dojo.declare("com.ibm.pb.layout.filters.ContainerStyleFilter", [com.ibm.mashups.enabler.runtime.skin.StyleFilter], {

	widgetMaxHeight: 10000,	// widget maximum height in pixels
	widgetMaxWidth: 10000,	// widget maximum width in pixels
	widgetMinWidth: 100,	// widget minimum width in pixels
	widgetMinHeight: 80,	// widget minimum height in pixels
	containerMinWidth: 5, 	// container minimum width in a percentage
	
	onChangingStyle: function(layoutNode, oldStyle, newStyle, filterControl, filterChain) {
		// summary: set disagree if _isAgree returns false, then trigger the next filter
		// 			gets called as part of the filter chain triggered when checkStyle() is called on a runtime skin node
		var node = com.ibm.pb.layout.LayoutParser.findById(layoutNode.getID());
        if (!this._isAgree(layoutNode, node, oldStyle, newStyle)) {
			filterControl.setDisagree();   
        }
		this._filterStyle(layoutNode, node, oldStyle, newStyle);
		filterChain.doFilter(layoutNode, oldStyle, newStyle, filterControl);
    },
    
    onChangeStyle: function(layoutNode, oldStyle, newStyle, filterChain) {
		// summary: filter the new style and call the next filter if _isAgree returns true
		// 			gets called as part of the filter chain triggered when setStyle() is called on a modifiable runtime skin node
		var node = com.ibm.pb.layout.LayoutParser.findById(layoutNode.getID());
        if (this._isAgree(layoutNode, node, oldStyle, newStyle)) {
			this._filterStyle(layoutNode, node, oldStyle, newStyle);
            filterChain.doFilter(layoutNode, oldStyle, newStyle);
        }
    },
	
	_isContainer: function(layoutNode) {
		// summary: returns true if the given node is a layout container
		return (layoutNode instanceof com.ibm.mashups.enabler.layout.LayoutContainer);
	},
	
	_isControl: function(layoutNode) {
		// summary: returns true if the given node is a layout control
		return (layoutNode instanceof com.ibm.mashups.enabler.layout.LayoutControl);
	},
	
	_isAgree: function(layoutNode, node, oldStyle, newStyle) {
		// summary: return true if the new style is allowed, false otherwise
		return true;
	},
	
	_filterStyle: function(layoutNode, node, oldStyle, newStyle) {
		// summary: makes any needed changes to the newStyle object
	}
});

}

if(!dojo._hasResource["com.ibm.pb.layout.filters.ColumnContainerStyleFilter"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.layout.filters.ColumnContainerStyleFilter"] = true;
dojo.provide("com.ibm.pb.layout.filters.ColumnContainerStyleFilter");

dojo.declare("com.ibm.pb.layout.filters.ColumnContainerStyleFilter", [com.ibm.pb.layout.filters.ContainerStyleFilter], {
	// corresponds to a column container type
	
    _filterStyle: function(layoutNode, node, oldStyle, newStyle) {
		if (this._isControl(layoutNode)) {
			// resize widget
			// widgets in columns cannot change width, it should be fluid
			if (newStyle.width){
				delete newStyle.width;
			}
			// make sure the widget is not too tall
			if (parseInt(newStyle.height) > this.widgetMaxHeight) {
				newStyle.height = this.widgetMaxHeight + "px";
			}
			// make sure the widget is not too short
			if (parseInt(newStyle.height) < this.widgetMinHeight) {
				newStyle.height = this.widgetMinHeight + "px";
			}
		} else if (this._isContainer(layoutNode)) {
			// resizer container
			if(parseInt(newStyle.width) < this.containerMinWidth){
				newStyle.width = this.containerMinWidth+"%";
			}
		}
	},
	_isAgree: function(layoutNode, node, oldStyle, newStyle) {
		// summary: return true if the new style is allowed, false otherwise
		if (this._isContainer(layoutNode)) {
			if(parseInt(newStyle.width) < this.containerMinWidth){
				return false;
			}
		}
		return true;
	}
});

}

if(!dojo._hasResource["com.ibm.pb.layout.filters.RowContainerStyleFilter"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.layout.filters.RowContainerStyleFilter"] = true;
dojo.provide("com.ibm.pb.layout.filters.RowContainerStyleFilter");

dojo.declare("com.ibm.pb.layout.filters.RowContainerStyleFilter", [com.ibm.pb.layout.filters.ContainerStyleFilter], {
	// corresponds to a row container type
	
    _filterStyle: function(layoutNode, node, oldStyle, newStyle) {
		if (this._isControl(layoutNode)) {
			// resize widget
			// widgets in rows cannot change height, it should be fluid
			if (newStyle.height){
				delete newStyle.height;
			}
			// make sure widget is not too wide (ie: extends beyond its container)
			var maxWidth = dojo.contentBox(node.parentNode).w;
			if (parseInt(newStyle.width) > maxWidth) {
				newStyle.width = maxWidth + "px";
			}
			// make sure the widget is not too thin
			if (parseInt(newStyle.width) < this.widgetMinWidth) {
				newStyle.width = this.widgetMinWidth + "px";
			}
		} else if (this._isContainer(layoutNode)) {
			// resizer container
			if(parseInt(newStyle.width) < this.containerMinWidth){
				newStyle.width = this.containerMinWidth+"%";
			}
		}
	},
	_isAgree: function(layoutNode, node, oldStyle, newStyle) {
		// summary: return true if the new style is allowed, false otherwise
		if (this._isContainer(layoutNode)) {
			if(parseInt(newStyle.width) < this.containerMinWidth){
				return false;
			}
		}
		return true;
	}
});

}

if(!dojo._hasResource["com.ibm.pb.layout.filters.FreeFormContainerStyleFilter"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.layout.filters.FreeFormContainerStyleFilter"] = true;
dojo.provide("com.ibm.pb.layout.filters.FreeFormContainerStyleFilter");

dojo.declare("com.ibm.pb.layout.filters.FreeFormContainerStyleFilter", [com.ibm.pb.layout.filters.ContainerStyleFilter], {
	// corresponds to a free form container type
	
    _filterStyle: function(layoutNode, node, oldStyle, newStyle) {
		if (this._isControl(layoutNode)) {
			// resize widget
			var maxWidth = dojo.contentBox(node.parentNode).w - dojo.style(node, "left");
			// make sure the widget is not too wide (ie extends beyond its container)
			if (parseInt(newStyle.width) > maxWidth) {
				newStyle.width = maxWidth + "px";
			}
			// make sure the widget is not too tall
			if (parseInt(newStyle.height) > this.widgetMaxHeight) {
				newStyle.height = this.widgetMaxHeight + "px";
			}
			// make sure the widget is not too thin
			if (parseInt(newStyle.width) < this.widgetMinWidth) {
				newStyle.width = this.widgetMinWidth + "px";
			}
			// make sure the widget is not too short
			if (parseInt(newStyle.height) < this.widgetMinHeight) {
				newStyle.height = this.widgetMinHeight + "px";
			}
		} else if (this._isContainer(layoutNode)) {
			// resizer container
			if(parseInt(newStyle.width) < this.containerMinWidth){
				newStyle.width = this.containerMinWidth+"%";
			}
		}
	},
	_isAgree: function(layoutNode, node, oldStyle, newStyle) {
		// summary: return true if the new style is allowed, false otherwise
		if (this._isContainer(layoutNode)) {
			if(parseInt(newStyle.width) < this.containerMinWidth){
				return false;
			}
		}
		return true;
	}
});

}

if(!dojo._hasResource["com.ibm.pb.extension.Operations"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.extension.Operations"] = true;
dojo.provide("com.ibm.pb.extension.Operations");

dojo.declare("com.ibm.pb.extension.SimpleOperation", [com.ibm.mashups.enabler.ac.operation.Operation], {
	allowed: false,
	constructor: function(allowed, finished) {
		this.allowed = allowed;
		if(finished) {
			finished(this);
		}
	},
	isAllowed: function(context){
		return this.allowed;
	}
});

(function(){
	var ops = com.ibm.pb.extension.Operations = {
		PAGE_ACTIONS: "com.ibm.pb.extension.Operations.pageActions",
		CREATE_PAGE: "com.ibm.pb.extension.Operations.createPage"
	}, 	simpleOp = com.ibm.pb.extension.SimpleOperation,
		enabler = com.ibm.mashups.enabler,
		allowedOpsModel = enabler.ac.operation.AllowedOperationsModelFactory.getAllowedOperationsModel(),
		navModel = enabler.navigation.Factory.getNavigationModel(),
		navConstants = enabler.navigation.Constants;
	
	/**
	 * PAGE_ACTIONS operation by default is allowed if the user is logged in.
	 */
	allowedOpsModel.setOperation(ops.PAGE_ACTIONS, function(opName, jsonContext, sync, finished){
		new simpleOp(enabler.user.Factory.getUserModel().getAnonymousMode() != enabler.user.AnonymousMode.ANONYMOUS, finished);
	});
	
	/**
	 * CREATE_PAGE operation by default is allowed if the user can insert a private node
	 * under the jsonContext.navNode|contentNode of if the user can insert a public node under
	 * the jsonContext.navNode|contentNode .
	 */
	allowedOpsModel.setOperation(ops.CREATE_PAGE, function(opName, jsonContext, sync, finished){
		var currentNavNode = jsonContext.navNode || jsonContext.contentNode,
			canCreatePage = dojo.some([true, false], function(isPrivate){
				var res = false, args = {type: navConstants.NAVIGATION_PAGE};
				if(isPrivate) {
					args["private"] = true;
				}
				if(navModel.confirmCreate(args)){
					var dummyPage = navModel.create(args);
					res = navModel.confirmInsert(dummyPage,currentNavNode);
				}
				return res;
			});
		new simpleOp(canCreatePage, finished);
	});
		
})();

}

if(!dojo._hasResource["com.ibm.pb.extension.contextmenu.ContextMenuAcOperation"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.extension.contextmenu.ContextMenuAcOperation"] = true;
dojo.provide("com.ibm.pb.extension.contextmenu.ContextMenuAcOperation");
dojo.declare("com.ibm.pb.extension.contextmenu.ContextMenuAcOperation", [com.ibm.mashups.enabler.ac.operation.Operation], {
	id: "none",
	url: "",
	sync: true,
	roleCheck: "",
	finished: null,
	allowed: false,
	
    constructor: function(id, url, sync, roleCheck, finished){
		if(!com.ibm.pb.extension.contextmenu.ContextMenuAcOperation.allowedOperations) com.ibm.pb.extension.contextmenu.ContextMenuAcOperation.allowedOperations = {};
		this.id = id;
		this.url = url;
		this.sync = sync;
		this.roleCheck = roleCheck;
		this.finished = finished || function(){};
		this._checkForFeed();
    },
	
	_checkForFeed: function(){
		if(com.ibm.pb.extension.contextmenu.ContextMenuAcOperation.allowedOperations[this.id]) {
			if(com.ibm.pb.extension.contextmenu.ContextMenuAcOperation.allowedOperations[this.id][this.roleCheck]) { this.allowed = true; }
			else { this.allowed = false; }
			this.finished(this);
		} else {
			this._getXml();
		}
	},
	
	_getXml: function(){
		var me = this,
			useString = dojo.isIE || dojo.isOpera || dojo.isFF < 3.5;
		dojo.xhrGet ({
			url: this.url,
			handleAs: (useString) ? "text" : "xml",
			sync: this.sync,
			load: function(data){
				var xml = data;
				com.ibm.pb.extension.contextmenu.ContextMenuAcOperation.allowedOperations[me.id] = {};
				if(useString){
					var menuItems = xml.match(/label="(\w+)"/g);
					for(var i in menuItems){
						if((typeof menuItems[i]) == "string") {
							var label = menuItems[i].substring(7,menuItems[i].length-1);
							com.ibm.pb.extension.contextmenu.ContextMenuAcOperation.allowedOperations[me.id][label] = true;
						}
					}
				} else {
					var menuItems = xml.querySelectorAll("menuitem");
					for(var i in menuItems){
						if(menuItems[i].getAttribute){
							var label = menuItems[i].getAttribute("label");
							com.ibm.pb.extension.contextmenu.ContextMenuAcOperation.allowedOperations[me.id][label] = true;
						}
					}
				}
				me._checkForFeed();
			}
		});
	},
	
	isAllowed: function(context){
		return this.allowed;
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.constant"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.constant"] = true;
/**
 * @author Marshall (shiwcsdl@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.constant");

com.ibm.mm.builder.constant = {
	//remove, useless
	appURL: "http://localhost:8080",
	
	enablerModelIdPrefix:"id:",
	
	iwIWidget: "iw-iWidget",//iWidget spec v1
	
	iWStandalone: "iw-Standalone",
	
	mmIWidget: "mm_iWidget",//legacy
	
	iwOAGadget: "iw-OAGadget", //openAjax
	
	mmOAGadget: "mm_OAGadget", //openAjax
	
	iwGGadget: "iw-OSGadget", //OpenSocial Gadget
	
	mmGGadget: "mm_OSGadget", //OpenSocial Gadget
	
	osGadgetChrome: "gadgets-gadget-chrome",
	
	osGadgetUserPrefs: "gadgets-gadget-user-prefs-dialog",
	
	osGadgetContent: "gadgets-gadget-content",

	
	iwDefinition:"iw-Definition", //iWidget spec v1
	
	mmDefinition:"mm_Definition", //legacy
	
	iwItemSet: "iw-ItemSet",//iWidget spec v1
	
	mmItemSet: "mm_ItemSet",//legacy
	
	iwItem: "iw-Item",//iWidget spec v1
	
	mmItem: "mm_Item",//legacy
	
	generic_widget_icon: "/mum/images/generic_widget_icon.gif",
	
	skinIdPrefix: "mm_ibm_skin_",
	
	skinClass: "iWidgetSkin",
	
	dragHandler: "_dragHandler",
	
	resizeHandler: "_resizer",
	
	resizeHandlerExt: "_res",
	
	resizeHeightExt: "_heightRes",
	
	widgetBody: "_widgetBody",
	
	widgetContent: "_content",
	
	menuHandler: "_menu",
	
	iWidgetContent: "mm_Content",
	
	iwWidgetContent: "iw-Content",
	
	iWidgetLoading: "mm_loading",
	
	iwWidgetLoading: "iw-loading",
	
	handledEvents: "mm_handledEvents",
	
	event: "mm_event",
	
	publishedEvents: "mm_publishedEvents",
	
	iwReceivedEvent: "iw-ReceivedEvent",//iWidget spec v1
	
	receivedEvent: "mm_ReceivedEvent",//legacy
	
	iwEvent:"iw-Event",//iWidget spec v1
	
	mmEvent:"mm_Event",//legacy
	
	sourceWidget: "mm_SourceWidget",
	
	mmSourceEventName:"mm_SourceEventName",//iWidget spec v1
	
	mmTargetEventName:"mm_TargetEventName",//iWidget spec v1
	
	iwSourceEvent: "iw-SourceEvent",
	
	iwTargetEvent: "iw-TargetEvent",
	
	sourceEvent: "mm_SourceEvent",
	
	targetEvent: "mm_TargetEvent",
	
	itemSet: "mm_itemSet",//to be removed, replaced by mmItemSet
	
	item: "mm_item",
	
	itemName: "mm_itemName",//to be removed, replaced by mmItemSet
	
	itemValue: "mm_itemValue",//to be removed, replaced by mmItemSet
	
	configPannelNode: "configPannelNode",
	
	widget_span_attr_class: "class",
	
	widget_span_attr_widget: "widget",//to be removed, replaced by mmDefinition
	
	widget_span_attr_style: "style",
	
	widget_span_attr_onNewWire: "onnewwire", //to be removed, enabler will handle onNewWire/onRemoveWire
	
	widget_span_attr_id: "id",
	
	widget_span_attr_visible: "visible",
	
	widget_span_attr_skin: "skin",
	
	nva_skin_upper: "_upper",
	
	no_page_message:"No page to show. Please use navigation widget to create a new page.",
	
	aclIdPrefix:"_acl",
	
	editbarDragHandler:"_dragHandler_editbar",
	
	freeformLayoutClass:"freednd",
	
	columnLayoutClass:"fixeddnd",
	
	HWCClass:"nva",
	
	toolboxClass:"toolbox",
	
	nvaSkinName:"nva",
	
	layoutWidgetItemSet:"LayoutWidgetAttributes",
	
	autoWiringEnabled: "com.ibm.mashups.builder.autoWiringEnabled",
	
	dbcsEnlarged: "dbcsEnlarged",
	/**
	 * navigation pagination number, default is 5; 
	 * adjust by the whole page reslovation and item height
	 */
	NavigationPageSize: 20,
	
	ToolboxPageSize: 20,
	
	editBarHeight:35,
	
	/**
	 * Send XmlHttpRequest to backend to keep session alive
	 * Current value: 5 minutes
	 */
	intervalToKeepSessionAlive:5*60*1000,
	
	defaultWidgetWidth : 400,
	
	cookieKey_previous_pid: "digest.ignore.previous_pid",
	cookieKey_globalPageId: "digest.ignore.global_page_id",
	cookieKey_globalPageOpenedSpaceId: "digest.ignore.global_page_id_openedSpace"
};

}

if(!dojo._hasResource["com.ibm.mm.builder.utils.htmlUtil"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.utils.htmlUtil"] = true;
dojo.provide("com.ibm.mm.builder.utils.htmlUtil");



com.ibm.mm.builder.utils.htmlUtil.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.utils.htmlUtil");

//OpenSocial support change
if (this.widgetType !== null && this.widgetType=="mm_OSGadget"){
	com.ibm.mm.builder.utils.htmlUtil.widgetClass = new RegExp("\\b"+com.ibm.mm.builder.constant.mmGGadget+"\\b");
} else {
	com.ibm.mm.builder.utils.htmlUtil.widgetClass = new RegExp("\\b"+com.ibm.mm.builder.constant.mmIWidget+"\\b");
}
	
com.ibm.mm.builder.utils.htmlUtil.classMatchType = {
	ContainsAll : 0, // all of the classes are part of the node's class (default)
	ContainsAny : 1, // any of the classes are part of the node's class
	IsOnly : 2 // only all of the classes are part of the node's class
};

com.ibm.mm.builder.utils.htmlUtil.endsWith = function(/*string*/str, /*string*/end, /*boolean*/ignoreCase){
// summary:
//	Returns true if 'str' ends with 'end'

	if(ignoreCase){
		str = str.toLowerCase();
		end = end.toLowerCase();
	}
	if((str.length - end.length) < 0){
		return false; // boolean
	}
	return str.lastIndexOf(end) == str.length - end.length; // boolean
};

com.ibm.mm.builder.utils.htmlUtil.startsWith = function(/*string*/str, /*string*/start, /*boolean*/ignoreCase){
	// summary:
	//	Returns true if 'str' starts with 'start'
	if(ignoreCase) {
		str = str.toLowerCase();
		start = start.toLowerCase();
	}
	return str.indexOf(start) === 0; // boolean
};

com.ibm.mm.builder.utils.htmlUtil.getAttribute = function(/* HTMLElement */node, /* string */attr){

	node = dojo.byId(node);

	if((!node)||(!node.getAttribute)){
		// if(attr !== 'nwType'){
		//	alert("getAttr of '" + attr + "' with bad node"); 
		// }
		return null;
	}
	var ta = typeof attr == 'string' ? attr : new String(attr); // JSLINT-IGNORE: 

	// first try the approach most likely to succeed
	var v = node.getAttribute(ta.toUpperCase());
	if((v)&&(typeof v == 'string')&&(v!="")){ 
		return v;	//	string 
	}

	// try returning the attributes value, if we couldn't get it as a string
	if(v && v.value){ 
		return v.value;	//	string 
	}

	// this should work on Opera 7, but it's a little on the crashy side
	if((node.getAttributeNode)&&(node.getAttributeNode(ta))){
		return (node.getAttributeNode(ta)).value;	//	string
	}else if(node.getAttribute(ta)){
		return node.getAttribute(ta);	//	string
	}else if(node.getAttribute(ta.toLowerCase())){
		return node.getAttribute(ta.toLowerCase());	//	string
	}
	return null;	//	string
};

com.ibm.mm.builder.utils.htmlUtil.getParentByType = function(/* HTMLElement */node, /* string */type) {
	//	summary
	//	Returns the first ancestor of node with tagName type.

	var _document = dojo.doc;
	var parent = dojo.byId(node);
	type = type.toLowerCase();
	while((parent)&&(parent.nodeName.toLowerCase()!=type)){
		if(parent==(_document.body||_document.documentElement)){
			return null;
		}
		parent = parent.parentNode;
	}
	return parent;	//	HTMLElement
};

com.ibm.mm.builder.utils.htmlUtil.hasAttribute = function(/* HTMLElement */node, /* string */attr){
	//	summary
	//	Determines whether or not the specified node carries a value for the attribute in question.
	return com.ibm.mm.builder.utils.htmlUtil.getAttribute(dojo.byId(node), attr) ? true : false;	//	boolean
};

com.ibm.mm.builder.utils.htmlUtil.hasClass = function(/* HTMLElement */node, /* string */classname){
	return (new RegExp('(^|\\s+)'+classname+'(\\s+|$)')).test(com.ibm.mm.builder.utils.htmlUtil.getClass(node));	//	boolean
};

com.ibm.mm.builder.utils.htmlUtil.addClass = function(/* HTMLElement */node, /* string */classStr){
	//	summary
	//	Adds the specified class to the end of the class list on the
	//	passed &node;. Returns &true; or &false; indicating success or failure.
	if (com.ibm.mm.builder.utils.htmlUtil.hasClass(node, classStr)) {
	  return false;
	}
	classStr = (com.ibm.mm.builder.utils.htmlUtil.getClass(node) + " " + classStr).replace(/^\s+|\s+$/g,"");
	return com.ibm.mm.builder.utils.htmlUtil.setClass(node, classStr);	//	boolean
};

com.ibm.mm.builder.utils.htmlUtil.setClass = function(/* HTMLElement */node, /* string */classStr){
	//	summary
	//	Clobbers the existing list of classes for the node, replacing it with
	//	the list given in the 2nd argument. Returns true or false
	//	indicating success or failure.
	node = dojo.byId(node);
	var cs = new String(classStr); // JSLINT-IGNORE: 
	try{
		if(typeof node.className == "string"){
			node.className = cs;
		}else if(node.setAttribute){
			node.setAttribute("class", classStr);
			node.className = cs;
		}else{
			return false;
		}
	}catch(e){
		com.ibm.mm.builder.utils.htmlUtil.LOGGER.severe("setClass",dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.E_HTML_UTIL_SET_CLASS_1,[e.message]));
	}
	return true;
};

com.ibm.mm.builder.utils.htmlUtil.getClass = function(/* HTMLElement */node){
	//	summary
	//	Returns the string value of the list of CSS classes currently assigned directly 
	//	to the node in question. Returns an empty string if no class attribute is found;
	node = dojo.byId(node);
	if(!node){ return ""; }
	var cs = "";
	if(node.className){
		cs = node.className;
	}else if(com.ibm.mm.builder.utils.htmlUtil.hasAttribute(node, "class")){
		cs = com.ibm.mm.builder.utils.htmlUtil.getAttribute(node, "class");
	}
	return cs.replace(/^\s+|\s+$/g, "");	//	string
};

com.ibm.mm.builder.utils.htmlUtil.getClasses = function(/* HTMLElement */node) {
	var c = com.ibm.mm.builder.utils.htmlUtil.getClass(node);
	return (c == "") ? [] : c.split(/\s+/g);	//	array
};

com.ibm.mm.builder.utils.htmlUtil.getChildrenbyClass = function(clzName,parent) {
	var iwidgetsSpan = dojo.query("." + clzName,parent);
	var len = iwidgetsSpan.length;
	var children = [];
	for (var x=0;x<len;x++){
		if (com.ibm.mm.builder.utils.htmlUtil.isDirectChild(iwidgetsSpan[x],parent)){
			children.push(iwidgetsSpan[x]);
		}
	}
	return children;
};

com.ibm.mm.builder.utils.htmlUtil.setUnderlayBgColor = function(){
	var bodyNode = document.getElementsByTagName("BODY")[0];
	var tags = dojo.query(".dijitDialogUnderlay", bodyNode);
	var len =  tags.length;
	for (var k=0;k<len;k++){
		dojo.style(tags[k], {
			background: "black",
			opacity: "0.35",
			filter: "progid:DXImageTransform.Microsoft.Alpha(style=0,opacity=0.35"
		});
	}		
};



// to check if there is any span named iw:iWidget, between child and parent
com.ibm.mm.builder.utils.htmlUtil.isDirectChild = function(child,parent){
	var clzName = child.className;
	var pNode = child.parentNode;
	while (pNode!=parent){
		if (pNode.className == clzName){
			return false;
		}else{
			pNode = pNode.parentNode;
		}
	}
	return true;
};

com.ibm.mm.builder.utils.htmlUtil.getDirectChildrenbyClass = function(clzName,parent) {
	var iwidgetsSpan = dojo.query("." + clzName,parent);
	var len = iwidgetsSpan.length;
	var children = [];
	for (var x=0;x<len;x++){
		if (iwidgetsSpan[x].parentNode == parent){
			children.push(iwidgetsSpan[x]);
		}
	}
	return children;
};

com.ibm.mm.builder.utils.htmlUtil.combineTwoColumn = function(root,left,right){
	if (this.endsWith(root,"/>")){
		root = root.substr(0,root.length - 2);
		root = root + ">\n";
	}else{
		if (this.endsWith(root,"</div>",true)){
			root = root.substr(0,root.length - 6)+"\n";
		}else{
			return "";
		}
	}
	root = root + left;
	root = root + right;
	root = root + "</div>";
	return root;
};

com.ibm.mm.builder.utils.htmlUtil.getElementById = function(parentNode, tagId) {
    var retval = null;
    var childTags = parentNode.getElementsByTagName("*");
    for (var ii=0; ii<childTags.length; ii++) {
        if (childTags[ii].id == tagId) {
            retval = childTags[ii];
            break;
        }
    }
    return (retval);
};
	
com.ibm.mm.builder.utils.htmlUtil.getElementsByClassName = function() {
	var retval = [];
	var searchTags= ["div", "span"];
	for (index=0;index<searchTags.length;index++) {
		els = document.getElementsByTagName(searchTags[index]);
		var elsLen = els.length;
		for (var i=0;i<elsLen; i++) {
			if ( this.widgetClass.test(els[i].className)) {
				retval[retval.length] = els[i];
				
			}
        }
	}
	return retval;
};
	
com.ibm.mm.builder.utils.htmlUtil.getElementString = function(node) {
	var ndiv = document.createElement("div");
	var clonedNode = node.cloneNode(true);
	ndiv.appendChild(clonedNode);
	return ndiv.innerHTML;
};

// Following methods are never called, to be removed.
/*
com.ibm.mm.builder.utils.htmlUtil.addOnclickToElement = function(element,func){
	if (element.attachEvent){
		//IE
		element.attachEvent("onclick",function(){eval(func);}); 
	}else{
		//FF
		element.setAttribute("onclick","javascript:"+func);
	}
};


com.ibm.mm.builder.utils.htmlUtil.removeOnclickFromElement = function(element,func){
	if (element.detachEvent){
		//IE TODO: this does not work, how to detach the onclick event?
		element.detachEvent("onclick",function(){eval(func);});
	}else{
		//FF
		element.removeAttribute("onclick");
	}		
};
*/

com.ibm.mm.builder.utils.htmlUtil.getInclosedWidgets = function(node) {
	var retval = [];
	if (node !== null) {		
		var allWidgets = this.getElementsByClassName();
		if (allWidgets && allWidgets.length>0) {
			for (var index=0;index<allWidgets.length;index++) {
				var aNode = allWidgets[index];
				if (node == this.getWidgetParent(aNode)) {
					retval[retval.length] = aNode;
				}
			}
		}
	}
	return retval;
};

com.ibm.mm.builder.utils.htmlUtil.getChildWidgets = function(/*Node*/selfNode) {
	 var retval = [];
	 if (selfNode) {
	 	var aNode = dojo.byId(selfNode);
		 var childNodes = aNode.childNodes;
		 if (childNodes !== null && childNodes.length > 0) {
			 for (var index=0;index<childNodes.length;index++) {
				 child = childNodes[index];
				 if (child) {
					 if (this.widgetClass.test(child.className)) {
						 retval[retval.length] = child;
					 }
					 else {
						 children = checkChildElement(child);
						 if (children !== null) {
							 for (ii=0;ii<children.length;ii++) {
								 retval[retval.length] = children[ii];
							 }
						 }
					 }
				 }
			 }
		 }
	 }
	 return retval;
};

com.ibm.mm.builder.utils.htmlUtil.checkParentElement = function(/*Node*/selfNode) {
	if (selfNode) {
		var dadNode = selfNode.parentNode;
		if (dadNode) {
			if (dadNode.className) {
				if (this.widgetClass.test(dadNode.className)) {
					return dadNode.id;
				}
			}
			return this.checkParentElement(dadNode);
		}
	}
	return null;
};

com.ibm.mm.builder.utils.htmlUtil.prependChild = function(/*Element*/node, /*Element*/parent){
	//	summary:
	//		prepends node to parent's children nodes
	if(parent.firstChild) {
		parent.insertBefore(node, parent.firstChild);
	} else {
		parent.appendChild(node);
	}
	return true;	//	boolean
};

com.ibm.mm.builder.utils.htmlUtil.disableSelection = function(/*DomNode*/element){
	// summary: disable selection on a node
	element = dojo.byId(element)||dojo.body();
	
	if(dojo.isMoz){
		element.style.MozUserSelect = "none";
	}else if(dojo.isSafari){
		element.style.KhtmlUserSelect = "none"; 
	}else if(dojo.isIE){
		element.unselectable = "on";
	}else{
		return false;
	}
	return true;
};

com.ibm.mm.builder.utils.htmlUtil.getWidgetParent = function(/*String*/id) {
	if (id===null) {
		return null;
	}	   		
	return this.checkParentElement(dojo.byId(id));
};

com.ibm.mm.builder.utils.htmlUtil.setStyle = function() {
	var node = arguments[0];
	for(var i=1; i<arguments.length; i++) {
		stylePair = arguments[i].split(":");
		node.style[stylePair[0]] = stylePair[1];
	}
};
	
com.ibm.mm.builder.utils.htmlUtil.createRadioButton = function(radioName,radioValue,radioOnclick,selected,title){
	var radioString = "<input type='radio' name='";
	radioString = radioString + radioName+ (title ? ("' title='" + title) : "") + "' value='";
	radioString = radioString + radioValue+ "' onclick='";
	radioString = radioString + radioOnclick+ "'";
	if (selected){
		radioString = radioString + " checked>";
	}else{
		radioString = radioString + ">";
	}
	return radioString;
};
	
com.ibm.mm.builder.utils.htmlUtil.getLimitedString = function(text, restrictionNum){
	if(!text) {
		return "";
	}
	if(text.length > restrictionNum){
		text = text.substr(0, restrictionNum) + "...";
	}
	return text;
};

/**
 * @deprecated
 */
com.ibm.mm.builder.utils.htmlUtil.addShadow = function(domNode,classes) {
	for(var i=0; i<classes.length; i++) {
		var div = document.createElement("div");
		div.className = classes[i];
		domNode.appendChild(div);
	}
};

com.ibm.mm.builder.utils.htmlUtil.getSubstitute = function(message, args){
	if(message && args){
		return dojo.string.substitute(message, args);
	}
	return message;
};

com.ibm.mm.builder.utils.htmlUtil.getCurrentStyle =	function (obj, prop) {
	if (obj.currentStyle) {		// IE
		var objStyle = obj.currentStyle[prop];
		if(ibmConfig.fontSizeEnlarged && prop === "fontSize" && objStyle.match(/em/)){
			var p = obj.parentNode;
			var isDialog = false;
			while(p && p.tagName.toLowerCase() != "body"){
				if (dojo.hasClass(p, "dialog_container")) {
					isDialog = true;
					break;
				}
				p = p.parentNode;
			}
			if(isDialog){
				var currentFontSize =parseFloat(objStyle.replace("em",""));
				var enlargedFontSize = parseFloat((p.currentStyle[prop]).replace("em",""));
				objStyle = currentFontSize*enlargedFontSize+"em";
			}
		}
		return objStyle;
	}
	else if (window.getComputedStyle) {	// FF
		prop = prop.replace (/([A-Z])/g, "-$1");
		prop = prop.toLowerCase ();
		return window.getComputedStyle (obj, "").getPropertyValue(prop);
	}
	return null;
};

com.ibm.mm.builder.utils.htmlUtil.createElementWithClass = function (type,classNm,innerHTML){
	var node = document.createElement(type);
	dojo.addClass(node, classNm);
	if(innerHTML){
		node.innerHTML = innerHTML;
	}
	return node;
};

/*
 * get the actually length of string with necessary style 
 */
com.ibm.mm.builder.utils.htmlUtil.getStrWidthByFontStyle = function(str, fontSize, fontFamily, fontWeight){
    if (!this.stringCheckDiv){
    	this.stringCheckDiv = document.createElement("span");
    	this.stringCheckDiv.style.whiteSpace = "nowrap";
    	this.stringCheckDiv.style.position = "absolute";
    	document.body.appendChild(this.stringCheckDiv);
    }
    fontSize = fontSize || this.getCurrentStyle(document.body, "fontSize") || "";
    fontFamily = fontFamily || this.getCurrentStyle(document.body, "fontFamily") || "";
    fontWeight = fontWeight || this.getCurrentStyle(document.body, "fontWeight") || "";
    
	this.stringCheckDiv.style.cssText += "; fontSize: " + fontSize
									   + "; fontFamily: " + fontFamily
									   + "; fontWeight: " + fontWeight;
    this.stringCheckDiv.innerHTML = this.formatBlankSpace(str);
    this.stringCheckDiv.style.display = '';
    var w = this.stringCheckDiv.scrollWidth;
    this.stringCheckDiv.style.display = 'none';
    return w;
};

/*
 * get the actually length of string with the node's style and its parents'
 */
com.ibm.mm.builder.utils.htmlUtil.getStrWidth = function(str, node, fontStyle){
	if(fontStyle && fontStyle.fontSize){
		this._fontSize = fontStyle.fontSize;
		this._fontFamily = fontStyle.fontFamily || "Arial,Helvetica,sans-serif";
		this._fontWeight = fontStyle.fontWeight || "normal";
		return this.getStrWidthByFontStyle(str, this._fontSize, this._fontFamily, this._fontWeight);
	}
	if(node){
		this._fontSize = this._fontFamily = this._fontWeight = null;
		while(node && !(this._fontSize && this._fontFamily && this._fontWeight)){
			if (!this._fontSize) {
				this._fontSize = this.getCurrentStyle(node, "fontSize");
			}
			if (!this._fontFamily) {
				this._fontFamily = this.getCurrentStyle(node, "fontFamily");
			}
			if (!this._fontWeight) {
				this._fontWeight = this.getCurrentStyle(node, "fontWeight");
			}
			node = node.parentNode;
		}
	}
	return this.getStrWidthByFontStyle(str, this._fontSize, this._fontFamily, this._fontWeight);
};

/*
 * get the intercepted string with the node's style and its parents' in limited width
 */
com.ibm.mm.builder.utils.htmlUtil.getStrWithLimit = function(str, node, limitWidth, fontStyle){
	if (!str || str.length <= 0 || !limitWidth || limitWidth <= 0) {
		return "";
	}
	var delta = 2;
	var percentage = 0.618;
	var min_str = str.substring(0, 1) + "...";
	var min_width = this.getStrWidth(min_str, node, fontStyle);
	if (limitWidth <= min_width) {
		return min_str;
	}
	var width = this.getStrWidth(str, node, fontStyle);
	if (width < limitWidth) { return str; }
	else {
		var begin = 0;
		var end = str.length;
		while (begin < end) {
			if (end - begin <= delta) {
				while (this.getStrWidth(str.substring(0, begin) + "...") > limitWidth) {
					begin -= 1;
				}
				return (str.substring(0, begin) + "...");
			}
			var index = begin + Math.round((end - begin) * percentage);
			var width_intercepted = this.getStrWidth(str.substring(0, index));
			if (width_intercepted < limitWidth) {
				begin = index;
				end = end;
			}else{
				begin = begin;
				end = index;
			}
		}
	}
};

/*
 * Truncate the string in 'textField' of 'node' and provide the whole string in 'tipField' if necessary.
 */

com.ibm.mm.builder.utils.htmlUtil.truncateAllChildNodesText = function(/* DomNode */node,/* String */tipField,/* obj */fontStyle){
	dojo.forEach(dojo.query(".truncatedLabel",node),function(item){
		com.ibm.mm.builder.utils.htmlUtil.truncateNodeText(item,tipField,fontStyle);
	});
};

com.ibm.mm.builder.utils.htmlUtil.truncateNodeText = function(/* DomNode */node,/* String */tipField, /*obj */fontStyle){
	var	textField = (node.tagName.toLowerCase() === "input") ? "value" : "innerHTML";
	if(!tipField){
		tipField = "title";
	}
	var widthLimit = 0;
	var str = node[textField];
	if(str.length === 0 ){return;}
	if (dojo.hasAttr(node, "widthlimit")) {
		widthLimit = parseInt(dojo.attr(node, "widthlimit"),10);
	}
	else {
		widthLimit = dojo.contentBox(node).w;
		if (widthLimit === 0) {
			widthLimit = parseInt(dojo.style(node,"width"),10);
		}
	}
	if (widthLimit > 0) {
		var shortStr = com.ibm.mm.builder.utils.htmlUtil.getStrWithLimit(str, node, widthLimit,fontStyle);
		if(shortStr.length <= str.length + 2 && !dojo.hasAttr(node,tipField)){
			dojo.attr(node,tipField,this.unEscapeString(str));
		}
		node[textField] = (textField === "innerHTML" && (!dojo.hasAttr(node,"keepBlankSpace"))) ? this.formatBlankSpace(shortStr) : shortStr;
	}
};

com.ibm.mm.builder.utils.htmlUtil.truncateAllChildNodesWord = function(node){
	dojo.forEach(dojo.query(".wordTruncatedLabel",node),function(item){
		com.ibm.mm.builder.utils.htmlUtil.truncateWord(item);
	});
};


com.ibm.mm.builder.utils.htmlUtil.truncateWord = function(node,strContent,widthLimit,ignoreEnlarge){
	// always truncate if set ignoreEnlarge=true
	if(ignoreEnlarge!==true)
		if(ibmConfig.fontSizeEnlarged){ return strContent; }
	
	if( !node ){return strContent;}
	var textType = (node.tagName.toLowerCase() === "input") ? "value" : "innerHTML";
	var str = strContent || node[textType];
	if(str.length === 0){ return strContent; }
	var wordsArr = str.split(" ");
	if (!widthLimit && dojo.hasAttr(node, "widthlimit")) {
		widthLimit = parseInt(dojo.attr(node, "widthlimit"),10);
	}
	var width = widthLimit ? widthLimit : dojo.contentBox(node).w;
	dojo.forEach(wordsArr,function(singleWord,index){
		wordsArr[index] =com.ibm.mm.builder.utils.htmlUtil.getStrWithLimit(singleWord,node,width); 
	});
	var content = wordsArr.join(" ");
	var resultContent = (textType === "innerHTML" && (!dojo.hasAttr(node,"keepBlankSpace"))) ? this.formatBlankSpace(content) : content;
	if(!str){	
		node[textType] = resultContent; 
	} else{
		return resultContent;
	}
	
};

com.ibm.mm.builder.utils.htmlUtil.markTruncation = function(node,widthLimit){
	dojo.addClass(node,"truncatedLabel");
	dojo.attr(node,"widthLimit",widthLimit);
};

/**
 *handle space and line separator 
 */
com.ibm.mm.builder.utils.htmlUtil.formatBlankSpace = function(title){
	if (!title) {
		return "";
	}
	return	title.replace(/\s/g, "&nbsp;");
};

/*
 * This method will replace & with &amp; to avoid incorrect display string &bmp; as an instance.
 * it will handle space as well.
 */
com.ibm.mm.builder.utils.htmlUtil.formatDisplayedContent = function(content, noNeedReplaceAmp, noNeedReplaceNbsp){
	if (!content) {
		return '';
	}
	if (!noNeedReplaceAmp) {
		content = content.replace(/&/g, "&amp;");
	}
	if (!noNeedReplaceNbsp) {
		content = content.replace(/\s/g, "&nbsp;");
	}
	return content;
};

com.ibm.mm.builder.utils.htmlUtil.escapeString = function(content){
	if (!content) {
		return "";
	}
	return content.replace(/&/g,"&amp;").replace(/"/g,"&quot;").replace(/</g,"&lt;").replace(/>/g,"&gt;");
};

com.ibm.mm.builder.utils.htmlUtil.unEscapeString = function(content){
	if (!content) {
		return "";
	}
	return content.replace(/&amp;/g,"&").replace(/&quot;/g,"\"").replace(/&lt;/g,"<").replace(/&gt;/g,">").replace(/&nbsp;/g," ");
};

/**
 * 
 * @param {String} str the message 
 */
com.ibm.mm.builder.utils.htmlUtil.formatMessage = function(str){
	if (!str || str.length <= 0) {
		return "";
	} 
	else {
		var lineSeparatorIndex = str.indexOf("\n");
		if (lineSeparatorIndex > 0) {
			var firstLine = str.substring(0, lineSeparatorIndex);
			var leftLine = str.substring(lineSeparatorIndex);//include '\n'
			return "<div class='firstLineFont truncatedLabel' widthLimit='400'>" + firstLine + "</div><span class='leftLineFont'>" +
			 leftLine.replace(/\n/g, "<br/>")+ "</span>";
		}
		else {
			return str.replace(/\n/g, "<br/>");
		}
	}
};

/**
 * set the title of node
 * @param {String} tileStr the tile of node
 * @param {Object} titleNode the node    
 * @param {Float} limitWidth the width of title
 * 
 */
com.ibm.mm.builder.utils.htmlUtil.setNodeTitle = function(titleStr, titleNode, limitWidth) {
	if (!titleNode || !titleStr) {
		return;
	}
	if(!limitWidth||limitWidth<=0){
		try{
			var valueStr=this.getCurrentStyle(titleNode,"width");
			if(valueStr == "auto") {
				limitWidth = dojo.style(titleNode,"width");
			}
			else if(valueStr.indexOf("%")>-1) {
				limitWidth = dojo.coords(titleNode).w;
			}
			else {
				limitWidth = parseFloat(valueStr.match(/\d*\.?\d*/));
			}
		}catch(e){
			limitWidth = null;
		}
	}
	titleNode.title = "";
    if(!limitWidth||limitWidth=="auto"){
    	titleNode.innerHTML =this.formatBlankSpace(titleStr);
    	return;
    }
	var _title = this.getStrWithLimit(titleStr, titleNode, limitWidth);
	titleNode.innerHTML = this.formatBlankSpace(_title);
	if (titleStr != _title) {
		titleNode.title = this.unEscapeString(titleStr);
	}
};

/**
 * set the title of node with font style
 * @param {String} tileStr, the tile of node
 * @param {Object} titleNode the node    
 * @param {Float} limitWidth, the width of title
 * @param {Map} fontStyle, it should be a map like this <code>{fontSize:"10px", fontFamily:"Sanson", fontWeight:"bold"}</code>
 * 
 */
com.ibm.mm.builder.utils.htmlUtil.setNodeTitleWithStyle = function(titleStr, titleNode, limitWidth, fontStyle) {
	if (!titleNode||!limitWidth||!titleStr||limitWidth<=0||!fontStyle){
		return;
	}
	titleNode.title = "";
	var _title = this.getStrWithLimit(titleStr, titleNode, limitWidth, fontStyle);
	if(titleNode.tagName == "INPUT"){//button
		titleNode.value = _title;
	}else{
		titleNode.innerHTML = this.formatDisplayedContent(_title);
	}
	titleNode.title = titleStr;
};

/**
 * set label and title under such conditions with limited width
 *  node.innerHTML = dojo.string.substitute(label,["<span class=\"youclass\">"+string+"</span>"]);
 */
com.ibm.mm.builder.utils.htmlUtil.setCombinedStringInNode = function(label, content, node, limitedWidth, className){
	var labelWidth = this.getStrWidth(label, node);
	if (labelWidth > limitedWidth) {
		var title = dojo.string.substitute(label, [content]);
		this.setNodeTitle(title, node, limitedWidth);
		return;
	}
	var tempSpan = document.createElement("span");
	tempSpan.className = className;
	node.appendChild(tempSpan);
	var limitedContent = this.getStrWithLimit(content, tempSpan, limitedWidth - labelWidth);
	
	var _content = dojo.string.substitute(label, ["<span class=\"" + className + "\">" + this.formatDisplayedContent(limitedContent) + "</span>"]);
	node.removeChild(tempSpan);
	node.innerHTML = _content;
	if (limitedContent != content) {
		node.title = dojo.string.substitute(label, [content]);
	}
};

/**
 * load a CSS file on the fly.
 */
com.ibm.mm.builder.utils.htmlUtil.loadCss = function(css_url){
	this.loadedCss = this.loadedCss || [];
	
	for(var i=0; i<this.loadedCss.length; i++) {
		var css = this.loadedCss[i];
		if(css == css_url){
			return;
		}
	}
	
	var headID = document.getElementsByTagName("head")[0];         
	var cssNode = document.createElement('link');
	cssNode.type = 'text/css';
	cssNode.rel = 'stylesheet';
	cssNode.href = css_url;
	cssNode.media = 'screen';
	headID.appendChild(cssNode);
			
	this.loadedCss.push(css_url);
};

com.ibm.mm.builder.utils.htmlUtil.removeIframe = function(node){
	if (!node) {
		return;
	}
	var iframe = dojo.query("iframe",node)[0];
	if(iframe){ iframe.parentNode.removeChild(iframe); }
};

com.ibm.mm.builder.utils.htmlUtil.showNodes = function(nodes){
	dojo.forEach(nodes, function(node){
		if (node.style) {
			node.style.display = "";
		}
	});
};

com.ibm.mm.builder.utils.htmlUtil.hideNodes = function(nodes){
	dojo.forEach(nodes, function(node){
		if (node.style) {
			node.style.display = "none";
		}
	});
};

com.ibm.mm.builder.utils.htmlUtil.releaseNode = function(node){
	if (node) {
		try {
			node.onmouseout = null;
			node.onmousemove = null;
			node.onclick = null;
			node.onfocus = null;
			node.onkeypress = null;
			node.innerHTML = "";
		} 
		catch (e) {
		}
	}
};

com.ibm.mm.builder.utils.htmlUtil.uncheckAll = function(pNodes){
	dojo.forEach(pNodes,function(item){
		var inputs = dojo.query("input", item);
		if (inputs) {
			var checkBox = dojo.query("input", item)[0];
			checkBox.checked = false;
		}
	});
};

com.ibm.mm.builder.utils.htmlUtil.getAllCheckedNodes = function(pNode){
	var checkedNodes = [];
	dojo.forEach(pNode.childNodes,function(item){
		var checkBox = dojo.query("input", item)[0];
		if(checkBox.checked){checkedNodes.push(item);}
	});
	return checkedNodes; 
};

//TODO: need to find another better way to fix the bug(scrollbar is hidden by the background in embed dialog)
com.ibm.mm.builder.utils.htmlUtil.showScrollBar = function(widgetId){
	if(widgetId != "layoutwidget"){ return; }
	var rootNode= dojo.byId(widgetId);
	if( !rootNode ){ return; }
	var iframeNode = rootNode.parentNode;
	while(iframeNode){
		if(iframeNode.nodeName.toLowerCase() === "#document"){ break; }
		iframeNode = iframeNode.parentNode;
	}
	if( !iframeNode ){ return; }
	iframeNode = rootNode.parentNode.parentNode.parentNode; 
	if(dojo.isIE && (iframeNode.URL.match(/mycontenthandler/))){
		var rDiv = dojo.query(".mm_Content > div",rootNode)[0];
		if(rDiv){ rDiv.style.position = "static"; }
		var container = dojo.query(".wrapper",rootNode)[0];
		if(container){ container.style.position = "static"; }
	}	
};

/*fix an ie bug: quotes of the attribute's value on a dom will be removed when use innerHTML to get the content.
 *for example: <div title="${key}" /> will be <div title=${key} /> in ie
 */
com.ibm.mm.builder.utils.htmlUtil.addMissingQuoteInTitle = function(str){
	if(!str){ return ""; }
	return str.replace(/title\s*=\s*\${([^}]+)}/g,"title=\"${$1}\""); // JSLINT-IGNORE: 
};

}

if(!dojo._hasResource["com.ibm.mm.builder.widget.CustomDialogResizer"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.widget.CustomDialogResizer"] = true;
dojo.provide("com.ibm.mm.builder.widget.CustomDialogResizer");



dojo.declare("com.ibm.mm.builder.widget.CustomDialogResizer", 
	[dojox.layout.ResizeHandle], {
	
	innerContainer: null,
	
	innerMargin: null,
	
	oritation: "right",
	
	intLeftRTLOrig:0,
	
	// shadow when resizing dialog
	resizeShadow: null,
	// onResize: function
	// called each time dialog is resized
	onResize: null,

	templateString: '<div dojoAttachPoint="resizeHandle" class="customDialogResizeHandle"><div></div></div>',
	
	_beginSizing: function(/*Event*/ e){
		// summary: setup movement listeners and calculate initial size
		
		if (this._isSizing){ return false; }

		this.targetWidget = dijit.byId(this.targetId);

		// FIXME: resizing widgets does weird things, disable virtual resizing for now:
		if (this.targetWidget) { this.activeResize = true; } 

		this.targetDomNode = this.targetWidget ? this.targetWidget.domNode : dojo.byId(this.targetId);
		if (this.targetContainer) { this.targetDomNode = this.targetContainer; } 
		if (!this.targetDomNode){ return; }

		this.intLeftRTLOrig = parseInt(this.targetDomNode.style.left,10);
		
		if (!this.activeResize) {
			this.targetDomNode.appendChild(this._activeResizeNode); 
			dojo.fadeIn({ node: this._activeResizeNode, duration:120, 
				beforeBegin: dojo.hitch(this,function(){
					this._activeResizeNode.style.display=''; 
				})
			}).play(); 
		}

		this._isSizing = true;
		this.startPoint  = {'x':e.clientX, 'y':e.clientY};

		// FIXME: this is funky: marginBox adds height, contentBox ignores padding (expected, but foo!)
		var mb = (this.targetWidget) ? dojo.marginBox(this.targetDomNode) : dojo.contentBox(this.targetDomNode);  
		this.startSize  = { 'w':mb.w, 'h':mb.h };

		this._connects = []; 
		this._connects.push(dojo.connect(document,"onmousemove",this,"_updateSizing")); 
		this._connects.push(dojo.connect(document,"onmouseup", this, "_endSizing"));
		this._connects.push(dojo.connect(document,"onmouseleave", this, "_endSizing"));
		
		// create the resize shadow
		this.resizeShadow = document.createElement("div");
		this.targetContainer.appendChild(this.resizeShadow);
		dojo.attr(this.resizeShadow, {"class": "dialog_resize_shadow"});
		dojo.style(this.resizeShadow, "width", mb.w + "px");
		dojo.style(this.resizeShadow, "height", mb.h + "px");
		
		e.preventDefault();
	},
	
	_changeSizing: function(/*Event*/ e){
		
		// summary: apply sizing information based on information in (e) to attached node
		var tmp = this._getNewCoords(e);
		if(tmp===false){ return; }
		
		if(this.targetWidget && typeof this.targetWidget.resize == "function"){
			this.targetWidget.resize(tmp);
		}else{
			var intLeft = 0;
			if (builderConfig.isBidi) {
				intLeft = this.intLeftRTLOrig - tmp.dx;				
			}			
			dojo.style(this.targetDomNode,"width",tmp.w+"px"); 
			dojo.style(this.targetDomNode,"height",tmp.h+"px");
			if (builderConfig.isBidi) {
				dojo.style(this.targetDomNode,"left",intLeft+"px");
			}
			if(this.innerContainer && this.innerMargin){
				this.innerContainer.style.height = (tmp.h - this.innerMargin.top - this.innerMargin.bottom ) + "px";
				this.innerContainer.style.width = (tmp.w - this.innerMargin.left - this.innerMargin.right - 2) + "px";				
			}
		}
		
		dojo.style(this.resizeShadow, "width", tmp.w + "px");	
		dojo.style(this.resizeShadow, "height", tmp.h + "px");
		e.preventDefault();
		
		if(this.onResize !== null)
		{
			this.onResize(tmp.w, tmp.h);
		}
	},

	_getNewCoords: function(/* Event */ e){
		
		// On IE, if you move the mouse above/to the left of the object being resized,
		// sometimes clientX/Y aren't set, apparently.  Just ignore the event.
		try{
			if(!e.clientX  || !e.clientY){ return false; }
		}catch(exception){
			// sometimes you get an exception accessing above fields...
			return false;
		}
		this._activeResizeLastEvent = e; 

		var dx = this.startPoint.x - e.clientX;
		var dy = this.startPoint.y - e.clientY;
		
		var newW = 0;
		var newH = (this._resizeY) ? this.startSize.h - dy : this.startSize.h;
		if (!builderConfig.isBidi) {
   		   newW = (this._resizeX) ? this.startSize.w - dx : this.startSize.w;		   
        } else {		
		   newW = (this._resizeX) ? this.startSize.w + dx : this.startSize.w;
        }

		// minimum size check
		if(this.minSize){
			//var mb = dojo.marginBox(this.targetDomNode);
			if(newW < this.minSize.w){
				newW = this.minSize.w;
			}
			if(newH < this.minSize.h){
				newH = this.minSize.h;
			}
		}
		return {w:newW, h:newH, dx:dx};  // Object
	},
	
	_endSizing: function(/*Event*/ e){
		this.inherited(arguments);
		dojo.forEach(this._connects,function(c){
			dojo.disconnect(c); 
		});
		
		// Note: the target dom node id is like : "widgetId_edit"
		if (this.targetDomNode){
			var domId = this.targetDomNode.id;
			if (domId.indexOf("_edit")!=-1){
				var widgetId = domId.substr(0,domId.length-5);
				var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
				var dlgContentNode = dojo.query(".dialog_container",this.targetDomNode)[0];
				var payload = {"newWidth": parseInt(dlgContentNode.style.width,10),"newHeight": parseInt(dlgContentNode.style.height,10)};
				eventService.publishEvent(com.ibm.mashups.iwidget.Constants.RESIZE_WIDGET+"."+widgetId,payload);	
			}			
		}
		// remove resize shadow
		this.targetContainer.removeChild(this.resizeShadow);
		this.resizeShadow = null;
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.widget.CustomDialogMoveable"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.widget.CustomDialogMoveable"] = true;
dojo.provide("com.ibm.mm.builder.widget.CustomDialogMoveable");



dojo.declare("com.ibm.mm.builder.widget.CustomDialogMoveable", dojo.dnd.Moveable, {

    adjustPosOnMouseUp: function(){
        this.node.style.left = this.checkValue(this.node.style.left);
        this.node.style.top = this.checkValue(this.node.style.top);
    },
    
    checkValue: function(value){
        try {
            var numValue = parseInt(value.substring(0, value.length - 2),10);
            if (numValue < 0) {
				return "0px";
			}
        } 
        catch (e) {
        }
        return value;
    },
    
    onMoveStop: function(/* dojo.dnd.Mover */mover){
        com.ibm.mm.builder.widget.CustomDialogMoveable.superclass.onMoveStop.call(this, mover);
        this.adjustPosOnMouseUp();
    }
    
});

}

if(!dojo._hasResource["com.ibm.mm.builder.widget.CustomDialog"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.widget.CustomDialog"] = true;
dojo.provide("com.ibm.mm.builder.widget.CustomDialog");








dojo.declare("com.ibm.mm.builder.widget.CustomDialog", [dijit.Dialog], {

    templateString: 
		"<div dojoAttachPoint='dialogNode' class='custom_dialog' waiRole='dialog' title=''>" +
		    "<div dojoAttachPoint='dialogDivsNode' class='customDialogDiv lotusDialog'>" +
			    "<div dojoAttachPoint='titleBar' class='dialog_titlebar' waiRole='dialog'>" +
					"<a title='${closeIconTitle}' class='dialog_titlebar_close_wrapper lotusBtnImg' dojoAttachPoint='closeButtonNode'" +
						"href='javascript:;' aria-label='${closeIconTitle}' dojoAttachEvent='onclick:trueHide,onkeypress:hideWithKey'>" +
						"<img alt='${closeIconTitle}' title='${closeIconTitle}' class='dialog_titlebar_close' src='" + builderConfig.builderPath + "/images/oneui/blank.gif'/>" +
						"<span class='lotusAltText'>X</span>" +
					"</a>" +
			    	"<div dojoAttachPoint='titleNode' class='dialog_titlebar_title'></div>" +
		    	"</div>" +
			    "<div dojoAttachPoint='containerNode' class='dialog_container'></div>" +
			    "<span dojoAttachPoint='tabEnd' ></span>" +
			    "<div dojoAttachPoint='leftBar' class='dialog_leftsidebar'></div>" +
			    "<div dojoAttachPoint='rightBar' class='dialog_rightsidebar'></div>" +
			    "<div dojoAttachPoint='endBar' class='dialog_endbar'></div>" +
			    "<div dojoAttachPoint='leftResizeHandler' class='dialog_leftResize_handler'></div>" +
			    "<div dojoAttachPoint='rightResizeHandler' class='dialog_rightResize_handler'></div>" +
		    "</div>" +
    	"</div>",
    
    sharedWidget: false, //whether this dialog widget should alive when page change
    
	belongId: null,
    
    nodeWidth: null,
    
    nodeHeight: null,
    
    title: null,
    
    titleHeight: 28,
    
    titleBarHeight: "0px",
    
    endBarHeight: "0px",
    
    bottomHeight: 14,
    
    topBarBackground: null,
    
    topBarOpacity: null,
    
    bottomBarBackground: null,
    
    bottomBarOpacity: null,
    
    bottomBarTip: null,
    
    bottomBarTipColor: "white",
    
    leftBarWidth: "0px",
    
    rightBarWidth: "0px",
    
    displayCloseButton: true,
    
    containerNodePadding: null,
    
    containerBackgroundColor: null,
    
    containerOpacity: null,
	
	dialogOpacity: null,
    
    hasLeftBottomResizer: false,
    
    hasRightBottomResizer: true,
    
    modelDialog: true,
    
    needUnderLay: true,
    
    initLeftPosition: null,
    
    initTopPosition: null,
    
    alwaysCenter: true,
    
    subDialogs: null,
    
    roundCorner: false,
    
    dialogStack: [],
    
    innerConnects: [],
    
    closeCallback: null, 	// a callback to set when you need to do something when the dialog is hided
    
	displayCallback: null,  // a callback to set when you need to do something after the dialog is displayed
    
    dynaInitialized: false, // used when user doens't specify the node's width
    						// After calculate the outer container's width, will be set to true
    
    closeIconTitle: com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_CANCEL,
    
    //isEmbedPageBidi: false, // 8143: embedPage will set to true when creating a bidi preview dialog 
    // 9637: removed rtl version of custom_dialog_nomodel so removed param isEmbedPageBidi
    
	scrollEnabled: false,
	
    postCreate: function(){
        this.inherited(arguments);
        this.domNode.className = "custom_dialog";
        this.subDialogs = [];
		//this.setTitle();//postpone until show to allow width to be set
		if (this.scrollEnabled) {
			dojo.style(this.containerNode, "overflow", "scroll");
		}
        
		dojo.subscribe("/enabler/pageChanged", this, "destroyOnPageChange");
    },
    
    setTitle: function(title){
		this.title = title || this.title;
		if (this.title && this.titleNode && this.title != this.titleNode.title) {
			com.ibm.mm.builder.utils.htmlUtil.setNodeTitle(this.title, this.titleNode);
			
		}
		dojo.attr(this.dialogNode, "title", this.title);
		dojo.attr(this.titleBar, "title", this.title);
	},
    
    // Search for if the page contains an applet
    containXOjbect: function(){
        return document.applets.length > 0 || document.getElementsByTagName("Object").length > 0;
    },
    
    // temp fix for old widget spec
    oldWidgetSpecHitch: function(){ // for custom dialog instance to over write
    },
    // end temp fix
    
    registerSubDialog: function(subDialogId){
        if (dojo.isString(subDialogId)) {
            this.subDialogs.push(subDialogId);
            var subDialog = dijit.byId(subDialogId);
            if (subDialog && !subDialog.modelDialog) {
                subDialog.domNode.style.zIndex = this.domNode.style.zIndex;
            }
        }
    },
    
    hideWithKey: function(event){
        var keyCode = event.keyCode;
        if (keyCode != dojo.keys.ENTER) {
			return true;
		}
        this.hide();
    },
    
    hide: function(){		
        this.doHide();
    },
    
    doHide: function(){
		if (!this.open) {
			return;
		}
		
    	if (!dojo.isIE && this.closeButtonNode.style.display != "none") {
			this.closeButtonNode.focus();
		}
		
        //disconnect the onkey function for the dialog
        if (this.dialogStack.length > 1) {
            var subDig = this.dialogStack.pop();
            dojo.disconnect(subDig.onKeyHandler);
            var parentDialog = this.dialogStack[this.dialogStack.length - 1];
            parentDialog.onKeyHandler = dojo.connect(document.documentElement, "onkeypress", parentDialog, "_onKey");
        }
        else 
            if (this.dialogStack.length === 1) {
                var dialog = this.dialogStack.pop();
                dojo.disconnect(dialog.onKeyHandler);
            }
			
		dojo.forEach(this.subDialogs, function(subDialogId){
			var subDialog = dijit.byId(subDialogId);
			if(subDialog){
				subDialog.hide();
			}
		});

        // temp fix for old widget spec
        setTimeout(this.oldWidgetSpecHitch, this.duration);
    
		//override the dijit.Dialog hide logic here. 
		var ds = com.ibm.mm.builder.widget.customDialogStack;
		if(!this._alreadyInitialized || this != ds[ds.length-1]){
			return;
		}
		
		if(this.modelDialog){
			com.ibm.mm.builder.widget.customDlgHighestZIndex -= 2;
			this.domNode.style.zIndex = com.ibm.mm.builder.widget.customDlgZIndexOnPage;
		}
		
		if(this._fadeIn.status() == "playing"){
			this._fadeIn.stop();
		}
		
		com.ibm.mm.builder.widget.customDialogStack.pop();

		this._fadeOut.play();

		if (this._scrollConnected){
			this._scrollConnected = false;
		}
		dojo.forEach(this._modalconnects, dojo.disconnect);
		this._modalconnects = [];

		if(this._relativePosition){
			delete this._relativePosition;	
		}
		this.open = false;
	},
    
    trueHide: function(){
		this.doHide();
    },
    
	_onKey: function(/*Event*/ evt){
		// summary:
		//		Handles the keyboard events for accessibility reasons
		// tags:
		//		private
		if (dijit._dialogStack.length > 0) {
			return;
		}
			
		var ds = com.ibm.mm.builder.widget.customDialogStack;
		if (ds[ds.length - 1] != this) {
			return;
		}
		
		if (evt.charOrCode) {
			var dk = dojo.keys;
			var node = evt.target;
			if (evt.charOrCode === dk.TAB) {
				this._getFocusItems(this.domNode);
			}
			var singleFocusItem = (this._firstFocusItem == this._lastFocusItem);
			// see if we are shift-tabbing from first focusable item on dialog
			if (node == this._firstFocusItem && evt.shiftKey && evt.charOrCode === dk.TAB) {
				if (!singleFocusItem) {
					dijit.focus(this._lastFocusItem); // send focus to last item in dialog
				}
				dojo.stopEvent(evt);
			}
			else 
				if (node == this._lastFocusItem && evt.charOrCode === dk.TAB && !evt.shiftKey) {
					if (!singleFocusItem) {
						dijit.focus(this._firstFocusItem); // send focus to first item in dialog
					}
					dojo.stopEvent(evt);
				}
				else {
					// see if the key is for the dialog
					while (node) {
						if (node == this.domNode) {
							if (evt.charOrCode == dk.ESCAPE) {
								this.onCancel();
							}
							else {
								return; // just let it go
							}
						}
						node = node.parentNode;
					}
					// this key is for the disabled document window
					if (evt.charOrCode !== dk.TAB) { // allow tabbing into the dialog for a11y
						dojo.stopEvent(evt);
					// opera won't tab to a div
					}
					else 
						if (!dojo.isOpera) {
							try {
								this._firstFocusItem.focus();
							} 
							catch (e) { /*squelch*/
							}
						}
				}
		}
	},
	
	/**
	 * the recommended way to get underlay of the dialog.
	 */
    _getUnderlay: function(){
		if (!this._underlay) {
			this._underlay = new com.ibm.mm.builder.widget.CustomDialogUnderlay();
		}
		return this._underlay;		
	},
	
	//In dojo 1.4, we can use dojo.isMac
	_isMac : function() {
		return navigator.appVersion.indexOf("Macintosh") >= 0;
	},
	
	/**
	 * Initialization when the dialog is showed for the first time
	 */
    _setup: function(){
        this.moveableHandles = [];
        
		//initialize the global dijit._underlay to avoid exception when the parent's uninitialize is called
		if (!dijit._underlay) {
			dijit._underlay = new dijit.DialogUnderlay();
		} 
		
        if (this.titleBar) {
			this.moveableHandles.push(new com.ibm.mm.builder.widget.CustomDialogMoveable(this.domNode, {
				handle: this.titleBar
			}));
		}
        if (this.leftBar) {
			this.moveableHandles.push(new com.ibm.mm.builder.widget.CustomDialogMoveable(this.domNode, {
				handle: this.leftBar
			}));
		}
        if (this.rightBar) {
			this.moveableHandles.push(new com.ibm.mm.builder.widget.CustomDialogMoveable(this.domNode, {
				handle: this.rightBar
			}));
		}
        if (this.endBar) {
			this.moveableHandles.push(new com.ibm.mm.builder.widget.CustomDialogMoveable(this.domNode, {
				handle: this.endBar
			}));
		}
        
        if (this.modelDialog) { // is model dialog
//			com.ibm.mm.builder.widget.customDlgZIndexOnPage += 2;	//Increase every time when there is a new model dialog on the page
            this.domNode.style.zIndex = com.ibm.mm.builder.widget.customDlgZIndexOnPage;
        } else { 				// is not model dialog
        	//if (!this.isEmbedPageBidi) { 9637
        		com.ibm.mm.builder.utils.htmlUtil.setClass(this.domNode, "custom_dialog_nomodel");
        	//}
        }
		
		var node = this.domNode;
		if (this.modelDialog && this.needUnderLay) {
			var underlay = this._getUnderlay();
            this._fadeIn = dojo.fx.combine([
				dojo.fadeIn({
                    node: node,
                    duration: this.duration,
					onEnd: dojo.hitch(this,function(){
						if(this.dialogOpacity != null) {
							dojo.style(this.domNode, "opacity", this.dialogOpacity);
						}
					})
                }), 
				dojo.fadeIn({
                    node: underlay.domNode,
                    duration: this.duration,
                    onEnd: dojo.hitch(this, function(){
                        underlay.show();
                        underlay.setZIndex(dojo.style(node, "zIndex") - 1);
                        //TODO: from dojo1.4, this can be removed, dijit.dialogUnderlay will add iframe by default.
						if (!(this._isMac() && dojo.isSafari == 4)) {
							this._addBackIFrame(dojo.style(node, "zIndex") - 2);
						}				
						
                    })
            	})
			]);
            this._fadeOut = dojo.fx.combine([
				dojo.fadeOut({
                    node: node,
                    duration: 600
            	}), 
				dojo.fadeOut({
                    node: underlay.domNode,
                    duration: 700,
                    onEnd: dojo.hitch(this, function(){
						node.style.display = "none";
                        underlay.hide();
                        //TODO: from dojo1.4, this can be removed, dijit.dialogUnderlay will add iframe by default.
						this._removeBackIFrame();
						if (this.closeCallback) {
							setTimeout(dojo.hitch(this, this.closeCallback), 500);
						}
              		})
            	})
			]);
        } else {
            this._fadeIn = dojo.fadeIn({
                node: node,
                duration: this.duration,
				onEnd: dojo.hitch(this, function(){
					if(this.dialogOpacity != null) {
						dojo.style(this.domNode, "opacity", this.dialogOpacity);
					}
				})
            });
            this._fadeOut = dojo.fadeOut({
                node: node,
                duration: 600,
                onEnd: dojo.hitch(this,function(){
                    node.style.display = "none";
					if (this.closeCallback) {
						setTimeout(dojo.hitch(this, this.closeCallback), 500);
					}
                })
            });
        }
    },
	
	/**
	 * Initialize the skin of the dialog accoring to the given params when the it's created
	 */
	InitDialogSkin: function(){
        if (this.roundCorner) {
			dojo.addClass(this.dialogNode, "mumRoundCorner");
		}
        
        this.closeButtonNode.style.display = this.displayCloseButton ? "" : "none";
        
        if (!this.title) {
            this.titleNode.style.display = "none";
            com.ibm.mm.builder.utils.htmlUtil.setClass(this.titleBar, "dialog_titlebar_notitle");
            com.ibm.mm.builder.utils.htmlUtil.setClass(this.leftBar, "dialog_leftsidebar_notitle");
            com.ibm.mm.builder.utils.htmlUtil.setClass(this.rightBar, "dialog_rightsidebar_notitle");
            this.titleHeight = 14;
        }
        else {
            this.titleNode.style.display = "";
            com.ibm.mm.builder.utils.htmlUtil.setClass(this.titleBar, "dialog_titlebar");
            com.ibm.mm.builder.utils.htmlUtil.setClass(this.leftBar, "dialog_leftsidebar");
            com.ibm.mm.builder.utils.htmlUtil.setClass(this.rightBar, "dialog_rightsidebar");
            this.titleHeight = 28;
        }
        
        if (this.nodeWidth) {
			(this.containerNode.style.width = this.nodeWidth);
		}
		dojo.forEach((this.nodeStyle || "").split(";"), function(singleStyle){
			var kvp = singleStyle.split(":");
			if (kvp.length === 2) {
				this.containerNode.style[kvp[0]] = kvp[1];
			}
		}, this);
        if (this.nodeHeight) {
			this.containerNode.style.height = this.nodeHeight;
		}
		
        if (this.containerNodePadding){this.containerNode.style.padding = this.containerNodePadding;}
        if (this.leftBarWidth) {
			this.leftBar.style.width = this.leftBarWidth;
		}
        if (this.leftBarWidth) {
			this.containerNode.style.marginLeft = this.leftBarWidth;
		}
        if (this.rightBarWidth) {
			this.rightBar.style.width = this.rightBarWidth;
		}
        if (this.rightBarWidth) {
			this.containerNode.style.marginRight = this.rightBarWidth;
		}
        if (this.containerBackgroundColor) {
			this.containerNode.style.backgroundColor = this.containerBackgroundColor;
		}
        if (this.containerOpacity) {
			this.containerNode.style.opacity = this.containerOpacity;
		}
		
        //the style of the title and bottom bar
        if (this.topBarBackground) {
			this.titleBar.style.backgroundColor = this.topBarBackground;
		}
        if (this.topBarOpacity) {
			this.titleBar.style.opacity = this.topBarOpacity;
		}
        if (this.topBarOpacity) {
			this.titleBar.style.filter = "progid:DXImageTransform.Microsoft.Alpha(style=0,opacity=" + this.topBarOpacity * 100;
		}
        if (this.titleBarHeight != "0px") {
			this.titleBar.style.height = this.titleBarHeight;
		}
        if (this.bottomBarBackground) {
			this.endBar.style.backgroundColor = this.bottomBarBackground;
		}
        if (this.bottomBarOpacity) {
			this.endBar.style.opacity = this.bottomBarOpacity;
		}
        if (this.bottomBarOpacity) {
			this.endBar.style.filter = "progid:DXImageTransform.Microsoft.Alpha(style=0,opacity=" + this.bottomBarOpacity * 100;
		}
        
        if (this.endBarHeight && this.endBarHeight != "0px") {
            this.endBar.style.height = this.endBarHeight;
            var _height = parseInt(this.endBarHeight,10) + 1 + "px";
            this.leftBar.style.bottom = _height;
            this.rightBar.style.bottom = _height;
        }
        
        if (this.bottomBarTip) {
			this.endBar.innerHTML = this.bottomBarTip;
			this.endBar.style.color = this.bottomBarTipColor;
		}
        //Init resize handle
        if (this.hasLeftBottomResizer) {
			this.leftResizeHandler.style.display = "";
            this.leftResizer = new com.ibm.mm.builder.widget.CustomDialogResizer({
                targetContainer: this.domNode,
                animateSizing: false,
                activeResize: true,
                innerContainer: this.containerNode,
                innerMargin: {
                    top: this.titleHeight,
                    bottom: this.bottomHeight,
                    left: parseInt(this.leftBarWidth,10),
                    right: parseInt(this.rightBarWidth,10)
                },
				onResize: dojo.hitch(this, "onResize")
            }, this.leftResizeHandler);
            this.leftResizer.startup();
        }
        if (this.hasRightBottomResizer) {
			this.rightResizeHandler.style.display = "";
            this.rightResizer = new com.ibm.mm.builder.widget.CustomDialogResizer({
                targetContainer: this.domNode,
                animateSizing: false,
                activeResize: true,
                innerContainer: this.containerNode,
                innerMargin: {
                    top: this.titleHeight,
                    bottom: this.bottomHeight,
                    left: parseInt(this.leftBarWidth,10),
                    right: parseInt(this.rightBarWidth,10)
                },
				onResize: dojo.hitch(this, "onResize")
            }, this.rightResizeHandler);
            this.rightResizer.startup();
        }
    },
    
    /**
     * Display the dialog
     */
    show: function(){
        if (this.open) {
			return;
		}
        
		// first time we show the dialog, there's some initialization stuff to do			
        if (!this._alreadyInitialized) {
            this._setup();
			this.InitDialogSkin();
            this._alreadyInitialized = true;
        }
        if (this._fadeOut.status() == "playing") {
            this._fadeOut.stop();
        }
        
        this._modalconnects.push(dojo.connect(window, "onscroll", this, "layout"));
        this._modalconnects.push(dojo.connect(window, "onresize", this, function(){
				// IE gives spurious resize events and can actually get stuck
				// in an infinite loop if we don't ignore them
				var viewport = dijit.getViewport();
				if(!this._oldViewport ||
						viewport.h != this._oldViewport.h ||
						viewport.w != this._oldViewport.w){
					this.layout();
					this._oldViewport = viewport;
				}
			}));
		
        if (this.dialogStack.length > 0) {
            var formerDialog = this.dialogStack[this.dialogStack.length - 1];
            dojo.disconnect(formerDialog.onKeyHandler);
        }
        this.dialogStack.push(this);
        if (this.modelDialog) {
            this._modalconnects.push(this.onKeyHandler = dojo.connect(document.documentElement, "onkeypress", this, "_onKey"));
        }
        
        dojo.style(this.domNode, "opacity", 0);
        var hasHeightDivList = [];
        //fix the width bug of IE6 
        if (!this.dynaInitialized) {
            if (dojo.isIE == 6) {
                dojo.query("div", this.domNode).forEach(function(node, i){
                    // add if cause here ,if need.
                    var heightObj = [];
                    heightObj.node = node;
                    heightObj.height = node.style.height;
                    node.style.height = "auto";
                    hasHeightDivList.push(heightObj);
                });
            }
        }
        this.domNode.style.display = "block";
        this.domNode.style.visibility = "";
        this.open = true;
        //removed in dojo1.4
//        this._loadCheck(); // lazy load trigger
		
		//only do this once, when use modify the width/height of the dialog by resizer, the second time show will keep the user's config
        if (!this.dynaInitialized) {
        	this.domNode.style.height = null;
        	
        	if(this.nodeHeight !== null){
        		this.containerNode.style.height = this.nodeHeight;
        	}else {
        		this.containerNode.style.height = null;
        	}
        	
            var leftnum = parseInt(this.leftBarWidth.substring(0, this.leftBarWidth.length - 2),10);
            var rightnum = parseInt(this.rightBarWidth.substring(0, this.rightBarWidth.length - 2),10);
            var nodeWidthNum;
            if (this.nodeWidth !== null) {
				this.containerNode.style.width = this.nodeWidth;
                nodeWidthNum = parseInt(this.nodeWidth.substring(0, this.nodeWidth.length - 2),10);
                this.domNode.style.width = (nodeWidthNum + leftnum + rightnum + 2) + "px";
            }
            else {
				var node;
				if(this.containerNode.hasChildNodes())
				{
					node = this.containerNode.childNodes[0];
				}
				else
				{
					node = this.containerNode;
				}
				
                nodeWidthNum = dojo.coords(node).w;
                this.containerNode.style.width = nodeWidthNum + "px";
                this.domNode.style.width = (nodeWidthNum + leftnum + rightnum + 2) + "px";
            }
            if (dojo.isIE == 6) {
                for (var i = 0; i < hasHeightDivList.length; i++) {
                    if (hasHeightDivList[i].height && hasHeightDivList[i].height != "auto") {
                        hasHeightDivList[i].node.style.height = hasHeightDivList[i].height;
                    }
                    else {
                        hasHeightDivList[i].node.style.height = "";
                    }
                }
            }
            this._position();
            this.positionWithGivenValue();
            this.dynaInitialized = true;
        } else {
            if (this.alwaysCenter && this.initLeftPosition === null && this.initTopPosition === null) {
				this._position();
			}
			dojo.style(this.containerNode, "width", "100%");
        }
//		this.hasXObject = this.containXOjbect();
//		if (this.hasXObject) {
//            //hide all the applets, otherwise the applets will display beyond the background layer
//            this._hideXObjects();
//        }
		
		//update the ZIndex information
		if(this.modelDialog){
			com.ibm.mm.builder.widget.customDlgHighestZIndex += 2;
			this.domNode.style.zIndex = com.ibm.mm.builder.widget.customDlgHighestZIndex;
		}
		
         //set title after width has been set
        this.setTitle();
        com.ibm.mm.builder.widget.customDialogStack.push(this);
        this._fadeIn.play();
        this._savedFocus = dijit.getFocus(this);
        
        hasHeightDivList = null;
        //For dojo1.1.1 support
        this._getFocusItems(this.domNode);
        // set timeout to allow the browser to render dialog
        setTimeout(dojo.hitch(this, function(){
			try {
				var elems = dijit._getTabNavigable(this.containerNode);
				var f = elems.lowest || elems.first || this._firstFocusItem;
				if (f) {
					dijit.focus(f);
				}
				if(this.displayCallback){
					this.displayCallback();
				}
			} catch (e) {
				this.closeButtonNode.focus();
			}
        }), this.duration + 500);
    },
	
    setNodeWidth: function(newWidth){
        this.containerNode.style.width = this.nodeWidth = newWidth;
        if (this.dynaInitialized) { //if has been shown
            var leftnum = parseInt(this.leftBarWidth,10);
            var rightnum = parseInt(this.rightBarWidth,10);
            var nodeWidthNum = this.nodeWidth ? parseInt(this.nodeWidth,10) : dojo.coords(this.containerNode).w;
            
            this.domNode.style.width = (nodeWidthNum + leftnum + rightnum + 2) + "px";
        }
    },
    
    setNodeHeight: function(newHeight){
        this.containerNode.style.height = this.nodeHeight = newHeight;
    },
    
    setBottomTip: function(tip){
        this.endBar.innerHTML = this.bottomBarTip = tip;
    },
    
    setBottomTipColor: function(color){
        this.endBar.style.color = this.bottomBarTipColor = color;
    },
    
    autoAdjust: function(){},
    
    
    //Although this is a protected function for dijit.Dialog
    //Use it anyway to avoid copy much code from dijit.Dialog
	onCancel: function(){
		this.trueHide();
	},
    
    destroyOnPageChange: function(){
        if (!this.sharedWidget) {
			this.destroy();
		}
    },
    
    destroy: function(){
		if (this.open) {
			this.hide();
		}
        dojo.forEach(this.innerConnects, dojo.disconnect);
		if (this.moveableHandles){
		    for (var i = 0; i < this.moveableHandles.length; i++){
				this.moveableHandles[i].destroy();
			}	
		}
		
		dojo.destroy(this.leftBar);
		dojo.destroy(this.rightBar);
		dojo.destroy(this.endBar);
		dojo.destroy(this.closeButtonNode);
		dojo.destroy(this.titleBar);
		if (this.leftResizer) {
			this.leftResizer.destroy();
		}
		if (this.rightResizer) {
			this.rightResizer.destroy();
		}
		dojo.destroy(this.leftResizeHandler);
		dojo.destroy(this.rightResizeHandler);
		
		if (this._underlay) { // need this since from 1.3.2, dijit.dialog doesn't destroy the underlay
			this._underlay.destroy();
            this._underlay =null;
		}
		if(this.shimmer){  
			dojo.destroy(this.shimmer);
		}
		if (dijit._underlay) {
			dijit._underlay.destroy();
		}
		this.inherited(arguments);
		if (dijit._underlay) {
			dijit._underlay = null;
		}        
    },
    
    positionWithGivenValue: function(){
        if (this.initLeftPosition) {
			this.domNode.style.left = this.initLeftPosition;
		}
        if (this.initTopPosition) {
			this.domNode.style.top = this.initTopPosition;
		}
    },
    
    /**
     * Position modal dialog in center of screen
     */
    _position: function(){
        if (dojo.hasClass(dojo.body(), "dojoMove")) {
			return;
		}
		// wait a moment until the domNode is fully ready, otherwise it's height maybe wrong
		window.setTimeout(dojo.hitch(this,function(){
			var viewport = dijit.getViewport();
	        var mb = dojo.marginBox(this.domNode);
	        
	        var left = Math.floor((viewport.l + (viewport.w - mb.w) / 2));
	        var top = Math.floor((viewport.t + (viewport.h - mb.h) / 2));
	        this.domNode.style.left = left > 0 ? left + "px" : "0px";
	        this.domNode.style.top = top > 0 ? top + "px" : "0px";
		}),500);
    },
    
    layout: function(){
        // summary: position the Dialog and the underlay
        if (this.domNode.style.display != "none" && this.modelDialog && this.needUnderLay) {
            this._getUnderlay().layout();
        }
    },
    
    /**
     * This function will add one iframe under the underlay of the dialog
     * Its purpose is to solve the overlap problem of applet,flash,ActiveX object,ect.
     */
    _addBackIFrame: function(zIndex){
		this.shimmer = document.createElement('iframe');
		this.shimmer.style.position = 'absolute';
		this.shimmer.style.zIndex = zIndex;
		this.shimmer.setAttribute('frameborder', '0');
		this.shimmer.style.filter = 'progid:DXImageTransform.Microsoft.Alpha(style=0,opacity=0)';
		document.body.appendChild(this.shimmer);
        this._adjustBackIFramePosition();
    },
    
    /**
     * This function is in charge of adjust the iframe's positon when user scroll the window
     */
    _adjustBackIFramePosition: function(){
        var viewport = dijit.getViewport();
        this.shimmer.style.top = viewport.t + "px";
        this.shimmer.style.left = viewport.l + "px";
        this.shimmer.style.width = viewport.w + "px";
        this.shimmer.style.height = viewport.h + "px";
        
        // process twice since the scroll bar may have been removed
        // by the previous resizing
        var viewport2 = dijit.getViewport();
        if (viewport.w != viewport2.w) {
            this.shimmer.style.width = viewport2.w + "px";
        }
        if (viewport.h != viewport2.h) {
            this.shimmer.style.height = viewport2.h + "px";
        }
    },
    
    /**
     * Remove the iframe when the dialog is hidden
     */
    _removeBackIFrame: function(){
        if (this.shimmer) {
			dojo.destroy(this.shimmer);
			this.shimmer = null;
        }
    },
    
//    _hideXObjects: function(){
//        //hide all the applets
//        var applets = document.getElementsByTagName("Applet");
//        for (var i = 0; i < applets.length; i++) {
//            applets[i].style.visibility = "hidden";
//        }
//        //hide all object div(flash, svg)
//        var objs = document.getElementsByTagName("Object");
//        for (var i = 0; i < objs.length; i++) {
//            objs[i].style.visibility = "hidden";
//        }
//    },
	
	onResize: function(width, height){
		// hook for child widgets
	}
});

com.ibm.mm.builder.widget.customDialogStack = [];
com.ibm.mm.builder.widget.customDlgZIndexOnPage = 800;
com.ibm.mm.builder.widget.customDlgHighestZIndex = 800;
com.ibm.mm.builder.widget.editDialogUnderlay = null;

dojo.declare("com.ibm.mm.builder.widget.CleanDialog", com.ibm.mm.builder.widget.CustomDialog, {
	/**
	 * Override the super method to make all WidgetEditDialog use the only global underlay:
	 * com.ibm.mm.builder.widget.editDialogUnderlay
	 */
	_getUnderlay: function(){
		if (!com.ibm.mm.builder.widget.editDialogUnderlay) {
			com.ibm.mm.builder.widget.editDialogUnderlay = new com.ibm.mm.builder.widget.CustomDialogUnderlay({
				id: "cleanDialogUnderlay"
			});
		}
		return com.ibm.mm.builder.widget.editDialogUnderlay;
	}
});

dojo.declare("com.ibm.mm.builder.widget.GeneralWidgetModeDialog", com.ibm.mm.builder.widget.CleanDialog, {
	
	postCreate: function(){
		this.inherited(arguments);
		this.modeChangeHandle = dojo.subscribe(iwConstants.EVENTS.modeChanged,
			this, this.onModeChanged);
	},
	
	onModeChanged: function(widgetId, mode){
		this.hide();
	},
	
	hideWithKey: function(event){
        var keyCode = event.keyCode;
        if (keyCode != dojo.keys.ENTER) {
			return true;
		}
        this.trueHide();
    },
	
	trueHide: function(){
		if(this.belongId) {
			com.ibm.mashups.services.ServiceManager.getService("eventService").fireEvent(this.belongId, "onModeChanged", {newMode:'view'});
			return;	
		}
		this.doHide();
	},
	
	destroy: function(){
		dojo.unsubscribe(this.modeChangeHandle);
		this.inherited(arguments);
	}
});

dojo.declare("com.ibm.mm.builder.widget.WidgetEditDialog", com.ibm.mm.builder.widget.GeneralWidgetModeDialog, {
	onModeChanged: function(widgetId, mode){
		if(mode === "edit" && this.belongId === widgetId) {
			this.hide();
		}
	}
});

dojo.declare("com.ibm.mm.builder.widget.CustomDialogUnderlay", dijit.DialogUnderlay, {
    templateString: 
		'<div class="customDialogUnderlayWrapper" id="${id}_underlay">' +
    		'<div class="customDialogUnderlay" dojoAttachPoint="node"></div>' +
    	'</div>',
    
    setZIndex: function(zIndex){
        dojo.style(this.domNode, "zIndex", zIndex);
    }
//	postCreate: function() {
//		this.inherited('postCreate',arguments);
//		if(this.bgIframe.iframe){
//			dojo.attr(this.bgIframe.iframe,'title','underlay');
//		}
//	}

});

}

if(!dojo._hasResource["com.ibm.mm.builder.dialog.DialogFooter"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.dialog.DialogFooter"] = true;
dojo.provide("com.ibm.mm.builder.dialog.DialogFooter");




dojo.declare("com.ibm.mm.builder.dialog.DialogFooter",
	[dijit._Widget, dijit._Templated],
	{
		templateString: 
			'<div class="${baseClass}">'+
			    '<input id="${saveId}" role="button" wairole="button" aria-label="${saveText}" title="${saveText}" type="button" class="${saveClass}" value="${saveText}" dojoAttachPoint="saveNode" dojoAttachEvent="onclick:onSave" accesskey="${saveAccessKey}"/>'+
				'<a id="${cancelId}" role="button" wairole="button" title="${cancelText}" aria-label="${cancelText}" class="${cancelClass}" href="JavaScript:void(0)" dojoAttachPoint="cancelNode" dojoAttachEvent="onclick:onCancel,onkeypress:_onCancelKeypress">${cancelText}</a>'+
			    //'<input id="${cancelId}" type="button" class="${cancelClass}" value="${cancelText}" dojoAttachPoint="cancelNode" dojoAttachEvent="onclick:onCancel,onkeypress:_onCancelKeypress" accesskey="${cancelAccessKey}"/>'+
		    '</div>',
		
		baseClass: "lotusDialogFooter",
		widgetId: "",
		IWID: "",
		
		saveId: "_${widgetId}_btn_save",
		saveClass: "lotusFormButton common_save",
		saveText: "${I_COMMON_SAVE}",
		saveAccessKey: "",
		
		cancelId: "_${widgetId}_cancel_text",
		cancelClass: "common_cancel lotusAction",
		cancelText: "${I_COMMON_CANCEL}",
		cancelAccessKey: "",
		
		resourceBundles: [com.ibm.mm.builder.coreWidgetsStrings],
		
		postMixInProperties: function() {
			this.inherited(arguments);
			if (this.IWID) {
				this.widgetId = this.IWID.substr(1, this.IWID.length - 2);
			}
			var smashedMixin = dojo.mixin.apply(dojo, [{}, this].concat(this.resourceBundles));
			dojo.forEach(["saveId", "saveText", "cancelId", "cancelText"], function(prop){
				this[prop] = dojo.string.substitute(this[prop], smashedMixin);
			}, this);
		},
		
		postCreate: function() {
			if (!this.cancelAccessKey) {
				this.cancelNode.removeAttribute("accesskey");
			}
			if (!this.saveAccessKey) {
				this.saveNode.removeAttribute("accesskey");
			}
			this.inherited(arguments);
		},
		
		_onSaveKeypress: function(e) {
			if (e.charCode === dojo.keys.SPACE || e.keyCode === dojo.keys.ENTER) {
				this.onSave(e);
			}
		},
		
		_onCancelKeypress: function(e) {
			if (e.charCode === dojo.keys.SPACE || e.keyCode === dojo.keys.ENTER) {
				this.onCancel(e);
			}
		},
		
		onSave: function(evt) {
			
		},
		onCancel: function(evt) {
			
		}
	}
);

}

if(!dojo._hasResource["com.ibm.mm.builder.widget.ResizeWidget"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.widget.ResizeWidget"] = true;
dojo.provide("com.ibm.mm.builder.widget.ResizeWidget");





dojo.declare("com.ibm.mm.builder.widget.ResizeWidget",[dijit._Widget, dijit._Templated],{	

	templateString:
		'<div dojoAttachEvent="onkeypress: _onKeyPress" class="resizeWidgetContainer">'+
			'<div class="resizeWidgetDiv" dojoAttachPoint="containerNode">'+
				'<div class="resizeWidgetItem" dojoAttachPoint="resizeWidthDiv">'+
					'<span class="resizeWidget_item_label">${I_CONTEXT_MENU_WIDGET_WIDTH}</span>'+
					'<input dojoType="dijit.form.NumberSpinner" dojoAttachPoint="widgetWidthInput" type="text" required="true" '+
						'class="resizeWidget_inputField" title="${I_CONTEXT_MENU_WIDGET_WIDTH}" '+
						'invalidMessage="${I_CONTEXT_MENU_WIDGET_INPUT_INVALIDMESSAGE}" tabindex=0 />'+
				'</div>'+
				'<div class="clearthefloats"></div>' +
				'<div class="resizeWidgetItem" dojoAttachPoint="resizeHeightDiv">'+
					'<span class="resizeWidget_item_label">${I_CONTEXT_MENU_WIDGET_HEIGHT}</span>'+
					'<input dojoType="dijit.form.NumberSpinner" dojoAttachPoint="widgetHeightInput" type="text" required="true" '+
						'class="resizeWidget_inputField" title="${I_CONTEXT_MENU_WIDGET_HEIGHT}" '+
						'invalidMessage="${I_CONTEXT_MENU_WIDGET_INPUT_INVALIDMESSAGE}" tabindex=0 />'+
				'</div>'+
				'<div class="clearthefloats"></div>' +
			'</div>'+
			'<div dojoType="com.ibm.mm.builder.dialog.DialogFooter" dojoAttachPoint="footer" '+
				'dojoAttachEvent="onSave: save, onCancel: hide">'+
		'</div>',
	
	I_CONTEXT_MENU_WIDGET_INPUT_INVALIDMESSAGE: com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_WIDGET_INPUT_INVALIDMESSAGE,
	// TODO: remove the 'or' after translation is ready
	I_CONTEXT_MENU_WIDGET_WIDTH: com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_WIDGET_WIDTH_TITLE || "Widget width",
	I_CONTEXT_MENU_WIDGET_HEIGHT: com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_WIDGET_HEIGHT_TITLE || "Widget height",
	I_COMMON_CANCEL: com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_CANCEL,
	I_COMMON_SAVE: com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_SAVE,
	
	minWidth:50,
	minHeight:50,
	
	widgetsInTemplate: true,
	
	postCreate: function(){
		this.evtSvc = com.ibm.mashups.services.ServiceManager.getService("eventService");
		
		this.uniDialog = new com.ibm.mm.builder.widget.CustomDialog(this.dlgPara);
		this.uniDialog.containerNode.appendChild(this.domNode);
		
		dojo.connect(this.uniDialog, "onResize", this, "onDialogResize");
		this._setA11YHint();
		
		if(dijit._masterTT){
			dijit.setWaiState(dijit._masterTT.containerNode,"live","assertive");
			dijit.setWaiRole(dijit._masterTT.containerNode,"alert");
		}
	},
	
	_setA11YHint: function() {
		var widthInput = dojo.query("input", this.resizeWidthDiv)[0];
		dojo.attr(widthInput, "title", this.I_CONTEXT_MENU_WIDGET_WIDTH);
		
		var heightInput = dojo.query("input", this.resizeHeightDiv)[0];
		dojo.attr(heightInput, "title", this.I_CONTEXT_MENU_WIDGET_HEIGHT);
		
	},
	
	_onKeyPress:function(evt){
		if (evt.keyCode == dojo.keys.ENTER ){
		   this.save();
		}
	},
	
	hide: function(){
		this.uniDialog.hide();
	},
	
	updateProperty: function(widgetId){
		this.widgetId = widgetId;
		var widgetWrapper = com.ibm.pb.layout.LayoutParser.findById(this.widgetId);
		this.maxSize = this.createMaxSize(widgetId);
		var pageWidthMode = com.ibm.mm.builder.utils.pageWidthChanger.getPageWidthMode();
		this.widgetWidthInput.constraints = {
			min: this.minWidth, 
			max: this.maxSize.maxW,
			places: 0
		};
		this.widgetHeightInput.constraints = {
			min: this.minHeight, 
			max: this.maxSize.h,
			places: 0
		};
		
		var height = dojo.style(widgetWrapper, "height");
		if (height){
			height = parseInt(height,10);	
			this.widgetHeightInput.setValue(height);
		}
		var width = dojo.style(widgetWrapper, "width");
		if (width){
			width = parseInt(width,10);		
			this.widgetWidthInput.setValue(width);		
		}
		this.uniDialog.show();
	},
	
	setTitle: function(title){
		if (this.uniDialog) {
		    this.uniDialog.setTitle(title);
		}
	},
		
	save: function(){
		if (!(this.widgetWidthInput.isValid() && this.widgetHeightInput.isValid())) {
			return;
		}

		var newH = this.widgetHeightInput.getValue();
		var newW = this.widgetWidthInput.getValue();
		
		var payload = {
			widgetId: this.widgetId,
			width: newW,
			height: newH
		};
		this.evtSvc.broadcastEvent("com.ibm.mashups.builder.resizeWidget", payload);
		this.hide();
	},
	
	createMaxSize:function(widgetId){
		var curWidget = com.ibm.pb.layout.LayoutParser.findById(widgetId);
		var containerNode = curWidget.parentNode;
		if(curWidget && containerNode){
			// defect 7486
			var curWidgetBox = dojo.marginBox(curWidget);
			var curLeft = parseInt(curWidgetBox.l,10);
			var curTop = parseInt(curWidgetBox.t,10);	
			var wholeWidth = dojo._getContentBox(containerNode).w;
			var wholeHeight = dojo._getContentBox(containerNode).h;
			var pageWidthRange = com.ibm.mm.builder.utils.pageWidthChanger.getPageWidthRange();
			return {
				maxW: pageWidthRange.max - curLeft,
				w: wholeWidth - curLeft,
				h: wholeHeight - curTop
			};
		}
		return null;		
	},
	
	onDialogResize: function(width, height){
		var dialogContainerCB = dojo.contentBox(this.uniDialog.containerNode);
		var containerMB = dojo.marginBox(this.containerNode);
		var footerHeight = dojo.marginBox(this.footer.domNode).h;
		containerMB.w = dialogContainerCB.w;
		containerMB.h = dialogContainerCB.h - footerHeight;
		dojo.marginBox(this.containerNode, containerMB);
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.widget.RuntimeResizeWidget"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.widget.RuntimeResizeWidget"] = true;
// @author Laura
// This is a popup dialog that allows a user to set the width and/or height on a widget
// An accessible alternative to com.ibm.pb.layout.resize.WidgetResizer

dojo.provide("com.ibm.mm.builder.widget.RuntimeResizeWidget");




dojo.declare("com.ibm.mm.builder.widget.RuntimeResizeWidget",[com.ibm.mm.builder.widget.ResizeWidget],{	
	
	minStyle: {height:"0px",width:"0px"},	 			// the minimum height/width allowed for a skin
	maxStyle: {height:"1000000px",width:"1000000px"},	// the maximum height/width allowed for a skin
	skinId: "",				// the id of the control
	skinNode: null,			// the modifiable runtime skin node
	showHeight: true,		// true if the height input should show
	showWidth: true,		// true if the width input should show
	control: null,			// the DOM node for the control/skin
	bodyClass: "lotusWidgetBody",	// the CSS clas on the widget body present inside the skin
	
	postCreate: function() {
		this.inherited(arguments);
		this.setupDialog(this.skinId,this.showWidth,this.showHeight);
	},
	
	setupDialog: function(skinId, showWidth, showHeight) {
		// summary: update the dialog for the given skin
		// skinId: if of the given skin/control
		// showWidth: true if the width input should be shown
		// showHeight: true if the height input should be shown
		this.skinId = skinId;
		var rsModel = com.ibm.mashups.enabler.runtime.skin.Factory.getRuntimeSkinModel();
		this.skinNode = rsModel.find(this.skinId);
		this.control = com.ibm.pb.layout.LayoutParser.findById(this.skinId);
		// hide the heights or width input if necessary
		this.showWidth = showWidth;
		if (!this.showWidth) {
			dojo.style(this.resizeWidthDiv, "display", "none");
		} else {
			dojo.style(this.resizeWidthDiv, "display", "block");
		}
		this.showHeight = showHeight;
		if (!this.showHeight) {
			dojo.style(this.resizeHeightDiv, "display", "none");
		} else {
			dojo.style(this.resizeHeightDiv, "display", "block");
		}
		this.setupSpinners();
	},
	
	setupSpinners: function() {
		// summary: sets the values and constraints on the width and height input spinners
		
		// calculate the contraints on the height and width by running really small and really big values
		//			for height and width through the style filters so they are reset to reasonable numbers
		var minStyle = dojo.mixin({}, this.minStyle);  this.skinNode.checkStyle(minStyle);
		var maxStyle = dojo.mixin({}, this.maxStyle);  this.skinNode.checkStyle(maxStyle);
		if (this.showHeight) {
			this.widgetHeightInput.constraints = {
				min: parseInt(minStyle.height), 
				max: parseInt(maxStyle.height),
				places: 0
			};
		}
		if (this.showWidth) {
			this.widgetWidthInput.constraints = {
				min: parseInt(minStyle.width), 
				max: parseInt(maxStyle.width),
				places: 0
			};
		}
		
		// set the current height and width as the values in the dialog
		if (this.showHeight) {
			var height = dojo.style(this.control, "height");
			if (height) {
				this.oldHeight = height;
				this.widgetHeightInput.setValue(parseInt(height));
			}
		}
		if (this.showWidth) {
			var width = dojo.style(this.control, "width");
			if (width) {
				this.widgetWidthInput.setValue(parseInt(width));		
			}
		}
		
		// show the dialog
		this.uniDialog.show();
	},
		
	save: function() {
		// summary: save the new height/width to the runtime skin model
		if (this.showWidth && !this.widgetWidthInput.isValid() || this.showHeight && !this.widgetHeightInput.isValid()) {
			return;
		}

		// retrieve the height and/or width inputs
		var style = this.skinNode.getStyle();
		var changes = {};
		if (this.showHeight) {
			var newH = this.widgetHeightInput.getValue();
			this.newHeight = newH;
			changes.height = newH + "px";
		}
		if (this.showWidth) {
			var newW = this.widgetWidthInput.getValue();
			changes.width = newW + "px";
			// get the left value from the DOM instead of "style" in case it's not present in the runtime skin style
			var left = parseInt(dojo.style(this.control).left);
			if (left != Number.NaN && ibmCfg.themeConfig.isRTL) {
				// adjust left style in RTL mode so the widget doesn't jump to the left
				var dx = newW - parseInt(dojo.style(this.control).width);
				changes.left = left - dx + "px";
			}
		}

        // if there is no template url
		// associated with this layout navstate
        // then get it from the page instance
        // and set it here
        var navStateModel = com.ibm.mashups.enabler.model.state.NavigationStateModelFactory.getNavigationStateModel();
        var pageId = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
        var layoutAccessor =  com.ibm.mashups.enabler.model.state.AccessorFactory.getLayoutAccessor(navStateModel, pageId);

        if (!layoutAccessor.getTemplateURL()) {
            var navNode = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel().find(pageId).start(true);
            var content = navNode.getContent().start(true);
            var templateUrl = content.getStaticContentURL();

            layoutAccessor.setTemplateURL(templateUrl)
        }
		
		// save the new control size in the NavState
		var accessorFactory = com.ibm.mashups.enabler.model.state.AccessorFactory;
		var widgetAccessor = accessorFactory.getWidgetAccessor(navStateModel, this.skinId);
		widgetAccessor.setSize(changes.width, changes.height);
		navStateModel.commit().start();
		
		// save the new style to the runtime skin model and make the page dirty
		this.skinNode.setStyle(dojo.mixin(style, changes));
		com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
		
		// update the skin UI and close the dialog
		var newWidthHeight = this._updateUI(changes);
		this.hide();
		
		// broadcast the widget change size event to tell the widget it can reflow since its size has changed
		// create a new changes object instead of just using {height:newH,width:newW} 
		//			because if either height or width is null, errors are thrown
		var changes = {"widgetId":this.skinId};
		if (this.showWidth) {
			changes.newWidth = newW;
		} else {	
			// #18723 include width in column layout too
			var box = dojo.contentBox(dojo.query(".lotusWidgetBody",this.control)[0]);
			changes.newWidth = box.w;
		}
		if (this.showHeight && newWidthHeight) {
			changes.newHeight = parseInt(newWidthHeight);
		}
		this.evtSvc.publishEvent(com.ibm.mashups.iwidget.Constants.RESIZE_WIDGET + "." + this.skinId, changes);
		this.evtSvc.publishEvent("com.ibm.mashups.builder.resizeWidget", changes);  // needed for freeform layout
	},
	
	_updateUI: function(style) {
		// summary: set the new height and width in the UI
		// style: a style object {height:"XXpx",width:"YYpx",left:"ZZpx"} to be set on the control
		dojo.style(this.control, style);
		if (this.showHeight) {
			// the height of the widget body must be adjusted to maintain height:100% in the skin
			var widgetNode = dojo.query("."+this.bodyClass, this.control)[0];
			if (widgetNode) {
				var height = parseInt(dojo.style(widgetNode, "height")) - this.oldHeight + this.newHeight + "px";
				this._setWidgetStyle(height);  // Save this new height
				dojo.style(widgetNode, "height", height);
				return height;
			} else {
				return null;
			}
		} else {
			return null;
		}
	},
	
	_setWidgetStyle: function(/*String*/ style) {
		// summary: along with _setWidgetStyleContinue() sets the wrapper-css-style metadata on the control that will get applied to its widget DOM node
		// style: a string that represents the inline style for the widget DOM node
		var navModel = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel();
		var pageId = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
		var layoutModel = navModel.getLayoutModel(pageId);
		var control = layoutModel.find(this.skinId);
		var me = this;
		control.setFinishedCallback( function(control, status) {
			me._setWidgetStyleContinue(control, status, style);
		}, style);
		control.start(false);
	},
	
	_setWidgetStyleContinue: function(control, status, style) {
		// summary: along with _setWidgetStyle() sets the wrapper-css-style metadata on the control that will get applied to its widget DOM node
		// control: a layout control on which to set the metadata
		// status: the HTTP status result from retrieving the control
		// style: a string that represents the inline style for the widget DOM node
		if (status == 200) {
			control.setMetaData("widget-body-height", style);
		} else {
			console.error("Could not find control when setting wrapper-css-style metadata");
		}
	}
});

}

if(!dojo._hasResource["com.ibm.pb.contextMenu.sharedActions"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.contextMenu.sharedActions"] = true;
// functions referenced by action menus
dojo.provide("com.ibm.pb.contextMenu.sharedActions");




(function(){
	
var enabler = com.ibm.mashups.enabler,
	builder = com.ibm.mashups.builder,
	iwidgetControl = com.ibm.pb.iwidget.control,
	runtimeModel = builder.model.Factory.getRuntimeModel(),
	eventService = com.ibm.mashups.services.ServiceManager.getService("eventService"),
	navModel = enabler.navigation.Factory.getNavigationModel(),
	allowedOpsModel = enabler.ac.operation.AllowedOperationsModelFactory.getAllowedOperationsModel(),
	pbOperations = com.ibm.pb.extension.Operations,
	navStateModelFactory = enabler.model.state.NavigationStateModelFactory,
	accessorFactory = enabler.model.state.AccessorFactory,
	layoutParser = com.ibm.pb.layout.LayoutParser,
	localizedContext = enabler.context.Factory.getLocalizedContext();

var ctxMenus = {
	/** CONTENT SHELF **/
	confirmShowAddContent: function (currentPageID,somepassedinResourceType,_metadata,_someObject) {
		// Cannot show Add Content when:
		//		1. the user does not have edit access to the page
		//		2. there is a maximized widget on the page
		//		3. the page has a legacy layout
		if(!ctxMenus.canEditPage(currentPageID)) { return false; }
		else if(_someObject.isMaximized) { return false; }
		else if(ctxMenus.isLegacyPage(currentPageID,_someObject.layoutMetadataKey,_someObject.layoutFileMetadataKey)) { return false; }
		else { return true; }
	},
	confirmShowChangeStyle: function (currentPageID,somepassedinResourceType,_metadata,_someObject) {
		// Cannot show Change Style when:
		//		1. the user does not have edit access to the page
		//		2. the user does not have editor access to the page
		var page = navModel.find(currentPageID).start();
		if(!ctxMenus.canEditPage(currentPageID)) { return false; }
		else if(!page.hasRole(com.ibm.mashups.enabler.ac.RoleType.EDITOR)) { return false; }
		else { return true; }
	},
	confirmShowChangeLayout: function (currentPageID,somepassedinResourceType,_metadata,_someObject) {
		// Cannot show Change Layout when:
		//		1. the user does not have edit access to the page
		//		2. there is a maximized widget on the page
		//		3. the user does not have editor access to the page
		//		4. the page has a legacy layout
		var page = navModel.find(currentPageID).start();
		if(!ctxMenus.canEditPage(currentPageID)) { return false; }
		else if(_someObject.isMaximized) { return false; }
		else if(!page.hasRole(com.ibm.mashups.enabler.ac.RoleType.EDITOR)) { return false; }
		else if(ctxMenus.isLegacyPage(currentPageID,_someObject.layoutMetadataKey,_someObject.layoutFileMetadataKey)) { return false; }
		else { return true; }
	},
	showAddContent: function (currentPageID,somepassedinResourceType,_metadata,_someObject) {
		if(!ibmCfg.controllers.addContent){
			var maxLabelLength = ibmConfig.fontSizeEnlarged ? _someObject.maxLabelLengthLarge : _someObject.maxLabelLength;
			var acConfig = ibmPortalConfig.isWcmPresent ? _someObject.addContentWCM : _someObject.addContent;
			if(ctxMenus.hasAllowedPortletsList(currentPageID)) { acConfig = _someObject.addContentAllowed; }
			var widgetModel = enabler.widget.Factory.getWidgetModel();
			ibmCfg.controllers.addContent = new com.ibm.pb.customize.AddContentPaletteContainer({
				logger: com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.pb.customize.enabler.AddContentController"),
				smallWidget: true,
				draggable: true,
				dndType: "sm",
				maxLabelLength: maxLabelLength,
				imagePath: _someObject.imagePath,
				jsonFile: acConfig,
				navModel: navModel,
				widgetModel: widgetModel
			}, document.createElement("div"));
		} /*else if (ibmCfg.controllers.addContent.started && _someObject.contentIdChanged){ // causes IE memory leak
			ibmCfg.controllers.addContent.destroyChildWidgets();
			ibmCfg.controllers.addContent.startup();
		}*/
		return ibmCfg.controllers.addContent;
	},
	showChangeStyle: function (currentPageID,somepassedinResourceType,_metadata,_someObject) {
		if(!ibmCfg.controllers.changeStyle){
			var page = navModel.find(currentPageID).start(),
				url = page.getMetaData(_someObject.styleMetadataKey);
			var style = (url) ? url.substring(url.lastIndexOf("/")+1) : _someObject.pageDefaultStyle;
			var maxLabelLength = ibmConfig.fontSizeEnlarged ? _someObject.maxLabelLengthLarge : _someObject.maxLabelLength;
			ibmCfg.controllers.changeStyle = new com.ibm.pb.customize.ChangeStylePaletteContainer({
				logger: com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.pb.customize.enabler.ChangeStyleController"),
				set: style,
				numRows: 2,
				maxLabelLength: maxLabelLength,
				jsonFile: _someObject.changeStyle,
				imagePath: _someObject.imagePath,
				navModel: navModel
			}, document.createElement("div"));
			dojo.subscribe("com.ibm.pb.customize.pageStyleChanged", function(url) {
				var style = (url) ? url.substring(url.lastIndexOf("/")+1) : _someObject.defaultStyle;
				ibmCfg.controllers.changeStyle.set = ibmCfg.controllers.changeStyle.current = style;
				if(ibmCfg.controllers.changeStyle.started) { dojo.hitch(ibmCfg.controllers.changeStyle, "changeSelected", style)(); }
			});
		}
		return ibmCfg.controllers.changeStyle;
	},
	showChangeLayout: function (currentPageID,somepassedinResourceType,_metadata,_someObject) {
		var page = navModel.find(currentPageID).start(),
			content = page.getContent().start(),
			url = content.getMetaData(_someObject.layoutMetadataKey);
		var layout = _someObject.defaultLayout;
		if(url){
			if(url.lastIndexOf("/") == url.length-1) { url = url.substring(0,url.length-1); } 
			layout = url.substring(url.lastIndexOf("/")+1);
		}
		if(!ibmCfg.controllers.changeLayout){
			var maxLabelLength = ibmConfig.fontSizeEnlarged ? _someObject.maxLabelLengthLarge : _someObject.maxLabelLength;
			ibmCfg.controllers.changeLayout = new com.ibm.pb.customize.ChangeLayoutPaletteContainer({
				logger: com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.pb.customize.enabler.ChangeLayoutController"),
				set: layout,
				numRows: 2,
				maxLabelLength: maxLabelLength,
				jsonFile: _someObject.changeLayout,
				imagePath: _someObject.imagePath,
				navModel: navModel
			}, document.createElement("div"));
		} else {
			ibmCfg.controllers.changeLayout.set = ibmCfg.controllers.changeLayout.current = ibmCfg.controllers.changeLayout.current = layout; 
			if(ibmCfg.controllers.changeLayout.started) { dojo.hitch(ibmCfg.controllers.changeLayout, "changeSelected", layout)(); }
		}
		return ibmCfg.controllers.changeLayout;
	},
	hasAllowedPortletsList: function(pageId){
		// summary: returns true if the page has an allowed portlets list
		var page = navModel.find(pageId).start(),
			layout = navModel.getLayoutModel(page.getID()),
			root = layout.getRoot().start(),
			xml = root.getXml(),
			expr = '//*[model:allPortletsAllowed="false"]';
		return com.ibm.mashups.enabler.xml.XPath.evaluateBoolean(expr, xml, {
			atom: "http://www.w3.org/2005/Atom",
			model: "http://www.ibm.com/xmlns/prod/websphere/portal/v6.0.1/portal-model-elements"
		});
	},
	isLegacyPage: function(pageId,layoutMetadataKey,layoutFileMetadataKey){
		// summary: returns true if the page has a legacy layout and false otherwise
		if(pageId){
			var page = navModel.find(pageId).start();
			if(page.getNavigationElementType() === com.ibm.mashups.enabler.navigation.Constants.NAVIGATION_PAGE){
				page = page.getContent().start();
			}
			if(!page) { return true; }
			if(page.getMetaData(layoutMetadataKey)) { return false; }
			else if(page.getMetaData(layoutFileMetadataKey)) { return false; }
			else { return true; }
		} else { return true; }
	},
	canEditPage: function(pageId){
		// summary: returns true if the user can edit the current page
		if(pageId){
			page = navModel.find(pageId).start();
			if(!page) { return false; }
			if(page.hasRole(com.ibm.mashups.enabler.ac.RoleType.ADMIN) || 
				page.hasRole(com.ibm.mashups.enabler.ac.RoleType.EDITOR) ||
				page.hasRole("Privileged User")){
				return true;
			} else { return false; }
		} else { return false; }
	},
	/** PAGE: EDIT **/
	confirmAdvancedActions: function (currentPageID,somepassedinResourceType, _metadata,_someObject) {
		currentContentID = ctxMenus.getContentId(currentPageID);
	    return ( ctxMenus.isOperationAllowed(enabler.ac.operation.Constants.EDIT_LAYOUT, {contentNode: currentContentID}) ||
	        ctxMenus.isOperationAllowed(enabler.ac.operation.Constants.EDIT_PROPERTIES, {contentNode: currentPageID}) ||
			ctxMenus.confirmEditPageProperties(currentPageID,somepassedinResourceType, {operation:enabler.ac.operation.Constants.EDIT_PROPERTIES},_someObject) );
	},
	confirmEditPage: function (currentPageID,somepassedinResourceType, _metadata,_someObject) {
		if (!ctxMenus.isAuthenticated) return false;
		var page = navModel.find(currentPageID).start(), ret = false;
		var type = page.getNavigationElementType();
		if (type == com.ibm.mashups.enabler.navigation.Constants.NAVIGATION_PAGE) {
			if(page.getContent) {
				var sc = page.getContent().start();
				ret = sc.confirmSetStaticMarkup("");
			}
		}	
		return ret;	
	},
	
	isEditActive: function(currentPageID,somepassedinResourceType, _metadata,_someObject) {
		//not used b/c if isEditActive = true, "Edit" will show up even if confirmEditPage = false
		return (runtimeModel.getCurrentPage().getPageMode() != "edit");
	},
	editPage: function (currentPageID,somepassedinResourceType, _metadata,_someObject) {
	    // broadcasts the changePageMode ievent with an edit payload
        var userModel = enabler.user.Factory.getUserModel();
	    if (userModel.getAnonymousMode() != enabler.user.AnonymousMode.ANONYMOUS &&
	        runtimeModel.getCurrentPage().getPageMode() != "edit") {
	    		/* If the rendering controller exists and is in place, delegate mode changes to it */
	    		var controller = dojo.getObject("ibmCfg.controllers.rendering");
	    		if(controller) {
	    			controller.changePageMode("edit");
	    		}
	            else {
	            	eventService.broadcastEvent("com.ibm.mashups.builder.changePageMode", mode);
					runtimeModel.getCurrentPage().setPageMode(mode);
	            }
	    }
	},
	isOperationAllowed: function(operation, jsonContext) {
        if(jsonContext && typeof jsonContext.contentNode == "string"){
            var page = navModel.find(jsonContext.contentNode).start();
            jsonContext.contentNode = page.getContent().start();
        }
		return allowedOpsModel.getOperation(operation,jsonContext).start().isAllowed();
	},
	confirmOperation: function(ID,somepassedinResourceType, _metadata,_someObject){
		var mapping = {id: ID};
		if(!somepassedinResourceType || somepassedinResourceType == "com.ibm.mashups.enabler.navigation.NavigationNode") {
			mapping.navID = ID;
		}
		else {
			mapping.navID = runtimeModel.getCurrentPage().getID();
		}
		//mapping.contentID = ctxMenus.getContentId(mapping.navID);
		if(_metadata.operation == com.ibm.mashups.enabler.ac.operation.Constants.EDIT_PROPERTIES) { mapping.contentID = mapping.navID; }  // always use the navigation node id when checking permission for Edit Page Properties
		var jsonContext = ctxMenus.replaceMapVars(mapping, _metadata.jsonContext);
		return ctxMenus.isOperationAllowed(_metadata.operation,jsonContext);
	},
	confirmEditPageProperties: function(ID,somepassedinResourceType, _metadata,_someObject){
		var page = navModel.find(ID).start();
		var mapping = {id:ID,navID:ID,contentID:ID,contentNode:page};
		return allowedOpsModel.getOperation(_metadata.operation,mapping).start().isAllowed();
	},
	confirmChangeLayout: function(ID,somepassedinResourceType, _metadata,_someObject){
		var page = navModel.find(ID).start();
		if(!page.getContent) { return false; }
		var content = page.getContent().start();
		if(content.getMetaData("com.ibm.portal.layout.template.ref") || page.getMetaData("com.ibm.portal.static.page.file.name.html")){
			return false;
		} else {
			return ctxMenus.confirmOperation(ID,somepassedinResourceType, _metadata,_someObject);
		}
	},
	confirmAssignPermissions: function(ID,somepassedinResourceType, _metadata,_someObject){
		var page = navModel.find(ID).start();
		if(!page.getContent) { return false; }
		return ctxMenus.confirmOperation(ID,somepassedinResourceType, _metadata,_someObject);
	},
	/** PAGE: TAGGING AND RATING **/
	confirmTagAndRatePage: function(currentPageID,somepassedinResourceType, _metadata,_someObject){
		return true;
	},
	confirmCPAction: function(resourceId, resourceType, metadata, someObject){
		/*
		 * For this to work, the metadata.metadataName must be in the node.  If it's hidden
		 * for some reason, it should have been added to the hidden metadata loading strategy
		 * for that model.
		 */
		var configCheck = metadata.configCheck,
			resourceCheck = false,
			node = null;
		
		if (configCheck) {
			if(resourceType === "com.ibm.mashups.enabler.navigation.NavigationNode") {
				node = navModel.find(resourceId).start();
			}
			else if(resourceType === "com.ibm.mashups.iwidget.widget.IWidgetDefinition") {
				var nsm = navStateModelFactory.getNavigationStateModel();
				var spaceId = accessorFactory.getSpaceAccessor(nsm).getSpaceID();
				var pageAccessor = accessorFactory.getPageAccessor(nsm, spaceId);
				var currentPageID = pageAccessor.getPageID();
				var currentPage = navModel.find(currentPageID).start();
				var layoutModel = navModel.getLayoutModel(currentPage); 			
				node = layoutModel.find(resourceId).start();
			}
			else {
				console.warn("resourceType %o is not valid for a CP action", resourceType);
				return;
			}
			
			var scope = node.getMetaData(metadata.metadataName); 
			resourceCheck = scope !== "true";
		}
		return (configCheck && resourceCheck);
	},
	confirmbrowseTags: function (currentPageID,somepassedinResourceType, _metadata,_someObject) {
	    return true;
	},
	browseTags: function (currentPageID,somepassedinResourceType, _metadata,_someObject) {
    	var params = {};
    	params.uri = "tm:browsetags";
    	params.rmparam = "rm:oid:" + currentPageID;
    	var url = ctxMenus.createURL( currentPageID, params );
    	
    	ctxMenus.savePageChecker(function(){top.location.href = url;});
	},
	/** PAGE: SHARING **/
	confirmSharing: function (currentPageID,somepassedinResourceType, _metadata,_someObject) {
	    return ( ctxMenus.confirmAddSharedPages(currentPageID,somepassedinResourceType, _metadata,_someObject) ||
			ctxMenus.confirmSharePage(currentPageID,somepassedinResourceType, _metadata,_someObject) ||
	        ctxMenus.isOperationAllowed(enabler.ac.operation.Constants.ASSIGN_ROLES, {contentNode: currentPageID}));
	},
	confirmSharePage: function (currentPageID,somepassedinResourceType, _metadata,_someObject) {
        if (!currentPageID) { return false; }
        if (!navModel.hasLayoutModel(currentPageID)) { return false; }
		return ctxMenus.isPrivatePage(currentPageID) && ctxMenus.isPageOwner(currentPageID);
	},
	sharePage: function (currentPageID,somepassedinResourceType, _metadata,_someObject) {
		var node = navModel.find(currentPageID).start();
		try {
			var nodeLocale = localizedContext.getLocale(node);
		} catch (e) { //this exception is thrown out when node is created by builder
		}
		var pageName = node.getTitle(nodeLocale || dojo.locale) || node.getTitle(ibmConfig["default.locale"]) || "";          	
		var title = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_ACL_DIALOG_TITLE, [pageName]);
		ctxMenus.showInShareDialog(currentPageID, title);
    },
	assignPagePermissions: function (currentPageID,somepassedinResourceType, _metadata,_someObject) {
		var title = dojo.i18n.getLocalization("com.ibm.bundles", "Theme")["assignPagePermissions_title"];
		ctxMenus.showInShareDialog(currentPageID, title);
	},
	showInShareDialog: function (currentPageID, title){
		var payload = {
			widgetTypeId: "sharePage",
			eventName:  "com.ibm.mashups.builder.sharePage",
			eventPayload:  currentPageID,
			requestRefresh: true,
			dialogParam: {
				title: title.replace(/&/g,"&amp;").replace(/"/g,"&quot;").replace(/</g,"&lt;").replace(/>/g,"&gt;"),
				nodeWidth: "774px",
				hasRightBottomResizer: false
			}
		};
		ctxMenus.savePageChecker(function(){
			eventService.broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog",payload);
		}, function(){
			eventService.broadcastEvent("com.ibm.mashups.builder.switchPage",currentPageID);
			eventService.broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog",payload);
		});
    },
	confirmAddSharedPages: function (currentPageID,somepassedinResourceType, _metadata,_someObject) {
		var parent = navModel.find(ibmConfig.sharedPagesParent).start();
		if(parent.hasRole(com.ibm.mashups.enabler.ac.RoleType.ADMIN) || parent.hasRole(com.ibm.mashups.enabler.ac.RoleType.MANAGER) || parent.hasRole(com.ibm.mashups.enabler.ac.RoleType.EDITOR) || parent.hasRole("Privileged User")) { return true; }
		return false;
	},
	addSharedPages: function (currentPageID,somepassedinResourceType, _metadata,_someObject) {
		
		
		nlsBundle = dojo.i18n.getLocalization("com.ibm.bundles", "Theme");
		var title = nlsBundle["theme_add_pages_shared"];
		var dialogParam = {
			nodeWidth: "600px",
			containerBackgroundColor: "white",
			hasLeftBottomResizer: false,
			hasRightBottomResizer: false,
			title: title
		};
			var payload = {
			widgetTypeId: "viewMorePage",
			eventName: "com.ibm.mashups.builder.viewMorePage",
			eventPayload: "",
			dialogParam: dialogParam,
			requestRefresh: true
		};
		ctxMenus.savePageChecker(function(){
			eventService.broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog",payload); 
		}, function(){
			eventService.broadcastEvent("com.ibm.mashups.builder.switchPage",currentPageID);
			eventService.broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog",payload); 
		});
    },
	/** PAGE: ACTIONS **/
	confirmPageActions: function (currentPageID,somepassedinResourceType, _metadata,_someObject) {
	    return ( ctxMenus.confirmMovePage(currentPageID,somepassedinResourceType, _metadata,_someObject) ||
	        ctxMenus.confirmDeletePage(currentPageID,somepassedinResourceType, _metadata,_someObject) ||
			ctxMenus.confirmCreatePage(currentPageID,somepassedinResourceType, _metadata,_someObject) );
	},
	confirmCreatePage: function (currentPageID,somepassedinResourceType, _metadata,_someObject) {
		var currentNavNode = navModel.find(currentPageID).start();
		return allowedOpsModel.getOperation(pbOperations.CREATE_PAGE,{navNode: currentNavNode}).start().isAllowed();
	},
	createPage: function (currentPageID,somepassedinResourceType, _metadata,_someObject) {
		ctxMenus.savePageChecker(function(){
			iwidgetControl.onLoad(_metadata && _metadata.widgetId, function(){
				var navStateModel = navStateModelFactory.getNavigationStateModel();
				var spaceAccessor = accessorFactory.getSpaceAccessor(navStateModel);
				eventService.broadcastEvent("com.ibm.mashups.builder.createPage", {
					spaceId: spaceAccessor.getSpaceID(),
					parentPageId: currentPageID
				});
			});
		});
	},
	confirmCreateSiblingPage: function(currentPageID,somepassedinResourceType, _metadata,_someObject) {
		var isAuth = com.ibm.pb.contextMenu.sharedActions.isAuthenticated.apply(this,arguments);
		var pageNode = navModel.find(currentPageID).start();
		var parentPageNode = navModel.getParent(pageNode).start();
		var isPage = (pageNode.getNavigationElementType() == com.ibm.mashups.enabler.navigation.Constants.NAVIGATION_PAGE);
		var isOpAllowed = allowedOpsModel.getOperation(pbOperations.CREATE_PAGE,{navNode: parentPageNode}).start().isAllowed();
		return isAuth && isPage && isOpAllowed;
	},
	createSiblingPage: function (currentPageID,somepassedinResourceType, _metadata,_someObject) {
		var pageNode = navModel.find(currentPageID).start();
		var parentNode = navModel.getParent(pageNode).start();
		ctxMenus.savePageChecker(function(){
			iwidgetControl.onLoad(_metadata && _metadata.widgetId, function(){
				var navStateModel = navStateModelFactory.getNavigationStateModel();
				var spaceAccessor = accessorFactory.getSpaceAccessor(navStateModel);
				eventService.broadcastEvent("com.ibm.mashups.builder.createPage", {
					spaceId: spaceAccessor.getSpaceID(),
					parentPageId: parentNode.getID()
				});
			});
		});
	},
	confirmMovePage: function (currentPageID,somepassedinResourceType, _metadata,_someObject) {
		var page = navModel.find(currentPageID).start();
		if (page.getNavigationElementType() === com.ibm.mashups.enabler.navigation.Constants.NAVIGATION_PAGE){
			if(ctxMenus.isPrivatePage(currentPageID)) {
				return true;
			}
			var parent = navModel.getParent(page).start();
	        if (parent === null) {
	            return false;
	        }
			if (parent.hasRole(com.ibm.mashups.enabler.ac.RoleType.ADMIN) || parent.hasRole(com.ibm.mashups.enabler.ac.RoleType.MANAGER) || parent.hasRole(com.ibm.mashups.enabler.ac.RoleType.EDITOR)) { 
				return true; 
			}
		}
		return false;
	},
	movePage: function (currentPageID,somepassedinResourceType, _metadata,_someObject) {
	    ctxMenus.savePageChecker(function(){
			var payload = {
				widgetTypeId: "reorderPage",
				eventName: "com.ibm.mashups.builder.reorderPage",
				eventPayload: {
					pageId: currentPageID,
					spaceId: null
				},
				requestRefresh: true,
				dialogParam: {
					id: currentPageID + "_reorderPane",
					title: dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_REORDER_PAGE_DIALOG_TITLE,[com.ibm.mm.builder.utils.pageUtil.getPageTitle(currentPageID)]),
					nodeWidth: "420px",
					containerBackgroundColor: "white",
					hasRightBottomResizer: false
				}
			};
			com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
		});
	},
	isRemovePage: function (currentPageID,somepassedinResourceType, _metadata,_someObject) {
	    // check for (A) navigationNode.confirmRemove and (B) contentNode.confirmRemove
	    // if (A) and (B) is true, show "Delete this page"
	    // if (A) is true and (B) is false, show "Remove from navigation"
	    // in every other case hide delete
	    var node = navModel.find(currentPageID).start(),
			navRemove = navModel.confirmRemove(node),
			contentId = ctxMenus.getContentId(currentPageID),
			contentNode = navModel.find(contentId).start(),
			contentRemove = navModel.confirmRemove(contentNode);
	    if (navRemove && contentRemove) {
	        return false;
	    } else {
	        return true;
	    }
	},
	confirmDeletePage: function (currentPageID,somepassedinResourceType, _metadata,_someObject) {
	    var node = navModel.find(currentPageID).start();
	    return navModel.confirmRemove(node);
	},
	deletePage: function (currentPageID, somepassedinResourceType, _metadata, _someObject) {
		var bundle = dojo.i18n.getLocalization("com.ibm.bundles", "Theme");
		var pageNode = navModel.find(currentPageID).start();
		if(confirm(dojo.string.substitute(bundle[_metadata.confirmMsgKey], [localizedContext.getTitle(pageNode)]))){
			var node = navModel.find(currentPageID).start();
			var parent = navModel.getParent(node).start();
			var previousSibling = parent; // default to parent if no siblings
			var children = navModel.getChildren(parent);
			var child;
			// find previous sibling
			while (children.hasNext()) {
				child = children.next();
				if (child.getID() === currentPageID) {
					// if first child, and there are other children, use second child (next sibling)
					if (previousSibling === parent && children.hasNext()) {
						previousSibling = children.next();
					}
					break;
				}
				previousSibling = child;
			}			
			if ( navModel.confirmRemove(node) ) {
				navModel.remove(node);
			}
			navModel.commit().setFinishedCallback(function(){
				// clear all widget edit modes since we're deleting and discarding any changes
				com.ibm.pb.contextMenu.sharedActions.widgetEditModeClearer();	
				com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setID(null);
				com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(false);
				// switch to previous sibling
				var navStateModel = navStateModelFactory.getNavigationStateModel();
				var pageAccessor = accessorFactory.getPageAccessor(navStateModel, null);
				pageAccessor.setPageID(previousSibling.getID());
				navStateModel.commit().setFinishedCallback(function(){
					var evtSvc = com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService");
					evtSvc.broadcastEvent("com.ibm.mashups.builder.switchPage", previousSibling.getID());
					evtSvc.broadcastEvent("com.ibm.mashups.builder.refreshNavigation", previousSibling.getID());
				}).start();
			}).start();
		}
	},
	
	/** WIDGET: RESIZE **/
	resizeWidget: function(ID, resourceType, metadata, someObject) {
		var layoutControl = com.ibm.mm.builder.utils.pageUtil.getLayoutControlByWidgetId(ID);
		var widgetTitle = com.ibm.mm.builder.utils.enablerUtil.getNodeTitle(layoutControl,dojo.locale);
		var dialogTitle = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_RESIZE_WIDGET_PROMPT, [widgetTitle]);
		var containerType = ctxMenus.getContainerType(ID);
		
		if(!com.ibm.pb.contextMenu.sharedActions.resizeWidgetDialog) {
			
			com.ibm.pb.contextMenu.sharedActions.resizeWidgetDialog = new com.ibm.mm.builder.widget.RuntimeResizeWidget({
				dlgPara: {
					title: dialogTitle,
					nodeWidth: "395px",
					containerBackgroundColor: "white",
					requestRefresh: true
				},
				skinId: ID,
				showHeight: containerType != "row",
				showWidth: containerType != "column"
			});
		} else {
			com.ibm.pb.contextMenu.sharedActions.resizeWidgetDialog.setTitle(dialogTitle);
			com.ibm.pb.contextMenu.sharedActions.resizeWidgetDialog.setupDialog(ID, containerType != "column", containerType != "row");
		}
	},
	confirmResizeWidget: function(ID, resourceType, metadata, someObject) {
		if(com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getPageMode() == "view") {
			return false;
		}
		var windowID = ID; // we can assume that window ID and control ID are always the same, even in live preview
		
		var	currentMode = ctxMenus.getWidgetAccessor(windowID).getWindowState() || com.ibm.mm.iwidget.Constants.windowstate.NORMAL;
		return currentMode == com.ibm.mm.iwidget.Constants.windowstate.NORMAL;
	},
	getContainerType: function(controlId) {
		// returns "row" "column" "freeform" or null
		var control = layoutParser.findById(controlId),
			container = control.parentNode; 
		while (!dojo.hasClass(container,"component-container") && container.id != "layoutContainers") {
			container = container.parentNode;
		}
		if (dojo.hasClass(container, "ibmDndColumn")) {
			return "column";
		} else if (dojo.hasClass(container, "ibmDndRow")) {
			return "row";
		} else if (dojo.hasClass(container, "ibmDndFreeform")) {
			return "freeform";
		} else {
			return null;
		}
	},
	/** WIDGET: WIRING **/
	confirmEditWiring: function(ID, resourceType, metadata, someObject) {
		if(runtimeModel.getCurrentPage().getPageMode() == "view") { return false; }
		var layoutModel = ctxMenus.getLayoutModel(runtimeModel.getCurrentPage().getID()),
			wireModel = layoutModel.getWireModel();
		return wireModel.confirmCreate();
	},
	editWiring: function(ID, resourceType, metadata, someObject) {
		var dialogParam = {
				nodeWidth: '486px',
				title: com.ibm.mm.builder.coreWidgetsStrings.I_WIRING_NAME || "Wiring",
				leftBarWidth: '18px',
				rightBarWidth: '12px',
				displayCloseButton: true,
				hasRightBottomResizer: false
			};
			var payload = {
				widgetTypeId: 'wireInterface',
				eventName:  'com.ibm.mashups.builder.editWire',
				eventPayload: ID,
				dialogParam:  dialogParam,
				hasRightBottomResizer: false,
				requestRefresh: true
			};
			eventService.broadcastEvent('com.ibm.mashups.builder.displayInMashupDialog', payload);
			runtimeModel.getCurrentPage().setDirty(true);
	},
	/** WIDGET: CHANGE MODE **/
	confirmChangeWidgetMode: function (ID, somepassedinResourceType, _metadata, _someObject) {
		// summary: returns true if the control with the given ID can change into the given mode
		var widgetModel = enabler.widget.Factory.getWidgetModel();
		var window = widgetModel.findWidgetWindow(ID,runtimeModel.getCurrentPage().getID()).start(),
			definition = widgetModel.getWidgetDefinitionByWindow(window).start(),
			supportedModes = definition.getSupportedModes();
        var windowID = window.getID();
		var currentMode = ctxMenus.getWidgetAccessor(windowID).getWidgetMode() || com.ibm.mm.iwidget.Constants.mode.VIEW;
		if(currentMode == _metadata.mode) { return false; }  // already in this mode
		var unSwitchableModes = [com.ibm.mm.iwidget.Constants.mode.EDIT,
           com.ibm.mm.iwidget.Constants.mode.PERSONALIZE,com.ibm.mm.iwidget.Constants.mode.CONFIG];	
           //Our widgets does not support well on switch directly within these modes.
           //The reason is, our widgets rely on back to view mode to release dijits. 
        if(dojo.indexOf(unSwitchableModes,currentMode)>=0 && dojo.indexOf(unSwitchableModes,_metadata.mode)>=0 ){
            return false;
        }
		if (dojo.indexOf(supportedModes,_metadata.mode)<0){
			return false;
		}
		return ctxMenus.confirmOperation(ID, somepassedinResourceType, _metadata, _someObject);
	},
	changeWidgetMode: function (ID, somepassedinResourceType, _metadata, _someObject) {
		// summary: changes the mode of the control with the given ID by publishing an event or generating a new state url
		if (_metadata.mode == com.ibm.mm.iwidget.Constants.mode.HELP){  // only works in SSA, need to fire event for CSA but this will prb save state
			// help mode is launched in a new window in solo mode
			var urlGen = com.ibm.mashups.enabler.model.state.UrlGeneratorFactory.getURLGenerator(),
				navStateModel = navStateModelFactory.getNavigationStateModel(),
				widgetAccessor = ctxMenus.getWidgetAccessor(ID);
			widgetAccessor.setWidgetMode(com.ibm.mm.iwidget.Constants.mode.HELP);
			urlGen.getURL(navStateModel, function(url) {
				window.open(url,'','resizable=yes,scrollbars=yes,menubar=no,toolbar=no,status=no,width=800,height=600,screenX=10,screenY=10,top=10,left=10');
				navStateModel.discard();
			}, {"newWindow": true, "themeTemplate":"Plain", "soloState":{"portletWindowID":ID,"returnSelection":runtimeModel.getCurrentPage().getID()}});
		} else {
            var windowID = ID; // we can assume that window ID and control ID are always the same, even in live preview
			eventService.publishEvent(_metadata.event, {id:windowID, newMode:_metadata.mode});  // fire event, does nothing for portlets
			if (!ibmCfg.themeConfig.isPageRenderModeCSA && ctxMenus.getWidgetAccessor(windowID).getWidgetMode() != _metadata.mode) {
				// change navigational state and refresh page for portlets to change their modes
				// NOTE: this is only triggered for portlets (SSA only), so this code should never run in Mashups
				var navStateModel = navStateModelFactory.getNavigationStateModel();
				ctxMenus.getWidgetAccessor(windowID).setWidgetMode(_metadata.mode);
				runtimeModel.getCurrentPage().setID(runtimeModel.getCurrentPage().getID());
				navStateModel.commit().start();
				ctxMenus.savePageChecker(function(){
					document.location.href = enabler.model.state.UrlGeneratorFactory.getUrlGenerator().getUrl(navStateModel);
				});
			}
		}
	},
	getWidgetAccessor: function(id) {
		// summary: returns a widget accessor for the given widget/portlet id
		var navStateModel = navStateModelFactory.getNavigationStateModel(),
			widgetAccessor = accessorFactory.getWidgetAccessor(navStateModel, id);
		return widgetAccessor;
	},
	/** WIDGET: CHANGE STATE **/
	confirmChangeWindowState: function (ID,somepassedinResourceType, _metadata,_someObject) {
		if(ctxMenus.isPlainThemeTemplate()) { return false; }
		var navStateModel = navStateModelFactory.getNavigationStateModel();
        var windowID = ID; // we can assume that window ID and control ID are always the same, even in live preview
		var widgetAccessor = accessorFactory.getWidgetAccessor(navStateModel, windowID);
		var currentWindowState = widgetAccessor.getWindowState();
		
		if(!currentWindowState){ currentWindowState = widgetAccessor.NORMAL; }		

		// Mashup fixes for hiding max/min/restore for hidden widgets
        var hiddenContainerID = ctxMenus.getHiddenContainerID();
        var hiddenContainerNode = layoutParser.findById(hiddenContainerID);
        var result = dojo.query(".id-"+ID,hiddenContainerNode);
        if (result.length>0) {
            return false;
        }
		// End
		
		if(_metadata.newWindowState == widgetAccessor.NORMAL && currentWindowState == widgetAccessor.NORMAL){
			return false;
		}else if(_metadata.newWindowState == widgetAccessor.MIN && currentWindowState == widgetAccessor.MIN){
			return false;
		}else if(_metadata.newWindowState == widgetAccessor.MAX && currentWindowState == widgetAccessor.MAX){
			return false;
		}
		return true;
	},
	
	changeWindowState: function (ID, somepassedinResourceType, _metadata, _someObject) {
		// summary: changes the window state of the control with the given ID by publishing an event
		var navStateModel = navStateModelFactory.getNavigationStateModel();		
        var windowID = ID; // we can assume that window ID and control ID are always the same, even in live preview
		var widgetAccessor = accessorFactory.getWidgetAccessor(navStateModel, windowID);

		if(ibmCfg.themeConfig.isPageRenderModeCSA){
			var currentWindowState = widgetAccessor.getWindowState();
			if(!currentWindowState){ currentWindowState = widgetAccessor.NORMAL; }
			eventService.publishEvent(_metadata.event, {id: windowID, controlId: ID, newWindowState: _metadata.newWindowState, oldWindowState: currentWindowState});	
		}else{
			var pid = runtimeModel.getCurrentPage().getID();
			widgetAccessor.setWindowState(_metadata.newWindowState);
			runtimeModel.getCurrentPage().setID(pid);
			navStateModel.commit().start();
			if(!_metadata.noRefresh){
				ctxMenus.savePageChecker(function(){
					top.location.href = enabler.model.state.UrlGeneratorFactory.getUrlGenerator().getUrl(navStateModel);
				});
			}else{  // this is triggered when a widget needs to be unmaximized before being deleted or hidden
				var currentWindowState = widgetAccessor.MAX;
				eventService.publishEvent(_metadata.event, {id: windowID, controlId: ID, newWindowState: _metadata.newWindowState, oldWindowState: currentWindowState});	
			}
		}		
	},
	/** WIDGET: DISPLAY **/
	confirmDisplayControl: function (ID, somepassedinResourceType, _metadata, _someObject) {
		if (runtimeModel.getCurrentPage().getPageMode() == "view") { 
			return false; 
		}
        var hiddenContainerID = ctxMenus.getHiddenContainerID();
        if (!hiddenContainerID) {
            return false; // there is no hidden container
        }
        var layoutModel = ctxMenus.getLayoutModel(runtimeModel.getCurrentPage().getID()),
            control = layoutModel.find(ID).start();
        if (!control) { return false; }
        var parent = layoutModel.getParent(control).start();
        if (parent.getID() == hiddenContainerID) {
            return true; // the container is already hidden
        }
        return false;
	},
	
	displayControl: function (ID, somepassedinResourceType, _metadata, _someObject) {
		var layoutModel = ctxMenus.getLayoutModel(runtimeModel.getCurrentPage().getID());
		var rootDef = layoutModel.getRoot();
		var root = rootDef.start(); 
		var iter = layoutModel.getChildren(root); 
		var firstContainerDiv = null;
		var layoutContainers = dojo.byId("layoutContainers");
		var container = null;
		var childNodes = dojo.query(".component-container",layoutContainers);
		for (var i=0;i<childNodes.length;i++){
			if (dojo.hasClass(childNodes[i],"hiddenWidgetsContainer")==false){
				firstContainerDiv=childNodes[i];
				break;
			}
		}
		while(iter.hasNext()){
			container = iter.next();
			if (firstContainerDiv == layoutParser.findById(container.getID())){
				break;
			}
		}
		if (container) {
			var control = layoutModel.find(ID).start();
			var nextSibling = null;
			var iter = layoutModel.getChildren(container);
			if(iter.hasNext()) { nextSibling = iter.next(); }
			if(nextSibling && !(nextSibling instanceof com.ibm.mashups.enabler.layout.LayoutControl)) { 
				nextSibling = null;
			}
			layoutModel.insert(control, container, nextSibling);
			var controlDiv = layoutParser.findById(control.getID());
			if (nextSibling){
				firstContainerDiv.insertBefore(controlDiv,layoutParser.findById(nextSibling.getID()));
			}else{
				firstContainerDiv.appendChild(controlDiv); 
			}
			runtimeModel.getCurrentPage().setDirty(true);
			eventService.broadcastEvent("com.ibm.mashups.builder.widgetMoved", ID);
			if(com.ibm.pb.control.DNDController){
				com.ibm.pb.control.DNDController.getController().dndSources[container.getID()].sync();
			}
		} 
	},		
	/** WIDGET: HIDE **/
	confirmHideControl: function (ID, somepassedinResourceType, _metadata, _someObject) {
		// summary: returns true if the control with the given ID can be moved into the hidden widget container
        if(runtimeModel.getCurrentPage().getPageMode() == "view") { return false; }
        var hiddenContainerID = ctxMenus.getHiddenContainerID();
        if(!hiddenContainerID) {
            return false;  // there is no hidden container
        }
        var layoutModel = ctxMenus.getLayoutModel(runtimeModel.getCurrentPage().getID()),
            control = layoutModel.find(ID).start();
        if (!control) { return false; }
        var parent = layoutModel.getParent(control).start();
        if(parent.getID() == hiddenContainerID) {
            return false;  // the container is already hidden
        }
        var hiddenContainer = ctxMenus.getHiddenContainer();
        return layoutModel.confirmInsert(control, hiddenContainer);  // return if user can insert into the hidden container
	},
	hideControl: function (ID, somepassedinResourceType, _metadata, _someObject) {
		// summary: moves the control with the given ID into the hidden widgets container
		var layoutModel = ctxMenus.getLayoutModel(runtimeModel.getCurrentPage().getID()),
			hiddenContainer = ctxMenus.getHiddenContainer(),
			hiddenContainerDom = layoutParser.findById(hiddenContainer.getID()),
			control = layoutModel.find(ID).start(),
			controlDom = layoutParser.findById(control.getID());
		ctxMenus.changeWindowState(ID, somepassedinResourceType, {
			newWindowState: "normal",
			event: com.ibm.mashups.iwidget.Constants.CHANGE_WIDGETWINDOWSTATE,
			noRefresh: true
		}, _someObject);
			
		layoutModel.insert(control, hiddenContainer);
		hiddenContainerDom.appendChild(controlDom);
		runtimeModel.getCurrentPage().setDirty(true);
		eventService.broadcastEvent("com.ibm.mashups.builder.widgetMoved", ID);
		if(com.ibm.pb.control.DNDController){
			var dndS = com.ibm.pb.control.DNDController.getController().dndSources;
			if(dndS[hiddenContainer.getID()]) {
				dndS[hiddenContainer.getID()].sync();
			}
		}
	},
	/** WIDGET: DELETE **/
	confirmDeleteControl: function (ID, somepassedinResourceType, _metadata, _someObject) {
		// summary: returns true if the control with the given ID can be deleted
		if(runtimeModel.getCurrentPage().getPageMode() == "view") { return false; }
		var layoutModel = ctxMenus.getLayoutModel(runtimeModel.getCurrentPage().getID()),
			control = layoutModel.find(ID).start();
		if (!control) { return false; }
		return layoutModel.confirmRemove(control);
	},
    deleteControl: function (ID, somepassedinResourceType, _metadata, _someObject) {
        // summary: removes the control with the given ID from the layout model and then the DOM
        var layoutModel = ctxMenus.getLayoutModel(runtimeModel.getCurrentPage().getID()),
            domNode = layoutParser.findById(ID);
        var control = layoutModel.find(ID).start();
        var wid = ID; // we can assume that window ID and control ID are always the same, even in live preview
        ctxMenus.changeWindowState(ID, somepassedinResourceType, {
			newWindowState: "normal",
			event: com.ibm.mashups.iwidget.Constants.CHANGE_WIDGETWINDOWSTATE,
			noRefresh: true
		}, _someObject);
        layoutModel.remove(control);
        if(domNode) {
            domNode.parentNode.removeChild(domNode);
        }
        runtimeModel.getCurrentPage().setDirty(true);
        eventService.broadcastEvent("com.ibm.mashups.builder.widgetDeleted", ID);
        eventService.broadcastEvent(com.ibm.mashups.iwidget.Constants.UNLOAD_WIDGETS,[wid]);
    },
	/** HELPERS **/
	widgetEditModeChecker: function() {
		var widgetModel = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel();
		var widgets = widgetModel.getAllWidgets();
		var hasWidgetInEditMode = false;
		for(var i in widgets) {
			if(Object.prototype.hasOwnProperty.call(widgets, i)) {
				var mode = widgets[i].currentMode;
				if(mode && mode != "view") {	// mode could be undefined
					hasWidgetInEditMode = true;
					break;
				}
			}
		}
		if(hasWidgetInEditMode) {
			var cws = com.ibm.mm.builder.coreWidgetsStrings;
			// TODO: in case it is not localized... remove them when pii are ready
			var warning = cws.I_PAGE_SAVE_WARNING3 ? cws.I_PAGE_SAVE_WARNING3 : "You have unsaved widgets on the page.";
			var suggest = cws.I_PAGE_SAVE_SUGGEST2 ? cws.I_PAGE_SAVE_SUGGEST2 : "Save or discard the changes before leaving the page.";
			var returnBtn = cws.I_COMMON_RETURN ? cws.I_COMMON_RETURN : "Return";
			// No callback here since we always force users to back to page
			var confirmDlg = new com.ibm.mm.builder.dialog.PageSaveConfirmDialog({
		        contentWarning: warning,
		        contentQuestion: suggest,
		        btnSaveText: returnBtn,
		        btnCancelText: cws.I_COMMON_CANCEL,
				hideNotSave: true,
				savePageOnSave: false
		    });
		    confirmDlg.show();
		}
		return hasWidgetInEditMode;
	},
	widgetEditModeClearer: function() {
		var widgetModel = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel();
		var widgets = widgetModel.getAllWidgets();
		for(var i in widgets) {
			if(Object.prototype.hasOwnProperty.call(widgets, i)) {
				var mode = widgets[i].currentMode;
				if(mode && mode != "view") {	// mode could be undefined
					widgets[i].currentMode = "view";
				}
			}
		}
	},
	savePageChecker: function(callbackSave, callbackNoSave, cancelcb){
		if(runtimeModel.getCurrentPage().isDirty()){
			ibmCfg.themeConfig.savePageCheckerUnloading = true;
			if(!callbackNoSave) callbackNoSave = callbackSave;
			var cws = com.ibm.mm.builder.coreWidgetsStrings;
			var saveConfirmDlg = new com.ibm.mm.builder.dialog.PageSaveConfirmDialog({
		        contentWarning: cws.I_PAGE_SAVE_WARNING,
		        contentQuestion: cws.I_PAGE_SAVE_SUGGEST,
		        btnSaveText: cws.I_COMMON_SAVE,
		        btnNotSaveText: cws.I_PAGE_SAVE_NO_SAVE,
		        btnCancelText: cws.I_PAGE_SAVE_KEEP_EDIT,
				hideNotSave: true,
		        callbackSave: function(){ibmCfg.themeConfig.savePageCheckerUnloading=false;if(callbackSave)callbackSave();},
		        callbackNotSave: function(){ibmCfg.themeConfig.savePageCheckerUnloading=false;if(callbackNoSave)callbackNoSave();},
				callbackCancel: function(){ibmCfg.themeConfig.savePageCheckerUnloading=false;if(cancelcb)cancelcb();}
		    });
		    saveConfirmDlg.show();
		} else {
			if (callbackSave) {
				callbackSave();
			}
		}
	},
	getContentId: function(navId) {
		var navNode = navModel.find(navId).start();
		if(navNode && navNode.getContent) {
			var content = navNode.getContent().start();
			if(content) {
				navId = content.getID();
			}
		}
		return navId;
	},
    getHiddenContainerID: function () {
        var dom = dojo.query(".hiddenWidgetsContainer", layoutParser.getRootNode());
        if (dom) {
            return layoutParser.extractID(dom[0]);
        }
        return null;
    },
	getHiddenContainer: function () {
		// summary: returns the layout control with the name "ibmHiddenWidgets"
		var layoutModel = ctxMenus.getLayoutModel(runtimeModel.getCurrentPage().getID()),
			root = layoutModel.getRoot().start(),
			children = layoutModel.getChildren(root);
		while(children.hasNext()) {
			var child = children.next();
			if(child.getMetaData("com.ibm.portal.layoutnode.localname") == "ibmHiddenWidgets") {
				return child;
			}
		}
		return null;
	},
	getLayoutModel: function (pageId) {
		// summary: returns the layout model for the current page
		return navModel.getLayoutModel(pageId);
	},
	isPrivatePage: function(pageId){
		var navNode = navModel.find(pageId).start(),
			xml = navNode.getXml(),
			expr = "./atom:content/*/ac:allowed-access[@ac:private='true']";
		return com.ibm.mashups.enabler.xml.XPath.evaluateBoolean(expr, xml, {
			app: "http://www.w3.org/2007/app",
			atom: "http://www.w3.org/2005/Atom",
			ac: "http://www.ibm.com/xmlns/prod/lotus/access-control/v1.0"
		});
	},
	isPageOwner: function(pageId){
		var layoutModel = ctxMenus.getLayoutModel(pageId),
			layoutNode = layoutModel.getRoot().start(),
			acModel = com.ibm.mashups.enabler.ac.AccessControlModelFactory.getAccessControlModel(layoutNode),
			pageOwner = acModel.getOwner();
		if (pageOwner) {
			var userModel = com.ibm.mashups.enabler.user.Factory.getUserModel(),
				currentUser = userModel.findCurrentUser().start();
			if (pageOwner.getID() == currentUser.getID()) { return true; }
		}
		return false;
	},
	isAuthenticated: function() {
        var userModel = enabler.user.Factory.getUserModel();
		return userModel.getAnonymousMode() != enabler.user.AnonymousMode.ANONYMOUS;
	},
	isAnonymous: function() {
		return !ctxMenus.isAuthenticated();
	},
	isPlainThemeTemplate: function() {
		if (ibmCfg && ibmCfg.portalConfig && ibmCfg.portalConfig.bootstrapState 
			&& ibmCfg.portalConfig.bootstrapState.indexOf("<theme-template>Plain</theme-template>") >= 0) {
			return true;
		} else {
			return false;
		}
	},
	broadcastEventFromCurrentPage: function(currentResourceID,resourceType, metadata,someObject) {
		return ctxMenus.broadcastEvent.call(this,runtimeModel.getCurrentPage().getID(),resourceType, metadata,someObject);
	},
	broadcastEvent: function(currentResourceID,somepassedinResourceType, _metadata,_someObject) {
		var evtSvc = com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService");
		evtSvc.broadcastEvent(_metadata.event, {resourceId: currentResourceID, resourceType: somepassedinResourceType, domNode: this});
	},
	openWidget: function(currentResourceID,somepassedinResourceType, _metadata,_someObject) {
		var scope = this;
		iwidgetControl.onLoad(_metadata && _metadata.widgetId, function(iWidgetWrapper){
			if(iWidgetWrapper && iWidgetWrapper.iScope) {
				iWidgetWrapper.iScope.open({resourceId: currentResourceID, resourceType: somepassedinResourceType, domNode: scope});
			}
		});
	},
	loadURL: function(currentPageID,somepassedinResourceType, _metadata,_someObject) {
		ctxMenus.savePageChecker(function(){top.location.href = _metadata.url;});
	},
	refreshPage: function () {
		ctxMenus.savePageChecker(function () {
			var url = ctxMenus.createRefreshURL();
			dojo.cookie( "DigestTracker", (new Date()).getTime(), {path: "/"} );
			top.location.href = url;
		});
	},
	createRefreshURL: function () {
		var navStateModel = navStateModelFactory.getNavigationStateModel();
		var urlGen = enabler.model.state.UrlGeneratorFactory.getURLGenerator();
		return urlGen.getURL( navStateModel, null, { "nohash": true } );
	},
	createURL: function(targetPageID,urlParams){
		var navStateModel = navStateModelFactory.getNavigationStateModel();
		var spaceAccessor = accessorFactory.getSpaceAccessor(navStateModel);
		var pageAccessor = accessorFactory.getPageAccessor(navStateModel, spaceAccessor.getSpaceID());
		pageAccessor.setPageID(targetPageID);
		var urlGen = enabler.model.state.UrlGeneratorFactory.getURLGenerator();
		// add params to urlParams
		return (urlGen.getURL(navStateModel, null, {}) + "?" + dojo.objectToQuery(urlParams));
	},
	createURL: function(targetPageID,urlParams,widgetParams){
		var navStateModel = navStateModelFactory.getNavigationStateModel();
		var spaceAccessor = accessorFactory.getSpaceAccessor(navStateModel);
		var pageAccessor = accessorFactory.getPageAccessor(navStateModel, spaceAccessor.getSpaceID()),
			widgetAccessor, widgetState;
			
		pageAccessor.setPageID(targetPageID);
		
		/**
		 * widgetParams map has this format
			{
			  "widgetId_1": {
				mode: com.ibm.mm.iwidget.Constants.mode.EDIT,
				windowState: com.ibm.mm.iwidget.Constants.windowstate.MAXIMIZE,
				parameters: {
					"param1": "value1",
					"param2": ["value2", "value3"]
				}
			  },
			  "widgetId_2": {
				parameters: {
					"param1": "value1"
				}
			  }
			}
		 */
		for(var id in widgetParams) {
			widgetState = widgetParams[id];
			widgetAccessor = accessorFactory.getWidgetAccessor(navStateModel, id);
			if(widgetState.mode) {
				widgetAccessor.setWidgetMode(widgetState.mode);
			}
			if(widgetState.windowState) {
				widgetAccessor.setWindowState(widgetState.windowState);
			}
			for(var p in widgetState.parameters) {
				widgetAccessor.setWidgetState(p, widgetState.parameters[p]);
			}
		}
		
		var urlGen = enabler.model.state.UrlGeneratorFactory.getURLGenerator();
		// add params to urlParams
		return (urlGen.getURL(navStateModel, null, {}) + "?" + dojo.objectToQuery(urlParams));
	},
	navigateToPageFromCurrent: function(currentPageID,resourceType,metadata,someObject) {
		return ctxMenus.redirectToHiddenPage.call(this,runtimeModel.getCurrentPage().getID(),resourceType,metadata,someObject);
	},
	navigateToPage: function() {
		return ctxMenus.redirectToHiddenPage.apply(this, arguments);
	},
	redirectToHiddenPage: function(currentPageID,somepassedinResourceType, _metadata,_someObject) {
		var contentNodeId = currentPageID,
			targetPageNavNode = navModel.find(currentPageID).start();
		if(targetPageNavNode.getContent) {
			var contentNode = targetPageNavNode.getContent().start();
			contentNodeId = contentNode.getID();
		}
		// TODO: do we need to do some error checking if the IDs are null or leave the error handling to the target page?
		var mapping = {
		    navID: currentPageID,
		    contentID: contentNodeId
		};
		var newParams = ctxMenus.replaceMapVars(mapping, _metadata.urlParams);
		var widgetParams = ctxMenus.replaceMapVars(mapping, _metadata.widgetParams);
		var url = ctxMenus.createURL(_metadata.targetPageID, newParams, widgetParams);
		ctxMenus.savePageChecker(function(){
			if(_metadata && _metadata.refreshCache) {
				dojo.cookie( "DigestTracker", (new Date()).getTime(), {path: "/"} );
			}
			top.location.href = url;
		});
	},
	replaceMapVars: function(mapping, template) {
		var ret = template;
		if(dojo.isString(template)) {
			ret = dojo.string.substitute(template, mapping, function(value, key){
				if(value === undefined) {
					if(key === "contentID") {
						return ctxMenus.getContentId(mapping.navID);
					}
					else {
						return "";
					}
				}
				else {
					return value;
				}
			});
		}
		else if(dojo.isArray(template)){
			ret = [];
			for(var i=0; i<template.length; i++) {
				ret.push(ctxMenus.replaceMapVars(mapping, template[i]));
			}
		}
		else if(dojo.isObject(template)) {
			ret = {};
			for(var key in template) {
				ret[key] = ctxMenus.replaceMapVars(mapping, template[key]);
			}
		}
		return ret;
	},
	
	confirmLogout: function() {
		if(com.ibm.pb.contextMenu.sharedActions.widgetEditModeChecker()) {
			// skip the page dirty check and display another confirm dialog if there is unsaved widget
			return;
		}
		if(runtimeModel.getCurrentPage().isDirty()){
			var cws = com.ibm.mm.builder.coreWidgetsStrings;
			var saveConfirmDlg = new com.ibm.mm.builder.dialog.PageSaveConfirmDialog({
		        contentWarning: cws.I_PAGE_SAVE_WARNING,
		        contentQuestion: cws.I_PAGE_SAVE_SUGGEST,
		        btnSaveText: cws.I_COMMON_SAVE,
		        btnNotSaveText: cws.I_PAGE_SAVE_NO_SAVE,
		        btnCancelText: cws.I_PAGE_SAVE_KEEP_EDIT,
		        hideNotSave: true,
		        callbackSave: function() {
					var deffered = navModel.commit();
					deffered.setFinishedCallback(function() {
						com.ibm.pb.contextMenu.sharedActions.logout();
					});
					deffered.start();
				},
		        callbackNotSave: function() {
					com.ibm.pb.contextMenu.sharedActions.logout();
				},
				callbackCancel: function() {}
		    });
		    saveConfirmDlg.show();
		} else {
			com.ibm.pb.contextMenu.sharedActions.logout();
		}
	},
	
	logout: function() {
		
		// handle when current page is a global page
		com.ibm.pb.control.NavigationController.getController().setLastNonGlobalPage();
		
        var cs = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
		location.pathname = cs.getValue(com.ibm.mashups.enabler.services.ConfigConstants.LOGOUT_URL);
	}
};
com.ibm.pb.contextMenu.sharedActions = ctxMenus;

})();


}

if(!dojo._hasResource["com.ibm.pb.iwidget.PageModeWidgetHandler"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.iwidget.PageModeWidgetHandler"] = true;
dojo.provide("com.ibm.pb.iwidget.PageModeWidgetHandler");

/**
 * This module is used when parsing the page at initialization time to detect
 * iwidgets that are only used in certain page modes and to dynamically turn them 
 * into lazy-loading iwidgets by using a rendering controller like the
 * com.ibm.pb.control.RenderingController with the addModeWidgets function.
 * It's the RenderingController's responsibility to load those iwidgets when
 * the a particular page mode is entered for the first time.
 */
dojo.declare("com.ibm.pb.iwidget.PageModeWidgetHandler", null, {
	
	CLASS_PREFIX: "pb-pageMode-",
	
	renderingController: null,
	matchingModes: [],
	
	constructor: function(args) {
		dojo.safeMixin(this, args);
		if(!this.matchingModes) {
			this.matchingModes = [];
		}
		this.modeWidgets = {};
		dojo.forEach(this.matchingModes, function(mode){
			this.modeWidgets[mode] = [];
		}, this);
	},
	preProcessCallbackFunc: function(domNode, livetextList, tagEntry) {
		if(this.renderingController && this._isMatchingIWidgets(tagEntry)) {
			dojo.forEach(livetextList, function(node){
				for(var mode in this.modeWidgets) {
					if(dojo.hasClass(node, this.CLASS_PREFIX + mode)) {
						// if this inline iwidget declaration specifies
						// a class name with the given CLASS_PREFIX and
						// a mode we're matching, then turn it into a lazy-
						// loaded iwidget for that page mode
						node.setAttribute("lazyLoad", "true");
						var id = node.getAttribute("id");
						this.modeWidgets[mode].push(id);
						this.renderingController.addModeWidgets(mode, [id]);
					}
				}
			}, this);
		}
	},
	postProcessCallbackFunc: function(domNode, livetextList, errors, tagEntry) {
		// no-op
	},
	_isMatchingIWidgets: function(tagEntry) {
		return tagEntry.match && tagEntry.match.indexOf(".iw-iWidget") > -1;
	}
});

}

if(!dojo._hasResource["com.ibm.pb.themes.commonInit"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.pb.themes.commonInit"] = true;
dojo.provide("com.ibm.pb.themes.commonInit");









com.ibm.pb.themes.commonInit = function(initArgs) {
    if (!initArgs) {
        initArgs = {};
    }
    
    var lgr = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.pb.themes.commonInit"), mname = "commonInit", sharedMessages = dojo.i18n.getLocalization("com.ibm.bundles", "SharedMessages");
    lgr.entering(mname);
	
	ibmCfg.portalConfig.isRTL = ibmCfg.themeConfig.isRTL;
	if (ibmCfg.themeConfig.isRTL){
		dojo.addClass(dojo.body(), "mumrtl");
		dojo.addClass(dojo.body(), "lotus_rtl");
	}
    
    /* Prime the navigation model if enabled */
    if (ibmConfig.primeNavigation && initArgs.navPrimingContainers) {
        lgr.trace(mname, "Priming navigation model");
        var np = new com.ibm.pb.data.NavigationPrimer();
        dojo.forEach(initArgs.navPrimingContainers, np.parse, np);
        np.finalize();
        ibmCfg.themeConfig.navigationPrimed = true;
    }
    
    var evtSvc = com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService");
    
    lgr.trace(mname, "Initializing navigation model and HiddenMetaDataLoadingStrategy");
    /* Initialize the theme's HiddenMetaDataLoadingStrategy on the navigation model */
    var nm = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel(), hiddenMdStrategy = new com.ibm.mashups.enabler.strategy.HiddenMetaDataLoadingStrategy(ibmCfg.themeConfig.navHiddenMetadata);
    nm.addStrategy(hiddenMdStrategy);
    
    // TODO, re-enable in the performance APAR
//    lgr.trace(mname, "Initializing page load ahead strategy");
//    var pageLoadAheadStrategy = new com.ibm.mashups.enabler.strategy.PageLoadAheadStrategy(true, false, false);
//    nm.addStrategy(pageLoadAheadStrategy);
    
    lgr.trace(mname, "Initializing navigation node to content node meta data sync strategy");
    var syncStrategy = new com.ibm.mashups.enabler.strategy.SyncMetaDataStrategy();
    nm.addStrategy(syncStrategy);
    
    var currentPageId = null;
    var testPage = null;
    var redirect = false;
    var statehash = null;

    // 1, get page ID from cookie, which is passed when login
    // IT IS IMPORTANT THAT THIS CODE RUNS BEFORE THE NAVIGATION STATE MODEL IS FETCHED.
    if(dojo.cookie("url_pid")) {
        statehash = dojo.cookie("url_pid");
        dojo.cookie("url_pid", null, {expires: -1, path: "/"});
        window.location.hash = "#"+encodeURIComponent(statehash);
        
        /*
        // 2, try to get page from navigation model
        testPage = nm.find(currentPageId).start();  // 404 if not found
        if(!testPage) {
            // 3, try to get page from shared navigation model
            if (currentPageId !== ibmPortalConfig.currentPageOID) {
                var snm = com.ibm.mashups.enabler.navigation.Factory.getSharedNavigationModel();
                var sharedPage = snm.find(currentPageId).start(true);   // 404 if not found
                if (sharedPage && !snm.isAccepted(sharedPage)) {
                    var sharedPageRoot = nm.findDefaultAcceptParent().start(true);
                    if (sharedPageRoot) {
                        // auto accept the page
                        nm.insert(sharedPage, sharedPageRoot);
                        nm.commit().start(true);
                        testPage = sharedPage;
                    }
                }
            }
        }
        if (!testPage)
            redirect = true;
        */
    }
    
    /* Initalize the builder API RuntimeModel using the SPIs using the current context */
    lgr.trace(mname, "Initializing builder RuntimeModel");
    var navStateModel = com.ibm.mashups.enabler.model.state.NavigationStateModelFactory.getNavigationStateModel();
    var pageAccessor = com.ibm.mashups.enabler.model.state.AccessorFactory.getPageAccessor(navStateModel);
    var spaceAccessor = com.ibm.mashups.enabler.model.state.AccessorFactory.getSpaceAccessor(navStateModel);
    
    // 2, get the pid from the nav state
    // if statehash is definied, then the server or login form is telling us via the url_pid
    // cookie where we should be directed.  we also want to execute this code block
    // if we need to go to the last page visited on login
    var goToLastPageVisited = com.ibm.mm.builder.utils.navigationUtil.isLastPageWhenLogin();
    if (statehash || goToLastPageVisited) {
        currentPageId = pageAccessor.getPageID();
        if (!currentPageId) {
            currentPageId = ibmPortalConfig.currentPageOID;
            lgr.trace(mname, "Could not retrieve selected page from navigation state, retrieving from bootstrap config: ${0}", [currentPageId]);
            if ("-1" !== currentPageId) {
                pageAccessor.setPageID(currentPageId);
            }
        }
        if ("-1" !== currentPageId) {
            testPage = nm.find(currentPageId).start();
        }
    }
    
    // 3, try to get the page from shared navigation
    // this will take effect after you login, in this case cookie:url_pid is not exist
    if(!testPage && currentPageId && goToLastPageVisited) {
        if (currentPageId !== ibmPortalConfig.currentPageOID) {
            redirect = true; // the currentPageId that was retrieved by now could not be navigated to, so we definitely are redirected now
            var snm = com.ibm.mashups.enabler.navigation.Factory.getSharedNavigationModel();
            var sharedPage = snm.find(currentPageId).start(true);   // 404 if not found
            if (sharedPage && !snm.isAccepted(sharedPage)) {
                var sharedPageRoot = nm.findDefaultAcceptParent().start(true);
                if (sharedPageRoot) {
                    // auto accept the page
                    nm.insert(sharedPage, sharedPageRoot);
                    nm.commit().start(true);
                    testPage = sharedPage;
                }
            }
        }
    }
    
    // 4, home space - bspace case/overridden navstate preprocess
    if (!testPage) {
        testPage = com.ibm.mm.builder.utils.navigationUtil.gotoHomeSpace();
        if (testPage) {
            if ((currentPageId) && ("-1" != currentPageId)) {
                // if a currentPageId has been set above it means that we could not navigate to it. therefore we will now be redirected
                redirect = true;
            }
            currentPageId = testPage.getID();
            pageAccessor.setPageID(currentPageId);
        }
    }
    
    // 5, need to check whether the page or the containing space is hidden
    // this check is ommitted if the current user is the space owner (#17153)
    var spaceModel = com.ibm.mashups.enabler.space.Factory.getSpaceModel();
// 20070   var _sID = spaceAccessor.getSpaceID();
// 20070	if ((testPage) && (!_sID)) { // maybe the navState isn't setup correctly and this page really is part of a space
// 20070    	var spaceNode = spaceModel.findSpaceByNavigation(testPage).start(true);
// 20070   	if (spaceNode) {
// 20070       	_sID = spaceNode.getID();
// 20070   	}
// 20070	}
// 20070
// 20070    if(_sID) {
// 20070        var space = spaceModel.find(_sID).start();
// 20070       if(space) { // we are in space instead of in 'My Mashup Apps'
// 20070           if (!space.hasRole(com.ibm.mashups.enabler.ac.RoleType.MANAGER)) {
// 20070               if(testPage.isHidden() || space.isHidden()) {
// 20070                   testPage = null;
// 20070                   spaceAccessor.setSpaceID(nm.getRoot().start().getID());
// 20070               }
// 20070           }
// 20070       }
// 20070   }
    
    // 7, fall back to first child of navigation root page or root page itself
    if (!testPage) {
        var root = nm.getRoot().start(true);
        testPage = nm.getChildren(root).next() || root;
        if ((currentPageId) && ("-1" != currentPageId)) {
            // if a currentPageId has been set above it means that we could not navigate to it. therefore we will now be redirected
            redirect = true;
        }
    }

    // 7.5, Special case where we check whether we have selected a label even though there are child pages. If this is the case we select the first child
    if (testPage) {
        if (testPage.getNavigationElementType() === com.ibm.mashups.enabler.navigation.Constants.NAVIGATION_LABEL) {
            testPage = nm.getChildren(testPage).next() || testPage;
        }
    }

    // 8, set status in the end
	if (testPage) {
		currentPageId = testPage.getID();
	}
    // get a new page accessor if the current page is part of a space
    var currentSpaceId = spaceAccessor.getSpaceID();
    // now we need to fix the Navigational State since the navigational state doesn't know whether the page which was set is a page inside of a space
    var spaceNode = spaceModel.findSpaceByNavigation(testPage).start(true);
    if (spaceNode) {
        if (spaceNode.getID() != currentSpaceId) {
            currentSpaceId = spaceNode.getID();
            spaceAccessor.setSpaceID(currentSpaceId);
        }
        pageAccessor = com.ibm.mashups.enabler.model.state.AccessorFactory.getPageAccessor(navStateModel, currentSpaceId);
    }
    else {
        spaceAccessor.setSpaceID(); // unset
        pageAccessor = com.ibm.mashups.enabler.model.state.AccessorFactory.getPageAccessor(navStateModel);
    }
    pageAccessor.setPageID(currentPageId);
	navStateModel.commit({addToHistory: true}).start();
    
    var runtimeModel = com.ibm.mashups.builder.model.Factory.getRuntimeModel();
    var currentPage = runtimeModel.getCurrentPage();
    currentPage.setID(currentPageId);
    currentPage.setPageMode("view");
    runtimeModel.getCurrentTheme().setID(ibmCfg.themeConfig.themeUniqueName);
	
	/* Initialize the theme's HiddenMetaDataLoadingStrategy on the layout model, needed to see container and control names */
	var strategyService = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.StrategyService.SERVICE_NAME);
	var s = new com.ibm.mashups.enabler.strategy.HiddenMetaDataLoadingStrategy(ibmCfg.themeConfig.layoutHiddenMetadata);
	strategyService.setStrategy("com.ibm.mashups.enabler.layout.LayoutModel", s);
    
    /* Set the browser window title to match the current page */
    lgr.trace(mname, "Setting window title with current page title");
    nm.find(currentPageId).setFinishedCallback(function(res, status) {
        if (status != 200) {
            lgr.severe(mname, sharedMessages.nav_renderingError_0);
            dojo.publish("/portal/status/theme", ["error", sharedMessages.nav_renderingError_0, sharedMessages["nav_renderingError_0.useraction"]]);
            if (status == "404" || status == 404 || status == 0) {
                // this page no longer exists
                window.location = window.location.protocol + "//" + window.location.host + ibmCfg.portalConfig ? ibmCfg.portalConfig.portalURI : ibmConfig["com.ibm.mashups.contextroot"];
            }
        }
        else if (initArgs.setWindowTitle) {
            var title = "";
            var currentPageNode = res;
			if(currentPageId == nm.getRoot().start().getID()) {	// Root naviagtion
				title = ibmCfg.enablerConfig["com.ibm.mashups.productname"];
			} else {
				var localizedContext = com.ibm.mashups.enabler.context.Factory.getLocalizedContext();
            	var currentPageTitle = localizedContext.getTitle(currentPageNode);
            	if (dojo.isString(ibmCfg.themeConfig.portletOverridePageTitle) && ibmCfg.themeConfig.portletOverridePageTitle != currentPageTitle) {
                	title = ibmCfg.themeConfig.portletOverridePageTitle.replace(/&amp;/g, "&").replace(/&quot;/g, '"').replace(/&gt;/g, ">").replace(/&lt;/g, "<");
            	}
            	else {
                	title = currentPageTitle;
            	}
			}
            com.ibm.mashups.enabler.context.Factory.getPageContext().setBrowserTitle(title);
        }
    }).start();
    
    if (initArgs.useNavigationController) {
        /* Initialize the navigation controller */
        lgr.trace(mname, "Initializing navigation controller");
        ibmCfg.controllers.navigation = com.ibm.pb.control.NavigationController.getController();
    }
    
    if (initArgs.useRenderingController) {
        /* Initialize the rendering controller */
        lgr.trace(mname, "Initializing rendering controller");
        ibmCfg.controllers.rendering = com.ibm.pb.control.RenderingController.getController();
        ibmCfg.controllers.rendering.boostrapPreRenderProcess();
    }
    
    if (initArgs.useDNDController) {
        lgr.trace(mname, "Initializing page layout drag-and-drop controller");
        /* Initialize the drag-and-drop controller for page layout DND actions */
        ibmCfg.controllers.dnd = com.ibm.pb.control.DNDController.getController();
    }
    
    if (initArgs.serverRuntimeContentPrimingNode) {
    
    }
    
    if (initArgs.customInit) {
        initArgs.customInit();
    }

    if (initArgs.initLiveTextService) {
        lgr.trace(mname, "Initializing live text service");
        var liveTextInitArgs = initArgs.liveTextInitArgs || {}, livetextService = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.livetext.ServiceModel.SERVICE_NAME);
        if (initArgs.lazyLoadModeWidgets) {
            var pageModeWidgetHandler = new com.ibm.pb.iwidget.PageModeWidgetHandler({
                renderingController: ibmCfg.controllers.rendering,
                matchingModes: ["edit"]
            });
            /* The pageModeWidgetHandler picks up widgets that are flagged to work in certain modes and prepares them to be lazy loaded until that mode is entered */
            liveTextInitArgs.preProcessCallbackFunc = dojo.hitch(pageModeWidgetHandler, "preProcessCallbackFunc");
            liveTextInitArgs.postProcessCallbackFunc = dojo.hitch(pageModeWidgetHandler, function() {
				pageModeWidgetHandler.postProcessCallbackFunc(arguments);
				// #14071 display message if the page is redirected
				if (redirect) {
					var msgTitle = com.ibm.mm.builder.coreWidgetsStrings.I_NAVIGATION_REDIRECT_TITLE ? com.ibm.mm.builder.coreWidgetsStrings.I_NAVIGATION_REDIRECT_TITLE : "You have been redirected";
					var msgBody = com.ibm.mm.builder.coreWidgetsStrings.I_NAVIGATION_REDIRECT_TITLE_MESSAGE ? com.ibm.mm.builder.coreWidgetsStrings.I_NAVIGATION_REDIRECT_TITLE_MESSAGE : "You can't visit the page, because it has been deleted or you do not have authority.";
					var statusMessage = new com.ibm.widgets.StatusMessage("info", msgTitle, msgBody);
					dojo.publish("/message/status",[{message: statusMessage, uid: "ibmStatusBox"}]);
				}
			});
        }
        /* Initialize the live text service, which will immediately parse the page for semantic content */
        livetextService.init(liveTextInitArgs);
    }

	if(typeof(stproxy) != "undefined" && !stproxy.isLoggedIn && 
		typeof(ibmCfg.portalConfig) != "undefined" && typeof(ibmCfg.portalConfig.currentUser) != "undefined" && ibmCfg.portalConfig.currentUser.length > 0) {
		lgr.trace(mname, "Logging " + ibmCfg.portalConfig.currentUser + " onto Sametime");
		stproxy.login.loginByToken(ibmCfg.portalConfig.currentUser, stproxy.awareness.AVAILABLE, stproxy.i18nStrings.statusAvailable, null, function() {
				lgr.severe(mname, "Sametime login for " + ibmCfg.portalConfig.currentUser + " failed.");
		});
	}
}

}

if(!dojo._hasResource["com.ibm.themes.PageBuilder2.init"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.themes.PageBuilder2.init"] = true;
dojo.provide("com.ibm.themes.PageBuilder2.init");

// initialization script that is run for the PageBuilder2 theme
// this is built into the layer, and discarded and it won't end up in a driver as
// a single file
com.ibm.themes.PageBuilder2.init = function() {
	var lgr = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.themes.PageBuilder2.init"),
		mname = "onload";
	lgr.entering(mname);
	
	/* Required files, TODO: Add these to the Portal 7.0.5 layer - defect 18215 */
	
	
	
	/* end Required files */
	
	/* Register context menus for theme components */
	lgr.trace(mname, "Registering context menus");
	var menuDefinitionsModule = "com.ibm.themes.PageBuilder2.menuDefinitions";
	var ctxMenusObj = dojo.getObject("ibmCfg.themeConfig.contextMenus", true);
	var bannerLinksMenu = new com.ibm.pb.contextMenu.JsonContextMenuLoader({url:dojo.moduleUrl(menuDefinitionsModule,"bannerLinks.json"), data: ctxMenusObj.bannerLinks});
	var userActionsMenu = new com.ibm.pb.contextMenu.JsonContextMenuLoader({url:dojo.moduleUrl(menuDefinitionsModule,"userActions.json"), data: ctxMenusObj.userActions});
	var pageActionsMenu = new com.ibm.pb.contextMenu.JsonContextMenuLoader({url:dojo.moduleUrl(menuDefinitionsModule,"pageActions.json"), data: ctxMenusObj.pageActions});
	var widgetActionsMenu = new com.ibm.pb.contextMenu.JsonContextMenuLoader({url:dojo.moduleUrl(menuDefinitionsModule,"widgetActions.json"), data: ctxMenusObj.widgetActions});
	
	var cmm = com.ibm.mashups.builder.model.Factory.getContextMenuModel();
	cmm.registerContextMenu("bannerLinks", bannerLinksMenu);
	cmm.registerContextMenu("userActions", userActionsMenu);
	cmm.registerContextMenu("pageActions", pageActionsMenu);
	cmm.registerContextMenu("widgetActions", widgetActionsMenu);
	
	/* Add listener to update the pageActionsMenu on the page mode change event */
	var evtSvc = com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService");
	//evtSvc.subscribeEvent("com.ibm.mashups.builder.changePageMode", pageActionsMenu, pageActionsMenu.onChange);
	

	lgr.trace(mname, "Checking a11y");
	/* Detect high contrast mode, if enabled, places class on body element to hide images that blend in with background.
	 	 Alt text is displayed in place of image */
	var bodyElem = document.getElementsByTagName("body")[0];
	if (dojo.hasClass(bodyElem, "dijit_a11y")) {            
	   dojo.addClass(bodyElem, "lotusImagesOff");
	}

	/* setup the statusbar */
	var themeBundle = dojo.i18n.getLocalization("com.ibm.bundles", "Theme");
	var v3themeProperties = { 
		"clear": themeBundle["statusbar_clear"], 
		"print": themeBundle["statusbar_print"],
		"showDetails": themeBundle["statusbar_show_details"],
		"hideDetails": themeBundle["statusbar_hide_details"],
		"warning": themeBundle["statusbar_warning"],
		"error": themeBundle["statusbar_error"],
		"info": themeBundle["statusbar_info"],
		"statusError": themeBundle["statusbar_status_error"],
		"messagesAvailable": themeBundle["statusbar_messages_available"],
		"itemsAvailable": themeBundle["statusbar_items_available"]
	};
	dojo._loadedModules["com.ibm.portal.nls.v3theme"] = {"ROOT": v3themeProperties, "${wp.preferredLocale}": v3themeProperties };
	var statusBar = new com.ibm.widgets.StatusBar({
		uid: "ibmStatusBox",
		locale: ibmCfg.portalConfig.locale,
		errorGifPath: ibmCfg.themeConfig.themeRootURI+"/images/statusBar/error.gif",
		warningGifPath: ibmCfg.themeConfig.themeRootURI+"/images/statusBar/warning.gif",
		infoGifPath: ibmCfg.themeConfig.themeRootURI+"/images/statusBar/info.gif",
        multipleMessagesGifPath: ibmCfg.themeConfig.themeRootURI+"/images/statusBar/info.gif"
	},"ibmStatusBarContainer");
	statusBar.startup();
	
	lgr.trace(mname, "Parsing search widget");
	/* Parse the search widget container */
	dojo.parser.parse("themeSearchBoxContainer");
	
	lgr.trace(mname, "Adding live text config entries for decorations and semantic tagging");
	/* Add live text service configuration entries for layout control decorations and semantic tagging */
	var livetextEntryAdded = "/com/ibm/mashups/livetext/configentryadded";
	var decorationsEntry = new com.ibm.mashups.livetext.ConfigEntry("*.component-control", true, "com.ibm.pb.decorations", ibmConfig["com.ibm.mashups.contextroot.builder"]+"/js/com/ibm/pb/decorations","com.ibm.pb.decorations.DecorationManager", true);
    var configEntryVCard = new com.ibm.mashups.livetext.ConfigEntry(".vcard", false, "portallof","/wps_semanticTag/javascript",  "portallof.vcard",  false, "hcard");

	/* Important to add decorationsEntry to the front of the array so that skins get parsed before widgets */
    dojo.publish(livetextEntryAdded,[decorationsEntry, true]);
    dojo.publish(livetextEntryAdded,[configEntryVCard]);
    
    /* Subscribe the status bar to topic */
    dojo.subscribe("/portal/status/theme", dojo.global, function(type, message, details){
		var statusMessage = new com.ibm.widgets.StatusMessage(type, message, details);
		dojo.publish("/portal/status", [{message: statusMessage, uid: 'ibmStatusBox'}]);
	});
    
    /* Fix dijit unloading in IE */
    if ( dojo.isIE ) {
		dojo.addOnWindowUnload( function () {
			dijit.registry.forEach(function(widget){
				// Avoid double destroy of widgets like Menu that are attached to <body>
				// even though they are logically children of other widgets.
				if(!widget._destroyed){
					if(widget.destroyRecursive){
						widget.destroyRecursive();
					}else if(widget.destroy){
						widget.destroy();
					}
				}
			});
		});	
	}
	
	//if no edit mode javascript url is provided, assume that all the javascript is already loaded.
	if ( !ibmCfg.themeConfig.editModeJSURL ) {
		com.ibm.themes.PageBuilder2.initEditMode();
	}

	lgr.exiting(mname);
}

com.ibm.themes.PageBuilder2.initEditMode = function () {
	try {
		/* Load the edit_mode CSS style sheets at this point */
		dojo.query("link[rel~=edit_mode]").forEach(function(elem) { 
			dojo.attr(elem, "rel", "stylesheet"); 
		});
	} catch(err) {}
	var cmm = com.ibm.mashups.builder.model.Factory.getContextMenuModel();
	
	/* Add a menu contribution to the widgetActions that provides support for directional move operations */
	var moveControls = new com.ibm.pb.decorations.LayoutDirectionalMoveControls();
	cmm.addContribution("widgetActions", moveControls, 90);
	
	// Add Mashup choose skin menu options
	if(!ibmCfg.portalConfig.portalContext){
	// temp fix for 18222 - Portal only
	var mashupSkinItems = new com.ibm.pb.decorations.MashupSkinItems();
	mashupSkinItems.registerMenu("mashupSkinSelectionMenu");
	var mashupSkinMenu = new com.ibm.pb.decorations.MashupSkinSelectionMenu({subMenuID:"mashupSkinSelectionMenu"});
	cmm.addContribution("widgetActions", mashupSkinMenu, 140);
	}
	// End
	
	var evtSvc = com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService");
	
	/* Add listener to update the moveControls contribution on certain widget events */
	dojo.forEach(["com.ibm.mashups.builder.hideWidget","com.ibm.mashups.builder.displayWidget"], function(evt) {
		evtSvc.subscribeEvent(evt, moveControls, moveControls.onChange);
	}, this);

	dojo["require"]("com.ibm.utilities");
	dojo["require"]("com.ibm.pb.contextMenu.JsonContextMenuLoader");
	dojo["require"]("com.ibm.pb.decorations.LayoutDirectionalMoveControls");
	
	dojo["require"]("com.ibm.pb.customize.enabler.TabbedController");
	dojo["require"]("com.ibm.pb.customize.enabler.AddContentController");
	dojo["require"]("com.ibm.pb.customize.enabler.ChangeStyleController");
	dojo["require"]("com.ibm.pb.customize.enabler.ChangeLayoutController");
	
	dojo["require"]("com.ibm.pb.customize.AddContentPaletteContainer");
	dojo["require"]("com.ibm.pb.customize.ChangeStylePaletteContainer");
	dojo["require"]("com.ibm.pb.customize.ChangeLayoutPaletteContainer");
	
	/* Extend the PaletteContainer modules to use the corresponding Controllers */
	var containerBase = com.ibm.pb.customize, controllerBase = com.ibm.pb.customize.enabler;
	dojo.extend(containerBase.AddContentPaletteContainer, controllerBase.AddContentController);
	dojo.extend(containerBase.ChangeStylePaletteContainer, controllerBase.ChangeStyleController);
	dojo.extend(containerBase.ChangeLayoutPaletteContainer, controllerBase.ChangeLayoutController);
};

livetextService = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.livetext.ServiceModel.SERVICE_NAME);
TagService = SemTagSvc = livetextService;
(function(){
    var onTagContentChanged = livetextService.onTagContentChanged,
        onTagChanged = livetextService.onTagChanged;
    
    livetextService.onTagChanged = function() {
        if (ibmConfig && ibmConfig["pageLoadOptimizationAppWidgets"]) {
           var mp = com.ibm.mashups.enabler.io.XHRMultipartFactory.create();
           mp.startTransaction();
           onTagChanged.apply(this, arguments);
           mp.endTransactionDeferred(true).start();
        }
        else {
           onTagChanged.apply(this, arguments);
        }
    };
    
    livetextService.onTagContentChanged = function() {
        if (ibmConfig && ibmConfig["pageLoadOptimizationTheme"]) {
            var mp = com.ibm.mashups.enabler.io.XHRMultipartFactory.create();
            mp.startTransaction();
            onTagContentChanged.apply(this, arguments);
            mp.endTransactionDeferred(true).start();
        }
        else {
            onTagContentChanged.apply(this, arguments);
        }
    };
})();

}

