/** Licensed Materials - Property of IBM, 5724-U69, (C) Copyright IBM Corp. 2008, 2010 - All Rights reserved.  **/
dojo.provide("com.ibm.mm.enabler.edit");
if(!dojo._hasResource["com.ibm.mashups.enabler.ac.RoleNode_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.ac.RoleNode_API"] = true;
dojo.provide("com.ibm.mashups.enabler.ac.RoleNode_API");
dojo.provide("com.ibm.mashups.enabler.ac.RoleNode");

/**
 * Interface representing a role
 * @ibm-api
 * @ibm-module AccessControlModel
 */
dojo.declare("com.ibm.mashups.enabler.ac.RoleNode", [com.ibm.mashups.enabler.Identifiable], {
    /**
     * Returns the corresponding role name
     * @type String
     */
    getRoleName: function(){
    },
    
    /**
     * Returns the corresponding role type
     * @type RoleType
     */
    getRoleType: function(){
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.persistence.xml.EditLinkProviderXmlImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.persistence.xml.EditLinkProviderXmlImpl"] = true;
dojo.provide("com.ibm.mm.enabler.persistence.xml.EditLinkProviderXmlImpl");








// edit link provider
dojo.declare("com.ibm.mm.enabler.persistence.xml.EditLinkProviderXmlImpl", [com.ibm.mashups.enabler.EditLinkProvider], {
    constructor: function(){
        // initializaion
        this.modelMessages = dojo.i18n.getLocalization("com.ibm.mm.enabler", "modelMessages");
        var nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
        this.ns_elp = nsf.getNameSpaces([nsf.NS_ATOM]);
    },
    
    getEditLink: function(silent){
        var result = null;
        var node = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(com.ibm.mm.enabler.utils.Atom._EDIT_LINK, this.xmlData, this.ns_elp);
        if (node) {
            result = node.getAttribute("href");
        }
        else {
            if (silent) {
                return null;
            }
            throw new Error(dojo.string.substitute(this.modelMessages.E_ELEMENT_NOT_FOUND_2, [com.ibm.mm.enabler.utils.Atom._EDIT_LINK, this.toString()]));
        }
        return result;
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.ac.RoleNodeImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.ac.RoleNodeImpl"] = true;
dojo.provide("com.ibm.mm.enabler.ac.RoleNodeImpl");

 








dojo.declare("com.ibm.mm.enabler.ac.RoleNodeImpl", [com.ibm.mm.enabler.persistence.xml.IdentifiableXmlImpl, com.ibm.mm.enabler.TransformableImpl, com.ibm.mm.enabler.persistence.xml.EditLinkProviderXmlImpl], {
    constructor: function(data, usermodel, _roletype){
        this.nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
        this.ns = this.nsf.getNameSpaces([this.nsf.NS_ATOM, this.nsf.NS_AC, this.nsf.NS_AI]);
        this.modified = false;
        this.xmlData = data;
        this.um = usermodel;
        if (_roletype) {
            this.roleType = _roletype;
        }
        else {
            this.roleType = com.ibm.mashups.enabler.ac.RoleType.UNKNOWN;
            var expr = "atom:content/ac:role";
            var role = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, this.xmlData, this.ns);
            if (role) {
                var rt = com.ibm.mm.enabler.utils.Dom.getAttributeWithNS(role, "ac:type", "type", this.ns.ac);
                if (rt) {
                	rt = rt.toUpperCase();
                    if (rt.indexOf(com.ibm.mashups.enabler.ac.RoleType.USER)===0) {
                        this.roleType = com.ibm.mashups.enabler.ac.RoleType.USER;
                    }
                    else if (rt.indexOf(com.ibm.mashups.enabler.ac.RoleType.EDITOR)===0) {
                        this.roleType = com.ibm.mashups.enabler.ac.RoleType.EDITOR;
                    }
                    else if (rt.indexOf(com.ibm.mashups.enabler.ac.RoleType.MANAGER)===0) {
                        this.roleType = com.ibm.mashups.enabler.ac.RoleType.MANAGER;
                    }
                    else if ("EDIT" == rt) {
                        this.roleType = com.ibm.mashups.enabler.ac.RoleType.EDITOR;
                    }
                    else if ("MANAGE" == rt) {
                        this.roleType = com.ibm.mashups.enabler.ac.RoleType.MANAGER;
                    }
                }
            }
        }
    },
    
    getRoleName: function() {
        var expr = "atom:content/ac:role";
        var role = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, this.xmlData, this.ns);
        if (role) {
            return com.ibm.mm.enabler.utils.Dom.getAttributeWithNS(role, "ac:type", "type", this.ns.ac);
        }
        return this.getRoleType();
    },

    getRoleType: function(){
        return this.roleType;
    },
    
    toString: function(){
        return com.ibm.mm.enabler.utils.Dom.innerXML(this.xmlData);
    }
});

}

if(!dojo._hasResource["com.ibm.mashups.enabler.ac.RoleNode"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.ac.RoleNode"] = true;
dojo.provide("com.ibm.mashups.enabler.ac.RoleNode");






}

if(!dojo._hasResource["com.ibm.mashups.enabler.ac.MemberNode_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.ac.MemberNode_API"] = true;
dojo.provide("com.ibm.mashups.enabler.ac.MemberNode_API");
dojo.provide("com.ibm.mashups.enabler.ac.MemberNode");

/**
 * Interface representing a member
 * @ibm-api
 * @ibm-module AccessControlModel
 */
dojo.declare("com.ibm.mashups.enabler.ac.MemberNode", null, {
    /**
     * returns the user or group Entity
     * @type Entity
     * @return the enitity of this participant. Never <code>null</code>.
     */
    getEntity: function(){
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.ac.MemberNodeImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.ac.MemberNodeImpl"] = true;
dojo.provide("com.ibm.mm.enabler.ac.MemberNodeImpl");






dojo.declare("com.ibm.mm.enabler.ac.MemberNodeImpl", [com.ibm.mm.enabler.persistence.xml.EditLinkProviderXmlImpl], {
    constructor: function(_roleID, data, usermodel) {
        this.nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
        this.ns = this.nsf.getNameSpaces([this.nsf.NS_ATOM, this.nsf.NS_AC, this.nsf.NS_AI]);
        this.prefix = "role";
        this.modified = false;
        this.xmlData = data;
        this.um = usermodel;
        
        this.roleID = _roleID;
        
        if (this.xmlData) {
            var expr = "atom:content/ac:member";
            var member = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, this.xmlData, this.ns);
            if (member) {
                this.memberID = com.ibm.mm.enabler.utils.Dom.getAttributeWithNS(member, "ac:id", "id", this.ns.ac);
                this.memberType = com.ibm.mm.enabler.utils.Dom.getAttributeWithNS(member, "ac:type", "type", this.ns.ac);
                
                if (this.memberID) {
                    var e = null;
                    if (this.memberType == "user") {
                        e = this.um.find(this.memberID).start();
                    }
                    else {
                        e = this.um.findGroupByID(this.memberID).start();
                        if ((typeof e == "undefined") || (e === null)) {
                            e = this.um.find(this.memberID).start();
                        }
                    }
                    this.entity = e;
                }
            }
        }
    },
    
    getEntity: function() {
        return this.entity;
    },
    
    getID: function() {
        if (this.entity) {
            return this.entity.getID();
        }
        return this.memberID;
    },
    
    _toEntry: function() {
        return com.ibm.mm.enabler.utils.Dom.innerXML(this.xmlData);
    }
});

}

if(!dojo._hasResource["com.ibm.mashups.enabler.ac.MemberNode"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.ac.MemberNode"] = true;
dojo.provide("com.ibm.mashups.enabler.ac.MemberNode");





}

if(!dojo._hasResource["com.ibm.mashups.enabler.ac.MemberModel_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.ac.MemberModel_API"] = true;
dojo.provide("com.ibm.mashups.enabler.ac.MemberModel_API");
dojo.provide("com.ibm.mashups.enabler.ac.MemberModel");

/**
 * Interface for an access control member model
 * @ibm-api
 * @ibm-module AccessControlModel
 */
dojo.declare("com.ibm.mashups.enabler.ac.MemberModel", [com.ibm.mashups.enabler.ListModelController], {
    /**
     * creates a new Member. The created member can be inserted into the model
     * using an appropriate <code>insert</code> method. The node will not appear
     * in the model unless it is inserted.
     * @param {JSON} context array of predefined information
     * used for the creation of the node. Never <code>null</code>. Accepted names are:<br>
     * &nbsp;&nbsp;&nbsp;&nbsp;<code>entity</code> - an Entity object
     * (mandatory)<br>
     * @type MemberNode
     * @return created member node
     */
    create: function(context){
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.ac.MemberModelImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.ac.MemberModelImpl"] = true;
dojo.provide("com.ibm.mm.enabler.ac.MemberModelImpl");
















dojo.declare("com.ibm.mm.enabler.ac.MemberModelImpl", [com.ibm.mashups.enabler.ListModel, com.ibm.mm.enabler.DeferredIteratorImpl, com.ibm.mm.enabler.model.ModelImpl, com.ibm.mm.enabler.ConfirmableModelImpl], {
    constructor: function(_roleID, _accessControlModel, _um, _empty) {
        this.roleID = _roleID;
        this.accessControlModel = _accessControlModel;
        this.um = _um;
        this.cid = 0;
        
        this.modelMessages = dojo.i18n.getLocalization("com.ibm.mm.enabler", "modelMessages");
        this.nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
        this.ns = this.nsf.getNameSpaces([this.nsf.NS_ATOM, this.nsf.NS_AC, this.nsf.NS_AI]);
        this.prefix = "role";
        
        this.xmlDom = com.ibm.mm.enabler.utils.Dom.createDocument();
        
        this.accessControlModel.membersCursor[this.roleID] = 0;
        
        if (_empty) {
            this.xmlData = undefined;
            this.accessControlModel.membersEntries[this.roleID] = [];
            this.accessControlModel.membersEntries[this.roleID][0] = null;
            
            return;
        }
        else {
            this.xmlData = this.accessControlModel.xmlDataMember[this.roleID];
            
            var expr = "//atom:entry";
            var members = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(expr, this.xmlData, this.ns);
            if (members && members.length > 0) {
                for (var i = 0; i < members.length; i++) {
                    var node = new com.ibm.mm.enabler.ac.MemberNodeImpl(this.roleID, members[i], this.um);
                    this.accessControlModel.membersEntries[this.roleID][this.accessControlModel.membersCursor[this.roleID] + i] = node.getID();
                    this.accessControlModel._cacheNodeMembers(this.roleID, node);
                }
                // if there is a next link, set the next node to undefined otherwise to null
                var len = this.accessControlModel.membersEntries[this.roleID].length;
                this.accessControlModel.membersEntries[this.roleID][len] = null;
            }
            else {
                this.accessControlModel.membersEntries[this.roleID] = [];
                this.accessControlModel.membersEntries[this.roleID][0] = null;
            }
        }
    },
    
    create: function(context) {
        if (!context) {
            throw new Error("MemberModelImpl.create: no context");
            // return null; // not necessary after throw
        }
        if (!context.type) {
            throw new Error("MemberModelImpl.create: no type context");
            // return null; // not necessary after throw
        }
        if (!context.id) {
            throw new Error("MemberModelImpl.create: no type context");
            // return null; // not necessary after throw
        }
        
        var entry = com.ibm.mm.enabler.utils.Utils.createNode("atom:entry", this.ns.atom);
        entry.appendChild(com.ibm.mm.enabler.utils.Utils.createNode("atom:id", this.ns.atom));
        var title = com.ibm.mm.enabler.utils.Utils.createNode("atom:title", this.ns.atom);
        com.ibm.mm.enabler.utils.Dom.textContent(title, "Member");
        entry.appendChild(title);
        var updated = com.ibm.mm.enabler.utils.Utils.createNode("atom:updated", this.ns.atom);
        var time = new Date();
        com.ibm.mm.enabler.utils.Dom.textContent(updated, time.toGMTString());
        entry.appendChild(updated);
        var content = com.ibm.mm.enabler.utils.Utils.createNode("atom:content", this.ns.atom);
        content.setAttribute("type", "application/xml");
        var memberNode = com.ibm.mm.enabler.utils.Utils.createNode("ac:member", this.ns.ac);
        com.ibm.mm.enabler.utils.Utils.setAttributeWithNS(memberNode, "ac:id", this.nsf.getNameSpaceUri(this.nsf.NS_AC), context.id);
        com.ibm.mm.enabler.utils.Utils.setAttributeWithNS(memberNode, "ac:type", this.nsf.getNameSpaceUri(this.nsf.NS_AC), context.type);
        content.appendChild(memberNode);
        entry.appendChild(content);
        
        var newMember = new com.ibm.mm.enabler.ac.MemberNodeImpl(this.roleID, entry, this.um);
        
        return newMember;
    },
    
    iterator: function() {
        return this;
    },
    
    start: function(sync) {
        while (this._hasNext(this, sync)) {
            if (this._next(this, sync)) {
                continue;
            }
            else {
                break;
            }
        }
    },
    
    hasNext: function() {
        return this._hasNext(null, true);
    },
    
    _hasNext: function(deferred, sync) {
        var result = false;
        // check for loaded entries
        var next = this.accessControlModel.membersEntries[this.roleID][this.accessControlModel.membersCursor[this.roleID]];
        if (next !== null && next !== undefined) {
            result = true;
        }
        
        return result;
    },
    
    next: function() {
        return this._next(null, true);
    },
    
    _next: function(deferred, sync) {
        var hasNext = this._hasNext(deferred, sync);
        var entries = this.accessControlModel.membersEntries[this.roleID];
        var loadedNodes = this.accessControlModel.membersLoadedNodes[this.roleID];
        var ret = hasNext ? loadedNodes[entries[this.accessControlModel.membersCursor[this.roleID]]] : null;
        this.accessControlModel.membersCursor[this.roleID]++;
        return ret;
    },
    
    size: function() {
        return this.accessControlModel.membersSizeValue[this.roleID];
    },
    
    setCursorPosition: function(position) {
        this.accessControlModel.membersCursor[this.roleID] = position;
    },
    
    getCursorPosition: function() {
        return this.accessControlModel.membersCursor[this.roleID];
    },
    
    insert: function(node, nextNode) {
        // track old members of a role for update
        if (!this.accessControlModel.changedProperties.role) {
            this.accessControlModel.changedProperties.role = this.accessControlModel.getRoleModel()._getRoles();
        }
        
        this.accessControlModel.membersCreatedNodes[this.roleID][node.getID()] = node;
        
        var length = this.accessControlModel.membersEntries[this.roleID].length;
        if ((!length) || (length === 0)) {
            this.accessControlModel.membersEntries[this.roleID][0] = node.getID();
            this.accessControlModel.membersEntries[this.roleID][1] = null;
        }
        else {
            this.accessControlModel.membersEntries[this.roleID][length - 1] = node.getID();
            this.accessControlModel.membersEntries[this.roleID][length] = null;
        }
        
        this.accessControlModel._cacheNodeMembers(this.roleID, node);
        
    },
    
    find: function(id) {
        return new com.ibm.mm.enabler.DeferredImpl(this, this._find, id);
    },
    
    _find: function(deferred, sync, id) {
        if (id in this.accessControlModel.membersDeletedNodes[this.roleID]) {
            // public callback handling
            if (deferred) {
                deferred.finish(null, com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_NOT_FOUND);
            }
            
            return null;
        }
        
        if (id in this.accessControlModel.membersLoadedNodes[this.roleID]) {
            // fetch node from cache
            // public callback handling
            if (deferred) {
                deferred.finish(this.accessControlModel.membersLoadedNodes[this.roleID][id], com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK);
            }
            
            return this.accessControlModel.membersLoadedNodes[this.roleID][id];
        }
        
        var myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelUrl(com.ibm.mashups.enabler.model.url.ModelUrlFactory.AC_URL, this);
        myUrl.setNodes([{
            value: id,
            isID: true
        }]);
        
        var serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
        var entry = null;
        var result = {};
        result.node = null;
        
        serviceReq.read(dojo.hitch(this, function(type, data, xhr, args) {
            if (type != com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_ERROR) {
                var nodes = com.ibm.mashups.enabler.xml.XPath.evaluateEntry("//atom:entry", data, this.ns);
                if (nodes) {
                    var newentry = new com.ibm.mm.enabler.ac.MemberNodeImpl(nodes, this);
                    this.accessControlModel.membersNewid[this.roleID] = newentry.getID();
                    this.membersLoadedNodes[this.roleID][this.membersNewid[this.roleID]] = newentry;
                    result.node = this.accessControlModel.membersLoadedNodes[this.roleID][this.membersNewid[this.roleID]];
                }
                else if (sync) {
                    result.status = com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_NOT_FOUND;
                }
            }
            
            // finished callback 
            if (deferred) {
                deferred.finish(result.node || null, xhr.status);
            }
            
            // handle error in sync call
            if (sync && type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_ERROR) {
                // do not expose HTTP_NOT_FOUND; simply return null in this case
                if (xhr.status != com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_NOT_FOUND) {
                    result.status = xhr.status;
                }
            }
        }));
        if (result.status) {
            throw new Error(dojo.string.substitute(this.modelMessages.E_COMNODE_NOTFOUND_1, [id, result.status]));
        }
        retVal = result.node;
        
        return retVal;
    },
    
    
    remove: function(node) {
        // track old members of a role for update
        if (!this.accessControlModel.changedProperties.role) {
            this.accessControlModel.changedProperties.role = this.accessControlModel.getRoleModel()._getRoles();
        }
        
        var id = node.getID();
        // mark node as deleted
        if (!(id in this.accessControlModel.membersDeletedNodes[this.roleID])) {
            this.accessControlModel.membersDeletedNodesMemberIDs[this.roleID][id] = node.getEntity().getID();
            this.accessControlModel.membersDeletedNodes[this.roleID][id] = node;
        }
        // mark cache entry
        if (id in this.accessControlModel.membersLoadedNodes[this.roleID]) {
            delete this.accessControlModel.membersLoadedNodes[this.roleID][id];
        }
    }
});

}

if(!dojo._hasResource["com.ibm.mashups.enabler.ac.MemberModel"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.ac.MemberModel"] = true;
dojo.provide("com.ibm.mashups.enabler.ac.MemberModel");






}

if(!dojo._hasResource["com.ibm.mashups.enabler.ac.RoleModel_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.ac.RoleModel_API"] = true;
dojo.provide("com.ibm.mashups.enabler.ac.RoleModel_API");
dojo.provide("com.ibm.mashups.enabler.ac.RoleModel");

/**
 * Interface for an access control role model
 * @ibm-api
 * @ibm-module AccessControlModel
 */
dojo.declare("com.ibm.mashups.enabler.ac.RoleModel", [com.ibm.mashups.enabler.ListModelController], {

    /**
     * Creates a new Role. The created role can be inserted into the model
     * using an appropriate <code>insert</code> method. The node will not appear
     * in the model unless it is inserted.
     * @param {JSON} context json object of predefined name/value pairs
     * used for the creation of the node. Never <code>null</code>. Accepted names are:<br>
     * &nbsp;&nbsp;&nbsp;&nbsp;<code>roletype</code> - value: one of the role type constants
     * (mandatory)<br>
     * @return {RoleNode} created role node. Returns <code>null</code> if a Role already exists
     * for the specified role type.
     */
    create: function(context){
    },
    
    /**
     * Returns the member model for the given role.
     * @param {RoleNode} roleNode the role to retrieve the member model for
     * @type MemberModel
     */
    getMemberModel: function(roleNode){
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.ac.RoleModelImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.ac.RoleModelImpl"] = true;
dojo.provide("com.ibm.mm.enabler.ac.RoleModelImpl");

















dojo.declare("com.ibm.mm.enabler.ac.RoleModelImpl", [com.ibm.mashups.enabler.ac.RoleModel, com.ibm.mashups.enabler.ListModel, com.ibm.mm.enabler.DeferredIteratorImpl, com.ibm.mm.enabler.model.ModelImpl, com.ibm.mm.enabler.ConfirmableModelImpl], {
    constructor: function(_accessControlModel, _um) {
        this.accessControlModel = _accessControlModel;
        this.um = _um;
        
        this.modelMessages = dojo.i18n.getLocalization("com.ibm.mm.enabler", "modelMessages");
        this.serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_NAVIGATION);
        this.nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
        this.ns = dojo.delegate(this.serviceJson.namespaces, this.nsf.getNameSpaces([this.nsf.NS_ATOM, this.nsf.NS_AC, this.nsf.NS_AI]));
        this.prefix = "role";
        
        this.xmlDom = com.ibm.mm.enabler.utils.Dom.createDocument();
        this.cid = 0;
    },
    
    create: function(context) {
        if (!context) {
            throw new Error("RoleModelImpl.create: no context");
        }
        if (!context.roletype) {
            throw new Error("RoleModelImpl.create: no roletype context");
        }
        // Check if roletype already exists
        var oldCursor = this.getCursorPosition();
        this.setCursorPosition(0);
        var iterator = this.iterator();
        while (iterator.hasNext()) {
            var role = iterator.next();
            if (role.getRoleType() == context.roletype) {
                // already exists, return null
                if (oldCursor) {
                    this.setCursorPosition(oldCursor);
                }
                else {
                    this.setCursorPosition(0);
                }
                return null;
            }
        }
        
        var entry = com.ibm.mm.enabler.utils.Utils.createNode("atom:entry", this.ns.atom);
        entry.appendChild(com.ibm.mm.enabler.utils.Utils.createNode("atom:id", this.ns.atom));
        var title = com.ibm.mm.enabler.utils.Utils.createNode("atom:title", this.ns.atom);
        com.ibm.mm.enabler.utils.Dom.textContent(title, "Role");
        entry.appendChild(title);
        var updated = com.ibm.mm.enabler.utils.Utils.createNode("atom:updated", this.ns.atom);
        var time = new Date();
        com.ibm.mm.enabler.utils.Dom.textContent(updated, time.toGMTString());
        entry.appendChild(updated);
        var content = com.ibm.mm.enabler.utils.Utils.createNode("atom:content", this.ns.atom);
        content.setAttribute("type", "application/xml");
        var roleNode = com.ibm.mm.enabler.utils.Utils.createNode("ac:role", this.ns.ac);
        
        // now we generate the new name. if the model provides one we use this one, otherwise we use the roletype
        // this is required for the AI usecase as we store the roles all on space level and not on the resource
        var roleName = this.accessControlModel._getCreationRoleName(context.roletype);
        if (!roleName) {
            roleName = context.roletype;
        }
        com.ibm.mm.enabler.utils.Utils.setAttributeWithNS(roleNode, "ac:type", this.nsf.getNameSpaceUri(this.nsf.NS_AC), roleName);
        com.ibm.mm.enabler.utils.Dom.setAttributeWithNS(this.xmlDom, roleNode, "creation-context:role-types", "role-types", this.ns["creation-context"], context.roletype);
        
        var resourceID = this.accessControlModel._getCreationResourceID();
        com.ibm.mm.enabler.utils.Dom.setAttributeWithNS(this.xmlDom, roleNode, "creation-context:resource-id", "resource-id", this.ns["creation-context"], resourceID);
        content.appendChild(roleNode);
        entry.appendChild(content);
        
        var newrole = new com.ibm.mm.enabler.ac.RoleNodeImpl(entry, this.um, context.roletype);
        newrole.setID("" + (this.cid++));
        
        return newrole;
    },
    
    remove: function(role) {
        // track old roles for update
        if (!this.accessControlModel.changedProperties.role) {
            this.accessControlModel.changedProperties.role = this._getRoles();
        }
        
        // remove node from roles array
        var roleId = role.getID();
        for (var i = this.accessControlModel.rolesEntries.length; i > 0; i--) {
            if (this.accessControlModel.rolesEntries[i] == roleId) {
                this.accessControlModel.rolesEntries.splice(i, 1);
                break;
            }
        }
        
        // remove node from ac model
        this.accessControlModel._removeNodeRoles(role);
    },
    
    iterator: function() {
        return this;
    },
    
    start: function(sync) {
        while (this._hasNext(this, sync)) {
            if (this._next(this, sync)) {
                continue;
            }
            else {
                break;
            }
        }
    },
    
    hasNext: function() {
        return this._hasNext(null, true);
    },
    
    _hasNext: function(deferred, sync) {
        var result = false;
        // load entries if array of entries indicates more entries to load
        //if (this.accessControlModel.rolesEntries[this.accessControlModel.rolesCursor] === undefined) {
        //    this.accessControlModel._loadAheadRole(deferred, sync);
        //}
        // check for loaded entries
        var next = this.accessControlModel.rolesEntries[this.accessControlModel.rolesCursor];
        if (next !== null && next !== undefined) {
            result = true;
        }
        return result;
    },
    
    next: function() {
        return this._next(null, true);
    },
    
    _next: function(deferred, sync) {
        var hasNext = this._hasNext(deferred, sync);
        var entries = this.accessControlModel.rolesEntries;
        var loadedNodes = this.accessControlModel.rolesLoadedNodes;
        var ret = hasNext ? loadedNodes[entries[this.accessControlModel.rolesCursor]] : null;
        this.accessControlModel.rolesCursor++;
        return ret;
    },
    
    size: function() {
        return this.accessControlModel.rolesSizeValue;
    },
    
    setCursorPosition: function(position) {
        this.accessControlModel.rolesCursor = position;
    },
    
    getCursorPosition: function() {
        return this.accessControlModel.rolesCursor;
    },
    
    insert: function(node, nextNode) {
        // track old roles for update
        if (!this.accessControlModel.changedProperties.role) {
            this.accessControlModel.changedProperties.role = this._getRoles();
        }
        
        this.accessControlModel.rolesCreatedNodes[node.getID()] = node;
        var length = this.accessControlModel.rolesEntries.length;
        if ((!length) || (length === 0)) {
            this.accessControlModel.rolesEntries[0] = node.getID();
            this.accessControlModel.rolesEntries[1] = null;
        }
        else {
            this.accessControlModel.rolesEntries[length - 1] = node.getID();
            this.accessControlModel.rolesEntries[length] = null;
        }
        
        this.accessControlModel._cacheNodeRoles(node);
    },
    
    _getRoles: function() {
        var roles = {};
        this.setCursorPosition(0);
        var iterator = this.iterator();
        while (iterator.hasNext()) {
            var role = iterator.next();
            var roleID = role.getID();
            roles[roleID] = roleID;
        }
        
        return roles;
    },
    
    find: function(id) {
        return new com.ibm.mm.enabler.DeferredImpl(this, this._find, id);
    },
    
    _find: function(deferred, sync, id) {
        if (id in this.accessControlModel.rolesLoadedNodes) {
            // fetch node from cache
            // public callback handling
            if (deferred) {
                deferred.finish(this.accessControlModel.rolesLoadedNodes[id], com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK);
            }
            return this.accessControlModel.rolesLoadedNodes[id];
        }
        
        // check if role is deleted in model scope (deleted nodes are not exposed)
        if (id in this.accessControlModel.rolesDeletedNodes) {
            if (deferred) {
                deferred.finish(null, com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_NOT_FOUND);
            }
            return null;
        }
        
        // TODO - find does not work like this in all the cases
        var myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(com.ibm.mashups.enabler.model.url.ModelUrlFactory.AC_URL, this);
        myUrl.setNodes([{
            value: id,
            isID: true
        }]);
        
        var serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
        var entry = null;
        var result = {};
        result.node = null;
        
        serviceReq.read(dojo.hitch(this, function(type, data, xhr, args) {
            if (type != com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_ERROR) {
                var node = com.ibm.mashups.enabler.xml.XPath.evaluateEntry("//atom:entry", data, this.ns);
                if (node) {
                    var newentry = new com.ibm.mm.enabler.ac.RoleNodeImpl(node, this);
                    this.accessControlModel.rolesNewid = newentry.getID();
                    this.rolesLoadedNodes[this.rolesNewid] = newentry;
                    result.node = this.accessControlModel.rolesLoadedNodes[this.rolesNewid];
                }
                else if (sync) {
                    result.status = com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_NOT_FOUND;
                }
            }
            
            // finished callback
            if (deferred) {
                deferred.finish(result.node, xhr.status);
            }
            
            // handle error in sync call
            if (sync && type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_ERROR) {
                // do not expose HTTP_NOT_FOUND; simply return null in this case
                if (xhr.status != com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_NOT_FOUND) {
                    result.status = xhr.status;
                }
            }
        }));
        if (result.status) {
            throw new Error(dojo.string.substitute(this.modelMessages.E_COMNODE_NOTFOUND_1, [id, result.status]));
        }
        retVal = result.node;
        
        return retVal;
    },
    
    getMemberModel: function(roleNode) {
        if (!roleNode) {
            return null;
        }
        
        var id = roleNode.getID();
        if (!id) {
            return null;
        }
        if (this.accessControlModel.memberModel) {
            if (this.accessControlModel.memberModel[id]) {
                return this.accessControlModel.memberModel[id];
            }
        }
        
        this.accessControlModel._loadAheadMember(roleNode, null, true);
        
        if (this.accessControlModel.memberModel[id]) {
            return this.accessControlModel.memberModel[id];
        }
        
        return null;
    }
});

}

if(!dojo._hasResource["com.ibm.mashups.enabler.ac.RoleModel"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.ac.RoleModel"] = true;
dojo.provide("com.ibm.mashups.enabler.ac.RoleModel");







}

if(!dojo._hasResource["com.ibm.mashups.enabler.ac.AccessControlModel_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.ac.AccessControlModel_API"] = true;
dojo.provide("com.ibm.mashups.enabler.ac.AccessControlModel_API");
dojo.provide("com.ibm.mashups.enabler.ac.AccessControlModel");

/**
 * Interface for a access control model.
 * @ibm-api
 * @ibm-module AccessControlModel
 */
dojo.declare("com.ibm.mashups.enabler.ac.AccessControlModel", [com.ibm.mashups.enabler.model.Model], {

    /**
     * Indicates if the model is initialized.for the underlying resource.
     * @ibm-spi
     * @return {Boolean} <code>true</code> if the model is initialized, <code>false</code> otherwise
     */
    isInitialized: function() {
    },
    
    /**
     * Returns the owner of the resource
     * @type com.ibm.mashups.enabler.user.User
     * @return the owner of the resource; never <code>null</code>.
     */
    getOwner: function() {
    },
    /**
     * Sets a new owner for the resource
     * @type void
     * @param {com.ibm.mashups.enabler.user.User} user the new owner for the resource. Must not be <code>null</code>.
     */
    setOwner: function(user) {
    },
    
    /**
     * Confirms whether setting a new owner is possible.
     * @param {com.ibm.mashups.enabler.user.User} user new owner to set; must not be <code>null</code>
     * @return {Boolean} <code>true</code> if the new owner can be set, <code>false</code> otherwise.
     */
    confirmSetOwner: function(user) {
    },
    
    /**
     * Same as getRoleModel(true).
     * @type RoleModel
     * @return a RoleModel object. Never <code>null</code>.
     */
    getRoleModel: function() {
    },
    /**
     * Returns the role model for the given access control model.
     * @type RoleModel
     * @param {Boolean} create defines whether the role model should be created if it is not available
     * @return a RoleModel object. May be <code>null</code> if called with create equals false.
     */
    getRoleModel: function(create) { // JSLINT-IGNORE: cannot change public API
    },
    
    /**
     * Confirms whether getting the role model is possible
     * @return {Boolean} <code>true</code> if retrieving the role model is possible, <code>false</code> otherwise
     */
    confirmGetRoleModel: function() {
    },
    
    /**
     * Commits the modifications applied to this model and all dependent models.<br>
     * @return {DeferredOperation} a deferred object used to start this operation.
     * The return value when executed through the deferred object is <code>null</null>
     */
    commit: function() {
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.ACLinkProviderImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.ACLinkProviderImpl"] = true;
dojo.provide("com.ibm.mm.enabler.ACLinkProviderImpl");





dojo.declare("com.ibm.mm.enabler.ACLinkProviderImpl", null, {
    constructor: function(){
        // service document and initialization
        var serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_NAVIGATION);
        var nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
        this.ns_acrlp = dojo.delegate(serviceJson.namespaces, nsf.getNameSpaces([nsf.NS_ATOM, nsf.NS_XML, nsf.NS_EXT, nsf.NS_AC, nsf.NS_CA]));
        
        this.AC_RESOURCE_ATOM_LINK = "atom:link[@ext:rel='ac-resource-config']";
        this.AC_ROLES_ATOM_LINK = "atom:link[@ext:rel='roles']";
        this.CA_ROLES_ATOM_LINK = "atom:link[@ca:rel='roles']";
        this.AC_MEMBERS_ATOM_LINK = "atom:link[@ac:rel='members']";
    },
    
    getACResourceLink: function(xmlData){
        var result = null;
        var node = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(this.AC_RESOURCE_ATOM_LINK, xmlData, this.ns_acrlp);
        if (node) {
            result = node.getAttribute("href");
        }
        return result;
    },
    
    getACRolesLink: function(xmlData){
        var result = null;
        var node = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(this.AC_ROLES_ATOM_LINK, xmlData, this.ns_acrlp);
        if (node) {
            result = node.getAttribute("href");
        }
        return result;
    },
    
    getCARolesLink: function(xmlData){
        var result = null;
        var node = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(this.CA_ROLES_ATOM_LINK, xmlData, this.ns_acrlp);
        if (node) {
            result = node.getAttribute("href");
        }
        return result;
    },
    
    getACMembersLink: function(xmlData){
        var result = null;
        var node = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(this.AC_MEMBERS_ATOM_LINK, xmlData, this.ns_acrlp);
        if (node) {
            result = node.getAttribute("href");
        }
        return result;
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.ac.AccessControlModelImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.ac.AccessControlModelImpl"] = true;
dojo.provide("com.ibm.mm.enabler.ac.AccessControlModelImpl");























dojo.declare("com.ibm.mm.enabler.ac.AccessControlModelImpl", [com.ibm.mashups.enabler.ac.AccessControlModel, com.ibm.mm.enabler.model.ModelImpl, com.ibm.mm.enabler.persistence.xml.IdentifiableXmlImpl, com.ibm.mm.enabler.ACLinkProviderImpl, com.ibm.mm.enabler.ConfirmableModelImpl], {
    constructor: function(_mainResource) {
        this.mainResource = _mainResource;
        this.url = com.ibm.mashups.enabler.model.url.ModelUrlFactory.AI_URL;
    },
    
    _init: function() {
        this.initialContentsMembers = null;
        
        this.rolesLoadedNodes = {};
        this.rolesCreatedNodes = {};
        this.rolesDeletedNodes = {};
        
        var undefined; // JSLINT-IGNORE: workaround
        this.roleModel = undefined;
        this.rolesStart = null;
        this.rolesNum = null;
        this.rolesSizeValue = 9999; // assume a high size until we know the real size
        this.rolesEntries = [];
        this.rolesCursor = 0;
        this.rolesSize = null;
        
        this.membersLoadedNodes = {};
        this.membersCreatedNodes = {};
        this.membersDeletedNodes = {};
        this.membersDeletedNodesMemberIDs = {};
        
        this.memberModel = {};
        this.membersEntries = {};
        this.membersCursor = {};
        this.membersSize = {};
        
        this.xmlDataMember = {};
        this.initialContentsMember = {};
        
        this.owner = null;
        
        this.modelMessages = dojo.i18n.getLocalization("com.ibm.mm.enabler", "modelMessages");
        this.um = com.ibm.mashups.enabler.user.Factory.getUserModel();
        // service document and initialization
        this.prefix = "resource";
        this.nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
        this.ns = this.nsf.getNameSpaces([this.nsf.NS_ATOM, this.nsf.NS_XML, this.nsf.NS_OPENSEARCH, this.nsf.NS_AC, this.nsf.NS_AI, this.nsf.NS_APP, this.nsf.NS_CA]);
        
        // track changed properties(old values) in AC: resource owner, role block(inheritance/propagation), roles, memebers
        this.changedProperties = {};
    },
    
    /**
     * @IBM-internal-use do not remove this function
     */
    getResource: function() {
        return this.mainResource;
    },
    
    // abstract method, will be overwritten in child class
    _isPageInSpace: function() {
        return false;
    },
    // abstract method, will be overwritten in child class
    // must return a JSON object with roleType/roleName
    _getPossibleRoles: function() {
        return null;
    },
    // abstract method, will be overwritten in child class
    _getRolesLink: function() {
        return null;
    },
    // abstract method, will be overwritten in child class
    _getMembersLink: function(xmlData) {
        return null;
    },
    // abstract method, will be overwritten in child class
    // called when a new role is created
    _getCreationRoleName: function(roletype) {
        return null;
    },
    // abstract method, will be overwritten in child class
    _getCreationResourceID: function() {
        return this.mainResource.getID();
    },
    // abstract method, will be overwritten in child class
    // return true if the role should be filtered out/skipped, otherwise false
    _filterRole: function(node) {
        return false;
    },
    
    setID: function(id) {
        throw new Error(this.modelMessages.E_UNSUPPORTED_OP_0);
    },
    
    // trivial implementation; used by extensions
    isInitialized: function() {
        return true;
    },
    
    getRoleModel: function() {
        if (this.roleModel === undefined) {
            this._loadAheadRole(null, true);
        }
        
        return this.roleModel;
    },
    
    getRoleModel: function(create) { // JSLINT-IGNORE: cannot change public API
        if (this.roleModel === undefined) {
            this._loadAheadRole(null, true);
        }
        
        return this.roleModel;
    },
    
    confirmGetRoleModel: function() {
        if (com.ibm.mm.enabler.AnonymousHelper.getAnonymousMode() == com.ibm.mashups.enabler.user.AnonymousMode.ANONYMOUS) {
            return false;
        }
        return this.mainResource.hasRole(com.ibm.mashups.enabler.ac.RoleType.MANAGER);
    },
    
    _loadAheadRole: function(deferred, sync) {
        var myUrl;
        var nodeJSON;
        
        this.rolesEntries = [];
        this.rolesStart = 0;
        this.rolesCursor = 0;
        
        var pRoles = this._getPossibleRoles();
        if ((this._isPageInSpace()) && (pRoles)) {
            var i = 0;
            for (var roleType in pRoles) {
                if (Object.prototype.hasOwnProperty.call(pRoles, roleType)) {
                    var roleName = pRoles[roleType];
                    myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(this.url, this);
                    
                    nodeJSON = [{
                        value: "collection",
                        isID: false,
                        subModel: com.ibm.mashups.enabler.model.url.ModelUrlFactory.SUBMODEL_ROLE
                    }, {
                        value: this.mainResource.getID(),
                        isID: true
                    }];
                    myUrl.setNodes(nodeJSON);
                    myUrl.setParameter("filter", "type=" + roleName);
                    
                    this.__loadAheadRole(myUrl, deferred, sync, i, roleType);
                    
                    i++;
                }
            }
            this.roleModel = new com.ibm.mm.enabler.ac.RoleModelImpl(this, this.um);
        }
        else {
            if (!this.rolesNextLink) {
                var link = this._getRolesLink();
                if (link) {
                    myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(link, this);
                }
                else {
                    myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(this.url, this);
                    
                    nodeJSON = [{
                        value: "collection",
                        isID: false,
                        subModel: com.ibm.mashups.enabler.model.url.ModelUrlFactory.SUBMODEL_ROLE
                    }, {
                        value: this.mainResource.getID(),
                        isID: true
                    }];
                    myUrl.setNodes(nodeJSON);
                }
            }
            else {
                myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(this.rolesNextLink, this);
            }
            myUrl.setParameter("start", this.rolesPosition);
            if (this.url === com.ibm.mashups.enabler.model.url.ModelUrlFactory.AC_URL) {
                myUrl.setParameter("filter", "all");
            }
            
            if (this.strategy) {
                for (var x in this.strategy) {
                    if (com.ibm.mm.enabler.utils.Misc.isInstanceOf(this.strategy[x], com.ibm.mm.enabler.strategy.PageLoadAheadStrategyImpl)) {
                        myUrl.setParameter("num", this.strategy[x].getInterval());
                        break;
                    }
                }
            }
            this.__loadAheadRole(myUrl, deferred, sync, null);
        }
    },
    __loadAheadRole: function(myUrl, deferred, sync, singleModeCount, roleType) {
        var serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
        singleModeCount = singleModeCount || null;
        
        serviceReq.read(dojo.hitch(this, function(type, data, xhr, args) {
            if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_LOAD) {
                var expr, nodes;
                
                if (singleModeCount === null) { // load collection
                    if (!this.rolesSizeValue) {
                        expr = "atom:feed/openSearch:totalResults";
                        var sizeNodes = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, data, this.ns);
                        if (sizeNodes) {
                            this.rolesSizeValue = com.ibm.mm.enabler.utils.Dom.textContent(sizeNodes);
                        }
                    }
                    
                    this.rolesNextLink = null;
                    
                    expr = "atom:feed/atom:link[@rel='next']";
                    nodes = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, data, this.ns);
                    if (nodes) {
                        this.rolesNextLink = nodes.getAttribute("href");
                    }
                }
                
                nodes = com.ibm.mashups.enabler.xml.XPath.evaluateXPath("//atom:entry", data, this.ns);
                if (nodes.length > 0) {
                    var i, c, l, node;
                    if (singleModeCount === null) { // load collection
                        for (i = 0, c = 0, l = nodes.length; i < l; i++) {
                            node = new com.ibm.mm.enabler.ac.RoleNodeImpl(nodes[i], this.um);
                            if (this._filterRole(node)) {
                                continue;
                            }
                            this.rolesEntries[this.rolesCursor + c] = node.getID();
                            this._cacheNodeRoles(node);
                            c++;
                            if (deferred && deferred.foreachCallback) {
                                deferred.foreachCallback(this.rolesLoadedNodes[id], deferred.foreachCallbackParameters);
                            }
                        }
                    }
                    else {
                        for (i = 0, c = 0, l = nodes.length; i < l; i++) {
                            node = new com.ibm.mm.enabler.ac.RoleNodeImpl(nodes[i], this.um, roleType);
                            if (this._filterRole(node)) {
                                continue;
                            }
                            this.rolesEntries[this.rolesCursor + singleModeCount + c] = node.getID();
                            this._cacheNodeRoles(node);
                            c++;
                            //if (deferred && deferred.foreachCallback) {
                            //    deferred.foreachCallback(this.rolesLoadedNodes[id], deferred.foreachCallbackParameters);
                            //}
                        }
                    }
                }
                
                if (singleModeCount === null) { // load collection
                    // if there is a next link, set the next node to undefined otherwise to null
                    this.rolesEntries[this.rolesEntries.length] = this.rolesNextLink ? undefined : null;
                    this.roleModel = new com.ibm.mm.enabler.ac.RoleModelImpl(this, this.um);
                }
                else {
                    // if there is a next link, set the next node to undefined otherwise to null
                    this.rolesEntries[this.rolesEntries.length] = null;
                }
                
                if (deferred) {
                    deferred.finish(null, xhr.status);
                }
            }
            else if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_ERROR) {
                if (deferred) {
                    deferred.finish(null, xhr.status);
                }
            }
        }));
    },
    
    _cacheNodeRoles: function(node) {
        var id = node.getID();
        if (!(id in this.rolesLoadedNodes)) {
            this.rolesLoadedNodes[id] = node;
        }
        return this.rolesLoadedNodes[id];
    },
    
    _replaceNodeRoles: function(oldNode, newNode) {
        if (oldNode) {
            var oldID = oldNode.getID();
            var newID = newNode.getID();
            
            var len = this.rolesEntries.length;
            
            if (len <= 1) {
                this.rolesEntries = [];
                this.rolesEntries[0] = newNode.getID();
            }
            else {
                for (var i = 0; i < len; i++) {
                    var id = this.rolesEntries[i];
                    if (id == oldID) {
                        this.rolesEntries[i] = newID;
                        if (this.membersCreatedNodes[oldID]) {
                            this.membersCreatedNodes[newID] = this.membersCreatedNodes[oldID];
                            delete this.membersCreatedNodes[oldID];
                        }
                        break;
                    }
                }
            }
            
            delete this.rolesCreatedNodes[oldID];
            delete this.rolesLoadedNodes[oldID];
        }
        this._cacheNodeRoles(newNode);
    },
    
    _loadAheadMember: function(role, deferred, sync) {
        this._loadMemberModel(role.getID(), role.getRoleType(), this._getMembersLink(role.xmlData), null, true);
    },
    
    _loadMemberModel: function(id, roletype, link, deferred, sync) {
        this.memberModel[id] = null;
        
        this.membersLoadedNodes[id] = {};
        this.membersCreatedNodes[id] = {};
        this.membersDeletedNodes[id] = {};
        this.membersDeletedNodesMemberIDs[id] = {};
        
        this.membersEntries[id] = [];
        this.membersCursor[id] = 0;
        
        this.xmlDataMember[id] = {};
        this.initialContentsMember[id] = {};
        
        if (this.rolesCreatedNodes[id]) {
            var node = new com.ibm.mm.enabler.ac.MemberModelImpl(id, this, this.um, true);
            this.memberModel[id] = node;
            return;
        }
        
        var myUrl = null;
        if (!link) {
            //var node = new com.ibm.mm.enabler.ac.MemberModelImpl(id, this, this.um, true);
            //this.memberModel[id] = node;
            //return;
            // now let's create the url
            myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(this.url, this);
            var nodeJSON = [{
                value: "collection",
                isID: false,
                subModel: com.ibm.mashups.enabler.model.url.ModelUrlFactory.SUBMODEL_MEMBER
            }, {
                value: roletype,
                isID: false,
                subModel: com.ibm.mashups.enabler.model.url.ModelUrlFactory.SUBMODEL_ROLE
            }, {
                value: this.mainResource.getID(),
                isID: true
            }];
            myUrl.setNodes(nodeJSON);
        }
        else {
            myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(link, this);
        }
        
        var serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
        var entries = this.membersEntries[id];
        var model = this.model;
        
        serviceReq.read(dojo.hitch(this, function(type, data, xhr, args) {
            if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_LOAD) {
                var expr = "atom:feed";
                var feed = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, data, this.ns);
                var element = feed || data;
                
                this.xmlDataMember[id] = element;
                this.initialContentsMember[id] = com.ibm.mm.enabler.utils.Dom.innerXML(this.xmlDataMember[id]);
                
                var node = new com.ibm.mm.enabler.ac.MemberModelImpl(id, this, this.um, false);
                this.memberModel[id] = node;
                
                if (deferred) {
                    deferred.finish(null, xhr.status);
                }
            }
            else if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_ERROR) {
                if (deferred) {
                    deferred.finish(null, xhr.status);
                }
            }
        }));
    },
    
    _cacheNodeMembers: function(_id, _node) {
        var id = _node.getID();
        if (!(id in this.membersLoadedNodes[_id])) {
            this.membersLoadedNodes[_id][id] = _node;
        }
        return this.membersLoadedNodes[_id][id];
    },
    
    __commit: function(deferred, sync) {
        //var currentUserID = this.um.findCurrentUser().start().getID(); // skip updates for current user
        
        // Notify space extension first, and see if it succeed.
        if (com.ibm.mm.enabler.utils.Misc.isInstanceOf(this.mainResource, com.ibm.mashups.enabler.space.SpaceNode)) {
            var updatedSpace = this.mainResource;
            var spaceExtensionModel = com.ibm.mashups.enabler.space.Factory.getSpaceExtensionModel();
            var extension = spaceExtensionModel.findExtensionBySpace(updatedSpace).start();
            if (extension) {
                var changes = this._diffAccessControlChanges();
                if (changes !== null) {
                    var result = extension.onSpaceUpdate(updatedSpace.getID(), dojo.toJson(changes, true), null);
                    if (result && result.getState() != "OK") {
                        return;
                    }
                }
            }
        }
        
        this._acquire();
        
        var id;
        var link;
        var myUrl;
        var serviceReq;
        var nodeJSON;
        
        // HTTP POST created roles
        for (id in this.rolesCreatedNodes) {
            if (Object.prototype.hasOwnProperty.call(this.rolesCreatedNodes, id)) {
                var role = this.rolesCreatedNodes[id];
                var newRoleName = role.getRoleName();
                
                link = this._getRolesLink();
                if (link) {
                    myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(link, this);
                }
                else {
                    myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(this.url, this);
                    
                    nodeJSON = [{
                        value: "collection",
                        isID: false,
                        subModel: com.ibm.mashups.enabler.model.url.ModelUrlFactory.SUBMODEL_ROLE
                    }, {
                        value: this.mainResource.getID(),
                        isID: true
                    }];
                    myUrl.setNodes(nodeJSON);
                }
                
                serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
                this._acquire();
                serviceReq.create(role.toString(), dojo.hitch(this, function(type, data, xhr, args) {
                    var newNode = null;
                    if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_LOAD) {

                        var nodes = com.ibm.mashups.enabler.xml.XPath.evaluateXPath("//atom:entry", data, this.ns);
                        if (nodes.length > 0) {
                            for (var i = 0, l = nodes.length; i < l; i++) {
                                newNode = new com.ibm.mm.enabler.ac.RoleNodeImpl(nodes[i], this.um);
                                if (newNode.getRoleName() == newRoleName) {
                                    var len = this.rolesEntries.length;
                                    var oldNode = null;
                                    for (var id in this.rolesCreatedNodes) {
                                        if (Object.prototype.hasOwnProperty.call(this.rolesCreatedNodes, id)) {
                                            var node = this.rolesCreatedNodes[id];
                                            if (node.getRoleName() == newNode.getRoleName()) {
                                                oldNode = node;
                                                break;
                                            }
                                        }
                                    }
                                    this._replaceNodeRoles(oldNode, newNode);
                                    break;
                                }
                            }
                        }
                    }
                    
                    // public callback handling
                    if (deferred && deferred.operationCallback) {
                        deferred.operationCallback(newNode, com.ibm.mashups.enabler.DeferredOperation.OPERATION_MODIFY, xhr.status, deferred.operationCallbackParameters);
                    }
                    
                    this._release(deferred, xhr.status);
                })); // JSLINT-IGNORE: Enabler Team decided to keep this paradigma from dojo in tact
            }
        }
        this.rolesCreatedNodes = {};
        
        // HTTP DELETE deleted roles
        for (var id3 in this.rolesDeletedNodes) {
            if (this.rolesDeletedNodes.hasOwnProperty(id3)) {
                var deleteRole = this.rolesDeletedNodes[id3];
                var editLink = deleteRole.getEditLink();
                myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelUrl(editLink, this);
                serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
                this._acquire();
                serviceReq.remove(dojo.hitch(this, function(type, data, xhr, args) {
                    // callback handling
                    if (deferred && deferred.operationCallback) {
                        deferred.operationCallback(id3, com.ibm.mashups.enabler.DeferredOperation.OPERATION_DELETE, xhr.status, deferred.operationCallbackParameters);
                    }
                    this._release(deferred, xhr.status);
                })); // JSLINT-IGNORE: Enabler Team decided to keep this paradigma from dojo in tact
            }
        }
        this.rolesDeletedNodes = {};
        
        for (var id1 in this.rolesLoadedNodes) {
            if (Object.prototype.hasOwnProperty.call(this.rolesLoadedNodes, id1)) {
                var role1 = this.rolesLoadedNodes[id1];
                var roleID = role1.getID();
                var roleName = role1.getRoleType();
                
                // HTTP POST created members
                for (id in this.membersCreatedNodes[roleID]) {
                    if (Object.prototype.hasOwnProperty.call(this.membersCreatedNodes[roleID], id)) {
                        var member = this.membersCreatedNodes[roleID][id];
                        
                        link = this._getMembersLink(role1.xmlData);
                        if (link) {
                            myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(link, this);
                        }
                        else {
                            // now let's create the url
                            myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(this.url, this);
                            nodeJSON = [{
                                value: "collection",
                                isID: false,
                                subModel: com.ibm.mashups.enabler.model.url.ModelUrlFactory.SUBMODEL_MEMBER
                            }, {
                                value: roleName,
                                isID: false,
                                subModel: com.ibm.mashups.enabler.model.url.ModelUrlFactory.SUBMODEL_ROLE
                            }, {
                                value: this.mainResource.getID(),
                                isID: true
                            }];
                            myUrl.setNodes(nodeJSON);
                        }
                        
                        serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
                        this._acquire();
                        serviceReq.create(member._toEntry(), dojo.hitch(this, function(type, data, xhr, args) {
                            var newNode = null;
                            if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_LOAD) {
                                var expr = "//atom:entry";
                                var members = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(expr, data, this.ns);
                                if (members && members.length > 0) {
                                    for (var i = 0, l = members.length; i < l; i++) {
                                        newNode = new com.ibm.mm.enabler.ac.MemberNodeImpl(id, members[i], this.um);
                                        //this.accessControlModel.membersEntries[id][this.accessControlModel.membersCursor[this.roleID] + i] = node.getID();
                                        //this.accessControlModel._cacheNodeMembers(id, node);
                                    }
                                }
                                
                            }
                            
                            // public callback handling
                            if (deferred && deferred.operationCallback) {
                                deferred.operationCallback(newNode, com.ibm.mashups.enabler.DeferredOperation.OPERATION_MODIFY, xhr.status, deferred.operationCallbackParameters);
                            }
                            
                            this._release(deferred, xhr.status);
                        })); // JSLINT-IGNORE: Enabler Team decided to keep this paradigma from dojo in tact
                    }
                }
                this.membersCreatedNodes[roleID] = {};
                
                // HTTP DELETE deleted members
                for (var id2 in this.membersDeletedNodes[roleID]) {
                    if (Object.prototype.hasOwnProperty.call(this.membersDeletedNodes[roleID], id2)) {
                        var memberNode = this.membersDeletedNodes[roleID][id2];
                        var memberID = this.membersDeletedNodesMemberIDs[roleID][id2];
                        //if (memberID != currentUserID) { // User can't unshare to themself, skip any AC changes
                        var myUrl2 = null;
                        link = memberNode.getEditLink();
                        if (link) {
                            myUrl2 = new com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(link, this);
                        }
                        else {
                            myUrl2 = new com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(this.url, this);
                            nodeJSON = [{
                                value: memberID,
                                isID: false,
                                subModel: com.ibm.mashups.enabler.model.url.ModelUrlFactory.SUBMODEL_MEMBER
                            }, {
                                value: roleName,
                                isID: false,
                                subModel: com.ibm.mashups.enabler.model.url.ModelUrlFactory.SUBMODEL_ROLE
                            }, {
                                value: this.mainResource.getID(),
                                isID: true
                            }];
                            myUrl2.setNodes(nodeJSON);
                        }
                        
                        serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl2, null, null, false, sync);
                        this._acquire();
                        serviceReq.remove(dojo.hitch(this, function(type, data, xhr, args) {
                            var deletedID = null;
                            if (type != com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_ERROR) {
                                deletedID = id2;
                            }
                            if (deferred && deferred.operationCallback) {
                                deferred.operationCallback(deletedID, com.ibm.mashups.enabler.DeferredOperation.OPERATION_DELETE, xhr.status, deferred.operationCallbackParameters);
                            }
                            
                            this._release(deferred, xhr.status);
                        })); // JSLINT-IGNORE: Enabler Team decided to keep this paradigma from dojo in tact
                    }
                }
                this.membersDeletedNodes[roleID] = {};
                this.membersDeletedNodesMemberIDs[roleID] = {};
            }
        }
    },
    
    _initDelta: function() {
        var delta = {
            accesscontrol: {}
        };
        
        var resourceid, type;
        if (this.subResource) {
            resourceid = this.subResource.getID();
            type = (com.ibm.mm.enabler.utils.Misc.isInstanceOf(this.subResource, com.ibm.mashups.enabler.space.SpaceNode)) ? "space" : "page";
        }
        else {
            resourceid = this.mainResource.getID();
            type = "space";
        }
        delta.accesscontrol.resourceid = resourceid;
        delta.accesscontrol.type = type;
        
        return delta;
    },
    
    _diffAccessControlChanges: function() {
        var delta = null;
        var i, l;
        
        // owner
        if ("owner" in this.changedProperties) {
            if (!delta) {
                delta = this._initDelta();
            }
            var newOwner = this.getOwner();
            if (newOwner != this.changedProperties.owner) {
                delta.accesscontrol.owner = (typeof(newOwner) == "string") ? newOwner : newOwner.getID();
            }
        }
        
        // role-blocks
        if ("roleblock" in this.changedProperties) {
            if (!delta) {
                delta = this._initDelta();
            }
            for (var blockType in this.changedProperties.roleblock) {
                if (Object.prototype.hasOwnProperty.call(this.changedProperties.roleblock, blockType)) {
                    var oldRoleTypes = this.changedProperties.roleblock[blockType];
                    var newRoleTypes = this._getRoleTypes(blockType);
                    var changed = (newRoleTypes.length != oldRoleTypes.length);
                    if (!changed) {
                        for (var i2 = 0, l2 = newRoleTypes.length; i2 < l2; i2++) {
                            if (typeof oldRoleTypes[newRoleTypes[i2]] != "undefined") {
                                changed = true;
                                break;
                            }
                        }
                    }
                    
                    if (changed) { // set to new role type.
                        if (!delta.accesscontrol.roleblock) {
                            delta.accesscontrol.roleblock = {};
                        }
                        delta.accesscontrol.roleblock[blockType] = newRoleTypes;
                    }
                }
            }
        }
        
        // role
        if ("role" in this.changedProperties) {
            if (!delta) {
                delta = this._initDelta();
            }
            
            var getUncommittedChanges = function(created, loaded, removed) {
                var id;
                var changed = [];
                var index = 0;
                if (created) {
                    for (id in created) {
                        if (Object.prototype.hasOwnProperty.call(created, id)) {
                            if (created[id]) {
                                changed[index++] = created[id];
                            }
                        }
                    }
                }
                if (loaded) {
                    for (id in loaded) {
                        if (Object.prototype.hasOwnProperty.call(loaded, id)) {
                            if (typeof created[id] == "undefined" && loaded[id]) {
                                changed[index++] = loaded[id];
                            }
                        }
                    }
                }
                if (removed) {
                    for (id in removed) {
                        if (removed[id]) {
                            var removedID = removed[id].getID();
                            for (var j = 0; j < changed.length; j++) {
                                if (changed[j].getID() == removedID) {
                                    changed.splice(j, 1);
                                    break;
                                }
                            }
                        }
                    }
                }
                
                return changed;
            };
            
            var addMembersToDelta = function(delta, roleIndex, role, isExistingRole, membersCreated, membersLoaded, membersDeleted) {
                var id;
                
                var isMemberCreated = false;
                for (id in membersCreated) {
                    if (Object.prototype.hasOwnProperty.call(membersCreated, id)) {
                        isMemberCreated = true;
                    }
                }
                
                var isMemberDeleted = false;
                for (id in membersDeleted) {
                    if (Object.prototype.hasOwnProperty.call(membersDeleted, id)) {
                        isMemberDeleted = true;
                    }
                }
                
                if (isExistingRole && (isMemberCreated || isMemberDeleted) ||
                !isExistingRole) {
                    if (!delta.accesscontrol.role) {
                        delta.accesscontrol.role = [];
                    }
                    
                    delta.accesscontrol.role[roleIndex] = {};
                    delta.accesscontrol.role[roleIndex].name = role.getRoleType();
                    
                    var members = getUncommittedChanges(membersCreated, membersLoaded, membersDeleted);
                    for (var i = 0, l = members.length; i < l; i++) {
                        var member = members[i];
                        var entity = member.getEntity();
                        if (entity) {
                            if (!delta.accesscontrol.role[roleIndex].member) {
                                delta.accesscontrol.role[roleIndex].member = [];
                            }
                            delta.accesscontrol.role[roleIndex].member[i] = {
                                id: member.getID(),
                                type: entity.getEntityType()
                            };
                        }
                    }
                }
            };
            
            var roleIndex = 0;
            var uncommittedRoles = getUncommittedChanges(this.rolesCreatedNodes, this.rolesLoadedNodes, this.rolesDeletedNodes);
            for (i = 0, l = uncommittedRoles.length; i < l; i++) {
                var role = uncommittedRoles[i];
                var roleID = role.getID();
                // check this role is old role.
                var isExistingRole = false;
                for (var id in this.changedProperties.role) {
                    if (Object.prototype.hasOwnProperty.call(this.changedProperties.role, id)) {
                        var oldRoleID = this.changedProperties.role[id];
                        if (oldRoleID == roleID) {
                            isExistingRole = true;
                            break;
                        }
                    }
                }
                
                addMembersToDelta(delta, roleIndex, role, isExistingRole, this.membersCreatedNodes[roleID], this.membersLoadedNodes[roleID], this.membersDeletedNodes[roleID]);
                roleIndex++;
            }
        } // end role
        // finished, clear changed properties.
        this.changedProperties = {};
        return delta;
    },
    
    _removeNodeRoles: function(role) {
        var id = role.getID();
        
        // remove node from cache
        if (id in this.rolesLoadedNodes) {
            delete this.rolesLoadedNodes[id];
        }
        
        if (id in this.rolesCreatedNodes) {
            // un-create role
            delete this.rolesCreatedNodes[id];
        }
        else {
            // mark node to be deleted
            this.rolesDeletedNodes[id] = role;
        }
        
        // remove role members
        if (this.membersCreatedNodes[id]) {
            delete this.membersCreatedNodes[id];
        }
    },
    
    // acquire semaphore
    _acquire: function() {
        this.requestCount++;
    },
    
    // release semaphore
    _release: function(deferred, statusCode) {
        // set overall status Code
        this.statusCode = Math.max(parseInt(statusCode, 10), this.statusCode);
        // check for full release
        this.requestCount--;
        if (this.requestCount <= 0) {
            if (deferred) {
                deferred.finish(null, this.statusCode);
            }
        }
    }
});

}

if(!dojo._hasResource["com.ibm.mashups.enabler.ac.AccessControlModel"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.ac.AccessControlModel"] = true;
dojo.provide("com.ibm.mashups.enabler.ac.AccessControlModel");








}

if(!dojo._hasResource["com.ibm.mashups.enabler.ac.ResourceAccessControlModel_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.ac.ResourceAccessControlModel_API"] = true;
dojo.provide("com.ibm.mashups.enabler.ac.ResourceAccessControlModel_API");
dojo.provide("com.ibm.mashups.enabler.ac.ResourceAccessControlModel");

/**
 * Interface for a access control model with additional features for resource handling.
 * @ibm-api
 * @ibm-module AccessControlModel
 */
dojo.declare("com.ibm.mashups.enabler.ac.ResourceAccessControlModel", [com.ibm.mashups.enabler.ac.AccessControlModel], {
    /**
     * Returns if the inheritance block is set for the specified role type.
     * @param {com.ibm.mashups.enabler.ac.RoleType} roletype the role type for which to retrieve the inheritance block
     * @type boolean
     */
    isInheritanceBlock: function(roletype){
    },
    /**
     * Sets if the inheritance block is set or not for the specified role type.
     * @param {com.ibm.mashups.enabler.ac.RoleType} roletype the role type for which to set the inheritance block
     * @param {boolean} value <code>true</code> to set the inheritance block, or
     * <code>false</code> to unset the inheritance block.
     * @type void
     */
    setInheritanceBlock: function(roletype, value){
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.ac.ResourceAccessControlModelImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.ac.ResourceAccessControlModelImpl"] = true;
dojo.provide("com.ibm.mm.enabler.ac.ResourceAccessControlModelImpl");














dojo.declare("com.ibm.mm.enabler.ac.ResourceAccessControlModelImpl", [com.ibm.mashups.enabler.ac.ResourceAccessControlModel, com.ibm.mm.enabler.ac.AccessControlModelImpl], {
    constructor: function(_mainResource) {
        this.mainResource = _mainResource;
        this.subResource = this.mainResource;
        this.url = com.ibm.mashups.enabler.model.url.ModelUrlFactory.AC_URL;
        this.url2 = com.ibm.mashups.enabler.model.url.ModelUrlFactory.AC_URL;
    },
    
    _getRolesLink: function() {
        return this.getACRolesLink(this.mainResource.getXml());
    },
    
    _getMembersLink: function(xmlData) {
        return this.getACMembersLink(xmlData);
    },
    
    _getResourceLink: function() {
        return this.getACResourceLink(this.mainResource.getXml());
    },
    
    isInheritanceBlock: function(roletype) {
        return this.isRoleBlock(roletype, "inheritance");
    },
    
    setInheritanceBlock: function(roletype, value) {
        this.setRoleBlock(roletype, value, "inheritance");
    },
    
    getOwner: function() {
        if (this.owner === null) {
            if (this.xmlData === undefined) {
                this._loadAheadResource(null, true);
            }
            var expr = "atom:content/ac:resource-config/ac:owner";
            var owner = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, this.xmlData, this.ns);
            if (owner) {
                var ownerID = com.ibm.mm.enabler.utils.Dom.getAttributeWithNS(owner, "ac:id", "id", this.ns.ac);
                this.owner = this.um.find(ownerID).start();
            }
        }
        return this.owner;
    },
    
    setOwner: function(user) {
        if (this.xmlData === undefined) {
            this._loadAheadResource(null, true);
        }
        
        // track old resource onwer for update
        if (!this.changedProperties.owner) {
            this.changedProperties.owner = this._getOwner();
        }
        
        this.owner = user;
        
        var expr = "atom:content/ac:resource-config/ac:owner";
        var owner = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, this.xmlData, this.ns);
        if (owner) {
            com.ibm.mm.enabler.utils.Utils.setAttributeWithNS(owner, "ac:id", this.nsf.getNameSpaceUri(this.nsf.NS_AC), user.getID());
        }
        else {
            expr = "atom:content/ac:resource-config";
            var config = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, this.xmlData, this.ns);
            if (config) {
                // create owner  element
                var tn = com.ibm.mm.enabler.utils.Dom.createElement(this.xmlData.ownerDocument, "ac:owner", this.nsf.getNameSpaceUri(this.nsf.NS_AC));
                com.ibm.mm.enabler.utils.Utils.setAttributeWithNS(tn, "ac:id", this.nsf.getNameSpaceUri(this.nsf.NS_AC), user.getID());
                config.appendChild(tn);
            }
        }
    },
    
    confirmSetOwner: function(user) {
        return this.subResource.hasRole(com.ibm.mashups.enabler.ac.RoleType.MANAGER);
    },
    
    confirmGetRoleModel: function() {
        return this.subResource.hasRole(com.ibm.mashups.enabler.ac.RoleType.MANAGER);
    },
    
    _getOwner: function() {
        if (this.xmlData === undefined) {
            this._loadAheadResource(null, true);
        }
        
        var expr = "atom:content/ac:resource-config/ac:owner";
        var owner = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, this.xmlData, this.ns);
        if (owner) {
            return com.ibm.mm.enabler.utils.Dom.getAttributeWithNS(owner, "ac:id", "id", this.nsf.getNameSpaceUri(this.nsf.NS_AC));
        }
        
        return null;
    },
    
    _loadAheadResource: function(deferred, sync) {
        if (this.xmlData === undefined) {
            var myUrl = null;
            var link = this._getResourceLink();
            if (link) {
                myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(link, this);
            }
            else {
                myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(this.url2, this);
                var nodeJSON = [{
                    value: this.subResource.getID(),
                    isID: true,
                    subModel: com.ibm.mashups.enabler.model.url.ModelUrlFactory.SUBMODEL_RESOURCE
                }];
                myUrl.setNodes(nodeJSON);
            }
            
            var serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
            
            serviceReq.read(dojo.hitch(this, function(type, data, xhr, args){
                var expr = "atom:feed";
                var feed = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, data, this.ns);
                var element = feed || data;
                expr = "atom:entry";
                this.xmlData = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, element, this.ns);
                this.initialContentsResource = com.ibm.mm.enabler.utils.Dom.innerXML(this.xmlData);
                
                // callback handling
                if (deferred) {
                    deferred.finish(null, xhr.status);
                }
            }));
        }
    },
    
    isRoleBlock: function(roletype, blocktype) {
        if (this.xmlData === undefined) {
            this._loadAheadResource(null, true);
        }
        
        if (roletype) {
        	roletype = roletype.toUpperCase();
        	blocktype = blocktype.toUpperCase();
            var expr = "atom:content/ac:resource-config/ac:role-block";
            var roleBlocks = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(expr, this.xmlData, this.ns);
            if (roleBlocks) {
                for (var i = 0, l = roleBlocks.length; i < l; i++) {
                    var roleBlock = roleBlocks[i];
                    var block = com.ibm.mm.enabler.utils.Dom.getAttributeWithNS(roleBlock, "ac:block-type", "block-type", this.ns.ac);
                    var type = com.ibm.mm.enabler.utils.Dom.getAttributeWithNS(roleBlock, "ac:type", "type", this.ns.ac);
                    if (block && type) {
                        if (roletype == type.toUpperCase()) {
                            if (blocktype == block.toUpperCase()) {
                                return true;
                            }
                        }
                    }
                }
            }
        }
        
        return false;
    },
    
    isPropagationBlock: function(roletype) {
        return this.isRoleBlock(roletype, "propagation");
    },
    
    setRoleBlock: function(roletype, value, blocktype) {
        if (this.xmlData === undefined) {
            this._loadAheadResource(null, true);
        }
        
        // track old role-blocks for update
        if (!this.changedProperties.roleblock) {
            this.changedProperties.roleblock = {};
        }
        if (!this.changedProperties.roleblock[blocktype]) {
            this.changedProperties.roleblock[blocktype] = this._getRoleTypes(blocktype);
        }
        
        var expr, block;
        if (!value) {
            // remove
            expr = "atom:content/ac:resource-config/ac:role-block";
            var roleBlocks = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(expr, this.xmlData, this.ns);
            if (roleBlocks) {
            	roletype = roletype.toUpperCase();
            	blocktype = blocktype.toUpperCase();            	
                for (var i = 0, l = roleBlocks.length; i < l; i++) {
                    var roleBlock = roleBlocks[i];
                    block = com.ibm.mm.enabler.utils.Dom.getAttributeWithNS(roleBlock, "ac:block-type", "block-type", this.ns.ac);
                    var type = com.ibm.mm.enabler.utils.Dom.getAttributeWithNS(roleBlock, "ac:type", "type", this.ns.ac);
                    if (block && type) {
                        if (roletype == type.toUpperCase()) {
                            if (blocktype == block.toUpperCase()) {
                                dojo.destroy(roleBlock);
                                return;
                            }
                        }
                    }
                }
            }
        }
        else {
            // create
            expr = "atom:content/ac:resource-config";
            var resourceConfig = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, this.xmlData, this.ns);
            block = com.ibm.mm.enabler.utils.Dom.createElement(this.xmlData.ownerDocument, "ac:role-block", this.ns.ac);
            com.ibm.mm.enabler.utils.Dom.setAttributeWithNS(this.xmlData.ownerDocument, block, "ac:block-type", "block-type", this.ns.ac, blocktype);
            com.ibm.mm.enabler.utils.Dom.setAttributeWithNS(this.xmlData.ownerDocument, block, "ac:type", "type", this.ns.ac, roletype);
            resourceConfig.appendChild(block);
        }
        
    },
    
    _getRoleTypes: function(blocktype) {
        if (this.xmlData === undefined) {
            this._loadAheadResource(null, true);
        }
        
        var roleTypes = [];
        var expr = "atom:content/ac:resource-config/ac:role-block[@ac:block-type='" + blocktype + "']";
        var roleBlocks = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(expr, this.xmlData, this.ns);
        for (var i = 0, l = roleBlocks.length; i < l; i++) {
            roleTypes[i] = com.ibm.mm.enabler.utils.Dom.getAttributeWithNS(roleBlocks[i], "ac:type", "type", this.ns.ac);
        }
        
        return roleTypes;
    },
    
    setPropagationBlock: function(roletype, value) {
        this.setRoleBlock(roletype, value, "propagation");
    },
    
    commit: function() {
        return new com.ibm.mm.enabler.DeferredOperationImpl(this, this._commit);
    },
    
    _commit: function(deferred, sync) {
        //var LOG_METHOD = "_commit(deferred, sync)";
        //var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        //if (bIsLoggable) {
        //    this.LOGGER.entering(LOG_METHOD, [deferred, sync]);
        //}
        
        // PUT updated resource
        if (this.initialContentsResource && this.initialContentsResource !== com.ibm.mm.enabler.utils.Dom.innerXML(this.xmlData)) {
            // initialize callback handling
            this.statusCode = com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK;
            this.requestCount = 0;
            this._acquire();
            
            var myUrl = new com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(this.url2, this);
            var nodeJSON = [{
                value: this.subResource.getID(),
                isID: true,
                subModel: com.ibm.mashups.enabler.model.url.ModelUrlFactory.SUBMODEL_RESOURCE
            }];
            myUrl.setNodes(nodeJSON);
            
            
            var serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, true);
            this._acquire();
            serviceReq.update(com.ibm.mm.enabler.utils.Dom.innerXML(this.xmlData), dojo.hitch(this, function(type, data, xhr, args) {
                //var LOG_METHOD = "_commit_create_callback(type, data, xhr, args)";
                //if (bIsLoggable) {
                //    this.LOGGER.entering(LOG_METHOD, [type, data, xhr, args]);
                //}
                
//                if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_LOAD) {
//                }
                
                this.initialContentsResource = com.ibm.mm.enabler.utils.Dom.innerXML(this.xmlData);
                
                // public callback handling
                if (deferred && deferred.operationCallback) {
                    deferred.operationCallback(this, com.ibm.mashups.enabler.DeferredOperation.OPERATION_CREATE, xhr.status, deferred.operationCallbackParameters);
                }
                
                this._release(deferred, xhr.status);
                
                //if (bIsLoggable) {
                //    this.LOGGER.exiting(LOG_METHOD);
                //}
            }));
        }
        
        this.__commit(deferred, sync);
        
        //if (bIsLoggable) {
        //    this.LOGGER.exiting(LOG_METHOD);
        //}
    }
    
});

}

if(!dojo._hasResource["com.ibm.mashups.enabler.ac.ResourceAccessControlModel"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.ac.ResourceAccessControlModel"] = true;
dojo.provide("com.ibm.mashups.enabler.ac.ResourceAccessControlModel");






}

if(!dojo._hasResource["com.ibm.mashups.enabler.ac.SpaceAccessControlModel_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.ac.SpaceAccessControlModel_API"] = true;
dojo.provide("com.ibm.mashups.enabler.ac.SpaceAccessControlModel_API");
dojo.provide("com.ibm.mashups.enabler.ac.SpaceAccessControlModel");

/**
 * Interface for a space access control model.
 * 
 * @ibm-api
 * @ibm-module AccessControlModel
 */
dojo.declare("com.ibm.mashups.enabler.ac.SpaceAccessControlModel",com.ibm.mashups.enabler.ac.AccessControlModel,{
    
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.ac.SpaceAccessControlModelImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.ac.SpaceAccessControlModelImpl"] = true;
dojo.provide("com.ibm.mm.enabler.ac.SpaceAccessControlModelImpl");








dojo.declare("com.ibm.mm.enabler.ac.SpaceAccessControlModelImpl", [com.ibm.mashups.enabler.ac.SpaceAccessControlModel, com.ibm.mm.enabler.ac.AccessControlModelImpl], {
    constructor: function(_mainResource){
        this.mainResource = _mainResource;
        this.xmlData = this.mainResource.getXml();
        
        this.initialContentsResource = null;
        this.xmlDataResources = null;
        
        this._init();
    },

    // return true if the role should be filtered out/skipped, otherwise false
    _filterRole: function(node) {
        return (node.getRoleName().indexOf("@")>0);
    },

    _getRolesLink: function() {
        return this.getCARolesLink(this.mainResource.getXml());
    },
    
    _getMembersLink: function(xmlData) {
        return this.getACMembersLink(xmlData);
    },

    getOwner: function(){
        return this.mainResource.getOwner();
    },

    setOwner: function(user){
        this.mainResource.setOwner(user);
    },

    confirmSetOwner: function(user) {
        return this.mainResource.hasRole(com.ibm.mashups.enabler.ac.RoleType.MANAGER);
    },
    
    commit: function(){
        return new com.ibm.mm.enabler.DeferredOperationImpl(this, this._commit);
    },
    
    _commit: function(deferred, sync){
        //var LOG_METHOD = "_commit(deferred, sync)";
        //var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        //if (bIsLoggable) {
        //    this.LOGGER.entering(LOG_METHOD, [deferred, sync]);
        //}
        var spaceModel = com.ibm.mashups.enabler.space.Factory.getSpaceModel();
        spaceModel.commit().start();
        
        this.__commit(deferred, sync);
        
        //if (bIsLoggable) {
        //    this.LOGGER.exiting(LOG_METHOD);
        //}
    }    
});

}

if(!dojo._hasResource["com.ibm.mashups.enabler.ac.SpaceAccessControlModel"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.ac.SpaceAccessControlModel"] = true;
dojo.provide("com.ibm.mashups.enabler.ac.SpaceAccessControlModel");






}

if(!dojo._hasResource["com.ibm.mashups.enabler.ac.ResourceSpaceAccessControlModel_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.ac.ResourceSpaceAccessControlModel_API"] = true;
dojo.provide("com.ibm.mashups.enabler.ac.ResourceSpaceAccessControlModel_API");
dojo.provide("com.ibm.mashups.enabler.ac.ResourceSpaceAccessControlModel");

/**
 * Interface for a space access control model.
 * 
 * @ibm-api
 * @ibm-module AccessControlModel
 */
dojo.declare("com.ibm.mashups.enabler.ac.ResourceSpaceAccessControlModel",com.ibm.mashups.enabler.ac.SpaceAccessControlModel,{
    
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.ac.ResourceSpaceAccessControlModelImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.ac.ResourceSpaceAccessControlModelImpl"] = true;
dojo.provide("com.ibm.mm.enabler.ac.ResourceSpaceAccessControlModelImpl");







dojo.declare("com.ibm.mm.enabler.ac.ResourceSpaceAccessControlModelImpl", [com.ibm.mashups.enabler.ac.ResourceSpaceAccessControlModel, com.ibm.mm.enabler.ac.ResourceAccessControlModelImpl], {
    _metaPrefix: "com.ibm.mashups.acl.role.",
    
    constructor: function(_mainResource, _subResource){
        this.mainResource = _mainResource;
        this.subResource = _subResource;
        this.url = com.ibm.mashups.enabler.model.url.ModelUrlFactory.AI_URL;
        this.url2 = com.ibm.mashups.enabler.model.url.ModelUrlFactory.AC_URL;
    },
    
    _getRolesLink: function(){
        return this.getACRolesLink(this.mainResource.getXml());
    },
    
    _getResourceLink: function(){
        return this.getACResourceLink(this.subResource.getXml());
    },
    
    _getCreationRoleName: function(roletype){
        return roletype + "@" + this.subResource.getID();
    },
    
    _getCreationResourceID: function(){
        return this.subResource.getID();
    },
    
    // overwrite
    _isPageInSpace: function(){
        return true;
    },
    // overwrite
    _getPossibleRoles: function(){
        var roles = {};
        var names = this.subResource.getMetaDataNames();
        for (var i = 0, l = names.length; i < l; i++) {
			var l2 = this._metaPrefix.length;
            if (names[i].indexOf(this._metaPrefix) === 0) {
                // we found a role for access control - there might be one for each role
                var roleType = names[i].substring(l2);
                var roleName = this.subResource.getMetaData(names[i]);
                roles[roleType] = roleName;
            }
        }
        return roles;
    },
    
    commit: function(){
        return new com.ibm.mm.enabler.DeferredOperationImpl(this, this._commit);
    },
    
    _commit: function(deferred, sync){
        // first we update the fragment metadata, then we commit the remaining items
        com.ibm.mm.enabler.utils.Misc.forIn(this.rolesCreatedNodes, function(role){
            this.subResource.setMetaData(this._metaPrefix + role.getRoleType(), role.getRoleName());
        }, this);
        
        com.ibm.mashups.enabler.navigation.Factory.getNavigationModel().commit().start(true);
        
        this.inherited(arguments);
    }
    
});

}

if(!dojo._hasResource["com.ibm.mashups.enabler.ac.ResourceSpaceAccessControlModel"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.ac.ResourceSpaceAccessControlModel"] = true;
dojo.provide("com.ibm.mashups.enabler.ac.ResourceSpaceAccessControlModel");






}

if(!dojo._hasResource["com.ibm.mashups.enabler.catalog.CatalogNode"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.catalog.CatalogNode"] = true;
dojo.provide("com.ibm.mashups.enabler.catalog.CatalogNode");





/**
 * Interface that represents a catalog node
 * 
 * @ibm-api
 * @ibm-module CatalogModel
 */
dojo.declare("com.ibm.mashups.enabler.catalog.CatalogNode", [
		com.ibm.mashups.enabler.Identifiable,
		com.ibm.mashups.enabler.ModifiableLocalized, com.ibm.mashups.enabler.DefaultLocalized ], {});

}

if(!dojo._hasResource["com.ibm.mashups.enabler.catalog.CatalogCategoryNode_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.catalog.CatalogCategoryNode_API"] = true;
dojo.provide("com.ibm.mashups.enabler.catalog.CatalogCategoryNode_API");
dojo.provide("com.ibm.mashups.enabler.catalog.CatalogCategoryNode");

/**
 * Interface that represents a catalog category; used in the
 * CatalogCategoryModel
 * 
 * @ibm-api
 * @ibm-module CatalogModel
 */
dojo.declare("com.ibm.mashups.enabler.catalog.CatalogCategoryNode",
		[ com.ibm.mashups.enabler.catalog.CatalogNode ], {});

}

if(!dojo._hasResource["com.ibm.mm.enabler.persistence.xml.DefaultLocalizedXmlImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.persistence.xml.DefaultLocalizedXmlImpl"] = true;
dojo.provide("com.ibm.mm.enabler.persistence.xml.DefaultLocalizedXmlImpl");






dojo.declare("com.ibm.mm.enabler.persistence.xml.DefaultLocalizedXmlImpl", [com.ibm.mashups.enabler.ModifiableLocalized, com.ibm.mm.enabler.ac.EffectiveAccessImpl], {

    constructor: function(){
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass);
        this.LOG_LEVEL = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
        
        // service document and initialization
        var serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_NAVIGATION);
        var nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
        this.dli_ns = dojo.delegate(serviceJson.namespaces, nsf.getNameSpaces([nsf.NS_ATOM, nsf.NS_XML]));
                
        // title element
        this._DEFAULT_TITLE = "atom:title";
        
        // summary element
        this._DEFAULT_DESCRIPTION = "atom:summary";
        
        // title element language
        this._DEFAULT_LOCALE = this._DEFAULT_TITLE + "/@xml:lang";
    },
    
    getDefaultLocale: function(){
        return com.ibm.mashups.enabler.xml.XPath.evaluateString(this._DEFAULT_LOCALE, this.xmlData, this.dli_ns) || null;
    },
    
    getDefaultTitle: function(){
        var title = com.ibm.mashups.enabler.xml.XPath.evaluateString(this._DEFAULT_TITLE, this.xmlData, this.dli_ns);
        if (title === "") {
            // this is a special case as the atom:id element must be in the xml content but can easily be empty.
            // we must consider this as null;
            title = null;
        }
        return title;
    },
    
    getDefaultDescription: function(){
        var description = com.ibm.mashups.enabler.xml.XPath.evaluateString(this._DEFAULT_DESCRIPTION, this.xmlData, this.dli_ns);
        if (description === "") {
            // this is a special case as the atom:id element must be in the xml content but can easily be empty.
            // we must consider this as null;
            description = null;
        }
        return description;
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.persistence.xml.LocalizedXmlImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.persistence.xml.LocalizedXmlImpl"] = true;
dojo.provide("com.ibm.mm.enabler.persistence.xml.LocalizedXmlImpl");










dojo.declare("com.ibm.mm.enabler.persistence.xml.LocalizedXmlImpl", [com.ibm.mashups.enabler.ModifiableLocalized, com.ibm.mm.enabler.ac.EffectiveAccessImpl], {

    constructor: function(){
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass);
        this.LOG_LEVEL = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
        
        // service document and initialization
        var serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_NAVIGATION);
        var nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
        this.li_ns = dojo.delegate(serviceJson.namespaces, nsf.getNameSpaces([nsf.NS_ATOM, nsf.NS_XML]));
        this.enforcementHelper = com.ibm.mm.enabler.utils.APIEnforcementHelper;
        
        // base
        this.BASE_NLS_TITLE_STRING = "base:nls-string";
        this.BASE_NLS_DESCRIPTION_STRING = "base:nls-string";
        this.BASE_NS = this.li_ns.base;
        
        // title
        this.TITLE_ELEMENT = "atom:content/*/model:title";
        this.TITLE = this.TITLE_ELEMENT + "/" + this.BASE_NLS_TITLE_STRING;
        
        // description
        this.DESCRIPTION_ELEMENT = "atom:content/*/model:description";
        this.DESCRIPTION = this.DESCRIPTION_ELEMENT + "/" + this.BASE_NLS_DESCRIPTION_STRING;
    },
    
    _normalizeLocale: function(loc){
        return (dojo.isString(loc) && loc.length > 0) ? loc.replace(/_/g, "-").toLowerCase() : null;
    },
    
    getLocales: function(){
        this._readLocales();
        var result = [];
        com.ibm.mm.enabler.utils.Misc.forIn(this._cache.titles, function(title, loc){
            result.push(loc);
        });
        return result;
    },
    
    getTitle: function(loc){
        this.enforcementHelper.enforceDefinedNotNull(loc, this.modelMessages.E_PARAM_ISNULL_OR_UNDEFINED_3, ["locale", this.declaredClass, "getTitle(locale)"]);
        this._readLocales();
        var title = this._cache.titles[this._normalizeLocale(loc)];
        return (typeof title == "undefined") ? null : title;
    },
    
    getTitles: function(loc){
        this._readLocales();
        var result = {};
        if (loc) {
            var nLoc = this._normalizeLocale(loc);
            com.ibm.mm.enabler.utils.Misc.forIn(this._cache.titles, function(title, l){
                if (l.indexOf(nLoc) === 0) {
                    result[l] = title;
                }
            });
        }
        else {
            result = dojo.clone(this._cache.titles);
        }
        return result;
    },
    
    getDescription: function(loc){
        this.enforcementHelper.enforceDefinedNotNull(loc, this.modelMessages.E_PARAM_ISNULL_OR_UNDEFINED_3, ["locale", this.declaredClass, "getDescription(locale)"]);
        this._readLocales();
        var description = this._cache.descriptions[this._normalizeLocale(loc)];
        return (typeof description == "undefined") ? null : description;
    },
    
    getDescriptions: function(loc){
        this._readLocales();
        var result = {};
        if (loc) {
            var nLoc = this._normalizeLocale(loc);
            com.ibm.mm.enabler.utils.Misc.forIn(this._cache.descriptions, function(description, l){
                if (l.indexOf(nLoc) === 0) {
                    result[l] = description;
                }
            });
        }
        else {
            result = dojo.clone(this._cache.descriptions);
        }
        return result;
    },
    
    _getLang: function(node){
        return com.ibm.mm.enabler.utils.Dom.getAttributeWithNS(node, "xml:lang", "lang", this.li_ns.xml);
    },
    
    _readLocales: function(){
        if (!this._cache) {
            this._cache = {
                titles: {},
                descriptions: {}
            };
            var titles = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(this.TITLE, this.xmlData, this.li_ns);
            if (titles) {
                for (var i = titles.length; i > 0; i--) {
                    var title = titles[i - 1];
                    this._cache.titles[this._normalizeLocale(this._getLang(title))] = com.ibm.mm.enabler.utils.Dom.textContent(title);
                }
            }
            var descriptions = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(this.DESCRIPTION, this.xmlData, this.li_ns);
            if (descriptions) {
                for (var j = descriptions.length; j > 0; j--) {
                    var description = descriptions[j - 1];
                    this._cache.descriptions[this._normalizeLocale(this._getLang(description))] = com.ibm.mm.enabler.utils.Dom.textContent(description);
                }
            }
        }
    },
    
    setTitle: function(title, loc){
        this.enforcementHelper.enforceDefinedNotNull(title, this.modelMessages.E_PARAM_ISNULL_OR_UNDEFINED_3, ["title", this.declaredClass, "setTitle(title, locale)"]);
        this.enforcementHelper.enforceDefinedNotNull(loc, this.modelMessages.E_PARAM_ISNULL_OR_UNDEFINED_3, ["locale", this.declaredClass, "setTitle(title, locale)"]);
        if (dojo.isString(title) && loc) {
            if (this.getTitle(loc) == title) {
                // identical, so no need to change
                return;
            }
            // iterate the localized titles
            var titleBase = com.ibm.mashups.enabler.xml.XPath.createXPath(this.TITLE_ELEMENT, this.xmlData, this.li_ns);
            var titles = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(this.BASE_NLS_TITLE_STRING, titleBase, this.li_ns);
            var nLoc = this._normalizeLocale(loc);
            var localeExists = false;
            var i = titles.length;
            while (--i >= 0) {
                var t = titles[i];
                var lang = this._getLang(t);
                if (lang !== null && this._normalizeLocale(lang) == nLoc) {
                    // update title
                    com.ibm.mm.enabler.utils.Dom.textContent(t, title);
                    localeExists = true;
                    break;
                }
            }
            // create locale if it does not exists
            if (!localeExists) {
                var xmlDom = this.xmlData.ownerDocument;
                var node = com.ibm.mm.enabler.utils.Dom.createElement(xmlDom, this.BASE_NLS_TITLE_STRING, this.BASE_NS);
                com.ibm.mm.enabler.utils.Dom.setAttributeWithNS(xmlDom, node, "xml:lang", "lang", this.li_ns.xml, loc);
                com.ibm.mm.enabler.utils.Dom.textContent(node, title);
                titleBase.appendChild(node);
            }
            this._cache.titles[nLoc] = title;
            this._setDirty();
        }
    },
    
    confirmSetTitle: function(title, locale){
        return this.hasRole(com.ibm.mashups.enabler.ac.RoleType.EDITOR);
    },
    
    removeTitle: function(loc){
        this.enforcementHelper.enforceDefinedNotNull(loc, this.modelMessages.E_PARAM_ISNULL_OR_UNDEFINED_3, ["locale", this.declaredClass, "removeTitle(locale)"]);
        if (loc) {
            // iterate the localized titles
            var titles = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(this.TITLE, this.xmlData, this.li_ns);
            if (titles && titles.length > 0) {
                var nLoc = this._normalizeLocale(loc);
                for (var i = titles.length; i > 0; i--) {
                    var title = titles[i - 1];
                    var lang = this._getLang(title);
                    if (lang !== null && this._normalizeLocale(lang) == nLoc) {
                        // remove title
                        dojo.destroy(title);
                        break;
                    }
                }
                delete this._cache.titles[nLoc];
                this._setDirty();
            }
        }
    },
    
    confirmRemoveTitle: function(loc){
        return this.hasRole(com.ibm.mashups.enabler.ac.RoleType.EDITOR);
    },
    
    removeTitles: function(){
        // iterate the localized titles
        var titles = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(this.TITLE, this.xmlData, this.li_ns);
        if (titles && titles.length > 0) {
            for (var i = titles.length; i > 0; i--) {
                // remove title
                var parent = titles[i - 1].parentNode;
                parent.removeChild(titles[i - 1]);
            }
            this._cache.titles = {};
            this._setDirty();
        }
    },
    
    confirmRemoveTitles: function(){
        return this.hasRole(com.ibm.mashups.enabler.ac.RoleType.EDITOR);
    },
    
    setDescription: function(description, loc){
        this.enforcementHelper.enforceDefinedNotNull(description, this.modelMessages.E_PARAM_ISNULL_OR_UNDEFINED_3, ["description", this.declaredClass, "setDescription(description, locale)"]);
        this.enforcementHelper.enforceDefinedNotNull(loc, this.modelMessages.E_PARAM_ISNULL_OR_UNDEFINED_3, ["locale", this.declaredClass, "setDescription(description, locale)"]);
        if (dojo.isString(description) && loc) {
            if (this.getDescription(loc) == description) {
                // identical, so no need to change
                return;
            }
            // iterate the localized descriptions
            var descBase = com.ibm.mashups.enabler.xml.XPath.createXPath(this.DESCRIPTION_ELEMENT, this.xmlData, this.li_ns);
            var descriptions = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(this.BASE_NLS_DESCRIPTION_STRING, descBase, this.li_ns);
            var nLoc = this._normalizeLocale(loc);
            var localeExists = false;
            var i = descriptions.length;
            while (--i >= 0) {
                var desc = descriptions[i];
                var lang = this._getLang(desc);
                if (lang !== null && this._normalizeLocale(lang) == nLoc) {
                    // update description
                    com.ibm.mm.enabler.utils.Dom.textContent(desc, description);
                    localeExists = true;
                    break;
                }
            }
            
            // create locale if it does not exists
            if (!localeExists) {
                var xmlDom = this.xmlData.ownerDocument;
                var node = com.ibm.mm.enabler.utils.Dom.createElement(xmlDom, this.BASE_NLS_DESCRIPTION_STRING, this.BASE_NS);
                com.ibm.mm.enabler.utils.Dom.setAttributeWithNS(xmlDom, node, "xml:lang", "lang", this.li_ns.xml, loc);
                com.ibm.mm.enabler.utils.Dom.textContent(node, description);
                descBase.appendChild(node);
            }
            this._cache.descriptions[nLoc] = description;
            this._setDirty();
        }
    },
    
    confirmSetDescription: function(title, locale){
        return this.hasRole(com.ibm.mashups.enabler.ac.RoleType.EDITOR);
    },
    
    removeDescription: function(loc){
        this.enforcementHelper.enforceDefinedNotNull(loc, this.modelMessages.E_PARAM_ISNULL_OR_UNDEFINED_3, ["locale", this.declaredClass, "removeDescription(locale)"]);
        if (loc) {
            // iterate the localized titles
            var descriptions = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(this.DESCRIPTION, this.xmlData, this.li_ns);
            if (descriptions && descriptions.length > 0) {
                var locale = this._normalizeLocale(loc);
                for (var i = descriptions.length; i > 0; i--) {
                    var desc = descriptions[i - 1];
                    var lang = this._getLang(desc);
                    if (lang !== null && this._normalizeLocale(lang) == locale) {
                        // remove description
                        dojo.destroy(desc);
                        break;
                    }
                }
                delete this._cache.descriptions[this._normalizeLocale(loc)];
                this._setDirty();
            }
        }
    },
    
    confirmRemoveDescription: function(loc){
        return this.hasRole(com.ibm.mashups.enabler.ac.RoleType.EDITOR);
    },
    
    removeDescriptions: function(){
        // iterate the localized descriptions
        var descriptions = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(this.DESCRIPTION, this.xmlData, this.li_ns);
        if (descriptions && descriptions.length > 0) {
            for (var i = descriptions.length; i > 0; i--) {
                // remove description
                dojo.destroy(descriptions[i - 1]);
            }
            this._cache.descriptions = {};
            this._setDirty();
        }
    },
    
    confirmRemoveDescriptions: function(){
        return this.hasRole(com.ibm.mashups.enabler.ac.RoleType.EDITOR);
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.catalog.CatalogCategoryNodeImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.catalog.CatalogCategoryNodeImpl"] = true;
dojo.provide("com.ibm.mm.enabler.catalog.CatalogCategoryNodeImpl");












dojo.declare("com.ibm.mm.enabler.catalog.CatalogCategoryNodeImpl", [com.ibm.mashups.enabler.catalog.CatalogCategoryNode, com.ibm.mm.enabler.persistence.xml.IdentifiableXmlImpl, com.ibm.mm.enabler.persistence.xml.LocalizedXmlImpl, com.ibm.mm.enabler.persistence.xml.DefaultLocalizedXmlImpl, com.ibm.mm.enabler.persistence.xml.EditLinkProviderXmlImpl, com.ibm.mm.enabler.TransformableImpl], {
    constructor: function(node) {
        this.xmlData = node;
        this.parentModel = null;
        
        // service document and initialization
        this.serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_CATALOG);
        var nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
        this.ns = nsf.getNameSpaces([nsf.NS_ATOM, nsf.NS_THR, nsf.NS_XML, nsf.NS_XSI, nsf.NS_XML, nsf.NS_OPENSEARCH]);
        for (var prefix in this.serviceJson.namespaces) {
            if (Object.prototype.hasOwnProperty.call(this.serviceJson.namespaces,prefix)) {
                this.ns[prefix] = this.serviceJson.namespaces[prefix];
            }
        }
    },
    
    getParentModel: function() {
        return this.parentModel;
    },
    
    setParentModel: function(parentModel) {
        this.parentModel = parentModel;
    },
    
    toString: function() {
        return com.ibm.mm.enabler.utils.Dom.innerXML(this.xmlData);
    }
});

}

if(!dojo._hasResource["com.ibm.mashups.enabler.catalog.CatalogCategoryNode"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.catalog.CatalogCategoryNode"] = true;
dojo.provide("com.ibm.mashups.enabler.catalog.CatalogCategoryNode");





}

if(!dojo._hasResource["com.ibm.mashups.enabler.catalog.CatalogEntryNode_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.catalog.CatalogEntryNode_API"] = true;
dojo.provide("com.ibm.mashups.enabler.catalog.CatalogEntryNode_API");
dojo.provide("com.ibm.mashups.enabler.catalog.CatalogEntryNode");

/**
 * Interface that represents a catalog entry; used in the CatalogEntryModel
 * 
 * @ibm-api
 * @ibm-module CatalogModel
 */
dojo.declare("com.ibm.mashups.enabler.catalog.CatalogEntryNode", [
		com.ibm.mashups.enabler.catalog.CatalogNode,
		com.ibm.mashups.enabler.ModifiableMetaData ], {
	/**
	 * Returns the definition URL of this catalog entry
	 * @param {Boolean} resolveEndpoints optional parameter to resolve endpoint:// urls.  Optional, default is true.
	 * @return {String} the definition url, never <code>null</code>
	 */
	getDefinitionURL : function(resolveEndpoints) {
	},

	/**
	 * Returns the icon URL of this catalog entry
	 * @param {Boolean} resolveEndpoints optional parameter to resolve endpoint:// urls.  Optional, default is true.
	 * @return {String} the icon url, never <code>null</code>
	 */
	getIconURL : function(resolveEndpoints) {
	},

	/**
	 * Returns the preview thumbnail URL for this catalog entry
	 * @param {Boolean} resolveEndpoints optional parameter to resolve endpoint:// urls.  Optional, default is true.
	 * @return {String} the preview thumbnail url, may be <code>null</code>
	 */
	getPreviewThumbnailURL : function(resolveEndpoints) {
	},

	/**
	 * Returns the preview URL for this catalog entry
	 * @param {Boolean} resolveEndpoints optional parameter to resolve endpoint:// urls.  Optional, default is true.
	 * @return {String} the preview url, may be <code>null</code>
	 */
	getPreviewURL : function(resolveEndpoints) {
	},

	/**
	 * Returns the help URL for this catalog entry
	 * @param {Boolean} resolveEndpoints optional parameter to resolve endpoint:// urls.  Optional, default is true.
	 * @return {String} the help url, may be <code>null</code>
	 */
	getHelpURL : function(resolveEndpoints) {
	},

	/**
	 * Sets the definition URL of this catalog entry
	 * @param {String} url definition url to set; must not be <code>null</code>
	 * @type void
	 */
	setDefinitionURL : function(url) {
	},

	/**
	 * Confirms whether setting the url is possible.
	 * @param {String} url definition url to set; must not be <code>null</code>
	 * @return {Boolean} true if the value can be set, otherwise false.
	 */
	confirmSetDefinitionURL : function(url) {
	},

	/**
	 * Sets the icon URL of this catalog entry
	 * @param {String} url icon url to set; must not be <code>null</code>
	 * @type void
	 */
	setIconURL : function(url) {
	},

	/**
	 * Confirms whether setting the url is possible.
	 * @param {String} url icon url to set; must not be <code>null</code>
	 * @return {Boolean} true if the value can be set, otherwise false.
	 */
	confirmSetIconURL : function(url) {
	},

	/**
	 * Sets the preview thumbnail URL of this catalog entry
	 * @param {String} url preview thumbnail url to set; may be <code>null</code>
	 * @type void
	 */
	setPreviewThumbnailURL : function(url) {
	},

	/**
	 * Confirms whether setting the url is possible.
	 * @param {String} url preview thumbnail url to set; may be <code>null</code>
	 * @return {Boolean} true if the value can be set, otherwise false.
	 */
	confirmSetPreviewThumbnailURL : function(url) {
	},

	/**
	 * Sets the preview URL of this catalog entry
	 * @param {String} url preview url to set; may be <code>null</code>
	 * @type void
	 */
	setPreviewURL : function(url) {
	},

	/**
	 * Confirms whether setting the url is possible.
	 * @param {String} url preview url to set; may be <code>null</code>
	 * @return {Boolean} true if the value can be set, otherwise false.
	 */
	confirmSetPreviewURL : function(url) {
	},

	/**
	 * Sets the help URL of this catalog entry
	 * @param {String} url help url to set; may be <code>null</code>
	 * @type void
	 */
	setHelpURL : function(url) {
	},

	/**
	 * Confirms whether setting the url is possible.
	 * @param {String} url help url to set; may be <code>null</code>
	 * @return {Boolean} true if the value can be set, otherwise false.
	 */
	confirmSetHelpURL : function(url) {
	},

	/**
	 * Returns the short description of this object in the given locale.
	 * @param {String} locale   the locale for which to retrieve the
	 * short description, must not be <code>null</code>.
	 * @return {String} the short description of this node in the given locale. If a
	 * short description is not available in the given locale, this method
	 * will return <code>null</code>. It is up to the invoker of the
	 * method to implement an appropriate fallback mechanism.
	 */
	getShortDescription : function(locale) {
	},

	/**
	 * Sets the short description for the given locale.
	 * @param {String} desc     short description to set; must not be <code>null</code>
	 * @param {String} locale   locale to set the short description for; must not be <code>null</code>
	 * @return {String} the former short description; if none existed, <code>null</code> is returned
	 */
	setShortDescription : function(desc, locale) {
	}
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.catalog.CatalogEntryNodeImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.catalog.CatalogEntryNodeImpl"] = true;
dojo.provide("com.ibm.mm.enabler.catalog.CatalogEntryNodeImpl");
















dojo.declare("com.ibm.mm.enabler.catalog.CatalogEntryNodeImpl", [com.ibm.mashups.enabler.catalog.CatalogEntryNode, com.ibm.mm.enabler.persistence.xml.IdentifiableXmlImpl, com.ibm.mm.enabler.persistence.xml.LocalizedXmlImpl, com.ibm.mm.enabler.persistence.xml.DefaultLocalizedXmlImpl, com.ibm.mm.enabler.MetaDataImpl2, com.ibm.mm.enabler.persistence.xml.EditLinkProviderXmlImpl, com.ibm.mm.enabler.ac.EffectiveAccessImpl, com.ibm.mm.enabler.TransformableImpl], {
    constructor: function(node) {
        this.xmlData = node;
        // service document and initialization
        this.serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_CATALOG);
        var nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
        this.ceni_ns = dojo.delegate(this.serviceJson.namespaces, nsf.getNameSpaces([nsf.NS_ATOM, nsf.NS_THR, nsf.NS_XML, nsf.NS_XSI, nsf.NS_XML, nsf.NS_OPENSEARCH]));
        
        this.NLS_SHORT_DESCRIPTION = "atom:content/*/model:shortDescription/base:nls-string";
        this.NLS_SHORT_DESCRIPTION_TOP = "atom:content/*/model:shortDescription";
        this.BASE_SHORT_DESCRIPTION = "base:nls-string";
        
    },
    
    getDefinitionURL: function(resolveEndpoints) {
        return this._getURL("definition", resolveEndpoints);
    },
    setDefinitionURL: function(aUrl) {
        this._setURL("definition", aUrl);
    },
    confirmSetDefinitionURL: function(aUrl) {
        return this.hasRole(com.ibm.mashups.enabler.ac.RoleType.EDITOR);
    },
    
    getIconURL: function(resolveEndpoints) {
        var iconUrl = this._getURL("icon", resolveEndpoints);
        return iconUrl;
    },
    setIconURL: function(aUrl) {
        this._setURL("icon", aUrl);
    },
    confirmSetIconURL: function(aUrl) {
        return this.hasRole(com.ibm.mashups.enabler.ac.RoleType.EDITOR);
    },
    
    getPreviewThumbnailURL: function(resolveEndpoints) {
        return this._getURL("previewThumbnail", resolveEndpoints);
    },
    setPreviewThumbnailURL: function(aUrl) {
        this._setURL("previewThumbnail", aUrl);
    },
    confirmSetPreviewThumbnailURL: function(aUrl) {
        return this.hasRole(com.ibm.mashups.enabler.ac.RoleType.EDITOR);
    },
    
    getPreviewURL: function(resolveEndpoints) {
        var pUrl = this._getURL("preview", resolveEndpoints);
        return pUrl;
    },
    
    setPreviewURL: function(aUrl) {
        this._setURL("preview", aUrl);
    },
    confirmSetPreviewURL: function(aUrl) {
        return this.hasRole(com.ibm.mashups.enabler.ac.RoleType.EDITOR);
    },
    
    getHelpURL: function(resolveEndpoints) {
        var hUrl = this._getURL("help", resolveEndpoints);
        return hUrl;
    },
    
    setHelpURL: function(aUrl) {
        this._setURL("help", aUrl);
    },
    confirmSetHelpURL: function(aUrl) {
        return this.hasRole(com.ibm.mashups.enabler.ac.RoleType.EDITOR);
    },
    
    getShortDescription: function(locale) {
        var result = null;
        var nloc = locale.replace(/_/g, "-").toLowerCase();
        var descriptions = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(this.NLS_SHORT_DESCRIPTION, this.xmlData, this.li_ns);
        if (descriptions) {
            for (var i = 0; i < descriptions.length; i++) {
                var lang = com.ibm.mm.enabler.utils.Dom.getAttributeWithNS(descriptions[i], "xml:lang", "lang", com.ibm.mm.enabler.model.NameSpaceFactory.getNameSpaceUri("xml"));
                if (lang !== null && lang.replace(/_/g, "-").toLowerCase() == nloc) {
                    result = com.ibm.mm.enabler.utils.Dom.textContent(descriptions[i]);
                    break;
                }
            }
        }
        return result;
    },
    setShortDescription: function(descr, locale) {
        locale.replace(/-/g, "_");
        var descriptions = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(this.NLS_SHORT_DESCRIPTION, this.xmlData, this.li_ns);
        // iterate the localized titles (selecting the correct title via xpath doesnt seem to work)
        var localeExists = false;
        var i = descriptions.length;
        while (--i >= 0) {
            var lang = com.ibm.mm.enabler.utils.Dom.getAttributeWithNS(descriptions[i], "xml:lang", "lang", com.ibm.mm.enabler.model.NameSpaceFactory.getNameSpaceUri("xml"));
            if (lang !== null && lang.replace(/-/g, "_") == locale) {
                com.ibm.mm.enabler.utils.Dom.textContent(descriptions[i], descr);
                localeExists = true;
                break;
            }
        }
        
        // create locale
        if (!localeExists) {
            var descriptionBase = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(this.NLS_SHORT_DESCRIPTION_TOP, this.xmlData, this.li_ns);
            if (descriptionBase) {
                var xmlDom = this.xmlData.ownerDocument;
                var node = com.ibm.mm.enabler.utils.Dom.createElement(xmlDom, this.BASE_SHORT_DESCRIPTION, this.BASE_NS);
                node.setAttribute("xml:lang", locale);
                com.ibm.mm.enabler.utils.Dom.textContent(node, descr);
                descriptionBase.appendChild(node);
            }
            else {
                throw new Error(dojo.string.substitute(this.modelMessages.E_ELEMENT_NOT_FOUND_2, [this.NLS_SHORT_DESCRIPTION_TOP, this.toString()]));
            }
        }
        this._setDirty();
    },
    confirmSetShortDescription: function(descr, locale) {
        return this.hasRole(com.ibm.mashups.enabler.ac.RoleType.EDITOR);
    },
    
    _getURL: function(/*String*/rel, /*boolean*/ resolveEndpoints) {
        var result = null;
        var expr = "atom:content/model:catalog-entry/atom:link[@ext:rel='" + rel + "']";
        var nodes = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, this.xmlData, this.ceni_ns);
        if (nodes) {
            result = nodes.getAttribute("href");
            var newURL = new com.ibm.mm.enabler.utils.HttpUrl(result, resolveEndpoints);
            result = (newURL._absoluteURL ? newURL.toString(true) : result) || result;
        }
        var ret = result;
        if (resolveEndpoints !== false) {
            var ret2 = com.ibm.mm.enabler.EndpointUtils.checkForEndpoints(result);
            ret2 = ret2 || null;
            if (ret2 !== null) {
                ret = ret2;
            }
        }
        return ret;
    },
    
    _setURL: function(/*String*/rel, /*String*/ href) {
        var expr = "atom:content/model:catalog-entry/atom:link[@ext:rel='" + rel + "']";
        var nodes = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, this.xmlData, this.ceni_ns);
        if (nodes) {
            var newURL = new com.ibm.mm.enabler.utils.HttpUrl(href, false);
            var url = (newURL._absoluteURL ? newURL.toString() : newURL.toServerRelativeString(true)) || href;
            nodes.setAttribute("href", url);
            this._setDirty();
        }
    },
    
    toString: function() {
        return com.ibm.mm.enabler.utils.Dom.innerXML(this.xmlData);
    }
});

}

if(!dojo._hasResource["com.ibm.mashups.enabler.catalog.CatalogEntryNode"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.catalog.CatalogEntryNode"] = true;
dojo.provide("com.ibm.mashups.enabler.catalog.CatalogEntryNode");







}

if(!dojo._hasResource["com.ibm.mashups.enabler.layout.LayoutNode_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.layout.LayoutNode_API"] = true;
dojo.provide("com.ibm.mashups.enabler.layout.LayoutNode_API");
dojo.provide("com.ibm.mashups.enabler.layout.LayoutNode");





/**
 * Base interface for layout elements.
 *
 * @ibm-api
 * @ibm-module LayoutModel
 */
dojo.declare("com.ibm.mashups.enabler.layout.LayoutNode", [com.ibm.mashups.enabler.Transformable, com.ibm.mashups.enabler.ModifiableMetaData, com.ibm.mashups.enabler.Identifiable], {
	/**
	 * Returns the type of this layout node as defined in {@link com.ibm.mashups.enabler.layout.Constants Constants}.
	 * @return {String} type of this layout node  
	 */
	getLayoutNodeType : function() {
        throw new Error('Unimplemented API: com.ibm.mashups.enabler.layout.LayoutNode.getLayoutNodeType');
	}
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.layout.LayoutNodeImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.layout.LayoutNodeImpl"] = true;
dojo.provide("com.ibm.mm.enabler.layout.LayoutNodeImpl");










dojo.declare("com.ibm.mm.enabler.layout.LayoutNodeImpl", [
	com.ibm.mashups.enabler.layout.LayoutNode,
	com.ibm.mm.enabler.persistence.xml.IdentifiableXmlImpl,
	com.ibm.mm.enabler.TransformableImpl,
	com.ibm.mm.enabler.MetaDataImpl2,
	com.ibm.mm.enabler.persistence.xml.EditLinkProviderXmlImpl,
	com.ibm.mm.enabler.ac.EffectiveAccessImpl], 
{
	constructor : function(node, _layoutModel) {
		this.setXml(node,true);
		this.layoutModel = _layoutModel;
	},

	_getLayoutModel : function() {
		return this.layoutModel;
	},
	
    getLayoutNodeType : function() {
    	return this._type;
    },

	toString : function() {
		return com.ibm.mm.enabler.utils.Dom.innerXML(this.xmlData);
	}
});

}

if(!dojo._hasResource["com.ibm.mashups.enabler.layout.LayoutNode"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.layout.LayoutNode"] = true;
dojo.provide("com.ibm.mashups.enabler.layout.LayoutNode");





}

if(!dojo._hasResource["com.ibm.mashups.enabler.layout.LayoutContainer_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.layout.LayoutContainer_API"] = true;
dojo.provide("com.ibm.mashups.enabler.layout.LayoutContainer_API");
dojo.provide("com.ibm.mashups.enabler.layout.LayoutContainer");




/**
 * This interface represents a container.
 *
 * @since 2.4
 *
 * @ibm-api
 * @ibm-module LayoutModel
 */
dojo.declare("com.ibm.mashups.enabler.layout.LayoutContainer", [com.ibm.mashups.enabler.layout.LayoutNode, com.ibm.mashups.enabler.content.RuntimeContentProvider], {
    
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.DeferredSetImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.DeferredSetImpl"] = true;
dojo.provide("com.ibm.mm.enabler.DeferredSetImpl");





dojo.declare("com.ibm.mm.enabler.DeferredSetImpl",com.ibm.mm.enabler.DeferredImpl, {
  
  _deferreds: null,
  _returns: null,
  _started: false,
  _status: com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK,
  
  constructor: function() {
    this._deferreds   = new dojox.collections.ArrayList();
    this._returns     = new dojox.collections.ArrayList();
  },
  
  addDeferred: function(deferred) {
      if(this._started) {
          throw new Error();
      }
      var currentCallback = deferred.getFinishedCallback();
      var currentParameters = deferred.getFinishedCallbackParameters();

      deferred.setFinishedCallback(dojo.hitch(this,'_return'),{
          adtlCallback: currentCallback,
          adtlParameters: currentParameters,
          deferred: deferred
      });
      
      this._deferreds.add(deferred);
  },
  
  _return: function(resource, status, args) {
      var adtlCallback = args.adtlCallback;
      var adtlParameters = args.adtlParameters;
      var deferred = args.deferred;
      
      if(adtlCallback) {
          adtlCallback(resource, status, adtlParameters);
      }
      
      this._status = Math.max(this._status, status);
      
      this._returns.add({
          deferred: deferred,
          result: resource,
          status: status
      });
      
//      console.debug("return", this._returns.count , "of", this._deferreds.count );
      
      if(this._deferreds.count == this._returns.count) {
          this._finish();
      }
  },
  
  _finish: function() {
      var finishedCallback = this.getFinishedCallback();
      if(finishedCallback) {
          finishedCallback(this._returns, this._status ,this.getFinishedCallbackParameters());
      }
  },
  
  start: function(sync) {
      if (!this._started) {
          this._started = true;
          this.inherited(arguments);
          sync = (sync || typeof(sync) == 'undefined');
          if (this._deferreds.count > 0) {
              this._deferreds.forEach(function(deferred){
                  deferred.start(sync);
              }, this);
          } else {
              this._finish();
          }
      }
  }
  
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.DeferredSet"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.DeferredSet"] = true;
dojo.provide("com.ibm.mm.enabler.DeferredSet");



dojo.declare("com.ibm.mm.enabler.DeferredSet",com.ibm.mm.enabler.DeferredSetImpl, {
    
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.layout.LayoutContainerImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.layout.LayoutContainerImpl"] = true;
dojo.provide("com.ibm.mm.enabler.layout.LayoutContainerImpl");

// APIs




// Implementations








dojo.declare("com.ibm.mm.enabler.layout.LayoutContainerImpl",[com.ibm.mashups.enabler.layout.LayoutContainer, com.ibm.mm.enabler.layout.LayoutNodeImpl, com.ibm.mashups.enabler.content.RuntimeContentProvider], {

    constructor: function() {
    	// node type
    	this._type = com.ibm.mashups.enabler.layout.Constants.LAYOUT_CONTAINER;        
	},
    
    _getContent: function() {
        return this._getLayoutModel()._getNavigationNode().getContent().start(true);
    },
    
    _templates: {
    	baseMarkup:	dojo.string.trim(dojo.cache("com.ibm.mm.enabler.layout", "templates/LayoutContainerFragment.html", "<div class=\"component-container ${containerClass} id-${containerId}\" name=\"${containerName}\">\n    ${childrenMarkup}\n</div>\n")) // trim is needed because of a bug in dojo.place (markup must not have leading or trailing whitespaces
    },

	// layoutContainerFragment: function

	getRuntimeContent: function() {
		return new com.ibm.mm.enabler.content.RuntimeContentImpl(this,this._getRuntimeMarkup);
	},
    
    _templateFunc: function(deferred, sync, innerMarkup) {
        var ret = null;
        
        var cClass = this.getMetaData("css-classes");
        var cName  = this.getMetaData("com.ibm.portal.layoutnode.localname");
        
        ret = dojo.string.substitute(this._templates.baseMarkup, {
            containerClass : cClass || "",
            containerId: com.ibm.mm.enabler.utils.Utils.getIdFromIdentifiable(this),
            containerName: cName || "",        
            childrenMarkup: innerMarkup || ""
        });    
        
        if(deferred) { deferred.finish(ret, com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK); }
   
        return ret;                        
    },    
    
    _getRuntimeMarkup: function(deferred, sync) {
        var chain = new com.ibm.mm.enabler.DeferredSet();
        if(this._getLayoutModel().hasChildren(this)) {
            var children = this._getLayoutModel().getChildren(this);
            
            while(children.hasNext()) {
                var child = children.next();
                //if(com.ibm.mm.enabler.utils.Misc.isInstanceOf(child,com.ibm.mashups.enabler.layout.LayoutControl)) {
                    var childDeferred = child.getRuntimeContent().getRuntimeMarkup();
                    chain.addDeferred(childDeferred);
                //}
            }
        }            
        
        var ret = null;
        chain.setFinishedCallback(dojo.hitch(this,function(results, status, args) {
            var deferred = args.origDf;
            if(status == com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK) {
                var markup = [];
                results.forEach(function(item,idx,arr) {
                    this.push(item.result);
                },markup);
                
                ret = this._templateFunc(deferred,sync,markup.join("\n"));
            } else if(deferred) {
                deferred.finish(null,status);
            }
            return ret;
            
        }), {origDf: deferred});
        chain.start(sync);
        return ret;
    },
    
    getLayoutNodeType : function() {
    	return this._type;
    }
});

}

if(!dojo._hasResource["com.ibm.mashups.enabler.layout.LayoutContainer"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.layout.LayoutContainer"] = true;
dojo.provide("com.ibm.mashups.enabler.layout.LayoutContainer");





}

if(!dojo._hasResource["com.ibm.mashups.enabler.layout.LayoutControl_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.layout.LayoutControl_API"] = true;
dojo.provide("com.ibm.mashups.enabler.layout.LayoutControl_API");
dojo.provide("com.ibm.mashups.enabler.layout.LayoutControl");





/**
 * Interface for a control. A control holds a widget by referencing its instance.
 *
 * @since 2.4
 *
 * @ibm-api
 * @ibm-module LayoutModel
 */
dojo.declare("com.ibm.mashups.enabler.layout.LayoutControl", [com.ibm.mashups.enabler.layout.LayoutNode, com.ibm.mashups.enabler.ModifiableLocalized, com.ibm.mashups.enabler.content.RuntimeContentProvider], {

    /**
     * Returns the skin used by this control.
     * @return {com.ibm.mashups.enabler.Identifiable} id of the skin, or
     * <code>null</code> if no skin is defined for this control.
     */
    getSkin: function(){
        throw new Error('Unimplemented API: com.ibm.mashups.enabler.layout.LayoutControl.getSkin');
    },
    
    /**
     * Sets the skin to be used by this control.
     * @param {com.ibm.mashups.enabler.Identifiable} id id of the skin to set
     * @return {void}
     */
    setSkin: function(id){
        throw new Error('Unimplemented API: com.ibm.mashups.enabler.layout.LayoutControl.setSkin');
    },
     
    /**
     * Returns the widget body markup (w/o Skin)
     * 
     * @since 3.0
     * @ibm-spi
     */
    getWidgetBody: function() {
    	
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.layout.SkinIdentifiable"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.layout.SkinIdentifiable"] = true;


dojo.provide("com.ibm.mm.enabler.layout.SkinIdentifiable");

dojo.declare("com.ibm.mm.enabler.layout.SkinIdentifiable",com.ibm.mm.enabler.IdentifierImpl,{
    
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.layout.LayoutControlImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.layout.LayoutControlImpl"] = true;
dojo.provide("com.ibm.mm.enabler.layout.LayoutControlImpl");




















// TODO lazyload
//dojo..require("com.ibm.mashups.enabler.widget.Factory");










dojo.declare("com.ibm.mm.enabler.layout.LayoutControlImpl",[
	com.ibm.mashups.enabler.layout.LayoutControl,
	com.ibm.mm.enabler.layout.LayoutNodeImpl,
    com.ibm.mashups.enabler.content.RuntimeContentProvider,
	com.ibm.mm.enabler.persistence.xml.LocalizedXmlImpl],{
        
    _skins: new dojox.collections.Dictionary(),
    configService: null,
    
    // class member, NOT instance member
    _cachedSkinData: {},
    
    _templates: {
    	widgetFragment: 		dojo.cache("com.ibm.mm.enabler.layout.widget", "templates/WidgetFragment.html", "<div class=\"${css.iwWidget}\" id=\"${instanceID}\" sandbox=\"${sandboxEnabled}\">\n    <a class=\"${css.iwDefinition}\" href=\"${widgetDefinitionURI}\"></a>\n      ${eventDescriptions}\n      ${events}\n      ${itemSets}\n      ${receivedEvents}\n</div>\n"),
    	valueFragment:  		dojo.cache("com.ibm.mm.enabler.layout.widget", "templates/ValueFragment.html", "<span class=\"${css.iwValue}\" lang=\"${loc}\">${val}</span>\n"),
    	eventDescFragment:		dojo.cache("com.ibm.mm.enabler.layout.widget", "templates/EventDescriptionFragment.html", "  <span class=\"${css.iwEventDescription}\" title=\"${eventDescName}\">\n    <span class=\"${css.iwPayloadType}\">${payloadType}</span>\n    <span class=\"${css.iwDescription}\">\n      ${descriptions}\n    </span>\n    <span class=\"${css.iwTitle}\">\n      ${titles}\n    </span>\n  </span>\n"),
    	mappedNameFragment: 	dojo.cache("com.ibm.mm.enabler.layout.widget", "templates/MappedNameFragment.html", "<span class=\"${name}\">${value}</span>\n"),
    	eventFragment: 			dojo.cache("com.ibm.mm.enabler.layout.widget", "templates/EventFragment.html", "<span class=\"${css.iwEvent} ${additionalClasses}\" title=\"${eventName}\">\n    <a class=\"${css.iwDescRef}\" href=\"#${eventDescName}\"></a>\n    ${mappedName}\n</span>\n"),
        itemSetFragment:		dojo.cache("com.ibm.mm.enabler.layout.widget", "templates/ItemSetFragment.html", "<span class=\"${css.iwItemSet}\" title=\"${setName}\">\n    ${items}\n</span>\n"),
		receivedEventFragment:	dojo.cache("com.ibm.mm.enabler.layout.widget", "templates/ReceivedEventFragment.html", "<span class=\"${css.iwReceivedEvent}\">\n    <a class=\"${css.iwSourceEvent}\" href=\"#${sourceWidgetID}\">${sourceEventName}</a>\n    <span class=\"${css.iwTargetEvent}\">${targetEventName}</span>\n</span>\n"),
		itemSetItemFragment:	dojo.cache("com.ibm.mm.enabler.layout.widget", "templates/ItemSetItemFragment.html", "<a class=\"${css.iwItem}${readOnly}\" href=\"#${itemName}\">${itemValue}</a>\n"),     	
		gadgetFragment:			dojo.cache("com.ibm.mm.enabler.layout.gadget", "templates/GadgetFragment.html", "<div class=\"${css.iwOSGadget}\" id=\"${instanceID}\" style=\"overflow: auto; position: relative; width: 100%; height: 100%;\">\n    <a class=\"${css.iwDefinition}\" href=\"${gadgetDefinitionURI}\"></a>\n      ${itemSets}\n</div>\n"),
		baseMarkup:				dojo.string.trim(dojo.cache("com.ibm.mm.enabler.layout", "templates/LayoutControlFragment.html", "<div class=\"component-control id-${controlId}\" style=\"${cssStyle}\">\n    ${skinMarkup}\n</div>\n")) // trim is needed because of a bug in dojo.place (markup must not have leading or trailing whitespaces    	
    },
    
    constructor: function() {
        var serviceCollection = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_CONTENT);

		// define namespaces
		this.ns = dojo.delegate(serviceCollection.namespaces,
                            com.ibm.mm.enabler.model.NameSpaceFactory.getNameSpaces([
							com.ibm.mm.enabler.model.NameSpaceFactory.NS_ATOM
                            ]));
                            
        this.id_prefix = serviceCollection.idprefix;
        
        this.configService = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);

        // node type
        this._type = com.ibm.mashups.enabler.layout.Constants.LAYOUT_CONTROL;        

        this._displayTitle = null;
    },    
    
    _getDisplayTitle: function() {
        return this._displayTitle;
    },

    _setDisplayTitle: function(displayTitle) {
        this._displayTitle = displayTitle;
    },

    _getWidgetFragment: function(wWindow, widgetDefinitionURI, sandboxEnabled, eventDescriptions, events, itemSets, receivedEvents) {
        return dojo.string.substitute(this._templates.widgetFragment,{
            css: com.ibm.mm.iwidget.Constants.CSSCLASS_PREFIXED_INSTANCE,
            instanceID: com.ibm.mm.iwidget.Utils.getMarkupID(wWindow.getID()),
            sandboxEnabled: !!sandboxEnabled,
            widgetDefinitionURI: widgetDefinitionURI || "",
            eventDescriptions: eventDescriptions || "",
            events: events || "",
            itemSets: itemSets || "",
            receivedEvents: receivedEvents || ""
        });
        
    },
    
    _getValueFragment: function(locale, value) {
        var ret = dojo.string.substitute(this._templates.valueFragment,{
            css: com.ibm.mm.iwidget.Constants.CSSCLASS_PREFIXED_INSTANCE,
            loc: locale || "",
            val: value || ""
        });
        return ret;
    },
    
    _getEventDescriptionFragment: function(eventDescName, payloadType, descriptions, titles) {
        return dojo.string.substitute(this._templates.eventDescFragment,{
            css: com.ibm.mm.iwidget.Constants.CSSCLASS_PREFIXED_INSTANCE,
            eventDescName: eventDescName || "",
            payloadType: payloadType || "",
            descriptions: descriptions || "",
            titles: titles || ""
        });
    },
    
    _eventDescSuffix: '_desc', 
    
    _getEventDescriptions: function(eventProvider) {
        var filter = {};
        
        return dojo.map(eventProvider.getEvents(filter) || [],function(event) {
            var titles = [];
            var descriptions = [];
            dojo.forEach(event.getLocales() || [],function(locale) {
                titles.push(this._getValueFragment(locale,event.getTitle(locale)));
                descriptions.push(this._getValueFragment(locale,event.getDescription(locale)));
            },this);
            return this._getEventDescriptionFragment(event.getName()+this._eventDescSuffix, event.getPayloadType(), descriptions.join("\n"), titles.join("\n"));
        },this);
    },
    
    _getMappedNameFragment: function(mappedNameArray) {
        var ret = "";
        dojo.forEach(mappedNameArray, function(item, idx, arr) {
            var temp = dojo.string.substitute(this._templates.mappedNameFragment,{
                name: item.name,
                value: item.value
            });
            ret = ret + temp;
        }, this);
        return ret;
    },
    
    _getEventFragment: function(event, wrapper) {
        // TODO: get this from somewhere off the event
        var mappedName = [];
        
        var classes = [];
        if(event.isPublished()) {
            classes.push(com.ibm.mm.iwidget.Constants.CSSCLASS_PREFIXED_INSTANCE.iwPublished);
        }
        if(event.isHandled()) {
            classes.push(com.ibm.mm.iwidget.Constants.CSSCLASS_PREFIXED_INSTANCE.iwHandled);
        }
        
        if (wrapper) {
            var runtimeEvent = wrapper.getPublicEvent(event.getName());
            if (runtimeEvent) {
                if (runtimeEvent.handlingFn) {
                    if (!dojo.isFunction(runtimeEvent.handlingFn)) {
                        mappedName.push({ name: "iw-Handler", value: runtimeEvent.handlingFn});
                    }
                }
                if (runtimeEvent.getOnRemoveWire()) {
                    mappedName.push({ name: "iw-Remove-Wire", value: runtimeEvent.getOnRemoveWire()});
                }
                if (runtimeEvent.getOnNewWire()) {
                    mappedName.push({ name: "iw-New-Wire", value: runtimeEvent.getOnNewWire()});
                }
            }
        }
        
        var evtName = event.getName();
        return dojo.string.substitute(this._templates.eventFragment,{
            css: com.ibm.mm.iwidget.Constants.CSSCLASS_PREFIXED_INSTANCE,
            additionalClasses: classes.join(" "),
            eventName: evtName,
            eventDescName: evtName+this._eventDescSuffix,
            mappedName: this._getMappedNameFragment(mappedName) || ""
        });
    },
    
    _getEvents: function(eventProvider, wrapper) {
        var filter = {};
        //return dojo.map(eventProvider.getEvents(filter) || [],this._getEventFragment,this);
        return dojo.map(eventProvider.getEvents(filter) || [], 
            function(item) { 
                return this._getEventFragment(item, wrapper);
            },this);
    },
    
    _getReceivedEventFragment: function(wire) {
        return dojo.string.substitute(this._templates.receivedEventFragment,{
            css: com.ibm.mm.iwidget.Constants.CSSCLASS_PREFIXED_INSTANCE,
            sourceWidgetID: wire.getSourceWidget().getID(),
            sourceEventName: wire.getSourceEventName(),
            targetEventName: wire.getTargetEventName()
        });     
    },
    
    _getReceivedEvents: function(wWindow) {
        return dojo.map(this._getLayoutModel().getWireModel().findByTargetWidget(wWindow).start(), function(wire) {
            return this._getReceivedEventFragment(wire);
        },this);
        
//        Legacy code
//        TODO: optimize this by making a direct search for wires to a specific control
//        var events = [];
//        var wireIt = this._getLayoutModel().getWireModel().iterator();
//        while(wireIt.hasNext()) {
//            var wire = wireIt.next();
//            if(wire.getTargetWidget().equals(wWindow)) {
//                // wire targets current control
//                events.push(this._getReceivedEventFragment(wire));
//            }
//        }
//        return events;
    },
    
    
    _getItemSetItemFragment: function(name, values, readOnly) {
        return dojo.string.substitute(this._templates.itemSetItemFragment, {
            css: com.ibm.mm.iwidget.Constants.CSSCLASS_PREFIXED_INSTANCE,
            readOnly: readOnly ? " "+com.ibm.mm.iwidget.Constants.CSSCLASS_PREFIXED_INSTANCE.iwReadOnly : "",
            itemName: name || "",
            itemValue: (dojo.isArray(values) && values.length === 1) ? dojox.html.entities.encode(values[0]) : dojo.toJson(values) || ""
        });
    },
    
    
    _getItemSetFragment: function(preferences) {
        
        var items = dojo.map(preferences.getNames() || [],function(name) {
            return this._getItemSetItemFragment(name,preferences.getValues(name),preferences.isReadOnly(name));
        },this);
        
        return dojo.string.substitute(this._templates.itemSetFragment, {
            css: com.ibm.mm.iwidget.Constants.CSSCLASS_PREFIXED_INSTANCE,
            setName: "attributes",
            items: items.join("\n")
        });
    },
    
    getWidgetBody: function() {
    	return this._getWidgetBody();
    },
    
    _getWidgetBody: function() {
        
        return new com.ibm.mm.enabler.DeferredImpl(this,function(deferred,sync) {
            
            var wm = com.ibm.mashups.enabler.widget.Factory.getWidgetModel();
            var windowDef = wm.getWidgetWindow(this);
           
            windowDef.setFinishedCallback(dojo.hitch(this,function(wWindow,status,args) {
                var deferred = args.deferred;
                var sync = args.sync;
                var wm = args.wm;
                var ret = null;
                if(status == com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK && wWindow) {
                    var defSet = new com.ibm.mm.enabler.DeferredSetImpl();
                    
                    defSet.addDeferred(wm.getHierarchicalPreferences(wWindow));
                    //defSet.addDeferred(wm.getHierarchicalEventProvider(wWindow));
                    
                    defSet.setFinishedCallback(dojo.hitch(this,function(results,status,args) {
                        var deferred = args.deferred;
                        var wWindow = args.wWindow;
                        var wm = args.wm;
                        var ret = null;
                        
                        if(status == com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK) {
                            
                            var prefs = results.item(0).result;
                            //var eventProvider = results.item(1).result;
                            var widgetInstance = wm.getWidgetInstance(wWindow).start(true);
                            var eventProvider = widgetInstance;
                            
                            var runtimeWidgetModel = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel();
                            var wrapper = runtimeWidgetModel.find(wWindow.getID());

                            var eventDescriptions = this._getEventDescriptions(eventProvider);
                            var events = this._getEvents(eventProvider, wrapper);
                            var itemSets = this._getItemSetFragment(prefs);
                            var receivedEvents = this._getReceivedEvents(wWindow);
                            var widgetDefinition = wm.getWidgetDefinitionByWindow(wWindow).start(true);

                            ret = this._getWidgetFragment(  wWindow,
                                                            widgetDefinition.getURL(),
                                                            widgetDefinition._isSandboxed() || widgetInstance.isSandboxed(),  // most-secure wins; can be sandboxed in either widget definition or in server/hub
                                                            eventDescriptions.join("\n"),
                                                            events.join("\n"),
                                                            itemSets,
                                                            receivedEvents.join("\n"));
                        }
                        
                        if(deferred) { deferred.finish(ret,ret ? com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK : com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_NOT_FOUND); }
                        return ret;
                    }),{
                        deferred: deferred,
                        wWindow: wWindow,
                        wm: wm
                        });
                    
                    ret = defSet.start(sync);
                } else {
                    if(deferred) { deferred.finish(ret,com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_NOT_FOUND); }
                }
                return ret;
                
            }),{
                deferred: deferred,
                sync: sync,
                wm: wm
            });
            
            var ret = windowDef.start(sync);
            return ret;
        });        
    },
    _getOpenSocialGadgetBody: function() {        
	        return new com.ibm.mm.enabler.DeferredImpl(this,function(deferred,sync){            
            var wm = com.ibm.mashups.enabler.widget.Factory.getWidgetModel();
            var windowDef = wm.getWidgetWindow(this);
			
            windowDef.setFinishedCallback(dojo.hitch(this,function(wWindow,status,args) {
                var deferred = args.deferred;
                var sync = args.sync;
                var wm = args.wm;
                var ret = null;
				
				// if gadget exists and it is pubsub2 (OAHub managed), remove its iframe first 
				com.ibm.mm.enabler.opensocial.OpenSocial.removeGadgetInstance(wWindow.getID());
				
                if(status == com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK && wWindow) {
                    var defSet = new com.ibm.mm.enabler.DeferredSetImpl();
                    
                    defSet.addDeferred(wm.getHierarchicalPreferences(wWindow));
                    
                    defSet.setFinishedCallback(dojo.hitch(this,function(results,status,args) {
                        var deferred = args.deferred;
                        var wWindow = args.wWindow;
                        var wm = args.wm;
                        var ret = null;
                        
                        if(status == com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK) {
                            
                            var prefs = results.item(0).result;
                            
                            var itemSets = this._getItemSetFragment(prefs);
                            var widgetInstance = wm.getWidgetInstance(wWindow).start(true);
                            var gadgetDefinition = wm.getWidgetDefinitionByWindow(wWindow).start(true);

                            ret = this._getGadgetFragment(  wWindow,
                                                            gadgetDefinition.getURL(),
                                                            itemSets);
                        }
                        
                        if(deferred) { deferred.finish(ret,ret ? com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK : com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_NOT_FOUND); }
                        return ret;
                    }),{
                        deferred: deferred,
                        wWindow: wWindow,
                        wm: wm
                        });
                    
                    ret = defSet.start(sync);
                } else {
                    if(deferred) { deferred.finish(ret,com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_NOT_FOUND); }
                }
                return ret;
                
            }),{
                deferred: deferred,
                sync: sync,
                wm: wm
            });
            
            var ret = windowDef.start(sync);
            return ret;
        });        
    },
    _getGadgetFragment: function(wWindow, gadgetDefinitionURI, itemSets) {
    	
        return dojo.string.substitute(this._templates.gadgetFragment,{
            css: com.ibm.mm.iwidget.Constants.CSSCLASS_PREFIXED_INSTANCE,
            instanceID: com.ibm.mm.iwidget.Utils.getMarkupID(wWindow.getID()),
            gadgetDefinitionURI: gadgetDefinitionURI || "",
            itemSets: itemSets || ""
			});        
    },    
    _getGenericWidgetURI: function() {
        return this.configService.getValue(com.ibm.mashups.enabler.services.ConfigConstants.NON_PREVIEWABLE_WIDGET_LOCATION) || dojo.moduleUrl("com.ibm.mm.enabler.layout.widget","NonPreviewableContentWidget.xml").toString();
    },    
    _getGenericWidgetBody: function() {
        return new com.ibm.mm.enabler.DeferredImpl(this,function(deferred,sync) {
            
            var wm = com.ibm.mashups.enabler.widget.Factory.getWidgetModel();
            var windowDef = wm.getWidgetWindow(this);
           
            windowDef.setFinishedCallback(dojo.hitch(this,function(wWindow,status,args) {
                var deferred = args.deferred;
                var sync = args.sync;
                var ret = null;
                if (status == com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK && wWindow) {
                    ret = this._getWidgetFragment(wWindow, this._getGenericWidgetURI());
                }
                
                if(deferred) { deferred.finish(ret,ret ? com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK : com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_NOT_FOUND); }
                return ret;                          
            }),{
                deferred: deferred,
                sync: sync
            });
            
            var ret = windowDef.start(sync);
            return ret;                    
        });
    },    
    
    /**
     * to be overwritten/extended by products.
     */
    replaceControl: function(skinData, widgetBody) {
        //  <a rel="dynamic-content" href="lm:control"></a> 
        return skinData.replace(com.ibm.mm.enabler.layout.LayoutControlImpl.REGEX_CONTROL,widgetBody);
    },
    
    /**
     * to be overwritten/extended by products.
     */
    replaceTitle: function(skinData, title) {
        // <a rel="dynamic-content" href="lm:title"></a>
        return skinData.replace(com.ibm.mm.enabler.layout.LayoutControlImpl.REGEX_TITLE,title);
    },    
    
    _templateFunc: function(deferred, sync, skinData) {
        // checks if it is an iwidget or a gadget to be previewed
        var isGadget = false;
		var isManaged = false;
        if (deferred.context) {
            var widgetDef  = null;
            var wm = com.ibm.mashups.enabler.widget.Factory.getWidgetModel();
            var widgetWindow = wm.getWidgetWindow(deferred.context).start();
            widgetDef = wm.getWidgetDefinitionByWindow(widgetWindow).start(true);
            if (widgetDef && dojo.isFunction(widgetDef.getType) && widgetDef.getType()) {
               isGadget = (widgetDef.getType() == com.ibm.mm.iwidget.Constants.OSGADGET_DEFINITION_TYPE);
            }
		    if (com.ibm.mashups.enabler.services.IdentificationService.isServerID(widgetWindow.getID())) {
				// we actually CAN render gadgets once they are managed
				isManaged = true;
		    }
        } 
        
        var def;
        if (dojo.isString(skinData) && !this.configService.getValue(com.ibm.mashups.enabler.services.ConfigConstants.NON_PREVIEWABLE_WIDGET_LOCATION) && !isGadget) {
            def = this._getWidgetBody();
        } else if (isGadget && isManaged) {  // renders the gadget content if it is already "managed"
            def = this._getOpenSocialGadgetBody();
        } else {
            def = this._getGenericWidgetBody();
        }
        
        def.setFinishedCallback(dojo.hitch(this,function(resource,status,args) {
            var skinData = args.skinData;
            var deferred = args.deferred;
            var ret = null;
            
            if(dojo.isString(skinData) && !this.configService.getValue(com.ibm.mashups.enabler.services.ConfigConstants.NON_PREVIEWABLE_WIDGET_LOCATION)) {
                skinData = this.replaceControl(skinData, resource);
                
                var lContext = com.ibm.mashups.enabler.context.Factory.getLocalizedContext();
                var title = lContext.getTitle(this);
                if ((title===null) || (typeof title == "undefined")) {
                    if (widgetDef!==null) {
                        title = lContext.getTitle(widgetDef);
                    }
                    // we should not rely on the display title anymore
                    //title = this._getDisplayTitle();
                    if ((title===null) || (typeof title == "undefined")) {
                        title = ""; // do not display null
                    }
                }
                skinData = this.replaceTitle(skinData, title);
            } else {
                // generate default generic widget markup
                skinData = resource;
            }
            
            ret = dojo.string.substitute(this._templates.baseMarkup, {
                controlId: com.ibm.mm.enabler.utils.Utils.getIdFromIdentifiable(this),
                cssStyle: this.getMetaData("css-style") || "",
                skinMarkup: skinData
            });
            
            if(deferred) { deferred.finish(ret, com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK); }
    
            return ret;            
        }),{
            deferred: deferred,
            skinData: skinData
        });
        
        return def;
    },
    
    getRuntimeContent: function() {
        return new com.ibm.mm.enabler.content.RuntimeContentImpl(this,function(deferred, sync) {
            var self = this;
            var skin = this.getSkin();
            var markup = null;
            if (skin) {
                var skinModel = com.ibm.mashups.enabler.model.staticSkin.Factory.getStaticSkinModel();
                var rawID = this.getSkin()._getRawID();
                var themeId = rawID.substring(1+rawID.lastIndexOf(":"));
                var defSkin = skinModel.find(skin, themeId);
                defSkin.setFinishedCallback(function(resource,status, deferred) {
                    var ret = null;
             	    var _load = com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_LOAD;
            	    var _404 = com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_NOT_FOUND;                    
                    if(status == com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK) {
                       var rawUrl = resource._getMediaURL();
                       if (rawUrl) {

                           if(rawUrl in self._cachedSkinData) {
                        	   // look if its cached
                        	   if(_load in self._cachedSkinData[rawUrl]) {
                        		   ret = self._templateFunc(deferred, sync, self._cachedSkinData[rawUrl][_load]).start(sync);
                        	   } else if (deferred) {
                                   deferred.finish(null,_404);
                               }
                           } else {                    	   
	                           var req = new com.ibm.mm.enabler.services.ModelRestServiceRequest(new com.ibm.mm.enabler.utils.HttpUrl(rawUrl), null, null, true, sync);
	                           
	                           req.read(function(status, skinData, xhr, deferred){
	                        	   
	                        	   // add to cache
	                        	   self._cachedSkinData[rawUrl] = {};
	                        	   self._cachedSkinData[rawUrl][status] = skinData;
	                        	   
	                               if (status == _load) {
	                                   ret = self._templateFunc(deferred, sync, skinData).start(sync);
	                               } else if (deferred) {
	                                   deferred.finish(null,_404);
	                               }
	                               
	                           }, deferred);
                           }
                       } else {
                           // no previewable skin available
                           ret = self._templateFunc(deferred, sync, null).start(sync);
                       }
                    } else if(deferred) {
                        deferred.finish(null,_404);
                    }
                    return ret;
                }, deferred);
                
                markup = defSkin.start(sync);                
            } else {
                // no skin set on control
                markup = this._templateFunc(deferred,sync,null).start(sync);
            }
            return markup;
        });
    },
        
    setMetaData: function(name, value) {
        var oldValue = this.inherited(arguments);
        dojo.publish(com.ibm.mm.enabler.layout.LayoutControlImpl.TOPIC_METADATA_SET,[this,name,oldValue,value]);
        this._setDirty();
        return oldValue;
    },
    
    removeMetaData: function(name) {
        var oldValue = this.inherited(arguments);
        dojo.publish(com.ibm.mm.enabler.layout.LayoutControlImpl.TOPIC_METADATA_REMOVE,[this,name,oldValue,null]);
        this._setDirty();
        return oldValue;
    },

   getSkin: function() {
       var node = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(com.ibm.mm.enabler.layout.LayoutControlImpl.XPATH_SKIN_ELEMENT, this.getXml(), this.ns);
       if(node) {
           var id = com.ibm.mm.enabler.utils.Dom.getAttributeWithNS(node,"ext:uri", "uri",this.ns.ext);
           var skin = new com.ibm.mm.enabler.layout.SkinIdentifiable(id);
           
           if(this._skins.containsKey(skin.getID())) {
               return this._skins.item(skin.getID());
           } else {
               this._skins.add(skin.getID(),skin);
               return skin;
           }
       }
       return null;
   },
   
   setSkin: function(id){
        if (this.layoutModel._isEmpty(id)) {
            throw new Error(this.layoutModel.modelMessages.E_PARAM_ISNULL_0);
        }
       
       var node = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(com.ibm.mm.enabler.layout.LayoutControlImpl.XPATH_SKIN_ELEMENT, this.getXml(), this.ns);
       var currentId;
       if (!node) {
            // create node here
            node = com.ibm.mm.enabler.utils.Utils.createNode("atom:link", this.ns.atom);
            
            // FIX (Opera): set the rel="related" attribute BEFORE the ext:rel 
            // attribute; otherwise, the rel attribute is set as ext:rel attribute
            node.setAttribute("rel", "related");
            node.setAttribute("type", "application/atom+xml");
            com.ibm.mm.enabler.utils.Dom.setAttributeWithNS(this.getXml().ownerDocument, node, "ext:rel", "rel", this.ns.ext, "skin");
            
            // add the link
            this.getXml().appendChild(node);
       } else {
           currentId = this.getSkin().getID();
       }

       var newId = com.ibm.mm.enabler.utils.Utils.getIdFromIdentifiable(id);
       if (newId != currentId) {
           // id changed
            var modelUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(com.ibm.mashups.enabler.model.url.ModelUrlFactory.THEME_URL, this.layoutModel);
            modelUrl.setNodes([{
                value: newId,
                isID: true
            },{
            	value: this.layoutModel._getNavigationNode().getThemeIdentifier().getID(),
            	isID: true
            }]);
            node.setAttribute("href", modelUrl.getAbsoluteURL());
            com.ibm.mm.enabler.utils.Dom.setAttributeWithNS(this.getXml().ownerDocument, node, "ext:uri", "uri", this.ns.ext, modelUrl.getModelURI());
            
            // mark as dirty
            this._setDirty();
            
            if (this._skins.containsKey(currentId)) {
                var it = this._skins.item(currentId);
                this._skins.remove(currentId);
                it.setID(modelUrl.getModelURI());
                this._skins.add(newId,it);
            }
            
            // publish the change
            dojo.publish(com.ibm.mm.enabler.layout.LayoutControlImpl.TOPIC_SKIN_SET,[this,null,currentId || null,newId]);
            
        }
   },
   
   /**
    * Returns the URI of the&nbsp; {@link com.ibm.mm.enabler.widget.WidgetWindow WidgetWindow} representing this layout control.
    * 
    */
   _getWidgetWindowURI: function() {       
       var uri = com.ibm.mashups.enabler.xml.XPath.evaluateString("atom:link[@ext:rel='portlet']/@ext:uri", this.getXml(), this.ns);
       return uri ? dojo.string.trim(uri) : null;
   },
   
   
   /**
    * TODO: get URL also from committed controls - won't be added by portal for now - see Work Item 13726
    */
   _getWidgetDefinitionURL: function() {
       var xp2 = "atom:content/model:layout-control/@creation-context:widget-definition-url";
       return com.ibm.mashups.enabler.xml.XPath.evaluateString(xp2, this.getXml(), this.ns);
   },
   
   /**
    * Returns a context object compatible with what is specified in {@link com.ibm.mashups.enabler.model.LayoutModel#create(Object) create} method {@link com.ibm.mashups.enabler.model.LayoutModel LayoutModel}.
    * returns null if nothing (defintion, url, container) found
    * 
    */
   _getContext: function() {
       var context = {};
       
       // check for portlet definition
       var xp1 = "atom:content/model:layout-control/@creation-context:portlet-definition";
       var id = com.ibm.mashups.enabler.xml.XPath.evaluateString(xp1, this.getXml(), this.ns);
       
       if(id) {
           context[com.ibm.mashups.enabler.layout.Constants.CONTEXT_WIDGET_DEFINITION_ID] = new com.ibm.mm.enabler.IdentifierImpl(id);
           context[com.ibm.mashups.enabler.layout.Constants.CONTEXT_TYPE]                 = com.ibm.mashups.enabler.layout.Constants.LAYOUT_CONTROL;
           return context;
       }
       
       // check for widget URL
       var url = this._getWidgetDefinitionURL();
       if(url) {
           context[com.ibm.mashups.enabler.layout.Constants.CONTEXT_WIDGET_DEFINITION_URL] = url;
           context[com.ibm.mashups.enabler.layout.Constants.CONTEXT_TYPE]                  = com.ibm.mashups.enabler.layout.Constants.LAYOUT_CONTROL;
           return context;
       }       
       
       return null;
   }
});

com.ibm.mm.enabler.layout.LayoutControlImpl.TOPIC_BASE = "/"+"com.ibm.mashups.enabler.model.LayoutControl".replace(/\./ig,'/')+"/";

com.ibm.mm.enabler.layout.LayoutControlImpl.TOPIC_SKIN_BASE       = com.ibm.mm.enabler.layout.LayoutControlImpl.TOPIC_BASE + "skin/";
com.ibm.mm.enabler.layout.LayoutControlImpl.TOPIC_SKIN_SET        = com.ibm.mm.enabler.layout.LayoutControlImpl.TOPIC_SKIN_SET + "set";

com.ibm.mm.enabler.layout.LayoutControlImpl.TOPIC_METADATA_BASE   = com.ibm.mm.enabler.layout.LayoutControlImpl.TOPIC_BASE + "meta/";
com.ibm.mm.enabler.layout.LayoutControlImpl.TOPIC_METADATA_SET    = com.ibm.mm.enabler.layout.LayoutControlImpl.TOPIC_METADATA_BASE + "set";
com.ibm.mm.enabler.layout.LayoutControlImpl.TOPIC_METADATA_REMOVE = com.ibm.mm.enabler.layout.LayoutControlImpl.TOPIC_METADATA_BASE + "remove";

com.ibm.mm.enabler.layout.LayoutControlImpl.XPATH_SKIN_ELEMENT = "atom:link[@ext:rel = 'skin' and @rel = 'related']";

com.ibm.mm.enabler.layout.LayoutControlImpl._REGEX_START = '<\\s*a\\s+rel\\s*=\\s*("|\')dynamic-content("|\')\\s+href\\s*=\\s*("|\')';
com.ibm.mm.enabler.layout.LayoutControlImpl._REGEX_END = '("|\')\\s*>.*?<\\s*\/\\s*a\\s*>';

// match <a rel="dynamic-content" href="lm:control"></a>
com.ibm.mm.enabler.layout.LayoutControlImpl.REGEX_CONTROL = new RegExp(com.ibm.mm.enabler.layout.LayoutControlImpl._REGEX_START+"lm:control"+com.ibm.mm.enabler.layout.LayoutControlImpl._REGEX_END,"i");
// match <a rel="dynamic-content" href="lm:title"></a>
com.ibm.mm.enabler.layout.LayoutControlImpl.REGEX_TITLE =  new RegExp(com.ibm.mm.enabler.layout.LayoutControlImpl._REGEX_START+"lm:title"+com.ibm.mm.enabler.layout.LayoutControlImpl._REGEX_END,"i");

    
    

}

if(!dojo._hasResource["com.ibm.mashups.enabler.layout.LayoutControl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.layout.LayoutControl"] = true;
dojo.provide("com.ibm.mashups.enabler.layout.LayoutControl");






}

if(!dojo._hasResource["com.ibm.mashups.enabler.layout.LayoutFragment"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.layout.LayoutFragment"] = true;
dojo.provide("com.ibm.mashups.enabler.layout.LayoutFragment");



/**
 * Interface that represents a layout fragment
 *
 * @deprecated use com.ibm.mashups.enabler.model.LayoutContainer and com.ibm.mashups.enabler.model.LayoutControl
 *
 * @ibm-api
 * @ibm-module LayoutModel
 */
dojo.declare("com.ibm.mashups.enabler.layout.LayoutFragment", [com.ibm.mashups.enabler.layout.LayoutNode], {
    /**
     * Returns the content of the fragment as a string.
     * @return {String} the fragment content. Never <code>null</code>
     */
    getFragment: function(){
    },
    
    /**
     * Sets the content of the fragment. Any previously set content is replaced.
     * @param {String} content content to set. Must not be <code>null</code>.
     * @type void
     */
    setFragment: function(content){
    },
    
    /**
     * Confirms whether setting the fragment is possible.
     * @param {String} content content to set; must not be <code>null</code>
     * @return {Boolean} true if the value can be set, otherwise false.
     */
    confirmSetFragment: function(content){
    }
});


}

if(!dojo._hasResource["com.ibm.mashups.enabler.layouttemplate.LayoutTemplate_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.layouttemplate.LayoutTemplate_API"] = true;
dojo.provide("com.ibm.mashups.enabler.layouttemplate.LayoutTemplate_API");
dojo.provide("com.ibm.mashups.enabler.layouttemplate.LayoutTemplate");






/**
 * Interface representing a layout template node.
 *
 * @ibm-api
 * @ibm-module LayoutTemplateModel
 */
dojo.declare("com.ibm.mashups.enabler.layouttemplate.LayoutTemplate", [com.ibm.mashups.enabler.Identifiable, com.ibm.mashups.enabler.ModifiableLocalized, com.ibm.mashups.enabler.ModifiableMetaData, com.ibm.mashups.enabler.TimeStamped], {

    /**
     * Returns the URL of the layout template.
     * @return {String} the base URL
     */
    getURL: function(){
    
    },
    
    /**
     * Returns the URL of the head file of this layout template.
     * @return {String} the layout template URL
     */
    getHeadURL: function(){
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.layouttemplate.LayoutTemplate"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.layouttemplate.LayoutTemplate"] = true;
dojo.provide("com.ibm.mm.enabler.layouttemplate.LayoutTemplate");



// summary: The PropertiesFileFacade is in charge of mediating the input into and out of
//		the standard Java-style properties file format.
com.ibm.mm.enabler.layouttemplate.PropertiesFileFacade = {
    serialize: function(objMap) {
        // summary: Takes a map of keys and values and serializes it to a Java-style properties file format.
        // description: The output includes a simple header with a comment containing the date of serialization, 
        //		followed by each key/value pair on a new line.
        // objMap: an associative array containing key-value pairs
        // returns: the string in standard Java-style properties file format (including new line characters)
        var ret = ["#\n"];
        ret.push("# ", (new Date()).toUTCString(), "\n");
        for (var obj in objMap) {
            if (Object.prototype.hasOwnProperty.call(objMap, obj)) {
                ret.push(obj, "=", objMap[obj], "\n");
            }
        }
        
        return ret.join("");
    },
    deserialize: function(propertiesString) {
        // summary: Parses a Java-style properties file specified by contents or URL.
        // propertiesString: the string value associated with that property will be treated as the properties file 
        // 		contents.
        // returns: a dojo.Deferred object where callbacks will be triggered with an associative array representing the
        //		properties file contents
        var dfd = new dojo.Deferred();
        this._parse(propertiesString, dfd);
        return dfd;
    },
    _parse: function(contents, deferred) {
        // summary: Executes the parsing.
        //TODO: replace with regexps
        var lines = contents.split("\n");
        var l = lines.length;
        var objMap = {};
        for (var i = 0; i < l; i++) {
            var line = lines[i];
            if (line.indexOf("#") !== 0) {
                var key;
                var value;
                var equals = line.indexOf("=");
                if (equals > 0) {
                    key = line.substring(0, equals);
                    value = this._filter(line.substring(equals + 1));
                    if (key !== "") {
                        objMap[key] = value;
                    }
                }
            }
        }
        
        deferred.callback(objMap);
    },
    _filter: function(str) {
        // summary: Filters a property value for usage in javascript code. 
        // str: the string to filter
        // returns: the filtered string, ready for display and usage in javascript code
        
        //currently, the only activity is processing unicode characters. this method exists in case any further
        //processing needs to be performed on these strings. 
        return this._processUnicodeCharacters(str);
    },
    _processUnicodeCharacters: function(str) {
        // summary: Processes a string containing expanded unicode references ("\u0639"), replacing 
        //		the expanded unicode sequence with the unicode character based on the same sequence.
        // description: An alternative method would be to simply eval() the string surrounded by quotes. We are using
        //		this method to avoid the security risks imposed by that approach. In this solution, we are only calling
        //		eval() on character sequences that match our unicode regular expression and only one "character" at a 
        //		time. Otherwise, anyone with edit access to the localized files could enter script code in the
        //		properties file and have it executed when the properties file was read. 
        // str: the string to process
        // returns: a string with all expanded unicode references reduced to the expected unicode character
        var unicodeRegexp = /\\u[0-9a-fA-F]{4}/g;
        var matches = str.match(unicodeRegexp);
        
        if (matches) {
            for (var i = 0, l = matches.length; i < l; i++) {
                var unicodeStr = matches[i];
                var unicodeChar = eval("'" + unicodeStr + "'"); // JSLINT-IGNORE: no other way known so far to do this
                str = str.replace(unicodeStr, unicodeChar);
            }
        }
        
        return str;
    }
};

// summary: Resolves a deferred.
// description: Since the contract for resolving an enabler Deferred object is not defined, this object handles this
//		for com.ibm.mm.enabler.DeferredImpl objects. It essentially triggers the callback function associated with the
//		specified Deferred with the resource and status code.
dojo.declare("com.ibm.mm.enabler.layouttemplate.DeferredResolver", null, {
    setDelegate: function( /*Deferred*/d) {
        this.deferred = d;
    },
    resolve: function( /*Object*/resource, /*int*/ status) {
        if (this.deferred) {
            var cb = this.deferred.getFinishedCallback();
            var cbParams = this.deferred.getFinishedCallbackParameters();
            if (cb) {
                cb(resource, status, cbParams);
            }
        }
    }
});

// summary: Manages multiple enabler Deferred objects.
// description: There is no contract or specification for chaining multiple enabler Deferred objects together. This 
//		object hides the complexities and ugliness of executing this ability. It only currently works for the default 
//		implementation of Deferred (com.ibm.mm.enabler.DeferredImpl) and the WebDAVDeferredImpl. The limitation is one
//		of not knowing how to access the Deferred's callback function as this is not defined in the Deferred's contract.
com.ibm.mm.enabler.layouttemplate.DeferredManager = {
    counter: 0,
    extractCallbackInfo: function(enablerDfd) {
        // summary: Extracts the specified callback information for a given deferred.
        // enablerDfd: an enabler style deferred object
        // returns: an object of the form { callback: function, params: [] }; the values MAY be undefined
        var callback;
        var callbackParams;
        if (enablerDfd.getFinishedCallback) {
            callback = enablerDfd.getFinishedCallback();
        }
        else if (enablerDfd._callback) {
            callback = enablerDfd._callback;
        }
        
        if (enablerDfd.getFinishedCallbackParameters) {
            callbackParams = enablerDfd.getFinishedCallbackParameters();
        }
        else if (enablerDfd._parameters) {
            callbackParams = enablerDfd._parameters;
        }
        
        return {
            callback: callback,
            params: callbackParams
        };
    },
    combine: function(d1, d2) {
        // summary: Combines two Deferred objects into a new Deferred. Callbacks added to the result of this operation 
        //		are not called until both of the combined Deferred objects have completed. Callbacks already established
        //		on the individual deferreds are still called when each individual deferred completes. Deferreds can be 
        //		combined multiple times. For example, d1, d2, and d3 need to execute in this order: d1, d2, d3. d1 and 
        //		d2 would be combined. Then, the result of the combination of d1 and d2 would be combined with d3.
        // d1: the deferred to execute first.
        // d2: the deferred to execute second.
        // returns: a com.ibm.mm.enabler.DeferredImpl object that represents the combination of d1 and d2.
        var cb1 = this.extractCallbackInfo(d1);
        
        //This info is useful for debugging the combination of Deferreds in Firebug/Web Inspector, but serves no 
        //functional purpose.
        if (ibmConfig.isDebug) {
            if (d1._uid === undefined) {
                d1._uid = this.counter++;
            }
            if (d2._uid === undefined) {
                d2._uid = this.counter++;
            }
        }
        
        //This is the new "wrapped" deferred that will resolve after both of the combined deferreds resolve.
        var d = new com.ibm.mm.enabler.DeferredImpl(d, function() {
            d1.start();
        });
        var me = this;
        d1.setFinishedCallback(function() {
            //Once the first deferred has completed, we need to:
            //		1. Trigger it's finished callback.
            //		2. Setup the second deferred's callback.
            //		3. Start the second deferred.
            if (cb1.callback) {
                cb1.callback(arguments[0], arguments[1], cb1.params);
            }
            
            var cb2 = me.extractCallbackInfo(d2);
            d2.setFinishedCallback(function() {
                //We need to take this over to make sure any callback added to the combined deferred gets called at the
                //appropriate time. 
                if (cb2.callback) {
                    cb2.callback(arguments[0], arguments[1], cb2.params);
                }
                
                var cb3 = me.extractCallbackInfo(d);
                
                if (cb3.callback) {
                    cb3.callback(arguments[0], arguments[1], cb3.params);
                }
            });
            d2.start();
        });
        
        //This info is useful for debugging the combination of Deferreds in Firebug/Web Inspector, but serves no 
        //functional purpose.
        if (ibmConfig.isDebug) {
            d._first = d1;
            d._second = d2;
            d._uid = this.counter++;
        }
        
        return d;
    }
};

// summary: Abstraction layer to insulate the model code from changes in the Enabler WebDAV APIs. Can easily be 
//		customized by mixing in any overridden functions.
com.ibm.mm.enabler.layouttemplate.WebDAVInterface = {
    init: function( /*RemoteModel*/rModel) {
        // summary: Initialize the interface with the Remote (WebDAV) model.
        this.remoteModel = rModel;
        this._commandFactory = com.ibm.mm.enabler.remote.WebDavCommandFactory;
    },
    getFileInfo: function( /*String*/path) {
        // summary: Retrieves the requested file information (PROPFIND). Note that the file could be a directory.
        // path: the path of the requested file
        // returns: a Deferred object that will eventually resolve to a RemoteFile object
        return this.remoteModel.find(path);
    },
    getFilename: function( /*RemoteFile*/file) {
        // summary: Returns the name (including any extension) of the file represented by the file
        //		object
        // file: the RemoteFile object
        // returns: a Deferred object that will eventually resolve to the file name
        var r = new com.ibm.mm.enabler.layouttemplate.DeferredResolver();
        var d = new com.ibm.mm.enabler.DeferredImpl(window, function() {
            r.resolve(file.getName(), 200);
        });
        r.setDelegate(d);
        return d;
    },
    isDirectory: function( /*RemoteFile*/file) {
        // summary: Returns the name (including any extension) of the file represented by the file
        //		object
        // file: the RemoteFile object
        // returns: a Deferred object that will eventually resolve to a boolean value
        var r = new com.ibm.mm.enabler.layouttemplate.DeferredResolver();
        var d = new com.ibm.mm.enabler.DeferredImpl(window, function() {
            r.resolve(file.isDirectory(), 200);
        });
        r.setDelegate(d);
        return d;
    },
    getDirectoryContentsURLs: function( /*RemoteFile*/file) {
        // summary: Returns an array of URLs that represent files or directories contained within
        //		the RemoteFile object provided
        // file: the RemoteFile object - must point to a directory
        // returns: a Deferred object that will eventually resolve to an array of URLs in string form that list
        //		the files and directories contained in the provided directory
        var r = new com.ibm.mm.enabler.layouttemplate.DeferredResolver();
        var d = new com.ibm.mm.enabler.DeferredImpl(window, function() {
            r.resolve(file._getChildHrefs(), 200);
        });
        r.setDelegate(d);
        return d;
    },
    getURL: function( /*RemoteFile*/file) {
        // summary: Returns the full URL to access the provided file
        // file: the RemoteFile object
        // returns: a Deferred object that will eventually resolve to a String value
        var r = new com.ibm.mm.enabler.layouttemplate.DeferredResolver();
        var d = new com.ibm.mm.enabler.DeferredImpl(window, function() {
            r.resolve(file.getURL(), 200);
        });
        r.setDelegate(d);
        return d;
    },
    getFileContents: function( /*String*/path) {
        // summary: Retrieves the file contents at the given path.
        // path: the path (relative to WebDAV root) to retrieve the file from
        // contents: the contents of the new file
        // returns a Deferred object that will eventually resolve to the contents of the file.
        var cmd = this._commandFactory.getDownloadCommand(path);
        var r = new com.ibm.mm.enabler.layouttemplate.DeferredResolver();
        var d = new com.ibm.mm.enabler.DeferredImpl(window, function() {
            var dfd = cmd.execute();
            dfd.addCallback(function(response, ioArgs) {
                r.resolve(response, ioArgs);
            });
        });
        r.setDelegate(d);
        
        return d;
    },
    createFile: function( /*String*/path, /*String*/ contents) {
        // summary: Creates a file at the given path with the given contents.
        // path: the path (relative to WebDAV root) where the file should be created (including the filename)
        // contents: the contents of the new file
        // returns a Deferred object that will eventually resolve to a RemoteFile object representing the new
        //		file.
        var cmd = this._commandFactory.getCreateCommand(path, null, contents);
        var r = new com.ibm.mm.enabler.layouttemplate.DeferredResolver();
        var d = new com.ibm.mm.enabler.DeferredImpl(window, function() {
            var dfd = cmd.execute();
            dfd.addCallback(function(response, ioArgs) {
                r.resolve(response);
            });
        });
        r.setDelegate(d);
        
        return d;
    },
    updateFile: function( /*String*/path, /*String*/ contents) {
        // summary: Updates an existing file at the given path with the given contents.
        // path: the path (relative to WebDAV root) where the file should be created (including the filename)
        // contents: the contents of the updated file - note that these contents REPLACE the existing contents
        // returns: a Deferred object that will eventually resolve to a RemoteFile object representing the new
        //		file.
        var cmd = this._commandFactory.getUpdateCommand(path, null, contents);
        var r = new com.ibm.mm.enabler.layouttemplate.DeferredResolver();
        var d = new com.ibm.mm.enabler.DeferredImpl(window, function() {
            var dfd = cmd.execute();
            dfd.addCallback(function(response, ioArgs) {
                r.resolve(response);
            });
        });
        r.setDelegate(d);
        
        return d;
    },
    createDirectory: function( /*String*/path) {
        // summary: Creates a directory for the given path. The path should include the new directory name.
        // path: the path to the new directory relative to the WebDAV root
        // returns: a Deferred object that will resolve when the create operation has completed
        var cmd = this._commandFactory.getMakeCollectionCommand(path);
        var r = new com.ibm.mm.enabler.layouttemplate.DeferredResolver();
        var d = new com.ibm.mm.enabler.DeferredImpl(window, function() {
            var dfd = cmd.execute();
            dfd.addCallback(function(response, ioArgs) {
                r.resolve(response);
            });
        });
        r.setDelegate(d);
        
        return d;
    },
    remove: function( /*String*/path) {
        // summary: Removes the resource identified by the provided path.
        // path: the path to the resource to remove - relative to the WebDAV root
        // returns: a Deferred object that will resolve when the delete operation has completed
        var cmd = this._commandFactory.getDeleteCommand(path);
        var r = new com.ibm.mm.enabler.layouttemplate.DeferredResolver();
        var d = new com.ibm.mm.enabler.DeferredImpl(window, function() {
            var dfd = cmd.execute();
            dfd.addCallback(function(response, ioArgs) {
                r.resolve(response);
            });
        });
        r.setDelegate(d);
        
        return d;
    }
};

// summary: Generates the URLs to the various files that provide the backend for the localized and metadata interfaces.
com.ibm.mm.enabler.layouttemplate.TemplateURLHelper = {
    //baseLayoutTemplatesDirectory ends with a slash
    baseDirectory: ibmConfig && ibmConfig.baseLayoutTemplatesDirectory ? ibmConfig.baseLayoutTemplatesDirectory : "layout-templates/",
    getLocalizedFileURL: function(layoutDirectoryName, locale) {
        // summary: Returns the URL (relative to the WebDAV root) to the properties file containing the
        //		localized data for the given layout template and locale.
        return this.baseDirectory + layoutDirectoryName + "/metadata/localized_" + locale + ".properties";
    },
    getMetaDataFileURL: function(layoutDirectoryName) {
        // summary: Returns the URL (relative to the WebDAV root) to the properties file containing the
        //		metadata for the given layout template.
        return this.baseDirectory + layoutDirectoryName + "/metadata.properties";
    }
};

// summary: Interface for a resource that is backed by an object in WebDAV instead of a feed or database. Manages
//		references to various interfaces required to read and modify the backend data.
// remoteModel: the model for accessing files in WebDAV
// remoteFile: the remote file object (usually a directory) containing the backend data
// webDavInterface: interface for interacting with WebDAV
// urlHelper: helper object for creating URLs to the various backend files
// propertiesFileFacade: interface for reading and writing properties files
// exists: indicates whether or not the object already exists or potentially will be created
dojo.declare("com.ibm.mm.enabler.layouttemplate.WebDAVBackedObject", null, {
    constructor: function(rModel, rFile, wdInt, uHelper, pFacade, doesExist) {
        this.remoteModel = rModel;
        this.remoteFile = rFile;
        this.webDavInterface = wdInt;
        this.urlHelper = uHelper;
        this.propertiesFileFacade = pFacade;
        this.exists = doesExist;
        
        this.webDavInterface.init(this.remoteModel);
    },
    setRemoteNls: function(rNlsFile) {
        this.remoteNlsFile = rNlsFile;
    }
});


// summary: Describes a modifiable localized resource that is backed by a file in WebDAV instead of feed data or 
//		a database. 
dojo.declare("com.ibm.mm.enabler.layouttemplate.WebDAVBackedModifiableLocalized", [com.ibm.mm.enabler.layouttemplate.WebDAVBackedObject, com.ibm.mashups.enabler.ModifiableLocalized], {
    constructor: function() {
        //Separate bundle information set on the client versus loaded remotely. This becomes important when
        //submitting changes as we have to know whether or not the remote data has been loaded before
        //saving. If, for example, only a title is set for a particular locale, but a description was set
        //previously, we need to have the pre-existing description to avoid omitting the description in 
        //our update.
        this._localBundles = {};
        this._remoteBundles = {};
        //manages the state of the object so we know when a change has been made
        this._housekeeper = {
            isClean: true,
            dirtyLocales: {},
            makeLocaleDirty: function(locale) {
                this.dirtyLocales[locale] = true;
                this.isClean = false;
            },
            reset: function() {
                this.dirtyLocales = {};
                this.isClean = true;
            }
        };
    },
    _getBundle: function(locale) {
        // summary: Retrieve the bundle for the specified locale.
        // locale: the locale to retrieve the bundle for
        // returns: an enabler Deferred that will be triggered once the bundle
        //		has been loaded into the remote bundles object.
        // IMPORTANT: There's currently a bug in Enabler that keeps any callback from
        //		being triggered when an unsuccessful request is sent.
        var wdi = this.webDavInterface;
        var tuh = this.urlHelper;
        var p = this.propertiesFileFacade;
        var me = this;
        var d;
        if (this.exists) {
            d = wdi.getFileContents(tuh.getLocalizedFileURL(this.remoteFile.getName(), locale));
            d.setFinishedCallback(function(contents) {
                var dfd = p.deserialize(contents);
                dfd.addCallback(function(props) {
                    me._remoteBundles[locale] = props;
                });
            });
        }
        else {
            var r = new com.ibm.mm.enabler.layouttemplate.DeferredResolver();
            d = new com.ibm.mm.enabler.DeferredImpl(window, function() {
                r.resolve();
            });
            r.setDelegate(d);
        }
        return d;
    },
    _mergeRemoteAndLocalBundle: function(locale) {
        // summary: Merges the remote and local bundles for a locale to provide a single bundle containing
        //		the most up to date localized information for the given object. Local bundle takes 
        //		preference over remote.
        var bundle = this._remoteBundles[locale];
        if (bundle === undefined) {
            bundle = {};
        }
        var localBundle = this._localBundles[locale];
        for (var obj in localBundle) {
            if (Object.prototype.hasOwnProperty.call(localBundle, obj)) {
                bundle[obj] = localBundle[obj];
            }
        }
        return bundle;
    },
    getTitle: function(locale) {
        // summary: Retrieves the title for the given locale.
        // locale: the locale to retrieve the title for
        // returns: an enabler Deferred object that will be triggered with the title string
        // IMPORTANT: The official interface for Localized specifies a String returned here but we don't
        //		follow that for two reasons. One is that the RemoteModel currently has NO support for 
        //		synchronous operation (we have to request the contents of the localized file to retrieve 
        //		this information). Two is that this really should be a Deferred object returned to account
        //		for cases like this; where retrieving the title requires a remote operation. The current
        //		interface is too limiting.
        return this._deferredInvocation(locale, "title");
    },
    getDescription: function(locale) {
        // summary: Retrieves the description for the given locale.
        // locale: the locale to retrieve the description for
        // returns: an enabler Deferred object that will be triggered with the description string
        // IMPORTANT: The official interface for Localized specifies a String returned here but we don't
        //		follow that for two reasons. One is that the RemoteModel currently has NO support for 
        //		synchronous operation (we have to request the contents of the localized file to retrieve 
        //		this information). Two is that this really should be a Deferred object returned to account
        //		for cases like this; where retrieving the description requires a remote operation. The current
        //		interface is too limiting.
        return this._deferredInvocation(locale, "description");
    },
    _deferredInvocation: function(locale, property) {
        // summary: Creates a Deferred object that will access the specified property in the specified
        //		locale's bundle.
        // locale: the requested locale
        // property: the property inside the bundle to retrieve
        // returns: a Deferred that will be triggered with the given property in the specified bundle

        // we need to fix the passed in locale in that we make sure it is of format lowercase_UPPERCASE
        locale = com.ibm.mm.enabler.utils.LocaleHelper._getLocaleObj(locale).toString();

        var locales = this._getExistingLocalesAsMap();
        var localeDataExists = locales[locale];
        var r = new com.ibm.mm.enabler.layouttemplate.DeferredResolver();
        var newD = new com.ibm.mm.enabler.DeferredImpl(this, function() {
            if (localeDataExists) {
                r.resolve(this._mergeRemoteAndLocalBundle(locale)[property]);
            }
            else {
                r.resolve(undefined, 404);
            }
        });
        if (this._remoteBundles[locale] === undefined && this.exists && localeDataExists) {
            var d = this._getBundle(locale);
            var d2 = com.ibm.mm.enabler.layouttemplate.DeferredManager.combine(d, newD);
            r.setDelegate(d2);
            return d2;
        }
        else {
            r.setDelegate(newD);
            return newD;
        }
    },
    getLocales: function() {
        // summary: Returns an array of the available locales.
        if (this._locales === undefined) {
            this._locales = [];
            if (this.exists) {
                this._locales = this._readLocales();
            }
        }
        
        return this._locales;
    },
    _getExistingLocalesAsMap: function() {
        // summary: Converts the array of existing locales into an associative array where the locale is
        //		the key in the object and the value is true. An undefined locale equates to a non-existant
        //		bundle.
        var obj = {};
        
        if (this.exists) {
            var ls = this._readLocales();
            var len = ls.length;
            for (var i = 0; i < len; i++) {
                obj[ls[i]] = true;
            }
        }
        
        return obj;
    },
    _readLocales: function() {
        // summary: Reads the locales out of the RemoteFile object using the child hrefs stored in that
        //		object. This technically is not part of the public API, but seems worth it to save a 
        //		request to the server just to retrieve this information. 
        if (!this.remoteNlsFile) {
            return ["en"];
        }
        var childHrefs = this.remoteNlsFile._getChildHrefs();
        var l = childHrefs.length;
        var locales = [];
        for (var i = 1; i < l; i++) {
            var child = childHrefs[i];
            var name = child.substring(child.lastIndexOf("/") + 1);
            if (name.indexOf("localized_") === 0) {
                //slice off the extension
                name = name.split(".")[0];
                locales.push(name.substring(10));  	// name is "localized_xx" or "localized_xx_XX", 
													//so substring(10) chops off the "localized_" part, 
													//leaving the locale string behind
            }
        }
        return locales;
    },
    setTitle: function(locale, newTitle) {
        // summary: Sets the title for the given locale. Note that no changes are saved until commit is
        //		called on the model.
        // locale: the locale
        // newTitle: the new title
        var bundle = this._localBundles[locale];
        if (bundle === undefined || bundle === null) {
            //bundle = {};
            this._localBundles[locale] = {};
            this.getLocales().push(locale);
        }
        
        this._localBundles[locale].title = newTitle;
        this._housekeeper.makeLocaleDirty(locale);
    },
    confirmSetTitle: function(locale, newTitle) {
        // summary: Confirms whether or not the given title for the given locale CAN be set.
        //TODO: what permissions to check here?
        return true;
    },
    removeTitle: function(locale) {
        // summary: Removes the title for the given locale. Note that no changes are saved until the model
        //		is committed.
        // locale: the locale to remote the title for
        var bundle = this._mergeRemoteAndLocalBundle(locale);
        if (!(bundle === undefined || bundle === null)) {
            delete bundle.title;
            this._housekeeper.makeLocaleDirty(locale);
        }
    },
    confirmRemoveTitle: function(locale) {
        // summary: Confirms whether or not the given title for the given locale CAN be removed.
        //TODO: what permissions to check here?
        var bundle = this._mergeRemoteAndLocalBundle(locale);
        return !(bundle === undefined || bundle === null);
    },
    removeTitles: function() {
        // summary: Removes all titles for this object. Note that no changes are saved until the model is
        //		committed.
        for (var locale in this._locales) {
            if (Object.prototype.hasOwnProperty.call(this._locales, locale)) {
                delete this._bundles[locale].title;
                this._housekeeper.makeLocaleDirty(locale);
            }
        }
    },
    setDescription: function(locale, newDescription) {
        // summary: Sets the description for the given locale. Note that no changes are saved until commit 
        //		is called on the model.
        // locale: the locale
        // newTitle: the new description
        var bundle = this._mergeRemoteAndLocalBundle(locale);
        if (bundle === undefined || bundle === null) {
            bundle = {};
            this._localBundles[locale] = bundle;
            this.getLocales().push(locale);
        }
        
        bundle.description = newDescription;
        this._housekeeper.makeLocaleDirty(locale);
    },
    confirmSetDescription: function(locale, newDescription) {
        // summary: Confirms whether or not the given description for the given locale CAN be set.
        //TODO: what permissions to check here?
        return true;
    },
    removeDescription: function(locale) {
        // summary: Removes the description for the given locale. Note that no changes are saved until the model
        //		is committed.
        // locale: the locale to remote the description for
        var bundle = this._bundles[locale];
        if (!(bundle === undefined || bundle === null)) {
            delete bundle.description;
            this._housekeeper.makeLocaleDirty(locale);
        }
    },
    confirmRemoveDescription: function(locale) {
        // summary: Confirms whether or not the given description for the given locale CAN be removed.
        //TODO: what permissions to check here?
        var bundle = this._remoteBundles[locale];
        return !(bundle === undefined || bundle === null);
    },
    removeDescriptions: function() {
        // summary: Removes all descriptions for this object. Note that no changes are saved until the model is
        //		committed.
        for (var locale in this._bundles) {
            if (Object.prototype.hasOwnProperty.call(this._bundles, locale)) {
                delete this._bundles[locale].description;
                this._housekeeper.makeLocaleDirty(locale);
            }
        }
    },
    _setLocalizedData: function() {
        // summary: Persists the localization data.
        // returns: a Deferred that will be triggered once all the save operations complete.
        // IMPORTANT: Modifying a large number of locales at once can generate a LARGE number of requests.
        //		For each bundle modified, we have to request the current contents of the bundle (if not 
        //		already requested), modify them, and then save the contents back to the server. Essentially,
        //		for each bundle modified, 2 requests will be generated.
        var wdi = this.webDavInterface;
        var tuh = this.urlHelper;
        var p = this.propertiesFileFacade;
        
        var locales = this._housekeeper.dirtyLocales;
        //All callbacks get rolled up into the retVal
        var retVal;
        //d stores the callback for the current iteration of the loop
        var d;
        
        for (var l in locales) {
            if (Object.prototype.hasOwnProperty.call(locales, l)) {
                var path = tuh.getLocalizedFileURL(this.remoteFile.getName(), l);
                //If this evaluates to true, the file already exists remotely.
                if (this._getExistingLocalesAsMap()[l] === true) {
                    //If the remote data has not been loaded, we need to load it FIRST.
                    if (this._remoteBundles[l] === undefined) {
                        d = this._getBundle(l);
                    }
                    if (d) {
                        //This needs to be in a separate function to give the locale a new closure. Otherwise,
                        //l will always refer to the last locale once the loop has completed.
                        d = this._newUpdateLocaleFn(d, l, wdi, path, p);
                    }
                    else {
                        //We already had the remote data.
                        d = wdi.updateFile(path, p.serialize(this._mergeRemoteAndLocalBundle(l)));
                    }
                }
                else {
                    //The file did not exist and we have to create it. We obviously can avoid retrieving
                    //the remote data in this case.
                    d = wdi.createFile(path, p.serialize(this._mergeRemoteAndLocalBundle(l)));
                }
                if (retVal === undefined) {
                    //First time through; no need to build on existing callbacks.
                    retVal = d;
                }
                else {
                    //Combine the existing callback with the latest one. 
                    retVal = com.ibm.mm.enabler.layouttemplate.DeferredManager.combine(retVal, d);
                }
            }
        }
        
        var resetResolver = new com.ibm.mm.enabler.layouttemplate.DeferredResolver();
        var resetHousekeeper = new com.ibm.mm.enabler.DeferredImpl(this, function() {
            this._housekeeper.reset();
            resetResolver.resolve();
        });
        resetResolver.setDelegate(resetHousekeeper);
        
        retVal = com.ibm.mm.enabler.layouttemplate.DeferredManager.combine(retVal, resetHousekeeper);
        
        return retVal;
    },
    _newUpdateLocaleFn: function(getBundleDfd, locale, wdi, path, p) {
        // summary: Creates a new Deferred that contains the retrieval of the existing bundle, followed by 
        //		the request to update the file contents with the modified properties.
        var r = new com.ibm.mm.enabler.layouttemplate.DeferredResolver();
        var newD = new com.ibm.mm.enabler.DeferredImpl(this, function() {
            //The remote data has been retrieved, now merge it with our changes and update the file.
            var d2 = wdi.updateFile(path, p.serialize(this._mergeRemoteAndLocalBundle(locale)));
            var me = this;
            d2.setFinishedCallback(function() {
                //The remote data IS the local data now.
                me._remoteBundles[locale] = me._mergeRemoteAndLocalBundle(locale);
                me._localBundles[locale] = {};
                r.resolve();
            });
            d2.start();
        });
        var d3 = com.ibm.mm.enabler.layouttemplate.DeferredManager.combine(getBundleDfd, newD);
        r.setDelegate(d3);
        return d3;
    },
    _commitLocalizedChanges: function() {
        // summary: Commits the changes to the localized data.
        var d;
        if (this._isLocalizedDataDirty()) {
            d = this._setLocalizedData();
        }
        return d;
    },
    _isLocalizedDataDirty: function() {
        // summary: Indicates whether or not the localized data has been modified or not since the last
        //		time it was saved.
        return !this._housekeeper.isClean;
    },
    _revertLocalizedChanges: function() {
        // summary: Discards any localized changes made locally.
        this._housekeeper.reset();
        this._localBundles = {};
    }
});

// summary: Describes a modifiable metadata provider that is backed by a file in WebDAV instead of feed data or 
//		a database.
dojo.declare("com.ibm.mm.enabler.layouttemplate.WebDAVBackedModifiableMetaData", [com.ibm.mm.enabler.layouttemplate.WebDAVBackedObject, com.ibm.mashups.enabler.ModifiableMetaData], {
    constructor: function() {
        //Separate remote data from local data. Allows us to track what's changed and what's been saved.
        this._remoteMd = undefined;
        this._localMd = {};
        this._mdNames = undefined;
        this._isMdDirty = false;
    },
    getMetaData: function(name) {
        // summary: Retrieves the metadata value associated with the given name.
        // name: the name of the metadata property
        // returns: a Deferred object that is triggered with the property value (if it exists)
        // IMPORTANT: The official interface for MetaData specifies a String returned here but we don't
        //		follow that for two reasons. One is that the RemoteModel currently has NO support for 
        //		synchronous operation (we have to request the contents of the metadata file to retrieve 
        //		this information). Two is that this really should be a Deferred object returned to account
        //		for cases like this; where retrieving the metadata requires a remote operation. The current
        //		interface is too limiting.
        var r = new com.ibm.mm.enabler.layouttemplate.DeferredResolver();
        var newD = new com.ibm.mm.enabler.DeferredImpl(this, function() {
            //We need to merge the remote and local data in case the value has been set on the client.
            var md = this._mergeRWMd();
            var result = md[name];
            r.resolve(result);
        });
        if (this._remoteMd === undefined && this.exists) {
            //No remote data has been retrieved. Do this first.
            //TODO: If a value has been set on the client, isn't that sufficient? Can't we avoid the request
            //in that case?
            var d = this._loadMetaData();
            var d2 = com.ibm.mm.enabler.layouttemplate.DeferredManager.combine(d, newD);
            r.setDelegate(d2);
            return d2;
        }
        else {
            //Otherwise, the only thing to do is retrieve the property and resolve the deferred immediately.
            r.setDelegate(newD);
            return newD;
        }
    },
    _mergeRWMd: function() {
        // summary: Merges the remote data with the local data (local takes precedence).
        // returns: an associative array where the key is the metadata name and the value is the metadata value.
        var md = this._remoteMd;
        if (typeof md == "undefined") {
            md = {};
        }
        for (var obj in this._localMd) {
            if (Object.prototype.hasOwnProperty.call(this._localMd, obj)) {
                md[obj] = this._localMd[obj];
            }
        }
        return md;
    },
    getMetaDataNames: function() {
        // summary: Retrieves the names of all the metadata properties set on a particular resource.
        // returns: a Deferred that will resolve to an array containing the names of the available properties.
        // IMPORTANT: The official interface for MetaData specifies a String [] returned here but we don't
        //		follow that for two reasons. One is that the RemoteModel currently has NO support for 
        //		synchronous operation (we have to request the contents of the localized file to retrieve 
        //		this information). Two is that this really should be a Deferred object returned to account
        //		for cases like this; where retrieving the metadata requires a remote operation. The current
        //		interface is too limiting.
        var r = new com.ibm.mm.enabler.layouttemplate.DeferredResolver();
        var newD = new com.ibm.mm.enabler.DeferredImpl(this, function() {
            var n = [];
            var md = this._mergeRWMd();
            for (var obj in md) {
                if (Object.prototype.hasOwnProperty.call(md, obj)) {
                    n.push(obj);
                }
            }
            this._mdNames = n;
            r.resolve(this._mdNames);
        });
        var d2 = com.ibm.mm.enabler.layouttemplate.DeferredManager.combine(this.getMetaData(), newD);
        r.setDelegate(d2);
        return d2;
    },
    _loadMetaData: function() {
        // summary: Loads the remote data that describes the metadata for this resource. 
        // returns: a Deferred that resolves when the _remoteMd property has been assigned.
        var wdi = this.webDavInterface;
        var tuh = this.urlHelper;
        var p = this.propertiesFileFacade;
        var d = wdi.getFileContents(tuh.getMetaDataFileURL(this.remoteFile.getName()));
        var me = this;
        d.setFinishedCallback(function(contents) {
            var dfd = p.deserialize(contents);
            dfd.addCallback(function(props) {
                me._remoteMd = props;
            });
        });
        //d.start();
        return d;
    },
    setMetaData: function(name, value) {
        // summary: Sets the meta data value for the given name.
        this._localMd[name] = value;
        this._mdNames = undefined;
        this._isMdDirty = true;
    },
    confirmSetMetaData: function(name, value) {
        // summary: Confirms that the metadata name/value pair CAN be set.
        // returns: true if the operation is allowed, false otherwise
        return true;
    },
    removeMetaData: function(name) {
        // summary: Removes a metadata property.
        // name: the name of the metadata property to delete
        // returns: the String value of the property if it existed; NULL otherwise
        var dirty = false;
        var retVal = null;
        if (this._localMd[name] !== undefined) {
            retVal = this._localMd[name];
            delete this._localMd[name];
            dirty = true;
        }
        if (this._remoteMd[name] !== undefined) {
            retVal = this._remoteMd[name];
            delete this._remoteMd[name];
            dirty = true;
        }
        
        if (dirty) {
            this._mdNames = undefined;
            this._isMdDirty = true;
        }
        return retVal;
    },
    confirmRemoveMetaData: function(name) {
        // summary: Confirms that the metadata name/value pair CAN be removed.
        // returns: true if the operation is allowed, false otherwise
        return true;
    },
    _updateMetaData: function() {
        // summary: Updates the metadata properties file with the contents of the 
        //		new metadata.
        // returns: a Deferred object that resolves once the save operation is completed.
        var wdi = this.webDavInterface;
        var tuh = this.urlHelper;
        var p = this.propertiesFileFacade;
        
        var retVal;
        
        //If the remote data has not been previously retrieved, we need to do this FIRST.
        if (this._remoteMd === undefined && this.exists) {
            retVal = this._loadMetaData();
        }
        
        var r = new com.ibm.mm.enabler.layouttemplate.DeferredResolver();
        var newD = new com.ibm.mm.enabler.DeferredImpl(this, function() {
            //Save the new contents of the file.
            //TODO: Once it's possible to tell when the file doesn't yet exist, we need to handle the create
            //case here.
            var d = wdi.updateFile(tuh.getMetaDataFileURL(this.remoteFile.getName()), p.serialize(this._mergeRWMd()));
            d.setFinishedCallback(function() {
                r.resolve();
            });
            d.start();
        });
        
        if (retVal !== undefined) {
            retVal = com.ibm.mm.enabler.layouttemplate.DeferredManager.combine(retVal, newD);
        }
        else {
            retVal = newD;
        }
        
        r.setDelegate(retVal);
        
        var resetResolver = new com.ibm.mm.enabler.layouttemplate.DeferredResolver();
        var resetDirtyFlag = new com.ibm.mm.enabler.DeferredImpl(this, function() {
            this._isMdDirty = false;
            resetResolver.resolve();
        });
        resetResolver.setDelegate(resetDirtyFlag);
        
        retVal = com.ibm.mm.enabler.layouttemplate.DeferredManager.combine(retVal, resetDirtyFlag);
        
        return retVal;
    },
    _commitMetaDataChanges: function() {
        // summary: Commit the metadata changes that currently exist.
        var d;
        
        if (this._isMdDirty) {
            d = this._updateMetaData();
        }
        return d;
    },
    _isMetaDataDirty: function() {
        // summary: Indicates whether or not local changes have been made to the metadata for this resource.
        // returns: true if changes have been made, false if not.
        return this._isMdDirty;
    },
    _revertMetaDataChanges: function() {
        // summary: Discards any changes made to the metadata locally.
        this._localMd = {};
        this._isMdDirty = false;
    }
});

dojo.declare("com.ibm.mm.enabler.layouttemplate.LayoutTemplate", [com.ibm.mm.enabler.layouttemplate.WebDAVBackedModifiableMetaData, com.ibm.mm.enabler.layouttemplate.WebDAVBackedModifiableLocalized, com.ibm.mashups.enabler.layouttemplate.LayoutTemplate], {
    LAYOUT_HTML: "layout.html",
    HEAD_HTML: "head.html",
    getURL: function() {
        // summary: Get the URL to the layout.html file.
        // returns: the URL to the layout.html file inside the layout template directory
        var remoteFileURL = this.remoteFile.getURL();
        if (remoteFileURL && remoteFileURL[remoteFileURL.length - 1] !== "/") {
            remoteFileURL += "/";
        }
        return remoteFileURL + this.LAYOUT_HTML;
    },
    getHeadURL: function() {
        // summary: Get the URL to the head.html file.
        // returns: the URL to the head.html file inside the layout template directory
        // IMPORTANT: This method should be removed from the interface.
        return this.remoteFile.getURL() + this.HEAD_HTML;
    },
    getID: function() {
        // summary: Gets a unique identifier for this layout template.
        // returns: a String representing a unique identifier for this template
        return this.remoteFile.getID();
    },
    /**
     * Returns the creation date of the resource.
     * @return {Date} the creation date, never <code>null</code>.
     */
    getCreated: function() {
        if (this.remoteFile && !this.createdTime) {
            var resp = new com.ibm.mm.enabler.remote.WebDavResponseImpl();
            var created = resp.getCreationDate(this.remoteFile._properties, this.getURL());
            if (created) {
                //the created date comes back in a different format than the browser will parse
                //simplistic regexp here... could be more robust
                var dateCheck = /(\d\d\d\d)-(\d\d)-(\d\d)T(\d\d):(\d\d):(\d\d)(\.\d*)Z/;
                var match = created.match(dateCheck);
                if (match) {
                    //skip the first match - it will just be the full string
                    //second match will be the 4 digit year
                    var year = parseInt(match[1], 10);
                    //third match will be the 2 digit month
                    var month = parseInt(match[2], 10);
                    //fourth match will be the 2 digit day
                    var day = parseInt(match[3], 10);
                    //fifth match will be the 2 digit hour
                    var hour = parseInt(match[4], 10);
                    //sixth match will be the 2 digit minute
                    var minute = parseInt(match[5], 10);
                    //seventh match will be the 2 digit second
                    var seconds = parseInt(match[6], 10);
                    
                    var millis = 0;
                    if (match.length > 7) {
                        //this match will start with a period so cut that off and throw it away
                        millis = parseInt(match[7].substring(1), 10);
                    }
                    //the corresponding numbers for the months start at 0 in the Date constructor.
                    created = Date.UTC(year, month - 1, day, hour, minute, seconds, millis);
                }
                
                this.createdTime = new Date(created);
            }
        }
        return this.createdTime;
    },
    /**
     * Returns the modification date of the resource.
     * @return {Date} the modification date, never <code>null</code>.
     */
    getLastModified: function() {
        if (this.remoteFile && !this.lastModifiedTime) {
            var resp = new com.ibm.mm.enabler.remote.WebDavResponseImpl();
            var lastModified = resp.getLastModified(this.remoteFile._properties, this.getURL());
            this.lastModifiedTime = new Date(lastModified);
        }
        return this.lastModifiedTime;
    },
    _isDirty: function() {
        // summary: Indicates if this LayoutTemplate has been changed since the last save.
        // description: Typically only called by the model to query the state of the templates that it has
        //		loaded.
        // returns: true if the layout template has changed; false if it has not
        return this._isMetaDataDirty() || this._isLocalizedDataDirty();
    },
    _commit: function() {
        // summary: Commits the changes for this layout template.
        // returns: a Deferred object that resolves when the save for this template is completed.
        var d1 = this._commitLocalizedChanges();
        var d2 = this._commitMetaDataChanges();
        var retVal;
        
        if (d1 && d2) {
            //There are changes to both the localized data AND the metadata.
            retVal = com.ibm.mm.enabler.layouttemplate.DeferredManager.combine(d1, d2);
        }
        else if (d1 || d2) {
            //There are changes to either the localized data OR the metadata.
            retVal = d1 ? d1 : d2;
        }
        
        return retVal;
    },
    _create: function() {
        var wdi = this.webDavInterface;
        var urls = this.urlHelper;
        var d1 = wdi.createDirectory(urls.baseDirectory + this.remoteFile.getName());
        var d2 = this._commit();
        var retVal = d1;
        if (d2 !== undefined) {
            retVal = com.ibm.mm.enabler.layouttemplate.DeferredManager.combine(d1, d2);
        }
        return retVal;
    },
    _delete: function() {
        var wdi = this.webDavInterface;
        var urls = this.urlHelper;
        var d1 = wdi.remove(urls.baseDirectory + this.remoteFile.getName());
        return d1;
    },
    _revert: function() {
        this._revertLocalizedChanges();
        this._revertMetaDataChanges();
    }
});

}

if(!dojo._hasResource["com.ibm.mashups.enabler.layouttemplate.LayoutTemplate"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.layouttemplate.LayoutTemplate"] = true;
dojo.provide("com.ibm.mashups.enabler.layouttemplate.LayoutTemplate");





}

if(!dojo._hasResource["com.ibm.mashups.enabler.layouttemplate.LayoutTemplateModel_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.layouttemplate.LayoutTemplateModel_API"] = true;
dojo.provide("com.ibm.mashups.enabler.layouttemplate.LayoutTemplateModel_API");
dojo.provide("com.ibm.mashups.enabler.layouttemplate.LayoutTemplateModel");






/**
 * This list model controller exposes layout templates. It allows to add and
 * remove layout templates.
 * 
 * @since 2.4
 * 
 * @ibm-api
 * @ibm-module LayoutTemplateModel
 */
dojo.declare("com.ibm.mashups.enabler.layouttemplate.LayoutTemplateModel", [
		com.ibm.mashups.enabler.ListModelController,
		com.ibm.mashups.enabler.ResourceLocator,
		com.ibm.mashups.enabler.Commitable ], {
	/**
	 * Creates a layout template. Note that it will not appear in the model unless
	 * it is inserted using the <code>insert</code> method.
	 *
	 * @param {JSON} context array of predefined information used for the creation of
	 * the layout template. Must not be <code>null</code>. You must specify all of following:<br>
	 * &nbsp;&nbsp;<b><code>name</code></b> - name as string; mandatory <br>
	 * @return {com.ibm.mashups.enabler.layouttemplate.LayoutTemplate} the created layout template, or <code>null</code> in case
	 * it cannot be created.
	 */
	create : function(context) {
	}
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.layouttemplate.LayoutTemplateModel"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.layouttemplate.LayoutTemplateModel"] = true;
dojo.provide("com.ibm.mm.enabler.layouttemplate.LayoutTemplateModel");







// summary: Wraps the RemoteFileIterator to convert the remote file objects into LayoutTemplate objects.
// IMPORTANT: Synchronous iteration is broken due to the fact that the RemoteFileIterator does not provide
//		support for this type of iteration. Strangely, it also does not implement the setForEachCallback
//		option either. See the LayoutTemplateTests for an example of how to use this iterator until those
//		shortcomings are fixed. The RemoteFileIterator also has a bug where the size returned is too large
//		by one. This implementation works around that bug, but this workaround will need to be removed 
//		when this bug is fixed in the remote iterator.
dojo.declare("com.ibm.mm.enabler.layouttemplate.DeferredIteratorImpl", com.ibm.mashups.enabler.DeferredIterator, {
    constructor: function(baseDirFar, ltModel, remoteModel){
        // important to omit the leading slash!
        //Setup the deferred that will load the iterator.
        var me = this;
        var baseURL = com.ibm.mm.enabler.layouttemplate.TemplateURLHelper.baseDirectory;
        baseDirFar.setFinishedCallback(function(template){
            var hrefs = template._getChildHrefs();
            var l = hrefs.length;
            
            for (var i = 1; i < l; i++) {
                var indexOf = hrefs[i].indexOf(baseURL);
                if (indexOf >= 0) {
                    hrefs[i] = hrefs[i].substring(indexOf);
                }
            }
            
            me._hrefs = hrefs;
        });
        this._deferred = baseDirFar;
        this._ltModel = ltModel;
        this._remoteModel = remoteModel;
        this._position = 1;
        this._hrefs = undefined;
    },
    start: function(sync){
        // summary: Starts the request to retrieve the iterator if it is undefined.
        // sync: indicates if this should be a synchronous request
        // IMPORTANT: sync currently does nothing
        if (sync) {
            console.error("Layout template iterator does not support synchronous iteration currently.");
        }
        if (this._hrefs === undefined) {
            this._deferred.start();
        }
    },
    setForEachCallback: function(callback, parameters){
        // summary: Sets the callback function that will be called for each item in the collection.
        // callback: the callback function
        // parameters: additional parameters to pass to the callback function
        // IMPORTANT: this method does nothing currently
        console.warn("setForEachCallback is not currently enabled in the Remote iterator! This callback will never get called!");
        //this._iterator.setForEachCallback( callback, parameters );
    },
    setFinishedCallback: function(callback, parameters){
        // summary: Sets the callback that is called when the iterator is loaded and initialized.
        // callback: the callback function
        // parameters: additional parameters to pass to the callback function
        var d = new com.ibm.mm.enabler.DeferredImpl(this, function(){
            callback(parameters);
        });
        this._deferred = com.ibm.mm.enabler.layouttemplate.DeferredManager.combine(this._deferred, d);
    },
    //Iterator methods
    hasNext: function(){
        // summary: Indicates if the iterator has any elements remaining.
        // returns: true if another element remains; false if none remain
        if (this._hrefs === undefined) {
            console.error("Iterator has not been loaded yet. Please call start() and call this method in or after the setFinishedCallback() callback is called.");
        }
        else {
            return this._position < this._hrefs.length;
        }
    },
    next: function(){
        // summary: Retrieves the next item in the iteration. Note that calling next() before the iterator 
        //		is defined will automatically wait until the iterator exists before resolving the callback.
        // returns: a Deferred that resolves to the next item in the iteration
        var rv;
        
        var me = this;
        var hrefs = this._hrefs;
        var r = new com.ibm.mm.enabler.layouttemplate.DeferredResolver();
        var next = hrefs === undefined ? undefined : this._hrefs[this._position++];
        var d2 = new com.ibm.mm.enabler.DeferredImpl(this, function(){
			
            var nextItem;
			if (next) {
				if (next.indexOf("access-control.xml") == -1) {
					nextItem = next;
				}
				else {
					nextItem = me._hrefs[me._position++];
				}
			} 
            
			if (nextItem) {
                var nextFar = me._ltModel.find(nextItem);
                nextFar.setFinishedCallback(function(object){
                    if (object) {
                        r.resolve(object);
                    }
                    else {
                        me.next();
                    }
                });
                nextFar.start();
            }
            else {
                r.resolve(undefined);
            }
        });
        r.setDelegate(d2);
        
        rv = this._hrefs === undefined ? com.ibm.mm.enabler.layouttemplate.DeferredManager(this._deferred, d2) : d2;
        
        return rv;
    },
    size: function(){
        // summary: Retrieves the number of elements in this iteration.
        // returns: a Deferred that resolves with the size of the iteration.
        var r = new com.ibm.mm.enabler.layouttemplate.DeferredResolver();
        var size = this._hrefs.length;
        var d = new com.ibm.mm.enabler.DeferredImpl(this, function(){
            //TODO: Fix once the Remote iterator is fixed.
            r.resolve(size - 1);
        });
        r.setDelegate(d);
        
        return d;
    },
    setCursorPosition: function(newPos){
        // summary: Sets the cursor position.
        // IMPORTANT: Only works as much as the remote iterator has implemented it
        //this.start( true );
        this._position = newPos;
    },
    getCursorPosition: function(){
        // summary: Gets the cursor position.
        // returns: the current cursor position
        // IMPORTANT: Only works as much as the remote iterator has implemented it
        //this.start( true );
        return this._position;
    }
});


dojo.declare("com.ibm.mm.enabler.layouttemplate.LayoutTemplateModel", com.ibm.mashups.enabler.layouttemplate.LayoutTemplateModel, {
    constructor: function(){
        this.remoteModel = com.ibm.mashups.enabler.remote.Factory.getRemoteModel();
        this._localCache = {};
        this._baseLayoutLocation = undefined;
    },
    iterator: function(){
        // summary: Retrieves a DeferredIterator that will iterate over the layout templates.
        // returns: a DeferredIterator.
        // IMPORTANT: The DeferredIterator does NOT support the synchronous operation mode. This is due
        //		to the fact that the RemoteModel currently has NO support for synchronous operations. 
        
        var d;
        if (this._baseLayoutLocation === undefined) {
            var baseURL = com.ibm.mm.enabler.layouttemplate.TemplateURLHelper.baseDirectory;
            d = this.remoteModel.find(baseURL);
            var me = this;
            d.setFinishedCallback(function(template){
                me._baseLayoutLocation = template;
            });
        }
        
        var r = new com.ibm.mm.enabler.layouttemplate.DeferredResolver();
        var d2 = new com.ibm.mm.enabler.DeferredImpl(this, function(){
            r.resolve(this._baseLayoutLocation);
        });
        r.setDelegate(d2);
        
        var baseLayoutFar;
        if (d) {
            baseLayoutFar = com.ibm.mm.enabler.layouttemplate.DeferredManager.combine(d, d2);
        }
        else {
            baseLayoutFar = d2;
        }
        
        return new com.ibm.mm.enabler.layouttemplate.DeferredIteratorImpl(baseLayoutFar, this, this.remoteModel);
    },
    find: function(id){
        // summary: Finds the layout template with the given ID. Currently, this ID should be the path
        //		(relative to the WebDAV root) to the layout template directory.
        // returns: a Deferred object that resolves to the LayoutTemplate object requested, if it exists
        return this._deferredFind(id);
    },
    isDirty: function(){
        // summary: Indicates if any of the retrieved layout templates have been modified.
        // returns: true if any templates have changed since the last save; false if not.
        var retVal = false;
        var c = this._localCache;
        for (var node in c) {
            if (Object.prototype.hasOwnProperty.call(c, node) && c[node]._isDirty) {
                retVal = retVal || c[node]._isDirty();
            }
        }
        
        return retVal;
    },
    commit: function(){
        // summary: Commits any changed layout templates.
        // returns: a Deferred that resolves when all save operations are complete
        var c = this._localCache;
        var retVal;
        for (var node in c) {
        
            if (Object.prototype.hasOwnProperty.call(c, node) && c[node]._commit && c[node]._isDirty && c[node]._isDirty()) {
                var d = c[node]._commit();
                if (d) {
                    if (!retVal) {
                        retVal = d;
                    }
                    else {
                        retVal = com.ibm.mm.enabler.layouttemplate.DeferredManager.combine(retVal, d);
                    }
                }
            }
        }
        
        return retVal;
    },
    _deferredFind: function(id){
        // summary: Handles retrieving a template either remotely or locally.
        // returns: a Deferred that resolves when the template is retrieved
        
        //Resolves once the item has been loaded in to the local cache.
        var r = new com.ibm.mm.enabler.layouttemplate.DeferredResolver();
        var newD = new com.ibm.mm.enabler.DeferredImpl(this, function(item){
            r.resolve(this._localCache[id]);
        });
        if (this._localCache[id] === undefined) {
            //The item does not currently exist in the local cache. Request it and resolve the find before
            //resolving the retrieval from local cache.
            var me = this;
            var d = this.remoteModel.find(id);
            d.setFinishedCallback(function(item){
                var n = null;
                if (item.isDirectory()) {
                    n = new com.ibm.mm.enabler.layouttemplate.LayoutTemplate(me.remoteModel, item, com.ibm.mm.enabler.layouttemplate.WebDAVInterface, com.ibm.mm.enabler.layouttemplate.TemplateURLHelper, com.ibm.mm.enabler.layouttemplate.PropertiesFileFacade, true);
                }
                me._localCache[id] = n;
            });
            var suffix = "/";
            if (id.indexOf("access-control.xml") == -1) {
                suffix = "metadata" + suffix;
            }
            var dNLS = this.remoteModel.find(id + suffix);
            dNLS.setFinishedCallback(function(nlsItem){
                me._localCache[id].setRemoteNls(nlsItem);
            });
            
            var d2 = com.ibm.mm.enabler.layouttemplate.DeferredManager.combine(d, dNLS);
            var d3 = com.ibm.mm.enabler.layouttemplate.DeferredManager.combine(d2, newD);
            r.setDelegate(d3);
            return d3;
        }
        else {
            //Item already exists in local cache - this results in an immediate resolution of the Deferred.
            r.setDelegate(newD);
            return newD;
        }
    },
    //create methods
    create: function(context){
        var remoteFile = new com.ibm.mm.enabler.remote.RemoteFileImpl({
            name: context.name,
            isDirectory: true
        });
        var n = new com.ibm.mm.enabler.layouttemplate.LayoutTemplate(this.remoteModel, remoteFile, com.ibm.mm.enabler.layouttemplate.WebDAVInterface, com.ibm.mm.enabler.layouttemplate.TemplateURLHelper, com.ibm.mm.enabler.layouttemplate.PropertiesFileFacade, false);
        return n;
    },
    confirmCreate: function(){
        return true;
    },
    insert: function(layoutTemplate){
        var d = layoutTemplate._create();
        d.start();
    },
    confirmInsert: function(){
        return true;
    },
    remove: function(layoutTemplate){
        var d = layoutTemplate._delete();
        d.start();
    },
    confirmRemove: function(){
        return true;
    }
});

}

if(!dojo._hasResource["com.ibm.mashups.enabler.layouttemplate.LayoutTemplateModel"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.layouttemplate.LayoutTemplateModel"] = true;
dojo.provide("com.ibm.mashups.enabler.layouttemplate.LayoutTemplateModel");





}

if(!dojo._hasResource["com.ibm.mashups.enabler.model.CatalogEntryModel_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.model.CatalogEntryModel_API"] = true;
dojo.provide("com.ibm.mashups.enabler.model.CatalogEntryModel_API");
dojo.provide("com.ibm.mashups.enabler.model.CatalogEntryModel");

/**
 * Interface for a catalog model containing entry nodes. This list model
 * describes a list of concrete catalog entries for a given category.
 * @ibm-api
 * @ibm-module CatalogModel
 */
dojo.declare("com.ibm.mashups.enabler.model.CatalogEntryModel", com.ibm.mashups.enabler.ListModelController, {
    /**
     * creates a new CatalogEnryNode. The created node can be inserted into the
     * model using an appropriate <code>insert</code> method. The node will not
     * appear in the model unless it is inserted.
     * @param {JSON} context array of predefined information
     * used for the creation of the node. May be <code>null</code>. Accepted
     * names are:<br>
     * &nbsp;&nbsp;&nbsp;&nbsp;<code>cid</code> - the client id for the entry
     * to be created (optional)<br>
     * @return {com.ibm.mashups.enabler.catalog.CatalogEntryNode} the created node
     */
    create: function(context){
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.ModelIteratorImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.ModelIteratorImpl"] = true;
dojo.provide("com.ibm.mm.enabler.ModelIteratorImpl");











dojo.declare("com.ibm.mm.enabler.ModelIteratorImpl", [com.ibm.mm.enabler.DeferredIteratorImpl], {
    constructor: function(url, model, parentId) {
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass);
        this.LOG_LEVEL = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
        
        // parent id
        this.parentId = parentId;
        
        // the iterator's model
        this.model = model;
        
        // entries in feed order; undefined entries denote potential 
        // nodes to load; null entry marks end of node collection 
        this.entries = [];
        
        // cursor position
        this.cursor = 0;
        
        // number of nodes
        this.sizeValue = null;
        
        // atom feed
        this.ATOM_FEED = "atom:feed";
        
        // atom entry
        this.ATOM_ENTRY = this.ATOM_FEED + "/atom:entry";
        
        // next link
        this.ATOM_NEXT = this.ATOM_FEED + "/atom:link[@rel='next']";
        
        // size indicator
        this.OPENSEARCH_TOTALRESULTS = this.ATOM_FEED + "/opensearch:totalResults";
        
        if (url) {
            // collection url
            this.collectionUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(url, model);
            
            if (model.strategy) {
                for (var x in model.strategy) {
                    if (com.ibm.mm.enabler.utils.Misc.isInstanceOf(model.strategy[x], com.ibm.mashups.enabler.strategy.ListLoadAheadStrategy)) {
                        // max number of entries 
                        this.collectionUrl.setParameter("num", model.strategy[x].getInterval());
                        // start element (only set with paging) 
                        this.collectionUrl.setParameter("start", this.getCursorPosition());
                        break;
                    }
                }
            }
            
            // let iterator implementations customize the url
            this._customizeUrl(this.collectionUrl);
        }
        
        // number of created nodes to include in this iterator
        this.numCreatedNodes = 0;
        
        // compile key-value pairs for each created node included in this 
        // iterator: (createdId, nextId)
        this._createdNodes = {};
        com.ibm.mm.enabler.utils.Misc.forIn(this.model.createdNodes, function(value, createdId) {
            var createdParent = this.model.getParent(createdId).start();
            if (createdParent && this.parentId == createdParent.getID()) {
                var created = this.model.find(createdId).start();
                // next link of created node
                var next = com.ibm.mashups.enabler.xml.XPath.evaluateEntry("atom:link[@rel='next']", created.getXml(), this.model.ns);
                this._createdNodes[createdId] = next ? com.ibm.mm.enabler.utils.Utils.getIdFromExtUri(this.model.prefix, next) : null;
                this.numCreatedNodes++;
            }
        }, this);
        
        // number of removed nodes not to include in this iterator
        this.numRemovedNodes = 0;
        
        // if the url is not present, removed nodes do not count towards size anymore
        if (url) {
            com.ibm.mm.enabler.utils.Misc.forIn(this.model.deletedNodes, function(value, removedId) {
                var parentLink = com.ibm.mashups.enabler.xml.XPath.evaluateEntry("thr:in-reply-to[@ext:uri]", this.model.deletedNodes[removedId].getXml(), this.model.ns);
                if (parentLink) {
                    if (this.parentId == com.ibm.mm.enabler.utils.Utils.getIdFromExtUri(this.model.prefix, parentLink)) {
                        this.numRemovedNodes++;
                    }
                }
            }, this);
        }
    },
    
    // This abstract function must be implemented for each iterator implementation.
    // It is invoked for each atom entry in the collection, where the atom entry 
    // is passed in as xml data. This function must return an instance of a 
    // resource based on the xml data, or null, in case no node is to be created.
    _createNode: function(xmlData) {
        return null;
    },
    
    // This abstract function allows to modify the collection url, e.g. by adding 
    // url parameters. This method is applied on the url created in the constructor 
    // of the base iterator implementation, as well as on all 'next'-link urls, 
    // which are obtained from collection chunks in order to obtain the next chunk. 
    _customizeUrl: function(url) {
    },
    
    hasNext: function(dfr, sync) {
        if (typeof this.entries[this.cursor] == "undefined") {
            var insertionIndex = 0;
            if (this.collectionUrl) {
                // load nodes from server
                this._loadAhead(dfr || null, true);
                insertionIndex = this.cursor;
            }
            else {
                // do not load entries
                this.entries[0] = null;
            }
            // inject nodes, which are created at runtime
            this._insertCreated(this.entries, insertionIndex);
            
            // reflect number of created/removed nodes in size value
            this.sizeValue = this.sizeValue + this.numCreatedNodes - this.numRemovedNodes;
        }
        
        var candidate = this.entries[this.cursor];
        var hasNext = candidate ? true : false;
        if (hasNext && this.model.deletedNodes && this.model.deletedNodes[candidate]) {
            // do not expose nodes, which are deleted at runtime
            this.cursor++;
            return this.hasNext(dfr, sync);
        }
        return hasNext;
    },
    
    next: function(dfr, sync) {
        return this.hasNext(dfr || null, typeof sync == "undefined" ? true : sync) ? this.model.loadedNodes[this.entries[this.cursor++]] : null;
    },
    
    _insertCreated: function(entries, cursor) {
        while (entries[cursor]) {
            var currentId = entries[cursor];
            for (var createdId in this._createdNodes) {
                if (currentId == this._createdNodes[createdId]) {
                    // insert created node if not done already
                    if (cursor > 0 && entries[cursor - 1] != createdId) {
                        entries.splice(cursor, 0, createdId);
                    }
                }
            }
            cursor++;
        }
        // handle nodes appended to the end of the list
        if (entries[cursor] === null) {
            for (var createdLastId in this._createdNodes) {
                if (null === this._createdNodes[createdLastId]) {
                    entries.splice(cursor, 0, createdLastId);
                    cursor++;
                }
            }
        }
    },
    
    setCursorPosition: function(position) {
        this.cursor = position;
        this.collectionUrl.setParameter("start", position);
    },
    
    getCursorPosition: function() {
        return this.cursor;
    },
    
    size: function() {
        return new com.ibm.mm.enabler.DeferredImpl(this, this._size);
    },
    
    _size: function(dfr, sync) {
        if (!this.sizeValue) {
            this.hasNext(null, true);
        }
        
        // finished callback 
        if (dfr) {
            dfr.finish(this.sizeValue, com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK);
        }
        // convenience
        return this.sizeValue;
    },
    
    start: function(sync) {
        this._loadAhead(this, sync, true);
    },
    
    _loadAhead: function(deferred, sync, iterate) {
        // logging support
        var LOG_METHOD = "_loadAhead";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, arguments);
        }
        
        // handle empty iterator
        if (!this.collectionUrl) {
            this.entries[this.cursor] = null;
            if (deferred) {
                deferred.finish(null, com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK);
            }
            return;
        }
        
        // service request
        var serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(this.collectionUrl, null, null, false, sync);
        serviceReq.read(dojo.hitch(this, function(type, data, xhr, args) {
            if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_LOAD) {
            
                // fetch size
                this.sizeValue = com.ibm.mashups.enabler.xml.XPath.evaluateNumber(this.OPENSEARCH_TOTALRESULTS, data, this.model.ns);
                
                // iterate atom entries
                var c = 0;
                var nodes = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(this.ATOM_ENTRY, data, this.model.ns);
                if (nodes) {
                    for (var i = 0, l = nodes.length; i < l; i++) {
                        // instantiate node
                        var node = this._createNode(nodes[i]);
                        if (node) {
                            // put id in entry list
                            this.entries[this.cursor + c++] = node.getID();
                            
                            // callback handling
                            if (deferred) {
                                deferred.nextFinish(node);
                            }
                        }
                        else {
                            // an entry for which no node is instantiated  
                            // does not count towards collection size
                            this.sizeValue--;
                        }
                    }
                }
                // check for 'next'-link on feed level
                var next = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(this.ATOM_NEXT, data, this.model.ns);
                if (next) {
                    var url = next.getAttribute("href");
                    
                    // set collection url from 'next'-link
                    this.collectionUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(url, this.model);
                    
                    // let iterator implementations customize the url
                    this._customizeUrl(this.collectionUrl);
                    if (nodes && iterate) {
                        // was last next element
                        this._loadAhead(deferred, sync, iterate);
                    }
                }
                else {
                    // mark end of collection
                    this.entries[this.cursor + c] = null;
                    
                    // finished callback (end of collection)
                    if (deferred) {
                        deferred.finish(null, xhr.status);
                    }
                }
            }
            else {
                // finished callback (error)
                if (deferred) {
                    deferred.finish(null, xhr.status);
                }
            }
        }));
        // exit trace
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD);
        }
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.catalog.CatalogEntryIteratorImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.catalog.CatalogEntryIteratorImpl"] = true;
// APIs



// Implementations





dojo.provide("com.ibm.mm.enabler.catalog.CatalogEntryIteratorImpl");

// navigation model iterator
dojo.declare("com.ibm.mm.enabler.catalog.CatalogEntryIteratorImpl", [com.ibm.mm.enabler.ModelIteratorImpl], {    
    _createNode: function(xmlData) {
		// instantiate node
		var node = new com.ibm.mm.enabler.catalog.CatalogEntryNodeImpl(xmlData);

		// cache node in model
        node = this.model._cacheNode(node);

        return node;
    },
    
    _customizeUrl: function(url) {
		// access control info
        url.addParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT_VALUE_ACCESS_CONTROL);
        
		// full representation
        url.setParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_REPRESENTATION, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_REPRESENTATION_VALUE_FULL);

		// hidden meta data
		this.model._applyHiddenMetaDataLoadingStrategyToModelURL(url);
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.strategy.HiddenMetaDataLoadingStrategyHelperImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.strategy.HiddenMetaDataLoadingStrategyHelperImpl"] = true;
dojo.provide("com.ibm.mm.enabler.strategy.HiddenMetaDataLoadingStrategyHelperImpl");




dojo.declare("com.ibm.mm.enabler.strategy.HiddenMetaDataLoadingStrategyHelperImpl", null, {

	_applyHiddenMetaDataLoadingStrategyToModelURL: function(modelURL) {
		var s = this._findStrategyByType("com.ibm.mashups.enabler.strategy.HiddenMetaDataLoadingStrategy");
		if (s) {
			dojo.forEach(s.getHiddenMetaDataToLoad(), function(name) {
				modelURL.addParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_MDNAME, name);
			});
		}
	}
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.catalog.CatalogEntryModelImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.catalog.CatalogEntryModelImpl"] = true;
dojo.provide("com.ibm.mm.enabler.catalog.CatalogEntryModelImpl");

































// catalog entry model
dojo.declare("com.ibm.mm.enabler.catalog.CatalogEntryModelImpl", [com.ibm.mashups.enabler.model.CatalogEntryModel, com.ibm.mashups.enabler.ListModel, com.ibm.mm.enabler.DeferredIteratorImpl, com.ibm.mm.enabler.model.ModelImpl, com.ibm.mm.enabler.ConfirmableModelImpl, com.ibm.mm.enabler.strategy.HiddenMetaDataLoadingStrategyHelperImpl], {
    constructor: function(category, parentModel) {
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass);
        this.LOG_LEVEL = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
        
        this.category = category;
        this.parentModel = parentModel;
        this.strategy = parentModel.strategy;
        this.loadedNodes = {};
        this.createdNodes = {};
        this.deletedNodes = {};
        this.initialContents = {};
        this.nodeIds = [];
        this.cid = 0;
        
        // service document and initialization
        this.serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_CATALOG);
        this.prefix = this.serviceJson.idprefix;
        var nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
        this.ns = dojo.delegate(this.serviceJson.namespaces, nsf.getNameSpaces([nsf.NS_ATOM, nsf.NS_THR, nsf.NS_XML, nsf.NS_OPENSEARCH, nsf.NS_XSI]));
        
        var node = com.ibm.mashups.enabler.xml.XPath.evaluateEntry("atom:link[@ext:rel='entries']", this.category.xmlData, this.ns);
        this.collectionUrl = node.getAttribute("href");
    },
    
    find: function(uri) {
        return new com.ibm.mm.enabler.DeferredImpl(this, this._find, uri);
    },
    
    _find: function(deferred, sync, uri) {
        // logging support
        var LOG_METHOD = "_find";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, [deferred, sync, uri]);
        }
        
        if (this.category.getID() == "CATROOT") {
            return null;
        }
        if (uri in this.deletedNodes) {
            if(deferred) { deferred.finish(null, com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_NOT_FOUND); }
            return null;
        }
        if (uri in this.loadedNodes) {
            // fetch node from cache
            if (deferred && deferred.getFinishedCallback()) {
                // callback handling
                if(deferred) { deferred.finish(this.loadedNodes[uri], com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK); }
            } else {
                return this.loadedNodes[uri];
            }
        }
        else {
            // prepare xhr
            var myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(com.ibm.mashups.enabler.model.url.ModelUrlFactory.CATALOG_URL, this);
            myUrl.setNodes([{
                value: com.ibm.mm.enabler.utils.Misc.encodeModelID4Uri(uri),
                isID: true
            }, {
                value: com.ibm.mm.enabler.utils.Misc.encodeModelID4Uri(this.category.getID()),
                isID: true
            }]);
            myUrl.setParameter("rep", "full");
            myUrl.addParameter("aspect", "ac");
            var serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
            var entry = null;
            var result = {};
            serviceReq.read(dojo.hitch(this, function(type, data, xhr, args) {
                // obtain node
                var expr = "atom:feed/atom:entry";
                var node = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, data, this.ns);
                if (node) {
                    this._cacheNode(new com.ibm.mm.enabler.catalog.CatalogEntryNodeImpl(node));
                }
                // callback handling
                if(deferred) { deferred.finish(this.loadedNodes[uri] || null, xhr.status); }
                // handle error in sync call
                if (sync && type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_ERROR) {
                    // do not expose HTTP_NOT_FOUND; simply return null in this case
                    if (xhr.status != com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_NOT_FOUND) {
                        result.status = xhr.status;
                    }
                }
            }));
            
            if (result.status) {
                throw new Error(dojo.string.substitute(this.modelMessages.E_CATNODE_NOTFOUND_1, [uri, result.status]));
            }
        }
        // exit trace
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD);
        }
        return this.loadedNodes[uri];
    },
    
    _cacheNode: function(node) {
        var id = node.getID();
        if (!(id in this.loadedNodes)) {
            this.loadedNodes[id] = node;
            this.initialContents[id] = node.toString();
        }
        return this.loadedNodes[id];
    },
    
    iterator: function() {        
    	if (!this.entries) {
    		this.entries = new com.ibm.mm.enabler.catalog.CatalogEntryIteratorImpl(this.collectionUrl, this);
    	} else {			   
    		this.entries.setCursorPosition(0);
    	}
        return this.entries;
    },
    
    create: function(context) {
        // logging support
        var LOG_METHOD = "create";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, [context]);
        }
        
        var clientId;
        if (context && context.cid) {
            // use cid specified with context
            clientId = context.cid;
        }
        else {
            // use generated cid
            clientId = "" + this.cid++;
        }
        var entry = com.ibm.mm.enabler.utils.Utils.createNode("atom:entry", this.ns.atom);
        var idElement = com.ibm.mm.enabler.utils.Utils.createNode("atom:id", this.ns.atom);
        com.ibm.mm.enabler.utils.Dom.textContent(idElement, "cid:" + clientId + "@" + this.prefix + ":" + this.category.getID());
        entry.appendChild(idElement);
        var contentElement = com.ibm.mm.enabler.utils.Utils.createNode("atom:content", this.ns.atom);
        entry.appendChild(contentElement);
        var catalogEntryElement = com.ibm.mm.enabler.utils.Utils.createNode("model:catalog-entry", this.ns.model);
        contentElement.appendChild(catalogEntryElement);
        catalogEntryElement.appendChild(com.ibm.mm.enabler.utils.Utils.createNode("model:title", this.ns.model));
        catalogEntryElement.appendChild(com.ibm.mm.enabler.utils.Utils.createNode("model:description", this.ns.model));
        catalogEntryElement.appendChild(com.ibm.mm.enabler.utils.Utils.createExtLinkNode("", null, "definition"));
        catalogEntryElement.appendChild(com.ibm.mm.enabler.utils.Utils.createExtLinkNode("", null, "icon"));
        catalogEntryElement.appendChild(com.ibm.mm.enabler.utils.Utils.createExtLinkNode("", null, "preview"));
        catalogEntryElement.appendChild(com.ibm.mm.enabler.utils.Utils.createExtLinkNode("", null, "previewThumbnail"));
        catalogEntryElement.appendChild(com.ibm.mm.enabler.utils.Utils.createExtLinkNode("", null, "help"));
        var ret = new com.ibm.mm.enabler.catalog.CatalogEntryNodeImpl(entry);
        
        // exit trace
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD, [ret]);
        }
        
        return ret;
    },
    confirmCreate: function(context) {
        return this.getConfirmCreate();
    },
    
    insert: function(node, nextNode) {
        // logging support
        var LOG_METHOD = "insert";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, [node, nextNode]);
        }
        var id = node.getID();
        // check if the node is inserted or moved
        if (!(id in this.loadedNodes)) {
            // cache node
            this.loadedNodes[id] = node;
            // mark as created
            this.createdNodes[id] = null;
        }
        // exit trace
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD);
        }
    },
    confirmInsert: function(node, nextNode) {
        return this.getConfirmInsert();
    },
    
    remove: function(node) {
        // logging support
        var LOG_METHOD = "remove";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, [node]);
        }
        
        var id = (com.ibm.mm.enabler.utils.Misc.isInstanceOf(node, com.ibm.mm.enabler.catalog.CatalogEntryNodeImpl)) ? node.getID() : node;
        // mark node as deleted
        if (!(id in this.deletedNodes)) {
            this.deletedNodes[id] = this.loadedNodes[id];
        }
        // remove cache entry
        if (id in this.loadedNodes) {
            delete this.loadedNodes[id];
        }
        // exit trace
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD);
        }
    },
    confirmRemove: function(node) {
        return this.getConfirmRemove(node);
    },
    
    // internal commit
    _commit: function(deferred, sync, mpHandler) {
        // logging support
        var LOG_METHOD = "_commit";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, [deferred, sync, mpHandler]);
        }
        
        var serviceReq;
        var myUrl, urlId;
        
        for (var id in this.loadedNodes) {
			if (Object.prototype.hasOwnProperty.call(this.loadedNodes,id)) {
				var nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
				var entry = com.ibm.mm.enabler.utils.Utils.createFeed("catalog:" + id, "IBM Lotus Mashups Catalog Feed", this.loadedNodes[id], this.ns);
				if (id in this.createdNodes) {
					// handle created nodes
					myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(this.collectionUrl, this);
					
					// HTTP POST created nodes
					this.parentModel._acquire();
					serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
					serviceReq.create(entry, dojo.hitch(this, function(type, data, xhr, args){
						if (deferred) {
							// public callback handling
							if (deferred.operationCallback) {
								deferred.operationCallback(this.loadedNodes[args], com.ibm.mashups.enabler.DeferredOperation.OPERATION_CREATE, xhr.status, deferred.operationCallbackParameters);
							}
							// internal callback handling
							if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_ERROR) {
								if (deferred.errorCallback) {
									deferred.errorCallback(xhr.status, deferred.errorCallbackParameters);
								}
							}
							else {
								this.length++;
							}
						}
						this.parentModel._release(deferred, xhr.status);
					}), id); // JSLINT-IGNORE: Enabler Team decided to keep this paradigma from dojo in tact
				}
				else {
					// skip  unmodified nodes
					if (this.initialContents[id] === this.loadedNodes[id].toString()) {
						continue;
					}
					// handle modified nodes
                    var _editLink = this.loadedNodes[id].getEditLink(true);
                    if (!_editLink) {
                        if (deferred) {
                            // public callback handling
                            if (deferred.operationCallback) {
                                deferred.operationCallback(this.loadedNodes[id], com.ibm.mashups.enabler.DeferredOperation.OPERATION_MODIFY, 403, deferred.operationCallbackParameters);
                            }
                        }
                    }
                    else {
                        myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(_editLink, this);
                        
                        // HTTP PUT modified nodes
                        myUrl.setParameter("update", "replace");
                        this.parentModel._acquire();
                        serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
                        serviceReq.update(entry, dojo.hitch(this, function(type, data, xhr, args){
                            if (deferred) {
                                // public callback handling
                                if (deferred.operationCallback) {
                                    deferred.operationCallback(this.loadedNodes[args], com.ibm.mashups.enabler.DeferredOperation.OPERATION_MODIFY, xhr.status, deferred.operationCallbackParameters);
                                }
                                // internal callback handling
                                if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_ERROR) {
                                    if (deferred.errorCallback) {
                                        deferred.errorCallback(xhr.status, deferred.errorCallbackParameters);
                                    }
                                }
                            }
                            this.parentModel._release(deferred, xhr.status);
                        }), id); // JSLINT-IGNORE: Enabler Team decided to keep this paradigma from dojo in tact
                        // mark new contents
                        this.initialContents[id] = this.loadedNodes[id].toString();
                    }
				}
				// unmark created nodes
				this.createdNodes = {};
			}
		}
        
        // HTTP DELETE deleted nodes
        for (var id2 in this.deletedNodes) {
			if (Object.prototype.hasOwnProperty.call(this.deletedNodes,id2)) {
				myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(this.deletedNodes[id2].getEditLink(), this);
				
				this.parentModel._acquire();
				serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
				serviceReq.remove(dojo.hitch(this, function(type, data, xhr, args){
					if (deferred) {
						// public callback handling
						if (deferred.operationCallback) {
							deferred.operationCallback(args, com.ibm.mashups.enabler.DeferredOperation.OPERATION_CREATE, xhr.status, deferred.operationCallbackParameters);
						}
						if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_ERROR) {
							if (deferred.errorCallback) {
								deferred.errorCallback(xhr.status, deferred.errorCallbackParameters);
							}
						}
					}
					this.parentModel._release(deferred, xhr.status);
				}), id2); // JSLINT-IGNORE: Enabler Team decided to keep this paradigma from dojo in tact
			}
		}
        
        // unmark deleted nodes
        this.deletedNodes = {};
        
        // exit trace
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD);
        }
    }
});

}

if(!dojo._hasResource["com.ibm.mashups.enabler.model.CatalogEntryModel"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.model.CatalogEntryModel"] = true;
dojo.provide("com.ibm.mashups.enabler.model.CatalogEntryModel");







}

if(!dojo._hasResource["com.ibm.mashups.enabler.model.CatalogCategoryModel_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.model.CatalogCategoryModel_API"] = true;
dojo.provide("com.ibm.mashups.enabler.model.CatalogCategoryModel_API");
dojo.provide("com.ibm.mashups.enabler.model.CatalogCategoryModel");

/**
 * Interface for a catalog model containing category nodes. This tree model
 * describes the topology in which the categories are structured.
 * As of now only one level below the root is supported; no child categories.
 * @ibm-api
 * @ibm-module CatalogModel
 */
dojo.declare("com.ibm.mashups.enabler.model.CatalogCategoryModel", com.ibm.mashups.enabler.TreeModelController, {
    /**
     * Returns the catalog entry model for the given category.
     * @param {com.ibm.mashups.enabler.catalog.CatalogCategoryNode} category the CatalogCategoryNode for which
     * to return the CatalogEntryModel; must not be <code>null</code>
     * @type com.ibm.mashups.enabler.catalog.CatalogEntryModel
     * @return catalog entry model for given category, Never <code>null</code>.
     */
    getCatalogEntryModel: function(category){
    },
    
    /**
     * creates a new CatalogCategoryNode. The created node can be inserted into
     * the model using an appropriate <code>insert</code> method. The node will
     * not appear in the model unless it is inserted.
     * @param {JSON} context array of predefined information
     * used for the creation of the node. May be <code>null</code>. Accepted names are:<br>
     * &nbsp;&nbsp;&nbsp;&nbsp;<code>category</code> - the name of the category
     * to be created (mandatory)<br>
     * @type com.ibm.mashups.enabler.catalog.CatalogCategoryNode
     * @return the created node
     */
    create: function(context){
    },
    
    /**
     * Commits the modifications applied to this model and all dependent models.<br>
     * @return {DeferredOperation} a deferred object used to start this operation. 
     * The return value when executed through the deferred object is <code>null</null>
     */
    commit: function(){
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.catalog.CatalogCategoryIteratorImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.catalog.CatalogCategoryIteratorImpl"] = true;
// APIs



// Implementations





dojo.provide("com.ibm.mm.enabler.catalog.CatalogCategoryIteratorImpl");

// navigation model iterator
dojo.declare("com.ibm.mm.enabler.catalog.CatalogCategoryIteratorImpl", [com.ibm.mm.enabler.ModelIteratorImpl], {    
    _createNode: function(xmlData) {
		// instantiate node
		var node = new com.ibm.mm.enabler.catalog.CatalogCategoryNodeImpl(xmlData);

		// cache node in model
        node = this.model._cacheNode(node);

        return node;
    },
    
    _customizeUrl: function(url) {
		// access control info
        url.addParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT_VALUE_ACCESS_CONTROL);
        
		// full representation
        url.setParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_REPRESENTATION, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_REPRESENTATION_VALUE_FULL);

		// hidden meta data
		this.model._applyHiddenMetaDataLoadingStrategyToModelURL(url);
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.catalog.CatalogCategoryModelImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.catalog.CatalogCategoryModelImpl"] = true;
dojo.provide("com.ibm.mm.enabler.catalog.CatalogCategoryModelImpl");



































// catalog category model
dojo.declare("com.ibm.mm.enabler.catalog.CatalogCategoryModelImpl", [com.ibm.mashups.enabler.model.CatalogCategoryModel, com.ibm.mm.enabler.model.ModelImpl, com.ibm.mm.enabler.ConfirmableModelImpl, com.ibm.mm.enabler.strategy.HiddenMetaDataLoadingStrategyHelperImpl], {
    constructor: function() {
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass);
        this.LOG_LEVEL = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
        
        this.root = null;
        this.loadedNodes = {};
        this.createdNodes = {};
        this.deletedNodes = {};
        this.initialContents = {};
        this.entryModels = {};
        // service document and initialization
        this.serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_CATALOG);
        this.entryUrl = this.serviceJson.url;
        this.prefix = this.serviceJson.idprefix;
        var nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
        this.ns = dojo.delegate(this.serviceJson.namespaces, nsf.getNameSpaces([nsf.NS_ATOM, nsf.NS_THR, nsf.NS_XML, nsf.NS_OPENSEARCH]));
    },
    
    // singleton
    getInstance: function() {
        var instance = com.ibm.mm.enabler.catalog.CatalogCategoryModelImpl._instance;
        return instance ? instance : (com.ibm.mm.enabler.catalog.CatalogCategoryModelImpl._instance = new com.ibm.mm.enabler.catalog.CatalogCategoryModelImpl());
    },
    
    getCatalogEntryModel: function(category) {
        if (!(category in this.entryModels)) {
            this.entryModels[category] = new com.ibm.mm.enabler.catalog.CatalogEntryModelImpl(category, this);
        }
        return this.entryModels[category];
    },
    
    _cacheNode: function(node) {
        var id = node.getID();
        if (!(id in this.loadedNodes)) {
            this.loadedNodes[id] = node;
            this.initialContents[id] = node.toString();
        }
        return this.loadedNodes[id];
    },
    
    find: function(uri) {
        return new com.ibm.mm.enabler.DeferredImpl(this, this._find, uri);
    },
    
    _find: function(deferred, sync, uri) {
        // logging support
        var LOG_METHOD = "_find";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, [deferred, sync, uri]);
        }
        
        // check if node is deleted in controller scope
        if (uri in this.deletedNodes) {
            // callback handling
            if (deferred) {
                deferred.finish(null, com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_NOT_FOUND);
            }
            return null;
        }
        
        // fetch node from cache
        if (uri in this.loadedNodes) {
            // public callback handling
            if (deferred) {
                deferred.finish(this.loadedNodes[uri], com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK);
            }
        }
        else {
            // prepare xhr
            var myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(com.ibm.mashups.enabler.model.url.ModelUrlFactory.CATALOG_URL, this);
            myUrl.setNodes([{
                value: com.ibm.mm.enabler.utils.Misc.encodeModelID4Uri(uri),
                isID: true
            }]);
            myUrl.setParameter("rep", "full");
            myUrl.addParameter("aspect", "ac");
            var serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
            var entry = null;
            var result = {};
            serviceReq.read(dojo.hitch(this, function(type, data, xhr, args) {
                // obtain node
                var expr = "atom:feed/atom:entry";
                var node = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, data, this.ns);
                if (node) {
                    var entry = new com.ibm.mm.enabler.catalog.CatalogCategoryNodeImpl(node);
                    if (entry !== null) {
                        entry.setParentModel(this);
                        if (!(uri in this.loadedNodes)) {
                            this.loadedNodes[uri] = entry;
                            this.initialContents[uri] = entry.toString();
                        }
                    }
                }
                // handle callback
                if (deferred) {
                    deferred.finish(this.loadedNodes[uri] || null, xhr.status);
                }
                // handle error in sync call
                if (sync && type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_ERROR) {
                    // do not expose HTTP_NOT_FOUND; simply return null in this case
                    if (xhr.status != com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_NOT_FOUND) {
                        result.status = xhr.status;
                    }
                }
            }));
            if (result.status) {
                throw new Error(dojo.string.substitute(this.modelMessages.E_CCATNODE_NOTFOUND_1, [uri, result.status]));
            }
            
        }
        // exit trace
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD);
        }
        return this.loadedNodes[uri];
    },
    
    create: function(context) {
        // logging support
        var LOG_METHOD = "create";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, [context]);
        }
        var ret = null;
        if (context && context.category) {
            var entry = com.ibm.mm.enabler.utils.Utils.createNode("atom:entry", this.ns.atom);
            var idElement = com.ibm.mm.enabler.utils.Utils.createNode("atom:id", this.ns.atom);
            com.ibm.mm.enabler.utils.Dom.textContent(idElement, "catalog:" + this.prefix + ":" + context.category);
            entry.appendChild(idElement);
            entry.appendChild(com.ibm.mm.enabler.utils.Utils.createNode("atom:title", this.ns.atom));
            entry.appendChild(com.ibm.mm.enabler.utils.Utils.createNode("atom:summary", this.ns.atom));
            entry.appendChild(com.ibm.mm.enabler.utils.Utils.createNode("atom:published", this.ns.atom));
            entry.appendChild(com.ibm.mm.enabler.utils.Utils.createNode("atom:updated", this.ns.atom));
            var contentElement = com.ibm.mm.enabler.utils.Utils.createNode("atom:content", this.ns.atom);
            entry.appendChild(contentElement);
            var catalogCategoryElement = com.ibm.mm.enabler.utils.Utils.createNode("model:catalog-category", this.ns.model);
            contentElement.appendChild(catalogCategoryElement);
            catalogCategoryElement.appendChild(com.ibm.mm.enabler.utils.Utils.createNode("model:title", this.ns.model));
            catalogCategoryElement.appendChild(com.ibm.mm.enabler.utils.Utils.createNode("model:description", this.ns.model));
            ret = new com.ibm.mm.enabler.catalog.CatalogCategoryNodeImpl(entry);
        }
        // exit trace
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD, [ret]);
        }
        return ret;
    },
    confirmCreate: function(context) {
        return this.getConfirmCreate();
    },
    
    commit: function() {
        return new com.ibm.mm.enabler.DeferredOperationImpl(this, this._commit);
    },
    
    _commit: function(deferred, sync) {
        // logging support
        var LOG_METHOD = "_commit";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, [deferred, sync]);
        }
        // initialize callback handling
        this.statusCode = com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK;
        this.requestCount = 0;
        this._acquire();
        var serviceReq;
        // commit category model changes
        for (var id in this.loadedNodes) {
            if (Object.prototype.hasOwnProperty.call(this.loadedNodes,id)) {
                var time = new Date();
                var entry = '<?xml version="1.0" encoding="UTF-8"?>\n' +
                this.loadedNodes[id];
                var createUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(this.entryUrl, this);
                if (id in this.createdNodes) {
                    // HTTP POST created nodes
                    this._acquire();
                    serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(createUrl, null, null, false, sync);
                    serviceReq.create(entry, dojo.hitch(this, function(type, data, xhr, args) {
                        if (deferred) {
                            // public callback handling
                            if (deferred.operationCallback) {
                                deferred.operationCallback(this.loadedNodes[args], com.ibm.mashups.enabler.DeferredOperation.OPERATION_CREATE, xhr.status, deferred.operationCallbackParameters);
                            }
                            // internal callback handling
                            if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_ERROR) {
                                if (deferred.errorCallback) {
                                    deferred.errorCallback(xhr.status, deferred.errorCallbackParameters);
                                }
                            }
                        }
                        this._release(deferred, xhr.status);
                    }), id); // JSLINT-IGNORE: Enabler Team decided to keep this paradigma from dojo in tact
                }
                else {
                    // skip  unmodified nodes
                    if (this.initialContents[id] === this.loadedNodes[id].toString()) {
                        continue;
                    }
                    // HTTP PUT modified nodes
                    var updateUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(this.loadedNodes[id].getEditLink(), this);
                    updateUrl.setParameter("update", "replace");
                    this._acquire();
                    serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(updateUrl, null, null, false, sync);
                    serviceReq.update(entry, dojo.hitch(this, function(type, data, xhr, args) {
                        if (deferred) {
                            // public callback handling
                            if (deferred.operationCallback) {
                                deferred.operationCallback(this.loadedNodes[args], com.ibm.mashups.enabler.DeferredOperation.OPERATION_MODIFY, xhr.status, deferred.operationCallbackParameters);
                            }
                            // internal callback handling
                            if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_ERROR) {
                                if (deferred.errorCallback) {
                                    deferred.errorCallback(xhr.status, deferred.errorCallbackParameters);
                                }
                            }
                        }
                        this._release(deferred, xhr.status);
                    }), id); // JSLINT-IGNORE: Enabler Team decided to keep this paradigma from dojo in tact
                }
            }
        }
        
        // HTTP DELETE deleted nodes
        for (var deleted_id in this.deletedNodes) {
            if (Object.prototype.hasOwnProperty.call(this.deletedNodes,deleted_id)) {
                var deleteUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(this.deletedNodes[deleted_id].getEditLink(), this);
                this._acquire();
                serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(deleteUrl, null, null, false, sync);
                serviceReq.remove(dojo.hitch(this, function(type, data, xhr, args) {
                    if (deferred) {
                        // public callback handling
                        if (deferred.operationCallback) {
                            deferred.operationCallback(args, com.ibm.mashups.enabler.DeferredOperation.OPERATION_DELETE, xhr.status, deferred.operationCallbackParameters);
                        }
                        // internal callback handling
                        if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_ERROR) {
                            if (deferred.errorCallback) {
                                deferred.errorCallback(xhr.status, deferred.errorCallbackParameters);
                            }
                        }
                    }
                    this._release(deferred, xhr.status);
                }), deleted_id); // JSLINT-IGNORE: Enabler Team decided to keep this paradigma from dojo in tact
            }
        }
        
        // commit the entry model changes
        for (var entry_id in this.entryModels) {
            if (Object.prototype.hasOwnProperty.call(this.entryModels,entry_id)) {
                this.entryModels[entry_id]._commit(deferred, sync);
            }
        }
        
        // the finishedCallback is called in _release
        this._release(deferred, 0);
        
        // exit trace
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD);
        }
    },
    
    // acquire semaphore
    _acquire: function() {
        this.requestCount++;
    },
    
    // release semaphore
    _release: function(deferred, statusCode) {
        // set overall status Code
        this.statusCode = Math.max(parseInt(statusCode, 10), this.statusCode);
        // check for full release
        this.requestCount--;
        if (this.requestCount <= 0) {
            if (deferred) {
                deferred.finish(null, this.statusCode);
            }
        }
    },
    
    getRoot: function() {
        return new com.ibm.mm.enabler.DeferredImpl(this, this._getRoot);
    },
    
    _getRoot: function(deferred, sync) {
        if (this.root === null) {
            var node = com.ibm.mm.enabler.utils.Utils.createNode("atom:entry", this.ns.atom);
            node.appendChild(com.ibm.mm.enabler.utils.Utils.createNode("atom:id", this.ns.atom));
            this.root = new com.ibm.mm.enabler.catalog.CatalogCategoryNodeImpl(node);
            this.root.setParentModel(this);
            this.root.setID("CATROOT");
        }
        return this.root;
    },
    
    hasChildren: function(node) {
        return (node.getID() == "CATROOT") ? true : false;
    },
    
    getChildren: function(node) {
        // fix collection url
        if (!this.children) {
            this.children = new com.ibm.mm.enabler.catalog.CatalogCategoryIteratorImpl(this.serviceJson.url, this);
        }
        else {
            this.children.setCursorPosition(0);
        }
        return this.children;
    },
    
    getParent: function(uri) {
        return new com.ibm.mm.enabler.DeferredImpl(this, this._getParent, uri);
    },
    
    _getParent: function(deferred, sync, node) {
        return (node.getID() == "CATROOT") ? null : this.getRoot();
    },
    
    insert: function(node) {
        // cache and mark as created
        this.loadedNodes[node.getID()] = node;
        this.createdNodes[node.getID()] = null;
    },
    confirmInsert: function(node) {
        return this.getConfirmCreate();
    },
    
    remove: function(node) {
        // logging support
        var LOG_METHOD = "remove";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, [node]);
        }
        
        var id = (com.ibm.mm.enabler.utils.Misc.isInstanceOf(node, com.ibm.mm.enabler.catalog.CatalogCategoryNodeImpl)) ? node.getID() : node;
        // mark node as deleted
        if (!(id in this.deletedNodes)) {
            this.deletedNodes[id] = this.loadedNodes[id];
        }
        // remove cache entry
        if (id in this.loadedNodes) {
            delete this.loadedNodes[id];
        }
        // exit trace
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD);
        }
    },
    confirmRemove: function(node) {
        return this.getConfirmRemove(node);
    }
});

}

if(!dojo._hasResource["com.ibm.mashups.enabler.model.CatalogCategoryModel"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.model.CatalogCategoryModel"] = true;
dojo.provide("com.ibm.mashups.enabler.model.CatalogCategoryModel");









}

if(!dojo._hasResource["com.ibm.mashups.enabler.wire.Wire_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.wire.Wire_API"] = true;
dojo.provide("com.ibm.mashups.enabler.wire.Wire_API");
dojo.provide("com.ibm.mashups.enabler.wire.Wire");



/**
 * Interface for a wire.
 *
 * @since 2.4
 *
 * @ibm-api
 * @ibm-module WireModel
 */
dojo.declare("com.ibm.mashups.enabler.wire.Wire", [com.ibm.mashups.enabler.Identifiable], {

    /**
     * Returns the identifier of the source widget associated with this wire
     *
     * @return {com.ibm.mashups.enabler.Identifiable} the widget instance identifier
     */
    getSourceWidget: function(){
    },
    
    /**
     * Returns the identifier of the source event associated with this wire.
     *
     * @return {com.ibm.mashups.enabler.Identifiable} the source event
     */
    getSourceEvent: function(){
    },
	
    /**
     * Returns the name of the source event associated with this wire.
     *
     * @return {String} the event name
     */
    getSourceEventName: function(){
    },
    
    /**
     * Returns the identifier of the source page associated with this wire.
     *
     * @return {com.ibm.mashups.enabler.Identifiable} the page identifier
     */
    getSourcePage: function(){
    },
    
    /**
     * Returns the identifier of the target widget associated with this wire.
     *
     * @return {com.ibm.mashups.enabler.Identifiable} the widget instance identifier
     */
    getTargetWidget: function(){
    },
    
    /**
     * Returns the identifier of the target event associated with this wire.
     *
     * @return {com.ibm.mashups.enabler.Identifiable} the target event
     */
    getTargetEvent: function(){
    },
	
    /**
     * Returns the name of the target event associated with this wire.
     *
     * @return {String} the event name
     */
    getTargetEventName: function(){
    },
    
    /**
     * Returns the identifier of the target page associated with this wire.
     *
     * @return {com.ibm.mashups.enabler.Identifiable} the page identifier
     */
    getTargetPage: function(){
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.wire.WireImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.wire.WireImpl"] = true;
dojo.provide("com.ibm.mm.enabler.wire.WireImpl");









dojo.declare("com.ibm.mm.enabler.wire.WireImpl", [com.ibm.mashups.enabler.wire.Wire, com.ibm.mm.enabler.persistence.xml.IdentifiableXmlImpl], {
    constructor: function(node, _wireModel) {
        this.xmlData = node;
        this.wireModel = _wireModel;
        this.idService = com.ibm.mashups.enabler.services.IdentificationService;
    },
    _getWireModel: function() {
        return this.wireModel;
    },
    
    toString: function() {
        return com.ibm.mm.enabler.utils.Dom.innerXML(this.xmlData);
    },
    
    _getWireModelUrl: function() {
        return this.wireModel.href;
    },
    
    _getWireUri: function() {
        var expr = "atom:id";
        var node = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, this.xmlData, this.wireModel.ns);
        if (node) {
            return dojo.string.trim(com.ibm.mm.enabler.utils.Dom.textContent(node));
        }
        return null;
    },
    
    _getNode: function(property) {
        var expr = "atom:link[@ext:rel='" + property + "']";
        var node = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, this.xmlData, this.wireModel.ns);
        return node || null;
    },
    
    _getIdentifier: function(property) {
        var result = null;
        var node = this._getNode(property);
        if (node) {
            var id = null;
            var uri = com.ibm.mm.enabler.utils.Dom.getAttributeWithNS(node, "ext:uri", "uri", this.wireModel.ns.ext);
            
            // FIXME use code from IdentifiableHelper
            if (uri) {
                // check for associative id
                var aPos = uri.indexOf("@");
                if (aPos != -1) {
                    uri = uri.slice(0, aPos);
                }
                // remove model scope from id
                var idPos = uri.lastIndexOf(":");
                if (idPos != -1) {
                    uri = uri.slice(idPos + 1);
                }
                idPos = uri.toUpperCase().lastIndexOf("%3A");
                if (idPos != -1) {
                    uri = uri.slice(idPos + 3);
                }
                idPos = uri.lastIndexOf("/");
                if (idPos != -1) {
                    uri = uri.slice(idPos + 1);
                }
                id = uri;
            }
            if (id) {
                result = new com.ibm.mm.enabler.IdentifierImpl(id, uri);
            }
        }
        
        return result;
    },
    _setIdentifier: function(property, value) {
        var node = this._getNode(property);
        if (node) {
            var id = null;
            com.ibm.mm.enabler.utils.Dom.setAttributeWithNS(node.ownerDocument, node, "ext:uri", "uri", this.wireModel.ns.ext, value);
        }
    },
    _updateEventIDs: function() {
        this._updateIdentifier("sourcePortletWindow", com.ibm.mashups.enabler.model.url.ModelUrlFactory.WIDGET_URL);
        this._updateIdentifier("communicationSource", com.ibm.mashups.enabler.model.url.ModelUrlFactory.EVENT_URL);
        
        this._updateIdentifier("targetPortletWindow", com.ibm.mashups.enabler.model.url.ModelUrlFactory.WIDGET_URL);
        this._updateIdentifier("communicationTarget", com.ibm.mashups.enabler.model.url.ModelUrlFactory.EVENT_URL);
    },
    _updateIdentifier: function(name, modelPrefix) {
        var oldID = this._getIdentifier(name);
        var newID = this.idService.resolveID(oldID);
        
        var modelUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(modelPrefix, this.wireModel);
        
        modelUrl.setNodes([{
            value: newID,
            isID: true
        }]);
        
        var modelUri = dojo.string.trim(modelUrl.getModelURI());
        
        this._setIdentifier(name, modelUri);
    },
    _getName: function(property) {
        var node = this._getNode(property);
        if (node) {
            var name = com.ibm.mm.enabler.utils.Dom.getAttributeWithNS(node, "model:internalName", "internalName", this.wireModel.ns.model);
            if (name) {
                return name;
            }
        }
        
        return null;
    },
    
    getSourceWidget: function() {
        var property = "sourcePortletWindow";
        return this._getIdentifier(property);
    },
    
    getSourceEvent: function() {
        var property = "communicationSource";
        return this._getIdentifier(property);
    },
    
    getSourceEventName: function() {
        var property = "communicationSource";
        return this._getName(property);
    },
    
    getSourcePage: function() {
        var property = "sourcePage";
        return this._getIdentifier(property);
    },
    
    getTargetWidget: function() {
        var property = "targetPortletWindow";
        return this._getIdentifier(property);
    },
    
    getTargetEvent: function() {
        var property = "communicationTarget";
        return this._getIdentifier(property);
    },
    
    getTargetEventName: function() {
        var property = "communicationTarget";
        return this._getName(property);
    },
    
    getTargetPage: function() {
        var property = "targetPage";
        return this._getIdentifier(property);
    },
    
    getXml: function() {
        return this.xmlData;
    },
    
    setXml: function(xml) {
        this.xmlData = xml;
        this._setDirty();
    }
});

}

if(!dojo._hasResource["com.ibm.mashups.enabler.wire.Wire"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.wire.Wire"] = true;
dojo.provide("com.ibm.mashups.enabler.wire.Wire");





}

if(!dojo._hasResource["com.ibm.mashups.enabler.wire.WireModel_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.wire.WireModel_API"] = true;
dojo.provide("com.ibm.mashups.enabler.wire.WireModel_API");
dojo.provide("com.ibm.mashups.enabler.wire.WireModel");






/**
 * This list model controller exposes wires, which are available with the
 * provider of the wire model. It allows to add and remove wires.
 *
 * @since 2.4
 *
 * @ibm-api
 * @ibm-module WireModel
 */
dojo.declare("com.ibm.mashups.enabler.wire.WireModel", [com.ibm.mashups.enabler.ListModelController, com.ibm.mashups.enabler.DirtyFlagProvider], {
    /**
     * Creates a wire. Note that the wire will not appear in the model unless
     * it is inserted using the <code>insert</code> method.
     *
     * @param {JSON} context array of predefined information used for the creation of
     * the wire. Must not be <code>null</code>. You must specify all of following:<br>
     * &nbsp;&nbsp;<b><code>sourceWidgetId</code></b> - com.ibm.mashups.enabler.Identifiable of source widget window; mandatory <br>
     * &nbsp;&nbsp;<b><code>sourcePageId</code></b> - com.ibm.mashups.enabler.Identifiable of source page; mandatory <br>
     * &nbsp;&nbsp;<b><code>sourceEventId</code></b> - com.ibm.mashups.enabler.Identifiable of source event; mandatory <br>
     * &nbsp;&nbsp;<b><code>targetWidgetId</code></b> - com.ibm.mashups.enabler.Identifiable of target widget window; mandatory <br>
     * &nbsp;&nbsp;<b><code>targetPageId</code></b> - com.ibm.mashups.enabler.Identifiable of target page; mandatory <br>
     * &nbsp;&nbsp;<b><code>targetEventId</code></b> - com.ibm.mashups.enabler.Identifiable of target event; mandatory <br>
	      * @return {com.ibm.mashups.enabler.wire.Wire} the created wire, or <code>null</code> in case the wire cannot be created.
     * @see com.ibm.mashups.enabler.widget.WidgetWindow
     */
    create: function(context){
    },
	
    /**
     * Returns an array of Wires with the given target widget id.
     * @param {com.ibm.mashups.enabler.Identifiable} id identifiable or string id of the target widget;
     * must not be <code>null</code>.
     * @return {com.ibm.mashups.enabler.Deferred} a deferred object used to start this operation. 
     * The return value when executed through the deferred object is
     * an array of {com.ibm.mashups.enabler.wire.Wire} objects with the given target widget id.  Never null, but
     * may be empty.
     */
	findByTargetWidget: function(id) {
	},
	
    /**
     * Returns an array of Wires with the given source widget id.
     * @param {com.ibm.mashups.enabler.Identifiable} id identifiable or string id of the source widget;
     * must not be <code>null</code>.
     * @return {com.ibm.mashups.enabler.Deferred} a deferred object used to start this operation. 
     * The return value when executed through the deferred object is
     * an array of {com.ibm.mashups.enabler.wire.Wire} objects with the given source widget id.  Never null, but
     * may be empty.
     */
	findBySourceWidget: function(id) {
	}
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.wire.WireModelImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.wire.WireModelImpl"] = true;
dojo.provide("com.ibm.mm.enabler.wire.WireModelImpl");









// Constants




// Other stuff - still needed?




















// i18n



dojo.declare("com.ibm.mm.enabler.wire.WireModelImpl", [com.ibm.mashups.enabler.wire.WireModel, com.ibm.mashups.enabler.ListModelController, com.ibm.mm.enabler.ConfirmableModelImpl, com.ibm.mm.enabler.model.ModelImpl, com.ibm.mm.enabler.DeferredIteratorImpl, com.ibm.mm.enabler.DirtyFlagProviderImpl], {
    _cidCounter: 0,
    _cursor: 0,
    _layoutModel: null,
    
    constructor: function(href, uri, layoutModel) {
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass);
        this.LOG_LEVEL = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
        
        this.uri = uri;
        this.href = href;
        this._layoutModel = layoutModel;
        
        // service document and
        // initialization
        var serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_CONTENT);
        this.entryUrl = serviceJson.url;
        this.prefix = serviceJson.idprefix;
        var nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
        this.ns = dojo.delegate(serviceJson.namespaces, nsf.getNameSpaces([nsf.NS_ATOM, nsf.NS_THR, nsf.NS_XML, nsf.NS_OPENSEARCH, nsf.NS_XHTML, nsf.NS_XSI]));
        
        // messages
        this.modelMessages = dojo.i18n.getLocalization("com.ibm.mm.enabler", "modelMessages");
        
        this._nodes = new dojox.collections.Dictionary();
        this._ids = [];
        this._insertedNodes = new dojox.collections.Dictionary();
        this._deletedNodes = new dojox.collections.Dictionary();
        
        var handler = function() {
            var LOG_METHOD = "WireModel.dirtyHandler()";
            var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
            if (bIsLoggable) {
                this.LOGGER.trace(LOG_METHOD, "Wire Model has been changed. Switching to edit representation.");
            }
            var cs = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.iwidget.services.ContainerService.SERVICE_NAME);
            cs.switchToModifiablePersistenceMode();
            this.removeDirtyCallback(handler);
        };
        this.addDirtyCallback(this, dojo.hitch(this, handler));
        
    },
    
    _setWireModelDirty: function() {
        this._setDirty();
    },
    
    create: function(context) {
        if (this._isEmpty(context) || this._isEmpty(context.sourceWidgetId) || this._isEmpty(context.sourcePageId) || this._isEmpty(context.sourcePageId) || this._isEmpty(context.sourceEventId) || this._isEmpty(context.targetWidgetId) || this._isEmpty(context.targetPageId) || this._isEmpty(context.targetEventId)) {
            // if context is not empty, and either both def and url or none are defined, throw an error
            throw new Error(this.modelMessages.E_INVALID_CONTEXT_SPECIFIED_0);
        }
        
        // create atom:entry
        var result = com.ibm.mm.enabler.utils.Atom.createEntry("New Wire", "model:wire", this.ns.model);
        var entry = result.entryElement;
        
        com.ibm.mm.enabler.utils.Utils.setAttributeWithNS(result.idElement, "ext:uniquename", this.ns.ext, "wire.orderDetails.orderId");
        com.ibm.mm.enabler.utils.Dom.textContent(result.idElement, "cid:" + this._cidCounter++);
        
        var immedSwitch = com.ibm.mm.enabler.utils.Utils.createNode("model:isimmediateswitch", this.ns.model);
        immedSwitch.setAttribute("value", "false");
        result.modelElement.appendChild(immedSwitch);
        
        var urlType = com.ibm.mashups.enabler.model.url.ModelUrlFactory.FRAGMENT_URL;
        
        var modelUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(urlType, this);
        
        modelUrl.setNodes([{
            value: dojo.string.trim(context.sourcePageId.getID()),
            isID: true
        }]);
        
        var modelUri = dojo.string.trim(modelUrl.getModelURI());
        
        var link = com.ibm.mm.enabler.utils.Utils.createNode("atom:link", this.ns.atom);
        link.setAttribute("rel", "related");
        com.ibm.mm.enabler.utils.Utils.setAttributeWithNS(link, "ext:rel", this.ns.ext, "sourcePage");
        com.ibm.mm.enabler.utils.Utils.setAttributeWithNS(link, "ext:uri", this.ns.ext, modelUri);
        entry.appendChild(link);
        
        urlType = com.ibm.mashups.enabler.model.url.ModelUrlFactory.WIDGET_URL;
        
        modelUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(urlType, this);
        
        modelUrl.setNodes([{
            value: dojo.string.trim(context.sourceWidgetId.getID()),
            isID: true
        }]);
        
        modelUri = dojo.string.trim(modelUrl.getModelURI());
        
        link = com.ibm.mm.enabler.utils.Utils.createNode("atom:link", this.ns.atom);
        link.setAttribute("rel", "related");
        com.ibm.mm.enabler.utils.Utils.setAttributeWithNS(link, "ext:rel", this.ns.ext, "sourcePortletWindow");
        com.ibm.mm.enabler.utils.Utils.setAttributeWithNS(link, "ext:uri", this.ns.ext, modelUri);
        entry.appendChild(link);
        
        urlType = com.ibm.mashups.enabler.model.url.ModelUrlFactory.FRAGMENT_URL;
        
        modelUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(urlType, this);
        
        modelUrl.setNodes([{
            value: dojo.string.trim(context.targetPageId.getID()),
            isID: true
        }]);
        
        modelUri = dojo.string.trim(modelUrl.getModelURI());
        
        link = com.ibm.mm.enabler.utils.Utils.createNode("atom:link", this.ns.atom);
        link.setAttribute("rel", "related");
        com.ibm.mm.enabler.utils.Utils.setAttributeWithNS(link, "ext:rel", this.ns.ext, "targetPage");
        com.ibm.mm.enabler.utils.Utils.setAttributeWithNS(link, "ext:uri", this.ns.ext, modelUri);
        entry.appendChild(link);
        
        urlType = com.ibm.mashups.enabler.model.url.ModelUrlFactory.WIDGET_URL;
        
        modelUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(urlType, this);
        
        modelUrl.setNodes([{
            value: dojo.string.trim(context.targetWidgetId.getID()),
            isID: true
        }]);
        
        modelUri = dojo.string.trim(modelUrl.getModelURI());
        
        link = com.ibm.mm.enabler.utils.Utils.createNode("atom:link", this.ns.atom);
        link.setAttribute("rel", "related");
        com.ibm.mm.enabler.utils.Utils.setAttributeWithNS(link, "ext:rel", this.ns.ext, "targetPortletWindow");
        com.ibm.mm.enabler.utils.Utils.setAttributeWithNS(link, "ext:uri", this.ns.ext, modelUri);
        entry.appendChild(link);
        
        urlType = com.ibm.mashups.enabler.model.url.ModelUrlFactory.EVENT_URL;
        
        modelUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(urlType, this);
        
        modelUrl.setNodes([{
            value: dojo.string.trim(context.sourceEventId.getID()),
            isID: true
        }]);
        
        modelUri = dojo.string.trim(modelUrl.getModelURI());
        
        link = com.ibm.mm.enabler.utils.Utils.createNode("atom:link", this.ns.atom);
        link.setAttribute("rel", "related");
        com.ibm.mm.enabler.utils.Utils.setAttributeWithNS(link, "ext:rel", this.ns.ext, "communicationSource");
        com.ibm.mm.enabler.utils.Utils.setAttributeWithNS(link, "ext:uri", this.ns.ext, modelUri);
        
        if (context.sourceEventId.getName) {
            var sourceName = context.sourceEventId.getName();
            com.ibm.mm.enabler.utils.Utils.setAttributeWithNS(link, "model:internalName", this.ns.model, sourceName);
        }
        
        entry.appendChild(link);
        
        urlType = com.ibm.mashups.enabler.model.url.ModelUrlFactory.EVENT_URL;
        
        modelUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(urlType, this);
        
        modelUrl.setNodes([{
            value: dojo.string.trim(context.targetEventId.getID()),
            isID: true
        }]);
        
        modelUri = dojo.string.trim(modelUrl.getModelURI());
        
        link = com.ibm.mm.enabler.utils.Utils.createNode("atom:link", this.ns.atom);
        //link.setAttribute("type", "application/atom+xml");
        link.setAttribute("rel", "related");
        //link.setAttribute("href", dojo.string.trim(modelUrl.getAbsoluteURL()));
        com.ibm.mm.enabler.utils.Utils.setAttributeWithNS(link, "ext:rel", this.ns.ext, "communicationTarget");
        com.ibm.mm.enabler.utils.Utils.setAttributeWithNS(link, "ext:uri", this.ns.ext, modelUri);
        
        if (context.targetEventId.getName) {
            var targetName = context.targetEventId.getName();
            com.ibm.mm.enabler.utils.Utils.setAttributeWithNS(link, "model:internalName", this.ns.model, targetName);
        }
        
        entry.appendChild(link);
        
        ret = new com.ibm.mm.enabler.wire.WireImpl(entry, this);
        
        return ret;
    },
    
    confirmCreate: function(context) {
        var page = this._layoutModel._getNavigationNode();
        if (page) {
            return page.hasRole(com.ibm.mashups.enabler.ac.RoleType.EDITOR) ? true : false;
        }
        else {
            return this.getConfirmCreate();
        }
    },
    
    insert: function(node, nextNode) {
        if (this._isEmpty(node)) {
            throw new Error(this.modelMessages.E_NODE_ISNULL_0);
        }
        
        this._getData();
        
        var id = node.getID();
        this._nodes.add(id, node);
        this._ids.push(id);
        this._insertedNodes.add(id, node);
        
        this._setDirty();
        node._addDirtyCallback(this, this._setWireModelDirty);
        
        dojo.publish(com.ibm.mashups.enabler.wire.WireModel.TOPIC_WIRE_ADDED, [this, node]);
        
        //parentNode.getXml().parentNode.appendChild(node.getXml());
        //		console.debug(com.ibm.mashups.enabler.xml.XPath.evaluateXPath("//atom:entry", this._getData(), this.ns));
    },
    
    confirmInsert: function(node, parentNode, nextNode) {
        if (this._isEmpty(node)) {
            throw new Error(this.modelMessages.E_NODE_ISNULL_0);
        }
        if (this._isEmpty(parentNode)) {
            throw new Error(this.modelMessages.E_NODE_ISNULL_0);
        }
        
        
        return true; // TODO
    },
    
    remove: function(node) {
        if (this._isEmpty(node)) {
            throw new Error(this.modelMessages.E_NODE_ISNULL_0);
        }
        
        node = this.find(node).start(true);
        
        if (node) {
            var id = node.getID();
            
            
            this._deleteNode(node.getXml());
            this._nodes.remove(id);
            
            for (var ds = 0; ds < this._ids.length; ds++) {
                if (this._ids[ds] == id) {
                    this._ids.splice(ds, 1);
                    break;
                }
            }
            
            // if it was created new, remove it
            if (!this._insertedNodes.remove(id)) {
                // was not removed, so it is new
                this._deletedNodes.add(id, node);
            }
            
            this._setDirty();
            node._removeDirtyCallback(this._setWireModelDirty);
            
            dojo.publish(com.ibm.mashups.enabler.wire.WireModel.TOPIC_WIRE_REMOVED, [this, node]);
        }
    },
    
    confirmRemove: function(node) {
        if (this._isEmpty(node)) {
            throw new Error(this.modelMessages.E_NODE_ISNULL_0);
        }
        var page = this._layoutModel._getNavigationNode();
        if (page) {
            return page.hasRole(com.ibm.mashups.enabler.ac.RoleType.EDITOR) ? true : false;
        }
        else {
            return this.getConfirmRemove();
        }
    },
    
    iterator: function() {
        this._cursor = 0;
        return this;
    },
    
    _getData: function(deferred, sync) {
        if (!this._data) {
            this._loadAhead(deferred, true);
        }
        
        return this._data;
    },
    
    _loadAhead: function(deferred, sync) {
        var callBack = null;
        if (deferred) {
            callBack = deferred.getFinishedCallback();
        }
        
        if (this._data) {
            if (callBack) {
                // callback handling
                callBack(this._data, com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK, deferred.getFinishedCallbackParameters());
            }
            
            // convenience only
            return this._data;
        }
        else if (!this.href) {
            if (callBack) {
                // error callback
                callBack(null, com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_NOT_FOUND, deferred.getFinishedCallbackParameters());
            }
            
            // convenience only
            return null;
        }
        
        var myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(this.href, this);
        
        //myUrl.setParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_REPRESENTATION,
        //com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_REPRESENTATION_VALUE_FULL); // force
        //myUrl.addParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT,
        //com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT_VALUE_ACCESS_CONTROL);
        
        var wireReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
        wireReq.read(dojo.hitch(this, function(type, data, xhr, args) {
            if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_LOAD) {
                this._data = data;
                var entries = com.ibm.mashups.enabler.xml.XPath.evaluateXPath("/atom:feed/atom:entry[not(thr:in-reply-to)]", data, this.ns);
                if (entries && entries.length > 0) {
                    for (var i = 0, l = entries.length; i < l; i++) {
                        var node = new com.ibm.mm.enabler.wire.WireImpl(entries[i], this);
                        var id = node.getID();
                        this._nodes.add(id, node);
                        this._ids[i] = id;
                    }
                }
                
                
            }
            else if (deferred && callBack) {
                // error callback when xhr didn't come back correctly
                callBack(null, xhr.status, deferred.getFinishedCallbackParameters());
            }
        }));
        
        // convenience only
        return this._data;
    },
    
    _isEmpty: function(obj) {
        return com.ibm.mm.enabler.utils.Misc.isEmpty(obj);
    },
    
    _checkValidNode: function(id) {
        if (this._isEmpty(id) && !com.ibm.mm.enabler.utils.Misc.isInstanceOf(id, com.ibm.mashups.enabler.Identifiable)) {
            throw new Error(dojo.string.substitute(this.modelMessages.E_WIRENODE_NOTFOUND_1, [id]));
        }
        return true;
    },
    
    _findNode: function(id) {
        this._checkValidNode(id);
        var xp = "/atom:feed/atom:entry[contains(atom:id/text(),':" + com.ibm.mm.enabler.utils.Utils.getIdFromIdentifiable(id) + "')]";
        var node = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(xp, this._getData(), this.ns);
        return node ? new com.ibm.mm.enabler.wire.WireImpl(node, this) : null;
    },
    
    find: function(id) {
        if (this._isEmpty(id)) {
            throw new Error(this.modelMessages.E_PARAM_ISNULL_0);
        }
        
        this._checkValidNode(id);
        
        if (id.getID) {
            id = id.getID();
        }
        
        return new com.ibm.mm.enabler.DeferredImpl(this, function(deferred, sync, id) {
            var callBack = deferred.getFinishedCallback();
            
            var node;
            
            if (this._nodes.containsKey(id)) {
                node = this._nodes.entry(id).valueOf();
            }
            else {
                node = this._findNode(id);
                if (node) {
                    this._nodes.add(id, node);
                    this._ids.push(id);
                }
            }
            
            if (node && callBack) {
                callBack(node, com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK, deferred.getFinishedCallbackParameters());
            }
            else if (callBack) {
                // couldn't find the node in response
                callBack(null, com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_NOT_FOUND, deferred.getFinishedCallbackParameters());
            }
            
            return node;
        }, id);
    },
    
    _replaceNodeXmlFromFeed: function(node, feedXml) {
        var entry = com.ibm.mashups.enabler.xml.XPath.evaluateEntry("//atom:entry", feedXml, this.ns);
        if (entry) {
            this._replaceNodeXml(node, entry);
        }
    },
    
    _replaceNodeXml: function(node, newXml) {
        // find feed parent
        var parent = node.getXml().parentNode;
        
        // get old id
        var oldId = com.ibm.mm.enabler.utils.Utils.getIdFromIdentifiable(node);
        
        // remove the old node from the feed
        this._deleteNode(node.getXml());
        
        
        // replace old XML by new XML
        node.setXml(newXml);
        
        
        // came from server, so no update needed, mark clean
        node._setClean();
        
        
        if (parent) {
            // add new node to the feed
            parent.appendChild(node.getXml());
        }
        
        // get new id
        var newId = com.ibm.mm.enabler.utils.Utils.getIdFromIdentifiable(node);
        
        if (oldId != newId) {
            // obviously this was a create and the ID changed, so replace the node in our dictionary
            this._nodes.remove(oldId);
            
            for (var ds = 0; ds < this._ids.length; ds++) {
                if (this._ids[ds] == oldId) {
                    this._ids.splice(ds, 1);
                    break;
                }
            }
            
            this._nodes.add(newId, node);
            this._ids.push(newId);
        }
    },
    _isDirty: function() {
        this._nodes.forEach(function(entry) {
            var node = entry.valueOf();
            
            if (node._isDirty()) {
                return true;
            }
        }, this);
        
        if (this._insertedNodes.count > 0 || this._deletedNodes.count > 0) {
            return true;
        }
        
        return false;
    },
    _commit: function(deferred, sync, parentModel) {
        var mpHandler = com.ibm.mashups.enabler.io.XHRMultipartFactory.create();
        mpHandler.startTransaction();
        
        // walk through all accessed nodes, wiremodel never really does this
        this._nodes.forEach(function(entry) {
            var node = entry.valueOf();
            
            if (node._isDirty() && !this._insertedNodes.containsKey(entry.key) && !this._deletedNodes.containsKey(entry.key)) {
                // node has changed, is not new and shall not be deleted
                
                var i = this.href.indexOf("uri=");
                var makeup = this.href.substring(0, i + 4);
                makeup = makeup + node._getWireUri();
                var myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(makeup, this);
                
                var serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
                
                node._updateEventIDs();
                
                parentModel._acquire();
                serviceReq.update(node.toString(), dojo.hitch(this, function(type, data, xhr, args) {
                
                    var id = com.ibm.mm.enabler.utils.Utils.getIdFromIdentifiable(args.node);
                    var myDeferred = args.deferred;
                    
                    if (xhr.status == com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK) {
                        this._replaceNodeXmlFromFeed(args.node, data);
                    }
                    
                    var callBack;
                    if (myDeferred) {
                        myDeferred.finishOperation(id, com.ibm.mashups.enabler.DeferredOperation.OPERATION_MODIFY, xhr.status);
                    }
                    parentModel._release(deferred, xhr.status);
                }), {
                    node: node,
                    deferred: deferred
                });
            }
        }, this);
        
        
        // INSERT
        // walk through all inserted nodes
        this._insertedNodes.forEach(function(entry) {
            var node = entry.valueOf();
            node._updateEventIDs();

            // we need to make sure the source and target widget really do exist, otherwise we skip this update
            var sourceWidget = this._layoutModel.find(node.getSourceWidget().getID()).start();
            var targetWidget = this._layoutModel.find(node.getTargetWidget().getID()).start();
            if ((!sourceWidget) || (!targetWidget)) {
                // either the source or the target widget does not exist
                return;
            }

            var myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(this.href, this);
            var serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
            
            parentModel._acquire();
            
            serviceReq.create(node.toString(), dojo.hitch(this, function(type, data, xhr, args) {
                var deferred = args.deferred;
                
                if (xhr.status == com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_CREATED) {
                    this._replaceNodeXmlFromFeed(node, data);
                }
                
                if (deferred) {
                    deferred.finishOperation(node, com.ibm.mashups.enabler.DeferredOperation.OPERATION_CREATE, xhr.status);
                }
                parentModel._release(deferred, xhr.status);
            }), {
                node: node,
                deferred: deferred
            });
            
            
        }, this);
        
        mpHandler.endTransactionDeferred().start();
        
        // clear the inserted nodes
        this._insertedNodes.clear();
        
        
        // DELETE
        
        
        // walk through all deleted nodes
        this._deletedNodes.forEach(function(entry) {
            var node = entry.valueOf();
            
            var i = this.href.indexOf("uri=");
            var makeup = this.href.substring(0, i + 4);
            makeup = makeup + node._getWireUri();
            var myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(makeup, this);
            
            node._updateEventIDs();
            
            var serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
            
            parentModel._acquire();
            serviceReq.remove(dojo.hitch(this, function(type, data, xhr, myDeferred) {
                var callBack;
                if (myDeferred) {
                    myDeferred.finishOperation(node.getID(), com.ibm.mashups.enabler.DeferredOperation.OPERATION_DELETE, xhr.status);
                }
                parentModel._release(myDeferred, xhr.status);
            }), deferred);
            
        }, this);
        
        // clear the deleted nodes
        this._deletedNodes.clear();
    },
    
    hasNext: function() {
        return this.size().start(true) > this._cursor;
    },
    
    next: function() {
        var ret = null;
        
        if (this.hasNext()) {
            var cursor = this._cursor++;
            
            var id = this._ids[cursor];
            ret = this._nodes.item(id).valueOf() || null;
            
            if (ret) {
                var callBack = this.getForeachCallback();
                if (callBack) {
                    callBack(ret, this.getForeachCallbackParameters());
                }
            }
        }
        
        return ret;
    },
    
    size: function() {
        return new com.ibm.mm.enabler.DeferredImpl(this, function(deferred, sync) {
            if (!this._data) {
                this._getData();
            }
            
            var size = this._nodes.count;
            var callBack = deferred.getFinishedCallback();
            if (callBack) {
                callBack(size, com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK, deferred.getFinishedCallbackParameters());
            }
            return size;
        });
    },
    
    setCursorPosition: function(position) {
        if (position < 0) {
            throw new Error(this.modelMessages.E_PARAM_IS_SMALLER_ZERO_0);
        }
        this._cursor = position || 0;
    },
    
    getCursorPosition: function() {
        return this._cursor;
    },
    
    _deleteNode: function(node) {
        if (node && node.parentNode) {
            node.parentNode.removeChild(node);
        }
    },
    
    findByTargetWidget: function(id) {
        if (this._isEmpty(id)) {
            throw new Error(this.modelMessages.E_PARAM_ISNULL_0);
        }
        
        this._checkValidNode(id);
        
        if (id.getID) {
            id = id.getID();
        }
        
        return new com.ibm.mm.enabler.DeferredImpl(this, function(deferred, sync, id) {
            var callBack = deferred.getFinishedCallback();
            
            var wires = [];
            
            var it = this.iterator();
            it.start(true);
            it.setCursorPosition(0);
            
            while (it && it.hasNext()) {
                var wire = it.next();
                if ((wire.getTargetWidget()) && (wire.getTargetWidget().getID() == id)) {
                    wires.push(wire);
                }
            }
            
            if (wires && callBack) {
                callBack(wires, com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK, deferred.getFinishedCallbackParameters());
            }
            else if (callBack) {
                // couldn't find the node in response
                callBack(null, com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_NOT_FOUND, deferred.getFinishedCallbackParameters());
            }
            
            return wires;
        }, id);
    },
    
    findBySourceWidget: function(id) {
        if (this._isEmpty(id)) {
            throw new Error(this.modelMessages.E_PARAM_ISNULL_0);
        }
        
        this._checkValidNode(id);
        
        if (id.getID) {
            id = id.getID();
        }
        
        return new com.ibm.mm.enabler.DeferredImpl(this, function(deferred, sync, id) {
            var callBack = deferred.getFinishedCallback();
            
            var wires = [];
            
            var it = this.iterator();
            it.start(true);
            it.setCursorPosition(0);
            
            while (it && it.hasNext()) {
                var wire = it.next();
                if ((wire.getSourceWidget()) && (wire.getSourceWidget().getID() == id)) {
                    wires.push(wire);
                }
            }
            
            if (wires && callBack) {
                callBack(wires, com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK, deferred.getFinishedCallbackParameters());
            }
            else if (callBack) {
                // couldn't find the node in response
                callBack(null, com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_NOT_FOUND, deferred.getFinishedCallbackParameters());
            }
            
            return wires;
        }, id);
    }
});

}

if(!dojo._hasResource["com.ibm.mashups.enabler.wire.WireModel"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.wire.WireModel"] = true;
dojo.provide("com.ibm.mashups.enabler.wire.WireModel");



/**
 * @private
 */
com.ibm.mashups.enabler.wire.WireModel.TOPIC_BASE = "/"+("com.ibm.mashups.enabler.wire.WireModel".replace(/\./ig,'/'))+"/";
/**
 * @private
 */
com.ibm.mashups.enabler.wire.WireModel.TOPIC_WIRE_ADDED    = com.ibm.mashups.enabler.wire.WireModel.TOPIC_BASE + "add";
/**
 * @private
 */
com.ibm.mashups.enabler.wire.WireModel.TOPIC_WIRE_REMOVED = com.ibm.mashups.enabler.wire.WireModel.TOPIC_BASE + "remove";




}

if(!dojo._hasResource["com.ibm.mashups.enabler.wire.WireModelProvider"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.wire.WireModelProvider"] = true;
dojo.provide("com.ibm.mashups.enabler.wire.WireModelProvider");



/**
 * Interface for a provider of a wire model.
 *
 * @since 2.4
 *
 * @ibm-api
 * @ibm-module WireModel
 */
dojo.declare("com.ibm.mashups.enabler.wire.WireModelProvider", null, {
    /**
     * Returns the wire model of this provider.
     *
     * @return {com.ibm.mashups.enabler.wire.WireModel} The wire model of this provider
     */
    getWireModel: function(){
    }
});

}

if(!dojo._hasResource["com.ibm.mashups.enabler.model.LayoutModel_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.model.LayoutModel_API"] = true;
dojo.provide("com.ibm.mashups.enabler.model.LayoutModel_API");
dojo.provide("com.ibm.mashups.enabler.model.LayoutModel");

/**
 * This tree model exposes containers and controls. The following applies to the topology:
 * <ul>
 * <li>the root node is a container</li>
 * <li>containers may contain containers</li>
 * <li>containers may contain controls</li>
 * <li>controls and containers must not be mixed within a container</li>
 * </ul>
 * The layout model supports the following strategies:
 * <ul>
 * <li>{@link com.ibm.mashups.enabler.strategy.HiddenMetaDataLoadingStrategy HiddenMetaDataLoadingStrategy}</li>
 * </ul>
 * 
 * @see com.ibm.mashups.enabler.layout.LayoutContainer
 * @see com.ibm.mashups.enabler.layout.LayoutControl
 *
 * @ibm-api
 * @ibm-module LayoutModel
 */
dojo.declare("com.ibm.mashups.enabler.model.LayoutModel", [com.ibm.mashups.enabler.TreeModelController, com.ibm.mashups.enabler.wire.WireModelProvider, com.ibm.mashups.enabler.DirtyFlagProvider], {

    /**
     * Creates a layout control. Note that the layout control will not appear in the model unless
     * it is inserted using the <code>insert</code> method.<br>
     * <br>
     * <b>Example:</b> To create a layout control based on a widget definition located at a specific URL, 
     * you do the following:<br>
     * &nbsp;&nbsp;<code>var context = {};</code><br>
     * &nbsp;&nbsp;<code>context["type"] = com.ibm.mashups.enabler.layout.Constants.LAYOUT_CONTROL;</code><br>
     * &nbsp;&nbsp;<code>context[com.ibm.mashups.enabler.layout.Constants.WIDGET_DEFINITION_URL] = "http://my/widget/definition.xml";</code><br>
     * &nbsp;&nbsp;<code>layoutModel.create(context);</code>
     * @param {Object} context context with predefined information used for the creation of
     * the layout control. Must not be <code>null</code>. You must specify the following:<br>
     * &nbsp;&nbsp;<b><code>type</code></b> - type of layout entity to create as defined in 
     * &nbsp; {@link com.ibm.mashups.enabler.layout.Constants Constants}; must be one of the 
     * following:<br>
     * &nbsp;&nbsp;&nbsp;LAYOUT_CONTROL<br>
     * <br>
     * &nbsp;&nbsp;In case type equals LAYOUT_CONTROL, you must specify the widget to create 
     * using one of the following keys as defined in &nbsp; {@link com.ibm.mashups.enabler.layout.Constants Constants}<br>
     * &nbsp;&nbsp;<b><code>WIDGET_DEFINITION_ID</code></b> - &nbsp; {@link com.ibm.mashups.enabler.Identifiable Identifiable} 
     * of widget definition to instantiate for this control, or<br>
     * &nbsp;&nbsp;<b><code>WIDGET_DEFINITION_URL</code></b> - URL (string) pointing to a widget definition to instantiate for
     * this control; note that the widget definition will be managed by the backend after this layout control is inserted into a 
     * layout container and the layout model is committed.
     *
     * @return {com.ibm.mashups.enabler.layout.LayoutControl} the created layout control, or <code>null</code>
     * if it can not be created.
     *
     * @see com.ibm.mashups.enabler.widget.WidgetDefinition
     * @see com.ibm.mashups.enabler.layout.Constants
     */
    create: function(context){
    },
    
    /**
     * Returns the root node of the layout model; never <code>null</code>.
     *
     * @return  {com.ibm.mashups.enabler.Deferred} a deferred object used to start this operation. The
     *          return value when executed through the deferred object
     *          is the root &nbsp; {@link com.ibm.mashups.enabler.layout.LayoutNode LayoutNode} of the layout model
     */
    getRoot: function(){
    },
    
    /**
     * Returns whether or not the given node has children.
     *
     * @param   {com.ibm.mashups.enabler.layout.LayoutNode} node the layout node for which to check if it has
     * 			children; must not be <code>null</code>.
     * @return {Boolean} <tt>true</tt> if the specified node has children, <tt>false</tt> otherwise
     */
    hasChildren: function(node){
    },
    
    /**
     * Returns an iterator of the child nodes for the given node.
     *
     * @param 	{com.ibm.mashups.enabler.layout.LayoutNode} node the node object for which to return its children; must not be 
     * 			<code>null</code>.
     * @return  {com.ibm.mashups.enabler.DeferredIterator} deferred iterator of the children for 
     * 			the given node; never <code>null</code>
     */
    getChildren: function(node){
    },
    
    /**
     * Returns the parent of a given node.
     * @param 	{com.ibm.mashups.enabler.layout.LayoutNode} node node object for which to return its parent node; must not
     *          be <code>null</code>
     * @return  {com.ibm.mashups.enabler.Deferred} a deferred object used to start this operation. The
     *          return value when executed through the deferred object
     *          is the parent &nbsp; {@link com.ibm.mashups.enabler.layout.LayoutNode LayoutNode} of the given node, or 
     *          <code>null</code>, if the node has no parent
     */
    getParent: function(node){
    },
    
    /**
     * Indicates if the specified resource is modifiable.
     *
     * @since 2.4
     *
     * @param {com.ibm.mashups.enabler.layout.LayoutNode} node the layout node to check; must not be <code>null</code>
     *
     * @return {Boolean} <code>true</code> if the node is modifiable, <code>false</code> otherwise
     */
    isModifiable: function(node){
    },
    
    /**
     * Indicates if the specified layout node is deletable.
     *
     * @since 2.4
     *
     * @param {com.ibm.mashups.enabler.layout.LayoutNode} node The layout node to check; must not be <code>null</code>
     *
     * @return {Boolean} <code>true</code> if the node is deletable, <code>false</code> otherwise
     */
    isDeletable: function(node){
    },
    
    /**
     * Returns an element of a model (searches throughout the whole tree) with the given ID. May be either a {@link com.ibm.mashups.enabler.layout.LayoutControl LayoutControl} or a {@link com.ibm.mashups.enabler.layout.LayoutContainer LayoutContainer}
     * @param {com.ibm.mashups.enabler.Identifiable} id identifiable or string id of the object to find; 
     * must not be <code>null</code>.
     * @return {com.ibm.mashups.enabler.Deferred} a deferred object used to start this operation. 
     * The return value when executed through the deferred object is
     * the element with the given ID or <code>null</code> if the element cannot be found.
     */
    find: function (id) {
    }    
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.layout.LayoutModelIteratorImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.layout.LayoutModelIteratorImpl"] = true;
dojo.provide("com.ibm.mm.enabler.layout.LayoutModelIteratorImpl");







dojo.declare("com.ibm.mm.enabler.layout.LayoutModelIteratorImpl",com.ibm.mm.enabler.DeferredIteratorImpl,{
	node: null,
	layoutModel: null,
	_cursor: 0,
	_last: null,
	
	constructor: function(node, layoutModel) {
		this.node = node;
		this.layoutModel = layoutModel;
		
		// important, store entries upon constructing this class, as we need to work on a copy 
		this._setEntries();
	},
	
	
	_setEntries: function() {
        var xp = "/atom:feed/atom:entry[contains(thr:in-reply-to/@ref,':" + com.ibm.mm.enabler.utils.Utils.getIdFromIdentifiable(this.node) + "')]";
        this._entries = dojo.map(com.ibm.mashups.enabler.xml.XPath.evaluateXPath(xp, this.layoutModel._getData(), this.layoutModel.ns) || [],this._transform,this);
	},
	
	_getId: function(node) {
        var xp = "atom:id";
		var rawID = dojo.string.trim(com.ibm.mashups.enabler.xml.XPath.evaluateString(xp, node, this.layoutModel.ns));
		return com.ibm.mm.enabler.IdentifiableHelper.getID(rawID);
	},
	
	/**
	 * must not return a live representation, but a representation of the feed when the iterator was constructed
	 */
	_getEntries: function() {
        return this._entries;
	},
    
    _transform: function(elem) {
        var ret = null; 
        var id = this._getId(elem);
        if(this.layoutModel._nodes.containsKey(id)) {
            ret = this.layoutModel._nodes.item(id);
        } else {
            ret = this.layoutModel._transformNode(elem);
            this.layoutModel._nodes.add(ret.getID(),ret);
        }
        return ret;
    }, 
	
	hasNext: function() {
		return this.size().start(true) >  this._cursor;
	},
    
    hasPrevious: function() {
        return this._cursor > 0;
    },
	
	/**
	 * Seems to be weird to not make this use XPath on the live data source,
	 * but we need to make sure to not pick up any changes made in between.
	 * Iterator must be able to work independently
	 * 
	 * @param {Object} id
	 */
	_findEntryById: function(id) {
		var ret = null;
		if (id) {
			dojo.forEach(this._getEntries(), function(node, idx, arr){
				if (node.getID() == id) {
					ret = node;
				}
			}, this);
		}
		return ret;		
	},
	
	_firstEntry: function() {
		var pointers = {};
		dojo.forEach(this._getEntries(), function(node, idx, arr){
			var nextID = this.layoutModel._getNextNodeID(node);
			if (nextID) {
				pointers[nextID] = true;
			}
		}, this);
		
		var ret = null;
		dojo.forEach(this._getEntries(),function(node,idx,arr) {
			if(!(node.getID() in pointers)) {
                ret = node;
			}
		},this);
		return ret;
	},
	
	_nextEntry: function(node) {
		if(!node) {
			// get first entry (thats the one with no "next" link pointing to it)
			return this._firstEntry();
		} else {
			// it's an entry with a link pointing to it
			return this._findEntryById(this.layoutModel._getNextNodeID(node));
		}
	},
    
    _lastEntry: function() {
        var ret = null;
		dojo.forEach(this._getEntries(), function(node, idx, arr){
			var nextID = this.layoutModel._getNextNodeID(node);
//            console.debug("node",this._getId(node),"nextID",nextID);
			if (!nextID) {
				ret = node;
			}
		}, this);
        return ret;
    },
    
    _previousEntry: function(node) {
        if(!node) {
            return this._lastEntry();
        } else {
//            var id = this._getId(node);
//            console.debug("id",id);
            var previousNodeID = this.layoutModel._findPointingNodeID(node);
//            console.debug("previousNodeID",previousNodeID,"for",node.getID());
            // its and entry with a link pointing to the given node
            return this._findEntryById(previousNodeID);
        }
    },
    
    
    previous: function() {
        if(!this.hasPrevious()) {
            return null;
        }
        var elem = this._previousEntry(this._last);
        this._last = elem;

		this._cursor--;
		
		return elem || null;
    },
	
	next: function() {
		if(!this.hasNext()) {
			return null;
		}
		var elem = this._nextEntry(this._last);
	    this._last = elem;
        
		this._cursor++;
		
		return elem || null;
	},
	
	size: function() {
		return new com.ibm.mm.enabler.DeferredImpl(this, function(deferred, sync) {
			var size = this._getEntries().length;
            if(deferred) { deferred.finish(size,com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK); }
			return size;
		});
	},
    
    seekToEnd: function() {
        this.setCursorPosition(this.size().start(true));
        this._last = null;        
    },
	
	setCursorPosition: function(position) {
		if(position < 0) {
			throw new Error(this.layoutModel.modelMessages.E_PARAM_IS_SMALLER_ZERO_0);
		}
		this._cursor = position || 0;
		
		// this only works because we loaded all nodes already
		var x;
		for(var i = 0, size = this.size().start(true); i < this._cursor && i < size; i++) {
			x = this._nextEntry(x);
		}
		this._last = x;
	},
	
	getCursorPosition: function() {
		return this._cursor;
	},
    
    start: function() {
        while (this.hasNext()) {
            this.nextFinish(this.next());
        }
    }
	
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.layout._LayoutModelBaseMixin"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.layout._LayoutModelBaseMixin"] = true;
dojo.provide("com.ibm.mm.enabler.layout._LayoutModelBaseMixin");

dojo.declare("com.ibm.mm.enabler.layout._LayoutModelBaseMixin", null, {

    _nodes: null,
    _cidPrefix: 'cid:',
    
    constructor: function(){
        this._nodes = new dojox.collections.Dictionary();
    },
    
    _setLMBaseDirty: function(){
        this._setDirty();
    },
    
    _deleteNode: function(node){
        if (com.ibm.mm.enabler.utils.Misc.isInstanceOf(node, com.ibm.mashups.enabler.Transformable)) {
            node = node.getXml();
        }
        dojo.destroy(node);
    },
    
    _isClientNode: function(node){
        return (node && node._getRawID().indexOf(this._cidPrefix) === 0);
    },
    
    /**
     * Returns the layout data
     *
     * @private
     */
    _getData: function(){
        if (!this._data) {
            this.getRoot().start(true);
        }
        return this._data;
    },
    
    /**
     * Checks whether an object is null or undefined
     *
     * @param {Object} obj An object to check for null/undefined
     * @return {Boolean} true if object is null or undefined
     */
    _isEmpty: function(obj){
        return obj === null || typeof obj == 'undefined';
    },
    
    isModifiable: function(node){
    
        var LOG_METHOD = "isModifiable(node)";
        var IS_LOGGING = com.ibm.mm.enabler.layout.LayoutModelImpl.LOGGER.isLoggable(com.ibm.mm.enabler.layout.LayoutModelImpl.LOG_LEVEL);
        if (IS_LOGGING) {
            com.ibm.mm.enabler.layout.LayoutModelImpl.LOGGER.entering(LOG_METHOD, [node]);
        }
        
        if (this._isEmpty(node)) {
            throw new Error(this.modelMessages.E_NODE_ISNULL_0);
        }
        
        if (this._isClientNode(node)) {
            return true;
        }
        
        var mod = com.ibm.mashups.enabler.xml.XPath.evaluateString("atom:content//model:modifiable", node.getXml(), this.ns);
        
        var ret = dojo.string.trim(mod).toLowerCase() == 'true';
        if (IS_LOGGING) {
            com.ibm.mm.enabler.layout.LayoutModelImpl.LOGGER.exiting(LOG_METHOD, [ret]);
        }
        
        return ret;
    },
    
    isDeletable: function(node){
    
        var LOG_METHOD = "isDeletable(node)";
        var IS_LOGGING = com.ibm.mm.enabler.layout.LayoutModelImpl.LOGGER.isLoggable(com.ibm.mm.enabler.layout.LayoutModelImpl.LOG_LEVEL);
        if (IS_LOGGING) {
            com.ibm.mm.enabler.layout.LayoutModelImpl.LOGGER.entering(LOG_METHOD, [node]);
        }
        
        if (this._isEmpty(node)) {
            throw new Error(this.modelMessages.E_NODE_ISNULL_0);
        }
        
        if (this._isClientNode(node)) {
            return true;
        }
        
        var del = com.ibm.mashups.enabler.xml.XPath.evaluateString("atom:content//model:deletable", node.getXml(), this.ns);
        
        var ret = dojo.string.trim(del).toLowerCase() == 'true';
        if (IS_LOGGING) {
            com.ibm.mm.enabler.layout.LayoutModelImpl.LOGGER.exiting(LOG_METHOD, [ret]);
        }
        
        return ret;
    },
    
    /**
     * Checks whether an atom entry represents a layout container or not
     *
     * @param {Object} node	An ATOM entry
     */
    _isContainer: function(node){
        if (this._isEmpty(node)) {
            return false;
        }
        if (com.ibm.mm.enabler.utils.Misc.isInstanceOf(node, com.ibm.mashups.enabler.Transformable)) {
            node = node.getXml();
        }
        return com.ibm.mashups.enabler.xml.XPath.evaluateBoolean("atom:content/model:layout-container", node, this.ns);
    },
    
    _isControl: function(node){
        if (this._isEmpty(node)) {
            return false;
        }
        if (com.ibm.mm.enabler.utils.Misc.isInstanceOf(node, com.ibm.mashups.enabler.Transformable)) {
            node = node.getXml();
        }
        return com.ibm.mashups.enabler.xml.XPath.evaluateBoolean("atom:content/model:layout-control", node, this.ns);
    },
    
    /**
     * Transforms an atom entry into a LayoutContainer or LayoutControl
     *
     * @param {Object} node	An ATOM entry
     */
    _transformNode: function(node){
        var ret = this._isContainer(node) ? new com.ibm.mm.enabler.layout.LayoutContainerImpl(node, this) : new com.ibm.mm.enabler.layout.LayoutControlImpl(node, this);
        ret._addDirtyCallback(this, this._setLMBaseDirty);
        return ret;
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.layout._LayoutModelWireModelProviderMixin"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.layout._LayoutModelWireModelProviderMixin"] = true;
dojo.provide("com.ibm.mm.enabler.layout._LayoutModelWireModelProviderMixin");

dojo.declare("com.ibm.mm.enabler.layout._LayoutModelWireModelProviderMixin", null, {

    _wireModel: null,
    
    _setLMWireModelProvDirty: function(){
        this._setDirty();
    },
    
    getWireModel: function(){
        var LOG_METHOD = "getWireModel()";
        var IS_LOGGING = com.ibm.mm.enabler.layout.LayoutModelImpl.LOGGER.isLoggable(com.ibm.mm.enabler.layout.LayoutModelImpl.LOG_LEVEL);
        if (IS_LOGGING) {
            com.ibm.mm.enabler.layout.LayoutModelImpl.LOGGER.entering(LOG_METHOD, []);
        }
        
        if (!this._wireModel && this._getData()) {
            var expr = "/atom:feed/atom:link[@ext:rel='wire']";
            var node = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, this._getData(), this.ns);
            if (node) {
                var href = node.getAttribute("href");
                var uri = com.ibm.mm.enabler.utils.Dom.getAttributeWithNS(node, "ext:uri", "uri", this.ns.ext);
                this._wireModel = new com.ibm.mm.enabler.wire.WireModelImpl(href, uri, this);
                this._wireModel._addDirtyCallback(this, this._setLMWireModelProvDirty);
            }
        }
        
        
        if (!this._wireModel) {
            this._wireModel = new com.ibm.mm.enabler.wire.WireModelImpl(null, null, this);
            this._wireModel._addDirtyCallback(this, this._setLMWireModelProvDirty);
        }
        
        if (IS_LOGGING) {
            com.ibm.mm.enabler.layout.LayoutModelImpl.LOGGER.exiting(LOG_METHOD, [this._wireModel]);
        }
        
        return this._wireModel;
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.layout._LayoutModelLocatorMixin"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.layout._LayoutModelLocatorMixin"] = true;
dojo.provide("com.ibm.mm.enabler.layout._LayoutModelLocatorMixin");

dojo.declare("com.ibm.mm.enabler.layout._LayoutModelLocatorMixin", null, {

    find: function(id){
        var LOG_METHOD = "find(id)";
        var IS_LOGGING = com.ibm.mm.enabler.layout.LayoutModelImpl.LOGGER.isLoggable(com.ibm.mm.enabler.layout.LayoutModelImpl.LOG_LEVEL);
        if (IS_LOGGING) {
            com.ibm.mm.enabler.layout.LayoutModelImpl.LOGGER.entering(LOG_METHOD, [id]);
        }
        
        var ret = this._find(id);
        
        if (IS_LOGGING) {
            com.ibm.mm.enabler.layout.LayoutModelImpl.LOGGER.exiting(LOG_METHOD, [ret]);
        }
        
        return ret;
    },
    
    _setLMLocatorDirty: function(){
        this._setDirty();
    },
    
    /**
     * TODO combine this with com.ibm.mm.layout._LayoutModelTreeModelMixin._assertValidNode
     */
    _checkValidNode: function(id){
        if (this._isEmpty(id) && !com.ibm.mm.enabler.utils.Misc.isInstanceOf(id, com.ibm.mashups.enabler.Identifiable)) {
            throw new Error(dojo.string.substitute(this.modelMessages.E_LAYOUTNODE_NOTFOUND_1, [id]));
        }
    },
    
    _findNode: function(id){
        this._checkValidNode(id);
        var xp = "/atom:feed/atom:entry[contains(atom:id/text(),':" + com.ibm.mm.enabler.utils.Utils.getIdFromIdentifiable(id) + "')]";
        return com.ibm.mashups.enabler.xml.XPath.evaluateEntry(xp, this._getData(), this.ns) || null;
    },
    
    _find: function(id){
        if (this._isEmpty(id)) {
            throw new Error(this.modelMessages.E_PARAM_ISNULL_0);
        }
        this._checkValidNode(id);
        
        return new com.ibm.mm.enabler.DeferredImpl(this, function(deferred, sync, id){
            var callBack = deferred.getFinishedCallback();
            
            var node = null;
            
            var tId = com.ibm.mm.enabler.utils.Utils.getIdFromIdentifiable(id);
            
            if (this._nodes.containsKey(tId)) {
                //                console.debug("in cache");
                node = this._nodes.item(tId);
            }
            else {
                //                console.debug("didn't find",node);
                node = this._findNode(id);
                // we need to verify again if the node is in the hashmap as the _findNode may trigger another find.
                if (this._nodes.containsKey(tId)) {
                    //                console.debug("in cache");
                    node = this._nodes.item(tId);
                }
                else {
                    if (node) {
                        node = this._transformNode(node);
                        //                    console.debug("create new",node);
                        node._addDirtyCallback(this, this._setLMLocatorDirty());
                        this._nodes.add(tId, node);
                    }
                }
            }
            
            if (deferred) {
                deferred.finish(node, node ? com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK : com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_NOT_FOUND);
            }
            
            return node;
        }, id);
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.layout._LayoutModelTreeModelMixin"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.layout._LayoutModelTreeModelMixin"] = true;
dojo.provide("com.ibm.mm.enabler.layout._LayoutModelTreeModelMixin");







dojo.declare("com.ibm.mm.enabler.layout._LayoutModelTreeModelMixin", null, {
    _root: null,
    
    getRoot: function(){
        var LOG_METHOD = "getRoot()";
        var IS_LOGGING = com.ibm.mm.enabler.layout.LayoutModelImpl.LOGGER.isLoggable(com.ibm.mm.enabler.layout.LayoutModelImpl.LOG_LEVEL);
        if (IS_LOGGING) {
            com.ibm.mm.enabler.layout.LayoutModelImpl.LOGGER.entering(LOG_METHOD, arguments);
        }
        
        var ret = new com.ibm.mm.enabler.DeferredImpl(this, this._getRoot);
        
        if (IS_LOGGING) {
            com.ibm.mm.enabler.layout.LayoutModelImpl.LOGGER.exiting(LOG_METHOD, [ret]);
        }
        
        return ret;
    },
    
    _getRoot: function(deferred, sync){
        if (this._root) {
            if (deferred) {
                deferred.finish(this._root, com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK);
            }
            // convenience only
            return this._root;
        }
        else 
            if (!this.href) {
                if (deferred) {
                    deferred.finish(null, com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_NOT_FOUND);
                }
                // convenience only
                return null;
            }
        
        var myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(this.href, this);
        
        // fetch full representation
        myUrl.setParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_REPRESENTATION, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_REPRESENTATION_VALUE_FULL);
        
        // AC mode needed
        myUrl.addParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT_VALUE_ACCESS_CONTROL);
        
        // apply hidden meta data strategy
        var md = {};
        var mds = "com.ibm.mashups.enabler.strategy.HiddenMetaDataLoadingStrategy";
        
        // ... set directly with the model
        var s = this._findStrategyByType(mds);
        if (s) {
            dojo.forEach(s.getHiddenMetaDataToLoad(), function(name){
                md[name] = null;
            });
        }
        
        // ... set via service
        var strategyService = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.StrategyService.SERVICE_NAME);
        s = strategyService.getStrategy("com.ibm.mashups.enabler.layout.LayoutModel", mds);
        if (s) {
            dojo.forEach(s.getHiddenMetaDataToLoad(), function(name){
                md[name] = null;
            });
        }
        
        for (var n in md) {
            myUrl.addParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_MDNAME, n);
        }
        
        var fragmentReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
        fragmentReq.read(dojo.hitch(this, function(type, data, xhr, deferred){
        
            if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_LOAD) {
                this._data = data;
                var node = com.ibm.mashups.enabler.xml.XPath.evaluateEntry("/atom:feed/atom:entry[not(thr:in-reply-to)]", data, this.ns);
                if (node) {
                    this._root = new com.ibm.mm.enabler.layout.LayoutContainerImpl(node, this);
                }
                if (deferred) {
                    deferred.finish(this._root || null, this._root ? com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK : com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_NOT_FOUND);
                }
            }
            else 
                if (deferred) {
                    // error callback when xhr didn't come back correctly
                    deferred.finish(null, xhr.status);
                }
        }), deferred);
        
        // convenience only
        return this._root;
    },
    
    hasChildren: function(node){
        var LOG_METHOD = "hasChildren(node)";
        var IS_LOGGING = com.ibm.mm.enabler.layout.LayoutModelImpl.LOGGER.isLoggable(com.ibm.mm.enabler.layout.LayoutModelImpl.LOG_LEVEL);
        if (IS_LOGGING) {
            com.ibm.mm.enabler.layout.LayoutModelImpl.LOGGER.entering(LOG_METHOD, arguments);
        }
        
        this._assertValidNode(node);
        
        
        var ret = this._findRepliesNode(node.getXml()) !== null;
        
        if (IS_LOGGING) {
            com.ibm.mm.enabler.layout.LayoutModelImpl.LOGGER.exiting(LOG_METHOD, [ret]);
        }
        
        return ret;
    },
    
    /**
     * TODO combine this with com.ibm.mm.enabler.layout._LayoutModelLocatorMixin._checkValidNode
     */
    _assertValidNode: function(node){
        if (this._isEmpty(node)) {
            throw new Error(this.modelMessages.E_NODE_ISNULL_0);
        }
        
        if (!com.ibm.mm.enabler.utils.Misc.isInstanceOf(node, com.ibm.mashups.enabler.layout.LayoutNode)) {
            throw new Error(dojo.string.substitute(this.modelMessages.E_LAYOUTNODE_NOTFOUND_1, [node]));
        }
    },
    
    getChildren: function(node){
        var LOG_METHOD = "getChildren(node)";
        var IS_LOGGING = com.ibm.mm.enabler.layout.LayoutModelImpl.LOGGER.isLoggable(com.ibm.mm.enabler.layout.LayoutModelImpl.LOG_LEVEL);
        if (IS_LOGGING) {
            com.ibm.mm.enabler.layout.LayoutModelImpl.LOGGER.entering(LOG_METHOD, arguments);
        }
        
        this._assertValidNode(node);
        
        var ret = new com.ibm.mm.enabler.layout.LayoutModelIteratorImpl(node, this);
        
        if (IS_LOGGING) {
            com.ibm.mm.enabler.layout.LayoutModelImpl.LOGGER.exiting(LOG_METHOD, [ret]);
        }
        
        return ret;
    },
    
    getParent: function(node){
        var LOG_METHOD = "getParent(node)";
        var IS_LOGGING = com.ibm.mm.enabler.layout.LayoutModelImpl.LOGGER.isLoggable(com.ibm.mm.enabler.layout.LayoutModelImpl.LOG_LEVEL);
        if (IS_LOGGING) {
            com.ibm.mm.enabler.layout.LayoutModelImpl.LOGGER.entering(LOG_METHOD, arguments);
        }
        
        this._assertValidNode(node);
        
        var ret = new com.ibm.mm.enabler.DeferredImpl(this, this._getParentDeferredStart, {
            node: node
        });
        
        if (IS_LOGGING) {
            com.ibm.mm.enabler.layout.LayoutModelImpl.LOGGER.exiting(LOG_METHOD, [ret]);
        }
        
        return ret;
    },
    
    _getParentDeferredStart: function(deferred, sync, args){
        var node = args.node;
        var ret = null;
        var xid = com.ibm.mashups.enabler.xml.XPath.evaluateEntry("thr:in-reply-to", node.getXml(), this.ns);
        if (xid) {
            var rawId = xid.getAttribute("ref");
            var id = com.ibm.mm.enabler.IdentifiableHelper.getID(rawId);
            if (this._nodes.containsKey(id)) {
                ret = this._nodes.item(id);
            }
            else {
                var xp = "/atom:feed/atom:entry[contains(atom:id/text(),'" + rawId + "')]";
                var node2 = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(xp, this._getData(), this.ns);
                if (node2) {
                    ret = new com.ibm.mm.enabler.layout.LayoutContainerImpl(node2, this);
                    this._nodes.add(com.ibm.mm.enabler.utils.Utils.getIdFromIdentifiable(ret), ret);
                }
            }
        }
        if (deferred) {
            deferred.finish(ret, ret ? com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK : com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_NOT_FOUND);
        }
        return ret;
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.layout._LayoutModelTreeModelControllerMixin"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.layout._LayoutModelTreeModelControllerMixin"] = true;
dojo.provide("com.ibm.mm.enabler.layout._LayoutModelTreeModelControllerMixin");




dojo.declare("com.ibm.mm.enabler.layout._LayoutModelTreeModelControllerMixin", [com.ibm.mm.enabler.layout._LayoutModelTreeModelMixin], {

    _deletedNodes: null,
    
    constructor: function(){
        this._deletedNodes = new dojox.collections.Dictionary();
    },
    
    /**
     * removes a [@rel="replies"] link from a node when there are no additional children
     * @param {Object} node
     */
    _deParent: function(node){
        var parent = this.getParent(node).start(true);
        if (parent) {
            var iterator = this.getChildren(parent);
            if (iterator && iterator.size().start(true) === 1) {
                this._deleteNode(this._findRepliesNode(parent.getXml()));
                return true;
            }
        }
        return false;
    },
    
    _findRepliesNode: function(entry){
        return com.ibm.mashups.enabler.xml.XPath.evaluateEntry("atom:link[@rel='replies']", entry, this.ns) || null;
    },
    
    _findPointingNodeID: function(node){
        var ret = null;
        var xp = '/atom:feed/atom:entry[contains(atom:link[@rel="next"]/@ext:uri,":' + com.ibm.mm.enabler.utils.Utils.getIdFromIdentifiable(node) + '@")]/atom:id';
        //        console.debug(xp);
        //        DATA = this._getData();
        //        NS = this.ns;
        
        var id = com.ibm.mashups.enabler.xml.XPath.evaluateString(xp, this._getData(), this.ns);
        if (id) {
            var rawID = dojo.string.trim(id);
            ret = com.ibm.mm.enabler.IdentifiableHelper.getID(rawID);
        }
        
        return ret;
    },
    
    _getPrevious: function(node){
        var pointingID = this._findPointingNodeID(node);
        //        console.debug("pointing: ", pointingID);
        if (pointingID) {
            return this.find(pointingID).start(true);
        }
        return null;
    },
    
    _setNext: function(node, nextNode){
        //        console.debug("_setNext",node.getID(),nextNode.getID());
        
        if (node) {
            var next = com.ibm.mashups.enabler.xml.XPath.evaluateEntry("atom:link[@rel='next']", node.getXml(), this.ns);
            if (!next && nextNode) {
                next = com.ibm.mm.enabler.utils.Utils.createNode("atom:link", this.ns.atom);
                next.setAttribute("rel", "next");
                next.setAttribute("type", "application/atom+xml");
                node.getXml().appendChild(next);
            }
            
            if (next && nextNode) {
                var modelUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(this.urlType, this);
                modelUrl.setNodes([{
                    value: nextNode.getID(),
                    isID: true
                }, {
                    value: this.navigationNode.getID(),
                    isID: true
                }]);
                
                next.setAttribute("href", "?uri=" + modelUrl.getModelURI());
                com.ibm.mm.enabler.utils.Dom.setAttributeWithNS(node.getXml().ownerDocument, next, "ext:uri", "uri", this.ns.ext, modelUrl.getModelURI());
            }
            else 
                if (next) {
                    this._deleteNode(next);
                }
        }
    },
    
    _getNextNodeRawID: function(node){
        var ret = null;
        if (com.ibm.mm.enabler.utils.Misc.isInstanceOf(node, com.ibm.mashups.enabler.Transformable)) {
            node = node.getXml();
        }
        var xp = "atom:link[@rel='next']";
        var n = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(xp, node, this.ns);
        if (n) {
            ret = dojo.string.trim(com.ibm.mm.enabler.utils.Dom.getAttributeWithNS(n, "ext:uri", "uri", this.ns.ext));
        }
        return ret;
    },
    
    _getNextNodeID: function(node){
    
        var ret = this._getNextNodeRawID(node);
        if (ret) {
            ret = com.ibm.mm.enabler.IdentifiableHelper.getID(ret);
        }
        return ret;
    },
    
    _getNext: function(node){
        var nextID = this._getNextNodeID(node.getXml());
        if (nextID) {
            return this.find(nextID).start(true);
        }
        return null;
    },
    
    _setParent: function(node, parentNode){
        if (node && parentNode) {
            var modelUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(this.urlType, this);
            modelUrl.setNodes([{
                value: parentNode.getID(),
                isID: true
            }, {
                value: this.navigationNode.getID(),
                isID: true
            }]);
            var thr = com.ibm.mashups.enabler.xml.XPath.evaluateEntry("thr:in-reply-to", node.getXml(), this.ns);
            if (!thr) {
                thr = com.ibm.mm.enabler.utils.Utils.createNode("thr:in-reply-to", this.ns.thr);
                node.xmlData.appendChild(thr);
            }
            var modelUri = modelUrl.getModelURI();
            thr.setAttribute("ref", modelUri);
            com.ibm.mm.enabler.utils.Dom.setAttributeWithNS(node.getXml().ownerDocument, thr, "ext:uri", "uri", this.ns.ext, modelUri);
            thr.setAttribute("href", modelUrl.getAbsoluteURL());
        }
    },
    
    _setReplies: function(node){
        var modelUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(this.urlType, this);
        // create replies link
        modelUrl.setNodes([{
            value: node.getID(),
            isID: true
        }]);
        
        modelUrl.setParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_REPRESENTATION, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_REPRESENTATION_VALUE_FULL);
        
        var reply = this._findRepliesNode(node.getXml());
        if (reply === null) {
            reply = com.ibm.mm.enabler.utils.Dom.createElement(this._getData(), "atom:link", this.ns.atom);
            reply.setAttribute("rel", "replies");
            reply.setAttribute("type", "application/atom+xml");
            node.getXml().appendChild(reply);
        }
        reply.setAttribute("href", modelUrl.getAbsoluteURL());
        com.ibm.mm.enabler.utils.Dom.setAttributeWithNS(this._getData(), reply, "ext:uri", "uri", this.ns.ext, modelUrl.getModelURI());
    },
    
    create: function(context){
    
        var LOG_METHOD = "create(context)";
        var IS_LOGGING = com.ibm.mm.enabler.layout.LayoutModelImpl.LOGGER.isLoggable(com.ibm.mm.enabler.layout.LayoutModelImpl.LOG_LEVEL);
        if (IS_LOGGING) {
            com.ibm.mm.enabler.layout.LayoutModelImpl.LOGGER.entering(LOG_METHOD, arguments);
        }
        
        if (this._isEmpty(context)) {
            throw new Error(this.modelMessages.E_PARAM_ISNULL_0);
        }
        
        var widgetDef = context[com.ibm.mashups.enabler.layout.Constants.CONTEXT_WIDGET_DEFINITION_ID];
        var widgetUrl = context[com.ibm.mashups.enabler.layout.Constants.CONTEXT_WIDGET_DEFINITION_URL];
        var type = context[com.ibm.mashups.enabler.layout.Constants.CONTEXT_TYPE];
        var displayTitle = context[com.ibm.mashups.enabler.layout.Constants.DISPLAY_TITLE];
        
        if (this._isEmpty(type) || (type != com.ibm.mashups.enabler.layout.Constants.LAYOUT_CONTROL && type != com.ibm.mashups.enabler.layout.Constants.LAYOUT_CONTAINER)) {
            throw new Error(this.modelMessages.E_INVALID_CONTEXT_MISSING_TYPE_0);
        }
        
        if (type == com.ibm.mashups.enabler.layout.Constants.LAYOUT_CONTROL && !(this._isEmpty(widgetDef) ^ this._isEmpty(widgetUrl))) {
            // if either both def and url or none are defined, throw an error
            throw new Error(this.modelMessages.E_INVALID_CONTEXT_SPECIFIED_0);
        }
        
        if (!this._isEmpty(widgetDef) && (!dojo.isString(widgetDef) && !com.ibm.mm.enabler.utils.Misc.isInstanceOf(widgetDef, com.ibm.mashups.enabler.Identifiable))) {
            throw new Error(this.modelMessages.E_WIDGETDEF_MUST_BE_IDENTIFIABLE_0);
        }
        
        var entry = com.ibm.mm.enabler.utils.Utils.createNode("atom:entry", this.ns.atom);
        
        // make the id know to the identification service
        com.ibm.mashups.enabler.services.IdentificationService.attachClientID(this._cidCounter);

        var id = com.ibm.mm.enabler.utils.Utils.createNode("atom:id", this.ns.atom);
        com.ibm.mm.enabler.utils.Dom.textContent(id, this._cidPrefix + this._cidCounter++);
        entry.appendChild(id);
        
        var content = com.ibm.mm.enabler.utils.Utils.createNode("atom:content", this.ns.atom);
        content.setAttribute("type", "application/xml");
        entry.appendChild(content);
        
        var mNode, ret;
        if (type == com.ibm.mashups.enabler.layout.Constants.LAYOUT_CONTROL) {
            mNode = com.ibm.mm.enabler.utils.Utils.createNode("model:layout-control", this.ns.model);
            
            var attr, val;
            if (widgetDef) {
                attr = "portlet-definition";
                var tempUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(com.ibm.mashups.enabler.model.url.ModelUrlFactory.WIDGET_URL, this);
                tempUrl.setNodes([{
                    value: com.ibm.mm.enabler.utils.Utils.getIdFromIdentifiable(widgetDef),
                    isID: true
                }]);
                val = tempUrl.getModelURI();
            }
            else {
                attr = "widget-definition-url";
                val = widgetUrl.toString();
            }
            com.ibm.mm.enabler.utils.Dom.setAttributeWithNS(this._getData(), mNode, "creation-context:" + attr, attr, this.ns["creation-context"], val);
            
            ret = new com.ibm.mm.enabler.layout.LayoutControlImpl(entry, this);
            ret._setDisplayTitle(displayTitle);
            ret._addDirtyCallback(this, this._setLMBaseDirty);
        }
        else 
            if (type == com.ibm.mashups.enabler.layout.Constants.LAYOUT_CONTAINER) {
                mNode = com.ibm.mm.enabler.utils.Utils.createNode("model:layout-container", this.ns.model);
                ret = new com.ibm.mm.enabler.layout.LayoutContainerImpl(entry, this);
                ret._addDirtyCallback(this, this._setLMBaseDirty);
            }
        content.appendChild(mNode);
        
        if (IS_LOGGING) {
            com.ibm.mm.enabler.layout.LayoutModelImpl.LOGGER.exiting(LOG_METHOD, [ret]);
        }
        
        return ret;
    },
    
    _cidCounter: 0,
    
    confirmCreate: function(context){
        var LOG_METHOD = "confirmCreate(context)";
        var IS_LOGGING = com.ibm.mm.enabler.layout.LayoutModelImpl.LOGGER.isLoggable(com.ibm.mm.enabler.layout.LayoutModelImpl.LOG_LEVEL);
        if (IS_LOGGING) {
            com.ibm.mm.enabler.layout.LayoutModelImpl.LOGGER.entering(LOG_METHOD, arguments);
        }
        
        var ret = this.getConfirmCreate();
        
        if (IS_LOGGING) {
            com.ibm.mm.enabler.layout.LayoutModelImpl.LOGGER.exiting(LOG_METHOD, [ret]);
        }
        
        return ret;
    },
    
    insert: function(node, parentNode, nextNode){
        var LOG_METHOD = "insert(node,parentNode,nextNode)";
        var IS_LOGGING = com.ibm.mm.enabler.layout.LayoutModelImpl.LOGGER.isLoggable(com.ibm.mm.enabler.layout.LayoutModelImpl.LOG_LEVEL);
        if (IS_LOGGING) {
            com.ibm.mm.enabler.layout.LayoutModelImpl.LOGGER.entering(LOG_METHOD, arguments);
        }
        
        if (this._isEmpty(node)) {
            throw new Error(this.modelMessages.E_NODE_ISNULL_0);
        }
        if (this._isEmpty(parentNode)) {
            throw new Error(this.modelMessages.E_NODE_ISNULL_0);
        }
        if (com.ibm.mm.enabler.utils.Utils.getIdFromIdentifiable(node) == com.ibm.mm.enabler.utils.Utils.getIdFromIdentifiable(nextNode)) {
            throw new Error(this.modelMessages.E_LAYOUTNODE_NEXT_CAN_NOT_BE_ITSELF_0);
        }
        
        var oldParent = this.getParent(node).start(true);
        var lastOfNewParent = this.getChildren(parentNode)._lastEntry();
        
        // get old next node
        var oldNext = this._getNext(node);
        // get old previous node
        var oldPrev = this._getPrevious(node);
        
        var parentChanged = com.ibm.mm.enabler.utils.Utils.getIdFromIdentifiable(oldParent) != com.ibm.mm.enabler.utils.Utils.getIdFromIdentifiable(parentNode);
        if (parentChanged) {
            // parent changed
            if (oldParent) {
                // if the page to delete is the only child of its parent, 
                // the replies-link of the parent must be removed			
                this._deParent(node);
            }
            // parent is new or changed, so set it
            this._setParent(node, parentNode);
            node._setDirty();
            
            // add replies link to new parent (if there is none, yet)
            this._setReplies(parentNode);
        }
        
        // no else if here!
        if (nextNode) {
            // we have a next node (if not, node is at the end)
            var oldNextPrev = this._getPrevious(nextNode);
            if (oldNextPrev) {
                // wasn't first node
                // change "next" link of previous node to point to the new inserted node
                this._setNext(oldNextPrev, node);
            }
        }
        else {
            // node shall be inserted at the end, so let the current last node point to it
            if (lastOfNewParent) {
                this._setNext(lastOfNewParent, node);
            }
        }
        
        if (oldPrev) {
            // if old previous node is not null (the node was not at the beginning), we need to change the next link
            this._setNext(oldPrev, oldNext || null);
        }
        
        // set "next" link of new node
        this._setNext(node, nextNode || null);
        node._setDirty();
        
        this._nodes.add(com.ibm.mm.enabler.utils.Utils.getIdFromIdentifiable(node), node);
        
        node._addDirtyCallback(this, this._setLMBaseDirty);
        this._setDirty();
        
        parentNode.getXml().parentNode.appendChild(node.getXml());
        
        if (IS_LOGGING) {
            com.ibm.mm.enabler.layout.LayoutModelImpl.LOGGER.exiting(LOG_METHOD);
        }
    },
    
    confirmInsert: function(node, parentNode, nextNode){
        var LOG_METHOD = "confirmInsert(node,parentNode,nextNode)";
        var IS_LOGGING = com.ibm.mm.enabler.layout.LayoutModelImpl.LOGGER.isLoggable(com.ibm.mm.enabler.layout.LayoutModelImpl.LOG_LEVEL);
        if (IS_LOGGING) {
            com.ibm.mm.enabler.layout.LayoutModelImpl.LOGGER.entering(LOG_METHOD, arguments);
        }
        
        if (this._isEmpty(node)) {
            throw new Error(this.modelMessages.E_NODE_ISNULL_0);
        }
        if (this._isEmpty(parentNode)) {
            throw new Error(this.modelMessages.E_NODE_ISNULL_0);
        }
        
        // first check ac THEN model restrictions (model is superior to ac)
        // we don't care for parentNode currently, as every access is restricted on navigation node level
        var ret = this._isContainer(parentNode) && com.ibm.mm.enabler.utils.Utils.getIdFromIdentifiable(node) != com.ibm.mm.enabler.utils.Utils.getIdFromIdentifiable(parentNode) && this.getConfirmInsert(null, this.navigationNode, null) && this.isModifiable(node) && this.isModifiable(parentNode);
        
        if (IS_LOGGING) {
            com.ibm.mm.enabler.layout.LayoutModelImpl.LOGGER.exiting(LOG_METHOD, [ret]);
        }
        
        return ret;
    },
    
    remove: function(node){
        var LOG_METHOD = "confirmInsert(node,parentNode,nextNode)";
        var IS_LOGGING = com.ibm.mm.enabler.layout.LayoutModelImpl.LOGGER.isLoggable(com.ibm.mm.enabler.layout.LayoutModelImpl.LOG_LEVEL);
        if (IS_LOGGING) {
            com.ibm.mm.enabler.layout.LayoutModelImpl.LOGGER.entering(LOG_METHOD, arguments);
        }
        
        var ret = this._remove(node);
        
        this._setDirty();
        
        if (IS_LOGGING) {
            com.ibm.mm.enabler.layout.LayoutModelImpl.LOGGER.exiting(LOG_METHOD, [ret]);
        }
        
        return ret;
    },
    
    _remove: function(node, skipRealDelete){
        if (this._isEmpty(node)) {
            throw new Error(this.modelMessages.E_NODE_ISNULL_0);
        }
        
        node = this.find(node).start(true);
        
        if (node) {
        
            var siblings = -1;
            
            if (this._isContainer(node)) {
                // user is trying to delete a container, so delete all children
                var childIt = this.getChildren(node);
                var deleteNodes = [];
                while (childIt.hasNext()) {
                    var child = childIt.next();
                    deleteNodes.push(child);
                }
                dojo.forEach(deleteNodes, function(node){
                    // skipRealDelete true -> don't add the children to the deleted nodes
                    this._remove(node, true);
                }, this);
            }
            
            var parent = this.getParent(node).start(true);
            if (parent) {
                siblings = this.getChildren(parent).size().start(true) - 1;
            }
            
            this._deleteNode(node.getXml());
            
            var id = com.ibm.mm.enabler.utils.Utils.getIdFromIdentifiable(node);
            //console.debug("removed?",this._nodes.count);
            this._nodes.remove(id);
            
            node._removeDirtyCallback(this._setLMBaseDirty);
            
            this._setDirty();
            
            //console.debug("removed after?",this._nodes.count);
            // if it was created new, remove it
            
            if (!skipRealDelete && !this._isClientNode(node)) {
                // is not not on client only, so really delete
                this._deletedNodes.add(id, node);
            }
            if (id == com.ibm.mm.enabler.utils.Utils.getIdFromIdentifiable(this._root)) {
                // root has been deleted - kill it
                this._root = null;
            }
            // if the page to delete is the only child of its parent, 
            // the replies-link of the parent must be removed			
            if (siblings === 0) {
                // has no other siblings, so remove the replies link from parent
                this._deParent(node);
            }
            else 
                if (siblings > 0) {
                    // was not the only child, so rearrange links
                    var nextNode = this._getNext(node);
                    //                console.debug("nextNode",nextNode);
                    // next node may be null (if there are no more nodes)
                    var previousNode = this._getPrevious(node);
                    //                console.debug("previousNode",previousNode);
                    if (previousNode) {
                        // and there is a previous node
                        // change "next" link pointing to this node to the node this node is pointing to
                        this._setNext(previousNode, nextNode);
                    }
                }
                else {
                // is root container (siblings == -1)
                }
        }
    },
    
    confirmRemove: function(node){
        var ret;
        var LOG_METHOD = "confirmRemove(node)";
        var IS_LOGGING = com.ibm.mm.enabler.layout.LayoutModelImpl.LOGGER.isLoggable(com.ibm.mm.enabler.layout.LayoutModelImpl.LOG_LEVEL);
        if (IS_LOGGING) {
            com.ibm.mm.enabler.layout.LayoutModelImpl.LOGGER.entering(LOG_METHOD, arguments);
        }
        
        if (this._isEmpty(node)) {
            throw new Error(this.modelMessages.E_NODE_ISNULL_0);
        }
        
        // first check ac THEN model restrictions (model is superior to ac)
        // we don't care for parentNode currently, as every access is restricted on navigation node level
        if (this.isDeletable(node)) {
            if (this.navigationNode.isPrivate()) {
                ret = this.navigationNode.hasRole(com.ibm.mashups.enabler.ac.RoleType.PRIVILEGED_USER);
            }
            else {
                ret = this.navigationNode.hasRole(com.ibm.mashups.enabler.ac.RoleType.EDITOR);
            }
        }
        else {
            ret = false;
        }
        
        if (IS_LOGGING) {
            com.ibm.mm.enabler.layout.LayoutModelImpl.LOGGER.exiting(LOG_METHOD, [ret]);
        }
        return ret;
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.layout.LayoutModelImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.layout.LayoutModelImpl"] = true;
dojo.provide("com.ibm.mm.enabler.layout.LayoutModelImpl");

// APIs















// Implementations








//





// Constants







// for backwards compatibility


// i18n



// mixins






// layout model
dojo.declare("com.ibm.mm.enabler.layout.LayoutModelImpl", [// APIs
com.ibm.mashups.enabler.model.LayoutModel, com.ibm.mashups.enabler.TreeModelController, com.ibm.mashups.enabler.wire.WireModelProvider, com.ibm.mm.enabler.strategy.HiddenMetaDataLoadingStrategyHelperImpl, com.ibm.mm.enabler.ConfirmableModelImpl, com.ibm.mm.enabler.model.ModelImpl, // LayoutModel extensions
 com.ibm.mm.enabler.layout._LayoutModelBaseMixin, com.ibm.mm.enabler.layout._LayoutModelWireModelProviderMixin, com.ibm.mm.enabler.layout._LayoutModelTreeModelControllerMixin, com.ibm.mm.enabler.layout._LayoutModelLocatorMixin, com.ibm.mm.enabler.DirtyFlagProviderImpl, com.ibm.mm.enabler.LazyLoadSupport], {
    /**
     * Namespaces hash map
     *
     * @private
     */
    ns: null,
    
    
    /**
     * Fragment (Layout Model)
     */
    urlType: com.ibm.mashups.enabler.model.url.ModelUrlFactory.LAYOUT_URL,
    
    
    /**
     * The collection URL
     *
     * @private
     */
    entryUrl: "",
    
    navigationNode: null,
    
    /**
     * The constructor
     *
     * @param {Object} href
     * @param {Object} uri
     * @param {Object} navigationModel
     * @param {Object} navigationNode
     */
    constructor: function(href, uri, navigationNode) {
    
        this.uri = uri;
        this.href = href;
        this.navigationNode = navigationNode;
        
        // messages
        this.modelMessages = dojo.i18n.getLocalization("com.ibm.mm.enabler", "modelMessages");
        
        var serviceCollection = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_CONTENT);
        this.prefix = serviceCollection.idprefix;
        
        this.entryUrl = this.href;
        
        // define namespaces
        this.ns = dojo.delegate(serviceCollection.namespaces, com.ibm.mm.enabler.model.NameSpaceFactory.getNameSpaces([com.ibm.mm.enabler.model.NameSpaceFactory.NS_ATOM, com.ibm.mm.enabler.model.NameSpaceFactory.NS_THR, com.ibm.mm.enabler.model.NameSpaceFactory.NS_XML, com.ibm.mm.enabler.model.NameSpaceFactory.NS_OPENSEARCH, com.ibm.mm.enabler.model.NameSpaceFactory.NS_XHTML, com.ibm.mm.enabler.model.NameSpaceFactory.NS_XSI]));

        var handler = function() {
            //var LOG_METHOD = "LayoutModel.dirtyHandler()";
            //var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
            //if (bIsLoggable) {
            //    this.LOGGER.trace(LOG_METHOD, "Layout Model has been changed. Switching to edit representation.");
            //}
            var cs = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.iwidget.services.ContainerService.SERVICE_NAME);
            cs.switchToModifiablePersistenceMode();
            this.removeDirtyCallback(handler);
        };
        this.addDirtyCallback(this, dojo.hitch(this, handler));

    },
    
    _getNavigationNode: function() {
        return this.navigationNode;
    },
    
    _commit: function(deferred, sync, parentModel) {
        // the _commit has to run sync at the moment. if multipart is disabled the method is not forced into sync mode if the variable
        // that is passed in is false. In this case we force it to be synchronous
        if (!com.ibm.mashups.enabler.io.XHRMultipartFactory.isMultipartEnabled()) {
            sync = true;
        }
        // first commit changes for new controls / modified ones
        var mpHandler = com.ibm.mashups.enabler.io.XHRMultipartFactory.create();
        mpHandler.startTransaction();
        this.widgetWindowLoadAheadMap = {};
        this._commitChanges(deferred, sync, parentModel, this.getRoot().start(true));
        var strategyService = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.StrategyService.SERVICE_NAME);
        var strategy = new com.ibm.mashups.enabler.strategy.WidgetWindowLoadAheadStrategy(this.widgetWindowLoadAheadMap);
        strategyService.setStrategy("com.ibm.mashups.enabler.widget.WidgetModel", strategy);
        // now we call the multipart handler
        mpHandler.endTransactionDeferred().start();
        // clean out the strategy
        strategyService.removeStrategy("com.ibm.mashups.enabler.widget.WidgetModel", "com.ibm.mashups.enabler.strategy.WidgetWindowLoadAheadStrategy");
        
        // then commit wiremodel (maybe wires are deleted as well
        this._commitWireModel(deferred, sync, parentModel);
        
        // delete layout controls last
        mpHandler = com.ibm.mashups.enabler.io.XHRMultipartFactory.create();
        mpHandler.startTransaction();
        this._commitDelete(deferred, sync, parentModel);
        mpHandler.endTransactionDeferred().start();
        
        // mark this model as 'clean' (no more pending changes)
        this._setClean();
    },
    
    _replaceNodeXmlFromFeed: function(node, previousNode, feedXml) {
        //console.debug("_replaceNodeXmlFromFeed",feedXml);
        if (feedXml) {
            var entry = com.ibm.mashups.enabler.xml.XPath.evaluateEntry("//atom:entry", feedXml, this.ns);
            if (entry) {
                this._replaceNodeXml(node, previousNode, entry);
            }
        }
    },
    
    _replaceNodeXml: function(node, previousNode, newXml) {
        
        if (dojo.isWebKit) {
            // Safari can not reparent a node from one Document to another - needs to be cloned first
            newXml = newXml.cloneNode(true);
        }
        
        // find feed parent
        var parent = node.getXml().parentNode;
        if (!previousNode) {
            previousNode = this._getPrevious(node);
        }
        var nextNode = this._getNext(node);
        var wasClientNode = this._isClientNode(node);
        
        // get old id
        var oldId = com.ibm.mm.enabler.utils.Utils.getIdFromIdentifiable(node);
        
        // remove the old node from the feed
        this._deleteNode(node.getXml());
        
        // replace old XML by new XML
        node.setXml(newXml);
        
        // came from server, so no update needed, mark clean
        node._setClean();
        
        // add new node to the feed
        parent.appendChild(node.getXml());
        
        if (previousNode && wasClientNode) {
            // set the old previous node to point to this
            this._setNext(previousNode, node);
        }
        
        // WARNING:
        // make sure to always set the next node, as the server currently doesn't send next links in the update response
        // if this is done only for client next nodes, multi-commit scenarios like switching the layout to freeform with
        // multiple widgets on page will break as the model looses knowledge about next nodes once the first control
        // is committed. As a result the iterator.next() call will fail!
        if (nextNode) {
            // set this node to point to the old nextNode
            this._setNext(node, nextNode);
        }
        
        // get new id
        var newId = com.ibm.mm.enabler.utils.Utils.getIdFromIdentifiable(node);
        if (oldId != newId) {
            // obviously this was a create and the ID changed, so replace the node in our dictionary
            this._nodes.remove(oldId);
            this._nodes.add(newId, node);
        }
        this._setDirty();
    },
    
    _commitWireModel: function(deferred, sync, parentModel) {
        // commit wire model
        if (this._wireModel) {
            this.lazyLoadModules(["WidgetModel"]);
            
            var widgetModel = com.ibm.mashups.enabler.widget.Factory.getWidgetModel();
            
            if (this._wireModel._isDirty() && widgetModel.isDirty()) {
                widgetModel.commit().start(sync);
            }
            this._wireModel._commit(deferred, sync, parentModel);
        }
    },
    
    _commitDelete: function(deferred, sync, parentModel) {
        // DELETE
        // walk through all deleted nodes
        this._deletedNodes.forEach(function(entry) {
            var node = entry.valueOf();
            var myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(node.getEditLink(), this);
            var serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
            
            parentModel._acquire();
            serviceReq.remove(dojo.hitch(this, function(type, data, xhr, deferred) {
                if (deferred) {
                    deferred.finishOperation(node.getID(), com.ibm.mashups.enabler.DeferredOperation.OPERATION_DELETE, xhr.status);
                }
                parentModel._release(deferred, xhr.status);
            }), deferred);
            
        }, this);
        
        // clear the deleted nodes
        this._deletedNodes.clear();
    },
    
    _commitChanges: function(deferred, sync, parentModel, container) {
        if (!container) {
            return;
        }
        var childrenIt = this.getChildren(container);

        var previousNode = null;
        while (childrenIt.hasNext()) {
            var node = childrenIt.next();
            
            if (this._isClientNode(node)) {
                // was inserted
                this._insertCommit(node, previousNode, deferred, sync, parentModel);
            }
            else if (node && node._isDirty()) {
                // was changed
                this._updateCommit(node, deferred, sync, parentModel);
            }
            if (this._isContainer(node)) {
                this._commitChanges(deferred, sync, parentModel, node);
            }

            previousNode = node;
        }
    },
    
    _prepareNodeCommit: function(node) {
        // Since we commit from top to bottom now we calculate the closest fixed node as next link.
        // A fixed node is a node which has not been deleted, updated, nor inserted. This may also be null in case it is the end
        // This is especially important for a scenario where one has four nodes and the two middle ones are client nodes.
        // The first client node must be added with a next link of ID(4) and the second client node as well to end up in the right order.
        // Example #1:
        // top to bottom: 1, 2 (client), 3 (client), 4, 5 (client)
        // 1. insert 2 with next link 4 -> result on the server 1,2,4
        // 2. insert 3 with next link 4 -> result on the server 1,2,3,4
        // 3. insert 5 with no next link -> result on the server 1,2,3,4,5
        // Example #2:
        // pages (start): 1, 2, 3, 4
        // pages (end): 2 (moved), 4 (moved), 1 (updated), 3, 5 (new)
        // top to bottom:
        // 1. PUT 2 with next link 3 (as this is the closest fixed node) -> result on the server 1,2,3,4
        // 2. PUT 4 with next link 3 (as this is the closest fixed node) -> result on the server 1,2,4,3
        // 3. PUT 1 with next link 3 (as this is the closest fixed node) -> result on the server 2,4,1,3
        // 4. POST 5 with next link null (as this is the closest fixed node) -> result on the server 2,4,1,3,5
        var isChanged = true;
        var fixedNextNode = null;
        var tempNode = node;
        while (isChanged) { // we stop once we find a none client id or hit the end
            var nextLink = com.ibm.mashups.enabler.xml.XPath.evaluateEntry("atom:link[@rel='next']", tempNode.getXml(), this.ns);
            if (nextLink) { // yes we have a next link so we have to lookup this node
                var nextId = com.ibm.mm.enabler.utils.Utils.getIdFromExtUri(this.prefix, nextLink);
                var nextNode = this.find(nextId).start(); // this is all in memory so we can do this
                var isClient = this._isClientNode(nextNode);
                var isDirty = nextNode._isDirty();
                isChanged = isClient || isDirty;
                if (!isChanged) {
                    fixedNextNode = nextNode;
                }
                tempNode = nextNode;
            }
            else {
                // we are at the end
                isChanged = false;
                fixedNextNode = null;
            }
        }
        // we create a temp node to replace the next link
        tempNode = new com.ibm.mm.enabler.layout.LayoutNodeImpl(node.getXml().cloneNode(true), this);
        this._setNext(tempNode, fixedNextNode);
        return tempNode;
    },
    
    _updateCommit: function(node, deferred, sync, parentModel) {
        
        var myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(node.getEditLink(), this);
        
        // Full representation
        myUrl.setParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_REPRESENTATION, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_REPRESENTATION_VALUE_FULL);
        
        var newNode = node;
        if (this._isControl(node)) {
            // AC mode needed
            myUrl.addParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT_VALUE_ACCESS_CONTROL);

            // we add the id as window id here as we know that widget window and control always have the same ID
            // this map is used later in the WidgetModel for preloading the nodes in a multipart request
            this.widgetWindowLoadAheadMap[node.getID()] = node;
            
            newNode = this._prepareNodeCommit(node);
        }
        
        var serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
        
        parentModel._acquire();
        serviceReq.update(newNode.toString(), dojo.hitch(this, function(type, data, xhr, args) {
            var deferred = args.deferred;
            
            try {
                if (xhr.status == com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK) {
                    this._replaceNodeXmlFromFeed(args.node, null, data);
                }
                
                if (deferred) {
                    deferred.finishOperation(com.ibm.mm.enabler.utils.Utils.getIdFromIdentifiable(args.node), com.ibm.mashups.enabler.DeferredOperation.OPERATION_MODIFY, xhr.status);
                }
            } 
            catch (e) {
                console.error(e);
            }
            
            parentModel._release(deferred, xhr.status);
        }), {
            node: node,
            deferred: deferred
        });
    },
    
    _insertCommit: function(node, previousNode, deferred, sync, parentModel) {
        var myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(this.entryUrl, this);
        
        // Full representation
        myUrl.setParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_REPRESENTATION, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_REPRESENTATION_VALUE_FULL);
        
        var newNode = node;
        if (this._isControl(node)) {
            // AC mode needed
            myUrl.addParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT_VALUE_ACCESS_CONTROL);
            
            // we add the id as window id here as we know that widget window and control always have the same ID
            // this map is used later in the WidgetModel for preloading the nodes in a multipart request
            this.widgetWindowLoadAheadMap[node.getID()] = node;
            
            newNode = this._prepareNodeCommit(node);
        }

        var serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
        parentModel._acquire();
        serviceReq.create(newNode.toString(), dojo.hitch(this, function(type, data, xhr, args) {
            var deferred = args.deferred;
            var node = args.node;
            var previousNode = args.previousNode;
            
            try {
                if (xhr.status == com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_CREATED) {
                    this._replaceNodeXmlFromFeed(node, previousNode, data);
                }
                
                if (deferred) {
                    deferred.finishOperation(node, com.ibm.mashups.enabler.DeferredOperation.OPERATION_CREATE, xhr.status);
                }
            } 
            catch (e) {
                console.error(e);
            }

            parentModel._release(deferred, xhr.status);
        }), {
            node: node,
            previousNode: previousNode,
            deferred: deferred
        });
    },
    
    _getMediaLink: function() {
        // media link
        var xmlResult = com.ibm.mashups.enabler.xml.XPath.evaluateEntry("atom:link[@ext:rel='media']", this.root.xmlData, this.ns);
        if (xmlResult) {
            return xmlResult.getAttribute("href");
        }
        return null;
    },
    
    _getEditMediaLink: function() {
        // edit media link
        var xmlResult2 = com.ibm.mashups.enabler.xml.XPath.evaluateEntry("atom:link[@rel='edit-media']", this.root.xmlData, this.ns);
        if (xmlResult2) {
            return xmlResult2.getAttribute("href");
        }
        return null;
    }
});

// get the logger for this class
com.ibm.mm.enabler.layout.LayoutModelImpl.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.enabler.layout.LayoutModelImpl");
// specify the default log level for this class
com.ibm.mm.enabler.layout.LayoutModelImpl.LOG_LEVEL = com.ibm.mashups.enabler.logging.LogLevel.TRACE;

}

if(!dojo._hasResource["com.ibm.mashups.enabler.model.LayoutModel"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.model.LayoutModel"] = true;
dojo.provide("com.ibm.mashups.enabler.model.LayoutModel");











//dojo..require("com.ibm.mashups.enabler.widget.WidgetDefinition");






}

if(!dojo._hasResource["com.ibm.mashups.enabler.remote.RemoteFile_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.remote.RemoteFile_API"] = true;
dojo.provide("com.ibm.mashups.enabler.remote.RemoteFile_API");
dojo.provide("com.ibm.mashups.enabler.remote.RemoteFile");

/**
 * Interface for a remote File.
 * @ibm-api
 * @ibm-module RemoteModel
 */
dojo.declare("com.ibm.mashups.enabler.remote.RemoteFile", [com.ibm.mashups.enabler.MetaData, com.ibm.mashups.enabler.Identifiable], {
    /**
     * Returns the name of this File
     * @return {String} The name
     */
    getName: function(){
    },
    
    /**
     * Returns true if this is a directory otherwise returns false.
     * @return {boolean} True if this is a directory
     */
    isDirectory: function(){
    },
    
    /**
     * Returns the absolute URL of this file.
     * @return {String} The URL
     * @deprecated Use getURL instead.
     */
    getUrl: function(){
    },
    
    /**
     * Returns the absolute URL of this file.
     * @return {String} The URL
     */
    getURL: function(){
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.remote.WebDavUrlFactoryImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.remote.WebDavUrlFactoryImpl"] = true;
dojo.provide("com.ibm.mm.enabler.remote.WebDavUrlFactoryImpl");




/*
 * A private object that supplies the urls used to access the webdav server
 * Since this is a private object, this does not implement a public interface but that could easily be done.
 */
dojo.declare("com.ibm.mm.enabler.remote.WebDavUrlFactoryImpl", com.ibm.mm.enabler.ServiceDocConsumer, {

    _initServiceDoc: function() {
    	this.inherited("_initServiceDoc", arguments);
        // Get the absolute url
        var collectionData = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData([com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_WEBDAV, com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_FILESTORE]);
        
        if (collectionData) {
            this._fullUrl = collectionData.url;
            
            var idx = this._fullUrl.indexOf("//");
            var tempString = this._fullUrl.substring(idx + 2);
            var idx2 = tempString.indexOf("/");
            var domainLength = idx + idx2 + 2;
            
            // This is the protocol, domain and port
            // example: http://localhost:8080
            this._domainUrl = this._fullUrl.substring(0, domainLength);
            
            // This is the path to the filestore root
            // example: /mum/mycontenthandler/mm/dav/mmdav/
            this._context = this._fullUrl.substring(domainLength);
        }
    },
    
    /*
     * Returns an absolute path to a webdav resource
     */
    createUrl: function(path) {
    	this._initServiceDoc();
        var uri = null;
        if (!path) {
            uri = this._fullUrl;
        }
        else if (path == this._fullUrl) {
            // they're asking for root but they're missing the elusive double slash
            uri = path + "/";
        }
        else if (path.indexOf(this._fullUrl) === 0) {
            // this is already an absolute path
            uri = path;
        }
        else if (path.indexOf(this._context) === 0) {
            // this has the context but not the domain etc
            uri = this._domainUrl + path;
        }
        else {
            // this is just the relative path, make it absolute
            uri = this._fullUrl + path;
        }
        return uri;
    },
    
    getUserHome: function() {
        var userHome = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData([com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_WEBDAV, com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_USER]);
        
        return userHome.url;
    }
});

// create a static var to make it easier to call
com.ibm.mm.enabler.remote.WebDavUrlFactory = new com.ibm.mm.enabler.remote.WebDavUrlFactoryImpl();

}

if(!dojo._hasResource["com.ibm.mm.enabler.remote.WebDavCommandImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.remote.WebDavCommandImpl"] = true;
dojo.provide("com.ibm.mm.enabler.remote.WebDavCommandImpl");




/*
 * A private object that hides xhr requests to a Webdav server
 * Since this is a private object, this does not implement a public interface but that could easily be done.
 */
dojo.declare("com.ibm.mm.enabler.remote.WebDavCommandImpl", null, {

    statics: {
        timeout: 1000 * 60 * 3 // 3 mins       
    },
    
    /*
     * action: the http method to use
     * path: the path of the resource
     * form: (optional) the id of a form node that contains data to send with the request
     * data: (optional) the data to send within the body of the action
     * headers: (optional) a map of headers & values to send with the request
     * handleAs: should be "xml" or "text"
     */
    constructor: function(action, path, form, data, headers, handleAs) {
        this._action = action;
        if (dojo.isIE) {
            // Internet Explorer sucks, it does not encode the url for ajax when it should
            // without this, urls with unicode chars break (ie filenames with asian chars)        	
            this._path = encodeURI(path);
        }
        else {
            this._path = path;
        }
        this._handleAs = handleAs;
        this._form = form;
        this._data = data;
        this._headers = headers;
    },
    
    /*
     * Returns an absolute uri for the file
     */
    getURI: function() {
        var uri = com.ibm.mm.enabler.remote.WebDavUrlFactory.createUrl(this._path);
        return uri;
    },
    
    /*
     * Returns a dojo.deferred
     */
    execute: function(sync) {
    
        var actionArgs = {
            url: this.getURI(),
            sync: sync || false,
            handleAs: this._handleAs,
            timeout: this.statics.timeout,
			preventCache: dojo.isIE <7			
        };
        
        // check if we need to send a body with the request as well
        var hasBody = false;
        if (this._data) {
            actionArgs.postData = this._data;
            hasBody = true;
        }
        
        // add any custom headers if applicable
        if (this._headers) {
            actionArgs.headers = this._headers;
        }
        
        if (this._form) {
            // if we're given a form that contains a file input, we can't use ajax (because of security constraints) 
            // instead we need to use an iframe which unfortunately can only can do a POST.			
            actionArgs.form = this._form;
            actionArgs.method = "POST";
            
            // dojo.io.iframe expects a special html response wrapped in a <textarea>
            // add a special param so that the Portal resolver knows to wrap the response 
            if (actionArgs.url.indexOf('?') == -1) {
                actionArgs.url = actionArgs.url + "?mime-type=text/html";
            }
            else {
                actionArgs.url = actionArgs.url + "&mime-type=text/html";
            }
            
            return dojo.io.iframe.send(actionArgs);
        }
        else {
            return dojo.xhr(this._action, actionArgs, hasBody);
        }
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.remote.WebDavResponseImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.remote.WebDavResponseImpl"] = true;
dojo.provide("com.ibm.mm.enabler.remote.WebDavResponseImpl");




/*
 * A private object that hides handling of an xml response to an xhr requests
 * Since this is a private object, this does not implement a public interface but that could easily be done.
 */
dojo.declare("com.ibm.mm.enabler.remote.WebDavResponseImpl", null, {

    // We have to pass the namespace to the XPath engine
    namespace: {
        "D": "DAV:",
        "a": "DAV:",
        "dav": "DAV:"
    },
    
    paths: {
        collection: "//D:multistatus/D:response/D:propstat/D:prop/D:resourcetype/D:collection",
        href: "//D:multistatus/D:response/D:href",
        lastmodified: "//D:multistatus/D:response[D:href='${path}']/D:propstat/D:prop/D:getlastmodified",
        creationdate: "//D:multistatus/D:response[D:href='${path}']/D:propstat/D:prop/D:creationdate"
    },
    
    constructor: function() {
    },
    
    /*
     * Returns an array of nodes
     * If this is an empty array, then the resource is a collection
     */
    isCollection: function(data) {
        return com.ibm.mashups.enabler.xml.XPath.evaluateBoolean(this.paths.collection, data, this.namespace);
    },
    
    /*
     * Returns an array of nodes
     * If this is a collection, there will be one node per child containing it's href
     * Otherwise, there will be just a single node that contains the href of the item.
     */
    getHrefs: function(data) {
        var nodes = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(this.paths.href, data, this.namespace);
        return this.convertNodesToStrings(nodes);
    },
    
    getID: function(data, fn) {
        if (!data) {
            return null;
        }
        var nodes = this.getHrefs(data);
        return nodes && nodes.length > 0 ? nodes[0] : null;
    },
    
    getLastModified: function(data, fileHref) {
        var expr = this.paths.lastmodified.replace(/\$\{path\}/, fileHref);
        var nodes = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(expr, data, this.namespace);
        var arr = this.convertNodesToStrings(nodes);
        return arr && arr.length > 0 ? arr[0] : null;
    },
    
    getCreationDate: function(data, fileHref) {
        var expr = this.paths.creationdate.replace(/\$\{path\}/, fileHref);
        var nodes = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(expr, data, this.namespace);
        var arr = this.convertNodesToStrings(nodes);
        return arr && arr.length > 0 ? arr[0] : null;
    },
    
    /*
     * Converts a node[] to a string[]
     */
    convertNodesToStrings: function(nodes) {
        var strings = null;
        if (nodes) {
            strings = [];
            for (var i = 0, l = nodes.length; i < l; i++) {
                // we need to use this dojo method for browser compatability 
                var s = dojox.xml.parser.textContent(nodes[i]);
                // the contents are url encoded so we need to decode this
                strings[i] = decodeURI(s);
            }
        }
        return strings;
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.remote.WebDavCommandFactoryImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.remote.WebDavCommandFactoryImpl"] = true;
dojo.provide("com.ibm.mm.enabler.remote.WebDavCommandFactoryImpl");




/*
 * A private factory object that creates WebDavCommandImpl objects.
 * Since this is a private object, this does not implement a public interface but that could easily be done/
 */
dojo.declare("com.ibm.mm.enabler.remote.WebDavCommandFactoryImpl", null, {

    REQUEST_METHOD_MKCOL: "MKCOL",
    REQUEST_METHOD_PROPFIND: "PROPFIND",
    REQUEST_METHOD_PUT: "PUT",
    REQUEST_METHOD_DELETE: "DELETE",
	POST_ACTION_HEADER: "X-Method-Override",

    constructor: function() {
    },
    defaultProperties: {
        "resourcetype": true
    },
    defaultPropfindDataString: '<?xml version="1.0" encoding="utf-8" ?><D:propfind xmlns:D="DAV:"><D:prop><D:resourcetype/></D:prop></D:propfind>',
    propfindParameterizedDataString: '<?xml version="1.0" encoding="utf-8" ?><D:propfind xmlns:D="DAV:"><D:prop ${xmlns}>${props}</D:prop></D:propfind>',
    webDAVNamespaceAlias: "D",
    requiredWebDAVProperties: {
        "resourcetype": true
    },
    getDownloadCommand: function(path) {
        return new com.ibm.mm.enabler.remote.WebDavCommandImpl("GET", path, null, null, null, "text");
    },
    
    getCreateCommand: function(path, node, content) {
        var headers = null;
        if ((!node) && (content)) {
            // we're uploading content and not a file so set the content type correctly
            // without this, it will default to form/urlencoded which the portal resolver 
            // does not handle consistently
            headers = {
                "content-type": "text/html;charset=utf-8"
            };
        }
        return new com.ibm.mm.enabler.remote.WebDavCommandImpl("POST", path, node, content, headers, "text");
    },
    
    getCopyCommand: function(path, dest) {
        var headers = {
            "destination": encodeURI(dest)
        };
        return new com.ibm.mm.enabler.remote.WebDavCommandImpl("COPY", path, null, null, headers, "text");
    },
    
    getMoveCommand: function(path, dest) {
        var headers = {
            "destination": encodeURI(dest),
            "overwrite": false
        };
        return new com.ibm.mm.enabler.remote.WebDavCommandImpl("MOVE", path, null, null, headers, "text");
    },
    
    getUpdateCommand: function(path, node, content) {
        if (com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME).getValue(com.ibm.mashups.enabler.services.ConfigConstants.TUNNEL_MODE) === true) {
            var headers = {
                "depth": "1"
            };
            if ((!node) && (content)) {
                // we're uploading content and not a file so set the content type correctly
                // without this, it will default to form/urlencoded which the portal resolver
                // does not handle consistently
                headers["content-type"] = "text/html;charset=utf-8";
            }
            headers[this.POST_ACTION_HEADER] = this.REQUEST_METHOD_PUT;
            return new com.ibm.mm.enabler.remote.WebDavCommandImpl("POST", path, node, content, headers, "text");
        }
        return new com.ibm.mm.enabler.remote.WebDavCommandImpl("PUT", path, node, content, null, "text");
    },

    
    getDeleteCommand: function(path) {
        var headers = {
        	"depth": "1"
        };
        if (com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME).getValue(com.ibm.mashups.enabler.services.ConfigConstants.TUNNEL_MODE) === true) {
        	headers[this.POST_ACTION_HEADER] = this.REQUEST_METHOD_DELETE;
        	return new com.ibm.mm.enabler.remote.WebDavCommandImpl("POST", path, null, null, headers, "text");
        }
        return new com.ibm.mm.enabler.remote.WebDavCommandImpl("DELETE", path, null, null, null, "text");
    },
    
    getMakeCollectionCommand: function(path) {
        var headers = {
            "depth": "1"
        };
        if (com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME).getValue(com.ibm.mashups.enabler.services.ConfigConstants.TUNNEL_MODE) === true) {
            headers[this.POST_ACTION_HEADER] = this.REQUEST_METHOD_MKCOL;
            return new com.ibm.mm.enabler.remote.WebDavCommandImpl("POST", path, null, null, headers, "xml");
        }
								
        return new com.ibm.mm.enabler.remote.WebDavCommandImpl("MKCOL", path, null, null, headers, "xml");
    },
    
    getFindPropertiesCommand: function(path, props) {
        // the server will respond with whatever properties we ask for so send a small list.
        // including the resourcetype allows us to determine if it's a collection or not
        //<D:getlastmodified/><D:lockdiscovery/><D:displayname/><D:getcontentlength/><D:getcontenttype/>
        var data = this.defaultPropfindDataString;
        
        if (props) {
            data = this.propfindParameterizedDataString;
            props = dojo.mixin(props, this.defaultProperties);
            var propsString = "";
            var xmlnsString = "";
            //TODO: Devise a better way to get a unique namespace alias... Not sure if a number is a valid alias...
            //Skip "D" because it's already in use for the WebDAV namespace
            var aliases = ["A", "B", "C", "E", "F", "G", "H", "I"];
            var aliasIndex = 0;
            for (var prop in props) {
                if (Object.prototype.hasOwnProperty.call(props,prop)) {
                    var alias = this.webDAVNamespaceAlias;
                    var namespace = "";
                    var indexOfHash = prop.indexOf("#");
                    
                    if (indexOfHash >= 0) {
                        namespace = prop.substring(0, indexOfHash);
                        prop = prop.substring(indexOfHash + 1);
                        alias = aliases[aliasIndex++];
                        xmlnsString += alias + ":" + namespace + " ";
                    }
                    
                    propsString += "<" + alias + ":" + prop + "/>";
                }
            }
            
            data = data.replace(/\$\{props\}/, propsString);
            data = data.replace(/\$\{xmlns\}/, xmlnsString);
        }
        
        var headers = {
            "depth": "1"
        };
        if (com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME).getValue(com.ibm.mashups.enabler.services.ConfigConstants.TUNNEL_MODE) === true) {
            headers[this.POST_ACTION_HEADER] = this.REQUEST_METHOD_PROPFIND;
            return new com.ibm.mm.enabler.remote.WebDavCommandImpl("POST", path, null, data, headers, "xml");
        }
				
        return new com.ibm.mm.enabler.remote.WebDavCommandImpl("PROPFIND", path, null, data, headers, "xml");
    }
});

// create a static var to make it easier to call
com.ibm.mm.enabler.remote.WebDavCommandFactory = new com.ibm.mm.enabler.remote.WebDavCommandFactoryImpl();

}

if(!dojo._hasResource["com.ibm.mm.enabler.remote.WebDavDeferredImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.remote.WebDavDeferredImpl"] = true;
dojo.provide("com.ibm.mm.enabler.remote.WebDavDeferredImpl");



/*
 * A simple implementation of com.ibm.mashups.enabler.Deferred
 */
dojo.declare("com.ibm.mm.enabler.remote.WebDavDeferredImpl", com.ibm.mashups.enabler.Deferred, {

    constructor: function(context, startfn) {
        // context for start function
        this._context = context;
        // start function
        this._startfn = startfn;
    },
    
    setFinishedCallback: function(callback, parameters) {
        this._callback = callback;
        this._parameters = parameters;
    },
    
    start: function(sync) {
        // we only support asynchronous..
        if ((this._context) && (this._startfn)) {
            dojo.hitch(this._context, this._startfn)(sync);
        }
        return null;
    },
    
    doCallback: function(resource, status) {
        if (this._callback) {
            this._callback(resource, status, this._parameters);
        }
    }
    
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.remote.RemoteFileImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.remote.RemoteFileImpl"] = true;
dojo.provide("com.ibm.mm.enabler.remote.RemoteFileImpl");









/*
 * Implementation of com.ibm.mashups.enabler.remote.RemoteFile
 */
dojo.declare("com.ibm.mm.enabler.remote.RemoteFileImpl", [com.ibm.mashups.enabler.remote.RemoteFile], {

    constructor: function(context) {
    
        if (context && context.name) {
            this._name = context.name;
        }
        else {
            this._name = null;
        }
        
        this._children = null;
        this._isDirectory = context.isDirectory;
        this._id = null;
        this._properties = null; // a Document containing relevant properties 
        this._context = context;
        this._deferred = null;
    },
    
    /**
     * @private
     * used by consumer to get Deferred object
     */
    init: function() {
        this._deferred = new com.ibm.mm.enabler.remote.WebDavDeferredImpl(this, this._init);
        return this._deferred;
    },
    
    /**
     * @private
     * called by WebDavDeferredImpl.start() and triggers the actual request
     */
    _init: function(sync) {
        if (this._context && this._context.isCreate) {
            if ((this._context.isDirectory) && (this._context.form)) {
                // we're uploading a zip 
                this._uploadDirectory(this._name, this._context.form);
            }
            else if (this._context.isDirectory) {
                // we're creating an empty directory
                this._createDirectory(this._name, sync);
            }
            else {
                // we're creating a new file
                this._createFile(this._name, this._context.form, this._context.content, sync);
            }
        }
        else if (this._context && this._context.isUpdate) {
            // we're updating an existing file
            this._updateFile(this._name, this._context.form, this._context.content);
        }
        else {
            // we're just loading info about the file
            this._load(this._name);
        }
    },
    
    /**
     * @private
     * Loads information from the server
     */
    _load: function(name) {
        var commandFactory = com.ibm.mm.enabler.remote.WebDavCommandFactory;
        var propsToRequest = this._context && this._context.props ? this._context.props : null;
        var command = commandFactory.getFindPropertiesCommand(name, propsToRequest);
        var d = command.execute();
        
        // this callback will process the data
        d.addCallback(dojo.hitch(this, this._handleLoad));
        // this callback will notify the caller's callbacks
        d.addCallback(dojo.hitch(this, this._handleSuccess));
        d.addErrback(dojo.hitch(this, this._handleError));
    },
    
    /**
     * @private
     * Creates a file
     */
    _createFile: function(name, form, content, sync) {
        var commandFactory = com.ibm.mm.enabler.remote.WebDavCommandFactory;
        var command = commandFactory.getCreateCommand(name, form, content);
        var d = command.execute(sync);
        
        d.addCallback(dojo.hitch(this, this._handleSuccess));
        d.addErrback(dojo.hitch(this, this._handleError));
    },
    
    /**
     * @private
     * Updates an existing file
     */
    _updateFile: function(name, form, content) {
        var commandFactory = com.ibm.mm.enabler.remote.WebDavCommandFactory;
        var command = commandFactory.getUpdateCommand(name, form, content);
        var d = command.execute();
        
        d.addCallback(dojo.hitch(this, this._handleSuccess));
        d.addErrback(dojo.hitch(this, this._handleError));
    },
    
    /**
     * @private
     * Creates a new directory
     */
    _createDirectory: function(name, sync) {
        var commandFactory = com.ibm.mm.enabler.remote.WebDavCommandFactory;
        var command = commandFactory.getMakeCollectionCommand(name);
        var d = command.execute(sync);
        
        d.addCallback(dojo.hitch(this, this._handleSuccess));
        d.addErrback(dojo.hitch(this, this._handleError));
    },
    
    /**
     * @private
     * Uploads a zip file and creates a new directory
     */
    _uploadDirectory: function(name, form) {
        var commandFactory = com.ibm.mm.enabler.remote.WebDavCommandFactory;
        var command = commandFactory.getUpdateCommand(name, form, null);
        var d = command.execute();
        
        d.addCallback(dojo.hitch(this, this._handleSuccess));
        d.addErrback(dojo.hitch(this, this._handleError));
    },
    
    /**
     * @private
     * a private callback
     */
    _handleLoad: function(loadData) {
        // this should be an xml document 
        // I'd love to do an error check on this but that breaks IE :( 
        this._properties = loadData;
    },
    
    /**
     * @private
     * A private success callback that triggers the caller's callback
     * Internally we use a dojo.deferred but the caller expects a com.ibm.mashups.enabler.Deferred so
     * this does the "conversion". It's also useful for debugging / logging
     */
    _handleSuccess: function(data) {
        // This callback does not get the http status info, just the returned object.
        // Return a 200 to indicate this was succesful
        this._deferred.doCallback(this, 200);
    },
    
    /**
     * @private
     * A private error handler that just calls the defferred's errback
     * Internally we use a dojo.deferred but the caller expects a com.ibm.mashups.enabler.Deferred so
     * this does the "conversion". It's also useful for debugging / logging
     */
    _handleError: function(error) {
        // this is a normal error scenario
        // unfortunately com.ibm.mashups.enabler.Deferred does not support a seperate error callback
        // which means the caller has to understand http status codes and the server has to send the correct one..
        // we don't have the actual status code but we know this is an error so return a 500
        this._deferred.doCallback(this, 500);
    },
    
    /**
     * @private
     * deletes this file
     */
    _delete: function() {
        var commandFactory = com.ibm.mm.enabler.remote.WebDavCommandFactory;
        var command = commandFactory.getDeleteCommand(this.getID());
        var d = command.execute();
        
        d.addCallback(dojo.hitch(this, this._handleSuccess));
        d.addErrback(dojo.hitch(this, this._handleError));
        
        return this._deferred;
    },
    
    getName: function() {
        // this should only return the name and not the full path even though we
        // may be storing the full name
        
        var ret = this._name;
        
        if ("/" == this._name) {
            // do nothing	
        }
        else {
            var parts = this._name.split("/");
            var c = this._name.charAt(this._name.length - 1);
            if (c == "/") {
                ret = parts[parts.length - 2];
            }
            else {
                ret = parts[parts.length - 1];
            }
        }
        
        return ret;
    },
    
    isDirectory: function() {
        if (!this._isDirectory) {
            var resp = new com.ibm.mm.enabler.remote.WebDavResponseImpl();
			if (!this._properties) {
				this._properties = document;
			}
            this._isDirectory = resp.isCollection(this._properties);
        }
        
        return this._isDirectory;
    },
    
    /**
     * @private
     */
    _getChildHrefs: function() {
        if (!this._children) {
            this._children = [];
            
            if (this.isDirectory()) {
                var resp = new com.ibm.mm.enabler.remote.WebDavResponseImpl();
                var nodes = resp.getHrefs(this._properties);
                
                var i = 0;
                for (var node in nodes) {
                    if (Object.prototype.hasOwnProperty.call(nodes,node)) {
                        if (i > 0) {
                            // the first file is the current file so we skip it
                            this._children[i] = nodes[node];
                        }
                        i++;
                    }
                }
            }
        }
        
        return this._children;
    },
    getID: function() {
        if (!this._id) {
            var resp = new com.ibm.mm.enabler.remote.WebDavResponseImpl();
            var id = resp.getID(this._properties);
            
            if (id) {
                this._id = id;
            }
            else {
                this._id = com.ibm.mm.enabler.remote.WebDavUrlFactory.createUrl(this._name);
            }
        }
        return this._id;
    },
    
    // @deprecated
    getUrl: function() {
        return this.getURL();
    },
    getURL: function() {
        return this.getID();
    }
});

}

if(!dojo._hasResource["com.ibm.mashups.enabler.remote.RemoteFile"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.remote.RemoteFile"] = true;
dojo.provide("com.ibm.mashups.enabler.remote.RemoteFile");








}

if(!dojo._hasResource["com.ibm.mashups.enabler.remote.RemoteLocator"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.remote.RemoteLocator"] = true;
dojo.provide("com.ibm.mashups.enabler.remote.RemoteLocator");




/**
 * Interface for finding RemoteFile objects.
 * @ibm-api
 * @ibm-module RemoteModel
 */
dojo.declare("com.ibm.mashups.enabler.remote.RemoteLocator", null, {
    /**
     * Returns the current user's home Directory.
     * @return {com.ibm.mashups.enabler.Deferred} A Deferred object for 
     * which the callback will be passed a RemoteFile.
     * @see RemoteFile 
     */
    getUserRoot: function(){
    
    }
  
});

}

if(!dojo._hasResource["com.ibm.mashups.enabler.model.RemoteModel_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.model.RemoteModel_API"] = true;
dojo.provide("com.ibm.mashups.enabler.model.RemoteModel_API");
dojo.provide("com.ibm.mashups.enabler.model.RemoteModel");

/**
 * Interface for a remote File.
 *
 * @ibm-api
 * @ibm-module RemoteModel
 */
dojo.declare("com.ibm.mashups.enabler.model.RemoteModel", [com.ibm.mashups.enabler.TreeModel, com.ibm.mashups.enabler.remote.RemoteLocator], {});


}

if(!dojo._hasResource["com.ibm.mm.enabler.remote.WidgetHelper"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.remote.WidgetHelper"] = true;
dojo.provide("com.ibm.mm.enabler.remote.WidgetHelper");







/**
 * A RemoteModel helper object for widgets.
 * This is a protected api.
 */
dojo.declare("com.ibm.mm.enabler.remote.WidgetHelper", null, {
    /**
     * @private
     */
    constructor: function(model) {
        this._model = model;
    },
    
    /**
     * Returns a url that will retrieve the specified Directory as a zip file.
     * @param {com.ibm.mashups.enabler.remote.RemoteFile} dir The directory
     * @return {String} The modified url
     */
    getDirectoryAsZipUrl: function(dir) {
        return dir.getID() + '?mime-type=application/zip';
    },
    
    /**
     * @return {com.ibm.mashups.enabler.Deferred} A Deferred object for which the callback will be passed
     * a com.ibm.mashups.enabler.remote.RemoteFile.
     */
    addNewTemplate: function(name, form) {
        if (name && name.length > 0) {
            // this has to be a collection, if the user did not pass in a 
            // name ending in a slash, add the slash
            var lastChar = name.charAt(name.length - 1);
            if (lastChar != '/') {
                name = name + '/';
            }
        }
        var d = new com.ibm.mm.enabler.DeferredImpl(this, this._addNewTemplate, {
            "name": name,
            "form": form
        });
        return d;
    },
    
    _addNewTemplate: function(deferred, sync, params) {
    
        params.deferred = deferred;
        
        var d = this.getTemplateDir();
        d.setFinishedCallback(function(templateDir, status, params) {
            var context = {};
            context.name = templateDir.getUrl() + params.name + "?mode=replace";
            context.isDirectory = true;
            context.isCreate = true;
            context.form = params.form;
            
            var file = new com.ibm.mm.enabler.remote.RemoteFileImpl(context);
            var d2 = file.init();
            d2.setFinishedCallback(function(template, status, params) {
                var originalDeferred = params.deferred;
                if (originalDeferred) {
                    originalDeferred.finish(template, status);
                }
            }, params);
            d2.start();
            
        }, params);
        d.start();
    },
    
    /**
     * @return {com.ibm.mashups.enabler.Deferred} A Deferred object for which the callback will be passed
     * a com.ibm.mashups.enabler.remote.RemoteFile.
     */
    uploadZip: function(path, name, form) {
        if (name && name.length > 0) {
            // this has to be a collection, if the user did not pass in a 
            // name ending in a slash, add the slash
            var lastChar = name.charAt(name.length - 1);
            if (lastChar != '/') {
                name = name + '/';
            }
        }
        var d = new com.ibm.mm.enabler.DeferredImpl(this, this._uploadZip, {
            "path": path,
            "name": name,
            "form": form
        });
        return d;
    },
    
    _uploadZip: function(deferred, sync, params) {
        params.deferred = deferred;
        
        var d = this.getZipDir(params.path);
        d.setFinishedCallback(function(zipDir, status, params) {
            var context = {};
            context.name = zipDir.getUrl() + params.name + "?mode=merge";
            context.isDirectory = true;
            context.isCreate = true;
            context.form = params.form;
            
            var file = new com.ibm.mm.enabler.remote.RemoteFileImpl(context);
            var d2 = file.init();
            d2.setFinishedCallback(function(template, status, params) {
                var originalDeferred = params.deferred;
                if (originalDeferred) {
                    originalDeferred.finish(template, status);
                }
            }, params);
            d2.start();
            
        }, params);
        d.start();
    },
    
    getZipDir: function(path) {
        return this._model.find(path);
    },
    
    /**
     * Returns the remote directory where Template objects are stored.
     * @return {com.ibm.mashups.enabler.Deferred} A Deferred object for which the callback will be passed
     * a com.ibm.mashups.enabler.remote.RemoteFile.
     */
    getTemplateDir: function() {
        return this._model.find("/public/templates/");
    },
    
    /**
     * Returns the remote directory where Project objects are stored.
     * @return {com.ibm.mashups.enabler.Deferred} A Deferred object for which the callback will be passed
     * a com.ibm.mashups.enabler.remote.RemoteFile.
     */
    getProjectDir: function() {
        var userhome = com.ibm.mm.enabler.remote.WebDavUrlFactory.getUserHome();
        return this._model.find(userhome + "/public/projects/");
    },
    
    /**
     * Returns a new File object created from the supplied context.
     * @param {Object} context The file context
     * 	context.name = the name of the file
     *  context.content = (optional) the contents of the file
     *  context.form = (optional) the id of a form that contains the contents of the file.
     *  If uploading a file, the following should be true:
     *  	The form action should be POST
     *  	The form enctype should be multipart/form-data
     *  	The input of type file should have both a valid id and name.
     * @return {com.ibm.mashups.enabler.Deferred} A Deferred object for which the callback will be passed
     * a RemoteFile.
     */
    createFile: function(context) {
        context.isDirectory = false;
        context.isCreate = true;
        var file = new com.ibm.mm.enabler.remote.RemoteFileImpl(context);
        return file.init();
    },
    
    /**
     * Returns a new File object created from the supplied context.
     * @param {String} path The full path of the folder to create
     */
    createFolder: function(path) {
        var context = {};
        context.isDirectory = true;
        context.isCreate = true;
        context.name = path;
        var file = new com.ibm.mm.enabler.remote.RemoteFileImpl(context);
        return file.init();
    },
    
    /**
     * Updates an existing file
     * @param {com.ibm.mashups.enabler.remote.RemoteFile} file The file to update
     *  context.content = (optional) the new contents of the file
     *  context.form = (optional) the id of a form that contains the new contents of the file
     *  If uploading a file, the following should be true:
     *  	The form action should be POST
     *  	The form enctype should be multipart/form-data
     *  	The input of type file should have both a valid id and name.
     * @param {Object} context The file context
     * @type void
     */
    updateFile: function(file, context) {
        context.isDirectory = false;
        context.isUpdate = true;
        
        var returnFile = new com.ibm.mm.enabler.remote.RemoteFileImpl(context);
        return returnFile.init();
    },
    
    /**
     * Copies an existing file or folder
     * @param {com.ibm.mashups.enabler.remote.RemoteFile} file The RemoteFile to copy
     * @param {String} newPath The destination file / folder name. This must be an absolute path.
     * @return {com.ibm.mashups.enabler.Deferred} A Deferred object for which the callback will be passed
     * a RemoteFile.
     */
    copy: function(file, newPath) {
        var copyCommand = com.ibm.mm.enabler.remote.WebDavCommandFactory.getCopyCommand(file.getUrl(), newPath);
        var ed = new com.ibm.mm.enabler.remote.WebDavDeferredImpl();
        var d = copyCommand.execute();
        d.addCallback(dojo.partial(this._copy, ed));
        
        return ed;
    },
    
    _copy: function(ed, result) {
        ed.doCallback(result, 200);
    },
    
    /**
     * Moves an existing file or folder
     * @param {com.ibm.mashups.enabler.remote.RemoteFile} file The RemoteFile to copy
     * @param {String} newPath The destination file / folder name. This must be an absolute path.
     * 	known bug: the full path is required but it won't be used. The file will always be moved to the same folder as the source.
     * 	IE you cannot move a file to a different folder.
     * @return {com.ibm.mashups.enabler.Deferred} A Deferred object for which the callback will be passed
     * a RemoteFile.
     */
    move: function(file, newPath) {
        var moveCommand = com.ibm.mm.enabler.remote.WebDavCommandFactory.getMoveCommand(file.getUrl(), newPath);
        var ed = new com.ibm.mm.enabler.remote.WebDavDeferredImpl();
        var d = moveCommand.execute();
        d.addCallback(dojo.partial(this._move, ed));
        
        return ed;
    },
    
    _move: function(ed, result) {
        ed.doCallback(result, 200);
    },
    
    /**
     * Deletes an existing file
     * @param {com.ibm.mashups.enabler.remote.RemoteFile} file The file to delete
     * @type void
     */
    deleteFile: function(file) {
        return file._delete();
    }
    
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.remote.RemoteIteratorImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.remote.RemoteIteratorImpl"] = true;
dojo.provide("com.ibm.mm.enabler.remote.RemoteIteratorImpl");



/*
 * Implementation of com.ibm.mm.enabler.DeferredIteratorImpl that returns com.ibm.mm.enabler.remote.RemoteFileImpl
 */
dojo.declare("com.ibm.mm.enabler.remote.RemoteIteratorImpl", com.ibm.mm.enabler.DeferredIteratorImpl, {
    constructor: function(model, hrefs) {
        this._model = model;
        this._hrefs = hrefs;
        this._position = 1;
    },
    
    start: function(sync) {
    
    },
    
    hasNext: function(sync) {
        return this._position < this._hrefs.length;
    },
    
    next: function(sync) {
        var href = this._hrefs[this._position];
        var next = null;
        if (href) {
            this._position++;
            next = this._model.find(href);
        }
        
        return next;
    },
    
    setCursorPosition: function(position) {
        this._position = position;
    },
    
    getCursorPosition: function() {
        // we increment position after we fetch it in next() so we need to decrement before we return it here
        return (this._position - 1);
    },
    
    size: function() {
        return this._hrefs.length;
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.remote.RemoteModelImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.remote.RemoteModelImpl"] = true;
dojo.provide("com.ibm.mm.enabler.remote.RemoteModelImpl");







 
dojo.declare("com.ibm.mm.enabler.remote.RemoteModelImpl", [com.ibm.mashups.enabler.model.RemoteModel, com.ibm.mm.enabler.model.ModelImpl], {

    constructor: function() {
        this._files = {};
    },
    
    getRoot: function() {
        return this.find('/');
    },
    
    find: function(path) {
        var file = new com.ibm.mm.enabler.remote.RemoteFileImpl({
            name: path,
            props: {
            	"getlastmodified": true,
            	"resourcetype": true,
            	"creationdate": true
            }
        });
        var d = file.init();
        return d;
    },
    
    /**
     * Returns the current user's home Directory.
     * @return {com.ibm.mashups.enabler.Deferred} A Deferred object for which the callback will be passed
     * a RemoteFile.
     */
    getUserRoot: function() {
        var userhome = com.ibm.mm.enabler.remote.WebDavUrlFactory.getUserHome();
        return this.find(userhome);
    },
    
    hasChildren: function(file) {
        var kids = file._getChildren();
        if (kids) {
            for (var child in kids) {
                if (Object.prototype.hasOwnProperty.call(kids,child)) {
                    return true;
                }
            }
        }
        return false;
    },
    
    getParent: function(file) {
        var id = file.getID();
        var index = id.lastIndexOf('/');
        var parentPath = id.substring(0, index);
        if (file.isDirectory()) {
            parentPath = parentPath + "/../";
        }
        
        return this.find(parentPath);
    },
    
    getChildren: function(file) {
        return new com.ibm.mm.enabler.remote.RemoteIteratorImpl(this, file._getChildHrefs());
    }
});

}

if(!dojo._hasResource["com.ibm.mashups.enabler.model.RemoteModel"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.model.RemoteModel"] = true;
dojo.provide("com.ibm.mashups.enabler.model.RemoteModel");







}

if(!dojo._hasResource["com.ibm.mashups.enabler.model.SkinModel_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.model.SkinModel_API"] = true;
dojo.provide("com.ibm.mashups.enabler.model.SkinModel_API");
dojo.provide("com.ibm.mashups.enabler.model.SkinModel");

/**
 * Interface for a skin model. This list model describes a list of skin objects.<br>
 * <br>
 * The skin model supports the following strategies:
 * <ul>
 * <li>{@link com.ibm.mashups.enabler.strategy.ListLoadAheadStrategy ListLoadAheadStrategy}</li>
 * <li>{@link com.ibm.mashups.enabler.strategy.HiddenMetaDataLoadingStrategy HiddenMetaDataLoadingStrategy}</li>
 * </ul>
 * @ibm-api
 * @ibm-module ThemeModel
 */
dojo.declare("com.ibm.mashups.enabler.model.SkinModel", [com.ibm.mashups.enabler.ListModel, com.ibm.mashups.enabler.ResourceLocator], {
    
});

}

if(!dojo._hasResource["com.ibm.mashups.enabler.theme.Skin"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.theme.Skin"] = true;
dojo.provide("com.ibm.mashups.enabler.theme.Skin");






/**
 * Interface that represents a skin; used in the SkinModel
 * @ibm-api
 * @ibm-module ThemeModel
 */
dojo.declare("com.ibm.mashups.enabler.theme.Skin", [com.ibm.mashups.enabler.Identifiable, com.ibm.mashups.enabler.Localized, com.ibm.mashups.enabler.DefaultLocalized, com.ibm.mashups.enabler.MetaData], {
    /**
     * Returns the base url of the skin
     * @type String
     * @return base url of the skin. can never be <code>null</code>
     * @deprecated Since 2.0. Use ThemeModel/ResourceLocator findResourceURL instead
     */
    getBaseUrl: function(){
    },
    
    /**
     * Returns an image which can be used for preview urls
     * @type String
     * @return url to an image; may be <code>null</code>
     * @deprecated Use getPreviewURL instead.
     */
    getPreviewUrl: function(){
    },
    
    /**
     * Returns an image which can be used for preview urls
     * @return {String} url to an image; may be <code>null</code>
     */
    getPreviewURL: function(){
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.theme.SkinImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.theme.SkinImpl"] = true;
dojo.provide("com.ibm.mm.enabler.theme.SkinImpl");













// skin
dojo.declare("com.ibm.mm.enabler.theme.SkinImpl", [com.ibm.mashups.enabler.theme.Skin, com.ibm.mm.enabler.persistence.xml.IdentifiableXmlImpl, com.ibm.mm.enabler.persistence.xml.LocalizedXmlImpl, com.ibm.mm.enabler.persistence.xml.DefaultLocalizedXmlImpl, com.ibm.mm.enabler.MetaDataImpl2], {
    constructor: function(node) {
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass);
        this.LOG_LEVEL = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
        
        this.xmlData = node;
        // service document and initialization
        var serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_THEME);
        var nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
        this.ns = dojo.delegate(serviceJson.namespaces, nsf.getNameSpaces([nsf.NS_ATOM]));
    },
    
    getBaseUrl: function(internal) {
        if (typeof internal == "undefined") {
            var LOG_METHOD = "getBaseUrl";
            this.LOGGER.warning(LOG_METHOD, "Deprecated. Use com.ibm.mashups.enabler.model.ThemeModel.findResourceURL instead.");
        }
        return this._getBaseUrl();
    },
    _getBaseUrl: function() {
        var entry = com.ibm.mashups.enabler.xml.XPath.evaluateEntry("atom:content/model:skin/model:link[@ext:rel='baseUrl']", this.xmlData, this.ns);
        return entry ? entry.getAttribute("href") : null;
    },
    
    // @deprecated
    getPreviewUrl: function() {
        return this.getPreviewURL();
    },
    
    getPreviewURL: function() {
        var entry = com.ibm.mashups.enabler.xml.XPath.evaluateEntry("atom:content/model:skin/model:link[@ext:rel='previewUrl']", this.xmlData, this.ns);
        return entry ? entry.getAttribute("href") : null;
    },
    
    _getMediaURL: function() {
        var entry = com.ibm.mashups.enabler.xml.XPath.evaluateEntry('atom:link[@ext:rel="media"]', this.xmlData, this.ns);
        return entry ? entry.getAttribute("href") : null;
    },
    
    toString: function() {
        return com.ibm.mm.enabler.utils.Dom.innerXML(this.xmlData);
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.theme.SkinModelIteratorImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.theme.SkinModelIteratorImpl"] = true;
dojo.provide("com.ibm.mm.enabler.theme.SkinModelIteratorImpl");








// skin model iterator
dojo.declare("com.ibm.mm.enabler.theme.SkinModelIteratorImpl", [com.ibm.mashups.enabler.Iterator, com.ibm.mm.enabler.DeferredIteratorImpl, com.ibm.mm.enabler.ModelIteratorImpl], {
    constructor: function() {
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass);
        this.LOG_LEVEL = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
    },
    
    _createNode: function(xmlData) {
        var node = new com.ibm.mm.enabler.theme.SkinImpl(xmlData);
        this.model.loadedNodes[node.getID()] = node;
        return node;
    },
    
    _customizeUrl: function(url) {
        // include access control info
        url.addParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT_VALUE_ACCESS_CONTROL);
        
        // full representation
        url.setParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_REPRESENTATION, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_REPRESENTATION_VALUE_FULL);
        
        // include hidden meta data
        this.model._applyHiddenMetaDataLoadingStrategyToModelURL(url);
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.theme.SkinModelImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.theme.SkinModelImpl"] = true;
dojo.provide("com.ibm.mm.enabler.theme.SkinModelImpl");















// skin model
dojo.declare("com.ibm.mm.enabler.theme.SkinModelImpl", [com.ibm.mashups.enabler.model.SkinModel, com.ibm.mm.enabler.model.ModelImpl, com.ibm.mm.enabler.strategy.HiddenMetaDataLoadingStrategyHelperImpl], {
    constructor: function(url, themeId) {
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass);
        this.LOG_LEVEL = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
        
        // service document and initialization
        var serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_THEME);
        var nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
        this.ns = dojo.delegate(serviceJson.namespaces, nsf.getNameSpaces([nsf.NS_ATOM, nsf.NS_THR, nsf.NS_XML, nsf.NS_OPENSEARCH]));
        
        // loaded nodes
        this.loadedNodes = {};
        
        // skin collection url
        this.collectionUrl = url;
        
        // theme id
        this.themeId = themeId;
    },
    
    iterator: function() {
        return new com.ibm.mm.enabler.theme.SkinModelIteratorImpl(this.collectionUrl, this);
    },
    
    
    /**
     * Attention: This is also used by StaticSkinModelImpl in a static way, e.g. no themeId attached
     *
     * @param {Object} uri
     */
    find: function(uri) {
        return new com.ibm.mm.enabler.DeferredImpl(this, this._load, uri);
    },
    
    /**
     * gets called from StaticSkinModelImpl
     */
    _setThemeId: function(themeId) {
        this.themeId = com.ibm.mm.enabler.utils.Utils.getIdFromIdentifiable(themeId);
    },
    
    /**
     * Attention: This is also used by StaticSkinModelImpl in a static way, e.g. no themeId attached
     *
     * @param {Object} deferred
     * @param {Object} sync
     * @param {Object} uri
     */
    _load: function(deferred, sync, uri) {
    
        uri = com.ibm.mm.enabler.utils.Utils.getIdFromIdentifiable(uri);
        
        // logging support
        var LOG_METHOD = "_load";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, arguments);
        }
        var ret;
        if (uri in this.loadedNodes) {
            // finished callback
            ret = this.loadedNodes[uri];
            if (deferred) {
                deferred.finish(ret, com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK);
            }
        }
        else {
            // request node from server
            var myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(com.ibm.mashups.enabler.model.url.ModelUrlFactory.THEME_URL, this);
            
            var nodeArray = [{
                value: uri,
                isID: true
            }];
            
            // check if themeId is there - may not be there when being used by StaticSkinModel
            if (this.themeId) {
                nodeArray.push({
                    value: this.themeId,
                    isID: true
                });
            }
            
            myUrl.setNodes(nodeArray);
            
            // include access control info
            myUrl.addParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT_VALUE_ACCESS_CONTROL);
            
            // full representation
            myUrl.setParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_REPRESENTATION, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_REPRESENTATION_VALUE_FULL);
            
            // apply hidden meta data strategy
            this._applyHiddenMetaDataLoadingStrategyToModelURL(myUrl);
            var serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
            serviceReq.read(dojo.hitch(this, function(type, data, xhr, args) {
                if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_LOAD) {
                    var entry = com.ibm.mashups.enabler.xml.XPath.evaluateEntry("atom:feed/atom:entry", data, this.ns);
                    if (entry) {
                        this.loadedNodes[uri] = new com.ibm.mm.enabler.theme.SkinImpl(entry);
                        ret = this.loadedNodes[uri] || null;
                    }
                }
                // finished/error callback
                if (deferred) {
                    deferred.finish(ret, xhr.status);
                }
            }));
        }
        // exit trace
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD);
        }
        return ret;
    },
    
    // @deprecated
    findResourceUrl: function(node, name) {
        return this.findResourceURL(node, name);
    },
    findResourceURL: function(node, name) {
        var myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(com.ibm.mashups.enabler.model.url.ModelUrlFactory.THEME_MEDIA_URL, this);
        var nodeJSON = [{
            value: node.getID(),
            isID: true
        }, {
            value: this.themeId,
            isID: true
        }, {
            value: name,
            isID: false
        }];
        myUrl.setNodes(nodeJSON);
        return myUrl.getAbsoluteURL();
    },
    
    invalidate: function() {
        this.loadedNodes = {};
    }
});

}

if(!dojo._hasResource["com.ibm.mashups.enabler.model.SkinModel"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.model.SkinModel"] = true;
dojo.provide("com.ibm.mashups.enabler.model.SkinModel");







}

if(!dojo._hasResource["com.ibm.mashups.enabler.model.StaticSkinModel_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.model.StaticSkinModel_API"] = true;
dojo.provide("com.ibm.mashups.enabler.model.StaticSkinModel_API");
dojo.provide("com.ibm.mashups.enabler.model.StaticSkinModel");

/**
 * @ibm-module ThemeModel
 * @since 2.4
 * @private
 */
dojo.declare("com.ibm.mashups.enabler.model.StaticSkinModel", [com.ibm.mashups.enabler.Locator], {
    
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.theme.StaticSkinModelImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.theme.StaticSkinModelImpl"] = true;
dojo.provide("com.ibm.mm.enabler.theme.StaticSkinModelImpl");




dojo.declare("com.ibm.mm.enabler.theme.StaticSkinModelImpl",com.ibm.mashups.enabler.model.StaticSkinModel,{
    // singleton
    getInstance: function() {
        if (!com.ibm.mm.enabler.theme.StaticSkinModelImpl._instance) {
            com.ibm.mm.enabler.theme.StaticSkinModelImpl._instance = new com.ibm.mm.enabler.theme.StaticSkinModelImpl();
        }
        return com.ibm.mm.enabler.theme.StaticSkinModelImpl._instance;
    },
    
    _skinModel: null,
    
    constructor: function() {
        this._skinModel = new com.ibm.mm.enabler.theme.SkinModelImpl();
    },
    
    find: function(id,themeId) {
       this._skinModel._setThemeId(themeId);
       return this._skinModel.find(id);
    },
    
    invalidate: function() {
    	this._skinModel.invalidate();
    }
});

}

if(!dojo._hasResource["com.ibm.mashups.enabler.model.StaticSkinModel"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.model.StaticSkinModel"] = true;
dojo.provide("com.ibm.mashups.enabler.model.StaticSkinModel");








}

if(!dojo._hasResource["com.ibm.mashups.enabler.template.TemplateNode"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.template.TemplateNode"] = true;
dojo.provide("com.ibm.mashups.enabler.template.TemplateNode");




/**
 * Interface representing a template node.
 * @ibm-api
 * @ibm-module TemplateModel
 */
dojo.declare("com.ibm.mashups.enabler.template.TemplateNode", [com.ibm.mashups.enabler.Identifiable, com.ibm.mashups.enabler.ModifiableLocalized], {
    /**
     * Returns a URL to export the template in zip file format
     * @return {String} link to export the template
     */
    getExportURL: function(){
    }
});

}

if(!dojo._hasResource["com.ibm.mashups.enabler.model.TemplateModel_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.model.TemplateModel_API"] = true;
dojo.provide("com.ibm.mashups.enabler.model.TemplateModel_API");
dojo.provide("com.ibm.mashups.enabler.model.TemplateModel");

/**
 * Interface for a template model.
 * @ibm-api
 * @ibm-module TemplateModel
 */
dojo.declare("com.ibm.mashups.enabler.model.TemplateModel", [com.ibm.mashups.enabler.ListModelController, com.ibm.mashups.enabler.Invalidatable, com.ibm.mashups.enabler.SubmittableFormProvider], {
    /**
     * Commits the modifications applied to this model and all dependent models.<br>
     * @return {DeferredOperation} a deferred object used to start this operation. 
     * The return value when executed through the deferred object is <code>null</null>
     */
    commit: function(){
    },
    
    /**
     * Confirms whether exporting the template is possible.
     * @param{com.ibm.mashups.enabler.template.TemplateNode} template template object or template uri (without any scope).
     * Must not be <code>null</code>
     * @return {Boolean} <code>true</code> if the node can be exported, <code>false</code> otherwise.
     */
    confirmExport: function(template){
    },
    
    /**
     * Returns a SubmittableForm object associated with the given id to import a template.
     * Same as <code>getSubmittableForm</code>
     * @param {String} id the id of the html form this object is associated with
     * @return {com.ibm.mashups.enabler.SubmittableForm} SubmittableForm object, maybe <code>null</code>
     */
    getSubmittableImportForm: function(id){
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.template.TemplateNodeImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.template.TemplateNodeImpl"] = true;
dojo.provide("com.ibm.mm.enabler.template.TemplateNodeImpl");










dojo.declare("com.ibm.mm.enabler.template.TemplateNodeImpl", [com.ibm.mashups.enabler.template.TemplateNode, com.ibm.mm.enabler.persistence.xml.IdentifiableXmlImpl, com.ibm.mm.enabler.persistence.xml.LocalizedXmlImpl, com.ibm.mm.enabler.persistence.xml.EditLinkProviderXmlImpl], {
    constructor: function(node){
        this.xmlData = node;
        
        // service document and initialization
        this.serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_TEMPLATE);
        this.prefix = this.serviceJson.idprefix;
        var nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
        this.ns = dojo.delegate(this.serviceJson.namespaces, nsf.getNameSpaces([nsf.NS_ATOM, nsf.NS_CA]));
        
        // Override LocalizedImpl to handle composite app titles and descriptions
        this.li_ns = dojo.delegate(this.serviceJson.namespaces, nsf.getNameSpaces([nsf.NS_ATOM, nsf.NS_XML, nsf.NS_CA]));
        
        this.BASE_NLS_TITLE_STRING = "ca:title";
        this.BASE_NLS_DESCRIPTION_STRING = "ca:description";
        this.BASE_NS = this.li_ns.ca;

        // title
        this.TITLE_ELEMENT = "atom:content/*";
        this.TITLE = this.TITLE_ELEMENT + "/" + this.BASE_NLS_TITLE_STRING;

        // description
        this.DESCRIPTION_ELEMENT = "atom:content/*";
        this.DESCRIPTION = this.DESCRIPTION_ELEMENT + "/" + this.BASE_NLS_DESCRIPTION_STRING;
		
    },
    
    getExportURL: function(){
        var expr = "atom:link[@ca:rel='template-export']";
        var node = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, this.xmlData, this.ns);
        return node ? node.getAttribute("href") : null;
    },
    
    toString: function(){
        return com.ibm.mm.enabler.utils.Dom.innerXML(this.xmlData);
    }
    
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.ModelIteratorUnorderedImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.ModelIteratorUnorderedImpl"] = true;
dojo.provide("com.ibm.mm.enabler.ModelIteratorUnorderedImpl");











// this is an implementation of an unorder iterator
dojo.declare("com.ibm.mm.enabler.ModelIteratorUnorderedImpl", [com.ibm.mm.enabler.DeferredIteratorImpl], {
    constructor: function(url, model) {
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass);
        this.LOG_LEVEL = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
        
        // the iterator's model
        this.model = model;
        
        // entries in feed order; undefined entries denote potential 
        // nodes to load; null entry marks end of node collection 
        this.entries = [];
        
        // cursor position
        this.cursor = 0;
        
        // number of nodes
        this.sizeValue = null;
        
        // atom feed
        this.ATOM_FEED = "atom:feed";
        
        // atom entry
        this.ATOM_ENTRY = this.ATOM_FEED + "/atom:entry";
        
        // next link
        this.ATOM_NEXT = this.ATOM_FEED + "/atom:link[@rel='next']";
        
        // size indicator
        this.OPENSEARCH_TOTALRESULTS = this.ATOM_FEED + "/opensearch:totalResults";
        
        if (url) {
            // collection url
            this.collectionUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(url, model);
            
            if (model.strategy) {
                for (var x in model.strategy) {
                    if (com.ibm.mm.enabler.utils.Misc.isInstanceOf(model.strategy[x], com.ibm.mashups.enabler.strategy.ListLoadAheadStrategy)) {
                        // max number of entries 
                        this.collectionUrl.setParameter("num", model.strategy[x].getInterval());
                        // start element (only set with paging) 
                        this.collectionUrl.setParameter("start", this.getCursorPosition());
                        break;
                    }
                }
            }
            
            // let iterator implementations customize the url
            this._customizeUrl(this.collectionUrl);
        }
        
        // number of created nodes to include in this iterator
        this.numCreatedNodes = 0;
        
        // compile key-value pairs for each created node included in this 
        // iterator: (createdId, nextId)
        this._createdNodes = {};
        com.ibm.mm.enabler.utils.Misc.forIn(this.model.createdNodes, function(value, createdId) {
            var created = this.model.find(createdId).start();
            this._createdNodes[createdId] = created;
            this.numCreatedNodes++;
        }, this);
        
        // number of removed nodes not to include in this iterator
        this.numRemovedNodes = 0;
        
        // if the url is not present, removed nodes do not count towards size anymore
        if (url) {
            com.ibm.mm.enabler.utils.Misc.forIn(this.model.deletedNodes, function() {
                this.numRemovedNodes++;
            }, this);
        }
    },
    
    // This abstract function must be implemented for each iterator implementation.
    // It is invoked for each atom entry in the collection, where the atom entry 
    // is passed in as xml data. This function must return an instance of a 
    // resource based on the xml data, or null, in case no node is to be created.
    _createNode: function(xmlData) {
        return null;
    },
    
    // This abstract function allows to modify the collection url, e.g. by adding 
    // url parameters. This method is applied on the url created in the constructor 
    // of the base iterator implementation, as well as on all 'next'-link urls, 
    // which are obtained from collection chunks in order to obtain the next chunk. 
    _customizeUrl: function(url) {
    },
    
    hasNext: function(dfr, sync) {
        if (typeof this.entries[this.cursor] == "undefined") {
            var insertionIndex = 0;
            if (this.collectionUrl) {
                // load nodes from server
                this._loadAhead(dfr || null, true);
                insertionIndex = this.cursor;
            }
            else {
                // do not load entries
                this.entries[0] = null;
            }
            
            // reflect number of created/removed nodes in size value
            this.sizeValue = this.sizeValue + this.numCreatedNodes - this.numRemovedNodes;
        }
        
        var candidate = this.entries[this.cursor];
        var hasNext = candidate ? true : false;
        if (hasNext && this.model.deletedNodes && this.model.deletedNodes[candidate]) {
            // do not expose nodes, which are deleted at runtime
            this.cursor++;
            return this.hasNext(dfr, sync);
        }
        return hasNext;
    },
    
    next: function(dfr, sync) {
        return this.hasNext(dfr || null, typeof sync == "undefined" ? true : sync) ? this.model.loadedNodes[this.entries[this.cursor++]] : null;
    },
    
    _insertCreated: function(entries, cursor) {
        for (var createdId in this._createdNodes) { // JSLINT-IGNORE: no prototype properties in here
            entries.splice(cursor, 0, createdId);
            cursor++;
        }
    },
    
    setCursorPosition: function(position) {
        this.cursor = position;
        this.collectionUrl.setParameter("start", position);
    },
    
    getCursorPosition: function() {
        return this.cursor;
    },
    
    size: function() {
        return new com.ibm.mm.enabler.DeferredImpl(this, this._size);
    },
    
    _size: function(dfr, sync) {
        if (!this.sizeValue) {
            this.hasNext(null, true);
        }
        
        // finished callback 
        if (dfr) {
            dfr.finish(this.sizeValue, com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK);
        }
        // convenience
        return this.sizeValue;
    },
    
    start: function(sync) {
        this._loadAhead(this, sync, true);
    },
    
    _loadAhead: function(deferred, sync, iterate) {
        // logging support
        var LOG_METHOD = "_loadAhead";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, arguments);
        }
        
        // handle empty iterator
        if (!this.collectionUrl) {
            this.entries[this.cursor] = null;
            if (deferred) {
                deferred.finish(null, com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK);
            }
            return;
        }
        
        // service request
        var serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(this.collectionUrl, null, null, false, sync);
        serviceReq.read(dojo.hitch(this, function(type, data, xhr, args) {
            if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_LOAD) {
            
                // fetch size
                this.sizeValue = com.ibm.mashups.enabler.xml.XPath.evaluateNumber(this.OPENSEARCH_TOTALRESULTS, data, this.model.ns);
                
                // iterate atom entries
                var c = 0;
                var nodes = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(this.ATOM_ENTRY, data, this.model.ns);
                if (nodes) {
                    for (var i = 0, l = nodes.length; i < l; i++) {
                        // instantiate node
                        var node = this._createNode(nodes[i]);
                        if (node) {
                            // put id in entry list
                            this.entries[this.cursor + c++] = node.getID();
                            
                            // callback handling
                            if (deferred) {
                                deferred.nextFinish(node);
                            }
                        }
                        else {
                            // an entry for which no node is instantiated  
                            // does not count towards collection size
                            this.sizeValue--;
                        }
                    }
                }
                // check for 'next'-link on feed level
                var next = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(this.ATOM_NEXT, data, this.model.ns);
                if (next) {
                    var url = next.getAttribute("href");
                    
                    // set collection url from 'next'-link
                    this.collectionUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(url, this.model);
                    
                    // let iterator implementations customize the url
                    this._customizeUrl(this.collectionUrl);
                    if (nodes && iterate) {
                        // was last next element
                        this._loadAhead(deferred, sync, iterate);
                    }
                }
                else {
                    // mark end of collection
                    this.entries[this.cursor + c] = null;

                    // inject nodes, which are created at runtime
                    this._insertCreated(this.entries, this.cursor + c);
                    
                    // finished callback (end of collection)
                    if (deferred) {
                        deferred.finish(null, xhr.status);
                    }
                }
            }
            else {
                // finished callback (error)
                if (deferred) {
                    deferred.finish(null, xhr.status);
                }
            }
        }));
        // exit trace
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD);
        }
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.template.TemplateModelIteratorImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.template.TemplateModelIteratorImpl"] = true;
// APIs



// Implementations




dojo.provide("com.ibm.mm.enabler.template.TemplateModelIteratorImpl");

// navigation model iterator
dojo.declare("com.ibm.mm.enabler.template.TemplateModelIteratorImpl", [com.ibm.mm.enabler.ModelIteratorUnorderedImpl], {
    constructor: function() {
    },
    
    _createNode: function(xmlData) {
       var node = new com.ibm.mm.enabler.template.TemplateNodeImpl(xmlData);
       /*
            node._addDirtyCallback(this.model, function() {
                // if navigation node gets dirty, so does the model 
                this._setDirty();
            });
       */     
        // cache node in model
        node = this.model._cacheNode(node);

        return node || null;
    },
    
    _customizeUrl: function(url) {
        // include access control info
        url.addParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT_VALUE_ACCESS_CONTROL);

        // apply caching strategy
        this.model._applyNoCacheStrategy(url);
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.template.TemplateModelImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.template.TemplateModelImpl"] = true;
dojo.provide("com.ibm.mm.enabler.template.TemplateModelImpl");

























dojo.declare("com.ibm.mm.enabler.template.TemplateModelImpl", [com.ibm.mashups.enabler.ListModel, com.ibm.mm.enabler.model.ModelImpl, com.ibm.mm.enabler.ConfirmableModelImpl], {

    constructor: function() {
        this.LOG_LEVEL = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass);
        var LOG_METHOD = "constructor()";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD);
        }

        this.loadedNodes = {};
        this.createdNodes = {};
        this.deletedNodes = {};
        this.initialContents = {};
        
        this.modelMessages = dojo.i18n.getLocalization("com.ibm.mm.enabler", "modelMessages");
        
        // service document and initialization
        this.serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_TEMPLATE);
        this.prefix = this.serviceJson.idprefix;
        this.nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
        this.ns = dojo.delegate(this.serviceJson.namespaces, this.nsf.getNameSpaces([this.nsf.NS_ATOM, this.nsf.NS_XHTML, this.nsf.NS_OPENSEARCH, this.nsf.NS_CA, this.nsf.NS_APP]));
        
        this.urlType = com.ibm.mashups.enabler.model.url.ModelUrlFactory.TEMPLATE_URL;
        
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD);
        }
    },
    
    // singleton
    getInstance: function() {
        var instance = com.ibm.mm.enabler.template.TemplateModelImpl._instance;
        return instance ? instance : (com.ibm.mm.enabler.template.TemplateModelImpl._instance = new com.ibm.mm.enabler.template.TemplateModelImpl());
    },
    
    invalidate: function() {
        delete com.ibm.mm.enabler.template.TemplateModelImpl._instance;
        // clear all
        
        // get IDs before - concurrency!
        var clearIds = [];
        for (var id in this.loadedNodes) {
            if (Object.prototype.hasOwnProperty.call(this.loadedNodes, id)) {
                clearIds.push(id);
            }
        }
        dojo.forEach(clearIds, this._invalidate, [this, this.loadedNodes, true]);
        clearIds = [];
        for (var id in this.createdNodes) {
            if (Object.prototype.hasOwnProperty.call(this.createdNodes, id)) {
                clearIds.push(id);
            }
        }
        dojo.forEach(clearIds, this._invalidate, [this, this.createdNodes, false]);
        clearIds = [];
        for (var id in this.deletedNodes) {
            if (Object.prototype.hasOwnProperty.call(this.deletedNodes, id)) {
                clearIds.push(id);
            }
        }
        dojo.forEach(clearIds, this._invalidate, [this, this.deletedNodes, false]);

        this.loadedNodes = {};
        this.createdNodes = {};
        this.deletedNodes = {};
        this.initialContents = {};
    },
    _invalidate: function(id) {
        var _that = this[0];
        var _array = this[1];
        
        if (id in _array) {
            delete _array[id];
            if (id in _that.initialContents) {
                delete _that.initialContents[id];
            }
        }
    },
    
    find: function(id) {
        return new com.ibm.mm.enabler.DeferredImpl(this, this._find, id);
    },
    
    _find: function(deferred, sync, id) {
        var LOG_METHOD = "_find(id, deferred, sync)";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, [id, deferred, sync]);
        }
        
        if (id in this.deletedNodes) {
            // public callback handling
            if (deferred) {
                deferred.finish(null, com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_NOT_FOUND);
            }
            
            if (bIsLoggable) {
                this.LOGGER.exiting(LOG_METHOD);
            }
            return null;
        }
        
        if (id in this.loadedNodes) {
            // fetch node from cache
            // public callback handling
            if (deferred) {
                deferred.finish(this.loadedNodes[id], com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK);
            }
            
            if (bIsLoggable) {
                this.LOGGER.exiting(LOG_METHOD, this.loadedNodes[id]);
            }
            
            return this.loadedNodes[id];
        }
        
        // use href info from identifier
        var myUrl = null;
        var href = com.ibm.mm.enabler.utils.Utils.getHrefFromIdentifiable(id);
        if (href) {
            myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(href, this);
        }
        else {
            // construct url otherwise
            myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(this.urlType, this);
            myUrl.setNodes([{
                value: id,
                isID: true
            }]);
        }
        
        // include access control info
        myUrl.addParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT_VALUE_ACCESS_CONTROL);
        
        // apply caching strategy
        this._applyNoCacheStrategy(myUrl);

        var serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
        var entry = null;
        var result = {};
        serviceReq.read(dojo.hitch(this, function(type, data, xhr, args) {
            var LOG_METHOD = "_find_callback(type, data, xhr, args)";
            if (bIsLoggable) {
                this.LOGGER.entering(LOG_METHOD, [type, data, xhr, args]);
            }
            
            var node = com.ibm.mashups.enabler.xml.XPath.evaluateEntry("//atom:entry", data, this.ns);
            
            var newentry = new com.ibm.mm.enabler.template.TemplateNodeImpl(node);
            this.newid = newentry.getID();
            this.loadedNodes[this.newid] = newentry;
            this.initialContents[this.newid] = newentry.toString();
            
            
            // finished callback 
            if (deferred) {
                deferred.finish(this.loadedNodes[this.newid] || null, xhr.status);
            }
            
            // handle error in sync call
            if (sync && type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_ERROR) {
                // do not expose HTTP_NOT_FOUND; simply return null in this case
                if (xhr.status != com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_NOT_FOUND) {
                    result.status = xhr.status;
                }
            }
            
            if (bIsLoggable) {
                this.LOGGER.exiting(LOG_METHOD);
            }
        }));
        if (result.status) {
            throw new Error(dojo.string.substitute(this.modelMessages.E_COMNODE_NOTFOUND_1, [id, result.status]));
        }
        
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD, this.loadedNodes[this.newid]);
        }
        return this.loadedNodes[this.newid];
    },
    
    create: function(context) {
        // Not implemented here - create is run through import
        return null;
    },
    confirmCreate: function(context) {
        return this.getConfirmCreate();
    },
    
    insert: function(node, nextNode) {
        var id = node.getID();
        this.createdNodes[id] = node;
    },
    confirmInsert: function(node, nextNode) {
        return this.getConfirmInsert(nextNode);
    },
    
    confirmExport: function(node) {
        if (com.ibm.mm.enabler.AnonymousHelper.getAnonymousMode() == com.ibm.mashups.enabler.user.AnonymousMode.ANONYMOUS) {
            return false;
        }
        return true;
    },
    
    commit: function() {
        return new com.ibm.mm.enabler.DeferredOperationImpl(this, this._commit);
    },
    
    _commit: function(deferred, sync) {
        var LOG_METHOD = "_commit(deferred, sync)";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, [deferred, sync]);
        }
        
        // initialize callback handling
        this.statusCode = com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK;
        this.requestCount = 0;
        this._acquire();
        
        // HTTP PUT updated nodes
        for (var id in this.loadedNodes) {
            if (Object.prototype.hasOwnProperty.call(this.loadedNodes,id)) {
                // Not implemented here - update is run through import
            }
        }
        
        // HTTP POST created nodes
        for (var created_id in this.createdNodes) {
            if (Object.prototype.hasOwnProperty.call(this.createdNodes,created_id)) {
                // Not implemented here - update is run through import
            }
        }
        this.createdNodes = {};
        
        // HTTP DELETE deleted nodes
        for (var deleted_id in this.deletedNodes) {
            if (Object.prototype.hasOwnProperty.call(this.deletedNodes,deleted_id)) {
                if (bIsLoggable) {
                    this.LOGGER.trace(LOG_METHOD, "Processing delete of template ${0}", deleted_id);
                }
                
                var myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(this.deletedNodes[deleted_id].getEditLink(), this);
                var serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
                this._acquire();
                serviceReq.remove(dojo.hitch(this, function(type, data, xhr, args) {
                    var LOG_METHOD = "_commit_remove_callback(type, data, xhr, args)";
                    if (bIsLoggable) {
                        this.LOGGER.entering(LOG_METHOD, [type, data, xhr, args]);
                    }
                    
                    // finished callback
                    if (deferred && deferred.operationCallback) {
                        deferred.operationCallback(newentry, com.ibm.mashups.enabler.DeferredOperation.OPERATION_DELETE, xhr.status, deferred.operationCallbackParameters);
                    }
                    
                    this._release(deferred, xhr.status);
                    
                    if (bIsLoggable) {
                        this.LOGGER.exiting(LOG_METHOD, [type, data, xhr, args]);
                    }
                })); // JSLINT-IGNORE: Enabler Team decided to keep this paradigma from dojo in tact
            }
        }
        this.deletedNodes = {};
        
        // the finishedCallback ist called in _release
        this._release(deferred, 0);
        
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD);
        }
    },
    
    // acquire semaphore
    _acquire: function() {
        this.requestCount++;
    },
    
    // release semaphore
    _release: function(deferred, statusCode) {
        // set overall status Code
        this.statusCode = Math.max(parseInt(statusCode, 10), this.statusCode);
        // check for full release
        this.requestCount--;
        if (this.requestCount <= 0) {
            if (deferred) {
                deferred.finish(null, this.statusCode);
            }
        }
    },
    
    remove: function(node) {
        var LOG_METHOD = "remove(node)";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, node);
        }
        
        var id = node.getID();
        // mark node as deleted
        if (!(id in this.deletedNodes)) {
            this.deletedNodes[id] = this.loadedNodes[id];
        }
        // mark cache entry
        if (id in this.loadedNodes) {
            delete this.loadedNodes[id];
        }
        
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD, node);
        }
    },
    confirmRemove: function(node) {
        return this.getConfirmRemove(node);
    },
    
    iterator: function() {
        return new com.ibm.mm.enabler.template.TemplateModelIteratorImpl(this.serviceJson.url, this);
    },
    
    _cacheNode: function(node) {
        var id = node.getID();
        if (!(id in this.loadedNodes)) {
            this.loadedNodes[id] = node;
            this.initialContents[id] = node.toString();
        }
        return this.loadedNodes[id];
    },
    _applyNoCacheStrategy: function(url) {
        var s = this._findStrategyByType("com.ibm.mashups.enabler.strategy.NoCacheStrategy");
        if (s) {
            url.addParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_NOCACHE, "true");
        }
    }
});

}

if(!dojo._hasResource["com.ibm.mashups.enabler.model.TemplateModel"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.model.TemplateModel"] = true;
dojo.provide("com.ibm.mashups.enabler.model.TemplateModel");










}

if(!dojo._hasResource["com.ibm.mashups.enabler.theme.Theme"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.theme.Theme"] = true;
dojo.provide("com.ibm.mashups.enabler.theme.Theme");






/**
 * Interface that represents a theme; used in the ThemeModel
 * @ibm-api
 * @ibm-module ThemeModel
 */
dojo.declare("com.ibm.mashups.enabler.theme.Theme", [com.ibm.mashups.enabler.Identifiable, com.ibm.mashups.enabler.Localized, com.ibm.mashups.enabler.DefaultLocalized, com.ibm.mashups.enabler.MetaData], {
    /**
     * Returns the base url of the theme.
     * @type String
     * @return base url of the theme. can never be <code>null</code>
     * @deprecated Since 2.0. Use ThemeModel/ResourceLocator findResourceURL instead
     */
    getBaseUrl: function(){
    },
    
    /**
     * Returns the default skin id for the given theme.
     * @type String
     * @return the default skin id for given theme, <code>null</code> in case of no default skin set.
     * @deprecated use com.ibm.mashups.enabler.ThemeProvider.getDefaultSkinIdentifier instead
     */
    getDefaultSkin: function(){
    },
    
    /**
     * Returns the default skin identifier for this theme.
     * @return {com.ibm.mashups.enabler.Identifiable} the default skin id for this theme, <code>null</code> in case of
     * no default skin set.
     */
    getDefaultSkinIdentifier: function(){
    }
    
});

}

if(!dojo._hasResource["com.ibm.mashups.enabler.model.ThemeModel_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.model.ThemeModel_API"] = true;
dojo.provide("com.ibm.mashups.enabler.model.ThemeModel_API");
dojo.provide("com.ibm.mashups.enabler.model.ThemeModel");

/**
 * Interface for a theme model. This list model describes a list of theme objects.<br>
 * <br>
 * The theme model supports the following strategies:
 * <ul>
 * <li>{@link com.ibm.mashups.enabler.strategy.ListLoadAheadStrategy ListLoadAheadStrategy}</li>
 * <li>{@link com.ibm.mashups.enabler.strategy.HiddenMetaDataLoadingStrategy HiddenMetaDataLoadingStrategy}</li>
 * </ul>
 * @ibm-api
 * @ibm-module ThemeModel
 */
dojo.declare("com.ibm.mashups.enabler.model.ThemeModel", [com.ibm.mashups.enabler.ListModel, com.ibm.mashups.enabler.ResourceLocator], {

    /**
     * Returns the skin model for the given theme.
     * @param {com.ibm.mashups.enabler.theme.Theme} theme the Theme for which to return the skin model;
     * must not be <code>null</code>
     * @type com.ibm.mashups.enabler.model.SkinModel
     * @return skin model for given theme, Never <code>null</code>.
     */
    getSkinModel: function(theme){
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.theme.EmptySkinModelImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.theme.EmptySkinModelImpl"] = true;
dojo.provide("com.ibm.mm.enabler.theme.EmptySkinModelImpl");









// empty skin model
dojo.declare("com.ibm.mm.enabler.theme.EmptySkinModelImpl", [com.ibm.mashups.enabler.model.SkinModel, com.ibm.mm.enabler.model.ModelImpl], {
    constructor: function() {
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass);
        this.LOG_LEVEL = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
    },
    
    iterator: function() {
        return new com.ibm.mm.enabler.EmptyModelIteratorImpl();
    },
    
    find: function(uri) {
        return new com.ibm.mm.enabler.DeferredImpl(this, this._find, uri);
    },
    
    _find: function(dfr, sync, uri) {
        // finished callback 
        if(dfr) { dfr.finish(null, com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_NOT_FOUND); }
        // convenience
        return null;
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.theme.ThemeImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.theme.ThemeImpl"] = true;
dojo.provide("com.ibm.mm.enabler.theme.ThemeImpl");















// theme
dojo.declare("com.ibm.mm.enabler.theme.ThemeImpl", [com.ibm.mashups.enabler.theme.Theme, com.ibm.mm.enabler.persistence.xml.IdentifiableXmlImpl, com.ibm.mm.enabler.persistence.xml.LocalizedXmlImpl, com.ibm.mm.enabler.persistence.xml.DefaultLocalizedXmlImpl, com.ibm.mm.enabler.MetaDataImpl2], {
    constructor: function(node) {
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass);
        this.LOG_LEVEL = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
        
        this.xmlData = node;
        // service document and initialization
        var serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_THEME);
        this.prefix = serviceJson.idprefix;
        var nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
        this.ns = dojo.delegate(serviceJson.namespaces, nsf.getNameSpaces([nsf.NS_ATOM]));
    },
    
    getBaseUrl: function(internal) {
        if (typeof internal == "undefined") {
            var LOG_METHOD = "getBaseUrl";
            this.LOGGER.warning(LOG_METHOD, "Deprecated. Use com.ibm.mashups.enabler.model.ThemeModel.findResourceURL instead.");
        }
        return this._getBaseUrl();
    },
    _getBaseUrl: function() {
        var node = com.ibm.mashups.enabler.xml.XPath.evaluateEntry("atom:content/model:theme/model:link[@ext:rel='baseUrl']", this.xmlData, this.ns);
        return node ? node.getAttribute("href") : null;
    },
    
    // deprecated
    getDefaultSkin: function() {
        var id = this.getDefaultSkinIdentifier();
        return id ? id.getID() : null;
    },
    
    getDefaultSkinIdentifier: function() {
        var result = null;
        var expr = "atom:link[@rel='related' and @ext:rel='defaultSkin']";
        var node = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, this.xmlData, this.ns);
        if (node) {
            var id = com.ibm.mm.enabler.utils.Utils.getIdFromExtUri(this.prefix, node);
            var href = node.getAttribute("href");
            result = new com.ibm.mm.enabler.IdentifierImpl(id, {
                "href": href
            });
        }
        return result || null;
    },
    
    toString: function() {
        return com.ibm.mm.enabler.utils.Dom.innerXML(this.xmlData);
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.theme.ThemeModelIteratorImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.theme.ThemeModelIteratorImpl"] = true;
dojo.provide("com.ibm.mm.enabler.theme.ThemeModelIteratorImpl");











// theme model iterator
dojo.declare("com.ibm.mm.enabler.theme.ThemeModelIteratorImpl", [com.ibm.mashups.enabler.Iterator, com.ibm.mm.enabler.DeferredIteratorImpl, com.ibm.mm.enabler.ModelIteratorImpl], {
    constructor: function() {
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass);
        this.LOG_LEVEL = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
    },
    
    _createNode: function(xmlData) {
        var node = new com.ibm.mm.enabler.theme.ThemeImpl(xmlData);
        this.model.loadedNodes[node.getID()] = node;
        return node;
    },
    
    _customizeUrl: function(url) {
        // include access control info
        url.addParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT_VALUE_ACCESS_CONTROL);
        
        // full representation
        url.setParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_REPRESENTATION, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_REPRESENTATION_VALUE_FULL);
        
        // include hidden meta data
        this.model._applyHiddenMetaDataLoadingStrategyToModelURL(url);
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.theme.ThemeModelImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.theme.ThemeModelImpl"] = true;
dojo.provide("com.ibm.mm.enabler.theme.ThemeModelImpl");






















dojo.declare("com.ibm.mm.enabler.theme.ThemeModelImpl", [com.ibm.mashups.enabler.model.ThemeModel, com.ibm.mm.enabler.model.ModelImpl, com.ibm.mm.enabler.strategy.HiddenMetaDataLoadingStrategyHelperImpl], {
    constructor: function() {
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass);
        this.LOG_LEVEL = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
        
        // cache of loaded nodes; (name:id, value:node)
        this.loadedNodes = {};
        
        // skin models
        this.skinModels = {};
        
        // service document and initialization
        var serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_THEME);
        var nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
        this.ns = dojo.delegate(serviceJson.namespaces, nsf.getNameSpaces([nsf.NS_ATOM, nsf.NS_THR, nsf.NS_XML, nsf.NS_OPENSEARCH]));
        
        // theme collection url
        this.collectionUrl = serviceJson.url;
    },
    
    // singleton
    getInstance: function() {
        var instance = com.ibm.mm.enabler.theme.ThemeModelImpl._instance;
        return instance ? instance : (com.ibm.mm.enabler.theme.ThemeModelImpl._instance = new com.ibm.mm.enabler.theme.ThemeModelImpl());
    },
    
    iterator: function() {
        return new com.ibm.mm.enabler.theme.ThemeModelIteratorImpl(this.collectionUrl, this);
    },
    
    find: function(uri) {
        return new com.ibm.mm.enabler.DeferredImpl(this, this._load, uri);
    },
    
    getSkinModel: function(theme) {
        var themeId = theme.getID();
        if (!(themeId in this.skinModels)) {
            // link to skin collection
            var href;
            var expr = "atom:link[@ext:rel='skin']";
            var skin = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, theme.xmlData, this.ns);
            if (skin) {
                href = skin.getAttribute("href");
                this.skinModels[themeId] = new com.ibm.mm.enabler.theme.SkinModelImpl(href, themeId);
            }
            if (!href) {
                // dont cache empty model
                return new com.ibm.mm.enabler.theme.EmptySkinModelImpl();
            }
        }
        return this.skinModels[themeId];
    },
    
    _load: function(deferred, sync, ident) {
        // logging support
        var LOG_METHOD = "_load";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, arguments);
        }
        
        var id = com.ibm.mm.enabler.utils.Utils.getIdFromIdentifiable(ident);
        if (id in this.loadedNodes) {
            // finished callback
            if(deferred) { deferred.finish(this.loadedNodes[id], com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK); }
        }
        else {
            var myUrl;
            // use href info from identifier
            var href = com.ibm.mm.enabler.utils.Utils.getHrefFromIdentifiable(ident);
            if (href) {
                myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(href, this);
            }
            else {
                // construct url otherwise
                myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(com.ibm.mashups.enabler.model.url.ModelUrlFactory.THEME_URL, this);
                myUrl.setNodes([{
                    value: id,
                    isID: true
                }]);
            }
            // include access control info
            myUrl.addParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT_VALUE_ACCESS_CONTROL);
            
            // full representation
            myUrl.setParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_REPRESENTATION, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_REPRESENTATION_VALUE_FULL);
            
            // apply hidden meta data strategy
            this._applyHiddenMetaDataLoadingStrategyToModelURL(myUrl);
            
            var serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
            serviceReq.read(dojo.hitch(this, function(type, data, xhr, args) {
                if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_LOAD) {
                    var expr = "atom:feed/atom:entry";
                    var node = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, data, this.ns);
                    if (node) {
                        this.loadedNodes[id] = new com.ibm.mm.enabler.theme.ThemeImpl(node);
                    }
                }
                // finished/error callback
                if(deferred) { deferred.finish(this.loadedNodes[id] || null, xhr.status); }
            }));
        }
        // exit trace
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD);
        }
        
        return this.loadedNodes[id] || null;
    },
    
    // @deprecated
    findResourceUrl: function(node, name) {
        return this.findResourceURL(node, name);
    },
    findResourceURL: function(node, name){
        var url;
        var xmlResult = com.ibm.mashups.enabler.xml.XPath.evaluateEntry("atom:link[@ext:rel='media']", node.xmlData, node.ns);
        if (xmlResult) {
            var href = xmlResult.getAttribute("href");
            if (href) {
                if (href.lastIndexOf(name) == (href.length - name.length)) {
                    url = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(href, this);
                }
            }
        }
        if (!url) {
            url = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(com.ibm.mashups.enabler.model.url.ModelUrlFactory.THEME_MEDIA_URL, this);
            var nodeJSON = [{
                value: node.getID(),
                isID: true
            }, {
                value: name,
                isID: false
            }];
            url.setNodes(nodeJSON);
        }
        return url.getAbsoluteURL();
    }
});

}

if(!dojo._hasResource["com.ibm.mashups.enabler.model.ThemeModel"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.model.ThemeModel"] = true;
dojo.provide("com.ibm.mashups.enabler.model.ThemeModel");









}

if(!dojo._hasResource["com.ibm.mashups.enabler.widget.Event"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.widget.Event"] = true;
dojo.provide("com.ibm.mashups.enabler.widget.Event");




/**
 * An interface representing an widget event. It can be obtained through an&nbsp; {@link com.ibm.mashups.enabler.widget.EventProvider EventProvider}.
 * @since 2.4
 *
 * @ibm-api
 * @ibm-module WidgetModel
 */
dojo.declare("com.ibm.mashups.enabler.widget.Event", [com.ibm.mashups.enabler.Identifiable,
                                                      com.ibm.mashups.enabler.Localized], {
    /**
     * Get's the name of this event.
     * @return {String} the name of this event.
     */
    getName: function() {
    },
    /**
     * Returns whether this event is published or not.
     * @return {boolean} whether this event is published or not.
     */
    isPublished: function() {
    },
    /**
     * Returns whether this event is handled or not.
     * @return {boolean} whether this event is handled or not.
     */
    isHandled: function() {
    },
    /**
     * Get's the payload type of this event.
     * @return {String} the payload type of this event.
     */
    getPayloadType: function() {
    }
});


}

if(!dojo._hasResource["com.ibm.mashups.enabler.widget.EventProvider"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.widget.EventProvider"] = true;
dojo.provide("com.ibm.mashups.enabler.widget.EventProvider");



/**
 * Interface for a widget event provider.
 *
 * @since 2.4
 *
 * @ibm-api
 * @ibm-module WidgetModel
 */
dojo.declare("com.ibm.mashups.enabler.widget.EventProvider", null, {
    /**
     * Returns an array of wigdet events, never <code>null</code>.
     * @param {JSON} filter filter to limit the result to handled or published events; optional, must not 
     * be <code>null</code>. Accepted names are:<br>
     * &nbsp;&nbsp;<b><code>FILTER_HANDLED_EVENTS</code></b>, as defined in &nbsp; {@link com.ibm.mashups.enabler.widget.Constants Constants}; must 
     * be <code>true</code> to have handled events returned.<br>
     * &nbsp;&nbsp;<b><code>FILTER_PUBLISHED_EVENTS</code></b>, as defined in &nbsp; {@link com.ibm.mashups.enabler.widget.Constants Constants}; must be <code>true</code> to 
     * have published events returned.<br>
     * If no filter is set, both handled and published events are returned.<br>
     * <br>
     * For example, use the following code to get only the handled events:<br>
     * &nbsp;&nbsp;<code>var filter = {};</code><br>
     * &nbsp;&nbsp;<code>filter[com.ibm.mashups.enabler.widget.Constants.FILTER_HANDLED_EVENTS] = true;</code><br>
     * &nbsp;&nbsp;<code>getEvents(filter);</code><br>
     * <br>
     * <b>Note:</b> Modifying the array does not change the widget events. 
     *
     * @return {Event[]} widget events
     */
    getEvents: function(filter){
    },
    
    /**
     * Returns the event identified by <tt>name</tt> or <tt>null</tt> if the event doesn't exist
     * in this provider.
     * @param {String} name the name of the&nbsp; {@link Event Event}.
     * @return {com.ibm.mashups.enabler.widget.Event} the event identified by <tt>name</tt> or <tt>null</tt>.
     */
    getEvent: function(name) {
        
    },

    /**
     * Returns the event identified by <tt>id</tt> or <tt>null</tt> if the event doesn't exist
     * in this provider.
     * @param {Identifiable} id identifiable or string id of the &nbsp; {@link Event Event}.
     * @return {com.ibm.mashups.enabler.widget.Event} the event or <tt>null</tt>.
     */
    getEventByID: function(id) {
        
    },

    /**
     * @private
     */
    HANDLED_NAME_PREFIX: "handled_",
    /**
     * @private
     */
    PUBLISHED_NAME_PREFIX: "published_"
});

}

if(!dojo._hasResource["com.ibm.mashups.enabler.widget.ModifiableEvent"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.widget.ModifiableEvent"] = true;
dojo.provide("com.ibm.mashups.enabler.widget.ModifiableEvent");





/**
 * An interface representing an widget event. It can be obtained through an&nbsp; {@link com.ibm.mashups.enabler.widget.EventProvider EventProvider}.
 * @since 2.4
 *
 * @ibm-api
 * @ibm-module WidgetModel
 */
dojo.declare("com.ibm.mashups.enabler.widget.ModifiableEvent", [com.ibm.mashups.enabler.widget.Event,
                                                                com.ibm.mashups.enabler.ModifiableLocalized,
                                                                com.ibm.mashups.enabler.DirtyFlagProvider], {
    /**
     * Set's the name of this event.
     * @param {String} name the name of this event.
     * @return {void}
     */
    setName: function(name) {
    },

//    /**
//     * Set's whether this event is published or not.
//     * @param {boolean} published whether this event is published or not.
//     * @return {void}
//     */
//    setPublished: function(published) {
//    },
//
//    /**
//     * Set's whether this event is handled or not.
//     * @param {boolean} handled whether this event is handled or not.
//     * @return {void}
//     */
//    setHandled: function(handled) {
//    },

    /**
     * Set's the payload type of this event.
     * @param {String} payloadType the payload type of this event.
     * @return {void}
     */
    setPayloadType: function(payloadType) {
    }
});


}

if(!dojo._hasResource["com.ibm.mashups.enabler.widget.ModifiableEventProvider"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.widget.ModifiableEventProvider"] = true;
dojo.provide("com.ibm.mashups.enabler.widget.ModifiableEventProvider");





/**
 * Interface for a modifiable widget event provider.
 *
 * @since 2.4
 *
 * @ibm-api
 * @ibm-module WidgetModel
 */
dojo.declare("com.ibm.mashups.enabler.widget.ModifiableEventProvider", [com.ibm.mashups.enabler.widget.EventProvider, com.ibm.mashups.enabler.DirtyFlagProvider], {
    /**
     * Creates an&nbsp; {@link Event Event} with the given name.
     * @param {String} name the name of the event
     * @param {boolean} handled if <tt>true</tt> the created event will be &quot;handled&quot;, otherwiseit will be &quot;published&quot;
     * @return {com.ibm.mashups.enabler.widget.Event} the newly created event with name
     */
    createEvent: function(name, handled) {
        
    },
    /**
     * Returns wigdet events.
     *
     * @return {com.ibm.mashups.enabler.widget.ModifiableEvent[]} widget events
     */
    getEvents: function(filter){
    },
    /**
     * Returns the event identified by <tt>name</tt> or <tt>null</tt> if the event doesn't exist
     * in this provider.
     * @param {String} name the name of the&nbsp; {@link Event Event}.
     * @return {com.ibm.mashups.enabler.widget.ModifiableEvent} the event identified by <tt>name</tt> or <tt>null</tt>.
     */
    getEvent: function(name) {
        
    },
    /**
     * Adds an Event to this&nbsp; {@link EventProvider EventProvider}. If the event already exists
     * it will be overwritten, otherwise it will be added. 
     * @param {com.ibm.mashups.enabler.widget.Event} event the event to add to this event provider
     * @return {void}
     */
    addEvent: function(event) {
        
    },
    /**
     * Removes an Event from this&nbsp; {@link EventProvider EventProvider}.
     * @param {com.ibm.mashups.enabler.widget.Event} event the event to add to this event provider
     * @return {void}
     */
    removeEvent: function(event) {
        
    },
    /**
     * Indicates if the specified event may be added.
     * @param {com.ibm.mashups.enabler.widget.Event} event the event to add
     * @return {boolean} <code>true</code> in case the event may be added, <code>false</code> otherwise
     */
    confirmAddEvent: function(event) {
        
    },
    /**
     * Indicates if the given event may be removed. 
     * @param {com.ibm.mashups.enabler.widget.Event} event the event to remove
     * @return {boolean} <code>true</code> in case the preference may be removed, <code>false</code> otherwise
     */
    confirmRemoveEvent: function(event) {
        
    }
});

}

if(!dojo._hasResource["com.ibm.mashups.enabler.widget.Preferences"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.widget.Preferences"] = true;
dojo.provide("com.ibm.mashups.enabler.widget.Preferences");

/**
 * An interface representing preferences. It can be obtained through an&nbsp; {@link com.ibm.mashups.enabler.widget.PreferencesProvider PreferencesProvider}.
 * @since 2.4
 *
 * @ibm-api
 * @ibm-module WidgetModel
 */
dojo.declare("com.ibm.mashups.enabler.widget.Preferences", null, {
    /**
     * Returns the preference value for the given preference name. 
     * If there are multiple values for the given preference, the first value will be returned.
     * @param {String} name the preference name. Must not be <tt>null</tt>
     * @return {String} the preference value or <code>null</code>, if the preference is not set.
     */
    getValue: function(name) {
    },
    /**
     * Returns the preference values for the given preference name.
     * @param {String} name the preference name. Must not be <tt>null</tt>
     * @return {String[]} the preference values or <code>null</code>, if the preference is not set.
     */
    getValues: function(name) {
    },
    
    /**
     * Return <code>true</code> if the preference is set and marked as read-only in the widget definition, <code>false</code> otherwise.
     * @param {String} name the preference key. Must not be <tt>null</tt>
     * @return {boolean} <code>true</code> if the preference is set and marked as read-only
     */
    isReadOnly: function(name) {
    },
    
    /**
     * Returns a list of the names of preference entries.
     * @return {String[]} the list of names.
     */
    getNames: function() {
    },
    /**
     * Returns a map of all the preferences, with the name as key and the first value only as child.
     * @return {Map} a JSON object representing a map, never <code>null</code>
     */
    getMap: function() {
    }
});


}

if(!dojo._hasResource["com.ibm.mashups.enabler.widget.ModifiablePreferences"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.widget.ModifiablePreferences"] = true;
dojo.provide("com.ibm.mashups.enabler.widget.ModifiablePreferences");




/**
 * An interface representing modifiable preferences. It can be obtained through an&nbsp; {@link com.ibm.mashups.enabler.widget.PreferencesProvider PreferencesProvider}.
 * @since 2.4
 *
 * @ibm-api
 * @ibm-module WidgetModel
 */
dojo.declare("com.ibm.mashups.enabler.widget.ModifiablePreferences", [com.ibm.mashups.enabler.widget.Preferences, com.ibm.mashups.enabler.DirtyFlagProvider], {
    /**
     * Indicates if the preference identified with the specified name may be removed. 
     * @param {String} name name of preference. Must not be <tt>null</tt>
     * @return {boolean} <code>true</code> in case the preference may be removed, <code>false</code> otherwise
     */
    confirmRemove: function(name) {
    },
	
    /**
     * Indicates if the value for the preference identified by the specified name may be set.
     * @param {String} name name of preference. Must not be <tt>null</tt>
     * @param {String} value preference value. Must not be <tt>null</tt>
     * @return {boolean} <code>true</code> in case the preference may be set, <code>false</code> otherwise
     */
    confirmSetValue: function(name, value) {
    },
    /**
     * Indicates if the values for the preference identified by the specified name may be set.
     * @param {String} name name of preference. Must not be <tt>null</tt>
     * @param {String[]} values preference values. Must not be <tt>null</tt>
     * @return {boolean} <code>true</code> in case the preference may be set, <code>false</code> otherwise
     */
    confirmSetValues: function(name, values) {
    },
	
    /**
     * Indicates if the readOnly parameter of the&nbsp; {@link #setValue(String, String, boolean) setValue} method
     *  is evaluated by the remote system.
     * @param {String} name name of preference. Must not be <tt>null</tt>
     * @return {boolean} <code>true</code> in case the readOnly parameter is evaluated, <code>false</code> otherwise.
     */
    confirmSetReadOnly: function(name) {
    },
	
    /**
     * Sets the value for the preference identified by the specified name. The value has to be of type String. 
     * If the name does not exist a new preference is created with the given name, value and read-only to <code>false</false>.
     * @param {String} name name of preference to set the value for. Must not be <tt>null</tt>
     * @param {String} value preference value to set. Must not be <tt>null</tt>
     * @return {boolean} returns <tt>true</tt> in case the setting of the value was successful, <tt>false</tt> otherwise.
     */
    setValue: function(name, value){ // JSLINT-IGNORE: cannot change public API
    },
	
    /**
     * Sets the value for the preference identified by the specified name. The value has to be of type String. 
     * If the name does not exist a new preference is created with the given name, value.
     * @param {String} name name of preference to set the value for. Must not be <tt>null</tt>
     * @param {String} value preference value to set. Must not be <tt>null</tt>
     * @param {boolean} readOnly <code>true</code> if a <b>new</b> created preference should be read-only. <code>false</code> otherwise. default: <code>false</code>
     * @return {boolean} returns <tt>true</tt> in case the setting of the value was successful, <tt>false</tt> otherwise.
     */
    setValue: function(name, value, readOnly) { // JSLINT-IGNORE: cannot change public API
    },
    /**
     * Sets the values for the preference identified by the specified name. The values have to be of type String. 
     * If the name does not exist a new preference is created with the given name, value.
     * @param {String} name name of preference to set the value for. Must not be <tt>null</tt>
     * @param {String[]} values preference values to set. Must not be <tt>null</tt>
     * @return {boolean} returns <tt>true</tt> in case the setting of the values was successful, <tt>false</tt> otherwise.
     */
    setValues: function(name, values) { // JSLINT-IGNORE: cannot change public API
    },
    /**
     * Sets the values for the preference identified by the specified name. The values have to be of type String. 
     * If the name does not exist a new preference is created with the given name, value.
     * @param {String} name name of preference to set the value for. Must not be <tt>null</tt>
     * @param {String[]} values preference values to set. Must not be <tt>null</tt>
     * @param {boolean} readOnly <code>true</code> if a <b>new</b> created preference should be read-only. <code>false</code> otherwise. default: <code>false</code>
     * @return {boolean} returns <tt>true</tt> in case the setting of the values was successful, <tt>false</tt> otherwise.
     */
    setValues: function(name, values, readOnly) { // JSLINT-IGNORE: cannot change public API
    },
    /**
     * Removes the preference identified with the specified name. If read-only is specified, the preference will not be removed.
     * <i>Note: if this object is hierachical, then the remove method will only remove any value on the top layer (if available).</i>
     * @param {String} name name of preference to remove. Must not be <tt>null</tt>
     * @see com.ibm.mashups.enabler.widget.WidgetModel#getHierachicalPreferences(PreferenceProvider) 
     * @return {boolean} returns <tt>true</tt> in case the removing of the value was successful, <tt>false</tt> otherwise.
     */
    remove: function(name) {
    }
});

/**
 * @private
 */
com.ibm.mashups.enabler.widget.ModifiablePreferences.TOPIC_BASE = "/"+("com.ibm.mashups.enabler.widget.ModifiablePreferences".replace(/\./ig,'/'))+"/";
/**
 * @private
 */
com.ibm.mashups.enabler.widget.ModifiablePreferences.TOPIC_PREFERENCES_SET    = com.ibm.mashups.enabler.widget.ModifiablePreferences.TOPIC_BASE + "set";
/**
 * @private
 */
com.ibm.mashups.enabler.widget.ModifiablePreferences.TOPIC_PREFERENCES_REMOVE = com.ibm.mashups.enabler.widget.ModifiablePreferences.TOPIC_BASE + "remove";

}

if(!dojo._hasResource["com.ibm.mashups.enabler.widget.PreferencesProvider_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.widget.PreferencesProvider_API"] = true;
dojo.provide("com.ibm.mashups.enabler.widget.PreferencesProvider_API");
dojo.provide("com.ibm.mashups.enabler.widget.PreferencesProvider");


/**
 * Interface for a widget preference provider.
 *
 * @since 2.4
 *
 * @ibm-api
 * @ibm-module WidgetModel
 */
dojo.declare("com.ibm.mashups.enabler.widget.PreferencesProvider", null, {
    /**
     * Returns wigdet preferences.
     *
     * @return {com.ibm.mashups.enabler.widget.ModifiablePreferences} widget preferences
     */
    getPreferences: function(){
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.widget.PreferencesImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.widget.PreferencesImpl"] = true;
dojo.provide("com.ibm.mm.enabler.widget.PreferencesImpl");










/**
 * Default impl for ModifiablePreferences
 * @since 2.4
 */
dojo.declare("com.ibm.mm.enabler.widget.PreferencesImpl", [com.ibm.mashups.enabler.widget.Preferences], {
    /**
     *
     * @param {XMLDOMNode} node the xml node for this preferences
     * @param {PreferencesProvider} prefProvider the preferences provider
     * @param {Preferences} defaultPreferences  the default preferences
     */
    constructor: function(node, prefProvider, defaultPreferences) {
        //this.xmlData = node;
        this.prefProvider = prefProvider;
        
        this.defaultPreferences = defaultPreferences;
        
        // service document and initialization
        var serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_WIDGET);
        var nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
        this.li_ns = dojo.delegate(serviceJson.namespaces, nsf.getNameSpaces([nsf.NS_ATOM, nsf.NS_XML, nsf.NS_XSI]));
        
        this.PREFERENCES = "atom:content/*/model:portletpreferences[@name='${0}']/base:value";
        this.PREFERENCES_BY_NAME = "atom:content/*/model:portletpreferences[@name='${0}']";
        this.PREFERENCES_TOP = "atom:content/*/model:portletpreferences";
        this.STAR_NODE = "atom:content/*";
        
        this.BASE_NS = this.li_ns.base;
        this.BASE_VALUE = "base:value";
        this.BASE_STRING = "base:String";
        
        this.XSI_NS = this.li_ns.xsi;
        this.XSI_TYPE = "xsi:type";
        
        this.MODEL_NS = this.li_ns.model;
        this.MODEL_PORTLETPREFERENCES = "model:portletpreferences";
    },
    _getPrefNode: function(name) {
        if (!name) {
            return null;
        }
        
        var result = null;
        
        var expr = dojo.string.substitute(this.PREFERENCES_BY_NAME, [name]);
        
        var xmlData = this.prefProvider._getPreferencesXML();
        
        var preference = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, xmlData, this.li_ns);
        
        return preference || result;
        
    },
    getValue: function(name) {
        var prefNode = this._getPrefNode(name);
        
        if (prefNode) {
            var valExpr = "base:value[@xsi:type='base:String' and position()=1]/@value";
            var value = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(valExpr, prefNode, this.li_ns);
            
            if (value) {
                return com.ibm.mm.enabler.utils.Dom.textContent(value);
            }
        }
        
        if (this.defaultPreferences) {
            return this.defaultPreferences.getValue(name);
        }
        
        return null;
    },
    getValues: function(name) {
        var prefNode = this._getPrefNode(name);
        
        if (prefNode) {
            var valExpr = "base:value[@xsi:type='base:String']/@value";
            var values = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(valExpr, prefNode, this.li_ns);
            
            if (values && values.length > 0) {
                return dojo.map(values, function(node) {
                    return com.ibm.mm.enabler.utils.Dom.textContent(node);
                });
            }
        }
        
        if (this.defaultPreferences) {
            return this.defaultPreferences.getValues(name);
        }
        
        return null;
    },
    isReadOnly: function(name) {
        var result = false;
        
        var prefNode = this._getPrefNode(name);
        
        if (prefNode) {
            var attReadOnly = prefNode.getAttribute("read-only");
            
            if (attReadOnly == "true") {
                result = true; // make sure that either ro setting is accepted
            }
        } else {
            if (this.defaultPreferences) {
                result = this.defaultPreferences.isReadOnly(name);
            }
        }
        
        return result;
    },
    getNames: function() {
        var result = [];
        
        var names = {};
        
        var xmlData = this.prefProvider._getPreferencesXML();
        var preferences = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(this.PREFERENCES_TOP, xmlData, this.li_ns);
        
        var i;
        
        if (preferences) {
            var prefCount = preferences.length;
            for (i = 0; i < prefCount; i++) {
                names[preferences[i].getAttribute("name")] = null;
            }
        }
        
        if (this.defaultPreferences) {
            var defNames = this.defaultPreferences.getNames();
            var defNameCount = defNames.length;
            for (i = 0; i < defNameCount; ++i) {
                names[defNames[i]] = null;
            }
        }
        
        for (var name in names) {
            if (Object.prototype.hasOwnProperty.call(names,name)) {
                result.push(name);
            }
        }
        
        return result;
    },
    _getValueForMap: function(prefNode) {
        if (prefNode) {
            var valExpr = "base:value[@xsi:type='base:String' and position()=1]/@value";
            var value = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(valExpr, prefNode, this.li_ns);
            
            if (value) {
                return com.ibm.mm.enabler.utils.Dom.textContent(value);
            }
        }
        return null;
    },
    getMap: function() {
        var result = {};
        
        var xmlData = this.prefProvider._getPreferencesXML();
        var preferences = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(this.PREFERENCES_TOP, xmlData, this.li_ns);
        
        var i;
        
        if (this.defaultPreferences) {
            result = this.defaultPreferences.getMap();
        }

        if (preferences) {
            var map = {};
            var prefCount = preferences.length;
            for (i = 0; i < prefCount; i++) {
                var name = preferences[i].getAttribute("name");
                var value = this._getValueForMap(preferences[i]);
                map[name] = value;
            }
            dojo.mixin(result, map);
        }
        
        return result;
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.widget.ModifiablePreferencesImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.widget.ModifiablePreferencesImpl"] = true;
dojo.provide("com.ibm.mm.enabler.widget.ModifiablePreferencesImpl");















/**
 * This is a class for documentation only, to document the context structure that might be used as additional parameter for set and remove methods.
 * @private
 */
dojo.declare("com.ibm.mm.enabler.widget.PreferencesUpdateContext", null, {
    /**
     * The source of the update method (caller)
     * @type Object
     */
    source: "<instance>",
    /**
     * The context type under which the sender updates the prefs, e.g. iContext
     * @type String
     */
    type: "<context>"
});

/**
 * Default impl for ModifiablePreferences
 * @since 2.4
 */
dojo.declare("com.ibm.mm.enabler.widget.ModifiablePreferencesImpl", [com.ibm.mashups.enabler.widget.ModifiablePreferences, 
                                                                     com.ibm.mm.enabler.widget.PreferencesImpl,
                                                                     com.ibm.mm.enabler.DirtyFlagProviderImpl], {

    /**
     * 
     * @param {Object} name
     * @param {Object} value
     * @param {Object} readOnly
     * @param {PreferenceUpdateContext} _context the context to send with the published event.
     */
    setValue: function(name, value, readOnly, _context) {
        if (value === null) {
            return false;
        }

		name = name || null;
		
		if (!name || name === null || name === 'undefined') {
		    var indx = value.indexOf(":");
			if (indx > 0) {
			    name = value.substring(2, indx - 1);
			}
			var indx2 = value.indexOf(",");
			if (indx2 > indx) {
    			value = value.substring(indx + 2, indx2 - 1);
    		}
		}
		            
        if (!this.confirmSetValue(name, value)) { 
            return false;
        }
            
        var oldValue = this.getValue(name);
        
        var retVal = this._setValuesInternally(name, [value], readOnly);
        
        if (retVal) {
            var senderContext = null;
            if (_context) {
                senderContext = _context;
            }
                
            dojo.publish(com.ibm.mashups.enabler.widget.ModifiablePreferences.TOPIC_PREFERENCES_SET, [this, name, oldValue, value, senderContext]);
        }
        
        return retVal;
    },
    setValues: function(name, values, readOnly) {
        if (values === null) {
            return false;
        }
            
        if (!this.confirmSetValues(name, values)) { 
            return false;
        }
            
        return this._setValuesInternally(name, values, readOnly);
    },
    _setValuesInternally: function(name, values, readOnly) {
        if (!dojo.isArray(values)) {
            return false;
        }
            
        if (this.defaultPreferences && this.defaultPreferences.isReadOnly(name)) {
            return false;
        }
            
        // first get an original existing pref node
        var prefNode = this._getPrefNode(name);
        
        var xmlData = this.prefProvider._getPreferencesXML();
        
        var xmlDom = xmlData.ownerDocument;
        
        if (prefNode) {
            // if prefNode is there, remove the childNodes
            if (prefNode.hasChildNodes()) {
                var childNodes = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(this.BASE_VALUE, prefNode, this.li_ns);
                
                // kill and remove each childNode
                dojo.forEach(childNodes, dojo.destroy);
            }
        }
        else {
            // create the node
            var parentNode = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(this.STAR_NODE, xmlData, this.li_ns);
            
            // something is not right, so let us just return
            if (!parentNode) { 
                return false;
            }
            
            prefNode = com.ibm.mm.enabler.utils.Dom.createElement(xmlDom, this.MODEL_PORTLETPREFERENCES, this.MODEL_NS);
            prefNode.setAttribute("name", name);
            
            parentNode.appendChild(prefNode);
            
            prefNode.setAttribute("read-only", "false");
        }
        
        // make sure that readOnly only get's set in case it is allowed and that there is a true test for true / false
        if (this.confirmSetReadOnly(name)) {
            if (readOnly === true) {
                prefNode.setAttribute("read-only", "true");
            }
            else if (readOnly === false) { 
                prefNode.setAttribute("read-only", "false");
            }
        }
        
        var valueCount = values.length;
        for (var i = 0; i < valueCount; ++i) {
            var value = values[i];
            var node = com.ibm.mm.enabler.utils.Dom.createElement(xmlDom, this.BASE_VALUE, this.BASE_NS);
            com.ibm.mm.enabler.utils.Dom.setAttributeWithNS(xmlDom, node, this.XSI_TYPE, "type", this.XSI_NS, this.BASE_STRING);
            node.setAttribute("value", value);
            prefNode.appendChild(node);
        }
        
        this._setDirty();
        
        return true;
    },
    /**
     * 
     * @param {Object} name
     * @param {PreferenceUpdateContext} _context the context to send with the published event.
     */
    remove: function(name, _context) {
        if (!this.confirmRemove(name)) { 
            return false;
        }
        
        // first get an original existing pref node
        var prefNode = this._getPrefNode(name);
        
        // seems the node didn't exist in the first place
        if (!prefNode) { 
            return false;
        }
        
        // save the old value for the callback
        var oldValue = this.getValue(name);
        
        var xmlData = this.prefProvider._getPreferencesXML();
        
        // find the parent node
        var parentNode = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(this.STAR_NODE, xmlData, this.li_ns);
        
        // something is really screwed here, so let us just return
        if (!parentNode) { 
            return false;
        }
        
        parentNode.removeChild(prefNode);
        this._setDirty();
        
        var senderContext = null;
        if (_context) {
            senderContext = _context;
        }
            
        dojo.publish(com.ibm.mashups.enabler.widget.ModifiablePreferences.TOPIC_PREFERENCES_REMOVE, [this, name, oldValue, null, senderContext]);
        
        return true;
    },

    confirmRemove: function(name) {
        var prefNode = this._getPrefNode(name);
        if (!prefNode) {
            return false;
        }
            
        return true;
    },
    confirmSetValue: function(name, value) {
        return true;
    },
    confirmSetValues: function(name, values) {
        return true;
    },
    confirmSetReadOnly: function(name) {
        return true;
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.widget.HierarchicalPreferencesImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.widget.HierarchicalPreferencesImpl"] = true;
dojo.provide("com.ibm.mm.enabler.widget.HierarchicalPreferencesImpl");




dojo.declare("com.ibm.mm.enabler.widget.HierarchicalPreferencesImpl", com.ibm.mashups.enabler.widget.ModifiablePreferences, {
    constructor: function(basePreferences) {
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass);
        this.LOG_LEVEL = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
        
        // logging support
        var LOG_METHOD = "constructor(basePreferences)";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL, basePreferences);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD);
        }
        
        this.basePrefs = basePreferences;
        this.prefProvider = this.basePrefs.prefProvider;
        this.parentPrefs = this.prefProvider._getParentHierarchicalPreferences();
        
        dojo.subscribe(com.ibm.mashups.enabler.widget.ModifiablePreferences.TOPIC_PREFERENCES_SET, this, "_setValueHandler");
        dojo.subscribe(com.ibm.mashups.enabler.widget.ModifiablePreferences.TOPIC_PREFERENCES_REMOVE, this, "_removeHandler");
        
        this.eventContext = {
            source: this,
            type: "hierachyUpdate",
            provider: this.prefProvider.getID()
        };
        
        // exit trace
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD);
        }
    },
    isReadOnly: function(name) {
        if (this.basePrefs.getValue(name) !== null) {
            return this.basePrefs.isReadOnly(name);
        }
        
        if (this.parentPrefs) {
            return this.parentPrefs.isReadOnly(name);
        }
        
        return false;
    },
    getValue: function(name) {
        var value = this.basePrefs.getValue(name);
        
        if (value !== null) {
            return value;
        }
        
        if (this.parentPrefs) {
            return this.parentPrefs.getValue(name);
        }
        
        return null;
    },
    getValues: function(name) {
        var values = this.basePrefs.getValues(name);
        
        if (values !== null) {
            return values;
        }
        
        if (this.parentPrefs) {
            return this.parentPrefs.getValues(name);
        }
        
        return null;
    },
    setValue: function(name, value, readOnly, _context) {
        // logging support
        var LOG_METHOD = "setValue(name, value, readOnly, _context)";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL, [name, value, readOnly, _context]);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD);
        }
        
        
        if (!this.confirmSetValue(name, value)) {
            // log this
            if (bIsLoggable) {
                this.LOGGER.trace(LOG_METHOD, "confirmSetValue is false");
            }
            
            // exit trace
            if (bIsLoggable) {
                this.LOGGER.exiting(LOG_METHOD, false);
            }
            
            return false;
        }
        
        // log this
        if (bIsLoggable) {
            this.LOGGER.trace(LOG_METHOD, "Setting the new value");
        }
        
        var oldValue = this.getValue(name);
        
        var retVal = this.basePrefs.setValue(name, value, readOnly, _context);
        
        // exit trace
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD, retVal);
        }
        
        return retVal;
    },
    setValues: function(name, values, readOnly) {
        // logging support
        var LOG_METHOD = "setValues(name, values, readOnly)";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL, [name, values, readOnly]);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD);
        }
        
        
        if (!this.confirmSetValues(name, values)) {
            // log this
            if (bIsLoggable) {
                this.LOGGER.trace(LOG_METHOD, "confirmSetValues is false");
            }
            
            // exit trace
            if (bIsLoggable) {
                this.LOGGER.exiting(LOG_METHOD, false);
            }
            
            return false;
        }
        
        // log this
        if (bIsLoggable) {
            this.LOGGER.trace(LOG_METHOD, "Setting the new values");
        }
        
        // var oldValues = this.getValues(name)
        
        var retVal = this.basePrefs.setValues(name, values, readOnly);
        
        //        if (retVal) {
        //            dojo.publish(com.ibm.mashups.enabler.widget.ModifiablePreferences.TOPIC_PREFERENCES_REMOVE, [this, name, oldValue, values]);
        //        }
        
        // exit trace
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD, retVal);
        }
        
        return retVal;
    },
    remove: function(name, _context) {
        var retVal = this.basePrefs.remove(name, _context);
        
        return retVal;
    },
    getNames: function() {
        // logging support
        var LOG_METHOD = "getNames()";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD);
        }
        
        var result = [];
        var names = {};
        
        var i;
        
        if (this.parentPrefs) {
            // log this
            if (bIsLoggable) {
                this.LOGGER.trace(LOG_METHOD, "Getting names from parent preference");
            }
            
            var parentNames = this.parentPrefs.getNames();
            
            var parentNameCount = parentNames.length;
            
            for (i = 0; i < parentNameCount; ++i) {
                names[parentNames[i]] = null;
            }
        }
        
        // log this
        if (bIsLoggable) {
            this.LOGGER.trace(LOG_METHOD, "Getting own names");
        }
        
        var baseNames = this.basePrefs.getNames();
        
        var baseNameCount = baseNames.length;
        
        for (i = 0; i < baseNameCount; ++i) {
            names[baseNames[i]] = null;
        }
        
        for (var name in names) {
            if (Object.prototype.hasOwnProperty.call(names,name)) {
                result.push(name);
            }
        }
        
        // exit trace
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD);
        }
        
        return result;
    },
    getMap: function() {
        // logging support
        var LOG_METHOD = "getMap()";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD);
        }
        var result = {};

        if (this.parentPrefs) {
            // log this
            if (bIsLoggable) {
                this.LOGGER.trace(LOG_METHOD, "Getting map from parent preference");
            }
            result = this.parentPrefs.getMap();
        }
        // log this
        if (bIsLoggable) {
            this.LOGGER.trace(LOG_METHOD, "Getting own map");
        }

        var baseMap = this.basePrefs.getMap();
        dojo.mixin(result,baseMap);

        // exit trace
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD);
        }
        
        return result;
    },
    confirmRemove: function(name) {
        return this.basePrefs.confirmRemove(name);
    },
    confirmSetValue: function(name, value) {
        // logging support
        var LOG_METHOD = "confirmSetValue(name, value)";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL, [name, value]);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD);
        }
        
        if (this.parentPrefs && this.parentPrefs.isReadOnly(name)) {
            // log this
            if (bIsLoggable) {
                this.LOGGER.trace(LOG_METHOD, "Preference is read only on parent");
            }
            
            // exit trace
            if (bIsLoggable) {
                this.LOGGER.exiting(LOG_METHOD, false);
            }
            
            return false;
        }
        
        var baseConfirm = this.basePrefs.confirmSetValue(name, value);
        
        // log this
        if (bIsLoggable) {
            this.LOGGER.trace(LOG_METHOD, "Confirm on base preferences is ${0}", baseConfirm);
        }
        
        
        // exit trace
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD, baseConfirm);
        }
        
        return baseConfirm;
    },
    confirmSetValues: function(name, values) {
        return this.confirmSetValue(name, values);
    },
    confirmSetReadOnly: function(name) {
        return false;
    },
    _valueExistsOnHierarchy: function(prefName) {
    
    },
    _setValueHandler: function(preferencesObj, prefName, oldValue, newValue, context) {
        // we only want to see events for our layer or the parent layer
        if (preferencesObj !== this.basePrefs && preferencesObj !== this.parentPrefs) {
            return;
        }
        var myOV = oldValue;
        
        if (preferencesObj === this.basePrefs) {
            if (oldValue === null && this.parentPrefs) {
                myOV = this.parentPrefs.getValue(prefName); // try to overwrite with parent value
            }
        } else if (preferencesObj === this.parentPrefs) {
            var baseVal = this.basePrefs.getValue(prefName);
            
            // if the event is sent by the parent and we have our own value, there is no change at all because of the layermerge
            if (baseVal !== null) {
                return;
            }
        }
        
        
        if (context === null) {
            context = this.eventContext;
        }
        
        
        dojo.publish(com.ibm.mashups.enabler.widget.ModifiablePreferences.TOPIC_PREFERENCES_SET, [this, prefName, myOV, newValue, context]);
    },
    _removeHandler: function(preferencesObj, prefName, oldValue, newValue, context) {
        // we only want to see events for our layer or the parent layer
        if (preferencesObj !== this.basePrefs && preferencesObj !== this.parentPrefs) {
            return;
        }
        
        if (context === null) {
            context = this.eventContext;
        }
        
        var value;
        
        // if we have a local resource, ignore the deletion on the parent
        if (preferencesObj === this.parentPrefs) {
            value = this.basePrefs.getValue(prefName);
            
            if (value !== null) {
                return;
            }
        }
        
        // if we have a parent value, this is just a change, not a delete
        if (preferencesObj === this.basePrefs) {
            if (this.parentPrefs) {
                value = this.parentPrefs.getValue(prefName);
                if (value !== null) {
                    dojo.publish(com.ibm.mashups.enabler.widget.ModifiablePreferences.TOPIC_PREFERENCES_SET, [this, prefName, oldValue, value, context]);
                    return;
                }
            }
        }
        
        
        // if none of the above was fullfilled, we need to resend the remove here.
        dojo.publish(com.ibm.mashups.enabler.widget.ModifiablePreferences.TOPIC_PREFERENCES_REMOVE, [this, prefName, oldValue, newValue, context]);
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.widget.PreferencesProviderImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.widget.PreferencesProviderImpl"] = true;
dojo.provide("com.ibm.mm.enabler.widget.PreferencesProviderImpl");







dojo.declare("com.ibm.mm.enabler.widget.PreferencesProviderImpl", com.ibm.mashups.enabler.widget.PreferencesProvider, {
    getPreferences: function() {
        if (!this.preferences) {
            var prefXML = this._getPreferencesXML();
            
            // don't try to create the needed DOM nodes for now
            if (!prefXML) {
                return null;
            }
            
            // try to find the default preferences to initialize correctly
            var defXML = null;
            var defaultPreferences = null;
            if (this._getDefaultPreferencesXML) {
            
                defXML = this._getDefaultPreferencesXML();
                if (defXML) {
                    var me = this;
                    var defPrefProvider = {
                        _getPreferencesXML: function() {
                            return me._getDefaultPreferencesXML();
                        }
                    };
                    
                    defaultPreferences = new com.ibm.mm.enabler.widget.PreferencesImpl(defXML, defPrefProvider);
                }
            }
            this.preferences = new com.ibm.mm.enabler.widget.ModifiablePreferencesImpl(prefXML, this, defaultPreferences);
        }
        return this.preferences;
    },
    /**
     * Gets the preferences object of the parent
     */
    _getParentPreferences: function() {
        var parentObject = this.model._getParent(this);
        
        if (parentObject && parentObject.getPreferences) {
            return parentObject.getPreferences();
        }
        else {
            return null;
        }
    },
    _getHierarchicalPreferences: function() {
        if (!this.hierarchicalPrefs) {
            this.hierarchicalPrefs = new com.ibm.mm.enabler.widget.HierarchicalPreferencesImpl(this.getPreferences());
        }
        
        return this.hierarchicalPrefs;
    },
    _getParentHierarchicalPreferences: function() {
        var parentObject = this.model._getParent(this);
        
        if (parentObject && parentObject._getParentHierarchicalPreferences) {
            return parentObject._getHierarchicalPreferences();
        }
        else {
            return null;
        }
    }
    
});

}

if(!dojo._hasResource["com.ibm.mashups.enabler.widget.PreferencesProvider"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.widget.PreferencesProvider"] = true;
dojo.provide("com.ibm.mashups.enabler.widget.PreferencesProvider");





}

if(!dojo._hasResource["com.ibm.mashups.enabler.widget.WidgetDefinition_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.widget.WidgetDefinition_API"] = true;
dojo.provide("com.ibm.mashups.enabler.widget.WidgetDefinition_API");
dojo.provide("com.ibm.mashups.enabler.widget.WidgetDefinition");

/**
 * Interface for a widget definition.
 *
 * @ibm-api
 * @ibm-module WidgetModel
 */
dojo.declare("com.ibm.mashups.enabler.widget.WidgetDefinition", [com.ibm.mashups.enabler.Identifiable, com.ibm.mashups.enabler.ModifiableLocalized, com.ibm.mashups.enabler.ModifiableMetaData, com.ibm.mashups.enabler.widget.PreferencesProvider, com.ibm.mashups.enabler.widget.ModifiableEventProvider], {
    /**
     * @private
     */
    _type: "definition",
    
    /**
     * This method returns the url pointing to the widget definition xml file.
     * @return{String}  URL pointing to the widget definition xml file.
     *
     * @since 3.0
     */
    getURL: function() {
    },
    
    /**
     * This method returns the type of the entity represented by this definition (e.g. iWidgets or OpenSocial gadget).
     * @return{String}  the type of the entity represented in the definition xml file.
     *
     * @since 3.0
     */
    getType: function() {
    },
    
    /**
     * This method returns an array of supported modes such as &quot;view&quot; and &quot;edit&quot;.
     * @return{String[]}  an array of modes this iWidget supports.
     *
     * @since 2.4
     */
    getSupportedModes: function() {
    }
});

}

if(!dojo._hasResource["com.ibm.mashups.enabler.widget.WidgetDefinition"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.widget.WidgetDefinition"] = true;
dojo.provide("com.ibm.mashups.enabler.widget.WidgetDefinition");










}

if(!dojo._hasResource["com.ibm.mashups.enabler.widget.WidgetInstance_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.widget.WidgetInstance_API"] = true;
dojo.provide("com.ibm.mashups.enabler.widget.WidgetInstance_API");
dojo.provide("com.ibm.mashups.enabler.widget.WidgetInstance");

/**
 * Interface for a widget instance.
 *
 * @since 2.4
 *
 * @ibm-api
 * @ibm-module WidgetModel
 */
dojo.declare("com.ibm.mashups.enabler.widget.WidgetInstance", [com.ibm.mashups.enabler.Identifiable, 
                                                               com.ibm.mashups.enabler.ModifiableMetaData,
                                                               com.ibm.mashups.enabler.widget.PreferencesProvider,
                                                               com.ibm.mashups.enabler.widget.ModifiableEventProvider], {
    /**
     * @private
     */
    _type: "instance"
});

}

if(!dojo._hasResource["com.ibm.mashups.enabler.widget.WidgetInstance"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.widget.WidgetInstance"] = true;
dojo.provide("com.ibm.mashups.enabler.widget.WidgetInstance");








}

if(!dojo._hasResource["com.ibm.mashups.enabler.widget.WidgetWindow"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.widget.WidgetWindow"] = true;
dojo.provide("com.ibm.mashups.enabler.widget.WidgetWindow");





/**
 * Interface for a widget window.
 *
 * @since 2.4
 *
 * @ibm-api
 * @ibm-module WidgetModel
 */
dojo.declare("com.ibm.mashups.enabler.widget.WidgetWindow", [com.ibm.mashups.enabler.Identifiable,
                                                             com.ibm.mashups.enabler.widget.PreferencesProvider,
                                                             com.ibm.mashups.enabler.widget.ModifiableEventProvider], {
    /**
     * @private
     */
    _type: "window"
});

}

if(!dojo._hasResource["com.ibm.mashups.enabler.widget.WidgetModel_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.widget.WidgetModel_API"] = true;
dojo.provide("com.ibm.mashups.enabler.widget.WidgetModel_API");
dojo.provide("com.ibm.mashups.enabler.widget.WidgetModel");












/**
 * This interface provides a model for widgets. It exposes widget definitions,
 * instances, and windows. You may create widget instances based on definitions
 * and remove widget instances.<br>
 * <br>
 * The widget model supports the following strategies:
 * <ul>
 * <li>{@link com.ibm.mashups.enabler.strategy.HiddenMetaDataLoadingStrategy HiddenMetaDataLoadingStrategy}</li>
 * </ul>
 *
 * @ibm-api
 * @ibm-module WidgetModel
 */
dojo.declare("com.ibm.mashups.enabler.widget.WidgetModel", [com.ibm.mashups.enabler.Commitable, com.ibm.mashups.enabler.model.Model, com.ibm.mashups.enabler.Locator, com.ibm.mashups.enabler.Discardable, com.ibm.mashups.enabler.DirtyFlagProvider], {
    /**
     * Returns the widget definition specified with the id.
     *
     * @param {com.ibm.mashups.enabler.Identifiable} id of the widget definition
     * @return {com.ibm.mashups.enabler.Deferred} a deferred object used to start this operation,
     * never <code>null</code>. The return value when executed through the deferred
     * object is a&nbsp; {@link com.ibm.mashups.enabler.widget.WidgetDefinition WidgetDefinition} for the given&nbsp; {@link Identifiable Identifiable} or <tt>null</tt> if no
     * widget definition is found.
     *
     * @since 2.4
     */
    find: function(id) {
    },
    /**
     * Returns the widget window for the specified windowID and pageID.
     * @param {String} windowID the ID of the window to lookup
     * @param {String} pageID the page ID of the window to lookup
     * @return {com.ibm.mashups.enabler.Deferred} a deferred object used to start this operation, never <tt>null</tt>. The return value when executed
     * through the deferred object is a&nbsp; {@link com.ibm.mashups.enabler.widget.WidgetWindow WidgetWindow} for the given IDs or <tt>null</tt> if no widget window is found.
     *
     * @since 3.0
     */
    findWidgetWindow: function(windowID, pageID) {
    },
    /**
     * Returns the widget definition specified with the widget window
     * @param {com.ibm.mashups.enabler.widget.WidgetWindow} window the widget window
     * @return {com.ibm.mashups.enabler.Deferred} a deferred object used to start this operation,
     * never <code>null</code>. The return value when executed through the deferred
     * object is a&nbsp; {@link com.ibm.mashups.enabler.widget.WidgetDefinition WidgetDefinition} for the given&nbsp; {@link com.ibm.mashups.enabler.widget.WidgetWindow WidgetWindow} or <tt>null</tt> if no
     * widget definition is found.
     *
     * @since 2.4
     */
    getWidgetDefinitionByWindow: function(window) {
    },
    
    /**
     * Returns the widget definition specified with the widget instance
     * @param {com.ibm.mashups.enabler.widget.WidgetInstance} instance the widget instance
     * @return {com.ibm.mashups.enabler.Deferred} a deferred object used to start this operation,
     * never <code>null</code>. The return value when executed through the deferred
     * object is a&nbsp; {@link com.ibm.mashups.enabler.widget.WidgetDefinition WidgetDefinition} for the given&nbsp; {@link com.ibm.mashups.enabler.widget.WidgetInstance WidgetInstance} or <tt>null</tt> if no
     * widget definition is found.
     *
     * @since 2.4
     */
    getWidgetDefinitionByInstance: function(instance) {
    },
    
    /**
     * Returns the widget window of the specified layout control.
     * @param {com.ibm.mashups.enabler.layout.LayoutControl} control the layout control
     * @return {com.ibm.mashups.enabler.Deferred} a deferred object used to start this operation,
     * never <code>null</code>. The return value when executed through the deferred
     * object is a&nbsp; {@link WidgetWindow WidgetWindow} for the given&nbsp; {@link LayoutControl LayoutControl} or <tt>null</tt> if no
     * widget window is found.
     *
     * @since 2.4
     */
    getWidgetWindow: function(control) {
    },
    
    /**
     * Returns <tt>true</tt> in case the&nbsp; {@link WidgetWindow WidgetWindow} identified by <tt>id</tt> is cached in this model. <tt>false</tt> otherwise.
     *
     * @param {String} id the identifier of the window
     * @since 3.0
     * @return {boolean} <tt>true</tt> in case the window is cached <tt>false</tt> otherwise.
     *
     * @since 3.0
     */
    isWidgetWindowCached: function(id) {
    },
    /**
     * Returns the widget instance of the specified widget window.
     * @param {com.ibm.mashups.enabler.widget.WidgetWindow} window the widget window
     * @return {com.ibm.mashups.enabler.Deferred} a deferred object used to start this operation,
     * never <code>null</code>. The return value when executed through the deferred
     * object is a&nbsp; {@link com.ibm.mashups.enabler.widget.WidgetInstance WidgetInstance} for the given&nbsp; {@link com.ibm.mashups.enabler.widget.WidgetWindow WidgetWindow} or <tt>null</tt> if no
     * widget instance is found.
     *
     * @since 2.4
     */
    getWidgetInstance: function(window) {
    },
    /**
     * Gets hierarchical preferences of the specified&nbsp; {@link PreferenceProvider PreferenceProvider} down to the levels.
     * This means, that the preferences of each level (definition, instance and window) will be aggregated, depending on which preference provider you provided as argument.
     * @param {com.ibm.mashups.enabler.widget.PreferencesProvider} preferenceProvider the preference provider from which to aggregate preferences down.
     * @return {com.ibm.mashups.enabler.Deferred} returns an&nbspM {@link ModifiablePreferences ModifiablePreferences} object, that represents the aggregated preferences down to the lowest level, starting on the preference level of the given&nbsp; {@link PreferenceProvider PreferenceProvider}
     *
     * @since 2.4
     */
    getHierarchicalPreferences: function(preferenceProvider) {
    
    },
    /**
     * Gets the <i>hierarchical</i>&nbsp; {@link EventProvider EventProvider} for the specified&nbsp; {@link EventProvider EventProvider} down to the levels.
     * This means, that the events of each level (definition, instance and window) will be aggregated, depending on which event provider you provided as argument and then be accessible through the retuned eventprovider.
     * @param {com.ibm.mashups.enabler.widget.EventProvider} eventProvider the event provider from which to aggregate events down.
     * @return {com.ibm.mashups.enabler.Deferred} returns an&nbsp; {@link ModifiableEventProvider ModifiableEventProvider} providing the aggregated events down to the lowest level, starting on the event level of the given&nbsp; {@link EventProvider EventProvider}
     *
     * @since 2.4
     */
    getHierarchicalEventProvider: function(eventProvider) {
    
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.widget.ModifiableEventImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.widget.ModifiableEventImpl"] = true;
dojo.provide("com.ibm.mm.enabler.widget.ModifiableEventImpl");
















/**
 * Default impl for ModifiablePreferences
 * @since 2.4
 */
dojo.declare("com.ibm.mm.enabler.widget.ModifiableEventImpl", [com.ibm.mashups.enabler.widget.ModifiableEvent, com.ibm.mm.enabler.persistence.xml.LocalizedXmlImpl, com.ibm.mm.enabler.DirtyFlagProviderImpl], {
    constructor: function(node, eventProvider) {
        this.xmlData = node;
        this.eventProvider = eventProvider;
        
        // service document and initialization
        var serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_WIDGET);
        var nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
        this.li_ns = dojo.delegate(serviceJson.namespaces, nsf.getNameSpaces([nsf.NS_ATOM, nsf.NS_XML, nsf.NS_XSI, nsf.NS_EVENT_DATATYPES]));
        
        this.QNAME_XPATH = "model:qname";
        this.PAYLOAD_TYPE_XPATH = "model:payload-type";
        
        this.PUBLISHED_LNAME = "publish-event";
        this.PROCESSED_LNAME = "process-event";
        
        this.MODEL_QNAME = "model:qname";
        this.MODEL_PAYLOAD_TYPE = "model:payload-type";
        
        this.STAR_NODE = "atom:content/*";
        
        this.BASE_NS = this.li_ns.base;
        this.BASE_VALUE = "base:value";
        this.BASE_STRING = "base:String";
        
        this.XSI_NS = this.li_ns.xsi;
        this.XSI_TYPE = "xsi:type";
        
        this.MODEL_NS = this.li_ns.model;
        
        // let's do some overrides for the localized impl
        // let's do some overrides for the localized impl
        this.TITLE_ELEMENT = "model:title";
        this.TITLE = this.TITLE_ELEMENT + "/" + this.BASE_NLS_TITLE_STRING;
        this.DESCRIPTION_ELEMENT = "model:description";
        this.DESCRIPTION = this.DESCRIPTION_ELEMENT + "/" + this.BASE_NLS_TITLE_STRING;
        
        this.DEFAULT_PAYLOAD_PREFIX = "mmpayload";
        this.DEFAULT_NAME_PREFIX = "mmname";
        
        this.DATATYPE_NS = this.li_ns[nsf.NS_EVENT_DATATYPES];
        
        this.XMLNS_NS = nsf.getNameSpaces([nsf.NS_XMLNS])[nsf.NS_XMLNS];
    },
    getID: function() {
        var rawID = this.xmlData.getAttribute("id");
        return com.ibm.mm.enabler.IdentifiableHelper.getID(rawID);
    },
    getName: function() {
        var expr = this.QNAME_XPATH;
        var qNameNode = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, this.xmlData, this.li_ns);
        
        if (!qNameNode) {
            return null;
        }
        
        var qName = com.ibm.mm.enabler.utils.Dom.textContent(qNameNode);
        
        var nsPrefix = com.ibm.mm.enabler.utils.Dom.getNodeNSPrefix(qName);
        var localName = com.ibm.mm.enabler.utils.Dom.removeNodeNS(qName);
        
        if (nsPrefix === null) {
            return localName;
        }
        
        var ns = com.ibm.mm.enabler.utils.Dom.lookupNamespaceURI(qNameNode, nsPrefix);
        
        if (ns === null) {
            return localName;
        }
        
        return "{" + ns + "}" + localName;
    },
    isPublished: function() {
        var localName = com.ibm.mm.enabler.utils.Dom.getLocalName(this.xmlData);
        
        return (localName == this.PUBLISHED_LNAME);
    },
    isHandled: function() {
        var localName = com.ibm.mm.enabler.utils.Dom.getLocalName(this.xmlData);
        
        return (localName == this.PROCESSED_LNAME);
    },
    getPayloadType: function() {
        var expr = this.PAYLOAD_TYPE_XPATH;
        var payLoadTypeNode = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, this.xmlData, this.li_ns);
        
        if (!payLoadTypeNode) {
            return null;
        }
        
        var payLoadType = com.ibm.mm.enabler.utils.Dom.textContent(payLoadTypeNode);
        
        var nsPrefix = com.ibm.mm.enabler.utils.Dom.getNodeNSPrefix(payLoadType);
        var localName = com.ibm.mm.enabler.utils.Dom.removeNodeNS(payLoadType);
        
        if (nsPrefix === null) {
            return localName;
        }
        
        
        var ns = com.ibm.mm.enabler.utils.Dom.lookupNamespaceURI(payLoadTypeNode, nsPrefix);
        
        if (ns === null) {
            return localName;
        }
        
        return "{" + ns + "}" + localName;
    },
    /**
     * Set's a qname based node with the given parameters
     * @param {String} modelNodeName the name of the node (needs to be in model namespace)
     * @param {String} nodeXPath the XPath for looking up already existing nodes
     * @param {String} value the value of the node, might also be in qName notation ( {namespace} localName )
     * @return {void}
     */
    _setQNameNode: function(modelNodeName, nodeXPath, value, nsPrefix) {
        var expr = nodeXPath;
        var xmlDom = this.xmlData.ownerDocument;
        var qNameNode = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, this.xmlData, this.li_ns);
        
        if (!qNameNode) {
            qNameNode = com.ibm.mm.enabler.utils.Dom.createElement(xmlDom, modelNodeName, this.li_ns.model);
            this.xmlData.appendChild(qNameNode);
        }
        
        // we suppose that the browser will do the cleanup for now
        //var level = com.ibm.mashups.enabler.xml.XPath.evaluateSingle(expr, xmlData, ns);
        var nsUri = null;
        var localName = null;
        // now let's see what we've got
        var nsStart = value.indexOf("{");
        if (nsStart === 0) {
            var nsEnd = value.indexOf("}");
            if (nsEnd == -1) {
                throw new Error("Name is not a valid qName");
            }
            
            nsUri = value.substring(nsStart + 1, nsEnd);
            localName = value.substring(nsEnd + 1);
        } else {
            localName = value;
        }
        
        if (nsUri !== null) {
            com.ibm.mm.enabler.utils.Dom.setAttributeWithNS(qNameNode.ownerDocument, qNameNode, "xmlns:" + nsPrefix, nsPrefix, this.XMLNS_NS, nsUri);
            com.ibm.mm.enabler.utils.Dom.textContent(qNameNode, nsPrefix + ":" + localName);
        } else {
            com.ibm.mm.enabler.utils.Dom.textContent(qNameNode, localName);
        }
    },
    setName: function(name) {
        if (this.getName()==name) {
            // identical, so we don't need to change it
            return;
        }
        this._setQNameNode(this.MODEL_QNAME, this.QNAME_XPATH, name, this.DEFAULT_NAME_PREFIX);
        this._setDirty();
    },
    setPayloadType: function(payloadType) {
        var qNamePayloadType = payloadType;
        
        var uriPos = payloadType.indexOf("{");
        
        if (uriPos == -1) {
            qNamePayloadType = "{" + this.DATATYPE_NS + "}" + payloadType;
        }
        if (this.getPayloadType()==qNamePayloadType) {
            // identical, so we don't need to change it
            return;
        }
        
        this._setQNameNode(this.MODEL_PAYLOAD_TYPE, this.PAYLOAD_TYPE_XPATH, qNamePayloadType, this.DEFAULT_PAYLOAD_PREFIX);
        this._setDirty();
    },
    _getXML: function() {
        return this.xmlData;
    },
    _setXML: function(xmlData) {
        this.xmlData = xmlData;
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.widget.HierarchicalEventProviderImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.widget.HierarchicalEventProviderImpl"] = true;
dojo.provide("com.ibm.mm.enabler.widget.HierarchicalEventProviderImpl");





dojo.declare("com.ibm.mm.enabler.widget.HierarchicalEventProviderImpl", com.ibm.mashups.enabler.widget.EventProvider, {
    constructor: function(baseEventProvider) {
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass);
        this.LOG_LEVEL = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
        
        // logging support
        var LOG_METHOD = "constructor(baseEventProvider)";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL, baseEventProvider);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD);
        }
        
        this.baseEP = baseEventProvider;
        this.parentEP = this.baseEP._getParentHierarchicalEventProvider();
        
        // exit trace
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD);
        }
        
        
    },
    createEvent: function(name, handled) {
        // logging support
        var LOG_METHOD = "createEvent(name, handled)";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL, [name, handled]);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD);
        }
        var retVal = this.baseEP.createEvent(name, handled);
        
        // exit trace
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD, retVal);
        }
        
        return retVal;
    },
    getEvents: function(filter) {
        // logging support
        var LOG_METHOD = "getEvents()";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD);
        }
        
        var result = [];
        var events = {};
        
        var i;
        var namePrefix;
        
        // log this
        if (bIsLoggable) {
            this.LOGGER.trace(LOG_METHOD, "Getting own events");
        }
        
        var baseEvents = this.baseEP.getEvents(filter);
        
        var baseEventCount = baseEvents.length;
        
        for (i = 0; i < baseEventCount; ++i) {
            var baseEvent = baseEvents[i];
            
            if (baseEvent.isHandled()) {
                namePrefix = this.HANDLED_NAME_PREFIX;
            } else {
                namePrefix = this.PUBLISHED_NAME_PREFIX;
            }
            
            events[namePrefix + baseEvent.getName()] = baseEvents[i];
        }
        
        if (this.parentEP) {
            // log this
            if (bIsLoggable) {
                this.LOGGER.trace(LOG_METHOD, "Getting events from parent event provider");
            }
            
            var parentEvents = this.parentEP.getEvents(filter);
            
            var parentEventCount = parentEvents.length;
            
            var name;
            
            for (i = 0; i < parentEventCount; ++i) {
                var parentEvent = parentEvents[i];
                name = parentEvent.getName();
                
                if (parentEvent.isHandled()) {
                    namePrefix = this.HANDLED_NAME_PREFIX;
                } else {
                    namePrefix = this.PUBLISHED_NAME_PREFIX;
                }
                
                var tempName = namePrefix + name;
                if (!(tempName in events)) {
                    events[tempName] = parentEvents[i];
                }
            }
        }
        
        for (var eventName in events) {
            if (Object.prototype.hasOwnProperty.call(events, eventName)) {
                result.push(events[eventName]);
            }
        }
        
        // exit trace
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD);
        }
        
        return result;
    },
    getEvent: function(name) {
        var event = this.baseEP.getEvent(name);
        
        if (event !== null) {
            return event;
        }
        
        if (this.parentEP) {
            return this.parentEP.getEvent(name);
        }
        
        return null;
    },
    addEvent: function(event) {
        // logging support
        var LOG_METHOD = "addEvent(event)";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL, [event]);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD);
        }
        
        
        if (!this.confirmAddEvent(event)) {
            // log this
            if (bIsLoggable) {
                this.LOGGER.trace(LOG_METHOD, "confirmAddEvent is false");
            }
            
            // exit trace
            if (bIsLoggable) {
                this.LOGGER.exiting(LOG_METHOD);
            }
            
            return;
        }
        
        this.baseEP.addEvent(event);
        
        // exit trace
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD);
        }
    },
    removeEvent: function(event) {
        // logging support
        var LOG_METHOD = "removeEvent(event)";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL, [event]);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD);
        }
        
        
        if (!this.confirmRemoveEvent(event)) {
            // log this
            if (bIsLoggable) {
                this.LOGGER.trace(LOG_METHOD, "confirmRemoveEvent is false");
            }
            
            // exit trace
            if (bIsLoggable) {
                this.LOGGER.exiting(LOG_METHOD);
            }
            
            return;
        }
        
        this.baseEP.removeEvent(event);
        
        // exit trace
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD);
        }
    },
    confirmAddEvent: function(event) {
        return this.baseEP.confirmAddEvent(event);
    },
    confirmRemoveEvent: function(event) {
        return this.baseEP.confirmRemoveEvent(event);
    },
    
    getEventByID: function(id) {
        var event = this.baseEP.getEventByID(id);
        
        if (event !== null) {
            return event;
        }
        
        if (this.parentEP) {
            return this.parentEP.getEventByID(id);
        }
        
        return null;
        
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.widget.ModifiableEventProviderImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.widget.ModifiableEventProviderImpl"] = true;
dojo.provide("com.ibm.mm.enabler.widget.ModifiableEventProviderImpl");












dojo.declare("com.ibm.mm.enabler.widget.ModifiableEventProviderImpl", [com.ibm.mashups.enabler.widget.ModifiableEventProvider, com.ibm.mm.enabler.DirtyFlagProviderImpl], {
    constructor: function() {
        // internal events hashmap, is identified by name
        this._events = null;
        
        this.EVENTS_TOP_XPATH = "atom:content/*/model:events";
        this.EVENTS_XPATH = this.EVENTS_TOP_XPATH + "/*";
        this.PARENT_XPATH = "atom:content/*";
        
        this.MODEL_PUBLISH_EVENT = "model:publish-event";
        this.MODEL_PROCESS_EVENT = "model:process-event";
        this.MODEL_EVENTS = "model:events";
        
        // will be used to track add / remove
        this._eventProviderIsDirty = false;
        
        this.idService = com.ibm.mashups.enabler.services.IdentificationService;
    },
    
    createEvent: function(name, handled) {
        var xmlDom = this._getEventXML().ownerDocument;
        
        var nodeName = this.MODEL_PUBLISH_EVENT;
        
        if (handled) {
            nodeName = this.MODEL_PROCESS_EVENT;
        }
        
        // first let's assume that we have a published event.
        var node = com.ibm.mm.enabler.utils.Dom.createElement(xmlDom, nodeName, this.ns.model);
        node.setAttribute("id", "cid:" + this.idService.createClientID());
        
        var myEvent = new com.ibm.mm.enabler.widget.ModifiableEventImpl(node, this);
        myEvent._addDirtyCallback(this, function() {
            // if layout model gets dirty, so does the navigation model 
            this._setDirty();
        });
        myEvent.setName(name);
        myEvent.setPayloadType("{" + this.ns.xsi + "}String");
        myEvent._setDirty();
        
        return myEvent;
    },
    getEvents: function(filter) {
        var filterAll = true;
        var filterHandled = false;
        var filterPublished = false;
        
        
        if (typeof filter != "undefined" && filter !== null) {
        
            if (filter[com.ibm.mashups.enabler.widget.Constants.FILTER_HANDLED_EVENTS] !== null &&
            filter[com.ibm.mashups.enabler.widget.Constants.FILTER_HANDLED_EVENTS] === true) {
                filterHandled = true;
                filterAll = false;
            }
            if (filter[com.ibm.mashups.enabler.widget.Constants.FILTER_PUBLISHED_EVENTS] !== null &&
            filter[com.ibm.mashups.enabler.widget.Constants.FILTER_PUBLISHED_EVENTS] === true) {
                filterPublished = true;
                filterAll = false;
            }
            
            if (filterPublished && filterHandled) {
                filterAll = true;
            }
            
        }
        
        if (this._events === null) {
            this._loadEventsFromXML();
        }
        
        var eventArray = [];
        
        for (var eventName in this._events) {
            if (Object.prototype.hasOwnProperty.call(this._events, eventName)) {
                eventArray.push(this._events[eventName]);
            }
        }
        
        var event;
        // _defaultEventProvider needs to be defined by the consumer.
        if (this._defaultEventProvider) {
            var defaultEvents = this._defaultEventProvider.getEvents();
            var defaultEventCount = defaultEvents.length;
            
            for (var i = 0; i < defaultEventCount; ++i) {
                event = defaultEvents[i];
                
                if (event.isHandled()) {
                    namePrefix = this.HANDLED_NAME_PREFIX;
                }
                else {
                    namePrefix = this.PUBLISHED_NAME_PREFIX;
                }
                
                if (!(namePrefix + event.getName() in this._events)) {
                    eventArray.push(event);
                }
            }
        }
        var filterArray = [];
        if (!filterAll) {
            var eventCount = eventArray.length;
            for (var j = 0; j < eventCount; ++j) {
                event = eventArray[j];
                if (filterHandled && event.isHandled()) {
                    filterArray.push(event);
                }
                else if (filterPublished && event.isPublished()) {
                    filterArray.push(event);
                }
            }
            eventArray = filterArray;
        }
        
        return eventArray;
    },
    _updateEventsFromXML: function(xmlData) {
        // we optionally allow to pass in data which we use to verify the events
        
        if (this._events === null) {
            // if the events are null we don't need to do something
            return;
        }
        
        if (!this._getEventXML()) {
            return;
        }
        
        var expr = this.EVENTS_XPATH;
        var eventNodes = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(expr, (xmlData)?xmlData:this._getEventXML(), this.ns);
        
        if (!eventNodes) {
            return;
        }
        
        var nodeCount = eventNodes.length;
        
        var eventNode;
        for (var i = 0; i < nodeCount; ++i) {
            var event = new com.ibm.mm.enabler.widget.ModifiableEventImpl(eventNodes[i], this);
            var namePrefix;
            
            if (event.isHandled()) {
                namePrefix = this.HANDLED_NAME_PREFIX;
            }
            else {
                namePrefix = this.PUBLISHED_NAME_PREFIX;
            }
            
            var tempName = namePrefix + event.getName();
            
            if (tempName in this._events) {
                var oldID = this._events[tempName].getID();
                
                this._events[tempName]._setXML(event._getXML());
                
                var newID = this._events[tempName].getID();
                
                if (oldID != newID) {
                    this.idService.attachServerID(oldID, newID);
                }
            }
        }
    },
    _loadEventsFromXML: function() {
        var expr = this.EVENTS_XPATH;
        var eventNodes = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(expr, this._getEventXML(), this.ns);
        
        this._events = {}; // initialize the hashmap
        if (!eventNodes) {
            return;
        }
        
        var nodeCount = eventNodes.length;
        
        var eventNode;
        for (var i = 0; i < nodeCount; ++i) {
            var event = new com.ibm.mm.enabler.widget.ModifiableEventImpl(eventNodes[i], this);
            var namePrefix;
            
            if (event.isHandled()) {
                namePrefix = this.HANDLED_NAME_PREFIX;
            }
            else {
                namePrefix = this.PUBLISHED_NAME_PREFIX;
            }
            
            var tempName = namePrefix + event.getName();
            
            this._events[tempName] = event;
        }
    },
    getEvent: function(name) {
        if (this._events === null) {
            this._loadEventsFromXML();
        }
        
        if (name === null) {
            return null;
        }
        
        
        var tempName = this.HANDLED_NAME_PREFIX + name;
        
        if (tempName in this._events) {
            return this._events[tempName];
        }
        
        tempName = this.PUBLISHED_NAME_PREFIX + name;
        
        if (tempName in this._events) {
            return this._events[tempName];
        }
        
        if (this._defaultEventProvider) {
            return this._defaultEventProvider.getEvent(name);
        }
        
        return null;
    },
    addEvent: function(event) {
        if (!event) {
            return;
        }
        // append the event to the parent's DOM node
        if (!this.confirmAddEvent(event)) {
            return;
        }
        
        // select the EVENTS node
        var expr = this.EVENTS_TOP_XPATH;
        var eventsNode = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, this._getEventXML(), this.ns);
        
        if(!eventsNode) {
            var parentNode = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(this.PARENT_XPATH, this._getEventXML(), this.ns);
            
            // something is not right, so let us just return
            if (!parentNode) {
                return;
            }
            
            eventsNode = com.ibm.mm.enabler.utils.Dom.createElement(this._getEventXML().ownerDocument, this.MODEL_EVENTS, this.ns.model);
            
            parentNode.appendChild(eventsNode);
        }
        
        // make sure the event is attached to the DOM
        eventsNode.appendChild(event._getXML());
        
        if (this._events === null) {
            this._loadEventsFromXML();
        }
        
        // make sure the event is inside of the internal hashmap
        var namePrefix;
        
        if (event.isHandled()) {
            namePrefix = this.HANDLED_NAME_PREFIX;
        }
        else {
            namePrefix = this.PUBLISHED_NAME_PREFIX;
        }
        
        var tempName = namePrefix + event.getName();
        
        this._events[tempName] = event;
        
        this._eventProviderIsDirty = true;
        this._setDirty();
    },
    removeEvent: function(event) {
        if (!event) {
            return;
        }
        
        if (!this.confirmRemoveEvent(event)) {
            return;
        }
        
        // select the EVENTS node
        var expr = this.EVENTS_TOP_XPATH;
        var eventsNode = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, this._getEventXML(), this.ns);
        
        if (!eventsNode) {
            return;
        }
        
        eventsNode.removeChild(event._getXML());
        
        // make sure the hashmap is cleaned up
        if (this._events !== null) {
            var namePrefix;
            
            if (event.isHandled()) {
                namePrefix = this.HANDLED_NAME_PREFIX;
            }
            else {
                namePrefix = this.PUBLISHED_NAME_PREFIX;
            }
            
            var tempName = namePrefix + event.getName();
            
            if (tempName in this._events) {
                delete this._events[tempName];
            }
        }
        
        this._eventProviderIsDirty = true;
        this._setDirty();
    },
    confirmAddEvent: function(event) {
        return true;
    },
    confirmRemoveEvent: function(event) {
        return true;
    },
    _getHierarchicalEventProvider: function() {
        if (!this.hierarchicalEvents) {
            this.hierarchicalEvents = new com.ibm.mm.enabler.widget.HierarchicalEventProviderImpl(this);
        }
        
        return this.hierarchicalEvents;
    },
    _getParentHierarchicalEventProvider: function() {
        var parentObject = this.model._getParent(this);
        
        if (parentObject && parentObject._getParentHierarchicalEventProvider) {
            return parentObject._getHierarchicalEventProvider();
        }
        else {
            return null;
        }
    },
    _getEventXML: function() {
        return this.xmlData;
    },
    /**
     * This method tests whether this eventprovider has dirty events.
     */
    _isEventProviderDirty: function() {
        if (this._eventProviderIsDirty) {
            return true;
        }
        
        if (this._events === null) {
            return false;
        }
        
        for (var eventName in this._events) {
            if (Object.prototype.hasOwnProperty.call(this._events, eventName)) {
            
                var event = this._events[eventName];
                
                if (event._isDirty()) {
                    return true;
                }
            }
        }
        
        return false;
    },
    /**
     * resets the internal eventprovider
     */
    _setEventProviderClean: function() {
        this._eventProviderIsDirty = false;
        
        if (this._events === null) {
            return;
        }
        
        for (var eventName in this._events) {
            if (Object.prototype.hasOwnProperty.call(this._events, eventName)) {
            
                var event = this._events[eventName];
                
                event._setClean();
            }
        }
    },
    
    _isEmpty: function(obj) {
        return obj === null || typeof obj == 'undefined';
    },
    
    getEventByID: function(id) {
        if (this._events === null) {
            this._loadEventsFromXML();
        }
        
        if (id === null) {
            return null;
        }
        var events = this.getEvents(null);
        
        if (events && events !== null) {
        
            for (var i = 0, l = events.length; i < l; i++) {
                if (events[i].getID() === id) {
                    return events[i];
                }
            }
        }
        return null;
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.widget.utils"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.widget.utils"] = true;
dojo.provide("com.ibm.mm.enabler.widget.utils");






/**
 * This is a helper class for &quot;Child nodes&quot; that utilizes parent methods.
 */
dojo.declare("com.ibm.mm.enabler.widget.ChildNodeImpl", null, {
    /**
     * @return {String} the ID of the parent node or <tt>null</tt> if there is no parent link.
     */
    _getParentID: function() {
        var linkNode = this._getParentLink();
        
        var retVal = null;
        
        if (linkNode) {
            retVal = com.ibm.mm.enabler.utils.Utils.getIdFromExtUri(this.prefix, linkNode);
        }
        
        return retVal;
    },
    _setParent: function(node, parentNode, urlType) {
        if (parentNode !== null) {
            var modelUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(urlType, this);
            modelUrl.setNodes([{
                value: parentNode.getID(),
                isID: true
            }]);
            var thr = com.ibm.mashups.enabler.xml.XPath.evaluateEntry("thr:in-reply-to", node.xmlData, this.ns);
            if (!thr) {
                thr = com.ibm.mm.enabler.utils.Utils.createNode("thr:in-reply-to", this.ns.thr);
                node.xmlData.appendChild(thr);
            }
            com.ibm.mm.enabler.utils.Dom.setAttributeWithNS(node.xmlData.ownerDocument, thr, "ext:uri", "uri", this.ns.ext, modelUrl.getModelURI());
            thr.setAttribute("ref", modelUrl.getModelURI());
            thr.setAttribute("href", modelUrl.getAbsoluteURL());
        }
    },
    /**
     * @return {String} the URL to the parent node or <tt>null</tt> if there is no parent link.
     */
    _getParentHref: function() {
        
        var linkNode = this._getParentLink();
        
        var retVal = null;
        
        if (linkNode) {
            retVal = linkNode.getAttribute("href");
        }
        
        return retVal;
    },
    /**
     * Returns the XML that contains the parent link. Might be overloaded by implementors of this class if they
     * consist of multiple xml data objects.
     */
    _getRelationXML: function() {
        return this.xmlData;
    },
    _getParentLink: function() {
        var relationXML = this._getRelationXML();
        
        return com.ibm.mm.enabler.widget.utils.getParentLink(relationXML, this.ns);
    }
});

/**
 * 
 * @param {XMLDOMNode} entryNode the entryNode on which to perform the lookup
 * @param {Hashmap} ns the namespaces to use
 */
com.ibm.mm.enabler.widget.utils.getParentLink = function (entryNode, ns) {
        var expr = "thr:in-reply-to";
        var node = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, entryNode, ns);
        return node || null;
};

}

if(!dojo._hasResource["com.ibm.mm.enabler.widget.WidgetWindowImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.widget.WidgetWindowImpl"] = true;
dojo.provide("com.ibm.mm.enabler.widget.WidgetWindowImpl");

// own api


// own impl deps




// 3rd party impl deps







/**
 * Class for Widget Window
 *
 * @since 2.4
 *
 */
dojo.declare("com.ibm.mm.enabler.widget.WidgetWindowImpl", [com.ibm.mashups.enabler.widget.WidgetWindow,
                                                            com.ibm.mm.enabler.persistence.xml.IdentifiableXmlImpl, 
                                                            com.ibm.mm.enabler.widget.PreferencesProviderImpl,
                                                            com.ibm.mm.enabler.widget.ChildNodeImpl,
                                                            com.ibm.mm.enabler.widget.ModifiableEventProviderImpl], {
    constructor: function(windowNode, persEntityNode, model){
        this.xmlData = windowNode;
        
        if (persEntityNode) {
            this.entity = new com.ibm.mm.enabler.IdentifierImpl(persEntityNode);
        }
        
        this.model = model;
        
        this.cs = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
        
        // service document and initialization
        this.serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_WIDGET);
        this.prefix = this.serviceJson.idprefix;
        var nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
        this.ns = dojo.delegate(this.serviceJson.namespaces,nsf.getNameSpaces([nsf.NS_ATOM, nsf.NS_THR, nsf.NS_XSI]));
    },
    _setXMLData: function (xmlData, entityXmlData) {
        this.xmlData = xmlData;
        
        this.entity.xmlData = entityXmlData;
        this._setClean();
    },
    _getPreferencesXML: function() {
        if (this.entity) {
            return this.entity.xmlData;
        }
    },
    _getRawEntityID: function() {
        if (this.entity) {
            return this.entity._getRawID();
        }
        
        return null;
    },
    _setRawEntityID: function(entityID) {
        if (this.entity) {
            this.entity._setRawID(entityID);
        }
    },
    _setEntityParent: function(parent, urlType) {
        this._setParent(this.entity, parent, urlType);
    },
    _getRelationXML: function() {
        if (this.entity) {
            return this.entity.xmlData;
        }
        
        return this.xmlData;
    },
    _getEventXML: function() {
        if (this.entity) {
            return this.entity.xmlData;
        }
        
        return this.xmlData;
    },
    _isDirty: function() {
        // as delegates are the only changeable things at the moment, delegate
        return this.getPreferences()._isDirty() || this._isEventProviderDirty();
    },
    /**
     * This method sets all modifiable resources of this instace to dirty = false. It should be called after comitting
     * this resource to the backend.
     */
    _setClean: function() {
        this._dirty = false;
        
        this.getPreferences()._setClean();
        this._setEventProviderClean();
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.widget.WidgetInstanceImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.widget.WidgetInstanceImpl"] = true;
dojo.provide("com.ibm.mm.enabler.widget.WidgetInstanceImpl");

// own api


// own impl deps




// 3rd party impl deps






/**
 * Class for Widget Instance
 *
 * @since 2.4
 *
 */
dojo.declare("com.ibm.mm.enabler.widget.WidgetInstanceImpl", [com.ibm.mashups.enabler.widget.WidgetInstance, com.ibm.mm.enabler.persistence.xml.IdentifiableXmlImpl, com.ibm.mm.enabler.MetaDataImpl2, com.ibm.mm.enabler.persistence.xml.EditLinkProviderXmlImpl, com.ibm.mm.enabler.widget.PreferencesProviderImpl, com.ibm.mm.enabler.widget.ChildNodeImpl, com.ibm.mm.enabler.widget.ModifiableEventProviderImpl], {
    constructor: function(node, model) {
        this.xmlData = node;
        
        this.model = model;
        
        this.cs = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
        
        // service document and initialization
        this.serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_WIDGET);
        this.prefix = this.serviceJson.idprefix;
        var nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
        this.ns = dojo.delegate(this.serviceJson.namespaces, nsf.getNameSpaces([nsf.NS_ATOM, nsf.NS_THR, nsf.NS_XSI]));
    },
    _setXMLData: function(xmlData) {
        this.xmlData = xmlData;
        this._setClean();
    },
    _getPreferencesXML: function() {
        return this.xmlData;
    },
    _isDirty: function() {
        // as delegates are the only changeable things at the moment, delegate
        return this.getPreferences()._isDirty() || this._isEventProviderDirty();
    },
    /**
     * This method sets all modifiable resources of this instace to dirty = false. It should be called after comitting
     * this resource to the backend.
     */
    _setClean: function() {
        this._dirty = false;
        
        this.getPreferences()._setClean();
        this._setEventProviderClean();
    },
    
    setSandboxed: function(enable) {
        var expr = "atom:content/model:portlet-entity";
        var nodes = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, this.xmlData, this.ns);
        if (nodes) {
        	com.ibm.mm.enabler.utils.Dom.setAttributeWithNS(this.xmlData.ownerDocument, nodes, "model:sandboxed", "sandboxed", this.ns.model, enable ? "true" : "false");
        	this.getPreferences()._setDirty();
        }
    },
    
    isSandboxed: function() {
        var expr = "atom:content/model:portlet-entity";
        var nodes = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, this.xmlData, this.ns);
        if (nodes) {
            var sandboxed = com.ibm.mm.enabler.utils.Dom.getAttributeWithNS(nodes, "model:sandboxed", "sandboxed", this.ns.model);
            if (typeof(sandboxed) !== "undefined" && "true" === sandboxed) {
                return true;
            }
        }
        return false;
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.widget.SimpleEventProviderImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.widget.SimpleEventProviderImpl"] = true;
dojo.provide("com.ibm.mm.enabler.widget.SimpleEventProviderImpl");








dojo.declare("com.ibm.mm.enabler.widget.SimpleEventProviderImpl", com.ibm.mashups.enabler.widget.EventProvider, {
    constructor: function(entryNode) {
        
        this.cs = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
        
        // service document and initialization
        this.serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_WIDGET);
        this.prefix = this.serviceJson.idprefix;
        var nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
        this.ns = dojo.delegate(this.serviceJson.namespaces,nsf.getNameSpaces([nsf.NS_ATOM, nsf.NS_THR]));
        
        // internal events hashmap, is identified by name
        this._events = null;
        
        this.EVENTS_XPATH = "atom:content/*/model:events/*";
        this.PARENT_XPATH = "atom:content/*";
        
        this.MODEL_PUBLISH_EVENT = "model:publish-event";
        this.MODEL_PROCESS_EVENT = "model:process-event";
        
        this.xmlData = entryNode;
    },
    getEvents: function(filter) {
		var filterAll = true;
		var filterHandled = false;
		var filterPublished = false;
		
		
		if (typeof filter != "undefined" && filter !== null) {
			
			if (filter[com.ibm.mashups.enabler.widget.Constants.FILTER_HANDLED_EVENTS] !== null &&
				filter[com.ibm.mashups.enabler.widget.Constants.FILTER_HANDLED_EVENTS] === true) {
				filterHandled = true;
				filterAll = false;
			}
			if (filter[com.ibm.mashups.enabler.widget.Constants.FILTER_PUBLISHED_EVENTS] !== null &&
			    filter[com.ibm.mashups.enabler.widget.Constants.FILTER_PUBLISHED_EVENTS] === true)  {
				filterPublished = true;
				filterAll = false;
			}
			
			if (filterPublished && filterHandled) {
				filterAll = true;
			}
				
		}		
        if (this._events === null) {
            this._loadEventsFromXML();
        }
        
        var eventArray = [];
        
        for (var eventName in this._events) {
            if (Object.prototype.hasOwnProperty.call(this._events,eventName)) {
                eventArray.push(this._events[eventName]);
            }
        }
        
        // _defaultEventProvider needs to be defined by the consumer.
        var event;
        if (this._defaultEventProvider) {
            var defaultEvents = this._defaultEventProvider.getEvents(filter);
            var defaultEventCount = defaultEvents.length;
            
            for (var i = 0; i < defaultEventCount; ++i) {
                event = defaultEvents[i];
                
                if (event.isHandled()) {
                    namePrefix = this.HANDLED_NAME_PREFIX;
                }
                else {
                    namePrefix = this.PUBLISHED_NAME_PREFIX;
                }
                
                if (!(namePrefix + event.getName() in this._events)) {
                    eventArray.push(event);
                }
            } 
        }
		
		        var filterArray = [];
		if (!filterAll) {
			var eventCount = eventArray.length;
			for (var j=0;j< eventCount; ++j) {
				event = eventArray[j];
				if (filterHandled && event.isHandled() ) {
					filterArray.push(event);					
				} else if (filterPublished && event.isPublished()) {
					filterArray.push(event);
				}
			}
		 	eventArray = filterArray; 
		} 
        
        return eventArray;
    },
    getEvent: function(name) {
        if (this._events === null) {
            this._loadEventsFromXML();
        }

        if (name === null) {
            return null;
        }
        
        var tempName = this.HANDLED_NAME_PREFIX + name;
        
        if (tempName in this._events) {
            return this._events[tempName];
        }
            
        tempName = this.PUBLISHED_NAME_PREFIX + name;
        
        if (tempName in this._events) {
            return this._events[tempName];
        }

        return null;
    },
    _loadEventsFromXML: function() {
        var expr = this.EVENTS_XPATH;
        var eventNodes = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(expr, this._getEventXML(), this.ns);
        
        this._events = {}; // initialize the hashmap
        
        if (!eventNodes) {
            return;
        }
        
        var nodeCount = eventNodes.length;
        
        var eventNode;
        for (var i=0; i< nodeCount; ++i) {
            var event = new com.ibm.mm.enabler.widget.ModifiableEventImpl(eventNodes[i], this);
            var namePrefix;
            
            if (event.isHandled()) {
                namePrefix = this.HANDLED_NAME_PREFIX;
            }
            else {
                namePrefix = this.PUBLISHED_NAME_PREFIX;
            }
                
            var tempName = namePrefix + event.getName();
                
            this._events[tempName] = event;
        }
    },
	getEventByID: function(id) {
        if (this._events === null) {
            this._loadEventsFromXML();
        }
        
        if (id === null) {
            return null;
        }
        var events = this.getEvents(null);

		if (events && events !== null){

			for (var i = 0, l = events.length; i < l; i++) {
				if (events[i].getID() === id) {
					return events[i];
				}
			}
		}	        
        return null;
    },
	
    _getEventXML: function() {
        return this.xmlData;
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.widget.WidgetDefinitionImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.widget.WidgetDefinitionImpl"] = true;
dojo.provide("com.ibm.mm.enabler.widget.WidgetDefinitionImpl");

// own api


// 3rd party api



// own impl deps






// 3rd party impl deps










/**
 * Class for Widget Definition
 *
 * @since 2.4
 *
 */
dojo.declare("com.ibm.mm.enabler.widget.WidgetDefinitionImpl", [com.ibm.mashups.enabler.widget.WidgetDefinition, com.ibm.mashups.enabler.ModifiableLocalized, com.ibm.mm.enabler.persistence.xml.IdentifiableXmlImpl, com.ibm.mm.enabler.persistence.xml.LocalizedXmlImpl, com.ibm.mm.enabler.MetaDataImpl2, com.ibm.mm.enabler.persistence.xml.EditLinkProviderXmlImpl, com.ibm.mm.enabler.widget.PreferencesProviderImpl, com.ibm.mm.enabler.widget.ModifiableEventProviderImpl], {
    constructor: function(definitionNode, portletNode, model) {
        this.xmlData = definitionNode;
        
        // shouldn't be needed anymore, but keep it here for legacy ctor calls
        this.portletXML = portletNode;
        
        this.model = model;
        
        this.cs = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
        
        // service document and initialization
        this.serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_WIDGET);
        this.prefix = this.serviceJson.idprefix;
        var nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
        this.ns = dojo.delegate(this.serviceJson.namespaces, nsf.getNameSpaces([nsf.NS_ATOM, nsf.NS_THR, nsf.NS_XSI]));
        
        this.modes = null;
        
        /*
         <model:supports>
         <model:mime-type>html</model:mime-type>
         <model:portlet-mode>view</model:portlet-mode>
         <model:portlet-mode>edit_defaults</model:portlet-mode>
         </model:supports>
         */
        this.MODEL_NS = this.ns.model;
        this.MODEL_SUPPORTS = "model:supports";
        this.MODEL_MIME_TYPE = "model:mime-type";
        this.MODEL_PORTLET_MODE = "model:portlet-mode";
        
        this.MODEL_PORTLET_DEF = "atom:content/model:portlet-definition";
    },
    
    _getPortletDefinitionNode: function() {
    	return com.ibm.mashups.enabler.xml.XPath.evaluateEntry(this.MODEL_PORTLET_DEF, this.xmlData, this.ns);
    },
    
    getURL: function() {
        var url = null;
        var node = this._getPortletDefinitionNode();
        if (node) {
            url = com.ibm.mm.enabler.utils.Dom.getAttributeWithNS(node, "model:url", "url", this.ns.model);
        }
        return url;
    },
    _setURL: function(url) {
        var node = this._getPortletDefinitionNode();
        if (node) {
            com.ibm.mm.enabler.utils.Dom.setAttributeWithNS(node.ownerDocument, node, "model:url", "url", this.ns.model, url);
        }
    },
    getType: function() {
        var type = null;
        var node = this._getPortletDefinitionNode();
        if (node) {
            type = com.ibm.mm.enabler.utils.Dom.getAttributeWithNS(node, "model:type", "type", this.ns.model);
        }
        return type;
    },
    _setType: function(type) {
        var node = this._getPortletDefinitionNode();
        if (node) {
            com.ibm.mm.enabler.utils.Dom.setAttributeWithNS(node.ownerDocument, node, "model:type", "type", this.ns.model, type);
        }
    },	    
    _setXMLData: function(xmlData, portletXML) {
        this.xmlData = xmlData;
        this.portletXML = portletXML;
        this._setClean();
    },
    _getPreferencesXML: function() {
        return this.xmlData;
    },
    _isDirty: function() {
        // as delegates are the only changeable things at the moment, delegate
        return this.getPreferences()._isDirty() || this._isEventProviderDirty();
    },
    /**
     * This method sets all modifiable resources of this instace to dirty = false. It should be called after comitting
     * this resource to the backend.
     */
    _setClean: function() {
        this._dirty = false;
        
        this.getPreferences()._setClean();
        this._setEventProviderClean();
    },
    _createModeMap: function() {
        this.portlet2WidgetModesMap = {
            view: "view",
            edit_defaults: "edit",
            edit: "personalize",
            config: "config",
            help: "help"
        };
        
        this.widget2PortletModesMap = {
            view: "view",
            edit: "edit_defaults",
            personalize: "edit",
            config: "config",
            help: "help"
        };
        
    },
    getSupportedModes: function() {
        if (!this.portlet2WidgetModesMap) {
            this._createModeMap();
        }
        
        var expr = "atom:content/model:portlet-definition/model:supports[model:mime-type='html']/model:portlet-mode";
        var nodes = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(expr, this.xmlData, this.ns);
        
        return dojo.map(nodes || [], function(node) {
            var portletMode = com.ibm.mm.enabler.utils.Dom.textContent(node);
            if (portletMode in this.portlet2WidgetModesMap) {
                return this.portlet2WidgetModesMap[portletMode];
            }
            return portletMode;
        },this);
    },
    /**
     * sets the supported modes of this definition.
     * @param {String[}} modes an array of mode strings
     */
    _setSupportedModes: function(modes) {
        if (!this.widget2PortletModesMap) {
            this._createModeMap();
        }
        
        // find the owner Document
        var xmlDom = this.xmlData.ownerDocument;
        
        // first we need to see if we have the according node available
        var expr = "atom:content/model:portlet-definition/model:supports[model:mime-type='html']";
        var supportsElement = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, this.xmlData, this.ns);
        
        if (supportsElement) {
            // first delete all the modes (if there are any at all)
            // TODO can't we iterate without an XPath here?
            var childNodes = com.ibm.mashups.enabler.xml.XPath.evaluateXPath("*", supportsElement, this.ns);
            dojo.forEach(childNodes, dojo.destroy);
        } else {
            // create the node
            var parentNode = this._getPortletDefinitionNode();
            
            // something is not right, so let us just return
            if (!parentNode) {
                return; // whoa something went wrong here
            }
            
            supportsElement = com.ibm.mm.enabler.utils.Dom.createElement(xmlDom, this.MODEL_SUPPORTS, this.MODEL_NS);
            parentNode.appendChild(supportsElement);
        }
        
        if (!supportsElement) {
            return;
        }
        
        var mimeElement = com.ibm.mm.enabler.utils.Dom.createElement(xmlDom, this.MODEL_MIME_TYPE, this.MODEL_NS);
        com.ibm.mm.enabler.utils.Dom.textContent(mimeElement, "html");
        supportsElement.appendChild(mimeElement);
        
        // skip if modes is not an array
        if (!dojo.isArray(modes)) {
            return;
        }
        
        dojo.forEach(modes,function(widgetMode){
            var portletMode = widgetMode;
            
            if (widgetMode in this.widget2PortletModesMap) {
                portletMode = this.widget2PortletModesMap[widgetMode];
            }
            
            var modeElement = com.ibm.mm.enabler.utils.Dom.createElement(xmlDom, this.MODEL_PORTLET_MODE, this.MODEL_NS);
            com.ibm.mm.enabler.utils.Dom.textContent(modeElement, portletMode);
            
            supportsElement.appendChild(modeElement);
        },this);
    },     
    _setSandboxed: function(enable) {
         var expr = "atom:content/model:portlet-definition";
         var nodes = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, this.xmlData, this.ns);
         if (nodes) {
        	 com.ibm.mm.enabler.utils.Dom.setAttributeWithNS(this.xmlData.ownerDocument, nodes, "model:sandboxed", "sandboxed", this.ns.model, enable ? "true" : "false");
        	 this.getPreferences()._setDirty();
         }
     },     
     _isSandboxed: function() {
         var expr = "atom:content/model:portlet-definition";
         var nodes = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, this.xmlData, this.ns);
         if (nodes) {
             var sandboxed = com.ibm.mm.enabler.utils.Dom.getAttributeWithNS(nodes, "model:sandboxed", "sandboxed", this.ns.model);
             if (typeof(sandboxed) !== "undefined" && "true" === sandboxed) {
                 return true;
             }
         }
         return false;
     }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.model.SemaphoreHelperImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.model.SemaphoreHelperImpl"] = true;
dojo.provide("com.ibm.mm.enabler.model.SemaphoreHelperImpl");

dojo.declare("com.ibm.mm.enabler.model.SemaphoreHelperImpl", null, {

    _initSemaphore: function() {
        this.requestCount = 0;
    },
    
    // acquire semaphore
    _acquire: function() {
        this.requestCount++;
    },
    
    // release semaphore
    _release: function(deferred, statusCode) {
        // set overall status Code
        this.statusCode = Math.max(parseInt(statusCode, 10), this.statusCode);
        // check for full release
        this.requestCount--;
        if (this.requestCount <= 0) {
            if (deferred) {
                deferred.finish(null, this.statusCode);
            }
        }
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.widget.attributes.WidgetModelPersistentAttributesImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.widget.attributes.WidgetModelPersistentAttributesImpl"] = true;
dojo.provide("com.ibm.mm.enabler.widget.attributes.WidgetModelPersistentAttributesImpl");


















dojo.declare("com.ibm.mm.enabler.widget.attributes.WidgetModelPersistentAttributesImpl", com.ibm.mashups.iwidget.itemset.ManagedItemSet, {
    constructor: function(widgetWrapper){
        this.widgetWrapper = widgetWrapper;
        
        this.widgetModel = com.ibm.mashups.enabler.widget.Factory.getWidgetModel();
        
        //get the page ID
        this.pageID = com.ibm.mm.enabler.utils.Model.getCurrentPageID();
        
        this.modelID = com.ibm.mm.iwidget.Utils.getModelID(widgetWrapper.getID());
        
        // get the widget window for the control
        this.widgetWindow = this.widgetModel.findWidgetWindow(this.modelID, this.pageID).start();
        this.widgetInstance = this.widgetModel.getWidgetInstance(this.widgetWindow).start();
        this.widgetDefinition = this.widgetModel.getWidgetDefinitionByInstance(this.widgetInstance).start();
        
        this.preferences = this._getPreferences();
        this._initItems();
        
        this.listeners = new dojox.collections.ArrayList();
        
        this.uuid = dojox.uuid.generateRandomUuid();
        
        this.autoCommit = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME).getValue(com.ibm.mashups.enabler.services.ConfigConstants.ICONTEXT_AUTO_COMMIT);
        
        // make the subscriptions
        dojo.subscribe(com.ibm.mashups.enabler.widget.ModifiablePreferences.TOPIC_PREFERENCES_SET, this, "_preferencesSetCallback");
        dojo.subscribe(com.ibm.mashups.enabler.widget.ModifiablePreferences.TOPIC_PREFERENCES_REMOVE, this, "_preferencesRemoveCallback");
    },
    _initItems: function(){
        this._items = {};
        // copy the prefs into internal hashmap
        var map = this.preferences.getMap();
        for (var name in map) {
            this._items[name] = {
                value: map[name],
                change: null
            };
        }
    },
    setItemValue: function(itemName, value){
        if (!this.preferences.confirmSetValue(itemName, value)) {
            return null;
        }
        
        if (itemName in this._items) {
            var itemEntry = this._items[itemName];
            itemEntry.value = value;
            itemEntry.change = com.ibm.mm.enabler.widget.attributes.WidgetModelPersistentAttributesImpl.CHANGE_CHANGEDVALUE;
        }
        else {
            this._items[itemName] = {
                "value": value,
                "change": com.ibm.mm.enabler.widget.attributes.WidgetModelPersistentAttributesImpl.CHANGE_NEWITEM
            };
        }
        
        return this;
    },
    getItemValue: function(itemName){
        if (!(itemName in this._items)) {
            return null;
        }
        
        var itemEntry = this._items[itemName];
        
        if (itemEntry.change == com.ibm.mm.enabler.widget.attributes.WidgetModelPersistentAttributesImpl.CHANGE_REMOVEDITEM) {
            return null;
        }
        
        return itemEntry.value;
    },
    getAllNames: function(){
        var itemNames = [];
        
        for (var itemName in this._items) {
            if (Object.prototype.hasOwnProperty.call(this._items, itemName)) {
                var itemEntry = this._items[itemName];
                
                if (itemEntry.change !== com.ibm.mm.enabler.widget.attributes.WidgetModelPersistentAttributesImpl.CHANGE_REMOVEDITEM) {
                    itemNames.push(itemName);
                }
            }
        }
        
        if (itemNames.length === 0) {
            return null;
        }
        
        return itemNames;
    },
    removeItem: function(itemName){
        if (!(itemName in this._items)) {
            return null;
        }
        
        var change = this._items[itemName].change;
        
        // if it is a new item or an overload of an item in another layer (change + !confirmed) delete it from the map
        if (change == com.ibm.mm.enabler.widget.attributes.WidgetModelPersistentAttributesImpl.CHANGE_NEWITEM ||
        (change == com.ibm.mm.enabler.widget.attributes.WidgetModelPersistentAttributesImpl.CHANGE_CHANGEDVALUE && !this.preferences.confirmRemove(itemName))) {
            delete this._items[itemName];
            return this;
        }
        
        // otherwise it must be on this layer
        if (!this.preferences.confirmRemove(itemName)) {
            return null;
        }
        
        this._items[itemName].change = com.ibm.mm.enabler.widget.attributes.WidgetModelPersistentAttributesImpl.CHANGE_REMOVEDITEM;
        this._items[itemName].value = null;
        
        return this;
    },
    isReadOnly: function(itemName){
        return this.preferences.isReadOnly(itemName);
    },
    save: function(callbackfn){
        return this.commit(callbackfn);
    },
    commit: function(callbackfn){
        var success = true;
        var myContext = {
            source: this,
            type: "iContext"
        };
        
        var itemSetChangedEntries = [];
        
        for (var itemName in this._items) {
            if (Object.prototype.hasOwnProperty.call(this._items, itemName)) {
                var change = this._items[itemName].change;
                
                if (change === null) {
                    continue;
                }
                
                var oldValue = this.preferences.getValue(itemName);
                var value = this._items[itemName].value;
                
                if (change == com.ibm.mm.enabler.widget.attributes.WidgetModelPersistentAttributesImpl.CHANGE_NEWITEM ||
                change == com.ibm.mm.enabler.widget.attributes.WidgetModelPersistentAttributesImpl.CHANGE_CHANGEDVALUE) {
                    if (!this.preferences.setValue(itemName, value, false, myContext)) {
                        success = false;
                    }
                }
                else 
                    if (change == com.ibm.mm.enabler.widget.attributes.WidgetModelPersistentAttributesImpl.CHANGE_REMOVEDITEM) {
                        if (!this.preferences.remove(itemName, myContext)) {
                            success = false;
                        }
                    }
                
                itemSetChangedEntries.push({
                    "id": itemName,
                    "alias": null,
                    "changeType": change,
                    "oldVal": oldValue,
                    "newVal": value
                });
            }
        }
        
        var self = this;
        if (this.autoCommit === true) {
            var dfr = this.widgetModel.commit();
            dfr.setFinishedCallback(function(){
                // if we don't have a success we can go out here directly
                if (!success) {
                    if (dojo.isFunction(callbackfn)) {
                        callbackfn("attributes", false);
                    }
                    return;
                }
                
                var iEvent = self._createIEvent([itemSetChangedEntries]);
                self._callListeners(iEvent);
                
                self.preferences = self._getPreferences();
                self._initItems();
                
                if (success) {
                    if (dojo.isFunction(callbackfn)) {
                        callbackfn("attributes", true);
                    }
                }
            });
            dfr.start(false);
        }
        else {
            // if we don't have a success we can go out here directly
            if (!success) {
                if (dojo.isFunction(callbackfn)) {
                    callbackfn("attributes", false);
                }
                return;
            }
            
            var iEvent = this._createIEvent([itemSetChangedEntries]);
            this._callListeners(iEvent);
            
            this.preferences = this._getPreferences();
            this._initItems();
            if (success) {
                if (dojo.isFunction(callbackfn)) {
                    callbackfn("attributes", true);
                }
            }
        }
    },
    addListener: function(/*obj*/fn){
        if (!dojo.isFunction(fn)) {
            return null;
        }
        
        this.listeners.add(fn);
        var index = this.listeners.indexOf(fn);
        
        return this.uuid + "_" + index;
    },
    removeListener: function(/*String*/listenerId){
        if (dojo.isFunction(listenerId)) {
            if (this.listeners.contains(fn)) {
                this.listeners.remove(fn);
            }
        }
        else 
            if (dojo.isString(listenerId)) {
                var parts = listenerId.split(listenerId);
                if (parts.length != 2) {
                    return;
                }
                
                var index = parts[1];
                this.listeners.removeAt(parseInt(index, 10));
            }
        return this._internal().removeListener(listenerId);
    },
    _getPreferences: function(){
        var mode = this.widgetWrapper.currentMode;
        
        if (mode === iwConstants.mode.CONFIG) {
            return this.widgetDefinition.getPreferences();
        }
        
        // definition
        if (mode === iwConstants.mode.EDIT) {
            return this.widgetModel.getHierarchicalPreferences(this.widgetInstance).start();
        }
        
        // instance
        return this.widgetModel.getHierarchicalPreferences(this.widgetWindow).start();
    },
    _preferencesSetCallback: function(preferencesObj, prefName, oldValue, newValue, context){
        if (preferencesObj !== this.preferences) {
            return;
        }
        
        var type = null;
        
        if (context.source === this) {
            return;
        }
        
        if (context.type == "iContext") {
            if (this._items[prefName] && this._items[prefName].change === null) {
                this._items[prefName].value = newValue;
            }
            else {
                this._items[prefName] = {
                    value: newValue,
                    change: null
                };
            }
        }
        
        var cType = com.ibm.mm.enabler.widget.attributes.WidgetModelPersistentAttributesImpl.CHANGE_CHANGEDVALUE;
        
        if (oldValue === null) {
            cType = com.ibm.mm.enabler.widget.attributes.WidgetModelPersistentAttributesImpl.CHANGE_NEWITEM;
        }
        
        var itemSetChangedEntry = {
            id: prefName,
            alias: null,
            changeType: cType,
            oldVal: oldValue,
            newVal: newValue
        };
        var iEvent = this._createIEvent([itemSetChangedEntry]);
        this._callListeners(iEvent);
    },
    _preferencesRemoveCallback: function(preferencesObj, prefName, oldValue, newValue, context){
        if (preferencesObj !== this.preferences) {
            return;
        }
        
        var type = null;
        
        if (context.source === this) {
            return;
        }
        
        if (context.type == "iContext") {
            if (this._items[prefName] && this._items[prefName].change === null) {
                delete this._items[prefName];
            }
        }
        
        if (context && context.type == "iContext") {
            return;
        }
        
        var cType = com.ibm.mm.enabler.widget.attributes.WidgetModelPersistentAttributesImpl.CHANGE_REMOVEDITEM;
        
        var itemSetChangedEntry = {
            itemName: prefName,
            alias: null,
            changeType: cType,
            oldVal: oldValue,
            newVal: newValue
        };
        var iEvent = this._createIEvent([itemSetChangedEntry]);
        this._callListeners(iEvent);
    },
    _createIEvent: function(entries){
        var itemSetChangedEvent = {
            name: "onItemSetChanged",
            type: null,
            source: null,
            payload: {
                itemSetName: "attributes",
                alias: null,
                changes: entries
            }
        };
        
        return itemSetChangedEvent;
    },
    /**
     *
     * @param {Array} entries the itemSetChangedEntries as an array
     */
    _callListeners: function(iEvent){
        var listenerCount = this.listeners.count;
        
        for (var i = 0; i < listenerCount; ++i) {
            var cbFn = this.listeners.item(i);
            
            if (cbFn) {
                cbFn(iEvent);
            }
        }
    }
});

com.ibm.mm.enabler.widget.attributes.WidgetModelPersistentAttributesImpl.CHANGE_NEWITEM = "newItem";
com.ibm.mm.enabler.widget.attributes.WidgetModelPersistentAttributesImpl.CHANGE_REMOVEDITEM = "removedItem";
com.ibm.mm.enabler.widget.attributes.WidgetModelPersistentAttributesImpl.CHANGE_CHANGEDVALUE = "changedValue";

}

if(!dojo._hasResource["com.ibm.mm.enabler.widget.attributes.WidgetModelPersistentAttributesFactoryImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.widget.attributes.WidgetModelPersistentAttributesFactoryImpl"] = true;
dojo.provide("com.ibm.mm.enabler.widget.attributes.WidgetModelPersistentAttributesFactoryImpl");



// inject this factory into the factory service at the end. Therefore we have to require the implementation




dojo.declare("com.ibm.mm.enabler.widget.attributes.WidgetModelPersistentAttributesFactoryImpl", com.ibm.mashups.iwidget.itemset.PersistentAttributesFactory, {
    constructor: function(){
        this.modes = [com.ibm.mashups.enabler.widget.Constants.PERSISTENCE_MODE_MODEL, com.ibm.mashups.enabler.widget.Constants.PERSISTENCE_MODE_MODEL_PREFERENCES];
    },
    createPersistentAttributes: function(widgetWrapper, persistenceMode){
        return new com.ibm.mm.enabler.widget.attributes.WidgetModelPersistentAttributesImpl(widgetWrapper);
    },
    getSupportedPersistenceMode: function(){
        return this.modes;
    }
});


com.ibm.mashups.services.ServiceManager.getService("persistentAttributesFactoryService").setFactory(com.ibm.mashups.enabler.widget.Constants.PERSISTENCE_MODE_MODEL, new com.ibm.mm.enabler.widget.attributes.WidgetModelPersistentAttributesFactoryImpl());

com.ibm.mashups.services.ServiceManager.getService("persistentAttributesFactoryService").setFactory(com.ibm.mashups.enabler.widget.Constants.PERSISTENCE_MODE_MODEL_PREFERENCES, new com.ibm.mm.enabler.widget.attributes.WidgetModelPersistentAttributesFactoryImpl());

}

if(!dojo._hasResource["com.ibm.mm.enabler.widget.icontext.WidgetModelEventsImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.widget.icontext.WidgetModelEventsImpl"] = true;
dojo.provide("com.ibm.mm.enabler.widget.icontext.WidgetModelEventsImpl");

















dojo.declare("com.ibm.mm.enabler.widget.icontext.WidgetModelEventsImpl", com.ibm.mashups.iwidget.model.EventModel, {
    constructor: function(widgetWrapper){
        //one event model is used across different modes of the widgets.
        this.widgetWrapper = widgetWrapper;
        
        this.widgetModel = com.ibm.mashups.enabler.widget.Factory.getWidgetModel();
        
        //get the page ID
        this.pageID = com.ibm.mm.enabler.utils.Model.getCurrentPageID();
        
        this.modelID = com.ibm.mm.iwidget.Utils.getModelID(widgetWrapper.getID());
        
        // get the widget window for the control
        this.widgetWindow = this.widgetModel.findWidgetWindow(this.modelID, this.pageID).start();
        
        if (!this.widgetWindow) {
            throw new Error("WidgetWindow can't be found");
        }
        
        this.widgetInstance = this.widgetModel.getWidgetInstance(this.widgetWindow).start();
        this.widgetDefinition = this.widgetModel.getWidgetDefinitionByInstance(this.widgetInstance).start();
        
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.enabler.widget.icontext.WidgetModelEventsImpl");
        
        this._runtimeIEventModels = {}; // we need to cache iEventDescriptions since there're runtime artifacts
        this._runtimeIEventModels[iwConstants.mode.CONFIG] = {};//eventName--iEventDescription Object
        this._runtimeIEventModels[iwConstants.mode.EDIT] = {};
        this._runtimeIEventModels[iwConstants.mode.VIEW] = {};
        
        this.autoCommit = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME).getValue(com.ibm.mashups.enabler.services.ConfigConstants.ICONTEXT_AUTO_COMMIT);
        
        //need this since model doesn't return complete event description all the time, might be fixed later, then we can remove this
        this._initRuntimeModel();
        
    },
    _initRuntimeModel: function(){
        var events = this.widgetWrapper.widgetDef._getPublicEvents();
        if (events) {
            com.ibm.mm.enabler.utils.Misc.forIn(events, function(evt, i){
                this._runtimeIEventModels[iwConstants.mode.CONFIG][i] = evt;
            }, this);
        }
    },
    _getHierarchicalRuntimeModel: function(mode){
        if (mode && mode == iwConstants.mode.CONFIG) {
            return this._runtimeIEventModels[iwConstants.mode.CONFIG];
        }
        var mixedRuntimeModel = {};
        
        if (mode && mode == iwConstants.mode.EDIT) {
            return dojo.mixin(mixedRuntimeModel, this._runtimeIEventModels[iwConstants.mode.CONFIG], this._runtimeIEventModels[iwConstants.mode.EDIT]);
        }
        
        var events = dojo.mixin(mixedRuntimeModel, this._runtimeIEventModels[iwConstants.mode.CONFIG], this._runtimeIEventModels[iwConstants.mode.EDIT]);
        return dojo.mixin(events, this._runtimeIEventModels[iwConstants.mode.VIEW]);
    },
    _getEventProvider: function(mode){
        // DISABLED PERS MODE
        
        //return events from widget model
        if (!mode) {
            mode = this._getMode();
        }
        
        if (mode == iwConstants.mode.CONFIG) {
            return this.widgetDefinition;
        }
        
        return this.widgetModel.getHierarchicalEventProvider(this.widgetInstance).start();
    },
    _getRuntimeModel: function(mode){
        //return in memory IEventsModel for specified Mode
        if (!mode) {
            mode = iwConstants.mode.VIEW;
        }
        var model = this._runtimeIEventModels[mode];
        if (typeof model == "undefined") {
            model = null;
        }
        return model;
    },
    _getMode: function(){
        var mode = this.widgetWrapper.currentMode;
        if (mode && mode == iwConstants.mode.CONFIG) {
            return mode;
        }
        return iwConstants.mode.EDIT;
    },
    _getContext: function(mode){
        // DISABLED PERS
        //widgetDefinition/widgetinstance/widgetwindow
        if (!mode) {
            mode = this._getMode();
        }
        if (mode && mode == iwConstants.mode.CONFIG) {
            return this.widgetDefinition;
        }
        return this.widgetInstance;
    },
    _find: function(name){
        if (!name) {
            return null;
        }
        var mode = this._getMode();
        var runtimeModel = this._getHierarchicalRuntimeModel(mode);
        if (runtimeModel === null) {
            return null;
        }
        if (runtimeModel[name] && runtimeModel[name] !== null) {
            return runtimeModel[name];
        }
        return this._findInWidgetModel(name, mode);
    },
    _findInWidgetModel: function(name, mode){
        var restModel = this._getEventProvider(mode);
        var anEvent = restModel.getEvent(name);
        if (!anEvent) {
            return null;
        }
        return anEvent;
    },
    find: function(name){
        var anEvent = this._find(name);
        if (!anEvent) {
            return null;
        }
        return this._toIEventDescription(anEvent);
    },
    eventExists: function(id){
        var myEvent = this.find(id);
        if (!myEvent) {
            return false;
        }
        return true;
    },
    _getEventDescObj: function(eventDesc){
        var obj = eventDesc;
        var declaredClass = eventDesc.declaredClass;
        if (!declaredClass) {
            obj = new com.ibm.mm.iwidget.IEventDescriptionImpl(eventDesc);
        }
        return obj;
    },
    _createEvent: function(eventDescData, isCommitable){
        var eventDesc = this._getEventDescObj(eventDescData);
        var eventExists = this.eventExists(eventDesc.name);
        if (eventExists) {
            return false;
        }
        else {
            var mode = this._getMode();
            var runtimeModel = this._getRuntimeModel(mode);
            eventDesc.setAttribute("isComplete", true);
            runtimeModel[eventDesc.name] = eventDesc;
            //call the api
            var context = this._getContext(mode);
            var handled = ((eventDesc.isHandled == true) || (eventDesc.isHandled == "true")) ? true : false;
            var myEvent = context.createEvent(eventDesc.name, handled);
            myEvent = this._addEvent(myEvent, eventDesc);
            context.addEvent(myEvent);
            if (isCommitable) {
                this._commit();
            }
            return true;
        }
    },
    createEvent: function(eventDesc){
        return this._createEvent(eventDesc, true);
    },
    _addEvent: function(myEvent, eventDesc){
        var payloadType = eventDesc.type;
        if (payloadType) {
            myEvent.setPayloadType(payloadType);
        }
        
        var locales = eventDesc.getLocales();
        for (var i = 0; i < locales.length; i++) {
            var aLocale = locales[i];
            var title = eventDesc.getAttribute("title", aLocale);
            var desc = eventDesc.getAttribute("description", aLocale);
            if (title) {
                myEvent.setTitle(title, aLocale);
            }
            if (desc) {
                myEvent.setDescription(desc, aLocale);
            }
        }
        return myEvent;
        
    },
    removeEvent: function(eventName){
        return this._removeEvent(eventName, true);
    },
    _removeEvent: function(eventName, isCommitable){
        if (!eventName) {
            return false;
        }
        var mode = this._getMode();
        var anEvent = this._findInWidgetModel(eventName, mode);
        if (anEvent === null) {
            return true;
        }
        
        var runtimeModel = this._getRuntimeModel(mode);
        if (typeof runtimeModel[eventName] != "undefined") {
            delete runtimeModel[eventName];
        }
        
        var context = this._getContext(mode);
        context.removeEvent(anEvent);
        if (isCommitable) {
            this._commit();
        }
        return true;
    },
    isUpdateEventRequired: function(eventDescData){
        return true;
    },
    updateEvent: function(eventDescData){
        return this._updateEvent(eventDescData, true);
    },
    _updateEvent: function(eventDescData, isCommitable){
        if (!eventDescData) {
            return false;
        }
        var eventDesc = this._getEventDescObj(eventDescData);
        var mode = this._getMode();
        var anEvent = this._findInWidgetModel(eventDesc.name, mode);
        if (anEvent === null) {
            return false;
        }
        var runtimeModel = this._getRuntimeModel(mode);
        eventDesc.setAttribute("isComplete", true);
        runtimeModel[eventDesc.name] = eventDesc;
        
        this._addEvent(anEvent, eventDesc);
        if (isCommitable) {
            this._commit();
        }
        return true;
    },
    getEvents: function(condition){
        var mode = this._getMode();
        var events = this._getEventProvider(mode).getEvents();
        var temp = this._toIEventDescriptions(events);
        var iEventsArr = this._mergeRuntimeModel(temp, mode);
        if (iEventsArr === null) {
            return null;
        }
        
        if (!condition) {
            return iEventsArr;
        }
        
        //now support all the fun queries
        //var partialEventDescs = getEvents({handlingFn: null, isHandled:true});
        if (dojo.isString(condition)) {
            try {
                condition = dojo.fromJson(condition);
            } 
            catch (e) {
                return null; // invalid condition
            }
        }
        
        var result = [];
        if (typeof condition.isHandled != "undefined" &&
        condition.isHandled &&
        !condition.handlingFn) {
            for (var i = 0, l = iEventsArr.length; i < l; i++) {
                var anIEvent = iEventsArr[i];
                if (!!anIEvent.isHandled) {
                    if (!anIEvent.handlingFn) {
                        result.push(anIEvent);
                    }
                }
            }
            if (result.length === 0) {
                return null;
            }
            return result;
        }
        
        for (var j in iEventsArr) {
            if (Object.prototype.hasOwnProperty.call(iEventsArr, j)) {
                var eventDesc = iEventsArr[j];
                var rc = com.ibm.mashups.enabler.utils.EventModelHelper.checkMatch(eventDesc._getInternalJsonObj(), condition);
                if (rc) {
                    result.push(eventDesc);
                }
            }
        }
        
        if (result.length === 0) {
            return null;
        }
        else {
            return result;
        }
    },
    setEvents: function(eventsArr){
        var finalRc = true;
        for (var i in eventsArr) {
            if (Object.prototype.hasOwnProperty.call(eventsArr, i)) {
                var anEvent = eventsArr[i];
                var temp = this._find(anEvent.name);
                if (temp) {
                    rc = this._updateEvent(anEvent);
                }
                else {
                    rc = this._createEvent(anEvent);
                }
                if (!rc) {
                    finalRc = false;
                }
            }
        }
        this._commit();
        return finalRc;
    },
    removeEvents: function(eventNames){
        var finalRc = true;
        for (var i in eventNames) {
            if (eventNames.hasOwnProperty(i)) {
                var anEvent = eventNames[i];
                rc = this._removeEvent(anEvent);
                if (!rc) {
                    finalRc = false;
                }
            }
        }
        this._commit();
        return finalRc;
    },
    commit: function(){
        //commit all the changes 
        this.widgetModel.commit().start();
    },
    _commit: function(){
        if (this.autoCommit === true) {
            this.commit();
        }
    },
    _toIEventDescriptions: function(eventsArr){
        if (!eventsArr || !dojo.isArray(eventsArr) || eventsArr.length === 0) {
            return null;
        }
        return dojo.map(eventsArr, this._toIEventDescription, this);
    },
    _toIEventDescription: function(anEvent){
        /*{
         id: "",
         name: "",
         type: "",
         lang: "",
         handlingFn: "" | Function,
         isHandled: true | false,
         isPublished: true | false,
         localizedAttributes: [<locale>: {<attName>: <attValue>}, ...],
         attributes: {<attName>: <attValue>, ... }
         }*/
        if (!anEvent.getName) {
            return anEvent;
        }
        if ((anEvent.__json) && (anEvent._isDirty) && (!anEvent._isDirty())) {
            // we have a cached version, so return right away
            return new com.ibm.mm.iwidget.IEventDescriptionImpl(anEvent.__json);
        }
        //console.log("Event: ",anEvent);
        var obj = {
            name: anEvent.getName(),
            isHandled: anEvent.isHandled(),
            isPublished: anEvent.isPublished(),
            type: anEvent.getPayloadType(),
            localizedAttributes: {},
            attributes: {},
            isComplete: false
        };
        
        // PERFORMANCE fix: assuming a description can only exist when there is a title
        com.ibm.mm.enabler.utils.Misc.forIn(anEvent.getTitles(), function(title, locale){
            if (!(locale in obj.localizedAttributes)) {
                obj.localizedAttributes[locale] = {};
            }
            obj.localizedAttributes[locale][iwConstants.event.TITLE] = title;
            
            var description = anEvent.getDescription(locale);
            if (description) {
                obj.localizedAttributes[locale][iwConstants.event.DESCRIPTION] = description;
            }
        }, this);
        
        // cache the json representation
        anEvent.__json = obj;
        return new com.ibm.mm.iwidget.IEventDescriptionImpl(obj);
    },
    _mergeRuntimeModel: function(arr, mode){
        //
        if (!arr) {
            return null;
        }
        if (dojo.isArray(arr) && arr.length === 0) {
            return null;
        }
        var runtimeModel = this._getHierarchicalRuntimeModel(mode);
        
        var isEmpty = com.ibm.mm.enabler.utils.Misc.isEmpty(runtimeModel);
        
        if (isEmpty) {
            return arr;
        }
        
        for (var j = 0; j < arr.length; j++) {
            var anEvent = arr[j];
            var name = anEvent.name;
            if (runtimeModel[name]) {
                arr[j] = runtimeModel[name];
            }
        }
        return arr;
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.widget.icontext.WidgetModelEventsFactoryImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.widget.icontext.WidgetModelEventsFactoryImpl"] = true;
dojo.provide("com.ibm.mm.enabler.widget.icontext.WidgetModelEventsFactoryImpl");

// inject this service into the ServiceManager at the end. Therefore we have to require the implementation





dojo.declare("com.ibm.mm.enabler.widget.icontext.WidgetModelEventsFactoryImpl", com.ibm.mashups.iwidget.model.EventModelFactory, {
    constructor: function(){
        this.modes = [com.ibm.mashups.enabler.widget.Constants.PERSISTENCE_MODE_MODEL];
    },
    createEventModel: function(widgetWrapper, persistenceMode){
        return new com.ibm.mm.enabler.widget.icontext.WidgetModelEventsImpl(widgetWrapper);
    },
    getSupportedPersistenceMode: function(){
        return this.modes;
    }
});


com.ibm.mashups.services.ServiceManager.getService("WidgetEventModelFactoryService").setFactory(com.ibm.mashups.enabler.widget.Constants.PERSISTENCE_MODE_MODEL, new com.ibm.mm.enabler.widget.icontext.WidgetModelEventsFactoryImpl());

}

if(!dojo._hasResource["com.ibm.mm.enabler.wire.icontext.ReadOnlyWireModelImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.wire.icontext.ReadOnlyWireModelImpl"] = true;
dojo.provide("com.ibm.mm.enabler.wire.icontext.ReadOnlyWireModelImpl");





dojo.declare("com.ibm.mm.enabler.wire.icontext.ReadOnlyWireModelImpl", null, {
    constructor: function(widgetInstance){
        this._instance = widgetInstance;
        this.svc = com.ibm.mashups.services.ServiceManager.getService("eventService");
        this.modelID = com.ibm.mm.iwidget.Utils.getModelID(this._instance.id);
        
        // make the subscriptions
        dojo.subscribe(com.ibm.mashups.enabler.wire.WireModel.TOPIC_WIRE_ADDED, this, "_wireAddedCallback");
        dojo.subscribe(com.ibm.mashups.enabler.wire.WireModel.TOPIC_WIRE_REMOVED, this, "_wireRemovedeCallback");
    },
    
    toJson: function(){
        return null;
    },
    isDirty: function(){
        return false;
    },
    setDirty: function(isDirty){
        throw "Cannot call setDirty on on Read Only WireModel";
    },
    registerTargets: function(tw, te, se){
        if (!this._targets) {
            this._targets = {};
        }
        if (!this._targets[tw]) {
            this._targets[tw] = [];
        }
        var wire = {
            tw: tw,
            te: te,
            sw: this._instance.id,
            se: se
        };
        this._targets[tw].push(wire);
    },
    getTargets: function(){
        if (!this._targets) {
            return null;
        }
        return this._targets;
    },
    removeTargets: function(tw, te, se){
        if (this._targets) {
            if (this._targets[tw]) {
                if (!te && !se) {
                    delete (this._targets[tw]);
                }
                //todo,very rare case te,se will be available
            }
        }
    },
	
    getEventName: function(tempEvents, eventID) {
        if (tempEvents && tempEvents !== null){
            
          for (var i = 0, l = tempEvents.length; i < l; i++) {
             if (tempEvents[i].getID() == eventID.getID()) {
                return tempEvents[i].getName();

             }
          }	
      }
     return null;
    },

    
    _addWire: function(wire, loadFromDom){
        var wire2 = this._findWire(wire.getID()) || null;
        if (wire2 === null) {
            if (!this._wires) {
                this._wires = [];
            }
            loadFromDom = loadFromDom || false;
            if (!loadFromDom) {
                wire.setType(wire.TYPE_NEW);
            }
            this._wires.push(wire);
            
            var index;
            var source = wire.SourceEvent;
            if (source) {
                //index = source.indexOf("}");
                //if (index > 0) {
                //    source = source.substring(index + 1);
                //}
                
                index = source.indexOf("publish.");
                if (index === 0) {
                    source = source.substring(8);
                }
            }
            
            var target = wire.TargetEvent;
            if (target) {
                //index = target.indexOf("}");
                //if (index > 0) {
                //    target = target.substring(index + 1);
                //}
				
				index = target.indexOf("process.");
                if (index === 0) {
                    target = target.substring(8);
                }
            }
            
            this.svc.subscribeWire(wire.SourceWidget, source, this._instance.id, target);
        }
    },
    
    _removeWire: function(id){
        var wire = this._findWire(id) || null;
        if (wire !== null) {
            // unsubscribe wire
            for (var i in this._wires) {
                if (Object.prototype.hasOwnProperty.call(this._wires, i)) {
                    if (this._wires[i].getID() == id) {
                        // remove wire from wire array
                        this._wires[i].setType(this._wires[i].TYPE_DELETE);
                        
                        var index;
                        var source = wire.SourceEvent;
                        if (source) {
                            //index = source.indexOf("}");
                            //if (index > 0) {
                            //    source = source.substring(index + 1);
                            //}
                            
                            index = source.indexOf("publish.");
                            if (index === 0) {
                                source = source.substring(8);
                            }
                        }
                        
                        var target = wire.TargetEvent;
                        if (target) {
                            //index = target.indexOf("}");
                            //if (index > 0) {
                            //    target = target.substring(index + 1);
                            //}
                            
                            index = target.indexOf("process.");
                            if (index === 0) {
                                target = target.substring(8);
                            }
                        }
                        
                        this.svc.unSubscribeWire(wire.SourceWidget, source, this._instance.id, target);
                        break;
                    }
                }
            }
        }
    },
    
    addWire: function(sourceWidget, sourceEvent, targetEvent){
        var aWire = {};
        aWire.SourceWidget = sourceWidget;
        aWire.SourceEvent = sourceEvent;
        aWire.TargetEvent = targetEvent;
        var wire = new com.ibm.mm.iwidget.widget.WireImpl(this._instance.id, aWire);
        this._addWire(wire);
    },
    removeWire: function(sourceWidget, sourceEvent, targetEvent){
        var aWire = {};
        sourceWidget = sourceWidget || null;
        sourceEvent = sourceEvent || null;
        targetEvent = targetEvent || null;
        if (sourceWidget !== null && sourceEvent !== null && targetEvent !== null) {
            aWire.SourceWidget = sourceWidget;
            aWire.SourceEvent = sourceEvent;
            aWire.TargetEvent = targetEvent;
            var wireObj = new com.ibm.mm.iwidget.widget.WireImpl(this._instance.id, aWire);
            this._removeWire(wireObj.getID());
        }
        else 
            if (sourceWidget !== null) {
                //delete all the wires that has this widget as source
                for (var w in this._wires) {
                    if (Object.prototype.hasOwnProperty.call(this._wires, w)) {
                        if (this._wires[w].getSourceWidgetID() == sourceWidget) {
                            this._wires[w].setType(this._wires[w].TYPE_DELETE);
                            var wire = this._wires[w];
                            this.svc.unSubscribeWire(sourceWidget, wire.SourceEvent, wire.TargetWidget, wire.TargetEvent);
                        }
                    }
                }
            }
    },
    // find Wire by id
    _findWire: function(id){
        var wire;
        this._wires = this._wires || null;
        if (this._wires !== null) {
            for (var w in this._wires) {
                if (Object.prototype.hasOwnProperty.call(this._wires, w)) {
                    if (this._wires[w].getID() == id) {
                        wire = this._wires[w] || null; //commit the change
                        if ((wire.getType() !== null) && (wire.getType() == wire.TYPE_DELETE)) {
                            delete this._wires[w];
                            wire = null;
                        } else {
                            break;
                        }
                    }
                }
            }
        }
        return wire || null;
    },
    getWires: function(){
        if (!this._wires) {
            this._loadWires();
        }
        var arr = [];
        for (var wire in this._wires) {
            if (Object.prototype.hasOwnProperty.call(this._wires, wire)) {
                var aWire = this._wires[wire];
                if (aWire.getType() != aWire.TYPE_DELETE) {
                    arr.push(aWire);
                }
            }
        }
        //if (arr.length == 0 ) return null;
        return arr;
    },
    _loadWires: function(){
        this._wires = [];
        
        var layoutModel = com.ibm.mm.enabler.utils.Model.getCurrentPageLayoutModel();
        
        var wireModel = layoutModel.getWireModel();
        
        var wiresFromModel = wireModel.findByTargetWidget(this.modelID).start(true);
        
        dojo.forEach(wiresFromModel || [], function(wire){
            var aWire = {};
            aWire.SourceWidget = com.ibm.mm.iwidget.Utils.getMarkupID(wire.getSourceWidget().getID());
            aWire.SourceEvent = wire.getSourceEventName();
            aWire.TargetEvent = wire.getTargetEventName();
            this._addWire(new com.ibm.mm.iwidget.widget.WireImpl(this._instance.id, aWire), true);
        }, this);
    },
    
    commit: function(){
        throw "Cannot call commit on Read Only WireModel";
    },
    
    _addToDOM: function(aWire){
        throw "Cannot call _addToDOM on Read Only WireModel";
    },
    
    _removeFromDOM: function(aWire){
        throw "Cannot call _removeFromDOM on Read Only WireModel";
    },
    
    _wireAddedCallback: function(wireModel, wire){
        if (wire.getTargetWidget().getID() == this.modelID) {
            var sourceWidget = com.ibm.mm.iwidget.Utils.getMarkupID(wire.getSourceWidget().getID());
            
            var sourceId = wire.getSourceWidget().getID();
            var targetId = wire.getTargetWidget().getID();
            var sourceEventID = wire.getSourceEvent();
            var targetEventID = wire.getTargetEvent();
            
            //get the page ID
            var pageID = com.ibm.mm.enabler.utils.Model.getCurrentPageID();
            
            var widgetModel = com.ibm.mashups.enabler.widget.Factory.getWidgetModel();

            var sourceWidgetWindow = widgetModel.findWidgetWindow(sourceId, pageID).start();
            var sourceEventProvider = widgetModel.getHierarchicalEventProvider(sourceWidgetWindow).start();
            var tempEvents = sourceEventProvider.getEvents(null);
            var sourceEventName = this.getEventName(tempEvents, sourceEventID);
            
            var targetWidgetWindow = widgetModel.findWidgetWindow(targetId, pageID).start();
            
            var targetEventProvider = widgetModel.getHierarchicalEventProvider(targetWidgetWindow).start();
            tempEvents = targetEventProvider.getEvents(null);
            var targetEventName =   this.getEventName(tempEvents, targetEventID);

            var sourceEvent = sourceEventName;
            var targetEvent = targetEventName;
            
            this.addWire(sourceWidget, sourceEvent, targetEvent);
        }
        
    },
    
    _wireRemovedeCallback: function(wireModel, wire){
        if (wire.getTargetWidget().getID() == this.modelID) {
            var sourceWidget = com.ibm.mm.iwidget.Utils.getMarkupID(wire.getSourceWidget().getID());

            var sourceId = wire.getSourceWidget().getID();
            var targetId = wire.getTargetWidget().getID();
            var sourceEventID = wire.getSourceEvent();
            var targetEventID = wire.getTargetEvent();
            
            //get the page ID
            var pageID = com.ibm.mm.enabler.utils.Model.getCurrentPageID();
            
            var widgetModel = com.ibm.mashups.enabler.widget.Factory.getWidgetModel();

            var sourceWidgetWindow = widgetModel.findWidgetWindow(sourceId, pageID).start();
            var sourceEventProvider = widgetModel.getHierarchicalEventProvider(sourceWidgetWindow).start();
            var tempEvents = sourceEventProvider.getEvents(null);
            var sourceEventName = this.getEventName(tempEvents, sourceEventID);
            
            var targetWidgetWindow = widgetModel.findWidgetWindow(targetId, pageID).start();
            
            var targetEventProvider = widgetModel.getHierarchicalEventProvider(targetWidgetWindow).start();
            tempEvents = targetEventProvider.getEvents(null);
            var targetEventName =   this.getEventName(tempEvents, targetEventID);

            var sourceEvent = sourceEventName;
            var targetEvent = targetEventName;
            
            this.removeWire(sourceWidget, sourceEvent, targetEvent);
        }
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.wire.icontext.WireModelWireProviderFactoryImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.wire.icontext.WireModelWireProviderFactoryImpl"] = true;
dojo.provide("com.ibm.mm.enabler.wire.icontext.WireModelWireProviderFactoryImpl");

// inject this service into the ServiceManager at the end. Therefore we have to require the implementation






dojo.declare("com.ibm.mm.enabler.wire.icontext.WireModelWireProviderFactoryImpl", com.ibm.mashups.iwidget.widget.WireProviderFactory, {
    constructor: function(){
        this.modes = [com.ibm.mashups.enabler.widget.Constants.PERSISTENCE_MODE_MODEL];
    },
    createWireProvider: function(widgetInstance, persistenceMode){
        return new com.ibm.mm.enabler.wire.icontext.ReadOnlyWireModelImpl(widgetInstance);
    },
    getSupportedPersistenceMode: function(){
        return this.modes;
    }
});


com.ibm.mashups.services.ServiceManager.getService("WireProviderFactoryService").setFactory(com.ibm.mashups.enabler.widget.Constants.PERSISTENCE_MODE_MODEL, new com.ibm.mm.enabler.wire.icontext.WireModelWireProviderFactoryImpl());

}

if(!dojo._hasResource["com.ibm.mm.enabler.widget.WidgetModelImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.widget.WidgetModelImpl"] = true;
dojo.provide("com.ibm.mm.enabler.widget.WidgetModelImpl");

// own api


// 3rd party api









// own impl deps




// 3rd party impl deps




















// iwidget deps


// integration into the iContext




// dojo deps



/*
 * This file provides the WidgetModel
 */



/**
 * Implementation for {@link com.ibm.mashups.enabler.widget.WidgetModel WidgetModel}.
 * @since 2.4
 */
dojo.declare("com.ibm.mm.enabler.widget.WidgetModelImpl", [com.ibm.mashups.enabler.widget.WidgetModel, com.ibm.mm.enabler.strategy.HiddenMetaDataLoadingStrategyHelperImpl, com.ibm.mm.enabler.model.ModelImpl, com.ibm.mm.enabler.model.SemaphoreHelperImpl, com.ibm.mm.enabler.DirtyFlagProviderImpl, com.ibm.mm.enabler.ServiceDocConsumer], {
    constructor: function(){
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass);
        this.LOG_LEVEL = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
        
        var LOG_METHOD = "constructor()";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD);
        }
        
        this.modelMessages = dojo.i18n.getLocalization("com.ibm.mm.enabler", "modelMessages");
        
        this.definitions = {};
        this.instances = {};
        this.controls = new dojox.collections.ArrayList();
        this.windows = {}; // map where layoutcontrol index is the key
        this.cachedWindows = {}; // map of windows where window ID is the key
        this.urlType = com.ibm.mashups.enabler.model.url.ModelUrlFactory.WIDGET_URL;
        this.widgetDefinitionIDByURL = {};
        // get the id service
        this.idService = com.ibm.mashups.enabler.services.IdentificationService;
        
        var handler = function() {
            var LOG_METHOD = "WidgetModel.dirtyHandler()";
            var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
            if (bIsLoggable) {
                this.LOGGER.trace(LOG_METHOD, "Widget Model has been changed. Switching to edit representation.");
            }
            var cs = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.iwidget.services.ContainerService.SERVICE_NAME);
            cs.switchToModifiablePersistenceMode();
            this.removeDirtyCallback(handler);
        };
        this.addDirtyCallback(this, dojo.hitch(this, handler));
        
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD);
        }
    },
    _initServiceDoc: function(){
        this.inherited("_initServiceDoc", arguments);
        // service document and initialization
        var serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_WIDGET);
        var nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
        this.ns = dojo.delegate(serviceJson.namespaces, nsf.getNameSpaces([nsf.NS_ATOM, nsf.NS_XML, nsf.NS_XSI, nsf.NS_THR, nsf.NS_EVENT_DATATYPES]));
        this.DATATYPE_NS = this.ns[nsf.NS_EVENT_DATATYPES];
    },
    _getNS: function(){
        this._initServiceDoc();
        return this.ns;
    },
    // singleton
    getInstance: function(){
        var instance = com.ibm.mm.enabler.widget.WidgetModelImpl._instance;
        return instance ? instance : (com.ibm.mm.enabler.widget.WidgetModelImpl._instance = new com.ibm.mm.enabler.widget.WidgetModelImpl());
    },
    
    _setWidgetModelDirty: function(){
        this._setDirty();
    },
    
    find: function(id){
        return new com.ibm.mm.enabler.DeferredImpl(this, this._find, id);
    },
    findWidgetWindow: function(windowID, pageID){
        return new com.ibm.mm.enabler.DeferredImpl(this, this._findWidgetWindow, {
            "windowID": windowID,
            "pageID": pageID
        });
    },
    getWidgetDefinitionByWindow: function(widWindow){
        return new com.ibm.mm.enabler.DeferredImpl(this, this._getWidgetDefinitionByWindow, widWindow);
    },
    getWidgetDefinitionByInstance: function(instance){
        return new com.ibm.mm.enabler.DeferredImpl(this, this._getWidgetDefinitionByInstance, instance);
    },
    getWidgetWindow: function(control){
        return new com.ibm.mm.enabler.DeferredImpl(this, this._getWidgetWindow, control);
    },
    isWidgetWindowCached: function(id){
        return (id in this.cachedWindows);
    },
    getWidgetInstance: function(widWindow){
        return new com.ibm.mm.enabler.DeferredImpl(this, this._getWidgetInstance, widWindow);
    },
    commit: function(){
        return new com.ibm.mm.enabler.DeferredOperationImpl(this, this._commit);
    },
    isDirty: function(){
        var LOG_METHOD = "isDirty()";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD);
        }
        
        // iterate through all the childs and see whether they are dirty or not.
        // windows
        if (bIsLoggable) {
            this.LOGGER.trace(LOG_METHOD, "Checking for WidgetWindows");
        }
        
        for (var id in this.cachedWindows) {
            if (Object.prototype.hasOwnProperty.call(this.cachedWindows, id)) {
                var widWindow = this.cachedWindows[id];
                if (widWindow._isDirty()) {
                    if (bIsLoggable) {
                        this.LOGGER.trace(LOG_METHOD, "Window ${0} is dirty ...", widWindow.getID());
                    }
                    if (bIsLoggable) {
                        this.LOGGER.exiting(LOG_METHOD, true);
                    }
                    return true;
                }
            }
        }
        
        // instances
        if (bIsLoggable) {
            this.LOGGER.trace(LOG_METHOD, "Checking for WidgetInstances");
        }
        
        for (var instID in this.instances) {
            if (Object.prototype.hasOwnProperty.call(this.instances, instID)) {
                var widInstance = this.instances[instID];
                if (widInstance._isDirty()) {
                    if (bIsLoggable) {
                        this.LOGGER.trace(LOG_METHOD, "Instance ${0} is dirty ...", instID);
                    }
                    if (bIsLoggable) {
                        this.LOGGER.exiting(LOG_METHOD, true);
                    }
                    return true;
                }
            }
        }
        
        // definitions
        if (bIsLoggable) {
            this.LOGGER.trace(LOG_METHOD, "Checking for WidgetDefinitions");
        }
        for (var defID in this.definitions) {
            if (Object.prototype.hasOwnProperty.call(this.definitions, defID)) {
                var widDef = this.definitions[defID];
                if (widDef._isDirty()) {
                    if (bIsLoggable) {
                        this.LOGGER.trace(LOG_METHOD, "Definition ${0} is dirty ...", defID);
                    }
                    if (bIsLoggable) {
                        this.LOGGER.exiting(LOG_METHOD, true);
                    }
                    return true;
                }
            }
        }
        
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD, false);
        }
        
        return false;
    },
    getHierarchicalPreferences: function(prefProvider){
        return new com.ibm.mm.enabler.DeferredImpl(this, this._getHierarchicalPreferences, prefProvider);
    },
    getHierarchicalEventProvider: function(eventProvider){
        return new com.ibm.mm.enabler.DeferredImpl(this, this._getHierarchicalEventProvider, eventProvider);
    },
    _find: function(deferred, sync, id){
        var LOG_METHOD = "_find(deferred, sync, id)";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, [deferred, sync, id]);
        }
        
        if (!id || dojo.isString(id)) {
            if (bIsLoggable) {
                this.LOGGER.trace(LOG_METHOD, "id is null or a string");
            }
            throw new Error(this.modelMessages.E_NODE_ISNULL_0);
        }
        
        var retVal;
        
        var idStr = id.getID();
        
        if (idStr in this.definitions) {
            var definition = this.definitions[idStr];
            
            if (deferred) {
                deferred.finish(definition, com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK);
            }
            retVal = definition;
        }
        else {
            var myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(this.urlType, this);
            myUrl.setNodes([{
                value: idStr,
                isID: true
            }]);
            
            myUrl.setParameter("mode", "download");
            myUrl.setParameter("rep", "full");
            myUrl.setParameter("levels", "-all");
            myUrl.setParameter("events", "single");
            
            // apply hidden meta data strategy
            this._applyHiddenMetaDataLoadingStrategyToModelURL(myUrl);
            
            var serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
            var result = {};
            result.node = null;
            
            serviceReq.read(dojo.hitch(this, function(type, data, xhr, args){
            
                if (type != com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_ERROR) {
                    // store the definition
                    var definition = this._getDefinitionFromFeed(data);
                    
                    if (!definition) {
                        throw new Error(dojo.string.substitute(this.modelMessages.E_WIDGET_NOTFOUND_1, [id]));
                    }
                    
                    retVal = definition;
                    result.node = definition;
                }
                
                if (deferred) {
                    deferred.finish(result.node, xhr.status);
                }
                // handle error in sync call
                if (sync && type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_ERROR) {
                    // do not expose HTTP_NOT_FOUND; simply return null in this case
                    if (xhr.status != com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_NOT_FOUND) {
                        result.status = xhr.status;
                    }
                }
            }));
            
            if (result.status) {
                throw new Error(dojo.string.substitute(this.modelMessages.E_NODE_NOTFOUND_1, [uri, result.status]));
            }
            
        }
        
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD, retVal);
        }
        
        return retVal;
    },
    _findWidgetWindow: function(deferred, sync, idData){
        var LOG_METHOD = "_findWidgetWindow(deferred, sync, idData)";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, [deferred, sync, idData]);
        }
        
        if (!idData || !idData.windowID || !idData.pageID) {
            if (bIsLoggable) {
                this.LOGGER.trace(LOG_METHOD, "id is null or a string");
            }
            throw new Error(this.modelMessages.E_NODE_ISNULL_0);
        }
        
        var ids = [];
        ids[0] = idData.windowID;
        ids[1] = idData.pageID;
        
        var strategyService = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.StrategyService.SERVICE_NAME);
        var widgetWindowLoadAheadStrategy = strategyService.getStrategy("com.ibm.mashups.enabler.widget.WidgetModel", "com.ibm.mashups.enabler.strategy.WidgetWindowLoadAheadStrategy");
        if (widgetWindowLoadAheadStrategy) {
            var skip = false;
            if (this.widgetWindowLoadAheadStrategyOnGoingMarker) {
                if (sync) {
                    skip = true;
                }
                else {
                    setTimeout(dojo.hitch(this, function(){
                        this.__findWidgetWindow(deferred, sync, ids);
                    }), 0);
                    return null;
                }
            }
            if (!skip) {
                try {
                    this.widgetWindowLoadAheadStrategyOnGoingMarker = true;
                    widgetWindowLoadAheadStrategy = widgetWindowLoadAheadStrategy.getWidgetWindowMap();
                    if (ids[0] in widgetWindowLoadAheadStrategy) {
                        var windowArray = [];
                        for (var id in widgetWindowLoadAheadStrategy) {
                            if (!(id in this.cachedWindows)) {
                                windowArray.push(id);
                            }
                        }
                        if (windowArray.length > 0) {
                            this.preLoadWidgetWindows(ids[1], windowArray);
                            strategyService.removeStrategy("com.ibm.mashups.enabler.widget.WidgetModel", "com.ibm.mashups.enabler.strategy.WidgetWindowLoadAheadStrategy");
                        }
                    }
                } 
                catch (e) {
                    console.log(e);
                }
                this.widgetWindowLoadAheadStrategyOnGoingMarker = false;
            }
        }
        return this.__findWidgetWindow(deferred, sync, ids);
    },
    __findWidgetWindow: function(deferred, sync, ids){
        var LOG_METHOD = "__findWidgetWindow(deferred, sync, ids)";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, [deferred, sync, ids]);
        }
        
        if (this.widgetWindowLoadAheadStrategyOnGoingMarker) {
            setTimeout(dojo.hitch(this, function(){
                this.__findWidgetWindow(deferred, sync, ids);
            }), 0);
        }
        var retVal = null;
        
        if (ids[0] in this.cachedWindows) {
            retVal = this.cachedWindows[ids[0]];
            if (deferred) {
                deferred.finish(retVal, com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK);
            }
        }
        else {
            retVal = this._loadFullWindowParentTree(deferred, sync, ids, false);
        }
        
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD, retVal);
        }
        
        return retVal;
    },
    preLoadWidgetWindows: function(pageID, windowArray){
        if (!com.ibm.mashups.enabler.io.XHRMultipartFactory.isMultipartEnabled()) {
            // nothing to do
            return;
        }
        var mpHandler = com.ibm.mashups.enabler.io.XHRMultipartFactory.create();
        mpHandler.startTransaction();
        
        var ids;
        for (var i = 0, l = windowArray.length; i < l; i++) {
            ids = [];
            ids[0] = windowArray[i];
            ids[1] = pageID;
            this._loadFullWindowParentTree(null, false, ids, false);
        }
        mpHandler.endTransactionDeferred().start();
    },
    _getWidgetDefinitionByWindow: function(deferred, sync, widWindow){
        var LOG_METHOD = "_getWidgetDefinitionByWindow(deferred, sync, widWindow)";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, [deferred, sync, widWindow]);
        }
        
        if (!widWindow) {
            throw new Error(this.modelMessages.E_NODE_ISNULL_0);
        }
        
        var retVal;
        
        var instance = this.getWidgetInstance(widWindow).start();
        
        if (instance) {
            var definition = this.getWidgetDefinitionByInstance(instance).start();
            
            if (definition) {
                if (deferred) {
                    deferred.finish(definition, com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK);
                }
                retVal = definition;
            }
        }
        
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD, retVal);
        }
        
        return retVal;
    },
    _getWidgetDefinitionByID: function(deferred, sync, defID){
        var LOG_METHOD = "_getWidgetDefinitionByID(deferred, sync, instance)";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, [deferred, sync, instance]);
        }
        
        if (!defID) {
            throw new Error(this.modelMessages.E_NODE_ISNULL_0);
        }
        
        var retVal = null;
        
        // check if we already have the definition
        if (defID in this.definitions) {
            var definition = this.definitions[defID];
            if (deferred) {
                deferred.finish(definition, com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK);
            }
            retVal = definition;
        }
        else {
            var defHref = instance._getParentHref();
            var myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(defHref, this);
            
            // set the parameters to get the full information.
            myUrl.setParameter("mode", "download");
            myUrl.setParameter("rep", "full");
            myUrl.setParameter("levels", "-all");
            myUrl.setParameter("events", "single");
            
            // apply hidden meta data strategy
            this._applyHiddenMetaDataLoadingStrategyToModelURL(myUrl);
            
            var serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
            var result = {};
            result.node = null;
            
            serviceReq.read(dojo.hitch(this, function(type, data, xhr, args){
                // since we had a full model request
                if (type != com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_ERROR) {
                    // store the definition
                    var definition = this._getDefinitionFromFeed(data);
                    
                    if (!definition) {
                        throw new Error(dojo.string.substitute(this.modelMessages.E_WIDGET_NOTFOUND_1, [instance]));
                    }
                    
                    retVal = definition;
                    result.node = definition;
                }
                
                if (deferred) {
                    deferred.finish(result.node, xhr.status);
                }
                // handle error in sync call
                if (sync && type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_ERROR) {
                    // do not expose HTTP_NOT_FOUND; simply return null in this case
                    if (xhr.status != com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_NOT_FOUND) {
                        result.status = xhr.status;
                    }
                }
            }));
            
            if (result.status) {
                throw new Error(dojo.string.substitute(this.modelMessages.E_NODE_NOTFOUND_1, [uri, result.status]));
            }
        }
        
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD, retVal);
        }
        
        return retVal;
    },
    _getWidgetDefinitionByInstance: function(deferred, sync, instance){
        var LOG_METHOD = "_getWidgetDefinitionByInstance(deferred, sync, instance)";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, [deferred, sync, instance]);
        }
        
        if (!instance) {
            throw new Error(this.modelMessages.E_NODE_ISNULL_0);
        }
        
        var retVal = null;
        var defID;
        
        if (dojo.isString(instance)) {
            defID = instance;
        }
        else {
            defID = instance._getParentID();
            defID = this.idService.resolveID(defID);
        }
        
        // check if we already have the definition
        if (defID in this.definitions) {
            var definition = this.definitions[defID];
            if (deferred) {
                deferred.finish(definition, com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK);
            }
            retVal = definition;
        }
        else {
            var myUrl = null;
            if (dojo.isString(instance)) {
                myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(this.urlType, this);
                myUrl.setNodes([{
                    value: defID,
                    isID: true
                }]);
            }
            else {
                var defHref = instance._getParentHref();
                myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(defHref, this);
            }
            
            // set the parameters to get the full information.
            myUrl.setParameter("mode", "download");
            myUrl.setParameter("rep", "full");
            myUrl.setParameter("levels", "-all");
            myUrl.setParameter("events", "single");
            
            // apply hidden meta data strategy
            this._applyHiddenMetaDataLoadingStrategyToModelURL(myUrl);
            
            var serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
            var result = {};
            result.node = null;
            
            serviceReq.read(dojo.hitch(this, function(type, data, xhr, args){
                // since we had a full model request
                
                if (type != com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_ERROR) {
                    // store the definition
                    var definition = this._getDefinitionFromFeed(data);
                    
                    if (!definition) {
                        throw new Error(dojo.string.substitute(this.modelMessages.E_WIDGET_NOTFOUND_1, [instance]));
                    }
                    
                    retVal = definition;
                    result.node = definition;
                }
                
                if (deferred) {
                    deferred.finish(result.node, xhr.status);
                }
                // handle error in sync call
                if (sync && type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_ERROR) {
                    // do not expose HTTP_NOT_FOUND; simply return null in this case
                    if (xhr.status != com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_NOT_FOUND) {
                        result.status = xhr.status;
                    }
                }
            }));
            
            if (result.status) {
                throw new Error(dojo.string.substitute(this.modelMessages.E_NODE_NOTFOUND_1, [uri, result.status]));
            }
        }
        
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD, retVal);
        }
        
        return retVal;
    },
    _getWidgetWindow: function(deferred, sync, control){
        var LOG_METHOD = "_getWidgetWindow(deferred, sync, control)";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, [deferred, sync, control]);
        }
        
        if (!control) {
            throw new Error(this.modelMessages.E_NODE_ISNULL_0);
        }
        
        var retVal;
        
        var index = this.controls.indexOf(control);
        
        if (index > -1) {
            var window = this.windows[index];
            if (deferred) {
                deferred.finish(window, com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK);
            }
            retVal = window;
        }
        else {
            var uri = control._getWidgetWindowURI();
            var context = null;
            
            if (!uri) {
                // see if we are in preview mode
                context = control._getContext();
                
                if (!context) {
                    throw new Error(this.modelMessages.E_NODE_ISNULL_0);
                }
                
                // neither a definition URL nor an ID are defined, so let's go out here
                if (!context[com.ibm.mashups.enabler.layout.Constants.CONTEXT_WIDGET_DEFINITION_ID] && !context[com.ibm.mashups.enabler.layout.Constants.CONTEXT_WIDGET_DEFINITION_URL]) {
                    throw new Error(this.modelMessages.E_NODE_ISNULL_0);
                }
                
                retVal = this._getWidgetWindowByContext(context, control);
                
                if (deferred) {
                    deferred.finish(retVal, com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK);
                }
            }
            else {
                // right now control is just an String ID
                var ids = this._splitFullWindowID(uri);
                
                // control ID should be <windowid>@<pageid> ...
                if (ids.length != 2) {
                    throw new Error(this.modelMessages.E_NODE_ISNULL_0);
                }
                
                if (ids[0] in this.cachedWindows) {
                    retVal = this.cachedWindows[ids[0]];
                }
                else {
                    retVal = this._loadFullWindowParentTree(deferred, sync, control, false);
                }
                
                if (deferred) {
                    deferred.finish(retVal, com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK);
                }
            }
            
        }
        
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD, retVal);
        }
        
        return retVal;
    },
    _loadFullWindowParentTree: function(deferred, sync, control, idUpdateOnly){
        var LOG_METHOD = "_loadFullWindowParentTree(deferred, sync, control, idUpdateOnly)";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, [deferred, sync, control, idUpdateOnly]);
        }
        
        if (typeof idUpdateOnly == "undefined") {
            idUpdateOnly = false;
        }
        
        var retVal = null;
        var ids;
        if (!dojo.isArray(control)) {
            var uri = control._getWidgetWindowURI();
            
            // right now control is just an String ID
            ids = this._splitFullWindowID(uri);
            
            // control ID should be <windowid>@<pageid> ...
            if (ids.length != 2) {
                throw new Error(this.modelMessages.E_NODE_ISNULL_0);
            }
        }
        else {
            ids = control;
        }
        
        // see if we have already the window loaded node [0] = windowID; [1] = pageID
        var windowID = ids[0];
        var pageID = ids[1];
        
        var myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(this.urlType, this);
        myUrl.setNodes([{
            value: windowID,
            isID: true
        }, {
            value: pageID,
            isID: true
        }]);
        
        myUrl.setParameter("mode", "download");
        myUrl.setParameter("rep", "full");
        myUrl.setParameter("levels", "-all");
        myUrl.setParameter("events", "single");
        
        // apply hidden meta data strategy
        this._applyHiddenMetaDataLoadingStrategyToModelURL(myUrl);
        
        var serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
        var result = {};
        result.node = null;
        
        serviceReq.read(dojo.hitch(this, function(type, data, xhr, args){
            // since we had a full model request
            
            if (type != com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_ERROR) {
                // store the window
                var window = this._getWindowFromFeed(data, control, idUpdateOnly);
                
                if (!window) {
                    throw new Error(dojo.string.substitute(this.modelMessages.E_WIDGET_NOTFOUND_1, [control]));
                }
                
                retVal = window;
                result.node = window;
                
                // finally try to do prefetching
                this._getInstanceFromFeed(data, idUpdateOnly);
                this._getDefinitionFromFeed(data, idUpdateOnly);
            }
            
            if (deferred) {
                deferred.finish(result.node, xhr.status);
            }
            // handle error in sync call
            if (sync && type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_ERROR) {
                // do not expose HTTP_NOT_FOUND; simply return null in this case
                if (xhr.status != com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_NOT_FOUND) {
                    result.status = xhr.status;
                }
            }
        }));
        
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD, retVal);
        }
        
        return retVal;
    },
    _getWidgetInstance: function(deferred, sync, widWindow){
        var LOG_METHOD = "_getWidgetInstance(deferred, sync, widWindow)";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, [deferred, sync, widWindow]);
        }
        
        if (!widWindow) {
            throw new Error(this.modelMessages.E_NODE_ISNULL_0);
        }
        
        var retVal;
        
        var instanceID = widWindow._getParentID();
        // check if we already have the instance
        if (instanceID in this.instances) {
            var instance = this.instances[instanceID];
            if (deferred) {
                deferred.finish(instance, com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK);
            }
            retVal = instance;
        }
        else {
            var instHref = widWindow._getParentHref();
            var myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(instHref, this);
            
            // set the parameters to get the full information.
            myUrl.setParameter("mode", "download");
            myUrl.setParameter("rep", "full");
            myUrl.setParameter("levels", "-all");
            myUrl.setParameter("events", "single");
            
            // apply hidden meta data strategy
            this._applyHiddenMetaDataLoadingStrategyToModelURL(myUrl);
            
            var serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
            var result = {};
            result.node = null;
            
            serviceReq.read(dojo.hitch(this, function(type, data, xhr, args){
                // since we had a full model request
                
                if (type != com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_ERROR) {
                    // store the instance
                    var instance = this._getInstanceFromFeed(data);
                    
                    if (!instance) {
                        throw new Error(dojo.string.substitute(this.modelMessages.E_WIDGET_NOTFOUND_1, [window]));
                    }
                    
                    // do some prefetching
                    this._getDefinitionFromFeed(data);
                    
                    retVal = instance;
                    result.node = instance;
                }
                
                if (deferred) {
                    deferred.finish(result.node, xhr.status);
                }
                // handle error in sync call
                if (sync && type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_ERROR) {
                    // do not expose HTTP_NOT_FOUND; simply return null in this case
                    if (xhr.status != com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_NOT_FOUND) {
                        result.status = xhr.status;
                    }
                }
            }));
            
            if (result.status) {
                throw new Error(dojo.string.substitute(this.modelMessages.E_NODE_NOTFOUND_1, [uri, result.status]));
            }
        }
        
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD, retVal);
        }
        
        return retVal;
    },
    _commit: function(deferred, sync){
        var LOG_METHOD = "_commit(deferred, sync)";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, [deferred, sync]);
        }
        
        // global semaphore handling
        this._initSemaphore();
        this._acquire();
        
        this.statusCode = com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK;
        
        // iterate through all the childs and see whether they are dirty or not.
        if (!this.isDirty()) {
            if (bIsLoggable) {
                this.LOGGER.trace(LOG_METHOD, "Model isn't dirty, exiting");
            }
            
            this._release(deferred, this.statusCode);
            
            if (bIsLoggable) {
                this.LOGGER.exiting(LOG_METHOD);
            }
            return;
        }
        
        // Now we verify that we no client resources any longer. The user of the Enabler API has to call navigationModel.commit first
        // UPDATE: we don't do this anymore, instead we simply skip them in below loops. Reason:
        // In case a widget is added to the page and immediately removed again artifacts are left over in the model. We just skip them now
        var id, widWindow, instID, widInstance, defID, widDef;
        
        if (bIsLoggable) {
            this.LOGGER.trace(LOG_METHOD, "Checking for WidgetWindows to commit");
        }
        
        var mpHandler = com.ibm.mashups.enabler.io.XHRMultipartFactory.create();
        mpHandler.startTransaction();
        /* handled by Semaphore       // initialize callback handling
         this.statusCode = com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK;
         this.requestCount = 0; */
        for (id in this.cachedWindows) {
            if (Object.prototype.hasOwnProperty.call(this.cachedWindows, id)) {
                widWindow = this.cachedWindows[id];
                if ((widWindow._isDirty()) && (!this.idService.isClientID(widWindow.getID()))) {
                    // we are not commiting client ids, they have to be committed through the layout model first and then made known
                    // to the widget model. However in case a widget is added to the page and immediately removed again
                    // artifacts are left over in the model. We just skip them here
                    if (bIsLoggable) {
                        this.LOGGER.trace(LOG_METHOD, "Window ${0} is dirty, committing ...", widWindow.getID());
                    }
                    this._commitWidgetModelNode(deferred, sync, widWindow);
                    widWindow._setClean();
                }
            }
        }
        
        // instances
        if (bIsLoggable) {
            this.LOGGER.trace(LOG_METHOD, "Checking for WidgetInstances to commit");
        }
        for (instID in this.instances) {
            if (Object.prototype.hasOwnProperty.call(this.instances, instID)) {
                widInstance = this.instances[instID];
                if (widInstance._type && widInstance._type == "window" && widInstance._isDirty() && (!this.idService.isClientID(widInstance.getID()))) {
                    // we are not commiting client ids, they have to be committed through the layout model first and then made known
                    // to the widget model. However in case a widget is added to the page and immediately removed again
                    // artifacts are left over in the model. We just skip them here
                    if (bIsLoggable) {
                        this.LOGGER.trace(LOG_METHOD, "Instance ${0} is dirty, committing ...", instID);
                    }
                    this._commitWidgetModelNode(deferred, sync, widInstance);
                    widInstance._setClean();
                }
            }
        }
        mpHandler.endTransactionDeferred().start();
        
        
        var mpHandler = com.ibm.mashups.enabler.io.XHRMultipartFactory.create();
        mpHandler.startTransaction();
        // instances
        if (bIsLoggable) {
            this.LOGGER.trace(LOG_METHOD, "Checking for WidgetInstances to commit");
        }
        for (instID in this.instances) {
            if (Object.prototype.hasOwnProperty.call(this.instances, instID)) {
                widInstance = this.instances[instID];
                if ((!widInstance._type || widInstance._type != "window") && widInstance._isDirty() && (!this.idService.isClientID(widInstance.getID()))) {
                    // we are not commiting client ids, they have to be committed through the layout model first and then made known
                    // to the widget model. However in case a widget is added to the page and immediately removed again
                    // artifacts are left over in the model. We just skip them here
                    if (bIsLoggable) {
                        this.LOGGER.trace(LOG_METHOD, "Instance ${0} is dirty, committing ...", instID);
                    }
                    this._commitWidgetModelNode(deferred, sync, widInstance);
                    widInstance._setClean();
                }
            }
        }
        
        // definitions
        if (bIsLoggable) {
            this.LOGGER.trace(LOG_METHOD, "Checking for WidgetDefinitions to commit");
        }
        for (defID in this.definitions) {
            if (Object.prototype.hasOwnProperty.call(this.definitions, defID)) {
                widDef = this.definitions[defID];
                if (widDef._isDirty() && (!this.idService.isClientID(widDef.getID()))) {
                    // we are not commiting client ids, they have to be committed through the layout model first and then made known
                    // to the widget model. However in case a widget is added to the page and immediately removed again
                    // artifacts are left over in the model. We just skip them here
                    if (bIsLoggable) {
                        this.LOGGER.trace(LOG_METHOD, "Definition ${0} is dirty, committing ...", defID);
                    }
                    this._commitWidgetModelNode(deferred, sync, widDef);
                    widDef._setClean();
                }
            }
        }
        mpHandler.endTransactionDeferred().start();
        
        // global semaphore _release to fire finish() on the deferred object
        this._release(deferred, this.statusCode);
        
        this._setClean(); // mark as 'clean' (no more pending changes)
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD);
        }
    },
    /**
     * Commits a widget model node.
     * @param {Object} node the node to commit. Can be either&nbsp; {@link com.ibm.mashups.enabler.widget.WidgetWindow WidgetWindow},
     * &nbsp; {@link com.ibm.mashups.enabler.widget.WidgetInstance WidgetInstance} or &nbsp;{@link com.ibm.mashups.enabler.widget.WidgetDefinition WidgetDefinition}.
     */
    _commitWidgetModelNode: function(deferred, sync, node){
        // logging support
        var LOG_METHOD = "_commitWidgetModelNode(deferred, sync, node)";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, [deferred, sync, node]);
        }
        
        var modelURL = null;
        var putData = null;
        
        var id = null;
        
        if (node._type == "window") {
            id = node.entity.getID();
            
            if (this.idService.isClientID(id)) {
                // we don't have a personalized entity so let's create it on the server
                var remoteEntityID = this._createNewPersNttyOnServer(deferred, node);
                
                if (!remoteEntityID) {
                    return;
                }
                
                // log this
                if (bIsLoggable) {
                    this.LOGGER.trace(LOG_METHOD, "The ID for the newly created entity is ${0}", remoteEntityID);
                }
                
                // replace the entityID with the one from the server
                node._setRawEntityID(remoteEntityID);
                
                // also replace the internal id which we use for the next request
                id = com.ibm.mm.enabler.IdentifiableHelper.getID(remoteEntityID);
            }
            
            modelURL = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(this.urlType, this);
            modelURL.setNodes([{
                value: id,
                isID: true
            }]);
            
            putData = node.entity.xmlData;
        }
        else {
            try {
                modelURL = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(node.getEditLink(), this);
            } 
            catch (err) {
                id = node.getID();
                //[0] = windows [1] = page
                modelURL = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(this.urlType, this);
                modelURL.setNodes([{
                    value: id,
                    isID: true
                }]);
            }
            
            putData = node.xmlData;
        }
        
        // we should force the update mode to replace
        modelURL.setParameter("update", "replace");
        
        // also rep and events should be set
        modelURL.setParameter("rep", "full");
        modelURL.setParameter("events", "single");
        
        // HTTP PUT updated nodes
        var putMarkup = com.ibm.mm.enabler.utils.Dom.innerXML(putData);
        this._acquire();
        serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(modelURL, null, null, false, sync);
        serviceReq.update(putMarkup, dojo.hitch(this, function(type, data, xhr, args){
            if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_LOAD && data) {
                if (node._type == "window") {
                    var persEntity = this._getInstanceFromFeed(data, true);
                    if (persEntity) {
                        node.entity.xmlData = persEntity.xmlData; // copy over the xml
                    }
                }
                else 
                    if (node._type == "instance") {
                        var entity = this._getInstanceFromFeed(data, true);
                        if (entity) {
                            node.xmlData = entity.xmlData; // copy over the xml
                        }
                    }
                    else 
                        if (node._type == "definition") {
                            var def = this._getDefinitionFromFeed(data, true);
                            if (def) {
                                node.xmlData = def.xmlData;
                            }
                        }
                // update events
                node._updateEventsFromXML();
            }
            
            var callback = deferred.getOperationCallback();
            
            if (callback) {
                callback(node, com.ibm.mashups.enabler.DeferredOperation.OPERATION_MODIFY, xhr.status, deferred.operationCallbackParameters);
            }
            this._release(deferred, xhr.status);
        }), id);
        
        // exit trace
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD);
        }
    },
    /**
     * Creates an personalized entity on the server by using a creation context
     * @param {com.ibm.mashups.enabler.widget.WidgetWindow} widgetWindow the window for which to create
     * the personalized entity.
     * @return {String} the ID of the new created entity.
     */
    _createNewPersNttyOnServer: function(deferred, widgetWindow){
        var ns = this._getNS();
        var xmlDom = widgetWindow.xmlData.ownerDocument;
        
        var sharedEntityID = widgetWindow._getParentID();
        
        var entry = com.ibm.mm.enabler.utils.Utils.createNode("atom:entry", this.ns.atom);
        
        var id = com.ibm.mm.enabler.utils.Utils.createNode("atom:id", this.ns.atom);
        com.ibm.mm.enabler.utils.Dom.textContent(id, "cid:0");
        entry.appendChild(id);
        
        var content = com.ibm.mm.enabler.utils.Utils.createNode("atom:content", this.ns.atom);
        content.setAttribute("type", "application/xml");
        entry.appendChild(content);
        
        var modelURL = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(this.urlType, this);
        modelURL.setNodes([{
            value: sharedEntityID,
            isID: true
        }]);
        
        // also rep and events should be set
        modelURL.setParameter("rep", "full");
        modelURL.setParameter("events", "single");
        
        var entity = com.ibm.mm.enabler.utils.Utils.createNode("model:portlet-entity", this.ns.model);
        
        com.ibm.mm.enabler.utils.Dom.setAttributeWithNS(xmlDom, entity, "creation-context:portlet-entity", "portlet-entity", this.ns["creation-context"], modelURL.getModelURI());
        content.appendChild(entity);
        
        var entryMarkup = com.ibm.mm.enabler.utils.Dom.innerXML(entry);
        
        
        var retVal = null;
        
        // HTTP POST updated nodes
        this._acquire();
        serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(modelURL, null, null, false, true);
        serviceReq.create(entryMarkup, dojo.hitch(this, function(type, data, xhr, args){
            if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_LOAD && data) {
                var expr = "atom:feed/atom:entry[atom:content/model:portlet-entity]/atom:id";
                var node = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, data, this.ns);
                if (node) {
                    retVal = com.ibm.mm.enabler.utils.Dom.textContent(node);
                }
            }
            
            var callback = deferred.getOperationCallback();
            if (callback) {
                callback(retVal, com.ibm.mashups.enabler.DeferredOperation.OPERATION_CREATE, xhr.status, deferred.operationCallbackParameters);
            }
            this._release(deferred, xhr.status);
        }), id);
        
        return retVal;
    },
    _getHierarchicalPreferences: function(deferred, sync, prefProvider){
        var prefences;
        if (prefProvider && prefProvider._getHierarchicalPreferences) {
            preferences = prefProvider._getHierarchicalPreferences();
        }
        else {
            preferences = prefProvider.getPreferences();
        }
        
        if (deferred) {
            deferred.finish(preferences, com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK);
        }
        
        return preferences;
    },
    _getHierarchicalEventProvider: function(deferred, sync, eventProvider){
        var ep;
        
        if (eventProvider && eventProvider._getHierarchicalEventProvider) {
            ep = eventProvider._getHierarchicalEventProvider();
        }
        else {
            ep = eventProvider;
        }
        
        if (deferred) {
            deferred.finish(ep, com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK);
        }
        
        return ep;
    },
    _updateLayoutControl: function(control, sync){
        var uri = control._getWidgetWindowURI();
        
        if (!uri) {
            return;
        }
        
        //pseudo:
        
        // load window for control
        var index = this.controls.indexOf(control);
        
        if (index == -1) {
            // this is a normal scenario where the widget/control is not yet made available to the widget model.
            // In this case we also do not need to update the model
            return;
            //throw new Error(this.modelMessages.E_NODE_ISNULL_0);
        }
        
        // get the window for the control
        var window = this.windows[index];
        
        this._updateFullWindowParentTree(window, control, sync);
        // fetch feed from backend
        // replace the internal ID's with the new ones
    },
    _updateFullWindowParentTree: function(wnd, control, sync){
    
        var uri = control._getWidgetWindowURI();
        
        // right now control is just an String ID
        var ids = this._splitFullWindowID(uri);
        
        // control ID should be <windowid>@<pageid> ...
        if (ids.length != 2) {
            throw new Error(this.modelMessages.E_NODE_ISNULL_0);
        }
        
        // see if we have already the window loaded node [0] = windowID; [1] = pageID
        var windowID = ids[0];
        var pageID = ids[1];
        
        var myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(this.urlType, this);
        myUrl.setNodes([{
            value: windowID,
            isID: true
        }, {
            value: pageID,
            isID: true
        }]);
        
        myUrl.setParameter("mode", "download");
        myUrl.setParameter("rep", "full");
        myUrl.setParameter("levels", "-all");
        myUrl.setParameter("events", "single");
        
        // apply hidden meta data strategy
        this._applyHiddenMetaDataLoadingStrategyToModelURL(myUrl);
        
        var serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
        var result = {};
        result.node = null;
        
        serviceReq.read(dojo.hitch(this, function(type, data, xhr, args){
            // since we had a full model request
            
            if (type != com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_ERROR) {
                // store the window
                var resWindow = this._getWindowFromFeed(data, control, true);
                
                if (!resWindow) {
                    throw new Error(dojo.string.substitute(this.modelMessages.E_WIDGET_NOTFOUND_1, [control]));
                }
                
                var oldID = wnd.getID();
                var newID = resWindow.getID();
                
                wnd._setRawID(resWindow._getRawID());
                
                // attach the ID's in the ID service
                this.idService.attachServerID(oldID, newID);
                
                var instance = this.getWidgetInstance(wnd).start();
                var resInstance = this._getInstanceFromFeed(data, true);
                
                this._copyWidgetStateInfo(oldID, newID);
                
                delete this.instances[instance.getID()];
                
                instance._setRawID(resInstance._getRawID());
                this.instances[instance.getID()] = instance;
                wnd._setEntityParent(instance, this.urlType);
                
                var def = this.getWidgetDefinitionByInstance(instance).start();
                var resDef = this._getDefinitionFromFeed(data, true);
                
                if (def.getID() != resDef.getID()) {
                    var oldID = def.getID();
                    
                    delete this.definitions[def.getID()];
                    def._setRawID(resDef._getRawID());
                    this.definitions[def.getID()] = def;
                    
                    instance._setParent(instance, def, this.urlType);
        
                    // We need to do this because of the following scenario:
                    // 1. First time a widget is ever dropped on the page (and not known by the server)
                    // 2. Drop one widget on the page and configure it
                    // 3. Drop second widget (the same) on the page. It should immediately show the config values
                    // 4. On save the second POST/GET - if in multipart - must resolve the client id with the server id
                    //    in order to find the node in the internal cache.
                    // Because of this we attach the server id in the id service
                    var newID = def.getID();
                    // attach the ID's in the ID service
                    this.idService.attachServerID(oldID, newID);
                    
                    // update any events (if def is a eventprovider impl)
                    if (def._updateEventsFromXML) {
                        def._updateEventsFromXML(resDef.xmlData);
                    }
                }
            }
        }));
    },
    _copyWidgetStateInfo: function(oldID, newID){
        var navStateModel = com.ibm.mashups.enabler.model.state.NavigationStateModelFactory.getNavigationStateModel();
        var accessorFactory = com.ibm.mashups.enabler.model.state.AccessorFactory;
        var oldWidgetAccessor = accessorFactory.getWidgetAccessor(navStateModel, oldID), newWidgetAccessor = accessorFactory.getWidgetAccessor(navStateModel, newID);
        
        dojo.forEach(["WidgetMode", "WindowState", "Size"], function(part){
            this._copyWidgetStatePart(oldWidgetAccessor, newWidgetAccessor, part);
        }, this);
        
        // copy other arbitrary state name/value pairs?
        
        navStateModel.commit().start();
    },
    _copyWidgetStatePart: function(oldAcc, newAcc, part){
        switch (part) {
            case "WidgetMode":
            case "WindowState":
                var value = oldAcc["get" + part]();
                if (value) {
                    newAcc["set" + part](value);
                }
                break;
            case "Size":
                // can't use above since get returns an object and set takes two numbers -- defect 18726 - dosofsky
                var size = oldAcc.getSize();
                if (size) {
                    newAcc.setSize(size.w, size.h);
                }
                break;
            default:
        }
    },
    _getWidgetWindowByContext: function(context, control){
        var LOG_METHOD = "_getWidgetWindowByContext(context, control)";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, [context, control]);
        }
        
        // first of all, get the definition object as we need the IDs for the instance
        var widDef = this._getWidgetDefinitionByContext(context);
        
        // then get the instance based on the definition
        var widInstance = this._createWidgetInstance(widDef);
        // last but not least create the window based on the instance
        var widWindow = this._createWidgetWindow(widInstance, control.getID());
        
        // make sure we add everything to it's internal lists
        var index = this.controls.indexOf(control);
        
        if (index > -1) {
            throw new Error(this.modelMessages.E_PARAM_IS_SMALLER_ZERO_0);
        }
        else {
            this.controls.add(control);
            
            var myControl = control;
            var me = this;
            dojo.connect(control, "setXml", this, function(){
                var doMultipart = com.ibm.mashups.enabler.io.XHRMultipartFactory.isMultipartEnabled();
                var strategyService = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.StrategyService.SERVICE_NAME);
                var widgetWindowLoadAheadStrategy = strategyService.getStrategy("com.ibm.mashups.enabler.widget.WidgetModel", "com.ibm.mashups.enabler.strategy.WidgetWindowLoadAheadStrategy");
                if ((widgetWindowLoadAheadStrategy) && (doMultipart)) {
                    // we only preload data when multipart is enabled and we found a set of widgets that are set in the strategy
                    
                    var map = widgetWindowLoadAheadStrategy.getWidgetWindowMap();
                    
                    // we implement a failsafe listener. In case below logic is not triggering the multipart, this one will.
                    if (!widgetWindowLoadAheadStrategy.listener) {
                        widgetWindowLoadAheadStrategy.listener = dojo.connect(strategyService, "removeStrategy", this, function(modelName, strategyName) {
                            if ((modelName == "com.ibm.mashups.enabler.widget.WidgetModel") && (strategyName == "com.ibm.mashups.enabler.strategy.WidgetWindowLoadAheadStrategy")) {
                                if (!com.ibm.mm.enabler.utils.Misc.isEmpty(map)) {
                                    var idService = com.ibm.mashups.enabler.services.IdentificationService;
                                    var mpHandler = com.ibm.mashups.enabler.io.XHRMultipartFactory.create();
                                    mpHandler.startTransaction();
                                    for (var id in map) {
                                        if (idService.isServerID(id)) {
                                            var innerControl = map[id];
                                            if (innerControl) {
                                                me._updateLayoutControl(innerControl, false); // those are loaded async so that the multipart transaction is picking them up
                                            }
                                        }
                                    }
                                    mpHandler.endTransactionDeferred().start(); // this is our synchronization point as this is again executed synchronously
                                    for (var id in map) {
                                        delete map[id];
                                    }
                                }
                                // cleanup
                                dojo.disconnect(widgetWindowLoadAheadStrategy.listener);
                                delete widgetWindowLoadAheadStrategy.listener;
                            }
                        });
                    }


                    // implementing a method that will trigger the multipart on the last setXml call.
                    // the assumption is that setXml is called as often as entries are in the loadahead map
                    // if this is not the case the widget model is not updated
                    
                    // first we check whether we have already handled this node in a previous call
                    var myControlID = myControl.getID();
                    var value = map[myControlID];
                    if (typeof value == "undefined") {
                        // now we need to replace the cid entry with the new server id
                        for (var id in map) {
                            var innerControl = map[id];
                            if ((innerControl) && (innerControl.getID() == myControlID)) {
                                map[myControlID] = innerControl;
                                delete map[id];
                                break;
                            }
                        }
                    }
                    // now we check if only server id's are left in the array
                    var idService = com.ibm.mashups.enabler.services.IdentificationService;
                    var clientIDFound = false;
                    for (var id in map) {
                        if (!idService.isServerID(id)) {
                            clientIDFound = true;
                            break;
                        }
                    }
                    // if no client id is in the array anymore we kick off the multipart request
                    if (!clientIDFound) {
                        var mpHandler = com.ibm.mashups.enabler.io.XHRMultipartFactory.create();
                        mpHandler.startTransaction();
                        for (var id in map) {
                            var innerControl = map[id];
                            if (innerControl) {
                                me._updateLayoutControl(innerControl, false); // those are loaded async so that the multipart transaction is picking them up
                            }
                        }
                        mpHandler.endTransactionDeferred().start(); // this is our synchronization point as this is again executed synchronously
                        for (var id in map) {
                            delete map[id];
                        }
                    }
                }
                else {
                    me._updateLayoutControl(myControl, true);
                }
            });
            
            
            index = this.controls.indexOf(control);
            this.windows[index] = widWindow;
            this.cachedWindows[widWindow.getID()] = widWindow; // add to cache
        }
        
        // add the definition
        this.definitions[widDef.getID()] = widDef;
        
        // add the instance
        this.instances[widInstance.getID()] = widInstance;
        
        var retVal = widWindow;
        
        
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD, retVal);
        }
        
        return retVal;
    },
    _getWidgetDefinitionByContext: function(context){
        var LOG_METHOD = "_getWidgetDefinitionByContext(context)";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, [context]);
        }
        
        var retVal = null;
        
        var defIdentifiable = context[com.ibm.mashups.enabler.layout.Constants.CONTEXT_WIDGET_DEFINITION_ID];
        var url = context[com.ibm.mashups.enabler.layout.Constants.CONTEXT_WIDGET_DEFINITION_URL];
        
        if (defIdentifiable) {
            // forcing sync mode
            retVal = this._getWidgetDefinitionByInstance(null, true, defIdentifiable.getID());
        }
        else 
            if (url) {
                retVal = this._getWidgetDefinitionFromURL(url);
            }
        
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD, retVal);
        }
        
        return retVal;
    },
    _getWidgetDefinitionFromURL: function(url){
        var id = this.widgetDefinitionIDByURL[url];
        if (id) {
            var def = this.find(new com.ibm.mm.enabler.IdentifierImpl(id)).start();
            if (def) {
                return def;
            }
        }
        // load widget definition
        var scope = com.ibm.mashups.enabler.model.url.ModelUrlFactory.WIDGET_URL;
        var myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(scope, this);
        myUrl.setNodes([{
            value: "collection",
            isID: false
        }]);
        
        // full representation
        myUrl.setParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_REPRESENTATION, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_REPRESENTATION_VALUE_FULL);
        
        // filter by URL
        myUrl.setParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_FILTER_BY_URL, url);
        
        // sunchronous xhr
        var serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, true);
        var result = {};
        
        serviceReq.read(dojo.hitch(this, function(type, data, xhr, args){
            if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_LOAD) {
                var definition = this._getDefinitionFromFeed(data);
                if (definition) {
                    this.widgetDefinitionIDByURL[url] = definition.getID();
                }
            }
        }));
        var id = this.widgetDefinitionIDByURL[url];
        if (id) {
            var def = this.find(new com.ibm.mm.enabler.IdentifierImpl(id)).start(true);
            if (def) {
                return def;
            }
        }
        
        // fall back to widget load service
        var widgetLoadService = com.ibm.mashups.services.ServiceManager.getService("widgetLoadService");
        
        // after success this one will contain the widget
        var iWidgetDefinition;
        
        // yes, we are yet again forcing synchronous mode
        widgetLoadService.getWidgetXML(url, true, function(data, statuscode, xhr){
            if (typeof xhr != "undefined" && xhr !== null) {
                statuscode = xhr.status;
            }
            if (statuscode != 200) {
                data = null; //set to null value
            }
            iWidgetDefinition = data;
        });
        
        if (iWidgetDefinition === null) {
            throw new Error(this.modelMessages.E_NODE_ISNULL_0);
        }
        
        var definition = this._createWidgetDefinition(iWidgetDefinition, url);
        if (definition) {
            this.widgetDefinitionIDByURL[url] = definition.getID();
        }
        return definition;
    },
    
    _createWidgetDefinition: function(iWidgetDefinition, url){
        var LOG_METHOD = "_createWidgetDefinition(iWidgetDefinition, url)";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, [iWidgetDefinition, url]);
        }
        
        var widgetNode = this._createWidgetNode(iWidgetDefinition.getSupportedModes());
        var definitionNode = this._createDefinitionNode(new com.ibm.mm.enabler.IdentifierImpl(widgetNode));
        
        var def = new com.ibm.mm.enabler.widget.WidgetDefinitionImpl(definitionNode, widgetNode, this);
        def._setURL(url);
        def._addDirtyCallback(this, this._setWidgetModelDirty);
        
        var widgetDefObj = iWidgetDefinition.widgetDef;
        
        if (widgetDefObj && dojo.isFunction(widgetDefObj.getType) && widgetDefObj.getType() === com.ibm.mm.iwidget.Constants.OSGADGET_DEFINITION_TYPE) { // for gadgets
            var gadgetsModes = ["view"];
            def._setSupportedModes(gadgetsModes);
            def._setType(widgetDefObj.getType());
        }
        else { // for widgets
            if (typeof this.widgetDefinitionCache == "undefined") {
                this.widgetDefinitionCache = {};
            }
            var entry;
            if ((url) && (url in this.widgetDefinitionCache)) {
                entry = this.widgetDefinitionCache[url];
            }
            else {
                var specObj = iWidgetDefinition.toSpecObject();
                
                var sandboxedString = "false";
                // set the sandbox flag
                if (specObj._sandbox && specObj._sandbox.toLowerCase() === "true") {
                    sandboxedString = "true";
                }
                
                // we have to recreate the whole atom:entry as in WebKIT we cannot replace nodes from other documents.
                entry = [];
                entry.push("<atom:entry");
                for (var ns in this.ns) {
                    if (ns.indexOf("xml") !== 0) { // http://support.microsoft.com/kb/262585
                        entry.push(" xmlns:" + ns + "=\"" + this.ns[ns] + "\"");
                    }
                }
                entry.push(">");

                // add old content but atom:content
                var contentNode = com.ibm.mashups.enabler.xml.XPath.evaluateEntry("atom:content", def.xmlData, this.ns);
                def.xmlData.removeChild(contentNode);
                while (def.xmlData.firstChild) {
                    entry.push(com.ibm.mm.enabler.utils.Dom.innerXML(def.xmlData.firstChild));
                    def.xmlData.removeChild(def.xmlData.firstChild);
                }
                
                entry.push("<atom:content type=\"application/xml\">");
                entry.push("<model:portlet-definition model:sandboxed=\"" + sandboxedString + "\" model:type=\"iWidget\" model:url=\"" + url + "\">");
                
                // set title
                if (specObj.itemSets.idescriptor &&
                specObj.itemSets.idescriptor.items &&
                specObj.itemSets.idescriptor.items.title) {
                    var title = specObj.itemSets.idescriptor.items.title;
                    var lang = title._lang;
                    entry.push("<model:title>");
                    entry.push("<base:nls-string xml:lang=\"" + title._lang + "\">" + title._value + "</base:nls-string>");
                    var title_alts = title.alts;
                    for (var alt in title_alts) {
                        if (lang != alt) {
                            entry.push("<base:nls-string xml:lang=\"" + title_alts[alt]._lang + "\">" + title_alts[alt]._value + "</base:nls-string>");
                        }
                    }
                    entry.push("</model:title>");
                }
                
                // set description
                if (specObj.itemSets.idescriptor &&
                specObj.itemSets.idescriptor.items &&
                specObj.itemSets.idescriptor.items.description) {
                    var description = specObj.itemSets.idescriptor.items.description;
                    var lang = description._lang;
                    entry.push("<model:description>");
                    entry.push("<base:nls-string xml:lang=\"" + description._lang + "\">" + description._value + "</base:nls-string>");
                    var description_alts = description.alts;
                    for (var alt in description_alts) {
                        if (lang != alt) {
                            entry.push("<base:nls-string xml:lang=\"" + description_alts[alt]._lang + "\">" + description_alts[alt]._value + "</base:nls-string>");
                        }
                    }
                    entry.push("</model:description>");
                }
                
                // set attributes
                var attributes = specObj.itemSets.attributes;
                if (attributes) {
                    var prefs = def.getPreferences();
                    for (var itemName in attributes.items) {
                        if (Object.prototype.hasOwnProperty.call(attributes.items, itemName)) {
                            var item = attributes.items[itemName];
                            var readOnly = "false";
                            if (item._readOnly && item._readOnly === "true") {
                                readOnly = "true";
                            }
                            entry.push("<model:portletpreferences name=\"" + dojox.html.entities.encode(itemName) + "\" read-only=\"" + readOnly + "\"><base:value value=\"" + dojox.html.entities.encode(item._value) + "\" xsi:type=\"base:String\"/></model:portletpreferences>");
                        }
                    }
                    
                    // make sure that everything is clean
                    prefs._setClean();
                }
                //entry += innerEntry.join("");
                
                // set events
                entry.push("<model:events>");
                // define methods used in the loop
                var writeEvent = function(published){
					
					// D19162
                    // Changed from using the client-side generated ID to using the event name.
					// Without this change, the wire is persisted with the client-side generated ID.
					// Upon a page refresh, a new client-side ID is created for the event, which
					// makes any scenario dependant on the event IDs being the same fail (e.g.,
					// com.ibm.mm.builder.utils.wireUtil.getAllMatchHandleEventsCSA2 and
					// com.ibm.mm.builder.utils.wireUtil.getAllMatchPubEventsCSA2
					// pubEvent.getID() == aWire.getSourceEvent().getID() 
                    // targetEvent.getID() == aWire.getTargetEvent().getID()
					//  
					// var id = "cid:" + this.idService.createClientID();					 
					var id = "cid:" + name;
					
                    entry.push("<model:" + ((published) ? "publish-event" : "process-event") + " id=\"" + id + "\">");
                    // NOTE: This has been done by the WidgetDefinitionNodeImpl so far but 
                    // for IE7 runtime performance we have to change the way we do things here
                    var writeQName = function(elementname, value, setdefault){
                        var nsUri = null;
                        var localName = null;
                        // now let's see what we've got
                        var nsStart = value.indexOf("{");
                        if (nsStart === 0) {
                            var nsEnd = value.indexOf("}");
                            if (nsEnd == -1) {
                                if (setdefault) {
                                    nsUri = this.DATATYPE_NS;
                                }
                                localName = value;
                            }
                            else {
                                nsUri = value.substring(nsStart + 1, nsEnd);
                                localName = value.substring(nsEnd + 1);
                            }
                        }
                        else {
                            if (setdefault) {
                                nsUri = this.DATATYPE_NS;
                            }
                            localName = value;
                        }
                        if (nsUri != null) {
                            return "<model:" + elementname + " xmlns:ns=\"" + nsUri + "\">ns:" + localName + "</model:" + elementname + ">";
                        }
                        else {
                            return "<model:" + elementname + ">" + localName + "</model:" + elementname + ">";
                        }
                        
                    };
                    // set qname
                    entry.push(dojo.hitch(this, writeQName)("qname", name, false));
                    // set payload type
                    entry.push(dojo.hitch(this, writeQName)("payload-type", eventDesc._payloadType, true));
                    var lang = null;
                    var elementWritten = false;
                    if (eventDesc._title) {
                        lang = eventDesc._lang;
                        entry.push("<model:title>");
                        elementWritten = true;
                        entry.push("<base:nls-string xml:lang=\"" + eventDesc._lang + "\">" + eventDesc._title + "</base:nls-string>");
                    }
                    for (var alt in eventDesc.alts) {
                        if ((eventDesc.alts[alt]._title) && (lang != alt)) {
                            if (!elementWritten) {
                                entry.push("<model:title>");
                                elementWritten = true;
                            }
                            entry.push("<base:nls-string xml:lang=\"" + eventDesc.alts[alt]._lang + "\">" + eventDesc.alts[alt]._title + "</base:nls-string>");
                        }
                    }
                    if (elementWritten) {
                        entry.push("</model:title>");
                    }
                    lang = null;
                    elementWritten = false;
                    if (eventDesc._description) {
                        lang = eventDesc._lang;
                        entry.push("<model:description>");
                        elementWritten = true;
                        entry.push("<base:nls-string xml:lang=\"" + eventDesc._lang + "\">" + eventDesc._description + "</base:nls-string>");
                    }
                    for (var alt in eventDesc.alts) {
                        if ((eventDesc.alts[alt]._title) && (lang != alt)) {
                            if (!elementWritten) {
                                entry.push("<model:description>");
                                elementWritten = true;
                            }
                            entry.push("<base:nls-string xml:lang=\"" + eventDesc.alts[alt]._lang + "\">" + eventDesc.alts[alt]._description + "</base:nls-string>");
                        }
                    }
                    if (elementWritten) {
                        entry.push("</model:description>");
                    }
                    entry.push("</model:" + ((published) ? "publish-event" : "process-event") + ">");
                };
                
                for (var eventName in specObj.events) {
                    if (Object.prototype.hasOwnProperty.call(specObj.events, eventName)) {
                        var iwidEvent = specObj.events[eventName];
                        var name, event, alias = null;
                        if (iwidEvent._alias) {
                            alias = iwidEvent._alias;
                            name = iwidEvent._id;
                        }
                        else {
                            name = iwidEvent._id;
                        }
                        
                        var descId = (iwidEvent._eventDescName) ? iwidEvent._eventDescName : iwidEvent._description;
                        if (!descId) {
                            continue;
                        }
                        var eventDesc = specObj.eventDescriptions[descId];
                        if (!eventDesc) {
                            continue;
                        }
                        
                        // write twice if handled and published
                        if (iwidEvent._published) {
                            dojo.hitch(this, writeEvent)(true);
                        }
                        if (iwidEvent._handled) {
                            dojo.hitch(this, writeEvent)(false);
                        }
                    }
                }
                entry.push("</model:events>");
                
                // prep setting supported modes - NOTE: This has been done by the WidgetDefinitionNodeImpl so far but 
                // for IE7 runtime performance we have to change the way we do things here
                var widget2PortletModesMap = {
                    view: "view",
                    edit: "edit_defaults",
                    personalize: "edit",
                    config: "config",
                    help: "help"
                };
                // set the supported modes
                var flatModes = specObj._supportedModes;
                if (flatModes === undefined || flatModes === null) {
                    flatModes = "view"; // default to view if not specified, according to widget spec
                }
                var modes = flatModes.split(" ");
                entry.push("<model:supports><model:mime-type>html</model:mime-type>");
                for (var i = 0, l = modes.length; i < l; i++) {
                    var portletMode = modes[i];
                    if (modes[i] in widget2PortletModesMap) {
                        portletMode = widget2PortletModesMap[modes[i]];
                    }
                    entry.push("<model:portlet-mode>" + portletMode + "</model:portlet-mode>");
                }
                entry.push("</model:supports>");
                entry.push("</model:portlet-definition>");
                entry.push("</atom:content>");
                entry.push("</atom:entry>");
                entry = entry.join("");
                
                // cache entry
                if (url) {
                    this.widgetDefinitionCache[url] = entry;
                }
            }
            def.xmlData = dojox.xml.parser.parse(entry).firstChild;
            
            // set the definition clean
            def._setClean();
        }
        
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD, def);
        }
        
        return def;
    },
    _createWidgetInstance: function(widgetDefinition){
        var instanceNode = this._createEntityNode(widgetDefinition);
        return new com.ibm.mm.enabler.widget.WidgetInstanceImpl(instanceNode, this);
    },
    _createWidgetWindow: function(widgetInstance, newID){
        var persEntityNode = this._createEntityNode(widgetInstance);
        var persEntity = new com.ibm.mm.enabler.IdentifierImpl(persEntityNode);
        
        var widWindowNode = this._createWindowNode(persEntity, newID);
        
        return new com.ibm.mm.enabler.widget.WidgetWindowImpl(widWindowNode, persEntityNode, this);
    },
    /**
     *
     * @param {com.ibm.mashups.enabler.Identifiable} parentIdentifiable if specified, an reply-to link for this one will be created
     */
    _createModelNode: function(type, parentIdentifiable, newID){
        var ns = this._getNS();
        var entry = com.ibm.mm.enabler.utils.Utils.createNode("atom:entry", this.ns.atom);
        
        var xmlDom = entry.ownerDocument;
        
        var id = com.ibm.mm.enabler.utils.Utils.createNode("atom:id", this.ns.atom);
        
        com.ibm.mm.enabler.utils.Dom.textContent(id, "cid:" + (newID ? newID : this.idService.createClientID()));
        
        entry.appendChild(id);
        
        entry.appendChild(com.ibm.mm.enabler.utils.Utils.createNode("atom:title", this.ns.atom));
        var updated = com.ibm.mm.enabler.utils.Utils.createNode("atom:updated", this.ns.atom);
        var time = new Date();
        com.ibm.mm.enabler.utils.Dom.textContent(updated, time.toGMTString());
        entry.appendChild(updated);
        var content = com.ibm.mm.enabler.utils.Utils.createNode("atom:content", this.ns.atom);
        content.setAttribute("type", "application/xml");
        var entityNode = com.ibm.mm.enabler.utils.Utils.createNode("model:" + type, this.ns.model);
        content.appendChild(entityNode);
        entry.appendChild(content);
        
        if (parentIdentifiable) {
            var replyNode = com.ibm.mm.enabler.utils.Utils.createNode("thr:in-reply-to", this.ns.thr);
            com.ibm.mm.enabler.utils.Dom.setAttributeWithNS(xmlDom, replyNode, "ext:uri", "uri", this.ns.ext, parentIdentifiable._getRawID());
            replyNode.setAttribute("ref", parentIdentifiable._getRawID());
            replyNode.setAttribute("href", "#");
            
            var atomLink = com.ibm.mm.enabler.utils.Utils.createNode("atom:link", this.ns.atom);
            com.ibm.mm.enabler.utils.Dom.setAttributeWithNS(xmlDom, atomLink, "ext:uri", "uri", this.ns.ext, parentIdentifiable._getRawID());
            atomLink.setAttribute("rel", "related");
            atomLink.setAttribute("type", "application/atom+xml");
            atomLink.setAttribute("href", "#");
            
            entry.appendChild(replyNode);
            entry.appendChild(atomLink);
        }
        
        return entry;
    },
    _createWindowNode: function(parentIdentifiable, newID){
        return this._createModelNode("portlet-window", parentIdentifiable, newID);
    },
    _createEntityNode: function(parentIdentifiable){
        return this._createModelNode("portlet-entity", parentIdentifiable);
    },
    _createWidgetNode: function(modes){
        if (modes.length === 0) {
            return null;
        }
        var ns = this._getNS();
        
        var widgetNode = this._createModelNode("portlet");
        
        var expr = "atom:content/model:portlet";
        
        var portletNode = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, widgetNode, this.ns);
        
        if (!portletNode) {
            return null;
        }
        
        // supports node
        var supportsNode = com.ibm.mm.enabler.utils.Utils.createNode("model:supports", this.ns.model);
        portletNode.appendChild(supportsNode);
        
        // mime type
        var mimeTypeNode = com.ibm.mm.enabler.utils.Utils.createNode("model:mime-type", this.ns.model);
        com.ibm.mm.enabler.utils.Dom.textContent(mimeTypeNode, "html");
        supportsNode.appendChild(mimeTypeNode);
        
        // add the modes
        var modeCount = modes.length;
        
        for (var i = 0; i < modeCount; ++i) {
            var modeNode = com.ibm.mm.enabler.utils.Utils.createNode("model:portlet-mode", this.ns.model);
            com.ibm.mm.enabler.utils.Dom.textContent(modeNode, modes[i]);
            supportsNode.appendChild(modeNode);
        }
        
        return widgetNode;
    },
    _createDefinitionNode: function(parentIdentifiable){
        return this._createModelNode("portlet-definition", parentIdentifiable);
    },
    _createPersonalizedNttyNode: function(windowNode){
        var entry = this._createEntityNode();
        var ns = this._getNS();
        var expr = "thr:in-reply-to";
        var replyLink = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, windowNode, this.ns) || null;
        
        expr = "atom:link[@rel='related']";
        var atomLink = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, windowNode, this.ns) || null;
        
        if (dojo.isWebKit) {
            // Safari can not reparent a node from one Document to another - needs to be cloned first
            replyLink = replyLink.cloneNode(true);
            atomLink = atomLink.cloneNode(true);
        }
        
        entry.appendChild(replyLink);
        entry.appendChild(atomLink);
        
        return entry;
    },
    _splitFullWindowID: function(control){
        // right now, control is a string in the format <windowid>@<pageid>
        // e.g. pm:id:7_a@id:6_b
        var parts = control.split("@");
        
        if (parts.length != 2) {
            return null;
        }
        
        // parts now contains:
        // [0] pm:id:7_a
        // [1] id:6_b
        
        var windowIDParts = parts[0].split(":");
        var pageIDParts = parts[1].split(":");
        
        // windowIDParts should contain
        // [0] pm
        // [1] id
        // [2] 7_a
        var windowID = windowIDParts[windowIDParts.length - 1]; // get the last element
        // pageIDParts should contain
        // [0] id
        // [1] 6_b
        var pageID = pageIDParts[pageIDParts.length - 1]; // get the last element
        return [windowID, pageID];
    },
    /**
     * This function gets the personalized entity from the feed.
     * @param {XMLDocument} feed the feed containing the entities.
     * @param {String} uri the entities uri
     * @return {XMLDOMNode} the node cotaining the personalized entity or <tt>null</tt> if there is none.
     */
    _getPersonalizedEntity: function(feed, uri){
        var ns = this._getNS();
        // TODO make this a count() XPath statement, because we don't need the result
        var expr = "atom:feed/atom:entry[atom:content/model:portlet-entity]";
        var entities = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(expr, feed, this.ns);
        
        var retVal = null;
        
        // there is either no entitiy or only the shared entity so no personalization is here
        if (!entities || entities.length == 1) {
            return null;
        }
        
        // use xpath to get the actual definition
        expr = "atom:feed/atom:entry[contains(atom:id/child::text(),'" + uri + "')]";
        var persEntity = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, feed, this.ns);
        
        return persEntity || null;
    },
    /**
     * This function gets a widget window from a result feed.
     * @param {XMLDocument} feed the feed containing the window.
     * @param {LayoutControl} control the layout controlfor this window
     * @return {WidgetWindow} the&nbsp; {@link WidgetWindow WidgetWindow} extracted from the feed or <tt>null</tt> if
     * there was no widget window in the feed.
     */
    _getWindowFromFeed: function(feed, control, skipCacheUpdate){
        var ns = this._getNS();
        // note that the window also needs to load the personalized entity.
        var expr = "atom:feed/atom:entry[atom:content/model:portlet-window]";
        var windowNode = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, feed, this.ns);
        
        var retVal = null;
        
        if (windowNode) {
        
            expr = "thr:in-reply-to";
            var link = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, windowNode, this.ns);
            
            var persEntityNode = null;
            
            if (link) {
                var uri = com.ibm.mm.enabler.utils.Dom.getAttributeWithNS(link, "ext:uri", "uri", this.ns.ext);
                persEntityNode = this._getPersonalizedEntity(feed, uri);
                if (!persEntityNode) {
                    persEntityNode = this._createPersonalizedNttyNode(windowNode);
                }
            }
            
            if (!skipCacheUpdate) {
                var index = this.controls.indexOf(control);
                var wnd;
                if (index > -1) {
                    var oldID = this.windows[index].getID();
                    
                    this.windows[index]._setXMLData(windowNode, persEntityNode);
                    
                    var newID = this.windows[index].getID();
                    if (oldID !== newID) {
                        delete this.cachedWindows[oldID];
                        this.cachedWindows[newID] = this.windows[index];
                    }
                    wnd = this.windows[index];
                }
                else {
                    wnd = new com.ibm.mm.enabler.widget.WidgetWindowImpl(windowNode, persEntityNode, this);
                    
                    if (!dojo.isArray(control)) {
                        this.controls.add(control);
                        index = this.controls.indexOf(control);
                        this.windows[index] = wnd;
                    }
                    
                    var id = wnd.getID();
                    this.cachedWindows[id] = wnd;
                }
                retVal = wnd;
            }
            else {
                retVal = new com.ibm.mm.enabler.widget.WidgetWindowImpl(windowNode, persEntityNode, this);
            }
        }
        return retVal;
    },
    /**
     * This function gets a widget instance from a result feed.
     * @param {XMLDocument} the feed containing the instance.
     * @return {WidgetInstance} the&nbsp; {@link WidgetInstance WidgetInstance} extracted from the feed or <tt>null</tt> if
     * there was no widget instance in the feed.
     */
    _getInstanceFromFeed: function(feed, skipCacheUpdate){
        var ns = this._getNS();
        var expr = "atom:feed/atom:entry[atom:content/model:portlet-entity]";
        var nodes = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(expr, feed, this.ns);
        
        var retVal = null;
        
        if (!nodes) {
            return null;
        }
        
        var instanceNode = null;
        var identifier;
        
        if (nodes.length == 1) {
            instanceNode = nodes[0];
        }
        else {
            // iterate through the nodes and create an array with the IDs
            var entities = {};
            
            var nodeCount = nodes.length;
            
            var i;
            
            // load the hashmap that contains the id's of the entities.
            for (i = 0; i < nodeCount; ++i) {
                identifier = new com.ibm.mm.enabler.IdentifierImpl(nodes[i]);
                var id = identifier.getID();
                entities[id] = null; // tell the system about the entities found
            }
            
            // iterate through the nodes until we find one that has an parent that is not inside of the hashmap
            for (i = 0; i < nodeCount; ++i) {
                var currentNode = nodes[i];
                
                var parentLink = com.ibm.mm.enabler.widget.utils.getParentLink(currentNode, this.ns);
                var parentID = com.ibm.mm.enabler.utils.Utils.getIdFromExtUri(this.prefix, parentLink);
                
                if (!(parentID in entities)) {
                    instanceNode = currentNode;
                    break;
                }
            }
        }
        
        
        if (!skipCacheUpdate) {
            identifier = new com.ibm.mm.enabler.IdentifierImpl(instanceNode);
            
            var instID = identifier.getID();
            
            identifier = null;
            
            if (instID in this.instances) {
                this.instances[instID]._setXMLData(instanceNode);
            }
            else {
                this.instances[instID] = new com.ibm.mm.enabler.widget.WidgetInstanceImpl(instanceNode, this);
            }
            
            return this.instances[instID];
        }
        
        return new com.ibm.mm.enabler.widget.WidgetInstanceImpl(instanceNode, this);
    },
    /**
     * This function checks if the child nodes of a parent node are all of a certain tag name or not.
     * @param {XMLNode} node the node representing the parent tag whose children to check
     * @param {String} name the tag name to check
     * @return {boolean} true if all child tags are of name, otherwise false
     */
    _allChildElementsOfTagName: function(node, name){
        var LOG_METHOD = "_allChildElementsOfTagName(node, name)";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, [node, name]);
        }
        var retVal = true;
        var child;
        for (var i = 0; i < node.childNodes.length; i++) {
            child = node.childNodes[i];
            if (child.nodeName != name) {
                retVal = false;
                
                if (bIsLoggable) {
                    this.LOGGER.exiting(LOG_METHOD, retVal);
                }
                
                return retVal;
            }
        }
        
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD, retVal);
        }
        
        return retVal;
    },
    /**
     * This function gets a widget definition from a result feed.
     * @param {XMLDocument} feed the feed containing the definition.
     * @return {WidgetDefinition} the&nbsp; {@link WidgetDefinition WidgetDefinition} extracted from the feed or <tt>null</tt> if
     * there was no widget definition in the feed.
     */
    _getDefinitionFromFeed: function(feed, skipCacheUpdate){
        var LOG_METHOD = "_getDefinitionFromFeed(feed, skipCacheUpdate)";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, [feed, skipCacheUpdate]);
        }
        
        var ns = this._getNS();
        
        // store the definition and portlet
        var expr = "atom:feed/atom:entry[atom:content/model:portlet-definition]";
        var defNode = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, feed, this.ns);
        
        var retVal = null;
        var url = null;
        if (defNode) {
            // 18247: Make widgets unmanaged. If the portlet-definition tag has no child tags or only model:portletpreferences
            // child tags, then the data is only partially managed in the database as in v3.0.0.1, so load the portlet-definition 
            // child data from the widget xml file. Otherwise, the data is fully managed in the database as in v3.0, so proceed as
            // is without going to the widget xml file.
            expr = "atom:content/model:portlet-definition";
            var portletDefNode = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, defNode, this.ns);
            if (portletDefNode.childElementCount == 0 || this._allChildElementsOfTagName(portletDefNode, "model:portletpreferences")) {
                
                // yes, we are yet again forcing synchronous mode
                url = com.ibm.mm.enabler.utils.Dom.getAttributeWithNS(portletDefNode, "model:url", "url", this.ns.model);

                if (bIsLoggable) {
                    this.LOGGER.trace(LOG_METHOD, "partial managed data from server; loading widget definition from widget xml file at ${0}", url);
                }

                // we check now whether we have cached this already so we would be able to return it
                var id = this.widgetDefinitionIDByURL[url];
                if (id) {
                    if (this.definitions[id]) {
                        return this.definitions[id];
                    }
                }
                
                // fall back to widget load service
                var widgetLoadService = com.ibm.mashups.services.ServiceManager.getService("widgetLoadService");
                
                // after success this one will contain the widget
                var iWidgetDefinition;
                
                widgetLoadService.getWidgetXML(url, true, function(data, statuscode, xhr){
                    if (typeof xhr != "undefined" && xhr !== null) {
                        statuscode = xhr.status;
                    }
                    if (statuscode != 200) {
                        data = null; //set to null value
                    }
                    iWidgetDefinition = data;
                });
                
                if (iWidgetDefinition === null) {
                    throw new Error(this.modelMessages.E_NODE_ISNULL_0);
                }
                
                var widgetDefFromWidgetXML = this._createWidgetDefinition(iWidgetDefinition, url);
                
                // move the children of the portlet-definition tag from the widget xml to be children of the portlet-definition tag from the feed
                expr = "atom:content/model:portlet-definition";
                var portletDefNodeFromWidgetXML = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, widgetDefFromWidgetXML.xmlData, this.ns);
                var childFromWidgetXML;
                var child;
                var bSameNameAlreadyExists = false;
                while (portletDefNodeFromWidgetXML.firstChild) {
                    // If a portletpreference child of the same name already exists, then don't append the child. Keep the child from the
                    // feed, as it is a config preference, which wins out over the child from the widget xml, which is an edit preference.
                    childFromWidgetXML = portletDefNodeFromWidgetXML.firstChild;
                    bSameNameAlreadyExists = false;
                    if (childFromWidgetXML.nodeName == "model:portletpreferences") {
                        for (var j = 0; j < portletDefNode.childNodes.length; j++) {
                            child = portletDefNode.childNodes[j];
                            if ((child.nodeName == "model:portletpreferences") &&
                            (child.getAttribute("name") == childFromWidgetXML.getAttribute("name"))) {
                                bSameNameAlreadyExists = true;
                                if (bIsLoggable) {
                                    this.LOGGER.trace(LOG_METHOD, "duplicate portletpreference for ${0} found; using config one from feed; ignoring edit one from widget xml", child.getAttribute("name"));
                                }
                                break;
                            }
                        }
                    }
                    if (!bSameNameAlreadyExists) {
                        // use it if it is something that does not match a config preference
                        var newNode = childFromWidgetXML;
                        if (dojo.isWebKit) {
                            // Safari can not reparent a node from one Document to another - needs to be cloned first
                            var deepClone = function(node) {
                                // handle node istelf
                                var retVal = node.cloneNode(false);
                                // clone all children
                                for (var x=0,l=node.childNodes.length; x<l; x++) {
                                    retVal.appendChild(deepClone(node.childNodes[x]));
                                }
                                return retVal;
                            }
                            newNode = deepClone(childFromWidgetXML);
                            //newNode = childFromWidgetXML.cloneNode(true);
                            portletDefNodeFromWidgetXML.removeChild(childFromWidgetXML);
                        }
                        portletDefNode.appendChild(newNode);
                    }
                    else {
                        // throw it out if a matching config preference is already present
                        portletDefNodeFromWidgetXML.removeChild(childFromWidgetXML);
                    }
                }
                
                // move the model:sandboxed attribute of the portlet-definition tag from the widget xml to the portlet-definition tag from the feed
                var sandboxed = com.ibm.mm.enabler.utils.Dom.getAttributeWithNS(portletDefNodeFromWidgetXML, "model:sandboxed", "sandboxed", this.ns.model);
                com.ibm.mm.enabler.utils.Dom.setAttributeWithNS(feed, portletDefNode, "model:sandboxed", "sandboxed", this.ns.model, sandboxed);
            }
            
            expr = "atom:feed/atom:entry[atom:content/model:portlet]";
            var portletNode = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, feed, this.ns) || null;
            
            if (!skipCacheUpdate) {
                var identifier = new com.ibm.mm.enabler.IdentifierImpl(defNode);
                
                var defID = identifier.getID();
                
                if (defID in this.definitions) {
                    this.definitions[defID]._setXMLData(defNode, portletNode);
                }
                else {
                    this.definitions[defID] = new com.ibm.mm.enabler.widget.WidgetDefinitionImpl(defNode, portletNode, this);
                }
                retVal = this.definitions[defID];
                
                if (url) {
                    this.widgetDefinitionIDByURL[url] = defID;
                }
            }
            else {
                retVal = new com.ibm.mm.enabler.widget.WidgetDefinitionImpl(defNode, portletNode, this);
            }
        }
        
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD, retVal);
        }
        
        return retVal;
    },
    /**
     * Gets the parent of the specified childObject.
     * @param {Object} childObject The child object of which to get the parent object
     * @return {Object} the parent of the specified child object or <tt>null</tt> if the specified object doesn't have a parent.
     */
    _getParent: function(childObject){
        // the given object is not extending Definition, Instance or window
        if (!childObject._type) {
            return null;
        }
        
        var type = childObject._type;
        
        var parentObject = null;
        
        if (type == "window") {
            parentObject = this.getWidgetInstance(childObject).start();
        }
        else 
            if (type == "instance") {
                parentObject = this.getWidgetDefinitionByInstance(childObject).start();
            }
            else {
                parentObject = null;
            }
        return parentObject;
    },
    
    discard: function(){
        this.definitions = {};
        this.instances = {};
        this.controls.clear();
        this.windows = {};
        this.cachedWindows = {};
        this._setClean();
    },
    
    invalidate: function(){
        this.discard();
    }
});

}

if(!dojo._hasResource["com.ibm.mashups.enabler.widget.WidgetModel"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.widget.WidgetModel"] = true;
dojo.provide("com.ibm.mashups.enabler.widget.WidgetModel");





}

if(!dojo._hasResource["com.ibm.mm.enabler.persistence.xml.NextLinkProviderXmlImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.persistence.xml.NextLinkProviderXmlImpl"] = true;
dojo.provide("com.ibm.mm.enabler.persistence.xml.NextLinkProviderXmlImpl");











dojo.declare("com.ibm.mm.enabler.persistence.xml.NextLinkProviderXmlImpl", [com.ibm.mashups.enabler.NextLinkProvider], {
    constructor: function(node){
        // initializaion
        this.modelMessages = dojo.i18n.getLocalization("com.ibm.mm.enabler", "modelMessages");
        this.serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_NAVIGATION);
        var nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
        this.ns_nlp = dojo.delegate(this.serviceJson.namespaces, nsf.getNameSpaces([nsf.NS_ATOM]));
    },
    
    _getNextURI: function(){
        var result = null;
        var node = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(com.ibm.mm.enabler.utils.Atom._LINK, this.xmlData, this.ns_nlp);
        if (node) {
            result = com.ibm.mm.enabler.utils.Dom.getAttributeWithNS(node, "ext:rel", "rel", this.ns_nlp.ext);
        }
        else {
            throw new Error(dojo.string.substitute(this.modelMessages.E_ELEMENT_NOT_FOUND_2, [com.ibm.mm.enabler.utils.Atom._LINK, this.toString()]));
        }
        return result;
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.persistence.xml.ThreadingLinkProviderXmlImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.persistence.xml.ThreadingLinkProviderXmlImpl"] = true;
dojo.provide("com.ibm.mm.enabler.persistence.xml.ThreadingLinkProviderXmlImpl");





// threading link provider
dojo.declare("com.ibm.mm.enabler.persistence.xml.ThreadingLinkProviderXmlImpl", null, {
    constructor: function(){
        var nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
        this.ns_tlp = nsf.getNameSpaces([nsf.NS_ATOM]);
    },
    getParentLink: function(){
        return com.ibm.mashups.enabler.xml.XPath.evaluateString(com.ibm.mm.enabler.utils.Atom._IN_REPLY_TO_LINK_HREF, this.xmlData, this.ns_tlp) || null;
    },
    getChildrenLink: function(){
        return com.ibm.mashups.enabler.xml.XPath.evaluateString(com.ibm.mm.enabler.utils.Atom._REPLIES_LINK_HREF, this.xmlData, this.ns_tlp) || null;
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.persistence.xml.XmlPersistenceImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.persistence.xml.XmlPersistenceImpl"] = true;
dojo.provide("com.ibm.mm.enabler.persistence.xml.XmlPersistenceImpl");

dojo.declare("com.ibm.mm.enabler.persistence.xml.XmlPersistenceImpl", null, {
    constructor: function(d){
        this.xmlData = d;
    },
    toString: function(){
        return com.ibm.mm.enabler.utils.Dom.innerXML(this.xmlData);
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.content.persistence.xml.ContentPageXmlImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.content.persistence.xml.ContentPageXmlImpl"] = true;
dojo.provide("com.ibm.mm.enabler.content.persistence.xml.ContentPageXmlImpl");












dojo.declare("com.ibm.mm.enabler.content.persistence.xml.ContentPageXmlImpl", [com.ibm.mashups.enabler.content.ContentPage, com.ibm.mm.enabler.persistence.xml.XmlPersistenceImpl, com.ibm.mm.enabler.persistence.xml.EditLinkProviderXmlImpl, com.ibm.mm.enabler.persistence.xml.IdentifiableXmlImpl, com.ibm.mm.enabler.MetaDataImpl2, com.ibm.mm.enabler.TransformableImpl, com.ibm.mm.enabler.DirtyFlagProviderImpl, com.ibm.mm.enabler.ac.EffectiveAccessImpl], {
    _navigationNode: null,
    
    constructor: function(node, navigationNode) {
        this.xmlData = node;
        this._navigationNode = navigationNode;
	},

    setMetaData: function(name,value, dontBubble) {
        if(this._navigationNode.shouldSyncMetaData() && !dontBubble) {
            this._navigationNode.setMetaData(name,value, true);
        }
        this.inherited(arguments);
    },
    
    removeMetaData: function(name, dontBubble) {
        if(this._navigationNode.shouldSyncMetaData() && !dontBubble) {
            this._navigationNode.removeMetaData(name, true);
        }
        this.inherited(arguments);
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.content.persistence.xml.StaticContentPageXmlImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.content.persistence.xml.StaticContentPageXmlImpl"] = true;
dojo.provide("com.ibm.mm.enabler.content.persistence.xml.StaticContentPageXmlImpl");












dojo.declare("com.ibm.mm.enabler.content.persistence.xml.StaticContentPageXmlImpl", [com.ibm.mashups.enabler.content.StaticContentPage, com.ibm.mm.enabler.content.persistence.xml.ContentPageXmlImpl, com.ibm.mm.enabler.persistence.xml.EditLinkProviderXmlImpl], {
    constructor: function(node) {
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass);
        this.LOG_LEVEL = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
        
        this.cs = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
        
        // service document and initialization
        this.serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_NAVIGATION);
        var nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
        this.ns = dojo.delegate(this.serviceJson.namespaces, nsf.getNameSpaces([nsf.NS_ATOM, nsf.NS_CA]));
        
        // link to static markup
        this._MEDIA_LINK = "atom:link[@ext:rel='media']";
        
        // name of meta data holding the static content URL
        this._LAYOUT_TEMPLATE_REF_MDNAME = "com.ibm.portal.layout.template.ref";
        
        // markup of static content
        this._staticMarkup = null;
        
        // indicator for markup refresh
        this._refreshStaticMarkup = true;
        
        this._isStaticMarkupDirty = false;
    },

    getStaticContentURL: function() {
        return this.getMetaData(this._LAYOUT_TEMPLATE_REF_MDNAME);
    },
    
    setStaticContentURL: function(url) {
        return this.setMetaData(this._LAYOUT_TEMPLATE_REF_MDNAME, url);
    },
    
    confirmSetStaticContentURL: function(url) {
        return this.confirmSetMetaData(this._LAYOUT_TEMPLATE_REF_MDNAME, url);
    },
    
    getStaticMarkup: function() {
        return new com.ibm.mm.enabler.DeferredImpl(this, this._getStaticMarkup);
    },
    
    _getStaticMarkup: function(dfr, sync) {
        // logging support
        var LOG_METHOD = "_getStaticMarkup";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, [dfr, sync]);
        }
        
        if (this._staticMarkup) {
            if (dfr) {
                dfr.finish(this._staticMarkup, com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK);
            }
            return this._staticMarkup;
        }
        
        // page markup link
        var markupURL = null;
        var mediaLink = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(this._MEDIA_LINK, this.xmlData, this.ns);
        if (mediaLink) {
            markupURL = mediaLink.getAttribute("href");
        }
        else {
            if (dfr) {
                dfr.finish(null, com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_NOT_FOUND);
            }
            return null;
        }
        var markupModelURL = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(markupURL, this);
        
        // request markup
        result = {};
        var markupReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(markupModelURL, null, null, true, sync);
        markupReq.read(dojo.hitch(this, function(type, data, xhr, args) {
            if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_LOAD) {
                result.markup = data;
            }
            if (dfr) {
                dfr.finish(result.markup || null, xhr.status);
            }
            result.status = xhr.status;
        }));
        
        // exit trace
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD, [result]);
        }
        
        return result.markup;
    },
    
    setStaticMarkup: function(markup) {
        if (markup && markup != this._staticMarkup) {
            this._isStaticMarkupDirty = true;
            this._staticMarkup = markup;
        }
    },
    
    confirmSetStaticMarkup: function(markup) {
        return this.hasRole(com.ibm.mashups.enabler.ac.RoleType.PRIVILEGED_USER) || this.hasRole(com.ibm.mashups.enabler.ac.RoleType.EDITOR);
    },
    
    refreshStaticMarkup: function() {
        this._refreshStaticMarkup = true;
        this._setDirty();
    },
    
    confirmRefreshStaticMarkup: function() {
        // TODO what to do here?
        return true;
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.content.persistence.xml.ContentNodeFactoryImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.content.persistence.xml.ContentNodeFactoryImpl"] = true;
dojo.provide("com.ibm.mm.enabler.content.persistence.xml.ContentNodeFactoryImpl");
dojo.provide("com.ibm.mm.enabler.content.persistence.xml.ContentNodeFactory");








dojo.declare("com.ibm.mm.enabler.content.persistence.xml.ContentNodeFactoryImpl", null, {
    constructor: function() {
        // we do a lazy init
        this.serviceJson = null;
        // content page type
        this._CONTENT_NODE_TYPE_PAGE = "content-page";
        // content label type
        this._CONTENT_NODE_TYPE_STATIC_PAGE = "static-content-page";
    },
    
    _lazyInit: function() {
        if (this.serviceJson) {
            return;
        }
        // service document and initialization
        this.serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_NAVIGATION);
        var nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
        this.ns = dojo.delegate(this.serviceJson.namespaces, nsf.getNameSpaces([nsf.NS_ATOM]));
    },
    
    createContentNode: function(xmlData, navNode) {
        var result = null;
        this._lazyInit();
        var expr = "atom:content/*";
        var modelElement = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, xmlData, this.ns);
        var type = modelElement ? com.ibm.mm.enabler.utils.Dom.getLocalName(modelElement) : null;
        switch (type) {
            case this._CONTENT_NODE_TYPE_PAGE:
                result = new com.ibm.mm.enabler.content.persistence.xml.ContentPageXmlImpl(null, navNode);
                break;
            case this._CONTENT_NODE_TYPE_STATIC_PAGE:
                result = new com.ibm.mm.enabler.content.persistence.xml.StaticContentPageXmlImpl(null, navNode);
                break;
            default:
                result = new com.ibm.mm.enabler.content.persistence.xml.ContentPageXmlImpl(null, navNode);
                break;
        }
        result.setXml(xmlData, true);
        return result;
    }
});

com.ibm.mm.enabler.content.persistence.xml.ContentNodeFactory = new com.ibm.mm.enabler.content.persistence.xml.ContentNodeFactoryImpl();

}

if(!dojo._hasResource["com.ibm.mm.enabler.navigation.persistence.xml.NavigationElementXmlImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.navigation.persistence.xml.NavigationElementXmlImpl"] = true;
dojo.provide("com.ibm.mm.enabler.navigation.persistence.xml.NavigationElementXmlImpl");

























dojo.declare("com.ibm.mm.enabler.navigation.persistence.xml.NavigationElementXmlImpl", [com.ibm.mashups.enabler.navigation.NavigationElement, com.ibm.mm.enabler.persistence.xml.XmlPersistenceImpl, com.ibm.mm.enabler.persistence.xml.IdentifiableXmlImpl, com.ibm.mm.enabler.TransformableImpl, com.ibm.mm.enabler.persistence.xml.LocalizedXmlImpl, com.ibm.mm.enabler.persistence.xml.DefaultLocalizedXmlImpl, com.ibm.mm.enabler.MetaDataImpl2, com.ibm.mm.enabler.persistence.xml.EditLinkProviderXmlImpl, com.ibm.mm.enabler.persistence.xml.NextLinkProviderXmlImpl, com.ibm.mm.enabler.persistence.xml.ThreadingLinkProviderXmlImpl, com.ibm.mm.enabler.ac.EffectiveAccessImpl, com.ibm.mm.enabler.navigation.persistence.meta.NavigationElementMetaImpl, com.ibm.mm.enabler.DirtyFlagProviderImpl, com.ibm.mm.enabler.space.SpaceIdentifierAspect], {
    constructor: function(){
        this.cs = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
        
        // content node (currently StaticContentPage only)
        this._contentNode = null;
        
        // link to content node
        this._CONTENT_NODE_LINK = "atom:link[@rel='related' and @ext:class='content-node']";
        
        // service document and initialization
        this.serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_NAVIGATION);
        this.prefix = this.serviceJson.idprefix;
        var nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
        this.ns_nav = dojo.delegate(this.serviceJson.namespaces, nsf.getNameSpaces([nsf.NS_ATOM, nsf.NS_CA]));
        
        // link to theme
        this._THEME_LINK = "atom:link[@ext:rel='theme']";
    },
    
    isPrivate: function(){
        return this._isPrivate();
    },
    
    setHidden: function(hide){
        var name = this.cs.getValue("com.ibm.mashups.navigation.hidden");
        this.setMetaData(name, (hide) ? "true" : "false");
    },
    
    confirmSetHidden: function(hide){
        var ret1 = this.confirmSetMetaData("com.ibm.mashups.navigation.hidden", (hide) ? "true" : "false");
        var ret2 = this.confirmSetMetaData("com.ibm.portal.Hidden", (hide) ? "true" : "false");
        return (ret1 && ret2);
    },
    
    getSpaceIdentifier: function(){
        // locate space link
        var result = null;
        var spaceLink = com.ibm.mashups.enabler.xml.XPath.evaluateEntry("atom:link[@ca:rel='application']", this.xmlData, this.ns_nav);
        if (spaceLink) {
            var id = com.ibm.mm.enabler.utils.Utils.getIdFromExtUri(this.prefix, spaceLink);
            var href = spaceLink.getAttribute("href");
            result = new com.ibm.mm.enabler.IdentifierImpl(id, {
                "href": href
            });
        }
        return result;
    },
    
    // deprecated
    getTheme: function(){
        var id = this.getThemeIdentifier();
        return id ? id.getID() : null;
    },
    
    // deprecated
    setTheme: function(id){
        this.setThemeIdentifier(new com.ibm.mm.enabler.IdentifierImpl(id));
    },
    
    getThemeIdentifier: function(){
        // locate theme link
        var result = null;
        var themeLink = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(this._THEME_LINK, this.xmlData, this.ns_nav);
        if (themeLink) {
            var id = com.ibm.mm.enabler.utils.Utils.getIdFromExtUri(this.prefix, themeLink);
            var href = themeLink.getAttribute("href");
            result = new com.ibm.mm.enabler.IdentifierImpl(id, {
                "href": href
            });
        }
        return result || null;
    },
    
    setThemeIdentifier: function(identifier){
        // locate theme link
        var themeLink = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(this._THEME_LINK, this.xmlData, this.ns_nav);
        if (!themeLink) {
            // create link
            themeLink = com.ibm.mm.enabler.utils.Dom.createElement(this.xmlData.ownerDocument, "atom:link", this.ns_nav.atom);
            
            // set theme relation
            com.ibm.mm.enabler.utils.Dom.setAttributeWithNS(this.xmlData.ownerDocument, themeLink, "ext:rel", "rel", this.ns_nav.ext, "theme");
            this.xmlData.appendChild(themeLink);
        }
        // Setting the attribute ext:uri on IE changes the order of the attributes, causing 
        // the navigation node to be committed
        var oldId = com.ibm.mm.enabler.utils.Utils.getIdFromExtUri(this.prefix, themeLink);
        if (oldId != identifier.getID()) {
            // set theme uri
            var themeUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(com.ibm.mashups.enabler.model.url.ModelUrlFactory.THEME_URL, this);
            themeUrl.setNodes([{
                value: identifier.getID(),
                isID: true
            }]);
            com.ibm.mm.enabler.utils.Dom.setAttributeWithNS(this.xmlData.ownerDocument, themeLink, "ext:uri", "uri", this.ns_nav.ext, themeUrl.getModelURI());
        }
        this._setDirty();
    },
    
    getNavigationElementType: function(){
        return this._type;
    },
    
    _createContentNode: function(){
        var entry = com.ibm.mm.enabler.utils.Utils.createNode("atom:entry", this.ns_nav.atom);
        entry.appendChild(com.ibm.mm.enabler.utils.Utils.createNode("atom:id", this.ns_nav.atom));
        var content = com.ibm.mm.enabler.utils.Utils.createNode("atom:content", this.ns_nav.atom);
        content.appendChild(com.ibm.mm.enabler.utils.Utils.createNode("model:static-content-page", this.ns_nav.model));
        entry.appendChild(content);
        var node = com.ibm.mm.enabler.content.persistence.xml.ContentNodeFactory.createContentNode(entry, this);
        node._setClean();
        return node;
    },
    
    getContent: function(){
        return new com.ibm.mm.enabler.DeferredImpl(this, this._getContent);
    },
    
    _getContent: function(dfr, sync){
        // logging support
        var LOG_METHOD = "_getContent";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, arguments);
        }
        
        if (this._contentNode) {
            dfr.finish(this._contentNode, com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK);
            return this._contentNode;
        }
        
        var contentURL;
        // page content link
        var contentLink = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(this._CONTENT_NODE_LINK, this.xmlData, this.ns_nav);
        if (contentLink) {
            contentURL = contentLink.getAttribute("href");
        }
        else {
            // if there is no content link, create a new content to be committed later on
            this._contentNode = this._createContentNode();
            dfr.finish(this._contentNode, com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK);
            return this._contentNode;
        }
        var contentModelURL = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(contentURL, this);
        
        // include access control info
        contentModelURL.addParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT_VALUE_ACCESS_CONTROL);
        
        // include otherwise hidden static content URL meta data
        contentModelURL.addParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_MDNAME, this._LAYOUT_TEMPLATE_REF_MDNAME);
        
        // full representation
        contentModelURL.setParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_REPRESENTATION, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_REPRESENTATION_VALUE_FULL);
        
        // request content
        var result = {};
        var contentReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(contentModelURL, null, null, false, sync);
        contentReq.read(dojo.hitch(this, function(type, data, xhr, args){
            result.status = xhr.status;
            if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_LOAD) {
                var expr = "atom:feed/atom:entry";
                var nodes = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, data, this.ns_nav);
                if (nodes) {
                    this._contentNode = com.ibm.mm.enabler.content.persistence.xml.ContentNodeFactory.createContentNode(nodes, this);
                    result.node = this._contentNode;
                }
                else {
                    result.status = com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_NOT_FOUND;
                }
            }
            dfr.finish(result.node || null, result.status);
        }));
        // exit trace
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD, [result]);
        }
        return result.node;
    },
    
    toString: function(){
        return com.ibm.mm.enabler.utils.Dom.innerXML(this.xmlData);
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.navigation.persistence.xml.NavigationNodeXmlImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.navigation.persistence.xml.NavigationNodeXmlImpl"] = true;
dojo.provide("com.ibm.mm.enabler.navigation.persistence.xml.NavigationNodeXmlImpl");























dojo.declare("com.ibm.mm.enabler.navigation.persistence.xml.NavigationNodeXmlImpl", [com.ibm.mm.enabler.navigation.persistence.xml.NavigationElementXmlImpl], {
    constructor: function(){
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass);
        this.LOG_LEVEL = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
        
        this._fragmentData = null;
        this._fragmentMediaData = null;
        
        // link to layout-view (server runtime content)
        this._LAYOUT_VIEW_LINK = "atom:link[@ext:rel='layout' and @type='text/html']";
        
        // link to resource
        this._RESOURCE_LINK = "atom:link[@ext:rel='resourcefeed']";
        
        // name of meta data holding the static content URL
        this._LAYOUT_TEMPLATE_REF_MDNAME = "com.ibm.portal.layout.template.ref";
        
        // element type
        this._type = com.ibm.mashups.enabler.navigation.Constants.NAVIGATION_PAGE;
    },
    
    getExportPageURL: function(){
        var result = null;
        var resourceLink = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(this._RESOURCE_LINK, this.xmlData, this.ns_nav);
        if (resourceLink) {
            result = resourceLink.getAttribute("href");
        }
        return result || null;
    },
    
    _getFragmentData: function(){
        return this._fragmentData;
    },
    
    _setFragmentData: function(data){
        this._fragmentData = data;
    },
    
    _getFragmentMediaData: function(){
        return this._fragmentMediaData;
    },
    
    _setFragmentMediaData: function(data){
        this._fragmentMediaData = data;
    },
    
    getServerRuntimeMarkup: function(navStateModel){
        return new com.ibm.mm.enabler.DeferredImpl(this, this._getServerRuntimeMarkup, navStateModel);
    },
    
    _getServerRuntimeMarkup: function(dfr, sync, navStateModel){
        // logging support
        var LOG_METHOD = "_getServerRuntimeMarkup";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, arguments);
        }
        var result = {};
        
        // page markup link
        var layoutLink = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(this._LAYOUT_VIEW_LINK, this.xmlData, this.ns_nav);
        if (layoutLink) {
            var markupURL = layoutLink.getAttribute("href");
            
            var markupModelURL = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(markupURL, this);
            
            // 3.0.0.1: if global cache setting is enabled then digest will be digest=skip,  so remove digest and mode
            var digest = markupModelURL.getParameter("digest");
            if (digest == 'skip') {
                markupModelURL.setParameter("mode", null);
                markupModelURL.setParameter("digest", null);
            }
            
            // add URL for stateful layout rendering
            var URLGen = com.ibm.mashups.enabler.model.state.UrlGeneratorFactory.getURLGenerator();
            if (!navStateModel) {
                navStateModel = com.ibm.mashups.enabler.model.state.NavigationStateModelFactory.getNavigationStateModel();
            }
            var stateURL = URLGen.getURL(navStateModel);
            markupModelURL.addParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_STATE_URL, stateURL);
            
            // request markup
            var markupReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(markupModelURL, null, null, true, sync);
            markupReq.enableLogoutVerificationForRawRetrieval();
            markupReq.read(dojo.hitch(this, function(type, data, xhr, args){
                if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_LOAD) {
                    result.markup = data;
                }
                result.status = xhr.status;
                if (dfr) {
                    dfr.finish(result.markup, result.status);
                }
            }));
        }
        else {
            // failed to follow layout view link
            result.markup = null;
            result.status = com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_NOT_FOUND;
            if (dfr) {
                dfr.finish(result.markup, result.status);
            }
        }
        // exit trace
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD, [result]);
        }
        return result.markup;
    },
    
    getServerRuntimeContent: function(){
        return this;
    },
    
    confirmSetDescription: function(description, locale){
        // override confirmSetDescription to check for size limit of page descriptions
        var DEFAULT_LIMIT = 1024;
        var limit = this.cs.getValue(com.ibm.mashups.enabler.services.ConfigConstants.LIMIT_PAGE_DESCRIPTION);
        if (limit) {
            limit = parseInt(limit, 10);
            if (isNaN(limit) || limit < 0) {
                limit = DEFAULT_LIMIT;
            }
        }
        else {
            limit = DEFAULT_LIMIT;
        }
        return (description.length <= limit) &&
        this.inherited(arguments);
    },
    
    shouldSyncMetaData: function(){
        return com.ibm.mashups.enabler.navigation.Factory.getNavigationModel().getStrategy("com.ibm.mashups.enabler.strategy.SyncMetaDataStrategy") !== null;
    },
    
    setMetaData: function(name, value, dontBubble){
        if (this.shouldSyncMetaData() && !dontBubble) {
            var content = this.getContent().start(true);
            if (content) {
                content.setMetaData(name, value, true);
            }
        }
        this.inherited(arguments);
    },
    
    removeMetaData: function(name, dontBubble){
        if (this.shouldSyncMetaData() && !dontBubble) {
            var content = this.getContent().start(true);
            if (content) {
                content.removeMetaData(name, true);
            }
        }
        this.inherited(arguments);
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.navigation.persistence.xml.SharedNavigationNodeXmlImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.navigation.persistence.xml.SharedNavigationNodeXmlImpl"] = true;
dojo.provide("com.ibm.mm.enabler.navigation.persistence.xml.SharedNavigationNodeXmlImpl");




dojo.declare("com.ibm.mm.enabler.navigation.persistence.xml.SharedNavigationNodeXmlImpl", 
[com.ibm.mashups.enabler.navigation.SharedNavigationNode, com.ibm.mm.enabler.navigation.persistence.xml.NavigationNodeXmlImpl], {});

}

if(!dojo._hasResource["com.ibm.mm.enabler.navigation.persistence.xml.SharedNavigationRootXmlImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.navigation.persistence.xml.SharedNavigationRootXmlImpl"] = true;
dojo.provide("com.ibm.mm.enabler.navigation.persistence.xml.SharedNavigationRootXmlImpl");




dojo.declare("com.ibm.mm.enabler.navigation.persistence.xml.SharedNavigationRootXmlImpl", 
[com.ibm.mashups.enabler.navigation.SharedNavigationRoot, com.ibm.mm.enabler.navigation.persistence.xml.NavigationNodeXmlImpl], {});

}

if(!dojo._hasResource["com.ibm.mm.enabler.navigation.persistence.xml.NavigationLabelXmlImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.navigation.persistence.xml.NavigationLabelXmlImpl"] = true;
dojo.provide("com.ibm.mm.enabler.navigation.persistence.xml.NavigationLabelXmlImpl");





dojo.declare("com.ibm.mm.enabler.navigation.persistence.xml.NavigationLabelXmlImpl", [com.ibm.mm.enabler.navigation.persistence.xml.NavigationElementXmlImpl], { // navigation element type
    constructor: function(){
        // element type
        this._type = com.ibm.mashups.enabler.navigation.Constants.NAVIGATION_LABEL;
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.navigation.persistence.xml.NavigationURLXmlImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.navigation.persistence.xml.NavigationURLXmlImpl"] = true;
dojo.provide("com.ibm.mm.enabler.navigation.persistence.xml.NavigationURLXmlImpl");





dojo.declare("com.ibm.mm.enabler.navigation.persistence.xml.NavigationURLXmlImpl", [com.ibm.mm.enabler.navigation.persistence.xml.NavigationElementXmlImpl], {
    constructor: function(){
        // element type
        this._type = com.ibm.mashups.enabler.navigation.Constants.NAVIGATION_URL;
        
        // URL target link
        this._URL_TARGET_LINK = "atom:link[@ext:rel='content-url-target' and @rel='related']";
    },
    
    getURL: function(){
        var result = null;
        var urlLink = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(this._URL_TARGET_LINK, this.xmlData, this.ns_nav);
        if (urlLink) {
            result = urlLink.getAttribute("href");
        }
        return result || null;
    },
    
    setURL: function(url){
        var urlLink = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(this._URL_TARGET_LINK, this.xmlData, this.ns_nav);
        if (!urlLink) {
            urlLink = com.ibm.mm.enabler.utils.Utils.createNode("atom:link", this.ns_nav.atom);
            this.xmlData.appendChild(urlLink);
            urlLink.setAttribute("rel", "related");
            com.ibm.mm.enabler.utils.Dom.setAttributeWithNS(this.xmlData, urlLink, "ext:rel", "rel", this.ns_nav.ext, "content-url-target");
        }
        urlLink.setAttribute("href", url);
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.navigation.persistence.xml.FactoryImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.navigation.persistence.xml.FactoryImpl"] = true;
dojo.provide("com.ibm.mm.enabler.navigation.persistence.xml.FactoryImpl");













dojo.declare("com.ibm.mm.enabler.navigation.persistence.xml.FactoryImpl", null, {
    constructor: function(){
        // we do a lazy init
        this.serviceJson = null;
        
        // navigation page type
        this._NAVIGATION_NODE_TYPE_PAGE = "page";
        // navigation label type
        this._NAVIGATION_NODE_TYPE_LABEL = "label";
        // navigation url type
        this._NAVIGATION_NODE_TYPE_URL = "url";
    },
    
    _lazyInit: function(){
        if (!this.serviceJson) {
            // service document and initialization
            this.serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_NAVIGATION);
            var nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
            this.ns = dojo.delegate(this.serviceJson.namespaces, nsf.getNameSpaces([nsf.NS_ATOM]));
        }
    },
    
    createNavigationElementPersistence: function(xmlData, type){
        var result;
        this._lazyInit();
        var expr = "atom:link[@ext:class='content-node']";
        var contentLink = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, xmlData, this.ns);
        if (!type) {
            type = contentLink ? com.ibm.mm.enabler.utils.Dom.getAttributeWithNS(contentLink, "ext:rel", "rel", this.ns.ext) : null;
        }
        // create persistence implementation
        var c = com.ibm.mashups.enabler.navigation.Constants;
        if ((type == this._NAVIGATION_NODE_TYPE_PAGE) || (type == c.NAVIGATION_PAGE)) {
            var user_own = com.ibm.mm.enabler.utils.Dom.getAttributeWithNS(contentLink, "ext:user-own", "user-own", this.ns.ext);
            if (user_own == "false") {
                result = new com.ibm.mm.enabler.navigation.persistence.xml.SharedNavigationNodeXmlImpl();
            }
            else {
                result = new com.ibm.mm.enabler.navigation.persistence.xml.NavigationNodeXmlImpl();
            }
        }
        else 
            if ((type == this._NAVIGATION_NODE_TYPE_LABEL) || (type == c.NAVIGATION_LABEL)) {
                expr = "//model:navigation-node[@type='shared-root']";
                var sharedRoot = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, xmlData, this.ns);
                if (sharedRoot) {
                    result = new com.ibm.mm.enabler.navigation.persistence.xml.SharedNavigationRootXmlImpl();
                }
                else {
                    result = new com.ibm.mm.enabler.navigation.persistence.xml.NavigationLabelXmlImpl();
                }
            }
            else 
                if ((type == this._NAVIGATION_NODE_TYPE_URL) || (type == c.NAVIGATION_URL)) {
                    result = new com.ibm.mm.enabler.navigation.persistence.xml.NavigationURLXmlImpl();
                }
                else {
                    result = new com.ibm.mm.enabler.navigation.persistence.xml.NavigationNodeXmlImpl();
                }
        result.setXml(xmlData, true);
        return result;
    }
});

com.ibm.mm.enabler.navigation.persistence.xml.Factory = new com.ibm.mm.enabler.navigation.persistence.xml.FactoryImpl();

}

if(!dojo._hasResource["com.ibm.mm.enabler.strategy.PageLoadAheadStrategyExecutor"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.strategy.PageLoadAheadStrategyExecutor"] = true;
dojo.provide("com.ibm.mm.enabler.strategy.PageLoadAheadStrategyExecutor");








dojo.declare("com.ibm.mm.enabler.strategy.PageLoadAheadStrategyExecutor", com.ibm.mm.enabler.LazyLoadSupport, {
    constructor: function(strategies) {
    
        this.strategies = strategies;
        
        this.loadAheadUser = false;
        this.loadAheadCatalogCategoryModel = false;
        this.loadAheadLayoutModel = false;
        this.userLoadAheadStrategy = null;
        this.pageLoadAheadStrategy = null;
        this.catalogCategoryLoadAheadStrategy = null;
        for (var x in this.strategies) {
            if (com.ibm.mm.enabler.utils.Misc.isInstanceOf(this.strategies[x], com.ibm.mashups.enabler.strategy.UserLoadAheadStrategy)) {
                this.loadAheadUser = this.strategies[x].isLoadAheadUser();
                this.userLoadAheadStrategy = this.strategies[x];
            }
            else if (com.ibm.mm.enabler.utils.Misc.isInstanceOf(this.strategies[x], com.ibm.mashups.enabler.strategy.CatalogCategoryLoadAheadStrategy)) {
                /*
                 this.loadAheadCatalogCategoryModel = this.strategies[x].isLoadAheadCatalogCategoryModel();
                 this.catalogCategoryLoadAheadStrategy = this.strategies[x];
                 */
            }
            else if (com.ibm.mm.enabler.utils.Misc.isInstanceOf(this.strategies[x], com.ibm.mashups.enabler.strategy.PageLoadAheadStrategy)) {
                var configService = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
                var pageLoadOptimization = configService.getValue(com.ibm.mashups.enabler.services.ConfigConstants.PAGE_LOAD_OPTIMIZATION);
                if (pageLoadOptimization === true) {
                    this.loadAheadLayoutModel = this.strategies[x].isLoadAheadLayoutModel();
                }
                var pageLoadOptimizationTheme = configService.getValue(com.ibm.mashups.enabler.services.ConfigConstants.PAGE_LOAD_OPTIMIZATION_THEME);
                if (pageLoadOptimization === true) {
                    this.loadAheadTheme = this.strategies[x].isLoadAheadTheme();
                }
                else {
                    this.loadAheadTheme = false;
                }
                this.pageLoadAheadStrategy = strategies[x];
            }
        }
        
        // service document and initialization
        this.serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_NAVIGATION);
        var nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
        this.prefix = this.serviceJson.idprefix;
        this.ns = dojo.delegate(this.serviceJson.namespaces, nsf.getNameSpaces([nsf.NS_ATOM, nsf.NS_THR, nsf.NS_XML, nsf.NS_OPENSEARCH]));
    },
    
    processLoadAhead: function(loadedNodes, layoutModels, sync) {
        if (!com.ibm.mashups.enabler.io.XHRMultipartFactory.isMultipartEnabled()) {
            // nothing to do
            return;
        }
        this.lazyLoadModules(["CatalogModel","ThemeModel","LayoutModel"]);

        var mpHandler = com.ibm.mashups.enabler.io.XHRMultipartFactory.create();
        mpHandler.startTransaction();
        // FIXME Hack!  extract the digest 
        if (loadedNodes.length > 0) {
            var h_expr = "atom:link[@rel='edit']";
            //var h_expr = "atom:link[@rel='edit' and @ext:class='content-node']";
            var h_node = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(h_expr, loadedNodes[0].xmlData, this.ns);
            if (h_node) {
                // href of fragment
                var h_href = h_node.getAttribute("href");
                var h_url = new com.ibm.mm.enabler.utils.HttpUrl(h_href);
                mpHandler.statics.digest = h_url.getParameter("digest");
            }
        }
        
        // Load the current user
        if (this.loadAheadUser) {
            var userModel = this.userLoadAheadStrategy.getUserModel();
            userModel.findCurrentUser().start();
        }
        
        // Catalog Entry Model
        if (this.loadAheadCatalogCategoryModel) {
            var catalogEntryModel = this.catalogCategoryLoadAheadStrategy.getCatalogCategoryModel();
            var rootNode = catalogEntryModel.getRoot().start();
            var iter = catalogEntryModel.getChildren(rootNode);
            iter.hasNext();
        }
        
        // Layout model
        for (var i = 0; i < loadedNodes.length; i++) {
            if (this.loadAheadLayoutModel) {
                // Preload the fragment if the strategy dictates it
                if(loadedNodes[i].getNavigationElementType() == com.ibm.mashups.enabler.navigation.Constants.NAVIGATION_PAGE){
					loadedNodes[i].getContent().start(false);
				}
            }
            if (this.loadAheadTheme) {
                var themeId = loadedNodes[i].getThemeIdentifier().getID();
                if (themeId !== null) {
                    var themeModel = com.ibm.mashups.enabler.theme.Factory.getThemeModel();
                    themeModel.find(themeId).start();
                }
                // skins
                com.ibm.mm.builder.utils.skinUtil.getAllSkins();
            }
        }
        
        if (this.loadAheadLayoutModel) {
            for (var j in layoutModels) {
                if (Object.prototype.hasOwnProperty.call(layoutModels, j)) {
                    var layoutModel = layoutModels[j];
                    layoutModel.getRoot().start(false);
                }
            }
        }
        
        mpHandler.endTransactionDeferred().start();
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.navigation.persistence.xml.NavigationModelXmlImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.navigation.persistence.xml.NavigationModelXmlImpl"] = true;
dojo.provide("com.ibm.mm.enabler.navigation.persistence.xml.NavigationModelXmlImpl");

/*
 * This is injected on the fly and not fetched through an API. Therefore we need to define the @ibm-module so that the build process is picking it up
 * @ibm-module NavigationModelXml
 */





















































// navigation model
dojo.declare("com.ibm.mm.enabler.navigation.persistence.xml.NavigationModelXmlImpl", [com.ibm.mashups.enabler.model.NavigationModel, com.ibm.mm.enabler.model.ModelImpl, com.ibm.mm.enabler.ConfirmableModelImpl, com.ibm.mm.enabler.strategy.HiddenMetaDataLoadingStrategyHelperImpl, com.ibm.mm.enabler.model.SemaphoreHelperImpl, com.ibm.mm.enabler.DirtyFlagProviderImpl, com.ibm.mm.enabler.ServiceDocConsumer, com.ibm.mm.enabler.LazyLoadSupport], {
    constructor: function(){
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass);
        this.LOG_LEVEL = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
        
        // collection of layout models; (name:(navnode)id, value layoutModel)
        this.layoutModels = {};
        
        // client id counter
        this.cid = 0;
        
        // messages
        this.modelMessages = dojo.i18n.getLocalization("com.ibm.mm.enabler", "modelMessages");
        
        this.urlType = com.ibm.mashups.enabler.model.url.ModelUrlFactory.NAVIGATION_URL;
        
        // atom entry
        this._ATOM_ENTRY = "atom:feed/atom:entry";
        
        // atom link
        this._ATOM_LINK = "atom:link";
        
        // content node link
        this._CONTENT_NODE_LINK = this._ATOM_LINK + "[@rel='related' and @ext:class='content-node']";
        
        // layout link
        this._LAYOUT_LINK = this._ATOM_LINK + "[@rel='related' and @ext:rel='layout']";
        
        // static markup link
        this._MEDIA_LINK = this._ATOM_LINK + "[@ext:rel='media']";
        
        // next link
        this._NEXT_LINK = this._ATOM_LINK + "[@rel='next']";
        
        // replies link
        this._REPLIES_LINK = this._ATOM_LINK + "[@rel='replies']";
        
        // in-reply-to link
        this._IN_REPLY_TO_LINK = "thr:in-reply-to";
        
        // name of meta data holding the static content URL
        this._LAYOUT_TEMPLATE_REF_MDNAME = "com.ibm.portal.layout.template.ref";
        
        this.THR_INREPLYTO_URI_PREFIX = this._IN_REPLY_TO_LINK + "[@ext:uri='";
        
        this.THR_INREPLYTO_URI_SUFFIX = "']";
        
        this.initialContents = {};
        
        // invalidate children is not needed here
        dojo.subscribe(com.ibm.mashups.enabler.model.NavigationModel.TOPIC_INVALIDATE_NODE, this, "_invalidateNode");
    },
    _initServiceDoc: function(){
        this.inherited("_initServiceDoc", arguments);
        // service document and initialization
        this.serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_NAVIGATION);
        this.entryUrl = this.serviceJson.url;
        this.prefix = this.serviceJson.idprefix;
        var nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
        this.ns = dojo.delegate(this.serviceJson.namespaces, nsf.getNameSpaces([nsf.NS_ATOM, nsf.NS_THR, nsf.NS_XML, nsf.NS_OPENSEARCH, nsf.NS_XHTML, nsf.NS_APP]));
        
        this.fragmentServiceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_CONTENT);
        this.fragmentPrefix = this.serviceJson.idprefix;
        
        var serviceJsonSN = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_SPACE_NAVIGATION);
        this.spaceNavigationEntryUrl = serviceJsonSN.url;
    },
    
    // singleton
    _getInstance: function(){
        var instance = com.ibm.mm.enabler.navigation.persistence.xml.NavigationModelXmlImpl._instance;
        return instance ? instance : (com.ibm.mm.enabler.navigation.persistence.xml.NavigationModelXmlImpl._instance = new com.ibm.mm.enabler.navigation.persistence.xml.NavigationModelXmlImpl());
    },
    
    _setNavigationModelDirty: function(){
        this._setDirty();
    },
    
    find: function(uri){
        return new com.ibm.mm.enabler.DeferredImpl(this, this._find, uri);
    },
    
    getSharedRoot: function(){
        return this.findDefaultAcceptParent();
    },
    
    findDefaultAcceptParent: function(){
        return this.getRoot();
    },
    
    getRoot: function(){
        return new com.ibm.mm.enabler.DeferredImpl(this, function(dfr, sync){
            return this._find(dfr, sync, "collection");
        });
    },
    
    hasChildren: function(node){
        return this._getChildrenLink(node) ? true : false;
    },
    
    _getChildrenLink: function(node){
        node = this._resolve(node);
        this._initServiceDoc();
        return com.ibm.mashups.enabler.xml.XPath.evaluateString(this._REPLIES_LINK + "/@href", node.getXml(), this.ns);
    },
    
    _resolve: function(node){
        if (!node) {
            throw new Error(this.modelMessages.E_NODE_ISNULL_0);
        }
        // TODO must not be done here but in the uber model
        return dojo.isString(node) ? this.find(node).start() : node;
    },
    
    getParent: function(uri, context){
        return new com.ibm.mm.enabler.DeferredImpl(this, function(dfr, sync, node){
            node = this._resolve(node);
            var parent = null;
            if (node !== null) {
                // check node for 'in-reply-to' link
                var replyLink = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(this._IN_REPLY_TO_LINK + "[@ext:uri]", node.getXml(), this.ns);
                if (replyLink) {
                    // parent id
                    var parentId = com.ibm.mm.enabler.utils.Utils.getIdFromExtUri(this.prefix, replyLink);
                    
                    if (context) {
                        parent = context.lookupNodeInCache(parentId);
                    }
                    if (parent) {
                        // fetch node from cache
                        if (dfr) {
                            dfr.finish(parent, com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK);
                        }
                    }
                    else {
                        parent = this._find(dfr, sync, parentId, true);
                    }
                }
                else {
                    // no parent link; return null
                    if (dfr) {
                        dfr.finish(null, com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_NOT_FOUND);
                    }
                }
            }
            // compatibility: only meaningful in sync mode
            return parent || null;
        }, uri);
    },
    
    /**
     * @param {Object} node
     * @param {Object} parentNode
     * @param {Object} urlType
     */
    _setParent: function(node, parentNode, urlType){
        if (node !== null && parentNode !== null) {
            this._initServiceDoc();
            var modelUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(urlType, this);
            modelUrl.setNodes([{
                value: parentNode.getID(),
                isID: true
            }]);
            var replyLink = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(this._IN_REPLY_TO_LINK, node.getXml(), this.ns);
            if (!replyLink) {
                replyLink = com.ibm.mm.enabler.utils.Utils.createNode(this._IN_REPLY_TO_LINK, this.ns.thr);
                node.getXml().appendChild(replyLink);
            }
            com.ibm.mm.enabler.utils.Dom.setAttributeWithNS(node.getXml().ownerDocument, replyLink, "ext:uri", "uri", this.ns.ext, modelUrl.getModelURI());
            replyLink.setAttribute("ref", modelUrl.getModelURI());
            replyLink.setAttribute("href", modelUrl.getAbsoluteURL());
        }
    },
    
    /**
     * This is also used by the LayoutModel!!
     *
     * @param {Object} node
     * @param {Object} nextNode
     */
    _setNext: function(node, nextNode){
        if (node) {
            this._initServiceDoc();
            var next = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(this._NEXT_LINK, node.getXml(), this.ns);
            var modelUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(this.urlType, this);
            if (next) {
                if (nextNode) {
                    // update next link
                    modelUrl.setNodes([{
                        value: nextNode.getID(),
                        isID: true
                    }]);
                    next.setAttribute("href", "?uri=" + modelUrl.getModelURI());
                    com.ibm.mm.enabler.utils.Dom.setAttributeWithNS(node.getXml().ownerDocument, next, "ext:uri", "uri", this.ns.ext, modelUrl.getModelURI());
                }
                else {
                    dojo.destroy(next);
                }
            }
            else 
                if (nextNode) {
                    // create next link
                    modelUrl.setNodes([{
                        value: nextNode.getID(),
                        isID: true
                    }]);
                    next = com.ibm.mm.enabler.utils.Utils.createNode(this._ATOM_LINK, this.ns.atom);
                    next.setAttribute("href", "?uri=" + modelUrl.getModelURI());
                    next.setAttribute("rel", "next");
                    next.setAttribute("type", "application/atom+xml");
                    com.ibm.mm.enabler.utils.Dom.setAttributeWithNS(node.getXml().ownerDocument, next, "ext:uri", "uri", this.ns.ext, modelUrl.getModelURI());
                    node.getXml().appendChild(next);
                }
        }
    },
    
    _replaceNext: function(oldID, newID, loadedNodes){
        // now we need to replace the previous node with the new server side ID
        var isServerID = com.ibm.mashups.enabler.services.IdentificationService.isServerID(oldID);
        if (!isServerID) {
            // it is sufficient if we do this in memory
            com.ibm.mm.enabler.utils.Misc.forIn(loadedNodes, function(node, id){
                var nextLink = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(this._NEXT_LINK, node.getXml(), this.ns);
                if (nextLink) {
                    var nextId = com.ibm.mm.enabler.utils.Utils.getIdFromExtUri(this.prefix, nextLink);
                    // this is the ID we want to replace
                    if (nextId == oldID) {
                        var modelUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(this.urlType, this);
                        if (newID) {
                            // update next link
                            modelUrl.setNodes([{
                                value: newID,
                                isID: true
                            }]);
                            nextLink.setAttribute("href", "?uri=" + modelUrl.getModelURI());
                            com.ibm.mm.enabler.utils.Dom.setAttributeWithNS(node.getXml().ownerDocument, nextLink, "ext:uri", "uri", this.ns.ext, modelUrl.getModelURI());
                        }
                        else {
                            dojo.destroy(nextLink);
                        }
                        this.initialContents[node.getID()] = node.toString();
                    }
                }
            }, this);
        }
    },
    
    _setRepliesLink: function(parentNode){
        // add replies link to the new parent in case there is no such link yet
        replies = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(this._REPLIES_LINK, parentNode.getXml(), this.ns);
        if (!replies) {
            var modelUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(this.urlType, this);
            // create replies link
            modelUrl.setNodes([{
                value: parentNode.getID(),
                isID: true
            }]);
            
            // two levels
            modelUrl.setParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_LEVELS, "2");
            
            // full representation
            modelUrl.setParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_REPRESENTATION, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_REPRESENTATION_VALUE_FULL);
            
            var xmlDom = parentNode.getXml().ownerDocument;
            replies = com.ibm.mm.enabler.utils.Dom.createElement(xmlDom, this._ATOM_LINK, this.ns.atom);
            replies.setAttribute("href", modelUrl.getAbsoluteURL());
            replies.setAttribute("rel", "replies");
            replies.setAttribute("type", "application/atom+xml");
            com.ibm.mm.enabler.utils.Dom.setAttributeWithNS(xmlDom, replies, "ext:uri", "uri", this.ns.ext, modelUrl.getModelURI());
            parentNode.getXml().appendChild(replies);
        }
    },
    
    insert: function(node, parentNode, nextNode, ctx){
        this._initServiceDoc();
        // logging support
        var LOG_METHOD = "insert";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, [node, parentNode, nextNode]);
        }
        // fetch previous node at this early stage to get the "current" previous node
        var prev = ctx.getPrevNode();
        if (ctx.isManaged(node.getID())) {
            // update next link of old previous node
            var siblings = ctx.getOldSiblings();
            if (siblings && siblings.prev) {
                this._setNext(siblings.prev, siblings.next);
            }
            // update replies link of old parent node
            if (ctx.wasOnlyChild()) {
                var replies = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(this._REPLIES_LINK, ctx.getOldParent().getXml(), this.ns);
                if (replies) {
                    // remove replies link
                    replies.parentNode.removeChild(replies);
                }
            }
            // remember old parent so that we can invalidate it later
            node.__oldParentID = ctx.getOldParent().getID();
        }
        else {
            ctx.nodeInserted(node);
        }
        
        // update replies link of new parent node
        if (ctx.isOnlyChild) {
            this._setRepliesLink(parentNode);
        }
        
        // update next link of new previous node
        if (prev) {
            this._setNext(prev, node);
        }
        
        // update parent link of node itself
        this._setParent(node, parentNode, this.urlType);
        
        // update next link of node itself
        this._setNext(node, nextNode);
        
        // force content node creation
        if (ctx.isCreated(node.getID())) {
            var content = node.getContent().start();
            
            // page content link
            var links = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(this._CONTENT_NODE_LINK, parentNode.getXml(), this.ns);
            if (links) {
                var uri = com.ibm.mm.enabler.utils.Dom.getAttributeWithNS(links, "ext:uri", "uri", this.ns.ext);
                if (uri) {
                    parentId = new com.ibm.mm.enabler.IdentifierImpl(uri);
                }
            }
            // set content parent
            this._setParent(content, parentId || parentNode, com.ibm.mashups.enabler.model.url.ModelUrlFactory.FRAGMENT_URL);
        }
        
        // mark node as dirty
        node.setDirty();
        
        // exit trace
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD);
        }
    },
    
    confirmInsert: function(node, parentNode, nextNode, ctx){
        // TEMPORARY FIX
        if (node === null || typeof node == 'undefined') {
            console.warn("TEMPORARY FIX: Gracefully returning 'true' on NavigationModel.confirmInsert(node) with null or undefined node.");
            return true;
        }
        
        if (node) {
            var isReparent = false;
            
            // check for client id
            if (com.ibm.mm.enabler.model.Utils.isClientNode(node)) {
                if (parentNode) {
                    if (parentNode.isPrivate()) {
                        return node.isPrivate();
                    }
                    else {
                        return parentNode.hasRole(node.isPrivate() ? com.ibm.mashups.enabler.ac.RoleType.PRIVILEGED_USER : com.ibm.mashups.enabler.ac.RoleType.EDITOR);
                    }
                }
                else {
                    return false;
                }
            }
            else {
                var oldParent = ctx.getOldParent();
                if (oldParent) {
                    if (oldParent.getID() != parentNode.getID()) {
                        isReparent = true;
                    }
                }
                if (isReparent) {
                    // trying to reparent
                    return this.getConfirmReparent(node, oldParent, parentNode, nextNode);
                }
                else {
                    // assume it is a move
                    return this.getConfirmReorder(node, parentNode, nextNode);
                }
            }
        }
    },
    
    confirmExport: function(node){
        return (com.ibm.mm.enabler.AnonymousHelper.getAnonymousMode() == com.ibm.mashups.enabler.user.AnonymousMode.ANONYMOUS) ? false : true;
    },
    
    remove: function(node, ctx){
        this._initServiceDoc();
        
        // logging support
        var LOG_METHOD = "remove";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, [node]);
        }
        
        // parent page
        var parent = ctx.parent;
        
        // remove replies-link of the parent, if the node to delete is the only child
        if (parent && ctx.isOnlyChild) {
            var repliesLink = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(this._REPLIES_LINK, parent.getXml(), this.ns);
            if (repliesLink) {
                repliesLink.parentNode.removeChild(repliesLink);
            }
        }
        
        // exit trace
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD);
        }
    },
    
    confirmRemove: function(node){
        if (!com.ibm.mm.enabler.utils.Misc.isInstanceOf(node, com.ibm.mashups.enabler.Identifiable)) {
            node = this.find(node).start(true);
        }
        return this.getConfirmRemove(node);
    },
    
    hasLayoutModel: function(node){
        var page = this._resolve(node);
        // fetch uri from navigation node
        if (page) {
            this._initServiceDoc();
            var layoutLink = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(this._LAYOUT_LINK, page.getXml(), this.ns);
            if (layoutLink) {
                return true;
            }
        }
        return false;
    },
    
    getLayoutModel: function(node){
        if (!this.hasLayoutModel(node)) {
            return null;
        }
        
        var nodeId = null;
        if (typeof(node) == "string") {
            // should never happen
            nodeId = node;
            node = this._find(null, true, nodeId);
        }
        else {
            nodeId = node.getID();
        }
        
        // check for cached layout model
        if (!(nodeId in this.layoutModels)) {
            this.lazyLoadModules(["LayoutModel"]);
            
            var layoutURL;
            var layoutURI;
            // fetch URI/URL from navigation node
            if (node) {
                var layoutLink = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(this._LAYOUT_LINK, node.getXml(), this.ns);
                if (layoutLink) {
                    layoutURL = layoutLink.getAttribute("href");
                    layoutURI = com.ibm.mm.enabler.utils.Utils.getIdFromExtUri(this.prefix, layoutLink);
                }
            }
            this.layoutModels[nodeId] = new com.ibm.mm.enabler.layout.LayoutModelImpl(layoutURL || null, layoutURI || nodeId, node);
            this.layoutModels[nodeId]._addDirtyCallback(this, this._setNavigationModelDirty);
            
            // preload page artifacts
            if (com.ibm.mashups.enabler.io.XHRMultipartFactory.isMultipartEnabled() && (this.strategy !== null) &&
            (node) &&
            (!node._fragmentData)) {
                // See if we have a multipart strategy
                var executor = new com.ibm.mm.enabler.strategy.PageLoadAheadStrategyExecutor(this.strategy);
                executor.processLoadAhead([node], [this.layoutModels[nodeId]], false);
            }
        }
        return this.layoutModels[nodeId];
    },
    
    _postContentNode: function(contentNode, navNodeId){
        var LOG_METHOD = "_postContentNode";
        var sync = true;
        var result = com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK;
        this._initServiceDoc();
        
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        
        var cleanOutLayoutCSS = false;

        // HTTP POST content node
        var serviceCollection = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_CONTENT);
        var contentURL = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(serviceCollection.url, this);
        
        // refresh static markup 
        if (contentNode._refreshStaticMarkup) {
            contentURL.setParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_MODE, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_MODE_VALUE_REFRESH);
            cleanOutLayoutCSS = true;
        }
        
        // full representation
        contentURL.setParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_REPRESENTATION, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_REPRESENTATION_VALUE_FULL);
        
        var contentReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(contentURL, null, null, false, sync);
        contentReq.create(contentNode.toString(), dojo.hitch(this, function(type, data, xhr, args){
            if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_LOAD) {
                if (data !== null) {
                    // replace current content node
                    var node = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(this._ATOM_ENTRY, data, this.ns);
                    if (node) {
                        contentNode.setXml(node, true);
                        contentNode._setClean();
                        contentNode._refreshStaticMarkup = false;
                    }
                }
            }
            else 
                if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_ERROR) {
                    result = xhr.status;
                    
                    if (bIsLoggable) {
                        this.LOGGER.warning(LOG_METHOD, this.modelMessages.E_XHR_REQUEST_FAILED_2, [xhr, data || "n/a"]);
                    }
                }
        }));
        if (result == com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK) {
            // HTTP POST static markup
            if (contentNode._staticMarkup) {
                cleanOutLayoutCSS = true;
                // markup link
                var xmlResult = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(this._MEDIA_LINK, contentNode.getXml(), this.ns);
                if (xmlResult) {
                    var markupURL = xmlResult.getAttribute("href");
                    var markupModelURL = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(markupURL, this);
                    
                    // create request
                    var markupReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(markupModelURL, null, null, true, sync);
                    markupReq.create(contentNode._staticMarkup, dojo.hitch(this, function(type, data, xhr, args){
                        if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_LOAD) {
                            contentNode._staticMarkup = data;
                            contentNode._isStaticMarkupDirty = false;
                        }
                        else 
                            if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_ERROR) {
                                if (bIsLoggable) {
                                    this.LOGGER.warning(LOG_METHOD, this.modelMessages.E_XHR_REQUEST_FAILED_2, [xhr, data || "n/a"]);
                                }
                            }
                    }));
                }
            }
        }
        if (cleanOutLayoutCSS) {
            // check for cached layout model
            if (navNodeId in this.layoutModels) {
                var lm = this.getLayoutModel(navNodeId);
                this._clearLayoutNodeCSSMetaData(lm, lm.getRoot().start(true));
            }
        }
        return result;
    },
    
    _putContentNode: function(contentNode, navNodeId){
        var LOG_METHOD = "_putContentNode";
        var sync = true;
        this._initServiceDoc();
        
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        
        var cleanOutLayoutCSS = false;

        // HTTP PUT content node
        var url = contentNode.getEditLink();
        var contentURL = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(url, this);
        
        // refresh static markup
        if (contentNode._refreshStaticMarkup) {
            contentURL.setParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_MODE, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_MODE_VALUE_REFRESH);
            cleanOutLayoutCSS = true;
        }
        
        // full representation
        contentURL.setParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_REPRESENTATION, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_REPRESENTATION_VALUE_FULL);
        
        // update by replacement
        contentURL.setParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_UPDATE, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_UPDATE_VALUE_REPLACE);
        
        // include otherwise hidden static content URL meta data
        contentURL.addParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_MDNAME, this._LAYOUT_TEMPLATE_REF_MDNAME);
        
        var contentReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(contentURL, null, null, false, sync);
        contentReq.update(contentNode.toString(), dojo.hitch(this, function(type, data, xhr, args){
            if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_LOAD) {
                if (data !== null) {
                    // replace current content node
                    var node = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(this._ATOM_ENTRY, data, this.ns);
                    if (node) {
                        contentNode.xmlData = node;
                        contentNode._setClean();
                        contentNode._refreshStaticMarkup = false;
                    }
                }
            }
            else 
                if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_ERROR) {
                    if (bIsLoggable) {
                        this.LOGGER.warning(LOG_METHOD, this.modelMessages.E_XHR_REQUEST_FAILED_2, [xhr, data || "n/a"]);
                    }
                }
        }));
        
        // HTTP PUT static markup
        if (contentNode._staticMarkup && contentNode._isStaticMarkupDirty) {
            cleanOutLayoutCSS = true;
            // markup link
            var xmlResult = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(this._MEDIA_LINK, contentNode.getXml(), this.ns);
            if (xmlResult) {
                var markupURL = xmlResult.getAttribute("href");
                var markupModelURL = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(markupURL, this);
                
                // update request
                var markupReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(markupModelURL, null, null, true, sync);
                markupReq.update(contentNode._staticMarkup, dojo.hitch(this, function(type, data, xhr, args){
                    if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_LOAD) {
                        contentNode._staticMarkup = data;
                        contentNode._isStaticMarkupDirty = false;
                    }
                    else 
                        if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_ERROR) {
                            if (bIsLoggable) {
                                this.LOGGER.warning(LOG_METHOD, this.modelMessages.E_XHR_REQUEST_FAILED_2, [xhr, data || "n/a"]);
                            }
                        }
                }));
            }
        }
        if (cleanOutLayoutCSS) {
            // check for cached layout model
            if (navNodeId in this.layoutModels) {
                var lm = this.getLayoutModel(navNodeId);
                this._clearLayoutNodeCSSMetaData(lm, lm.getRoot().start(true));
            }
        }
    },

    _clearLayoutNodeCSSMetaData: function(lm, node) {
        var children = lm.getChildren(node);
        while(children.hasNext()) { 
            var child = children.next();
            child.removeMetaData("css-style");
            if (child.getLayoutNodeType() == com.ibm.mashups.enabler.layout.Constants.LAYOUT_CONTAINER) {
                // this is a bit of special logic:
                // Because of the usecase when one changes the size of a container (e.g. by changing the width) in one layout template
                // (e.g. 2 column layout) and then immediately changes into a freeform layout we run into a situation where
                // first the layout is changed and then afterwards the container is attempted to be persisted. This fails as there is no
                // container available anymore besides the one freeform container.
                // In order to get around the incorrect request we tell the enabler that this node is clean and doesn't need to be persisted.
                child._setClean();
            }
            if (lm.hasChildren(child)) {
                this._clearLayoutNodeCSSMetaData(lm, child);
            }
        }
    },
    
    create: function(context){
        this._initServiceDoc();
        // atom:entry
        var entry = com.ibm.mm.enabler.utils.Atom.createEntry(null, "model:navigation-node", this.ns.model).entryElement;
        
        var type = (context && context.type) ? context.type : com.ibm.mashups.enabler.navigation.Constants.NAVIGATION_PAGE;
        if (type == com.ibm.mashups.enabler.navigation.Constants.NAVIGATION_PAGE) {
            if (context && context.template) {
                // clone node from template node
                entry = context.template.getXml().cloneNode(true);
                // remove parent info
                var parent = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(this._IN_REPLY_TO_LINK, entry, this.ns);
                if (parent) {
                    parent.parentNode.removeChild(parent);
                }
            }
        }
        else 
            if (type == com.ibm.mashups.enabler.navigation.Constants.NAVIGATION_LABEL) {
            }
            else 
                if (type == com.ibm.mashups.enabler.navigation.Constants.NAVIGATION_URL) {
                }
                else {
                    throw new Error(this.modelMessages.E_INVALID_CONTEXT_SPECIFIED_0);
                }
        var node = com.ibm.mm.enabler.navigation.persistence.xml.Factory.createNavigationElementPersistence(entry, type);
        if (node) {
            var cid = com.ibm.mashups.enabler.model.Constants.CLIENT_ID_PREFIX + ((context && context.cid) ? context.cid : this.cid++);
            node._setRawID(cid);
            
            // access control info
            node._setRole(com.ibm.mashups.enabler.ac.RoleType.USER);
            node._setRole(com.ibm.mashups.enabler.ac.RoleType.EDITOR);
            node._setRole(com.ibm.mashups.enabler.ac.RoleType.MANAGER);
            node._setRole(com.ibm.mashups.enabler.ac.RoleType.PRIVILEGED_USER);
            node._setUserOwned(true);
            
            //node._setDirty();
            node._addDirtyCallback(this, this._setNavigationModelDirty);
        }
        return node || null;
    },
    
    confirmCreate: function(context){
        return this.getConfirmCreate();
    },
    
    commit: function(ctx){
        return new com.ibm.mm.enabler.DeferredOperationImpl(this, function(deferred, sync){
            this._initServiceDoc();
            // logging support
            var LOG_METHOD = "_commit";
            var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
            if (bIsLoggable) {
                this.LOGGER.entering(LOG_METHOD, [deferred, sync]);
            }
            
            var nodes = ctx.getNodes();
            var loadedNodes = nodes.loadedNodes;
            var createdNodes = nodes.createdNodes;
            var deletedNodes = nodes.deletedNodes;
            
            var id, serviceReq, myUrl, expr, entry, page, content, modelUrl, edit;
            
            var toInvalidate = [];
            
            // nodes to create
            var toCreate = [];
            
            // nodes to update
            var toUpdate = [];
            
            // key-value pairs of created nodes (key) pointing to created nodes (value) 
            var nextCid = {};
            
            // initialize arrays
            com.ibm.mm.enabler.utils.Misc.forIn(loadedNodes, function(node, id){
                if (id in createdNodes) {
                    toCreate.push(id);
                    var nextLink = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(this._NEXT_LINK, node.getXml(), this.ns);
                    if (nextLink) {
                        var nextId = com.ibm.mm.enabler.utils.Utils.getIdFromExtUri(this.prefix, nextLink);
                        if (createdNodes[nextId] === null) { // note: value is null for created nodes
                            // compile key-value pair for each created node pointing
                            // to another created node (createdId, nextCreatedId)
                            nextCid[id] = nextId;
                            // remove "next"-link from xml representation; the order is
                            // preserved by the order in which the nodes are POSTed
                            nextLink.parentNode.removeChild(nextLink);
                        }
                    }
                }
                else {
                    var testContent = loadedNodes[id]._contentNode;
                    if (loadedNodes[id].isDirty() ||
                    (testContent && (testContent.isDirty() || testContent._isStaticMarkupDirty))) {
                        toUpdate.push(id);
                    }
                }
            }, this);
            
            var toCreateOrdered = [];
            
            // order created nodes by dependencies
            dojo.forEach(toCreate, function(id){
                var nextId = nextCid[id];
                if (nextId) {
                    // put it before the next id
                    var index = dojo.indexOf(toCreateOrdered, nextId);
                    toCreateOrdered.splice(index == -1 ? 0 : index, 0, id);
                }
                else {
                    toCreateOrdered.push(id);
                }
            }, this);
            
            // initialize overall status
            var status = {};
            status.code = parseInt(com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK, 10);
            
            // first (empty) element in deferred chain
            var initialDfr = new com.ibm.mm.enabler.DeferredImpl(this, function(chainDfr, sync, params){
                chainDfr.finish(); // trigger next deferred in chain
            });
            var chainDfr = initialDfr;
            
            var failedNodes = {};
            
            // created nodes
            dojo.forEach(toCreateOrdered, function(id){
                var dfr = new com.ibm.mm.enabler.DeferredImpl(this, function(chainDfr, sync, args){
                    // id of page to POST
                    var id = args.id;
                    // overall status to update
                    var status = args.status;
                    // deferred object of commit function
                    var baseDfr = args.baseDfr;
                    /* do not create fragment/fragment-media for shared nodes which are inserted into the navigation topology */
                    var contentLink = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(this._CONTENT_NODE_LINK, loadedNodes[id].getXml(), this.ns);
                    page = loadedNodes[id];
                    var model = ctx.getModel();
                    var parent = dojo.hitch(model, model.getParent)(ctx.getModelNode(page)).start();
                    // TODO-DANIEL: This happens for newly created pages because we have no parent relation ship in the ubermodel.
                    // needs to be added and this to be removed
                    if (parent == null) {
                        parent = this.getParent(page).start();
                    }
                    var postStatus = com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK;
                    if (!contentLink) {
                        // force content creation
                        content = page.getContent().start() || null;
                        postStatus = this._postContentNode(content, id);
                        
                        if (postStatus == com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK) {
                        
                            // content reference
                            var fragmentHref = content.getEditLink();
                            // content uri
                            expr = "atom:id";
                            var fragmentUri = com.ibm.mashups.enabler.xml.XPath.evaluateString(expr, content.getXml(), this.ns);
                            
                            // create content link
                            var xmlData = loadedNodes[id].getXml();
                            var link = com.ibm.mm.enabler.utils.Dom.createElement(xmlData.ownerDocument, this._ATOM_LINK, this.ns.atom);
                            // FIX (Opera): set the rel="related" attribute BEFORE the ext:rel 
                            // attribute; otherwise, the rel attribute is set as ext:rel attribute
                            link.setAttribute("rel", "related");
                            link.setAttribute("href", fragmentHref);
                            link.setAttribute("type", "application/atom+xml");
                            com.ibm.mm.enabler.utils.Dom.setAttributeWithNS(xmlData.ownerDocument, link, "ext:rel", "rel", this.ns.ext, "page");
                            com.ibm.mm.enabler.utils.Dom.setAttributeWithNS(xmlData.ownerDocument, link, "ext:class", "class", this.ns.ext, "content-node");
                            com.ibm.mm.enabler.utils.Dom.setAttributeWithNS(xmlData.ownerDocument, link, "ext:uri", "uri", this.ns.ext, fragmentUri);
                            xmlData.appendChild(link);
                        }
                    }
                    if (postStatus == com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK) {
                    
                        modelUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(this.urlType, this);
                        modelUrl.setNodes([{
                            value: id,
                            isID: true
                        }]);
                        entry = com.ibm.mm.enabler.utils.Utils.createFeed(modelUrl.getModelURI(), "IBM Lotus Mashups Navigation Feed", loadedNodes[id], this.ns);
                        
                        // we are in the space scenarios so POST against another collection
                        myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(parent.getSpaceIdentifier() ? this.spaceNavigationEntryUrl : this.entryUrl, this);
                        
                        // include access control info
                        myUrl.addParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT_VALUE_ACCESS_CONTROL);
                        
                        // include space info
                        myUrl.addParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT_VALUE_COMPOSITE_APPLICATION);
                        
                        // include all information
                        myUrl.setParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_REPRESENTATION, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_REPRESENTATION_VALUE_FULL);
                        serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
                        serviceReq.create(entry, dojo.hitch(this, function(type, data, xhr, args){
                            // id of page to POST
                            var id = args.id;
                            // overall status to update
                            var status = args.status;
                            // deferred object of commit function
                            var baseDfr = args.baseDfr;
                            // deferred chain object
                            var chainDfr = args.chainDfr;
                            if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_ERROR) {
                                if (bIsLoggable) {
                                    this.LOGGER.warning(LOG_METHOD, this.modelMessages.E_XHR_REQUEST_FAILED_2, [xhr, data || "n/a"]);
                                }
                            }
                            else {
                                var createdEntry = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(this._ATOM_ENTRY, data, this.ns);
                                if (createdEntry) {
                                    // update navigation node xml data
                                    page.setXml(createdEntry);
                                    
                                    // update navigation node caches
                                    this.initialContents[page.getID()] = page.toString();
                                    
                                    ctx.nodeCreated(id, page);
                                    // TODO OLIVER/DANIEL
                                    // This fixes the usecase of creating a new page when no child node is available yet
                                    // as well as the normal create sibling usecase. forcing a relaod broke the read scenario
                                    // the core reason is because hasChildren will still return false
                                    // UNLESS the original node is changed as this is being held by builder
                                    // AND additionally it has to be invalidated as the JSON layer holds on to the old information
                                    this._setRepliesLink(parent);
                                    this._replaceNext(id, page.getID(), loadedNodes);
                                    
                                    // we need to send the invalidate directly because sometimes the navigation is being re-rendered before the
                                    // commit has been finished
                                    
                                    dojo.publish(com.ibm.mashups.enabler.model.NavigationModel.TOPIC_INVALIDATE_CHILDREN, [{
                                        nodes: parent.getID()
                                    }]);
                                    
                                    // update layout model caches
                                    if (this.layoutModels[id] && !this.layoutModels[page.getID()]) {
                                        this.layoutModels[page.getID()] = this.layoutModels[id];
                                        this._invalidateLayoutModel(id);
                                    }
                                    
                                    // operation callback on base deferred
                                    if (baseDfr && baseDfr.operationCallback) {
                                        baseDfr.operationCallback(ctx.getModelNode(page), com.ibm.mashups.enabler.DeferredOperation.OPERATION_CREATE, xhr.status, baseDfr.operationCallbackParameters);
                                    }
                                }
                            }
                            // status
                            status.code = this._overallStatus(xhr.status, status.code);
                            chainDfr.finish(); // trigger next deferred in chain
                        }), {
                            // xhr arguments
                            id: id,
                            baseDfr: baseDfr,
                            chainDfr: chainDfr,
                            status: status
                        }); // JSLINT-IGNORE: Enabler Team decided to keep this paradigm from dojo in tact  
                    } // end of status check 
                    else {
                        failedNodes[id] = page;
                        var postResult = parseInt(postStatus, 10);
                        status.code = this._overallStatus(postResult, status.code);
                        chainDfr.finish(); // trigger next deferred in chain
                    }
                    
                }, {
                    // deferred arguments
                    id: id,
                    baseDfr: deferred,
                    status: status
                });
                // chain POSTing functions
                chainDfr.setChainedDeferred(dfr);
                chainDfr = dfr;
            }, this);
            
            // updated nodes
            dojo.forEach(toUpdate, function(id){
                var dfr = new com.ibm.mm.enabler.DeferredImpl(this, function(chainDfr, sync, args){
                    // id of page to PUT
                    var id = args.id;
                    // overall status to update
                    var status = args.status;
                    // deferred object of commit function
                    var baseDfr = args.baseDfr;
                    
                    // update content node 
                    page = loadedNodes[id];
                    content = page._contentNode;
                    if (content && (content._isDirty() || content._isStaticMarkupDirty)) {
                        this._putContentNode(content, id);
                    }
                    
                    modelUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(this.urlType, this);
                    modelUrl.setNodes([{
                        value: id,
                        isID: true
                    }]);
                    entry = com.ibm.mm.enabler.utils.Utils.createFeed(modelUrl.getModelURI(), "IBM Lotus Mashups Navigation Feed", loadedNodes[id], this.ns);
                    // HTTP PUT updated nodes
                    edit = page.getEditLink();
                    myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(edit, this);
                    
                    // full representation
                    myUrl.setParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_REPRESENTATION, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_REPRESENTATION_VALUE_FULL);
                    
                    // update by replacement
                    myUrl.setParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_UPDATE, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_UPDATE_VALUE_REPLACE);
                    
                    // include access control info
                    myUrl.addParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT_VALUE_ACCESS_CONTROL);
                    
                    // include space info
                    myUrl.addParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT_VALUE_COMPOSITE_APPLICATION);
                    
                    serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
                    serviceReq.update(entry, dojo.hitch(this, function(type, data, xhr, args){
                        // id of page to PUT
                        var page = args.page;
                        // overall status to update
                        var status = args.status;
                        // deferred object of commit function
                        var baseDfr = args.baseDfr;
                        // deferred chain object
                        var chainDfr = args.chainDfr;
                        if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_ERROR) {
                            if (bIsLoggable) {
                                this.LOGGER.warning(LOG_METHOD, this.modelMessages.E_XHR_REQUEST_FAILED_2, [xhr, data || "n/a"]);
                            }
                        }
                        else {
                            var updatedEntry = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(this._ATOM_ENTRY, data, this.ns);
                            if (updatedEntry) {
                                // update navigation node xml data
                                page.setXml(updatedEntry);
                                // update initial contents
                                this.initialContents[page.getID()] = page.toString();
                                ctx.nodeUpdated(page);
                                
                                var model = ctx.getModel();
                                var parent = dojo.hitch(model, model.getParent)(ctx.getModelNode(page)).start();
                                if (parent) {
                                    var arrayInval = [parent.getID()];
                                    if ((page.__oldParentID) && (page.__oldParentID != parent.getID())) {
                                        arrayInval.push(page.__oldParentID);
                                    }
                                    dojo.publish(com.ibm.mashups.enabler.model.NavigationModel.TOPIC_INVALIDATE_CHILDREN, [{
                                        nodes: arrayInval
                                    }]);
                                }
                            }
                            // operation callback on base deferred
                            if (baseDfr && baseDfr.operationCallback) {
                                baseDfr.operationCallback(ctx.getModelNode(page), com.ibm.mashups.enabler.DeferredOperation.OPERATION_MODIFY, xhr.status, baseDfr.operationCallbackParameters);
                            }
                        }
                        // overall status
                        status.code = this._overallStatus(xhr.status, status.code);
                        chainDfr.finish(); // trigger next deferred in chain
                    }), {
                        // xhr arguments
                        page: page,
                        baseDfr: baseDfr,
                        chainDfr: chainDfr,
                        status: status
                    }); // JSLINT-IGNORE: Enabler Team decided to keep this paradigm from dojo in tact        
                }, {
                    // deferred arguments
                    id: id,
                    baseDfr: deferred,
                    status: status
                });
                // chain PUTting functions
                chainDfr.setChainedDeferred(dfr);
                chainDfr = dfr;
            }, this);
            
            // deleted nodes
            com.ibm.mm.enabler.utils.Misc.forIn(deletedNodes, function(node, id){
                var dfr = new com.ibm.mm.enabler.DeferredImpl(this, function(chainDfr, sync, args){
                    // id of page to DELETE
                    var id = args.id;
                    // overall status to update
                    var status = args.status;
                    // deferred object of commit function
                    var baseDfr = args.baseDfr;
                    
                    // delete layout model
                    delete this.layoutModels[id];
                    // delete page
                    edit = deletedNodes[id].getEditLink();
                    myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(edit, this);
                    serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
                    serviceReq.remove(dojo.hitch(this, function(type, data, xhr, args){
                        // id of page to DELETE
                        var id = args.id;
                        var navid = id;
                        // overall status to update
                        var status = args.status;
                        // deferred object of commit function
                        var baseDfr = args.baseDfr;
                        // deferred chain object
                        var chainDfr = args.chainDfr;
                        
                        // delete fragment (unchained xhr!)
                        // Note that we must not perform any read operations in the commit 
                        // function. Thus, we must not fetch the layout model, since it may
                        // involve GET requests. Thus, we delete the fragment from here.
                        var contentRef = com.ibm.mashups.enabler.xml.XPath.evaluateString(this._CONTENT_NODE_LINK + "/@href", deletedNodes[id].getXml(), this.ns);
                        if (contentRef) {
                            // fragment link
                            myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(contentRef, this);
                            serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
                            serviceReq.remove(dojo.hitch(this, function(type, data, xhr, args){
                                // id of page to DELETE
                                var id = args.id;
                                // overall status to update
                                var status = args.status;
                                // deferred object of commit function
                                var baseDfr = args.baseDfr;
                                if (baseDfr && baseDfr.operationCallback) {
                                    baseDfr.operationCallback(id, com.ibm.mashups.enabler.DeferredOperation.OPERATION_DELETE, xhr.status, baseDfr.operationCallbackParameters);
                                }
                                if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_ERROR) {
                                    if (bIsLoggable) {
                                        this.LOGGER.warning(LOG_METHOD, this.modelMessages.E_XHR_REQUEST_FAILED_2, [xhr, data || "n/a"]);
                                    }
                                }
                                var sc = com.ibm.mm.enabler.model.HttpStatusCodes;
                                if (status.code == sc.HTTP_NOT_FOUND || status.code == sc.HTTP_OK) {
                                    ctx.nodeDeleted(navid);
                                    // deleted nodes have to be invalidated lazily
                                    toInvalidate.push([navid, false]); // false means to invalidate the node itself
                                }
                                status.code = this._overallStatus(xhr.status, status.code);
                                chainDfr.finish(); // trigger next deferred in chain
                            }), {
                                // xhr arguments
                                id: id,
                                baseDfr: baseDfr,
                                chainDfr: chainDfr,
                                status: status
                            }); // JSLINT-IGNORE: Enabler Team decided to keep this paradigm from dojo in tact        
                        }
                    }), {
                        // xhr arguments
                        id: id,
                        baseDfr: baseDfr,
                        chainDfr: chainDfr,
                        status: status
                    }); // JSLINT-IGNORE: Enabler Team decided to keep this paradigma from dojo in tact
                }, {
                    // deferred arguments
                    id: id,
                    baseDfr: deferred,
                    chainDfr: chainDfr,
                    status: status
                });
                // chain DELETEing functions
                chainDfr.setChainedDeferred(dfr);
                chainDfr = dfr;
            }, this);
            
            var layoutDfr = new com.ibm.mm.enabler.DeferredImpl(this, function(chainDfr, _sync, args){
                // deferred object of commit function
                var baseDfr = args.baseDfr;
                
                // initialize semaphore and global status; still used in sub models
                // TODO remove initSemaphore/acquire after all sub models use chaining
                this.statusCode = status.code;
                this._initSemaphore();
                this._acquire();
                
                try {
                    // commit layout models
                    com.ibm.mm.enabler.utils.Misc.forIn(this.layoutModels, function(model, id){
                        if (!(id in failedNodes)) {
                            model._commit(baseDfr, sync, this); // we use the outer sync here. The inner is called _sync
                        }
                    }, this);
                } 
                catch (e) {
                    console.error(e);
                }
                
                // overall status
                //status.code = this._overallStatus(xhr.status, status.code);
                chainDfr.finish(); // trigger next deferred in chain
            }, {
                baseDfr: deferred,
                status: status
            });
            // chain DELETEing functions
            chainDfr.setChainedDeferred(layoutDfr);
            chainDfr = layoutDfr;
            
            // final deferred
            var finalDfr = new com.ibm.mm.enabler.DeferredImpl(this, function(chainDfr, sync, args){
                // deferred object of commit function
                var baseDfr = args.baseDfr;
                
                // overall status to update
                var status = args.status;
                
                // we need to invalidate this because metadata set on navModel might shine through to LayoutModel - defect 16101
                // TODO performance improvement: only invalidate layout models which have not been committed (and therefore reloaded from the server) afterwards
                dojo.forEach(toUpdate, function(id){
                    this._invalidateLayoutModel(id);
                }, this);
                
                var model = ctx.getModel();
                
                var invalidateChildren = [];
                var invalidateNodes = [];
                dojo.forEach(toInvalidate, function(data){
                    var id = data[0];
                    var childrenOnly = data[1];
                    
                    if (childrenOnly) {
                        invalidateChildren.push(id);
                    }
                    else {
                        invalidateNodes.push(id);
                    }
                }, this);
                
                if (invalidateChildren.length > 0) {
                    dojo.publish(com.ibm.mashups.enabler.model.NavigationModel.TOPIC_INVALIDATE_CHILDREN, [{
                        nodes: invalidateChildren
                    }]);
                }
                
                if (invalidateNodes.length > 0) {
                    dojo.publish(com.ibm.mashups.enabler.model.NavigationModel.TOPIC_INVALIDATE_NODE, [{
                        nodes: invalidateNodes
                    }]);
                }
                
                // invalidate shared navigation model
                com.ibm.mashups.enabler.navigation.Factory.getSharedNavigationModel().invalidate();
                
                // releasing the initial 'acquire'
                // TODO remove release after all sub models use chaining
                //baseDfr.finish(null, status.code);
                this._release(baseDfr, 0);
            }, {
                baseDfr: deferred,
                status: status
            });
            
            // chain final deferred
            chainDfr.setChainedDeferred(finalDfr);
            
            // start deferred chain
            initialDfr.start();
            
            // TODO: only set clean, if no error occured while committing sub models
            this._setClean();
            
            // exit trace
            if (bIsLoggable) {
                this.LOGGER.exiting(LOG_METHOD);
            }
        });
    },
    
    // acquire semaphore
    _acquire: function(){
        this.requestCount++;
    },
    
    // release semaphore
    _release: function(deferred, statusCode){
        // set overall status Code
        this.statusCode = Math.max(parseInt(statusCode, 10), this.statusCode);
        // check for full release
        this.requestCount--;
        if (this.requestCount <= 0) {
            if (deferred) {
                deferred.finish(null, this.statusCode);
            }
        }
    },
    
    _overallStatus: function(operationStatus, overallStatus){
        return Math.max(parseInt(operationStatus, 10), overallStatus);
    },
    
    _find: function(deferred, sync, uri, _getParent){
        this._initServiceDoc();
        // logging support
        var LOG_METHOD = "_find";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, arguments);
        }
        
        if (!uri) {
            throw new Error(this.modelMessages.E_NODE_ISNULL_0);
        }
        var id = com.ibm.mm.enabler.utils.Utils.getIdFromIdentifiable(uri);
        
        var retVal = null;
        // use href info from identifier
        var myUrl;
        var href = com.ibm.mm.enabler.utils.Utils.getHrefFromIdentifiable(uri);
        if (href) {
            myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(href, this);
        }
        else {
            // construct url otherwise
            if (uri == "collection") {
                myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(this.entryUrl, this);
            }
            else {
                myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(this.urlType, this);
                myUrl.setNodes([{
                    value: com.ibm.mm.enabler.utils.Misc.encodeModelID4Uri(uri),
                    isID: true
                }]);
            }
        }
        
        // number of levels
        var s = this._findStrategyByType("com.ibm.mashups.enabler.strategy.TreeLoadAheadStrategy");
        var levels = "1";
        if (s) {
            if (_getParent) {
                var parentLevel = s.getParentLevel();
                if (parentLevel) {
                    levels = "-" + (parentLevel + 1);
                }
            }
            else {
                var childrenLevel = s.getChildrenLevel();
                if (childrenLevel && childrenLevel > 0) {
                    levels = childrenLevel + 1;
                }
            }
        }
        myUrl.setParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_LEVELS, levels);
        
        // access control
        myUrl.addParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT_VALUE_ACCESS_CONTROL);
        
        // spaces
        myUrl.addParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT_VALUE_COMPOSITE_APPLICATION);
        
        // full representation
        myUrl.setParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_REPRESENTATION, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_REPRESENTATION_VALUE_FULL);
        
        this._applyHiddenMetaDataLoadingStrategyToModelURL(myUrl);
        
        // apply caching strategy
        this._applyNoCacheStrategy(myUrl);
        
        var serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
        var result = {};
        result.node = null;
        
        serviceReq.read(dojo.hitch(this, function(type, data, xhr, args){
            if (type != com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_ERROR) {
                var nodes = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(this._ATOM_ENTRY, data, this.ns);
                if (nodes) {
                    for (var i = 0; i < nodes.length; i++) {
                        var node = com.ibm.mm.enabler.navigation.persistence.xml.Factory.createNavigationElementPersistence(nodes[i]);
                        // The following check was updated to handle bookmarked ids.  If the id is from v2.0, then the server
                        // will update the id in the PersistenceIdentificationServiceImpl class.  The correct pageid 
                        // for V3+ will be returned.  The index check below checks to see if the id was updated 
                        // with a "M" at the beginning of the id. 
                        if (id == node.getID() || id == node.getUniqueName() || ((node.getID().indexOf(id)) == 1)) {
                            result.node = node;
                        }
                        else {
                            // if root node is requested; return node without parent, i.e. the root node 
                            var replyLink = com.ibm.mashups.enabler.xml.XPath.evaluateBoolean(this._IN_REPLY_TO_LINK + "[@ext:uri]", node.getXml(), this.ns);
                            if (uri == "collection" && (this.urlType != com.ibm.mashups.enabler.model.url.ModelUrlFactory.NAVIGATION_URL || !replyLink)) {
                                result.node = node;
                            }
                        }
                    }
                }
                else {
                    if (sync) {
                        result.status = com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_NOT_FOUND;
                    }
                }
            }
            
            if (deferred) {
                deferred.finish(result.node, xhr.status);
            }
            
            if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_ERROR) {
                // do not expose HTTP_NOT_FOUND; simply return null in this case
                if (xhr.status != com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_NOT_FOUND) {
                    if (bIsLoggable) {
                        this.LOGGER.warning(LOG_METHOD, this.modelMessages.E_XHR_REQUEST_FAILED_2, [xhr, data || "n/a"]);
                    }
                    // handle error in sync call
                    if (sync) {
                        result.status = xhr.status;
                    }
                }
            }
        }));
        retVal = result.node;
        
        // exit trace
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD, retVal);
        }
        // compatibility: only meaningful in sync mode
        return retVal;
    },
    
    _invalidateNode: function(eventParam){
        if (eventParam.nodes) {
            // there are two entry points. one passes in a simple array or string the other a JSON with a nodes property
            eventParam = eventParam.nodes;
        }
        var nodeArray = dojo.isArray(eventParam) ? eventParam : [eventParam];
        
        for (var i = 0, l = nodeArray.length; i < l; ++i) {
            var nodeID = nodeArray[i];
            
            this._invalidateLayoutModel(nodeID);
        }
    },
    
    _invalidateLayoutModel: function(id){
        if (this.layoutModels[id] && this.layoutModels[id]._wireModel) {
            this.layoutModels[id]._wireModel = null;
        }
        delete this.layoutModels[id];
    },
    
    _cacheNode: function(node){
    },
    
    _applyNoCacheStrategy: function(url){
        var s = this._findStrategyByType("com.ibm.mashups.enabler.strategy.NoCacheStrategy");
        if (s) {
            url.addParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_NOCACHE, "true");
        }
    },
    
    _getIteratorPersistenceHandler: function(parent){
        this._initServiceDoc();
        var that = this;
        return {
            // result is a json object
            // nodes: the nodes preloaded
            // size: the size of the iterator
            // loadFurtherNodes: defines whether we are at the end of the iterator or not
            loadAhead: function(context){
                return new com.ibm.mm.enabler.DeferredImpl(that, function(deferred, sync, node){
                    // logging support
                    var LOG_METHOD = "loadAhead";
                    var bIsLoggable = this.LOGGER.isLoggable(that.LOG_LEVEL);
                    if (bIsLoggable) {
                        this.LOGGER.entering(LOG_METHOD, arguments);
                    }
                    var retVal = null;
                    if (context.url == null) {
                        // there are no children on this node
                        retVal = {
                            nodes: [],
                            size: 0,
                            loadFurtherNodes: false
                        };
                        if (deferred) {
                            deferred.finish(retVal, 200);
                        }
                        // exit trace
                        if (bIsLoggable) {
                            this.LOGGER.exiting(LOG_METHOD, retVal);
                        }
                        return retVal;
                    }
                    // service request
                    var serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(context.url, null, null, false, sync);
                    serviceReq.read(dojo.hitch(this, function(type, data, xhr, args){
                        var id;
                        var f = com.ibm.mm.enabler.navigation.persistence.xml.Factory;
                        if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_LOAD) {
                            retVal = {
                                nodes: [],
                                loadFurtherNodes: false
                            };
                            // fetch size
                            retVal.size = com.ibm.mashups.enabler.xml.XPath.evaluateNumber("atom:feed/opensearch:totalResults", data, this.ns);
                            // iterate favorites node entries
                            var nodes = com.ibm.mashups.enabler.xml.XPath.evaluateXPath("atom:feed/atom:entry", data, this.ns);
                            if (nodes) {
                                for (var i = 0; i < nodes.length; i++) {
                                    var uri = context.url.getModelURI();
                                    var expr = this.THR_INREPLYTO_URI_PREFIX + uri + this.THR_INREPLYTO_URI_SUFFIX;
                                    var inReply = com.ibm.mashups.enabler.xml.XPath.evaluateBoolean(expr, nodes[i], this.ns);
                                    if (inReply) {
                                        var node = f.createNavigationElementPersistence(nodes[i]);
                                        retVal.nodes.push(node);
                                    }
                                    else {
                                        // do not count nodes outside the iterator
                                        retVal.size--;
                                    }
                                }
                            }
                            // check for 'next'-link on feed level
                            var next = com.ibm.mashups.enabler.xml.XPath.evaluateEntry("atom:feed/atom:link[@rel='next']", data, this.ns);
                            if (next) {
                                // tell the iterator that it can load more nodes
                                retVal.loadFurtherNodes = true;
                                
                                var url = next.getAttribute("href");
                                // set collection url from 'next'-link
                                context.url = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(url, this);
                                
                                // include access control info
                                context.url.addParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT_VALUE_ACCESS_CONTROL);
                                // include space info
                                context.url.addParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT_VALUE_COMPOSITE_APPLICATION);
                                // full representation
                                context.url.setParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_REPRESENTATION, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_REPRESENTATION_VALUE_FULL);
                                // include hidden meta data
                                this._applyHiddenMetaDataLoadingStrategyToModelURL(context.url);
                                // apply caching strategy
                                this._applyNoCacheStrategy(context.url);
                            }
                            if (deferred) {
                                deferred.finish(retVal, xhr.status);
                            }
                        }
                        else {
                            // error callback
                            if (deferred) {
                                deferred.finish(null, xhr.status);
                            }
                        }
                    }));
                    // exit trace
                    if (bIsLoggable) {
                        this.LOGGER.exiting(LOG_METHOD, retVal);
                    }
                    return retVal;
                });
            },
            getLoadAheadContext: function(context, iterator){
                if (!context) { // start at the beginning
                    context = {};
                    var href = that._getChildrenLink(parent);
                    if (href) {
                        context.url = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(href, that);
                        if (that.strategy) {
                            for (var x in that.strategy) {
                                if (com.ibm.mm.enabler.utils.Misc.isInstanceOf(that.strategy[x], com.ibm.mashups.enabler.strategy.ListLoadAheadStrategy)) {
                                    // max number of entries 
                                    context.url.setParameter("num", that.strategy[x].getInterval());
                                    // start element (only set with paging) 
                                    context.url.setParameter("start", iterator.getCursorPosition());
                                    break;
                                }
                            }
                        }
                        // include access control info
                        context.url.addParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT_VALUE_ACCESS_CONTROL);
                        // include space info
                        context.url.addParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT_VALUE_COMPOSITE_APPLICATION);
                        // full representation
                        context.url.setParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_REPRESENTATION, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_REPRESENTATION_VALUE_FULL);
                        // include hidden meta data
                        that._applyHiddenMetaDataLoadingStrategyToModelURL(context.url);
                        // apply caching strategy
                        that._applyNoCacheStrategy(context.url);
                    }
                    else {
                        context.url = null;
                    }
                }
                return context;
            },
            setCursorPosition: function(context, iterator){
                if ((context) && (context.url)) {
                    context.url.setParameter("start", iterator.getCursorPosition());
                }
                return context;
            }
        };
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.navigation.persistence.xml.SharedNavigationModelXmlImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.navigation.persistence.xml.SharedNavigationModelXmlImpl"] = true;
dojo.provide("com.ibm.mm.enabler.navigation.persistence.xml.SharedNavigationModelXmlImpl");

/*
 * This is injected on the fly and not fetched through an API. Therefore we need to define the @ibm-module so that the build process is picking it up
 * @ibm-module NavigationModelXml
 */




// navigation model
dojo.declare("com.ibm.mm.enabler.navigation.persistence.xml.SharedNavigationModelXmlImpl", [ com.ibm.mm.enabler.navigation.persistence.xml.NavigationModelXmlImpl ], {
    constructor: function(){
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass);
        this.LOG_LEVEL = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
        
        // url type: shared navigation
        this.urlType = com.ibm.mashups.enabler.model.url.ModelUrlFactory.SHARED_NAVIGATION_URL;
    },
    
    _initServiceDoc: function(){
        this.inherited("_initServiceDoc", arguments);
        // service document and initialization
        this.serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_SHARED_NAVIGATION);
        this.entryUrl = this.serviceJson.url;
        this.prefix = this.serviceJson.idprefix;
        var nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
        this.ns = dojo.delegate(this.serviceJson.namespaces, nsf.getNameSpaces([nsf.NS_ATOM, nsf.NS_THR, nsf.NS_XML, nsf.NS_OPENSEARCH, nsf.NS_XHTML, nsf.NS_APP]));
    },
    
    // singleton
    _getInstance: function(){
        var instance = com.ibm.mm.enabler.navigation.persistence.xml.SharedNavigationModelXmlImpl._instance;
        return instance ? instance : (com.ibm.mm.enabler.navigation.persistence.xml.SharedNavigationModelXmlImpl._instance = new com.ibm.mm.enabler.navigation.persistence.xml.SharedNavigationModelXmlImpl());
    },
    
    isAccepted: function(node) {
        if (node === null || typeof node == 'undefined') {
            throw new Error(dojo.string.substitute(this.modelMessages.E_PARAM_ISNULL_OR_UNDEFINED_3, ["id", this.declaredClass, "isAccepted(id)"]));
        }
        
        // load node 
        if (typeof(node) == "string") {
            node = this.find(node.getID()).start();
        }
        
        if (!node) {
            throw new Error(this.modelMessages.E_NODE_ISNULL_0);
        }
        
        var expr = "atom:link[@ext:rel='linked']";
        return com.ibm.mashups.enabler.xml.XPath.evaluateBoolean(expr, node.xmlData, this.ns);
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.space.persistence.xml.SpaceNodeXmlImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.space.persistence.xml.SpaceNodeXmlImpl"] = true;
dojo.provide("com.ibm.mm.enabler.space.persistence.xml.SpaceNodeXmlImpl");


























dojo.declare("com.ibm.mm.enabler.space.persistence.xml.SpaceNodeXmlImpl", [com.ibm.mm.enabler.persistence.xml.XmlPersistenceImpl, com.ibm.mm.enabler.persistence.xml.IdentifiableXmlImpl, com.ibm.mm.enabler.persistence.xml.LocalizedXmlImpl, com.ibm.mm.enabler.persistence.xml.DefaultLocalizedXmlImpl, com.ibm.mm.enabler.MetaDataImpl, com.ibm.mm.enabler.persistence.xml.EditLinkProviderXmlImpl, com.ibm.mm.enabler.TransformableImpl, com.ibm.mm.enabler.space.persistence.meta.SpaceNodeMetaImpl, com.ibm.mm.enabler.DirtyFlagProviderImpl, com.ibm.mm.enabler.ac.OwnerAspect, com.ibm.mm.enabler.space.SpaceExtensionAspect], {
    constructor: function(node){
        // node is taken care of in the XmlPersistenceImpl
        this.owner = null;
        
        // service document and initialization
        this.serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_SPACE);
        this.prefix = this.serviceJson.idprefix;
        this.nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
        this.ns = dojo.delegate(this.serviceJson.namespaces, this.nsf.getNameSpaces([this.nsf.NS_ATOM, this.nsf.NS_CA]));
        
        // Override LocalizedImpl to handle composite app titles and descriptions
        this.li_ns = dojo.mixin(this.nsf.getNameSpaces([this.nsf.NS_ATOM, this.nsf.NS_XML, this.nsf.NS_CA]), this.serviceJson.namespaces);
        
        // base
        this.BASE_NLS_TITLE_STRING = "ca:title";
        this.BASE_NLS_DESCRIPTION_STRING = "ca:description";
        this.BASE_NS = this.li_ns.ca;
        
        // title
        this.TITLE_ELEMENT = "atom:content/ca:application";
        this.TITLE = this.TITLE_ELEMENT + "/" + this.BASE_NLS_TITLE_STRING;
        
        // description
        this.DESCRIPTION_ELEMENT = "atom:content/ca:application";
        this.DESCRIPTION = this.DESCRIPTION_ELEMENT + "/" + this.BASE_NLS_DESCRIPTION_STRING;
        
        // track changed properties(old values) in space: title, description, metaData, owner
        this.changedProperties = {};
        this.sourceSpaceID = null;
        this.latestLocale = "en";
    },
    getOwner: function(){
        if (!this.owner) {
            var expr = "atom:content/ca:application/ca:owner";
            var owner = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, this.xmlData, this.ns);
            if (owner) {
                var um = com.ibm.mashups.enabler.user.Factory.getUserModel();
                var ownerID = com.ibm.mm.enabler.utils.Dom.getAttributeWithNS(owner, "ca:id", "id", this.ns.ca);
                this.owner = um.find(ownerID).start();
            }
        }
        return this.owner;
    },
    setOwner: function(user){
        // track old owner for update
        if (!this.changedProperties.owner) {
            this.changedProperties.owner = this.getOwner();
        }
        
        this.owner = user;
        var expr = "atom:content/ca:application/ca:owner";
        var owner = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, this.xmlData, this.ns);
        if (owner) {
            com.ibm.mm.enabler.utils.Utils.setAttributeWithNS(owner, "ca:id", this.ns.ca, user.getID());
        }
        else {
            expr = "atom:content/ca:application";
            var application = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, this.xmlData, this.ns);
            if (application) {
                // create owner  element
                var tn = com.ibm.mm.enabler.utils.Dom.createElement(this.xmlData.ownerDocument, "ca:owner", this.ns.ca);
                com.ibm.mm.enabler.utils.Utils.setAttributeWithNS(tn, "ca:id", this.ns.ca, user.getID());
                application.appendChild(tn);
            }
        }
        this.setDirty();
    },
    
    getExportSpaceURL: function(){
        var expr = "atom:link[@ca:rel='application-export']";
        var node = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, this.xmlData, this.ns);
        return node ? node.getAttribute("href") : null;
    },
    
    getExportTemplateURL: function(){
        var expr = "atom:link[@ca:rel='template-export']";
        var node = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, this.xmlData, this.ns);
        return node ? node.getAttribute("href") : null;
    },
    
    setHidden: function(hide){
        var name = this._getHiddenMetaNameDynamic();
        this.setMetaData(name, (hide) ? "true" : "false");
    },
    
    confirmSetHidden: function(hide){
        var ret1 = this.confirmSetMetaData(this._getHiddenMetaNameFixed(), (hide) ? "true" : "false");
        var ret2 = this.confirmSetMetaData(this._getHiddenMetaNameDynamic(), (hide) ? "true" : "false");
        return (ret1 && ret2);
    },
       
    getRootNavigation: function(){
        var result;
        var expr = "atom:link[@ca:rel='navigation']";
        var node = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, this.xmlData, this.ns);
        if (node) {
            var id = com.ibm.mm.enabler.utils.Utils.getIdFromExtUri(this.prefix, node);
            var href = node.getAttribute("href");
            result = new com.ibm.mm.enabler.IdentifierImpl(id, {
                "href": href
            });
        }
        return result || null;
    },
    
    /**
     * If template will use current titles/descriptions of this space. Update them if needed.
     */
    saveAsTemplate: function(){
        return new com.ibm.mm.enabler.DeferredOperationImpl(this, this._saveAsTemplate);
    },
    
    _saveAsTemplate: function(deferred, sync){
        //POST to template:collection with feed containing space id
        var entry = com.ibm.mm.enabler.utils.Utils.createNode("atom:entry", this.ns.atom);
        entry.appendChild(com.ibm.mm.enabler.utils.Utils.createNode("atom:id", this.ns.atom));
        entry.appendChild(com.ibm.mm.enabler.utils.Utils.createNode("atom:title", this.ns.atom));
        
        var updated = com.ibm.mm.enabler.utils.Utils.createNode("atom:updated", this.ns.atom);
        var time = new Date();
        com.ibm.mm.enabler.utils.Dom.textContent(updated, time.toGMTString());
        entry.appendChild(updated);
        
        var content = com.ibm.mm.enabler.utils.Utils.createNode("atom:content", this.ns.atom);
        content.setAttribute("type", "application/xml");
        
        var template = com.ibm.mm.enabler.utils.Utils.createNode("ca:template", this.ns.ca);
        com.ibm.mm.enabler.utils.Utils.setAttributeWithNS(template, "creation-context:app-id", this.ns["creation-context"], this.getID());
        
        var locales = this.getLocales();
        for (var i = 0, l = locales.length; i < l; i++) {
            var title = com.ibm.mm.enabler.utils.Utils.createNode("ca:title", this.ns.ca);
            title.setAttribute("xml:lang", locales[i]);
            com.ibm.mm.enabler.utils.Dom.textContent(title, this.getTitle(locales[i]));
            template.appendChild(title);
            
            var description = com.ibm.mm.enabler.utils.Utils.createNode("ca:description", this.ns.ca);
            description.setAttribute("xml:lang", locales[i]);
            com.ibm.mm.enabler.utils.Dom.textContent(description, this.getDescription(locales[i]));
            template.appendChild(description);
        }
        
        content.appendChild(template);
        entry.appendChild(content);
        
        var templateServiceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_TEMPLATE);
        var myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(templateServiceJson.url, this.spaceModel);
        var serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
        serviceReq.create(com.ibm.mm.enabler.utils.Dom.innerXML(entry), dojo.hitch(this, function(type, data, xhr, args){
            // public callback handling
            if (deferred && deferred.operationCallback) {
                deferred.operationCallback(entry, com.ibm.mashups.enabler.DeferredOperation.OPERATION_CREATE, xhr.status, deferred.operationCallbackParameters);
            }
            
            // internal callback handling
            if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_ERROR) {
                if (deferred.errorCallback) {
                    deferred.errorCallback(xhr.status, deferred.errorCallbackParameters);
                }
            }
        }));
    },
    
    setTitle: function(title, locale){
        this.latestLocale = locale; // remember locale and use it for life cycle callback
        if (!this.changedProperties.title) {
            this.changedProperties.title = {};
        }
        if (!this.changedProperties.title[locale]) {
            this.changedProperties.title[locale] = this.getTitle(locale); // save current
        }
        // call super
        this.inherited(arguments);
    },
    
    removeTitle: function(locale){
        if (!this.changedProperties.title) {
            this.changedProperties.title = {};
        }
        if (!this.changedProperties.title[locale]) {
            this.changedProperties.title[locale] = this.getTitle(locale); // save current
        }
        // call super
        this.inherited(arguments);
    },
    
    removeTitles: function(){
        if (!this.changedProperties.title) {
            this.changedProperties.title = {};
        }
        // save all current titles
        var locales = this.getLocales();
        for (var locale in locales) {
            if (!this.changedProperties.title[locale]) {
                this.changedProperties.title[locale] = this.getTitle(locale);
            }
        }
        // call super
        this.inherited(arguments);
    },
    
    setDescription: function(desc, locale){
        if (!this.changedProperties.description) {
            this.changedProperties.description = {};
        }
        if (!this.changedProperties.description[locale]) {
            this.changedProperties.description[locale] = this.getDescription(locale); // save current
        }
        // call super
        this.inherited(arguments);
    },
    
    removeDescription: function(locale){
        if (!this.changedProperties.description) {
            this.changedProperties.description = {};
        }
        if (!this.changedProperties.description[locale]) {
            this.changedProperties.description[locale] = this.getDescription(locale); // save current           
        }
        // call super
        this.inherited(arguments);
    },
    
    removeDescriptions: function(){
        if (!this.changedProperties.description) {
            this.changedProperties.description = {};
        }
        // save all current descriptions
        var locales = this.getLocales();
        for (var locale in locales) {
            if (!this.changedProperties.description[locale]) {
                this.changedProperties.description[locale] = this.getDescription(locale);
            }
        }
        // call super
        this.inherited(arguments);
    },
    
    setMetaData: function(name, value){
        if (!this.changedProperties.metadata) {
            this.changedProperties.metadata = {};
        }
        if (!this.changedProperties.metadata[name]) {
            this.changedProperties.metadata[name] = this.getMetaData(name); // save current
        }
        // call super
        this.inherited(arguments);
    },
    
    removeMetaData: function(name){
        if (!this.changedProperties.metadata) {
            this.changedProperties.metadata = {};
        }
        if (!this.changedProperties.metadata[name]) {
            this.changedProperties.metadata[name] = this.getMetaData(name); // save current
        }
        // call super
        this.inherited(arguments);
    },
    
    isFavorite: function(){
        if (this.isFavoriteChanged()) {
            return this.favoriteOverwrite;
        }
        var ret = com.ibm.mashups.enabler.xml.XPath.evaluateBoolean("atom:link[@ca:rel='favorite']", this.xmlData, this.ns);
        return ret;
    },
    
    setFavorite: function(favorite){
        this.favoriteOverwrite = favorite;
        // now check if we can reset ourselves
        var ret = com.ibm.mashups.enabler.xml.XPath.evaluateBoolean("atom:link[@ca:rel='favorite']", this.xmlData, this.ns);
        if (ret == this.favoriteOverwrite) {
            delete this.favoriteOverwrite;
        }
    },
    
    isFavoriteChanged: function() {
        return (typeof this.favoriteOverwrite != "undefined");
    },

    // this one is used by the xml model
    _favoriteUpdateCommited: function(url) {
        if (this.isFavoriteChanged()) {
            var node = com.ibm.mashups.enabler.xml.XPath.evaluateEntry("atom:link[@ca:rel='favorite']", this.xmlData, this.ns);
            if (this.favoriteOverwrite) {
                if (!node) {
                    var linkNode = com.ibm.mm.enabler.utils.Utils.createLinkNode(url, "related", this.nsf.getNameSpaceUri(this.nsf.NS_ATOM));
                    com.ibm.mm.enabler.utils.Utils.setAttributeWithNS(linkNode, "ca:rel", this.nsf.getNameSpaceUri(this.nsf.NS_CA), "favorite");
                    this.xmlData.appendChild(linkNode);
                }
            }
            else {
                if (node) {
                    this.xmlData.removeChild(node);
                }
            }
            delete this.favoriteOverwrite;
        }
    },

    getSpaceExtensionURL: function(){
        return this.getMetaData("{http://www.ibm.com/xmlns/prod/lotus/mashups/v1.0/extensions}com.ibm.space.extension_url");
    },
    
    _setCopiedFrom: function(sourceSpaceID){
        this.sourceSpaceID = sourceSpaceID;
    },
    
    _getCopiedFrom: function(){
        return this.sourceSpaceID;
    },
    
    _diffSpaceChanges: function(){
        var delta = {};
        var locale;
        // owner
        if ("owner" in this.changedProperties) {
            var oldID = (!this.changedProperties.owner) ? "" : this.changedProperties.owner.getID();
            var newOwner = this.getOwner();
            var newID = (!newOwner) ? "" : newOwner.getID();
            if (newID != oldID) {
                delta.owner = newID;
            }
        }
        
        // title
        if ("title" in this.changedProperties) {
            for (locale in this.changedProperties.title) {
                if (Object.prototype.hasOwnProperty.call(this.changedProperties.title, locale)) {
                    var newTitle = this.getTitle(locale);
                    if (newTitle != this.changedProperties.title[locale]) {
                        if (!delta.title) {
                            delta.title = {};
                        }
                        delta.title[locale] = newTitle;
                    }
                }
            }
        }
        
        // description
        if ("description" in this.changedProperties) {
            for (locale in this.changedProperties.description) {
                if (Object.prototype.hasOwnProperty.call(this.changedProperties.description, locale)) {
                    var newDescription = this.getDescription(locale);
                    if (newDescription != this.changedProperties.description[locale]) {
                        if (!delta.description) {
                            delta.description = {};
                        }
                        delta.description[locale] = newDescription;
                    }
                }
            }
        }
        
        // metadata
        if ("metadata" in this.changedProperties) {
            for (var name in this.changedProperties.metadata) {
                if (Object.prototype.hasOwnProperty.call(this.changedProperties.metadata, name)) {
                    var value = this.getMetaData(name);
                    if (value != this.changedProperties.metadata[name]) {
                        if (!delta.metadata) {
                            delta.metadata = {};
                        }
                        delta.metadata[name] = value;
                    }
                }
            }
        }
        
        // finished, clear changed properties.
        this.changedProperties = {};
        return delta;
    },
    
    _getFavoriteURL: function(){
        var node = com.ibm.mashups.enabler.xml.XPath.evaluateEntry("atom:link[@ca:rel='favorite']", this.xmlData, this.ns);
        return node ? node.getAttribute("href") : null;
    }
    
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.space.persistence.xml.FactoryImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.space.persistence.xml.FactoryImpl"] = true;
dojo.provide("com.ibm.mm.enabler.space.persistence.xml.FactoryImpl");



dojo.declare("com.ibm.mm.enabler.space.persistence.xml.FactoryImpl", null, {

    createSpaceNodePersistence: function(data){
        // create persistence implementation
        return new com.ibm.mm.enabler.space.persistence.xml.SpaceNodeXmlImpl(data);
    }
});

// factory
com.ibm.mm.enabler.space.persistence.xml.Factory = new com.ibm.mm.enabler.space.persistence.xml.FactoryImpl();

}

if(!dojo._hasResource["com.ibm.mm.enabler.space.persistence.xml.SpaceModelXmlImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.space.persistence.xml.SpaceModelXmlImpl"] = true;
dojo.provide("com.ibm.mm.enabler.space.persistence.xml.SpaceModelXmlImpl");

/*
 * This is injected on the fly and not fetched through an API. Therefore we need to define the @ibm-module so that the build process is picking it up
 * @ibm-module SpaceModelXml
 */
































dojo.declare("com.ibm.mm.enabler.space.persistence.xml.SpaceModelXmlImpl", [com.ibm.mm.enabler.model.ModelImpl, com.ibm.mm.enabler.ConfirmableModelImpl, com.ibm.mm.enabler.SubmittableFormProviderImpl, com.ibm.mm.enabler.strategy.HiddenMetaDataLoadingStrategyHelperImpl, com.ibm.mm.enabler.ServiceDocConsumer], {

    constructor: function(){
        this.LOG_LEVEL = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass);
        var LOG_METHOD = "constructor()";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD);
        }
        
        // client id counter
        this.cid = 0;
        
        this.modelMessages = dojo.i18n.getLocalization("com.ibm.mm.enabler", "modelMessages");
        this.enforcementHelper = com.ibm.mm.enabler.utils.APIEnforcementHelper;
        this.xmlDom = com.ibm.mm.enabler.utils.Dom.createDocument();
        this.spaceExtensionModel = com.ibm.mashups.enabler.space.Factory.getSpaceExtensionModel();
        this.urlType = com.ibm.mashups.enabler.model.url.ModelUrlFactory.SPACE_URL;
        this._ATOM_FEED_ENTRY = "atom:feed/atom:entry";
        
        // service document and initialization
        this.serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_SPACE);
        this.prefix = this.serviceJson.idprefix;
        this.nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
        this.ns = dojo.delegate(this.serviceJson.namespaces, this.nsf.getNameSpaces([this.nsf.NS_ATOM, this.nsf.NS_XHTML, this.nsf.NS_OPENSEARCH, this.nsf.NS_CA, this.nsf.NS_APP]));
        
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD);
        }
    },
    
    _initServiceDoc: function(){
        this.inherited("_initServiceDoc", arguments);
        // service document and initialization
        this.serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_SPACE);
        this.prefix = this.serviceJson.idprefix;
        this.nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
        this.ns = dojo.delegate(this.serviceJson.namespaces, this.nsf.getNameSpaces([this.nsf.NS_ATOM, this.nsf.NS_XHTML, this.nsf.NS_OPENSEARCH, this.nsf.NS_CA, this.nsf.NS_APP]));
    },
    
    // singleton
    _getInstance: function(){
        var instance = com.ibm.mm.enabler.space.persistence.xml.SpaceModelXmlImpl._instance;
        return instance ? instance : (com.ibm.mm.enabler.space.persistence.xml.SpaceModelXmlImpl._instance = new com.ibm.mm.enabler.space.persistence.xml.SpaceModelXmlImpl());
    },
    
    invalidate: function(){
        delete com.ibm.mm.enabler.space.persistence.xml.SpaceModelXmlImpl._instance;
    },
    
    find: function(id){
        this.enforcementHelper.enforceDefinedNotNull(id, this.modelMessages.E_PARAM_ISNULL_OR_UNDEFINED_3, ["id", this.declaredClass, "find(id)"]);
        this._initServiceDoc();
        return new com.ibm.mm.enabler.DeferredImpl(this, this._find, id);
    },
    
    _find: function(deferred, sync, _id){
        var LOG_METHOD = "_find(_id, deferred, sync)";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, [_id, deferred, sync]);
        }
        
        var id = com.ibm.mm.enabler.utils.Utils.getIdFromIdentifiable(_id);
        
        // use href info from identifier
        var myUrl = null;
        var href = com.ibm.mm.enabler.utils.Utils.getHrefFromIdentifiable(_id);
        if (href) {
            myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(href, this);
        }
        else {
            // construct url otherwise
            myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(this.urlType, this);
            myUrl.setNodes([{
                value: id,
                isID: true
            }]);
        }
        
        // include access control info
        myUrl.addParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT_VALUE_ACCESS_CONTROL);
        
        // apply hidden meta data strategy
        this._applyHiddenMetaDataLoadingStrategyToModelURL(myUrl);
        
        // apply caching strategy
        this._applyNoCacheStrategy(myUrl);
        
        var serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
        var retVal = null;
        serviceReq.read(dojo.hitch(this, function(type, data, xhr, args){
            var LOG_METHOD = "_find_callback(type, data, xhr, args)";
            if (bIsLoggable) {
                this.LOGGER.entering(LOG_METHOD, [type, data, xhr, args]);
            }
            this._initServiceDoc();
            
            if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_LOAD) {
                var node = com.ibm.mashups.enabler.xml.XPath.evaluateEntry("//atom:entry", data, this.ns);
                retVal = com.ibm.mm.enabler.space.persistence.xml.Factory.createSpaceNodePersistence(node);
            }
            
            // finished callback 
            if (deferred) {
                deferred.finish(retVal, xhr.status);
            }
            
            if (bIsLoggable) {
                this.LOGGER.exiting(LOG_METHOD);
            }
        }));
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD, retVal);
        }
        return retVal;
    },
    
    create: function(context){
        this._initServiceDoc();
        // create atom:entry
        var result = com.ibm.mm.enabler.utils.Atom.createEntry("New Space", "ca:application", this.ns.ca);
        if (context) {
            if (context.clonedSpace) {
                com.ibm.mm.enabler.utils.Dom.setAttributeWithNS(this.xmlDom, result.modelElement, "creation-context:app-id", "app-id", this.ns["creation-context"], context.clonedSpace);
            }
            else 
                if (context.templateID) {
                    result.modelElement.setAttribute("ca:template-id", context.templateID);
                }
        }
        
        var f = com.ibm.mm.enabler.space.persistence.xml.Factory;
        var space = f.createSpaceNodePersistence(result.entryElement);
        space.setID((context && context.cid) ? context.cid : "" + this.cid++);
        
        if (context && context.clonedSpace) {
            space._setCopiedFrom(context.clonedSpace);
        }
        
        space._setDirty();
        return space;
    },
    confirmCreate: function(context){
        return this.getConfirmCreate();
    },
    
    commit: function(ctx){
        return new com.ibm.mm.enabler.DeferredOperationImpl(this, function(deferred, sync){
            var LOG_METHOD = "_commit(deferred, sync)";
            var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
            if (bIsLoggable) {
                this.LOGGER.entering(LOG_METHOD, [deferred, sync]);
            }
            this._initServiceDoc();
            
            var nodes = ctx.getNodes();
            var loadedNodes = nodes.loadedNodes;
            var createdNodes = nodes.createdNodes;
            var deletedNodes = nodes.deletedNodes;
            var createdFavorites = nodes.createdFavoriteNodes;
            var deletedFavorites = nodes.deletedFavoriteNodes;
            
            // initialize callback handling
            this.statusCode = com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK;
            this.requestCount = 0;
            this._acquire();
            
            var space, extension, result, myUrl, serviceReq, entry, link, id;
            var failedNodes = {};
            
            // HTTP PUT updated nodes
            for (id in loadedNodes) {
                if (Object.prototype.hasOwnProperty.call(loadedNodes, id)) {
                    if (bIsLoggable) {
                        this.LOGGER.trace(LOG_METHOD, "Checking if loaded space ${0} is modified", id);
                    }
                    space = loadedNodes[id];
                    if (space.isDirty()) {
                        if (bIsLoggable) {
                            this.LOGGER.trace(LOG_METHOD, "Space is modified, updating");
                        }
                        // onUpdateSpace event
                        extension = this.spaceExtensionModel.findExtensionBySpace(space).start();
                        if (extension) {
                            result = extension.onSpaceUpdate(space.getID(), dojo.toJson(space._diffSpaceChanges(), true), null);
                            if (result && result.getState() != "OK") {
                                if (bIsLoggable) {
                                    this.LOGGER.trace(LOG_METHOD, "Space update aborted: " + space.getID());
                                    this.LOGGER.trace(LOG_METHOD, "Space extension update problem: " + result.getLocaleMessage());
                                    this.LOGGER.trace(LOG_METHOD, "Solution: " + result.getLocaleSolution());
                                }
                                
                                continue;
                            }
                        }
                        
                        entry = com.ibm.mm.enabler.utils.Utils.createFeed("space:" + this.prefix + space.getID(), "IBM Lotus Mashups Space Feed", loadedNodes[id], this.ns);
                        
                        // now let's create the url
                        myUrl = new com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(space.getEditLink(), this);
                        // include access control info
                        myUrl.addParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT_VALUE_ACCESS_CONTROL);
                        
                        serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, true);
                        this._acquire();
                        serviceReq.update(entry, dojo.hitch(this, function(type, data, xhr, args){
                            if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_ERROR) {
                                if (bIsLoggable) {
                                    this.LOGGER.warning(LOG_METHOD, this.modelMessages.E_XHR_REQUEST_FAILED_2, [xhr, data || "n/a"]);
                                }
                            }
                            else {
                                var updatedEntry = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(this._ATOM_FEED_ENTRY, data, this.ns);
                                var id = space.getID();
                                if (updatedEntry) {
                                    // update space node xml data
                                    loadedNodes[id].setXml(updatedEntry);
                                    ctx.nodeUpdated(loadedNodes[id]);
                                }
                                else {
                                    // if there is no entry in the response, then remove the space node
                                    // this might happen, if someone set a new owner and removes the read permissions of the old owner
                                    ctx.nodeDeleted(id);
                                }
                                // operation callback on base deferred
                                if (deferred && deferred.operationCallback) {
                                    deferred.operationCallback(loadedNodes[id], com.ibm.mashups.enabler.DeferredOperation.OPERATION_MODIFY, xhr.status, deferred.operationCallbackParameters);
                                }
                                this._release(deferred, xhr.status);
                            }
                        })); // JSLINT-IGNORE: Enabler Team decided to keep this paradigma from dojo in tact
                    }
                }
            }
            
            // HTTP POST created nodes
            for (var count in createdNodes) {
                if (Object.prototype.hasOwnProperty.call(createdNodes, count)) {
                    if (bIsLoggable) {
                        this.LOGGER.trace(LOG_METHOD, "Processing new space");
                    }
                    space = createdNodes[count];
                    var oldid = space.getID();
                    var sourceSpaceID = space._getCopiedFrom(); // not null, then onSpaceCopy even
                    var latestLocale = space.latestLocale;
                    if (sourceSpaceID) { // see if extension allow it to be copied
                        extension = this.spaceExtensionModel.findExtensionBySpace(sourceSpaceID).start();
                        if (extension) {
                            result = extension.canCopySpace(space.getID(), null);
                            if (result && result.getState() != "OK") {
                                if (bIsLoggable) {
                                    this.LOGGER.trace(LOG_METHOD, "Space copy aborted: " + sourceSpaceID);
                                    this.LOGGER.trace(LOG_METHOD, "Space extension does not allow to copy this space.");
                                }
                                
                                continue;
                            }
                        }
                    }
                    
                    // now let's create the url
                    myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(this.serviceJson.url, this);
                    // include access control info
                    myUrl.addParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT_VALUE_ACCESS_CONTROL);
                    
                    serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, true);
                    this._acquire();
                    serviceReq.create(space.toString(), dojo.hitch(this, function(type, data, xhr, args){
                        var LOG_METHOD = "_commit_create_callback(type, data, xhr, args)";
                        if (bIsLoggable) {
                            this.LOGGER.entering(LOG_METHOD, [type, data, xhr, args]);
                        }
                        var newentry = null;
                        if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_LOAD) {
                            var entry = com.ibm.mashups.enabler.xml.XPath.evaluateEntry("//atom:entry", data, this.ns);
                            if (entry) {
                                newentry = com.ibm.mm.enabler.space.persistence.xml.Factory.createSpaceNodePersistence(entry);
                                ctx.nodeCreated(oldid, newentry);
                                // now we need to update the favorite entry with the cid
                                if (oldid in createdFavorites) {
                                    createdFavorites[newentry.getID()] = newentry;
                                    // we need to transfer the favorite setting between enodes so that it is correctly setup in the in memory XML
                                    if (createdFavorites[oldid].isFavoriteChanged()) {
                                        newentry.setFavorite(createdFavorites[oldid].isFavorite());
                                    }
                                    delete createdFavorites[oldid];
                                }
                                
                                // onCopyspace or onCreateSpace
                                extension = this.spaceExtensionModel.findExtensionBySpace(newentry).start();
                                if (extension) {
                                    var userLocale = (!latestLocale) ? "en" : latestLocale;
                                    var id = newentry.getID();
                                    var title = newentry.getTitle(userLocale);
                                    var description = newentry.getDescription(userLocale);
                                    var sourceSpaceID = args;
                                    result = sourceSpaceID ? extension.onSpaceCopy(sourceSpaceID, id, title, description, null) : extension.onSpaceCreate(id, title, description, null);
                                    if (result && result.getState() != "OK") {
                                        if (bIsLoggable) {
                                            this.LOGGER.trace(LOG_METHOD, "Space create/copy aborted: " + id);
                                            this.LOGGER.trace(LOG_METHOD, "Space extension update problem: " + result.getLocaleMessage());
                                            this.LOGGER.trace(LOG_METHOD, "Solution: " + result.getLocaleSolution());
                                        }
                                        
                                        failedNodes[id] = newentry;
                                    }
                                }
                            }
                        }
                        
                        // public callback handling
                        if (deferred && deferred.operationCallback) {
                            deferred.operationCallback(newentry, com.ibm.mashups.enabler.DeferredOperation.OPERATION_CREATE, xhr.status, deferred.operationCallbackParameters);
                        }
                        
                        this._release(deferred, xhr.status);
                        
                        if (bIsLoggable) {
                            this.LOGGER.exiting(LOG_METHOD);
                        }
                    }), sourceSpaceID); // JSLINT-IGNORE: Enabler Team decided to keep this paradigma from dojo in tact
                }
            }
            
            // Deleted those node failed during copy or create events, no onSpaceDelete event will be fired for them.
            for (var failedID in failedNodes) {
                if (Object.prototype.hasOwnProperty.call(failedNodes, failedID)) {
                    if (bIsLoggable) {
                        this.LOGGER.trace(LOG_METHOD, "Processing delete of space ${0}", id);
                    }
                    myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(failedNodes[failedID].getEditLink(), this);
                    serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
                    this._acquire();
                    serviceReq.remove(dojo.hitch(this, function(type, data, xhr, args){
                        var LOG_METHOD = "_commit_remove_callback(type, data, xhr, args)";
                        if (bIsLoggable) {
                            this.LOGGER.entering(LOG_METHOD, [type, data, xhr, args]);
                        }
                        
                        // finished callback
                        if (deferred && deferred.operationCallback) {
                            deferred.operationCallback(null, com.ibm.mashups.enabler.DeferredOperation.OPERATION_DELETE, xhr.status, deferred.operationCallbackParameters);
                        }
                        
                        this._release(deferred, xhr.status);
                        
                        if (bIsLoggable) {
                            this.LOGGER.exiting(LOG_METHOD, [type, data, xhr, args]);
                        }
                    })); // JSLINT-IGNORE: Enabler Team decided to keep this paradigma from dojo in tact
                }
            }
            
            // HTTP DELETE deleted nodes
            for (id in deletedNodes) {
                if (Object.prototype.hasOwnProperty.call(deletedNodes, id)) {
                    if (bIsLoggable) {
                        this.LOGGER.trace(LOG_METHOD, "Processing delete of space ${0}", id);
                    }
                    // onSpaceDelete event
                    var spaceToDelete = ctx.getModelNode(loadedNodes[id]);
                    extension = this.spaceExtensionModel.findExtensionBySpace(spaceToDelete).start();
                    if (extension) {
                        var deleteID = spaceToDelete.getID();
                        result = extension.canDeleteSpace(deleteID, null);
                        if (result && result.getState() != "OK") {
                            if (bIsLoggable) {
                                this.LOGGER.trace(LOG_METHOD, "Space delete aborted: " + spaceToDelete.getID());
                                this.LOGGER.trace(LOG_METHOD, "Space extension update problem: " + result.getLocaleMessage());
                                this.LOGGER.trace(LOG_METHOD, "Solution: " + result.getLocaleSolution());
                            }
                            
                            continue;
                        }
                        
                        result = extension.onSpaceDelete(deleteID, null);
                        if (result && result.getState() != "OK") {
                            if (bIsLoggable) {
                                this.LOGGER.trace(LOG_METHOD, "Space delete aborted: " + spaceToDelete.getID());
                                this.LOGGER.trace(LOG_METHOD, "Space extension update problem: " + result.getLocaleMessage());
                                this.LOGGER.trace(LOG_METHOD, "Solution: " + result.getLocaleSolution());
                            }
                            
                            continue;
                        }
                    }
                    
                    myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(deletedNodes[id].getEditLink(), this);
                    serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
                    this._acquire();
                    serviceReq.remove(dojo.hitch(this, function(type, data, xhr, args){
                        var LOG_METHOD = "_commit_remove_callback(type, data, xhr, args)";
                        if (bIsLoggable) {
                            this.LOGGER.entering(LOG_METHOD, [type, data, xhr, args]);
                        }
                        
                        var sc = com.ibm.mm.enabler.model.HttpStatusCodes;
                        if (xhr.status == sc.HTTP_NOT_FOUND || xhr.status == sc.HTTP_OK) {
                            ctx.nodeDeleted(id);
                        }
                        
                        // finished callback
                        if (deferred && deferred.operationCallback) {
                            deferred.operationCallback(null, com.ibm.mashups.enabler.DeferredOperation.OPERATION_DELETE, xhr.status, deferred.operationCallbackParameters);
                        }
                        
                        this._release(deferred, xhr.status);
                        
                        if (bIsLoggable) {
                            this.LOGGER.exiting(LOG_METHOD, [type, data, xhr, args]);
                        }
                    })); // JSLINT-IGNORE: Enabler Team decided to keep this paradigma from dojo in tact
                }
            }
            
            // HTTP DELETE deleted favorites
            for (id in deletedFavorites) {
                if (deletedFavorites[id]) {
                    if (bIsLoggable) {
                        this.LOGGER.trace(LOG_METHOD, "Processing delete of space-favorite ${0}", id);
                    }
                    myUrl = null;
                    
                    link = deletedFavorites[id]._getFavoriteURL();
                    if (typeof(link) == "string") {
                        myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(link, this);
                    }
                    else 
                        if (!link) {
                            myUrl = new com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(com.ibm.mashups.enabler.model.url.ModelUrlFactory.SPACE_FAVORITE_URL, this);
                            myUrl.setNodes([{
                                value: id,
                                isID: true
                            }]);
                        }
                        else {
                            myUrl = link;
                        }
                    
                    serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
                    this._acquire();
                    serviceReq.remove(dojo.hitch(this, function(type, data, xhr, args){
                        var LOG_METHOD = "_commit_remove_callback(type, data, xhr, args)";
                        if (bIsLoggable) {
                            this.LOGGER.entering(LOG_METHOD, [type, data, xhr, args]);
                        }
                        if (deletedFavorites[id]) {
                            deletedFavorites[id]._favoriteUpdateCommited();
                        }
                        // finished callback
                        if (deferred && deferred.operationCallback) {
                            deferred.operationCallback(null, com.ibm.mashups.enabler.DeferredOperation.OPERATION_DELETE, xhr.status, deferred.operationCallbackParameters);
                        }
                        this._release(deferred, xhr.status);
                        if (bIsLoggable) {
                            this.LOGGER.exiting(LOG_METHOD, [type, data, xhr, args]);
                        }
                    })); // JSLINT-IGNORE: Enabler Team decided to keep this paradigma from dojo in tact
                }
            }
            
            // HTTP POST created favorites
            for (id in createdFavorites) {
                if (Object.prototype.hasOwnProperty.call(createdFavorites, id) && createdFavorites[id]) {
                    if (bIsLoggable) {
                        this.LOGGER.trace(LOG_METHOD, "Processing create of space-favorite ${0}", id);
                    }
                    entry = com.ibm.mm.enabler.utils.Utils.createNode("atom:entry", this.nsf.getNameSpaceUri(this.nsf.NS_ATOM));
                    entry.appendChild(com.ibm.mm.enabler.utils.Utils.createNode("atom:id", this.nsf.getNameSpaceUri(this.nsf.NS_ATOM)));
                    
                    var title = com.ibm.mm.enabler.utils.Utils.createNode("atom:title", this.nsf.getNameSpaceUri(this.nsf.NS_ATOM));
                    com.ibm.mm.enabler.utils.Dom.textContent(title, "Adding a favorite space " + id);
                    entry.appendChild(title);
                    
                    var content = com.ibm.mm.enabler.utils.Utils.createNode("atom:content", this.nsf.getNameSpaceUri(this.nsf.NS_ATOM));
                    content.setAttribute("type", "application/xml");
                    
                    var favorite = com.ibm.mm.enabler.utils.Utils.createNode("ca:application-favorite", this.nsf.getNameSpaceUri(this.nsf.NS_CA));
                    com.ibm.mm.enabler.utils.Utils.setAttributeWithNS(favorite, "ca:app-id", this.nsf.getNameSpaceUri(this.nsf.NS_CA), id);
                    
                    content.appendChild(favorite);
                    entry.appendChild(content);
                    
                    myUrl = null;
                    
                    link = createdFavorites[id]._getFavoriteURL();
                    if (typeof(link) == "string") {
                        myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(link, this);
                    }
                    else 
                        if (!link) {
                            myUrl = new com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(com.ibm.mashups.enabler.model.url.ModelUrlFactory.SPACE_FAVORITE_URL, this);
                            myUrl.setNodes([{
                                value: id,
                                isID: true
                            }]);
                        }
                        else {
                            myUrl = link;
                        }
                    
                    serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
                    this._acquire();
                    serviceReq.create(com.ibm.mm.enabler.utils.Dom.innerXML(entry), dojo.hitch(this, function(type, data, xhr, args){
                        if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_LOAD) {
                            if (createdFavorites[id]) {
                                createdFavorites[id]._favoriteUpdateCommited(myUrl.getAbsoluteURL());
                            }
                        }
                        this._release(deferred, xhr.status);
                    })); // JSLINT-IGNORE: Enabler Team decided to keep this paradigma from dojo in tact
                }
            }
            
            // the finishedCallback is triggered within the _release
            this._release(deferred, 0);
            
            if (bIsLoggable) {
                this.LOGGER.exiting(LOG_METHOD);
            }
        });
    },
    
    // get submittable form
    getSubmittableImportForm: function(id){
        this._initServiceDoc();
        var model = null;
        var url;
        if (id == "spaceForm") {
            url = new com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(com.ibm.mashups.enabler.model.url.ModelUrlFactory.SPACE_URL, null);
            url.setNodes([{
                value: "collection",
                isID: false
            }]);
            url.setParameter("mode", "import");
            url.setParameter("mime-type", "text/html");
            url = url.toProxifiedString();
            /*"/mum/mycontenthandler?uri=space:collection&mode=import"*/
            model = new com.ibm.mm.enabler.SubmittableFormImpl(url, "post", id);
        }
        else 
            if (id == "pageForm") {
                var serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_RESOURCE);
                url = new com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(serviceJson.url, this);
                url.setParameter("mode", "import");
                url.setParameter("mime-type", "text/html");
                // post the spaceId to server.
                if (arguments[1]) {
                    url.setParameter("spaceId", arguments[1]);
                }
                url = url.toProxifiedString();
                /*"/mum/mycontenthandler?uri=resource:collection&mode=import"*/
                model = new com.ibm.mm.enabler.SubmittableFormImpl(url, "post", id);
            }
        return model;
    },
    
    // acquire semaphore
    _acquire: function(){
        this.requestCount++;
    },
    
    // release semaphore
    _release: function(deferred, statusCode){
        // set overall status Code
        this.statusCode = Math.max(parseInt(statusCode, 10), this.statusCode);
        // check for full release
        this.requestCount--;
        if (this.requestCount <= 0) {
            if (deferred) {
                deferred.finish(null, this.statusCode);
            }
        }
    },
    
    remove: function(node){
        // noop
    },
    
    
    confirmRemove: function(node){
        var allowedByExtension = true;
        var extension = this.spaceExtensionModel.findExtensionBySpace(node).start();
        if (extension) {
            var spaceID = typeof(node) == "string" ? node : node.getID();
            var result = extension.canDeleteSpace(spaceID, null);
            allowedByExtension = (!result || result.getState() == "OK");
        }
        
        return this.getConfirmRemove(node) && allowedByExtension;
    },
    
    _applyNoCacheStrategy: function(url){
        var s = this._findStrategyByType("com.ibm.mashups.enabler.strategy.NoCacheStrategy");
        if (s) {
            url.addParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_NOCACHE, "true");
        }
    },
    
    _getIteratorPersistenceHandler: function(){
        this._initServiceDoc();
        var that = this;
        return {
            // result is a json object
            // nodes: the nodes preloaded
            // size: the size of the iterator
            // loadFurtherNodes: defines whether we are at the end of the iterator or not
            loadAhead: function(context){
                return new com.ibm.mm.enabler.DeferredImpl(that, function(deferred, sync, node){
                    // logging support
                    var LOG_METHOD = "loadAhead";
                    var bIsLoggable = this.LOGGER.isLoggable(that.LOG_LEVEL);
                    if (bIsLoggable) {
                        this.LOGGER.entering(LOG_METHOD, arguments);
                    }
                    var retVal = null;
                    
                    // service request
                    var serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(context.url, null, null, false, sync);
                    serviceReq.read(dojo.hitch(this, function(type, data, xhr, args){
                        var id;
                        var f = com.ibm.mm.enabler.space.persistence.xml.Factory;
                        if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_LOAD) {
                            retVal = {
                                nodes: [],
                                loadFurtherNodes: false
                            };
                            // fetch size
                            retVal.size = com.ibm.mashups.enabler.xml.XPath.evaluateNumber("atom:feed/opensearch:totalResults", data, this.ns);
                            // iterate favorites node entries
                            var nodes = com.ibm.mashups.enabler.xml.XPath.evaluateXPath("atom:feed/atom:entry", data, this.ns);
                            if (nodes) {
                                for (var i = 0; i < nodes.length; i++) {
                                    // instantiate node
                                    var node = f.createSpaceNodePersistence(nodes[i]);
                                    retVal.nodes.push(node);
                                }
                            }
                            // check for 'next'-link on feed level
                            var next = com.ibm.mashups.enabler.xml.XPath.evaluateEntry("atom:feed/atom:link[@rel='next']", data, this.ns);
                            if (next) {
                                // tell the iterator that it can load more nodes
                                retVal.loadFurtherNodes = true;
                                
                                var url = next.getAttribute("href");
                                // set collection url from 'next'-link
                                context.url = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(url, this);
                                
                                // include access control info
                                context.url.addParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT_VALUE_ACCESS_CONTROL);
                                // apply caching strategy
                                this._applyNoCacheStrategy(context.url);
                            }
                            if (deferred) {
                                deferred.finish(retVal, xhr.status);
                            }
                        }
                        else {
                            // error callback
                            if (deferred) {
                                deferred.finish(null, xhr.status);
                            }
                        }
                    }));
                    // exit trace
                    if (bIsLoggable) {
                        this.LOGGER.exiting(LOG_METHOD, retVal);
                    }
                    return retVal;
                });
            },
            getLoadAheadContext: function(context, iterator){
                if (!context) { // start at the beginning
                    context = {};
                    // collection url
                    context.url = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(that.serviceJson.url, that);
                    if (that.strategy) {
                        for (var x in that.strategy) {
                            if (com.ibm.mm.enabler.utils.Misc.isInstanceOf(that.strategy[x], com.ibm.mashups.enabler.strategy.ListLoadAheadStrategy)) {
                                // max number of entries 
                                context.url.setParameter("num", that.strategy[x].getInterval());
                                // start element (only set with paging) 
                                context.url.setParameter("start", iterator.getCursorPosition());
                                break;
                            }
                        }
                    }
                    // include access control info
                    context.url.addParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT_VALUE_ACCESS_CONTROL);
                    // apply caching strategy
                    that._applyNoCacheStrategy(context.url);
                }
                return context;
            },
            setCursorPosition: function(context, iterator){
                if ((context) && (context.url)) {
                    context.url.setParameter("start", iterator.getCursorPosition());
                }
                return context;
            }
        };
    },
    
    _getFavoriteIteratorPersistenceHandler: function(){
        var that = this;
        return {
            // result is a json object
            // nodes: the nodes preloaded
            // size: the size of the iterator
            // loadFurtherNodes: defines whether we are at the end of the iterator or not
            loadAhead: function(context){
                return new com.ibm.mm.enabler.DeferredImpl(that, function(deferred, sync, node){
                    // logging support
                    var LOG_METHOD = "loadAhead";
                    var bIsLoggable = this.LOGGER.isLoggable(that.LOG_LEVEL);
                    if (bIsLoggable) {
                        this.LOGGER.entering(LOG_METHOD, arguments);
                    }
                    var retVal = null;
                    
                    // url parameter
                    var myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelURL(this.serviceJson.url, this);
                    // favorites filter
                    myUrl.setParameter("filter", "is-favorite=true");
                    // include access control info
                    myUrl.addParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_ASPECT_VALUE_ACCESS_CONTROL);
                    // full representation
                    myUrl.setParameter(com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_REPRESENTATION, com.ibm.mm.enabler.model.url.ModelUrlConstants.PARAMETER_REPRESENTATION_VALUE_FULL);
                    
                    // service request
                    var serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
                    serviceReq.read(dojo.hitch(this, function(type, data, xhr, args){
                        var id;
                        var f = com.ibm.mm.enabler.space.persistence.xml.Factory;
                        if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_LOAD) {
                            retVal = {
                                nodes: [],
                                loadFurtherNodes: false
                            };
                            // iterate favorites node entries
                            var expr = "atom:feed/atom:entry";
                            var nodes = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(expr, data, this.ns);
                            if (nodes) {
                                for (var i = 0; i < nodes.length; i++) {
                                    // instantiate node
                                    var node = f.createSpaceNodePersistence(nodes[i]);
                                    retVal.nodes.push(node);
                                }
                            }
                            retVal.size = retVal.nodes.length;
                            if (deferred) {
                                deferred.finish(retVal, xhr.status);
                            }
                        }
                        else {
                            // error callback
                            if (deferred) {
                                deferred.finish(null, xhr.status);
                            }
                        }
                    }));
                    // exit trace
                    if (bIsLoggable) {
                        this.LOGGER.exiting(LOG_METHOD, retVal);
                    }
                    return retVal;
                });
            },
            getLoadAheadContext: function(context, result){
                return context;
            },
            setCursorPosition: function(context, iterator){
                return context;
            }
        };
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.user.persistence.xml.EntityImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.user.persistence.xml.EntityImpl"] = true;
dojo.provide("com.ibm.mm.enabler.user.persistence.xml.EntityImpl");




// UserImpl and GroupImpl provide their own getLoginName(), getCN(), and getID()
dojo.declare("com.ibm.mm.enabler.user.persistence.xml.EntityImpl", 
[com.ibm.mm.enabler.persistence.xml.IdentifiableXmlImpl, com.ibm.mm.enabler.persistence.xml.XmlPersistenceImpl], {});

}

if(!dojo._hasResource["com.ibm.mm.enabler.user.persistence.xml.UserImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.user.persistence.xml.UserImpl"] = true;
dojo.provide("com.ibm.mm.enabler.user.persistence.xml.UserImpl");










dojo.declare("com.ibm.mm.enabler.user.persistence.xml.UserImpl", [com.ibm.mm.enabler.user.persistence.UserBaseImpl, com.ibm.mm.enabler.user.persistence.xml.EntityImpl], {
    constructor: function(data, anonUserID, anonUserIDEncoded) {
        // anonUserID, anonUserIDEncoded are covered in the base impl
        this.xmlData = data;

        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass);
        this.LOG_LEVEL = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
        
        var nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
        this.ns = nsf.getNameSpaces([nsf.NS_ATOM, nsf.NS_UM]);

        this.changedAttributes = {};
        this.addedAttributes = {};
        this.removedAttributes = {};
    },
    
    getAttribute: function(attName) {
        if (typeof attName == "undefined" || attName === null) {
            return null;
        }
        if (this.removedAttributes[attName]) {
            return null;
        }
        else if (this.changedAttributes[attName]) {
            return this.changedAttributes[attName];
        }
        else if (this.addedAttributes[attName]) {
            return this.addedAttributes[attName];
        }
        
        var expr = "atom:content/um:profile/um:attribute[@name='" + attName + "']/um:attributeValue";
        var xmlResult = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, this.xmlData, this.ns);
        if (!xmlResult) {
            return null;
        }
        var attValue = com.ibm.mm.enabler.utils.Dom.textContent(xmlResult);
        return attValue;
    },
    
    _getAttributeNames: function() {
        var xmlResult = com.ibm.mashups.enabler.xml.XPath.evaluateXPath("atom:content/um:profile/um:attribute", this.xmlData, this.ns);
        if (xmlResult.length === 0) {
            return [];
        }
        var ret = [];
        for (var i = 0; i < xmlResult.length; i++) {
            var aNode = xmlResult[i];
            var aName = aNode.getAttribute("name");
            ret.push(aName);
        }
        return ret;
    },
    
    getID: function() {
        var node = com.ibm.mashups.enabler.xml.XPath.evaluateEntry("atom:id", this.xmlData, this.ns);
        if (!node) {
            return null;
        }
        
        var fullID = com.ibm.mm.enabler.utils.Dom.textContent(node);
        if ((fullID === null) || (fullID.length === 0)) {
            return null;
        }
        // strip off extra details
        var pos = fullID.indexOf("profiles/");
        if (pos == -1) {
            pos = fullID.indexOf("profiles:");
        }
        var id = fullID.slice(pos + "profiles:".length);
        return decodeURIComponent(id);
    },
    
    setAttribute: function(name, value) {
        var result = null;
        var expr = "atom:content/*/um:attribute" + "[@name='" + name + "']/" + "um:attributeValue";
        var node = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, this.xmlData, this.ns);
        if (node) {
            // update existing meta data
            com.ibm.mm.enabler.utils.Dom.textContent(node, value);
            this.changedAttributes[name] = value;
            this.removedAttributes[name] = null;
        }
        else {
            // create meta data
            var mdBase = com.ibm.mashups.enabler.xml.XPath.evaluateEntry("atom:content/um:profile", this.xmlData, this.ns);
            if (mdBase) {
                var xmlDom = this.xmlData.ownerDocument;
                var nameNode = com.ibm.mm.enabler.utils.Dom.createElement(xmlDom, "um:attribute", this.ns.um);
                nameNode.setAttribute("name", name);
                nameNode.setAttribute("type", "xs:string");
                nameNode.setAttribute("multiValued", "false");
                var valueNode = com.ibm.mm.enabler.utils.Dom.createElement(xmlDom, "um:attributeValue", this.ns.um);
                com.ibm.mm.enabler.utils.Dom.textContent(valueNode, value);
                nameNode.appendChild(valueNode);
                mdBase.appendChild(nameNode);
                this.changedAttributes[name] = null;
                this.addedAttributes[name] = value;
                this.removedAttributes[name] = null;
            }
        }
        return result;
    },
    
    removeAttribute: function(name) {
        var expr = "atom:content/*/um:attribute" + "[@name='" + name + "']";
        var node = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, this.xmlData, this.ns);
        if (node) {
            dojo.destroy(node);
            this.changedAttributes[name] = null;
            this.addedAttributes[name] = null;
            this.removedAttributes[name] = "";
            return "";
        }
    },
    
    getChangedAttributeNames: function() {
        return this.changedAttributes;
    },
    
    getAddedAttributeNames: function() {
        return this.addedAttributes;
    },
    
    getRemovedAttributeNames: function() {
        return this.removedAttributes;
    },
    
    clearChangedAttributeNames: function(){
        this.changedAttributes = {};
        this.addedAttributes = {};
        this.removedAttributes = {};
    }
    
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.user.persistence.xml.CurrentUserImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.user.persistence.xml.CurrentUserImpl"] = true;
dojo.provide("com.ibm.mm.enabler.user.persistence.xml.CurrentUserImpl");




dojo.declare("com.ibm.mm.enabler.user.persistence.xml.CurrentUserImpl", [com.ibm.mm.enabler.user.persistence.xml.UserImpl], {
    constructor: function() {
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass);
        this.LOG_LEVEL = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
    },
    
    getJ2EEPrincipalName: function() {
        var principal = this.getAttribute("j2ee_principialname");
        if (principal) {
            // return j2ee principal name
            return principal;
        } else {
            // fall back to principal name
            return this.getLoginName();
        }
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.user.persistence.xml.AttributeImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.user.persistence.xml.AttributeImpl"] = true;
dojo.provide("com.ibm.mm.enabler.user.persistence.xml.AttributeImpl");







dojo.declare("com.ibm.mm.enabler.user.persistence.xml.AttributeImpl", com.ibm.mm.enabler.persistence.xml.XmlPersistenceImpl, {
    constructor: function(data) {
        var nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
        this.ns = nsf.getNameSpaces([nsf.NS_ATOM, nsf.NS_UM]);
        this.xmlData = data;
    },
    
    getName: function() {
        var xmlResult = com.ibm.mashups.enabler.xml.XPath.evaluateEntry("atom:title", this.xmlData, this.ns);
        if (!xmlResult) {
            return null;
        }
        return com.ibm.mm.enabler.utils.Dom.textContent(xmlResult);
    },
    
    getType: function() {
        var xmlResult = com.ibm.mashups.enabler.xml.XPath.evaluateEntry("atom:content/um:attribute", this.xmlData, this.ns);
        if (!xmlResult) {
            return null;
        }
        return xmlResult.getAttribute("type");
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.user.persistence.xml.GroupImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.user.persistence.xml.GroupImpl"] = true;
dojo.provide("com.ibm.mm.enabler.user.persistence.xml.GroupImpl");








dojo.declare("com.ibm.mm.enabler.user.persistence.xml.GroupImpl", [com.ibm.mm.enabler.user.persistence.xml.EntityImpl], {
    constructor: function(data, allAuthID, allAuthIDEncoded) {
        this.xmlData = data;
        this.allAuthID = allAuthID;
        this.allAuthIDEncoded = allAuthIDEncoded;

        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass);
        this.LOG_LEVEL = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
        
        var nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
        this.ns = nsf.getNameSpaces([nsf.NS_ATOM, nsf.NS_UM]);
    },
    
    getID: function() {
        var node = com.ibm.mashups.enabler.xml.XPath.evaluateEntry("atom:id", this.xmlData, this.ns);
        if (!node) {
            return null;
        }
        
        var fullID = com.ibm.mm.enabler.utils.Dom.textContent(node);
        if ((fullID === null) || (fullID.length === 0)) {
            return null;
        }
        
        if (com.ibm.mm.enabler.model.UserModel.iConfig.getID) {
            return com.ibm.mm.enabler.model.UserModel.iConfig.getID(fullID);
        }
        // strip off extra details
        var pos = fullID.indexOf("profiles/");
        if (pos == -1) {
            pos = fullID.indexOf("profiles:");
        }
        var id = fullID.slice(pos + "profiles:".length);
        return decodeURIComponent(id);
    },
    
    getCN: function() {
        var xmlResult = com.ibm.mashups.enabler.xml.XPath.evaluateEntry("atom:content/um:profile/um:attribute[@name='cn']/um:attributeValue", this.xmlData, this.ns);
        if (!xmlResult) {
            return null;
        }
        var cn = com.ibm.mm.enabler.utils.Dom.textContent(xmlResult);
        return cn;
    },
    
    getDisplayName: function() {
        if ((this.getID() == this.allAuthID) || (this.getID() == this.allAuthIDEncoded)) {
            this.iwStr = dojo.i18n.getLocalization("com.ibm.mm.enabler", "iwStr");
            return this.iwStr.ALL_AUTH;
        }
        
        var displayName = null;
        
        var xmlResult = com.ibm.mashups.enabler.xml.XPath.evaluateEntry("atom:content/um:profile/um:attribute[@name='displayName']/um:attributeValue", this.xmlData, this.ns);
        if (xmlResult) {
            displayName = com.ibm.mm.enabler.utils.Dom.textContent(xmlResult);
        }
        
        if ((typeof displayName == "undefined") || (displayName === null) || (displayName.length === 0)) {
            var configService = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
            var displayNameProp = configService.getValue(com.ibm.mashups.enabler.services.ConfigConstants.DEFAULT_GROUP_DISPLAY_PROP);
            if ((typeof displayNameProp != "undefined") && (displayNameProp !== null)) {
                displayName = this.getAttribute(displayNameProp);
            }
        }
        
        if ((typeof displayName == "undefined") || (displayName === null) || (displayName.length === 0)) {
            displayName = this.getCN();
        }
        
        return displayName;
    },
    
    getEntityType: function() {
        return "group";
    },
    
    getAttribute: function(attName) {
        var expr = "atom:content/um:profile/um:attribute[@name='" + attName + "']/um:attributeValue";
        var xmlResult = com.ibm.mashups.enabler.xml.XPath.evaluateEntry(expr, this.xmlData, this.ns);
        if (!xmlResult) {
            return null;
        }
        return com.ibm.mm.enabler.utils.Dom.textContent(xmlResult);
    },
    
    isVirtual: function() {
        if ((this.getID() == this.allAuthID) || (this.getID() == this.allAuthIDEncoded)) {
            return true;
        }
        
        return false;
    },
    
    getVirtualType: function() {
        if ((this.getID() == this.allAuthID) || (this.getID() == this.allAuthIDEncoded)) {
            return com.ibm.mashups.enabler.user.VirtualType.ALL_AUTHENTICATED_GROUP;
        }
        
        return null;
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.user.persistence.xml.UserModelImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.user.persistence.xml.UserModelImpl"] = true;
dojo.provide("com.ibm.mm.enabler.user.persistence.xml.UserModelImpl");

/*
 * This is injected on the fly and not fetched through an API. Therefore we need to define the @ibm-module so that the build process is picking it up
 * @ibm-module UserModelXml
 */






























// User Model
dojo.declare("com.ibm.mm.enabler.user.persistence.xml.UserModelImpl", [com.ibm.mm.enabler.model.ModelImpl], {
    constructor: function(anonUserID, anonUserIDEncoded, anonUser,
                allAuthID, allAuthIDEncoded, allAuth){
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass);
        this.LOG_LEVEL = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
        
        this.anonUserID = anonUserID;
        this.anonUserIDEncoded = anonUserIDEncoded;
        this.anonUser = anonUser;
        this.allAuthID = allAuthID;
        this.allAuthIDEncoded = allAuthIDEncoded;
        this.allAuth = allAuth;
        
        var nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
        this.ns = nsf.getNameSpaces([nsf.NS_ATOM, nsf.NS_UM]);
    },
    
    // singleton
    _getInstance: function(anonUserID, anonUserIDEncoded, anonUser,
                allAuthID, allAuthIDEncoded, allAuth){
        var instance = com.ibm.mm.enabler.user.persistence.xml.UserModelImpl._instance;
        return instance ? instance : (com.ibm.mm.enabler.user.persistence.xml.UserModelImpl._instance = 
            new com.ibm.mm.enabler.user.persistence.xml.UserModelImpl(anonUserID, anonUserIDEncoded, anonUser,
                allAuthID, allAuthIDEncoded, allAuth));
    },
    
    find: function(uri){
        return new com.ibm.mm.enabler.DeferredImpl(this, this._find, uri);
    },
    
    _find: function(dfr, sync, id){
        // logging support
        var LOG_METHOD = "_find";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, arguments);
        }
        
        var myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(com.ibm.mashups.enabler.model.url.ModelUrlFactory.USER_URL, this);
        myUrl.setSchemeSpecificPart("users:profiles:" + encodeURIComponent(id));
        myUrl.setParameter("expandRefs", "true");
        
        var serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
        var retVal = null;
        
        serviceReq.read(dojo.hitch(this, function(type, data, xhr, args){
            if (type != com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_ERROR) {
                var status = com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK;
                var userXml = com.ibm.mashups.enabler.xml.XPath.evaluateEntry("//atom:entry", data, this.ns);
                if (userXml) {
                    retVal = new com.ibm.mm.enabler.user.persistence.xml.UserImpl(userXml, this.anonUserID, this.anonUserIDEncoded);
                }
                if (retVal !== null) {
                }
                else 
                    if (sync) {
                        status = com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_NOT_FOUND;
                    }
            }
            
            if (dfr) {
                dfr.finish(retVal, status);
            }
        }));
        
        // exit trace
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD);
        }
        return retVal;
    },
    
    findUsersByAttribute: function(/*String*/attributeName, /*String*/ attributeValue){
        return new com.ibm.mm.enabler.DeferredImpl(this, this._findUsersByAttribute, {
            name: attributeName,
            value: attributeValue
        });
    },
    
    _findUsersByAttribute: function(dfr, sync, attr){
        // logging support
        var LOG_METHOD = "_findUsersByAttributes";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, arguments);
        }
        var attributeName = attr.name;
        var attributeValue = attr.value;
        var myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(com.ibm.mashups.enabler.model.url.ModelUrlFactory.USER_URL, this);
        myUrl.setSchemeSpecificPart("users:profiles");
        myUrl.setParameter("expandRefs", "true");
        myUrl.setParameter("searchAttributes", attributeName + "=" + encodeURIComponent(attributeValue));
        
        var retVal = null;
        var serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
        serviceReq.read(dojo.hitch(this, function(type, data, xhr, args){
            if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_LOAD) {
	            var userXmls = com.ibm.mashups.enabler.xml.XPath.evaluateXPath("atom:feed/atom:entry", data, this.ns);
    	        retVal = dojo.map(userXmls, function(userXml){
        	        return new com.ibm.mm.enabler.user.persistence.xml.UserImpl(userXml, this.anonUserID, this.anonUserIDEncoded);
            	}, this);
            }
            if (dfr) {
                dfr.finish(retVal, xhr.status);
            }
        }));
        // exit trace
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD);
        }
        return retVal;
    },
    
    findGroupByID: function(/*String*/id){
        return new com.ibm.mm.enabler.DeferredImpl(this, this._findGroupByID, id);
    },
    
    _findGroupByID: function(dfr, sync, id){
        // logging support
        var LOG_METHOD = "_findGroupByID";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, arguments);
        }
        
        if ((id === this.allAuthID) || (id === this.allAuthIDEncoded)) {
            return this.allAuth;
        }
        
        var myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(com.ibm.mashups.enabler.model.url.ModelUrlFactory.USER_URL, this);
        myUrl.setSchemeSpecificPart("groups:profiles:" + encodeURIComponent(id));
        myUrl.setParameter("expandRefs", "true");
        
        var serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
        var retVale = null;
        serviceReq.read(dojo.hitch(this, function(type, data, xhr, args){
            var groupXml = com.ibm.mashups.enabler.xml.XPath.evaluateEntry("//atom:entry", data, this.ns);
            if (groupXml) {
                retVal = new com.ibm.mm.enabler.user.persistence.xml.GroupImpl(groupXml, this.allAuthID, this.allAuthIDEncoded) || null;
            }
            if (dfr) {
                dfr.finish(retVal, xhr.status);
            }
        }));
        
        // exit trace
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD);
        }
        return retVal;
    },
    
    findGroupsByAttribute: function(/*String*/attributeName, /*String*/ attributeValue){
        return new com.ibm.mm.enabler.DeferredImpl(this, this._findGroupsByAttribute, {
            name: attributeName,
            value: attributeValue
        });
    },
    
    _findGroupsByAttribute: function(dfr, sync, attr){
        // logging support
        var LOG_METHOD = "_findGroupsByAttribute";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, arguments);
        }
        var attributeName = attr.name;
        var attributeValue = attr.value;
        var myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(com.ibm.mashups.enabler.model.url.ModelUrlFactory.USER_URL, this);
        //myUrl.addParameter("uri", "um:groups:profiles&expandRefs=true&searchAttributes="+attributeName+"="+attributeValue);
        myUrl.setSchemeSpecificPart("groups:profiles");
        myUrl.setParameter("expandRefs", "true");
        myUrl.setParameter("searchAttributes", attributeName + "=" + encodeURIComponent(attributeValue));
        
        var serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
        var retVal = null;
        serviceReq.read(dojo.hitch(this, function(type, data, xhr, args){
            var groupXmls = com.ibm.mashups.enabler.xml.XPath.evaluateXPath("atom:feed/atom:entry", data, this.ns);
            retVal = dojo.map(groupXmls, function(groupXml){
                return new com.ibm.mm.enabler.user.persistence.xml.GroupImpl(groupXml, this.allAuthID, this.allAuthIDEncoded);
            }, this);
            if (dfr) {
                dfr.finish(retVal, xhr.status);
            }
        }));
        // exit trace
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD);
        }
        return retVal;
    },
    
    findCurrentUser: function(){
        return new com.ibm.mm.enabler.DeferredImpl(this, this._findCurrentUser);
    },
    
    _findCurrentUser: function(dfr, sync){
        // logging support
        var LOG_METHOD = "_findCurrentUser";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, arguments);
        }
        var retVal = null;
        var myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(com.ibm.mashups.enabler.model.url.ModelUrlFactory.USER_URL, this);
        myUrl.setSchemeSpecificPart("currentuser:profile");
        myUrl.setParameter("expandRefs", "true");
        
        var serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
        serviceReq.read(dojo.hitch(this, function(type, data, xhr, args){
            var userXml = com.ibm.mashups.enabler.xml.XPath.evaluateEntry("//atom:entry", data, this.ns);
            if (userXml) {
                retVal = new com.ibm.mm.enabler.user.persistence.xml.CurrentUserImpl(userXml, this.anonUserID, this.anonUserIDEncoded);
            }
            if (dfr) {
                dfr.finish(retVal, xhr.status);
            }
        }));
        
        // exit trace
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD);
        }
        return retVal;
    },
    
    findGroupAttributes: function(){
        return new com.ibm.mm.enabler.DeferredImpl(this, this._findGroupAttributes);
    },
    
    _findGroupAttributes: function(dfr, sync){
        // logging support
        var LOG_METHOD = "findGroupAttributes";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, arguments);
        }
        
        var myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(com.ibm.mashups.enabler.model.url.ModelUrlFactory.USER_URL, this);
        myUrl.setSchemeSpecificPart("attributes:groups");
        myUrl.setParameter("expandRefs", "true");
        
        var serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
        var retVal = null;
        serviceReq.read(dojo.hitch(this, function(type, data, xhr, args){
            var attributeXmls = com.ibm.mashups.enabler.xml.XPath.evaluateXPath("atom:feed/atom:entry", data, this.ns);
            retVal = dojo.map(attributeXmls, function(attributeXml){
                return new com.ibm.mm.enabler.user.persistence.xml.AttributeImpl(attributeXml);
            }, this);
            if (dfr) {
                dfr.finish(retVal, xhr.status);
            }
        }));
        
        // exit trace
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD);
        }
        return retVal;
    },
    
    findUserAttributes: function(){
        return new com.ibm.mm.enabler.DeferredImpl(this, this._findUserAttributes);
    },
    
    _findUserAttributes: function(dfr, sync){
        // logging support
        var LOG_METHOD = "_findUserAttributes";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, arguments);
        }
        
        var myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(com.ibm.mashups.enabler.model.url.ModelUrlFactory.USER_URL, this);
        myUrl.setSchemeSpecificPart("attributes:users");
        myUrl.setParameter("expandRefs", "true");
        
        var serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, sync);
        var retVal = null;
        serviceReq.read(dojo.hitch(this, function(type, data, xhr, args){
            var attributeXmls = com.ibm.mashups.enabler.xml.XPath.evaluateXPath("atom:feed/atom:entry", data, this.ns);
            retVal = dojo.map(attributeXmls, function(attributeXml){
                return new com.ibm.mm.enabler.user.persistence.xml.AttributeImpl(attributeXml);
            }, this);
            if (dfr) {
                dfr.finish(retVal, xhr.status);
            }
        }));
        // exit trace
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD);
        }
        return retVal;
    },
    
    isDirty: function(node){
        var LOG_METHOD = "isDirty()";
        var bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, arguments);
        }
        if (node) {
            if (node.getAddedAttributeNames() || node.getChangedAttributeNames() || node.getChangedAttributeNames()) {
                if (bIsLoggable) {
                    this.LOGGER.exiting(LOG_METHOD, true);
                }
                return true;
            }
        }
        if (bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD, false);
        }
        
        return false;
    },
    
    commit: function(node){
        return new com.ibm.mm.enabler.DeferredOperationImpl(this, this._commit, node);
    },
    
    _commit: function(deferred, sync, node){
        if (node) {
            if (node.getAddedAttributeNames() || node.getChangedAttributeNames() || node.getChangedAttributeNames()) {
                // HTTP PUT updated nodes
                var myUrl = com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelURL(com.ibm.mashups.enabler.model.url.ModelUrlFactory.USER_URL, this);
                myUrl.setSchemeSpecificPart("currentuser:profile");
                myUrl.setParameter("expandRefs", "true");
                
                var serviceReq = new com.ibm.mm.enabler.services.ModelRestServiceRequest(myUrl, null, null, false, true);
                
                serviceReq.update(node.toString(), dojo.hitch(this, function(type, data, xhr, args){
                    if (type == com.ibm.mm.enabler.services.ModelRestServiceRequest.XHR_STATUS_LOAD) {
                        node.clearChangedAttributeNames();
                        var userXml = com.ibm.mashups.enabler.xml.XPath.evaluateEntry("//atom:entry", data, this.ns);
                        if (userXml) {
                            node = new com.ibm.mm.enabler.user.persistence.xml.UserImpl(userXml, this.anonUserID, this.anonUserIDEncoded);
                        }
                        
                        if (deferred && deferred.operationCallback) {
                            deferred.operationCallback(node, com.ibm.mashups.enabler.DeferredOperation.OPERATION_MODIFY, xhr.status, deferred.operationCallbackParameters);
                        }
                    }
                    if (deferred) {
                        deferred.finish(node, xhr.status);
                    }
                }));
            }
        }
    }
    
});

}


dojo.i18n._preloadLocalizations("com.ibm.mm.enabler.nls.enabler", ["ROOT","ar","ca","cs","da","de","de-de","el","en","en-gb","en-us","es","es-es","fi","fi-fi","fr","fr-fr","he","he-il","hr","hu","it","it-it","ja","ja-jp","ko","ko-kr","nb","nl","nl-be","nl-nl","no","pl","pt","pt-br","pt-pt","ro","ro-ro","ru","sk","sl","sv","th","tr","uk","xx","zh","zh-cn","zh-tw"]);
