/** Licensed Materials - Property of IBM, 5724-U69, (C) Copyright IBM Corp. 2008, 2010 - All Rights reserved.  **/
dojo.provide("com.ibm.mm.enabler.minimal");

dojo.i18n._preloadLocalizations("com.ibm.mm.enabler.nls.enabler", ["ROOT","ar","ca","cs","da","de","de-de","el","en","en-gb","en-us","es","es-es","fi","fi-fi","fr","fr-fr","he","he-il","hr","hu","it","it-it","ja","ja-jp","ko","ko-kr","nb","nl","nl-be","nl-nl","no","pl","pt","pt-br","pt-pt","ro","ro-ro","ru","sk","sl","sv","th","tr","uk","xx","zh","zh-cn","zh-tw"]);


(function() { 
    var ver = "3.0.0.20110722-1812".split(".");
    var flag = "enabler.minimal";

    if (flag) {
		flag = "_" + flag;
	}

    if (ver.length == 4) {
        dojo.setObject("com.ibm.mashups.enabler.version",{ 
            major: ver[0], 
            minor: ver[1], 
            patch: ver[2],
            "flag": flag,
            revision: ver[3], 
            toString: function() {
            	return this.major + "." + this.minor + "." + this.patch + (this.flag || "") + " (" + this.revision + ")";    // String
            }
        });
    }
})();

if(!dojo._hasResource["com.ibm.mashups.enabler.Deferred_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.Deferred_API"] = true;
dojo.provide("com.ibm.mashups.enabler.Deferred_API");
dojo.provide("com.ibm.mashups.enabler.Deferred");

/**
 * Base interface for all classes which handle actions asynchronously.
 * An action may involve one or more operations, for example creating or
 * updating a model resource, which in turn may involve one or more HTTP
 * requests. The Deferred interface allows to trigger a callback after
 * the entire action, i.e. all involved HTTP requests, is finished. Thus,
 * the Deferred interface may be used to get the overall result of an action.
 * @ibm-api
 * @ibm-module Base2
 */
dojo.declare( "com.ibm.mashups.enabler.Deferred", null, {
	
    /**
     * Sets the handler of the deferred action. It is called when the entire
     * action has finished.<br> 
     * Please note that the status of the action is transported only with 
     * callbacks, even if you use synchronous mode. If you need to check the status, 
     * you must use callback functions.
     * @param {Object} callback the callback funtion in the format of <code>Function(Object resource, int statusCode, Object[] params)</code>. 
     * Must not be <code>null</code><br>
     * &nbsp;&nbsp;&nbsp;&nbsp;<b>Callbackparameters</b><br>
     * &nbsp;&nbsp;&nbsp;&nbsp;<code>resource</code> - resource object or id string
     * of the related resource.
     * May be <code>null</code> in case the action does not relate
     * to a particular resource. In case multiple resources are involved in the
     * action, the DeferredOperation interface may be used to obtain the resource
     * objects or string <code>id</code>s of those resources.<br>
     * &nbsp;&nbsp;&nbsp;&nbsp;<code>statusCode</code> - the overall HTTP status
     * code of the action (the highest status code of the involved operations).<br>
     * &nbsp;&nbsp;&nbsp;&nbsp;<code>params</code> - the parameters
     * passed into the callback
     * @param {Object[]} parameters optional array of parameters to be
     * passed on to the callback function. May be <code>null</code>
     * @return {com.ibm.mashups.enabler.Deferred} the deferred object
     */
    setFinishedCallback: function(callback, parameters) {
    },

    /**
     * Executes the deferred action and invokes the callback functions set
     * with the deferred object.
     * @param {Boolean} sync indicates if the deferred action is executed 
     * synchronously or asynchronously. Optional, defaults to true.
     * @return {Object} resource if called asynchronously, the return value is 
     * <code>undefined</code>, otherwise a resource object or id string of the 
     * related resource is returned.<br> In order to obtain information on
     * the resource as well as on the status code of the operation, you
     * must use the callback functions of the deferred object.
     */
    start: function(sync) {
        return {};
    }
});

}

if(!dojo._hasResource["com.ibm.mashups.enabler.logging.LogLevel"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.logging.LogLevel"] = true;
dojo.provide("com.ibm.mashups.enabler.logging.LogLevel" ); 

/**
* The LogLevel class defines a set of standard logging levels that can be used to control logging output. 
* The logging levels are internally ordered. Enabling logging at a given level also enables logging at all higher levels.
*
* Clients should normally use the predefined Level constants such as <code>com.ibm.mashups.enabler.logging.LogLevel.SEVERE</code>.
*
* The levels in descending order are:
* <ul>
* <li>SEVERE (highest value)</li>
* <li>WARNING</li>
* <li>INFO</li>
* <li>TRACE (lowest value)</li>
* </ul>
*
* @ibm-api
* @ibm-module Base2
*/
dojo.declare("com.ibm.mashups.enabler.logging.LogLevel", null,
{
	/**
	* TRACE is a message level providing tracing information.<br/><br/>
	* TRACE is intended for relatively detailed tracing. The exact meaning of the this levels will vary 
	* between subsystems. 
	* In general the TRACE level should be used for information that will be broadly interesting to developers 
	* who do not have a specialized interest in the specific subsystem.<br/><br/>
	* TRACE messages might include things like minor (recoverable) failures. Issues indicating potential 
	* performance problems are also worth logging as FINE. This level is initialized to <code>500</code>.
	* @type {int}
	*/
	TRACE:   500,
	/**
	* INFO is a message level for informational messages.<br/><br/>
	* Typically INFO messages will be written to the console or its equivalent (like the system messages widget).
	* So the INFO level should only be used for reasonably significant messages that will make sense 
	* to end users and system admins. This level is initialized to <code>800</code>.
	* @type {int}
	*/
	INFO:    800,
	/**
	* WARNING is a message level indicating a potential problem.<br/><br/>
	* In general WARNING messages should describe events that will be of interest to end users or system 
	* managers, or which indicate potential problems. This level is initialized to <code>900</code>. 
	* @type {int}
	*/
	WARNING: 900,
	/**
	* SEVERE is a message level indicating a serious failure.<br/><br/>
	* In general SEVERE messages should describe events that are of considerable importance and which 
	* will prevent normal program execution. They should be reasonably intelligible to end users and to 
	* system administrators. This level is initialized to <code>1000</code>. 
	* @type {int}
	*/
	SEVERE:  1000
});

// instance of the internal log level class for convinient accessing of the LogLevels.
com.ibm.mashups.enabler.logging.LogLevel = new com.ibm.mashups.enabler.logging.LogLevel();

}

if(!dojo._hasResource["com.ibm.mashups.enabler.logging.LogHandler"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.logging.LogHandler"] = true;
dojo.provide("com.ibm.mashups.enabler.logging.LogHandler"); 

dojo.require("com.ibm.mashups.enabler.logging.LogLevel" ); 

/**
* A <code>LogHandler</code> object takes log messages from a Logger and exports them. It might for example, 
* write them to a console or write them to a widget or whatever. 
* @ibm-spi 
* @ibm-module Base2
*/
dojo.declare("com.ibm.mashups.enabler.logging.LogHandler",null,
{
	/**
	* @private
	*/
	constructor: function() {
	},
	/**
	* Returns the ID of this handler. This ID needs to be unique and must not be <code>null</code>.
	* @type {String}
	* @return the ID of this handler.
	*/
	getHandlerID: function() {
		return null; 
	},
	/**
	* Get the log level specifying which messages will be logged by this <code>LogHandler</code>. Message levels lower than this level will be discarded. 
	* @type {int}
	* @return the level of messages being logged. The returned int needs to be a log level as defined in com.ibm.mashups.enabler.logging.LogLevel.
	*/
	getLogLevel: function() {
		return null;
	}, 
	/**
	* Method that get's invoked as soon as a subscribed and valid event is published in the logging framework.
	* @param {String} loggerName the name of the logger that published the event.
	* @param {int} logLevel  the LogLevel of the published event.
	* @param {String} method the method that caused the event.
	* @param {String} message the message sent by the method
	* @type {void}
	*/
	log: function(loggerName, logLevel, method, message) {
	} 
});

}

if(!dojo._hasResource["com.ibm.mashups.enabler.logging.Logger_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.logging.Logger_API"] = true;
dojo.provide("com.ibm.mashups.enabler.logging.Logger_API");
dojo.provide("com.ibm.mashups.enabler.logging.Logger");

dojo.require("com.ibm.mashups.enabler.logging.LogLevel" ); 
 

/**
* A Logger object is used to log messages for a specific system or application component. Loggers are 
* normally named, using a hierarchical dot-separated namespace. Logger names can be arbitrary strings, 
* but they should normally be based on the package name or class name of the logged component, such as <tt>com.ibm.mm.enabler</tt> or <tt>com.ibm.mm.enabler.services.ConfigService</tt>.
* <br/><br/>
* Logger objects may be obtained by calls on one of the getLogger factory methods. These will either create a new Logger or return a suitable existing Logger.
* <br/><br/>
* Logging messages will be forwarded to registered Handler objects, which can forward the messages to a variety of destinations, including consoles, files, OS logs, etc.
* <br/><br/>
* Each Logger keeps track of a &quot;parent&quot; Logger, which is its nearest existing ancestor in the Logger namespace. The default Enabler logging framework uses only one parent logger, the &quot;root Logger&quot;
* <br/><br/>
* On each logging call the Logger initially performs a cheap check of the request level (e.g. <tt>SEVERE</tt> or <tt>TRACE</tt>) against the effective global log level for the logger. If the request level is lower than the log level, the logging call returns immediately.
* <br/><br/>
* After passing this initial (cheap) test, the Logger will publish a the specified paramters to its output Handlers. By default, if the logger is not the root logger, it also publishes to it's parent's Handlers.
* <br/><br/>
* Most of the logger output methods take a &quot;message&quot; argument. This message argument may be either a raw value or a format string. During formatting, the format string will be filled in with the specified parameters. Otherwise the original message string is used. Typically the logger uses <tt>dojo.string.substitute</tt> style formatting to format parameters, so for example a format string &quot;<tt>${0} ${1}</tt>&quot; would format two parameters as strings.
* <br/><br/>
* A global JS object can be used to configure the loggers that are considered for tracing. <br />
* This object is named <code>traceConfig</code> and can be accessed through the &nbsp;{@link com.ibm.mashups.enabler.services.ConfigService ConfigService} or initialized by <tt>ConfigService.properties</tt><br/><br/>
* <pre>[
* "com.ibm.mashups.*",</br>
* "com.ibm.mm.*"
* ]</pre><br />Additional to the classes that should be logged the <code>isDebug</code> Flag must be set to <code>true</code>.
* 
* @since 2.0
* @ibm-module Base2
*/
dojo.declare("com.ibm.mashups.enabler.logging.Logger", null,
{
	/**
	* @private
	*/
	constructor: function() {
	},
	/**
	* Find or create a logger for a named subsystem. If a logger has already been created with the given name it is returned. Otherwise a new logger is created.
	* @ibm-api
	* @param {String} loggerName A name for the logger. This should be a dot-separated name and should normally be based on the package name or class name of the subsystem, such as com.ibm.mm.enabler or com.ibm.mm.enabler.services.ConfigService
	* @type {com.ibm.mashups.enabler.logging.Logger}
	* @return a suitable Logger 
	*/
	getLogger: function(loggerName) {
		return null;
	},
	/**
	* Adds a handler to the handler chain, so that it is capable of receiving events from the logging framework.
	* @ibm-spi
	* @param {com.ibm.mashups.enabler.logging.LogHandler} handler the LogHandler to subscribe to the specific logging events.
	* @type {void}
	*/
	addHandler: function(handler) {
	},
	/**
	* Removes a handler from the handler chain and unsubscribing it from the logging framework events.
	* @ibm-spi
	* @param {com.ibm.mashups.enabler.logging.LogHandler} handler the LogHandler to unsubscribe to the specific logging events.
	* @type {void}
	*/
	removeHandler: function(handler) {
	},
	/**
	* This is a convenience method that can be used to log entry to a method. A event with the message "ENTRY", log level <tt>TRACE</tt>, and the given methodName is published
	* @ibm-api
	* @param {String} methodName  the name of the method .
	* @param {Object[]} args  array of arguments that's passed into the method. Those arguments will be added to the entering comment in a comma separated way.
	* @type {void}
	*/ 	
	entering: function(methodName, args) {
	},
	/**
	* This is a convenience method that can be used to log returning of a method. A event with the message "RETURN", log level <tt>TRACE</tt>, and the given methodName is published. 
	* This method allows components to trace the exiting of the method.
	* @ibm-api
	* @param {String} methodName  the name of the method .
	* @param {Object[]} args  array of arguments that's passed into the method. Those arguments will be added to the exiting comment in a comma separated way.
	* @type {void}
	*/ 	
	exiting: function(methodName, args) {
	},
	/**
	* This method allows components to log an <tt>INFO</tt> level event.
	* @ibm-api
	* @param {String} methodName  the name of the method .
	* @param {String} message the message that you want to log.
	* @param {Object[]} args  array of arguments that's passed into the method. Those arguments will be filled into the wildcards in your message.
	* @type {void}
	*/ 	
	info: function(methodName, message, args) {
	},
	/**
	* This method allows components to log an <tt>WARNING</tt> level event.
	* @ibm-api
	* @param {String} methodName  the name of the method .
	* @param {String} message the message that you want to log.
	* @param {Object[]} args  array of arguments that's passed into the method. Those arguments will be filled into the wildcards in your message.
	* @type {void}
	*/ 	
	warning: function(methodName, message, args) {
	},
	/**
	* This method allows components to log an <tt>SEVERE</tt> level event.
	* @ibm-api
	* @param {String} methodName  the name of the method .
	* @param {String} message the message that you want to log.
	* @param {Object[]} args  array of arguments that's passed into the method. Those arguments will be filled into the wildcards in your message.
	* @type {void}
	*/ 	
	severe: function(methodName, message, args) {
	},
	/**
	* This method allows components to log an <tt>TRACE</tt> level event.
	* @ibm-api
	* @param {String} methodName  the name of the method .
	* @param {String} message the message that you want to log.
	* @param {Object[]} args  array of arguments that's passed into the method. Those arguments will be filled into the wildcards in your message.
	* @type {void}
	*/ 	
	trace: function(methodName, message, args) {
	},
	/**
	* This method allows components to log a logging event for the specified &nbsp;{@link com.ibm.mashups.enabler.logging.LogLevel LogLevel}
	* @ibm-api
	* @param {int} logLevel the &nbsp;{@link com.ibm.mashups.enabler.logging.LogLevel LogLevel} to use for logging.
	* @param {String} methodName  the name of the method.
	* @param {String} message the message that you want to log.
	* @param {Object[]} args  array of arguments that's passed into the method. Those arguments will be filled into the wildcards in your message.
	* @type {void}
	*/ 	
	log: function(logLevel, methodName, message, args) {
	},
	/**
	* Check if a message of the given level would actually be logged by this logger.
	* @ibm-api
	* @param {int} logLevel the &nbsp;{@link com.ibm.mashups.enabler.logging.LogLevel LogLevel} to check
	* @type {boolean}
	* @return <code>true</code> if the given message level is currently being logged.
	*/
	isLoggable: function(logLevel) {
		return false;
	}
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.logging.ConsoleHandler"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.logging.ConsoleHandler"] = true;
dojo.provide("com.ibm.mm.enabler.logging.ConsoleHandler");



dojo.declare("com.ibm.mm.enabler.logging.ConsoleHandler",[com.ibm.mashups.enabler.logging.LogHandler],
{
	constructor: function() {
		this.handlerID = "com.ibm.mm.enabler.logging.ConsoleHandler";
		this.logLevel = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
	},
	getHandlerID: function() {
		return this.handlerID;
	},
	getLogLevel: function() {
		return this.logLevel;
	},
	log: function(loggerName, logLevel, method, message) {
		if (logLevel == com.ibm.mashups.enabler.logging.LogLevel.SEVERE) {
			console.error(loggerName + " " + method + ": " + message);
		}
		else if (logLevel == com.ibm.mashups.enabler.logging.LogLevel.WARNING) {
			console.warn(loggerName + " " + method + ": " + message);
		}
		else if (logLevel == com.ibm.mashups.enabler.logging.LogLevel.INFO) {
			console.info(loggerName + " " + method + ": " + message);
		}
		else if (logLevel == com.ibm.mashups.enabler.logging.LogLevel.TRACE) {
			console.debug(loggerName + " " + method + ": " + message);
		}
	} 
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.logging.LoggerImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.logging.LoggerImpl"] = true;
dojo.provide("com.ibm.mm.enabler.logging.LoggerImpl");




/**
* This is the root logger class which will automatically dispatch getLoggerRequests and other requests
* to it's real implementors.
*/
dojo.declare("com.ibm.mm.enabler.logging.LoggerImpl", [com.ibm.mashups.enabler.logging.Logger],
{
	BASE_TOPIC: "com.ibm.mm.enabler.logging.",
	
	constructor: function(name, parentLogger) {
		this.loggers = {};
		this.handlers = {};
		
		// make sure those two are really null
		this.name = name?name:null;
		this.parentLogger = parentLogger?parentLogger:null;
		
		if (!this.parentLogger) {
			if (ibmConfig && ibmConfig.traceConfig) {
				this._setTraceConfig(ibmConfig.traceConfig);
			}
			else {
				this._setTraceConfig();
			}
		}
			
	},
	getLogger: function(name) {
		// if we have a parentlogger dispatch to it
		if (this.parentLogger) {
			return this.parentLogger.getLogger(name);
		}
			
		// since we are here we have no parent and need to handle everything be ourself
		if (!this.loggers[name]) {
			this.loggers[name] = new com.ibm.mm.enabler.logging.LoggerImpl(name, this);
		}
		
		return this.loggers[name];
	},
	addHandler: function(handler) {
		if (this.parentLogger) {
			return this.parentLogger.addHandler(handler);
		}
			
		this.handlers[handler.handlerID] = {};
		var handlerObject = this.handlers[handler.handlerID];
		handlerObject.handler = handler;
		
		
		// get the handlers desired log level and subscribe him with respect to priority
		// ordering including from RTL severe, warning, info, trace
		var logLevel = handler.getLogLevel();
		var handlerLogMethod = "log";
		
		// always subscribe to severe
		handlerObject.severeHandle = dojo.subscribe(this.BASE_TOPIC+com.ibm.mashups.enabler.logging.LogLevel.SEVERE, handler, handlerLogMethod);
		
		// subscribe to warning, if warning or finer
		if (logLevel <= com.ibm.mashups.enabler.logging.LogLevel.WARNING) {
			handlerObject.warningHandle = dojo.subscribe(this.BASE_TOPIC+com.ibm.mashups.enabler.logging.LogLevel.WARNING, handler, handlerLogMethod);
		}
			
		// subscribe to info, if info or finer
		if (logLevel <= com.ibm.mashups.enabler.logging.LogLevel.INFO) {
			handlerObject.infoHandle = dojo.subscribe(this.BASE_TOPIC+com.ibm.mashups.enabler.logging.LogLevel.INFO, handler, handlerLogMethod);
		}
			
		// subscribe to trace, if trace or finer
		if (logLevel <= com.ibm.mashups.enabler.logging.LogLevel.TRACE) {
			handlerObject.traceHandle = dojo.subscribe(this.BASE_TOPIC+com.ibm.mashups.enabler.logging.LogLevel.TRACE, handler, handlerLogMethod);
		}
	},
	removeHandler: function(handler) {
        var handlerObject;
        var handlerID;
        
        if (dojo.isString(handler)) {
            if (!handler in this.handlers) {
                return;
            }
                
            handlerObject = this.handlers[handler];
            handlerID = handler;
        } else if (dojo.isObject(handler)) {
            handlerObject = this.handlers[handler.getHandlerID()];
            handlerID = handler.getHandlerID();
        } else {
            return;
        }
		
		if (handlerObject) {
			if (handlerObject.severeHandle) {
				dojo.unsubscribe(handlerObject.severeHandle);
			}
				
			if (handlerObject.warningHandle) {
				dojo.unsubscribe(handlerObject.warningHandle);
			}
				
			if (handlerObject.infoHandle) {
				dojo.unsubscribe(handlerObject.infoHandle);
			}
				
			if (handlerObject.traceHandle) {
				dojo.unsubscribe(handlerObject.traceHandle);
			}
				
			if (handlerObject.handler) {
				delete handlerObject.handler;
			}
		}
		
		delete this.handlers[handlerID];
	},
	entering: function(methodName, args) {
		var logLevel = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
		if (this.isLoggable(logLevel)) {
			var msg = this._getMessageString(args); 
			this._log(this.name, logLevel, methodName, "ENTRY" + (msg?" " + msg:""));
		}
			
	},
	exiting: function(methodName, args) {
		var logLevel = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
		if (this.isLoggable(logLevel)) {
			var msg = this._getMessageString(args); 
			this._log(this.name, logLevel, methodName, "RETURN" + (msg?" " + msg:""));
		}
	},
	info: function(methodName, message, args) {
		var logLevel = com.ibm.mashups.enabler.logging.LogLevel.INFO;
		this.log(logLevel, methodName, message, args);
	},
	warning: function(methodName, message, args) {
		var logLevel = com.ibm.mashups.enabler.logging.LogLevel.WARNING;
		this.log(logLevel, methodName, message, args);
	},
	severe: function(methodName, message, args) {
		var logLevel = com.ibm.mashups.enabler.logging.LogLevel.SEVERE;
		this.log(logLevel, methodName, message, args);
	},
	trace: function(methodName, message, args) {
		var logLevel = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
		this.log(logLevel, methodName, message, args);
	},
	log: function(logLevel, methodName, message, args) {
        if (!this.parentLogger) {
            this._log("com.ibm.mashups.enabler.logging.Logger", com.ibm.mashups.enabler.logging.LogLevel.WARNING, "{log|info|warning|severe|trace|entering|exiting}", 
            "You must not use the RootLogger (com.ibm.mashups.enabler.logging.Logger). Create your own logger for each class.");
        }
		if (this.isLoggable(logLevel)) {
			this._log(this.name, logLevel, methodName, message, args);
		}
	},
	isLoggable: function(logLevel) {
		// unless we want to also modify loglevels per package return true for LL > TRACE
		if (logLevel != com.ibm.mashups.enabler.logging.LogLevel.TRACE) {
			return true;
		}
		
		// if not isDebug is set we don't want to log
		if (!(ibmConfig && ibmConfig.isDebug)) {
			return false;
		}
			
		var regExp = this._getRegExp();
		
		if (regExp && regExp.exec(this.name)) {
			return true;
		}
			
		return false;
	},
	_log: function(loggerName, logLevel, methodName, message, args) {
		// for convinience wrap single objects to an object (that user doesn't need to).
		if ((args && !dojo.isArray(args)) || args === false) {
			args = [args];
		}
		
		var formattedMessage = args ? dojo.string.substitute(message.toString(), args) : message;
		
		// publish the logging event ...
		dojo.publish(this.BASE_TOPIC + logLevel, [loggerName, logLevel, methodName, formattedMessage]);
	},
	_getMessageString: function(args) {
		var argc = 0;
		var msg = "";
		if (args || args === false) {
			msg += "[ ";
			if (dojo.isArray(args)) {
                for (var i=0; i<args.length; ++i) {
                    var arg = args[i];
                    
                     if (msg.length > 2) {
                        msg += ", "; // make sure to add the separator for the output
                     }
                        
                    if (typeof arg == "undefined") {
                        msg += "undefined";
                    }

                    if (arg && arg.toString) {                          
                    	msg += arg.toString(); // make sure to use toString if possible
                    }
                    else if (arg === null) {
                        msg += "null"; // see if the value is null
                    }
                    else {
                        msg += "n/a"; // otherwise there is no simple way to output the object
                    }
                }
            } else { // not an array but only one element
                if (args && args.toString) {
                    msg += args.toString(); // make sure to use toString if possible
                }
                else if (args === null) {
                    msg += "null"; // see if the value is null
                }
                else {
                    msg += "n/a"; // otherwise there is no simple way to output the object
                }
			}			
			msg += " ]";
		}
		
		return msg;
	},
    _setTraceConfig: function(traceConfig) {
		if (dojo.isString(traceConfig) && traceConfig.length > 0 && traceConfig == "*") {
            this._log("RootLogger", com.ibm.mashups.enabler.logging.LogLevel.TRACE, "_setTraceConfig", "Invalid traceConfig specified: *");
		}
		else if ((dojo.isArray(traceConfig) || dojo.isString(traceConfig)) && traceConfig.length > 0) {
            this._log("RootLogger", com.ibm.mashups.enabler.logging.LogLevel.TRACE, "_setTraceConfig", "Changing traceConfig: " + traceConfig);
            var baseRegExp = dojo.isArray(traceConfig)?traceConfig.join("|"):traceConfig;
            
            if (baseRegExp.length > 0) {
                this.regExp = new RegExp(baseRegExp);
                return;
            }
        }
        
        this.regExp = null;
    },
	
	_disableTraceConfig: function() {
		this.regExp = null;
	},
	
	_getRegExp: function() {
		if (this.parentLogger) {
			return this.parentLogger._getRegExp();
		}
		return this.regExp;
	}

});

//create the root logger (no package, no parentlogger)
com.ibm.mashups.enabler.logging.Logger = new com.ibm.mm.enabler.logging.LoggerImpl(); 
//add the default handler to the root logger
com.ibm.mashups.enabler.logging.Logger.addHandler(new com.ibm.mm.enabler.logging.ConsoleHandler());

}

if(!dojo._hasResource["com.ibm.mashups.enabler.logging.Logger"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.logging.Logger"] = true;
dojo.provide("com.ibm.mashups.enabler.logging.Logger");





}

if(!dojo._hasResource["com.ibm.mm.enabler.DeferredImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.DeferredImpl"] = true;
dojo.provide("com.ibm.mm.enabler.DeferredImpl");






// base
dojo.declare("com.ibm.mm.enabler.DeferredImpl", [com.ibm.mashups.enabler.Deferred], {

    _chainedDeferred: null,
    
    _sync: false,
    _previous: null,
    
    // If you mixin the DeferredImpl into your class, you may use a different 
    // set of parameters for the constructor, but then you do not have access
    // to the parameters 'context', 'startfn', as well as 'params' and thus, 
    // you need to overwrite the start function, which accesses those parameters.
    // If you want to use the start function defined in DeferredImpl, you need 
    // to make sure, the parameters 'context', 'startfn', as well as 'params' 
    // are set in the constructor of DeferredImpl.     
    constructor: function(context, startfn, params){
        // context for start function
        this.context = context;
        
        // start function
        this.startfn = startfn;
        
        // parameters to pass to start function
        this.params = params;
        
        // logger
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass);
    },
    
    // deprecated
    addErrorCallback: function(callback, parameters){
        dojo.deprecated("com.ibm.mashups.enabler.Deferred.addErrorCallback()", "use com.ibm.mashups.enabler.Deferred.setFinishedCallback() instead");
        this.errorCallback = callback;
        this.errorCallbackParameters = parameters;
    },
    
    // deprecated
    addFinishedCallback: function(callback, parameters){
        dojo.deprecated("com.ibm.mashups.enabler.Deferred.addFinishedCallback()", "use com.ibm.mashups.enabler.Deferred.setFinishedCallback() instead");
        this.finishedCallback = callback;
        this.finishedCallbackParameters = parameters;
        
        // forward compatibility
        //this.setFinishedCallback(callback, parameters);
    },
    
    setFinishedCallback: function(callback, parameters){
        this.finishedCallback2 = callback;
        this.finishedCallbackParameters2 = parameters;
        return this;
    },
    
    start: function(sync, previous){
        this._sync = (sync || typeof(sync) == 'undefined');
        var ret = null;
        if (dojo.isFunction(this.startfn)) {
            ret = dojo.hitch(this.context || null, this.startfn)(this, this._sync, this.params, previous || null);
        }
        return ret;
    },
    
    getFinishedCallback: function(){
        return this.finishedCallback2;
    },
    
    getFinishedCallbackParameters: function(){
        return this.finishedCallbackParameters2;
    },
    
    setChainedDeferred: function(deferred){
        this._chainedDeferred = deferred;
    },
    
    getChainedDeferred: function(){
        return this._chainedDeferred;
    },
    
    getPrevious: function(){
        return this._previous;
    },
    
    _setPreviousDeferred: function(deferred, result, status){
        this._previous = {
            deferred: deferred,
            result: result,
            status: status
        };
    },
    
    removeChainedDeferred: function(){
        this._chainedDeferred = null;
    },
    
    /**
     * call this at the end of whatever you are doing
     *
     * @param {Object} result
     * @param {Object} status
     */
    finish: function(result, status){
        try {
            if (dojo.isFunction(this.getFinishedCallback())) {
                // call callback
                dojo.partial(this.getFinishedCallback())(result, status, this.getFinishedCallbackParameters());
            }
            else {
                if (dojo.isFunction(this.finishedCallback) && ("" + status).indexOf('2') === 0) {
                    // backwards compatibility
                    dojo.partial(this.finishedCallback)(result, this.finishedCallbackParameters);
                }
                else {
                    if (dojo.isFunction(this.errorCallback) && status >= 400) {
                        dojo.partial(this.errorCallback)(result, this.errorCallbackParameters);
                    }
                }
            }
        } 
        catch (e) {
            this.LOGGER.warning("finish", "Callback failed to execute; skipping. Reason: "+e.message);
        }
        if (this._chainedDeferred) {
            this._chainedDeferred._setPreviousDeferred(this, result, status);
            this._chainedDeferred.start(this._sync);
        }
    }
    
});

}

if(!dojo._hasResource["com.ibm.mashups.enabler.Deferred"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.Deferred"] = true;
dojo.provide( "com.ibm.mashups.enabler.Deferred");



dojo.require( "com.ibm.mm.enabler.DeferredImpl" );

}

if(!dojo._hasResource["com.ibm.mashups.enabler.context.LocalizedContext_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.context.LocalizedContext_API"] = true;
dojo.provide("com.ibm.mashups.enabler.context.LocalizedContext_API");
dojo.provide("com.ibm.mashups.enabler.context.LocalizedContext");

/**
 * LocalizedContext to get the preferred locale, the default locale, as well as
 * titles and descriptions of localized resources within this localized context.
 * 
 * @ibm-api
 * @ibm-module Base2
 */
dojo.declare("com.ibm.mashups.enabler.context.LocalizedContext", null, {
	/**
	 * Returns the preferred locale of this LocalizedContext.
	 * @ibm-api
	 * @type {String}
	 * @return the preferred locale
	 */
	getPreferredLocale : function() {
	},

	/**
	 * Returns the default locale of this LocalizedContext.
	 * @ibm-api
	 * @type {String}
	 * @return the default locale
	 */
	getDefaultLocale : function() {
	},

	/**
	 * Returns the locale of the localized resource, which matches best the locale set with
	 * the browser.
	 * @ibm-api
	 * @param {com.ibm.mashups.enabler.Localized} localized resource implementing the Localized interface; must not be <code>null</code>
	 * @type {String}
	 * @return the preferred locale. Returns <code>null</code> if no locale is available.
	 */
	getLocale : function(localized) {
	},

	/**
	 * Returns the display locale set with the browser matching the specified locale.
	 * @ibm-api
	 * @param {String} locale; mandatory, must not be <code>null</code>
	 * @type {String}
	 * @return the display locale. Returns <code>null</code> if no display locale is available.
	 */
	getDisplayLocale : function(locale) {
	},

	/**
	 * Returns the title of the localized resource in the locale, which matches best the locale
	 * set with the browser.
	 * @ibm-api
	 * @param {com.ibm.mashups.enabler.Localized} localized resource implementing the Localized interface; must not be <code>null</code>
	 * @type {String}
	 * @return the title string in the preferred locale. Returns <code>null</code> if no locale is available.
	 */
	getTitle : function(localized) {
	},

	/**
	 * Returns the description of the localized resource in the locale, which matches best the
	 * locale set with the browser.
	 * @ibm-api
	 * @param {com.ibm.mashups.enabler.Localized} localized resource implementing the Localized interface; must not be <code>null</code>
	 * @type {String}
	 * @return the description string in the preferred locale. Returns <code>null</code> if no locale is available.
	 */
	getDescription : function(localized) {
	}
});

}

if(!dojo._hasResource["com.ibm.mashups.enabler.xml.XPath_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.xml.XPath_API"] = true;
dojo.provide("com.ibm.mashups.enabler.xml.XPath_API");
dojo.provide("com.ibm.mashups.enabler.xml.XPath");

/**
 * Interface provides functions to select nodes by evaluating XPATH expression
 * 
 * @ibm-api
 * @ibm-module Base2
 */
dojo.declare("com.ibm.mashups.enabler.xml.XPath", null, {
	/**
	 * This interface returns a list of XMLNodes upon XPATH evaluation.
	 * @param {String} xpathExpr the xpath expression (i.e. /atom:content). Must not be NULL.
	 * @param {XMLDocument} doc the XML document. Must not be NULL.
	 * @param {JSON} namespaces the namespaces used as part of the xpath expression. The json must be of the format {"prefix": "URL", ... }; must not be NULL.<br>
	 * Example: { "atom" : "http://www.w3.org/2005/Atom", "app" : "http://www.w3.org/2007/app" };
	 * 
	 * @return {XMLNodeList} select nodes from XML document with xpath; may be <code>null</code>.
	 */
	evaluateXPath : function(xpathExpr, doc, namespaces) {
	},
    
    
    /**
	 * This interface returns a single Entry upon XPATH evaluation or null if the entry is not present.
	 * 
	 * @param {String} xpathExpr the xpath expression (i.e. /atom:content). Must not be NULL.
	 * @param {XMLDocument} doc the XML document. Must not be NULL.
	 * @param {JSON} namespaces the namespaces used as part of the xpath expression. The json must be of the format {"prefix": "URL", ... }; must not be NULL.<br>
	 * Example: { "atom" : "http://www.w3.org/2005/Atom", "app" : "http://www.w3.org/2007/app" };
	 * 
	 * @return {Object}
     */
    evaluateEntry: function(xpathExpr, doc, namespaces) {
    },
    
    /**
	 * This interface returns a boolean upon XPATH evaluation. Returns false if the result is not valid (e.g. node does not exist, etc.).
	 * 
	 * @param {String} xpathExpr the xpath expression (i.e. /atom:content). Must not be NULL.
	 * @param {XMLDocument} doc the XML document. Must not be NULL.
	 * @param {JSON} namespaces the namespaces used as part of the xpath expression. The json must be of the format {"prefix": "URL", ... }; must not be NULL.<br>
	 * Example: { "atom" : "http://www.w3.org/2005/Atom", "app" : "http://www.w3.org/2007/app" };
	 * 
	 * @return {Boolean}
     */
    evaluateBoolean: function(xpathExpr, doc, namespaces) {
    },
    
    /**
	 * This interface returns a String upon XPATH evaluation. Returns an empty String if the result is not valid (e.g. node does not exist, etc.).
	 * If you want to check for existence of an attribute/element use either evaluateBoolean (which returns false if the element is not present) or evaluateEntry (which returns null if the element is not present). 
	 * 
	 * @param {String} xpathExpr the xpath expression (i.e. /atom:content). Must not be NULL.
	 * @param {XMLDocument} doc the XML document. Must not be NULL.
	 * @param {JSON} namespaces the namespaces used as part of the xpath expression. The json must be of the format {"prefix": "URL", ... }; must not be NULL.<br>
	 * Example: { "atom" : "http://www.w3.org/2005/Atom", "app" : "http://www.w3.org/2007/app" };
	 * 
	 * @return {String}
     */
    evaluateString: function(xpathExpr, doc, namespaces) {
    },
    
    /**
	 * This interface returns a Number upon XPATH evaluation. Returns zero (0) if the result is not valid (e.g. node does not exist, etc.).
	 * If you want to check for existence of an attribute/element use either evaluateBoolean (which returns false if the element is not present) or evaluateEntry (which returns null if the element is not present). 
	 * 
	 * @param {String} xpathExpr the xpath expression (i.e. /atom:content). Must not be NULL.
	 * @param {XMLDocument} doc the XML document. Must not be NULL.
	 * @param {JSON} namespaces the namespaces used as part of the xpath expression. The json must be of the format {"prefix": "URL", ... }; must not be NULL.<br>
	 * Example: { "atom" : "http://www.w3.org/2005/Atom", "app" : "http://www.w3.org/2007/app" };
	 * 
	 * @return {Number}
     */
    evaluateNumber: function(xpathExpr, doc, namespaces) {
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.utils.Dom"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.utils.Dom"] = true;
dojo.provide("com.ibm.mm.enabler.utils.Dom");




com.ibm.mm.enabler.utils.Dom = {
    getAttributeWithNS: function(element, attName, localAttName, nsUri) {
        if (!element) {
            return null;
        }
        if (!attName) {
            return null;
        }
        if (!localAttName) {
            return null;
        }
        if (!nsUri) {
            return null;
        }
        var value = null;
        if (dojo.isIE) {
            // IE with no namepsace
            value = element.getAttribute(attName);
            if (value === null || value == "") {
                // IE with namepsace
                var attributes = element.attributes;
                for (var i = attributes.length; i > 0; i--) {
                    if (attributes[i - 1].baseName == localAttName && attributes[i - 1].namespaceURI == nsUri) {
                        value = attributes[i - 1].value;
                        break;
                    }
                }
            }
        }
        else {
            // Safari & Firefox
            value = element.getAttributeNS(nsUri, localAttName);
        }
        return value;
    },
    setAttributeWithNS: function(dom, element, attName, localAttName, nsUri, value) {
        if (!dojo.isObject(element)) {
            throw new Error("element must be a DOMNode");
        }
        if (dojo.isIE) {
            var attr = dom.createNode(2, attName, nsUri);
            // set value
			if (value === null || value === undefined) {
				value = "";
			}
            attr.nodeValue = value;
            // attach to element
            element.setAttributeNode(attr);
        }
        else {
            element.setAttributeNS(nsUri, attName, value);
        }
    },
    textContent: function(node, text) {
        if (!node) {
            return "";
        }
        if (arguments.length > 1) {
            var doc = node.ownerDocument;
            var aNode = doc.createTextNode(text || ""); // IE8 createTextNode fails when text == null
            com.ibm.mm.enabler.utils.Dom.replaceChildren(node, aNode);
            return;
        }
        else {
            var tc = dojox.xml.parser.textContent(node);
            if (tc) {
                return tc;
            }
            
            return dojo.map(node.childNodes || [], function(node) {
            	return (node.nodeType > 0 && node.nodeType < 4) ? node.nodeValue : "";
            }).join("");
        }
    },
    createElement: function(dom, name, ns) {
        var newElem;
        if (dojo.isIE) {
            if (ns) {
                newElem = dom.createNode(1, name, ns);
            }
            else {
                newElem = dom.createElement(name);
            }
        }
        else {
            newElem = dom.createElementNS(ns, name);
        }
        return newElem;
    },
    destroyNode: function(node) {
        //avoid pseudo leaks since our webpage are open for long long time!
        var garbageBin = dojo.byId('IELeakGarbageBin');
        if (!garbageBin) {
        	garbageBin = dojo.create("div",{
        		id: "IELeakGarbageBin",
        		style: {display: "none"}
        	}, dojo.body());
        }
        
        // move the element to the garbage bin
        dojo.place(node,garbageBin);
        dojo.attr(garbageBin,'innerHTML','');
        
        if (node.nodeType != 3) { // ingore TEXT_NODE
            if (dojo.isIE) {
            	dojo.attr(node,'outerHTML',''); //prevent ugly IE mem leak 
            }
        }
    },
    createDocument: function(/*string?*/str, /*string?*/ mimetype) {
        return dojox.xml.parser.parse(str, mimetype);
    },
    replaceChildren: function(/*Element*/node, /*Node || array*/ newChildren) {
        return dojox.xml.parser.replaceChildren(node, newChildren);
    },
    innerXML: function(node) {
        return node ? dojox.xml.parser.innerXML(node) : null;
    },
    removeChildren: function(node) {
        return dojox.xml.parser.removeChildren(node);
    },
    copyChildren: function(/*Element*/srcNode, /*Element*/ destNode, /*boolean?*/ trim) {
        var clonedNode = srcNode.cloneNode(true);
        return this.moveChildren(clonedNode, destNode, trim); //	number
    },
    moveChildren: function(srcNode, destNode, trim) {
        var count = 0;
        if (trim) {
            while (srcNode.hasChildNodes() &&
            srcNode.firstChild.nodeType == 3) {
                srcNode.removeChild(srcNode.firstChild);
            }
            while (srcNode.hasChildNodes() &&
            srcNode.lastChild.nodeType == 3) {
                srcNode.removeChild(srcNode.lastChild);
            }
        }
        while (srcNode.hasChildNodes()) {
            destNode.appendChild(srcNode.firstChild);
            count++;
        }
        return count; //	number
    },
    /**
     * Get's the local name of the node passed in as parameter
     *
     * @param {Node} node the node of which to get the local name
     * @return {String} the local name of the node or <tt>null</tt> if the node doesn't have a local name
     */
    getLocalName: function(node) {
        if (!node) {
            return null;
        }
        switch (node.nodeType) {
            case 3:
                return "#text";
            case 1:
                return node.localName || com.ibm.mm.enabler.utils.Dom.removeNodeNS(node.nodeName);
        }
        
        return null;
    },
    /**
     * Get's the namespace prefix from the given nodename or <tt>null</tt> if there is no NS Prefix.
     *
     * @param {String} nodeName The name of the node
     * @return {String} the namespace prefix of the node name or <tt>null</tt> if there is none.
     */
    getNodeNSPrefix: function(nodeName) {
        var tN = '' + nodeName;
        var hasColon = tN.indexOf(':');
        return (hasColon != -1) ? tN.substring(0, hasColon) : null;
    },
    /**
     * Removes the namespace from a node name.
     * This is a copy of com.ibm.mashups.widget.dijit.url.util.Dom.removeNodeNs and should
     * replace this method in case, this one here becomes public.
     *
     * @private
     * @param {String} nodeName the node name with or without namespace
     * @return {String} the node name without namespace
     * @see com.ibm.mashups.widget.dijit.url.util.Dom#removeNodeNs(String)
     */
    removeNodeNS: function(nodeName) {
        var tN = '' + nodeName;
        var hasColon = tN.indexOf(':');
        return (hasColon != -1) ? tN.substring(1 + hasColon) : nodeName;
    },
    /**
     * Looks up the namespace for the specified prefix
     * @param {Node} node the node for which to lookup the namespace
     * @param {String} prefix the prefix to lookup the namespace for.
     * @return {String} the namespace for the specified prefix or <tt>null</tt> if the namespace for the prefix wasn't found.
     */
    lookupNamespaceURI: function(node, prefix) {
        // If we are not on IE, we have native support for this
        if (!dojo.isIE) {
            return node.lookupNamespaceURI(prefix);
        }
        
        // seems we are on IE, so let's do some magic here
        var lastNode = node;
        
        // while node != null and node isn't a document
        while (lastNode && lastNode.nodeType != 9) {
            var attrValue = lastNode.getAttribute("xmlns:" + prefix);
            
            if (attrValue) {
                return attrValue;
            }
            
            lastNode = lastNode.parentNode;
        }
        
        return null;
    }
};

}

if(!dojo._hasResource["com.ibm.mm.enabler.xml.xpath._Generic"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.xml.xpath._Generic"] = true;
dojo.provide("com.ibm.mm.enabler.xml.xpath._Generic");




// generic impl
dojo.declare("com.ibm.mm.enabler.xml.xpath._Generic", null, {
    constructor: function(){
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.enabler.xml.xpath._Generic");
    },
    
    _evaluateXPath: function(/*String*/xpathExpr, /*DOMDocument*/ doc, /*Object{prefix:ns,prefix2:ns2,...}*/ namespaces){
        if (dojo.isSafari) {
            return this._safariEvaluateXPath(xpathExpr, doc, namespaces);
        } else if (dojo.isIE) {
            return this._ieEvaluateXPath(xpathExpr, doc, namespaces);
        } else {
            return this._geckoEvaluateXPath(xpathExpr, doc, namespaces);
        }
    },
    
    _transformNode: function(result, resType){
        if (typeof XPathResult != "undefined" && result instanceof XPathResult) {
            return this._xpathResultValue(result, resType);
        } else {
            if (resType == com.ibm.mm.enabler.xml.xpath._Generic.ANY_TYPE) {
                return result;
            } else if (resType == com.ibm.mm.enabler.xml.xpath._Generic.NUMBER_TYPE) {
                return parseFloat(com.ibm.mm.enabler.utils.Dom.textContent(result));
            } else if (resType == com.ibm.mm.enabler.xml.xpath._Generic.STRING_TYPE) {
                return com.ibm.mm.enabler.utils.Dom.textContent(result);
            } else if (resType == com.ibm.mm.enabler.xml.xpath._Generic.BOOLEAN_TYPE) {
                return !!result;
            }
        }
        return null;
    },
    
    _xpathResultValue: function(node, resType){
        if (resType == com.ibm.mm.enabler.xml.xpath._Generic.ANY_TYPE) {
            return node;
        } else if (resType == com.ibm.mm.enabler.xml.xpath._Generic.NUMBER_TYPE) {
            return node.numberValue;
        } else if (resType == com.ibm.mm.enabler.xml.xpath._Generic.STRING_TYPE) {
            return node.stringValue;
        } else if (resType == com.ibm.mm.enabler.xml.xpath._Generic.BOOLEAN_TYPE) {
            return node.booleanValue;
        }
        return null;
    },
    
    _evaluateXPathSingle: function(xpathExpr, doc, namespaces, resType){
        resType = resType || com.ibm.mm.enabler.xml.xpath._Generic.ANY_TYPE;
        
        var result;
        if (dojo.isSafari) {
            result = this._safariEvaluateXPathRaw(xpathExpr, doc, namespaces, resType);
            if (XPathResult && result instanceof XPathResult) {
                if (resType == com.ibm.mm.enabler.xml.xpath._Generic.ANY_TYPE) {
                    return result.iterateNext();
                }
                return this._transformNode(result, resType);
            } else if (result) {
                return this._transformNode(result[0], resType);
            }
        } else if (dojo.isIE) {
            result = this._ieEvaluateXPathRawSingle(xpathExpr, doc, namespaces);
            if (result || result === null) {
                return this._transformNode(result, resType);
            }
        } else {
            result = this._geckoEvaluateXPathRaw(xpathExpr, doc, namespaces, resType);
            if (result && resType == com.ibm.mm.enabler.xml.xpath._Generic.ANY_TYPE) {
                return result.iterateNext();
            } else {
                return this._transformNode(result, resType);
            }
        }
        return result || null;
    },
    
    _geckoEvaluateXPath: function(/*String*/xpathExpr, /*DOMDocument*/ doc, /*Object{prefix:ns,prefix2:ns2,...}*/ namespaces){
        var result = this._geckoEvaluateXPathRaw(xpathExpr, doc, namespaces, com.ibm.mm.enabler.xml.xpath._Generic.ANY_TYPE);
        
        var resultSet = [];
        if (result) {
            var thisResult;
            while ((thisResult = result.iterateNext())) {
                resultSet.push(thisResult);
            }
        }
        return resultSet;
    },
    
    _geckoEvaluateXPathRaw: function(xpathExpr, doc, namespaces, type){
        var xmlDocument = doc;
        if (doc.nodeType != 9) {
            xmlDocument = doc.ownerDocument;
        }
        return xmlDocument.evaluate(xpathExpr, doc, function(prefix){
            return namespaces[prefix] ? namespaces[prefix].toString() : null;
        }, type, null);
    },
    
    _ieEvaluateXPath: function(/*String*/xpathExpr, /*DOMDocument*/ doc, /*Object{prefix:ns,prefix2:ns2,...}*/ namespaces){
        var result = this._ieEvaluateXPathRaw(xpathExpr, doc, namespaces);
        return result || [];
    },
    
    _setIeNamespaces: function(doc, namespaces) {
        if (namespaces) {
            var ns = [];
            var item;
            for (var prop in namespaces) { // JSLINT-IGNORE: Filtering for prototype properties must not be done here, as namespaces often use dojo.delegate to save memory - dojo.delegate uses the prototype functionality for doing so - we use dojo.isFunction() which should suffice.
                // ATTENTION: DON'T ADD .hasOwnProperty() CHECK HERE!
                item = namespaces[prop];
                if (prop != "xml") { // we cannot use !dojo.isFunction(item) as it costs too much performance
                    // There is no automatic namespace recognition, this is a workaround
                    ns.push("xmlns:", prop, "='", item, "' ");
                }
            }
            var sDoc = doc.ownerDocument || doc;
            sDoc.setProperty("SelectionNamespaces", ns.join(""));
            sDoc.setProperty("SelectionLanguage", "XPath");
        }    	
    },
    
    _ieEvaluateXPathRaw: function(xpathExpr, doc, namespaces){
    	this._setIeNamespaces(doc, namespaces);
        return doc.selectNodes(xpathExpr);
    },
    
    _ieEvaluateXPathRawSingle: function(xpathExpr, doc, namespaces){
    	this._setIeNamespaces(doc, namespaces);
    	return doc.selectSingleNode(xpathExpr);
    },
    
    _safariEvaluateXPath: function(/*String*/xpathExpr, /*DOMDocument*/ doc, /*Object{prefix:ns,prefix2:ns2,...}*/ namespaces){
        var result = this._safariEvaluateXPathRaw(xpathExpr, doc, namespaces, com.ibm.mm.enabler.xml.xpath._Generic.ANY_TYPE);
        if (XPathResult && result instanceof XPathResult) {
            var resultSet = [];
            var thisResult;
            while ((thisResult = result.iterateNext())) {
                resultSet.push(thisResult);
            }
            return resultSet;
        }
        return result || [];
    },
    
    _safariEvaluateXPathRaw: function(xpathExpr, doc, namespaces, type){
        if (typeof XPathResult != "undefined") {
            //use build in xpath support for Safari 3.0
            return document.evaluate(xpathExpr, doc, function(prefix){
                return namespaces[prefix] ? namespaces[prefix].toString() : null;
            }, type, null);
        } else if (doc.selectNodes) {
            //use javeline Safari2 xpath support
            return doc.selectNodes(xpathExpr);
        }
    }
    
});

com.ibm.mm.enabler.xml.xpath._Generic.ANY_TYPE = 0;
com.ibm.mm.enabler.xml.xpath._Generic.NUMBER_TYPE = 1;
com.ibm.mm.enabler.xml.xpath._Generic.STRING_TYPE = 2;
com.ibm.mm.enabler.xml.xpath._Generic.BOOLEAN_TYPE = 3;

}

if(!dojo._hasResource["com.ibm.mm.enabler.xml.XPathImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.xml.XPathImpl"] = true;
dojo.provide("com.ibm.mm.enabler.xml.XPathImpl");









dojo.declare("com.ibm.mm.enabler.xml.XPathImpl", [com.ibm.mashups.enabler.xml.XPath, com.ibm.mm.enabler.xml.xpath._Generic], {
    
    modelMessages: null,
    
    constructor: function() {
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.enabler.xml.XPath");
        this.modelMessages = dojo.i18n.getLocalization("com.ibm.mm.enabler", "modelMessages");
    },
    
    ANY_TYPE: com.ibm.mm.enabler.xml.xpath._Generic.ANY_TYPE,
    NUMBER_TYPE: com.ibm.mm.enabler.xml.xpath._Generic.NUMBER_TYPE,
    STRING_TYPE: com.ibm.mm.enabler.xml.xpath._Generic.STRING_TYPE,
    BOOLEAN_TYPE: com.ibm.mm.enabler.xml.xpath._Generic.BOOLEAN_TYPE,
    
    evaluateXPath: function(xpathExpr, doc, namespaces) {
        var METHOD_NAME = "evaluateXPath(xpathExpr,  doc, namespaces)";
        var bIsLogging = this.LOGGER.isLoggable(com.ibm.mashups.enabler.logging.LogLevel.TRACE);
        if (bIsLogging) {
            this.LOGGER.entering(METHOD_NAME, [xpathExpr, doc, namespaces]);
        }
        
        if(!dojo.isString(xpathExpr) || xpathExpr.length === 0) {
            throw new Error(this.modelMessages.E_INVALID_XPATH_EXPR_0);
        }
        
        if(!doc) {
            throw new Error(this.modelMessages.E_INVALID_DOCUMENT_0);
        }        
        
        var ret = this._evaluateXPath(xpathExpr, doc, namespaces);
        
        if (bIsLogging) {
            this.LOGGER.exiting(METHOD_NAME, ret);
        }
        
        return ret;
    },
    
    evaluateSingle: function(xpathExpr, doc, namespaces, type) {
        
        if(!dojo.isString(xpathExpr) || xpathExpr.length === 0) {
            throw new Error(this.modelMessages.E_INVALID_XPATH_EXPR_0);
        }
        
        if(!doc) {
            throw new Error(this.modelMessages.E_INVALID_DOCUMENT_0);
        }
        
        
        return this._evaluateXPathSingle(xpathExpr, doc, namespaces, type);
    },
    
    evaluateEntry: function(xpathExpr, doc, namespaces) {
        return this.evaluateSingle(xpathExpr, doc, namespaces, com.ibm.mashups.enabler.xml.XPath.ANY_TYPE);
    },
    
    evaluateBoolean: function(xpathExpr, doc, namespaces) {
        return this.evaluateSingle(xpathExpr, doc, namespaces, com.ibm.mashups.enabler.xml.XPath.BOOLEAN_TYPE);
    },
    
    evaluateString: function(xpathExpr, doc, namespaces) {
        return this.evaluateSingle(xpathExpr, doc, namespaces, com.ibm.mashups.enabler.xml.XPath.STRING_TYPE);
    },
    
    evaluateNumber: function(xpathExpr, doc, namespaces) {
        return this.evaluateSingle(xpathExpr, doc, namespaces, com.ibm.mashups.enabler.xml.XPath.NUMBER_TYPE);
    },
    
    /**
     * evaluates the specified xpath, but creates xml elements, which are not part
     * of the document; please note that attributes are not supported
     *
     * @param {Object} xPath
     * @param {Object} node
     * @param {Object} namespaces
     */
    createXPath: function(xPath, node, namespaces) {
    
        // split off first part of xpath
        var xPathParts = xPath.split("/");
        
        // handle head
        var qName = xPathParts[0];
        
        // extract name and name space 
        var qNameParts = qName.split(":");
        var name, namespace;
        if (qNameParts.length > 1) {
            namespace = qNameParts[0];
            name = qNameParts[1];
        }
        else {
            name = qNameParts[0];
        }
        
        // search for first part of xpath (what about case insensitive search for attributes, especially "_" vs "-" in locales?)
        var names = com.ibm.mashups.enabler.xml.XPath.evaluateXPath((namespace ? namespace + ":" : "") + name, node, namespaces);
        var result;
        if (names && names.length > 0) {
            // use existing xml element
            result = names[0];
        }
        else {
            // what about attributes?
            // create xml element
            result = com.ibm.mm.enabler.utils.Dom.createElement(node.ownerDocument, (namespace ? namespace + ":" : "") + name, namespace ? namespaces[namespace] : null);
            node.appendChild(result);
        }
        
        // handle remaining parts of xpath
        if (xPathParts.length > 1) {
            // recursive call with remaining xpath part
            result = com.ibm.mashups.enabler.xml.XPath.createXPath(xPath.substr(xPath.indexOf("/") + 1), result, namespaces);
        }
        return result;
    }
});

// create the singleton
com.ibm.mashups.enabler.xml.XPath = new com.ibm.mm.enabler.xml.XPathImpl();

// backwards compatibility - still needed?
// TODO remove this in next enabler version
com.ibm.mm.enabler.xml.xpath.evaluateXPath = function(xpathExpr, doc, namespaces) {
    var LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.enabler.xml.xpath");
    var LOG_METHOD = "evaluateXPath";
    LOGGER.warning(LOG_METHOD, "This method must not be used directly. Use com.ibm.mashups.enabler.xml.XPath.evaluateXPath instead.");
    dojo.deprecated("com.ibm.mm.enabler.xml.xpath.evaluateXPath", "The method com.ibm.mm.enabler.xml.xpath.evaluateXPath is deprecated, please use com.ibm.mashups.enabler.xml.XPath.evaluateXPath instead");
    return com.ibm.mm.enabler.xml.xpath._Generic.evaluateXPath.apply(null, arguments);
};

}

if(!dojo._hasResource["com.ibm.mashups.enabler.xml.XPath"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.xml.XPath"] = true;
dojo.provide("com.ibm.mashups.enabler.xml.XPath");





}

if(!dojo._hasResource["com.ibm.mm.enabler.utils.LocaleHelper"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.utils.LocaleHelper"] = true;
dojo.provide("com.ibm.mm.enabler.utils.LocaleHelper");




com.ibm.mm.enabler.utils.LocaleHelper = {
    LOG_LEVEL: com.ibm.mashups.enabler.logging.LogLevel.TRACE,
    LOGGER: com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.enabler.utils.LocaleHelper"),
    
    getLocale:function(/*com.ibm.mashups.enabler.Localized*/localized,aLocale,defaultLocale){
        
        // warn
        com.ibm.mm.enabler.utils.LocaleHelper.LOGGER.warning("com.ibm.mm.enabler.utils.LocaleHelper.getLocale", "Deprecated. Use com.ibm.mashups.enabler.context.Factory.getLocalizedContext().getLocale() instead.");
        
        
        if (typeof localized == "undefined" || localized === null) {
            return null;
        }
        
        var localeArr = localized.getLocales();
        if (typeof localeArr == "undefined" || localeArr === null || !dojo.isArray(localeArr)) {
            return null;
        }
        
        if (localeArr.length === 0) {
            return null;
        }
        
        var returnLocale = null;
        if (localeArr.length === 1) {
            returnLocale = localeArr[0];
        }
        
        var arr = {};
        for (var i in localeArr) {
            if (Object.prototype.hasOwnProperty.call(localeArr,i)) {
                var temp = localeArr[i];
                arr[temp] = temp;
            }
        }
        
        var tempArr;
        if (returnLocale === null) {
            if (typeof aLocale != "undefined" && aLocale !== null) {
                returnLocale = this.findMatchLocale(arr, aLocale);
                if (returnLocale === null) {
                    tempArr = aLocale.split(/-|_/);
                    if (tempArr.length == 2) {
                        var iLocale = tempArr[0];
                        if (typeof arr[iLocale] != "undefined" && arr[iLocale] !== null) {
                            returnLocale = iLocale;
                        }
                    }
                }
            }
        }
        if (returnLocale === null) {
            //get browser locale
            var browserLocale = (dojo.isIE ? navigator.userLanguage : navigator.language).toLowerCase();
            if (typeof ibmConfig != "undefined" && ibmConfig && typeof(ibmConfig.locale) != "undefined" && ibmConfig.locale) {
                browserLocale = ibmConfig.locale;
            }
            if (browserLocale !== null) {
                //browserLocale = browserLocale.replace(/-/,"_");
                returnLocale = this.findMatchLocale(arr, browserLocale);
                if (returnLocale === null) {
                    tempArr = browserLocale.split(/-|_/);
                    if (tempArr.length == 2) {
                        var tempLocale = tempArr[0];
                        if (typeof arr[tempLocale] != "undefined" && arr[tempLocale] !== null) {
                            returnLocale = tempLocale;
                        }
                    }
                }
            }
        }
        
        if (returnLocale === null) {
            if (defaultLocale) {
                returnLocale = defaultLocale;
            }
        }
        if (returnLocale === null) {
            if (arr.en) {
                returnLocale = "en";
            }
        }
        if (returnLocale === null) {
            returnLocale = localeArr[0];
        }
        return returnLocale;
    },
    findMatchLocale:function(arr,locale){
        com.ibm.mm.enabler.utils.LocaleHelper.LOGGER.warning("com.ibm.mm.enabler.utils.LocaleHelper.findMatchLocale", "Deprecated. Use com.ibm.mm.enabler.utils.LocaleHelper.matchLocale() instead.");
        
        var returnLocale = null;
        if (arr[locale]) {
            returnLocale = locale;
        }
        var serverLocale = this.toServerLocale(locale);
        if (returnLocale === null && arr[serverLocale]) {
            returnLocale = serverLocale;
        }
        var serverLocaleLowercase = serverLocale.toLowerCase();
        if (returnLocale === null && arr[serverLocaleLowercase]) {
            returnLocale = serverLocaleLowercase;
        }
        return returnLocale;
    },
    
    /**
     * match a locale against an array of locales
     * 
     * TODO: also allow preferred to be an array
     * 
     * @param {String} preferred
     * @param {Array} available
     */
    matchLocale: function(preferred, available) {
        return com.ibm.mm.enabler.utils.LocaleHelper._matchLocale(
            com.ibm.mm.enabler.utils.LocaleHelper._getLocaleObj(preferred),
            com.ibm.mm.enabler.utils.LocaleHelper.normalizeLocale(available));
    },
    
    /**
     * match a normalized locale against an array of normalized locales
     * 
     * FIXME: we need to add handling of multiple possible locales matching against multiple available ones,
     * keeping in mind the order the user defined and also handling for exceptions
     * (e.g. pt-br must not fall back to pt, sh traditional must fall back to simplified, etc.)
     * 
     * @param {Object} locale an locale object
     * @param {Array} locales an Array of normalized locale strings
     */
    _matchLocale: function(locale, locales, stop) {
        
        // console.debug("match locale:",locale,"against",locales);
        
        var _origLocale = locale;
        
        var match = null;
        var found = dojo.some(locales, function(item) {
            if (item == com.ibm.mm.enabler.utils.LocaleHelper.normalizeLocale(locale.toString())) {
                match = item;
                return true;
            }
        });
        if (found && match) {
            return match;
        }
        
        if (locale.variant) {
            // try without variant
            locale.variant = null;
            return com.ibm.mm.enabler.utils.LocaleHelper._matchLocale(locale, locales);
        }
        
        if (locale.country) {
            // try without country
            locale.country = null;
            return com.ibm.mm.enabler.utils.LocaleHelper._matchLocale(locale, locales);
        }
        if (!stop) {
            // TODO: make list of aliases [he,iw], to automate this for other fallbacks.
            
            locale = _origLocale;
            switch (locale.language) {
                case 'he':
                    // special handling for hebrew (he and iw (old) are equal)
                    locale.language = "iw";
                    break;
                case 'iw':
                    // special handling for hebrew (he and iw (old) are equal)
                    locale.language = "he";
                    break;
            }
            return com.ibm.mm.enabler.utils.LocaleHelper._matchLocale(locale, locales, true);
        }
        
        return null;
    },
    
    /**
     * (DE_dE_VariAnt -> de_DE)
     * removes the variant part to sustain backwards compatibility - please use com.ibm.mm.enabler.utils.LocaleHelper.normalizeLocale
     * whitespaces are trimmed at the beginning and end
     * 
     * @deprecated
     * 
     * @param {Object} locale
     */
    toServerLocale:function(locale) {
        com.ibm.mm.enabler.utils.LocaleHelper.LOGGER.warning("com.ibm.mm.enabler.utils.LocaleHelper.normalizeLocale", "Deprecated. Use com.ibm.mm.enabler.utils.LocaleHelper.normalizeLocale() instead.");
        if (!locale) {
            return null;
        }
        if (locale.indexOf("-") < 0) {
            return locale;
        }
        locale = locale.replace(/-/, "_");
        var tempArr = locale.split('_');
        var lang = tempArr[0];
        var country = tempArr[1].toUpperCase();
        var returnLocale = lang + "_" + country;
        return returnLocale;
    },
    
    /**
     * returns a locale object with normalized parts
     * 
     * (DE_dE_VariAnt -> {language: 'de', country: 'DE', variant: 'VariAnt'})
     * whitespaces are trimmed at the beginning and end
     * 
     * @param {String|Array} locale
     * 
     */
    _getLocaleObj: function(locale) {
        
        if (dojo.isArray(locale)) {
            return dojo.map(locale, function(item) {
                return com.ibm.mm.enabler.utils.LocaleHelper._getLocaleObj(item);
            });
        }
        else if (dojo.isString(locale) && dojo.string.trim(locale).length > 0) {
            var localeObj = {
                language: null,
                country: null,
                variant: null,
                toString: function() {
                    return (this.language ? this.language + (this.country ? "_" + this.country + (this.variant ? "_" + this.variant : "") : "") : "");
                },
                isValid: function() {
                    return !!this.language;
                }
            };
            var parts = dojo.string.trim(locale).replace(/-/g, "_").split('_');
            switch (parts.length) {
                case 3:
                    // we have got a variant
                    localeObj.variant = parts[2]; // JSLINT-IGNORE: NO BREAK HERE
                // ATTN: no break here
                case 2:
                    // we have got a country
                    localeObj.country = parts[1].toUpperCase(); // JSLINT-IGNORE: NO BREAK HERE
                // ATTN: no break here
                case 1:
                    // and we have got a language
                    localeObj.language = parts[0].toLowerCase();
                    break;
            }
            return localeObj;
        }
        else {
            return null;
        }
    },
        
    /**
     * normalizes a locale or an array of locales
     * 
     * (DE_dE_VariAnt -> de-DE_VariAnt)
     * whitespaces are trimmed at the beginning and end
     * @param {String|Array} locale
     */
    normalizeLocale: function(locale) {
        
        if (dojo.isArray(locale)) {
            return dojo.map(locale, function(item) {
                return com.ibm.mm.enabler.utils.LocaleHelper.normalizeLocale(item);
            });
        }
        else if (locale && dojo.isString(locale)) {
            return locale.replace(/_/g, "-").toLowerCase();
        }
        else {
            return null;
        }
    }
};

}

if(!dojo._hasResource["com.ibm.mm.enabler.model.NameSpaceFactory"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.model.NameSpaceFactory"] = true;
dojo.provide("com.ibm.mm.enabler.model.NameSpaceFactory");

dojo.declare( "com.ibm.mm.enabler.model.NameSpaceFactoryImpl", null,
    {
        constructor:function () {

            // name space prefixes
            this.NS_APP 	    		= "app";
            this.NS_ATOM 	    		= "atom";
            this.NS_THR 	    		= "thr";
            this.NS_UM 		   	 		= "um";
            this.NS_XHTML      			= "xhtml";
            this.NS_XML 	    		= "xml";
            this.NS_XSI 	    		= "xsi";
            this.NS_OPENSEARCH  		= "opensearch";
            this.NS_CM          		= "cm";
            this.NS_CA          		= "ca";
            this.NS_AC                  = "ac";
            this.NS_EVENT_DATATYPES     = "event-datatypes";
            this.NS_XMLNS               = "xmlns";
			this.NS_XSD                 = "xsd";
			this.NS_JS                  = "js";

            // name space URIs
            this.namespaces = {};
            this.namespaces[this.NS_APP]        		= "http://www.w3.org/2007/app";
            this.namespaces[this.NS_ATOM]       		= "http://www.w3.org/2005/Atom";
            this.namespaces[this.NS_THR]        		= "http://purl.org/syndication/thread/1.0";
            this.namespaces[this.NS_UM]         		= "http://www.ibm.com/xmlns/prod/websphere/um.xsd";
            this.namespaces[this.NS_XHTML]      		= "http://www.w3.org/1999/xhtml";
            this.namespaces[this.NS_XML]        		= "http://www.w3.org/XML/1998/namespace";
            this.namespaces[this.NS_XSI]        		= "http://www.w3.org/2001/XMLSchema-instance";
            this.namespaces[this.NS_XMLNS]              = "http://www.w3.org/2000/xmlns/";
            this.namespaces[this.NS_OPENSEARCH] 		= "http://a9.com/-/spec/opensearch/1.1/";
            this.namespaces[this.NS_CM]         		= "http://www.ibm.com/xmlns/prod/composite-applications/v1.0";
            this.namespaces[this.NS_CA]         		= "http://www.ibm.com/xmlns/prod/composite-applications/v1.0";
            this.namespaces[this.NS_AC]                 = "http://www.ibm.com/xmlns/prod/lotus/access-control/v1.0";
            this.namespaces[this.NS_EVENT_DATATYPES]    = "http://www.ibm.com/xmlns/prod/lotus/mashups/event-datatypes";
			this.namespaces[this.NS_XSD]                = "http://www.w3.org/2001/XMLSchema";
			this.namespaces[this.NS_JS]                 = "text/javascript";
        },

        /**
		 * Returns an object with a property for each element in the
		 * passed in array and the corresponding name space uri as value
		 * @param {Array} prefixes
		 */
        getNameSpaces: function(prefixes) {
            var result = {};
            var len = prefixes.length;
            for (var i=0; i<len; i++) {
                var name = prefixes[i];
            	result[name] = this.namespaces[name];
            }
            return result;
        },

        /**
         * Returns the name space uri that corresponds to the passed in prefix
         */
        getNameSpaceUri: function(prefix) {
            return this.namespaces[prefix];
        }
    }
);

//internal
com.ibm.mm.enabler.model.NameSpaceFactory = new com.ibm.mm.enabler.model.NameSpaceFactoryImpl();

}

if(!dojo._hasResource["com.ibm.mm.enabler.context.LocalizedContextImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.context.LocalizedContextImpl"] = true;
dojo.provide("com.ibm.mm.enabler.context.LocalizedContextImpl");









dojo.declare("com.ibm.mm.enabler.context.LocalizedContextImpl", [com.ibm.mashups.enabler.context.LocalizedContext], {
    constructor: function(preferredLocale, defaultLocale){
        // get the logger for this class
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.enabler.context.LocalizedContextImpl");
        // specify the default log level for this class
        this.LOG_LEVEL = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
        
        var nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
        this.ns = nsf.getNameSpaces([nsf.NS_ATOM, nsf.NS_XML]);
        
        // if no locales are specified for this context, use the 
        // basic fallback mechanism (atom:title, atom:summary)
        this.basicFallback = !(preferredLocale || defaultLocale);
        
        // preferred locale
        this.preferredLocale = preferredLocale || null;
        if (this.preferredLocale === null) {
            // get browser locale, respectively locale set with ibmConfig
            if (typeof ibmConfig != "undefined" && ibmConfig !== null && typeof(ibmConfig.locale) != "undefined" && ibmConfig.locale !== null) {
                this.preferredLocale = ibmConfig.locale;
            }
            else {
                this.preferredLocale = (dojo.isIE ? navigator.userLanguage : navigator.language).toLowerCase();
            }
        }
        // default locale
        this.defaultLocale = defaultLocale || "en";
        
        // title element
        this._DEFAULT_TITLE = "atom:title";
        
        // summary element
        this._DEFAULT_DESCRIPTION = "atom:summary";
        
        // title element language
        this._DEFAULT_LOCALE = this._DEFAULT_TITLE + "/@xml:lang";
    },
    
    getPreferredLocale: function(){
        return this.preferredLocale;
    },
    
    getDefaultLocale: function(){
        return this.defaultLocale;
    },
    
    getLocale: function(localized){
        // if no localized resource is specified, return null
        if (typeof localized == "undefined" || localized === null) {
            return null;
        }
        
        // check for default locale
        if (this.basicFallback && dojo.isFunction(localized.getDefaultLocale)) {
            // TODO only if localized object is not dirty
            return localized.getDefaultLocale();
        }
        
        // resource locales
        var localesArray = localized.getLocales();
        
        switch (localesArray.length) {
            case 0:
                // there is no localization
                return null;
            case 1:
                // there is only one localization, so use that
                return com.ibm.mm.enabler.utils.LocaleHelper.normalizeLocale(localesArray[0]);
            default:
                var preferredMatch = com.ibm.mm.enabler.utils.LocaleHelper.matchLocale(this.preferredLocale, localesArray);
                if (preferredMatch) {
                    // preferred was matched
                    return preferredMatch;
                }
                var defaultMatch = com.ibm.mm.enabler.utils.LocaleHelper.matchLocale(this.defaultLocale, localesArray);
                if (defaultMatch) {
                    // default was matched
                    return defaultMatch;
                }
                
                // nothing was matched, return first (as defaultLocale is not available) 
                return com.ibm.mm.enabler.utils.LocaleHelper.normalizeLocale(localesArray[0]);
        }
    },
    
    getTitle: function(localized){
        // if no localized resource is specified, return null
        if (typeof localized == "undefined" || localized === null) {
            return null;
        }
        
        var title;
        if (this.basicFallback && dojo.isFunction(localized.getDefaultTitle)) {
            // TODO only if localized object is not dirty
            title = localized.getDefaultTitle();
        }
        if (!title) {
            var locale = this.getLocale(localized);
            if (locale) {
                title = localized.getTitle(locale);
            }
        }
        if (typeof title == "undefined") {
            title = null;
        }
        return title;
    },
    
    getDescription: function(localized){
        // if no localized resource is specified, return null
        if (typeof localized == "undefined" || localized === null) {
            return null;
        }
        var description;
        // basic fallback
        if (this.basicFallback && dojo.isFunction(localized.getDefaultDescription)) {
            // TODO only if localized object is not dirty
            description = localized.getDefaultDescription();
        }
        if (!description) {
            var locale = this.getLocale(localized);
            if (locale) {
                description = localized.getDescription(locale);
            }
        }
        if (typeof description == "undefined") {
            description = null;
        }
        return description;
    },
    
    getDisplayLocale: function(locales){
        var localesArray = dojo.isArray(locales) ? locales : [locales];
        if (ibmConfig && ibmConfig.displayLocale) {
            var displayLocalesArray = ibmConfig.displayLocale.split(",");
            com.ibm.mm.enabler.utils.LocaleHelper.normalizeLocale(displayLocalesArray);
            for (var i = 0; i < displayLocalesArray.length; i++) {
                var displayLocale = displayLocalesArray[i];
                if (displayLocale) {
                    var match = com.ibm.mm.enabler.utils.LocaleHelper.matchLocale(displayLocale, localesArray);
                    if (match) {
                        return displayLocale;
                    }
                }
            }
        }
        return localesArray[0];
    }
});

}

if(!dojo._hasResource["com.ibm.mashups.enabler.context.LocalizedContext"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.context.LocalizedContext"] = true;
dojo.provide("com.ibm.mashups.enabler.context.LocalizedContext");





}

if(!dojo._hasResource["com.ibm.mashups.enabler.context.PageContext_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.context.PageContext_API"] = true;
dojo.provide("com.ibm.mashups.enabler.context.PageContext_API");
dojo.provide("com.ibm.mashups.enabler.context.PageContext");

/**
 * Page context to set the page title.
 *
 * @since 2.4
 *
 * @ibm-spi
 * @ibm-module Base2
 */
dojo.declare("com.ibm.mashups.enabler.context.PageContext", null, {
    /**
     * Sets the browser title. Note that the browser title is
     * not persisted.
     *
     * @param {String} title the browser title
     * @return {void}
     */
    setBrowserTitle: function(title){
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.context.PageContextImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.context.PageContextImpl"] = true;
dojo.provide("com.ibm.mm.enabler.context.PageContextImpl");




dojo.declare("com.ibm.mm.enabler.context.PageContextImpl", [com.ibm.mashups.enabler.context.PageContext], {
    constructor: function(){
        // get the logger for this class
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.enabler.context.PageContextImpl");
        // specify the default log level for this class
        this.LOG_LEVEL = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
    },

    setBrowserTitle: function(title){
    
        var LOG_METHOD = "setBrowserTitle(title)";
        var bIsLogging = this.LOGGER.isLoggable(this.LOG_LEVEL);
        if (bIsLogging) {
            this.LOGGER.entering(LOG_METHOD, [title]);
        }
        // decode &, < and >
        dojo.doc.title = title.replace(/&amp;/g,"&").replace(/&quot;/g,"\"").replace(/&gt;/g,">").replace(/&lt;/g,"<");
        
        if (bIsLogging) {
            this.LOGGER.exiting(LOG_METHOD, [dojo.doc.title]);
        }
    }
    
});



com.ibm.mm.enabler.context.PageContext = new com.ibm.mm.enabler.context.PageContextImpl();

}

if(!dojo._hasResource["com.ibm.mashups.enabler.context.PageContext"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.context.PageContext"] = true;
dojo.provide("com.ibm.mashups.enabler.context.PageContext");





}

if(!dojo._hasResource["com.ibm.mashups.enabler.context.Factory_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.context.Factory_API"] = true;
dojo.provide("com.ibm.mashups.enabler.context.Factory_API");
dojo.provide("com.ibm.mashups.enabler.context.Factory");




/**
 * Factory to get context objects.
 *
 * @ibm-module Base2
 */
dojo.declare("com.ibm.mashups.enabler.context.Factory", null, {
    /**
     * Returns a LocalizedContext.
     *
     * @ibm-api
     *
     * @return {com.ibm.mashups.enabler.context.LocalizedContext} localized context.
     */
    getLocalizedContext: function(){
    },
    
    /**
    * Returns a LocalizedContext for the specified locales.
    *
    * @ibm-spi
    *
    * @param {String} preferredLocale preferred locale to use; optional, defaults to the preferred 
    * locale set with the browser.
    * @param {String} defaultLocale default locale to use; optional, defaults to the locale "en"
    * @return {com.ibm.mashups.enabler.context.LocalizedContext} localized context for the specified locales.
    */
   getLocalizedContext: function(preferredLocale, defaultLocale){	// JSLINT-IGNORE: separation between public API and SPI
   },

    /**
     * Returns a PageContext.
     *
     * @ibm-spi
     * @since 2.4
     *
     * @return {com.ibm.mashups.enabler.context.PageContext} the page context
     */
    getPageContext: function(){
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.context.FactoryImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.context.FactoryImpl"] = true;
dojo.provide("com.ibm.mm.enabler.context.FactoryImpl");





// factory implementation
dojo.declare( "com.ibm.mm.enabler.context.FactoryImpl", [com.ibm.mashups.enabler.context.Factory],
    {
        constructor:function () {
        },

        getLocalizedContext: function(preferredLocale, defaultLocale) {
            return new com.ibm.mm.enabler.context.LocalizedContextImpl(preferredLocale, defaultLocale);
        },		

        getPageContext: function() {
            return new com.ibm.mm.enabler.context.PageContextImpl();
        }		
    }
);

// factory singleton
com.ibm.mashups.enabler.context.Factory = new com.ibm.mm.enabler.context.FactoryImpl();

}

if(!dojo._hasResource["com.ibm.mashups.enabler.context.Factory"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.context.Factory"] = true;
dojo.provide("com.ibm.mashups.enabler.context.Factory");





}

if(!dojo._hasResource["com.ibm.mashups.enabler.services.ConfigConstants"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.services.ConfigConstants"] = true;
dojo.provide("com.ibm.mashups.enabler.services.ConfigConstants");

/**
 * This constants class contains well defined constants available to the config service.
 * They are defined in the ConfigService.properties
 * @ibm-spi
 * @ibm-module Base2
 */
dojo.declare("com.ibm.mashups.enabler.services.ConfigConstants", null, {
    /**
     * URL pointing to the proxy
     * @type String
     */
    PROXY_URL: "com.ibm.mashups.proxy.url",
    
    /**
     * URL pointing to the hub
     * @type String
     */
    HUB_URL: "com.ibm.mashups.hub.url",
    
    /**
     * URL pointing to login
     * @type String
     */
    LOGIN_URL: "com.ibm.mashups.url.login",
    
    /**
     * URL pointing to logout
     * @type String
     */
    LOGOUT_URL: "com.ibm.mashups.url.logout",
    
    /**
     * context root of the server
     * @type String
     */
    CONTEXT_ROOT: "com.ibm.mashups.contextroot",
    
    /**
     * context root of the enabler component
     * @type String
     */
    CONTEXT_ROOT_ENABLER: "com.ibm.mashups.contextroot.enabler",

    /**
     * context root of the builder component
     * @type String
     */
    CONTEXT_ROOT_BUILDER: "com.ibm.mashups.contextroot.builder",

    /**
     * public name of the content handler servlet
     * @type String
     */
    CONTENTHANDLER_PUBLIC: "com.ibm.mashups.contenthandler.public",
    /**
     * private name of the content handler servlet
     * @type String
     */
    CONTENTHANDLER_PRIVATE: "com.ibm.mashups.contenthandler.private",
    
    /**
     * public name of the embedding handler servlet
     * @type String
     */
    EMBEDDING_PUBLIC: "com.ibm.mashups.embedding.public",
    /**
     * private name of the content handler servlet
     * @type String
     */
    EMBEDDING_PRIVATE: "com.ibm.mashups.embedding.private",
    
    /**
     * TBD
     * @type String
     */
    THEMES_FEEDS_EXPIRATION: "themes.feed.expiration",
    
    /**
     * comma separated list of all available locales in the system
     * @type String
     */
    AVAILABLE_LOCALES: "availableLocales",
    /**
     * the default locale of the mashups system
     * @type String
     */
    DEFAULT_LOCALE: "default.locale",
		 /**
     * the default locale that's based on user preference for UI components to display date,currency etc.
     * @type String
     */
    DISPLAY_LOCALE: "displayLocale",
    /**
     * defines whether PUT/DELETE tunneling over POST should be used
     * @type String
     */
    TUNNEL_MODE: "tunnel.mode",
    
    /**
     * turns on debugging
     * @type String
     */
    CLIENT_IS_DEBUG: "isDebug",
    
    /**
     * BiDi setting
     * @type String
     */
    CLIENT_IS_BIDI: "isBidi",
    
    /**
     * Definition Url list of the widgets which is sandbox disabled: /dataEditor/dataEditor.xml,id1,id2
     * @type String
     */
    WIDGETDEFID_SANDBOX_DISABLED: "com.ibm.mashups.sandbox.force.disable",
    
    /**
     * Trace configuration for the client runtime
     * @type String
     */
    TRACE_CONFIG: "traceConfig",
    /**
     * tbd
     * @type String
     */
    CLIENT_POPUP_CONSOLE: "popupConsole",
    /**
     * tbd
     * @type String
     */
    CLIENT_ALLOW_PUBLISH_LOGGING: "allowPublishLogging",
    /**
     * tbd
     * @type String
     */
    CLIENT_ALLOW_PUBLISH_TRACING: "allowPublishTracing",
    /**
     * tbd
     * @type String
     */
    CLIENT_ADDITIONAL_SERVICES: "additionalServices",
    
    /**
     * Theme id used in case no theme is set.
     * @type String
     */
    CLIENT_DEFAULT_THEME_ID: "com.ibm.mashups.theme.defaultThemeId",
    /**
     * tbd
     * @type String
     */
    CLIENT_PAGE_SOURCE_READ_ONLY: "pageSourceReadOnly",
    /**
     * Group name used for auto accepting pages
     * @type String
     */
    CLIENT_AUTO_ACCEPT_SHARED_GROUPNAME: "autoAcceptSharedGroupName",
    /**
     * Default value for page level auto wiring enablement
     * @type String
     */
    AUTO_WIRING_DEFAULT_ENABLED: "autoWiringDefaultEnabled",
    /**
     * tbd
     * @type String
     */
    CLIENT_USER_ID_KEY: "userIdKey",
    /**
     * tbd
     * @type String
     */
    CLIENT_GROUP_CN_KEY: "groupCNKey",
    /**
     * Url used to fetch the service document
     * @type String
     */
    SERVICE_DOCUMENT_URL: "serviceDocumentUrl",
    /**
     * turns on multipart support
     * @type String
     */
    MULTIPART_ENABLED: "com.ibm.mashups.multipart.enabled",
    /**
     * if multipart support is enabled, determines if requests are correlated
     * by hostname
     * @type String
     */
    MULTIPART_CORRELATE_HOSTS: "com.ibm.mashups.multipart.correlatehosts",
    /**
     * if multipart support is enabled, should URLs with query strings be
     * considered cacheable
     * @type String
     */
    MULTIPART_CACHE_QUERIES: "com.ibm.mashups.multipart.cachequeries",
    /**
     * Returns the semicolon separated list of Endpoint IDs
     * @type String
     */
    ENDPOINTS: "endpointIDs",
    /**
     * Returns the name of the Endpoints Config Provider
     * @type String
     */
    ENDPOINT_CONFIG_PROVIDER: "Endpoints",
    /**
     * Returns the name of the Anonymous User Config setting
     * @type {String}
     */
    ANONYMOUS_USER: "anonymousUser",
    /**
     * MetaData name used to recognize whether a page is hidden or not
     * @type String
     */
    NAVIGATION_HIDDEN: "com.ibm.mashups.navigation.hidden",
    /**
     * MetaData name used to recognize whether a space is hidden or not
     * @type String
     */
    SPACE_HIDDEN: "com.ibm.mashups.space.hidden",
    /**
     * Returns the name of the current User Config setting
     * @type String
     */
    USER: "user",
    /**
     * Returns the name of subdomains Config setting, subdomains are used to create sandboxed iwidgets
     * @type String
     */
    SUBDOMAINS: "subdomains",
    /**
     * Returns the name of server domain Config setting
     * @type String
     */
    SERVERDOMAIN: "serverdomain",
    /**
     * Returns the name of sandboxenabled Config setting, sandboxed feature is disabled if this configuration is set to false
     * @type String
     */
    SANDBOXENABLED: "sandboxenabled",
    /**
     * Returns the name of config setting that decides if subdomain should be reused when an existing sandboxed iwidget is removed from the page.
     * @type String
     */
    SUBDOMAINREUSE: "subdomainreuse",
    /**
     * MetaData name used to indicate attributes that need to added to url
     * @type String
     */
    NAVSTATE_PERSISTENCE_URL: "navstate.persistence.url",
    /**
     * MetaData name used to indicate attributes that need to added to persistence store
     * @type String
     */
    NAVSTATE_PERSISTENCE_PSTORE: "navstate.persistence.pstore",
    /**
     * MetaData name used to indicate number of widgets whose navigation state will be added to url
     * @type String
     */
    NAVSTATE_PERSISTENCE_URL_LIMIT: "navstate.persistence.url.limit",
	  /**
     * MetaData name used to indicate number of sharedparametersets whose navigation state will be added to url
     * @type String
     */
    NAVSTATE_PERSISTENCE_URL_SPLIMIT: "navstate.persistence.url.splimit",
    /**
     * MetaData name used to indicate if navigation state is huffmann encoded or not
     * @type String
     */
    NAVSTATE_HUFFMANNENCODE_ENABLED: "navstate.huffmannencode.enabled",
    /**
     * MetaData name used to indicate the html fragment that's displayed when a widget is under loading
     * @type String
     */
    LOADING_HTML: "loadingHTML",
    
    /**
     * Specified whether pageloading should be optimized (Multipart)
     * @type String
     */
    PAGE_LOAD_OPTIMIZATION: "pageLoadOptimization",
    
    /**
     * Specified whether pageloading should be optimized for themes (Multipart)
     * @type String
     */
    PAGE_LOAD_OPTIMIZATION_THEME: "pageLoadOptimizationTheme",
	
	/**
	 * Specifies whether application widgets should be optimized (Multipart)
     * @type String
	 */
	PAGE_LOAD_OPTIMIZATION_APP_WIDGETS: "pageLoadOptimizationAppWidgets",
    
    /**
     * Allows to create New Spaces and Pages for anonymous users
     * @type String
     */
    ANONYMOUS_ALLOW_CREATE: "com.ibm.mashups.anonymous.allow.create",
    
    /**
     * If displayName is not sent from server use this property for User Display Name
     * @type String
     */
    DEFAULT_USER_DISPLAY_PROP: "com.ibm.mashups.default.user.display.prop",
    
    /**
     * The product name which will show up in the browser title, other product can replace it.
     * @type String
     */
    PRODUCT_NAME: "com.ibm.mashups.productname",
    
    /**
     * If displayName is not sent from server use this property for Group Display Name
     * @type String
     */
    DEFAULT_GROUP_DISPLAY_PROP: "com.ibm.mashups.default.group.display.prop",
    
    /**
     * The unique name of the welcome space
     * @type String
     */
    WELCOME_SPACE_ID: "com.ibm.mashups.welcome.space.name",
    
    /**
     * The filter as regexp for characters used on page and space title.
     * @type String
     */
    BUILDER_TITLE_FILTER_REGEXP : "com.ibm.mashups.builder.filter.title.regexp",
	
	/**
     * ID of the Anonymous Virtual User
     * @type String
     */
    ANON_VIRTUAL_USER_ID : "com.ibm.mashups.anonUserId",
	
	/**
     * ID of the All Authenticated Users Virtual Group
     * @type String
     */
    ALL_AUTH_VIRTUAL_GROUP_ID : "com.ibm.mashups.allAuthGroupId",
    
    /**
     * The server type this enabler is connected to. It can be either SERVER_TYPE_MASHUPS or SERVER_TYPE_PORTAL
     * @type String
     */
    SERVER_TYPE : "com.ibm.mashups.server",

    /**
     * The server type value for Lotus Mashups
     * @type String
     */
    SERVER_TYPE_MASHUPS : "Lotus_Mashups",

    /**
     * The server type value for WebSphere Portal
     * @type String
     */
    SERVER_TYPE_PORTAL : "WebSphere_Portal",
	
    /**
     * The server type value for Business Space
     */
    SERVER_TYPE_BSPACE : "Business_Space",
	
	/**
	 * Anonymous mode enabled default is false
     * @type String
	 */
	ANON_MODE_ENABLED : "com.ibm.mashups.anonymous.mode",
	
	/**
	 * Setting to true will prevent search clients for automatically adding wildcards
	 * to user and group searches.  Default is false.
	 * @type String
	 */
	AUTO_WILDCARD_DISABLED : "com.ibm.mashups.autoWildcardSearchDisabled",
	
	/**
	 * Sets the name of the property in the ContextMenu_Provider to use for the
	 * context menu
	 * @type String
	 */
	CONTEXT_MENU_NAME : "com.ibm.mashups.contextmenu.name",
	
	WIDGET_BUILDER_ENABLED : "com.ibm.mashups.widgetBuilder.enabled",	

	CREATE_SPACE_TEMPLATE_MODE: "createSpaceOnTemplateMode",
	
	FAVORITE_SPACES_MAXIMUM_NUMBER: "favorite.spaces.maximum.number",
	RECENT_SPACES_MAXIMUM_NUMBER: "recent.spaces.maximum.number",
	/**
	 * Register resources that's preloaded with enabler so enabler won't load it anymore
	 * For example:
	 *  [{globalid: "lconn.coreUtilities", version: "2.5"}, {globalid: "lconn.coreCSS", version: "2.5"}]
	 * @type String
	 */
	REGISTER_LOADEDRESOURCES:"register.loadedresources",
    
    /**
     * Defines the persistence mode that should be used by the iContext. Default is <tt>DOM</tt>.
     */
    PERSISTENCE_MODE: "com.ibm.mashups.enabler.icontext.persistence.mode",
    
    /**
     * Defines the read-only persistence mode for the event provider that is used by the iContext. It overwrites any mode defined as part of <tt>PERSISTENCE_MODE</tt>.Default is <tt>DOM</tt>.
     */
    PERSISTENCE_MODE_EVENTS: "com.ibm.mashups.enabler.icontext.persistence.mode.events",
    /**
     * Defines the modifiable persistence mode for the event provider that is used by the iContext. It overwrites any mode defined as part of <tt>PERSISTENCE_MODE</tt>.Default is <tt>DOM</tt>.
     */
    PERSISTENCE_MODE_EVENTS_MODIFIABLE: "com.ibm.mashups.enabler.icontext.persistence.mode.events.modifiable",
    
    /**
     * Defines the read-only persistence mode for the wire provider that is used by the iContext. It overwrites any mode defined as part of <tt>PERSISTENCE_MODE</tt>.Default is <tt>DOM</tt>.
     */
    PERSISTENCE_MODE_WIRES: "com.ibm.mashups.enabler.icontext.persistence.mode.wires",
    /**
     * Defines the modifiable persistence mode for the wire provider that is used by the iContext. It overwrites any mode defined as part of <tt>PERSISTENCE_MODE</tt>.Default is <tt>DOM</tt>.
     */
    PERSISTENCE_MODE_WIRES_MODIFIABLE: "com.ibm.mashups.enabler.icontext.persistence.mode.wires.modifiable",
    
    /**
     * Defines the read-only persistence mode for the attributes provider that is used by the iContext. It overwrites any mode defined as part of <tt>PERSISTENCE_MODE</tt>.Default is <tt>DOM</tt>.
     */
    PERSISTENCE_MODE_ATTRIBUTES: "com.ibm.mashups.enabler.icontext.persistence.mode.attributes",
    /**
     * Defines the modifiable persistence mode for the attributes provider that is used by the iContext. It overwrites any mode defined as part of <tt>PERSISTENCE_MODE</tt>.Default is <tt>DOM</tt>.
     */
    PERSISTENCE_MODE_ATTRIBUTES_MODIFIABLE: "com.ibm.mashups.enabler.icontext.persistence.mode.attributes.modifiable",

    /**
     * Defines whether the json attributes implementation will be injecting the attributes defined in the widget xml 
     * as well into the attributes map. This will only apply if the json attributes have been enabled through the PERSISTENCE_MODE_ATTRIBUTES setting.
     */
    PERSISTENCE_MODE_ATTRIBUTES_JSON_INJECTXML: "com.ibm.mashups.enabler.icontext.attributes.json.injectxml",

    /**
     * Defines whether autocommit is enabled on the iContext. If set to <tt>true</tt> the iContext will automatically commit data to the
     * backend if commit is called on e.g. the iWidgetAttributes.
     */
    ICONTEXT_AUTO_COMMIT: "com.ibm.mashups.enabler.icontext.autocommit",
	
	ID_PREFIX: "com.ibm.mashups.iWidget.idPrefix",
    /**
     * Defines how violations of enabler usage is prompted to the user; see
     * <ul>
     * <li><code>API_ENFORCEMENT_MODE_WARN</code></li>
     * <li><code>API_ENFORCEMENT_MODE_ERROR</code></li>
     * </ul>
     * Defaults to <code>API_ENFORCEMENT_MODE_WARN</code>.
     * @type String
     * @private
     */
    API_ENFORCEMENT_MODE: "com.ibm.mashups.enabler.enforcement",
    
    /**
     * Warnings will be prompted in the console denoting usage errors of the enabler api.
     * @type String
     * @private
     */
    API_ENFORCEMENT_MODE_WARN: "warning",

    /**
     * Errors will be thrown denoting usage errors of the enabler api, note that
     * this potentially breaks the driver if the api is used incorrectly. 
     * @type String
     * @private
     */
    API_ENFORCEMENT_MODE_ERROR: "error",
    
    /**
     * With this option the location (a URL) of the widget which will be displayed for non previewable content can be defined.
     * If empty (thats the default) the widget delivered with the enabler will be used.
     * 
     * @since 3.0
     * @type String
     */
    NON_PREVIEWABLE_WIDGET_LOCATION: "com.ibm.mashups.enabler.layout.widget.NonPreviewableContentWidget.location",

    /**
     * Size limit of page descriptions, implied from persistence 
     * @since 3.0
     * @type String
     */
    LIMIT_PAGE_DESCRIPTION: "com.ibm.mashups.persistence.page.description.limit",
    
    /**
     * Defines whether personalize is allowed or not for users. Defaults to true.
     * @since 3.0
     * @type Boolean
     */
    WIDGET_PERSONALIZE_ENABLED: "com.ibm.mashups.widget.attributes.personalize.enabled",
	
    /**
     * Defines maximum page number when creating page base on page from hub. Defaults to 50.
     * @since 3.0
     * @type String
     */
	SPACEMANAGER_PAGE_QUERYCOUNT : "com.ibm.mashups.spacemanager.page.queryCount",
    /**
     * Defines the search keyword when pages in hub are queried. Keep it empty will return all pages.
     * @since 3.0
     * @type String
     */	
	SPACEMANAGER_PAGE_QUERYKEYWORD : "com.ibm.mashups.spacemanager.page.queryKeyword",
    /**
     * Defines maximum space number when creating space base on space from hub. Defaults to 50.
     * @since 3.0
     * @type String
     */
	SPACEMANAGER_SPACE_QUERYCOUNT : "com.ibm.mashups.spacemanager.spacetemplate.queryCount",
    /**
     * Defines the search keyword when spaces in hub are queried. Keep it empty will return all spaces.
     * @since 3.0
     * @type String
     */	
	SPACEMANAGER_SPACE_QUERYKEYWORD : "com.ibm.mashups.spacemanager.spacetemplate.queryKeyword",
 
     /**
     * Defines the search keyword when spaces in hub are queried. Keep it empty will return all spaces.
     * @since 3.0
     * @type String
     */	
    
    LOCALAPPS_REGEX : "com.ibm.mashups.multipart.localapps.regex",

    /**
     * Defines the format (as a regular expression) of the server side object IDs.
     * @since 3.0
     * @type String
     */
    SERVER_OBJECT_ID_FORMAT: "com.ibm.mashups.server.oid.format"
		
});

com.ibm.mashups.enabler.services.ConfigConstants = new com.ibm.mashups.enabler.services.ConfigConstants();

}

if(!dojo._hasResource["com.ibm.mashups.enabler.services.ConfigObject_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.services.ConfigObject_API"] = true;
dojo.provide("com.ibm.mashups.enabler.services.ConfigObject_API");
dojo.provide("com.ibm.mashups.enabler.services.ConfigObject");

/**
 * The Config Object allows to access config variables as defined by the system.
 * for a specific config provider.
 * @ibm-spi
 * @ibm-module Base2
 */
dojo.declare("com.ibm.mashups.enabler.services.ConfigObject", null, {
    /**
     * This method returns the value of the config variable as defined by the system
     * @param {String} name the name of the config variable
     * @return {String} the value of the config variable. Maybe be NULL.
     */
    getValue: function(name) {
        return null;
    },
	
	/**
     * This method returns the value of the config variable as defined by the system in a async way
     * @param {String} name the name of the config variable
     * @return {com.ibm.mashups.enabler.Deferred} a deferred object used to start this operation. The return value
     * when executed through the deferred object is the value of the config variable. Maybe be NULL
     */
	getValueDeferred: function(name) {
        return null;
    }
	
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.services.ConfigObjectDefaultImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.services.ConfigObjectDefaultImpl"] = true;
dojo.provide("com.ibm.mm.enabler.services.ConfigObjectDefaultImpl");




dojo.declare("com.ibm.mm.enabler.services.ConfigObjectDefaultImpl", [com.ibm.mashups.enabler.services.ConfigObject], {
    constructor: function(provider, configService) {
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass);
        this.provider = provider;
        this.configService = configService;
        this.ns = {};
        this.ns.app = "http://www.w3.org/2007/app";
        this.ns.atom = "http://www.w3.org/2005/Atom";
    },
    
    /**
     * @deprecated
     */
    getPreferenceValue: function( /*string*/name) {
        if (this.provider == "all") {
            return this.configService.getValue(name);
        }
        else {
            return this._getValue(this.provider, name);
        }
        
        return null;
    },
    
    getValue: function( /*string*/name) {
        if (this.provider == "all") {
            return this.configService.getValue(name, internal);
        }
        else {
            return this._getValue(this.provider, name);
        }
        
        return null;
    },
    
    _getValue: function(/*string*/provider, /*string*/ name) {
        return null;
    },
	
	getValueDeferred: function(/*string*/name){
		if (this.provider == "all") {
			return new com.ibm.mm.enabler.DeferredImpl(this, function(deferred, sync, name) {
				var callBack = deferred.getFinishedCallback();
				var retValue = this.configService.getValue(name, internal);
				if (retValue && callBack ) {
					callBack(retValue, com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_OK, deferred.getFinishedCallbackParameters());
				}
				return retValue;
			});
		}
		else {
			return this._getValueDeferred(this.provider, name);
		}
	},
	
	_getValueDeferred: function(/*string*/provider, /*string*/ name) {
        return null;
    } 
});

// IMPORTANT
// ibmConfig.enablerLayerModules is a comma separated string of all supported modules at runtime
// This section dynamically loads the Extended representation when the variable enablerLayerModules contains the given module
if ((ibmConfig.enablerLayerModules) && (dojo.indexOf(ibmConfig.enablerLayerModules, "Base")>=0)) {
    dojo["require"]("com.ibm.mm.enabler.services.ConfigObjectExtendedImpl"); // JSLINT-IGNORE: This needs to be done to allow modularization and to support the minimal layer
}

}

if(!dojo._hasResource["com.ibm.mashups.enabler.services.ConfigObject"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.services.ConfigObject"] = true;
dojo.provide("com.ibm.mashups.enabler.services.ConfigObject");





}

if(!dojo._hasResource["com.ibm.mashups.enabler.services.ConfigService_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.services.ConfigService_API"] = true;
dojo.provide("com.ibm.mashups.enabler.services.ConfigService_API");
dojo.provide("com.ibm.mashups.enabler.services.ConfigService");



/**
 * The Config Service allows to access config variables as defined by the system.
 * The service can be retrieved using the following code: <br>
 * <code>var configService = com.ibm.mashups.services.ServiceManager.getService(<br/>
 * &nbsp;&nbsp;&nbsp;&nbsp;com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);</code><br/>
 * @ibm-spi
 * @ibm-module Base2
 */
dojo.declare("com.ibm.mashups.enabler.services.ConfigService", null, {
    /**
     * The service name to be used to fetch the service from the ServiceManager
     * @type String
     */
    SERVICE_NAME: "configService",
    
    /**
     * This method returns the value of the config variable as defined by the system
     * @param {String} name the name of the config variable
     * @return {String} the value of the config variable. Maybe be NULL.
     */
    getValue: function(name) {
        return null;
    },
    
    /**
     * This method returns the value of the config object for a config provider
     * @param {String} name the name of the config provider
     * @return {com.ibm.mashups.enabler.services.ConfigObject} the config provider. Maybe be NULL.
     */
    getConfigObject: function(name) {
        return null;
    },
    
    /**
     * This method returns the Config Provider names.  Each Config Provider will
     * have a corresponding ConfigObject.
     * @return {String[]} the config provider names. Never NULL.
     */
    getConfigProviderNames: function() {
        return null;
    }
});
// make sure we can reference this globally
com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME = "configService";

}

if(!dojo._hasResource["com.ibm.mashups.services.ServiceManager_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.services.ServiceManager_API"] = true;
dojo.provide("com.ibm.mashups.services.ServiceManager_API");
dojo.provide("com.ibm.mashups.services.ServiceManager");

/**
 * This interface manages services that are provided to the system, i.e. to iWidgets and other components.<br/>
 * It provides capability to access Services in Lotus Mashups. <br/>
 * By default EventService and ConfigService are provided.<br/>
 * Page components are able to use event services by using following api:<p/>
 * <code>var eventService = com.ibm.mashups.services.ServiceManager.getService(<br/>
 * &nbsp;&nbsp;&nbsp;&nbsp;com.ibm.mashups.iwidget.services.EventService.SERVICE_NAME);</code><br/>
 * <p/><p/>
 * <b>Configuration of services:</b><br/>
 * This section describes how each service is configured and  how additional services can be added.<p/>
 * 
 * Through the ConfigService.properties one can define an additional property named "additionalServices" 
 * defining additional services besides EventService and ConfigService.<p/>
 * Each entry should have the following format.<p />
 * <code>"name": service name.</code><br/>
 * <code>"path": url that point to the service js file.</code><br/>
 * <code>"baseClass": the class that implements the service. one instance of this class will be generated.</code><br />
 * <p/>
 * Example:<br/>
 *  &nbsp;&nbsp;&nbsp;additionalServices = [<br/>
 *  &nbsp;&nbsp;&nbsp;{ "name":"SecurityService",<br/>
 *  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"path":"/mum/js/com/ibm/enabler/iw/securityservices.js",<br/>
 *  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"baseClass":"com.ibm.mm.iwidget.services.SecurityService"}<br/> 
 *  &nbsp;&nbsp;&nbsp;] <p />
 *
 * @ibm-spi
 * @ibm-module Base2
 */
dojo.declare("com.ibm.mashups.services.ServiceManager",null,
  {
    /**
     * @private
     */
    constructor:function(){
    },
    /**
    This interface allow page components to get the required service.
    @param{String} serviceName required service name that's used to uniquely identify a service .
    @type Object
    @returns{Object} an instance of required service. NULL if configured incorrectly.
    */
    getService:function(serviceName) {
    }
  }
);

}

if(!dojo._hasResource["com.ibm.mashups.services.ServiceManager"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.services.ServiceManager"] = true;
dojo.provide("com.ibm.mashups.services.ServiceManager");





}

if(!dojo._hasResource["com.ibm.mm.services.ServiceManagerImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.services.ServiceManagerImpl"] = true;
dojo.provide("com.ibm.mm.services.ServiceManagerImpl");






dojo.declare("com.ibm.mm.services.ServiceManagerImpl", com.ibm.mashups.services.ServiceManager, {
    constructor: function() {
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass);
        this.LOG_LEVEL = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
        
        this._serviceEntries = {};
        
        //allow overwritten if ibmConfig.loadServices is set
        ibmConfig = ibmConfig || {};
        ibmConfig.additionalServices = ibmConfig.additionalServices || null;
        if (ibmConfig.additionalServices) {
            var entries = dojo.fromJson(ibmConfig.additionalServices);
            for (var i in entries) {
                if (Object.prototype.hasOwnProperty.call(entries,i)) {
                    var anEntry = entries[i];
                    this._serviceEntries[anEntry.name] = anEntry;
                }
            }
        }
    },
    getService: function(serviceName) {
    
        var serviceEntry = this._serviceEntries[serviceName];
        serviceEntry = serviceEntry || null;
        if (serviceEntry !== null) {
            var serviceHandler = serviceEntry.serviceHandler;
            serviceHandler = serviceHandler || null;
            if (serviceHandler === null) {
                // assume js is already loaded, create service object
                serviceHandler = this._createService(serviceEntry);
                serviceHandler = serviceHandler || null;
                if (serviceHandler === null) {
                    this._loadScript(serviceEntry);
                    //  serviceHandler = this._createService(serviceEntry);
                }
                else {
                    this._serviceEntries[serviceName].serviceHandler = serviceHandler;
                }
            }
        }
        return this._serviceEntries[serviceName].serviceHandler;
    },
    //if serviceHandler is String, then it's baseClass
    //if it's object, then it's the service handler instance
    setService: function(serviceName, serviceHandler) {
        serviceHandler = serviceHandler || null;
        if (serviceHandler === null) {
            return null;
        }
        //create new service or overwrite an existing service
        var serviceEntry = this._serviceEntries[serviceName];
        serviceEntry = serviceEntry || null;
        if (serviceEntry !== null) {
            delete this._serviceEntries[serviceName];
        }
        if (!this._serviceEntries[serviceName]) {
            this._serviceEntries[serviceName] = {};
        }
        if (dojo.isString(serviceHandler)) {
            this._serviceEntries[serviceName].baseClass = serviceHandler;
        }
        else {
            this._serviceEntries[serviceName].serviceHandler = serviceHandler;
        }
    },
    
    _loadScript: function(serviceEntry) {
        var me = this;
        dojo.xhrGet({
            url: serviceEntry.path,
            handleAs: "text",
            sync: true,
            load: function(result) {
                dojo.eval(result); // JSLINT-IGNORE: We have to evaluate the services JavaScript in this case
                var serviceHandler = me._createService(serviceEntry);
                if (typeof serviceHandler != "undefined" && serviceHandler !== null) {
                    var serviceName = serviceEntry.name;
                    serviceEntry.serviceHandler = serviceHandler;
                }
            },
            error: function(data, ioArgs) {
                this.LOGGER.severe("_loadScript", "error loading service:" + serviceEntry.name, data);
            }
        });
    },
    
    _createService: function(serviceEntry) {
        var service = null;
        try {
            service = new (dojo.getObject(serviceEntry.baseClass))();
        } 
        catch (err) {
            // this.LOGGER.severe("_createService", "failed to create service error detail: " + err.description);
        }
        return service;
    }
});

com.ibm.mashups.services.ServiceManager = new com.ibm.mm.services.ServiceManagerImpl();


}

if(!dojo._hasResource["com.ibm.mm.enabler.services.AbstractConfigServiceImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.services.AbstractConfigServiceImpl"] = true;
dojo.provide("com.ibm.mm.enabler.services.AbstractConfigServiceImpl");




dojo.declare("com.ibm.mm.enabler.services.AbstractConfigServiceImpl", com.ibm.mashups.enabler.services.ConfigService, {
	
    constructor: function(){
		this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass);
    },
    
    /**
     * @deprecated
     */
    getPreferenceValue: function( /*string*/name){
        return this.getValue(name);
    },
    
    getValue: function( /*string*/name, internal){
        if (typeof internal == "undefined") {
            this.LOGGER.warning("com.ibm.mm.enabler.services.ConfigService.getValue", "This method must not be used directly. Use com.ibm.mashups.enabler.services.ConfigService.getValue instead.  name: ${0}", [name]);
        }
        var value = ibmConfig[name];
        return value;
    },
    
    getConfigObject: function(/*string*/configProvider){
        return null;
    },
    
    getConfigProviderNames: function(){
        return null;
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.services.ConfigServiceDefaultImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.services.ConfigServiceDefaultImpl"] = true;
dojo.provide("com.ibm.mm.enabler.services.ConfigServiceDefaultImpl");

// inject this service into the ServiceManager at the end. Therefore we have to require the implementation




//
//dojo.require("com.ibm.mm.enabler.services.ModelRestServiceRequest");
//dojo.require("com.ibm.mm.enabler.endpoints.XHREndpointExtensionImpl");



dojo.declare("com.ibm.mm.enabler.services.ConfigServiceDefaultImpl", [com.ibm.mm.enabler.services.AbstractConfigServiceImpl], {
    constructor: function() {
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.enabler.services.ConfigServiceDefaultImpl");
    },
    
    _getConfigObject: function(/*string*/configProvider) {
        if (!ibmConfig["CO_" + configProvider]) {
            var co = new com.ibm.mm.enabler.services.ConfigObjectDefaultImpl(configProvider, this);
            ibmConfig["CO_" + configProvider] = co;
        }
        
        return ibmConfig["CO_" + configProvider];
    },
    
    _getConfigProviderNames: function() {
        var ret = [];
        ret.push("all");
        return ret;
    },
    
    getValue: function(name) {
        var METHOD_NAME = "getValue(name)";
        var bIsLogging = this.LOGGER.isLoggable(com.ibm.mashups.enabler.logging.LogLevel.TRACE);
        if (bIsLogging) {
            this.LOGGER.entering(METHOD_NAME, name);
        }
        var ret = this.inherited(arguments, [name, true]);
        
        if (bIsLogging) {
            this.LOGGER.exiting(METHOD_NAME, ret);
        }
        return ret;
    },
    
    getConfigObject: function(name) {
        var METHOD_NAME = "getConfigObject(name)";
        var bIsLogging = this.LOGGER.isLoggable(com.ibm.mashups.enabler.logging.LogLevel.TRACE);
        if (bIsLogging) {
            this.LOGGER.entering(METHOD_NAME, name);
        }
        var ret = this._getConfigObject(name);
        
        if (bIsLogging) {
            this.LOGGER.exiting(METHOD_NAME, ret);
        }
        return ret;
        
    },
    
    getConfigProviderNames: function() {
        var METHOD_NAME = "getConfigProviderNames()";
        var bIsLogging = this.LOGGER.isLoggable(com.ibm.mashups.enabler.logging.LogLevel.TRACE);
        if (bIsLogging) {
            this.LOGGER.entering(METHOD_NAME, name);
        }
        var ret = this._getConfigProviderNames();
        
        if (bIsLogging) {
            this.LOGGER.exiting(METHOD_NAME, ret);
        }
        return ret;
    }
    
});

com.ibm.mashups.services.ServiceManager.setService("configService", "com.ibm.mm.enabler.services.ConfigServiceDefaultImpl");

// IMPORTANT
// ibmConfig.enablerLayerModules is a comma separated string of all supported modules at runtime
// This section dynamically loads the Extended representation when the variable enablerLayerModules contains the given module
if ((ibmConfig.enablerLayerModules) && (dojo.indexOf(ibmConfig.enablerLayerModules, "Base")>=0)) {
    dojo["require"]("com.ibm.mm.enabler.services.ConfigServiceExtendedImpl"); // JSLINT-IGNORE: This needs to be done to allow modularization and to support the minimal layer
}

}

if(!dojo._hasResource["com.ibm.mashups.enabler.services.ConfigService"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.services.ConfigService"] = true;
dojo.provide("com.ibm.mashups.enabler.services.ConfigService");





}

if(!dojo._hasResource["com.ibm.mashups.enabler.utils.EndpointHelper_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.utils.EndpointHelper_API"] = true;
dojo.provide("com.ibm.mashups.enabler.utils.EndpointHelper_API");
dojo.provide("com.ibm.mashups.enabler.utils.EndpointHelper");

/**
 * Helper utility for endpoint encoded urls.
 * 
 * @ibm-module Base2
 * TODO: Change/Remove
 */
dojo.declare("com.ibm.mashups.enabler.utils.EndpointHelper", null, {
	/**
	 * This method resolves endpoint://{endpointid}/relativeurl
	 * 
	 * @param {String} url the url to resolve for endpoints
     * @return {String} the url with endpoints resolved
     */
    resolve: function(url) {
        return null;
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.EndpointUtils"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.EndpointUtils"] = true;
dojo.provide("com.ibm.mm.enabler.EndpointUtils");

dojo.declare("com.ibm.mm.enabler.EndpointUtilsDefaultImpl", null, {
    constructor: function(){
    },
    
    checkForEndpoints: function(/*String*/url){
        return null;
    }
});
com.ibm.mm.enabler.EndpointUtils = new com.ibm.mm.enabler.EndpointUtilsDefaultImpl();

// IMPORTANT
// ibmConfig.enablerLayerModules is a comma separated string of all supported modules at runtime
// This section dynamically loads the Extended representation when the variable enablerLayerModules contains the given module
if ((ibmConfig.enablerLayerModules) && (dojo.indexOf(ibmConfig.enablerLayerModules, "iWidget")>=0)) {
    dojo["require"]("com.ibm.mm.enabler.EndpointUtilsExtendedImpl"); // JSLINT-IGNORE: This needs to be done to allow modularization and to support the minimal layer
}

}

if(!dojo._hasResource["com.ibm.mm.enabler.utils.EndpointHelperImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.utils.EndpointHelperImpl"] = true;
dojo.provide("com.ibm.mm.enabler.utils.EndpointHelperImpl");




dojo.declare("com.ibm.mm.enabler.utils.EndpointHelperImpl", null,
    {
        resolve: function(url) {
            if (!url) {
                return url;
            }
            
            var url2 = com.ibm.mm.enabler.EndpointUtils.checkForEndpoints(url);
            if (url2) {
               return url2; 
            }
            
            return url;
        }
    }
);

com.ibm.mashups.enabler.utils.EndpointHelper = new com.ibm.mm.enabler.utils.EndpointHelperImpl();

}

if(!dojo._hasResource["com.ibm.mashups.enabler.utils.EndpointHelper"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.utils.EndpointHelper"] = true;
dojo.provide("com.ibm.mashups.enabler.utils.EndpointHelper");





}

if(!dojo._hasResource["com.ibm.mashups.enabler.utils.URLHelper_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.utils.URLHelper_API"] = true;
dojo.provide("com.ibm.mashups.enabler.utils.URLHelper_API");
dojo.provide("com.ibm.mashups.enabler.utils.URLHelper");

/**
 * Helper utility for encoding urls.
 * 
 * @ibm-module Base2
 */
dojo.declare("com.ibm.mashups.enabler.utils.URLHelper", null, {
    /**
     * This method rewrites a url and takes care for instance to proxify the given url
     * 
     * @ibm-api
     *
     * @param {String} url the url to rewrite
     * @return {String} the encoded url
     */
    rewriteURL: function(targetUrl){
        return null;
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.utils.Misc"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.utils.Misc"] = true;
dojo.provide("com.ibm.mm.enabler.utils.Misc");




com.ibm.mm.enabler.utils.Misc = {
    LOG_LEVEL: com.ibm.mashups.enabler.logging.LogLevel.TRACE,
    LOGGER: com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.enabler.utils.Misc"),
    
    /**
     * Example usage:
     * 
     * 
     * 
     * var myObj = {a: 1, b: "bla", c: function(){}};
     * 
     * com.ibm.mm.enabler.utils.Misc.forIn(myObj,function(item,idx,arr) {
     *    console.debug(arguments);
     *   });
     *   // prints:
     *   // [1, "a", Object { a=1,  more...}]
     *   // ["bla", "b", Object { a=1, more...}]
     *   // [function(), "c", Object { a=1, more...}]
     *   
     *   
     *  var myScope = {
     *     count: 0,
     *    f: function(item,idx,arr) {
     *          this.count++;
     *         }
     *   }
     *  com.ibm.mm.enabler.utils.Misc.forIn(myObj,'f',myScope);
     *  
     *  console.debug(myScope.count); // prints: 3

     * @param {Object} obj The object to iterate over
     * @param {Function|String} func The function to call on each object with three parameters: value, key, object
     * @param {Object} scope Optional, the scope to call the function on.
     */
    forIn: function(obj, func, scope) {
       if(!obj || typeof obj != "object") {
          return;
       }
       scope = scope || null;
       var item;
       for(var idx in obj) {
           if(Object.prototype.hasOwnProperty.call(obj,idx)) {
               item = obj[idx];
               dojo.hitch(scope,func)(item,idx,obj);
           }
       }
    },
    
    encodePath: function(path, decoded) {
        if (path.length === 0) {
            return path;
        }
        
        var parts = path.split("/");
        
        for (var i=0; i<parts.length; ++i) {
            parts[i] = decoded ? com.ibm.mm.enabler.utils.Misc._pathPartUnescape(parts[i]) : 
                com.ibm.mm.enabler.utils.Misc._pathPartEscape(com.ibm.mm.enabler.utils.Misc._pathPartUnescape(parts[i]));
        }
        
        return parts.join("/");
    },
    // Acccording to RFC 1738
    // those are the allowed characters in a path element
    // reserved:        ";" | "/" | "?" | ":" | "@" | "&" | "="
    // allowed in path: ";" |             ":" | "@" | "&" | "="
    _pathPartUnescape:function(pathPart) {
        pathPart = decodeURIComponent(pathPart);
/* Removed per #18252
        pathPart = pathPart.replace(/%2F/g, '/');
        pathPart = pathPart.replace(/%2f/g, '/');
        pathPart = pathPart.replace(/%3F/g, '?');
        pathPart = pathPart.replace(/%3f/g, '?');
*/
        return pathPart;
    },
    _pathPartEscape:function(pathPart) {
        pathPart = encodeURIComponent(pathPart);
/* Removed per #18252
        pathPart = pathPart.replace(/\//g, '%2F');
        pathPart = pathPart.replace(/\?/g, '%3F');
*/
        // we do not encode a colon as this is allowed by the spec and the OpenSocial container requires it
        pathPart = pathPart.replace(/%3a/g, ':');
        pathPart = pathPart.replace(/%3A/g, ':');
        return pathPart;
    },
    inStringArray:function(str,/*[]*/arrayObj)
    {
        var rc = false;
        for (var i in arrayObj) {
            if (Object.prototype.hasOwnProperty.call(arrayObj,i)) {
                var temp1 = arrayObj[i];
                if (temp1 == str) {
                    rc = true;
                    break;
                }
            }
        }
        return rc;
    },
    isEmpty: function (object) {
    	if(object === null || typeof object == "undefined") {
    		return true;
    	} else if(dojo.isString(object)) {
    		return object.length === 0;
    	} else {
            for (var i in object) {
                if (Object.prototype.hasOwnProperty.call(object, i)) {
                    return false;
                }
            }
            return true;
    	}
    },
    encodeModelID4Uri:function(uri)
    {
        // encode uri part correctly
        var pos = uri.indexOf(":");
        if (pos != -1) {
            var start = uri.slice(0,pos+1);
            var end = uri.slice(pos+1);
            uri = start + encodeURIComponent(end);
        }
        return encodeURIComponent(uri);
    },
    preloadImage:function(path,width,height){
        var image = (width && height) ? new Image(width, height) : new Image();        
        image.src = path;
        return image;
    },
    isInstanceOf:function(obj1, obj2) {
        if (obj1 && obj2) {
            if (typeof obj1.isInstanceOf == "function") {
                 if (obj1.isInstanceOf(obj2)) {
                    return true;
                 }
                
            }
            return (obj1 instanceof obj2);
        }
        return false;
      
    },
	isPocUrl: function(urlString) {
		
    	var supportedSchema =  {
        	http: "http",
        	https: "https",
        	file: "file" //not resolver will handle web dav:/ url
    	};
        var rc = false;
        if (urlString.indexOf(":") > 0) {
            if (urlString.indexOf("/") === 0) { 
                return false;
            }
			if (urlString.indexOf("?") === 0) { 
                return false;
            }
            var schema = urlString.substring(0, urlString.indexOf(":"));
            if (!supportedSchema[schema]) {
                rc = true;
            }
        }
        return rc;
    }
};

}

if(!dojo._hasResource["com.ibm.mm.enabler.utils.HttpUrl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.utils.HttpUrl"] = true;
dojo.provide("com.ibm.mm.enabler.utils.HttpUrl");








dojo.declare("com.ibm.mm.enabler.utils.HttpUrl", null, {
    constructor: function( /*String*/urlString, /*boolean*/ resolveEndpoints){
    
        if (resolveEndpoints !== false) {
            var resolved = com.ibm.mm.enabler.EndpointUtils.checkForEndpoints(urlString);
            if (resolved) {
                urlString = resolved;
            }
        }
        
        this.pocurl = this._resolvePocUrl(urlString);
        if (!this.pocurl) {
            this.scheme = this._extractScheme(urlString);
            this.server = this._extractServer(urlString);
            this.port = this._extractPort(urlString);
            this.path = this._extractPath(urlString);
            this.parameters = this._extractQuery(urlString);
            this.anchor = this._extractAnchor(urlString);
        }
    },
    _resolvePocUrl: function(urlString){
    
        var rv = null;
        if (com.ibm.mm.enabler.utils.Misc.isPocUrl(urlString)) {
            var prefix = this._getPrefix();
            urlString = escape(unescape(urlString)); // encode before adding as parameter
            rv = prefix.concat(urlString);
        }
        return rv;
    },
    _getPrefix: function(){
        var cs = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
        var serverRoot = cs.getValue(com.ibm.mashups.enabler.services.ConfigConstants.CONTEXT_ROOT);
        var anonymousUser = cs.getValue(com.ibm.mashups.enabler.services.ConfigConstants.ANONYMOUS_USER);
        var contenthandlerPath;
        
        if (anonymousUser) {
            contenthandlerPath = cs.getValue(com.ibm.mashups.enabler.services.ConfigConstants.CONTENTHANDLER_PUBLIC);
        }
        else {
            contenthandlerPath = cs.getValue(com.ibm.mashups.enabler.services.ConfigConstants.CONTENTHANDLER_PRIVATE);
        }
        
        var rv = serverRoot.concat(contenthandlerPath).concat("?uri=");
        return rv;
    },
    
    addParameter: function( /*String*/name, /*String*/ value){
        if (dojo.isString(this.parameters[name])) {
            this.parameters[name] = [this.parameters[name], value];
        }
        else 
            if (dojo.isArray(this.parameters[name])) {
                this.parameters[name].push(value);
            }
            else {
                this.parameters[name] = value;
            }
    },
    setParameter: function(/*String*/name, /*Object*/ value){
        if (!this.parameters) {
            this.parameters = {};
        }
        this.parameters[name] = value;
    },
    getParameter: function(/*String*/name){
        if (!this.parameters) {
            return false;
        }
        return this.parameters[name];
    },
    getParameters: function(){
        return this.parameters;
    },
    isProxyNeeded: function(){
        var loc = document.location;
        // first test the scheme:
        if (loc.protocol != this.scheme) {
            return true;
        }
        // test the host
        if (!this._equalsServer(loc.hostname)) {
            return true;
        }
        // simplest case, ports are the same, return false
        if (loc.port == this.port) {
            return false;
        }
        
        var defaultPort;
        // tests for http with default port
        if (this.scheme == "http:") {
            defaultPort = "80";
            
            if ((loc.port == "" && this.port == defaultPort) ||
            (loc.port == defaultPort && this.port == "")) {
                return false;
            }
        }
        
        // tests for https with default port
        if (this.scheme == "https:") {
            defaultPort = "443";
            
            if ((loc.port == "" && this.port == defaultPort) ||
            (loc.port == defaultPort && this.port == "")) {
                return false;
            }
        }
        
        return true;
    },
    toServerRelativeString: function(decoded){
        if (this.pocurl) {
            return this.pocurl;
        }
        var str = "";
        
        if (this.path != "") {
            str += "/" + com.ibm.mm.enabler.utils.Misc.encodePath(this.path, decoded);
        }
        if (!com.ibm.mm.enabler.utils.Misc.isEmpty(this.parameters)) {
            str += "?" + (decoded ? this._parametersToQuery(this.parameters) : dojo.objectToQuery(this.parameters));
        }
        if (this.anchor != "") {
            str += "#" + this.anchor;
        }
        
        return str;
    },
    toProxifiedString: function(){
        //check if we need the proxy
        if (this.pocurl) {
            return this.pocurl;
        }
        if (typeof ibmConfig == 'undefined') {
            return this.toString();
        }
        
        var newURL = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME).getValue(com.ibm.mashups.enabler.services.ConfigConstants.PROXY_URL);
        if (!newURL) {
            return this.toString();
        }
        newURL += "/";
        
        if (window.location.protocol == this.scheme && this._equalsServer(window.location.hostname)) {
            if (window.location.port == this.port) {
                return this.toString();
            }
            else 
                if (this.scheme == "http:" && window.location.port == "" && this.port == "80") {
                    return this.toString();
                }
                else 
                    if (this.scheme == "https:" && window.location.port == "" && this.port == "443") {
                        return this.toString();
                    }
                    else 
                        if (this.scheme == "http:" && window.location.port == "80" && this.port == "") {
                            return this.toString();
                        }
                        else 
                            if (this.scheme == "https:" && window.location.port == "443" && this.port == "") {
                                return this.toString();
                            }
        }
        
        // rewrite
        if (this.scheme == "https:") {
            newURL += "https/" + this.server + ((this.port != "443" && this.port != "") ? ":" + this.port : "");
        }
        else {
            newURL += "http/" + this.server + ((this.port != "80" && this.port != "") ? ":" + this.port : "");
        }
        
        // add the slash portion in ANY case
        newURL += "/";
        
        if (this.path != "") {
            newURL += com.ibm.mm.enabler.utils.Misc.encodePath(this.path);
        }
        
        if (!com.ibm.mm.enabler.utils.Misc.isEmpty(this.parameters)) {
            newURL += "?" + dojo.objectToQuery(this.parameters);
        }
        
        if (this.anchor != "") {
            newURL += "#" + this.anchor;
        }
        
        return newURL;
    },
    toString: function(decoded){
        if (this.pocurl) {
            return this.pocurl;
        }
        var str = "";
        //safari doesn't support url normalization on xhr request
        if (this.server != "") {
            str += this.scheme + "//" + this.server;
            if (this.port != "") {
                if (this.scheme == "http:" && this.port == "80") {
                    str += "";
                }
                else 
                    if (this.scheme == "https:" && this.port == "443") {
                        str += "";
                    }
                    else {
                        str += ":" + this.port;
                    }
            }
        }
        
        // add the slash portion in ANY case
        str += "/";
        
        if (this.path != "") {
            str += com.ibm.mm.enabler.utils.Misc.encodePath(this.path, decoded);
        }
        
        if (!com.ibm.mm.enabler.utils.Misc.isEmpty(this.parameters)) {
            str += "?" + (decoded ? this._parametersToQuery(this.parameters) : dojo.objectToQuery(this.parameters));
        }
        
        if (this.anchor != "") {
            str += "#" + this.anchor;
        }
        
        return str;
    },
    _parametersToQuery: function(params){
        var str = "";
        // concatenation function (defined outside of the for-loop)
        var fn = function(value){
            str += k + "=" + value + "&";
        };
        for (var k in params) {
            // concatenate parameters
            if (dojo.isArray(params[k])) {
                dojo.forEach(params[k], fn);
            }
            else {
                fn(params[k]);
            }
        }
        // remove trailing ampersand
        if (str.lastIndexOf('&') === str.length - 1) {
            str = str.substr(0, str.length - 1);
        }
        return str;
    },
    _isAbsolute: function(){
        return this._absoluteURL;
    },
    _extractScheme: function(/*String*/urlString){
        // important check as :// may appear as query parameter and then below logic doesn't work in case it is a relative URL
        var isRelative = urlString.indexOf("/") === 0;
        if (isRelative) {
            return window.location.protocol; // location.protocol returns the protocol like http: or https:
        }
        var indexOfScheme = urlString.indexOf("://");
        if (indexOfScheme == -1) {
            this._absoluteURL = false;
            return window.location.protocol; // location.protocol returns the protocol like http: or https:
        }
        this._absoluteURL = true;
        return urlString.substring(0, indexOfScheme + 1);
    },
    _extractServer: function(/*String*/urlString){
        var indexOfScheme = urlString.indexOf(this.scheme);
        var retVal = "";
        if (indexOfScheme === 0) {
            var serverAndPort;
            var indexOfSlash = urlString.indexOf("/", indexOfScheme + this.scheme.length + 2);
            if (indexOfSlash != -1) {
                serverAndPort = urlString.substring(indexOfScheme + this.scheme.length + 2, indexOfSlash);
            }
            else {
                serverAndPort = urlString.substring(indexOfScheme + this.scheme.length + 2);
            }
            retVal = serverAndPort.split(":")[0];
        }
        else {
            var hostname = window.location.hostname;
            retVal = this._isIPv6(hostname) ? "[" + hostname + "]" : hostname;
        }
        
        return retVal;
    },
    _extractPort: function(/*String*/urlString){
        var indexOfServer = urlString.indexOf(this.server);
        var retVal = "";
        if (indexOfServer >= 0) {
            var serverAndPort;
            var indexOfSlash = urlString.indexOf("/", indexOfServer);
            if (indexOfSlash != -1) {
                serverAndPort = urlString.substring(indexOfServer, indexOfSlash);
            }
            else {
                serverAndPort = urlString.substring(indexOfServer);
            }
            var serverAndPortParts = serverAndPort.split(":");
            if (serverAndPortParts.length > 1) {
                retVal = serverAndPortParts[1];
            }
        }
        
        if (retVal == "") {
            if (urlString.indexOf("/") === 0) {
                retVal = window.location.port;
            }
            else {
                retVal = "";
            }
        }
        
        return retVal;
    },
    _extractPath: function( /*String*/urlString){
        var indexOfScheme = urlString.indexOf(this.scheme);
        var startIndex = 0;
        
        if (indexOfScheme === 0) {
            startIndex = this.scheme.length + 2;
        }
        
        var retVal = "";
        
        var indexOfSlash = urlString.indexOf("/", startIndex);
        var indexOfQuery = urlString.indexOf("?");
        var indexOfHash = urlString.lastIndexOf("#");
        if (indexOfQuery >= 0) {
            retVal = urlString.substring(indexOfSlash + 1, indexOfQuery);
        }
        else {
            if (indexOfHash >= 0 && indexOfSlash != -1) {
                retVal = urlString.substring(indexOfSlash + 1, indexOfHash);
            }
            else 
                if (indexOfSlash != -1) {
                    retVal = urlString.substring(indexOfSlash + 1);
                }
        }
        
        return retVal;
    },
    _extractQuery: function( /*String*/urlString){
        var retVal = {};
        var urlParts = urlString.split("?");
        
        if (urlParts.length > 1) {
            retVal = dojo.queryToObject(urlParts[1].split("#")[0]);
        }
        
        return retVal;
    },
    _extractAnchor: function( /*String*/urlString){
        var retVal = "";
        var urlParts = urlString.split("#");
        
        if (urlParts.length > 1) {
            retVal = urlParts[urlParts.length - 1];
        }
        
        return retVal;
    },
    _isIPv6: function(hostname){
        // only IPv6 addresses contain colons
        // note: the input hostname MUST NOT contain a port 
        return hostname.indexOf(":") != -1;
    },
    
    _equalsServer: function(hostname){
        // consider square brackets in IPv6 case 
        return this.server == (this._isIPv6(hostname) ? "[" + hostname + "]" : hostname);
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.utils.URLHelper"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.utils.URLHelper"] = true;
dojo.provide("com.ibm.mm.enabler.utils.URLHelper");




dojo.declare("com.ibm.mm.enabler.utils.URLHelperImpl", com.ibm.mashups.enabler.utils.URLHelper, {
    rewriteURL: function(targetUrl){
        var _targetURL = new com.ibm.mm.enabler.utils.HttpUrl(targetUrl);
        return _targetURL.toProxifiedString();
    }
});

com.ibm.mashups.enabler.utils.URLHelper = new com.ibm.mm.enabler.utils.URLHelperImpl();
com.ibm.mm.enabler.utils.URLHelper = com.ibm.mashups.enabler.utils.URLHelper;

}

if(!dojo._hasResource["com.ibm.mashups.enabler.utils.URLHelper"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.utils.URLHelper"] = true;
dojo.provide("com.ibm.mashups.enabler.utils.URLHelper");





}

if(!dojo._hasResource["com.ibm.mashups.iwidget.services.ContainerService_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.iwidget.services.ContainerService_API"] = true;
dojo.provide("com.ibm.mashups.iwidget.services.ContainerService_API");
dojo.provide("com.ibm.mashups.iwidget.services.ContainerService");

/**
 * @ibm-spi
 * @ibm-module iWidget2
 */
dojo.declare("com.ibm.mashups.iwidget.services.ContainerService",null,  {
    /**
     * The service name to be used to fetch the service from the ServiceManager
     * @type String
     */
    SERVICE_NAME: "iWidgetContainerService",
    
    /**
     * Constant defining the provider for event information
     * @type String
     */
    PROVIDER_EVENTS: "events",

    /**
     * Constant defining the provider for wire information
     * @type String
     */
    PROVIDER_WIRES: "wires",
    
    /**
     * Constant defining the provider for attribute information
     * @type String
     */
    PROVIDER_ATTRIBUTES: "attributes",

    registerOnChangeListener:function(provider, contextAndCallback) {
    },

    /**
     * Sets the persistence mode for the given type to the given new mode.
     *
     * @param {String} provider  One of the PROVIDER_* constants defined in this service. Must never be NULL.
     * @return {String} the current persistence mode for the given provider. May be NULL.
     */
    getPersistenceMode:function(provider, newMode) {
    },
    
    /**
     * Sets the persistence mode for all providers into their respective modifiable mode.
     *
     * @type void
     */
    switchToModifiablePersistenceMode:function() {
    }

});

// make sure we can reference this globally
com.ibm.mashups.iwidget.services.ContainerService.SERVICE_NAME = "iWidgetContainerService";
com.ibm.mashups.iwidget.services.ContainerService.PROVIDER_EVENTS = "events";
com.ibm.mashups.iwidget.services.ContainerService.PROVIDER_WIRES = "wires";
com.ibm.mashups.iwidget.services.ContainerService.PROVIDER_ATTRIBUTES = "attributes";


}

if(!dojo._hasResource["com.ibm.mashups.iwidget.services.ContainerService"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.iwidget.services.ContainerService"] = true;
dojo.provide("com.ibm.mashups.iwidget.services.ContainerService");





}

if(!dojo._hasResource["com.ibm.mm.iwidget.services.ContainerServiceImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.iwidget.services.ContainerServiceImpl"] = true;
dojo.provide("com.ibm.mm.iwidget.services.ContainerServiceImpl");

/*
 * This is injected on the fly and not fetched through an API. Therefore we need to define the @ibm-module so that the build process is picking it up
 * @ibm-module iWidget2
 *
 * This value defines the order in which the packages should be printed out into the dojo profile. Default is 100.
 * Any number that is smaller causes this class to be written out before any other with a higher number
 * @ibm-dojo-profile-level 40
 */
// inject this service into the ServiceManager at the end. Therefore we have to require the implementation




dojo.declare("com.ibm.mm.iwidget.services.ContainerServiceImpl", com.ibm.mashups.iwidget.services.ContainerService, {
    constructor: function(){
        this._modes = null;
        this._modModes = null;
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass);
        this.LOG_LEVEL = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
        this.bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);

        this.TOPIC_BASE = "/"+("com.ibm.mm.iwidget.services.ContainerServiceImpl".replace(/\./ig,'/'))+"/";
        this.TOPIC_CHANGE = this.TOPIC_BASE + "change";
        this.TOPIC_CHANGE_EVENTS = this.TOPIC_CHANGE + "/events";
        this.TOPIC_CHANGE_WIRES = this.TOPIC_CHANGE + "/wires";
        this.TOPIC_CHANGE_ATTRIBUTES = this.TOPIC_CHANGE + "/attributes";

        this._topics = {};
        this._topics[com.ibm.mashups.iwidget.services.ContainerService.PROVIDER_EVENTS] = this.TOPIC_CHANGE_EVENTS;
        this._topics[com.ibm.mashups.iwidget.services.ContainerService.PROVIDER_WIRES] = this.TOPIC_CHANGE_WIRES;
        this._topics[com.ibm.mashups.iwidget.services.ContainerService.PROVIDER_ATTRIBUTES] = this.TOPIC_CHANGE_ATTRIBUTES;
    },
    
    _invalidate: function() {
        this._modes = null;
        this._modModes = null;
    },
    
    _init:function() {
        if (this._modes) {
            return;
        }
        var LOG_METHOD = "_init";
        if (this.bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, arguments);
        }
        
        var cs = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
        var genericPersistenceMode = cs.getValue(com.ibm.mashups.enabler.services.ConfigConstants.PERSISTENCE_MODE);
        var eventPersistenceMode = cs.getValue(com.ibm.mashups.enabler.services.ConfigConstants.PERSISTENCE_MODE_EVENTS);
        var wirePersistenceMode = cs.getValue(com.ibm.mashups.enabler.services.ConfigConstants.PERSISTENCE_MODE_WIRES);
        var attributePersistenceMode = cs.getValue(com.ibm.mashups.enabler.services.ConfigConstants.PERSISTENCE_MODE_ATTRIBUTES);
        this._modes = {};
        this._modes[com.ibm.mashups.iwidget.services.ContainerService.PROVIDER_EVENTS] = (eventPersistenceMode) ? eventPersistenceMode : genericPersistenceMode;
        this._modes[com.ibm.mashups.iwidget.services.ContainerService.PROVIDER_WIRES] = (wirePersistenceMode) ? wirePersistenceMode :  genericPersistenceMode;
        this._modes[com.ibm.mashups.iwidget.services.ContainerService.PROVIDER_ATTRIBUTES] = (attributePersistenceMode) ? attributePersistenceMode : genericPersistenceMode;        

        eventPersistenceMode = cs.getValue(com.ibm.mashups.enabler.services.ConfigConstants.PERSISTENCE_MODE_EVENTS_MODIFIABLE);
        wirePersistenceMode = cs.getValue(com.ibm.mashups.enabler.services.ConfigConstants.PERSISTENCE_MODE_WIRES_MODIFIABLE);
        attributePersistenceMode = cs.getValue(com.ibm.mashups.enabler.services.ConfigConstants.PERSISTENCE_MODE_ATTRIBUTES_MODIFIABLE);
        this._modModes = {};
        this._modModes[com.ibm.mashups.iwidget.services.ContainerService.PROVIDER_EVENTS] = (eventPersistenceMode) ? eventPersistenceMode : genericPersistenceMode;
        this._modModes[com.ibm.mashups.iwidget.services.ContainerService.PROVIDER_WIRES] = (wirePersistenceMode) ? wirePersistenceMode :  genericPersistenceMode;
        this._modModes[com.ibm.mashups.iwidget.services.ContainerService.PROVIDER_ATTRIBUTES] = (attributePersistenceMode) ? attributePersistenceMode : genericPersistenceMode;        

        if (this.bIsLoggable) {
            this.LOGGER.trace(LOG_METHOD, "Selected Modes for the iWidget Providers:");
            this.LOGGER.trace(LOG_METHOD, com.ibm.mashups.iwidget.services.ContainerService.PROVIDER_EVENTS+": "+this._modes[com.ibm.mashups.iwidget.services.ContainerService.PROVIDER_EVENTS]);
            this.LOGGER.trace(LOG_METHOD, com.ibm.mashups.iwidget.services.ContainerService.PROVIDER_WIRES+": "+this._modes[com.ibm.mashups.iwidget.services.ContainerService.PROVIDER_WIRES]);
            this.LOGGER.trace(LOG_METHOD, com.ibm.mashups.iwidget.services.ContainerService.PROVIDER_ATTRIBUTES+": "+this._modes[com.ibm.mashups.iwidget.services.ContainerService.PROVIDER_ATTRIBUTES]);
            this.LOGGER.exiting(LOG_METHOD);
        }
    },

    registerOnChangeListener:function(provider, contextAndCallback) {
        this._init();
        var handle = dojo.subscribe(this._topics[provider], contextAndCallback.context, contextAndCallback.callback);
        if (dojo.isFunction(contextAndCallback.unregister)) {
            dojo.hitch(contextAndCallback.context, contextAndCallback.unregister)(handle);
        }
    },
    
    getPersistenceMode:function(provider, newMode) {
        this._init();
        return this._modes[provider];
    },
    
    switchToModifiablePersistenceMode:function(provider) {
        var LOG_METHOD = "switchToModifiablePersistenceMode";
        if (this.bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, arguments);
        }
        this._init();
        var oldModeEvents = this._modes[com.ibm.mashups.iwidget.services.ContainerService.PROVIDER_EVENTS];
        var newModeEvents = this._modModes[com.ibm.mashups.iwidget.services.ContainerService.PROVIDER_EVENTS];
        var oldModeWires = this._modes[com.ibm.mashups.iwidget.services.ContainerService.PROVIDER_WIRES];
        var newModeWires = this._modModes[com.ibm.mashups.iwidget.services.ContainerService.PROVIDER_WIRES];
        var oldModeAttributes = this._modes[com.ibm.mashups.iwidget.services.ContainerService.PROVIDER_ATTRIBUTES];
        var newModeAttributes = this._modModes[com.ibm.mashups.iwidget.services.ContainerService.PROVIDER_ATTRIBUTES];

        this._modes[com.ibm.mashups.iwidget.services.ContainerService.PROVIDER_EVENTS] = newModeEvents;
        this._modes[com.ibm.mashups.iwidget.services.ContainerService.PROVIDER_WIRES] = newModeWires;
        this._modes[com.ibm.mashups.iwidget.services.ContainerService.PROVIDER_ATTRIBUTES] = newModeAttributes;

        if (oldModeEvents != newModeEvents) {
            if (this.bIsLoggable) {
                this.LOGGER.trace(LOG_METHOD, "old mode != new mode, switching...");
            }
            dojo.publish(this._topics[com.ibm.mashups.iwidget.services.ContainerService.PROVIDER_EVENTS], 
                [com.ibm.mashups.iwidget.services.ContainerService.PROVIDER_EVENTS, oldModeEvents, newModeEvents]);
            dojo.publish(this._topics[com.ibm.mashups.iwidget.services.ContainerService.PROVIDER_WIRES], 
                [com.ibm.mashups.iwidget.services.ContainerService.PROVIDER_WIRES, oldModeWires, newModeWires]);
            dojo.publish(this._topics[com.ibm.mashups.iwidget.services.ContainerService.PROVIDER_ATTRIBUTES], 
                [com.ibm.mashups.iwidget.services.ContainerService.PROVIDER_ATTRIBUTES, oldModeAttributes, newModeAttributes]);
        }
        if (this.bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD);
        }
    }

});

com.ibm.mashups.services.ServiceManager.setService(com.ibm.mashups.iwidget.services.ContainerService.SERVICE_NAME, new com.ibm.mm.iwidget.services.ContainerServiceImpl());


}

if(!dojo._hasResource["com.ibm.mashups.enabler.widget.Constants_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.widget.Constants_API"] = true;
dojo.provide("com.ibm.mashups.enabler.widget.Constants_API");
dojo.provide("com.ibm.mashups.enabler.widget.Constants");

dojo.declare("com.ibm.mashups.enabler.widget.Constants", null, {

    /**
     * Handled events
     * @type {String}
     */
    FILTER_HANDLED_EVENTS: "HandledEvents",
    
    /**
     * Published events
     * @type {String}
     */
    FILTER_PUBLISHED_EVENTS: "PublishedEvents"
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.widget.Constants"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.widget.Constants"] = true;
dojo.provide("com.ibm.mm.enabler.widget.Constants");



dojo.declare("com.ibm.mm.enabler.widget.Constants", com.ibm.mashups.enabler.widget.Constants, {
    
    constructor: function() {
        
    },
    
    PERSISTENCE_MODE_MODEL: "Model",
    PERSISTENCE_MODE_MODEL_PREFERENCES: "ModelPreferences",
    PERSISTENCE_MODE_DOM: "DOM"
});

com.ibm.mashups.enabler.widget.Constants = new com.ibm.mm.enabler.widget.Constants();

}

if(!dojo._hasResource["com.ibm.mashups.enabler.widget.Constants"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.enabler.widget.Constants"] = true;
dojo.provide("com.ibm.mashups.enabler.widget.Constants");

/**
 * Constants for the widget model.
 * @ibm-api
 * @ibm-module iWidget2
 * @since 2.4
 */




}

if(!dojo._hasResource["com.ibm.mashups.iwidget.Constants"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.iwidget.Constants"] = true;
dojo.provide("com.ibm.mashups.iwidget.Constants");

/**
 * com.ibm.mashups.iwidget.Constants defines all the public iwidget framework constants.<br/>
 * Each constants should be referred to as : com.ibm.mashups.iwidget.Constants.WIDGET_LOADED...
 * @ibm-module iWidget2
 */

dojo.declare("com.ibm.mashups.iwidget.Constants", null, {

   /**
	*  Enabler would publish WIDGET_LOADED event when an iwidget is loaded. <br/>
  	* <b>Event</b>: com.ibm.mashups.iwidget.Constants.WIDGET_LOADED<br/>
	* <b>Value</b>:"com.ibm.mashups.iwidget.widgetloaded"<br/>
	* <b>Payload</b>: String -- widgetid<br/>
	* For example: 
	* When event is published, a name convention is use: com.ibm.mashups.iwidget.Constants.WIDGET_LOADED+"."+widgetId
	* An widget could subscribe to this event by using following SPI:
	* var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
	* eventService.subscribeEvent(com.ibm.mashups.iwidget.Constants.WIDGET_LOADED+"."+widgetId,scopeobject,"mycallbackfn");
	* @type String
	* @ibm-spi
	*/ 
	WIDGET_LOADED: "com.ibm.mashups.iwidget.widgetloaded",	
	
  /**
    *  Enabler would subscribe this event and page components could publish RESIZE_WIDGET event to indicate an iwidget need to be resized.<br/>
    *  When event is published, a name convention is used: com.ibm.mashups.iwidget.Constants.RESIZE_WIDGET+"."+widgetId
	*  Page component should publish event by using following SPI:
	*  var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
	*  eventService.publishEvent(com.ibm.mashups.iwidget.Constants.RESIZE_WIDGET+"."+widgetId,payload);
	* <b>Event</b>: com.ibm.mashups.iwidget.Constants.RESIZE_WIDGET<br/>
	* <b>Value</b>:"com.ibm.mashups.iwidget.resizewidget"<br/>
	* <b>Payload</b>: JSON object: {"newWidth": "","newHeight": ""}<br/>
	* @type String
	* @ibm-spi
	*/
   	RESIZE_WIDGET: "com.ibm.mashups.iwidget.resizewidget",  


  /**
    *  Enabler would subscribe this event and page components could publish UNLOAD_WIDGETS event to unload certain widgets.<br/>
    *  For example: layout widget could publish this event to unload all the widgets on the page upon page switch<br/>
    *  When all the requested iwidgets are unloaded, enabler would publish event --com.ibm.mashups.iwidget.Constants.WIDGETS_UNLOADED <br/>
	* <b>Event</b>: com.ibm.mashups.iwidget.Constants.UNLOAD_WIDGETS<br/>
	* <b>Value</b>:"com.ibm.mashups.iwidget.unloadwidgets"<br/>
	* <b>Payload</b>: an array of widget id that need to be unloaded<br/>
	* @type String
	* @ibm-spi
	*/
   	UNLOAD_WIDGETS: "com.ibm.mashups.iwidget.unloadwidgets",  

  /**
    *  Enabler would publish WIDGETS_UNLOADED event when requested iwidgets are  unloaded. This event is used together with com.ibm.mashups.iwidget.Constants.UNLOAD_WIDGETS.<br/>
    * <b>Event</b>: com.ibm.mashups.iwidget.Constants.WIDGETS_UNLOADED<br/>
    * <b>Value</b>:"com.ibm.mashups.iwidget.widgetsunloaded"<br/>
    * <b>Payload</b>: an array of widget id that are unloaded<br/>
    * @type String
    * @ibm-spi
    */   
	WIDGETS_UNLOADED: "com.ibm.mashups.iwidget.widgetsunloaded", 
 /**
    *  Enabler would publish WIDGET_MODECHANGED event when requested iwidget has switched from one mode to another mode. <br/>
    * <b>Event</b>: com.ibm.mashups.iwidget.Constants.WIDGET_MODECHANGED<br/>
    * <b>Value</b>:"com.ibm.mashups.iwidget.widgetmodechanged"<br/>
    * <b>Payload</b>: JSON object: {id:"",oldMode:"",newMode:""}<br/>
    * @type String
    * @ibm-api
    */   
	WIDGET_MODECHANGED: "com.ibm.mashups.iwidget.widgetmodechanged",
	/**
	*  Enabler would subscribe this event and page components could publish CHANGE_WIDGETMODE event to change a mode of a widget.<br/>
	*  Page components should publish event as follows:	
	*  var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
	*  eventService.publishEvent(com.ibm.mashups.iwidget.Constants.CHANGE_WIDGETMODE,payload);
	*  following api is deprecated:
	*  com.ibm.mashups.services.ServiceManager.getService("eventService").fireEvent(this.iwidgetId, "onModeChanged", {
    *        newMode: mode,
    *        rootElementId: <DOMNode>
    *    });
	*  <b>Event</b>: com.ibm.mashups.iwidget.Constants.CHANGE_WIDGETMODE<br/>
    * <b>Value</b>:"com.ibm.mashups.iwidget.changeWidgetMode"<br/>
    * <b>Payload</b>: JSON object: {id:"",newMode:"",parentNode:<DOMNode>}<br/>
    * @type String
    * @ibm-api
    */   
	CHANGE_WIDGETMODE: "com.ibm.mashups.iwidget.changewidgetmode",
	/**
    *  Enabler would subscribe WIDGET_WINDOWSTATECHANGED event when iwidget has been switched from one window state to another another. <br/>
    * <b>Event</b>: com.ibm.mashups.iwidget.Constants.WIDGET_WINDOWSTATECHANGED<br/>
    * <b>Value</b>:"com.ibm.mashups.iwidget.widgetwindowstatechanged"<br/>
    * <b>Payload</b>: JSON object: {id:"",oldWindowState:"",newWindowState:""}<br/>
    * @type String
    * @ibm-api
    */   
	WIDGET_WINDOWSTATECHANGED: "com.ibm.mashups.iwidget.widgetwindowstatechanged",
	/**
	*  Enabler would publish this event when widget is tried to change window state.<br/>
	*  <b>Event</b>: com.ibm.mashups.iwidget.Constants.CHANGE_WIDGETWINDOWSTATE<br/>
    * <b>Value</b>:"com.ibm.mashups.iwidget.changeWidgetWindowState"<br/>
    * <b>Payload</b>: JSON object: {id:"",newWindowState:"",oldWindowState:""}<br/>
    * @type String
    * @ibm-api
    */   
	CHANGE_WIDGETWINDOWSTATE: "com.ibm.mashups.iwidget.changewidgetwindowstate",
  /**
   * Event that will be published when navigation state is committed.
   * <b>Event</b>: com.ibm.mashups.iwidget.Constants.NAVSTATE_UPDATED<br/>
   * <b>Value</b>:"com.ibm.mashups.enabler.model.state.onNavStateUpdated"<br/>
   * For example: <br/>
   * An widget could subscribe to this event by using following SPI:<br/>
   * var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");<br/>
   * eventService.subscribeEvent("com.ibm.mashups.enabler.model.state.onNavStateUpdated",scope,"mycallbackfn");<br/>
   * In the callback function, an widget should use Accessor api to get the navstate they're interested </br>
   * Following example use PageAccessor as an example<br/>
   * 	var pageAccessor = com.ibm.mashups.enabler.model.state.AccessorFactory.getPageAccessor(navigationStateModel);<br/>
   *	var pageId = pageAccessor.getPageID();		<br/> 
   * @type String
   */
	NAVSTATE_UPDATED:"com.ibm.mashups.enabler.model.state.onNavStateUpdated"
 
});

com.ibm.mashups.iwidget.Constants = new com.ibm.mashups.iwidget.Constants();

}

if(!dojo._hasResource["com.ibm.mashups.iwidget.IEvent_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.iwidget.IEvent_API"] = true;
dojo.provide("com.ibm.mashups.iwidget.IEvent_API");
dojo.provide("com.ibm.mashups.iwidget.IEvent");

/**
 * it carries various pieces of information when an event flows at runtime
 *
 * @ibm-api
 * @ibm-module iWidget2
 */
dojo.declare("com.ibm.mashups.iwidget.IEvent", null, {
    constructor: function() {
        /**
         * @private
         */
    },
    /**
     The name of the event.
     @type String
     */
    name:/*String*/ "",
    /**
     The type of any payload. If this is set to null, no information is being provided.
     @type String
     */
    type:/*String*/ "",
    /**
     The data, if any, being provided by the source of the event.
     @type Object
     */
    payload:/*object*/ null,
    /**
     The iWidget supplied id for the source iWidget.
     @type String
     */
    source:/*String*/ ""
});


}

if(!dojo._hasResource["com.ibm.mm.iwidget.IEventImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.iwidget.IEventImpl"] = true;
dojo.provide("com.ibm.mm.iwidget.IEventImpl");



dojo.declare("com.ibm.mm.iwidget.IEventImpl", com.ibm.mashups.iwidget.IEvent, {

    constructor: function(/*String*/name,/*String*/ type,/*Object*/ payload,/*String*/ source) {
        this.name = name;
        
        if (typeof type != "undefined") { 
            this.type = type;
        }
        else { 
            this.type = null;
        }
        
        if (typeof payload != "undefined") { 
            this.payload = payload;
        }
        else { 
            this.payload = null;
        }
        
        if (typeof source != "undefined") { 
            this.source = source;
        }
        else { 
            this.source = null;
        }
        this.source = source;
    }
});

}

if(!dojo._hasResource["com.ibm.mashups.iwidget.IEvent"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.iwidget.IEvent"] = true;
dojo.provide("com.ibm.mashups.iwidget.IEvent");





}

if(!dojo._hasResource["com.ibm.mashups.iwidget.IEventDescription_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.iwidget.IEventDescription_API"] = true;
dojo.provide("com.ibm.mashups.iwidget.IEventDescription_API");
dojo.provide("com.ibm.mashups.iwidget.IEventDescription");

/**
 * It contains various pieces of information describing an event.
 *
 * @ibm-api
 * @ibm-module iWidget2
 */
dojo.declare("com.ibm.mashups.iwidget.IEventDescription", null, {


    constructor: function() {
        /**
         * @private
         */
    },
	/**
     The alias of the event.
     @type String
     */
    alias:/*String*/ "",
    /**
     The name of the event.
     @type String
     */
    name:/*String*/ "",
    /**
     The type of any payload. If this is set to null, no information is being provided.
     @type String
     */
    type:/*String*/ "",
    /**
     This provides the name of a callback function with the following signature and no return value.
     &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<code>   function(ievent) </code>
     @type String
     */
    handlingFn:/*String*/ "",
    /**
     it returns a user-oriented description (markup allowed) of the event in the requested locale. If no locale is supplied, the default locale of the iWidget is used (with "en" being the default iWidget locale). The description is likely to be displayed when a user is wiring event flow between iWidgets.
     @param{String} locale  required locale. Can be NULL. If no locale is supplied, the default locale of the iWidget is used (with "en" being the default iWidget locale).
     @type String
     @returns{String}  Return the description of a given locale,if no locale is provided, then the default locale of the iWidget is used.
     @deprecated please use getAttribute("description",locale) instead
     @since Deprecated since Version 2.0
     */
    getDescription: function(/*String*/locale) {
        return null;
    },
    /**
     This provides the default language of all the localized attributes within this event description.
     @type String
     */
    lang:/*String*/ "",
    /**
     This indicates if an event is a handled event or not. Default value is false.
     @type Boolean
     */
    isHandled: false,
    /**
     This indicates if an event is a published event or not. Default value is false.
     @type Boolean
     */
    isPublished: false,
    /**
     This method returns the asking value of an attribute of the event description. Each event description should have title and description . Normally title and description should be globalized, default locale should be specified by using the iso language code, if missing, the value for the default locale will be en. <br/>
     @param{String} attributeName  name of attribute. Can  Not be NULL.
     @param{String} locale  required locale. Can be NULL. If no locale is supplied, the default locale of the iWidget is used (with "en" being the default iWidget locale).
     @type String
     @returns{String}  Return the value of the required attribute,if locale is provided, it returns locale specific value.
     */
    getAttribute: function(/*String*/attributeName,/*String*/ locale) {
        return null;
    },
    /**
     The method set the value for a given event description attribute.It returns a handle of this eventdescription, return null upon failure. If the locale parameter is absent, then the given attribute won't be locale specific.
     @param{String} attributeName  name of attribute. Can  Not be NULL.
     @param{String} attributeValue  value of attribute. Can  Not be NULL.
     @param{String} locale  optional, locale. Can be NULL.
     @type com.ibm.mashups.iwidget.IEventDescription
     @returns{com.ibm.mashups.iwidget.IEventDescription}  return a handle of this eventdescription, return null upon failure..
     */
    setAttribute: function(/*String*/attributeName, /* String*/ attributeValue, /*String*/ locale) {
    }
});

}

if(!dojo._hasResource["com.ibm.mm.iwidget.IEventDescriptionImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.iwidget.IEventDescriptionImpl"] = true;
dojo.provide("com.ibm.mm.iwidget.IEventDescriptionImpl");





dojo.declare("com.ibm.mm.iwidget.IEventDescriptionImpl", com.ibm.mashups.iwidget.IEventDescription, {

    constructor: function(/*String*/name,/*function*/ handlingFn,/*String*/ type,/*String*/ description,/*String[]*/ aliases, defaultLang,/*[]*/ descriptions) {
        if (dojo.isString(name)) {
            /*backward compatibility, some widget are still trying to create iEventDescription by using this constuctor as is!*/
            var obj = {};
            obj.name = name;
            handlingFn = handlingFn || null;
            if (handlingFn) {
                obj.handlingFn = handlingFn;
                obj.isHandled = true;
                obj.isPublished = false; //backward compatibility either isPublished or isHandled
            }
            else {
                obj.isPublished = true;
            }
            type = type || null;
            if (type) {
                obj.type = type;
            }
            defaultLang = defaultLang || null;
            if (defaultLang) {
                obj.lang = defaultLang;
            }
            else {
                obj.lang = "en";
            }
            //how to set isPublished? or set it later
            obj.attributes = {};
            obj.localizedAttributes = {};
            aliases = aliases || null;
            if (aliases) {
                obj.attributes.aliases = aliases;
            }
            descriptions = descriptions || null;
            if (descriptions) {
                obj.localizedAttributes = descriptions;
            }
            //backward compatibility
            if (description) {
                if (!obj.localizedAttributes[obj.lang]) {
                    obj.localizedAttributes[obj.lang] = {};
                }
                obj.localizedAttributes[obj.lang].description = description;
            }
            
            this._internalJsonObj = obj;
        }
        else {
            this._internalJsonObj = name;
        }
        this.initPredefinedFields(this._internalJsonObj);
    },
    initPredefinedFields: function(obj) {
        //initialize  fields
        this.name = obj.name;
        this.type = obj.type;
        this.lang = obj.lang;
        this.handlingFn = obj.handlingFn;
        
        this.isHandled = obj.isHandled;
        this.isPublished = obj.isPublished;
        
//        if (this.handlingFn) {
//            this.isHandled = true;
//        }
//        else {
//            this.isHandled = false;
//        }
//        // set isPublished to true only when both isHandled and isPublished is not defined 
//        // this is required for backward compatiblity reason
//        if ((obj.isPublished && obj.isPublished == "true") || obj.isPublished) {
//            this.isPublished = true;
//        }
    },
    getDescription: function(locale) {
        return this._getLocalizedAttribute("description", locale);
    },
    getTitle: function(locale) {
        return this._getLocalizedAttribute("title", locale);
    },
    _getLocalizedAttribute: function(attributeName, locale) {
        var attValue = null, altAttValue = null;
        var lc = com.ibm.mashups.enabler.context.Factory.getLocalizedContext(locale, this.lang);
        var finalLocale = lc.getLocale(this);
        if (this.localemapping && this.localemapping[finalLocale]) {
            finalLocale = this.localemapping[finalLocale];
        }
        if (this._internalJsonObj.localizedAttributes) {
            altAttValue = this._internalJsonObj.localizedAttributes[finalLocale];
            if (altAttValue) {
                attValue = altAttValue[attributeName];
            }
        }
        if (!attValue) {
            attValue = this[attributeName];
        }
        
        if (typeof attValue == "undefined") {
            attValue = null;
        }
        return attValue;
    },
    setOnRemoveWire: function(/*String*/handler) {
        if (typeof handler == "undefined" || handler === null) {
            handler = "onRemoveWire";
        }
        //this.onRemoveWire = handler;    
        if (typeof this._internalJsonObj.attributes == "undefined") {
            this._internalJsonObj.attributes = {};
        }
        this._internalJsonObj.attributes.onRemoveWire = handler;
        return this;
    },
    getOnRemoveWire: function() {
        //can remove?
        if (typeof this._internalJsonObj.attributes != "undefined" && this._internalJsonObj.attributes.onRemoveWire) {
            return this._internalJsonObj.attributes.onRemoveWire;
        }
        return null;
    },
    setOnNewWire: function(/*String*/handler) {
        if (typeof handler == "undefined" || handler === null) {
            handler = "onNewWire";
        }
        //this.onNewWire = handler;  
        if (typeof this._internalJsonObj.attributes == "undefined") {
            this._internalJsonObj.attributes = {};
        }
        this._internalJsonObj.attributes.onNewWire = handler;
        return this;
    },
    getOnNewWire: function() {
        if (typeof this._internalJsonObj.attributes != "undefined" && this._internalJsonObj.attributes.onNewWire) {
            return this._internalJsonObj.attributes.onNewWire;
        }
        return null;
    },
    getLocales: function() {
        var locales = [];
        var mapping = {};
        if (this._internalJsonObj.localizedAttributes) {
            for (var i in this._internalJsonObj.localizedAttributes) {
                if (Object.prototype.hasOwnProperty.call(this._internalJsonObj.localizedAttributes,i)) {
                    locales.push(i);
                    var normalizedLocale = com.ibm.mm.enabler.utils.LocaleHelper.normalizeLocale(i);
                    if (normalizedLocale != i) {
                        mapping[normalizedLocale] = i;
                    }
                }
            }
        }
        this.localemapping = mapping;
        
        return locales;
    },
    toString: function() {
        //return null or unserialized string, dojo will throw exception if it's not a valid Json obj
        var temp = this.toJson();
        return dojo.toJson(temp);
    },
    _getInternalJsonObj: function() {
        return this._internalJsonObj;
    },
    toJson: function() {
        var internalJson = {};
        for (var i in this._internalJsonObj) {
            if (Object.prototype.hasOwnProperty.call(this._internalJsonObj,i)) {
                if (i == "handlingFn") { //it could be functionpointer
                    if (dojo.isFunction(this._internalJsonObj[i])) {
                        internalJson[i] = "HANDLEFN";
                        continue;
                    }
                }
                internalJson[i] = dojo.clone(this._internalJsonObj[i]);
            }
        }
        
        return internalJson;
    },
    clone: function() {
        var temp = dojo.toJson(this._internalJsonObj);
        if (temp) {
            return new com.ibm.mm.iwidget.IEventDescriptionImpl(dojo.fromJson(temp));
        }
        else {
            return null;
        }
    },
    getAttribute: function(attName, locale) {
        if (!attName) {
            return null;
        }
        if (!locale) {
            if (this._internalJsonObj.attributes && typeof this._internalJsonObj.attributes[attName] != "undefined") {
                return this._internalJsonObj.attributes[attName];
            }
            //get value for default locale
            if (this._internalJsonObj.localizedAttributes && this._internalJsonObj.localizedAttributes[this.lang]) {
                var attValue = this._internalJsonObj.localizedAttributes[this.lang][attName];
                if (attValue) {
                    return attValue;
                }
            }
            return null; //if no such attributes or localized attributes
        }
        else {
            return this._getLocalizedAttribute(attName, locale);
        }
    },
    setAttribute: function(attName, attValue, locale) {
        //todo; if no locale defined and attributes is predefined such as "title","description", set the value on default locale
        //return a handle of this eventdescription, return null upon failure.
        if (!attName) {
            return null;
        }
        if (typeof attValue == "undefined") {
            return null; // allow value to be null
        }
        if (!locale) {
            if (typeof this._internalJsonObj.attributes == "undefined") {
                this._internalJsonObj.attributes = {};
            }
            this._internalJsonObj.attributes[attName] = attValue;
            if (attValue === null) {
                delete this._internalJsonObj.attributes[attName];
            }
            return this;
        }
        if (!this._internalJsonObj.localizedAttributes[locale]) {
            this._internalJsonObj.localizedAttributes[locale] = {};
        }
        this._internalJsonObj.localizedAttributes[locale][attName] = attValue;
        if (attValue === null) {
            delete this._internalJsonObj.localizedAttributes[locale][attName];
        }
        return this;
    },
    copyRuntimeProperties: function(eventDesc2Copy) {
        if ((!this.handlingFn) && (eventDesc2Copy.handlingFn)) {
            this.handlingFn = eventDesc2Copy.handlingFn;
        }
        if ((!this._internalJsonObj.handlingFn) && (eventDesc2Copy._internalJsonObj.handlingFn)) {
            this._internalJsonObj.handlingFn = eventDesc2Copy._internalJsonObj.handlingFn;
        }
        if (typeof this._internalJsonObj.attributes == "undefined") {
            this._internalJsonObj.attributes = {};
        }
        for (name in eventDesc2Copy._internalJsonObj.attributes) {
            if (!this._internalJsonObj.attributes[name]) {
                this._internalJsonObj.attributes[name] = eventDesc2Copy._internalJsonObj.attributes[name];
            }
        }
    }
});

}

if(!dojo._hasResource["com.ibm.mashups.iwidget.IEventDescription"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.iwidget.IEventDescription"] = true;
dojo.provide("com.ibm.mashups.iwidget.IEventDescription");




}

if(!dojo._hasResource["com.ibm.mashups.iwidget.iEvents_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.iwidget.iEvents_API"] = true;
dojo.provide("com.ibm.mashups.iwidget.iEvents_API");
dojo.provide("com.ibm.mashups.iwidget.iEvents");

/**
 * This interface defines methods that's  used for event distribution and event management. Events service is accessible by using <b>"this.iContext"</b><p/>
 *  &nbsp;&nbsp;&nbsp; <code>this.iContext.iEvents</code><p/> 
 *  To distribute an event:<p/>
 *  &nbsp;&nbsp;&nbsp; <code>this.iContext.iEvents.fireEvent("eventName");</code><p/>   
 *
 * @ibm-api
 * @ibm-module iWidget2
 */
dojo.declare("com.ibm.mashups.iwidget.iEvents",null,
{	/**
            * @private
            */
    constructor:function () {
 
    },
/**
This method informs the iContext to distribute an event with proper payload and payload type
@param{String} eventName name of the event that needs to be distributed.Must not be <code>null</code>.
@param{String} payloadType optional,type of the payload.
@param{object} payload optional,object of the payload that needs to be distributed together with the event     
@type void
*/	
    fireEvent:function(/*String*/eventName,/*String*/payloadType,/*object*/payload){
    },
/**
This method simply creates a new event definition or updates an existing event if the name already exists. <br/>
It returns true if new event is created successfully or existing event is updated successfully. It returns false if it fails to create new event or update existing event.<br/>
@param{com.ibm.mashups.iwidget.IEventDescription} eventDesc IEventDescription object. Must not be <code>null</code>.
@type Boolean
@returns{Boolean} returns true if new event is created successfully or existing event is updated successfully. It returns false if it fails to create new event or update existing event.
*/	
    setEvent:function(/* iEventDescription*/ eventDesc){
	},
/**
Using this method will potentially allow optimizations to occur within the iContext. The returned boolean <br/>
indicates whether or not the request added all the described events to the iwidgets. <br/>
@param{com.ibm.mashups.iwidget.IEventDescription[]} eventDesc  array of IEventDescription object. Must not be <code>null</code>.
@type Boolean
@returns{Boolean} returns true if all the events are created successfully or existing events are updated successfully. It returns false if not all events are processed successfully.
*/	
    setEvents:function(/* iEventDescription[]*/ eventDescs){
	},
/**
This method removes an existing event description.It returns true if event is removed successfully or event doesn't exist, otherwise it returns false. <br/>
@param{String} eventName event name. Must not be <code>null</code>.
@type Boolean
@returns{Boolean} returns true if event is removed successfully or event doesn't exist, otherwise it returns false. 
*/
   removeEvent:function(/*String*/ eventName){
   },
/**
This method removes specified events.It returns true if all the events are removed successfully , otherwise it returns false. <br/>
@param{String[]} eventName event name. Must not be <code>null</code>.
@type Boolean
@returns{Boolean} returns true if all the events are removed successfully, otherwise it returns false. 
*/
   removeEvents:function(/*String[]*/ eventNames){
   },   
/**
The query method which takes a javascript object as condition, it returns a list of event descriptions which matches the given condition. <br/>
The scope of the events is limited to this iwidget instance. The returning result need to match all the conditions that's given. <br/>
For exampe, if a condition object looks like this: {type:'text', isHandled:true}<br/>
This method will return all the handled event description whose payload is text.<br/>
If no condition is provided, this method will return all the events. It returns null if no event is found for a given condition.Only predefined fields or non localized attributes should be used to define condition.
@param{Object} condition  JSON object that contains the condition. Must not be <code>null</code>.
@type com.ibm.mashups.iwidget.IEventDescription
@returns{com.ibm.mashups.iwidget.IEventDescription} returns an array of event description that matches the condition. It returns null if no event is found for a given condition. 
*/
   getEvents:function(/*Object*/ condition){
   },   
/**
This method allows to create a new IEventDescription object. All the data should be passed in as a JSON object.<br/>
Following rules applied to the JSON object:<br/>
1. Predefined fields: name,type,isHandled,isPublished,lang,handlingFn<br/>
2. Localized attributes: please see sample below<br/>
3. Non-localized attributes: please see sample below<br/>
4. Lotus Mashups provides a feature to allow a widget to register a private event so this event will not be exposed to other iwidgets by the wiring interface<br/>
&nbsp;&nbsp;&nbsp;private attribute is used to mark an event to be a private event. please see sample below<br/>
<code>
 &nbsp;&nbsp;&nbsp;var obj = {name:"sendData",  type:"text", isHandled:"true", lang:"en", handlingFn:"onSendData", <br/>
 &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;localizedAttributes:{  <br/>
  &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;"en":{"title":"mytitle_en","description":"mydescription_en"},<br/>
  &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;"fr":{"title":"mytitle_fr","description":"mydescription_fr"}  <br/>
  &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;} ,      <br/>
  &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;attributes:{  namespace:"com.ibm.mashups", onRemoveWire:"handleRemoveWire",private:"true"} <br/>
 &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;  };<br/>
 &nbsp;&nbsp;&nbsp;var event = this.iContext.iEvents.createEventDescription(obj);<br/>
 &nbsp;&nbsp;&nbsp;this.iContext.iEvents.setEvent(event);<br/>
</code>
@param{Object} object  JSON object that contains all the data to create an IEventDescription. Must not be <code>null</code>.
@type com.ibm.mashups.iwidget.IEventDescription
@returns{com.ibm.mashups.iwidget.IEventDescription} returns an  IEventDescription . It returns null if it fail to create the iEventDescription. 
*/ 
  createEventDescription:function(/* Object */object){
  }
	
});

}

if(!dojo._hasResource["com.ibm.mm.iwidget.icontext.IContextIEventsImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.iwidget.icontext.IContextIEventsImpl"] = true;
dojo.provide("com.ibm.mm.iwidget.icontext.IContextIEventsImpl");






dojo.declare("com.ibm.mm.iwidget.icontext.IContextIEventsImpl", com.ibm.mashups.iwidget.iEvents, {
    constructor: function(wrapper) {
        this.widget = wrapper;
        this.id = wrapper.id;
        this.svc = com.ibm.mashups.services.ServiceManager.getService("eventService");
		this.timer = null;
		this.timerEventQ = [];
		this.allTargetWidgetsLoaded = false;
	      
		this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass);
		this.LOG_LEVEL=com.ibm.mashups.enabler.logging.LogLevel.TRACE;
		this.bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);      
    },
    createEventDescription: function(/*json*/object) {
        return new com.ibm.mm.iwidget.IEventDescriptionImpl(object);
    },
    getEvents: function(condition) {
        //always return a data copy of each iEventDescription
        //return null if no events is found		
        var eventModel = this.widget._getPublicEvents(); //get the internal eventModel
        var events = eventModel.getEvents(condition);
        //now build a copy of iEventDescription
        if (!events) {
            return null;
        }
        var arr = [];
        for (var i in events) {
            if (Object.prototype.hasOwnProperty.call(events,i)) {
                arr.push(events[i].clone());
            }
        }
        return arr;
    },
    setEvent: function(eventDesc) {
        //create/update event
        //return true if event is successful
        
        // verify first whether the event is the same and no update is required
        var eventModel = this.widget._getPublicEvents(); //get the internal eventModel
        var rc = eventModel.eventExists(eventDesc.name);
        var updateRequired = false;
        if (rc) {
            updateRequired = eventModel.isUpdateEventRequired(eventDesc);
        }
        else {
            updateRequired = true;
        }
        if (updateRequired) {
            var cs = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.iwidget.services.ContainerService.SERVICE_NAME);
            if (cs) {
                cs.switchToModifiablePersistenceMode(com.ibm.mashups.iwidget.services.ContainerService.PROVIDER_EVENTS); 
            }
        }

        eventModel = this.widget._getPublicEvents(); //get the internal eventModel
        rc = eventModel.eventExists(eventDesc.name);
        if (rc) {
            if (this.widget._inIframe()) {
                this.svc._publishEvent(this.svc.WIDGETEVENT_PREFIX + "_stub_" + this.id, {
                    "scope": "eventmodel",
                    "methodname": "updateEvent",
                    "params": [eventDesc.toJson()]
                }, this.id);
            }
            rc = eventModel.updateEvent(eventDesc);
        }
        else {
            if (this.widget._inIframe()) {
                this.svc._publishEvent(this.svc.WIDGETEVENT_PREFIX + "_stub_" + this.id, {
                    "scope": "eventmodel",
                    "methodname": "createEvent",
                    "params": [eventDesc.toJson()] //turn iEventDescription into an json object 
                }, this.id);
            }
            rc = eventModel.createEvent(eventDesc);
        }
        return rc;
    },
    removeEvent: function(eventName) {
        var cs = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.iwidget.services.ContainerService.SERVICE_NAME);
        if (cs) {
            cs.switchToModifiablePersistenceMode(com.ibm.mashups.iwidget.services.ContainerService.PROVIDER_EVENTS); 
        }

        //remove event
        //return true upon successful, if event doesn't exist or for other reason event can't be deleted, return false;
        if (this.widget._inIframe()) {
            this.svc._publishEvent(this.svc.WIDGETEVENT_PREFIX + "_stub_" + this.id, {
                "scope": "eventmodel",
                "methodname": "removeEvent",
                "params": [eventName]
            }, this.id);
        }
        var eventModel = this.widget._getPublicEvents(); //get the internal eventModel
        var rc = eventModel.removeEvent(eventName);
        return rc;
    },
    publishEvent: function(/*String*/eventName, payload, payloadType) {
        //internal, deprecated, todo remove
        return this.fireEvent(eventName, payloadType, payload);
    },
    fireEvent: function(/*String*/eventName, payloadType, payload) {
        var LOG_METHOD = "fireEvent(eventName, payloadType, payload)";
        if (this.bIsLoggable) {
            this.LOGGER.entering(LOG_METHOD, [eventName, payloadType, payload]);
        }
        // 18152: Make sure all target widgets are loaded before firing event. Since wires are stored with the
        // target widgets, the source widget could fireEvent before the target widgets, and therefore the wires,
        // are loaded. By waiting until the target widgets are loaded, we ensure the needed wires are loaded.
        if (this.allTargetWidgetsLoaded) {
        	this._fireEventFinish(eventName,payloadType,payload);
        } else {
        	// Multiple fireEvents could come in while the asynchronous this.timer is processing, so queue up all
        	// fireEvents that come in so they can all get processed in _fireEventContinue in the order received.
        	this.timerEventQ.push({"eventName":eventName,"payloadType":payloadType,"payload":payload});
        	if (!this.timer) {
        		var widgetModel = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel();
	            var all_wires = dojo.query("."+this.widget.ns+"ReceivedEvent", this.widget.rootElement);
	            var target_widgets = [];
	            for (var i = 0; i < all_wires.length; i++) {
	            	var sourceEvent = dojo.query("."+this.widget.ns+"SourceEvent", all_wires[i])[0];
	            	if (sourceEvent) {
	            		var href = sourceEvent.getAttribute("href");
	            		if (href.indexOf(this.widget.id) != -1) {
	            			var target_widget = widgetModel.find(all_wires[i].parentNode.id);
	            			if (target_widget) {
	            				target_widgets.push(target_widget);
	            			}
	            		}
	            	}
	            }
	            this.timer_tries = 0;
	            this.timer = setInterval(dojo.hitch(this, "_fireEventContinue", target_widgets), 5);
        	}
        }
        if (this.bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD);
        }
     },
     _fireEventContinue:function(target_widgets){
        var LOG_METHOD = "_fireEventContinue(target_widgets)";
        if (this.bIsLoggable) {
        	this.LOGGER.entering(LOG_METHOD, [target_widgets]);
        }
        for (var i = 0; i < target_widgets.length; i++) {
        	if (!target_widgets[i].isLoaded() && (this.timer_tries < 20)) {  // should never reach 20, but just in case
        		this.timer_tries++;
        		if (this.bIsLoggable) {
        			this.LOGGER.trace(LOG_METHOD, "Not all target widgets are loaded, retry " + this.timer_tries);
        		}
        		if (this.bIsLoggable) {
        			this.LOGGER.exiting(LOG_METHOD);
        		}
        		return;
        	}
        }
        clearInterval(this.timer);
        this.timer_tries = 0;
        while (this.timerEventQ.length > 0) {
        	var event = this.timerEventQ.shift(); // first in, first out
        	this._fireEventFinish(event.eventName,event.payloadType,event.payload);
        }
        this.allTargetWidgetsLoaded = true;
        this.timer = null;
        if (this.bIsLoggable) {
            this.LOGGER.exiting(LOG_METHOD);
        }
     },       
      _fireEventFinish:function(/*String*/eventName,payloadType,payload){
    	 var LOG_METHOD = "_fireEventFinish(eventName, payloadType, payload)";
    	 if (this.bIsLoggable) {
    		 this.LOGGER.entering(LOG_METHOD, [eventName, payloadType, payload]);
    	 }
        //event description here...
        var eventModel = this.widget._getPublicEvents();
        //var isHandled = widgetWrapper.handleEvent(eventName,aEvent);
        //handle internally only if it's not a handled event
        var isHandledEvent = false;
        var temp;
        if (eventModel) {
            temp = eventModel.find(eventName);
            //assign payload type
            if (temp) {
                payloadType = temp.type;
            }
            if (temp && temp.handlingFn) {
                isHandledEvent = true;
            }
        }
        var aEvent = new com.ibm.mm.iwidget.IEventImpl(eventName, payloadType, payload, null);
        if (!isHandledEvent) {
            this.widget.handleEvent(aEvent);
        }
        
        //publish wire if it's a published event
        if (eventModel) {
            temp = eventModel.find(eventName);
            if (temp && temp.isPublished) {
                this.svc.publishWire(this.id, eventName, payload, payloadType);
            }
        }
        if (this.bIsLoggable) {
        	this.LOGGER.exiting(LOG_METHOD);
        }
    },
    setEvents: function(eventDescs) {
        var eventModel = this.widget._getPublicEvents();
        if (this.widget._inIframe()) {
            var arr = [];
            for (var i = 0; i < eventDescs.length; i++) {
                arr.push(eventDescs[i].toJson());
            }
            this.svc._publishEvent(this.svc.WIDGETEVENT_PREFIX + "_stub_" + this.id, {
                "scope": "eventmodel",
                "methodname": "setEvents",
                "params": [arr]
            }, this.id);
        }
        rc = eventModel.setEvents(eventDescs);
        return rc;
    },
    removeEvents: function(eventNames) {
        //remove event
        //return true upon successful, if event doesn't exist or for other reason event can't be deleted, return false;
        if (this.widget._inIframe()) {
            this.svc._publishEvent(this.svc.WIDGETEVENT_PREFIX + "_stub_" + this.id, {
                "scope": "eventmodel",
                "methodname": "removeEvents",
                "params": [eventNames]
            }, this.id);
        }
        var eventModel = this.widget._getPublicEvents(); //get the internal eventModel
        var rc = eventModel.removeEvents(eventNames);
        return rc;
    }
});


}

if(!dojo._hasResource["com.ibm.mashups.iwidget.iEvents"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.iwidget.iEvents"] = true;
dojo.provide("com.ibm.mashups.iwidget.iEvents");





}

if(!dojo._hasResource["com.ibm.mashups.iwidget.io_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.iwidget.io_API"] = true;
dojo.provide("com.ibm.mashups.iwidget.io_API");
dojo.provide("com.ibm.mashups.iwidget.io");

/**
 * This interface defines support the iContext is supplying regarding IO operations.<p/>
 *  &nbsp;&nbsp;&nbsp; <code>this.iContext.io.rewriteURI(aUri);</code><p/>
 *
 * @ibm-api
 * @ibm-module iWidget2
 */
dojo.declare("com.ibm.mashups.iwidget.io", null, {
    /**
     * @private
     */
    constructor: function() {
    
    },
    /**
     This object wraps the native XMLHttpRequest support to provide a consistent page in the face of asynchronous updates, especially those which may cause server-side coordination between the server-side components related to multiple iWidgets on the page.
     @type XMLHttpRequest
     @returns{XMLHttpRequest} returns  native XMLHttpRequest object.
     */
    XMLHttpRequest: function() {
    },
    
    /**
     This method takes a URI as a parameter and returns a URI which the browser can resolve for accessing the supplied URI.
     Examples of usage include resolving a relative URI against the source of the iWidget's definition and resolving other URIs to address any intermediate
     gateways, such as a proxy server. <p/>
     &nbsp;&nbsp;&nbsp;Sample usage that resolves URI to address a proxy server ,assume url to proxy server is "/mum/proxy".<br/>
     <code>
     &nbsp;&nbsp;&nbsp; var aUri = "http://yourco.com/mytest.js"; <br/>
     &nbsp;&nbsp;&nbsp; var rc = this.iContext.io.rewriteURI(aUri); <br/>
     </code>
     &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;the result will be "/mum/proxy/http/yourco.com/mytest.js"<br/>
     <br/>
     &nbsp;&nbsp;&nbsp;Sample usage that resolves a relative URI against the source of the iWidget's deinfition<br/>
     &nbsp;&nbsp;&nbsp; Assume iwidget is included on a page as follows:<br/>
     <code>
     &nbsp;&nbsp;&nbsp; &lt;span id="yourcoWidget" class="iw-iWidget"&gt;&lt;a class="iw-Definition" href="/mm/widget-catalog/yourcoWidget.xml"&gt;&lt;/a&gt;&lt;/span&gt;<br/><br/>
     &nbsp;&nbsp;&nbsp; var aUri = "mytest.js"; <br/>
     &nbsp;&nbsp;&nbsp; var rc = this.iContext.io.rewriteURI(aUri);  <br/>
     </code>
     &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;the result will be "/mm/widget-catalog/mytest.js" <br/>
     <br/>
     &nbsp;&nbsp;&nbsp;Sample usage that resolves a relative URI against the source of the iWidget's deinfition for an image resource.<br/>
     &nbsp;&nbsp;&nbsp; Assume iwidget is included on a page as follows:<br/>
     <code>
     &nbsp;&nbsp;&nbsp; &lt;span id="yourcoWidget" class="iw-iWidget"&gt;&lt;a class="iw-Definition" href="http://yourco.com/mm/widget-catalog/yourcoWidget.xml"&gt;&lt;/a&gt;&lt;/span&gt;<br/><br/>
     </code>
     &nbsp;&nbsp;&nbsp;the url for the img resource  of following code will be "http://yourco.com/mm/widget-catalog/mytest.gif" <br/>
     <code>
     &nbsp;&nbsp;&nbsp; var aUri = "mytest.gif"; <br/>
     &nbsp;&nbsp;&nbsp; var returnUri = this.iContext.io.rewriteURI(aUri,false);  <br/>
     &nbsp;&nbsp;&nbsp; var img = dojo.byId(id); <br/>
     &nbsp;&nbsp;&nbsp;  img.src = returnUri;<br/>
     </code>
     @param{String} uri URI that needs to be resolved. Must not be <code>null</code>.
     @param{Boolean} isXhr optional,boolean indicating the url is used as xhr. If no value is provided, the default is true.
     @type String
     @returns{String} return a URI which the browser can resolve for accessing the supplied URI. Must not be <code>null</code>.
     */
    rewriteURI: function(/*String*/uri,/*Boolean*/ isXhr) {
        return null;
    },
	/**
     This convenience method creates a new XMLHttpRequest and send the request with all supplied arguments on the XMLHttpRequest. <br/>
     The supported fields within the arguments object include: <br/>
     <code><br/>
     {<br/>
	   &nbsp;&nbsp;&nbsp; "requestVerb": {"get" | "post" | "put" | "delete"}, <br/>
	   &nbsp;&nbsp;&nbsp;"url": {url},<br/>
       &nbsp;&nbsp;&nbsp;"handleAs": {handleAs},<br/>
       &nbsp;&nbsp;&nbsp;"sync": {boolean},<br/>
       &nbsp;&nbsp;&nbsp;"preventCache": {boolean},<br/>
       &nbsp;&nbsp;&nbsp;"content": {content},<br/>
       &nbsp;&nbsp;&nbsp;"headers": {headers},<br/>
       &nbsp;&nbsp;&nbsp;"timeout": {int},<br/>
	   &nbsp;&nbsp;&nbsp;"user": {user},<br/>
       &nbsp;&nbsp;&nbsp;"password": {password},<br/>
       &nbsp;&nbsp;&nbsp;"form": {form},<br/>
       &nbsp;&nbsp;&nbsp;"msgData": {msgData},<br/>
       &nbsp;&nbsp;&nbsp;"load": {load},<br/>
       &nbsp;&nbsp;&nbsp;"error": {error},<br/>
       &nbsp;&nbsp;&nbsp;"handle": {handle}<br/>
	 }<br/>
	 </code><br/>
     @param{Object} args supported properties as listed above.
     @type void
     */
	xhrReq:function(/*Object*/ args){
		return;
	} 

});

}

if(!dojo._hasResource["com.ibm.mm.iwidget.icontext.IContextIOImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.iwidget.icontext.IContextIOImpl"] = true;
dojo.provide("com.ibm.mm.iwidget.icontext.IContextIOImpl");







dojo.declare("com.ibm.mm.iwidget.icontext.IContextIOImpl", com.ibm.mashups.iwidget.io, {
    constructor: function(wrapper) {
        this.id = wrapper.id;
        this.widget = wrapper;        
        
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass);
        this.LOG_LEVEL = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
        this.bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
    },
    XMLHttpRequest: function() {
        return dojo._xhrObj();
    },
    rewriteURI: function(/*String*/uri, isXhr) {
    
        if (this.bIsLoggable) {
            this.LOGGER.entering("com.ibm.mm.iwidget.io.rewriteURI", [uri, isXhr]);
        }
        
        var returnUri = this.widget._rewriteURI(uri, isXhr);
        if (this.bIsLoggable) {
            this.LOGGER.exiting("com.ibm.mm.iwidget.io.rewriteURI", [returnUri]);
        }
        
        return returnUri;
    },
    getWebAppRootPath: function() {
		//not all the widgets has context path, following are the examples:
		//a. "http://host:test/accuweather" --> absolute path
		//b. "/accuweather" --> full path
		if (this.rootPath) {
			return this.rootPath;
		}
	    var rawUri = this.widget.getIWidgetInstance().widgetXMLUrl;
		rawUri = this.widget._getRawBaseUri(rawUri); // resolve end point
		rawUri = this.widget._getResolvedPocUri(rawUri); //resolve Poc Uri
		
		var returnUri = null;
        if (rawUri && rawUri.indexOf("/")===0){
			var temp = rawUri.substring(1);
			if (temp.indexOf("/")>0) {
				returnUri = "/"+temp.substring(0,temp.indexOf("/"));
			}else{
				returnUri = rawUri;
			}
		}
		if (returnUri) {
			this.rootPath = returnUri;
			return returnUri;
		}
        if (rawUri && rawUri.indexOf("://") > 0) {
               var parts = rawUri.split("/");
               if (parts.length >= 4) {
                        returnUri = parts[0] + "//" + parts[2] + "/" + parts[3];
               }              
        }
        if (returnUri) {
			this.rootPath = returnUri;
			return returnUri;
		}
		return null;
    },
    request: function(requestVerb, uri, callbackFn, message,/* [{headerName, value}] */ requestHeader) {
        //Sends an HTTP request with the given method
        //The method argument should be uppercase.
        //sample callback Fn
        /*function callbackFunction(){
         if (this.readyState != 4) return;
         var response = this.responseText;
         }
         */
        var xhr = dojo._xhrObj();
        var realUri = this.rewriteURI(uri);
        
        var async = false;
        if (callbackFn) {
            xhr.onreadystatechange = callbackFn;
            //sets it to asynchronous only if a callbackFn is provided, per xhr spec, user agent should consider default is true if it's omitted
            async = true;
        }
        var method = requestVerb || null;
        if (!requestVerb) {
            method = this.httpmethods.GET;
        }
        if (requestVerb) {
            if (!this.httpmethods[requestVerb]) {
                method = this.httpmethods.GET;
            }
        }
        
        //user/password    xhr.open(method,realUri,async,user,pwd); 
        xhr.open(method, realUri, async);
        //xhr.send(); 
        //console.debug(method + " " + realUri);
        
        var contentType = null;
        var _defaultContentType = "application/x-www-form-urlencoded";
        if (requestHeader) {
            //Authors are strongly encouraged to ensure that they have specified the Content-Type header via setRequestHeader() before invoking send() with a non-null data argument.
            for (var i = 0; i < requestHeader.length; i++) {
                var anItem = requestHeader[i];
                var headerName = anItem[headerName];
                var value = anItem[value];
                if (headerName == "Content-Type") {
                    contentType = value;
                }
                else {
                    xhr.setRequestHeader(headerName, value);
                }
            }
        }
        xhr.setRequestHeader("Content-Type", (contentType || _defaultContentType));
        
        //user/password    xhr.open(method,realUri,async,user,pwd); 
        if (method == this.httpmethods.PUT || method == this.httpmethods.POST) {
            if (message) {
                xhr.send(message);
            }
        }
        else {
            xhr.send(null);
        }
        return xhr;
    },
	xhrReq:function(args){
		if (!args) {
			return;
		}
		if (!args.requestVerb || !args.url || !args.handleAs){ return;}
		
		var requestVerb = args.requestVerb;
		if (requestVerb && !this.requestVerbs[requestVerb]){
			requestVerb = this.requestVerbs.get;
		}
		
		if (requestVerb && requestVerb == this.requestVerbs.get){
			var obj = args;
			delete obj.requestVerb;
			dojo.xhrGet(obj);
			return;
		}
		if (requestVerb && requestVerb == this.requestVerbs.put){
			var obj1 = args;
			delete obj1.requestVerb;
			if (obj1.msgData){
				obj1.putData = obj1.msgData;
				delete obj1.msgData;
			}
			dojo.xhrPut(obj1);
			return;
		}
		if (requestVerb && requestVerb == this.requestVerbs["delete"]){
			var obj2 = args;
			delete obj2.requestVerb;
			dojo.xhrDelete(obj2);
			return;
		}
		if (requestVerb && requestVerb == this.requestVerbs.post){
			var obj3 = args;
			delete obj3.requestVerb;
			if (obj3.msgData){
				obj3.postData = obj3.msgData;
				delete obj3.msgData;
			}
			dojo.xhrPost(obj3);
			return;
		}
		
	},
    httpmethods: {
        GET: "GET",
        PUT: "PUT",
        POST: "POST",
        DELETE: "DELETE"
    },
	requestVerbs:{
		get: "get",
        put: "put",
        post: "post",
        "delete": "delete"
	}
});

}

if(!dojo._hasResource["com.ibm.mashups.iwidget.io"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.iwidget.io"] = true;
dojo.provide("com.ibm.mashups.iwidget.io");





}

if(!dojo._hasResource["com.ibm.mashups.iwidget.iContext_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.iwidget.iContext_API"] = true;
dojo.provide("com.ibm.mashups.iwidget.iContext_API");
dojo.provide("com.ibm.mashups.iwidget.iContext");

/**
 * This interface defines methods that the iWidget can use to interact with the iContext.
 * An iContext instance is created specifically for each iWidget instance and a reference will be set in iWidget encapsulation object.
 * Thus within iWidget encapsulation class, iContext should be referred to by using <b>"this.iContext"</b><p/>
 *  &nbsp;&nbsp;&nbsp; <code>var root = this.iContext.getRootElement();</code><p/>
 *
 * @ibm-api
 */
dojo.declare("com.ibm.mashups.iwidget.iContext", null, {

    /**
     * @private
     */
    constructor: function() {
    },
    /**
     * Defines constants available in iContext.<br/>
     * Constants defined within iContext can be referred as follows:</p>
     *
     *  &nbsp;&nbsp;&nbsp; <code>this.iContext.constants.mode.VIEW</code><br/>
     *  &nbsp;&nbsp;&nbsp; <code>this.iContext.constants.mode.EDIT</code><br/>
     *  &nbsp;&nbsp;&nbsp; <code>this.iContext.constants.mode.PERSONALIZE</code><br/>
     *  &nbsp;&nbsp;&nbsp;<code>this.iContext.constants.mode.HELP</code><br/>
     *  &nbsp;&nbsp;&nbsp;<code>this.iContext.constants.ATTRIBUTES</code><br/>
     *  &nbsp;&nbsp;&nbsp;<code>this.iContext.constants.IDESCRIPTOR</code><br/>
     *  &nbsp;&nbsp;&nbsp;<code>this.iContext.constants.USERPROFILE</code><br/>
     * </code>
     * @type Object
     * @ibm-module iWidget2
     */
    constants: {
        /*@type object*/
        mode: {
            /*@type String*/
            VIEW:/*String*/ "view",//The generated markup fragment(s) should reflect normal interaction with the iWidget
            /*@type String*/
            EDIT:/*String*/ "edit",//The generated markup fragment(s) should reflect iWidget interactions for editing iWidget attributes scoped to this instance of iwidget, but applicable to all users
            /*@type String*/
            PERSONALIZE:/*String*/ "personalize",//The generated markup fragment(s) should reflect iWidget interactions for personalizing iwidget attributes scoped to this instance on the iWidget for this user
            /*@type String*/
            CONFIG:/*String*/ "config",//The generated markup fragment(s) should reflect iWidget interactions for editing iwidget attributes scoped to all instances of the iWidget for all users		   
            /*@type String*/
            HELP:/*String*/ "help"//The iWidget should generate markup fragment(s) to assist the user with interacting with the iWidget
        },
        event: {
            /*@type String*/
            TITLE:/*String*/ "title",//Name for the Attribute holding event title
            /*@type String*/
            DESCRIPTION:/*String*/ "description"//Name for the Attribute holding event description
        },
        /*@type String*/
        ATTRIBUTES:/*String*/ "attributes", //Name for the ManagedItemSet holding the customization attributes.
        /*@type String*/
        IDESCRIPTOR:/*String*/ "idescriptor", //Name for the ManagedItemSet holding the items describing the iWidget
        /*@type String*/
        USERPROFILE:/*String*/ "userprofile", //Name for the ManagedItemSet holding data about the user
        /*@type Object*/
        keys: {
            /*@type int*/
            SHIFT:/*int*/ 1,
            /*@type int*/
            ALT:/*int*/ 2,
            /*@type int*/
            CTRL:/*int*/ 4,
            /*@type int*/
            META:/*int*/ 8,
            /*@type int*/
            CAPSLOCK:/*int*/ 16
        },
        windowstate: {
            /*@type String*/
            NORMAL:/*String*/ "normal",
            /*@type String*/
            MINIMIZE:/*String*/ "minimize",
            /*@type String*/
            MAXIMIZE:/*String*/ "maximize"
        },
        status: {
            /*@type int*/
            SUCCESS:/*int*/ 200,
            /*@type int*/
            TIMEOUT:/*int*/ 408,
            /*@type int*/
            NOTFOUND:/*int*/ 404,
            /*@type int*/
            INTERROR:/*int*/ 500,
            /*@type int*/
            OTHER:/*int*/ 303
        },
        changeType: {
            /*@type String*/
            CHANGEDVALUE:/*String*/ "changedValue",
            /*@type String*/
            NEWITEM:/*String*/ "newItem",
            /*@type String*/
            REMOVEDITEM:/*String*/ "removedItem"
        
        }
    },
	/**
     * This method returns the unique identifier for this instance of the iWidget in the current evironment (usually a web page). 
     * @type String
     * @return{String}  widgetId unique identifier of the iWidget. return <code>null</code> if element is not available.
     * @ibm-module iWidget2
     */
    getWidgetId: function() {
        return null;
    },
    /**
     * Returns the iContext supplied element containing the content for the current mode of the iwidget such that the iWidget can easily do things such as search its own markup.
     * @type DOMElement
     * @return{DOMElement}  rootElement of the iWidget. return <code>null</code> if element is not available.
     * @ibm-module iWidget2
     */
    getRootElement: function() {
        return null;
    },
    /**
     * This method provides the same semantics as the DOM method with the same name, but restricts the search to the iWidget's markup rather than the entire page
     * @param{String} id  element id. Must not be <code>null</code>.
     * @param{DOMElement} root  optional DOMElement to define a search scope, it will search in the scope of current active mode if root is not provided.
     * @type DOMElement
     * @return{DOMElement} return the element, or <code>null</code> if element is not found.
     * @ibm-module iWidget2
     */
    getElementById: function(/*String*/id,/*DOMNode*/ root) {
        return null;
    },
    /**
     * This method returns the ManagedItemSet that provides access to the iWidget's customization attributes.
     * If there is no ManagedItemSet  related to the iWidget's customization attributes, this method MUST create an empty set and return it.
     * @type com.ibm.mashups.iwidget.itemset.ManagedItemSet
     * @return{com.ibm.mashups.iwidget.itemset.ManagedItemSet } return the ManagedItemSet or empty ManagedItemSet if no customization attributes is found.
     * @ibm-module iWidget2
     */
    getiWidgetAttributes: function() {
        return {};
    },
    /**
     * This method returns an ItemSet corresponding to the requested name. If it does not already exist, an ItemSet will be created and associated with the supplied name.
     * @param{String}name name of ItemSet. Must not be <code>null</code>.
     * @param{Boolean}isPrivate deprecated,please use getShareableItemSet()if it's a ShareableItemSet.
     * @type com.ibm.mashups.iwidget.itemset.ItemSet
     * @return{com.ibm.mashups.iwidget.itemset.ItemSet} return the requested ItemSet or <code> null</code> if access is denied.
     * @ibm-module iWidget2
     */
    getItemSet: function(/*String*/name,/*Boolean*/ isPrivate) {
        return null;
    },
	  /**
     * This method returns an ShareableItemSet corresponding to the requested name. If it does not already exist, an ItemSet will be created and associated with the supplied name.
     * @param{String}name name of ItemSet. Must not be <code>null</code>.
     * @type com.ibm.mashups.iwidget.itemset.ItemSet
     * @return{com.ibm.mashups.iwidget.itemset.ShareableItemSet} return the requested ItemSet or <code> null</code> if access is denied.
     * @ibm-module iWidget2
     */
    getShareableItemSet: function(/*String*/name) {
        return null;
    },
    /**
     * Provides means for iWidget to declare dependency on set of shared resource support dynamic loads in asynchronous manner. JS and CSS resources are supported.
     * @param{String} globalid  globalid of the Item that needs to be loaded. Must not be <code>null</code>.
     * @param{String}version  optional 
     * @param{String}uri uri of the resource. Must not be <code>null</code>.
     * @param{Object}cb optional  
     * @param{String}mimeType  optional
     * @type void
     * @ibm-module iWidget2
     */
    requires: function(/*String*/globalid,/*String*/ version,/*String*/ uri,/*function*/ cb,/*String*/ mimeType) {
    },
    /**
     * This method returns an instance of type Object which was initialized prior to the loading of the iWidget (either as a generic Object or an instance of the encapsulation Object ) . Its purpose is to support proper
     * encapsulation of the iWidget's assets (variables and methods) such that multiple instances of the iWidget can be loaded into a
     * single page's DOM without stepping on each other.
     * So iWidget resources can refer to any functions that's defined within iWidget encapsulation object by using iContext.iScope().fn();
     * @type Object
     * @return{Object} return an instance of the encapsulation class or return a generic object
     * @ibm-module iWidget2
     */
    iScope: function() {
        return null;
    },
    /**
     * This method requests the iContext to process the markup such that it can be inserted into the iWidget's markup and properly interact with the page.
     * (i.e. all the iContext reference in the markup needs to be properly namespaced). Where, when and how the markup is inserted into the page
     * is the responsibility of the iWidget.
     * @param{String}markup  markupString that needs to be processed. Must not be <code>null</code>.
     * @type String
     * @return  On success this method MUST return the processed markup while on failure it MUST return null
     * @ibm-module iWidget2
     */
    processMarkup: function(/*String*/markup) {
        return null;
    },
    /**
     * This method requests the iContext to process the subtree under the supplied node for the purpose of resolving and instantiating any referenced iWidgets.
     * @param{DOMNode}root root element of the subtree. Must not be <code>null</code>.
     * @type void
     * @ibm-module iWidget2
     */
    processiWidgets: function(/*DOMNode*/root) {
        //summary: This method requests the iContext to process the subtree under the supplied node for the purpose of resolving and instantiating any referenced iWidgets.
        //root: root element of the subtree
    },
    /**
     * This method returns an array of Elements within the iWidget's markup which have the supplied value as one of those specified by the Element's "class" attribute.
     * @param{String}classname  name of class attribute. Must not be <code>null</code>.
     * @param{DOMElement}root root element of the subtree. Must not be <code>null</code>
     * @type DOMElement[]
     * @return{DOMElement[]} return an array of elements
     * @ibm-module iWidget2
     */
    getElementByClass: function(/*String*/classname,/*DOMElement*/ root) {
        return null;
    },
    /**
     * This method returns the ManagedItemSet that provides access to the user's profile data.
     * @type com.ibm.mashups.iwidget.itemset.ManagedItemSet
     * @return{com.ibm.mashups.iwidget.itemset.ManagedItemSet } if there is no ManagedItemSet related to the user's profile, this method creates an empty set and returns it. If access to the user's profile is denied, this method returns null.
     * @ibm-module iWidget
     */
    getUserProfile: function() {
        return null;
    },
    /**
     * This method returns the ManagedItemSet that provides access to iWidget's descriptive items.
     * @type com.ibm.mashups.iwidget.itemset.ManagedItemSet
     * @return {com.ibm.mashups.iwidget.itemset.ManagedItemSet } If there is no ManagedItemSet  related to the iWidget's descriptive items this method creates an empty set and returns it..
     * @ibm-module iWidget2
ja     */
    getiDescriptor: function() {
        return null;
    },
    /**
     * This object provides access to io service. io service is accessible by using "this.iContext.io".<p/>
     * @type com.ibm.mashups.iwidget.io
     * @ibm-module iWidget2
     */
    io: {},
    /**
     * This object provides access to events service. event service is accessible by using "this.iContext.iEvents".<p/>
     * @type com.ibm.mashups.iwidget.iEvents
     * @ibm-module iWidget
     */
    iEvents: {}
});

}

if(!dojo._hasResource["com.ibm.mm.iwidget.Utils"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.iwidget.Utils"] = true;
dojo.provide("com.ibm.mm.iwidget.Utils");



dojo.declare("com.ibm.mm.iwidget.UtilsDefaultImpl", null, {

    widgetClassRE: new RegExp("(mm:|mm_|iw-)iWidget"),
    
    findElementByAttribute: function(/*String*/att,/*String*/ value,/*DOMElement*/ root,/*[]*/ element, hasMultiple){
    
        var aRoot = root;
        if (!root.childNodes) {
            return false;
        }
        if (att == "class") {
            dojo.query("." + value, root).forEach(function(ele){
                element.push(ele);
            });
            
            return element.length !== 0;
        }
        else if (att == "query") {
            dojo.query(value, root).forEach(function(ele){
                element.push(ele);
            });
            
            return element.length !== 0;
        }
        
        //other attributes
        if (root.getElementsByTagName) {
        
            var nodes = root.getElementsByTagName("*");
            for (var i = 0, l = nodes.length; i < l; i++) {
                var aNode = nodes[i];
                if (aNode && aNode.getAttribute) {
                    var childValue = aNode.getAttribute(att);
                    if (childValue == value) {
                        element.push(aNode);
                        if (!hasMultiple) {
                            return true;
                        }
                    }
                }
            }
        }
        return false;
    },
    
    getClass: function(/*object*/node){
        var childValue = node.getAttribute("class");
        childValue = childValue ? childValue : node.getAttribute("className");
        return childValue;
    },
    
    checkParentElement: function(/*Node*/selfNode, /*RegExp*/ classToFind){
        if (selfNode) {
            var dadNode = selfNode.parentNode;
            if (dadNode) {
                if (dadNode.className) {
                    if (dadNode.className.match(classToFind)) {
                        return dadNode.id;
                    }
                }
                return this.checkParentElement(dadNode, classToFind);
            }
        }
        return null;
    },
    
    getWidgetParent: function(/*Domnode*/node, /*RegExp*/ classToFind){
        if (dojo.isString(node)) {
            node = dojo.byId(node);
        }
        if (!classToFind) {
            classToFind = this.widgetClassRE;
        }
        
        return this.checkParentElement(node, classToFind);
    },
    
    getParents: function(/*widget*/widget,/*array*/ arr){
        var parent = widget.getParent();
        if (parent) {
            arr.push(parent);
            this.getParents(parent, arr);
        }
        return;
    },
    
    /**
     * 	This utility method takes an id from the markup and returns
     *  an unprefixed id to pass into an enabler model (like Widget,
     *  Wire or Event.)  IE7 doesn't support ids that start with a
     *  number so the server may encode the ids with a prefix,
     *  like 'id_' to make an id valid.
     *
     *  If the markup id starts with the prefix from 
     *  ibmConfig["com.ibm.mashups.iWidget.idPrefix"] this method
     *  will remove the prefix.
     *  
     *  If the id does not start with the prefix no action will be
     *  taken.
     *       
     * @param {String}  id from the markup
     * @return {String} the unprefixed id to pass to the enabler 
     *                  models
     */
    getModelID: function(/*string*/id){
		var ret = id;
		var prefix = ibmConfig[com.ibm.mashups.enabler.services.ConfigConstants.ID_PREFIX];
		if (prefix && dojo.isString(ret)) {
			var indx = ret.indexOf(prefix);
			if (indx === 0) {
				ret = ret.substring(prefix.length);
			}
		}
		
		return ret;
    },
    
    /**
     * 	This utility method takes an id from an enabler (like Widget, 
     *  Wire or Event) and returns a prefixed markup id. IE7 doesn't 
     *  support ids that start with a number so the server may encode 
     *  the ids with a prefix, like 'id_' to make an id valid.
     *  
     *  If the model id starts with a number this method will take
     *  prefix from ibmConfig["com.ibm.mashups.iWidget.idPrefix"]
     *  and prepend it to the id passed in.
     *  
     *
     * @param {String} id retrieved from an enabler model
     * @return {String} the prefixed id to match the markup returned 
     *                  from the server
     */
    getMarkupID: function(/*string*/id) {
		var ret = id;
		var prefix = ibmConfig[com.ibm.mashups.enabler.services.ConfigConstants.ID_PREFIX];
		if (prefix && dojo.isString(ret)) {
			ret = prefix + ret;
		}
		
		return ret;
    },
    
    stripHashPrefix: function(str) {
        if (dojo.isString(str)) {
            var pos = str.indexOf('#');
            if (pos !== -1) { // not enough to just strip first character, because IE prepends the URL.
                return str.substr(1 + pos);
            }
        }
        return str;
    }
});

com.ibm.mm.iwidget.Utils = new com.ibm.mm.iwidget.UtilsDefaultImpl();


// IMPORTANT
// ibmConfig.enablerLayerModules is a comma separated string of all supported modules at runtime
// This section dynamically loads the Extended representation when the variable enablerLayerModules contains the given module
if ((ibmConfig.enablerLayerModules) && (dojo.indexOf(ibmConfig.enablerLayerModules, "iWidget") >= 0)) {
    dojo["require"]("com.ibm.mm.iwidget.UtilsExtended"); // JSLINT-IGNORE: This needs to be done to allow modularization and to support the minimal layer
}

}

if(!dojo._hasResource["com.ibm.mm.iwidget.icontext.IContextDefaultImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.iwidget.icontext.IContextDefaultImpl"] = true;
dojo.provide("com.ibm.mm.iwidget.icontext.IContextDefaultImpl");






dojo.declare("com.ibm.mm.iwidget.icontext.IContextDefaultImpl", com.ibm.mashups.iwidget.iContext, {

    constructor: function(wrapper){
        //information accessible from iwidget 
        this.widgetwrapper = wrapper;
        this.widgetId = wrapper.id;
        this.scope = {};
        
        //todo: root is associated with mode
        //this.rootElement = wrapper.rootElement;
        //keep this.rootElement and this.ns since this will break some widget code
        this.rootElement = dojo.byId(this.widgetId);
        this.ns = this.rootElement.className.substr(0, 3);
        this._initEvents();
        this._initIO();
        this._initMMExtension();
        
    },
    _destroy: function(){
        // # 17713, leak for one iw-iWidget DIV
        if (this.rootElement) {
            this.rootElement = null;
        }
    },
    getWidgetId: function(){
        if (this.widgetId) {
            return this.widgetId;
        }
        return null;
    },
    _initEvents: function(){
        this.iEvents = null;
    },
    _initMMExtension: function(){
        this._mm = null;
    },
    getRootElement: function(){
        //summary: returns the root element of the iWidget such that iWidget can easily do things such as
        // searching its own markup. RootElement can also be a convenient place to place items which iWidget wishes
        // to access later.
        //we generate it dynamically so it can work for sandboxed iwidget 
        return dojo.byId(this.widgetId);
    },
    getElementById: function(/*String*/id, root){
    
        //summary: this method provides the same semantics as the DOM method by the same name with the distinction that
        //  this method will restrict the search to the iWidget's markup rather than entire page
        if (!root) {
            root = this._getContentRoot();
        }
        
        //following dojo.query will query by id however it doesn't work, so use our legacy stuff instead
        /*
         var nodeList = dojo.query("#"+id,root);
         if (nodeList.length >= 1){
         return nodeList[0];
         }
         return null;
         */
        var element = [];
        var rc = com.ibm.mm.iwidget.Utils.findElementByAttribute("id", id, root, element, false);
        
        if (rc) {
            return element[0];
        }
        else {
            return null;
        }
    },
    getiWidgetAttributes: function(){
        //Summary: returns an ManagedItemSet which provides access to the iWidget's customization attributes. 
        //          The returned ManagedItemSet will be the same as getItemSet(iContext.constants.itemset.ATTRIBUTES).
        //          returns empty set if there's no ItemSet.
        var attrs = this.widgetwrapper.getAttributes();
        return attrs;
    },
    getItemSet: function(/*String*/name,/*boolean*/ isPrivate){
    
        if (typeof name == "undefined" || name === null) {
            return null;
        }
        if (name == iwConstants.ATTRIBUTES) {
            return this.getiWidgetAttributes();
        }
        if (name == iwConstants.USERPROFILE) {
            return this.getUserProfile();
        }
        if (name == iwConstants.IDESCRIPTOR) {
            return this.getiDescriptor();
        }
        
        var itemSet = this.widgetwrapper.getWidgetItemSet(name);
        return itemSet;
    },
    iScope: function(){
        return this.scope;
    },
    processMarkup: function(/*string*/markup){
        //return null upon failure
        var oldMarkup = markup.replace(/_IWID_/g, "_" + this.widgetId + "_");
        var finalMarkup = oldMarkup.replace(/iContext(?=\.|\s|\(|\))/g, "_" + this.widgetId + "_iContext");
        return finalMarkup;
    },
    getElementByClass: function(classname, root){
        if (!root) {
            root = this._getContentRoot();
        }
        
        //todo: use dojo.query
        var nodeList = dojo.query("." + classname, root);
        if (typeof nodeList != "undefined" && nodeList !== null) {
            if (nodeList.length === 0) {
                return null;
            }
            else {
                var elements = [];
                for (var i = 0; i < nodeList.length; i++) {
                    elements.push(nodeList[i]);
                }
                return elements;
            }
        }
        return null;
    },
    getWidgetXMLPath: function(){
        var url = this.widgetwrapper.getIWidgetInstance().widgetXMLUrl;
        var queryStart = url.indexOf("?");
        if (0 < queryStart) {
            url = url.substring(0, queryStart);
        }
        
        var url2 = com.ibm.mm.enabler.EndpointUtils.checkForEndpoints(url);
        if (url2) {
            url = url2;
        }
        
        return url;
    },
    _getWidgetBaseUri: function(){
    
        var widgetBaseUri = this.widgetwrapper.getIWidgetInstance().widgetXMLUrl;
        var queryStart = widgetBaseUri.indexOf("?");
        if (0 < queryStart) {
            widgetBaseUri = widgetBaseUri.substring(0, queryStart);
        }
        
        return widgetBaseUri.substring(0, widgetBaseUri.lastIndexOf("/") + 1);
    },
    _getContentRoot: function(){
    
        var contentRoot = this.getRootElement();
        var currentMode = this.widgetwrapper.currentMode;
        if (!currentMode) {
            currentMode = "view";
        }
        var currentWindow = this.widgetwrapper.windowManager[currentMode];
        if (currentWindow) {
            var temp = currentWindow.root;
            if (temp) {
                contentRoot = temp;
            }
        }
        
        return contentRoot;
    },
    getiDescriptor: function(){
        var iDescriptor = this.widgetwrapper.getIDescriptorItems();
        return iDescriptor;
    },
    
    // simply stubbed out for minimal
    _initIO: function(){
        this.io = new com.ibm.mm.iwidget.icontext.IContextIOImpl(this.widgetwrapper);
    },
    getUserProfile: function(){
        //todo: warning
        return null;
    },
    requires: function(/*String*/requiredItem,/*String*/ version,/*String*/ uri,/*function*/ cb, mimeType){
        //todo: warning
        return;
    },
    processiWidgets: function(/*domnode*/root){
        //todo: warning
        return;
    }
});

com.ibm.mm.iwidget.icontext.IContextImpl = com.ibm.mm.iwidget.icontext.IContextDefaultImpl;

// IMPORTANT
// ibmConfig.enablerLayerModules is a comma separated string of all supported modules at runtime
// This section dynamically loads the Extended representation when the variable enablerLayerModules contains the given module
if ((ibmConfig.enablerLayerModules) && (dojo.indexOf(ibmConfig.enablerLayerModules, "iWidget") >= 0)) {
    dojo["require"]("com.ibm.mm.iwidget.icontext.IContextExtendedImpl"); // JSLINT-IGNORE: This needs to be done to allow modularization and to support the minimal layer
}

}

if(!dojo._hasResource["com.ibm.mashups.iwidget.iContext"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.iwidget.iContext"] = true;
dojo.provide("com.ibm.mashups.iwidget.iContext");








}

if(!dojo._hasResource["com.ibm.mashups.iwidget.itemset.ItemSet"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.iwidget.itemset.ItemSet"] = true;
dojo.provide("com.ibm.mashups.iwidget.itemset.ItemSet");

/**
 * Interface to a simple abstraction of a datamodel. This provides a base from which more sofisticated data models can be built.
 * @ibm-api
 * @ibm-module iWidget2
 */
dojo.declare("com.ibm.mashups.iwidget.itemset.ItemSet", null, {
    /**
     @private
     */
    constructor: function() {
    },
    /**
     This method sets an item within the ItemSet, creates or replaces an existing entry as needed.
     Since only one value is allowed for any one name/locale combination, the supplied value replaces any existing value for the supplied name/locale.
	 When successful, this method MUST return a handle to the ItemSet while on failure it must return null.
     @param{String}itemName name of the item. Must never be <code>null</code>.
     @param{Object}value value of the item. Must never be <code>null</code>.
     @param{String}locale specified locale. Must never be <code>null</code>.
     @return{ItemSet} return an handle of ItemSet upon successful, <code>null</code> upon failure.
     */
    setLocalizedItemValue: function( /*String*/itemName, /*Object*/ value,/*String*/ locale) { 
        return this;
    },
    /**
     This method sets an item within the ItemSet, creates or replaces an existing entry as needed.
     To append a value to any existing item, suggest to get the current value of this item and append
     the new value to the list and supply the result to this method.
     Marking an item as ReadOnly indicates to the iContext that while this item maybe shared with other components
     on the page, the access of those components should not include changing or removing item.
     @param{String}itemName name of the item. Must never be <code>null</code>.
     @param{Object}value value of the item. Must never be <code>null</code>.
     @param{Boolean}readOnly optional Boolean attribute to indicate this item is readOnly or not.Default value is false if this parameter is not provided.
     @return{ItemSet} return an handle of ItemSet upon successful, <code>null</code> upon failure.
     @deprecated please use setItemValue(itemName,value) readOnly is always false
     */
    setItemValue: function( /*String*/itemName, /*Object*/ value,/*boolean*/ readOnly) {// JSLINT-IGNORE: in Java functions with the same name but different signatures are allowed - this is only used for generating JavaDoc
        return this;
    },	
	/**
     This method sets a nonlocalized value of an item within the ItemSet, creates or replaces an existing entry as needed.
     @param{String}itemName name of the item. Must never be <code>null</code>.
     @param{Object}value value of the item. Must never be <code>null</code>.
     @return{ItemSet} return an handle of ItemSet upon successful, <code>null</code> upon failure.
     */
    setItemValue: function( /*String*/itemName, /*Object*/ value) {// JSLINT-IGNORE: in Java functions with the same name but different signatures are allowed - this is only used for generating JavaDoc
        return this;
    },	
	/**
     This method returns the value for the named item in the specified locale. On failure this method MUST return null.
     @param{String}itemName name of the item. Must never be <code>null</code>.
     @param{String}locale specified locale. Must never be <code>null</code>.
     @return{Object} return value of the item, <code>null</code> upon failure.
     */
    getLocalizedItemValue: function( /*String*/itemName,/*String*/locale) {
        return null;
    },
    /**
     This method returns the nonlocalized value for the named item from the set.
     @param{String}itemName name of the item. Must never be <code>null</code>.
     @return{ItemSet} return the named item for the set, <code>null</code> upon failure.
     */
    getItemValue: function( /*String*/itemName) {
        return null;
    },
    /**
     This method returns an array of Strings, providing the name of each item.
     @return{String[]}  return an array of items names and return <code>null</code> if the set contains no item
     */
    getAllNames: function() {
        return null;
    },
    /**
     Removes the named item from the set.
     @param{String}itemName name of the item that needs to be removed. Must never be <code>null</code>.
     @return{ItemSet} return the handle to the ItemSet upon successful, <code>null</code> upon failure.
     */
    removeItem: function(/*String*/itemName) {
        return null;
    },
	 /**
     Removes the non localized value of the item from the set.
     @param{String}itemName name of the item that needs to be removed. Must never be <code>null</code>.
     @return{ItemSet} return the handle to the ItemSet upon successful, <code>null</code> upon failure.
     */
    removeItemValue: function(/*String*/itemName) {
        return null;
    },
	 /**
     Removes the  value of the item from the set for a specified locale.
     @param{String}itemName name of the item that needs to be removed. Must never be <code>null</code>.
     @param{String}locale a specified locale. Must never be <code>null</code>.
     @return{ItemSet} return the handle to the ItemSet upon successful, <code>null</code> upon failure.
     */
    removeLocalizedItemValue: function(/*String*/itemName,/*String*/locale) {
        return null;
    },
   /**
     The method returns an array of strings, each providing a locale where a value is defined. The empty string"" is
     returned for a value without a locale. if the set does not contain the names item, this method must return null.
     @param{String}itemName name of the item.  Must never be <code>null</code>.
     @return{String[]} return an array each providing  a locale where a value is defined.
     */
    getLocalesWithValues: function(/*String*/itemName) {
        return null;
    },
    /**
     This method returns a new ItemSet which is a duplicate of the current ItemSet.
     @return{ItemSet}  return a new ItemSet which contains all the data item in the current ItemSet
     @deprecated not used
     */
    clone: function() {
        return null;
    },
    /**
     This method returns a Boolean indicating whether or not the item specified by the supplied name can be modified by the user.
     @param{String}itemName name of the required Item. Must never be <code>null</code>.
     @return{Boolean} return a Boolean indicating whether or not the item specified by the supplied name can be modified by the user. Never <code>null</code>.
     @deprecated always return false
     */
    isReadOnly: function(/*String*/itemName) {
        return false;
    },
    /**
     As a limitation in Lotus Mashups, this method returns <code>null</code>.
     @return{Object} return As a limitation in Lotus Mashups, this method returns <code>null</code>.
     @deprecated not used
     */
    getItemSetDescription: function() {
        return null;
    },
		/**
     This function adds listener to this ShareableItemSet. So it will gets notified when this ShareableItemSet is updated.
     @param{Function}listener js function that should already be properly scoped. Must never be <code>null</code>.
     @return{String} return listener id if listener is registered successfully, return null if it's not.
     @deprecated not used
     */
    addListener: function(/*Function*/listener) {
        return null;
    },
    /**
     This function removes the  listener from this ShareableItemSet.
     @param{String}listenerId  listener id that's returned by the system when listener is added. Must never be <code>null</code>.
     @return{Boolean} return true if listener is removed successfully.
     @deprecated not used
     */
    removeListener: function(/*String*/listenerId) {
        return true;
    } //return true if listener is removed successfully
});

}

if(!dojo._hasResource["com.ibm.mashups.iwidget.itemset.ManagedItemSetCallbackModel"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.iwidget.itemset.ManagedItemSetCallbackModel"] = true;
dojo.provide("com.ibm.mashups.iwidget.itemset.ManagedItemSetCallbackModel");


/**
 * This API defines the callback functions for ManagedItemSet.
 * @ibm-api
 * @ibm-module iWidget2
 */
dojo.declare("com.ibm.mashups.iwidget.itemset.ManagedItemSetCallbackModel", null, {
    /**
     @private
     */
    constructor: function() {
    },
    /**
     This method defines the callback function after save operation.  IWidget may provide this function when invoke <code> managedItemSet.save(callbackfn)</code>.
     The iContext will invoke callbackfn upon save completion.
     @param{String}managedItemSetName  name of ManagedItemSet: attributes,idescriptor,userprofile. Must never be <code>null</code>.
     @param{Boolean}success boolean indicates if save operation is successful or not.
     @type void
     */
    postSaveCallbackFn: function(/*String*/managedItemSetName,/*Boolean*/ success) {
    }
});

}

if(!dojo._hasResource["com.ibm.mashups.iwidget.itemset.ManagedItemSet_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.iwidget.itemset.ManagedItemSet_API"] = true;
dojo.provide("com.ibm.mashups.iwidget.itemset.ManagedItemSet_API");
dojo.provide("com.ibm.mashups.iwidget.itemset.ManagedItemSet");

/**
 Interface to a simple abstraction of a datamodel. This provides a base from which more sofisticated datamodel can be built.
 There're 3 default ManagedItemSet provided in Lotus Mashups. They are attributes, userprofile and  idescriptor.<p/>
 @ibm-api
 @ibm-module iWidget2
 */
dojo.declare("com.ibm.mashups.iwidget.itemset.ManagedItemSet",null, {
    /**
     @private
     */
    constructor: function() {
    },
    /**
     This method requests the iContext save the current state of the ManagedItemSet.
     The iContext MAY also choose to save the ManagedItemSet at times other than when iWidgets request a save.
     This method MAY operate asynchronously.  The iContext  MUST invoke any supplied callbackFn upon completion of the save attempt.
     It need to be implemented by each subclass...signiture of callback function is as follows</br>
     &nbsp;&nbsp;&nbsp;<code>function(in String managedItemSetName, in Boolean success);</code>
     @param{com.ibm.mashups.iwidget.itemset.ManagedItemSetCallbackModel.postSaveCallbackFn}callbackfn optional callback function
     @type void
     @deprecated use commit(callbackfn) instead
     */
    save: function(callbackfn) {
    },
	 /**
     This method requests the queued change be processed. This includes simultaneous changes to multiple items and any persistence or other propagation of the values.
     This method MAY operate asynchronously.  The iContext  MUST invoke any supplied callbackFn upon completion of the commit attempt.
     It need to be implemented by each subclass...signiture of callback function is as follows</br>
     &nbsp;&nbsp;&nbsp;<code>function(in String managedItemSetName, in Boolean success);</code>
     @param{com.ibm.mashups.iwidget.itemset.ManagedItemSetCallbackModel.postSaveCallbackFn}callbackfn optional callback function
     @type void
     */
    commit: function(callbackfn) {
    },
	  /**
     This method sets an item within the ItemSet, creates or replaces an existing entry as needed.
     To append a value to any existing item, suggest to get the current value of this item and append
     the new value to the list and supply the result to this method.
     Marking an item as ReadOnly indicates to the iContext that while this item maybe shared with other components
     on the page, the access of those components should not include changing or removing item.
     @param{String}itemName name of the item. Must never be <code>null</code>.
     @param{String}value value of the item. Must never be <code>null</code>.
     @param{Boolean}readOnly optional Boolean attribute to indicate this item is readOnly or not.Default value is false if this parameter is not provided.
     @return{ItemSet} return an handle of ItemSet upon successful, <code>null</code> upon failure.
     @deprecated use setItemValue(itemName,value) instead
     */
    setItemValue: function( /*String*/itemName, /*Object*/ value,/*boolean*/ readOnly) {
        return this;
    },
	 /**
     This method sets an item within the ItemSet, creates or replaces an existing entry as needed.
     With the actual setting/processing of the change happening when commit() is invoked.As ManagedItemSet are controlled by
     the iContext, some items may be read only to the iwidget. 
     @param{String}itemName name of the item. Must never be <code>null</code>.
     @param{String}value value of the item. Must never be <code>null</code>.
     @return{ItemSet} return an handle of ItemSet upon successful, <code>null</code> upon failure.
     */
    setItemValue: function( /*String*/itemName, /*Object*/ value) { // JSLINT-IGNORE: in Java functions with the same name but different signatures are allowed - this is only used for generating JavaDoc
        return this;
    },
    /**
     This method returns the value for the named item from the set.
     @param{String}itemName name of the item. Must never be <code>null</code>.
     @return{String} return value of the named item for the set, <code>null</code> upon failure.
     */
    getItemValue: function( /*String*/itemName) {
        return null;
    },
    /**
     This method returns an array of Strings, providing the name of each item.
     @return{String[]}  return an array of items names and return <code>null</code> if the set contains no item
     */
    getAllNames: function() {
        return null;
    },
    /**
     Removes the named item from the set.
     @param{String}itemName name of the item that needs to be removed. Must never be <code>null</code>.
     @return{ItemSet} return the handle to the ManagedItemSet upon successful, <code>null</code> upon failure.
     */
    removeItem: function(/*String*/itemName) {
        return null;
    },
    /**
     This method returns a new ItemSet which is a duplicate of the current ItemSet.
     @return{ItemSet}  return a new ItemSet which contains all the data item in the current ItemSet
     @deprecated not used
     */
    clone: function() {
        return null;
    },
    /**
     This method returns a Boolean indicating whether or not the item specified by the supplied name can be modified by the user.
     @param{String}itemName name of the required Item. Must never be <code>null</code>.
     @return{Boolean} return a Boolean indicating whether or not the item specified by the supplied name can be modified by the user. Never <code>null</code>.
     */
    isReadOnly: function(/*String*/itemName) {
        return null;
    },
    /**
     As a limitation in Lotus Mashups, this method returns <code>null</code>.
     @return{Object} return As a limitation in Lotus Mashups, this method returns <code>null</code>.
     @deprecated not used
     */
    getItemSetDescription: function() {
        return null;
    },
	/**
     This function adds listener to this ShareableItemSet. So it will gets notified when this ShareableItemSet is updated.
     @param{Function}listener js function that should already be properly scoped. Must never be <code>null</code>.
     @return{String} return listener id if listener is registered successfully, return null if it's not.
     */
    addListener: function(/*Function*/listener) {
        return null;
    },
    /**
     This function removes the  listener from this ShareableItemSet.
     @param{String}listenerId  listener id that's returned by the system when listener is added. Must never be <code>null</code>.
     @return{Boolean} return true if listener is removed successfully.
     */
    removeListener: function(/*String*/listenerId) {
        return true;
    } //return true if listener is removed successfully
});

}

if(!dojo._hasResource["com.ibm.mashups.iwidget.services.EventService"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.iwidget.services.EventService"] = true;
dojo.provide("com.ibm.mashups.iwidget.services.EventService");

/**
 * This interface defines iWidget EventService which provides  a topic driven subscribe/publish mechanism. 
 * "fireEvent" and "broadcastEvent"  are provided as convenience functions on top of this basic model.
 * The service can be retrieved using the following code: <br>
 * <code>var eventService = com.ibm.mashups.services.ServiceManager.getService(<br/>
 * &nbsp;&nbsp;&nbsp;&nbsp;com.ibm.mashups.iwidget.services.EventService.SERVICE_NAME);</code><br/>
 * @ibm-spi
 * @ibm-module iWidget2
 */
dojo.declare("com.ibm.mashups.iwidget.services.EventService",null,  {
    /**
     * The service name to be used to fetch the service from the ServiceManager
     * @type String
     */
    SERVICE_NAME: "eventService",
    
  	/**
     * @private
     */
    constructor:function(){
    },

/**
Allows page component to invoke a handled event that's defined in an iWidget.<br/>
For example,  in Lotus Mashups, user can click "save" to save the attributes when user finished editing a widget .<br/>
Then the component that renders the "save" button could use this api to distribute an onModeChanged event to the widget.<br/>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<code>com.ibm.mashups.services.ServiceManager.getService("eventService").fireEvent(this.iwidgetId,"onModeChanged", {newMode:"view"});	 </code><br/>
So the widget could get notified and go back to "view"mode.<br/>
Same function can also be achieved by using "publishEvent"<br/>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<code>com.ibm.mashups.services.ServiceManager.getService("eventService").publishEvent("widgetevents."+this.iwidgetId+"."+"onModeChanged", {newMode:"view"}); </code><br/>
@param{String } targetWidget  id of target iWidget. Must never be NULL.
@param{String } targetEvent  event name of target Event .Must never be NULL.
@param{Object } payload  optional. data object that's distributed with an event. May be NULL.
@param{String } payloadType  optional. type of the payload
@param{String } sourceid  optional. id of source component that triggers this event
@type void
*/
      fireEvent: function(targetWidget,targetEvent,payload,payloadType,sourceid){
      },	
/**
Allows page components to broadcast  an event to all the widgets/components on the page. There's no need for widgets to subscribe that topic first.<br/>
For example,  mode selector iWidget may broadcast a "pageModeChanged" event when page mode is changed from view mode to edit mode.<br/>
Then all the widgets/components  will get notified and all widgets/components that  can handle "pageModeChanged" event will update accordingly.<br/>
A widget that can handle this event must have this event defined. <br/>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<code> &lt;iw:event id="pageModechanged"  eventDescName="pageModeChanged_desc" handled="true"  onEvent="handlePageModeChange" /&gt; </code><br/>
A component that can handle this event must subscribe this event by using:<br/>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <code>serviceManager.getService("eventService").subscribeEvent ("pageModechanged",handlerFn,scope,sourceid)</code><br/>
Code example:<br/>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<code>com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("pageModeChanged", payload,payloadtype,,sourceid); </code><br/>
Same function can also be achieved by using "publishEvent"<br/>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<code>com.ibm.mashups.services.ServiceManager.getService("eventService").publishEvent("*"+"."+"onModeChanged", {newMode:"view"}); </code><br/>
@param{String } targetEvent  event name of target Event .Must never be NULL.
@param{Object } payload  optional.  data object that's distributed with an event. May be NULL.
@param{String } payloadType  optional.  type of the payload
@param{String } sourceid  optional. id of client component that triggers this event.
@type void
*/ 	 	  
      broadcastEvent: function(targetEvent,payload,payloadType,sourceid){
      },
/**
Allows page components to switch to a different page and broadcast an event to all the widgets/components on that page.<br/>
@param{String } targetEvent  event name of target Event .Must never be NULL.
@param{Object } payload  optional.  data object that's distributed with an event. May be NULL.
@param{String } payloadType  optional.  type of the payload
@param{String } sourceid  optional. id of client component that triggers this event.
@param{String } pageid  optional. id of page to switch to and receive the event. If none is provided, no page switch will occur and event will broadcast to current page.
@type void
*/ 	 	  
      broadcastEvent: function(targetEvent,payload,payloadType,sourceid,pageid){ // JSLINT-IGNORE: cannot change public API
      },
/**
Allows page components to switch to a different page and space and broadcast an event to all the widgets/components on that page.<br/>
@param{String } targetEvent  event name of target Event .Must never be NULL.
@param{Object } payload  optional.  data object that's distributed with an event. May be NULL.
@param{String } payloadType  optional.  type of the payload
@param{String } sourceid  optional. id of client component that triggers this event.
@param{String } pageid  optional. id of page to switch to and receive the event. If none is provided, no page switch will occur and event will broadcast to current page.
@param{String } spaceid  optional. id of space containing the page to switch to and receive the event. If none is provided, current space is assumed.
@type void
*/ 	 	  
      broadcastEvent: function(targetEvent,payload,payloadType,sourceid,pageid,spaceid){ // JSLINT-IGNORE: cannot change public API
      },
/**
Allows page components to broadcast more than one event to all the widgets/components on the page.<br/>
@param{Array } eventsArray   Array of objects each containing the following event information: &#123; "targetEvent": targetEvent, "payload": payload, "payloadType": payloadType &#125;. Must never be NULL.
@param{String } sourceid  optional. id of client component that triggers this event.
@type void
*/ 	 	  
      broadcastEvents: function(eventsArray,sourceid){
      },
/**
Allows page components to switch to a different page and broadcast more than one event to all the widgets/components on that page.<br/>
@param{Array } eventsArray   Array of objects each containing the following event information: &#123; "targetEvent": targetEvent, "payload": payload, "payloadType": payloadType &#125;. Must never be NULL.
@param{String } sourceid  optional. id of client component that triggers this event.
@param{String } pageid  optional. id of page to switch to and receive the events. If none is provided, no page switch will occur and events will broadcast to current page.
@type void
*/ 	 	  
      broadcastEvents: function(eventsArray,sourceid,pageid){ // JSLINT-IGNORE: cannot change public API
      },
/**
Allows page components to switch to a different page and space and broadcast more than one event to all the widgets/components on that page.<br/>
@param{Array } eventsArray   Array of objects each containing the following event information: &#123; "targetEvent": targetEvent, "payload": payload, "payloadType": payloadType &#125;. Must never be NULL.
@param{String } sourceid  optional. id of client component that triggers this event.
@param{String } pageid  optional. id of page to switch to and receive the events. If none is provided, no page switch will occur and events will broadcast to current page.
@param{String } spaceid  optional. id of space containing the page to switch to and receive the events. If none is provided, current space is assumed.
@type void
*/ 	 	  
      broadcastEvents: function(eventsArray,sourceid,pageid,spaceid){ // JSLINT-IGNORE: cannot change public API
      },
/**
Allows page component to publish a global event that's available to all the other page components.<br/>
Event service supports global topics. For these topics all the page components could subscribe to it.<br/>
For example. when an iWidget is removed from page, a global event -"/enabler/unloadWidget" will be published by the skin component.<br/>
iWidget container is a subscriber of this topic, thus it can clean up the resource related to this iWidget accordingly.<br/>
@param{String } topic  topic that's published.Must never be NULL.
@param{Object } payload  optional. payload object.
@param{String } payloadType optional.  type of the payload
@param{String } sourceid  optional. id of client component that triggers this event.
@type void
*/ 	  
      publishEvent: function(topic,payload,payloadType,sourceid){
      },
/**
Allows page component to subscribe  a global event that's available to all the other page components.<br/>
Event service supports global topic. for these topics all the page listeners could subscribe to it.<br/>
For example. when an iWidget is removed from page, a global event -"/enabler/unloadWidget" will be published by the skin component.<br/>
iWidget container is a subscriber of this topic, thus it can clean up the resource related to this iWidget accordingly.
@param{String } event  event name 
@param{Object } object  optional. scope object of the handlerFn. default scope is global scope.
@param{String} eventCallback optional. eventCallback that will be invoked when event is published
@param{String} subscribeCallback optional. callback  to tell is subscription is good
@param{String } sourceid  optional. id of client component that subscribes this event
@type void
*/	  
      subscribeEvent:function(event,object,eventCallback,subscribeCallback,sourceid){
      },
/**
Allows page component to unsubscribe  a global event that's available to all the other page components.<br/>
@param{Object } subscriptionHandler   subscriptionHandler
@param{String } sourceid  optional. id of client component that subscribes this event
@type void
*/
	  unsubscribeEvent:function(subscriptionHandler,sourceid){
	  }
});
// make sure we can reference this globally
com.ibm.mashups.iwidget.services.EventService.SERVICE_NAME = "eventService";

}

if(!dojo._hasResource["com.ibm.mm.iwidget.manageditemset.IDescriptorDefaultImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.iwidget.manageditemset.IDescriptorDefaultImpl"] = true;
dojo.provide("com.ibm.mm.iwidget.manageditemset.IDescriptorDefaultImpl");






dojo.declare("com.ibm.mm.iwidget.manageditemset.IDescriptorDefaultImpl", com.ibm.mashups.iwidget.itemset.ManagedItemSet, {
    constructor: function(widget, defiDescriptor, instanceiDescriptor) {
        this.widget = widget;
        this.defiDescriptorItems = defiDescriptor; //associative array
        this.instanceiDescriptorItems = instanceiDescriptor; //associative array
        this.navStateModel = com.ibm.mashups.enabler.model.state.NavigationStateModelFactory.getNavigationStateModel();
        this._updatedItems = {}; // only manages mode and windowstate here
    },
    readOnlyItems: {
        defaultHeight: "defaultHeight",
        defaultWidth: "defaultWidth",
        displayLocale: "displayLocale",
        messageLocale: "messageLocale",
        author: "author",
        email: "email",
        website: "website",
        version: "version",
        icon: "icon"
    },
    writableItems: {
        title: "title",
        name: "name",
        description: "description",
        availableMessageLocales: "availableMessageLocales",
        mode: "mode",
        windowState: "windowState"
    },
    localizedItems: {
        title: "title",
        name: "name",
        description: "description"
    },
    getItemValue: function(/*string*/name) {
    
        if (typeof name == "undefined" || name === null) {
            return null;
        }
        var value = null;
        if (name == iwConstants.iDescriptorItems.mode) {
            var widgetWrapper = this.widget;
            if (widgetWrapper) {
                value = widgetWrapper.currentMode;
            }
        }
        else if (name == iwConstants.iDescriptorItems.displayLocale) {
            var aLocale = ibmConfig.locale;
            var configService = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
            var temp = configService.getValue(com.ibm.mashups.enabler.services.ConfigConstants.DISPLAY_LOCALE);
            if (temp) {
                aLocale = temp;
            }
            value = aLocale;
        }
        else if (name == iwConstants.iDescriptorItems.messageLocale) {
            value = this._getMessageLocale();
        }
        else if (name == iwConstants.iDescriptorItems.windowState) {
            value = this._getWindowState();
        }
        else {
            value = this._getItemValue(/*String*/name);
        }
        return value;
    },
    _getWindowState: function() {
        return "normal";
    },
    _getItemValue: function(/*String*/itemName) {
        var locale = null;
        if (this.localizedItems[itemName]) {
            locale = this._getMessageLocale(); //replace with mesage locale
        }
        var defItem = null;
        if (this.defiDescriptorItems) {
            defItem = this.defiDescriptorItems.getItemValue(itemName, locale);
            if (typeof defItem == "undefined") {
                defItem = null;
            }
        }
        var instanceItem = null;
        if (this.instanceiDescriptorItems) {
            instanceItem = this.instanceiDescriptorItems.getItemValue(itemName, locale);
        }
        
        if (instanceItem) {
            return instanceItem;
        }
        return defItem;
    },
    _setDynamicTitleOrIcon: function(name, value) {
        // noop
    },
    setItemValue: function(name, value) {
        if (typeof name == "undefined" || name === null) {
            return null;
        }
        if (typeof value == "undefined" || value === null) {
            return null;
        }
        if (this.readOnlyItems[name]) {
            return null;
        }
        
        if (name == iwConstants.iDescriptorItems.mode) {
            var supportedModes = this._getWidgetDef().getSupportedModes();
            if (this._contains(supportedModes, value)) {
                this._updatedItems[name] = value;
            }
            else {
                return null;
            }
        }
        if (name == iwConstants.iDescriptorItems.windowState) {
            var supportedWindowStates = this._getWidgetDef().getSupportedWindowStates();
            if (this._contains(supportedWindowStates, value)) {
                this._updatedItems[name] = value;
            }
            else {
                return null;
            }
        }
        
        // dynamic title or icon
        if (this.widget.id && ( name == iwConstants.iDescriptorItems.title || name == iwConstants.iDescriptorItems.icon)) {
            this._setDynamicTitleOrIcon(name, value);
        }
        
        var locale = null;
        if (this.localizedItems[name]) {
            locale = this._getMessageLocale();
        }
        //save to instance level because this is the level next to view
        //such as title/desription/icon, iContext always use the current locale
        if (name == this.writableItems.title || name == this.writableItems.name || name == this.writableItems.description) {
            this.instanceiDescriptorItems.setItemValue(name, value, false, locale);
        }
        if (name == iwConstants.iDescriptorItems.availableMessageLocales) {
            this.instanceiDescriptorItems.setItemValue(name, value, false);
        }
        return this;
    },
    isReadOnly: function(name) {
        if (typeof name == "undefined" || name === null) {
            return false;
        }
        if (this.readOnlyItems[name]) {
            return true;
        }
        else {
            return false;
        }
    },
    removeItem: function(name) {
        //can't remove idescriptor items
        return null;
    },
    getAllNames: function() {
        var arr = {};
        if (this.defiDescriptorItems) {
            var defNames = this.defiDescriptorItems.getAllNames();
            for (var i in defNames) {
                if (Object.prototype.hasOwnProperty.call(defNames,i)) {
                    arr[defNames[i]] = true;
                }
            }
        }
        if (this.instanceiDescriptorItems) {
            var instanceNames = this.instanceiDescriptorItems.getAllNames();
            for (var j in instanceNames) {
                if (Object.prototype.hasOwnProperty.call(instanceNames,j)) {
                    arr[instanceNames[j]] = true;
                }
            }
        }
        var nameArr = [];
        for (var name in arr) {
            if (Object.prototype.hasOwnProperty.call(arr,name)) {
                nameArr.push(name);
            }
        }
        return nameArr;
    },
    save: function(cb) {
        return this.commit(cb);
    },
    commit: function(callbackfn) {
        //todo, what if change mode,windowstate? each are different
        if (this.serverless) {
            this._saveMicroformat();
        }
        
        //need to process event one by one, mode first
        if (this._updatedItems[iwConstants.iDescriptorItems.mode]) {
            var newMode = this._updatedItems[iwConstants.iDescriptorItems.mode];
            this.widget._handleOnModeChange(newMode);
        }
        if (this._updatedItems[iwConstants.iDescriptorItems.windowState]) {
            var newWindowState = this._updatedItems[iwConstants.iDescriptorItems.windowState];
            var oldWindowState = this._getWindowState();
            var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
            eventService.publishEvent(com.ibm.mashups.iwidget.Constants.CHANGE_WIDGETWINDOWSTATE, {
                id: this.widget.id,
                newWindowState: newWindowState,
                oldWindowState: oldWindowState
            });
        }
        
        if (callbackfn) {
            callbackfn(iwConstants.IDESCRIPTOR, true);
        }
        
    },
    _saveMicroformat: function() { //for title/description/icon
        this.widget.commit();
        var payloadObj = {};
        payloadObj.wid = this.widget.id;
        this.widget.eventSvr._publishEvent(iwConstants.EVENTS.onAttributeSaved, payloadObj, this.widget.hubId);
    },
    addListener: function(/*obj*/fn) {
        var widgetWrapper = this.widget;
        var listenerId = widgetWrapper._registerListener(iwConstants.IDESCRIPTOR, fn);
        return listenerId;
    },
    removeListener: function(/*String*/listenerId) {
        var widgetWrapper = this.widget;
        return widgetWrapper._removeListener(iwConstants.IDESCRIPTOR, listenerId);
    },
    _getWidgetDef: function() {
        return this.widget.widgetDef;
    },
    _contains: function(arr, attribute) {
        var rc = false;
        for (var i = 0; i < arr.length; i++) {
            if (attribute == arr[i]) {
                rc = true;
                break;
            }
        }
        return rc;
        
    },
    _getMessageLocale: function() {
        if (this.messageLocale) {
            return this.messageLocale;
        }
        var aLocale = null;
        var availableMessageLocales = this._getItemValue(iwConstants.iDescriptorItems.messageLocale);
        if (availableMessageLocales) {
            var locales = availableMessageLocales.split(" ");
            var configService = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
            var temp = configService.getValue(com.ibm.mashups.enabler.services.ConfigConstants.DISPLAY_LOCALE);
            if (temp) {
                aLocale = this._getLocale(locales, temp, ibmConfig.locale);
            }
        }
        if (!aLocale) {
            aLocale = ibmConfig.locale;//most of our widgets use this today
        }
        this.messageLocale = aLocale;
        return this.messageLocale;
    },
    _getLocale: function(localesArray, preferredLocale, defaultLocale) {
    
        switch (localesArray.length) {
            case 0:
                // there is no localization
                return null;
                //break; // not necessary after return
            case 1:
                // there is only one localization, so use that
                return com.ibm.mm.enabler.utils.LocaleHelper.normalizeLocale(localesArray[0]);
                //break; // not necessary after return
            default:
                var preferredMatch = com.ibm.mm.enabler.utils.LocaleHelper.matchLocale(preferredLocale, localesArray);
                if (preferredMatch) {
                    // yep, preferred was matched
                    return preferredMatch;
                }
                var defaultMatch = com.ibm.mm.enabler.utils.LocaleHelper.matchLocale(defaultLocale, localesArray);
                if (defaultMatch) {
                    // default was matched
                    return defaultMatch;
                }
                
                // nothing was matched, return first (as defaultLocale is not available) 
                return com.ibm.mm.enabler.utils.LocaleHelper.normalizeLocale(localesArray[0]);
                //break; // not necessary after return
        }
        
    }
    
});

com.ibm.mm.iwidget.manageditemset.IDescriptorImpl = com.ibm.mm.iwidget.manageditemset.IDescriptorDefaultImpl;

// IMPORTANT
// ibmConfig.enablerLayerModules is a comma separated string of all supported modules at runtime
// This section dynamically loads the Extended representation when the variable enablerLayerModules contains the given module
if ((ibmConfig.enablerLayerModules) && (dojo.indexOf(ibmConfig.enablerLayerModules, "iWidget") >= 0)) {
    dojo["require"]("com.ibm.mm.iwidget.manageditemset.IDescriptorExtendedImpl"); // JSLINT-IGNORE: This needs to be done to allow modularization and to support the minimal layer
}

}

if(!dojo._hasResource["com.ibm.mashups.iwidget.itemset.ManagedItemSet"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.iwidget.itemset.ManagedItemSet"] = true;
dojo.provide("com.ibm.mashups.iwidget.itemset.ManagedItemSet");







}

if(!dojo._hasResource["com.ibm.mashups.iwidget.itemset.PersistentAttributesFactory"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.iwidget.itemset.PersistentAttributesFactory"] = true;
dojo.provide("com.ibm.mashups.iwidget.itemset.PersistentAttributesFactory");

/**
 * @private
 * @ibm-module iWidget2
 */
dojo.declare("com.ibm.mashups.iwidget.itemset.PersistentAttributesFactory",null,  {
    /**
     * Creates persistent attributes for the specified widget and persistence mode.
     * 
     * @param {com.ibm.mashups.iwidget.widget.IWidgetWrapper} widget the widget for which to create the persistent attributes
     * @param {String} persistenceMode the persistence mode for which to create the attributes
     * @return {ManagedItemSet} the persistent attributes for the given widget / mode. 
     * If the specified mode is not supported by this method <tt>null</tt> will be returned.
     */
    createPersistentAttributes: function(widgetWrapper, persistenceMode) {
        
    },
    /**
     * Returns the persistence modes that are supported by this factory.
     * @return {String[]} the supported persistence modes.
     */
    getSupportedPersistenceMode: function() {
        
    }
});

}

if(!dojo._hasResource["com.ibm.mashups.iwidget.model.Factory_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.iwidget.model.Factory_API"] = true;
dojo.provide("com.ibm.mashups.iwidget.model.Factory_API");
dojo.provide("com.ibm.mashups.iwidget.model.Factory");

/**
 * Interface represents  iWidgetModelFactory
 * @ibm-spi
 * @ibm-module iWidget2
 */
dojo.declare("com.ibm.mashups.iwidget.model.Factory", null, {
    /**
     * @private
     */
    constructor: function() {
    
    },
    /**
     Returns  global widget model.
     @type com.ibm.mashups.iwidget.model.WidgetModel
     @returns{com.ibm.mashups.iwidget.model.WidgetModel }  Interface for WidgetModel.
     */
    getGlobalWidgetModel: function() {
    }
    
});

}

if(!dojo._hasResource["com.ibm.mm.iwidget.Constants"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.iwidget.Constants"] = true;
dojo.provide("com.ibm.mm.iwidget.Constants");

dojo.declare("com.ibm.mm.iwidget.Constants", null, {
    constructor: function() {
    },
    WIDGETEVENT_PREFIX: "widgetevents.",
    WILDCARD_PREFIX: "*.",
    mode: {
        VIEW:/*String*/ "view",//The generated markup fragment(s) should reflect normal interaction with the iWidget
        EDIT:/*String*/ "edit",//The generated markup fragment(s) should reflect iWidget interactions for editing iWidget attributes scoped to this instance of iwidget, but applicable to all users
        PERSONALIZE:/*String*/ "personalize",//The generated markup fragment(s) should reflect iWidget interactions for personalizing iwidget attributes scoped to this instance on the iWidget for this user
        CONFIG:/*String*/ "config",//The generated markup fragment(s) should reflect iWidget interactions for editing iwidget attributes scoped to all instances of the iWidget for all users		   
        HELP:/*String*/ "help"//The iWidget should generate markup fragment(s) to assist the user with interacting with the iWidget
    },
	mode_view: "view",
    mode_edit: "edit",
    mode_help: "help",
    event: {
        TITLE:/*String*/ "title",//Name for the Attribute holding event title
        DESCRIPTION:/*String*/ "description"//Name for the Attribute holding event description
    },
    ATTRIBUTES:/*String*/ "attributes", //Name for the ManagedItemSet holding the customization attributes.
    IDESCRIPTOR:/*String*/ "idescriptor", //Name for the ManagedItemSet holding the items describing the iWidget
    USERPROFILE:/*String*/ "userprofile", //Name for the ManagedItemSet holding data about the user
    windowstate: {
        NORMAL:/*String*/ "normal",
        MINIMIZE:/*String*/ "minimize",
        MAXIMIZE:/*String*/ "maximize"
    },
    status: {
        SUCCESS:/*int*/ 200,
        TIMEOUT:/*int*/ 408,
        NOTFOUND:/*int*/ 404,
        INTERROR:/*int*/ 500,
        OTHER:/*int*/ 303
    },
    changeType: {
        CHANGEDVALUE:/*String*/ "changedValue",
        NEWITEM:/*String*/ "newItem",
        REMOVEDITEM:/*String*/ "removedItem"
    },
    iDescriptorItems: {
        title: "title",
        name: "name",
        description: "description",
        defaultHeight: "defaultHeight",
        defaultWidth: "defaultWidth",
        displayLocale: "displayLocale",
        mode: "mode",
        author: "author",
        email: "email",
        website: "website",
        version: "version",
        icon: "icon",
        windowState: "windowState",
		messageLocale:"messageLocale",
		availableMessageLocales:"availableMessageLocales",
		thumbnail:"thumbnail"
    },
    IW_PREFIX: "iw-",
    IW_DEFINITION_TYPE: "iwidget",
    OSGADGET_DEFINITION_TYPE: "os-gadget",
    CSSCLASS_INSTANCE: {
        iwWidget: "iWidget",
		iwOSGadget: "OSGadget",
		iwSandbox:"Sandbox",
        iwDefinition: "Definition",
		iwEventDescription:"EventDescription",
		iwPayloadType:"PayloadType",
        iwHandled: "Handled",
		iwPublished: "Published",		
        iwDescription: "Description",
		iwTitle:"Title",
		iwEvent:"Event",
		iwDescRef:"DescRef",
		iwGlobalid:"Globalid",
		iwHandler: "Handler",
		iwNewWire: "NewWire",
		iwRemoveWire: "RemoveWire",
        iwReadOnly: "ReadOnly",
        iwItemSet: "ItemSet",
        iwItem: "Item",
        iwValue: "Value",
        iwContent: "Content",
        iwReceivedEvent: "ReceivedEvent",
        iwSourceEvent: "SourceEvent",
        iwTargetEvent: "TargetEvent",
        iwMappedName: "MappedName",
        iwStandalone: "Standalone"
    },
    
    CSSCLASS_PREFIXED_INSTANCE: { /* filled at runtime */},
    
    CSSCLASS_PERSONALIZED: "mm-Personalized",
    
    RESOURCE: {
        src: "src",
        id: "id",
        globalid: "globalid",
        mimeType: "mimeType",
        callback: "callback",
        version: "version",
		blockInit:"blockInit",
		skipLoad:"skipLoad"
    },
    EVENTS: {
        onLoad:/*String*/ "onLoad",
        onUnLoad:/*String*/ "onUnload",
        onModeChanged:/*String*/ "onModeChanged",
        onItemSetChanged:/*String*/ "onItemSetChanged",
        unloadWidget:/*String*/ "/enabler/unloadWidget",
        unSubscribeWire:/*String*/ "/enabler/unSubscribeWire",
        modeChanged:/*String*/ "modeChanged",
        onSizeChanged:/*String*/ "onSizeChanged",
        onNavStateChanged:/*String*/ "onNavStateChanged",
        onAttributeSaved:/*String*/ "com.ibm.mashups.iwidget.onAttributeSaved",
        onWindowStateChanged:/*String*/ "onWindowStateChanged",
		onIncompleteEventDescription:/*String*/"onIncompleteEventDescription"
    },
	eventservice:{
		type:{
			MAIN:"MAIN",
			IFRAME:"IFRAME"
		}
	}

});
com.ibm.mm.iwidget.Constants = new com.ibm.mm.iwidget.Constants();

(function() {
    for(var key in com.ibm.mm.iwidget.Constants.CSSCLASS_INSTANCE) {
        if(Object.prototype.hasOwnProperty.call(com.ibm.mm.iwidget.Constants.CSSCLASS_INSTANCE,key)) {
            com.ibm.mm.iwidget.Constants.CSSCLASS_PREFIXED_INSTANCE[key] = com.ibm.mm.iwidget.Constants.IW_PREFIX + com.ibm.mm.iwidget.Constants.CSSCLASS_INSTANCE[key];
        }
    }
})();


// TODO: move to legacy layer
iwConstants = com.ibm.mm.iwidget.Constants;

}

if(!dojo._hasResource["com.ibm.mashups.iwidget.widget.WireProvider"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.iwidget.widget.WireProvider"] = true;
dojo.provide("com.ibm.mashups.iwidget.widget.WireProvider");

/**
 * Interface defines functions to access handled or published event descriptions.
 * @ibm-spi
 * @ibm-module iWidget2
 */
dojo.declare("com.ibm.mashups.iwidget.widget.WireProvider", null, {
    /**
     * @private
     */
    constructor: function(id) {
    
    },
    /**
     This method returns an array of supported wires.
     @type com.ibm.mashups.iwidget.widget.Wire[]
     @returns{com.ibm.mashups.iwidget.widget.Wire[] }  array of Wire this iWidget is wired as  target .
     */
    getWires: function() {
    }
});

}

if(!dojo._hasResource["com.ibm.mashups.iwidget.widget.EventProvider"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.iwidget.widget.EventProvider"] = true;
dojo.provide("com.ibm.mashups.iwidget.widget.EventProvider");



/**
 * Interface defines functions to access handled or published event descriptions.
 * @ibm-spi
 * @ibm-module iWidget2
 */
dojo.declare("com.ibm.mashups.iwidget.widget.EventProvider", null, {
    /**
     * @private
     */
    constructor: function() {
    
    },
    /**
     This method returns an array of event description. Only published event of this widget will be returned.
     @type {com.ibm.mashups.iwidget.IEventDescription}
     @returns{com.ibm.mashups.iwidget.IEventDescription[] }  array of event description
     */
    getWidgetPublishedEvents: function() {
    },
    
    /**
     This method returns an array of event description. Only handled event of this widget will be returned.
     @type {com.ibm.mashups.iwidget.IEventDescription[]}
     @returns{com.ibm.mashups.iwidget.IEventDescription[] }  array of event description
     */
    getWidgetHandledEvents: function() {
    },
    /**
     This method returns the required event.
     @param {String}name name of required public event
     @type {com.ibm.mashups.iwidget.IEventDescription}
     @returns{com.ibm.mashups.iwidget.IEventDescription }  an event description it returns NULL if event can't be found.
     */
    getPublicEvent: function(name) {
    }
    
});

}

if(!dojo._hasResource["com.ibm.mashups.iwidget.widget.Properties_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.iwidget.widget.Properties_API"] = true;
dojo.provide("com.ibm.mashups.iwidget.widget.Properties_API");
dojo.provide("com.ibm.mashups.iwidget.widget.Properties");

/**
 * Interface defines functions to iterates , updates and persist Properties.
 * @ibm-spi
 * @ibm-module iWidget2
 */
dojo.declare("com.ibm.mashups.iwidget.widget.Properties", null, {
    /**
     * @private
     */
    constructor: function() {
    },
    /**
     * This method returns the value of the required item
     * @param{String} itemName name of the item.Must never be NULL.
     * @param{String} locale the locale of the value to fetch. if locale isn't defined, the
     *                <code>DEFAULT_LOCALE</code> will be used
     * @return{String}  return the  value of required item
     */
    getItemValue: function(/*String*/itemName, locale) {
    
    },
    /**
     * This method returns an array of Strings,providing the name of each item.
     * @return{String[]}  return an array of items names and return NULL if the set contains no item
     */
    getAllNames: function() {
        return null;
    },
    
    /**
     * This methods returns the locales for the item specified by <code>itemName</code>
     * @param{String} itemName the name of the item for which do get the locales.
     * @return{String[]} return an array of locales valid for the specified itemName, returns an empty array if no localized item values are available.
     */
    getItemLocales: function(itemName) {
    },
    /**
     * This method allows the caller to check whether a specific item is readOnly or not.
     * @param{String} itemName the item name of the item to check readOnly
     * @return{Boolean} <code>true</code> if the item exists and is read only, <code>false</code> otherwise.
     */
    isReadOnly: function(itemName) {
    }
});

}

if(!dojo._hasResource["com.ibm.mm.iwidget.widget.PropertiesImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.iwidget.widget.PropertiesImpl"] = true;
dojo.provide("com.ibm.mm.iwidget.widget.PropertiesImpl");





dojo.declare("com.ibm.mm.iwidget.widget.PropertiesImpl", com.ibm.mashups.iwidget.widget.Properties, {
    DELETE_TOKEN: "com.ibm.mm.iwidget.widget.DELETE_TOKEN",
    TYPE_NEW: "newItem",
    TYPE_UPDATE: "updatedValue",
    TYPE_REMOVE: "removedItem",
    /**
     * @param items {ItemSet JSON} the items this Properties class is based on
     * @param defaultProps {Properties} The default properties object
     **/
    constructor: function(items, defaultProps) {
        this._defaultProperties = defaultProps;
        
        // create the new object
        this._items = {};
        
        if (items) {
            this._items = items;
        }
        
        this._localizedItems = {};
        // define the default locale of this properties set
        this.DEFAULT_LOCALE = ibmConfig[com.ibm.mashups.enabler.services.ConfigConstants.DEFAULT_LOCALE];
        if (!this.DEFAULT_LOCALE) {
            this.DEFAULT_LOCALE = "en";
        }
    },
    /**
     * Internal method which can be used by ENABLER components for determining the default locale of an Properties Element
     */
    _getItemDefaultLocale: function(itemName) {
        var defLocale = null;
        
        if (this._items[itemName]) {
            if (this._items[itemName].defaultLocale) {
                defLocale = this._items[itemName].defaultLocale;
            }
        }
        if (!defLocale) {
            defLocale = null;
        }
        return defLocale;
    },
	getLocalizedItemValue:function(itemName,locale){
		//internal function, used by private ItemSet
		//no fallback to default locale
		if (!itemName || !locale) {
			return;
		}
		if (!(itemName in this._items) && !this._defaultProperties) {
            return null;
        }
		var item = this._items[itemName];
        var value = null;        
       
        if (!item.values) {
            return null;
        }
        
        var matchLocales = [];
        for (var i in item.values) {
            if (Object.prototype.hasOwnProperty.call(item.values,i)) {
                matchLocales.push(i);
            }
        }
        
        var normalizedLocale;
        
        // check if we have a value for the specified locale
        normalizedLocale = com.ibm.mm.enabler.utils.LocaleHelper.matchLocale(locale, matchLocales);
		for (var i in item.values) {
			if (normalizedLocale == com.ibm.mm.enabler.utils.LocaleHelper.normalizeLocale(i)) {
				value = item.values[i];
				break;
			}
		}
        if (value == this.DELETE_TOKEN) {
            return null;
        }
		return value;
	},
    getItemValue: function(itemName, locale) {
        // if we don't have an item and don't have default properties, we can exit right away
        if (!(itemName in this._items) && !this._defaultProperties) {
            return null;
        }
        
        // if we don't have the item we can delegate to default props (which we checked earlier)
        if (!(itemName in this._items)) {
            return this._defaultProperties.getItemValue(itemName, locale);
        }
        
        // seems we have an item, so let's do the magic
        var item = this._items[itemName];
        var value = null;
        
        if ((typeof locale == "undefined" || locale === null) && typeof item.value != "undefined" && item.value !== null) {
            if (item.value == this.DELETE_TOKEN) {
                return null;
            }
            return item.value;
        }
        if (!item.values) {
            return null;
        }
        
        var matchLocales = [];
        for (var i in item.values) {
            if (Object.prototype.hasOwnProperty.call(item.values,i)) {
                matchLocales.push(i);
            }
        }
        
        var normalizedLocale;
        
        // check if we have a value for the specified locale
        if (locale) {
            normalizedLocale = com.ibm.mm.enabler.utils.LocaleHelper.matchLocale(locale, matchLocales);
			for (var i in item.values) {
				if (normalizedLocale == com.ibm.mm.enabler.utils.LocaleHelper.normalizeLocale(i)) {
					value = item.values[i];
					break;
				}
			}
        }
        
        // test the default locale of the item
        if (item.defaultLocale && value === null) {
            normalizedLocale = com.ibm.mm.enabler.utils.LocaleHelper.matchLocale(item.defaultLocale, matchLocales);
			for (var i in item.values) {
				if (normalizedLocale == com.ibm.mm.enabler.utils.LocaleHelper.normalizeLocale(i)) {
					value = item.values[i];
					break;
				}
			}
        }
        
        // test the default of the sytem
        if (this.DEFAULT_LOCALE && value === null) {
            normalizedLocale = com.ibm.mm.enabler.utils.LocaleHelper.matchLocale(this.DEFAULT_LOCALE, matchLocales);
			for (var i in item.values) {
				if (normalizedLocale == com.ibm.mm.enabler.utils.LocaleHelper.normalizeLocale(i)) {
					value = item.values[i];
					break;
				}
			}
        }
        
        // otherwise the first locale wins
        if (value === null) {
            for (var lang in item.values) {
                if (Object.prototype.hasOwnProperty.call(item.values,lang)) {
                    value = item.values[lang];
                    break;
                }
            }
        }
        
        if (value == this.DELETE_TOKEN) {
            return null;
        }
        
        return value;
    },
    getItemLocales: function(itemName) {
        var locales = [];
        
        if (itemName in this._items && this._items[itemName].values) {
            for (var locale in this._items[itemName].values) {
                if (Object.prototype.hasOwnProperty.call(this._items[itemName].values,locale)) {
                    locales.push(locale);
                }
            }
        }
        /*if (itemName in this._items && this._items[itemName].value) {
            locales.push("");
        }*/
        if (locales.length === 0) {
            return null;
        }
        return locales;
    },
    getAllNames: function() {
		//return empty array if there's no item
        var defaultNames = [];
        if (this._defaultProperties) {
            defaultNames = this._defaultProperties.getAllNames();
        }
        
        var mergedItems = {};
        
        for (var i = 0; i < defaultNames.length; i++) {
            mergedItems[defaultNames[i]] = null;
        }
        
        for (var itemName in this._items) {
            if (this._items[itemName] && this._items[itemName]._change && this._items[itemName]._change.changeType == this.TYPE_REMOVE) {
                if (itemName in mergedItems) {
                    delete mergedItems[itemName];
                }
            }
            else {
                mergedItems[itemName] = null;
            }
        }
        
        var names = [];
        
        for (var itemName2 in mergedItems) {
            if (Object.prototype.hasOwnProperty.call(mergedItems,itemName2)) {
                names.push(itemName2);
            }
        }
        
        return names;
    },
    isReadOnly: function(itemName) {
        var item = this._items[itemName];
        return (this._defaultProperties && this_defaultProperties.isReadOnly(itemName)) ||
            (item && item.readOnly);
    }
});

}

if(!dojo._hasResource["com.ibm.mashups.iwidget.widget.Properties"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.iwidget.widget.Properties"] = true;
dojo.provide("com.ibm.mashups.iwidget.widget.Properties");




}

if(!dojo._hasResource["com.ibm.mashups.iwidget.widget.PropertiesProvider"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.iwidget.widget.PropertiesProvider"] = true;
dojo.provide("com.ibm.mashups.iwidget.widget.PropertiesProvider");


/**
 * Read-Only interface defines functions to access properties that's defined with iWidget.
 * @ibm-spi
 * @ibm-module iWidget2
 */
dojo.declare("com.ibm.mashups.iwidget.widget.PropertiesProvider", null, {
    /**
     * @private
     */
    constructor: function() {
    },
    /**
     This method returns an object that contains iDescriptor items as defined by iWidget spec. It contains  default title and icon
     @type com.ibm.mashups.iwidget.widget.Properties
     @returns{com.ibm.mashups.iwidget.widget.Properties } object that contains iWidget  iDescriptor items information
     */
    getIDescriptorItems: function() {
    },
    /**
     This method returns an object that contains attributes as defined by iWidget spec.
     @type com.ibm.mashups.iwidget.widget.Properties
     @returns{com.ibm.mashups.iwidget.widget.Properties } object that contains iWidget  iDescriptor items information
     */
    getAttributes: function() {
    }
});

}

if(!dojo._hasResource["com.ibm.mashups.iwidget.widget.IWidgetDefinition_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.iwidget.widget.IWidgetDefinition_API"] = true;
dojo.provide("com.ibm.mashups.iwidget.widget.IWidgetDefinition_API");
dojo.provide("com.ibm.mashups.iwidget.widget.IWidgetDefinition");

/**
 * Interface defines functions to access all the data object in widget definition. PropertiesProvider is not implemented.
 * @ibm-spi
 * @ibm-module iWidget2
  */
dojo.declare("com.ibm.mashups.iwidget.widget.IWidgetDefinition",[com.ibm.mashups.iwidget.widget.EventProvider,com.ibm.mashups.iwidget.widget.PropertiesProvider],{
  	/**
            * @private
            */	
    constructor:function(){
 
	},
/**
This method returns an array of supported modes such as "view" and "edit".
@returns{String[] }  array of supported modes this iWidget supports.
*/				  
    getSupportedModes:function(){
    },    

/**
This method returns a  JSON based spec compliant object that represents all the data that's defined in widget xml.<p/>
Rule to follow:<br/>
1. Element -- "iw:iwidget" is considered to be root Element and a root object is created from here.<p/>
2. Any  attribute of this element will be a field in the root object. '_' will be added as prefix to field names.<br/>
   ":" within any namespaced attribute will be replaced with "_". 
<code>&lt;iw:iwidget id="map" xml:base="/root/test/" allowInstanceContent="false"......&gt;</code><br/>
{ _id:"map",_xml_base:"/root/test/",_allowInstanceContent:"false"......}<p/>
3. All repreatable elements, element name (append with "s") is used as a field name and an object is created to contain all the repeatable elements.
Within that object, value of "id" attribute is used as field name for an individual element if id attribute is available.<br/>
{<br/>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;resources:{<br/>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"myId":{_id:"myId",_src:"my.js"},<br/>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;		"myOtherId":{_id:"myOtherId",_src:"my2.js"}<br/>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;		}<br/>
}<p/>
4. For "iw:content" elements, "contents" is used as the key in the parent object and an object is created to contain all the content elements.<br/>
For each "content" element, "mode" attribute is used  as the key and CDATA section is saved as the value.<br/>
{<br/>
&nbsp;&nbsp;&nbsp;contents:{<br/>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; "view": {<br/>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; "_mode": "view",<br/>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; "value": "mycontent"<br/>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; }<br/>
&nbsp;&nbsp;&nbsp; }<br/>	 
}<p/>
5. For "iw:alt" elements,"alts" is used as the key in parent object and an object is created to contain all the alt elements.<br/>
For each "alt" element, "lang" attribute is used  as the key and  all the attributes are saved per attributes convention.<br/>
eventDescname:{<br/>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;_id:"eventDescnname",<br/>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;_payloadType:"payloadType",<br/>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;alts:{<br/>
	&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"en":{_lang:'en',_description:"description",_descriptionURI:"descriptionURI"},<br/>
	&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"zh":{_lang:'zh',_description:"description",_descriptionURI:"descriptionURI"}<br/>
        &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<br/>
}<p/>
An example of simple iWidget and  the return result.<br/>
<code>&lt;iw:iwidget id="stock" xmlns:iw="http://www.ibm.com/xmlns/prod/iWidget" iScope="stock" allowInstanceContent="true" supportedModes="view edit " mode="view" lang="en"></code><br/>
&nbsp;&nbsp;&nbsp;<code> &lt;iw:itemSet id="attributes" private="true" onItemSetChanged="changeItemSet"&gt;</code><br/>
 &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<code> &lt;iw:item id="broker"  readOnly="false"    value="Etrade" /&gt;</code><br/>
 &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<code> &lt;iw:item id="company"  value="IBM" /&gt;</code><br/>
 &nbsp;&nbsp;&nbsp;<code>&lt;/iw:itemSet&gt;</code><br/>
 &nbsp;&nbsp;&nbsp;<code> &lt;iw:event id="sendStockData" eventDescName="sendStockDataDesc"  published="true" onNewWire="sendData" /&gt; </code><br/> 
 &nbsp;&nbsp;&nbsp;<code> &lt;iw:eventDescription  id="sendStockDataDesc"  payloadType="stockData" title="Send stock data"  lang="en"  &gt;</code><br/>
   &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<code>&lt;iw:alt title="Send stock data"  lang="en" /&gt; </code><br/>
  &nbsp;&nbsp;&nbsp;<code>&lt;/iw:eventDescription&gt;</code><br/>
 &nbsp;&nbsp;&nbsp;<code>&lt;iw:resource src="stock.js" id="stock" /&gt;</code><br/>
  &nbsp;&nbsp;&nbsp;<code>&lt;iw:content mode="view"&gt;
        &lt;![CDATA[    
          mycontent
            ]]&gt;
     &lt;/iw:content&gt;</code><br/> 
  &nbsp;&nbsp;&nbsp;<code>&lt;/iw:iwidget&gt;</code><p/>
  
  Example of returnin json object. <br/>
  <code>
  {  _id:"map",_allowInstanceContent:"true",_iScope:"stock",_supportedModes:"view edit",_mode:"view",_lang:"en",<br/>
      &nbsp;&nbsp;&nbsp; itemSets:{<br/>
	       &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"attributes":{  _id:"attributes", _private:"true",_onItemSetChanged:"changedItemSet",<br/>
	        &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;                  items:{ <br/>
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  			"broker":{  _id:"broker",_readOnly:"false", _value:"Etrade"},<br/>
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  			"company":{ _id:"company",_value;"IBM"} <br/>
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;		     }<br/>
	&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;	            }<br/>
     &nbsp;&nbsp;&nbsp;},<br/>
           &nbsp;&nbsp;&nbsp;events:{ <br/>
	        &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"sendStockData":{  _id:"sendStockData", _eventDescName:"sendStockDataDesc", _published:"true",_onNewWire:"sendData"}<br/>
	 &nbsp;&nbsp;&nbsp;},<br/>
           &nbsp;&nbsp;&nbsp;eventDescriptions:{<br/>
	        &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"sendStockDataDesc":{ _id:"sendStockDataDesc", _payloadType:"stockData",_title:"Send stock data",_lang:"en",<br/>
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  	                    alts:{<br/>
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;  			        "en":{ _lang:"en",_title:"Send stock data"}	<br/>		
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  			      }	<br/>	
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;			}<br/>	  
	&nbsp;&nbsp;&nbsp;		    },<br/>
         &nbsp;&nbsp;&nbsp; resources:{<br/>	
		       &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"stock":{ _id:"stock", _src:"stock.js"}<br/>
	&nbsp;&nbsp;&nbsp;},<br/>
           &nbsp;&nbsp;&nbsp;contents:{<br/>
    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; "view": {<br/>
    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; "_mode": "view",<br/>
    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; "value": "mycontent"<br/>
    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; }<br/>
    &nbsp;&nbsp;&nbsp; }<br/>	 
  }<br/>
  </code>

@returns{object} a JSON based, spec compliant object that represents all the data that's defined in widget.xml
*/
    toSpecObject:function(){
    }
});

}

if(!dojo._hasResource["com.ibm.mm.iwidget.widget.IWidgetDefinitionDefaultImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.iwidget.widget.IWidgetDefinitionDefaultImpl"] = true;
dojo.provide("com.ibm.mm.iwidget.widget.IWidgetDefinitionDefaultImpl");





//no support on EventProvider, 
//todo toSpecObject should just return the json object
dojo.declare("com.ibm.mm.iwidget.widget.IWidgetDefinitionDefaultImpl", com.ibm.mashups.iwidget.widget.IWidgetDefinition, {
    namespaces: {
        "iw": "http://www.ibm.com/xmlns/prod/iWidget"
    },
    reservedAttributes: {
        iScope: "iScope",
        supportedModes: "supportedModes",
        id: "id",
        allowInstanceContent: "allowInstanceContent",
        lang: "language",
		"xml_lang":"_xml_lang",
        "xmlns_iw": "_xmlns_iw",
        supportedWindowStates: "supportedWindowStates",
        "xml_base": "_xml_base",
		sandbox:"sandbox"
    },
    
    constructor: function(/*/object*/widgetDef, xmlStr, specObject) {
        this.widgetDef = widgetDef; //xmlStr is now widgetDef.xmlStr, xmlData is rarely used so only load when it's called in toSpec function.
        if (xmlStr) {
            this.xmlStr = xmlStr;
        }
        if (specObject) {
            this.specObject = specObject;
            this._specObjectToWidgetDef();
        }
    },
    getXmlBase: function() {
        if (this.widgetDef.xmlBase) {
            return this.widgetDef.xmlBase;
        }
        return null;
    },
    getAllowInstanceContent: function() {
        return this.widgetDef.allowInstanceContent;
    },
    getResources: function() {
        if (!this.resources) {
            this.resources = [];
        }
        return this.resources;
    },
    getIScope: function() {
        return this.widgetDef.iScope;
    },
    getWidgetEvents: function() {
        return this.widgetDef.widgetEvents;
    },
    getMarkupByMode: function(mode) {
        if (this.widgetDef.markup) {
            if (!mode) {
                mode = "view";
            }
            var temp = this.widgetDef.markup[mode];
            return temp;
        }
        else {
            return null;
        }
    },
    setMarkupByMode: function(mode, elem) {
        if (this.widgetDef.markup) {
            if (!mode) {
                mode = "view";
            }
            this.widgetDef.markup[mode] = elem; //simple replacement
            return this;
        }
        return null;
    },
    _getManagedItemSetListener: function(itemsetname) {
        if (!itemsetname) {
            return null;
        }
        if (itemsetname != iwConstants.ATTRIBUTES && itemsetname != iwConstants.IDESCRIPTOR) {
            return null;
        }
		if (this.widgetDef.itemSetsArr) {
			var defAttrItemSet = this.widgetDef.itemSetsArr[itemsetname];
			if (defAttrItemSet && defAttrItemSet.onItemSetChanged) {
				return defAttrItemSet.onItemSetChanged;
			}
		}
        return null;
    },
    _getManagedItemSetItems: function(itemsetname, simpleAttributes) {
        var properties = {};
		if (this.widgetDef.itemSetsArr) {
			var defAttrItemSet = this.widgetDef.itemSetsArr[itemsetname];
			if (defAttrItemSet) {
				for (var itemName in defAttrItemSet.items) {
					if (Object.prototype.hasOwnProperty.call(defAttrItemSet.items, itemName)) {
						properties[itemName] = defAttrItemSet.items[itemName]; // the new internal json itemset notation is compatible with the SPI
					}
				}
			}
		}
        // determine the default locale for fallback
        /*var lang = ibmConfig[com.ibm.mashups.enabler.services.ConfigConstants.DEFAULT_LOCALE];
         if (!lang)
         lang = "en";*/
        simpleAttributes = simpleAttributes || null;
        if (simpleAttributes) {
            for (var attName in simpleAttributes) {
                if (Object.prototype.hasOwnProperty.call(simpleAttributes,attName)) {
                    var value = simpleAttributes[attName];
                    if (typeof value != "undefined" && value !== null) {
                        var property = {};
                        //property.defaultLocale = lang;
                        property.readOnly = false;
                        //property.values = {};
                        //property.values[lang] = value;    
                        property.value = value;
                        property.id = attName;
                        properties[attName] = property;
                    }
                }
            }
        }
        return new com.ibm.mm.iwidget.widget.PropertiesImpl(properties);
    },
    /**
     * PropertiesProvider Impl
     */
    getAttributes: function() {
        if (!this.attributeProperties) {
            this.attributeProperties = this._getManagedItemSetItems(iwConstants.ATTRIBUTES, this.widgetDef.simpleAttributes);
        }
        return this.attributeProperties;
    },
    /**
     * PropertiesProvider Impl
     */
    getIDescriptorItems: function() {
        if (!this.idescriptorProperties) {
            this.idescriptorProperties = this._getManagedItemSetItems(iwConstants.IDESCRIPTOR, this.widgetDef.iDescriptor);
        }
        return this.idescriptorProperties;
    },
    getAllItemSetNames: function() {
        var names = [];
        if (!this.widgetDef.itemSetsArr) {
            return names;
        }
        
        for (var itemName in this.widgetDef.itemSetsArr) {
            if (Object.prototype.hasOwnProperty.call(this.widgetDef.itemSetsArr,itemName)) {
                var itemSetWrapper = this.widgetDef.itemSetsArr[itemName];
                if (typeof(itemSetWrapper) != "undefined" && itemName != iwConstants.ATTRIBUTES && itemName != iwConstants.IDESCRIPTOR) {
                    names.push(itemSetWrapper.id);
                }
            }
        }
        return names;
    },
    getItemSet: function(/*String*/name) {
        if (name == "attributes") {
            return this.getAttributes();
        }
        var itemSetWrapper = this.widgetDef.itemSetsArr[name] || null;
        if (!itemSetWrapper) {
            return null;
        }
        return itemSetWrapper;
    },
    getWidgetId: function() {
        return this.widgetDef.id;
    },
    getWidgetName: function() {
        return this.widgetDef.id;
    },
    getPayloadDefs: function() {
        return null;
    },
    getPayloadDef: function(name) {
        return null;
    },
    getPayloadDefNames: function() {
        var arr = [];
        return arr;
    },
    getSupportedModes: function() {
        var temp = this.widgetDef.supportedModes;
        if (!temp) {
            return null;
        }
        var arr = temp.split(" ");
        return arr;
    },
    getSupportedWindowStates: function() {
        var temp = this.widgetDef.supportedWindowStates;
        if (!temp) {
            return null;
        }
        var arr = temp.split(" ");
        return arr;
    },
    getDefaultLanguage: function() {
        return this.widgetDef.lang;
    },
    getMarkup: function() {
        return this.widgetDef.markup;
    },
    _specObjectToWidgetDef: function() {
        this.widgetDef = {};
        if (null === this.specObject) {
            return;
        }
        // id
		var temp = this.specObject._id;
        if (!temp) {
            temp = this.specObject._name;
        }
		this.widgetDef.id = null;
		this.widgetDef.name = null;
		if (temp){
			this.widgetDef.id = temp;
			this.widgetDef.name = temp;
		}
        // allowInstanceContent
        this.widgetDef.allowInstanceContent = false;
        temp = this.specObject._allowInstanceContent;
        if (temp && temp == "true") {
            this.widgetDef.allowInstanceContent = true;
        }
        // iScope
        temp = this.specObject._iScope;
        this.widgetDef.iScope = null;
        if (temp) {
            this.widgetDef.iScope = temp;
        }
        // supportedModes
        temp = this.specObject._supportedModes;
        if (!temp) {
            temp = "view";
        }
        this.widgetDef.supportedModes = temp;
        
        // supportedWindowStates
        temp = this.specObject._supportedWindowStates;
        if (!temp) {
            temp = "normal";
        }
        this.widgetDef.supportedWindowStates = temp;
        
        // lang
        temp = this.specObject._lang;
        if (!temp) {
            temp = this.specObject._xml_lang;			
        }
		if (!temp){
			temp = "en";	
		}
        this.widgetDef.lang = temp;
		
		// xml:base
		temp = this.specObject._xml_base;
		if (temp){
			this.widgetDef.xmlBase = temp;
		}
        
        // iDescriptor
        var iDescriptorItems = iwConstants.iDescriptorItems;
        var iDescriptor = {};
        for (var i in iDescriptorItems) {
            if (Object.prototype.hasOwnProperty.call(iDescriptorItems,i)) {
                var name = iDescriptorItems[i];
                var value = this.specObject['_' + name];
				if (typeof value == "undefined") {
					value = null;
				}
                iDescriptor[name] = value;
            }
        }
        
        this.widgetDef.iDescriptor = iDescriptor;
        
        // simple attributes and widget events
        var simpleAttributes = {};
        var widgetEvents = {};
        for (var j in this.specObject) {
            if (Object.prototype.hasOwnProperty.call(this.specObject,j)) {
                // only root level attributes
                if (0 !== j.indexOf('_')) {
                    continue;
                }
                var attr = j;
                attr = attr.substr(1);
                if (attr.indexOf("on") !== 0 && !iwConstants.iDescriptorItems[attr] && !this.reservedAttributes[attr]) {
					simpleAttributes[attr] = this.specObject[j];
                }
                else if (attr.indexOf("on") === 0) {
                    widgetEvents[attr] = this.specObject[j];
                }
            }
        }
        this.widgetDef.simpleAttributes = simpleAttributes;
        this.widgetDef.widgetEvents = widgetEvents;
        
        // markup
        this.widgetDef.markup = this._extractMarkupFromSpecObject();
        
        // itemSets
        var itemSets = this._extractItemSetsFromSpecObject(this.widgetDef);
        if (null !== itemSets) {
            this.widgetDef.itemSetsArr = itemSets;
        }
        
        // public events
        this.widgetDef.publicEvents = this._extractEventsFromSpecObject();
        
        // resources
        this.widgetDef.resources = this._extractResourcesFromSpecObject();
        
        // payload defs
        // this.widgetDef.payloadDefs = this._extractPayloadDefsFromSpecObject();
        
        // event descriptions
        this.widgetDef.eventDescriptions = this._extractEventDescFromSpecObject();
    },
    // never used
	//    _extractEventsFromSpecObject: function() {
	//        // widget events
	//        var widgetEvents = {};
	//        for (var i in this.specObject) {
	//            var handler = this.specObject[i];
	//            if (typeof handler != "undefined" && handler != null) {
	//                widgetEvents[event.name] = handler;
	//            }
	//        }
	//        return widgetEvents;
	//    },
    _extractMarkupFromSpecObject: function() {
        var contents = this.specObject.contents;
        var widgetDefContents = {};
        for (var mode in contents) {
            if (Object.prototype.hasOwnProperty.call(contents,mode)) {
                if (contents[mode]) {
					widgetDefContents[mode] = {};
					if (contents[mode]._uri) {
						widgetDefContents[mode].uri = contents[mode]._uri;
					}
					if (contents[mode].value) {
						widgetDefContents[mode].content = contents[mode].value;
					}
				}
            }
        }
        return widgetDefContents;
    },
    _extractItemSetsFromSpecObject: function(widgetDef) {
        var itemSets = this.specObject.itemSets;
        if (itemSets) {
            var itemSetsArr = {};
            var shareableItemSetsArr = {};
            for (var i in itemSets) {
                if (Object.prototype.hasOwnProperty.call(itemSets,i)) {
                    var itemSet = itemSets[i];
                    var id = i;
                  
                    var onItemSetChanged = itemSet._onItemSetChanged;
                    var temp = itemSet._private;
                    var isPrivate = true;
                    if (temp && temp == "false") {
                        isPrivate = false;
                    }
					var alias = itemSet._alias?itemSet._alias:null;
                    
                    var descriptionRef = itemSet._description;
                    
                    var itemSetWrapper = {
                        id: id,
                        onItemSetChanged: onItemSetChanged,
                        isPrivate: isPrivate
                    };
                
					if (alias){
						itemSetWrapper.alias = alias;
					}
                    itemSetWrapper.items = {};
                    
                    var items = itemSet.items; // WARNING: this assumes that an itemset only contains items !
                    for (var j in items) {
                        if (Object.prototype.hasOwnProperty.call(items,j)) {
                            var item = items[j];
                            var readOnly = false;
                            var readOnlyAtt = item._readOnly;
                            
                            if (readOnlyAtt && readOnlyAtt == "true") {
                                readOnly = true;
                            }
                            
                            var id2 = item._id;
							var alias2 = item._alias?item._alias:null;
                           
                            var value = item._value;
                            var lang = item._lang;
							if (!lang){
								lang = item._xml_lang;
							}
                                                  
                            var anItem = {};
                            anItem.id = id2;
                           
							if (alias2){
								anItem.alias = alias2;
							}
                            anItem.readOnly = readOnly;
                            if (lang) {
								anItem.defaultLocale = lang;
							}
							//value could be ""
							if (typeof value != "undefined" && value !== null && !lang) {
								anItem.value = value;
							}
							if (typeof value != "undefined" && value !== null  && lang){
								anItem.values = {};
								anItem.values[lang]=value;
							}
							
                            var values = item.alts;
                            for (var v in values) {
                                if (Object.prototype.hasOwnProperty.call(values,v)) {
                                    var valueNode = values[v];
                                    var locale = v;
                                    var localeValue = valueNode._value;
									if (!anItem.values) {
										anItem.values = {};
									}
                                    anItem.values[locale] = localeValue;
									// if default value for default locale is defined in alts, remove default value here so no duplicates
									if (lang && locale == lang && anItem.value){
										delete anItem.value; 
									}
									
                                }
                            }
                            
                            itemSetWrapper.items[id2] = anItem;
                        }
                    }
                    
                    if (isPrivate === true) {
                        itemSetsArr[id] = itemSetWrapper;
                    }
                    else {
                        shareableItemSetsArr[id] = itemSetWrapper;
                    }
                }
            }
            widgetDef.shareableItemSetsArr = shareableItemSetsArr;
            return itemSetsArr;
        }
        return null;
    },
    _extractEventsFromSpecObject: function() {
        var events = this.specObject.events;
        var eventsArray = {};
        if (events && events.length !== 0) {
            for (var j in events) {
                if (Object.prototype.hasOwnProperty.call(events,j)) {
                    var event = events[j];
                    //todo. handler attributes
                    var iEvent = {};
                    for (var i in event) {
                        if (Object.prototype.hasOwnProperty.call(event,i)) {
                            var name = i;
                            if (0 === i.indexOf('_')) {
                                name = name.substr(1);
                            }
                            var value = event[i];
                            if (name == "eventDescName") {
                                name = "description"; //backward compatibility
                            }
                            if (name == "handled") {
                                name = "isHandled"; //align with js representation
                            }
                            if (name == "published") {
                                name = "isPublished"; //align with js representation
                            }
                            if (value) {
                                iEvent[name] = value;
                            }
                        }
                    }
                    eventsArray[iEvent.id] = iEvent;
                }
            }
        }
        return eventsArray;
    },
    _extractResourcesFromSpecObject: function() {
        var resources = [];
        var nodes = this.specObject.resources;
        var j = 0;
        if (nodes && nodes.length !== 0) {
            for (var i in nodes) {
                if (Object.prototype.hasOwnProperty.call(nodes,i)) {
                    var node = nodes[i];
                    var resource = {};
					var id = node._id;
					if (!id) {
						id = node._globalid;
					}
	
                    resource[iwConstants.RESOURCE.id] = id?id:null;
                    var src = node._src;
                    if (!src) {
                        src = node._uri;
                    }
				
                    resource[iwConstants.RESOURCE.src] = src;
                    resource[iwConstants.RESOURCE.version] = node._version?node._version:null;
                    resource[iwConstants.RESOURCE.callback] = node._callback?node._callback:null;
                    resource[iwConstants.RESOURCE.mimeType] = node._mimeType?node._mimeType:null;
					resource[iwConstants.RESOURCE.blockInit] = node._blockInit?node._blockInit:null;
					resource[iwConstants.RESOURCE.globalid] = node._globalid?node._globalid:null;
					resource[iwConstants.RESOURCE.skipLoad] = node._skipLoad?node._skipLoad:null;
				    resources[j] = resource;
                    j++;
                }
            }
        }
        return resources;
    },
    _extractPayloadDefsFromSpecObject: function() {
        var payloadDefsArr = {};
        var payloadDefs = this.specObject.payloadDefs;
        for (var i in payloadDefs) {
            if (Object.prototype.hasOwnProperty.call(payloadDefs,i)) {
                var aNode = payloadDef[i];
                // MDG to do fix!
                // var payloadDef = com.ibm.mm.iwidget.Utils.getPayloadDef(aNode);
                //payloadDefsArr[i]=payloadDef;
            }
        }
    },
	//todo!
    _extractEventDescFromSpecObject: function() {
        var eventDescriptions = {};
        var eventDescs = this.specObject.eventDescriptions;
        if (eventDescs && eventDescs.length !== 0) {
            for (var i in eventDescs) {
                if (Object.prototype.hasOwnProperty.call(eventDescs,i)) {
                    var node = eventDescs[i];
                    var eventDescription = {};
                    var id = i;
                    eventDescription.id = id;
                    eventDescription.payloadType = node._payloadType;
                    eventDescription.description = node._description;
                    eventDescription.title = node._title;
                    eventDescription.descriptionURI = node._descriptionURI?node._descriptionURI:null;
					//eventDescription.aliases = node._aliases?node._aliases:null;
					var lang = node._lang;
					if (!lang ){
						lang = node._xml_lang;
					}
                    if (lang) {
						eventDescription.lang = lang;
					}
                    
                    var children = node.alts;
                    for (var j in children) {
                        if (Object.prototype.hasOwnProperty.call(children,j)) {
                            var aNode = children[j];
                            var temp = {};
                            temp.description = aNode._description;
                            temp.title = aNode._title;
                            temp.descriptionURI = aNode._descriptionURI?aNode_descriptionURI:null;
							if (!eventDescription.descriptions){
								eventDescription.descriptions = {};
							}
                            eventDescription.descriptions[j] = temp;
                        }
                    }
                    eventDescriptions[id] = eventDescription;
                }
            }
        }
        return eventDescriptions;
    },
    toSpecObject: function() {
        if (this.specObject) {
            return this.specObject;
        }
        var outputJSON = {};
        return outputJSON;
    }
});

com.ibm.mm.iwidget.widget.IWidgetDefinitionImpl = com.ibm.mm.iwidget.widget.IWidgetDefinitionDefaultImpl;

// IMPORTANT
// ibmConfig.enablerLayerModules is a comma separated string of all supported modules at runtime
// This section dynamically loads the Extended representation when the variable enablerLayerModules contains the given module
if ((ibmConfig.enablerLayerModules) && (dojo.indexOf(ibmConfig.enablerLayerModules, "iWidget") >= 0)) {
    dojo["require"]("com.ibm.mm.iwidget.widget.IWidgetDefinitionExtendedImpl"); // JSLINT-IGNORE: This needs to be done to allow modularization and to support the minimal layer
}

}

if(!dojo._hasResource["com.ibm.mashups.iwidget.widget.IWidgetDefinition"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.iwidget.widget.IWidgetDefinition"] = true;
dojo.provide("com.ibm.mashups.iwidget.widget.IWidgetDefinition");






}

if(!dojo._hasResource["com.ibm.mashups.iwidget.widget.ModifiableProperties_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.iwidget.widget.ModifiableProperties_API"] = true;
dojo.provide("com.ibm.mashups.iwidget.widget.ModifiableProperties_API");
dojo.provide("com.ibm.mashups.iwidget.widget.ModifiableProperties");

/**
 * Modifiable interface defines functions to iterates , updates and persist Properties.
 * @ibm-spi
 * @ibm-module iWidget2
 */
dojo.declare("com.ibm.mashups.iwidget.widget.ModifiableProperties", [com.ibm.mashups.iwidget.widget.Properties], {
    /**
     * @private
     */
    constructor: function() {
    },
    /**
     * This method creates or overwrites the value of the required item
     * @param{String}itemName name of the item. Must never be NULL.
     * @param{String} itemValue value of the item. Must never be NULL.
     * @param{Boolean} readOnly whether the item value is read only (on this level).
     * @param{String} locale the locale in which the item value is
     * @return{com.ibm.mashups.iwidget.widget.Properties} return an handle of InstanceProperties upon successful, NULL upon failure.
     */
    setItemValue: function(itemName, itemValue, readOnly, locale) {
    },
    /**
     * Removes the named item from the set.
     * @param{String} itemName name of the item that should be removed.Must never be NULL.
     * @return{com.ibm.mashups.iwidget.widget.Properties} return an handle of InstanceProperties upon successful, NULL upon failure..
     */
    removeItem: function(itemName) {
        //summary:This method sets an value of an iDescriptor item
    },
    /**
     * Removes the specified item value with the given locale.
     * @param{String} itemName the name of the item for which to remove the value.
     * @param{String} locale the locale of the value to remove. Must never be NULL
     * @return{void}
     */
    removeItemValue: function(itemName, locale) {
    }
});

}

if(!dojo._hasResource["com.ibm.mm.iwidget.widget.ModifiablePropertiesImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.iwidget.widget.ModifiablePropertiesImpl"] = true;
dojo.provide("com.ibm.mm.iwidget.widget.ModifiablePropertiesImpl");





dojo.declare("com.ibm.mm.iwidget.widget.ModifiablePropertiesImpl", [com.ibm.mashups.iwidget.widget.ModifiableProperties, com.ibm.mm.iwidget.widget.PropertiesImpl], {
    constructor: function(items, defaultProps) {
        this._dirty = false;
    },
    _buildChange: function(item, itemName, oldVal, newVal, isRemove) {
        var isDirty = item._dirty;
        if (!isDirty) {
            item._dirty = true;
        }
        var change = item._change ? item._change : {};
        change.id = itemName;
        
        if (isRemove) {
            //if it's remove action
            if (isDirty && change.changeType && change.changeType == this.TYPE_NEW) {
                item._dirty = false;
                delete item._change;
                return;
            }
            else if (isDirty) {
                change.changeType = this.TYPE_REMOVE;
                return;
            }
            item._change.changeType = this.TYPE_REMOVE;
            item._change.oldVal = oldVal;
            return;
        }
        
        if (isDirty && change.changeType) {
            if (change.changeType == this.TYPE_NEW) {
                change.newVal = newVal;
            }
            else {
                change.changeType = this.TYPE_UPDATE;
                change.newVal = newVal;
            }
        }
        else {
            if (oldVal) {
                change.oldVal = oldVal;
            }
            if (newVal) {
                change.newVal = newVal;
            }
            if (oldVal) {
                change.changeType = this.TYPE_UPDATE;
            }
            else {
                change.changeType = this.TYPE_NEW;
            }
        }
        item._change = change;
        return;
    },
    setItemValue: function(itemName, itemValue, readOnly, locale) {
        if (!itemName || !itemValue) {
            return null;
        }
        if (itemName in this._items) {
            if (this._defaultProperties && this._defaultProperties.isReadOnly(itemName)) {
                return null;
            }
        }
        var oldValue = {};
        var newValue = {};
        var isReadOnly;
        if (!locale || (locale && locale == "")) { //that means this is a nonlocalized item
            if (itemName in this._items) {
                oldValue = {};
                newValue = {};
                if (this._items[itemName].values) {
                    oldValue = dojo.clone(this._items[itemName].values);
                    if (this._items[itemName].value) {
                        oldValue[""] = this._items[itemName].value;
                    }
                    newValue = dojo.clone(this._items[itemName].values);
                    newValue[""] = itemValue;
                }
                else {
                    if (this._items[itemName].value) {
                        oldValue[""] = this._items[itemName].value;
                    }
                    newValue[""] = itemValue;
                }
                this._items[itemName].value = itemValue;
                this._buildChange(this._items[itemName], itemName, oldValue, newValue);
            }
            else {
                var anItem = {};
                anItem.id = itemName;
                //anItem.name = itemName;
                anItem.value = itemValue;
                isReadOnly = !!readOnly;
                anItem.readOnly = isReadOnly;
                this._items[itemName] = anItem;
                newValue = {};
                newValue[""] = itemValue;
                this._items[itemName] = this._items[itemName] ? this._items[itemName] : {};
                this._buildChange(this._items[itemName], itemName, null, newValue);
            }
            if (this._items[itemName]._dirty) {
                this._dirty = true;
            }
            return this;
        }
        
        var normalizedLocale = locale.replace(/-/g, "_"); // normalize the locale
        if (itemName in this._items) {
            oldValue = {};
            newValue = {};
            //this is update
            if (this._items[itemName].values) {
                oldValue = dojo.clone(this._items[itemName].values);
            }
            this._items[itemName].values[normalizedLocale] = itemValue;
            newValue = dojo.clone(this._items[itemName].values);
            if (this._items[itemName].value) {
                oldValue[""] = this._items[itemName].value;
                newValue[""] = this._items[itemName].value;
            }
            this._items[itemName].readOnly = readOnly;
            this._buildChange(this._items[itemName], itemName, oldValue, itemValue);
            if (this._items[itemName]._dirty) {
                this._dirty = true;
            }
            return this;
        }
        
        //if it's a new item
        var item = {};
        item.values = {};
        item.values[normalizedLocale] = itemValue;
        item.id = itemName;
        isReadOnly = !!readOnly;
        item.readOnly = isReadOnly;
        this._items[itemName] = item;
        newValue = dojo.clone(item.values);
        this._buildChange(this._items[itemName], itemName, null, newValue);
        
        if (this._items[itemName]._dirty) {
            this._dirty = true;
        }
        return this;
    },
    removeItem: function(itemName) {
        //remove all the values of the Item
        
        // check if this item is read-only on the parent level
        if (this._defaultProperties && this._defaultProperties.isReadOnly(itemName)) {
            throw "The specified item [" + itemName + "] is readOnly!";
        }
        
        var change = {};
        var deleted = false;
        if (itemName in this._items) {
            //delete this._items[itemName]; //this._items only keeps track of any change
            if (this._items[itemName]._dirty) {
                this._items[itemName].value = this.DELETE_TOKEN;
                this._items[itemName].values = this.DELETE_TOKEN;
                change = this._items[itemName]._change ? this._items[itemName]._change : {};
                if (change.changeType == this.TYPE_NEW) {
                    delete this._items[itemName];
                    return this;
                }
                else {
                    change.changeType = this.TYPE_REMOVE; //keep old value
                }
            }
            else {
                var oldValue = {};
                if (this._items[itemName].values) {
                    oldValue = dojo.clone(this._items[itemName].values);
                }
                if (this._items[itemName].value) {
                    oldValue[""] = this._items[itemName].value;
                }
                this._items[itemName].value = this.DELETE_TOKEN;
                this._items[itemName].values = this.DELETE_TOKEN;
                change = {};
                change.changeType = this.TYPE_REMOVE;
                change.itemName = itemName;
                change.oldVal = oldValue;
                this._items[itemName]._change = change;
                this._items[itemName]._dirty = true;
            }
            deleted = true;
        }
        if (deleted) {
            this._dirty = true;
            return this;
        }
        else {
            return null;
        }
    },
    removeItemValue: function(itemName, locale) {
        if (!locale) {
           //remove nonlocalized value
		   locale = "";
        }
        
        // check if this item is read-only on the parent level
        if (this._defaultProperties && this._defaultProperties.isReadOnly(itemName)) {
            throw "The specified item [" + itemName + "] is readOnly!";
        }
        
        var normalizedLocale = locale.replace(/-/g, "_"); // normalize the locale			
        var deleted = false;
        var change = {};
        if (itemName in this._items) {
            if (this._items[itemName]._dirty) {
                change = this._items[itemName]._change ? this._items[itemName]._change : {};
                if (change.changeType == this.TYPE_REMOVE) {
                    return null; //item is already removed
                }
                else if (change.changeType == this.TYPE_NEW) { //don't change type
                    if (normalizedLocale == "" && this._items[itemName].value && this._items[itemName].value != this.DELETE_TOKEN) {
                        delete this._items[itemName].value;
                        if (this._items[itemName]._change.newVal[""]) {
                            delete this._items[itemName]._change.newVal[""];
                        }
                        deleted = true;
                    }
                    if (normalizedLocale != "") {
                        if (this._items[itemName].values[normalizedLocale]) {
                            delete this._items[itemName].values[normalizedLocale];
                            if (this._items[itemName]._change.newVal[normalizedLocale]) {
                                delete this._items[itemName]._change.newVal[normalizedLocale];
                            }
                            deleted = true;
                        }
                    }
                    if (this._isEmpty(this._items[itemName]._change.newVal)) {
                        delete this._items[itemName]._dirty;
                        delete this._items[itemName]._change;
                    }
                }
                else { //update
                    if (normalizedLocale == "" && this._items[itemName].value && this._items[itemName].value != this.DELETE_TOKEN) {
                        delete this._items[itemName].value;
                        if (this._items[itemName]._change.newVal[""]) {
                            delete this._items[itemName]._change.newVal[""];
                        }
                        deleted = true;
                    }
                    if (this._items[itemName].values[normalizedLocale]) {
                        delete this._items[itemName].values[normalizedLocale];
                        if (this._items[itemName]._change.newVal[normalizedLocale]) {
                            delete this._items[itemName]._change.newVal[normalizedLocale];
                        }
                        deleted = true;
                    }
                }
            }
            else {
                var oldValue = {};
                var newValue = {};
                if (normalizedLocale == "" && this._items[itemName].value) {
                    change = {};
                    change.id = itemName;
                    oldValue = {};
                    newValue = {};
                    if (this._items[itemName].values) {
                        change.changeType = this.TYPE_UPDATE;
                        oldValue = dojo.clone(this._items[itemName].values);
                        oldValue[""] = this._items[itemName][""];
                        change.oldVal = oldValue;
                        change.newVal = dojo.clone(this._items[itemName].values);
                        delete this._items[itemName].value;
                    }
                    else {
                        change.changeType = this.TYPE_REMOVE;
                        oldValue[""] = this._items[itemName][""];
                        change.oldVal = oldValue;
                        delete this._items[itemName].value;
                    }
                    this._items[itemName]._change = change;
                    this._items[itemName]._dirty = true;
                    deleted = true;
                }
                if (normalizedLocale in this._items[itemName].values) {
                    change = {};
                    change.id = itemName;
                    oldValue = {};
                    newValue = {};
                    if (this._items[itemName].value) {
                        change.changeType = this.TYPE_UPDATE;
                        oldValue = dojo.clone(this._items[itemName].values);
                        oldValue[""] = this._items[itemName][""];
                        change.oldVal = oldValue;
                        change.newVal = dojo.clone(this._items[itemName].values);
                        change.newVal[""] = this._items[itemName].value;
                        delete change.newVal[normalizedLocale];
                        delete this._items[itemName].value;
                    }
                    else {
                        oldValue = dojo.clone(this._items[itemName].values);
                        delete this._items[itemName].values[normalizedLocale];
                        if (this._isEmpty(this._items[itemName].values)) {
                            change.changeType = this.TYPE_REMOVE;
                        }
                        else {
                            change.changeType = this.TYPE_UPDATE;
                            change.newVal = dojo.clone(this._items[itemName].values);
                        }
                        change.oldVal = oldValue;
                    }
                    this._items[itemName]._change = change;
                    this._items[itemName]._dirty = true;
                    deleted = true;
                }
            }
            
        }
        
        if (deleted) {
            this._dirty = true;
            
            return this;
        }
        else {
            return null;
        }
    },
    _isDirty: function() {
        return this._dirty;
    },
    _setDirty: function(value) {
        this._dirty = value;
    },
    _isItemDirty: function(itemName) {
        if (!itemName) {
            return false;
        }
        var isDirty = false;
        if (this._items[itemName]) {
            isDirty = this._items[itemName]._dirty;
        }
        return isDirty;
    },
    _setItemDirty: function(itemName, value) {
        if (!itemName) {
            return;
        }
        if (this._items[itemName]) {
            this._items[itemName]._dirty = value;
            if (typeof value != "undefined" && !value) {
                delete this._items[itemName]._dirty;
                delete this._items[itemName]._change;
            }
            
            if (this._items[itemName].values && this._items[itemName].values == this.DELETE_TOKEN) {
                delete this._items[itemName].values;
            }
            if (this._items[itemName].value && this._items[itemName].value == this.DELETE_TOKEN) {
                delete this._items[itemName].value;
            }
            
            if (!this._items[itemName].value && !this._items[itemName].values) {
                delete this._items[itemName];
            }
        }
    },
    _getInternalItemValue: function(itemName) {
        if (this._items[itemName]) {
            return this._items[itemName];
        }
        return null;
    },
    _isEmpty: function(obj) {
    	return com.ibm.mm.enabler.utils.Misc.isEmpty(obj);
    },
    _getRequiredValue: function(obj, locale) {
        if (!obj) {
            return null;
        }
        if (dojo.isString(obj)) {
            return obj;
        }
        if (locale) {
            if (obj[locale]) {
                return obj[locale];
            }
            else {
                return null;
            }
        }
        var singleValue = null;
        var j = 0;
        for (var i in obj) {
            if (Object.prototype.hasOwnProperty.call(obj,i)) {
                if (i == "") {
                    singleValue = obj[i];
                }
                j++;
            }
        }
        if (singleValue && j == 1) {
            return singleValue;
        }
        return obj;
    },
	_updateProperties:function(updatedProperties){
		//used by sandboxed mode... updates is sent from wrapper to stub
		//merge the updates, latest one overwrites the old one
		var updatedItems = dojo.mixin(this._items,updatedProperties);
		this._items = updatedItems;
		this._dirty = true;
	},
	toJson:function(){
		return this._items;
	}
});

}

if(!dojo._hasResource["com.ibm.mashups.iwidget.widget.ModifiableProperties"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.iwidget.widget.ModifiableProperties"] = true;
dojo.provide("com.ibm.mashups.iwidget.widget.ModifiableProperties");





}

if(!dojo._hasResource["com.ibm.mashups.iwidget.widget.ModifiablePropertiesProvider"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.iwidget.widget.ModifiablePropertiesProvider"] = true;
dojo.provide("com.ibm.mashups.iwidget.widget.ModifiablePropertiesProvider");



/**
 * Modifiable interface defines functions to access properties that's defined with iWidget.
 * @ibm-spi
 * @ibm-module iWidget2
 */
dojo.declare("com.ibm.mashups.iwidget.widget.ModifiablePropertiesProvider", null, {
    /**
     * @private
     */
    constructor: function() {
    },
    /**
     This method returns an object that contains iDescriptor items as defined by iWidget spec. It contains  default title and icon
     @type com.ibm.mashups.iwidget.widget.ModifiableProperties
     @returns{com.ibm.mashups.iwidget.widget.ModifiableProperties } object that contains iWidget iDescriptor items information
     */
    getIDescriptorItems: function() {
    },
    
    /**
     This method returns an object that contains attributes as defined by iWidget spec.
     @type com.ibm.mashups.iwidget.widget.ModifiableProperties
     @returns{com.ibm.mashups.iwidget.widget.ModifiableProperties } object that contains iWidget iDescriptor items information
     */
    getAttributes: function() {
    }
});

}

if(!dojo._hasResource["com.ibm.mashups.iwidget.widget.ModifiableWireProvider"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.iwidget.widget.ModifiableWireProvider"] = true;
dojo.provide("com.ibm.mashups.iwidget.widget.ModifiableWireProvider");



/**
 * Interface defines functions to access handled or published event descriptions.
 * @ibm-spi
 * @ibm-module iWidget2
 */
dojo.declare("com.ibm.mashups.iwidget.widget.ModifiableWireProvider", com.ibm.mashups.iwidget.widget.WireProvider, {
    /**
     * @private
     */
    constructor: function(id) {
    
    },
    
    /**
     * @param {String}sourceWidgetId id of the widget that will publish the event
     * @param {String}sourceEventName  name of the event source widget will publish
     * @param {String}targetEventName   name of the event the receiving widget and this event will handle the event published by source widget
     * @type void
     */
    addWire: function(sourceWidgetId, sourceEventName, targetEventName) {
    },
    /**
     * @param {String}sourceWidgetId  id of the widget that will publish the event
     * @param {String}sourceEventName name of the event source widget will publish
     * @param {String}targetEventName name of the event the receiving widget and this event will handle the event published by source widget
     * @type void
     */
    removeWire: function(sourceWidgetId, sourceEventName, targetEventName) {
    }
});

}

if(!dojo._hasResource["com.ibm.mashups.iwidget.widget.IWidgetInstance_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.iwidget.widget.IWidgetInstance_API"] = true;
dojo.provide("com.ibm.mashups.iwidget.widget.IWidgetInstance_API");
dojo.provide("com.ibm.mashups.iwidget.widget.IWidgetInstance");

/**
 * Interface defines functions to access all the instance level descriptive data.
 * @ibm-spi
 * @ibm-module iWidget2
 */
dojo.declare("com.ibm.mashups.iwidget.widget.IWidgetInstance", [com.ibm.mashups.iwidget.widget.ModifiablePropertiesProvider, com.ibm.mashups.iwidget.widget.ModifiableWireProvider], {
    /**
     * @private
     */
    constructor: function() {
    
    }
    
});

}

if(!dojo._hasResource["com.ibm.mm.iwidget.widget.IWidgetInstanceDefaultImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.iwidget.widget.IWidgetInstanceDefaultImpl"] = true;
dojo.provide("com.ibm.mm.iwidget.widget.IWidgetInstanceDefaultImpl");










dojo.declare("com.ibm.mm.iwidget.widget.IWidgetInstanceDefaultImpl", com.ibm.mashups.iwidget.widget.IWidgetInstance, {
    constructor: function(wrapper, /*RootElement*/widgetSpan,/*String*/ id){
        this.wrapper = wrapper;
        this.rootElement = widgetSpan;
        this.id = id;
        this.ns = widgetSpan.className.substr(0, 3);
        
        var nodes = [];
        var className = this.ns + "Definition";
        com.ibm.mm.iwidget.Utils.findElementByAttribute("query", "> ."+className, this.rootElement, nodes, false);
        if (nodes && nodes.length > 0) {
            var node = nodes[0];
            var url = node.getAttribute("href");
            if (typeof(url) != "undefined" && url !== null) {
                this.widgetXMLUrl = url;
            }
        }
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass);
        this.LOG_LEVEL = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
        this.bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
    },
    _destroy: function(){
        // #17713 one leak for widgetWrapper.rootElement (iw-iWidget DIV)
        if (this.rootElement) {
            this.rootElement = null;
        }
    },
    getDefaultViewContent: function(){
        if (this.defaultViewContent) {
            return this.defaultViewContent;
        }
        var className = this.ns + "Content";
        var node = null;
        var nodeList = dojo.query("> ." + className+"."+iwConstants.mode_view, this.rootElement);
        if (nodeList) {
            node = nodeList[0];
        }
        if (!node) {
            nodeList = dojo.query("> ." + className, this.rootElement);
            if (nodeList) {
                node = nodeList[0];
            }
        }
        if (node) {
            this.defaultViewContent = node.innerHTML;
            return this.defaultViewContent;
        }
        else {
            return null;
        }
    },
    getWidgetEvents: function(){
        //simple events including all the predefined events and onSth. event
        if (this.widgetEvents) {
            return this.widgetEvents;
        }
        var widgetEvents = {};
        var attributes = this.rootElement.attributes;
        for (var i = 0; i < attributes.length; i++) {
            var attribute = attributes[i];
            if (attribute.name !== null && attribute.name.indexOf("on") === 0) {
                var handler = this.rootElement.getAttribute(attribute.name);
                if (typeof handler != "undefined" && handler !== null) {
                    widgetEvents[attribute.name] = handler;
                    if (this.bIsLoggable) {
                        this.LOGGER.trace("iWidgetInstance.getWidgetEvents", "eventName:" + attribute.name + " handler:" + widgetEvents[attribute.name]);
                    }
                }
            }
        }
        this.widgetEvents = widgetEvents;
        
        return this.widgetEvents;
    },
    _addWire: function(wire){
    },
    _removeWire: function(id){
    },
    addWire: function(sourceWidget, sourceEvent, targetEvent){
    },
    removeWire: function(sourceWidget, sourceEvent, targetEvent){
    },
    _getPublicEvents: function(){
        return null;
    },
    getWires: function(){
        return [];
    },
    getWireModel: function(){
        return null;
    },
    /**
     * ModifiablePropertiesProvider Impl
     */
    getAttributes: function(){
        if (!this.attributeProperties) {
            //return all the attributes as  JSON data
            var attributes = this.getItemSets()[iwConstants.ATTRIBUTES];
            var properties = {};
            if (attributes) {
                for (var itemName in attributes) {
                    if (Object.prototype.hasOwnProperty.call(attributes, itemName)) {
                        properties[itemName] = attributes[itemName]; // we are compatible with the new internal itemset format
                    }
                }
            }
            
            this.attributeProperties = new com.ibm.mm.iwidget.widget.ModifiablePropertiesImpl(properties);
        }
        
        return this.attributeProperties;
    },
    /**
     * ModifiablePropertiesProvider Impl
     */
    getIDescriptorItems: function(){
        if (!this.idescriptorProperties) {
            //return all the attributes as  JSON data
            var iDescriptor = this.getItemSets()[iwConstants.IDESCRIPTOR];
            
            var properties = {};
            
            if (iDescriptor) {
                for (var itemName in iDescriptor) {
                    if (Object.prototype.hasOwnProperty.call(iDescriptor, itemName)) {
                        properties[itemName] = iDescriptor[itemName]; // we are compatible with the new internal itemset format
                        // (this is working here, because on instance level we got the idescriptor from markup, not def)
                    }
                }
            }
            
            this.idescriptorProperties = new com.ibm.mm.iwidget.widget.ModifiablePropertiesImpl(properties);
        }
        
        return this.idescriptorProperties;
    },
    
    _getItemSets: function(){
        if (this.itemSets) {
            return this.itemSets;
        }
        this.loadItemSets();
        return this.itemSets;
    },
    getItemSets: function(){
        //returns a list of itemsets: each itemset is like following
        // { itemname1:object,itemname2;object}
        // 
        return this._getItemSets();
    },
    getItemSet: function(itemSetName){
        //returns json object as indicated in _loadItem
        //{ itemName1:{},itemName2:{}}
        if (!itemSetName) {
            return null;
        }
        var itemSets = this._getItemSets();
        if (itemSets && itemSets[itemSetName]) {
            return itemSets[itemSetName];
        }
    },
    loadItemSets: function(){
        //this.itemSets = this._loadItemSets(this.rootElement, this.ns);
        this.itemSets = this._loadItemSetsOptimized(this.rootElement, this.ns);
    },
    
    _loadItemSetsOptimized: function(rootElement, ns){
        var itemSets = {};
        if (rootElement.childNodes.length) {
        
            dojo.query('> .'+ns+com.ibm.mm.iwidget.Constants.CSSCLASS_INSTANCE.iwItemSet+' > .'+ns+com.ibm.mm.iwidget.Constants.CSSCLASS_INSTANCE.iwItem, rootElement).forEach(function(item){
                var setName = dojo.attr(item.parentNode, 'title');
                if (setName) {
                    if (!itemSets[setName]) {
                        itemSets[setName] = {};
                    }
                    var anItem = this._loadItemOptimized(item, ns);
                    itemSets[setName][anItem.id] = anItem;
                }
            }, this);
        }
        
        return itemSets;
    },
    
    _loadItemOptimized: function(elem, ns){
        var css = com.ibm.mm.iwidget.Constants.CSSCLASS_INSTANCE;
        
        var item = {
            id: com.ibm.mm.iwidget.Utils.stripHashPrefix(dojo.attr(elem, 'href')),
            readOnly: dojo.hasClass(elem, ns + css.iwReadOnly)
        };
        
        var lang = dojo.attr(elem, 'lang');
        if (lang) {
            item.defaultLocale = lang;
        }
        
        var value;
        var children = dojo.query('> .' + ns + css.iwValue, elem);
        if (children.length) {
            item.values = {};
            children.forEach(function(valElem){
                var locale = dojo.attr(valElem, 'lang') || lang;
                item.values[locale] = com.ibm.mm.enabler.utils.Dom.textContent(valElem);
            });
        }
        else {
            value = com.ibm.mm.enabler.utils.Dom.textContent(elem);
            if (dojo.isString(value)) {
                item.value = dojo.string.trim(value);
            }
        }
        
        return item;
    },
    
    // invalidate itemsets
    _invalidateItemSets: function(name){
        if (!name) {
            // invalidate all itemset
            this.itemSets = {};
        }
        else {
            // invalidate a single itemsets
            this.itemSets[name] = {};
        }
    },

    _getInstanceMarkup: function(){
        var node = dojo.clone(this.rootElement);
        //remove content div if it's available		
        dojo.query("> ." + this.ns + "Content", node).forEach(function(contentNode){
            com.ibm.mm.enabler.utils.Dom.destroyNode(contentNode);
        });
        dojo.query("> ." + this.ns + "loading", node).forEach(function(contentNode){
            com.ibm.mm.enabler.utils.Dom.destroyNode(contentNode);
        });
        
        var tempEl = document.createElement("div");
        tempEl.appendChild(node);
        var html = tempEl.innerHTML;
        return html;
    }
});

com.ibm.mm.iwidget.widget.IWidgetInstanceImpl = com.ibm.mm.iwidget.widget.IWidgetInstanceDefaultImpl;

// IMPORTANT
// ibmConfig.enablerLayerModules is a comma separated string of all supported modules at runtime
// This section dynamically loads the Extended representation when the variable enablerLayerModules contains the given module
if ((ibmConfig.enablerLayerModules) && (dojo.indexOf(ibmConfig.enablerLayerModules, "iWidget") >= 0)) {
    dojo["require"]("com.ibm.mm.iwidget.widget.IWidgetInstanceExtendedImpl"); // JSLINT-IGNORE: This needs to be done to allow modularization and to support the minimal layer
}

}

if(!dojo._hasResource["com.ibm.mashups.iwidget.widget.IWidgetInstance"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.iwidget.widget.IWidgetInstance"] = true;
dojo.provide("com.ibm.mashups.iwidget.widget.IWidgetInstance");






}

if(!dojo._hasResource["com.ibm.mashups.iwidget.widget.IWidgetWrapper_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.iwidget.widget.IWidgetWrapper_API"] = true;
dojo.provide("com.ibm.mashups.iwidget.widget.IWidgetWrapper_API");
dojo.provide("com.ibm.mashups.iwidget.widget.IWidgetWrapper");

/**
 * IWidgetWrapper interface  represents a runtime instance of an iWidget on the page. Information provided by the IWidgetWrapper is an aggregation of definition level data and instance level data.
 * To get desriptive data that's specific to instance level and definition level. It should use Provider api that's implemented by IWidgetDefinition or IWidgetIstance.
 * @ibm-spi
 * @ibm-module iWidget2
 */
dojo.declare("com.ibm.mashups.iwidget.widget.IWidgetWrapper", [com.ibm.mashups.iwidget.widget.WireProvider, com.ibm.mashups.iwidget.widget.EventProvider], {
    /**
     * @private
     */
    constructor: function() {
    
    },
    
    /**
     This method returns iWidgetDefinition of  this runtime instance.<br/>
     <code>var deferred = widgetWrapper.getIWidgetDefinition();</code><br/>
     <code>deferred.setFinishedCallback(callback,parameters);</code><br/>
     <code>deferred.start(true);</code><br/>
     here are the callback parameters that will be passed into callback function: <br/>
     &nbsp;&nbsp;&nbsp;&nbsp;<code>resource</code> -  IWidgetDefinition object <br>
     &nbsp;&nbsp;&nbsp;&nbsp;<code>statusCode</code> - the overall HTTP status,code of the action (the highest status code of the involved operations).<br>
     &nbsp;&nbsp;&nbsp;&nbsp;<code>params</code> - the parameters passed into the callback <br>
     @type com.ibm.mashups.enabler.Deferred
     @returns{com.ibm.mashups.enabler.Deferred}  a deferred object used to start this operation.
     @see com.ibm.mashups.iwidget.widget.IWidgetDefinition
     */
    getIWidgetDefinition: function() {
    },
    
    /**
     Sets the iWidgetDefinition for this runtime instance
     @param{com.ibm.mashups.iwidget.widget.IWidgetDefinition} widgetDefinition IWidgetDefinition to use for this runtime instance. Must not be null.
     @type{void}
     @return{void}
     */
    setIWidgetDefinition: function(widgetDefinition) {
    },
    /**
     This method returns iWidgetInstance which contains all the descriptive data for this iWidget instance
     @type com.ibm.mashups.iwidget.widget.IWidgetInstance
     @returns{com.ibm.mashups.iwidget.widget.IWidgetInstance }  iWidgetInstance object
     */
    getIWidgetInstance: function() {
    },
    /**
     * This method returns the a clone of the content of the widget as it is inside of the DOM.<br/>It removes automatically
     * any markup that was added to the DOM using microformats (given that the microformat implements the unProcess handler).<br/>
     * This method does not remove any additional DOM changes that where done by the widget itself and applies the unProcess only<br/>
     * to the subnodes of the actual widget node.<br/><br/>
     * If your widget needs to take special action to it's DOM nodes before the getMarkup is processing it, you can define the method<br/>
     * <code>_onGetMarkup</code> in your widgets JavaScript file. This method, as part of the iScope, will always be called before the actual<br/>
     * markup is processed.<br/><br/>
     * <b>The synchrounus mode of returned Deferred is not supported.</b>
     * @type com.ibm.mashups.enabler.Deferred
     * @returns {com.ibm.mashups.enabler.Deferred} a deferred object used to fetch the actual markup.
     */
    getMarkup: function() {
    },
    /**
     This method returns  true if an iwidget instance is already loaded on the page dom.
     @type Boolean
     @returns{Boolean }  true if widget is already completely rendered on the page.
     */
    isLoaded: function() {
    },
    /**
     * This method returns  true if an iwidget instance is standalone on the page.
     * @type Boolean
     * @returns{Boolean}  true if widget is standalone on the page.
     */
    isStandalone: function() {
    },
  /**
     This method displays the widgets on the page if widget has not been displayed yet.
     @type void
     */
    doRender: function() {
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.aggregation.javascript.Filter"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.aggregation.javascript.Filter"] = true;
dojo.provide("com.ibm.mm.enabler.aggregation.javascript.Filter");




function com_ibm_enabler_aggregation_javascript_globalEvalNonIE( /*String*/javascript) {
    // summary: Evaluates a string of javascript in the global scope.
    // description: Calling eval.call( self, ... ); from within a JS object apparently makes "this" point to the object from which the
    // eval call was made even though the scope is set using the "call" function. Therefore we need to have this function
    // available in the global scope and not as a member variable on a JS object.
    eval.call(self, javascript);
}

dojo.declare("com.ibm.mm.enabler.aggregation.javascript.Filter", null, {
    // summary:    Base interface for a filter. Each implementation must implement
    //  the doFilter function.
    // description: Passes the given event through to give the implementation of
    //  this filter a chance to alter or handle the event in some way.
    constructor: function() {
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass);
        this.LOG_LEVEL = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
        this.bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
    },
    
    doFilter: function( script) {
        // summary: Filter the given event.
        // description: Allows this filter to handle or alter the event. If this function
        //  returns true, processing is stopped and the event is considered "handled".
        // script: the script block (string or HTMLElement) 
        //dojo.unimplemented( "com.ibm.mm.enabler.aggregation.JavascriptFilter.doFilter" );
    },
    evalGlobal: function( javascript) {
        // summary: Evaluates the given javascript in the global context.
        // javascript: a string of javascript to evaluate.
        if (window.execScript) { // JSLINT-IGNORE: We have to use eval here
            window.execScript(this._stripHTMLComments(javascript), "JavaScript"); // JSLINT-IGNORE: We have to use eval here
        }
        else {
            //Using eval.call( window, javascript ) was apparently not really eval'ing
            //in the global scope since 'this' was still referring to the Filter object 
            //and not the window object as it should have (or I think it should have)...
            com_ibm_enabler_aggregation_javascript_globalEvalNonIE(javascript);
        }
    },
    _stripHTMLComments: function(str) {
        // summary: Strip all HTML comments from a script block.
        // description: Although HTML comments are allowed in a script block by the browser
        //  IE throws up whenever you try and eval a javascript string in the global context
        //  that has HTML comments in the string.
        if (this.bIsLoggable) {
            this.LOGGER.entering("com.ibm.mm.enabler.aggregation.javascript.Filter._stripHTMLComments", [str]);
        }
        
        var resultStr = str;
		resultStr = resultStr.replace(/<!--[^(-->)]+-->/g, '');        
		
        if (this.bIsLoggable) {
            this.LOGGER.exiting("com.ibm.mm.enabler.aggregation.javascript.Filter._stripHTMLComments", [resultStr]);
        }
        
        return resultStr;
    },
    prepareDocumentWrite: function(buffer) {
        // summary: Prepares support for document.write() and document.writeln
        // description: Overrides the original document.write() and document.writeln()
        //       functions with functions writing to the buffer
        if (this.bIsLoggable) {
            this.LOGGER.entering("com.ibm.mm.enabler.aggregation.javascript.Filter.prepareDocumentWrite");
        }
        var me = this;
        document.write = function() { // JSLINT-IGNORE: We have to use eval here
            me._documentWrite(buffer, document.write.arguments); // JSLINT-IGNORE: We have to use eval here
        };
        document.writeln = function(str) { // JSLINT-IGNORE: We have to use eval here
            me._documentWrite(buffer, document.writeln.arguments); // JSLINT-IGNORE: We have to use eval here
        };
        if (this.bIsLoggable) {
            this.LOGGER.exiting("com.ibm.mm.enabler.aggregation.javascript.Filter.prepareDocumentWrite");
        }
    },
    _documentWrite: function(buffer,  args) {
        // summary: Internal document.write() function writing to the given buffer
        // description: Just appends the given String arguments to our buffer
        for (var i = 0, l = args.length; i < l; i++) {
            buffer.content += args[i];
        }
    },
    
    applyDocumentWrite: function( script, buffer) {
        // summary: Injects the markup in the given buffer into the DOM
        // description: Looks up the script element in the original DOM
        //       and injects the markup before that element
        if (this.bIsLoggable) {
            this.LOGGER.entering("com.ibm.mm.enabler.aggregation.javascript.Filter.applyDocumentWrite", [script, buffer.content]);
        }
        var cont = buffer.content || null;
        if (cont !== null && cont.length > 0) {
            var i = 0;
            if (dojo.isIE) {
				// Attention: IE needs the <br> tag available, otherwise <script> tags get stripped when using .innerHTML
                cont = '<br>' + cont;
                i++; // the <br> tag must not be copied, so stop iterating one earlier
            }
            
            var div = dojo.create("div",{
                innerHTML: cont
            });
			
			var execute = dojo.isIE || dojo.isWebKit || dojo.isOpera; // IE, WebKit and Opera don't execute the inserted scripts automatically, so do it for them.
            
            var children = div.childNodes || null;
            if (children !== null && children.length > 0) {
                // copy the nodes over into the DOM
                var pred = script;
                
                var l;
                var scripts = [];
                while (i < (l = children.length)) {
                    var node = children[l - 1];
                    // we need to inject the markup before the script element
                    // to properly handle table updates
                    dojo.place(node, pred, 'before');
                    if (execute && node.tagName && node.tagName.toLowerCase() == 'script') {
                        scripts.unshift(node);
                    }
                    
                    pred = node;
                }
                
                if (execute) {
                    dojo.forEach(scripts, function(scr){
                        com.ibm.mm.enabler.aggregation.javascript.JAVASCRIPT_HANDLER.handle(scr);
                    });
                }
            }
            dojo.destroy(div);
        }
        if (this.bIsLoggable) {
            this.LOGGER.exiting("com.ibm.mm.enabler.aggregation.javascript.Filter.applyDocumentWrite");
        }
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.aggregation.javascript.ExternalScriptFilter"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.aggregation.javascript.ExternalScriptFilter"] = true;
dojo.provide("com.ibm.mm.enabler.aggregation.javascript.ExternalScriptFilter");






dojo.declare("com.ibm.mm.enabler.aggregation.javascript.ExternalScriptFilter", com.ibm.mm.enabler.aggregation.javascript.Filter, {
    doFilter: function( /*HTMLElement*/script) {
        // summary: Filter the given event.
        // description: Allows this filter to handle or alter the event. If this function
        //        returns true, processing is stopped and the script is considered "handled".
        // script: the script block (HTMLElement) 
        
        var url = this._getScriptUrl(script);
        
        var handled = false;
        
        if (url) {
            // check if the AJAX proxy is enabled
            var proxyURL = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME).getValue(com.ibm.mashups.enabler.services.ConfigConstants.PROXY_URL);
            proxyURL = proxyURL || null;
            if (proxyURL !== null) {
                proxyURL += "/";
                url = this._rewriteURL(url, proxyURL);
            }
            // prepare buffer for document.write/ln
            var buffer = {
                content: ""
            };
            this.prepareDocumentWrite(buffer);
            this._loadExternalScript(url);
            // apply document.write/ln to DOM
            this.applyDocumentWrite(script, buffer);
            handled = true;
        }
        
        return handled;
    },
    _getScriptUrl: function( /*HTMLElement*/script) {
        // summary: Retrieve the src attribute value of a script tag if it exists.
        // returns: the url for the script tag or null if the script tag doesn't specify a URL
        var url = null;

        if (script.getAttribute) {
            url = script.getAttribute("src");
        }
        else {
            var start = script.toLowerCase().indexOf("<script");
            var end = script.toLowerCase().indexOf(">");
            
            var scriptTagSubstr = script.substring(start, end);
            var srcIndex = scriptTagSubstr.toLowerCase().indexOf("src");
            
            
            if (srcIndex != -1) {
                // figure out whether it's a src='blah' or src="blah"
                var quoteIndex = scriptTagSubstr.indexOf("'", srcIndex);
                var dblQuoteIndex = scriptTagSubstr.indexOf('"', srcIndex);
                var markerChar = '"';
                var markerIndex = dblQuoteIndex;
                if (dblQuoteIndex == -1 || (quoteIndex != -1 && quoteIndex < dblQuoteIndex)) {
                    markerChar = "'";
                    markerIndex = quoteIndex;
                }
                var markerIndex2 = scriptTagSubstr.indexOf(markerChar, markerIndex + 1);
                url = scriptTagSubstr.substring(markerIndex + 1, markerIndex2);
            }
        }
        
        return url;
    },
    
    /**
     * This is reused by space-extension remote script loading.
     */
    loadExternalScript: function( /*String*/url) {
        var proxyURL = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME).getValue(com.ibm.mashups.enabler.services.ConfigConstants.PROXY_URL);
        proxyURL = proxyURL || null;
        if (proxyURL !== null) {
            proxyURL += "/";
            url = this._rewriteURL(url, proxyURL);
        }
        
        this._loadExternalScript(url);
    },
    
    _loadExternalScript: function( /*String*/url) {
        var me = this;
        dojo.xhrGet({
            url: url,
            load: function(data, ioArgs) {
                if (this.bIsLoggable) {
                    this.LOGGER.trace("com.ibm.mm.enabler.aggregation.javascript.Filter._loadExternalScript", "Retrieved JS file: ${0}", [data]);
                }
                me.evalGlobal(data);
            },
            sync: true,
            handleAs: "text"
        });
    },
    _rewriteURL: function(/*String*/targetUrl, /*String*/ proxyUrl) {
        var newURL = proxyUrl;
        var host = window.location.host;
        var protocol = window.location.protocol;
        
        // check if this is a proxy request:
        if (targetUrl.indexOf("://") < 0 || targetUrl.indexOf(protocol) === 0 && targetUrl.indexOf(host) == protocol.length + 2) {
            return targetUrl;
        }
        
        // rewrite
        if (targetUrl.indexOf("https") === 0) {
            newURL += "https/";
        }
        else {
            newURL += "http/";
        }

        newURL += targetUrl.substr(targetUrl.indexOf("://") + 3);
        return newURL;
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.aggregation.javascript.FilterChain"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.aggregation.javascript.FilterChain"] = true;
dojo.provide("com.ibm.mm.enabler.aggregation.javascript.FilterChain");

dojo.declare("com.ibm.mm.enabler.aggregation.javascript.FilterChain", null, {
    constructor: function() {
        this._filters = [];
    },
    // summary: Controls the registration and execution of the filters associated
    //        with this filter chain.
    
    addFilter: function(filter) {
        // summary: Register a filter at the end of the filter chain.
        // filter: the filter to append
        if (!this._filters) {
            this._filters = [];
        }
        this._filters.push(filter);
    },
    applyFilters: function(script) {
        // summary: Execute the filter chain.
        // description: Calls doFilter on every filter registered in this filter chain
        //        until all filters have been called or one of the filters returns true.
        // e: the event object
        // returns: true if the event was handled, false if it was not
        var returnValue = false;
        
        for(var i = 0, l = this._filters.length; i < l && !returnValue; i++) {
            returnValue = this._filters[i].doFilter(script);
        }
        
        return returnValue; //Boolean
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.aggregation.javascript.InlineScriptFilter"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.aggregation.javascript.InlineScriptFilter"] = true;
dojo.provide("com.ibm.mm.enabler.aggregation.javascript.InlineScriptFilter");



dojo.declare("com.ibm.mm.enabler.aggregation.javascript.InlineScriptFilter", com.ibm.mm.enabler.aggregation.javascript.Filter, {
    doFilter: function( /*HTMLElement*/script) {
        // summary: Filter the given event.
        // description: Allows this filter to handle or alter the script. If this function
        //        returns true, processing is stopped and the script is considered "handled".
        // script: the script block (HTMLElement) 

        var handled = false, tokenContents = "";

        if (!dojo.isString(script)) {
            //Use innerHTML because IE doesn't correctly provide the textContent for a script tag.
            tokenContents = script.innerHTML;
        }
        else {
            var scriptStr = script;
            var firstIndex = scriptStr.indexOf(">");
            var lastIndex = scriptStr.lastIndexOf("<");
            tokenContents = scriptStr.substring(firstIndex + 1, lastIndex);
        }

        if (this.bIsLoggable) {
            this.LOGGER.trace("com.ibm.mm.enabler.aggregation.javascript.InlineScriptFilter.doFilter", "Stripped HTML tags out: " + tokenContents);
        }
        if (tokenContents) {
            // prepare buffer for document.write/ln
            var buffer = {
                content: ""
            };
            this.prepareDocumentWrite(buffer);
            // Eval the contents
            this.evalGlobal(tokenContents);
            handled = true;
            // apply document.write/ln to DOM
            this.applyDocumentWrite(script, buffer);
        }

        return handled;
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.aggregation.javascript.WidgetJavascriptHandler"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.aggregation.javascript.WidgetJavascriptHandler"] = true;
dojo.provide("com.ibm.mm.enabler.aggregation.javascript.WidgetJavascriptHandler");





dojo.declare("com.ibm.mm.enabler.aggregation.javascript.WidgetJavascriptHandler", null, {
    constructor: function() {
        this.filterChain = new com.ibm.mm.enabler.aggregation.javascript.FilterChain();
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass);
        this.LOG_LEVEL = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
        this.bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
    },
    // summary: Examines all javascript included by a widget, modifies it if 
    //        necessary and evaluates it in the global context.
    // description: All script elements must be loaded manually since the widget
    //        markup is added asynchronously. This handler will evaluate a script
    //        element in the global context or load an external script file if necessary.
    
    handle: function(script) {
        // summary: Handles a script element added asynchronously.
        // script: the script element
        if (this.bIsLoggable) {
            this.LOGGER.entering("WidgetJavascriptHandler.handle", [script]);
        }
        
        var val = this.filterChain.applyFilters(script);
        
        if (this.bIsLoggable) {
            this.LOGGER.exiting("WidgetJavascriptHandler.handle");
        }
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.aggregation.javascript"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.aggregation.javascript"] = true;
dojo.provide("com.ibm.mm.enabler.aggregation.javascript");







com.ibm.mm.enabler.aggregation.javascript.JAVASCRIPT_HANDLER = new com.ibm.mm.enabler.aggregation.javascript.WidgetJavascriptHandler();

//Register the filters. The order registered is the order executed.
com.ibm.mm.enabler.aggregation.javascript.JAVASCRIPT_HANDLER.filterChain.addFilter(new com.ibm.mm.enabler.aggregation.javascript.ExternalScriptFilter());
com.ibm.mm.enabler.aggregation.javascript.JAVASCRIPT_HANDLER.filterChain.addFilter(new com.ibm.mm.enabler.aggregation.javascript.InlineScriptFilter());

}

if(!dojo._hasResource["com.ibm.mm.iwidget.manageditemset.PersistentAttributes"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.iwidget.manageditemset.PersistentAttributes"] = true;
dojo.provide("com.ibm.mm.iwidget.manageditemset.PersistentAttributes");




// INTERNAL PRIVATE CLASS - do NOT use directly
// Use PersistentAttributes instead
dojo.declare("com.ibm.mm.iwidget.manageditemset.InternalPersistentAttributesToPreferenceModelAdapter", com.ibm.mashups.iwidget.itemset.ManagedItemSet, {
    //Provides an the ItemSet interface to to the preference subsystem
    constructor: function(widget, serverless, parent) {
        if (serverless) {
            this.serverless = true;
        }
        else {
            this.serverless = false;
        }
        this.modes = iwConstants.mode;
        this.widget = widget;
        this.widgetInstance = this.widget.getIWidgetInstance();
        this.instanceAttributes = this.widgetInstance.getAttributes();
        this.defAttributes = this.widget.widgetDef.getAttributes();
        this.parent = parent;
        
        this.mode = this._getMode(null);
    },
    setItemValue: function(itemName, value, _merge) {
        if (!itemName) {
            return null;
        }
        if (!value) {
            return null;
        }
        if (this.isReadOnly(itemName)) {
            return null;
        }
        if (this.serverless) {
            if (this.mode == this.modes.EDIT) {
                //todo: replace with user preferred messagelocale
                this.instanceAttributes.setItemValue(itemName, value);
                //save to other level add more here
                if (this.parent) {
                    return this.parent;
                }
            }
        }
        return null;
    },
    getItemValue: function(itemName, _merge) {
        if (!itemName) {
            return null;
        }
        var value;
        if (this.serverless) {
            if (typeof _merge === "undefined") {
                _merge = true;
            }
            if (this.mode == this.modes.CONFIG) {
                value = this.defAttributes.getItemValue(itemName);
                if (typeof value === "undefined") {
                    value = null;
                }
                return value;
            }
            if (this.mode == this.modes.EDIT && !_merge) {
                value = this.instanceAttributes.getItemValue(itemName);
                if (typeof value === "undefined") {
                    value = null;
                }
                return value;
            }
            if (_merge) {
                value = this.instanceAttributes.getItemValue(itemName);
                if (!value) {
                    value = this.defAttributes.getItemValue(itemName);
                }
                if (typeof value === "undefined") {
                    value = null;
                }
                return value;
            }
        }
        return null;
    },
    getAllNames: function(_merge) {
        if (this.serverless) {
            if (typeof _merge === "undefined") {
                _merge = true;
            }
            var names;
            if (this.mode == this.modes.CONFIG) {
                names = this.defAttributes.getAllNames();
                if (names && names.length && names.length === 0) {
                    return null;
                }
                return names;
            }
            if (this.mode == this.modes.EDIT && !_merge) {
                names = this.instanceAttributes.getAllNames();
                if (names && names.length && names.length === 0) {
                    return null;
                }
                return names;
            }
            var name;
            if (_merge) {
                names = this.instanceAttributes.getAllNames();
                var obj = {};
                if (names && names.length && names.length > 0) {
                    for (var i in names) {
                        if (Object.prototype.hasOwnProperty.call(names,i)) {
                            name = names[i];
                            obj[name] = name;
                        }
                    }
                }
                names = this.defAttributes.getAllNames();
                if (names && names.length && names.length > 0) {
                    for (var j in names) {
                        if (Object.prototype.hasOwnProperty.call(names,j)) {
                            name = names[j];
                            obj[name] = name;
                        }
                    }
                }
                return this._getNamesArray(obj);
            }
        }
        return null;
    },
    removeItem: function(itemName) {
        if (!itemName) {
            return null;
        }
        if (this.isReadOnly(itemName)) {
            return null;
        }        
        if (this.serverless) {
            if (this.mode == this.modes.EDIT) {
                this.instanceAttributes.removeItem(itemName);
                if (this.parent) {
                    return this.parent;
                }
            }
        }
        return null;
    },
    isReadOnly: function(/*String*/itemName, _merge) {
        //readOnly is set on definition level, per spec we only overwrite value in editmode
        //however to keep things backward compatible, we allow define value in microformat as well.
        if (!itemName) {
            return false;
        }
        
        if (this.serverless) {
            if (typeof _merge === "undefined") {
                _merge = true;
            }
            if (this.mode == this.modes.CONFIG) {
                return this.defAttributes.isReadOnly(itemName);
            }
            if (this.mode == this.modes.EDIT && _merge) {
                var isReadOnly = this.defAttributes.isReadOnly(itemName);
                if (!isReadOnly) {
                    isReadOnly = this.instanceAttributes.isReadOnly(itemName);
                }
                return isReadOnly;
            }
            if (this.mode == this.modes.EDIT) {
                return this.instanceAttributes.isReadOnly(itemName);
            }
            
        }
        
        return false;
    },
    commit: function(callbackfn) {
        //should persist on all the mode level. however config is not supported in runtime model
        //only edit mode needs to persist
        if (this.serverless) {
            this._saveMicroformat();
        }
        else {
            return null;
        }        
        if (callbackfn) {
            callbackfn(iwConstants.ATTRIBUTES, true);
        }        
        return (this);
    },
    _getNamesArray: function(items) {
        var i = 0;
        var names = [];
        var name;
        
        for (name in items) {
            if (Object.prototype.hasOwnProperty.call(items,name)) {
                names.push(name);
                i++;
            }
        }
        if (i === 0) {
            return null;
        }
        return names;
    },
    _saveMicroformat: function() {
        this.widget.commit();
        var payloadObj = {};
        payloadObj.wid = this.widget.id;
        this.widget.eventSvr._publishEvent(iwConstants.EVENTS.onAttributeSaved, payloadObj, this.widget.hubId);
    },
    _getMode: function(_mode) {
        var mode = this.modes.EDIT;
        if (_mode) {
            mode = _mode;
        }
        else {
            mode = this.widget.currentMode;
        }
        //todo: we need to define all the systemmodes supported by the framework  
        //for runtime model, we only support edit
        if (mode == this.modes.VIEW) {
            mode = this.modes.EDIT;
        }
        return mode;
    },
    addListener: function(/*obj*/fn) {
        var listenerId = this.widget._registerListener(iwConstants.ATTRIBUTES, fn);
        return listenerId;
    },
    removeListener: function(/*String*/listenerId) {
        return this.widget._removeListener(iwConstants.ATTRIBUTES, listenerId);
    }
});

dojo.declare("com.ibm.mm.iwidget.manageditemset.PersistentAttributes", com.ibm.mashups.iwidget.itemset.ManagedItemSet, {
    constructor: function(widgetWrapper, serverless) {
        this._internalPersistentAttributesToPreferenceModelAdapter = 
            new com.ibm.mm.iwidget.manageditemset.InternalPersistentAttributesToPreferenceModelAdapter(widgetWrapper, serverless, this);
    },
    setItemValue: function(itemName, value) {
        return this._internal().setItemValue(itemName, value, true);
    },
    getItemValue: function(itemName) {
        return this._internal().getItemValue(itemName, true);
    },
    getAllNames: function() {
        return this._internal().getAllNames(true);
    },
    removeItem: function(itemName) {
        return this._internal().removeItem(itemName);
    },
    isReadOnly: function(itemName) {
        return this._internal().isReadOnly(itemName, true);
    },
    save: function(callbackfn) {
        return this.commit(callbackfn);
    },
    commit: function(callbackfn) {
        return this._internal().commit(callbackfn);
    },
    _internal: function() { //todo: cleanup
        return this._internalPersistentAttributesToPreferenceModelAdapter;
    },
    addListener: function(/*obj*/fn) {
        return this._internal().addListener(fn);
    },
    removeListener: function(/*String*/listenerId) {
        return this._internal().removeListener(listenerId);
    }
    
});

}

if(!dojo._hasResource["com.ibm.mm.iwidget.itemset.ItemsetDefaultImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.iwidget.itemset.ItemsetDefaultImpl"] = true;
dojo.provide("com.ibm.mm.iwidget.itemset.ItemsetDefaultImpl");





dojo.declare("com.ibm.mm.iwidget.itemset.ItemSetDefaultImpl", com.ibm.mashups.iwidget.itemset.ItemSet, {
    constructor: function(parent, defData, name) {
    
        this.widget = parent; //widget wrapper;
        this.name = name;
        //no persistence is needed thus we have only one merged data layer at runtime
        var instance = this.widget.getIWidgetInstance();
        var instanceProperties = null;
        if (instance) {
            instanceProperties = instance.getItemSet(name);
        }
        var properties = {};
        if (defData) {
            if (defData) {
                for (var itemName1 in defData.items) {
                    if (Object.prototype.hasOwnProperty.call(defData.items,itemName1)) {
                        properties[itemName1] = dojo.clone(defData.items[itemName1]); // the new internal json itemset notation is compatible with the SPI
                    }
                }
            }
            this.properties = new com.ibm.mm.iwidget.widget.ModifiablePropertiesImpl(properties);
        }
        if (!this.properties) {
            this.properties = new com.ibm.mm.iwidget.widget.ModifiablePropertiesImpl(properties);
        }
        
        if (instanceProperties) {
            for (var itemName in instanceProperties) { //overwrite only
                //if (defData.items[itemName]) {
			   if (Object.prototype.hasOwnProperty.call(instanceProperties,itemName)) {
 
                    var anItem = instanceProperties[itemName];
                    if (anItem.values) {
                        for (var j in anItem.values) {
                            if (Object.prototype.hasOwnProperty.call(anItem.values,j)) {
                                //always readOnly
                                this.properties.setItemValue(itemName, anItem.values[j], false, j);
                            }
                        }
                    }
                    if (anItem.value) {
                        this.properties.setItemValue(itemName, anItem.value);
                    }
              }
            }
        }
        
        
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass);
        this.LOG_LEVEL = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
        this.bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
    },
	_getResourceBundle: function() {
        if (!this.iwMessages) {
            this.iwMessages = dojo.i18n.getLocalization("com.ibm.mm.enabler", "iwMessages");
        }
        return this.iwMessages;
    },
	_logDeprecated:function(methodName,fn1,fn2){
		this._getResourceBundle();
        var warning = dojo.string.substitute(this.iwMessages.W_DEPRECATE_2, [fn1,fn2]);
		this.LOGGER.warning(methodName,warning);
	},
    getLocalesWithValues: function(/*String*/itemName) {
        return this.properties.getItemLocales(itemName);
    },
	setLocalizedItemValue:function(itemName,value,locale){
		if (!itemName || !locale) {
			return null;
		}
		if (!(typeof value != "undefined" && value !== null)){
			return null;
		}
		rc = this.properties.setItemValue(itemName,value,false,locale);
		if (rc){
			return this;
		}
		return null;		
	},
	setItemValue: function( /*String*/itemName, /*Object*/ value,/*String*/ locale) {
		if (!itemName ) {
			return null;
		}
		if (!(typeof value != "undefined" && value !== null)){
			return null;
		}
		
		//locale should be deprecated,use setLocalizedItemValue instead
		if (!locale){
			rc = this.properties.setItemValue(itemName,value,false);
		}else if (locale && !dojo.isString(locale)){
			this._logDeprecated("setItemValue","ItemSet.setItemValue(itemName,value,readOnly)","ItemSet.setItemValue(item,value)");
			rc = this.properties.setItemValue(itemName,value,false);
		}else{
			this._logDeprecated("setItemValue","ItemSet.setItemValue(itemName,value,locale)","ItemSet.setLocalizedItemValue(item,value,locale)");
			return this.setLocalizedItemValue(itemName,value,locale);
		}        
        if (rc) {
            return this;
        }
        return null;
    },
	getLocalizedItemValue: function( /*String*/itemName, locale) {
		if (!itemName || !locale) {
			return null;
		}
        return this.properties.getLocalizedItemValue(itemName, locale);
    },
    getItemValue: function( /*String*/itemName, locale) {
		if (!itemName ) {
			return null;
		}
		if (locale){
			this._logDeprecated("getItemValue","ItemSet.getItemValue(itemName,locale)","ItemSet.getLocalizedItemValue(item,locale)");
			return this.getLocalizedItemValue(itemName,locale);
		}
        return this.properties.getItemValue(itemName);
    },
    getAllNames: function() {
        rc =  this.properties.getAllNames();
		if (rc && rc.length === 0) {
			return null;
		}
		return rc;
    },
    removeItem: function(/*String*/itemName, locale) {
		if (!itemName ) {
			return null;
		}
		if (locale){
			this._logDeprecated("removeItem","ItemSet.removeItem(itemName,locale)","ItemSet.removeLocalizedItemValue(itemName,locale)");
			return this.removeLocalizedItemValue(itemName,locale);
		}
        rc = this.properties.removeItem(itemName);
        if (rc) {
            return this;
        }
        return null;
    },
	removeLocalizedItemValue:function(itemName,locale){
		if (!itemName || !locale) { return null;}
		rc = this.properties.removeItemValue(itemName,locale);
		 if (rc) {
            return this;
        }
        return null;
	},
	removeItemValue:function(itemName){
		if (!itemName ) { return null;}
		rc = this.properties.removeItemValue(itemName);
		if (rc) {
            return this;
        }
        return null;
		
	}
});


}

if(!dojo._hasResource["com.ibm.mm.iwidget.DeferredLiveTextUnprocessStubImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.iwidget.DeferredLiveTextUnprocessStubImpl"] = true;
dojo.provide("com.ibm.mm.iwidget.DeferredLiveTextUnprocessStubImpl");



dojo.declare("com.ibm.mm.iwidget.DeferredLiveTextUnprocessStubImpl", com.ibm.mm.enabler.DeferredImpl, {
    constructor: function(wrapper) {
        this.wrapper = wrapper;
    },
    start: function(sync) {
        // defaults to false
        if (sync) {
            return;
        }
        //todo, what should we return if widget is sandboxed?
        var widgetInstance = this.wrapper.getIWidgetInstance();
        var tempMarkup = dojo.clone(this.wrapper.rootElement);
        this._unchangeCompleteCallback(tempMarkup);
    },
    setIncludeParent: function(value) {
        this.includeParent = value;
    },
    getIncludeParent: function() {
        return this.includeParent;
    },
    _unchangeCompleteCallback: function(node) {
        if (dojo.isFunction(this.getFinishedCallback())) {
            this.finish(node, 200);
        }
    }
});

}

if(!dojo._hasResource["com.ibm.mm.iwidget.manageditemset.AttributesModeDelegate"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.iwidget.manageditemset.AttributesModeDelegate"] = true;
dojo.provide("com.ibm.mm.iwidget.manageditemset.AttributesModeDelegate");







dojo.declare("com.ibm.mm.iwidget.manageditemset.AttributesModeDelegate", com.ibm.mashups.iwidget.itemset.ManagedItemSet, {
    constructor: function(persistentAttributesFactoryService, wrapper) {
        this.persistentAttributesFactoryService = persistentAttributesFactoryService;
        this.wrapper = wrapper;
        this.callbackHandle = {context:this, callback:"_attributesProviderModeChange", 
            unregister: function(handle) {
                this.wrapper.unregisterArray.push(handle);
            }
        };
        this.widgetAttributes = [];
        this.widgetAttributesReplay = [];
        this._skipRecord = false;
        // init
        this._getAttributes();
    },
    _attributesProviderModeChange: function(provider, oldMode, newMode) {
        this.widgetAttributes = [];
        this._getAttributes();
        // replay here into the new persistence mode
        var modeSelector = this._getModeSelector();
        var replayArray = this.widgetAttributesReplay[modeSelector];
        if (replayArray) {
            this._skipRecord = true;
            for (var i=0; i<replayArray.length; i++) {
                var replay = replayArray[i];
                if (replay[0] == "set") {
                    this.setItemValue(replay[1], replay[2]);
                }
                else if (replay[0] == "remove") {
                    this.removeItem(replay[1]);
                }
            }
            this._skipRecord = false;
        }
        this.widgetAttributesReplay = [];
        this.widgetAttributesReplay[modeSelector] = [];
    },
    _getModeSelector: function() {
        // the rules for the modes are:
        // config -> config
        // edit -> edit
        // personalize -> personalize
        // view --> personalize
        // "else" --> personalize

        var currentMode = this.wrapper._getCurrentMode();
        var modeSelector = iwConstants.mode.PERSONALIZE;
        if (currentMode == iwConstants.mode.CONFIG || currentMode == iwConstants.mode.EDIT) {
            modeSelector = currentMode;
        }
        return modeSelector;
    },
    _getAttributes:function() {
        var modeSelector = this._getModeSelector();
        
        this.widgetAttributes[modeSelector] = this.widgetAttributes[modeSelector] || null;
        if (this.widgetAttributes[modeSelector] === null) {
            this.widgetAttributes[modeSelector] = this.persistentAttributesFactoryService.createPersistentAttributes(this.wrapper, this.callbackHandle);
            // we only want to register one callback handler to clean out all modes
            this.callbackHandle = null;
        }
        return this.widgetAttributes[modeSelector];
    },
    _record: function(array) {
        if (!this._skipRecord) {
            // first element is function name, everything after that parameters
            var modeSelector = this._getModeSelector();
            this.widgetAttributesReplay[modeSelector] = this.widgetAttributesReplay[modeSelector] || null;
            if (this.widgetAttributesReplay[modeSelector] === null) {
                this.widgetAttributesReplay[modeSelector] = [];
            }
            this.widgetAttributesReplay[modeSelector].push(array);
            //console.log("recorded ",array);
        }
    },
    _clearReplay: function()
    {
        var modeSelector = this._getModeSelector();
        this.widgetAttributesReplay[modeSelector] = [];
    },
    setItemValue: function(itemName, value) {
        this._record(["set",itemName, value]);        
        return this._getAttributes().setItemValue(itemName, value);
    },
    getItemValue: function(itemName) {
        return this._getAttributes().getItemValue(itemName, true);
    },
    getAllNames: function() {
        return this._getAttributes().getAllNames(true);
    },
    removeItem: function(itemName) {
        this._record(["remove",itemName]);        
        return this._getAttributes().removeItem(itemName);
    },
    isReadOnly: function(itemName) {
        return this._getAttributes().isReadOnly(itemName, true);
    },
    save: function(callbackfn) {
        var cs = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.iwidget.services.ContainerService.SERVICE_NAME);
        if (cs) {
            cs.switchToModifiablePersistenceMode(com.ibm.mashups.iwidget.services.ContainerService.PROVIDER_ATTRIBUTES); 
        }
        this._clearReplay();
        return this._getAttributes().save(callbackfn);
    },
    commit: function(callbackfn) {
        var cs = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.iwidget.services.ContainerService.SERVICE_NAME);
        if (cs) {
            cs.switchToModifiablePersistenceMode(com.ibm.mashups.iwidget.services.ContainerService.PROVIDER_ATTRIBUTES); 
        }
        this._clearReplay();
        return this._getAttributes().commit(callbackfn);
    },
    addListener: function(/*obj*/fn) {
        return this._getAttributes().addListener(fn);
    },
    removeListener: function(/*String*/listenerId) {
        return this._getAttributes().removeListener(listenerId);
    }
});

}

if(!dojo._hasResource["com.ibm.mm.iwidget.DeferredLoadImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.iwidget.DeferredLoadImpl"] = true;
dojo.provide("com.ibm.mm.iwidget.DeferredLoadImpl");




// deferred Load
dojo.declare("com.ibm.mm.iwidget.DeferredLoadImpl", com.ibm.mm.enabler.DeferredImpl, {
    constructor: function(uri, id, widgetDef) {
        this.uri = uri;
        if (typeof id == "undefined") {
            id = null;
        }
        this.id = id;
        if (typeof widgetDef == "undefined") {
            widgetDef = null;
        }
        this.widgetDef = widgetDef;
    },
    // defaults to synchronous
    start: function(sync) {
        if (this.widgetDef) {
            this._handleCallback(this.widgetDef, 200); //resource first, status code second
            return this.widgetDef;
        }
        var mode = (typeof(sync) == 'undefined') ? true : sync;
        var widgetLoadService = com.ibm.mashups.services.ServiceManager.getService("widgetLoadService");
        widgetLoadService.getWidgetXML(this.uri, mode, dojo.hitch(this, "_handleLoad"), this.id);
        if (sync) {
            return this.widgetDef;
        }
        return null;
    },
    _handleLoad: function(data, statuscode, xhr) {
        if (xhr) {
            statuscode = xhr.status;
        }
        if (statuscode != 200) {
            data = null; //set to null value
        }
        this.widgetDef = data;
        this._handleCallback(data, status);
    },
    _handleCallback: function(widgetDef, status) {
        this.finish(widgetDef, status);
    }
});

}

if(!dojo._hasResource["com.ibm.mm.iwidget.widget.IWidgetWrapperDefaultImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.iwidget.widget.IWidgetWrapperDefaultImpl"] = true;
dojo.provide("com.ibm.mm.iwidget.widget.IWidgetWrapperDefaultImpl");

/*
 * TODO
 * @ibm-module iWidget2
 */






















dojo.declare("com.ibm.mm.iwidget.widget.IWidgetWrapperDefaultImpl", com.ibm.mashups.iwidget.widget.IWidgetWrapper, {
    constructor: function(widgetSpan, id) {
        this._internalIbmModes = iwConstants._INTERNALIBMMODES;
        
        //parsing microformat
        this.rootElement = widgetSpan;
        this.id = id || dojo.attr(widgetSpan,'id');
        this.hubId = this.id; //hubClientId -- used for communication with openajax hub, for main view, it's the same as instanceid
        this.simpleWidgetEvents = {};
        this.loaded = false;
        this.standalone = null;
        this.widgetAttributes = null; // defer creation
        this.widgetItemSets = null; // defer creation to getWidgetItemSet or getItemSets
        this.ns = widgetSpan.className.substr(0, 3);
        this.windowManager = {}; // an associative array of window entities, key is windowid(for release1,it's mode);
        // value is simple json object: {id:"edit",root:rootElement,active:false}
        this.iwMessages = null;
        this.eventSvr = com.ibm.mashups.services.ServiceManager.getService("eventService");
        this._jsHandler = com.ibm.mm.enabler.aggregation.javascript.JAVASCRIPT_HANDLER;
        this.eventHandlers = [];
        this.unregisterArray = [];

        //backward compatibility
        this.publishedEvents = {};
        this.handledEvents = {};
        
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass);
        this.LOG_LEVEL = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
        this.bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
    },
    getID: function() {
        return this.id;
    },
    getIWidgetInstance: function() {
        if (this.widgetInstance) {
            return this.widgetInstance;
        }
        this.widgetInstance = new com.ibm.mm.iwidget.widget.IWidgetInstanceImpl(this, this.rootElement, this.id);
        return this.widgetInstance;
    },
    setIWidgetDefinition: function(widgetDef) {
        this.widgetDef = widgetDef;
    },
    getIWidgetDefinition: function() {
        if (this.loaded) {
            return new com.ibm.mm.iwidget.DeferredLoadImpl(this.getIWidgetInstance().widgetXMLUrl, this.id, this.widgetDef);
        }
        else {
            return new com.ibm.mm.iwidget.DeferredLoadImpl(this.getIWidgetInstance().widgetXMLUrl, this.id);
        }
    },
    getMarkup: function() {
        return new com.ibm.mm.iwidget.DeferredLiveTextUnprocessStubImpl(this);
    },
    doRender: function() {
        try {
            this.prepare();
            this.execute();
        } 
        catch (e) {
            this.LOGGER.severe("IWidgetWrapper.doRender", 'widget: ${0} OnloadingException: ${1}', [this.hubId, e]);
			//throw e;
        }
    },
    prepare: function() {
        var variableName = "_" + this.id + "_" + "iContext";
        if (!this.isModal()) {
            dojo.global[variableName] = new com.ibm.mm.iwidget.icontext.IContextImpl(this, this.ns);
        }
        else {
					var mainframeId = this._mainframeId;
			var iContextInstance = parent[mainframeId][variableName];
			dojo.global[variableName] = iContextInstance;					
        }
        
        //subscribe event handler so event can be handled
        //if (this._inIframe())  console.log("subscribe hubClient:"+this.eventSvr.WIDGETEVENT_PREFIX + this.hubId);
        var eventServiceHandler = this.eventSvr._subscribeEvent(this.eventSvr.WIDGETEVENT_PREFIX + this.hubId, this, "handleEvent", null, this.hubId);
        
        if (!this._inIframe()) {
            this.eventHandlers.push(eventServiceHandler);
        }
    },
    execute: function() {
        this._initialize(dojo.hitch(this, function(){
            this._doRender();
        }));
    },

    _initialize: function(callback) {
    
        var lang = this.widgetDef.getDefaultLanguage();
        if (typeof lang != "undefined" && lang !== null) {
            this.defaultLanguage = lang;
        }
        else {
            this.defaultLanguage = "en";
        }
        
        var aMode = this._getInitDefaultMode();
        if (aMode === null) {
            aMode = iwConstants.mode_view;
        }
        this.currentMode = aMode;
        if (this._handleSaveMode) {
            this._handleSaveMode();
        }
        
        this._initManagedItemSet();
        
        if (callback) {
            callback();
        }
    },
    
    _getResourceBundle: function() {
        return null;
    },
    
    _logUpdateMarkupError: function(mode) {
    },
    _getMarkupByMode: function(mode) {
        var wInfo = this.widgetDef;
        var elem = wInfo.getMarkupByMode(mode);
        if (elem && elem.uri) {
            var uri = this._rewriteURI(elem.uri);
            dojo.xhrGet({
                url: uri,
                handleAs: "text",
                sync: true,
                load: function(result) {
                    if (result) {
                        var newElem = {};
                        newElem.content = result;
                        wInfo.setMarkupByMode(mode, newElem);
                    }
                },
                error: function(data, ioArgs) {
                    this.LOGGER.severe("_getMarkupByMode", "error loading content for mode:" + mode, data);
                    delete elem.uri;
                }
            });
        }
        var markup = null;
        if (wInfo.getMarkupByMode(mode)) {
            markup = wInfo.getMarkupByMode(mode).content;
        }
        return markup;
    },
	_updateTitle: function() {
    	// noop
	},
    _updateMarkup: function(mode, contentDiv) {
        var markup = this._getMarkupByMode(mode);
        
        if (mode == iwConstants.mode_view) {
            if (this.widgetDef.getAllowInstanceContent()) {
                var temp = this.getIWidgetInstance().getDefaultViewContent();
                if (temp && temp !== null) {
                    markup = temp;
                }
            }
        }
        if (typeof markup == "undefined" || markup === null) {
            this._logUpdateMarkupError(mode);
            return true;
        }
        //parse the mark and replace iContext with _widgetid_iContext
        var updatedMarkup = this._prepareMarkup(markup);
        updatedMarkup = updatedMarkup.replace(/^\s+|\s+$/, '');
        if (updatedMarkup.indexOf("<script") === 0) {
            updatedMarkup = "&nbsp;" + updatedMarkup;
        }
        
        //append all the nodes to a temporary div element
        var tempDIV = document.createElement("DIV");
        tempDIV.innerHTML = updatedMarkup;
        
        // find the script elements
        var scriptElems = tempDIV.getElementsByTagName("script");
        if (scriptElems !== null) {
            // iterate over script elements and attach an id attribute ,
            // this is necessary so if there's document.write, it got over written
            // otherwise you will get a blank page!
            for (var i = 0, l = scriptElems.length; i < l; i++) {
                var scriptElem = scriptElems[i];
                
                // include an id if there is none so far
                // (needed to lookup script in original DOM later on)
                var id = scriptElem.getAttribute("id");
                if (id === null || id == "") {
                    scriptElem.setAttribute("id", "_scr#" + i);
                }
            }
        }
        // update the DOM before executing the scripts
        // (the scripts might rely on elements in the DOM)
        //var contentDiv = this.rootElement.lastChild;
        contentDiv.innerHTML = tempDIV.innerHTML;
        //destroy tempDiv
        com.ibm.mm.enabler.utils.Dom.destroyNode(tempDIV);
        return true;
    },
    _prepareMarkup: function(markup) {
        var oldMarkup = markup.replace(/_IWID_/g, "_" + this.id + "_");
        //?= is javascript 1.5 feature
        var finalMarkup = oldMarkup.replace(/iContext(?=\.|\s|\(|\))/g, "_" + this.id + "_iContext");
        return finalMarkup;
    },
    destroy: function() {
        if (this.loaded && !this.isModal()) {
            this._handleEventInternal(iwConstants.EVENTS.onUnLoad);
        }
        if (!this._inIframe()) {
            var wireModel = this.getIWidgetInstance().getWireModel();			
			//remove any wires coming into this widget (any wires that this widget is a target of)
			if (wireModel) {
				var myWires = wireModel.getWires();
				if (myWires) {
					var j = myWires.length;
					for (var k = j - 1; k >= 0; k--) {
						var wireSourceID = myWires[k].getSourceWidgetID();
						wireModel.removeWire(wireSourceID);
						this.commit();				
					}
				}
			}			
			//remove any wires going out of this widget (any wires that this widget is a source of)
            var targets = null;
            if (wireModel) {
                targets = wireModel.getTargets();
            }
            if (targets) {
				var widgetModel = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel();
                for (var i in targets) {
                    if (Object.prototype.hasOwnProperty.call(targets,i)) {
                        var widget = widgetModel.find(i);
                        if (widget) {
                            var wires = widget.getIWidgetInstance().getWireModel();
                            wires.removeWire(this.id); // remove all the wires that contains "this.id" as source
                            widget.commit();
                        }
                    }
                }
            }
            for (var x in this.eventHandlers) {
                if (Object.prototype.hasOwnProperty.call(this.eventHandlers,x)) {
                    this.eventSvr._unsubscribeEvent(this.eventHandlers[x], this.hubId);
                }
            }
            this.eventSvr._getHubAdapter(this.hubId).removeInlineHubClient(this.hubId);
            if (dojo.global["_" + this.id + "_" + "iContext"])//when iframe is removed,this could be null
            {
				dojo.global["_" + this.id + "_" + "iContext"]._destroy();
                dojo.global["_" + this.id + "_" + "iContext"] = null;
            }
        }
        else {
            //delete dojo.global["_"+this.id+"_"+"iContext"];   //doesn't work on IE7, can't delete from global context
            if (!this.isModal()) {
                this.eventSvr.disconnectHubClient();
                if (dojo.global["_" + this.id + "_" + "iContext"])//when iframe is removed,this could be null
                {
                    dojo.global["_" + this.id + "_" + "iContext"] = null;
                }
            }
        }
        if (this.rootElement) {
            this.rootElement = null;
        }
        if (this.windowManager) {
            this.windowManager = null;
        }
        //notify target widget to removeWire
    	// #17713 destroy the widgetInstance
		this.widgetInstance._destroy();
    },
    _doRender: function() {
		//update the title
        if (!this._inIframe()) {
			this._updateTitle();
		}
        var tempDiv = document.createElement("div");
        tempDiv.className = this.ns + "Content";
        this.rootElement.appendChild(tempDiv);
        var contentDiv = this.rootElement.lastChild;
        dojo.addClass(contentDiv, this.currentMode);
        contentDiv.style.visibility = "hidden";
        if (this._inIframe()) {
            dojo.style(contentDiv, "height", "100%");
        }
        //need to render default mode for modal dialog since some widgets will create dom in onload etc...
        var defIDescriptor = this.widgetDef.getIDescriptorItems();
        var defaultMode = defIDescriptor.getItemValue(iwConstants.iDescriptorItems.mode);
        if (this.isModal() && this.currentMode != defaultMode) {
            //create a div tag for main view
            var tempDiv1 = document.createElement("div");
            tempDiv1.className = this.ns + "Content";
            this.rootElement.appendChild(tempDiv1);
            contentDiv1 = this.rootElement.lastChild;
            dojo.addClass(contentDiv1, defaultMode);
            contentDiv1.style.visibility = "hidden";
            contentDiv1.style.display = "none";
            this._updateMarkup(defaultMode, contentDiv1);
        }
        
        this._updateMarkup(this.currentMode, contentDiv);
        this._loadWidgetSharedResource(dojo.partial(this._finishRender, contentDiv, this));
    },
    _finishRender: function(contentDiv, wrapper) {
        // Important for timing to subscribe to this event before loading widget
		try {
			var eventHandler = wrapper.eventSvr._subscribeEvent(com.ibm.mashups.iwidget.Constants.RESIZE_WIDGET + "." + wrapper.id, wrapper, "handleSizeChanged", null, wrapper.id);
			wrapper.eventHandlers.push(eventHandler);
			
			wrapper._createiScope();
			//contentDiv = wrapper.rootElement?
			wrapper._evalScripts(contentDiv);
			wrapper.windowManager[wrapper.currentMode] = {
				id: wrapper.currentMode,
				root: contentDiv,
				active: true,
				external: false
			};
			
            // remove the iw-loading div
            dojo.query("> ." + wrapper.ns + "loading", wrapper.rootElement).forEach(function(elem) {
                com.ibm.mm.enabler.utils.Dom.destroyNode(elem);
            });
            
			wrapper.onLoad();
            
			//now handle queued events if there's any
			if (typeof wrapper._eventqueue != "undefined" && wrapper._eventqueue !== null) {
				for (var event in wrapper._eventqueue) {
					if (Object.prototype.hasOwnProperty.call(wrapper._eventqueue, event)) {
						wrapper.handleEvent(wrapper._eventqueue[event]);
					}
				}
			}
		}catch(e){
			//stop widget Gracefully
			if (wrapper._logInlineMessage) {
				wrapper._logInlineMessage(wrapper,e);			
			}
			 if (wrapper.bIsLoggable) {
                       wrapper.LOGGER.trace("iWidget._finishRender", "failed to render widget:" + wrapper.id+ " Error:"+e.message);
             }
			 return;
			
		}
        
        dojo.query("." + wrapper.currentMode, wrapper.rootElement).style({
            "visibility": "" //display:"none" will make mode selector not displaying properly    
            //set visible will work funny in FF, the node will be visible even parent node is set to be invisible       
        });
    },
    _evalScripts: function(contentDiv) {
        dojo.query("script",contentDiv).forEach(function(script) {
            this._jsHandler.handle(script);
        },this);
    },
    onLoad: function() {
        if (!this.isModal()) { //no need to call onload anymore since it should already be initialized
            this._handleEventInternal(iwConstants.EVENTS.onLoad);
        }
        //update state like onNavStateChanged
        this.updateState();
        //tell the stub widget is loaded
		var iEvent = new com.ibm.mm.iwidget.IEventImpl("on" + this.currentMode,null,{oldMode:null}); 
        this._handleEventInternal("on" + this.currentMode,iEvent);
        this.loaded = true;
        try {
            //tell builder widget is loaded
            dojo.publish(com.ibm.mashups.iwidget.Constants.WIDGET_LOADED + "." + this.id, [this.id]);
        } 
        catch (e) {
            //workaround
            throw e;
        }
        this.eventSvr._publishEvent(com.ibm.mashups.iwidget.Constants.WIDGET_LOADED + "." + this.hubId, this.hubId);
        
    },
    updateState: function() {
        return;
    },
    _getSimpleEventHandler: function(/*String*/eventName) {
        if (this.simpleWidgetEvents && typeof this.simpleWidgetEvents[eventName] != "undefined") {
            return this.simpleWidgetEvents[eventName];
        }
        var handler = this.widgetDef.getWidgetEvents()[eventName];
        if (!handler) {
            handler = eventName;
        }
        var scope = this._getHandlerScope(handler);
        var handlerObj = null;
        if (scope) {
            handlerObj = dojo.hitch(scope, handler);
            this.simpleWidgetEvents[eventName] = handlerObj;
        }
        else if (handler.indexOf("on") === 0) {
            //get Uppercase event like onedit --> onEdit
            var newhandler = "on" + handler.substr(2, 1).toUpperCase() + handler.substr(3);
            if (newhandler != handler) {
                scope = this._getHandlerScope(newhandler);
                if (scope) {
                    handlerObj = dojo.hitch(scope, newhandler);
                    this.simpleWidgetEvents[eventName] = handlerObj;
                }
            }
        }
        return handlerObj;
    },
    _getHandlerScope: function(/*String*/handler) {
    
        //returns a global function or scope object
        var fn = dojo.global["_" + this.id + "_" + handler];
        if (typeof(fn) == "undefined") {
            var widgetScope = dojo.global["_" + this.id + "_iContext"].iScope();
            if (widgetScope && widgetScope[handler]) {
                fn = widgetScope;
            }
        }
        if (typeof fn == "undefined" || fn === null) {
            fn = dojo.global[handler];
        }
        if (typeof fn == "undefined" || fn === null) {
            return null;
        }
        else {
            return fn;
        }
    },
    handleEvent: function(payload) {
        //event handler that subscribes to event handler
        var declaredClass = payload.declaredClass;
        if (declaredClass == "com.ibm.mm.iwidget.IEventImpl") {
            var eventName = payload.name;
            return this._handleEvent(eventName, payload);
        }
    },
    _handleEvent: function(eventName, iEvent) {
        var METHOD_NAME = "_handleEvent(eventName, iEvent)";
        if (this.bIsLoggable) {
            this.LOGGER.entering(METHOD_NAME, [eventName, dojo.toJson(iEvent)]);
        }
        iEvent = this._deserializePayload(iEvent);
        
        //check here. it's just one payload with {eventName,iEvent}
        if (typeof eventName == "undefined" || eventName === null) {
            return false;
        }
        if (!this.loaded) {
            if (!this._eventqueue) {
                this._eventqueue = {};
            }
            this._eventqueue[eventName] = iEvent;
            return;
        }
        //handle onModeChanged event
        try {
            /*	if (eventName == iwConstants.EVENTS.onNavStateChanged) {
             return this._handleOnNavStateChanged(iEvent);
             }	*/
            if (eventName == iwConstants.EVENTS.onModeChanged) {
                if (this._inIframe()) {
                    //publish event to stub widget
                    var payloadObj = {};
                    payloadObj.methodname = "_handleOnModeChange";
                    payloadObj.hubclient = this.hubId;
                    payloadObj.params = [iEvent.payload];
                    //var id = "_stub_"+this.id.slice(0,this.id.lastIndexOf("_"));			
                    var id = "_stub_" + this.id;
                    this.eventSvr._publishEvent(iwConstants.WIDGETEVENT_PREFIX + id, payloadObj, this.hubId);
                    return;
                }
                
                return this._handleModeChange(iEvent);
            }
            
            return this._handleEventInternal(eventName, iEvent);
        } 
        catch (e) {
            this.LOGGER.severe("IWidgetWrapper.handleEvent", 'widget: ${0}, eventName: ${1}, HandleEventException: ${2}', [this.hubId, eventName, e]);
			throw e;
        }
    },
    _deserializePayload: function(iEvent) {
        // complex payload objects must be deserialized from json for case when widgets are sandboxed
        // to be serializable, complex payload objects must implement toJson method that returns json in format {"className":"x","json":"y"}
        // to be deserializable, complex payload objects must have a constructor with an argument that accepts the "y" json value returned from toJson
        if (typeof iEvent.payload == 'string' && iEvent.payload.indexOf("className") != -1 && iEvent.payload.indexOf("json") != -1) {
            try {
                var deserialized = dojo.fromJson(iEvent.payload);				
                if (deserialized.className && typeof deserialized.className == 'string' && deserialized.className.length > 0 && deserialized.json && typeof deserialized.json == 'string') {				
   				    var deserialized_payload = deserialized.json;				
					// check if this is a table object that requires an additional deserialization of its payload before it is instanciated as a table - 15594
					if (deserialized.className=="com.ibm.mm.data.table" && deserialized_payload.indexOf("data") != -1) {
						 deserialized_payload = dojo.fromJson(deserialized_payload); 
					}								
                    iEvent.payload = new (dojo.getObject(deserialized.className))(deserialized_payload);
                }
            } 
            catch (e) {
				this.LOGGER.severe("IWidgetWrapper._deserializePayload", 'widget: ${0}, eventName: ${1}, PayloadDeserializeException: ${2}', [this.hubId, iEvent.payload, e]);
				throw e;
            }
        }
        return iEvent;
    },
    _handleOnModeChange: function(newMode) {
        var aEvent = new com.ibm.mm.iwidget.IEventImpl("onModeChanged", null, {
            newMode: newMode
        }, null);
        this._handleModeChange(aEvent);
    },
    _handleModeChange: function(iEvent) {
        var isHandled = false;
        var oldMode = this.currentMode;
        
        var payload = iEvent.payload;
        if (typeof payload == "undefined" || payload === null) {
            return false;
        }
        if (dojo.isString(payload)) {
            payload = dojo.fromJson(payload);
        }
        if (typeof payload == "undefined" || payload === null) {
            return false;
        }
        var newMode = payload.newMode || null;
        var newRoot = payload.rootElementId || null;
        
        // support one active mode only, thus don't support this operation
        if (newMode !== null && newMode == this.currentMode) {
            return false;
        }
        if (newMode === null) {
            return false;
        }
        
        var external = newRoot !== null;
        var updatedNewRoot = newRoot;
        
        var defaultMode = this._getDefaultMode();
        if (!defaultMode) {
            defaultMode = "view";
        }

        var oldWindow = this.windowManager[newMode] || null;

        // make sure that we only make default logic if the widget was launched with default mode
        if (this._inIframe() && oldWindow !== null && defaultMode == newMode) {
            //swtich back to view mode
            this.currentMode = newMode;
            
            if (this._handleSaveMode) {
                this._handleSaveMode();
            }
            // update newMode window state
            this.windowManager[newMode].active = true; 
			if (updatedNewRoot !== null) {
			   this.windowManager[newMode].root = updatedNewRoot;
			}			
            dojo.style(this.windowManager[newMode].root, "display", "");			
			// update oldMode window state
			var oldModeWindow = this.windowManager[oldMode];
			oldModeWindow.active = false;
			if (oldModeWindow.root) {
               dojo.style(oldModeWindow.root, "display", "none");			
			}
            this._handleOnModeEvent(newMode,oldMode);
            return;
        }
        //change:e
        
        var isWindowAvailable = false;
        if (typeof oldWindow != "undefined" && oldWindow !== null) {
            var oldRoot = oldWindow.root;
            if (!oldWindow.external && oldRoot !== null && newRoot === null) {
                updatedNewRoot = oldRoot;
                isWindowAvailable = true;
                isHandled = true;
                //how to verify a node doesn't exist anymore?
                // turn on this window
                dojo.style(oldRoot, "display", "");
                
            }
        }

        //create new window and update markup
        if (!isWindowAvailable) {
            if (updatedNewRoot === null) {
                var tempDiv = document.createElement("div");
                tempDiv.className = this.ns + "Content";
                this.rootElement.appendChild(tempDiv);
                updatedNewRoot = this.rootElement.lastChild;
                dojo.addClass(updatedNewRoot, newMode);
            }
            isHandled = this._updateMarkup(newMode, updatedNewRoot);
        }
        if (isHandled) {
            //hide current view 
            var currentWindow = this.windowManager[this.currentMode];
            var currentRoot = currentWindow.root;
            if (currentWindow.external) {
                dojo.style(currentRoot, "display", "none");//todo, destroy external window?
                this.windowManager[this.currentMode] = null;
            }
            else if (newRoot !== null) { //if the newRoot is provided, don't hide current window. leave builder to do this.
                currentWindow.active = false;
            }
            else {
                currentWindow.active = false;
                dojo.style(currentRoot, "display", "none");
            }
            
            //change current mode
			oldMode = this.currentMode;
            this.currentMode = newMode;
            if (this._handleSaveMode) {
                this._handleSaveMode();
            }
            
            //  save/reset new window
            this.windowManager[newMode] = {
                id: newMode,
                root: updatedNewRoot,
                active: true,
                external: external
            };
            
            if (!isWindowAvailable) {
                this._evalScripts(updatedNewRoot);
            }
            this._handleOnModeEvent(newMode,oldMode);
        }
        if (isHandled && !this._inIframe()) {
            dojo.publish(iwConstants.EVENTS.modeChanged, [this.id, oldMode, newMode]);
            payload = {};
            payload.id = this.id;
            payload.oldMode = oldMode;
            payload.newMode = newMode;
            this.eventSvr._publishEvent(com.ibm.mashups.iwidget.Constants.WIDGET_MODECHANGED, payload, this.hubId);
        }
        
        if (this._inIframe()) {
            //switch from view -->edit  very rare use case since mode switch are triggered from skin
            //just tell stub mode is updated
            var payloadObj = {};
            payloadObj.methodname = "_handleOnModeUpdated";
            payloadObj.hubclient = this.hubId;
            payloadObj.params = [iEvent.payload];
            //var id = "_stub_"+this.id.slice(0,this.id.lastIndexOf("_"));			
            var id = "_stub_" + this.id;
            this.eventSvr._publishEvent(iwConstants.WIDGETEVENT_PREFIX + id, payloadObj, this.hubId);
        }
        
        return isHandled;
    },
    _handleOnModeUpdated: function(mode) {
        var newMode = mode.newMode || mode;

        // in case we get the update for the mode we are already in, don't switch
        if (newMode == this.currentMode) {
            return;
        }

        this.currentMode = newMode;

        if (this._handleSaveMode) {
            this._handleSaveMode();
        }
        this.windowManager[newMode] = {
            id: this.id,
            active: true,
            external: true
        };
    },
    _handleOnModeEvent: function(mode,oldMode) {
        if (this._inIframe()) {
            dojo.setContext(com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().global, com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().doc);
            if (dojo.isIE) {
                if (document._mmcreateElement) {
                    document.createElement = document._mmcreateElement;
                }
                if (document._mmgetElementsByTagName) {
                    document.getElementsByTagName = document._mmgetElementsByTagName;
                }
            }
        }
        var isHandled = false;
        //handle event
        var eventName = "on" + mode;
		if (!oldMode) {
			oldMode = null;
		}
		var iEvent = new com.ibm.mm.iwidget.IEventImpl(eventName,null,{oldMode:oldMode}); 
		isHandled = this._handleEventInternal(eventName,iEvent);
        return isHandled;
    },
    _handleEventInternal: function(/*String*/eventName, iEvent) {
        if (typeof eventName == "undefined" || eventName === null) {
            return false;
        }
        
        var isHandled = false;
        var handlerFn = null;
        
        if (eventName.indexOf("on") === 0) {
            var eventHandler = this._getSimpleEventHandler(eventName);
            if (eventHandler !== null) {
                handlerFn = eventHandler;
            }
        }
        if (handlerFn === null) {
            handlerFn = this.getPublicEventHandler(eventName);
        }
        if (dojo.isFunction(handlerFn)) {
            try {
                if (iEvent) {
                    //transform data if necessary
                    if (this._transform) {
                        iEvent = this._transform(eventName, iEvent);
                    }
                    dojo.partial(handlerFn)(iEvent);
                }
                else {
                    dojo.partial(handlerFn)();
                }
            } 
            catch (e) {
                this.LOGGER.severe("IWidgetWrapper._handleEventInternal", 'widget: ${0}, eventName: ${1}, HandleEventException: ${2}', [this.hubId, eventName, e]);
				throw e;
            }
            isHandled = true;
        }
        return isHandled;
    },
    getPublicEventHandler: function(/*String|Function*/eventName) {
        return null;
    },
    _getParent: function() {
        if (!this.parent) {
            this.parent = com.ibm.mm.iwidget.Utils.getWidgetParent(this.rootElement);
        }
        this.parent = this.parent || null;
        return this.parent;
    },
    _setParent: function(parent) {
        this.parent = parent;
    },
    getAttributes: function() {
        //Summary: returns an ManagedItemSet which provides access to the iWidget's customization attributes. 
        //          The returned ManagedItemSet will be teh same as getItemSet(iContext.constants.itemset.ATTRIBUTES).
        //          returns empty set if there's no ItemSet.Return null if iWidget customization attributes is not
        //          supported
        if (!this.widgetAttributes) {
            var service = com.ibm.mashups.services.ServiceManager.getService("persistentAttributesFactoryService");
            this.widgetAttributes = new com.ibm.mm.iwidget.manageditemset.AttributesModeDelegate(service, this);
        }
        return this.widgetAttributes;
    },
    getWidgetItemSets: function() {
        if (this.widgetItemSets) {
            return this.widgetItemSets;
        }
        this.widgetItemSets = {};
        
        if (this.widgetDef) {
            var names = this.widgetDef.getAllItemSetNames();
            for (var i = 0, l = names.length; i < l; i++) {
                var id = names[i];
                var itemSetWrapper = this.widgetDef.getItemSet(id);
                var anItemSet = new com.ibm.mm.iwidget.itemset.ItemSetDefaultImpl(this, itemSetWrapper, id);
                this.widgetItemSets[id] = anItemSet;
            }
        }
        return this.widgetItemSets;
    },
    getWidgetItemSet: function(/*String*/name) {
        var widgetItemSets = this.getWidgetItemSets();
        var rtnVal = null;
        if (widgetItemSets) {
            rtnVal = widgetItemSets[name];
            if (!rtnVal) {
                rtnVal = new com.ibm.mm.iwidget.itemset.ItemSetDefaultImpl(this, null, name);
                this.widgetItemSets[name] = rtnVal;
            }
        }
        return rtnVal;
    },
    _loadWidgetSharedResource: function(cb2) {
        if (cb2) {
            cb2();
        }
    },
    _createiScope: function() {
        if (!this.isModal()) {
            var iScope = this.widgetDef.getIScope();
            var iScopeInstance = null;
            if (typeof iScope != "undefined" && iScope !== null) {
                try {
                    iScopeInstance = new (dojo.getObject(iScope))();
                } 
                catch (err) {
                    if (this.bIsLoggable) {
                        this.LOGGER.trace("iWidget._createiScope", "iScope" + iScope, "Error", err);
                    }
                }
            }
            this.iScope = iScopeInstance ||
            {};
            
            dojo.global["_" + this.id + "_iContext"].scope = this.iScope;
            this._executeCallbackQueue();
        }
        else {
            this.iScope = dojo.global["_" + this.id + "_iContext"].scope;
        }
        this.iScope.iContext = dojo.global["_" + this.id + "_iContext"];
    },
    getIDescriptorItems: function() {
        if (this.iDescriptor) {
            return this.iDescriptor;
        }
        //read only for now
        this.iDescriptor = new com.ibm.mm.iwidget.manageditemset.IDescriptorImpl(this, this.widgetDef.getIDescriptorItems(), this.getIWidgetInstance().getIDescriptorItems());
        return this.iDescriptor;
    },
	_getInitDefaultMode:function(){
		if (this._getModeFromNavStateModel) {
            var aMode = this._getModeFromNavStateModel();
            if (typeof aMode != "undefined" && aMode !== null) {
                return aMode;
            }
        }
		return this._getDefaultMode();		
	},
    _getDefaultMode: function() {
      
        var instanceIDescriptor = this.getIWidgetInstance().getIDescriptorItems();
        if (typeof instanceIDescriptor != "undefined" && instanceIDescriptor !== null) {
            var instanceItem = instanceIDescriptor.getItemValue(iwConstants.iDescriptorItems.mode);
            if (instanceItem) {
                return instanceItem;
            }          
        }
        var defIDescriptor = this.widgetDef.getIDescriptorItems();
        var defItem = null;
        if (typeof defIDescriptor != "undefined" && defIDescriptor !== null) {
            defItem = defIDescriptor.getItemValue(iwConstants.iDescriptorItems.mode);
        }
        return defItem || null;
    },
    _getMarkup: function(includeParent) {
        //returning Markup to proxy widget stub		
        var that = this;
        var cb = function(node, status) {
            that.eventSvr._publishEvent(that.eventSvr.WIDGETEVENT_PREFIX + that.id + ".onMarkupReturned", node);
        };
        var deferred = this.getMarkup();
        deferred.setIncludeParent(includeParent);
        deferred.setFinishedCallback(cb);
        deferred.start();
    },
    _inIframe: function() {
        return false;
    },
    commit: function(noSync) {
        var widgetInstance = this.getIWidgetInstance();
        var instanceAttributes = null;
        if (this._inIframe() && !noSync) { //if it's within iframe, synchronize all the data change...
            //send attributes/wiremodel  to the stub for now...
            
            var dataObj = {};
            instanceAttributes = widgetInstance.getAttributes();
            if (instanceAttributes && instanceAttributes._isDirty()) {
                dataObj.attributes = dojo.clone(instanceAttributes.toJson());
            }
            var wireModel = widgetInstance.getWireModel();
            if (wireModel && wireModel.isDirty()) {
                dataObj.wiremodel = wireModel.toJson();
            }
            
            var payloadObj = {};
            payloadObj.methodname = "_handleDataSync";
            payloadObj.hubclient = this.hubId;
            payloadObj.params = [dataObj];
            //send any updates to stub widget first
            
            var id = "_stub_" + this.id;
            this.eventSvr._publishEvent(iwConstants.WIDGETEVENT_PREFIX + id, payloadObj, this.hubId);
            //here's the flow main dialog -- stub
            return;
            
        }
        // need to check attribute properties and idescriptor attributes
        instanceAttributes = widgetInstance.getAttributes();
        
        if (instanceAttributes && instanceAttributes._isDirty()) {
            //source onItemSetChanged to the widget
            this._notifyWidget(this, "attributes", instanceAttributes);
            this._writePropertiesToDOM(this, "attributes", instanceAttributes);
            instanceAttributes._setDirty(false);
        }
        
        var instanceIDescriptor = widgetInstance.getIDescriptorItems();
        
        if (instanceIDescriptor && instanceIDescriptor._isDirty()) {
            //source onItemSetChanged to the widget
            this._notifyWidget(this, "idescriptor", instanceIDescriptor);
            this._writePropertiesToDOM(this, "idescriptor", instanceIDescriptor);
            instanceIDescriptor._setDirty(false);
        }
        
        //check wires
        var wiremodel = widgetInstance.getWireModel();
        if (wiremodel && wiremodel.isDirty()) {
            wiremodel.commit();
        }
    },
    _writePropertiesToDOM: function(widgetWrapper, itemSetName, properties) {
        var ns = widgetWrapper.ns;
        var root = widgetWrapper.rootElement;
        
        // query the markup for the given itemSetName
        var itemSets = dojo.query('span.' + ns + 'ItemSet[title="' + itemSetName + '"]', root);
        
        // iterate through the itemsets and delete those that are already inside of the markup
        for (var i = 0, l = itemSets.length; i < l; i++) {
            var itemSet = itemSets[i];
            if (root == itemSet.parentNode) {
                root.removeChild(itemSet);
            }
        }
        
        // create the new ItemSet span
        var newItemSet = document.createElement("span");
        newItemSet.className = ns + 'ItemSet';
        newItemSet.title = itemSetName;
        newItemSet.style.display = "none";
        newItemSet.style.visibility = "hidden";
        
        // append it to the DOM
        root.appendChild(newItemSet);
        
        var names = properties.getAllNames();
        
        if (!names) {
            return;
        }
        
        // iterate through all the items in the itemset
        for (var k = 0, l2 = names.length; k < l2; k++) {
            var itemName = names[k];
            var newItem = document.createElement("a");
            newItem.className = ns + 'Item';
            newItem.style.visibility = "hidden";
            newItem.style.display = "none";
            newItem.href = "#" + itemName;
            // read only ? --todo, not spec compliant
            if (properties.isReadOnly(itemName)) {
                dojo.addClass(newItem, ns + "ReadOnly");
            }
            var locales = properties.getItemLocales(itemName);
            if (!locales || (locales !== null && locales.length == 1 && locales[0] == "")) {
                var value = properties.getItemValue(itemName);
                if (value) {
                    newItem.appendChild(document.createTextNode(value));
                }
                newItemSet.appendChild(newItem);
            }
            else if (locales !== null) {
                var defaultLocale = properties._getItemDefaultLocale(itemName);
                if (!defaultLocale) {
                    defaultLocale = properties.DEFAULT_LOCALE; // this is not as nice as it should be
                }
                // create the new Element
                
                newItem.setAttribute("lang", defaultLocale);
                
                for (var j = 0; j < locales.length; j++) {
                    var langSpan = document.createElement("span");
                    langSpan.setAttribute("class", ns + "Value");
                    langSpan.setAttribute("lang", locales[j]);
                    var langValue = properties.getItemValue(itemName, locales[j]);
                    langSpan.appendChild(document.createTextNode(langValue));
                    newItem.appendChild(langSpan);
                }
                
                // append it to the itemset Span
                newItemSet.appendChild(newItem);
            }
        }
    },
    _notifyWidget: function(widgetwrapper, itemsetname, properties) {
        var names = properties.getAllNames();
        if (!names) {
            return;
        }
        var payload = {};
        payload.itemSetName = itemsetname;
        payload.changes = [];
        
        // iterate through all the items in the itemset
        for (var i = 0, l = names.length; i < l; i++) {
            var itemName = names[i];
            if (properties._isItemDirty && properties._isItemDirty(itemName)) {
                var value = properties._getInternalItemValue(itemName);
                
                if (value && value._change) {
                    var _change = dojo.clone(value._change);
                    if (_change.newVal) {
                        _change.newVal = properties._getRequiredValue(_change.newVal);
                    }
                    if (_change.oldVal) {
                        _change.oldVal = properties._getRequiredValue(_change.oldVal);
                    }
                    payload.changes.push(_change);
                }
                properties._setItemDirty(itemName, false);
            }
        }
        
        var listeners = this._getListeners(itemsetname);
        for (var x in listeners) {
            if (Object.prototype.hasOwnProperty.call(listeners,x)) {
                listeners[x](payload);
            }
        }
    },
    isModal: function() {
        //indicate if this is an iframe rendered in a modal dialog
        //return this._isModal? this._isModal:false;
        return false;
    },
    isLoaded: function() {
        return this.loaded;
    },
    isStandalone: function() {
        if (this.standalone === null) {
            this.standalone = dojo.hasClass(this.rootElement,
                    com.ibm.mm.iwidget.Constants.CSSCLASS_PREFIXED_INSTANCE.iwStandalone);
        }
        return this.standalone;
    },
    handleSizeChanged: function(payload) {
        if (payload.newWidth) {
            this.width = payload.newWidth;
        }
        if (payload.newHeight) {
            this.height = payload.newHeight;
        }
        var aEvent = new com.ibm.mm.iwidget.IEventImpl(iwConstants.EVENTS.onSizeChanged, null, payload, null);
        this._handleEvent(iwConstants.EVENTS.onSizeChanged, aEvent);
    },
    _isEmpty: function(obj) {
    	return com.ibm.mm.enabler.utils.Misc.isEmpty(obj);
    },
    _getListeners: function(itemSetName) {
        //only iwConstants.ATTRIBUTES && iwConstants.IDESCRIPTOR
        if (!this.listenerManager) {
            return null;
        }
        if (!this.listenerManager[itemSetName]) {
            return null;
        }
        return this.listenerManager[itemSetName];
    },
    _registerListener: function(itemSetName, fn) {
        if (!this.listenerManager) {
            this.listenerManager = {};
        }
        this.listenerManager[itemSetName] = this.listenerManager[itemSetName] ? this.listenerManager[itemSetName] : {};
        var listenerId = this._generateListenerId();
        var me = this;
        var listener = function(payload) {
            var changes = payload.changes ? payload.changes : null;
            if (changes.length > 0) {
                var iEvent = new com.ibm.mm.iwidget.IEventImpl("onItemSetChanged", null, payload);
                if (dojo.isString(fn)) {
                    var scope = me._getHandlerScope(fn);
                    if (scope) {
                        fn = dojo.hitch(scope, fn);
                    }
                }
                if (dojo.isFunction(fn)) {
                    dojo.partial(fn)(iEvent);
                }
            }
        };
        this.listenerManager[itemSetName][listenerId] = listener;
        return listenerId;
    },
    _removeListener: function(itemSetName, id) {
        if (!itemSetName || typeof id == "undefined" || id === null) {
            return false;
        }
        if (!this.listenerManager) {
            return false;
        }
        if (!this.listenerManager[itemSetName]) {
            return false;
        }
        if (this.listenerManager[itemSetName][id]) {
            delete this.listenerManager[itemSetName][id];
            return true;
        }
        return false;
    },
    _generateListenerId: function() {
        if (typeof this._listenerCt == "undefined") {
            this._listenerCt = 0;
        }
        else {
            this._listenerCt++;
        }
        return this._listenerCt;
    },
    _initManagedItemSet: function() { //register listener for idescriptor and attributes
        var listener = null;
        if (typeof(this.widgetDef) != "undefined") {
            listener = this.widgetDef._getManagedItemSetListener(iwConstants.ATTRIBUTES);
            if (listener !== null) {
                this._registerListener(iwConstants.ATTRIBUTES, listener);
            }
            listener = this.widgetDef._getManagedItemSetListener(iwConstants.IDESCRIPTOR);
            if (listener !== null) {
                this._registerListener(iwConstants.IDESCRIPTOR, listener);
            }
        }
    },
	_getRawUri:function(){
			var rawUri = this.getIWidgetInstance().widgetXMLUrl;
            if (this.widgetDef.getXmlBase()) {
                rawUri = this.widgetDef.getXmlBase();
            }
			return rawUri;
	},
	_initBaseUri:function(rawUri){
		if (!rawUri) {
			return;
		}
		this.rawBaseUri = this._getRawBaseUri(rawUri);
        this.widgetBaseUri = this._getResolvedPocUri(this.rawBaseUri);
		this.widgetBaseUriXhr = this._getXhrUri(this.widgetBaseUri);  
			
		if (this.rawBaseUri.indexOf(":/") != -1) {
				var serverRoot = this._getServerRoot(this.rawBaseUri); 
				if (serverRoot) {
					this.serverRoot = this._getResolvedPocUri(serverRoot);
					this.serverRootXhr = this._getXhrUri(this.serverRoot);
				} 
		}
	},
    _rewriteURI: function(/*String*/uri, isXhr) {
        
        if (!this.widgetBaseUri) {
            var rawUri = this._getRawUri();
			this._initBaseUri(rawUri);
        }
		
		return this._rewriteURIWithContext(uri,isXhr,this.widgetBaseUri,this.widgetBaseUriXhr,this.serverRoot,this.serverRootXhr);
     },
	 _rewriteURIWithContext:function(uri,isXhr,widgetBaseUri,widgetBaseUriXhr,serverRoot,serverRootXhr)	{
     
	 	if (typeof isXhr == "undefined") {
			isXhr = true;
		}    
              
        var uri2 = com.ibm.mm.enabler.EndpointUtils.checkForEndpoints(uri);
        if (uri2) {
            uri = uri2;
        }
        
        var returnUri = uri;
        var pathQuery, encPath;
        if (isXhr) {
            if (uri.indexOf(":/") != -1) { //valid schema is defined. absolute url
                returnUri = com.ibm.mm.enabler.utils.URLHelper.rewriteURL(uri);
            }
            else if (serverRootXhr !== null && uri.indexOf(serverRootXhr) === 0) {
                // seems the uri is already rewritten, so reuse it
                returnUri = uri;
            }
            else {
                pathQuery = uri.split("?"); // split the query
                encPath = com.ibm.mm.enabler.utils.Misc.encodePath(pathQuery[0]);
				returnUri = encPath;
                if (uri.indexOf("/") === 0) { //fullpath eg. /accuWeather/accuWeather.js
                    if (serverRootXhr) {
                        returnUri = serverRootXhr + encPath.substring(1);
                    }
                }
                else {
					if (widgetBaseUriXhr){
						 returnUri =  widgetBaseUriXhr + encPath;
					}
                }
                
                if (pathQuery.length == 2) {
                    returnUri += "?" + pathQuery[1];
                }
            }
        }
        else {
            if (uri.indexOf(":/") === -1) { //not absolute path
                pathQuery = uri.split("?"); // split the query
                encPath = com.ibm.mm.enabler.utils.Misc.encodePath(pathQuery[0]);
                if (uri.indexOf("/") === 0) { //fullpath
                    if (serverRoot) {
                        returnUri = serverRoot + encPath.substring(1);
                    }
                }
                else { //relative path
                    if (widgetBaseUri) {
                        returnUri = widgetBaseUri + encPath;
                    }
                }
                if (pathQuery.length === 2) {
                    returnUri += "?" + pathQuery[1];
                }
            }
        }
        return returnUri;
    },
	_getRawBaseUri:function(rawUri){
		if (!rawUri) {
			return null;
		}
		//don't solve res:/ here so server root can be figured out correctly
			var queryStart = rawUri.indexOf("?");
            if (0 < queryStart) {
                rawUri = rawUri.substring(0, queryStart);
            }
            
            var uri2 = com.ibm.mm.enabler.EndpointUtils.checkForEndpoints(rawUri);
            if (uri2) {
                rawUri = uri2;
            }
        	var rc = rawUri.substring(0, rawUri.lastIndexOf("/") + 1);
			return rc;
	},
	_getResolvedPocUri:function(rawUri){
		//solve res:/ to be the correct one
		if (!rawUri) {
			return null;
		}
		    var rc = rawUri;
		 	if (com.ibm.mm.enabler.utils.Misc.isPocUrl(rawUri) === true){
		  		rc = com.ibm.mm.enabler.utils.URLHelper.rewriteURL(rawUri);
		  	}
			return rc;
	},
	_getXhrUri:function(baseUri){
		if (!baseUri) {
			return null;
		}
		  var rc = baseUri;
		  if (baseUri.indexOf("/") !== 0) {
              rc =  com.ibm.mm.enabler.utils.URLHelper.rewriteURL(baseUri);
          }
		  return rc;
	},
	_getServerRoot:function(rawUri){
		if (!rawUri) {
			return null;
		}
		if (rawUri.indexOf(":/") == -1) {
			return null;
		}
			var serverRoot = null;
		   
            	var indexOfScheme = rawUri.indexOf(":/");
            	serverRoot = rawUri.substring(0, indexOfScheme + 2); // value is "http:/" or "res:/"
            	if (rawUri.indexOf(":///") !== -1) {
                	serverRoot = rawUri.substring(0, indexOfScheme + 4); // "res:///" or "file:///"
            	}
            	else if (rawUri.indexOf("://") !== -1) { //http://www.ibm.com/
                	var indexOfRoot = rawUri.indexOf("/", indexOfScheme + 4);
                	serverRoot = rawUri.substring(0, indexOfRoot + 1); // "http://myhost/"
            	}
            
        	return serverRoot;
	},
	_executeCallbackQueue: function() {
        return;
    },
    // used by other classes within implementation
    _getCurrentMode: function() {
        return this.currentMode;
    }
});

com.ibm.mm.iwidget.widget.IWidgetWrapperImpl = com.ibm.mm.iwidget.widget.IWidgetWrapperDefaultImpl;

// IMPORTANT
// ibmConfig.enablerLayerModules is a comma separated string of all supported modules at runtime
// This section dynamically loads the Extended representation when the variable enablerLayerModules contains the given module
if ((ibmConfig.enablerLayerModules) && (dojo.indexOf(ibmConfig.enablerLayerModules, "iWidget") >= 0)) {
    dojo["require"]("com.ibm.mm.iwidget.widget.IWidgetWrapperExtendedImpl"); // JSLINT-IGNORE: This needs to be done to allow modularization and to support the minimal layer
}

}

if(!dojo._hasResource["com.ibm.mashups.iwidget.widget.IWidgetWrapper"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.iwidget.widget.IWidgetWrapper"] = true;
dojo.provide("com.ibm.mashups.iwidget.widget.IWidgetWrapper");









}

if(!dojo._hasResource["com.ibm.mashups.iwidget.model.WidgetModel"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.iwidget.model.WidgetModel"] = true;
dojo.provide("com.ibm.mashups.iwidget.model.WidgetModel");

/**
 * WidgetModel interface defines functions that expose information of a widget model.<br/>
 * Global model available to all the page components.<br/>
 * <code>var widgetModel = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel();</code>
 * @ibm-spi
 * @ibm-module iWidget2
 */
dojo.declare("com.ibm.mashups.iwidget.model.WidgetModel",null,{
/**
 * @private
 */
	constructor:function(id){

	},

/**
Returns  an iWidgetWrapper object which represents a runtime instance of an iWidget object. <br/>
Id is the  "id" attribute that's defined in  microformat. It's used to uniquely identify an iWidget instance on the page.<br/>
<code> &lt;span class="iw-iWidget" id="{id}"&gt;  </code>
@param{String} id  unique id of an iWidget wrapper. Must not be NULL.
@type com.ibm.mashups.iwidget.widget. IWidgetWrapper
@returns{com.ibm.mashups.iwidget.widget. IWidgetWrapper }  an  iWidget Wrapper of the required iWidget . iWidget Wrapper represents a runtime instance of an iWidget.
*/	
	find:function(id){	
	},
/**
Returns  whether or not the given node has children. NOT Implemented.
@param{com.ibm.mashups.iwidget.iWidgetWrapper} iWidgetWrapper  parent iWidgetWrapper object. Must not be NULL.
@type Boolean
@returns{Boolean }  returns TRUE if the given node has children.
*/	
	hasChildren:function(iWidgetWrapper){	
	},
/**
Returns  an array of iWidgetWrapper object. NOT Implemented.<br/>
@param{com.ibm.mashups.iwidget.widget.IWidgetWrapper} iWidgetWrapper  parent object .Must not be NULL.
@param{Boolean} isNested  optional. the default  value is TRUE. It returns all the nested iWidgets if it's true. It returns only direct children if it's false. 
@type  com.ibm.mashups.iwidget.widget. IWidgetWrapper[]
@returns{com.ibm.mashups.iwidget.widget. IWidgetWrapper[]}  return an array of iWidgetWrapper object .
*/	
	getChildren:function(iWidgetWrapper,isNested){	
	},
/**
Returns  the parent object of the specified iWidgetWrapper object . <br/>
@param{com.ibm.mashups.iwidget.widget. IWidgetWrapper} iWidgetWrapper  iWidgetWrapper object. Must not be NULL.
@type com.ibm.mashups.iwidget.widget. IWidgetWrapper
@returns{com.ibm.mashups.iwidget.widget. IWidgetWrapper } returns parent node or NULL if the node has no parent.
*/	
	getParent:function(iWidgetWrapper){	
	},

/**
Returns the deferred object used to start this operation and an IWidgetDefinition object is returned when deferred object is executed.<br/>
<code>var deferred = widgetModel.getWidgetDefinitionByUrl(url)</code><br/>
<code>deferred.setFinishedCallback(callback,parameters);</code><br/>
<code>deferred.start(false);</code><br/>
here are the callback parameters that will be passed into callback function: <br/>
 &nbsp;&nbsp;&nbsp;&nbsp;<code>resource</code> -  IWidgetDefinition object <br>
&nbsp;&nbsp;&nbsp;&nbsp;<code>statuscode</code> - the HTTP status,code of the action .<br>
&nbsp;&nbsp;&nbsp;&nbsp;<code>params</code> - optional.  may use this to pass additional parameters  into the callback .<br>
here is a sample implementation of callbackfunction:<br/>
 &nbsp;&nbsp;&nbsp;&nbsp;<code>function callback(resource, statuscode, params) { </code><br/>
 &nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;<code>  if (statuscode == 200) {   </code><br/>
 &nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;<code>  var defObj = resource;</code><br/>
 &nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;<code> ... }</code><br/>
 &nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;<code> } </code><br/>
@param{String} url  url to load widget definition. Must not be NULL.
@type com.ibm.mashups.enabler.Deferred
@returns{com.ibm.mashups.enabler.Deferred}  a deferred object used to start this operation. 
@see com.ibm.mashups.iwidget.widget.IWidgetDefinition
@deprecated Use getWidgetDefinitionByURL instead.
*/ 
	getWidgetDefinitionByUrl:function(url){
	},
/**
Returns the deferred object used to start this operation and an IWidgetDefinition object is returned when deferred object is executed.<br/>
<code>var deferred = widgetModel.getWidgetDefinitionByUrl(url)</code><br/>
<code>deferred.setFinishedCallback(callback,parameters);</code><br/>
<code>deferred.start(false);</code><br/>
here are the callback parameters that will be passed into callback function: <br/>
 &nbsp;&nbsp;&nbsp;&nbsp;<code>resource</code> -  IWidgetDefinition object <br>
&nbsp;&nbsp;&nbsp;&nbsp;<code>statuscode</code> - the HTTP status,code of the action .<br>
&nbsp;&nbsp;&nbsp;&nbsp;<code>params</code> - optional.  may use this to pass additional parameters  into the callback .<br>
here is a sample implementation of callbackfunction:<br/>
 &nbsp;&nbsp;&nbsp;&nbsp;<code>function callback(resource, statuscode, params) { </code><br/>
 &nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;<code>  if (statuscode == 200) {   </code><br/>
 &nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;<code>  var defObj = resource;</code><br/>
 &nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;<code> ... }</code><br/>
 &nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;<code> } </code><br/>
@param{String} url  url to load widget definition. Must not be NULL.
@type com.ibm.mashups.enabler.Deferred
@returns{com.ibm.mashups.enabler.Deferred}  a deferred object used to start this operation. 
@see com.ibm.mashups.iwidget.widget.IWidgetDefinition
*/ 
	getWidgetDefinitionByURL:function(url){
	},
    
    /**
    * Commits the modifications applied to this model and all dependent models.<br>
    * @return {DeferredOperation} a deferred object used to start this operation. 
    * The return value when executed through the deferred object is <code>null</null>
    */
    commit:function(){
        //summary: This method persists the data
    },
	
	/**
Returns iWidgetDefinition object for the specified JSON object. <br/>
@param{Object} json  JSON object. Must not be NULL.
@type com.ibm.mashups.iwidget.widget. IWidgetWrapper
@return{com.ibm.mashups.iwidget.widget.IWidgetDefinition} returns the IWidgetDefinition representation of the JSON object.
@see com.ibm.mashups.iwidget.widget.IWidgetDefinition
	 */
	createIWidgetDefinition:function(json) {
        //create WidgetDefinition based on JSON object 
	},
	
	/**
Creates a widget and associates it with a span element on the page <br/>
@param{Object} span  DOMElement to associate the widget with.  Must not be NULL.
@return{com.ibm.mashups.iwidget.widget.IWidgetWrapper} returns the IWidgetWrapper representation of the JSON object. May be NULL.
	 */
	createWidget:function(span) {
	}
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.hub.ManagedHubImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.hub.ManagedHubImpl"] = true;
dojo.provide("com.ibm.mm.enabler.hub.ManagedHubImpl");



dojo.declare("com.ibm.mm.enabler.hub.ManagedHubImpl", null, {
    constructor: function() {
        //implement singleton
        //allow any products to use enabler extensionregistry to plugin their own publishMgr and subscribeMgr,security manager
        //sample code
        /*var extensions = [];
         extensions.push({
         "com.ibm.mm.enabler.hub.ManagedHubImpl.publishMgr": {
         type: "around",
         handler: function ( executor, fnArgs ) { //executor is the default impl. function
         var topic = fnArgs[0];
         var data = fnArgs[1];
         var pubClientID = fnArgs[2];
         var subClientID = fnArgs[3];
         //do logic here...
         return;
         }
         }
         });
         */
    },
    publishMgr: function(topic, data, pubClient, subClient) {
        var pubClientID = pubClient ? pubClient.getClientID() : "manager";
        var subClientID = subClient ? subClient.getClientID() : "manager";
        var that = com.ibm.mm.enabler.hub.ManagedHubImpl._instance;
        if (that.bIsLoggable) { 
            that.LOGGER.trace("publishMgr", "(MANAGER): PUB: " + pubClientID + " -> " + subClientID + " || topic: '" + topic + "' data: '" + data + "'");
        }
        return true;
    },
    subscribeMgr: function(topic, client) {
        var clientID = client ? client.getClientID() : "manager";
        var that = com.ibm.mm.enabler.hub.ManagedHubImpl._instance;
        if (that.bIsLoggable) { 
            that.LOGGER.trace("subscribeMgr", "(MANAGER): SUB: id: '" + clientID + "' topic: '" + topic + "'");
        }
        return true;
    },
    securityMgr: function(source, alertType) {
        var that = com.ibm.mm.enabler.hub.ManagedHubImpl._instance;
        if (that.bIsLoggable) { 
            that.LOGGER.trace("securityMgr", "source:" + source + " alertType:" + alertType);
        }
    },
    getInstance: function() {
        //Hub api doc and sample is out of sync,need to confirm parameters
        var hub = com.ibm.mm.enabler.hub.ManagedHubImpl._instance;
        if (!hub) {
            com.ibm.mm.enabler.hub.ManagedHubImpl._instance = new OpenAjax.hub.ManagedHub({
                onPublish: this.publishMgr,
                onSubscribe: this.subscribeMgr,
                onSecurityAlert: this.securityMgr
            });
            com.ibm.mm.enabler.hub.ManagedHubImpl._instance.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.enabler.hub.ManagedHubImpl");
            com.ibm.mm.enabler.hub.ManagedHubImpl._instance.LOG_LEVEL = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
            com.ibm.mm.enabler.hub.ManagedHubImpl._instance.bIsLoggable = com.ibm.mm.enabler.hub.ManagedHubImpl._instance.LOGGER.isLoggable(com.ibm.mm.enabler.hub.ManagedHubImpl._instance.LOG_LEVEL);
            hub = com.ibm.mm.enabler.hub.ManagedHubImpl._instance;
        }
        return hub;
    }
});

com.ibm.mm.enabler.hub.ManagedHubImpl = new com.ibm.mm.enabler.hub.ManagedHubImpl();

}

if(!dojo._hasResource["com.ibm.mm.enabler.hub.SubDomainPoolImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.hub.SubDomainPoolImpl"] = true;
dojo.provide("com.ibm.mm.enabler.hub.SubDomainPoolImpl");






dojo.declare("com.ibm.mm.enabler.hub.SubDomainPoolImpl", null, {
    constructor: function(arr) {
        if (arr) {
            this._pool = arr;
            this._internalPool = dojo.clone(this._pool);
        }
        else {
            this._counter = 0;
            this._reusedSubDomain = [];
        }
        this.configService = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
        this.reuseSubDomain = this.configService.getValue(com.ibm.mashups.enabler.services.ConfigConstants.SUBDOMAINREUSE);
    },
    getSize: function() {
        if (this._internalPool) { 
            return this._internalPool.length;
        }
        return -1; //unlimited
    },
    //get next available
    get: function() {
        if (this._pool) { 
            return this._getFromPool();
        }
        
        var cnt = this._counter;
        if (this.reuseSubDomain) {
            if (this._reusedSubDomain.length > 0) {
                cnt = this._reusedSubDomain.shift();
                return cnt;
            }
            else {
                this._counter++;
            }
        }
        else {
            this._counter++;
        }
        return "w" + cnt;
        
    },
    //add old one back to pool for use eg. widget is deleted from the page
    add: function(subDomain) {
        if (!this.reuseSubDomain) { 
            return;
        }
        if (this._pool) {
            return this._addToPool(subDomain);
        }
        else {
            this._reusedSubDomain.push(subDomain);
        }
        return;
    },
    _getFromPool: function() {
        if (this._pool.length === 0) {
            return null;
        }
        return this._pool.shift();
    },
    _addToPool: function(subDomain) {
        this._pool.push(subDomain);
    }
});

}

if(!dojo._hasResource["com.ibm.mm.enabler.hub.XHRHeaderExtensionImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.hub.XHRHeaderExtensionImpl"] = true;
dojo.provide("com.ibm.mm.enabler.hub.XHRHeaderExtensionImpl");



dojo.declare("com.ibm.mm.enabler.hub.XHRHeaderExtensionImpl", null, {
    LOG_LEVEL: com.ibm.mashups.enabler.logging.LogLevel.TRACE,
    
    constructor: function() {
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass);
        this.LOG_METHOD = "dojo.xhr()";
        this.bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        
        this.originalDojoXHR = dojo.xhr;
        
        dojo.xhr = dojo.hitch(this, function(/* String */method, /* dojo.__XhrArgs */ args, /* Boolean */ hasBody) {
            if (this.bIsLoggable) {
                this.LOGGER.entering(this.LOG_METHOD, [method, args, hasBody]);
            }
            
            if (!args.headers) {
                args.headers = {};
            }
            args.headers["com.ibm.lotus.openajax.virtualhost"] = document.location.hostname;
            args.headers["com.ibm.lotus.openajax.virtualport"] = document.location.port;
            if (this.bIsLoggable) {
                this.LOGGER.trace(this.LOG_METHOD, "Adding headers: com.ibm.lotus.openajax.virtualhost=" + document.location.hostname + " - com.ibm.lotus.openajax.virtualport=" + document.location.port);
            }
            var ret = this.originalDojoXHR(method, args, hasBody);
            
            if (this.bIsLoggable) {
                this.LOGGER.exiting(this.LOG_METHOD);
            }
            
            return ret;
        });
    }
});

com.ibm.mm.enabler.hub.XHRHeaderExtension = new com.ibm.mm.enabler.hub.XHRHeaderExtensionImpl();

}

if(!dojo._hasResource["com.ibm.mm.enabler.hub.MainHubAdapterImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.enabler.hub.MainHubAdapterImpl"] = true;
dojo.provide("com.ibm.mm.enabler.hub.MainHubAdapterImpl");









dojo.declare("com.ibm.mm.enabler.hub.MainHubAdapterImpl", null, {
    constructor: function(managedhub) {
        this._managedhub = managedhub;
        //this._inlineContainerArr = {};
        //this._iframeContainerArr = {};
        this._inlineHubClients = {};
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass);
        this.LOG_LEVEL = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
        this.bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
    },
    PREFIX_INLINE: "_inline_",
    PREFIX_IFRAME: "_iframe_",
    createInlineHubContainer: function(id) {
        var fullId = this.PREFIX_INLINE + id;
        var me = this;
        
        function onClientConnect(container) {
            if (me.bIsLoggable) {
                me.LOGGER.trace("onClientConnect", "++ " + container.getClientID() + " connected");
            }
            
        }
        function onClientDisconnect(container) {
            if (me.bIsLoggable) {
                me.LOGGER.trace("onClientDisconnect", "-- " + container.getClientID() + " disconnected");
            }
        }
        function onClientSecurityAlert(container, securityAlert) {
            if (me.bIsLoggable) {
                me.LOGGER.trace("onClientSecurityAlert", "!! security alert - id: '" + container.getClientID() + "' msg: '" + securityAlert);
            }
        }
        function onClientError(container, error) {
            if (me.bIsLoggable) {
                me.LOGGER.trace("onClientError", "!! error - id: '" + container.getClientID() + "' msg: '" + error);
            }
        }
        
        var params = {
            Container: {
                onConnect: onClientConnect,
                onDisconnect: onClientDisconnect,
                onSecurityAlert: onClientSecurityAlert,
                onError: onClientError
            }
        };
        var client = new OpenAjax.hub.InlineContainer(this._managedhub, fullId, params);
        return client;
    },
		createIframeHubContainer:function(id,/*domNode*/widget,/*uri*/uri,isModal,width,height, myOnClientSecurityAlert){

        var fullId = this.PREFIX_IFRAME + id;
        
        var configService = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
        var enablerContext = configService.getValue(com.ibm.mashups.enabler.services.ConfigConstants.CONTEXT_ROOT_ENABLER);
        var tunnelPath = enablerContext + "/js/openajaxhub/rpc_relay.html";
        
        var schema = window.location.protocol;
        var host = window.location.hostname;
        var port = window.location.port;
        var tunnelUri = schema + "//" + host + ":" + port + tunnelPath;
        if (port == "") {
            tunnelUri = schema + "//" + host + tunnelPath;
        }
        var me = this;
        function onClientConnect(container) {
            if (me.bIsLoggable) {
                me.LOGGER.trace("onClientConnect", "++ " + container.getClientID() + " connected");
            }
        }
        function onClientDisconnect(container) {
            if (me.bIsLoggable) {
                me.LOGGER.trace("onClientDisconnect", "-- " + container.getClientID() + " disconnected");
            }
        }
        function onClientSecurityAlert(container, securityAlert) {
            if (me.bIsLoggable) {
                me.LOGGER.trace("onClientSecurityAlert", "!! security alert - id: '" + container.getClientID() + "' msg: '" + securityAlert);
            }
        }
        try {
            var w,h;
            this.removeIframeHubContainer(id); // remove any that already exists so there is never duplicate
            if (isModal && isModal == "true") {
                w = "600px";
                h = "400px";
            }
            else {
                w = "100%";
                h = "100%";
            }
            if (width) {
                w = width;
            }
            if (height) {
                h = height;
            }
            
			if (myOnClientSecurityAlert) {
				onClientSecurityAlert = myOnClientSecurityAlert;
			}
	
            var client = new OpenAjax.hub.IframeContainer(this._managedhub, fullId, {
                Container: {
                    onConnect: onClientConnect,
                    onDisconnect: onClientDisconnect,
                    //	      log:function(msg){
                    //	   	console.log("!!!!!!"+msg);
                    //	   },
                    onSecurityAlert: onClientSecurityAlert
                
                },
                IframeContainer: {
                    //uri: "http://c" + i + ".foo.bar.com/hub11/samples/plain_hub/widgetSender.html",
                    uri: uri,
                    tunnelURI: tunnelUri,
                    //    timeout:1000000000,
                    parent: widget,
                    //	iframeAttrs:{ style: { width: "100%", height: "100%" },scrolling:"no" }		
                    iframeAttrs: {
                        title: "iframe",
                        style: {
                            width: w,//need to set default size since IE7/6 either have wierd or no default size at all
                            height: h,
                            border: "0px",
                            overflow: "auto"
                        }/*,
                        id: "iframe_" + id,
                        name: id*/
                    },
                    timeout: 1200000
                }
            });
        } 
        catch (e) {
            if (me.bIsLoggable) {
                me.LOGGER.trace("createIframeHubContainer", "Creating iframe container exception:" + e.message);
            }
        }
    },
    createInlineHubClient: function(id) {
        //create hub client and connect to hub
        var fullId = this.PREFIX_INLINE + id;
        var me = this;
        
        var container = this._managedhub.getContainer(fullId);
        function onHubClientSecurityAlert(source, alertType) {
        }
        var hubClient1 = new OpenAjax.hub.InlineHubClient({
            HubClient: {
                onSecurityAlert: onHubClientSecurityAlert
            },
            InlineHubClient: {
                container: container
            }
        });
        function onHubClientConnect(client, success, error) {
            if (!success) {
                if (me.bIsLoggable) {
                    me.LOGGER.trace("createIframeHubContainer", "!! client connection error = id: '" + client.getClientID() + "' msg: '" + error);
                }
            }
        }
        hubClient1.connect(onHubClientConnect);
        this._inlineHubClients[fullId] = hubClient1;
        return hubClient1;
    },
    _getInlineHubClient: function(id) {
        if (!id) {
            return null;
        }
        var fullId = this.PREFIX_INLINE + id;
        var client = this._inlineHubClients[fullId];
        if (typeof client == "undefined") {
            client = null;
        }
        return client;
    },
    getInlineHubClient: function(id) {
        if (!id) {
            return this._managedhub;
        }
        var client = this._getInlineHubClient(id);
        return client ? client : this._managedhub;
    },
    isInlineClient: function(id) {
        var rc = false;
        var hubClient = this._getInlineHubClient(id);
        if (hubClient) {
            rc = true;
        }
        return rc;
    },
    removeInlineHubClient: function(id) {
        //eg. widget is removed from the page
        var hubClient = this._getInlineHubClient(id);
        var fullId = this.PREFIX_INLINE + id;
        if (hubClient) {
            var me = this;
            var onHubClientDisconnect = function (client, success, error) {
                if (!success) {
                    if (me.bIsLoggable) {
                        me.LOGGER.trace("onHubClientDisconnect", "-- " + client.getClientID() + " msg:" + error);
                    }
                }
            };
            hubClient.disconnect(onHubClientDisconnect);
            
            delete this._inlineHubClients[fullId];
            //var inlineContainer = this._inlineContainerArr[fullId];
            var inlineContainer = this._managedhub.getContainer(fullId);
            if (inlineContainer) {
                this._managedhub.removeContainer(inlineContainer);
            }
            return;
        }
    },
	getContainer:function(id,isIframe){
		isIframe = isIframe || false;
		if (isIframe === true) {
			id = this.PREFIX_IFRAME + id;
		}	
		return this._managedhub.getContainer(id);
	},
    removeIframeHubContainer: function(id) {
        var fullId = this.PREFIX_IFRAME + id;
        var iframeContainer = this._managedhub.getContainer(fullId);
        if (iframeContainer) {
            this._managedhub.removeContainer(iframeContainer);
        }
    },
    returnSubDomain: function(subDomain) {
        this.getSubDomainPool().add(subDomain);
    },
    getSubDomainSize: function() {
        return this.getSubDomainPool().getSize();
    },
    getSubDomain: function() {
        return this.getSubDomainPool().get();
    },
    getSubDomainPool: function() {
        if (!this.subDomainPool) {
            var configService = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
            var subDomains = configService.getValue(com.ibm.mashups.enabler.services.ConfigConstants.SUBDOMAINS);
            if (subDomains) {
                if (dojo.isArray(subDomains) && subDomains.length !== 0) {
                    this.subDomainPool = new com.ibm.mm.enabler.hub.SubDomainPoolImpl(subDomains);
                }
            }
            if (!this.subDomainPool) {
                this.subDomainPool = new com.ibm.mm.enabler.hub.SubDomainPoolImpl();
            }
        }
        return this.subDomainPool;
    }
});

}

if(!dojo._hasResource["com.ibm.mm.iwidget.services.EventService"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.iwidget.services.EventService"] = true;
dojo.provide("com.ibm.mm.iwidget.services.EventService");




// inject this service into the ServiceManager at the end. Therefore we have to require the implementation








dojo.declare("com.ibm.mm.iwidget.services.EventServiceDefaultImpl", com.ibm.mashups.iwidget.services.EventService, {
    constructor: function(){
        this.subMgr = {};
        this.managedhub = com.ibm.mm.enabler.hub.ManagedHubImpl.getInstance();
        this.hubAdapter = new com.ibm.mm.enabler.hub.MainHubAdapterImpl(this.managedhub);
        this._subscribeEventService();
        if (this.registerServices) {
            this.registerServices();
        }
        if (this.registerExtServices) {
            this.registerExtServices();
        }
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass);
        this.LOG_LEVEL = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
        this.bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
        
    },
    getType: function(){
        return com.ibm.mm.iwidget.Constants.eventservice.type.MAIN;
    },
    registerServices: function(){
        //listen to request to change widget mode
        var event = com.ibm.mashups.iwidget.Constants.CHANGE_WIDGETMODE;
        var me = this;
        var eventCallback = function(payload){
            var widgetId = payload.id;
            var newMode = payload.newMode;
            var parentNode = payload.parentNode;
            me.fireEvent(widgetId, "onModeChanged", {
                newMode: newMode,
                rootElementId: parentNode
            });
        };
        this.subscribeEvent(event, null, eventCallback, null, null);
    },
    setId: function(id){
        this.id = id;
    },
    getId: function(){
        return "main";
    },
    _subscribeEventService: function(){
        //dispatch event to each method....for now, just fireEvent
        //in future, broadcastEvent... has security concern though
        var that = this;
        // message should contain
        // methodname:fireEvent
        // params:{}
        // hubclient:hubclientid
        function eventCallback(topic, message, subscribeData){
            //(targetWidget,targetEvent,message.payload,message.payloadType,sourceWidget)
            var methodname = message.methodname;
            if (methodname) {
                var fn = that[message.methodname];
                if (fn) {
                    that[methodname].apply(that, message.params);
                }
            }
        }
        this.managedhub.subscribe("eventservice." + this.getId(), eventCallback, that, that._subscribeCallback);
    },
    _subscribeCallback: function(subHandle, success,/*OpenAjax.hub.Error*/ error){
        //common _subscribeCallback function
        if (!success) {
            console.log("subscribe failed " + subHandle);
        }
    },
    _getHubAdapter: function(){
        return this.hubAdapter;
    },
    _getManagedHub: function(){
        return this.managedhub;
    },
    WIDGETEVENT_PREFIX: iwConstants.WIDGETEVENT_PREFIX,
    WILDCARD_PREFIX: iwConstants.WILDCARD_PREFIX,
    subscribeWire: function(/*String*/sourceWidget,/*String*/ sourceEvent,/*String*/ targetWidget,/*String*/ targetEvent){
        return false;
    },
    publishWire: function(/*String*/sourceWidget,/*String*/ sourceEvent,/*object*/ payload,/*String*/ payloadType){
        return false;
    },
    unSubscribeWire: function(sourceWidget, sourceEvent, targetWidget, targetEvent){
        return false;
    },
    addWire: function(sourceWidget, sourceEvent, targetWidget, targetEvent){
        return false;
    },
    removeWire: function(sourceWidget, sourceEvent, targetWidget, targetEvent){
        return false;
    },
    fireEvent: function(targetWidget, targetEvent, payload, payloadType, sourceWidget){
        //allows a third party to fire a event in a target widget
        var aEvent = new com.ibm.mm.iwidget.IEventImpl(targetEvent, payloadType, payload, sourceWidget);
        //need to make sure  the widget is loaded
        var widgetModel = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel();
        var widget = widgetModel.find(targetWidget);
        
        var cb = function(eventSvr, targetWWrapper, aEvent, subscribeID){
            var isInlineClient = eventSvr.hubAdapter.isInlineClient(targetWWrapper.id);
            if (isInlineClient) {
                eventSvr._publishEvent(eventSvr.WIDGETEVENT_PREFIX + targetWWrapper.id, aEvent, aEvent.source);
            }
            else {
                var payloadObj = {};
                if (aEvent.name == iwConstants.EVENTS.onModeChanged) {
                    payloadObj.methodname = "_handleOnModeChange";
                    payloadObj.params = [payload];
                    targetWWrapper.handleEvent(payloadObj);
                    return;
                }
                
                payloadObj.methodname = "fireEvent";
                payloadObj.hubclient = eventSvr.getId();
                payloadObj.params = [targetWWrapper.id, aEvent.name, aEvent.payload, aEvent.type];
                eventSvr._publishEvent("eventservice." + targetWWrapper.id, payloadObj);
            }
            if (subscribeID) { //delete subscriber
                var subHandle = eventSvr.subMgr[subscribeID];
                if (subHandle) {
                    eventSvr.unsubscribeEvent(subHandle);
                }
                delete eventSvr.subMgr[subscribeID];
            }
        };
        if (widget && widget.isLoaded()) {
            cb(this, widget, aEvent);
        }
        else {
            var that = this;
            //subscribe widgetloaded event with callback
            //var subscribeID = com.ibm.mashups.iwidget.Constants.WIDGET_LOADED + "." + targetWidget;
            var subscribeID = dojox.uuid.generateRandomUuid();
            var subHandle = this.subscribeEvent(com.ibm.mashups.iwidget.Constants.WIDGET_LOADED + "." + targetWidget, null, function(){
                var widget = widgetModel.find(targetWidget);
                cb(that, widget, aEvent, subscribeID);
            });
            this.subMgr[subscribeID] = subHandle;
        }
    },
    //support pagechanged event and widget deleted event
    publishEvent: function(sourceEvent, payload, payloadType, sourceid){
        // dojo dojo.publish(topic: String, args: Array);
        if (this.bIsLoggable) {
            this.LOGGER.entering("eventService.publishEvent", [sourceEvent, payload, payloadType, sourceid]);
        }
        if (typeof sourceEvent == "undefined" || sourceEvent === null) {
            return;
        }
        var temp;
        if (sourceEvent.indexOf(this.WILDCARD_PREFIX) === 0) {
            temp = this.WILDCARD_PREFIX;
            return this.broadcastEvent(sourceEvent.substring(temp.length), payload, payloadType, sourceid);
        }
        else 
            if (sourceEvent.indexOf(this.WIDGETEVENT_PREFIX) === 0) {
                temp = sourceEvent.substring(this.WIDGETEVENT_PREFIX.length);
                var widget = temp.substring(0, temp.indexOf("."));
                var event = temp.substring(temp.indexOf(".") + 1);
                return this.fireEvent(widget, event, payload, payloadType, sourceid);
            }
        this._publishEvent(sourceEvent, payload, sourceid);
    },
    _publishEvent: function(event, payload, sourceid){
        //internal use	
        /*payload; need to be json object if it's openajax hub, for now, it's dojo, so it need to be array*/
        var client = this.hubAdapter.getInlineHubClient(sourceid);
        if (typeof payload == "undefined" || payload === null) {
            client.publish(event);
        }
        else {
            client.publish(event, payload);
        }
    },
    broadcastEvent: function(targetEvent, payload, payloadType, sourceid, pageid, spaceid){
        var eventObj = {};
        eventObj.targetEvent = targetEvent;
        eventObj.payload = payload;
        eventObj.payloadType = payloadType;
        this.broadcastEvents([eventObj], sourceid, pageid, spaceid);
        return;
    },
    
    broadcastEvents: function(eventsArray, sourceid, pageid, spaceid){
        if ((eventsArray === null) || !dojo.isArray(eventsArray)) {
            return;
        }
        var navStateModel = com.ibm.mashups.enabler.model.state.NavigationStateModelFactory.getNavigationStateModel();
        var spaceAccessor = com.ibm.mashups.enabler.model.state.AccessorFactory.getSpaceAccessor(navStateModel);
        var currentSpaceID = spaceAccessor.getSpaceID();
        var pageAccessor = com.ibm.mashups.enabler.model.state.AccessorFactory.getPageAccessor(navStateModel, currentSpaceID);
        var currentPageID = pageAccessor.getPageID();
        
        var switchPage = ((pageid) && (typeof pageid == "string") && (pageid != currentPageID));
        if (switchPage) {
        	this._switchPageForBroadcastEvents(eventsArray, sourceid, pageid, spaceid, navStateModel, spaceAccessor, currentSpaceID);
        }
        else {
            var subscribeID;
            var subHandle;
            // no switch page - stay on current page
            var widgetModel = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel();
            var widgets = widgetModel.getAllWidgets();
            var that = this;
            var checkHandledEvents = function(widget, eventsArray, subscribeID){
                var handledEvents = widget.getWidgetHandledEvents();
                if (handledEvents === null) {
                    // This is a hack for 15760
                    // In some instances the handled events aren't initialized on the IWidgetWrapper.
                    // If handledEvents comes back null get the events off the IWidgetDefinition.
                    var widgetDefinition = widget.getIWidgetDefinition().start();
                    if (widgetDefinition) {
                        handledEvents = widgetDefinition.getWidgetHandledEvents();
                    }
                }
                
                if (handledEvents) {
                    for (var i = 0; i < eventsArray.length; i++) {
                        for (var j = 0; j < handledEvents.length; j++) {
                            if (eventsArray[i].targetEvent == handledEvents[j].name) {
                                that.fireEvent(widget.getID(), eventsArray[i].targetEvent, eventsArray[i].payload, eventsArray[i].payloadType, sourceid);
                                break;
                            }
                        }
                    }
                }
                if (subscribeID) {
                    var subHandle = that.subMgr[subscribeID];
                    if (subHandle) {
                        that.unsubscribeEvent(subHandle);
                    }
                    delete that.subMgr[subscribeID];
                }
            };
            var isSubscribed = false;
            for (var i in widgets) {
                if (Object.prototype.hasOwnProperty.call(widgets, i)) {
                    var aWidget = widgets[i];
                    if (aWidget.isLoaded()) {
                        checkHandledEvents(aWidget, eventsArray);
                    }
                    else {
                        if (!aWidget.lazyLoad) {
                            isSubscribed = true;
                            subscribeID = dojox.uuid.generateRandomUuid();
                            subHandle = this.subscribeEvent(com.ibm.mashups.iwidget.Constants.WIDGET_LOADED + "." + aWidget.getID(), null, dojo.partial(checkHandledEvents, aWidget, eventsArray, subscribeID));
                            this.subMgr[subscribeID] = subHandle;
                        }
                    }
                }
            }
            // we are not allowed to verify for subscription anymore as the target widget is not yet in the global widget model after page switch. This happens later
            if ((eventsArray.length > 0) && (eventsArray[0].targetEvent === "com.ibm.mashups.builder.skinLoaded")) {
                subscribeID = dojox.uuid.generateRandomUuid();
                subHandle = this.subscribeEvent(com.ibm.mashups.iwidget.Constants.WIDGET_LOADED + "." + eventsArray[0].payload.widgetId, null, function(){
                    that._handleBroadcastEventsCache();
                    var subHandle = that.subMgr[subscribeID];
                    if (subHandle) {
                        that.unsubscribeEvent(subHandle);
                    }
                });
                this.subMgr[subscribeID] = subHandle;
            }
            for (var j = 0; j < eventsArray.length; j++) {
                this._publishEvent(eventsArray[j].targetEvent, eventsArray[j].payload, sourceid);
            }
        }
        return;
    },
	_switchPageForBroadcastEvents: function(eventsArray, sourceid, pageid, spaceid, navStateModel, spaceAccessor, currentSpaceID) {
    	// noop - implemented by subclass
    	// no pages in core or minimal layer, so only switch page in model layer
    },
    _handleBroadcastEventsCache: function(){
    	// noop - implemented by subclass
    	// no pages in core or minimal layer, so only switch page in model layer
    },
    _subscribeEvent: function(event, object, eventCallback, subscribeCallback, sourceid){
        var client = this._getHubAdapter().getInlineHubClient(sourceid);
        //return dojo.subscribe(event,object,eventCallback);
        //return subscription id for openajax hub
        
        var subHandle1 = client.subscribe(event, function(topic, data, subscriberData){ /*onData*/
            var ec = eventCallback;
            if (object && eventCallback) {
                ec = dojo.hitch(object, eventCallback);
            }
            
            //Deserialize data,not necessary		 
            
            if (ec) {
                ec(data);
            }
        }, null /* scope */, function(subID, success, error){ /*onComplete*/
            if (object && subscribeCallback) {
                subscribeCallback = dojo.hitch(object, subscribeCallback);
            }
            if (subscribeCallback) {
                subscribeCallback.apply(this, [subID, success, error]);
            }
            if (!success) {
                console.log("subscription for " + subID + " failed");
                return;
            }
        });
        return subHandle1;
    },
    subscribeEvent: function(event, object, eventCallback, subscribeCallback, sourceid){
        return this._subscribeEvent(event, object, eventCallback, subscribeCallback, sourceid);
    },
    _unsubscribeEvent: function(subscriptionHandler, sourceid){
        var client = this._getHubAdapter().getInlineHubClient(sourceid);
        try {
            if (client) {
                client.unsubscribe(subscriptionHandler);
            }
        } 
        catch (e) {//workaround for hub bug
            console.log("unsubscribe failure:" + e);
        }
    },
    unsubscribeEvent: function(subscriptionHandler, sourceid){
        if (!subscriptionHandler) {
            return;
        }
        this._unsubscribeEvent(subscriptionHandler, sourceid);
    },
    _generateWireId: function(sourceWidget, sourceEvent, targetWidget, targetEvent){
        return sourceWidget + "_" + sourceEvent + "_" + targetWidget + "_" + targetEvent;
    }
});

if (!ibmConfig.insideSandbox) {
    com.ibm.mashups.services.ServiceManager.setService("eventService", "com.ibm.mm.iwidget.services.EventServiceDefaultImpl");
}
// IMPORTANT
// ibmConfig.enablerLayerModules is a comma separated string of all supported modules at runtime
// This section dynamically loads the Extended representation when the variable enablerLayerModules contains the given module
if ((ibmConfig.enablerLayerModules) && (dojo.indexOf(ibmConfig.enablerLayerModules, "iWidget") >= 0)) {
    dojo["require"]("com.ibm.mm.iwidget.services.EventServiceExtended"); // JSLINT-IGNORE: This needs to be done to allow modularization and to support the minimal layer
    dojo["require"]("com.ibm.mm.iwidget.services.IFrameEventServiceImpl"); // JSLINT-IGNORE: This needs to be done to allow modularization and to support the minimal layer
}

}

if(!dojo._hasResource["com.ibm.mm.iwidget.model.WidgetModel"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.iwidget.model.WidgetModel"] = true;
dojo.provide("com.ibm.mm.iwidget.model.WidgetModel");










dojo.declare("com.ibm.mm.iwidget.model.WidgetModelDefaultImpl", com.ibm.mashups.iwidget.model.WidgetModel, {
    constructor: function() {
        this.widgetArr = {}; //associate array since it provides direct access
        this.parentMap = {}; // maps from widget id to parent widget id
        this.eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
        this.eventService.subscribeEvent(com.ibm.mashups.iwidget.Constants.UNLOAD_WIDGETS, this, "_unloadWidgets");
        
        if (!ibmConfig || (ibmConfig && typeof ibmConfig.loadingHTML != "string")) { // only preload anim gif if loadingHTML is not set
            if (ibmConfig["loadingHTML.imageURL"]) {
                this.processAnim = com.ibm.mm.enabler.utils.Misc.preloadImage(ibmConfig["loadingHTML.imageURL"], 20, 20);
            }
            else {
                var url = new dojo.moduleUrl("com.ibm.mm.iwidget", "image/");
                url = url + "progress-anim.gif";
                this.processAnim = com.ibm.mm.enabler.utils.Misc.preloadImage(url, 20, 20);
            }
        }
        dojo.addOnWindowUnload(this, "_onWindowUnload");
        this.global = dojo.global;
        this.doc = dojo.doc;
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass);
        this.LOG_LEVEL = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
        this.bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
    },
    _onWindowUnload: function() {
        try {
            var arr = [];
            for (var i in this.widgetArr) {
                if (Object.prototype.hasOwnProperty.call(this.widgetArr,i)) {
                    this._unloadWidget(i); //use _unloadWidget to avoid pulish event com.ibm.mashups.iwidget.Constants.WIDGETS_UNLOADED
                }
            }
        } 
        catch (e) {
            console.log("_onWindowUnload " + e.message);
        }
    },
    createWidget: function(/*DomElment*/widgetSpan) {
        // for now by design id is required attribute for each widget
        var id = widgetSpan.getAttribute("id");
        if (typeof(id) == "undefined") {
            return null;
        }
        
        // each fragment is uniquely identified by the widget id, thus we don't 
        // support different fragment that shares the same id the old one will 
        //be deleted
        var oldWidget = this.widgetArr[id];
        if (typeof oldWidget != "undefined" && oldWidget !== null) {
            var oldfragment = oldWidget.rootElement;
            if (oldfragment == widgetSpan) { //eg. switch skin if it's the same dom node
                return oldWidget;
            }
            else {
                this._unloadWidget(id);
            }
        }
        
        var aWidget = new com.ibm.mm.iwidget.widget.IWidgetWrapperImpl(widgetSpan, id);
        this.widgetArr[id] = aWidget;
        //this.parentMap[id] = aWidget._getParent();
        this.parentMap[id] = "DEFER_TOKEN";
        return aWidget;
    },
    createIWidgetDefinition: function(/*Object*/json) {
        return new com.ibm.mm.iwidget.widget.IWidgetDefinitionImpl(null, null, json);
    },
    
    find: function(/*String*/id) {
        var widget = this.widgetArr[id];
        if (typeof widget != "undefined") {
            if (widget.lazyLoad && !widget.loaded) {
                this.renderWidget(widget);
                delete widget.lazyLoad;
            }
            return widget;
        }
        return null;
    },
    getWidgetById: function(/*String*/id) { //deprecated
        return this.find(id);
    },
    commit: function() {
        return new com.ibm.mm.enabler.DeferredOperationImpl(this, this._commit);
    },
    _commit: function(deferred, sync) {
        // iterate through my widgets and see whether any itemset is dirty or not.
        for (var widgetId in this.widgetArr) {
            if (Object.prototype.hasOwnProperty.call(this.widgetArr,widgetId)) {
                var widgetWrapper = this.widgetArr[widgetId];
                var widgetInstance = widgetWrapper.getIWidgetInstance();
                
                if (!widgetInstance) {
                    continue;
                }
                widgetWrapper.commit();
            }
        }
    },
    _unloadWidgets: function(/*[]*/arr) {
        var aWidget;
        if (typeof arr != "undefined" || arr !== null) {
            if (dojo.isArray(arr)) {
                for (var i in arr) {
                    if (Object.prototype.hasOwnProperty.call(arr,i)) {
                        aWidget = arr[i];
                        this._unloadWidget(aWidget);
                    }
                }
                dojo.publish(com.ibm.mashups.iwidget.Constants.WIDGETS_UNLOADED, [arr]);
                this.eventService.publishEvent(com.ibm.mashups.iwidget.Constants.WIDGETS_UNLOADED, arr);
            }
            else if (dojo.isString(arr)) {
                this._unloadWidget(arr);
            }
        }
    },
    _unloadWidget: function(aWidget) {
        if (typeof this.widgetArr[aWidget] != "undefined" && this.widgetArr[aWidget] !== null) {
        
            var widgetwrapper = this.widgetArr[aWidget];
            try {
                widgetwrapper.destroy();
            } 
            catch (e) {
                //this.LOGGER.severe("_unloadWidget",dojo.string.substitute(this.iwMessages.E_WIDGET_UNLOAD_FAIL_2, [aWidget,e.message]));
            }
            delete this.widgetArr[aWidget];
            if (this.parentMap[aWidget]) {
                delete this.parentMap[aWidget];
            }
        }
    },
    getParent: function(widget) {
        var parentId = this.parentMap[widget.getID()];
        if (parentId && parentId == "DEFER_TOKEN") {
            parentId = widget._getParent();
            this.parentMap[widget.getID()] = parentId;
        }
        if (parentId) {
            parent = this.find(parentId);
        }
        return parent || null;
    },
    hasChildren: function(widget) {
        return (this.getChildren(widget, false).length === 0) ? false : true;
    },
    getChildren: function(widget, isNested) {
        this._checkParentMap();
        var children = [];
        var nested = (typeof isNested == "undefined") ? true : isNested;
        this._getChildren(widget, nested, children);
        return children;
    },
    _checkParentMap: function() {
        //make sure parent map is built
        for (var id in this.widgetArr) {
            if (Object.prototype.hasOwnProperty.call(this.widgetArr,id)) {
                var parentId = this.parentMap[id];
                if (parentId && parentId == "DEFER_TOKEN") {
                    var aWidget = this.widgetArr[id];
                    parentId = aWidget._getParent();
                    this.parentMap[id] = parentId;
                }
            }
        }
    },
    _getChildren: function(parent, nested, children) {
        // iterate parent map
        for (var id in this.parentMap) {
            // collect children
            if (this.parentMap[id] == parent.getID()) {
                var widget = this.find(id);
                if (widget) {
                    children.push(widget);
                    if (nested) {
                        // collect nested children
                        this._getChildren(widget, nested, children);
                    }
                }
            }
        }
    },
    // @deprecated
    getWidgetDefinitionByUrl: function(url) {
        return this.getWidgetDefinitionByURL(url);
    },
    getWidgetDefinitionByURL: function(url) {
        return new com.ibm.mm.iwidget.DeferredLoadImpl(url);
    },
    getAllWidgets: function() {
        return this.widgetArr;
    },
    
    renderWidget: function(/*Object*/iWidget) {
        if (typeof iWidget == "undefined") {
            return;
        }
        if (iWidget.loaded) {
            return;
        }
        iWidget.doRender();
    }
    
    
});

com.ibm.mm.iwidget.model.WidgetModelImpl = com.ibm.mm.iwidget.model.WidgetModelDefaultImpl;

// IMPORTANT
// ibmConfig.enablerLayerModules is a comma separated string of all supported modules at runtime
// This section dynamically loads the Extended representation when the variable enablerLayerModules contains the given module
if ((ibmConfig.enablerLayerModules) && (dojo.indexOf(ibmConfig.enablerLayerModules, "iWidget") >= 0)) {
    dojo["require"]("com.ibm.mm.iwidget.model.WidgetModelExtended"); // JSLINT-IGNORE: This needs to be done to allow modularization and to support the minimal layer
}

}

if(!dojo._hasResource["com.ibm.mm.iwidget.model.FactoryImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.iwidget.model.FactoryImpl"] = true;
dojo.provide("com.ibm.mm.iwidget.model.FactoryImpl");




dojo.declare("com.ibm.mm.iwidget.model.FactoryImpl", com.ibm.mashups.iwidget.model.Factory, {
    constructor: function() {
    
    },
    getGlobalWidgetModel: function() {
        if (!this._globalWidgetModel) {
            this._globalWidgetModel = new com.ibm.mm.iwidget.model.WidgetModelImpl();
        }
        return this._globalWidgetModel;
    }
});
com.ibm.mashups.iwidget.model.Factory = new com.ibm.mm.iwidget.model.FactoryImpl();

}

if(!dojo._hasResource["com.ibm.mashups.iwidget.model.Factory"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.iwidget.model.Factory"] = true;
dojo.provide("com.ibm.mashups.iwidget.model.Factory");




}

if(!dojo._hasResource["com.ibm.mashups.iwidget.services.PersistentAttributesFactoryService_API"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.iwidget.services.PersistentAttributesFactoryService_API"] = true;
dojo.provide("com.ibm.mashups.iwidget.services.PersistentAttributesFactoryService_API");
dojo.provide("com.ibm.mashups.iwidget.services.PersistentAttributesFactoryService");

/**
 * @private
 * @ibm-module iWidget2
 */
dojo.declare("com.ibm.mashups.iwidget.services.PersistentAttributesFactoryService",null,  {
	
	/**
	 * TODO make this public at some point, ServiceManager documentation says it should be there
	 * 
	 * @private
	 */
	SERVICE_NAME : "persistentAttributesFactoryService",
	
    /**
     * Creates persistent attributes for the specified widget by honoring the current persistence mode (e.g. DOM vs. WidgetModel).
     * The factory for the current persistence mode needs to be added to this service by using the <tt>addFactory</tt> method of this class.
     * 
     * @param {com.ibm.mashups.iwidget.widget.IWidgetWrapper} widget the widget for which to create the persistent attributes
     * @return {ManagedItemSet} an itemset for the specified widget using the according factory or <tt>null</tt> if no factory is available for the current mode.
     */
    createPersistentAttributes: function(widgetWrapper, contextAndCallback) {
        
    },
    /**
     * Sets the factory for the specified persistenceMode to this service.
     * @param {String} persistenceMode the mode that is supported by the specified factory
     * @param {com.ibm.mashups.iwidget.services.PersistentAttributesFactory} factory the factory that creates the attributes.
     * @return {void}
     */
    setFactory: function(persistenceMode, factory) {
        
    },
    
    /**
    * Removes a factory for a specified persistence mode.
    * 
    * @param {String} persistenceMode the mode to remove
    * 
    * TODO make this public at some time
    * @private
    */
   removeFactory: function(persistenceMode) {
   	
   }    
});

com.ibm.mashups.iwidget.services.PersistentAttributesFactoryService.SERVICE_NAME = com.ibm.mashups.iwidget.services.PersistentAttributesFactoryService.prototype.SERVICE_NAME;

}

if(!dojo._hasResource["com.ibm.mm.iwidget.manageditemset.DOMPersistentAttributesFactoryImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.iwidget.manageditemset.DOMPersistentAttributesFactoryImpl"] = true;
dojo.provide("com.ibm.mm.iwidget.manageditemset.DOMPersistentAttributesFactoryImpl");




dojo.declare("com.ibm.mm.iwidget.manageditemset.DOMPersistentAttributesFactoryImpl",com.ibm.mashups.iwidget.itemset.PersistentAttributesFactory, {
    constructor: function() {
        this.modes = ["DOM"];
    },
    createPersistentAttributes: function(widgetWrapper, persistenceMode) {
        return new com.ibm.mm.iwidget.manageditemset.PersistentAttributes(widgetWrapper, true/*serverless*/);
    },
    getSupportedPersistenceMode: function() {
        return this.modes;
    }
});

}

if(!dojo._hasResource["com.ibm.mm.iwidget.services.PersistentAttributesFactoryServiceImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.iwidget.services.PersistentAttributesFactoryServiceImpl"] = true;
dojo.provide("com.ibm.mm.iwidget.services.PersistentAttributesFactoryServiceImpl");

/*
 * This is injected on the fly and not fetched through an API. Therefore we need to define the @ibm-module so that the build process is picking it up
 * @ibm-module iWidget2
 */

// inject this service into the ServiceManager at the end. Therefore we have to require the implementation










dojo.declare("com.ibm.mm.iwidget.services.PersistentAttributesFactoryServiceImpl", com.ibm.mashups.iwidget.services.PersistentAttributesFactoryService, {
    constructor: function(){
        this._factories = {};
        
        
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass);
        this.LOG_LEVEL = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
        this.bIsLoggable = this.LOGGER.isLoggable(this.LOG_LEVEL);
    },
    createPersistentAttributes: function(widgetWrapper, contextAndCallback){
        if (contextAndCallback) {
            // register callback
            com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.iwidget.services.ContainerService.SERVICE_NAME).registerOnChangeListener(com.ibm.mashups.iwidget.services.ContainerService.PROVIDER_ATTRIBUTES, contextAndCallback);
        }
        var persistenceMode;
        var wID = widgetWrapper.id;

        var persistenceMode = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.iwidget.services.ContainerService.SERVICE_NAME).getPersistenceMode(com.ibm.mashups.iwidget.services.ContainerService.PROVIDER_ATTRIBUTES);
        
        var widgetDomNode = widgetWrapper.rootElement;
        
        if (dojo.hasClass(widgetDomNode, com.ibm.mm.iwidget.services.PersistentAttributesFactoryServiceImpl.STANDALONE_CLASS) || !persistenceMode) {
            persistenceMode = com.ibm.mm.iwidget.services.PersistentAttributesFactoryServiceImpl.DEFAULT_PERSISTENCE;
        }
        
        if (typeof persistenceMode !== "undefined" && persistenceMode == com.ibm.mashups.enabler.widget.Constants.PERSISTENCE_MODE_MODEL) {
            var widgetModel = com.ibm.mashups.enabler.widget.Factory.getWidgetModel();
            var navStateModel = com.ibm.mashups.enabler.model.state.NavigationStateModelFactory.getNavigationStateModel();
            var spaceAccessor = com.ibm.mashups.enabler.model.state.AccessorFactory.getSpaceAccessor(navStateModel);
            var pageAccessor = com.ibm.mashups.enabler.model.state.AccessorFactory.getPageAccessor(navStateModel, currentSpaceID);

            var currentSpaceID = spaceAccessor.getSpaceID();
            var currentPageID = pageAccessor.getPageID();
            
            var modelID = com.ibm.mm.iwidget.Utils.getModelID(wID);
            
            var wnd = widgetModel.findWidgetWindow(modelID, currentPageID).start();
            
            if (!wnd) {
                // we put a failsafe here to verify if the given ID is a client side ID, and if this is the case we are switching to DEFAULT PERSISTENCE
                // the reason resides in a chicken and egg problem in that a not yet live preview widget may try to get the attributes
                // in its onunload function, but it has already been discarded from the WidgetModel. This means that it would show an error that
                // iw-Standalone is required
                if (!com.ibm.mashups.enabler.services.IdentificationService.isClientID(modelID)) {
                    if (dojo.isFunction(widgetWrapper._getResourceBundle)) {
                        widgetWrapper._getResourceBundle();
                        this.LOGGER.warning("createPersistentAttributes", widgetWrapper.iwMessages.W_STANDALONECLASS_MISSING_1, [wID]);
                    } else {
                        this.LOGGER.warning("createPersistentAttributes", "widget " + wID + " is missing class " + com.ibm.mm.iwidget.Constants.CSSCLASS_PREFIXED_INSTANCE.iwStandalone);
                    }
                }
                persistenceMode = com.ibm.mm.iwidget.services.PersistentAttributesFactoryServiceImpl.DEFAULT_PERSISTENCE;
            }
        }
        
        if (!(persistenceMode in this._factories)) {
            return null;
        }
        
        return this._factories[persistenceMode].createPersistentAttributes(widgetWrapper, persistenceMode);
    },
    setFactory: function(persistenceMode, factory){
        this._factories[persistenceMode] = factory;
    },
    
    removeFactory: function(persistenceMode) {
    	if(persistenceMode in this._factories) {
    		delete this._factories[persistenceMode];
    	}
    }    
});


com.ibm.mm.iwidget.services.PersistentAttributesFactoryServiceImpl.DEFAULT_PERSISTENCE = com.ibm.mashups.enabler.widget.Constants.PERSISTENCE_MODE_DOM;
com.ibm.mm.iwidget.services.PersistentAttributesFactoryServiceImpl.STANDALONE_CLASS = com.ibm.mm.iwidget.Constants.CSSCLASS_PREFIXED_INSTANCE.iwStandalone;

com.ibm.mashups.services.ServiceManager.setService(com.ibm.mashups.iwidget.services.PersistentAttributesFactoryService.SERVICE_NAME, new com.ibm.mm.iwidget.services.PersistentAttributesFactoryServiceImpl());

com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.iwidget.services.PersistentAttributesFactoryService.SERVICE_NAME).setFactory(com.ibm.mashups.enabler.widget.Constants.PERSISTENCE_MODE_DOM, new com.ibm.mm.iwidget.manageditemset.DOMPersistentAttributesFactoryImpl());

}

if(!dojo._hasResource["com.ibm.mashups.iwidget.services.PersistentAttributesFactoryService"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.iwidget.services.PersistentAttributesFactoryService"] = true;
dojo.provide("com.ibm.mashups.iwidget.services.PersistentAttributesFactoryService");





}

if(!dojo._hasResource["com.ibm.mm.iwidget.services.IWidgetFragmentServiceImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.iwidget.services.IWidgetFragmentServiceImpl"] = true;
dojo.provide("com.ibm.mm.iwidget.services.IWidgetFragmentServiceImpl");

/*
 * This is injected on the fly and not fetched through an API. Therefore we need to define the @ibm-module so that the build process is picking it up
 * @ibm-module iWidget2
 */
// inject this service into the ServiceManager at the end. Therefore we have to require the implementation



dojo.declare("com.ibm.mm.iwidget.services.IWidgetFragmentServiceImpl", null, {
    /**
     This function creates an Item in microformat as defined by iWidget spec.<p/>
     If defaultValue is provided and no defaultLanguage is provided, following element will be created.<br/>
     &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<code> &lt;a class="iw-Item" href="#{itemName}" &gt;{defaultValue} &lt;/a&gt; </code><br/>
     If defaultLanguage is provided, following element will be created.</br>
     &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<code> &lt;a class="iw-Item" href="#{itemName}" lang="{defaultLang}"&gt; &lt;/a&gt; </code><br/>
     @param{String } itemName name of the item. Must never be NULL.
     @param{String } defaultValue  default value of the item. May be NULL.
     @param{String } defaultLang  default language of a localized item .May be NULL.
     @param{String } prefix  optional. namespace of the class, default is "iw-".
     @type DOMElement
     @returns{DOMElement }  DOMElement of the new item.
     */
    createItem: function(itemName, defaultValue, defaultLang, ns) {
        if (!ns) {
            ns = "iw-";
        }
        var item = document.createElement("a");
        dojo.addClass(item, ns + iwConstants.CSSCLASS_INSTANCE.iwItem);
        dojo.style(item, "visibility", "hidden");
        dojo.style(item, "display", "none");
        
        item.setAttribute("href", "#" + itemName);
        if (defaultLang) {
            item.setAttribute("lang", defaultLang);
        }
        if (defaultValue && !defaultLang) {
            item.innerHTML = defaultValue;
        }
        return item;
    },
    /**
     This function creates an ItemSet in microformat as defined by iWidget spec.<p/>
     Following element will be created.<br/>
     &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<code> &lt;span class="iw-ItemSet"  title="{setName}"&gt;&lt;/span&gt;</code><br/>
     @param{String } itemSetName name of the itemset. Must never be NULL.
     @param{String } prefix  optional. namespace of the class, default is "iw-".
     @type DOMElement
     @returns{DOMElement }  DOMElement of the new itemset.
     */
    createItemSet: function(itemSetName, ns) {
        if (!ns) {
            ns = "iw-";
        }
        var param = document.createElement("span");
        dojo.addClass(param, ns + iwConstants.CSSCLASS_INSTANCE.iwItemSet);
        param.setAttribute("title", itemSetName);
        dojo.style(param, "visibility", "hidden");
        dojo.style(param, "display", "none");
        return param;
    },
    /**
     This function creates an  anchor link that points to url to load widget definition.<p/>
     Following element will be created.<br/>
     &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<code> &lt;a class="iw-Definition" href="{uri}" /&gt;&lt;/code&gt;<br/>
     @param{String } widgetDefUrl  url to load widget definition xml. Must never be NULL.
     @param{String } prefix  optional. namespace of the class, default is "iw-".
     @type DOMElement
     @returns{DOMElement }  DOMElement of the new anchor link.
     */
    createWidgetDefRef: function(widgetDefUrl, ns) {
        if (!ns) {
            ns = "iw-";
        }
        var aTag = document.createElement("a");
        dojo.addClass(aTag, ns + iwConstants.CSSCLASS_INSTANCE.iwDefinition);
        aTag.setAttribute("href", widgetDefUrl);
        dojo.style(aTag, "visibility", "hidden");
        dojo.style(aTag, "display", "none");
        return aTag;
    },
    /**
     This function returns the required itemset with the given iwidget id.<br/>
     @param{String } iwidgetId  iwidget id. Must never be NULL.
     @param{String } name  name of the required ItemSet. Must never be NULL.
     @param{String } prefix  optional. namespace of the class, default is "iw-".
     @type DOMElement
     @returns{DOMElement }  DOMElement of the itemset.
     */
    getItemSet: function(iwidgetId, name, ns) {
        if (!ns) {
            ns = "iw-";
        }
        var rc = null;
        var widgetSpan = dojo.byId(iwidgetId);
        var itemsets = dojo.query("." + ns + iwConstants.CSSCLASS_INSTANCE.iwItemSet, widgetSpan);
        for (var i = 0; i < itemsets.length; i++) {
            var anItemSet = itemsets[i];
            var title = anItemSet.getAttribute("title");
            if (name == title) {
                rc = anItemSet;
                break;
            }
            
        }
        return rc;
    },
    /**
     This function returns the required item with the given parent.<br/>
     item element is a nested element within itemset element.<br/>
     @param{DOMElement } parent  parent element. Must never be NULL.
     @param{String } name  name of the required item. Must never be NULL.
     @param{String } prefix  optional. namespace of the class, default is "iw-".
     @type DOMElement
     @returns{DOMElement }  DOMElement of the item.
     */
    getItem: function(parent, name, ns) {
        if (!ns) {
            ns = "iw-";
        }
        var rc = null;
        var items = dojo.query("." + ns + iwConstants.CSSCLASS_INSTANCE.iwItem, parent);
        for (var i = 0; i < items.length; i++) {
            var anItem = items[i];
            var title = this.getKeyFromHref(anItem);
            if (title && title == name) {
                rc = anItem;
                break;
            }
        }
        return rc;
    },
    /**
     This function returns the all the items within the given parent itemset.<br/>
     item element is a nested element within itemset element.<br/>
     @param{DOMElement } parent  parent element. Must never be NULL.
     @param{String } prefix  optional. namespace of the class, default is "iw-".
     @type DOMElement[]
     @returns{DOMElement []}   list of DOMElements.
     */
    getItems: function(parent, ns) {
        if (!ns) {
            ns = "iw-";
        }
        var items = dojo.query("." + ns + iwConstants.CSSCLASS_INSTANCE.iwItem, parent);
        if (typeof items == "undefined" || items === null || items.length === 0) {
            items = null;
        }
        return items;
    },
    /**
     This function returns the reference to the widget definition.<br/>
     Widget definition reference is defined within anchor link.<br/>
     &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<code> &lt;a class="iw-Definition" href="{uri}" /&gt;&lt;/code&gt;<br/>
     @param{String } iwidgetId  id of the iWidget. Must never be NULL.
     @param{String } prefix  optional. namespace of the class, default is "iw-".
     @type String
     @returns{ String }   uri to download the iWidget definition.
     */
    getWidgetDefRef: function(iwidgetId, ns) {
        if (!ns) {
            ns = "iw-";
        }
        var rc = null;
        var widgetSpan = dojo.byId(iwidgetId);
        var def = dojo.query("." + ns + iwConstants.CSSCLASS_INSTANCE.iwDefinition, widgetSpan)[0];
        var ref = def.getAttribute("href");
        if (ref) {
            rc = ref;
        }
        return rc;
    },
    /**
     This function provides a convenience function to get  the real value defined with an "href" attribute.<br/>
     Per iWidget spec, several items are defined by using anchor link. <br/>
     For example,  item element or sourceEvent within a ReceivedEvent.<br/>
     &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<code> &lt;a class="iw-Item" href="#{itemName}" &gt;{value} &lt;/a&gt; </code><br/>
     &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<code>&lt;a class="iw-SourceEvent" href="#{sourceWidgetID}"&gt;{sourceEventName} &lt;/a &gt;</code><br/>
     This function will return itemname if it's an item node.<br/>
     This function will return id of source iWidget if it's an sourceevent node within a ReceivedEvent.<br/>
     @param{DOMNode } node  DOMNode which is an item. Must never be NULL.
     @type String
     @returns{ String }   .
     */
    getKeyFromHref: function(node) {
        var hrefValue = node.getAttribute("href");
        if (!hrefValue) {
            return null;
        }
        var pos = hrefValue.indexOf("#");
        if (pos < 0) {
            return null;
        }
        return hrefValue.substring(pos + 1);
    }
});


com.ibm.mashups.services.ServiceManager.setService("iwidgetFragmentService", new com.ibm.mm.iwidget.services.IWidgetFragmentServiceImpl());

}

